"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/objects","vs/base/common/uri","vs/editor/common/core/lineRange","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ee=function(j){for(var t=[],F=0,S=j.length;F<S;F++)t[F]=K[j[F]];return t};const qe=this,We=typeof global=="object"?global:{};var fe;(function(j){j.global=qe;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof j.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}j.Environment=t})(fe||(fe={}));var fe;(function(j){class t{constructor(o,E,g){this.type=o,this.detail=E,this.timestamp=g}}j.LoaderEvent=t;class F{constructor(o){this._events=[new t(1,"",o)]}record(o,E){this._events.push(new t(o,E,j.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}j.LoaderEventRecorder=F;class S{record(o,E){}getEvents(){return[]}}S.INSTANCE=new S,j.NullLoaderEventRecorder=S})(fe||(fe={}));var fe;(function(j){class t{static fileUriToFilePath(S,i){if(i=decodeURI(i).replace(/%23/g,"#"),S){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(S,i){return S.length>=i.length&&S.substr(0,i.length)===i}static endsWith(S,i){return S.length>=i.length&&S.substr(S.length-i.length)===i}static containsQueryString(S){return/^[^\#]*\?/gi.test(S)}static isAbsolutePath(S){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(S)}static forEachProperty(S,i){if(S){let o;for(o in S)S.hasOwnProperty(o)&&i(o,S[o])}}static isEmpty(S){let i=!0;return t.forEachProperty(S,()=>{i=!1}),i}static recursiveClone(S){if(!S||typeof S!="object"||S instanceof RegExp||!Array.isArray(S)&&Object.getPrototypeOf(S)!==Object.prototype)return S;let i=Array.isArray(S)?[]:{};return t.forEachProperty(S,(o,E)=>{E&&typeof E=="object"?i[o]=t.recursiveClone(E):i[o]=E}),i}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(S){return t.startsWith(S,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=j.global.performance&&typeof j.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?j.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,j.Utilities=t})(fe||(fe={}));var fe;(function(j){function t(i){if(i instanceof Error)return i;const o=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(o.stack=i.stack),o}j.ensureError=t;class F{static validateConfigurationOptions(o){function E(g){if(g.phase==="loading"){console.error('Loading "'+g.moduleId+'" failed'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}if(g.phase==="factory"){console.error('The factory function of "'+g.moduleId+'" has thrown an exception'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError>"u"&&(o.catchError=!1),typeof o.recordStats>"u"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=E),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(j.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags>"u"&&(o.preferScriptTags=!1),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){const g=t(new Error("INVALID cached data configuration, 'path' MUST be set"));g.phase="configuration",o.onError(g),o.nodeCachedData=void 0}return o}static mergeConfigurationOptions(o=null,E=null){let g=j.Utilities.recursiveClone(E||{});return j.Utilities.forEachProperty(o,(s,l)=>{s==="ignoreDuplicateModules"&&typeof g.ignoreDuplicateModules<"u"?g.ignoreDuplicateModules=g.ignoreDuplicateModules.concat(l):s==="paths"&&typeof g.paths<"u"?j.Utilities.forEachProperty(l,(m,R)=>g.paths[m]=R):s==="config"&&typeof g.config<"u"?j.Utilities.forEachProperty(l,(m,R)=>g.config[m]=R):g[s]=j.Utilities.recursiveClone(l)}),F.validateConfigurationOptions(g)}}j.ConfigurationOptionsUtil=F;class S{constructor(o,E){if(this._env=o,this.options=F.mergeConfigurationOptions(E),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let g=this.options.nodeRequire.main.filename,s=Math.max(g.lastIndexOf("/"),g.lastIndexOf("\\"));this.options.baseUrl=g.substring(0,s+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],j.Utilities.forEachProperty(this.options.paths,(o,E)=>{Array.isArray(E)?this.sortedPathsRules.push({from:o,to:E}):this.sortedPathsRules.push({from:o,to:[E]})}),this.sortedPathsRules.sort((o,E)=>E.from.length-o.from.length)}cloneAndMerge(o){return new S(this._env,F.mergeConfigurationOptions(o,this.options))}getOptionsLiteral(){return this.options}_applyPaths(o){let E;for(let g=0,s=this.sortedPathsRules.length;g<s;g++)if(E=this.sortedPathsRules[g],j.Utilities.startsWith(o,E.from)){let l=[];for(let m=0,R=E.to.length;m<R;m++)l.push(E.to[m]+o.substr(E.from.length));return l}return[o]}_addUrlArgsToUrl(o){return j.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o}_addUrlArgsIfNecessaryToUrls(o){if(this.options.urlArgs)for(let E=0,g=o.length;E<g;E++)o[E]=this._addUrlArgsToUrl(o[E]);return o}moduleIdToPaths(o){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o))return this.isBuild()?["empty:"]:["node|"+o];let E=o,g;if(!j.Utilities.endsWith(E,".js")&&!j.Utilities.isAbsolutePath(E)){g=this._applyPaths(E);for(let s=0,l=g.length;s<l;s++)this.isBuild()&&g[s]==="empty:"||(j.Utilities.isAbsolutePath(g[s])||(g[s]=this.options.baseUrl+g[s]),!j.Utilities.endsWith(g[s],".js")&&!j.Utilities.containsQueryString(g[s])&&(g[s]=g[s]+".js"))}else!j.Utilities.endsWith(E,".js")&&!j.Utilities.containsQueryString(E)&&(E=E+".js"),g=[E];return this._addUrlArgsIfNecessaryToUrls(g)}requireToUrl(o){let E=o;return j.Utilities.isAbsolutePath(E)||(E=this._applyPaths(E)[0],j.Utilities.isAbsolutePath(E)||(E=this.options.baseUrl+E)),this._addUrlArgsIfNecessaryToUrl(E)}isBuild(){return this.options.isBuild}shouldInvokeFactory(o){return!!(!this.options.isBuild||j.Utilities.isAnonymousModule(o)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[o])}isDuplicateMessageIgnoredFor(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)}getConfigForModule(o){if(this.options.config)return this.options.config[o]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(o){this.options.onError(o)}}j.Configuration=S})(fe||(fe={}));var fe;(function(j){class t{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,m,R,f){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=l.getConfig().getOptionsLiteral();e?this._scriptLoader=new F:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new F;let d={callback:R,errorback:f};if(this._callbackMap.hasOwnProperty(m)){this._callbackMap[m].push(d);return}this._callbackMap[m]=[d],this._scriptLoader.load(l,m,()=>this.triggerCallback(m),e=>this.triggerErrorback(m,e))}triggerCallback(l){let m=this._callbackMap[l];delete this._callbackMap[l];for(let R=0;R<m.length;R++)m[R].callback()}triggerErrorback(l,m){let R=this._callbackMap[l];delete this._callbackMap[l];for(let f=0;f<R.length;f++)R[f].errorback(m)}}class F{attachListeners(l,m,R){let f=()=>{l.removeEventListener("load",d),l.removeEventListener("error",e)},d=N=>{f(),m()},e=N=>{f(),R(N)};l.addEventListener("load",d),l.addEventListener("error",e)}load(l,m,R,f){if(/^node\|/.test(m)){let d=l.getConfig().getOptionsLiteral(),e=E(l.getRecorder(),d.nodeRequire||j.global.nodeRequire),N=m.split("|"),D=null;try{D=e(N[1])}catch(_){f(_);return}l.enqueueDefineAnonymousModule([],()=>D),R()}else{let d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript"),this.attachListeners(d,R,f);const{trustedTypesPolicy:e}=l.getConfig().getOptionsLiteral();e&&(m=e.createScriptURL(m)),d.setAttribute("src",m);const{cspNonce:N}=l.getConfig().getOptionsLiteral();N&&d.setAttribute("nonce",N),document.getElementsByTagName("head")[0].appendChild(d)}}}function S(s){const{trustedTypesPolicy:l}=s.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=S(l)),this._cachedCanUseEval}load(l,m,R,f){if(/^node\|/.test(m)){const d=l.getConfig().getOptionsLiteral(),e=E(l.getRecorder(),d.nodeRequire||j.global.nodeRequire),N=m.split("|");let D=null;try{D=e(N[1])}catch(_){f(_);return}l.enqueueDefineAnonymousModule([],function(){return D}),R()}else{const{trustedTypesPolicy:d}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(m).then(N=>{if(N.status!==200)throw new Error(N.statusText);return N.text()}).then(N=>{N=`${N}
//# sourceURL=${m}`,(d?self.eval(d.createScript("",N)):new Function(N)).call(self),R()}).then(void 0,f);return}try{d&&(m=d.createScriptURL(m)),importScripts(m),R()}catch(N){f(N)}}}}class o{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,m){const{nodeCachedData:R}=m.getConfig().getOptionsLiteral();if(!R||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const f=this,d=l("module");function e(N){const D=N.constructor;let _=function(y){try{return N.require(y)}finally{}};return _.resolve=function(y,b){return D._resolveFilename(y,N,!1,b)},_.resolve.paths=function(y){return D._resolveLookupPaths(y,N)},_.main=process.mainModule,_.extensions=D._extensions,_.cache=D._cache,_}d.prototype._compile=function(N,D){const _=d.wrap(N.replace(/^#!.*/,"")),v=m.getRecorder(),y=f._getCachedDataPath(R,D),b={filename:D};let w;try{const u=f._fs.readFileSync(y);w=u.slice(0,16),b.cachedData=u.slice(16),v.record(60,y)}catch{v.record(61,y)}const r=new f._vm.Script(_,b),a=r.runInThisContext(b),A=f._path.dirname(D),h=e(this),L=[this.exports,h,this,D,A,process,We,Buffer],c=a.apply(this.exports,L);return f._handleCachedData(r,_,y,!b.cachedData,m),f._verifyCachedData(r,_,y,w,m),c}}load(l,m,R,f){const d=l.getConfig().getOptionsLiteral(),e=E(l.getRecorder(),d.nodeRequire||j.global.nodeRequire),N=d.nodeInstrumenter||function(_){return _};this._init(e),this._initNodeRequire(e,l);let D=l.getRecorder();if(/^node\|/.test(m)){let _=m.split("|"),v=null;try{v=e(_[1])}catch(y){f(y);return}l.enqueueDefineAnonymousModule([],()=>v),R()}else{m=j.Utilities.fileUriToFilePath(this._env.isWindows,m);const _=this._path.normalize(m),v=this._getElectronRendererScriptPathOrUri(_),y=!!d.nodeCachedData,b=y?this._getCachedDataPath(d.nodeCachedData,m):void 0;this._readSourceAndCachedData(_,b,D,(w,r,a,A)=>{if(w){f(w);return}let h;r.charCodeAt(0)===o._BOM?h=o._PREFIX+r.substring(1)+o._SUFFIX:h=o._PREFIX+r+o._SUFFIX,h=N(h,_);const L={filename:v,cachedData:a},c=this._createAndEvalScript(l,h,L,R,f);this._handleCachedData(c,h,b,y&&!a,l),this._verifyCachedData(c,h,b,A,l)})}}_createAndEvalScript(l,m,R,f,d){const e=l.getRecorder();e.record(31,R.filename);const N=new this._vm.Script(m,R),D=N.runInThisContext(R),_=l.getGlobalAMDDefineFunc();let v=!1;const y=function(){return v=!0,_.apply(null,arguments)};return y.amd=_.amd,D.call(j.global,l.getGlobalAMDRequireFunc(),y,R.filename,this._path.dirname(R.filename)),e.record(32,R.filename),v?f():d(new Error(`Didn't receive define call in ${R.filename}!`)),N}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let m=l.match(/^([a-z])\:(.*)/i);return m?`file:///${(m[1].toUpperCase()+":"+m[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,m){const R=this._crypto.createHash("md5").update(m,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),f=this._path.basename(m).replace(/\.js$/,"");return this._path.join(l.path,`${f}-${R}.code`)}_handleCachedData(l,m,R,f,d){l.cachedDataRejected?this._fs.unlink(R,e=>{d.getRecorder().record(62,R),this._createAndWriteCachedData(l,m,R,d),e&&d.getConfig().onError(e)}):f&&this._createAndWriteCachedData(l,m,R,d)}_createAndWriteCachedData(l,m,R,f){let d=Math.ceil(f.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,N=0,D;const _=()=>{setTimeout(()=>{D||(D=this._crypto.createHash("md5").update(m,"utf8").digest());const v=l.createCachedData();if(!(v.length===0||v.length===e||N>=5)){if(v.length<e){_();return}e=v.length,this._fs.writeFile(R,Buffer.concat([D,v]),y=>{y&&f.getConfig().onError(y),f.getRecorder().record(63,R),_()})}},d*Math.pow(4,N++))};_()}_readSourceAndCachedData(l,m,R,f){if(!m)this._fs.readFile(l,{encoding:"utf8"},f);else{let d,e,N,D=2;const _=v=>{v?f(v):--D===0&&f(void 0,d,e,N)};this._fs.readFile(l,{encoding:"utf8"},(v,y)=>{d=y,_(v)}),this._fs.readFile(m,(v,y)=>{!v&&y&&y.length>0?(N=y.slice(0,16),e=y.slice(16),R.record(60,m)):R.record(61,m),_()})}}_verifyCachedData(l,m,R,f,d){f&&(l.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(m,"utf8").digest();f.equals(e)||(d.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${R}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(R,N=>{N&&d.getConfig().onError(N)}))},Math.ceil(5e3*(1+Math.random()))))}}o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`;function E(s,l){if(l.__$__isRecorded)return l;const m=function(f){s.record(33,f);try{return l(f)}finally{s.record(34,f)}};return m.__$__isRecorded=!0,m}j.ensureRecordedNodeRequire=E;function g(s){return new t(s)}j.createScriptLoader=g})(fe||(fe={}));var fe;(function(j){class t{constructor(s){let l=s.lastIndexOf("/");l!==-1?this.fromModulePath=s.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(s){let l=s,m;for(m=/\/\.\//;m.test(l);)l=l.replace(m,"/");for(l=l.replace(/^\.\//g,""),m=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;m.test(l);)l=l.replace(m,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(s){let l=s;return j.Utilities.isAbsolutePath(l)||(j.Utilities.startsWith(l,"./")||j.Utilities.startsWith(l,"../"))&&(l=t._normalizeModuleId(this.fromModulePath+l)),l}}t.ROOT=new t(""),j.ModuleIdResolver=t;class F{constructor(s,l,m,R,f,d){this.id=s,this.strId=l,this.dependencies=m,this._callback=R,this._errorback=f,this.moduleIdResolver=d,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(s,l){try{return{returnedValue:s.apply(j.global,l),producedError:null}}catch(m){return{returnedValue:null,producedError:m}}}static _invokeFactory(s,l,m,R){return s.shouldInvokeFactory(l)?s.shouldCatchError()?this._safeInvokeFunction(m,R):{returnedValue:m.apply(j.global,R),producedError:null}:{returnedValue:null,producedError:null}}complete(s,l,m,R){this._isComplete=!0;let f=null;if(this._callback)if(typeof this._callback=="function"){s.record(21,this.strId);let d=F._invokeFactory(l,this.strId,this._callback,m);f=d.producedError,s.record(22,this.strId),!f&&typeof d.returnedValue<"u"&&(!this.exportsPassedIn||j.Utilities.isEmpty(this.exports))&&(this.exports=d.returnedValue)}else this.exports=this._callback;if(f){let d=j.ensureError(f);d.phase="factory",d.moduleId=this.strId,d.neededBy=R(this.id),this.error=d,l.onError(d)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(s){return this._isComplete=!0,this.error=s,this._errorback?(this._errorback(s),!0):!1}isComplete(){return this._isComplete}}j.Module=F;class S{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(s){let l=this._strModuleIdToIntModuleId.get(s);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(s,l),this._intModuleIdToStrModuleId[l]=s),l}getStrModuleId(s){return this._intModuleIdToStrModuleId[s]}}class i{constructor(s){this.id=s}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),j.RegularDependency=i;class o{constructor(s,l,m){this.id=s,this.pluginId=l,this.pluginParam=m}}j.PluginDependency=o;class E{constructor(s,l,m,R,f=0){this._env=s,this._scriptLoader=l,this._loaderAvailableTimestamp=f,this._defineFunc=m,this._requireFunc=R,this._moduleIdProvider=new S,this._config=new j.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new E(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(s,l){let m=d=>d.replace(/\\/g,"/"),R=m(s),f=l.split(/\n/);for(let d=0;d<f.length;d++){let e=f[d].match(/(.*):(\d+):(\d+)\)?$/);if(e){let N=e[1],D=e[2],_=e[3],v=Math.max(N.lastIndexOf(" ")+1,N.lastIndexOf("(")+1);if(N=N.substr(v),N=m(N),N===R){let y={line:parseInt(D,10),col:parseInt(_,10)};return y.line===1&&(y.col-=53),y}}}throw new Error("Could not correlate define call site for needle "+s)}getBuildInfo(){if(!this._config.isBuild())return null;let s=[],l=0;for(let m=0,R=this._modules2.length;m<R;m++){let f=this._modules2[m];if(!f)continue;let d=this._buildInfoPath[f.id]||null,e=this._buildInfoDefineStack[f.id]||null,N=this._buildInfoDependencies[f.id];s[l++]={id:f.strId,path:d,defineLocation:d&&e?E._findRelevantLocationInStack(d,e):null,dependencies:N,shim:null,exports:f.exports}}return s}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new j.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=j.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(s,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let m=null;this._config.isBuild()&&(m=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:m,dependencies:s,callback:l}}defineModule(s,l,m,R,f,d=new t(s)){let e=this._moduleIdProvider.getModuleId(s);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(s)||console.warn("Duplicate definition of module '"+s+"'");return}let N=new F(e,s,this._normalizeDependencies(l,d),m,R,d);this._modules2[e]=N,this._config.isBuild()&&(this._buildInfoDefineStack[e]=f,this._buildInfoDependencies[e]=(N.dependencies||[]).map(D=>this._moduleIdProvider.getStrModuleId(D.id))),this._resolve(N)}_normalizeDependency(s,l){if(s==="exports")return i.EXPORTS;if(s==="module")return i.MODULE;if(s==="require")return i.REQUIRE;let m=s.indexOf("!");if(m>=0){let R=l.resolveModule(s.substr(0,m)),f=l.resolveModule(s.substr(m+1)),d=this._moduleIdProvider.getModuleId(R+"!"+f),e=this._moduleIdProvider.getModuleId(R);return new o(d,e,f)}return new i(this._moduleIdProvider.getModuleId(l.resolveModule(s)))}_normalizeDependencies(s,l){let m=[],R=0;for(let f=0,d=s.length;f<d;f++)m[R++]=this._normalizeDependency(s[f],l);return m}_relativeRequire(s,l,m,R){if(typeof l=="string")return this.synchronousRequire(l,s);this.defineModule(j.Utilities.generateAnonymousModule(),l,m,R,null,s)}synchronousRequire(s,l=new t(s)){let m=this._normalizeDependency(s,l),R=this._modules2[m.id];if(!R)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This is the first mention of this module!");if(!R.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This module has not been resolved completely yet.");if(R.error)throw R.error;return R.exports}configure(s,l){let m=this._config.shouldRecordStats();l?this._config=new j.Configuration(this._env,s):this._config=this._config.cloneAndMerge(s),this._config.shouldRecordStats()&&!m&&(this._recorder=null)}getConfig(){return this._config}_onLoad(s){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(s),l.dependencies,l.callback,null,l.stack)}}_createLoadError(s,l){let m=this._moduleIdProvider.getStrModuleId(s),R=(this._inverseDependencies2[s]||[]).map(d=>this._moduleIdProvider.getStrModuleId(d));const f=j.ensureError(l);return f.phase="loading",f.moduleId=m,f.neededBy=R,f}_onLoadError(s,l){const m=this._createLoadError(s,l);this._modules2[s]||(this._modules2[s]=new F(s,this._moduleIdProvider.getStrModuleId(s),[],()=>{},null,null));let R=[];for(let e=0,N=this._moduleIdProvider.getMaxModuleId();e<N;e++)R[e]=!1;let f=!1,d=[];for(d.push(s),R[s]=!0;d.length>0;){let e=d.shift(),N=this._modules2[e];N&&(f=N.onDependencyError(m)||f);let D=this._inverseDependencies2[e];if(D)for(let _=0,v=D.length;_<v;_++){let y=D[_];R[y]||(d.push(y),R[y]=!0)}}f||this._config.onError(m)}_hasDependencyPath(s,l){let m=this._modules2[s];if(!m)return!1;let R=[];for(let d=0,e=this._moduleIdProvider.getMaxModuleId();d<e;d++)R[d]=!1;let f=[];for(f.push(m),R[s]=!0;f.length>0;){let e=f.shift().dependencies;if(e)for(let N=0,D=e.length;N<D;N++){let _=e[N];if(_.id===l)return!0;let v=this._modules2[_.id];v&&!R[_.id]&&(R[_.id]=!0,f.push(v))}}return!1}_findCyclePath(s,l,m){if(s===l||m===50)return[s];let R=this._modules2[s];if(!R)return null;let f=R.dependencies;if(f)for(let d=0,e=f.length;d<e;d++){let N=this._findCyclePath(f[d].id,l,m+1);if(N!==null)return N.push(s),N}return null}_createRequire(s){let l=(m,R,f)=>this._relativeRequire(s,m,R,f);return l.toUrl=m=>this._config.requireToUrl(s.resolveModule(m)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(m,R=!1)=>{this.configure(m,R)},l.__$__nodeRequire=j.global.nodeRequire,l}_loadModule(s){if(this._modules2[s]||this._knownModules2[s])return;this._knownModules2[s]=!0;let l=this._moduleIdProvider.getStrModuleId(s),m=this._config.moduleIdToPaths(l),R=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||R.test(l))&&m.push("node|"+l);let f=-1,d=e=>{if(f++,f>=m.length)this._onLoadError(s,e);else{let N=m[f],D=this.getRecorder();if(this._config.isBuild()&&N==="empty:"){this._buildInfoPath[s]=N,this.defineModule(this._moduleIdProvider.getStrModuleId(s),[],null,null,null),this._onLoad(s);return}D.record(10,N),this._scriptLoader.load(this,N,()=>{this._config.isBuild()&&(this._buildInfoPath[s]=N),D.record(11,N),this._onLoad(s)},_=>{D.record(12,N),d(_)})}};d(null)}_loadPluginDependency(s,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let m=R=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],R,null,null)};m.error=R=>{this._config.onError(this._createLoadError(l.id,R))},s.load(l.pluginParam,this._createRequire(t.ROOT),m,this._config.getOptionsLiteral())}_resolve(s){let l=s.dependencies;if(l)for(let m=0,R=l.length;m<R;m++){let f=l[m];if(f===i.EXPORTS){s.exportsPassedIn=!0,s.unresolvedDependenciesCount--;continue}if(f===i.MODULE){s.unresolvedDependenciesCount--;continue}if(f===i.REQUIRE){s.unresolvedDependenciesCount--;continue}let d=this._modules2[f.id];if(d&&d.isComplete()){if(d.error){s.onDependencyError(d.error);return}s.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(f.id,s.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(f.id)+"' and '"+this._moduleIdProvider.getStrModuleId(s.id)+"'. The cyclic path follows:");let e=this._findCyclePath(f.id,s.id,0)||[];e.reverse(),e.push(f.id),console.warn(e.map(N=>this._moduleIdProvider.getStrModuleId(N)).join(` => 
`)),s.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[f.id]=this._inverseDependencies2[f.id]||[],this._inverseDependencies2[f.id].push(s.id),f instanceof o){let e=this._modules2[f.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,f);continue}let N=this._inversePluginDependencies2.get(f.pluginId);N||(N=[],this._inversePluginDependencies2.set(f.pluginId,N)),N.push(f),this._loadModule(f.pluginId);continue}this._loadModule(f.id)}s.unresolvedDependenciesCount===0&&this._onModuleComplete(s)}_onModuleComplete(s){let l=this.getRecorder();if(s.isComplete())return;let m=s.dependencies,R=[];if(m)for(let N=0,D=m.length;N<D;N++){let _=m[N];if(_===i.EXPORTS){R[N]=s.exports;continue}if(_===i.MODULE){R[N]={id:s.strId,config:()=>this._config.getConfigForModule(s.strId)};continue}if(_===i.REQUIRE){R[N]=this._createRequire(s.moduleIdResolver);continue}let v=this._modules2[_.id];if(v){R[N]=v.exports;continue}R[N]=null}const f=N=>(this._inverseDependencies2[N]||[]).map(D=>this._moduleIdProvider.getStrModuleId(D));s.complete(l,this._config,R,f);let d=this._inverseDependencies2[s.id];if(this._inverseDependencies2[s.id]=null,d)for(let N=0,D=d.length;N<D;N++){let _=d[N],v=this._modules2[_];v.unresolvedDependenciesCount--,v.unresolvedDependenciesCount===0&&this._onModuleComplete(v)}let e=this._inversePluginDependencies2.get(s.id);if(e){this._inversePluginDependencies2.delete(s.id);for(let N=0,D=e.length;N<D;N++)this._loadPluginDependency(s.exports,e[N])}}}j.ModuleManager=E})(fe||(fe={}));var J,fe;(function(j){const t=new j.Environment;let F=null;const S=function(g,s,l){typeof g!="string"&&(l=s,s=g,g=null),(typeof s!="object"||!Array.isArray(s))&&(l=s,s=null),s||(s=["require","exports","module"]),g?F.defineModule(g,s,l,null,null):F.enqueueDefineAnonymousModule(s,l)};S.amd={jQuery:!0};const i=function(g,s=!1){F.configure(g,s)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return F.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){F.defineModule(j.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=i,o.getConfig=function(){return F.getConfig().getOptionsLiteral()},o.reset=function(){F=F.reset()},o.getBuildInfo=function(){return F.getBuildInfo()},o.getStats=function(){return F.getLoaderEvents()},o.define=S;function E(){if(typeof j.global.require<"u"||typeof require<"u"){const g=j.global.require||require;if(typeof g=="function"&&typeof g.resolve=="function"){const s=j.ensureRecordedNodeRequire(F.getRecorder(),g);j.global.nodeRequire=s,o.nodeRequire=s,o.__$__nodeRequire=s}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=o:(t.isElectronRenderer||(j.global.define=S),j.global.require=o)}j.init=E,(typeof j.global.define!="function"||!j.global.define.amd)&&(F=new j.ModuleManager(t,j.createScriptLoader(t),S,o,j.Utilities.getHighPerformanceTimestamp()),typeof j.global.require<"u"&&typeof j.global.require!="function"&&o.config(j.global.require),J=function(){return S.apply(null,arguments)},J.amd=S.amd,typeof doNotInitLoader>"u"&&E())})(fe||(fe={})),J(K[57],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function F(g,s,l,m){if(m=m||{},(m["vs/css"]||{}).disabled){l({});return}const f=s.toUrl(g+".css");S(g,f,()=>{l({})},d=>{typeof l.error=="function"&&l.error("Could not find "+f+".")})}t.load=F;function S(g,s,l,m){if(i(g,s)){l();return}o(g,s,l,m)}function i(g,s){const l=document.getElementsByTagName("link");for(let m=0,R=l.length;m<R;m++){const f=l[m].getAttribute("data-name"),d=l[m].getAttribute("href");if(f===g||d===s)return!0}return!1}function o(g,s,l,m){const R=document.createElement("link");R.setAttribute("rel","stylesheet"),R.setAttribute("type","text/css"),R.setAttribute("data-name",g),E(g,R,l,m),R.setAttribute("href",s),(document.head||document.getElementsByTagName("head")[0]).appendChild(R)}function E(g,s,l,m){const R=()=>{s.removeEventListener("load",f),s.removeEventListener("error",d)},f=e=>{R(),l()},d=e=>{R(),m(e)};s.addEventListener("load",f),s.addEventListener("error",d)}}),J("vs/nls",["require","exports"],function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let F=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const S="i-default";function i(e,N){let D;return N.length===0?D=e:D=e.replace(/\{(\d+)\}/g,(_,v)=>{const y=v[0],b=N[y];let w=_;return typeof b=="string"?w=b:(typeof b=="number"||typeof b=="boolean"||b===void 0||b===null)&&(w=String(b)),w}),F&&(D="\uFF3B"+D.replace(/[aouei]/g,"$&$&")+"\uFF3D"),D}function o(e,N){let D=e[N];return D||(D=e["*"],D)?D:null}function E(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function g(e,N,D){const _=E(e)+E(N)+"vscode/"+E(D),v=await fetch(_);if(v.ok)return await v.json();throw new Error(`${v.status} - ${v.statusText}`)}function s(e){return function(N,D){const _=Array.prototype.slice.call(arguments,2);return i(e[N],_)}}function l(e,N,...D){return i(N,D)}t.localize=l;function m(e){}t.getConfiguredDefaultLocale=m;function R(e){F=e}t.setPseudoTranslation=R;function f(e,N){return{localize:s(N[e]),getConfiguredDefaultLocale:N.getConfiguredDefaultLocale??(D=>{})}}t.create=f;function d(e,N,D,_){const v=_["vs/nls"]??{};if(!e||e.length===0)return D({localize:l,getConfiguredDefaultLocale:()=>v.availableLanguages?.["*"]});const y=v.availableLanguages?o(v.availableLanguages,e):null,b=y===null||y===S;let w=".nls";b||(w=w+"."+y);const r=a=>{Array.isArray(a)?a.localize=s(a):a.localize=s(a[e]),a.getConfiguredDefaultLocale=()=>v.availableLanguages?.["*"],D(a)};typeof v.loadBundle=="function"?v.loadBundle(e,y,(a,A)=>{a?N([e+".nls"],r):r(A)}):v.translationServiceUrl&&!b?(async()=>{try{const a=await g(v.translationServiceUrl,y,e);return r(a)}catch(a){if(!y.includes("-"))return console.error(a),N([e+".nls"],r);try{const A=y.split("-")[0],h=await g(v.translationServiceUrl,A,e);return v.availableLanguages??={},v.availableLanguages["*"]=A,r(h)}catch(A){return console.error(A),N([e+".nls"],r)}}})():N([e+w],r,a=>{if(w===".nls"){console.error("Failed trying to load default language strings",a);return}console.error(`Failed to load message bundle for language ${y}. Falling back to the default language:`,a),N([e+".nls"],r)})}t.load=d}),function(){const j=globalThis.MonacoEnvironment,t=j&&j.baseUrl?j.baseUrl:"../../../",F=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:l=>l,createScript:(l,...m)=>{const R=m.slice(0,-1).join(","),f=m.pop().toString();return`(function anonymous(${R}) { ${f}
})`}}):void 0;function S(){try{return(F?globalThis.eval(F.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function i(){return new Promise((l,m)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return l();const R=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(R)&&R.substring(0,globalThis.origin.length)!==globalThis.origin)&&S()){fetch(R).then(d=>{if(d.status!==200)throw new Error(d.statusText);return d.text()}).then(d=>{d=`${d}
//# sourceURL=${R}`,(F?globalThis.eval(F.createScript("",d)):new Function(d)).call(globalThis),l()}).then(void 0,m);return}F?importScripts(F.createScriptURL(R)):importScripts(R),l()})}function o(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:F,amdModulesPattern:/^vs\//})}function E(l){i().then(()=>{o(),require([l],function(m){setTimeout(function(){const R=m.create((f,d)=>{globalThis.postMessage(f,d)},null);for(globalThis.onmessage=f=>R.onmessage(f.data,f.ports);s.length>0;){const f=s.shift();R.onmessage(f.data,f.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&o();let g=!0;const s=[];globalThis.onmessage=l=>{if(!g){s.push(l);return}g=!1,E(l.data)}}(),J(K[27],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function F(g,s){const l=Math.pow(10,s);return Math.round(g*l)/l}class S{constructor(s,l,m,R=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,s))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=F(Math.max(Math.min(1,R),0),3)}static equals(s,l){return s.r===l.r&&s.g===l.g&&s.b===l.b&&s.a===l.a}}t.RGBA=S;class i{constructor(s,l,m,R){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=F(Math.max(Math.min(1,l),0),3),this.l=F(Math.max(Math.min(1,m),0),3),this.a=F(Math.max(Math.min(1,R),0),3)}static equals(s,l){return s.h===l.h&&s.s===l.s&&s.l===l.l&&s.a===l.a}static fromRGBA(s){const l=s.r/255,m=s.g/255,R=s.b/255,f=s.a,d=Math.max(l,m,R),e=Math.min(l,m,R);let N=0,D=0;const _=(e+d)/2,v=d-e;if(v>0){switch(D=Math.min(_<=.5?v/(2*_):v/(2-2*_),1),d){case l:N=(m-R)/v+(m<R?6:0);break;case m:N=(R-l)/v+2;break;case R:N=(l-m)/v+4;break}N*=60,N=Math.round(N)}return new i(N,D,_,f)}static i(s,l,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?s+(l-s)*6*m:m<1/2?l:m<2/3?s+(l-s)*(2/3-m)*6:s}static toRGBA(s){const l=s.h/360,{s:m,l:R,a:f}=s;let d,e,N;if(m===0)d=e=N=R;else{const D=R<.5?R*(1+m):R+m-R*m,_=2*R-D;d=i.i(_,D,l+1/3),e=i.i(_,D,l),N=i.i(_,D,l-1/3)}return new S(Math.round(d*255),Math.round(e*255),Math.round(N*255),f)}}t.HSLA=i;class o{constructor(s,l,m,R){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=F(Math.max(Math.min(1,l),0),3),this.v=F(Math.max(Math.min(1,m),0),3),this.a=F(Math.max(Math.min(1,R),0),3)}static equals(s,l){return s.h===l.h&&s.s===l.s&&s.v===l.v&&s.a===l.a}static fromRGBA(s){const l=s.r/255,m=s.g/255,R=s.b/255,f=Math.max(l,m,R),d=Math.min(l,m,R),e=f-d,N=f===0?0:e/f;let D;return e===0?D=0:f===l?D=((m-R)/e%6+6)%6:f===m?D=(R-l)/e+2:D=(l-m)/e+4,new o(Math.round(D*60),N,f,s.a)}static toRGBA(s){const{h:l,s:m,v:R,a:f}=s,d=R*m,e=d*(1-Math.abs(l/60%2-1)),N=R-d;let[D,_,v]=[0,0,0];return l<60?(D=d,_=e):l<120?(D=e,_=d):l<180?(_=d,v=e):l<240?(_=e,v=d):l<300?(D=e,v=d):l<=360&&(D=d,v=e),D=Math.round((D+N)*255),_=Math.round((_+N)*255),v=Math.round((v+N)*255),new S(D,_,v,f)}}t.HSVA=o;class E{static fromHex(s){return E.Format.CSS.parseHex(s)||E.red}static equals(s,l){return!s&&!l?!0:!s||!l?!1:s.equals(l)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:o.fromRGBA(this.rgba)}constructor(s){if(s)if(s instanceof S)this.rgba=s;else if(s instanceof i)this.i=s,this.rgba=i.toRGBA(s);else if(s instanceof o)this.j=s,this.rgba=o.toRGBA(s);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(s){return!!s&&S.equals(this.rgba,s.rgba)&&i.equals(this.hsla,s.hsla)&&o.equals(this.hsva,s.hsva)}getRelativeLuminance(){const s=E.k(this.rgba.r),l=E.k(this.rgba.g),m=E.k(this.rgba.b),R=.2126*s+.7152*l+.0722*m;return F(R,4)}static k(s){const l=s/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(s){const l=this.getRelativeLuminance(),m=s.getRelativeLuminance();return l>m?(l+.05)/(m+.05):(m+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(s){const l=this.getRelativeLuminance(),m=s.getRelativeLuminance();return l>m}isDarkerThan(s){const l=this.getRelativeLuminance(),m=s.getRelativeLuminance();return l<m}lighten(s){return new E(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*s,this.hsla.a))}darken(s){return new E(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*s,this.hsla.a))}transparent(s){const{r:l,g:m,b:R,a:f}=this.rgba;return new E(new S(l,m,R,f*s))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new E(new S(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(s){const l=s.rgba,m=this.rgba.a,R=l.a,f=m+R*(1-m);if(f<1e-6)return E.transparent;const d=this.rgba.r*m/f+l.r*R*(1-m)/f,e=this.rgba.g*m/f+l.g*R*(1-m)/f,N=this.rgba.b*m/f+l.b*R*(1-m)/f;return new E(new S(d,e,N,f))}makeOpaque(s){if(this.isOpaque()||s.rgba.a!==1)return this;const{r:l,g:m,b:R,a:f}=this.rgba;return new E(new S(s.rgba.r-f*(s.rgba.r-l),s.rgba.g-f*(s.rgba.g-m),s.rgba.b-f*(s.rgba.b-R),1))}flatten(...s){const l=s.reduceRight((m,R)=>E.o(R,m));return E.o(this,l)}static o(s,l){const m=1-s.rgba.a;return new E(new S(m*l.rgba.r+s.rgba.a*s.rgba.r,m*l.rgba.g+s.rgba.a*s.rgba.g,m*l.rgba.b+s.rgba.a*s.rgba.b))}toString(){return this.u||(this.u=E.Format.CSS.format(this)),this.u}static getLighterColor(s,l,m){if(s.isLighterThan(l))return s;m=m||.5;const R=s.getRelativeLuminance(),f=l.getRelativeLuminance();return m=m*(f-R)/f,s.lighten(m)}static getDarkerColor(s,l,m){if(s.isDarkerThan(l))return s;m=m||.5;const R=s.getRelativeLuminance(),f=l.getRelativeLuminance();return m=m*(R-f)/R,s.darken(m)}}t.Color=E,E.white=new E(new S(255,255,255,1)),E.black=new E(new S(0,0,0,1)),E.red=new E(new S(255,0,0,1)),E.blue=new E(new S(0,0,255,1)),E.green=new E(new S(0,255,0,1)),E.cyan=new E(new S(0,255,255,1)),E.lightgrey=new E(new S(211,211,211,1)),E.transparent=new E(new S(0,0,0,0)),function(g){let s;(function(l){let m;(function(R){function f(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:g.Format.CSS.formatRGBA(r)}R.formatRGB=f;function d(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}R.formatRGBA=d;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:g.Format.CSS.formatHSLA(r)}R.formatHSL=e;function N(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}R.formatHSLA=N;function D(r){const a=r.toString(16);return a.length!==2?"0"+a:a}function _(r){return`#${D(r.rgba.r)}${D(r.rgba.g)}${D(r.rgba.b)}`}R.formatHex=_;function v(r,a=!1){return a&&r.rgba.a===1?g.Format.CSS.formatHex(r):`#${D(r.rgba.r)}${D(r.rgba.g)}${D(r.rgba.b)}${D(Math.round(r.rgba.a*255))}`}R.formatHexA=v;function y(r){return r.isOpaque()?g.Format.CSS.formatHex(r):g.Format.CSS.formatRGBA(r)}R.format=y;function b(r){const a=r.length;if(a===0||r.charCodeAt(0)!==35)return null;if(a===7){const A=16*w(r.charCodeAt(1))+w(r.charCodeAt(2)),h=16*w(r.charCodeAt(3))+w(r.charCodeAt(4)),L=16*w(r.charCodeAt(5))+w(r.charCodeAt(6));return new g(new S(A,h,L,1))}if(a===9){const A=16*w(r.charCodeAt(1))+w(r.charCodeAt(2)),h=16*w(r.charCodeAt(3))+w(r.charCodeAt(4)),L=16*w(r.charCodeAt(5))+w(r.charCodeAt(6)),c=16*w(r.charCodeAt(7))+w(r.charCodeAt(8));return new g(new S(A,h,L,c/255))}if(a===4){const A=w(r.charCodeAt(1)),h=w(r.charCodeAt(2)),L=w(r.charCodeAt(3));return new g(new S(16*A+A,16*h+h,16*L+L))}if(a===5){const A=w(r.charCodeAt(1)),h=w(r.charCodeAt(2)),L=w(r.charCodeAt(3)),c=w(r.charCodeAt(4));return new g(new S(16*A+A,16*h+h,16*L+L,(16*c+c)/255))}return null}R.parseHex=b;function w(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=l.CSS||(l.CSS={}))})(s=g.Format||(g.Format={}))}(E||(t.Color=E={}))}),J(K[28],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class F{constructor(i,o,E,g){this.originalStart=i,this.originalLength=o,this.modifiedStart=E,this.modifiedLength=g}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=F}),J(K[3],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class F{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?b.isErrorNoTelemetry(a)?new b(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(A=>{A(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}t.ErrorHandler=F,t.errorHandler=new F;function S(r){t.errorHandler.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=S;function i(r){if(!r||typeof r!="object")return!1;const a=r;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function o(r){l(r)||t.errorHandler.onUnexpectedError(r)}t.onUnexpectedError=o;function E(r){l(r)||t.errorHandler.onUnexpectedExternalError(r)}t.onUnexpectedExternalError=E;function g(r){if(r instanceof Error){const{name:a,message:A}=r,h=r.stacktrace||r.stack;return{$isError:!0,name:a,message:A,stack:h,noTelemetry:b.isErrorNoTelemetry(r)}}return r}t.transformErrorForSerialization=g;const s="Canceled";function l(r){return r instanceof m?!0:r instanceof Error&&r.name===s&&r.message===s}t.isCancellationError=l;class m extends Error{constructor(){super(s),this.name=this.message}}t.CancellationError=m;function R(){const r=new Error(s);return r.name=r.message,r}t.canceled=R;function f(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.illegalArgument=f;function d(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.illegalState=d;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function N(r){const a=new Error(`${r} has been disposed`);return a.name="DISPOSED",a}t.disposed=N;function D(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.getErrorMessage=D;class _ extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}t.NotImplementedError=_;class v extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}t.NotSupportedError=v;class y extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=y;class b extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof b)return a;const A=new b;return A.message=a.message,A.stack=a.stack,A}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}t.ErrorNoTelemetry=b;class w extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}t.BugIndicatingError=w}),J(K[29],ee([0,1,3]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function S(U,C=0){return U[U.length-(1+C)]}t.tail=S;function i(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}t.tail2=i;function o(U,C,O=(V,H)=>V===H){if(U===C)return!0;if(!U||!C||U.length!==C.length)return!1;for(let V=0,H=U.length;V<H;V++)if(!O(U[V],C[V]))return!1;return!0}t.equals=o;function E(U,C){const O=U.length-1;C<O&&(U[C]=U[O]),U.pop()}t.removeFastWithoutKeepingOrder=E;function g(U,C,O){return s(U.length,V=>O(U[V],C))}t.binarySearch=g;function s(U,C){let O=0,V=U-1;for(;O<=V;){const H=(O+V)/2|0,ne=C(H);if(ne<0)O=H+1;else if(ne>0)V=H-1;else return H}return-(O+1)}t.binarySearch2=s;function l(U,C){let O=0,V=U.length;if(V===0)return 0;for(;O<V;){const H=Math.floor((O+V)/2);C(U[H])?V=H:O=H+1}return O}t.findFirstInSorted=l;function m(U,C,O){if(U=U|0,U>=C.length)throw new TypeError("invalid index");const V=C[Math.floor(C.length*Math.random())],H=[],ne=[],ie=[];for(const ae of C){const ce=O(ae,V);ce<0?H.push(ae):ce>0?ne.push(ae):ie.push(ae)}return U<H.length?m(U,H,O):U<H.length+ie.length?ie[0]:m(U-(H.length+ie.length),ne,O)}t.quickSelect=m;function R(U,C){const O=[];let V;for(const H of U.slice(0).sort(C))!V||C(V[0],H)!==0?(V=[H],O.push(V)):V.push(H);return O}t.groupBy=R;function f(U,C,O){const V=[];function H(ae,ce,he){if(ce===0&&he.length===0)return;const Le=V[V.length-1];Le&&Le.start+Le.deleteCount===ae?(Le.deleteCount+=ce,Le.toInsert.push(...he)):V.push({start:ae,deleteCount:ce,toInsert:he})}let ne=0,ie=0;for(;;){if(ne===U.length){H(ne,0,C.slice(ie));break}if(ie===C.length){H(ne,U.length-ne,[]);break}const ae=U[ne],ce=C[ie],he=O(ae,ce);he===0?(ne+=1,ie+=1):he<0?(H(ne,1,[]),ne+=1):he>0&&(H(ne,0,[ce]),ie+=1)}return V}t.sortedDiff=f;function d(U,C,O){const V=f(U,C,O),H=[],ne=[];for(const ie of V)H.push(...U.slice(ie.start,ie.start+ie.deleteCount)),ne.push(...ie.toInsert);return{removed:H,added:ne}}t.delta=d;function e(U,C,O){if(O===0)return[];const V=U.slice(0,O).sort(C);return D(U,C,V,O,U.length),V}t.top=e;function N(U,C,O,V,H){return O===0?Promise.resolve([]):new Promise((ne,ie)=>{(async()=>{const ae=U.length,ce=U.slice(0,O).sort(C);for(let he=O,Le=Math.min(O+V,ae);he<ae;he=Le,Le=Math.min(Le+V,ae)){if(he>O&&await new Promise(De=>setTimeout(De)),H&&H.isCancellationRequested)throw new F.CancellationError;D(U,C,ce,he,Le)}return ce})().then(ne,ie)})}t.topAsync=N;function D(U,C,O,V,H){for(const ne=O.length;V<H;V++){const ie=U[V];if(C(ie,O[ne-1])<0){O.pop();const ae=l(O,ce=>C(ie,ce)<0);O.splice(ae,0,ie)}}}function _(U){return U.filter(C=>!!C)}t.coalesce=_;function v(U){let C=0;for(let O=0;O<U.length;O++)U[O]&&(U[C]=U[O],C+=1);U.length=C}t.coalesceInPlace=v;function y(U,C,O){U.splice(O,0,U.splice(C,1)[0])}t.move=y;function b(U){return!Array.isArray(U)||U.length===0}t.isFalsyOrEmpty=b;function w(U){return Array.isArray(U)&&U.length>0}t.isNonEmptyArray=w;function r(U,C=O=>O){const O=new Set;return U.filter(V=>{const H=C(V);return O.has(H)?!1:(O.add(H),!0)})}t.distinct=r;function a(U){const C=new Set;return O=>{const V=U(O);return C.has(V)?!1:(C.add(V),!0)}}t.uniqueFilter=a;function A(U,C){const O=h(U,C);if(O!==-1)return U[O]}t.findLast=A;function h(U,C){for(let O=U.length-1;O>=0;O--){const V=U[O];if(C(V))return O}return-1}t.lastIndex=h;function L(U,C){return U.length>0?U[0]:C}t.firstOrDefault=L;function c(U,C){return U.length>0?U[U.length-1]:C}t.lastOrDefault=c;function u(U,C,O=(V,H)=>V===H){let V=0;for(let H=0,ne=Math.min(U.length,C.length);H<ne&&O(U[H],C[H]);H++)V++;return V}t.commonPrefixLength=u;function p(U){return[].concat(...U)}t.flatten=p;function k(U,C){let O=typeof C=="number"?U:0;typeof C=="number"?O=U:(O=0,C=U);const V=[];if(O<=C)for(let H=O;H<C;H++)V.push(H);else for(let H=O;H>C;H--)V.push(H);return V}t.range=k;function P(U,C,O){return U.reduce((V,H)=>(V[C(H)]=O?O(H):H,V),Object.create(null))}t.index=P;function M(U,C){return U.push(C),()=>I(U,C)}t.insert=M;function I(U,C){const O=U.indexOf(C);if(O>-1)return U.splice(O,1),C}t.remove=I;function B(U,C,O){const V=U.slice(0,C),H=U.slice(C);return V.concat(O,H)}t.arrayInsert=B;function W(U,C){let O;if(typeof C=="number"){let V=C;O=()=>{const H=Math.sin(V++)*179426549;return H-Math.floor(H)}}else O=Math.random;for(let V=U.length-1;V>0;V-=1){const H=Math.floor(O()*(V+1)),ne=U[V];U[V]=U[H],U[H]=ne}}t.shuffle=W;function z(U,C){const O=U.indexOf(C);O>-1&&(U.splice(O,1),U.unshift(C))}t.pushToStart=z;function Z(U,C){const O=U.indexOf(C);O>-1&&(U.splice(O,1),U.push(C))}t.pushToEnd=Z;function Y(U,C){for(const O of C)U.push(O)}t.pushMany=Y;function G(U,C){return Array.isArray(U)?U.map(C):C(U)}t.mapArrayOrNot=G;function se(U){return Array.isArray(U)?U:[U]}t.asArray=se;function n(U){return U[Math.floor(Math.random()*U.length)]}t.getRandomElement=n;function me(U,C){for(const O of U){const V=C(O);if(V!==void 0)return V}}t.mapFind=me;function de(U,C,O){const V=we(U,C),H=U.length,ne=O.length;U.length=H+ne;for(let ie=H-1;ie>=V;ie--)U[ie+ne]=U[ie];for(let ie=0;ie<ne;ie++)U[ie+V]=O[ie]}t.insertInto=de;function be(U,C,O,V){const H=we(U,C),ne=U.splice(H,O);return de(U,H,V),ne}t.splice=be;function we(U,C){return C<0?Math.max(C+U.length,0):Math.min(C,U.length)}var Ne;(function(U){function C(H){return H<0}U.isLessThan=C;function O(H){return H>0}U.isGreaterThan=O;function V(H){return H===0}U.isNeitherLessOrGreaterThan=V,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(Ne||(t.CompareResult=Ne={}));function le(U,C){return(O,V)=>C(U(O),U(V))}t.compareBy=le;function oe(...U){return(C,O)=>{for(const V of U){const H=V(C,O);if(!Ne.isNeitherLessOrGreaterThan(H))return H}return Ne.neitherLessOrGreaterThan}}t.tieBreakComparators=oe;const Ae=(U,C)=>U-C;t.numberComparator=Ae;function ve(U,C){if(U.length===0)return;let O=U[0];for(let V=1;V<U.length;V++){const H=U[V];C(H,O)>0&&(O=H)}return O}t.findMaxBy=ve;function ye(U,C){if(U.length===0)return;let O=U[0];for(let V=1;V<U.length;V++){const H=U[V];C(H,O)>=0&&(O=H)}return O}t.findLastMaxBy=ye;function Fe(U,C){return ve(U,(O,V)=>-C(O,V))}t.findMinBy=Fe;class te{constructor(C){this.f=C,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(C){let O=this.c;for(;O<this.f.length&&C(this.f[O]);)O++;const V=O===this.c?null:this.f.slice(this.c,O);return this.c=O,V}takeFromEndWhile(C){let O=this.d;for(;O>=0&&C(this.f[O]);)O--;const V=O===this.d?null:this.f.slice(O+1,this.d+1);return this.d=O,V}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const C=this.f[this.c];return this.c++,C}removeLast(){const C=this.f[this.d];return this.d--,C}takeCount(C){const O=this.f.slice(this.c,this.c+C);return this.c+=C,O}}t.ArrayQueue=te;class X{constructor(C){this.iterate=C}forEach(C){this.iterate(O=>(C(O),!0))}toArray(){const C=[];return this.iterate(O=>(C.push(O),!0)),C}filter(C){return new X(O=>this.iterate(V=>C(V)?O(V):!0))}map(C){return new X(O=>this.iterate(V=>O(C(V))))}some(C){let O=!1;return this.iterate(V=>(O=C(V),!O)),O}findFirst(C){let O;return this.iterate(V=>C(V)?(O=V,!1):!0),O}findLast(C){let O;return this.iterate(V=>(C(V)&&(O=V),!0)),O}findLastMaxBy(C){let O,V=!0;return this.iterate(H=>((V||Ne.isGreaterThan(C(H,O)))&&(V=!1,O=H),!0)),O}}t.CallbackIterable=X,X.empty=new X(U=>{})}),J(K[11],ee([0,1,3]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function S(s,l){if(!s)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}t.ok=S;function i(s,l="Unreachable"){throw new Error(l)}t.assertNever=i;function o(s){if(!s)throw new F.BugIndicatingError("Assertion Failed")}t.assert=o;function E(s){if(!s()){debugger;s(),(0,F.onUnexpectedError)(new F.BugIndicatingError("Assertion Failed"))}}t.assertFn=E;function g(s,l){let m=0;for(;m<s.length-1;){const R=s[m],f=s[m+1];if(!l(R,f))return!1;m++}return!0}t.checkAdjacentItems=g}),J(K[15],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function F(S){const i=this;let o=!1,E;return function(){return o||(o=!0,E=S.apply(i,arguments)),E}}t.once=F}),J(K[16],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var F;(function(S){function i(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}S.is=i;const o=Object.freeze([]);function E(){return o}S.empty=E;function*g(b){yield b}S.single=g;function s(b){return i(b)?b:g(b)}S.wrap=s;function l(b){return b||o}S.from=l;function m(b){return!b||b[Symbol.iterator]().next().done===!0}S.isEmpty=m;function R(b){return b[Symbol.iterator]().next().value}S.first=R;function f(b,w){for(const r of b)if(w(r))return!0;return!1}S.some=f;function d(b,w){for(const r of b)if(w(r))return r}S.find=d;function*e(b,w){for(const r of b)w(r)&&(yield r)}S.filter=e;function*N(b,w){let r=0;for(const a of b)yield w(a,r++)}S.map=N;function*D(...b){for(const w of b)for(const r of w)yield r}S.concat=D;function _(b,w,r){let a=r;for(const A of b)a=w(a,A);return a}S.reduce=_;function*v(b,w,r=b.length){for(w<0&&(w+=b.length),r<0?r+=b.length:r>b.length&&(r=b.length);w<r;w++)yield b[w]}S.slice=v;function y(b,w=Number.POSITIVE_INFINITY){const r=[];if(w===0)return[r,b];const a=b[Symbol.iterator]();for(let A=0;A<w;A++){const h=a.next();if(h.done)return[r,S.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return a}}]}S.consume=y})(F||(t.Iterable=F={}))}),J(K[30],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(F||(t.KeyCode=F={}));var S;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(S||(t.ScanCode=S={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(N,D){this._keyCodeToStr[N]=D,this._strToKeyCode[D.toLowerCase()]=N}keyCodeToStr(N){return this._keyCodeToStr[N]}strToKeyCode(N){return this._strToKeyCode[N.toLowerCase()]||0}}const o=new i,E=new i,g=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const s=[],l=Object.create(null),m=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>m[e]||0,toEnum:e=>l[e]||0,toString:e=>s[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",N=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],D=[],_=[];for(const v of N){const[y,b,w,r,a,A,h,L,c]=v;if(_[b]||(_[b]=!0,s[b]=w,l[w]=b,m[w.toLowerCase()]=b,y&&(t.IMMUTABLE_CODE_TO_KEY_CODE[b]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[r]=b))),!D[r]){if(D[r]=!0,!a)throw new Error(`String representation missing for key code ${r} around scan code ${w}`);o.define(r,a),E.define(r,L||a),g.define(r,c||L||a)}A&&(t.EVENT_KEY_CODE_MAP[A]=r),h&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[h]=r)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var R;(function(e){function N(w){return o.keyCodeToStr(w)}e.toString=N;function D(w){return o.strToKeyCode(w)}e.fromString=D;function _(w){return E.keyCodeToStr(w)}e.toUserSettingsUS=_;function v(w){return g.keyCodeToStr(w)}e.toUserSettingsGeneral=v;function y(w){return E.strToKeyCode(w)||g.strToKeyCode(w)}e.fromUserSettings=y;function b(w){if(w>=98&&w<=113)return null;switch(w){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return o.keyCodeToStr(w)}e.toElectronAccelerator=b})(R||(t.KeyCodeUtils=R={}));var f;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(f||(t.KeyMod=f={}));function d(e,N){const D=(N&65535)<<16>>>0;return(e|D)>>>0}t.KeyChord=d}),J(K[31],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class F{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.Lazy=F}),J(K[7],ee([0,1,15,16]),function(j,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let o=null;function E(c){o=c}if(t.setDisposableTracker=E,i){const c="__is_disposable_tracked__";E(new class{trackDisposable(u){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[c]||console.log(p)},3e3)}setParent(u,p){if(u&&u!==v.None)try{u[c]=!0}catch{}}markAsDisposed(u){if(u&&u!==v.None)try{u[c]=!0}catch{}}markAsSingleton(u){}})}function g(c){return o?.trackDisposable(c),c}function s(c){o?.markAsDisposed(c)}function l(c,u){o?.setParent(c,u)}function m(c,u){if(o)for(const p of c)o.setParent(p,u)}function R(c){return o?.markAsSingleton(c),c}t.markAsSingleton=R;function f(c){return typeof c.dispose=="function"&&c.dispose.length===0}t.isDisposable=f;function d(c){if(S.Iterable.is(c)){const u=[];for(const p of c)if(p)try{p.dispose()}catch(k){u.push(k)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}t.dispose=d;function e(c){for(const u of c)f(u)&&u.dispose();return[]}t.disposeIfDisposable=e;function N(...c){const u=D(()=>d(c));return m(c,u),u}t.combinedDisposable=N;function D(c){const u=g({dispose:(0,F.once)(()=>{s(u),c()})});return u}t.toDisposable=D;class _{constructor(){this.f=new Set,this.g=!1,g(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return l(u,this),this.g?_.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(u),u}}t.DisposableStore=_,_.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this.q=new _,g(this),l(this.q,this)}dispose(){s(this),this.q.dispose()}B(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(u)}}t.Disposable=v,v.None=Object.freeze({dispose(){}});class y{constructor(){this.b=!1,g(this)}get value(){return this.b?void 0:this.a}set value(u){this.b||u===this.a||(this.a?.dispose(),u&&l(u,this),this.a=u)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const u=this.a;return this.a=void 0,u&&l(u,null),u}}t.MutableDisposable=y;class b{constructor(u){this.b=u,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=b;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,g(this)}set(u){let p=u;return this.unset=()=>p=void 0,this.isset=()=>p!==void 0,this.dispose=()=>{p&&(p(),p=void 0,s(this))},this}}t.SafeDisposable=w;class r{constructor(){this.a=new Map}acquire(u,...p){let k=this.a.get(u);k||(k={counter:0,object:this.b(u,...p)},this.a.set(u,k));const{object:P}=k,M=(0,F.once)(()=>{--k.counter===0&&(this.c(u,k.object),this.a.delete(u))});return k.counter++,{object:P,dispose:M}}}t.ReferenceCollection=r;class a{constructor(u){this.a=u}async acquire(u,...p){const k=this.a.acquire(u,...p);try{return{object:await k.object,dispose:()=>k.dispose()}}catch(P){throw k.dispose(),P}}}t.AsyncReferenceCollection=a;class A{constructor(u){this.object=u}dispose(){}}t.ImmortalReference=A;function h(c){const u=new _;try{c(u)}finally{u.dispose()}}t.disposeOnReturn=h;class L{constructor(){this.a=new Map,this.b=!1,g(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(u){return this.a.has(u)}get(u){return this.a.get(u)}set(u,p,k=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),k||this.a.get(u)?.dispose(),this.a.set(u,p)}deleteAndDispose(u){this.a.get(u)?.dispose(),this.a.delete(u)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=L}),J(K[17],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class F{constructor(o){this.element=o,this.next=F.Undefined,this.prev=F.Undefined}}F.Undefined=new F(void 0);class S{constructor(){this.a=F.Undefined,this.b=F.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===F.Undefined}clear(){let o=this.a;for(;o!==F.Undefined;){const E=o.next;o.prev=F.Undefined,o.next=F.Undefined,o=E}this.a=F.Undefined,this.b=F.Undefined,this.c=0}unshift(o){return this.d(o,!1)}push(o){return this.d(o,!0)}d(o,E){const g=new F(o);if(this.a===F.Undefined)this.a=g,this.b=g;else if(E){const l=this.b;this.b=g,g.prev=l,l.next=g}else{const l=this.a;this.a=g,g.next=l,l.prev=g}this.c+=1;let s=!1;return()=>{s||(s=!0,this.e(g))}}shift(){if(this.a!==F.Undefined){const o=this.a.element;return this.e(this.a),o}}pop(){if(this.b!==F.Undefined){const o=this.b.element;return this.e(this.b),o}}e(o){if(o.prev!==F.Undefined&&o.next!==F.Undefined){const E=o.prev;E.next=o.next,o.next.prev=E}else o.prev===F.Undefined&&o.next===F.Undefined?(this.a=F.Undefined,this.b=F.Undefined):o.next===F.Undefined?(this.b=this.b.prev,this.b.next=F.Undefined):o.prev===F.Undefined&&(this.a=this.a.next,this.a.prev=F.Undefined);this.c-=1}*[Symbol.iterator](){let o=this.a;for(;o!==F.Undefined;)yield o.element,o=o.next}}t.LinkedList=S}),J(K[8],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let F=!1,S=!1,i=!1,o=!1,E=!1,g=!1,s=!1,l=!1,m=!1,R=!1,f,d=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT,N,D;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let _;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?_=t.globals.vscode.process:typeof process<"u"&&(_=process);const v=typeof _?.versions?.electron=="string",y=v&&_?.type==="renderer";if(typeof navigator=="object"&&!y){D=navigator.userAgent,F=D.indexOf("Windows")>=0,S=D.indexOf("Macintosh")>=0,l=(D.indexOf("Macintosh")>=0||D.indexOf("iPad")>=0||D.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,i=D.indexOf("Linux")>=0,R=D?.indexOf("Mobi")>=0,g=!0,f=t.LANGUAGE_DEFAULT,d=f,e=navigator.language;const u=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),p=u&&u.getAttribute("data-settings");if(p)try{const k=JSON.parse(p),P=k.availableLanguages["*"];f=k.locale,e=k.osLocale,d=P||t.LANGUAGE_DEFAULT,N=k._translationsConfigFile}catch{}}else if(typeof _=="object"){F=_.platform==="win32",S=_.platform==="darwin",i=_.platform==="linux",o=i&&!!_.env.SNAP&&!!_.env.SNAP_REVISION,s=v,m=!!_.env.CI||!!_.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=t.LANGUAGE_DEFAULT,d=t.LANGUAGE_DEFAULT;const u=_.env.VSCODE_NLS_CONFIG;if(u)try{const p=JSON.parse(u),k=p.availableLanguages["*"];f=p.locale,e=p.osLocale,d=k||t.LANGUAGE_DEFAULT,N=p._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var b;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(b||(t.Platform=b={}));function w(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=w;let r=0;S?r=1:F?r=3:i&&(r=2),t.isWindows=F,t.isMacintosh=S,t.isLinux=i,t.isLinuxSnap=o,t.isNative=E,t.isElectron=s,t.isWeb=g,t.isWebWorker=g&&typeof t.globals.importScripts=="function",t.isIOS=l,t.isMobile=R,t.isCI=m,t.platform=r,t.userAgent=D,t.language=d;var a;(function(u){function p(){return t.language}u.value=p;function k(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}u.isDefaultVariant=k;function P(){return t.language==="en"}u.isDefault=P})(a||(t.Language=a={})),t.locale=f,t.platformLocale=e,t.translationsConfigFile=N,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const u=[];t.globals.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let P=0,M=u.length;P<M;P++){const I=u[P];if(I.id===k.data.vscodeScheduleAsyncWork){u.splice(P,1),I.callback();return}}});let p=0;return k=>{const P=++p;u.push({id:P,callback:k}),t.globals.postMessage({vscodeScheduleAsyncWork:P},"*")}}return u=>setTimeout(u)})();var A;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(A||(t.OperatingSystem=A={})),t.OS=S||l?2:F?1:3;let h=!0,L=!1;function c(){if(!L){L=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,h=new Uint16Array(u.buffer)[0]===(2<<8)+1}return h}t.isLittleEndian=c,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),J(K[32],ee([0,1,8]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let S;if(typeof F.globals.vscode<"u"&&typeof F.globals.vscode.process<"u"){const i=F.globals.vscode.process;S={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?S={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:S={get platform(){return F.isWindows?"win32":F.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=S.cwd,t.env=S.env,t.platform=S.platform,t.arch=S.arch}),J(K[33],ee([0,1,32]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const S=65,i=97,o=90,E=122,g=46,s=47,l=92,m=58,R=63;class f extends Error{constructor(a,A,h){let L;typeof A=="string"&&A.indexOf("not ")===0?(L="must not be",A=A.replace(/^not /,"")):L="must be";const c=a.indexOf(".")!==-1?"property":"argument";let u=`The "${a}" ${c} ${L} of type ${A}`;u+=`. Received type ${typeof h}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function d(r,a){if(r===null||typeof r!="object")throw new f(a,"Object",r)}function e(r,a){if(typeof r!="string")throw new f(a,"string",r)}const N=F.platform==="win32";function D(r){return r===s||r===l}function _(r){return r===s}function v(r){return r>=S&&r<=o||r>=i&&r<=E}function y(r,a,A,h){let L="",c=0,u=-1,p=0,k=0;for(let P=0;P<=r.length;++P){if(P<r.length)k=r.charCodeAt(P);else{if(h(k))break;k=s}if(h(k)){if(!(u===P-1||p===1))if(p===2){if(L.length<2||c!==2||L.charCodeAt(L.length-1)!==g||L.charCodeAt(L.length-2)!==g){if(L.length>2){const M=L.lastIndexOf(A);M===-1?(L="",c=0):(L=L.slice(0,M),c=L.length-1-L.lastIndexOf(A)),u=P,p=0;continue}else if(L.length!==0){L="",c=0,u=P,p=0;continue}}a&&(L+=L.length>0?`${A}..`:"..",c=2)}else L.length>0?L+=`${A}${r.slice(u+1,P)}`:L=r.slice(u+1,P),c=P-u-1;u=P,p=0}else k===g&&p!==-1?++p:p=-1}return L}function b(r,a){d(a,"pathObject");const A=a.dir||a.root,h=a.base||`${a.name||""}${a.ext||""}`;return A?A===a.root?`${A}${h}`:`${A}${r}${h}`:h}t.win32={resolve(...r){let a="",A="",h=!1;for(let L=r.length-1;L>=-1;L--){let c;if(L>=0){if(c=r[L],e(c,"path"),c.length===0)continue}else a.length===0?c=F.cwd():(c=F.env[`=${a}`]||F.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==a.toLowerCase()&&c.charCodeAt(2)===l)&&(c=`${a}\\`));const u=c.length;let p=0,k="",P=!1;const M=c.charCodeAt(0);if(u===1)D(M)&&(p=1,P=!0);else if(D(M))if(P=!0,D(c.charCodeAt(1))){let I=2,B=I;for(;I<u&&!D(c.charCodeAt(I));)I++;if(I<u&&I!==B){const W=c.slice(B,I);for(B=I;I<u&&D(c.charCodeAt(I));)I++;if(I<u&&I!==B){for(B=I;I<u&&!D(c.charCodeAt(I));)I++;(I===u||I!==B)&&(k=`\\\\${W}\\${c.slice(B,I)}`,p=I)}}}else p=1;else v(M)&&c.charCodeAt(1)===m&&(k=c.slice(0,2),p=2,u>2&&D(c.charCodeAt(2))&&(P=!0,p=3));if(k.length>0)if(a.length>0){if(k.toLowerCase()!==a.toLowerCase())continue}else a=k;if(h){if(a.length>0)break}else if(A=`${c.slice(p)}\\${A}`,h=P,P&&a.length>0)break}return A=y(A,!h,"\\",D),h?`${a}\\${A}`:`${a}${A}`||"."},normalize(r){e(r,"path");const a=r.length;if(a===0)return".";let A=0,h,L=!1;const c=r.charCodeAt(0);if(a===1)return _(c)?"\\":r;if(D(c))if(L=!0,D(r.charCodeAt(1))){let p=2,k=p;for(;p<a&&!D(r.charCodeAt(p));)p++;if(p<a&&p!==k){const P=r.slice(k,p);for(k=p;p<a&&D(r.charCodeAt(p));)p++;if(p<a&&p!==k){for(k=p;p<a&&!D(r.charCodeAt(p));)p++;if(p===a)return`\\\\${P}\\${r.slice(k)}\\`;p!==k&&(h=`\\\\${P}\\${r.slice(k,p)}`,A=p)}}}else A=1;else v(c)&&r.charCodeAt(1)===m&&(h=r.slice(0,2),A=2,a>2&&D(r.charCodeAt(2))&&(L=!0,A=3));let u=A<a?y(r.slice(A),!L,"\\",D):"";return u.length===0&&!L&&(u="."),u.length>0&&D(r.charCodeAt(a-1))&&(u+="\\"),h===void 0?L?`\\${u}`:u:L?`${h}\\${u}`:`${h}${u}`},isAbsolute(r){e(r,"path");const a=r.length;if(a===0)return!1;const A=r.charCodeAt(0);return D(A)||a>2&&v(A)&&r.charCodeAt(1)===m&&D(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let a,A;for(let c=0;c<r.length;++c){const u=r[c];e(u,"path"),u.length>0&&(a===void 0?a=A=u:a+=`\\${u}`)}if(a===void 0)return".";let h=!0,L=0;if(typeof A=="string"&&D(A.charCodeAt(0))){++L;const c=A.length;c>1&&D(A.charCodeAt(1))&&(++L,c>2&&(D(A.charCodeAt(2))?++L:h=!1))}if(h){for(;L<a.length&&D(a.charCodeAt(L));)L++;L>=2&&(a=`\\${a.slice(L)}`)}return t.win32.normalize(a)},relative(r,a){if(e(r,"from"),e(a,"to"),r===a)return"";const A=t.win32.resolve(r),h=t.win32.resolve(a);if(A===h||(r=A.toLowerCase(),a=h.toLowerCase(),r===a))return"";let L=0;for(;L<r.length&&r.charCodeAt(L)===l;)L++;let c=r.length;for(;c-1>L&&r.charCodeAt(c-1)===l;)c--;const u=c-L;let p=0;for(;p<a.length&&a.charCodeAt(p)===l;)p++;let k=a.length;for(;k-1>p&&a.charCodeAt(k-1)===l;)k--;const P=k-p,M=u<P?u:P;let I=-1,B=0;for(;B<M;B++){const z=r.charCodeAt(L+B);if(z!==a.charCodeAt(p+B))break;z===l&&(I=B)}if(B!==M){if(I===-1)return h}else{if(P>M){if(a.charCodeAt(p+B)===l)return h.slice(p+B+1);if(B===2)return h.slice(p+B)}u>M&&(r.charCodeAt(L+B)===l?I=B:B===2&&(I=3)),I===-1&&(I=0)}let W="";for(B=L+I+1;B<=c;++B)(B===c||r.charCodeAt(B)===l)&&(W+=W.length===0?"..":"\\..");return p+=I,W.length>0?`${W}${h.slice(p,k)}`:(h.charCodeAt(p)===l&&++p,h.slice(p,k))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const a=t.win32.resolve(r);if(a.length<=2)return r;if(a.charCodeAt(0)===l){if(a.charCodeAt(1)===l){const A=a.charCodeAt(2);if(A!==R&&A!==g)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(v(a.charCodeAt(0))&&a.charCodeAt(1)===m&&a.charCodeAt(2)===l)return`\\\\?\\${a}`;return r},dirname(r){e(r,"path");const a=r.length;if(a===0)return".";let A=-1,h=0;const L=r.charCodeAt(0);if(a===1)return D(L)?r:".";if(D(L)){if(A=h=1,D(r.charCodeAt(1))){let p=2,k=p;for(;p<a&&!D(r.charCodeAt(p));)p++;if(p<a&&p!==k){for(k=p;p<a&&D(r.charCodeAt(p));)p++;if(p<a&&p!==k){for(k=p;p<a&&!D(r.charCodeAt(p));)p++;if(p===a)return r;p!==k&&(A=h=p+1)}}}}else v(L)&&r.charCodeAt(1)===m&&(A=a>2&&D(r.charCodeAt(2))?3:2,h=A);let c=-1,u=!0;for(let p=a-1;p>=h;--p)if(D(r.charCodeAt(p))){if(!u){c=p;break}}else u=!1;if(c===-1){if(A===-1)return".";c=A}return r.slice(0,c)},basename(r,a){a!==void 0&&e(a,"ext"),e(r,"path");let A=0,h=-1,L=!0,c;if(r.length>=2&&v(r.charCodeAt(0))&&r.charCodeAt(1)===m&&(A=2),a!==void 0&&a.length>0&&a.length<=r.length){if(a===r)return"";let u=a.length-1,p=-1;for(c=r.length-1;c>=A;--c){const k=r.charCodeAt(c);if(D(k)){if(!L){A=c+1;break}}else p===-1&&(L=!1,p=c+1),u>=0&&(k===a.charCodeAt(u)?--u===-1&&(h=c):(u=-1,h=p))}return A===h?h=p:h===-1&&(h=r.length),r.slice(A,h)}for(c=r.length-1;c>=A;--c)if(D(r.charCodeAt(c))){if(!L){A=c+1;break}}else h===-1&&(L=!1,h=c+1);return h===-1?"":r.slice(A,h)},extname(r){e(r,"path");let a=0,A=-1,h=0,L=-1,c=!0,u=0;r.length>=2&&r.charCodeAt(1)===m&&v(r.charCodeAt(0))&&(a=h=2);for(let p=r.length-1;p>=a;--p){const k=r.charCodeAt(p);if(D(k)){if(!c){h=p+1;break}continue}L===-1&&(c=!1,L=p+1),k===g?A===-1?A=p:u!==1&&(u=1):A!==-1&&(u=-1)}return A===-1||L===-1||u===0||u===1&&A===L-1&&A===h+1?"":r.slice(A,L)},format:b.bind(null,"\\"),parse(r){e(r,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return a;const A=r.length;let h=0,L=r.charCodeAt(0);if(A===1)return D(L)?(a.root=a.dir=r,a):(a.base=a.name=r,a);if(D(L)){if(h=1,D(r.charCodeAt(1))){let I=2,B=I;for(;I<A&&!D(r.charCodeAt(I));)I++;if(I<A&&I!==B){for(B=I;I<A&&D(r.charCodeAt(I));)I++;if(I<A&&I!==B){for(B=I;I<A&&!D(r.charCodeAt(I));)I++;I===A?h=I:I!==B&&(h=I+1)}}}}else if(v(L)&&r.charCodeAt(1)===m){if(A<=2)return a.root=a.dir=r,a;if(h=2,D(r.charCodeAt(2))){if(A===3)return a.root=a.dir=r,a;h=3}}h>0&&(a.root=r.slice(0,h));let c=-1,u=h,p=-1,k=!0,P=r.length-1,M=0;for(;P>=h;--P){if(L=r.charCodeAt(P),D(L)){if(!k){u=P+1;break}continue}p===-1&&(k=!1,p=P+1),L===g?c===-1?c=P:M!==1&&(M=1):c!==-1&&(M=-1)}return p!==-1&&(c===-1||M===0||M===1&&c===p-1&&c===u+1?a.base=a.name=r.slice(u,p):(a.name=r.slice(u,c),a.base=r.slice(u,p),a.ext=r.slice(c,p))),u>0&&u!==h?a.dir=r.slice(0,u-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const w=(()=>{if(N){const r=/\\/g;return()=>{const a=F.cwd().replace(r,"/");return a.slice(a.indexOf("/"))}}return()=>F.cwd()})();t.posix={resolve(...r){let a="",A=!1;for(let h=r.length-1;h>=-1&&!A;h--){const L=h>=0?r[h]:w();e(L,"path"),L.length!==0&&(a=`${L}/${a}`,A=L.charCodeAt(0)===s)}return a=y(a,!A,"/",_),A?`/${a}`:a.length>0?a:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const a=r.charCodeAt(0)===s,A=r.charCodeAt(r.length-1)===s;return r=y(r,!a,"/",_),r.length===0?a?"/":A?"./":".":(A&&(r+="/"),a?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===s},join(...r){if(r.length===0)return".";let a;for(let A=0;A<r.length;++A){const h=r[A];e(h,"path"),h.length>0&&(a===void 0?a=h:a+=`/${h}`)}return a===void 0?".":t.posix.normalize(a)},relative(r,a){if(e(r,"from"),e(a,"to"),r===a||(r=t.posix.resolve(r),a=t.posix.resolve(a),r===a))return"";const A=1,h=r.length,L=h-A,c=1,u=a.length-c,p=L<u?L:u;let k=-1,P=0;for(;P<p;P++){const I=r.charCodeAt(A+P);if(I!==a.charCodeAt(c+P))break;I===s&&(k=P)}if(P===p)if(u>p){if(a.charCodeAt(c+P)===s)return a.slice(c+P+1);if(P===0)return a.slice(c+P)}else L>p&&(r.charCodeAt(A+P)===s?k=P:P===0&&(k=0));let M="";for(P=A+k+1;P<=h;++P)(P===h||r.charCodeAt(P)===s)&&(M+=M.length===0?"..":"/..");return`${M}${a.slice(c+k)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const a=r.charCodeAt(0)===s;let A=-1,h=!0;for(let L=r.length-1;L>=1;--L)if(r.charCodeAt(L)===s){if(!h){A=L;break}}else h=!1;return A===-1?a?"/":".":a&&A===1?"//":r.slice(0,A)},basename(r,a){a!==void 0&&e(a,"ext"),e(r,"path");let A=0,h=-1,L=!0,c;if(a!==void 0&&a.length>0&&a.length<=r.length){if(a===r)return"";let u=a.length-1,p=-1;for(c=r.length-1;c>=0;--c){const k=r.charCodeAt(c);if(k===s){if(!L){A=c+1;break}}else p===-1&&(L=!1,p=c+1),u>=0&&(k===a.charCodeAt(u)?--u===-1&&(h=c):(u=-1,h=p))}return A===h?h=p:h===-1&&(h=r.length),r.slice(A,h)}for(c=r.length-1;c>=0;--c)if(r.charCodeAt(c)===s){if(!L){A=c+1;break}}else h===-1&&(L=!1,h=c+1);return h===-1?"":r.slice(A,h)},extname(r){e(r,"path");let a=-1,A=0,h=-1,L=!0,c=0;for(let u=r.length-1;u>=0;--u){const p=r.charCodeAt(u);if(p===s){if(!L){A=u+1;break}continue}h===-1&&(L=!1,h=u+1),p===g?a===-1?a=u:c!==1&&(c=1):a!==-1&&(c=-1)}return a===-1||h===-1||c===0||c===1&&a===h-1&&a===A+1?"":r.slice(a,h)},format:b.bind(null,"/"),parse(r){e(r,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return a;const A=r.charCodeAt(0)===s;let h;A?(a.root="/",h=1):h=0;let L=-1,c=0,u=-1,p=!0,k=r.length-1,P=0;for(;k>=h;--k){const M=r.charCodeAt(k);if(M===s){if(!p){c=k+1;break}continue}u===-1&&(p=!1,u=k+1),M===g?L===-1?L=k:P!==1&&(P=1):L!==-1&&(P=-1)}if(u!==-1){const M=c===0&&A?1:c;L===-1||P===0||P===1&&L===u-1&&L===c+1?a.base=a.name=r.slice(M,u):(a.name=r.slice(M,L),a.base=r.slice(M,u),a.ext=r.slice(L,u))}return c>0?a.dir=r.slice(0,c-1):A&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=N?t.win32.normalize:t.posix.normalize,t.isAbsolute=N?t.win32.isAbsolute:t.posix.isAbsolute,t.join=N?t.win32.join:t.posix.join,t.resolve=N?t.win32.resolve:t.posix.resolve,t.relative=N?t.win32.relative:t.posix.relative,t.dirname=N?t.win32.dirname:t.posix.dirname,t.basename=N?t.win32.basename:t.posix.basename,t.extname=N?t.win32.extname:t.posix.extname,t.format=N?t.win32.format:t.posix.format,t.parse=N?t.win32.parse:t.posix.parse,t.toNamespacedPath=N?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=N?t.win32.sep:t.posix.sep,t.delimiter=N?t.win32.delimiter:t.posix.delimiter}),J(K[18],ee([0,1,8]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const S=F.globals.performance&&typeof F.globals.performance.now=="function";class i{static create(E=!0){return new i(E)}constructor(E){this.a=S&&E,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?F.globals.performance.now():Date.now()}}t.StopWatch=i}),J(K[9],ee([0,1,3,15,7,17,18]),function(j,t,F,S,i,o,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const g=!1,s=!1;var l;(function(c){c.None=()=>i.Disposable.None;function u(te){if(s){const{onDidAddListener:X}=te,U=e.create();let C=0;te.onDidAddListener=()=>{++C===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),X?.()}}}function p(te,X){return Y(te,()=>{},0,void 0,!0,void 0,X)}c.defer=p;function k(te){return(X,U=null,C)=>{let O=!1,V;return V=te(H=>{if(!O)return V?V.dispose():O=!0,X.call(U,H)},null,C),O&&V.dispose(),V}}c.once=k;function P(te,X,U){return Z((C,O=null,V)=>te(H=>C.call(O,X(H)),null,V),U)}c.map=P;function M(te,X,U){return Z((C,O=null,V)=>te(H=>{X(H),C.call(O,H)},null,V),U)}c.forEach=M;function I(te,X,U){return Z((C,O=null,V)=>te(H=>X(H)&&C.call(O,H),null,V),U)}c.filter=I;function B(te){return te}c.signal=B;function W(...te){return(X,U=null,C)=>(0,i.combinedDisposable)(...te.map(O=>O(V=>X.call(U,V),null,C)))}c.any=W;function z(te,X,U,C){let O=U;return P(te,V=>(O=X(O,V),O),C)}c.reduce=z;function Z(te,X){let U;const C={onWillAddFirstListener(){U=te(O.fire,O)},onDidRemoveLastListener(){U?.dispose()}};X||u(C);const O=new D(C);return X?.add(O),O.event}function Y(te,X,U=100,C=!1,O=!1,V,H){let ne,ie,ae,ce=0,he;const Le={leakWarningThreshold:V,onWillAddFirstListener(){ne=te(Se=>{ce++,ie=X(ie,Se),C&&!ae&&(De.fire(ie),ie=void 0),he=()=>{const Ie=ie;ie=void 0,ae=void 0,(!C||ce>1)&&De.fire(Ie),ce=0},typeof U=="number"?(clearTimeout(ae),ae=setTimeout(he,U)):ae===void 0&&(ae=0,queueMicrotask(he))})},onWillRemoveListener(){O&&ce>0&&he?.()},onDidRemoveLastListener(){he=void 0,ne.dispose()}};H||u(Le);const De=new D(Le);return H?.add(De),De.event}c.debounce=Y;function G(te,X=0,U){return c.debounce(te,(C,O)=>C?(C.push(O),C):[O],X,void 0,!0,void 0,U)}c.accumulate=G;function se(te,X=(C,O)=>C===O,U){let C=!0,O;return I(te,V=>{const H=C||!X(V,O);return C=!1,O=V,H},U)}c.latch=se;function n(te,X,U){return[c.filter(te,X,U),c.filter(te,C=>!X(C),U)]}c.split=n;function me(te,X=!1,U=[]){let C=U.slice(),O=te(ne=>{C?C.push(ne):H.fire(ne)});const V=()=>{C?.forEach(ne=>H.fire(ne)),C=null},H=new D({onWillAddFirstListener(){O||(O=te(ne=>H.fire(ne)))},onDidAddFirstListener(){C&&(X?setTimeout(V):V())},onDidRemoveLastListener(){O&&O.dispose(),O=null}});return H.event}c.buffer=me;class de{constructor(X){this.event=X,this.c=new i.DisposableStore}map(X){return new de(P(this.event,X,this.c))}forEach(X){return new de(M(this.event,X,this.c))}filter(X){return new de(I(this.event,X,this.c))}reduce(X,U){return new de(z(this.event,X,U,this.c))}latch(){return new de(se(this.event,void 0,this.c))}debounce(X,U=100,C=!1,O=!1,V){return new de(Y(this.event,X,U,C,O,V,this.c))}on(X,U,C){return this.event(X,U,C)}once(X,U,C){return k(this.event)(X,U,C)}dispose(){this.c.dispose()}}function be(te){return new de(te)}c.chain=be;function we(te,X,U=C=>C){const C=(...ne)=>H.fire(U(...ne)),O=()=>te.on(X,C),V=()=>te.removeListener(X,C),H=new D({onWillAddFirstListener:O,onDidRemoveLastListener:V});return H.event}c.fromNodeEventEmitter=we;function Ne(te,X,U=C=>C){const C=(...ne)=>H.fire(U(...ne)),O=()=>te.addEventListener(X,C),V=()=>te.removeEventListener(X,C),H=new D({onWillAddFirstListener:O,onDidRemoveLastListener:V});return H.event}c.fromDOMEventEmitter=Ne;function le(te){return new Promise(X=>k(te)(X))}c.toPromise=le;function oe(te,X){return X(void 0),te(U=>X(U))}c.runAndSubscribe=oe;function Ae(te,X){let U=null;function C(V){U?.dispose(),U=new i.DisposableStore,X(V,U)}C(void 0);const O=te(V=>C(V));return(0,i.toDisposable)(()=>{O.dispose(),U?.dispose()})}c.runAndSubscribeWithStore=Ae;class ve{constructor(X,U){this._observable=X,this.c=0,this.d=!1;const C={onWillAddFirstListener:()=>{X.addObserver(this)},onDidRemoveLastListener:()=>{X.removeObserver(this)}};U||u(C),this.emitter=new D(C),U&&U.add(this.emitter)}beginUpdate(X){this.c++}handlePossibleChange(X){}handleChange(X,U){this.d=!0}endUpdate(X){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function ye(te,X){return new ve(te,X).emitter.event}c.fromObservable=ye;function Fe(te){return X=>{let U=0,C=!1;const O={beginUpdate(){U++},endUpdate(){U--,U===0&&(te.reportChanges(),C&&(C=!1,X()))},handlePossibleChange(){},handleChange(){C=!0}};return te.addObserver(O),{dispose(){te.removeObserver(O)}}}}c.fromObservableLight=Fe})(l||(t.Event=l={}));class m{constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${m.c++}`,m.all.add(this)}start(u){this.d=new E.StopWatch(!0),this.listenerCount=u}stop(){if(this.d){const u=this.d.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this.d=void 0}}}t.EventProfiling=m,m.all=new Set,m.c=0;let R=-1;function f(c){const u=R;return R=c,{dispose(){R=u}}}t.setGlobalLeakWarningThreshold=f;class d{constructor(u,p=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=p,this.d=0}dispose(){this.c?.clear()}check(u,p){const k=this.threshold;if(k<=0||p<k)return;this.c||(this.c=new Map);const P=this.c.get(u.value)||0;if(this.c.set(u.value,P+1),this.d-=1,this.d<=0){this.d=k*.5;let M,I=0;for(const[B,W]of this.c)(!M||I<W)&&(M=B,I=W);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${I}):`),console.warn(M)}return()=>{const M=this.c.get(u.value)||0;this.c.set(u.value,M-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class N{constructor(u,p,k){this.callback=u,this.callbackThis=p,this.stack=k,this.subscription=new i.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class D{constructor(u){this.j=!1,this.d=u,this.f=R>0||this.d?.leakWarningThreshold?new d(this.d?.leakWarningThreshold??R):void 0,this.g=this.d?._profName?new m(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(g){const u=Array.from(this.q);queueMicrotask(()=>{for(const p of u)p.subscription.isset()&&(p.subscription.unset(),p.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(u,p,k)=>{if(this.q||(this.q=new o.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const P=this.q.isEmpty();P&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let M,I;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(I=e.create(),M=this.f.check(I,this.q.size+1)),g&&(I=I??e.create());const B=new N(u,p,I),W=this.q.push(B);P&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,u,p);const z=B.subscription.set(()=>{M?.(),this.j||(this.d?.onWillRemoveListener?.(this),W(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return k instanceof i.DisposableStore?k.add(z):Array.isArray(k)&&k.push(z),z}),this.l}fire(u){if(this.q){this.m||(this.m=new v(this.d?.onListenerError));for(const p of this.q)this.m.push(this,p,u);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=D;class _{constructor(u=F.onUnexpectedError){this.d=u,this.c=new o.LinkedList}get size(){return this.c.size}push(u,p,k){this.c.push(new y(u,p,k))}clear(u){const p=new o.LinkedList;for(const k of this.c)k.emitter!==u&&p.push(k);this.c=p}deliver(){for(;this.c.size>0;){const u=this.c.shift();try{u.listener.invoke(u.event)}catch(p){this.d(p)}}}}t.EventDeliveryQueue=_;class v extends _{clear(u){this.c.clear()}}class y{constructor(u,p,k){this.emitter=u,this.listener=p,this.event=k}}class b extends D{async fireAsync(u,p,k){if(this.q){this.c||(this.c=new o.LinkedList);for(const P of this.q)this.c.push([P,u]);for(;this.c.size>0&&!p.isCancellationRequested;){const[P,M]=this.c.shift(),I=[],B={...M,token:p,waitUntil:W=>{if(Object.isFrozen(I))throw new Error("waitUntil can NOT be called asynchronous");k&&(W=k(W,P.callback)),I.push(W)}};try{P.invoke(B)}catch(W){(0,F.onUnexpectedError)(W);continue}Object.freeze(I),await Promise.allSettled(I).then(W=>{for(const z of W)z.status==="rejected"&&(0,F.onUnexpectedError)(z.reason)})}}}}t.AsyncEmitter=b;class w extends D{get isPaused(){return this.h!==0}constructor(u){super(u),this.h=0,this.s=new o.LinkedList,this.t=u?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const u=Array.from(this.s);this.s.clear(),super.fire(this.t(u))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(u){this.q&&(this.h!==0?this.s.push(u):super.fire(u))}}t.PauseableEmitter=w;class r extends w{constructor(u){super(u),this.c=u.delay??100}fire(u){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(u)}}t.DebounceEmitter=r;class a extends D{constructor(u){super(u),this.c=[],this.h=u?.merge}fire(u){this.hasListeners()&&(this.c.push(u),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(p=>super.fire(p)),this.c=[]}))}}t.MicrotaskEmitter=a;class A{constructor(){this.d=!1,this.f=[],this.c=new D({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(u){const p={event:u,listener:null};this.f.push(p),this.d&&this.j(p);const k=()=>{this.d&&this.k(p);const P=this.f.indexOf(p);this.f.splice(P,1)};return(0,i.toDisposable)((0,S.once)(k))}g(){this.d=!0,this.f.forEach(u=>this.j(u))}h(){this.d=!1,this.f.forEach(u=>this.k(u))}j(u){u.listener=u.event(p=>this.c.fire(p))}k(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=A;class h{constructor(){this.c=[]}wrapEvent(u){return(p,k,P)=>u(M=>{const I=this.c[this.c.length-1];I?I.push(()=>p.call(k,M)):p.call(k,M)},void 0,P)}bufferEvents(u){const p=[];this.c.push(p);const k=u();return this.c.pop(),p.forEach(P=>P()),k}}t.EventBufferer=h;class L{constructor(){this.c=!1,this.d=l.None,this.f=i.Disposable.None,this.g=new D({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(u){this.d=u,this.c&&(this.f.dispose(),this.f=u(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=L}),J(K[19],ee([0,1,9]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const S=Object.freeze(function(g,s){const l=setTimeout(g.bind(s),0);return{dispose(){clearTimeout(l)}}});var i;(function(g){function s(l){return l===g.None||l===g.Cancelled||l instanceof o?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}g.isCancellationToken=s,g.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:F.Event.None}),g.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:S})})(i||(t.CancellationToken=i={}));class o{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?S:(this.b||(this.b=new F.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class E{constructor(s){this.a=void 0,this.b=void 0,this.b=s&&s.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new o),this.a}cancel(){this.a?this.a instanceof o&&this.a.cancel():this.a=i.Cancelled}dispose(s=!1){s&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof o&&this.a.dispose():this.a=i.None}}t.CancellationTokenSource=E}),J(K[34],ee([0,1,19]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class S{constructor(g){this.b=g,this.a=null}get(){if(this.a)return this.a;const g=new F.CancellationTokenSource,s=this.b(g.token);return this.a={promise:s,dispose:()=>{this.a=null,g.cancel(),g.dispose()}},this.a}}t.Cache=S;class i{constructor(g){this.c=g,this.a=void 0,this.b=void 0}get(g){const s=JSON.stringify(g);return this.b!==s&&(this.b=s,this.a=this.c(g)),this.a}}t.LRUCachedFunction=i;class o{get cachedValues(){return this.a}constructor(g){this.b=g,this.a=new Map}get(g){if(this.a.has(g))return this.a.get(g);const s=this.b(g);return this.a.set(g,s),s}}t.CachedFunction=o}),J(K[5],ee([0,1,34,31]),function(j,t,F,S){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function o(T){return!T||typeof T!="string"?!0:T.trim().length===0}t.isFalsyOrWhitespace=o;const E=/{(\d+)}/g;function g(T,...q){return q.length===0?T:T.replace(E,function(x,$){const Q=parseInt($,10);return isNaN(Q)||Q<0||Q>=q.length?x:q[Q]})}t.format=g;const s=/{([^}]+)}/g;function l(T,q){return T.replace(s,(x,$)=>q[$]??x)}t.format2=l;function m(T){return T.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}t.escape=m;function R(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=R;function f(T,q){let x=0;const $=q.charCodeAt(0);for(let Q=T.length-1;Q>=0;Q--)T.charCodeAt(Q)===$&&x++;return x}t.count=f;function d(T,q,x="\u2026"){return T.length<=q?T:`${T.substr(0,q)}${x}`}t.truncate=d;function e(T,q=" "){const x=N(T,q);return D(x,q)}t.trim=e;function N(T,q){if(!T||!q)return T;const x=q.length;if(x===0||T.length===0)return T;let $=0;for(;T.indexOf(q,$)===$;)$=$+x;return T.substring($)}t.ltrim=N;function D(T,q){if(!T||!q)return T;const x=q.length,$=T.length;if(x===0||$===0)return T;let Q=$,re=-1;for(;re=T.lastIndexOf(q,Q-1),!(re===-1||re+x!==Q);){if(re===0)return"";Q=re}return T.substring(0,Q)}t.rtrim=D;function _(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=_;function v(T){return T.replace(/\*/g,"")}t.stripWildcards=v;function y(T,q,x={}){if(!T)throw new Error("Cannot create regex from empty string");q||(T=R(T)),x.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let $="";return x.global&&($+="g"),x.matchCase||($+="i"),x.multiline&&($+="m"),x.unicode&&($+="u"),new RegExp(T,$)}t.createRegExp=y;function b(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}t.regExpLeadsToEndlessLoop=b;function w(T){return!!T.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=w;function r(T){return(T.global?"g":"")+(T.ignoreCase?"i":"")+(T.multiline?"m":"")+(T.unicode?"u":"")}t.regExpFlags=r;function a(T){return T.split(/\r\n|\r|\n/)}t.splitLines=a;function A(T){for(let q=0,x=T.length;q<x;q++){const $=T.charCodeAt(q);if($!==32&&$!==9)return q}return-1}t.firstNonWhitespaceIndex=A;function h(T,q=0,x=T.length){for(let $=q;$<x;$++){const Q=T.charCodeAt($);if(Q!==32&&Q!==9)return T.substring(q,$)}return T.substring(q,x)}t.getLeadingWhitespace=h;function L(T,q=T.length-1){for(let x=q;x>=0;x--){const $=T.charCodeAt(x);if($!==32&&$!==9)return x}return-1}t.lastNonWhitespaceIndex=L;function c(T,q,x){const $=[];let Q=0;for(const re of T.matchAll(q)){if($.push(T.slice(Q,re.index)),re.index===void 0)throw new Error("match.index should be defined");Q=re.index+re[0].length,$.push(x(re[0],...re.slice(1),re.index,T,re.groups))}return $.push(T.slice(Q)),Promise.all($).then(re=>re.join(""))}t.replaceAsync=c;function u(T,q){return T<q?-1:T>q?1:0}t.compare=u;function p(T,q,x=0,$=T.length,Q=0,re=q.length){for(;x<$&&Q<re;x++,Q++){const Re=T.charCodeAt(x),ue=q.charCodeAt(Q);if(Re<ue)return-1;if(Re>ue)return 1}const ge=$-x,Pe=re-Q;return ge<Pe?-1:ge>Pe?1:0}t.compareSubstring=p;function k(T,q){return P(T,q,0,T.length,0,q.length)}t.compareIgnoreCase=k;function P(T,q,x=0,$=T.length,Q=0,re=q.length){for(;x<$&&Q<re;x++,Q++){let Re=T.charCodeAt(x),ue=q.charCodeAt(Q);if(Re===ue)continue;if(Re>=128||ue>=128)return p(T.toLowerCase(),q.toLowerCase(),x,$,Q,re);I(Re)&&(Re-=32),I(ue)&&(ue-=32);const pe=Re-ue;if(pe!==0)return pe}const ge=$-x,Pe=re-Q;return ge<Pe?-1:ge>Pe?1:0}t.compareSubstringIgnoreCase=P;function M(T){return T>=48&&T<=57}t.isAsciiDigit=M;function I(T){return T>=97&&T<=122}t.isLowerAsciiLetter=I;function B(T){return T>=65&&T<=90}t.isUpperAsciiLetter=B;function W(T,q){return T.length===q.length&&P(T,q)===0}t.equalsIgnoreCase=W;function z(T,q){const x=q.length;return q.length>T.length?!1:P(T,q,0,x)===0}t.startsWithIgnoreCase=z;function Z(T,q){const x=Math.min(T.length,q.length);let $;for($=0;$<x;$++)if(T.charCodeAt($)!==q.charCodeAt($))return $;return x}t.commonPrefixLength=Z;function Y(T,q){const x=Math.min(T.length,q.length);let $;const Q=T.length-1,re=q.length-1;for($=0;$<x;$++)if(T.charCodeAt(Q-$)!==q.charCodeAt(re-$))return $;return x}t.commonSuffixLength=Y;function G(T){return 55296<=T&&T<=56319}t.isHighSurrogate=G;function se(T){return 56320<=T&&T<=57343}t.isLowSurrogate=se;function n(T,q){return(T-55296<<10)+(q-56320)+65536}t.computeCodePoint=n;function me(T,q,x){const $=T.charCodeAt(x);if(G($)&&x+1<q){const Q=T.charCodeAt(x+1);if(se(Q))return n($,Q)}return $}t.getNextCodePoint=me;function de(T,q){const x=T.charCodeAt(q-1);if(se(x)&&q>1){const $=T.charCodeAt(q-2);if(G($))return n($,x)}return x}class be{get offset(){return this.e}constructor(q,x=0){this.c=q,this.d=q.length,this.e=x}setOffset(q){this.e=q}prevCodePoint(){const q=de(this.c,this.e);return this.e-=q>=65536?2:1,q}nextCodePoint(){const q=me(this.c,this.d,this.e);return this.e+=q>=65536?2:1,q}eol(){return this.e>=this.d}}t.CodePointIterator=be;class we{get offset(){return this.c.offset}constructor(q,x=0){this.c=new be(q,x)}nextGraphemeLength(){const q=_e.getInstance(),x=this.c,$=x.offset;let Q=q.getGraphemeBreakType(x.nextCodePoint());for(;!x.eol();){const re=x.offset,ge=q.getGraphemeBreakType(x.nextCodePoint());if(Ce(Q,ge)){x.setOffset(re);break}Q=ge}return x.offset-$}prevGraphemeLength(){const q=_e.getInstance(),x=this.c,$=x.offset;let Q=q.getGraphemeBreakType(x.prevCodePoint());for(;x.offset>0;){const re=x.offset,ge=q.getGraphemeBreakType(x.prevCodePoint());if(Ce(ge,Q)){x.setOffset(re);break}Q=ge}return $-x.offset}eol(){return this.c.eol()}}t.GraphemeIterator=we;function Ne(T,q){return new we(T,q).nextGraphemeLength()}t.nextCharLength=Ne;function le(T,q){return new we(T,q).prevGraphemeLength()}t.prevCharLength=le;function oe(T,q){q>0&&se(T.charCodeAt(q))&&q--;const x=q+Ne(T,q);return[x-le(T,x),x]}t.getCharContainingOffset=oe;function Ae(T){const q=new we(T);let x=0;for(;!q.eol();)x++,q.nextGraphemeLength();return x}t.charCount=Ae;let ve;function ye(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Fe(T){return ve||(ve=ye()),ve.test(T)}t.containsRTL=Fe;const te=/^[\t\n\r\x20-\x7E]*$/;function X(T){return te.test(T)}t.isBasicASCII=X,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function U(T){return t.UNUSUAL_LINE_TERMINATORS.test(T)}t.containsUnusualLineTerminators=U;function C(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}t.isFullWidthCharacter=C;function O(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}t.isEmojiImprecise=O;function V(T,q){if(T.length<q)return T;const x=/\b/g;let $=0;for(;x.test(T)&&!(T.length-x.lastIndex<q);)$=x.lastIndex,x.lastIndex+=1;return T.substring($).replace(/^\s/,"")}t.lcut=V;const H=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ne=/\x1b\].*?\x07/g;function ie(T){return T&&(T=T.replace(H,"").replace(ne,"")),T}t.removeAnsiEscapeCodes=ie,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}t.startsWithUTF8BOM=ae;function ce(T){return ae(T)?T.substr(1):T}t.stripUTF8BOM=ce;function he(T,q){if(!T||!q||T.length<q.length)return!1;const x=q.length,$=T.toLowerCase();let Q=0,re=-1;for(;Q<x;){const ge=$.indexOf(q[Q],re+1);if(ge<0)return!1;re=ge,Q++}return!0}t.fuzzyContains=he;function Le(T,q=!1){return T?(q&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}t.containsUppercaseCharacter=Le;function De(T){return T.charAt(0).toUpperCase()+T.slice(1)}t.uppercaseFirstLetter=De;function Se(T,q=1){if(q===0)return"";let x=-1;do x=T.indexOf(`
`,x+1),q--;while(q>0&&x>=0);return x===-1?T:(T[x-1]==="\r"&&x--,T.substr(0,x))}t.getNLines=Se;function Ie(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}t.singleLetterHash=Ie;function Ve(T){return _e.getInstance().getGraphemeBreakType(T)}t.getGraphemeBreakType=Ve;function Ce(T,q){return T===0?q!==5&&q!==7:T===2&&q===3?!1:T===4||T===2||T===3||q===4||q===2||q===3?!0:!(T===8&&(q===8||q===9||q===11||q===12)||(T===11||T===9)&&(q===9||q===10)||(T===12||T===10)&&q===10||q===5||q===13||q===7||T===1||T===13&&q===14||T===6&&q===6)}var Oe;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(t.GraphemeBreakType=Oe={}));class _e{static getInstance(){return _e.c||(_e.c=new _e),_e.c}constructor(){this.d=je()}getGraphemeBreakType(q){if(q<32)return q===10?3:q===13?2:4;if(q<127)return 0;const x=this.d,$=x.length/3;let Q=1;for(;Q<=$;)if(q<x[3*Q])Q=2*Q;else if(q>x[3*Q+1])Q=2*Q+1;else return x[3*Q+2];return 0}}_e.c=null;function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(T,q){if(T===0)return 0;const x=He(T,q);if(x!==void 0)return x;const $=new be(q,T);return $.prevCodePoint(),$.offset}t.getLeftDeleteOffset=xe;function He(T,q){const x=new be(q,T);let $=x.prevCodePoint();for(;ze($)||$===65039||$===8419;){if(x.offset===0)return;$=x.prevCodePoint()}if(!O($))return;let Q=x.offset;return Q>0&&x.prevCodePoint()===8205&&(Q=x.offset),Q}function ze(T){return 127995<=T&&T<=127999}var Be;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),t.noBreakWhitespace="\xA0";class Ee{static getInstance(q){return Ee.d.get(Array.from(q))}static getLocales(){return Ee.e.value}constructor(q){this.f=q}isAmbiguous(q){return this.f.has(q)}getPrimaryConfusable(q){return this.f.get(q)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.AmbiguousCharacters=Ee,i=Ee,Ee.c=new S.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ee.d=new F.LRUCachedFunction(T=>{function q(ue){const pe=new Map;for(let Me=0;Me<ue.length;Me+=2)pe.set(ue[Me],ue[Me+1]);return pe}function x(ue,pe){const Me=new Map(ue);for(const[Te,Ue]of pe)Me.set(Te,Ue);return Me}function $(ue,pe){if(!ue)return pe;const Me=new Map;for(const[Te,Ue]of ue)pe.has(Te)&&Me.set(Te,Ue);return Me}const Q=i.c.value;let re=T.filter(ue=>!ue.startsWith("_")&&ue in Q);re.length===0&&(re=["_default"]);let ge;for(const ue of re){const pe=q(Q[ue]);ge=$(ge,pe)}const Pe=q(Q._common),Re=x(Pe,ge);return new Ee(Re)}),Ee.e=new S.Lazy(()=>Object.keys(Ee.c.value).filter(T=>!T.startsWith("_")));class ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ke.c())),this.d}static isInvisibleCharacter(q){return ke.e().has(q)}static get codePoints(){return ke.e()}}t.InvisibleCharacters=ke,ke.d=void 0}),J(K[35],ee([0,1,5]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function S(_){return i(_,0)}t.hash=S;function i(_,v){switch(typeof _){case"object":return _===null?o(349,v):Array.isArray(_)?s(_,v):l(_,v);case"string":return g(_,v);case"boolean":return E(_,v);case"number":return o(_,v);case"undefined":return o(937,v);default:return o(617,v)}}t.doHash=i;function o(_,v){return(v<<5)-v+_|0}t.numberHash=o;function E(_,v){return o(_?433:863,v)}function g(_,v){v=o(149417,v);for(let y=0,b=_.length;y<b;y++)v=o(_.charCodeAt(y),v);return v}t.stringHash=g;function s(_,v){return v=o(104579,v),_.reduce((y,b)=>i(b,y),v)}function l(_,v){return v=o(181387,v),Object.keys(_).sort().reduce((y,b)=>(y=g(b,y),i(_[b],y)),v)}class m{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=i(v,this.g),this.g}}t.Hasher=m;var R;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function f(_,v,y=32){const b=y-v,w=~((1<<b)-1);return(_<<v|(w&_)>>>b)>>>0}function d(_,v=0,y=_.byteLength,b=0){for(let w=0;w<y;w++)_[v+w]=b}function e(_,v,y="0"){for(;_.length<v;)_=y+_;return _}function N(_,v=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(y=>y.toString(16).padStart(2,"0")).join(""):e((_>>>0).toString(16),v/4)}t.toHexString=N;class D{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const y=v.length;if(y===0)return;const b=this.p;let w=this.r,r=this.u,a,A;for(r!==0?(a=r,A=-1,r=0):(a=v.charCodeAt(0),A=0);;){let h=a;if(F.isHighSurrogate(a))if(A+1<y){const L=v.charCodeAt(A+1);F.isLowSurrogate(L)?(A++,h=F.computeCodePoint(a,L)):h=65533}else{r=a;break}else F.isLowSurrogate(a)&&(h=65533);if(w=this.w(b,w,h),A++,A<y)a=v.charCodeAt(A);else break}this.r=w,this.u=r}w(v,y,b){return b<128?v[y++]=b:b<2048?(v[y++]=192|(b&1984)>>>6,v[y++]=128|(b&63)>>>0):b<65536?(v[y++]=224|(b&61440)>>>12,v[y++]=128|(b&4032)>>>6,v[y++]=128|(b&63)>>>0):(v[y++]=240|(b&1835008)>>>18,v[y++]=128|(b&258048)>>>12,v[y++]=128|(b&4032)>>>6,v[y++]=128|(b&63)>>>0),y>=64&&(this.y(),y-=64,this.t+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),y}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),N(this.h)+N(this.l)+N(this.m)+N(this.n)+N(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=D.g,y=this.q;for(let u=0;u<64;u+=4)v.setUint32(u,y.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)v.setUint32(u,f(v.getUint32(u-12,!1)^v.getUint32(u-32,!1)^v.getUint32(u-56,!1)^v.getUint32(u-64,!1),1),!1);let b=this.h,w=this.l,r=this.m,a=this.n,A=this.o,h,L,c;for(let u=0;u<80;u++)u<20?(h=w&r|~w&a,L=1518500249):u<40?(h=w^r^a,L=1859775393):u<60?(h=w&r|w&a|r&a,L=2400959708):(h=w^r^a,L=3395469782),c=f(b,5)+h+A+L+v.getUint32(u*4,!1)&4294967295,A=a,a=r,r=f(w,30),w=b,b=c;this.h=this.h+b&4294967295,this.l=this.l+w&4294967295,this.m=this.m+r&4294967295,this.n=this.n+a&4294967295,this.o=this.o+A&4294967295}}t.StringSHA1=D,D.g=new DataView(new ArrayBuffer(320))}),J(K[20],ee([0,1,28,35]),function(j,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(f){this.a=f}getElements(){const f=this.a,d=new Int32Array(f.length);for(let e=0,N=f.length;e<N;e++)d[e]=f.charCodeAt(e);return d}}t.StringDiffSequence=i;function o(R,f,d){return new m(new i(R),new i(f)).ComputeDiff(d).changes}t.stringDiff=o;class E{static Assert(f,d){if(!f)throw new Error(d)}}class g{static Copy(f,d,e,N,D){for(let _=0;_<D;_++)e[N+_]=f[d+_]}static Copy2(f,d,e,N,D){for(let _=0;_<D;_++)e[N+_]=f[d+_]}}var s;(function(R){R[R.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(s||(s={}));class l{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new F.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(f,d){this.b=Math.min(this.b,f),this.c=Math.min(this.c,d),this.d++}AddModifiedElement(f,d){this.b=Math.min(this.b,f),this.c=Math.min(this.c,d),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class m{constructor(f,d,e=null){this.a=e,this.b=f,this.c=d;const[N,D,_]=m.o(f),[v,y,b]=m.o(d);this.d=_&&b,this.e=N,this.f=D,this.g=v,this.h=y,this.k=[],this.m=[]}static n(f){return f.length>0&&typeof f[0]=="string"}static o(f){const d=f.getElements();if(m.n(d)){const e=new Int32Array(d.length);for(let N=0,D=d.length;N<D;N++)e[N]=(0,S.stringHash)(d[N],0);return[d,e,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}p(f,d){return this.f[f]!==this.h[d]?!1:this.d?this.e[f]===this.g[d]:!0}q(f,d){if(!this.p(f,d))return!1;const e=m.r(this.b,f),N=m.r(this.c,d);return e===N}static r(f,d){return typeof f.getStrictElement=="function"?f.getStrictElement(d):null}s(f,d){return this.f[f]!==this.f[d]?!1:this.d?this.e[f]===this.e[d]:!0}u(f,d){return this.h[f]!==this.h[d]?!1:this.d?this.g[f]===this.g[d]:!0}ComputeDiff(f){return this.v(0,this.f.length-1,0,this.h.length-1,f)}v(f,d,e,N,D){const _=[!1];let v=this.w(f,d,e,N,_);return D&&(v=this.z(v)),{quitEarly:_[0],changes:v}}w(f,d,e,N,D){for(D[0]=!1;f<=d&&e<=N&&this.p(f,e);)f++,e++;for(;d>=f&&N>=e&&this.p(d,N);)d--,N--;if(f>d||e>N){let r;return e<=N?(E.Assert(f===d+1,"originalStart should only be one more than originalEnd"),r=[new F.DiffChange(f,0,e,N-e+1)]):f<=d?(E.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),r=[new F.DiffChange(f,d-f+1,e,0)]):(E.Assert(f===d+1,"originalStart should only be one more than originalEnd"),E.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const _=[0],v=[0],y=this.y(f,d,e,N,_,v,D),b=_[0],w=v[0];if(y!==null)return y;if(!D[0]){const r=this.w(f,b,e,w,D);let a=[];return D[0]?a=[new F.DiffChange(b+1,d-(b+1)+1,w+1,N-(w+1)+1)]:a=this.w(b+1,d,w+1,N,D),this.H(r,a)}return[new F.DiffChange(f,d-f+1,e,N-e+1)]}x(f,d,e,N,D,_,v,y,b,w,r,a,A,h,L,c,u,p){let k=null,P=null,M=new l,I=d,B=e,W=A[0]-c[0]-N,z=-1073741824,Z=this.k.length-1;do{const Y=W+f;Y===I||Y<B&&b[Y-1]<b[Y+1]?(r=b[Y+1],h=r-W-N,r<z&&M.MarkNextChange(),z=r,M.AddModifiedElement(r+1,h),W=Y+1-f):(r=b[Y-1]+1,h=r-W-N,r<z&&M.MarkNextChange(),z=r-1,M.AddOriginalElement(r,h+1),W=Y-1-f),Z>=0&&(b=this.k[Z],f=b[0],I=1,B=b.length-1)}while(--Z>=-1);if(k=M.getReverseChanges(),p[0]){let Y=A[0]+1,G=c[0]+1;if(k!==null&&k.length>0){const se=k[k.length-1];Y=Math.max(Y,se.getOriginalEnd()),G=Math.max(G,se.getModifiedEnd())}P=[new F.DiffChange(Y,a-Y+1,G,L-G+1)]}else{M=new l,I=_,B=v,W=A[0]-c[0]-y,z=1073741824,Z=u?this.m.length-1:this.m.length-2;do{const Y=W+D;Y===I||Y<B&&w[Y-1]>=w[Y+1]?(r=w[Y+1]-1,h=r-W-y,r>z&&M.MarkNextChange(),z=r+1,M.AddOriginalElement(r+1,h+1),W=Y+1-D):(r=w[Y-1],h=r-W-y,r>z&&M.MarkNextChange(),z=r,M.AddModifiedElement(r+1,h+1),W=Y-1-D),Z>=0&&(w=this.m[Z],D=w[0],I=1,B=w.length-1)}while(--Z>=-1);P=M.getChanges()}return this.H(k,P)}y(f,d,e,N,D,_,v){let y=0,b=0,w=0,r=0,a=0,A=0;f--,e--,D[0]=0,_[0]=0,this.k=[],this.m=[];const h=d-f+(N-e),L=h+1,c=new Int32Array(L),u=new Int32Array(L),p=N-e,k=d-f,P=f-e,M=d-N,B=(k-p)%2===0;c[p]=f,u[k]=d,v[0]=!1;for(let W=1;W<=h/2+1;W++){let z=0,Z=0;w=this.J(p-W,W,p,L),r=this.J(p+W,W,p,L);for(let G=w;G<=r;G+=2){G===w||G<r&&c[G-1]<c[G+1]?y=c[G+1]:y=c[G-1]+1,b=y-(G-p)-P;const se=y;for(;y<d&&b<N&&this.p(y+1,b+1);)y++,b++;if(c[G]=y,y+b>z+Z&&(z=y,Z=b),!B&&Math.abs(G-k)<=W-1&&y>=u[G])return D[0]=y,_[0]=b,se<=u[G]&&1447>0&&W<=1447+1?this.x(p,w,r,P,k,a,A,M,c,u,y,d,D,b,N,_,B,v):null}const Y=(z-f+(Z-e)-W)/2;if(this.a!==null&&!this.a(z,Y))return v[0]=!0,D[0]=z,_[0]=Z,Y>0&&1447>0&&W<=1447+1?this.x(p,w,r,P,k,a,A,M,c,u,y,d,D,b,N,_,B,v):(f++,e++,[new F.DiffChange(f,d-f+1,e,N-e+1)]);a=this.J(k-W,W,k,L),A=this.J(k+W,W,k,L);for(let G=a;G<=A;G+=2){G===a||G<A&&u[G-1]>=u[G+1]?y=u[G+1]-1:y=u[G-1],b=y-(G-k)-M;const se=y;for(;y>f&&b>e&&this.p(y,b);)y--,b--;if(u[G]=y,B&&Math.abs(G-p)<=W&&y<=c[G])return D[0]=y,_[0]=b,se>=c[G]&&1447>0&&W<=1447+1?this.x(p,w,r,P,k,a,A,M,c,u,y,d,D,b,N,_,B,v):null}if(W<=1447){let G=new Int32Array(r-w+2);G[0]=p-w+1,g.Copy2(c,w,G,1,r-w+1),this.k.push(G),G=new Int32Array(A-a+2),G[0]=k-a+1,g.Copy2(u,a,G,1,A-a+1),this.m.push(G)}}return this.x(p,w,r,P,k,a,A,M,c,u,y,d,D,b,N,_,B,v)}z(f){for(let d=0;d<f.length;d++){const e=f[d],N=d<f.length-1?f[d+1].originalStart:this.f.length,D=d<f.length-1?f[d+1].modifiedStart:this.h.length,_=e.originalLength>0,v=e.modifiedLength>0;for(;e.originalStart+e.originalLength<N&&e.modifiedStart+e.modifiedLength<D&&(!_||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!v||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const y=[null];if(d<f.length-1&&this.I(f[d],f[d+1],y)){f[d]=y[0],f.splice(d+1,1),d--;continue}}for(let d=f.length-1;d>=0;d--){const e=f[d];let N=0,D=0;if(d>0){const r=f[d-1];N=r.originalStart+r.originalLength,D=r.modifiedStart+r.modifiedLength}const _=e.originalLength>0,v=e.modifiedLength>0;let y=0,b=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const a=e.originalStart-r,A=e.modifiedStart-r;if(a<N||A<D||_&&!this.s(a,a+e.originalLength)||v&&!this.u(A,A+e.modifiedLength))break;const L=(a===N&&A===D?5:0)+this.G(a,e.originalLength,A,e.modifiedLength);L>b&&(b=L,y=r)}e.originalStart-=y,e.modifiedStart-=y;const w=[null];if(d>0&&this.I(f[d-1],f[d],w)){f[d-1]=w[0],f.splice(d,1),d++;continue}}if(this.d)for(let d=1,e=f.length;d<e;d++){const N=f[d-1],D=f[d],_=D.originalStart-N.originalStart-N.originalLength,v=N.originalStart,y=D.originalStart+D.originalLength,b=y-v,w=N.modifiedStart,r=D.modifiedStart+D.modifiedLength,a=r-w;if(_<5&&b<20&&a<20){const A=this.A(v,b,w,a,_);if(A){const[h,L]=A;(h!==N.originalStart+N.originalLength||L!==N.modifiedStart+N.modifiedLength)&&(N.originalLength=h-N.originalStart,N.modifiedLength=L-N.modifiedStart,D.originalStart=h+_,D.modifiedStart=L+_,D.originalLength=y-D.originalStart,D.modifiedLength=r-D.modifiedStart)}}}return f}A(f,d,e,N,D){if(d<D||N<D)return null;const _=f+d-D+1,v=e+N-D+1;let y=0,b=0,w=0;for(let r=f;r<_;r++)for(let a=e;a<v;a++){const A=this.B(r,a,D);A>0&&A>y&&(y=A,b=r,w=a)}return y>0?[b,w]:null}B(f,d,e){let N=0;for(let D=0;D<e;D++){if(!this.p(f+D,d+D))return 0;N+=this.e[f+D].length}return N}C(f){return f<=0||f>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[f])}D(f,d){if(this.C(f)||this.C(f-1))return!0;if(d>0){const e=f+d;if(this.C(e-1)||this.C(e))return!0}return!1}E(f){return f<=0||f>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[f])}F(f,d){if(this.E(f)||this.E(f-1))return!0;if(d>0){const e=f+d;if(this.E(e-1)||this.E(e))return!0}return!1}G(f,d,e,N){const D=this.D(f,d)?1:0,_=this.F(e,N)?1:0;return D+_}H(f,d){const e=[];if(f.length===0||d.length===0)return d.length>0?d:f;if(this.I(f[f.length-1],d[0],e)){const N=new Array(f.length+d.length-1);return g.Copy(f,0,N,0,f.length-1),N[f.length-1]=e[0],g.Copy(d,1,N,f.length,d.length-1),N}else{const N=new Array(f.length+d.length);return g.Copy(f,0,N,0,f.length),g.Copy(d,0,N,f.length,d.length),N}}I(f,d,e){if(E.Assert(f.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),E.Assert(f.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),f.originalStart+f.originalLength>=d.originalStart||f.modifiedStart+f.modifiedLength>=d.modifiedStart){const N=f.originalStart;let D=f.originalLength;const _=f.modifiedStart;let v=f.modifiedLength;return f.originalStart+f.originalLength>=d.originalStart&&(D=d.originalStart+d.originalLength-f.originalStart),f.modifiedStart+f.modifiedLength>=d.modifiedStart&&(v=d.modifiedStart+d.modifiedLength-f.modifiedStart),e[0]=new F.DiffChange(N,D,_,v),!0}else return e[0]=null,!1}J(f,d,e,N){if(f>=0&&f<N)return f;const D=e,_=N-e-1,v=d%2===0;if(f<0){const y=D%2===0;return v===y?0:1}else{const y=_%2===0;return v===y?N-1:N-2}}}t.LcsDiff=m}),J(K[21],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function F(a){return typeof a=="string"}t.isString=F;function S(a){return Array.isArray(a)&&a.every(A=>F(A))}t.isStringArray=S;function i(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}t.isObject=i;function o(a){const A=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof A}t.isTypedArray=o;function E(a){return typeof a=="number"&&!isNaN(a)}t.isNumber=E;function g(a){return!!a&&typeof a[Symbol.iterator]=="function"}t.isIterable=g;function s(a){return a===!0||a===!1}t.isBoolean=s;function l(a){return typeof a>"u"}t.isUndefined=l;function m(a){return!R(a)}t.isDefined=m;function R(a){return l(a)||a===null}t.isUndefinedOrNull=R;function f(a,A){if(!a)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}t.assertType=f;function d(a){if(R(a))throw new Error("Assertion Failed: argument is undefined or null");return a}t.assertIsDefined=d;function e(...a){const A=[];for(let h=0;h<a.length;h++){const L=a[h];if(R(L))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);A.push(L)}return A}t.assertAllDefined=e;const N=Object.prototype.hasOwnProperty;function D(a){if(!i(a))return!1;for(const A in a)if(N.call(a,A))return!1;return!0}t.isEmptyObject=D;function _(a){return typeof a=="function"}t.isFunction=_;function v(...a){return a.length>0&&a.every(_)}t.areFunctions=v;function y(a,A){const h=Math.min(a.length,A.length);for(let L=0;L<h;L++)b(a[L],A[L])}t.validateConstraints=y;function b(a,A){if(F(A)){if(typeof a!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(_(A)){try{if(a instanceof A)return}catch{}if(!R(a)&&a.constructor===A||A.length===1&&A.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=b;function w(a){return a===null?void 0:a}t.withNullAsUndefined=w;function r(a){return typeof a>"u"?null:a}t.withUndefinedAsNull=r}),J(K[36],ee([0,1,21]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const S=Object.create(null);function i(g,s){if((0,F.isString)(s)){const l=S[s];if(l===void 0)throw new Error(`${g} references an unknown codicon: ${s}`);s=l}return S[g]=s,{id:g}}function o(){return S}t.getCodiconFontCharacters=o;function E(){return Object.values(t.Codicon)}t.getAllCodicons=E,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),J(K[12],ee([0,1,21]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function S(_){if(!_||typeof _!="object"||_ instanceof RegExp)return _;const v=Array.isArray(_)?[]:{};return Object.entries(_).forEach(([y,b])=>{v[y]=b&&typeof b=="object"?S(b):b}),v}t.deepClone=S;function i(_){if(!_||typeof _!="object")return _;const v=[_];for(;v.length>0;){const y=v.shift();Object.freeze(y);for(const b in y)if(o.call(y,b)){const w=y[b];typeof w=="object"&&!Object.isFrozen(w)&&!(0,F.isTypedArray)(w)&&v.push(w)}}return _}t.deepFreeze=i;const o=Object.prototype.hasOwnProperty;function E(_,v){return g(_,v,new Set)}t.cloneAndChange=E;function g(_,v,y){if((0,F.isUndefinedOrNull)(_))return _;const b=v(_);if(typeof b<"u")return b;if(Array.isArray(_)){const w=[];for(const r of _)w.push(g(r,v,y));return w}if((0,F.isObject)(_)){if(y.has(_))throw new Error("Cannot clone recursive data-structure");y.add(_);const w={};for(const r in _)o.call(_,r)&&(w[r]=g(_[r],v,y));return y.delete(_),w}return _}function s(_,v,y=!0){return(0,F.isObject)(_)?((0,F.isObject)(v)&&Object.keys(v).forEach(b=>{b in _?y&&((0,F.isObject)(_[b])&&(0,F.isObject)(v[b])?s(_[b],v[b],y):_[b]=v[b]):_[b]=v[b]}),_):v}t.mixin=s;function l(_,v){if(_===v)return!0;if(_==null||v===null||v===void 0||typeof _!=typeof v||typeof _!="object"||Array.isArray(_)!==Array.isArray(v))return!1;let y,b;if(Array.isArray(_)){if(_.length!==v.length)return!1;for(y=0;y<_.length;y++)if(!l(_[y],v[y]))return!1}else{const w=[];for(b in _)w.push(b);w.sort();const r=[];for(b in v)r.push(b);if(r.sort(),!l(w,r))return!1;for(y=0;y<w.length;y++)if(!l(_[w[y]],v[w[y]]))return!1}return!0}t.equals=l;function m(_){const v=new Set;return JSON.stringify(_,(y,b)=>{if((0,F.isObject)(b)||Array.isArray(b)){if(v.has(b))return"[Circular]";v.add(b)}return b})}t.safeStringify=m;function R(_,v){const y=Object.create(null);return!_||!v||Object.keys(v).forEach(w=>{const r=_[w],a=v[w];l(r,a)||(y[w]=a)}),y}t.distinct=R;function f(_,v){const y=v.toLowerCase(),b=Object.keys(_).find(w=>w.toLowerCase()===y);return b?_[b]:_[v]}t.getCaseInsensitive=f;function d(_,v){const y=Object.create(null);for(const[b,w]of Object.entries(_))v(b,w)&&(y[b]=w);return y}t.filter=d;function e(_){let v=[],y=Object.getPrototypeOf(_);for(;Object.prototype!==y;)v=v.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return v}t.getAllPropertyNames=e;function N(_){const v=[];for(const y of e(_))typeof _[y]=="function"&&v.push(y);return v}t.getAllMethodNames=N;function D(_,v){const y=w=>function(){const r=Array.prototype.slice.call(arguments,0);return v(w,r)},b={};for(const w of _)b[w]=y(w);return b}t.createProxyObject=D}),J(K[22],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var F;(function(o){o[o.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",o[o.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",o[o.MAX_UINT_8=255]="MAX_UINT_8",o[o.MAX_UINT_16=65535]="MAX_UINT_16",o[o.MAX_UINT_32=4294967295]="MAX_UINT_32",o[o.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(F||(t.Constants=F={}));function S(o){return o<0?0:o>255?255:o|0}t.toUint8=S;function i(o){return o<0?0:o>4294967295?4294967295:o|0}t.toUint32=i}),J(K[13],ee([0,1,33,8]),function(j,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.isUriComponents=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,o=/^\//,E=/^\/\//;function g(h,L){if(!h.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!i.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!o.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function s(h,L){return!h&&!L?"file":h}function l(h,L){switch(h){case"https":case"http":case"file":L?L[0]!==R&&(L=R+L):L=R;break}return L}const m="",R="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(L){return L instanceof d?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,c,u,p,k,P=!1){typeof L=="object"?(this.scheme=L.scheme||m,this.authority=L.authority||m,this.path=L.path||m,this.query=L.query||m,this.fragment=L.fragment||m):(this.scheme=s(L,P),this.authority=c||m,this.path=l(this.scheme,u||m),this.query=p||m,this.fragment=k||m,g(this,P))}get fsPath(){return b(this,!1)}with(L){if(!L)return this;let{scheme:c,authority:u,path:p,query:k,fragment:P}=L;return c===void 0?c=this.scheme:c===null&&(c=m),u===void 0?u=this.authority:u===null&&(u=m),p===void 0?p=this.path:p===null&&(p=m),k===void 0?k=this.query:k===null&&(k=m),P===void 0?P=this.fragment:P===null&&(P=m),c===this.scheme&&u===this.authority&&p===this.path&&k===this.query&&P===this.fragment?this:new D(c,u,p,k,P)}static parse(L,c=!1){const u=f.exec(L);return u?new D(u[2]||m,A(u[4]||m),A(u[5]||m),A(u[7]||m),A(u[9]||m),c):new D(m,m,m,m,m)}static file(L){let c=m;if(S.isWindows&&(L=L.replace(/\\/g,R)),L[0]===R&&L[1]===R){const u=L.indexOf(R,2);u===-1?(c=L.substring(2),L=R):(c=L.substring(2,u),L=L.substring(u)||R)}return new D("file",c,L,m,m)}static from(L,c){return new D(L.scheme,L.authority,L.path,L.query,L.fragment,c)}static joinPath(L,...c){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return S.isWindows&&L.scheme==="file"?u=d.file(F.win32.join(b(L,!0),...c)).path:u=F.posix.join(L.path,...c),L.with({path:u})}toString(L=!1){return w(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof d)return L;{const c=new D(L);return c._formatted=L.external??null,c._fsPath=L._sep===N?L.fsPath??null:null,c}}else return L}}t.URI=d;function e(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}t.isUriComponents=e;const N=S.isWindows?1:void 0;class D extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(L=!1){return L?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=N),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(h,L,c){let u,p=-1;for(let k=0;k<h.length;k++){const P=h.charCodeAt(k);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||L&&P===47||c&&P===91||c&&P===93||c&&P===58)p!==-1&&(u+=encodeURIComponent(h.substring(p,k)),p=-1),u!==void 0&&(u+=h.charAt(k));else{u===void 0&&(u=h.substr(0,k));const M=_[P];M!==void 0?(p!==-1&&(u+=encodeURIComponent(h.substring(p,k)),p=-1),u+=M):p===-1&&(p=k)}}return p!==-1&&(u+=encodeURIComponent(h.substring(p))),u!==void 0?u:h}function y(h){let L;for(let c=0;c<h.length;c++){const u=h.charCodeAt(c);u===35||u===63?(L===void 0&&(L=h.substr(0,c)),L+=_[u]):L!==void 0&&(L+=h[c])}return L!==void 0?L:h}function b(h,L){let c;return h.authority&&h.path.length>1&&h.scheme==="file"?c=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===47&&(h.path.charCodeAt(1)>=65&&h.path.charCodeAt(1)<=90||h.path.charCodeAt(1)>=97&&h.path.charCodeAt(1)<=122)&&h.path.charCodeAt(2)===58?L?c=h.path.substr(1):c=h.path[1].toLowerCase()+h.path.substr(2):c=h.path,S.isWindows&&(c=c.replace(/\//g,"\\")),c}t.uriToFsPath=b;function w(h,L){const c=L?y:v;let u="",{scheme:p,authority:k,path:P,query:M,fragment:I}=h;if(p&&(u+=p,u+=":"),(k||p==="file")&&(u+=R,u+=R),k){let B=k.indexOf("@");if(B!==-1){const W=k.substr(0,B);k=k.substr(B+1),B=W.lastIndexOf(":"),B===-1?u+=c(W,!1,!1):(u+=c(W.substr(0,B),!1,!1),u+=":",u+=c(W.substr(B+1),!1,!0)),u+="@"}k=k.toLowerCase(),B=k.lastIndexOf(":"),B===-1?u+=c(k,!1,!0):(u+=c(k.substr(0,B),!1,!0),u+=k.substr(B))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const B=P.charCodeAt(1);B>=65&&B<=90&&(P=`/${String.fromCharCode(B+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const B=P.charCodeAt(0);B>=65&&B<=90&&(P=`${String.fromCharCode(B+32)}:${P.substr(2)}`)}u+=c(P,!0,!1)}return M&&(u+="?",u+=c(M,!1,!1)),I&&(u+="#",u+=L?I:v(I,!1,!1)),u}function r(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+r(h.substr(3)):h}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function A(h){return h.match(a)?h.replace(a,L=>r(L)):h}}),J(K[58],ee([0,1,3,9,7,12,8,5]),function(j,t,F,S,i,o,E,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const s="$initialize";let l=!1;function m(A){E.isWeb&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(A.message))}t.logOnceWebWorkerWarning=m;var R;(function(A){A[A.Request=0]="Request",A[A.Reply=1]="Reply",A[A.SubscribeEvent=2]="SubscribeEvent",A[A.Event=3]="Event",A[A.UnsubscribeEvent=4]="UnsubscribeEvent"})(R||(R={}));class f{constructor(h,L,c,u){this.vsWorker=h,this.req=L,this.method=c,this.args=u,this.type=0}}class d{constructor(h,L,c,u){this.vsWorker=h,this.seq=L,this.res=c,this.err=u,this.type=1}}class e{constructor(h,L,c,u){this.vsWorker=h,this.req=L,this.eventName=c,this.arg=u,this.type=2}}class N{constructor(h,L,c){this.vsWorker=h,this.req=L,this.event=c,this.type=3}}class D{constructor(h,L){this.vsWorker=h,this.req=L,this.type=4}}class _{constructor(h){this.a=-1,this.g=h,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(h){this.a=h}sendMessage(h,L){const c=String(++this.b);return new Promise((u,p)=>{this.c[c]={resolve:u,reject:p},this.o(new f(this.a,c,h,L))})}listen(h,L){let c=null;const u=new S.Emitter({onWillAddFirstListener:()=>{c=String(++this.b),this.d.set(c,u),this.o(new e(this.a,c,h,L))},onDidRemoveLastListener:()=>{this.d.delete(c),this.o(new D(this.a,c)),c=null}});return u.event}handleMessage(h){!h||!h.vsWorker||this.a!==-1&&h.vsWorker!==this.a||this.h(h)}h(h){switch(h.type){case 1:return this.j(h);case 0:return this.k(h);case 2:return this.l(h);case 3:return this.m(h);case 4:return this.n(h)}}j(h){if(!this.c[h.seq]){console.warn("Got reply to unknown seq");return}const L=this.c[h.seq];if(delete this.c[h.seq],h.err){let c=h.err;h.err.$isError&&(c=new Error,c.name=h.err.name,c.message=h.err.message,c.stack=h.err.stack),L.reject(c);return}L.resolve(h.res)}k(h){const L=h.req;this.g.handleMessage(h.method,h.args).then(u=>{this.o(new d(this.a,L,u,void 0))},u=>{u.detail instanceof Error&&(u.detail=(0,F.transformErrorForSerialization)(u.detail)),this.o(new d(this.a,L,void 0,(0,F.transformErrorForSerialization)(u)))})}l(h){const L=h.req,c=this.g.handleEvent(h.eventName,h.arg)(u=>{this.o(new N(this.a,L,u))});this.f.set(L,c)}m(h){if(!this.d.has(h.req)){console.warn("Got event for unknown req");return}this.d.get(h.req).fire(h.event)}n(h){if(!this.f.has(h.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(h.req).dispose(),this.f.delete(h.req)}o(h){const L=[];if(h.type===0)for(let c=0;c<h.args.length;c++)h.args[c]instanceof ArrayBuffer&&L.push(h.args[c]);else h.type===1&&h.res instanceof ArrayBuffer&&L.push(h.res);this.g.sendMessage(h,L)}}class v extends i.Disposable{constructor(h,L,c){super();let u=null;this.a=this.B(h.create("vs/base/common/worker/simpleWorker",B=>{this.c.handleMessage(B)},B=>{u?.(B)})),this.c=new _({sendMessage:(B,W)=>{this.a.postMessage(B,W)},handleMessage:(B,W)=>{if(typeof c[B]!="function")return Promise.reject(new Error("Missing method "+B+" on main thread host."));try{return Promise.resolve(c[B].apply(c,W))}catch(z){return Promise.reject(z)}},handleEvent:(B,W)=>{if(b(B)){const z=c[B].call(c,W);if(typeof z!="function")throw new Error(`Missing dynamic event ${B} on main thread host.`);return z}if(y(B)){const z=c[B];if(typeof z!="function")throw new Error(`Missing event ${B} on main thread host.`);return z}throw new Error(`Malformed event name ${B}`)}}),this.c.setWorkerId(this.a.getId());let p=null;const k=globalThis.require;typeof k<"u"&&typeof k.getConfig=="function"?p=k.getConfig():typeof globalThis.requirejs<"u"&&(p=globalThis.requirejs.s.contexts._.config);const P=(0,o.getAllMethodNames)(c);this.b=this.c.sendMessage(s,[this.a.getId(),JSON.parse(JSON.stringify(p)),L,P]);const M=(B,W)=>this.g(B,W),I=(B,W)=>this.c.listen(B,W);this.f=new Promise((B,W)=>{u=W,this.b.then(z=>{B(w(z,M,I))},z=>{W(z),this.h("Worker failed to load "+L,z)})})}getProxyObject(){return this.f}g(h,L){return new Promise((c,u)=>{this.b.then(()=>{this.c.sendMessage(h,L).then(c,u)},u)})}h(h,L){console.error(h),console.info(L)}}t.SimpleWorkerClient=v;function y(A){return A[0]==="o"&&A[1]==="n"&&g.isUpperAsciiLetter(A.charCodeAt(2))}function b(A){return/^onDynamic/.test(A)&&g.isUpperAsciiLetter(A.charCodeAt(9))}function w(A,h,L){const c=k=>function(){const P=Array.prototype.slice.call(arguments,0);return h(k,P)},u=k=>function(P){return L(k,P)},p={};for(const k of A){if(b(k)){p[k]=u(k);continue}if(y(k)){p[k]=L(k,void 0);continue}p[k]=c(k)}return p}class r{constructor(h,L){this.a=L,this.b=null,this.c=new _({sendMessage:(c,u)=>{h(c,u)},handleMessage:(c,u)=>this.d(c,u),handleEvent:(c,u)=>this.f(c,u)})}onmessage(h){this.c.handleMessage(h)}d(h,L){if(h===s)return this.g(L[0],L[1],L[2],L[3]);if(!this.b||typeof this.b[h]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+h));try{return Promise.resolve(this.b[h].apply(this.b,L))}catch(c){return Promise.reject(c)}}f(h,L){if(!this.b)throw new Error("Missing requestHandler");if(b(h)){const c=this.b[h].call(this.b,L);if(typeof c!="function")throw new Error(`Missing dynamic event ${h} on request handler.`);return c}if(y(h)){const c=this.b[h];if(typeof c!="function")throw new Error(`Missing event ${h} on request handler.`);return c}throw new Error(`Malformed event name ${h}`)}g(h,L,c,u){this.c.setWorkerId(h);const P=w(u,(M,I)=>this.c.sendMessage(M,I),(M,I)=>this.c.listen(M,I));return this.a?(this.b=this.a(P),Promise.resolve((0,o.getAllMethodNames)(this.b))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy!==void 0&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((M,I)=>{(globalThis.require||j)([c],W=>{if(this.b=W.create(P),!this.b){I(new Error("No RequestHandler!"));return}M((0,o.getAllMethodNames)(this.b))},I)}))}}t.SimpleWorkerServer=r;function a(A){return new r(A,null)}t.create=a}),J(K[23],ee([0,1,22]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class S{constructor(g){const s=(0,F.toUint8)(g);this.c=s,this.a=S.d(s),this.b=new Map}static d(g){const s=new Uint8Array(256);return s.fill(g),s}set(g,s){const l=(0,F.toUint8)(s);g>=0&&g<256?this.a[g]=l:this.b.set(g,l)}get(g){return g>=0&&g<256?this.a[g]:this.b.get(g)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.CharacterClassifier=S;var i;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(i||(i={}));class o{constructor(){this.a=new S(0)}add(g){this.a.set(g,1)}has(g){return this.a.get(g)===1}clear(){return this.a.clear()}}t.CharacterSet=o}),J(K[6],ee([0,1,3]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRange=void 0;class S{static addRange(o,E){let g=0;for(;g<E.length&&E[g].endExclusive<o.start;)g++;let s=g;for(;s<E.length&&E[s].start<=o.endExclusive;)s++;if(g===s)E.splice(g,0,o);else{const l=Math.min(o.start,E[g].start),m=Math.max(o.endExclusive,E[s-1].endExclusive);E.splice(g,s-g,new S(l,m))}}static tryCreate(o,E){if(!(o>E))return new S(o,E)}constructor(o,E){if(this.start=o,this.endExclusive=E,o>E)throw new F.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(o){return new S(this.start+o,this.endExclusive+o)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(o){return this.start===o.start&&this.endExclusive===o.endExclusive}containsRange(o){return this.start<=o.start&&o.endExclusive<=this.endExclusive}contains(o){return this.start<=o&&o<this.endExclusive}join(o){return new S(Math.min(this.start,o.start),Math.max(this.endExclusive,o.endExclusive))}intersect(o){const E=Math.max(this.start,o.start),g=Math.min(this.endExclusive,o.endExclusive);if(E<=g)return new S(E,g)}}t.OffsetRange=S}),J(K[4],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class F{constructor(i,o){this.lineNumber=i,this.column=o}with(i=this.lineNumber,o=this.column){return i===this.lineNumber&&o===this.column?this:new F(i,o)}delta(i=0,o=0){return this.with(this.lineNumber+i,this.column+o)}equals(i){return F.equals(this,i)}static equals(i,o){return!i&&!o?!0:!!i&&!!o&&i.lineNumber===o.lineNumber&&i.column===o.column}isBefore(i){return F.isBefore(this,i)}static isBefore(i,o){return i.lineNumber<o.lineNumber?!0:o.lineNumber<i.lineNumber?!1:i.column<o.column}isBeforeOrEqual(i){return F.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,o){return i.lineNumber<o.lineNumber?!0:o.lineNumber<i.lineNumber?!1:i.column<=o.column}static compare(i,o){const E=i.lineNumber|0,g=o.lineNumber|0;if(E===g){const s=i.column|0,l=o.column|0;return s-l}return E-g}clone(){return new F(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new F(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.Position=F}),J(K[2],ee([0,1,4]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class S{constructor(o,E,g,s){o>g||o===g&&E>s?(this.startLineNumber=g,this.startColumn=s,this.endLineNumber=o,this.endColumn=E):(this.startLineNumber=o,this.startColumn=E,this.endLineNumber=g,this.endColumn=s)}isEmpty(){return S.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return S.containsPosition(this,o)}static containsPosition(o,E){return!(E.lineNumber<o.startLineNumber||E.lineNumber>o.endLineNumber||E.lineNumber===o.startLineNumber&&E.column<o.startColumn||E.lineNumber===o.endLineNumber&&E.column>o.endColumn)}static strictContainsPosition(o,E){return!(E.lineNumber<o.startLineNumber||E.lineNumber>o.endLineNumber||E.lineNumber===o.startLineNumber&&E.column<=o.startColumn||E.lineNumber===o.endLineNumber&&E.column>=o.endColumn)}containsRange(o){return S.containsRange(this,o)}static containsRange(o,E){return!(E.startLineNumber<o.startLineNumber||E.endLineNumber<o.startLineNumber||E.startLineNumber>o.endLineNumber||E.endLineNumber>o.endLineNumber||E.startLineNumber===o.startLineNumber&&E.startColumn<o.startColumn||E.endLineNumber===o.endLineNumber&&E.endColumn>o.endColumn)}strictContainsRange(o){return S.strictContainsRange(this,o)}static strictContainsRange(o,E){return!(E.startLineNumber<o.startLineNumber||E.endLineNumber<o.startLineNumber||E.startLineNumber>o.endLineNumber||E.endLineNumber>o.endLineNumber||E.startLineNumber===o.startLineNumber&&E.startColumn<=o.startColumn||E.endLineNumber===o.endLineNumber&&E.endColumn>=o.endColumn)}plusRange(o){return S.plusRange(this,o)}static plusRange(o,E){let g,s,l,m;return E.startLineNumber<o.startLineNumber?(g=E.startLineNumber,s=E.startColumn):E.startLineNumber===o.startLineNumber?(g=E.startLineNumber,s=Math.min(E.startColumn,o.startColumn)):(g=o.startLineNumber,s=o.startColumn),E.endLineNumber>o.endLineNumber?(l=E.endLineNumber,m=E.endColumn):E.endLineNumber===o.endLineNumber?(l=E.endLineNumber,m=Math.max(E.endColumn,o.endColumn)):(l=o.endLineNumber,m=o.endColumn),new S(g,s,l,m)}intersectRanges(o){return S.intersectRanges(this,o)}static intersectRanges(o,E){let g=o.startLineNumber,s=o.startColumn,l=o.endLineNumber,m=o.endColumn;const R=E.startLineNumber,f=E.startColumn,d=E.endLineNumber,e=E.endColumn;return g<R?(g=R,s=f):g===R&&(s=Math.max(s,f)),l>d?(l=d,m=e):l===d&&(m=Math.min(m,e)),g>l||g===l&&s>m?null:new S(g,s,l,m)}equalsRange(o){return S.equalsRange(this,o)}static equalsRange(o,E){return!o&&!E?!0:!!o&&!!E&&o.startLineNumber===E.startLineNumber&&o.startColumn===E.startColumn&&o.endLineNumber===E.endLineNumber&&o.endColumn===E.endColumn}getEndPosition(){return S.getEndPosition(this)}static getEndPosition(o){return new F.Position(o.endLineNumber,o.endColumn)}getStartPosition(){return S.getStartPosition(this)}static getStartPosition(o){return new F.Position(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,E){return new S(this.startLineNumber,this.startColumn,o,E)}setStartPosition(o,E){return new S(o,E,this.endLineNumber,this.endColumn)}collapseToStart(){return S.collapseToStart(this)}static collapseToStart(o){return new S(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}collapseToEnd(){return S.collapseToEnd(this)}static collapseToEnd(o){return new S(o.endLineNumber,o.endColumn,o.endLineNumber,o.endColumn)}delta(o){return new S(this.startLineNumber+o,this.startColumn,this.endLineNumber+o,this.endColumn)}static fromPositions(o,E=o){return new S(o.lineNumber,o.column,E.lineNumber,E.column)}static lift(o){return o?new S(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,E){return!(o.endLineNumber<E.startLineNumber||o.endLineNumber===E.startLineNumber&&o.endColumn<E.startColumn||E.endLineNumber<o.startLineNumber||E.endLineNumber===o.startLineNumber&&E.endColumn<o.startColumn)}static areIntersecting(o,E){return!(o.endLineNumber<E.startLineNumber||o.endLineNumber===E.startLineNumber&&o.endColumn<=E.startColumn||E.endLineNumber<o.startLineNumber||E.endLineNumber===o.startLineNumber&&E.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,E){if(o&&E){const l=o.startLineNumber|0,m=E.startLineNumber|0;if(l===m){const R=o.startColumn|0,f=E.startColumn|0;if(R===f){const d=o.endLineNumber|0,e=E.endLineNumber|0;if(d===e){const N=o.endColumn|0,D=E.endColumn|0;return N-D}return d-e}return R-f}return l-m}return(o?1:0)-(E?1:0)}static compareRangesUsingEnds(o,E){return o.endLineNumber===E.endLineNumber?o.endColumn===E.endColumn?o.startLineNumber===E.startLineNumber?o.startColumn-E.startColumn:o.startLineNumber-E.startLineNumber:o.endColumn-E.endColumn:o.endLineNumber-E.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}t.Range=S}),J(K[14],ee([0,1,3,2]),function(j,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRange=void 0;class i{static fromRange(E){return new i(E.startLineNumber,E.endLineNumber)}static joinMany(E){if(E.length===0)return[];let g=E[0];for(let s=1;s<E.length;s++)g=this.join(g,E[s]);return g}static join(E,g){if(E.length===0)return g;if(g.length===0)return E;const s=[];let l=0,m=0,R=null;for(;l<E.length||m<g.length;){let f=null;if(l<E.length&&m<g.length){const d=E[l],e=g[m];d.startLineNumber<e.startLineNumber?(f=d,l++):(f=e,m++)}else l<E.length?(f=E[l],l++):(f=g[m],m++);R===null?R=f:R.endLineNumberExclusive>=f.startLineNumber?R=new i(R.startLineNumber,Math.max(R.endLineNumberExclusive,f.endLineNumberExclusive)):(s.push(R),R=f)}return R!==null&&s.push(R),s}static ofLength(E,g){return new i(E,E+g)}constructor(E,g){if(E>g)throw new F.BugIndicatingError(`startLineNumber ${E} cannot be after endLineNumberExclusive ${g}`);this.startLineNumber=E,this.endLineNumberExclusive=g}contains(E){return this.startLineNumber<=E&&E<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(E){return new i(this.startLineNumber+E,this.endLineNumberExclusive+E)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(E){return new i(Math.min(this.startLineNumber,E.startLineNumber),Math.max(this.endLineNumberExclusive,E.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(E){const g=Math.max(this.startLineNumber,E.startLineNumber),s=Math.min(this.endLineNumberExclusive,E.endLineNumberExclusive);if(g<=s)return new i(g,s)}intersectsStrict(E){return this.startLineNumber<E.endLineNumberExclusive&&E.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(E){return this.startLineNumber<=E.endLineNumberExclusive&&E.startLineNumber<=this.endLineNumberExclusive}equals(E){return this.startLineNumber===E.startLineNumber&&this.endLineNumberExclusive===E.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new S.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new S.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}}t.LineRange=i}),J(K[37],ee([0,1,4,2]),function(j,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var i;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(i||(t.SelectionDirection=i={}));class o extends S.Range{constructor(g,s,l,m){super(g,s,l,m),this.selectionStartLineNumber=g,this.selectionStartColumn=s,this.positionLineNumber=l,this.positionColumn=m}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(g){return o.selectionsEqual(this,g)}static selectionsEqual(g,s){return g.selectionStartLineNumber===s.selectionStartLineNumber&&g.selectionStartColumn===s.selectionStartColumn&&g.positionLineNumber===s.positionLineNumber&&g.positionColumn===s.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(g,s){return this.getDirection()===0?new o(this.startLineNumber,this.startColumn,g,s):new o(g,s,this.startLineNumber,this.startColumn)}getPosition(){return new F.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new F.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(g,s){return this.getDirection()===0?new o(g,s,this.endLineNumber,this.endColumn):new o(this.endLineNumber,this.endColumn,g,s)}static fromPositions(g,s=g){return new o(g.lineNumber,g.column,s.lineNumber,s.column)}static fromRange(g,s){return s===0?new o(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):new o(g.endLineNumber,g.endColumn,g.startLineNumber,g.startColumn)}static liftSelection(g){return new o(g.selectionStartLineNumber,g.selectionStartColumn,g.positionLineNumber,g.positionColumn)}static selectionsArrEqual(g,s){if(g&&!s||!g&&s)return!1;if(!g&&!s)return!0;if(g.length!==s.length)return!1;for(let l=0,m=g.length;l<m;l++)if(!this.selectionsEqual(g[l],s[l]))return!1;return!0}static isISelection(g){return g&&typeof g.selectionStartLineNumber=="number"&&typeof g.selectionStartColumn=="number"&&typeof g.positionLineNumber=="number"&&typeof g.positionColumn=="number"}static createWithDirection(g,s,l,m,R){return R===0?new o(g,s,l,m):new o(l,m,g,s)}}t.Selection=o}),J(K[38],ee([0,1,23]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=t.WordCharacterClass=void 0;var S;(function(E){E[E.Regular=0]="Regular",E[E.Whitespace=1]="Whitespace",E[E.WordSeparator=2]="WordSeparator"})(S||(t.WordCharacterClass=S={}));class i extends F.CharacterClassifier{constructor(g){super(0);for(let s=0,l=g.length;s<l;s++)this.set(g.charCodeAt(s),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=i;function o(E){const g={};return s=>(g.hasOwnProperty(s)||(g[s]=E(s)),g[s])}t.getMapForWordSeparators=o(E=>new i(E))}),J(K[24],ee([0,1,16,7,17]),function(j,t,F,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.setDefaultGetWordAtTextConfig=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function o(R=""){let f="(-?\\d*\\.\\d\\w*)|([^";for(const d of t.USUAL_WORD_SEPARATORS)R.indexOf(d)>=0||(f+="\\"+d);return f+="\\s]+)",new RegExp(f,"g")}t.DEFAULT_WORD_REGEXP=o();function E(R){let f=t.DEFAULT_WORD_REGEXP;if(R&&R instanceof RegExp)if(R.global)f=R;else{let d="g";R.ignoreCase&&(d+="i"),R.multiline&&(d+="m"),R.unicode&&(d+="u"),f=new RegExp(R.source,d)}return f.lastIndex=0,f}t.ensureValidWordDefinition=E;const g=new i.LinkedList;g.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function s(R){const f=g.unshift(R);return(0,S.toDisposable)(f)}t.setDefaultGetWordAtTextConfig=s;function l(R,f,d,e,N){if(N||(N=F.Iterable.first(g)),d.length>N.maxLen){let b=R-N.maxLen/2;return b<0?b=0:e+=b,d=d.substring(b,R+N.maxLen/2),l(R,f,d,e,N)}const D=Date.now(),_=R-1-e;let v=-1,y=null;for(let b=1;!(Date.now()-D>=N.timeBudget);b++){const w=_-N.windowSize*b;f.lastIndex=Math.max(0,w);const r=m(f,d,_,v);if(!r&&y||(y=r,w<=0))break;v=w}if(y){const b={word:y[0],startColumn:e+1+y.index,endColumn:e+1+y.index+y[0].length};return f.lastIndex=0,b}return null}t.getWordAtText=l;function m(R,f,d,e){let N;for(;N=R.exec(f);){const D=N.index||0;if(D<=d&&R.lastIndex>=d)return N;if(e>0&&D>e)return null}return null}}),J(K[10],ee([0,1,3,6]),function(j,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DateTimeout=t.InfiniteTimeout=t.SequenceDiff=t.DiffAlgorithmResult=void 0;class i{static trivial(l,m){return new i([new o(new S.OffsetRange(0,l.length),new S.OffsetRange(0,m.length))],!1)}static trivialTimedOut(l,m){return new i([new o(new S.OffsetRange(0,l.length),new S.OffsetRange(0,m.length))],!0)}constructor(l,m){this.diffs=l,this.hitTimeout=m}}t.DiffAlgorithmResult=i;class o{constructor(l,m){this.seq1Range=l,this.seq2Range=m}reverse(){return new o(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(l){return new o(this.seq1Range.join(l.seq1Range),this.seq2Range.join(l.seq2Range))}}t.SequenceDiff=o;class E{isValid(){return!0}}t.InfiniteTimeout=E,E.instance=new E;class g{constructor(l){if(this.c=l,this.a=Date.now(),this.b=!0,l<=0)throw new F.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.a<this.c)&&this.b){this.b=!1;debugger}return this.b}disable(){this.c=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.b=!0}}t.DateTimeout=g}),J(K[39],ee([0,1,6,10]),function(j,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shiftSequenceDiffs=t.joinSequenceDiffs=t.smoothenSequenceDiffs=t.optimizeSequenceDiffs=void 0;function i(l,m,R){let f=R;return f=E(l,m,f),f=g(l,m,f),f}t.optimizeSequenceDiffs=i;function o(l,m,R){const f=[];for(const d of R){const e=f[f.length-1];if(!e){f.push(d);continue}d.seq1Range.start-e.seq1Range.endExclusive<=2||d.seq2Range.start-e.seq2Range.endExclusive<=2?f[f.length-1]=new S.SequenceDiff(e.seq1Range.join(d.seq1Range),e.seq2Range.join(d.seq2Range)):f.push(d)}return f}t.smoothenSequenceDiffs=o;function E(l,m,R){const f=[];R.length>0&&f.push(R[0]);for(let d=1;d<R.length;d++){const e=f[f.length-1],N=R[d];if(N.seq1Range.isEmpty){let D=!0;const _=N.seq1Range.start-e.seq1Range.endExclusive;for(let v=1;v<=_;v++)if(m.getElement(N.seq2Range.start-v)!==m.getElement(N.seq2Range.endExclusive-v)){D=!1;break}if(D){f[f.length-1]=new S.SequenceDiff(e.seq1Range,new F.OffsetRange(e.seq2Range.start,N.seq2Range.endExclusive-_));continue}}f.push(N)}return f}t.joinSequenceDiffs=E;function g(l,m,R){if(!l.getBoundaryScore||!m.getBoundaryScore)return R;for(let f=0;f<R.length;f++){const d=R[f];if(d.seq1Range.isEmpty){const e=f>0?R[f-1].seq2Range.endExclusive:-1,N=f+1<R.length?R[f+1].seq2Range.start:m.length;R[f]=s(d,l,m,N,e)}else if(d.seq2Range.isEmpty){const e=f>0?R[f-1].seq1Range.endExclusive:-1,N=f+1<R.length?R[f+1].seq1Range.start:l.length;R[f]=s(d.reverse(),m,l,N,e).reverse()}}return R}t.shiftSequenceDiffs=g;function s(l,m,R,f,d){let N=1;for(;l.seq2Range.start-N>d&&R.getElement(l.seq2Range.start-N)===R.getElement(l.seq2Range.endExclusive-N)&&N<20;)N++;N--;let D=0;for(;l.seq2Range.start+D<f&&R.getElement(l.seq2Range.start+D)===R.getElement(l.seq2Range.endExclusive+D)&&D<20;)D++;if(N===0&&D===0)return l;let _=0,v=-1;for(let y=-N;y<=D;y++){const b=l.seq2Range.start+y,w=l.seq2Range.endExclusive+y,r=l.seq1Range.start+y,a=m.getBoundaryScore(r)+R.getBoundaryScore(b)+R.getBoundaryScore(w);a>v&&(v=a,_=y)}return _!==0?new S.SequenceDiff(l.seq1Range.delta(_),l.seq2Range.delta(_)):l}}),J(K[40],ee([0,1,6,10]),function(j,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class i{compute(l,m,R=S.InfiniteTimeout.instance){if(l.length===0||m.length===0)return S.DiffAlgorithmResult.trivial(l,m);function f(w,r){for(;w<l.length&&r<m.length&&l.getElement(w)===m.getElement(r);)w++,r++;return w}let d=0;const e=new E;e.set(0,f(0,0));const N=new g;N.set(0,e.get(0)===0?null:new o(null,0,0,e.get(0)));let D=0;e:for(;;)for(d++,D=-d;D<=d;D+=2){if(!R.isValid())return S.DiffAlgorithmResult.trivialTimedOut(l,m);const w=D===d?-1:e.get(D+1),r=D===-d?-1:e.get(D-1)+1,a=Math.min(Math.max(w,r),l.length),A=a-D,h=f(a,A);e.set(D,h);const L=a===w?N.get(D+1):N.get(D-1);if(N.set(D,h!==a?new o(L,a,A,h-a):L),e.get(D)===l.length&&e.get(D)-D===m.length)break e}let _=N.get(D);const v=[];let y=l.length,b=m.length;for(;;){const w=_?_.x+_.length:0,r=_?_.y+_.length:0;if((w!==y||r!==b)&&v.push(new S.SequenceDiff(new F.OffsetRange(w,y),new F.OffsetRange(r,b))),!_)break;y=_.x,b=_.y,_=_.prev}return v.reverse(),new S.DiffAlgorithmResult(v,!1)}}t.MyersDiffAlgorithm=i;class o{constructor(l,m,R,f){this.prev=l,this.x=m,this.y=R,this.length=f}}class E{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,m){if(l<0){if(l=-l-1,l>=this.b.length){const R=this.b;this.b=new Int32Array(R.length*2),this.b.set(R)}this.b[l]=m}else{if(l>=this.a.length){const R=this.a;this.a=new Int32Array(R.length*2),this.a.set(R)}this.a[l]=m}}}class g{constructor(){this.a=[],this.b=[]}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,m){l<0?(l=-l-1,this.b[l]=m):this.a[l]=m}}}),J(K[41],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Array2D=void 0;class F{constructor(i,o){this.width=i,this.height=o,this.a=[],this.a=new Array(i*o)}get(i,o){return this.a[i+o*this.width]}set(i,o,E){this.a[i+o*this.width]=E}}t.Array2D=F}),J(K[42],ee([0,1,6,10,41]),function(j,t,F,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class o{compute(g,s,l=S.InfiniteTimeout.instance,m){if(g.length===0||s.length===0)return S.DiffAlgorithmResult.trivial(g,s);const R=new i.Array2D(g.length,s.length),f=new i.Array2D(g.length,s.length),d=new i.Array2D(g.length,s.length);for(let b=0;b<g.length;b++)for(let w=0;w<s.length;w++){if(!l.isValid())return S.DiffAlgorithmResult.trivialTimedOut(g,s);const r=b===0?0:R.get(b-1,w),a=w===0?0:R.get(b,w-1);let A;g.getElement(b)===s.getElement(w)?(b===0||w===0?A=0:A=R.get(b-1,w-1),b>0&&w>0&&f.get(b-1,w-1)===3&&(A+=d.get(b-1,w-1)),A+=m?m(b,w):1):A=-1;const h=Math.max(r,a,A);if(h===A){const L=b>0&&w>0?d.get(b-1,w-1):0;d.set(b,w,L+1),f.set(b,w,3)}else h===r?(d.set(b,w,0),f.set(b,w,1)):h===a&&(d.set(b,w,0),f.set(b,w,2));R.set(b,w,h)}const e=[];let N=g.length,D=s.length;function _(b,w){(b+1!==N||w+1!==D)&&e.push(new S.SequenceDiff(new F.OffsetRange(b+1,N),new F.OffsetRange(w+1,D))),N=b,D=w}let v=g.length-1,y=s.length-1;for(;v>=0&&y>=0;)f.get(v,y)===3?(_(v,y),v--,y--):f.get(v,y)===1?v--:y--;return _(-1,-1),e.reverse(),new S.DiffAlgorithmResult(e,!1)}}t.DynamicProgrammingDiffing=o}),J(K[25],ee([0,1,14]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMapping=t.LineRangeMapping=t.LinesDiff=void 0;class S{constructor(g,s){this.changes=g,this.hitTimeout=s}}t.LinesDiff=S;class i{static inverse(g,s,l){const m=[];let R=1,f=1;for(const e of g){const N=new i(new F.LineRange(R,e.originalRange.startLineNumber),new F.LineRange(f,e.modifiedRange.startLineNumber),void 0);N.modifiedRange.isEmpty||m.push(N),R=e.originalRange.endLineNumberExclusive,f=e.modifiedRange.endLineNumberExclusive}const d=new i(new F.LineRange(R,s+1),new F.LineRange(f,l+1),void 0);return d.modifiedRange.isEmpty||m.push(d),m}constructor(g,s,l){this.originalRange=g,this.modifiedRange=s,this.innerChanges=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}}t.LineRangeMapping=i;class o{constructor(g,s){this.originalRange=g,this.modifiedRange=s}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}t.RangeMapping=o}),J(K[26],ee([0,1,20,25,5,2,11,14]),function(j,t,F,S,i,o,E,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.SmartLinesDiffComputer=void 0;const s=3;class l{computeDiff(w,r,a){const h=new D(w,r,{maxComputationTime:a.maxComputationTimeMs,shouldIgnoreTrimWhitespace:a.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),L=[];let c=null;for(const u of h.changes){let p;u.originalEndLineNumber===0?p=new g.LineRange(u.originalStartLineNumber+1,u.originalStartLineNumber+1):p=new g.LineRange(u.originalStartLineNumber,u.originalEndLineNumber+1);let k;u.modifiedEndLineNumber===0?k=new g.LineRange(u.modifiedStartLineNumber+1,u.modifiedStartLineNumber+1):k=new g.LineRange(u.modifiedStartLineNumber,u.modifiedEndLineNumber+1);let P=new S.LineRangeMapping(p,k,u.charChanges?.map(M=>new S.RangeMapping(new o.Range(M.originalStartLineNumber,M.originalStartColumn,M.originalEndLineNumber,M.originalEndColumn),new o.Range(M.modifiedStartLineNumber,M.modifiedStartColumn,M.modifiedEndLineNumber,M.modifiedEndColumn))));c&&(c.modifiedRange.endLineNumberExclusive===P.modifiedRange.startLineNumber||c.originalRange.endLineNumberExclusive===P.originalRange.startLineNumber)&&(P=new S.LineRangeMapping(c.originalRange.join(P.originalRange),c.modifiedRange.join(P.modifiedRange),c.innerChanges&&P.innerChanges?c.innerChanges.concat(P.innerChanges):void 0),L.pop()),L.push(P),c=P}return(0,E.assertFn)(()=>(0,E.checkAdjacentItems)(L,(u,p)=>p.originalRange.startLineNumber-u.originalRange.endLineNumberExclusive===p.modifiedRange.startLineNumber-u.modifiedRange.endLineNumberExclusive&&u.originalRange.endLineNumberExclusive<p.originalRange.startLineNumber&&u.modifiedRange.endLineNumberExclusive<p.modifiedRange.startLineNumber)),new S.LinesDiff(L,h.quitEarly)}}t.SmartLinesDiffComputer=l;function m(b,w,r,a){return new F.LcsDiff(b,w,r).ComputeDiff(a)}class R{constructor(w){const r=[],a=[];for(let A=0,h=w.length;A<h;A++)r[A]=_(w[A],1),a[A]=v(w[A],1);this.lines=w,this.a=r,this.b=a}getElements(){const w=[];for(let r=0,a=this.lines.length;r<a;r++)w[r]=this.lines[r].substring(this.a[r]-1,this.b[r]-1);return w}getStrictElement(w){return this.lines[w]}getStartLineNumber(w){return w+1}getEndLineNumber(w){return w+1}createCharSequence(w,r,a){const A=[],h=[],L=[];let c=0;for(let u=r;u<=a;u++){const p=this.lines[u],k=w?this.a[u]:1,P=w?this.b[u]:p.length+1;for(let M=k;M<P;M++)A[c]=p.charCodeAt(M-1),h[c]=u+1,L[c]=M,c++;!w&&u<a&&(A[c]=10,h[c]=u+1,L[c]=p.length+1,c++)}return new f(A,h,L)}}class f{constructor(w,r,a){this.a=w,this.b=r,this.d=a}toString(){return"["+this.a.map((w,r)=>(w===10?"\\n":String.fromCharCode(w))+`-(${this.b[r]},${this.d[r]})`).join(", ")+"]"}e(w,r){if(w<0||w>=r.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(w){return w>0&&w===this.b.length?this.getEndLineNumber(w-1):(this.e(w,this.b),this.b[w])}getEndLineNumber(w){return w===-1?this.getStartLineNumber(w+1):(this.e(w,this.b),this.a[w]===10?this.b[w]+1:this.b[w])}getStartColumn(w){return w>0&&w===this.d.length?this.getEndColumn(w-1):(this.e(w,this.d),this.d[w])}getEndColumn(w){return w===-1?this.getStartColumn(w+1):(this.e(w,this.d),this.a[w]===10?1:this.d[w]+1)}}class d{constructor(w,r,a,A,h,L,c,u){this.originalStartLineNumber=w,this.originalStartColumn=r,this.originalEndLineNumber=a,this.originalEndColumn=A,this.modifiedStartLineNumber=h,this.modifiedStartColumn=L,this.modifiedEndLineNumber=c,this.modifiedEndColumn=u}static createFromDiffChange(w,r,a){const A=r.getStartLineNumber(w.originalStart),h=r.getStartColumn(w.originalStart),L=r.getEndLineNumber(w.originalStart+w.originalLength-1),c=r.getEndColumn(w.originalStart+w.originalLength-1),u=a.getStartLineNumber(w.modifiedStart),p=a.getStartColumn(w.modifiedStart),k=a.getEndLineNumber(w.modifiedStart+w.modifiedLength-1),P=a.getEndColumn(w.modifiedStart+w.modifiedLength-1);return new d(A,h,L,c,u,p,k,P)}}function e(b){if(b.length<=1)return b;const w=[b[0]];let r=w[0];for(let a=1,A=b.length;a<A;a++){const h=b[a],L=h.originalStart-(r.originalStart+r.originalLength),c=h.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(L,c)<s?(r.originalLength=h.originalStart+h.originalLength-r.originalStart,r.modifiedLength=h.modifiedStart+h.modifiedLength-r.modifiedStart):(w.push(h),r=h)}return w}class N{constructor(w,r,a,A,h){this.originalStartLineNumber=w,this.originalEndLineNumber=r,this.modifiedStartLineNumber=a,this.modifiedEndLineNumber=A,this.charChanges=h}static createFromDiffResult(w,r,a,A,h,L,c){let u,p,k,P,M;if(r.originalLength===0?(u=a.getStartLineNumber(r.originalStart)-1,p=0):(u=a.getStartLineNumber(r.originalStart),p=a.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(k=A.getStartLineNumber(r.modifiedStart)-1,P=0):(k=A.getStartLineNumber(r.modifiedStart),P=A.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),L&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&h()){const I=a.createCharSequence(w,r.originalStart,r.originalStart+r.originalLength-1),B=A.createCharSequence(w,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(I.getElements().length>0&&B.getElements().length>0){let W=m(I,B,h,!0).changes;c&&(W=e(W)),M=[];for(let z=0,Z=W.length;z<Z;z++)M.push(d.createFromDiffChange(W[z],I,B))}}return new N(u,p,k,P,M)}}class D{constructor(w,r,a){this.a=a.shouldComputeCharChanges,this.b=a.shouldPostProcessCharChanges,this.d=a.shouldIgnoreTrimWhitespace,this.e=a.shouldMakePrettyDiff,this.f=w,this.g=r,this.h=new R(w),this.j=new R(r),this.k=y(a.maxComputationTime),this.l=y(a.maxComputationTime===0?0:Math.min(a.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const w=m(this.h,this.j,this.k,this.e),r=w.changes,a=w.quitEarly;if(this.d){const c=[];for(let u=0,p=r.length;u<p;u++)c.push(N.createFromDiffResult(this.d,r[u],this.h,this.j,this.l,this.a,this.b));return{quitEarly:a,changes:c}}const A=[];let h=0,L=0;for(let c=-1,u=r.length;c<u;c++){const p=c+1<u?r[c+1]:null,k=p?p.originalStart:this.f.length,P=p?p.modifiedStart:this.g.length;for(;h<k&&L<P;){const M=this.f[h],I=this.g[L];if(M!==I){{let B=_(M,1),W=_(I,1);for(;B>1&&W>1;){const z=M.charCodeAt(B-2),Z=I.charCodeAt(W-2);if(z!==Z)break;B--,W--}(B>1||W>1)&&this.m(A,h+1,1,B,L+1,1,W)}{let B=v(M,1),W=v(I,1);const z=M.length+1,Z=I.length+1;for(;B<z&&W<Z;){const Y=M.charCodeAt(B-1),G=M.charCodeAt(W-1);if(Y!==G)break;B++,W++}(B<z||W<Z)&&this.m(A,h+1,B,z,L+1,W,Z)}}h++,L++}p&&(A.push(N.createFromDiffResult(this.d,p,this.h,this.j,this.l,this.a,this.b)),h+=p.originalLength,L+=p.modifiedLength)}return{quitEarly:a,changes:A}}m(w,r,a,A,h,L,c){if(this.n(w,r,a,A,h,L,c))return;let u;this.a&&(u=[new d(r,a,r,A,h,L,h,c)]),w.push(new N(r,r,h,h,u))}n(w,r,a,A,h,L,c){const u=w.length;if(u===0)return!1;const p=w[u-1];return p.originalEndLineNumber===0||p.modifiedEndLineNumber===0?!1:p.originalEndLineNumber===r&&p.modifiedEndLineNumber===h?(this.a&&p.charChanges&&p.charChanges.push(new d(r,a,r,A,h,L,h,c)),!0):p.originalEndLineNumber+1===r&&p.modifiedEndLineNumber+1===h?(p.originalEndLineNumber=r,p.modifiedEndLineNumber=h,this.a&&p.charChanges&&p.charChanges.push(new d(r,a,r,A,h,L,h,c)),!0):!1}}t.DiffComputer=D;function _(b,w){const r=i.firstNonWhitespaceIndex(b);return r===-1?w:r+1}function v(b,w){const r=i.lastNonWhitespaceIndex(b);return r===-1?w:r+2}function y(b){if(b===0)return()=>!0;const w=Date.now();return()=>Date.now()-w<b}}),J(K[43],ee([0,1,11,14,6,4,2,10,42,39,40,25]),function(j,t,F,S,i,o,E,g,s,l,m,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=t.getLineRangeMapping=t.lineRangeMappingFromRangeMappings=t.StandardLinesDiffComputer=void 0;class f{constructor(){this.b=new s.DynamicProgrammingDiffing,this.c=new m.MyersDiffAlgorithm}computeDiff(u,p,k){const P=k.maxComputationTimeMs===0?g.InfiniteTimeout.instance:new g.DateTimeout(k.maxComputationTimeMs),M=!k.ignoreTrimWhitespace,I=new Map;function B(le){let oe=I.get(le);return oe===void 0&&(oe=I.size,I.set(le,oe)),oe}const W=u.map(le=>B(le.trim())),z=p.map(le=>B(le.trim())),Z=new v(W,u),Y=new v(z,p),G=(()=>Z.length+Y.length<1500?this.b.compute(Z,Y,P,(le,oe)=>u[le]===p[oe]?p[oe].length===0?.1:1+Math.log(1+p[oe].length):.99):this.c.compute(Z,Y))();let se=G.diffs,n=G.hitTimeout;se=(0,l.optimizeSequenceDiffs)(Z,Y,se);const me=[],de=le=>{if(M)for(let oe=0;oe<le;oe++){const Ae=be+oe,ve=we+oe;if(u[Ae]!==p[ve]){const ye=this.f(u,p,new g.SequenceDiff(new i.OffsetRange(Ae,Ae+1),new i.OffsetRange(ve,ve+1)),P,M);for(const Fe of ye.mappings)me.push(Fe);ye.hitTimeout&&(n=!0)}}};let be=0,we=0;for(const le of se){(0,F.assertFn)(()=>le.seq1Range.start-be===le.seq2Range.start-we);const oe=le.seq1Range.start-be;de(oe),be=le.seq1Range.endExclusive,we=le.seq2Range.endExclusive;const Ae=this.f(u,p,le,P,M);Ae.hitTimeout&&(n=!0);for(const ve of Ae.mappings)me.push(ve)}de(u.length-be);const Ne=N(me,u,p);return new R.LinesDiff(Ne,n)}f(u,p,k,P,M){const I=new b(u,k.seq1Range,M),B=new b(p,k.seq2Range,M),W=I.length+B.length<500?this.b.compute(I,B,P):this.c.compute(I,B,P);let z=W.diffs;return z=(0,l.optimizeSequenceDiffs)(I,B,z),z=d(I,B,z),z=(0,l.smoothenSequenceDiffs)(I,B,z),{mappings:z.map(Y=>new R.RangeMapping(I.translateRange(Y.seq1Range),B.translateRange(Y.seq2Range))),hitTimeout:W.hitTimeout}}}t.StandardLinesDiffComputer=f;function d(c,u,p){const k=[];let P;function M(){if(!P)return;const B=P.s1Range.length-P.deleted,W=P.s2Range.length-P.added;Math.max(P.deleted,P.added)+(P.count-1)>B&&k.push(new g.SequenceDiff(P.s1Range,P.s2Range)),P=void 0}for(const B of p){let W=function(se,n){if(!P||!P.s1Range.containsRange(se)||!P.s2Range.containsRange(n))if(P&&!(P.s1Range.endExclusive<se.start&&P.s2Range.endExclusive<n.start)){const be=i.OffsetRange.tryCreate(P.s1Range.endExclusive,se.start),we=i.OffsetRange.tryCreate(P.s2Range.endExclusive,n.start);P.deleted+=be?.length??0,P.added+=we?.length??0,P.s1Range=P.s1Range.join(se),P.s2Range=P.s2Range.join(n)}else M(),P={added:0,deleted:0,count:0,s1Range:se,s2Range:n};const me=se.intersect(B.seq1Range),de=n.intersect(B.seq2Range);P.count++,P.deleted+=me?.length??0,P.added+=de?.length??0};const z=c.findWordContaining(B.seq1Range.start-1),Z=u.findWordContaining(B.seq2Range.start-1),Y=c.findWordContaining(B.seq1Range.endExclusive),G=u.findWordContaining(B.seq2Range.endExclusive);z&&Y&&Z&&G&&z.equals(Y)&&Z.equals(G)?W(z,Z):(z&&Z&&W(z,Z),Y&&G&&W(Y,G))}return M(),e(p,k)}function e(c,u){const p=[];for(;c.length>0||u.length>0;){const k=c[0],P=u[0];let M;k&&(!P||k.seq1Range.start<P.seq1Range.start)?M=c.shift():M=u.shift(),p.length>0&&p[p.length-1].seq1Range.endExclusive>=M.seq1Range.start?p[p.length-1]=p[p.length-1].join(M):p.push(M)}return p}function N(c,u,p){const k=[];for(const P of _(c.map(M=>D(M,u,p)),(M,I)=>M.originalRange.overlapOrTouch(I.originalRange)||M.modifiedRange.overlapOrTouch(I.modifiedRange))){const M=P[0],I=P[P.length-1];k.push(new R.LineRangeMapping(M.originalRange.join(I.originalRange),M.modifiedRange.join(I.modifiedRange),P.map(B=>B.innerChanges[0])))}return(0,F.assertFn)(()=>(0,F.checkAdjacentItems)(k,(P,M)=>M.originalRange.startLineNumber-P.originalRange.endLineNumberExclusive===M.modifiedRange.startLineNumber-P.modifiedRange.endLineNumberExclusive&&P.originalRange.endLineNumberExclusive<M.originalRange.startLineNumber&&P.modifiedRange.endLineNumberExclusive<M.modifiedRange.startLineNumber)),k}t.lineRangeMappingFromRangeMappings=N;function D(c,u,p){let k=0,P=0;c.modifiedRange.startColumn-1>=p[c.modifiedRange.startLineNumber-1].length&&c.originalRange.startColumn-1>=u[c.originalRange.startLineNumber-1].length&&(k=1),c.modifiedRange.endColumn===1&&c.originalRange.endColumn===1&&c.originalRange.startLineNumber+k<=c.originalRange.endLineNumber&&c.modifiedRange.startLineNumber+k<=c.modifiedRange.endLineNumber&&(P=-1);const M=new S.LineRange(c.originalRange.startLineNumber+k,c.originalRange.endLineNumber+1+P),I=new S.LineRange(c.modifiedRange.startLineNumber+k,c.modifiedRange.endLineNumber+1+P);return new R.LineRangeMapping(M,I,[c])}t.getLineRangeMapping=D;function*_(c,u){let p,k;for(const P of c)k!==void 0&&u(k,P)?p.push(P):(p&&(yield p),p=[P]),k=P;p&&(yield p)}class v{constructor(u,p){this.b=u,this.c=p}getElement(u){return this.b[u]}get length(){return this.b.length}getBoundaryScore(u){const p=u===0?0:y(this.c[u-1]),k=u===this.c.length?0:y(this.c[u]);return 1e3-(p+k)}}t.LineSequence=v;function y(c){let u=0;for(;u<c.length&&(c.charCodeAt(u)===32||c.charCodeAt(u)===9);)u++;return u}class b{constructor(u,p,k){this.lines=u,this.considerWhitespaceChanges=k,this.b=[],this.c=[],this.f=[];let P=!1;p.start>0&&p.endExclusive>=u.length&&(p=new i.OffsetRange(p.start-1,p.endExclusive),P=!0),this.lineRange=p;for(let M=this.lineRange.start;M<this.lineRange.endExclusive;M++){let I=u[M],B=0;if(P)B=I.length,I="",P=!1;else if(!k){const W=I.trimStart();B=I.length-W.length,I=W.trimEnd()}this.f.push(B);for(let W=0;W<I.length;W++)this.b.push(I.charCodeAt(W));M<u.length-1&&(this.b.push(`
`.charCodeAt(0)),this.c[M-this.lineRange.start]=this.b.length)}this.f.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return[...this.b].map(u=>String.fromCharCode(u)).join("")}getElement(u){return this.b[u]}get length(){return this.b.length}getBoundaryScore(u){const p=h(u>0?this.b[u-1]:-1),k=h(u<this.b.length?this.b[u]:-1);if(p===6&&k===7)return 0;let P=0;return p!==k&&(P+=10,k===1&&(P+=1)),P+=A(p),P+=A(k),P}translateOffset(u){if(this.lineRange.isEmpty)return new o.Position(this.lineRange.start+1,1);let p=0,k=this.c.length;for(;p<k;){const M=Math.floor((p+k)/2);this.c[M]>u?k=M:p=M+1}const P=p===0?0:this.c[p-1];return new o.Position(this.lineRange.start+p+1,u-P+1+this.f[p])}translateRange(u){return E.Range.fromPositions(this.translateOffset(u.start),this.translateOffset(u.endExclusive))}findWordContaining(u){if(u<0||u>=this.b.length||!w(this.b[u]))return;let p=u;for(;p>0&&w(this.b[p-1]);)p--;let k=u;for(;k<this.b.length&&w(this.b[k]);)k++;return new i.OffsetRange(p,k)}}function w(c){return c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57}var r;(function(c){c[c.WordLower=0]="WordLower",c[c.WordUpper=1]="WordUpper",c[c.WordNumber=2]="WordNumber",c[c.End=3]="End",c[c.Other=4]="Other",c[c.Space=5]="Space",c[c.LineBreakCR=6]="LineBreakCR",c[c.LineBreakLF=7]="LineBreakLF"})(r||(r={}));const a={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function A(c){return a[c]}function h(c){return c===10?7:c===13?6:L(c)?5:c>=97&&c<=122?0:c>=65&&c<=90?1:c>=48&&c<=57?2:c===-1?3:4}function L(c){return c===32||c===9}}),J(K[44],ee([0,1,26,43]),function(j,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={legacy:new F.SmartLinesDiffComputer,advanced:new S.StandardLinesDiffComputer}}),J(K[45],ee([0,1,27]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeDefaultDocumentColors=void 0;function S(f){const d=[];for(const e of f){const N=Number(e);(N||N===0&&e.replace(/\s/g,"")!=="")&&d.push(N)}return d}function i(f,d,e,N){return{red:f/255,blue:e/255,green:d/255,alpha:N}}function o(f,d){const e=d.index,N=d[0].length;if(!e)return;const D=f.positionAt(e);return{startLineNumber:D.lineNumber,startColumn:D.column,endLineNumber:D.lineNumber,endColumn:D.column+N}}function E(f,d){if(!f)return;const e=F.Color.Format.CSS.parseHex(d);if(e)return{range:f,color:i(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function g(f,d,e){if(!f||d.length!==1)return;const D=d[0].values(),_=S(D);return{range:f,color:i(_[0],_[1],_[2],e?_[3]:1)}}function s(f,d,e){if(!f||d.length!==1)return;const D=d[0].values(),_=S(D),v=new F.Color(new F.HSLA(_[0],_[1]/100,_[2]/100,e?_[3]:1));return{range:f,color:i(v.rgba.r,v.rgba.g,v.rgba.b,v.rgba.a)}}function l(f,d){return typeof f=="string"?[...f.matchAll(d)]:f.findMatches(d)}function m(f){const d=[],N=l(f,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(N.length>0)for(const D of N){const _=D.filter(w=>w!==void 0),v=_[1],y=_[2];if(!y)continue;let b;if(v==="rgb"){const w=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;b=g(o(f,D),l(y,w),!1)}else if(v==="rgba"){const w=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;b=g(o(f,D),l(y,w),!0)}else if(v==="hsl"){const w=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;b=s(o(f,D),l(y,w),!1)}else if(v==="hsla"){const w=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;b=s(o(f,D),l(y,w),!0)}else v==="#"&&(b=E(o(f,D),v+y));b&&d.push(b)}return d}function R(f){return!f||typeof f.getValue!="function"||typeof f.positionAt!="function"?[]:m(f)}t.computeDefaultDocumentColors=R}),J(K[46],ee([0,1,23]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.State=void 0;var S;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(S||(t.State=S={}));class i{constructor(e,N,D){const _=new Uint8Array(e*N);for(let v=0,y=e*N;v<y;v++)_[v]=D;this.a=_,this.rows=e,this.cols=N}get(e,N){return this.a[e*this.cols+N]}set(e,N,D){this.a[e*this.cols+N]=D}}class o{constructor(e){let N=0,D=0;for(let v=0,y=e.length;v<y;v++){const[b,w,r]=e[v];w>N&&(N=w),b>D&&(D=b),r>D&&(D=r)}N++,D++;const _=new i(D,N,0);for(let v=0,y=e.length;v<y;v++){const[b,w,r]=e[v];_.set(b,w,r)}this.a=_,this.b=N}nextState(e,N){return N<0||N>=this.b?0:this.a.get(e,N)}}t.StateMachine=o;let E=null;function g(){return E===null&&(E=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),E}var s;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(s||(s={}));let l=null;function m(){if(l===null){l=new F.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let N=0;N<d.length;N++)l.set(d.charCodeAt(N),1);const e=".,;:";for(let N=0;N<e.length;N++)l.set(e.charCodeAt(N),2)}return l}class R{static a(e,N,D,_,v){let y=v-1;do{const b=N.charCodeAt(y);if(e.get(b)!==2)break;y--}while(y>_);if(_>0){const b=N.charCodeAt(_-1),w=N.charCodeAt(y);(b===40&&w===41||b===91&&w===93||b===123&&w===125)&&y--}return{range:{startLineNumber:D,startColumn:_+1,endLineNumber:D,endColumn:y+2},url:N.substring(_,y+1)}}static computeLinks(e,N=g()){const D=m(),_=[];for(let v=1,y=e.getLineCount();v<=y;v++){const b=e.getLineContent(v),w=b.length;let r=0,a=0,A=0,h=1,L=!1,c=!1,u=!1,p=!1;for(;r<w;){let k=!1;const P=b.charCodeAt(r);if(h===13){let M;switch(P){case 40:L=!0,M=0;break;case 41:M=L?0:1;break;case 91:u=!0,c=!0,M=0;break;case 93:u=!1,M=c?0:1;break;case 123:p=!0,M=0;break;case 125:M=p?0:1;break;case 39:case 34:case 96:A===P?M=1:A===39||A===34||A===96?M=0:M=1;break;case 42:M=A===42?1:0;break;case 124:M=A===124?1:0;break;case 32:M=u?0:1;break;default:M=D.get(P)}M===1&&(_.push(R.a(D,b,v,a,r)),k=!0)}else if(h===12){let M;P===91?(c=!0,M=0):M=D.get(P),M===1?k=!0:h=13}else h=N.nextState(h,P),h===0&&(k=!0);k&&(h=1,L=!1,c=!1,p=!1,a=r+1,A=P),r++}h===13&&_.push(R.a(D,b,v,a,w))}return _}}t.LinkComputer=R;function f(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:R.computeLinks(d)}t.computeLinks=f}),J(K[47],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class F{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,o,E,g,s){if(i&&o){const l=this.a(o,s);if(l)return{range:i,value:l}}if(E&&g){const l=this.a(g,s);if(l)return{range:E,value:l}}return null}a(i,o){const E=this.b(i,o);return E!==null?E:this.d(i,o)}b(i,o){const E=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let g=Number(i);const s=parseFloat(i);return!isNaN(g)&&!isNaN(s)&&g===s?g===0&&!o?null:(g=Math.floor(g*E),g+=o?E:-E,String(g/E)):null}d(i,o){return this.e(this.c,i,o)}e(i,o,E){let g=null;for(let s=0,l=i.length;g===null&&s<l;s++)g=this.f(i[s],o,E);return g}f(i,o,E){let g=i.indexOf(o);return g>=0?(g+=E?1:-1,g<0?g=i.length-1:g%=i.length,i[g]):null}}t.BasicInplaceReplace=F,F.INSTANCE=new F}),J(K[48],ee([0,1,12]),function(j,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.isITextSnapshot=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var S;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(S||(t.OverviewRulerLane=S={}));var i;(function(b){b[b.Left=1]="Left",b[b.Right=2]="Right"})(i||(t.GlyphMarginLane=i={}));var o;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(o||(t.MinimapPosition=o={}));var E;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(E||(t.InjectedTextCursorStops=E={}));var g;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(g||(t.EndOfLinePreference=g={}));var s;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(s||(t.DefaultEndOfLine=s={}));var l;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(l||(t.EndOfLineSequence=l={}));class m{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(w){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,w.tabSize|0),w.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,w.indentSize|0),this.a=!1),this.insertSpaces=!!w.insertSpaces,this.defaultEOL=w.defaultEOL|0,this.trimAutoWhitespace=!!w.trimAutoWhitespace,this.bracketPairColorizationOptions=w.bracketPairColorizationOptions}equals(w){return this.tabSize===w.tabSize&&this.a===w.a&&this.indentSize===w.indentSize&&this.insertSpaces===w.insertSpaces&&this.defaultEOL===w.defaultEOL&&this.trimAutoWhitespace===w.trimAutoWhitespace&&(0,F.equals)(this.bracketPairColorizationOptions,w.bracketPairColorizationOptions)}createChangeEvent(w){return{tabSize:this.tabSize!==w.tabSize,indentSize:this.indentSize!==w.indentSize,insertSpaces:this.insertSpaces!==w.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==w.trimAutoWhitespace}}}t.TextModelResolvedOptions=m;class R{constructor(w,r){this._findMatchBrand=void 0,this.range=w,this.matches=r}}t.FindMatch=R;var f;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(f||(t.TrackedRangeStickiness=f={}));function d(b){return b&&typeof b.read=="function"}t.isITextSnapshot=d;var e;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var N;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(N||(t.ModelConstants=N={}));class D{constructor(w,r,a,A,h,L){this.identifier=w,this.range=r,this.text=a,this.forceMoveMarkers=A,this.isAutoWhitespaceEdit=h,this._isTracked=L}}t.ValidAnnotatedEditOperation=D;class _{constructor(w,r,a){this.regex=w,this.wordSeparators=r,this.simpleSearch=a}}t.SearchData=_;class v{constructor(w,r,a){this.reverseEdits=w,this.changes=r,this.trimAutoWhitespaceLineNumbers=a}}t.ApplyEditsResult=v;function y(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}t.shouldSynchronizeModel=y}),J(K[49],ee([0,1,29,22]),function(j,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class i{constructor(s){this.a=s,this.b=new Uint32Array(s.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(s,l){s=(0,S.toUint32)(s);const m=this.a,R=this.b,f=l.length;return f===0?!1:(this.a=new Uint32Array(m.length+f),this.a.set(m.subarray(0,s),0),this.a.set(m.subarray(s),s+f),this.a.set(l,s),s-1<this.c[0]&&(this.c[0]=s-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(R.subarray(0,this.c[0]+1)),!0)}setValue(s,l){return s=(0,S.toUint32)(s),l=(0,S.toUint32)(l),this.a[s]===l?!1:(this.a[s]=l,s-1<this.c[0]&&(this.c[0]=s-1),!0)}removeValues(s,l){s=(0,S.toUint32)(s),l=(0,S.toUint32)(l);const m=this.a,R=this.b;if(s>=m.length)return!1;const f=m.length-s;return l>=f&&(l=f),l===0?!1:(this.a=new Uint32Array(m.length-l),this.a.set(m.subarray(0,s),0),this.a.set(m.subarray(s+l),s),this.b=new Uint32Array(this.a.length),s-1<this.c[0]&&(this.c[0]=s-1),this.c[0]>=0&&this.b.set(R.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(s){return s<0?0:(s=(0,S.toUint32)(s),this.d(s))}d(s){if(s<=this.c[0])return this.b[s];let l=this.c[0]+1;l===0&&(this.b[0]=this.a[0],l++),s>=this.a.length&&(s=this.a.length-1);for(let m=l;m<=s;m++)this.b[m]=this.b[m-1]+this.a[m];return this.c[0]=Math.max(this.c[0],s),this.b[s]}getIndexOf(s){s=Math.floor(s),this.getTotalSum();let l=0,m=this.a.length-1,R=0,f=0,d=0;for(;l<=m;)if(R=l+(m-l)/2|0,f=this.b[R],d=f-this.a[R],s<d)m=R-1;else if(s>=f)l=R+1;else break;return new E(R,s-d)}}t.PrefixSumComputer=i;class o{constructor(s){this.a=s,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(s){return this.g(),s===0?0:this.d[s-1]}getIndexOf(s){this.g();const l=this.e[s],m=l>0?this.d[l-1]:0;return new E(l,s-m)}removeValues(s,l){this.a.splice(s,l),this.f(s)}insertValues(s,l){this.a=(0,F.arrayInsert)(this.a,s,l),this.f(s)}f(s){this.b=!1,this.c=Math.min(this.c,s-1)}g(){if(!this.b){for(let s=this.c+1,l=this.a.length;s<l;s++){const m=this.a[s],R=s>0?this.d[s-1]:0;this.d[s]=R+m;for(let f=0;f<m;f++)this.e[R+f]=s}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(s,l){this.a[s]!==l&&(this.a[s]=l,this.f(s))}}t.ConstantTimePrefixSumComputer=o;class E{constructor(s,l){this.index=s,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=s,this.remainder=l}}t.PrefixSumIndexOfResult=E}),J(K[50],ee([0,1,5,4,49]),function(j,t,F,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class o{constructor(g,s,l,m){this.d=g,this.f=s,this.g=l,this.h=m,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(g){g.eol&&g.eol!==this.g&&(this.g=g.eol,this.j=null);const s=g.changes;for(const l of s)this.o(l.range),this.p(new S.Position(l.range.startLineNumber,l.range.startColumn),l.text);this.h=g.versionId,this.k=null}l(){if(!this.j){const g=this.g.length,s=this.f.length,l=new Uint32Array(s);for(let m=0;m<s;m++)l[m]=this.f[m].length+g;this.j=new i.PrefixSumComputer(l)}}n(g,s){this.f[g]=s,this.j&&this.j.setValue(g,this.f[g].length+this.g.length)}o(g){if(g.startLineNumber===g.endLineNumber){if(g.startColumn===g.endColumn)return;this.n(g.startLineNumber-1,this.f[g.startLineNumber-1].substring(0,g.startColumn-1)+this.f[g.startLineNumber-1].substring(g.endColumn-1));return}this.n(g.startLineNumber-1,this.f[g.startLineNumber-1].substring(0,g.startColumn-1)+this.f[g.endLineNumber-1].substring(g.endColumn-1)),this.f.splice(g.startLineNumber,g.endLineNumber-g.startLineNumber),this.j&&this.j.removeValues(g.startLineNumber,g.endLineNumber-g.startLineNumber)}p(g,s){if(s.length===0)return;const l=(0,F.splitLines)(s);if(l.length===1){this.n(g.lineNumber-1,this.f[g.lineNumber-1].substring(0,g.column-1)+l[0]+this.f[g.lineNumber-1].substring(g.column-1));return}l[l.length-1]+=this.f[g.lineNumber-1].substring(g.column-1),this.n(g.lineNumber-1,this.f[g.lineNumber-1].substring(0,g.column-1)+l[0]);const m=new Uint32Array(l.length-1);for(let R=1;R<l.length;R++)this.f.splice(g.lineNumber+R-1,0,l[R]),m[R-1]=l[R].length+this.g.length;this.j&&this.j.insertValues(g.lineNumber,m)}}t.MirrorTextModel=o}),J(K[51],ee([0,1,5,38,4,2,48]),function(j,t,F,S,i,o,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0;const g=999;class s{constructor(v,y,b,w){this.searchString=v,this.isRegex=y,this.matchCase=b,this.wordSeparators=w}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=l(this.searchString):v=this.searchString.indexOf(`
`)>=0;let y=null;try{y=F.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!y)return null;let b=!this.isRegex&&!v;return b&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(b=this.matchCase),new E.SearchData(y,this.wordSeparators?(0,S.getMapForWordSeparators)(this.wordSeparators):null,b?this.searchString:null)}}t.SearchParams=s;function l(_){if(!_||_.length===0)return!1;for(let v=0,y=_.length;v<y;v++){const b=_.charCodeAt(v);if(b===10)return!0;if(b===92){if(v++,v>=y)break;const w=_.charCodeAt(v);if(w===110||w===114||w===87)return!0}}return!1}t.isMultilineRegexSource=l;function m(_,v,y){if(!y)return new E.FindMatch(_,null);const b=[];for(let w=0,r=v.length;w<r;w++)b[w]=v[w];return new E.FindMatch(_,b)}t.createFindMatch=m;class R{constructor(v){const y=[];let b=0;for(let w=0,r=v.length;w<r;w++)v.charCodeAt(w)===10&&(y[b++]=w);this.a=y}findLineFeedCountBeforeOffset(v){const y=this.a;let b=0,w=y.length-1;if(w===-1||v<=y[0])return 0;for(;b<w;){const r=b+((w-b)/2>>0);y[r]>=v?w=r-1:y[r+1]>=v?(b=r,w=r):b=r+1}return b+1}}class f{static findMatches(v,y,b,w,r){const a=y.parseSearchRequest();return a?a.regex.multiline?this.b(v,b,new D(a.wordSeparators,a.regex),w,r):this.c(v,b,a,w,r):[]}static a(v,y,b,w,r,a){let A,h=0;w?(h=w.findLineFeedCountBeforeOffset(r),A=y+r+h):A=y+r;let L;if(w){const k=w.findLineFeedCountBeforeOffset(r+a.length)-h;L=A+a.length+k}else L=A+a.length;const c=v.getPositionAt(A),u=v.getPositionAt(L);return new o.Range(c.lineNumber,c.column,u.lineNumber,u.column)}static b(v,y,b,w,r){const a=v.getOffsetAt(y.getStartPosition()),A=v.getValueInRange(y,1),h=v.getEOL()===`\r
`?new R(A):null,L=[];let c=0,u;for(b.reset(0);u=b.next(A);)if(L[c++]=m(this.a(v,a,A,h,u.index,u[0]),u,w),c>=r)return L;return L}static c(v,y,b,w,r){const a=[];let A=0;if(y.startLineNumber===y.endLineNumber){const L=v.getLineContent(y.startLineNumber).substring(y.startColumn-1,y.endColumn-1);return A=this.d(b,L,y.startLineNumber,y.startColumn-1,A,a,w,r),a}const h=v.getLineContent(y.startLineNumber).substring(y.startColumn-1);A=this.d(b,h,y.startLineNumber,y.startColumn-1,A,a,w,r);for(let L=y.startLineNumber+1;L<y.endLineNumber&&A<r;L++)A=this.d(b,v.getLineContent(L),L,0,A,a,w,r);if(A<r){const L=v.getLineContent(y.endLineNumber).substring(0,y.endColumn-1);A=this.d(b,L,y.endLineNumber,0,A,a,w,r)}return a}static d(v,y,b,w,r,a,A,h){const L=v.wordSeparators;if(!A&&v.simpleSearch){const p=v.simpleSearch,k=p.length,P=y.length;let M=-k;for(;(M=y.indexOf(p,M+k))!==-1;)if((!L||N(L,y,P,M,k))&&(a[r++]=new E.FindMatch(new o.Range(b,M+1+w,b,M+1+k+w),null),r>=h))return r;return r}const c=new D(v.wordSeparators,v.regex);let u;c.reset(0);do if(u=c.next(y),u&&(a[r++]=m(new o.Range(b,u.index+1+w,b,u.index+1+u[0].length+w),u,A),r>=h))return r;while(u);return r}static findNextMatch(v,y,b,w){const r=y.parseSearchRequest();if(!r)return null;const a=new D(r.wordSeparators,r.regex);return r.regex.multiline?this.e(v,b,a,w):this.f(v,b,a,w)}static e(v,y,b,w){const r=new i.Position(y.lineNumber,1),a=v.getOffsetAt(r),A=v.getLineCount(),h=v.getValueInRange(new o.Range(r.lineNumber,r.column,A,v.getLineMaxColumn(A)),1),L=v.getEOL()===`\r
`?new R(h):null;b.reset(y.column-1);const c=b.next(h);return c?m(this.a(v,a,h,L,c.index,c[0]),c,w):y.lineNumber!==1||y.column!==1?this.e(v,new i.Position(1,1),b,w):null}static f(v,y,b,w){const r=v.getLineCount(),a=y.lineNumber,A=v.getLineContent(a),h=this.g(b,A,a,y.column,w);if(h)return h;for(let L=1;L<=r;L++){const c=(a+L-1)%r,u=v.getLineContent(c+1),p=this.g(b,u,c+1,1,w);if(p)return p}return null}static g(v,y,b,w,r){v.reset(w-1);const a=v.next(y);return a?m(new o.Range(b,a.index+1,b,a.index+1+a[0].length),a,r):null}static findPreviousMatch(v,y,b,w){const r=y.parseSearchRequest();if(!r)return null;const a=new D(r.wordSeparators,r.regex);return r.regex.multiline?this.h(v,b,a,w):this.j(v,b,a,w)}static h(v,y,b,w){const r=this.b(v,new o.Range(1,1,y.lineNumber,y.column),b,w,10*g);if(r.length>0)return r[r.length-1];const a=v.getLineCount();return y.lineNumber!==a||y.column!==v.getLineMaxColumn(a)?this.h(v,new i.Position(a,v.getLineMaxColumn(a)),b,w):null}static j(v,y,b,w){const r=v.getLineCount(),a=y.lineNumber,A=v.getLineContent(a).substring(0,y.column-1),h=this.k(b,A,a,w);if(h)return h;for(let L=1;L<=r;L++){const c=(r+a-L-1)%r,u=v.getLineContent(c+1),p=this.k(b,u,c+1,w);if(p)return p}return null}static k(v,y,b,w){let r=null,a;for(v.reset(0);a=v.next(y);)r=m(new o.Range(b,a.index+1,b,a.index+1+a[0].length),a,w);return r}}t.TextModelSearch=f;function d(_,v,y,b,w){if(b===0)return!0;const r=v.charCodeAt(b-1);if(_.get(r)!==0||r===13||r===10)return!0;if(w>0){const a=v.charCodeAt(b);if(_.get(a)!==0)return!0}return!1}function e(_,v,y,b,w){if(b+w===y)return!0;const r=v.charCodeAt(b+w);if(_.get(r)!==0||r===13||r===10)return!0;if(w>0){const a=v.charCodeAt(b+w-1);if(_.get(a)!==0)return!0}return!1}function N(_,v,y,b,w){return d(_,v,y,b,w)&&e(_,v,y,b,w)}t.isValidMatch=N;class D{constructor(v,y){this._wordSeparators=v,this.a=y,this.b=-1,this.c=0}reset(v){this.a.lastIndex=v,this.b=-1,this.c=0}next(v){const y=v.length;let b;do{if(this.b+this.c===y||(b=this.a.exec(v),!b))return null;const w=b.index,r=b[0].length;if(w===this.b&&r===this.c){if(r===0){F.getNextCodePoint(v,y,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=w,this.c=r,!this._wordSeparators||N(this._wordSeparators,v,y,w,r))return b}while(b);return null}}t.Searcher=D}),J(K[52],ee([0,1,2,51,5,11,24]),function(j,t,F,S,i,o,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class g{static computeUnicodeHighlights(e,N,D){const _=D?D.startLineNumber:1,v=D?D.endLineNumber:e.getLineCount(),y=new m(N),b=y.getCandidateCodePoints();let w;b==="allNonBasicAscii"?w=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):w=new RegExp(`${s(Array.from(b))}`,"g");const r=new S.Searcher(null,w),a=[];let A=!1,h,L=0,c=0,u=0;e:for(let p=_,k=v;p<=k;p++){const P=e.getLineContent(p),M=P.length;r.reset(0);do if(h=r.next(P),h){let I=h.index,B=h.index+h[0].length;if(I>0){const Y=P.charCodeAt(I-1);i.isHighSurrogate(Y)&&I--}if(B+1<M){const Y=P.charCodeAt(B-1);i.isHighSurrogate(Y)&&B++}const W=P.substring(I,B);let z=(0,E.getWordAtText)(I+1,E.DEFAULT_WORD_REGEXP,P,0);z&&z.endColumn<=I+1&&(z=null);const Z=y.shouldHighlightNonBasicASCII(W,z?z.word:null);if(Z!==0){Z===3?L++:Z===2?c++:Z===1?u++:(0,o.assertNever)(Z);const Y=1e3;if(a.length>=Y){A=!0;break e}a.push(new F.Range(p,I+1,p,B+1))}}while(h)}return{ranges:a,hasMore:A,ambiguousCharacterCount:L,invisibleCharacterCount:c,nonBasicAsciiCharacterCount:u}}static computeUnicodeHighlightReason(e,N){const D=new m(N);switch(D.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const v=e.codePointAt(0),y=D.ambiguousCharacters.getPrimaryConfusable(v),b=i.AmbiguousCharacters.getLocales().filter(w=>!i.AmbiguousCharacters.getInstance(new Set([...N.allowedLocales,w])).isAmbiguous(v));return{kind:0,confusableWith:String.fromCodePoint(y),notAmbiguousInLocales:b}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=g;function s(d,e){return`[${i.escapeRegExpCharacters(d.map(D=>String.fromCodePoint(D)).join(""))}]`}var l;(function(d){d[d.Ambiguous=0]="Ambiguous",d[d.Invisible=1]="Invisible",d[d.NonBasicAscii=2]="NonBasicAscii"})(l||(t.UnicodeHighlighterReasonKind=l={}));class m{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const N of i.InvisibleCharacters.codePoints)R(String.fromCodePoint(N))||e.add(N);if(this.b.ambiguousCharacters)for(const N of this.ambiguousCharacters.getConfusableCodePoints())e.add(N);for(const N of this.a)e.delete(N);return e}shouldHighlightNonBasicASCII(e,N){const D=e.codePointAt(0);if(this.a.has(D))return 0;if(this.b.nonBasicASCII)return 1;let _=!1,v=!1;if(N)for(const y of N){const b=y.codePointAt(0),w=i.isBasicASCII(y);_=_||w,!w&&!this.ambiguousCharacters.isAmbiguous(b)&&!i.InvisibleCharacters.isInvisibleCharacter(b)&&(v=!0)}return!_&&v?0:this.b.invisibleCharacters&&!R(e)&&i.InvisibleCharacters.isInvisibleCharacter(D)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(D)?3:0}}function R(d){return d===" "||d===`
`||d==="	"}var f;(function(d){d[d.None=0]="None",d[d.NonBasicASCII=1]="NonBasicASCII",d[d.Invisible=2]="Invisible",d[d.Ambiguous=3]="Ambiguous"})(f||(f={}))}),J(K[53],ee([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var F;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(F||(t.AccessibilitySupport=F={}));var S;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(S||(t.CodeActionTriggerType=S={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i||(t.CompletionItemInsertTextRule=i={}));var o;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(o||(t.CompletionItemKind=o={}));var E;(function(n){n[n.Deprecated=1]="Deprecated"})(E||(t.CompletionItemTag=E={}));var g;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(t.CompletionTriggerKind=g={}));var s;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(s||(t.ContentWidgetPositionPreference=s={}));var l;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(l||(t.CursorChangeReason=l={}));var m;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(m||(t.DefaultEndOfLine=m={}));var R;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(R||(t.DocumentHighlightKind=R={}));var f;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(f||(t.EditorAutoIndentStrategy=f={}));var d;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=7]="autoClosingDelete",n[n.autoClosingOvertype=8]="autoClosingOvertype",n[n.autoClosingQuotes=9]="autoClosingQuotes",n[n.autoIndent=10]="autoIndent",n[n.automaticLayout=11]="automaticLayout",n[n.autoSurround=12]="autoSurround",n[n.bracketPairColorization=13]="bracketPairColorization",n[n.guides=14]="guides",n[n.codeLens=15]="codeLens",n[n.codeLensFontFamily=16]="codeLensFontFamily",n[n.codeLensFontSize=17]="codeLensFontSize",n[n.colorDecorators=18]="colorDecorators",n[n.colorDecoratorsLimit=19]="colorDecoratorsLimit",n[n.columnSelection=20]="columnSelection",n[n.comments=21]="comments",n[n.contextmenu=22]="contextmenu",n[n.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",n[n.cursorBlinking=24]="cursorBlinking",n[n.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",n[n.cursorStyle=26]="cursorStyle",n[n.cursorSurroundingLines=27]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",n[n.cursorWidth=29]="cursorWidth",n[n.disableLayerHinting=30]="disableLayerHinting",n[n.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",n[n.domReadOnly=32]="domReadOnly",n[n.dragAndDrop=33]="dragAndDrop",n[n.dropIntoEditor=34]="dropIntoEditor",n[n.emptySelectionClipboard=35]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",n[n.extraEditorClassName=37]="extraEditorClassName",n[n.fastScrollSensitivity=38]="fastScrollSensitivity",n[n.find=39]="find",n[n.fixedOverflowWidgets=40]="fixedOverflowWidgets",n[n.folding=41]="folding",n[n.foldingStrategy=42]="foldingStrategy",n[n.foldingHighlight=43]="foldingHighlight",n[n.foldingImportsByDefault=44]="foldingImportsByDefault",n[n.foldingMaximumRegions=45]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=47]="fontFamily",n[n.fontInfo=48]="fontInfo",n[n.fontLigatures=49]="fontLigatures",n[n.fontSize=50]="fontSize",n[n.fontWeight=51]="fontWeight",n[n.fontVariations=52]="fontVariations",n[n.formatOnPaste=53]="formatOnPaste",n[n.formatOnType=54]="formatOnType",n[n.glyphMargin=55]="glyphMargin",n[n.gotoLocation=56]="gotoLocation",n[n.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",n[n.hover=58]="hover",n[n.inDiffEditor=59]="inDiffEditor",n[n.inlineSuggest=60]="inlineSuggest",n[n.letterSpacing=61]="letterSpacing",n[n.lightbulb=62]="lightbulb",n[n.lineDecorationsWidth=63]="lineDecorationsWidth",n[n.lineHeight=64]="lineHeight",n[n.lineNumbers=65]="lineNumbers",n[n.lineNumbersMinChars=66]="lineNumbersMinChars",n[n.linkedEditing=67]="linkedEditing",n[n.links=68]="links",n[n.matchBrackets=69]="matchBrackets",n[n.minimap=70]="minimap",n[n.mouseStyle=71]="mouseStyle",n[n.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=73]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",n[n.multiCursorModifier=75]="multiCursorModifier",n[n.multiCursorPaste=76]="multiCursorPaste",n[n.multiCursorLimit=77]="multiCursorLimit",n[n.occurrencesHighlight=78]="occurrencesHighlight",n[n.overviewRulerBorder=79]="overviewRulerBorder",n[n.overviewRulerLanes=80]="overviewRulerLanes",n[n.padding=81]="padding",n[n.pasteAs=82]="pasteAs",n[n.parameterHints=83]="parameterHints",n[n.peekWidgetDefaultFocus=84]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=85]="definitionLinkOpensInPeek",n[n.quickSuggestions=86]="quickSuggestions",n[n.quickSuggestionsDelay=87]="quickSuggestionsDelay",n[n.readOnly=88]="readOnly",n[n.renameOnType=89]="renameOnType",n[n.renderControlCharacters=90]="renderControlCharacters",n[n.renderFinalNewline=91]="renderFinalNewline",n[n.renderLineHighlight=92]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=93]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=94]="renderValidationDecorations",n[n.renderWhitespace=95]="renderWhitespace",n[n.revealHorizontalRightPadding=96]="revealHorizontalRightPadding",n[n.roundedSelection=97]="roundedSelection",n[n.rulers=98]="rulers",n[n.scrollbar=99]="scrollbar",n[n.scrollBeyondLastColumn=100]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=101]="scrollBeyondLastLine",n[n.scrollPredominantAxis=102]="scrollPredominantAxis",n[n.selectionClipboard=103]="selectionClipboard",n[n.selectionHighlight=104]="selectionHighlight",n[n.selectOnLineNumbers=105]="selectOnLineNumbers",n[n.showFoldingControls=106]="showFoldingControls",n[n.showUnused=107]="showUnused",n[n.snippetSuggestions=108]="snippetSuggestions",n[n.smartSelect=109]="smartSelect",n[n.smoothScrolling=110]="smoothScrolling",n[n.stickyScroll=111]="stickyScroll",n[n.stickyTabStops=112]="stickyTabStops",n[n.stopRenderingLineAfter=113]="stopRenderingLineAfter",n[n.suggest=114]="suggest",n[n.suggestFontSize=115]="suggestFontSize",n[n.suggestLineHeight=116]="suggestLineHeight",n[n.suggestOnTriggerCharacters=117]="suggestOnTriggerCharacters",n[n.suggestSelection=118]="suggestSelection",n[n.tabCompletion=119]="tabCompletion",n[n.tabIndex=120]="tabIndex",n[n.unicodeHighlighting=121]="unicodeHighlighting",n[n.unusualLineTerminators=122]="unusualLineTerminators",n[n.useShadowDOM=123]="useShadowDOM",n[n.useTabStops=124]="useTabStops",n[n.wordBreak=125]="wordBreak",n[n.wordSeparators=126]="wordSeparators",n[n.wordWrap=127]="wordWrap",n[n.wordWrapBreakAfterCharacters=128]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=129]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=130]="wordWrapColumn",n[n.wordWrapOverride1=131]="wordWrapOverride1",n[n.wordWrapOverride2=132]="wordWrapOverride2",n[n.wrappingIndent=133]="wrappingIndent",n[n.wrappingStrategy=134]="wrappingStrategy",n[n.showDeprecated=135]="showDeprecated",n[n.inlayHints=136]="inlayHints",n[n.editorClassName=137]="editorClassName",n[n.pixelRatio=138]="pixelRatio",n[n.tabFocusMode=139]="tabFocusMode",n[n.layoutInfo=140]="layoutInfo",n[n.wrappingInfo=141]="wrappingInfo",n[n.defaultColorDecorators=142]="defaultColorDecorators"})(d||(t.EditorOption=d={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var N;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(N||(t.EndOfLineSequence=N={}));var D;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(D||(t.GlyphMarginLane=D={}));var _;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(_||(t.IndentAction=_={}));var v;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(v||(t.InjectedTextCursorStops=v={}));var y;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(y||(t.InlayHintKind=y={}));var b;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(b||(t.InlineCompletionTriggerKind=b={}));var w;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(w||(t.KeyCode=w={}));var r;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(r||(t.MarkerSeverity=r={}));var a;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(a||(t.MarkerTag=a={}));var A;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(A||(t.MinimapPosition=A={}));var h;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(h||(t.MouseTargetType=h={}));var L;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(L||(t.OverlayWidgetPositionPreference=L={}));var c;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(c||(t.OverviewRulerLane=c={}));var u;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(u||(t.PositionAffinity=u={}));var p;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(p||(t.RenderLineNumbersType=p={}));var k;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(k||(t.RenderMinimap=k={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P||(t.ScrollType=P={}));var M;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(M||(t.ScrollbarVisibility=M={}));var I;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(I||(t.SelectionDirection=I={}));var B;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(B||(t.SignatureHelpTriggerKind=B={}));var W;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(W||(t.SymbolKind=W={}));var z;(function(n){n[n.Deprecated=1]="Deprecated"})(z||(t.SymbolTag=z={}));var Z;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(Z||(t.TextEditorCursorBlinkingStyle=Z={}));var Y;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(Y||(t.TextEditorCursorStyle=Y={}));var G;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(G||(t.TrackedRangeStickiness=G={}));var se;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(se||(t.WrappingIndent=se={}))}),J(K[54],ee([0,1,9,7]),function(j,t,F,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class i{constructor(){this.a=new Map,this.b=new Map,this.c=new F.Emitter,this.onDidChange=this.c.event,this.d=null}handleChange(g){this.c.fire({changedLanguages:g,changedColorMap:!1})}register(g,s){return this.a.set(g,s),this.handleChange([g]),(0,S.toDisposable)(()=>{this.a.get(g)===s&&(this.a.delete(g),this.handleChange([g]))})}get(g){return this.a.get(g)||null}registerFactory(g,s){this.b.get(g)?.dispose();const l=new o(this,g,s);return this.b.set(g,l),(0,S.toDisposable)(()=>{const m=this.b.get(g);!m||m!==l||(this.b.delete(g),m.dispose())})}async getOrCreate(g){const s=this.get(g);if(s)return s;const l=this.b.get(g);return!l||l.isResolved?null:(await l.resolve(),this.get(g))}isResolved(g){if(this.get(g))return!0;const l=this.b.get(g);return!!(!l||l.isResolved)}setColorMap(g){this.d=g,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.TokenizationRegistry=i;class o extends S.Disposable{get isResolved(){return this.c}constructor(g,s,l){super(),this.f=g,this.g=s,this.h=l,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const g=await this.h.tokenizationSupport;this.c=!0,g&&!this.a&&this.B(this.f.register(this.g,g))}}}),J(K[55],ee([0,1,36,13,2,54]),function(j,t,F,S,i,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.FoldingRangeKind=t.SymbolKinds=t.SymbolTag=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.SelectedSuggestionInfo=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0;class E{constructor(I,B,W){this.offset=I,this.type=B,this.language=W,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=E;class g{constructor(I,B){this.tokens=I,this.endState=B,this._tokenizationResultBrand=void 0}}t.TokenizationResult=g;class s{constructor(I,B){this.tokens=I,this.endState=B,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=s;var l;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(l||(t.CompletionItemKind=l={}));var m;(function(M){const I=new Map;I.set(0,F.Codicon.symbolMethod),I.set(1,F.Codicon.symbolFunction),I.set(2,F.Codicon.symbolConstructor),I.set(3,F.Codicon.symbolField),I.set(4,F.Codicon.symbolVariable),I.set(5,F.Codicon.symbolClass),I.set(6,F.Codicon.symbolStruct),I.set(7,F.Codicon.symbolInterface),I.set(8,F.Codicon.symbolModule),I.set(9,F.Codicon.symbolProperty),I.set(10,F.Codicon.symbolEvent),I.set(11,F.Codicon.symbolOperator),I.set(12,F.Codicon.symbolUnit),I.set(13,F.Codicon.symbolValue),I.set(15,F.Codicon.symbolEnum),I.set(14,F.Codicon.symbolConstant),I.set(15,F.Codicon.symbolEnum),I.set(16,F.Codicon.symbolEnumMember),I.set(17,F.Codicon.symbolKeyword),I.set(27,F.Codicon.symbolSnippet),I.set(18,F.Codicon.symbolText),I.set(19,F.Codicon.symbolColor),I.set(20,F.Codicon.symbolFile),I.set(21,F.Codicon.symbolReference),I.set(22,F.Codicon.symbolCustomColor),I.set(23,F.Codicon.symbolFolder),I.set(24,F.Codicon.symbolTypeParameter),I.set(25,F.Codicon.account),I.set(26,F.Codicon.issues);function B(Z){let Y=I.get(Z);return Y||(console.info("No codicon found for CompletionItemKind "+Z),Y=F.Codicon.symbolProperty),Y}M.toIcon=B;const W=new Map;W.set("method",0),W.set("function",1),W.set("constructor",2),W.set("field",3),W.set("variable",4),W.set("class",5),W.set("struct",6),W.set("interface",7),W.set("module",8),W.set("property",9),W.set("event",10),W.set("operator",11),W.set("unit",12),W.set("value",13),W.set("constant",14),W.set("enum",15),W.set("enum-member",16),W.set("enumMember",16),W.set("keyword",17),W.set("snippet",27),W.set("text",18),W.set("color",19),W.set("file",20),W.set("reference",21),W.set("customcolor",22),W.set("folder",23),W.set("type-parameter",24),W.set("typeParameter",24),W.set("account",25),W.set("issue",26);function z(Z,Y){let G=W.get(Z);return typeof G>"u"&&!Y&&(G=9),G}M.fromString=z})(m||(t.CompletionItemKinds=m={}));var R;(function(M){M[M.Deprecated=1]="Deprecated"})(R||(t.CompletionItemTag=R={}));var f;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(f||(t.CompletionItemInsertTextRule=f={}));var d;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(t.CompletionTriggerKind=d={}));var e;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(e||(t.InlineCompletionTriggerKind=e={}));class N{constructor(I,B,W,z){this.range=I,this.text=B,this.completionKind=W,this.isSnippetText=z}equals(I){return i.Range.lift(this.range).equalsRange(I.range)&&this.text===I.text&&this.completionKind===I.completionKind&&this.isSnippetText===I.isSnippetText}}t.SelectedSuggestionInfo=N;var D;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(D||(t.CodeActionTriggerType=D={}));var _;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(_||(t.SignatureHelpTriggerKind=_={}));var v;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(v||(t.DocumentHighlightKind=v={}));function y(M){return M&&S.URI.isUri(M.uri)&&i.Range.isIRange(M.range)&&(i.Range.isIRange(M.originSelectionRange)||i.Range.isIRange(M.targetSelectionRange))}t.isLocationLink=y;var b;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(b||(t.SymbolKind=b={}));var w;(function(M){M[M.Deprecated=1]="Deprecated"})(w||(t.SymbolTag=w={}));var r;(function(M){const I=new Map;I.set(0,F.Codicon.symbolFile),I.set(1,F.Codicon.symbolModule),I.set(2,F.Codicon.symbolNamespace),I.set(3,F.Codicon.symbolPackage),I.set(4,F.Codicon.symbolClass),I.set(5,F.Codicon.symbolMethod),I.set(6,F.Codicon.symbolProperty),I.set(7,F.Codicon.symbolField),I.set(8,F.Codicon.symbolConstructor),I.set(9,F.Codicon.symbolEnum),I.set(10,F.Codicon.symbolInterface),I.set(11,F.Codicon.symbolFunction),I.set(12,F.Codicon.symbolVariable),I.set(13,F.Codicon.symbolConstant),I.set(14,F.Codicon.symbolString),I.set(15,F.Codicon.symbolNumber),I.set(16,F.Codicon.symbolBoolean),I.set(17,F.Codicon.symbolArray),I.set(18,F.Codicon.symbolObject),I.set(19,F.Codicon.symbolKey),I.set(20,F.Codicon.symbolNull),I.set(21,F.Codicon.symbolEnumMember),I.set(22,F.Codicon.symbolStruct),I.set(23,F.Codicon.symbolEvent),I.set(24,F.Codicon.symbolOperator),I.set(25,F.Codicon.symbolTypeParameter);function B(W){let z=I.get(W);return z||(console.info("No codicon found for SymbolKind "+W),z=F.Codicon.symbolProperty),z}M.toIcon=B})(r||(t.SymbolKinds=r={}));class a{static fromValue(I){switch(I){case"comment":return a.Comment;case"imports":return a.Imports;case"region":return a.Region}return new a(I)}constructor(I){this.value=I}}t.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var A;(function(M){function I(B){return!B||typeof B!="object"?!1:typeof B.id=="string"&&typeof B.title=="string"}M.is=I})(A||(t.Command=A={}));var h;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(h||(t.CommentThreadCollapsibleState=h={}));var L;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(L||(t.CommentThreadState=L={}));var c;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(c||(t.CommentMode=c={}));var u;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(u||(t.CommentState=u={}));var p;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(p||(t.InlayHintKind=p={}));class k{constructor(I){this.b=I,this.a=null}dispose(){this.a&&this.a.then(I=>{I&&I.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.LazyTokenizationSupport=k,t.TokenizationRegistry=new o.TokenizationRegistry;var P;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(P||(t.ExternalUriOpenerPriority=P={}))}),J(K[56],ee([0,1,19,9,30,13,4,2,37,55,53]),function(j,t,F,S,i,o,E,g,s,l,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class R{static chord(e,N){return(0,i.KeyChord)(e,N)}}t.KeyMod=R,R.CtrlCmd=2048,R.Shift=1024,R.Alt=512,R.WinCtrl=256;function f(){return{editor:void 0,languages:void 0,CancellationTokenSource:F.CancellationTokenSource,Emitter:S.Emitter,KeyCode:m.KeyCode,KeyMod:R,Position:E.Position,Range:g.Range,Selection:s.Selection,SelectionDirection:m.SelectionDirection,MarkerSeverity:m.MarkerSeverity,MarkerTag:m.MarkerTag,Uri:o.URI,Token:l.Token}}t.createMonacoBaseAPI=f}),J(K[59],ee([0,1,20,13,4,2,50,24,46,47,56,18,52,26,44,12,3,45]),function(j,t,F,S,i,o,E,g,s,l,m,R,f,d,e,N,D,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class v extends E.MirrorTextModel{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(r){const a=[];for(let A=0;A<this.f.length;A++){const h=this.f[A],L=this.offsetAt(new i.Position(A+1,1)),c=h.matchAll(r);for(const u of c)(u.index||u.index===0)&&(u.index=u.index+L),a.push(u)}return a}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(r){return this.f[r-1]}getWordAtPosition(r,a){const A=(0,g.getWordAtText)(r.column,(0,g.ensureValidWordDefinition)(a),this.f[r.lineNumber-1],0);return A?new o.Range(r.lineNumber,A.startColumn,r.lineNumber,A.endColumn):null}getWordUntilPosition(r,a){const A=this.getWordAtPosition(r,a);return A?{word:this.f[r.lineNumber-1].substring(A.startColumn-1,r.column-1),startColumn:A.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const a=this.f,A=this.q.bind(this);let h=0,L="",c=0,u=[];return{*[Symbol.iterator](){for(;;)if(c<u.length){const p=L.substring(u[c].start,u[c].end);c+=1,yield p}else if(h<a.length)L=a[h],u=A(L,r),c=0,h+=1;else break}}}getLineWords(r,a){const A=this.f[r-1],h=this.q(A,a),L=[];for(const c of h)L.push({word:A.substring(c.start,c.end),startColumn:c.start+1,endColumn:c.end+1});return L}q(r,a){const A=[];let h;for(a.lastIndex=0;(h=a.exec(r))&&h[0].length!==0;)A.push({start:h.index,end:h.index+h[0].length});return A}getValueInRange(r){if(r=this.r(r),r.startLineNumber===r.endLineNumber)return this.f[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const a=this.g,A=r.startLineNumber-1,h=r.endLineNumber-1,L=[];L.push(this.f[A].substring(r.startColumn-1));for(let c=A+1;c<h;c++)L.push(this.f[c]);return L.push(this.f[h].substring(0,r.endColumn-1)),L.join(a)}offsetAt(r){return r=this.s(r),this.l(),this.j.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this.l();const a=this.j.getIndexOf(r),A=this.f[a.index].length;return{lineNumber:1+a.index,column:1+Math.min(a.remainder,A)}}r(r){const a=this.s({lineNumber:r.startLineNumber,column:r.startColumn}),A=this.s({lineNumber:r.endLineNumber,column:r.endColumn});return a.lineNumber!==r.startLineNumber||a.column!==r.startColumn||A.lineNumber!==r.endLineNumber||A.column!==r.endColumn?{startLineNumber:a.lineNumber,startColumn:a.column,endLineNumber:A.lineNumber,endColumn:A.column}:r}s(r){if(!i.Position.isIPosition(r))throw new Error("bad position");let{lineNumber:a,column:A}=r,h=!1;if(a<1)a=1,A=1,h=!0;else if(a>this.f.length)a=this.f.length,A=this.f[a-1].length+1,h=!0;else{const L=this.f[a-1].length+1;A<1?(A=1,h=!0):A>L&&(A=L,h=!0)}return h?{lineNumber:a,column:A}:r}}class y{constructor(r,a){this.d=r,this.f=Object.create(null),this.g=a,this.h=null}dispose(){this.f=Object.create(null)}j(r){return this.f[r]}k(){const r=[];return Object.keys(this.f).forEach(a=>r.push(this.f[a])),r}acceptNewModel(r){this.f[r.url]=new v(S.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,a){if(!this.f[r])return;this.f[r].onEvents(a)}acceptRemovedModel(r){this.f[r]&&delete this.f[r]}async computeUnicodeHighlights(r,a,A){const h=this.j(r);return h?f.UnicodeTextModelHighlighter.computeUnicodeHighlights(h,a,A):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(r,a,A,h){const L=this.j(r),c=this.j(a);return!L||!c?null:y.l(L,c,A,h)}static l(r,a,A,h){const L=h==="advanced"?e.linesDiffComputers.advanced:e.linesDiffComputers.legacy,c=r.getLinesContent(),u=a.getLinesContent(),p=L.computeDiff(c,u,A);return{identical:p.changes.length>0?!1:this.n(r,a),quitEarly:p.hitTimeout,changes:p.changes.map(P=>[P.originalRange.startLineNumber,P.originalRange.endLineNumberExclusive,P.modifiedRange.startLineNumber,P.modifiedRange.endLineNumberExclusive,P.innerChanges?.map(M=>[M.originalRange.startLineNumber,M.originalRange.startColumn,M.originalRange.endLineNumber,M.originalRange.endColumn,M.modifiedRange.startLineNumber,M.modifiedRange.startColumn,M.modifiedRange.endLineNumber,M.modifiedRange.endColumn])])}}static n(r,a){const A=r.getLineCount(),h=a.getLineCount();if(A!==h)return!1;for(let L=1;L<=A;L++){const c=r.getLineContent(L),u=a.getLineContent(L);if(c!==u)return!1}return!0}async computeDirtyDiff(r,a,A){const h=this.j(r),L=this.j(a);if(!h||!L)return null;const c=h.getLinesContent(),u=L.getLinesContent();return new d.DiffComputer(c,u,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:A,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(r,a,A){const h=this.j(r);if(!h)return a;const L=[];let c;a=a.slice(0).sort((u,p)=>{if(u.range&&p.range)return o.Range.compareRangesUsingStarts(u.range,p.range);const k=u.range?0:1,P=p.range?0:1;return k-P});for(let{range:u,text:p,eol:k}of a){if(typeof k=="number"&&(c=k),o.Range.isEmpty(u)&&!p)continue;const P=h.getValueInRange(u);if(p=p.replace(/\r\n|\n|\r/g,h.eol),P===p)continue;if(Math.max(p.length,P.length)>y.o){L.push({range:u,text:p});continue}const M=(0,F.stringDiff)(P,p,A),I=h.offsetAt(o.Range.lift(u).getStartPosition());for(const B of M){const W=h.positionAt(I+B.originalStart),z=h.positionAt(I+B.originalStart+B.originalLength),Z={text:p.substr(B.modifiedStart,B.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:z.lineNumber,endColumn:z.column}};h.getValueInRange(Z.range)!==Z.text&&L.push(Z)}}return typeof c=="number"&&L.push({eol:c,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),L}async computeHumanReadableDiff(r,a,A){const h=this.j(r);if(!h)return a;const L=[];let c;a=a.slice(0).sort((u,p)=>{if(u.range&&p.range)return o.Range.compareRangesUsingStarts(u.range,p.range);const k=u.range?0:1,P=p.range?0:1;return k-P});for(let{range:u,text:p,eol:k}of a){let z=function(Y,G){return new i.Position(Y.lineNumber+G.lineNumber-1,G.lineNumber===1?Y.column+G.column-1:G.column)},Z=function(Y,G){const se=[];for(let n=G.startLineNumber;n<=G.endLineNumber;n++){const me=Y[n-1];n===G.startLineNumber&&n===G.endLineNumber?se.push(me.substring(G.startColumn-1,G.endColumn-1)):n===G.startLineNumber?se.push(me.substring(G.startColumn-1)):n===G.endLineNumber?se.push(me.substring(0,G.endColumn-1)):se.push(me)}return se};if(typeof k=="number"&&(c=k),o.Range.isEmpty(u)&&!p)continue;const P=h.getValueInRange(u);if(p=p.replace(/\r\n|\n|\r/g,h.eol),P===p)continue;if(Math.max(p.length,P.length)>y.o){L.push({range:u,text:p});continue}const M=P.split(/\r\n|\n|\r/),I=p.split(/\r\n|\n|\r/),B=e.linesDiffComputers.advanced.computeDiff(M,I,A),W=o.Range.lift(u).getStartPosition();for(const Y of B.changes)if(Y.innerChanges)for(const G of Y.innerChanges)L.push({range:o.Range.fromPositions(z(W,G.originalRange.getStartPosition()),z(W,G.originalRange.getEndPosition())),text:Z(I,G.modifiedRange).join(h.eol)});else throw new D.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof c=="number"&&L.push({eol:c,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),L}async computeLinks(r){const a=this.j(r);return a?(0,s.computeLinks)(a):null}async computeDefaultDocumentColors(r){const a=this.j(r);return a?(0,_.computeDefaultDocumentColors)(a):null}async textualSuggest(r,a,A,h){const L=new R.StopWatch(!0),c=new RegExp(A,h),u=new Set;e:for(const p of r){const k=this.j(p);if(k){for(const P of k.words(c))if(!(P===a||!isNaN(Number(P)))&&(u.add(P),u.size>y.p))break e}}return{words:Array.from(u),duration:L.elapsed()}}async computeWordRanges(r,a,A,h){const L=this.j(r);if(!L)return Object.create(null);const c=new RegExp(A,h),u=Object.create(null);for(let p=a.startLineNumber;p<a.endLineNumber;p++){const k=L.getLineWords(p,c);for(const P of k){if(!isNaN(Number(P.word)))continue;let M=u[P.word];M||(M=[],u[P.word]=M),M.push({startLineNumber:p,startColumn:P.startColumn,endLineNumber:p,endColumn:P.endColumn})}}return u}async navigateValueSet(r,a,A,h,L){const c=this.j(r);if(!c)return null;const u=new RegExp(h,L);a.startColumn===a.endColumn&&(a={startLineNumber:a.startLineNumber,startColumn:a.startColumn,endLineNumber:a.endLineNumber,endColumn:a.endColumn+1});const p=c.getValueInRange(a),k=c.getWordAtPosition({lineNumber:a.startLineNumber,column:a.startColumn},u);if(!k)return null;const P=c.getValueInRange(k);return l.BasicInplaceReplace.INSTANCE.navigateValueSet(a,p,k,P,A)}loadForeignModule(r,a,A){const h=(u,p)=>this.d.fhr(u,p),c={host:(0,N.createProxyObject)(A,h),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(c,a),Promise.resolve((0,N.getAllMethodNames)(this.h))):new Promise((u,p)=>{j([r],k=>{this.h=k.create(c,a),u((0,N.getAllMethodNames)(this.h))},p)})}fmr(r,a){if(!this.h||typeof this.h[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.h[r].apply(this.h,a))}catch(A){return Promise.reject(A)}}}t.EditorSimpleWorker=y,y.o=1e5,y.p=1e4;function b(w){return new y(w,null)}t.create=b,typeof importScripts=="function"&&(globalThis.monaco=(0,m.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=workerMain.js.map
