"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/base/common/types","vs/base/common/errors","vs/nls","vs/nls!vs/server/node/server.main","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/uuid","vs/base/common/objects","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","os","vs/platform/product/common/productService","vs/base/common/map","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","fs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/server/node/serverEnvironmentService","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/editor/common/core/range","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/mime","vs/base/common/processes","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/functional","vs/base/common/json","vs/base/common/hash","vs/base/common/glob","path","net","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/node/zip","vs/base/common/decorators","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/themables","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/position","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminal","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/amd","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/extpath","vs/base/node/ports","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/platform/credentials/node/credentialsMainService","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","yauzl","yazl","vs/server/node/server.main"],be=function(le){for(var e=[],y=0,L=le.length;y<L;y++)e[y]=pe[le[y]];return e};define(pe[140],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class y{static get(){const o=new Map,A=new Map,k=new Map,T=new Map;function v(d,g){d.has(g.detail)||d.set(g.detail,-g.timestamp)}function m(d,g){const p=d.get(g.detail);p&&(p>=0||d.set(g.detail,p+g.timestamp))}let R=[];typeof le.getStats=="function"&&(R=le.getStats().slice(0).sort((d,g)=>d.timestamp-g.timestamp));for(const d of R)switch(d.type){case 10:v(o,d);break;case 11:case 12:m(o,d);break;case 21:v(A,d);break;case 22:m(A,d);break;case 33:v(k,d);break;case 34:m(k,d);break;case 31:v(T,d);break;case 32:m(T,d);break}let E=0;k.forEach(d=>E+=d);function b(d){const g=[];return d.forEach((p,r)=>g.push([r,p])),g}return{amdLoad:b(o),amdInvoke:b(A),nodeRequire:b(k),nodeEval:b(T),nodeRequireTotal:E}}static toMarkdownTable(o,A){let k="";const T=[];return o.forEach((v,m)=>{T[m]=v.length}),A.forEach(v=>{v.forEach((m,R)=>{typeof m>"u"&&(m=v[R]="-");const E=m.toString().length;T[R]=Math.max(E,T[R])})}),o.forEach((v,m)=>{k+=`| ${v+" ".repeat(T[m]-v.toString().length)} `}),k+=`|
`,o.forEach((v,m)=>{k+=`| ${"-".repeat(T[m])} `}),k+=`|
`,A.forEach(v=>{v.forEach((m,R)=>{typeof m<"u"&&(k+=`| ${m+" ".repeat(T[R]-m.toString().length)} `)}),k+=`|
`}),k}}e.LoaderStats=y}),define(pe[92],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function y(k){return(T,v,m)=>{let R=null,E=null;if(typeof m.value=="function"?(R="value",E=m.value):typeof m.get=="function"&&(R="get",E=m.get),!E)throw new Error("not supported");m[R]=k(E,v)}}function L(k,T,v){let m=null,R=null;if(typeof v.value=="function"?(m="value",R=v.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(m="get",R=v.get),!R)throw new Error("not supported");const E=`$memoize$${T}`;v[m]=function(...b){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,b)}),this[E]}}e.memoize=L;function o(k,T,v){return y((m,R)=>{const E=`$debounce$${R}`,b=`$debounce$result$${R}`;return function(...d){this[b]||(this[b]=v?v():void 0),clearTimeout(this[E]),T&&(this[b]=T(this[b],...d),d=[this[b]]),this[E]=setTimeout(()=>{m.apply(this,d),this[b]=v?v():void 0},k)}})}e.debounce=o;function A(k,T,v){return y((m,R)=>{const E=`$throttle$timer$${R}`,b=`$throttle$result$${R}`,d=`$throttle$lastRun$${R}`,g=`$throttle$pending$${R}`;return function(...p){if(this[b]||(this[b]=v?v():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),T&&(this[b]=T(this[b],...p)),this[g])return;const r=this[d]+k;r<=Date.now()?(this[d]=Date.now(),m.apply(this,[this[b]]),this[b]=v?v():void 0):(this[g]=!0,this[E]=setTimeout(()=>{this[g]=!1,this[d]=Date.now(),m.apply(this,[this[b]]),this[b]=v?v():void 0},r-Date.now()))}})}e.throttle=A}),define(pe[9],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class y{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?I.isErrorNoTelemetry(n)?new I(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=y,e.errorHandler=new y;function L(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function o(t){if(!t||typeof t!="object")return!1;const n=t;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=o;function A(t){m(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=A;function k(t){m(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=k;function T(t){if(t instanceof Error){const{name:n,message:s}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:n,message:s,stack:i,noTelemetry:I.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=T;const v="Canceled";function m(t){return t instanceof R?!0:t instanceof Error&&t.name===v&&t.message===v}e.isCancellationError=m;class R extends Error{constructor(){super(v),this.name=this.message}}e.CancellationError=R;function E(){const t=new Error(v);return t.name=t.message,t}e.canceled=E;function b(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=b;function d(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=d;function g(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function p(t){const n=new Error(`${t} has been disposed`);return n.name="DISPOSED",n}e.disposed=p;function r(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=r;class f extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=f;class c extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=c;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=u;class I extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof I)return n;const s=new I;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=I;class O extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,O.prototype)}}e.BugIndicatingError=O}),define(pe[18],be([1,0,9]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(j,W=0){return j[j.length-(1+W)]}e.tail=L;function o(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=o;function A(j,W,x=(H,Q)=>H===Q){if(j===W)return!0;if(!j||!W||j.length!==W.length)return!1;for(let H=0,Q=j.length;H<Q;H++)if(!x(j[H],W[H]))return!1;return!0}e.equals=A;function k(j,W){const x=j.length-1;W<x&&(j[W]=j[x]),j.pop()}e.removeFastWithoutKeepingOrder=k;function T(j,W,x){return v(j.length,H=>x(j[H],W))}e.binarySearch=T;function v(j,W){let x=0,H=j-1;for(;x<=H;){const Q=(x+H)/2|0,G=W(Q);if(G<0)x=Q+1;else if(G>0)H=Q-1;else return Q}return-(x+1)}e.binarySearch2=v;function m(j,W){let x=0,H=j.length;if(H===0)return 0;for(;x<H;){const Q=Math.floor((x+H)/2);W(j[Q])?H=Q:x=Q+1}return x}e.findFirstInSorted=m;function R(j,W,x){if(j=j|0,j>=W.length)throw new TypeError("invalid index");const H=W[Math.floor(W.length*Math.random())],Q=[],G=[],Z=[];for(const ce of W){const Ee=x(ce,H);Ee<0?Q.push(ce):Ee>0?G.push(ce):Z.push(ce)}return j<Q.length?R(j,Q,x):j<Q.length+Z.length?Z[0]:R(j-(Q.length+Z.length),G,x)}e.quickSelect=R;function E(j,W){const x=[];let H;for(const Q of j.slice(0).sort(W))!H||W(H[0],Q)!==0?(H=[Q],x.push(H)):H.push(Q);return x}e.groupBy=E;function b(j,W,x){const H=[];function Q(ce,Ee,Ce){if(Ee===0&&Ce.length===0)return;const ke=H[H.length-1];ke&&ke.start+ke.deleteCount===ce?(ke.deleteCount+=Ee,ke.toInsert.push(...Ce)):H.push({start:ce,deleteCount:Ee,toInsert:Ce})}let G=0,Z=0;for(;;){if(G===j.length){Q(G,0,W.slice(Z));break}if(Z===W.length){Q(G,j.length-G,[]);break}const ce=j[G],Ee=W[Z],Ce=x(ce,Ee);Ce===0?(G+=1,Z+=1):Ce<0?(Q(G,1,[]),G+=1):Ce>0&&(Q(G,0,[Ee]),Z+=1)}return H}e.sortedDiff=b;function d(j,W,x){const H=b(j,W,x),Q=[],G=[];for(const Z of H)Q.push(...j.slice(Z.start,Z.start+Z.deleteCount)),G.push(...Z.toInsert);return{removed:Q,added:G}}e.delta=d;function g(j,W,x){if(x===0)return[];const H=j.slice(0,x).sort(W);return r(j,W,H,x,j.length),H}e.top=g;function p(j,W,x,H,Q){return x===0?Promise.resolve([]):new Promise((G,Z)=>{(async()=>{const ce=j.length,Ee=j.slice(0,x).sort(W);for(let Ce=x,ke=Math.min(x+H,ce);Ce<ce;Ce=ke,ke=Math.min(ke+H,ce)){if(Ce>x&&await new Promise(Fe=>setTimeout(Fe)),Q&&Q.isCancellationRequested)throw new y.CancellationError;r(j,W,Ee,Ce,ke)}return Ee})().then(G,Z)})}e.topAsync=p;function r(j,W,x,H,Q){for(const G=x.length;H<Q;H++){const Z=j[H];if(W(Z,x[G-1])<0){x.pop();const ce=m(x,Ee=>W(Z,Ee)<0);x.splice(ce,0,Z)}}}function f(j){return j.filter(W=>!!W)}e.coalesce=f;function c(j){let W=0;for(let x=0;x<j.length;x++)j[x]&&(j[W]=j[x],W+=1);j.length=W}e.coalesceInPlace=c;function u(j,W,x){j.splice(x,0,j.splice(W,1)[0])}e.move=u;function I(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=I;function O(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=O;function t(j,W=x=>x){const x=new Set;return j.filter(H=>{const Q=W(H);return x.has(Q)?!1:(x.add(Q),!0)})}e.distinct=t;function n(j){const W=new Set;return x=>{const H=j(x);return W.has(H)?!1:(W.add(H),!0)}}e.uniqueFilter=n;function s(j,W){const x=i(j,W);if(x!==-1)return j[x]}e.findLast=s;function i(j,W){for(let x=j.length-1;x>=0;x--){const H=j[x];if(W(H))return x}return-1}e.lastIndex=i;function a(j,W){return j.length>0?j[0]:W}e.firstOrDefault=a;function l(j,W){return j.length>0?j[j.length-1]:W}e.lastOrDefault=l;function h(j,W,x=(H,Q)=>H===Q){let H=0;for(let Q=0,G=Math.min(j.length,W.length);Q<G&&x(j[Q],W[Q]);Q++)H++;return H}e.commonPrefixLength=h;function C(j){return[].concat(...j)}e.flatten=C;function D(j,W){let x=typeof W=="number"?j:0;typeof W=="number"?x=j:(x=0,W=j);const H=[];if(x<=W)for(let Q=x;Q<W;Q++)H.push(Q);else for(let Q=x;Q>W;Q--)H.push(Q);return H}e.range=D;function w(j,W,x){return j.reduce((H,Q)=>(H[W(Q)]=x?x(Q):Q,H),Object.create(null))}e.index=w;function S(j,W){return j.push(W),()=>N(j,W)}e.insert=S;function N(j,W){const x=j.indexOf(W);if(x>-1)return j.splice(x,1),W}e.remove=N;function $(j,W,x){const H=j.slice(0,W),Q=j.slice(W);return H.concat(x,Q)}e.arrayInsert=$;function ee(j,W){let x;if(typeof W=="number"){let H=W;x=()=>{const Q=Math.sin(H++)*179426549;return Q-Math.floor(Q)}}else x=Math.random;for(let H=j.length-1;H>0;H-=1){const Q=Math.floor(x()*(H+1)),G=j[H];j[H]=j[Q],j[Q]=G}}e.shuffle=ee;function he(j,W){const x=j.indexOf(W);x>-1&&(j.splice(x,1),j.unshift(W))}e.pushToStart=he;function oe(j,W){const x=j.indexOf(W);x>-1&&(j.splice(x,1),j.push(W))}e.pushToEnd=oe;function ue(j,W){for(const x of W)j.push(x)}e.pushMany=ue;function me(j,W){return Array.isArray(j)?j.map(W):W(j)}e.mapArrayOrNot=me;function _(j){return Array.isArray(j)?j:[j]}e.asArray=_;function re(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=re;function q(j,W){for(const x of j){const H=W(x);if(H!==void 0)return H}}e.mapFind=q;function J(j,W,x){const H=ne(j,W),Q=j.length,G=x.length;j.length=Q+G;for(let Z=Q-1;Z>=H;Z--)j[Z+G]=j[Z];for(let Z=0;Z<G;Z++)j[Z+H]=x[Z]}e.insertInto=J;function U(j,W,x,H){const Q=ne(j,W),G=j.splice(Q,x);return J(j,Q,H),G}e.splice=U;function ne(j,W){return W<0?Math.max(W+j.length,0):Math.min(W,j.length)}var V;(function(j){function W(Q){return Q<0}j.isLessThan=W;function x(Q){return Q>0}j.isGreaterThan=x;function H(Q){return Q===0}j.isNeitherLessOrGreaterThan=H,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function se(j,W){return(x,H)=>W(j(x),j(H))}e.compareBy=se;function Y(...j){return(W,x)=>{for(const H of j){const Q=H(W,x);if(!V.isNeitherLessOrGreaterThan(Q))return Q}return V.neitherLessOrGreaterThan}}e.tieBreakComparators=Y;const ie=(j,W)=>j-W;e.numberComparator=ie;function z(j,W){if(j.length===0)return;let x=j[0];for(let H=1;H<j.length;H++){const Q=j[H];W(Q,x)>0&&(x=Q)}return x}e.findMaxBy=z;function P(j,W){if(j.length===0)return;let x=j[0];for(let H=1;H<j.length;H++){const Q=j[H];W(Q,x)>=0&&(x=Q)}return x}e.findLastMaxBy=P;function M(j,W){return z(j,(x,H)=>-W(x,H))}e.findMinBy=M;class K{constructor(W){this.f=W,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(W){let x=this.c;for(;x<this.f.length&&W(this.f[x]);)x++;const H=x===this.c?null:this.f.slice(this.c,x);return this.c=x,H}takeFromEndWhile(W){let x=this.d;for(;x>=0&&W(this.f[x]);)x--;const H=x===this.d?null:this.f.slice(x+1,this.d+1);return this.d=x,H}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const W=this.f[this.c];return this.c++,W}removeLast(){const W=this.f[this.d];return this.d--,W}takeCount(W){const x=this.f.slice(this.c,this.c+W);return this.c+=W,x}}e.ArrayQueue=K;class te{constructor(W){this.iterate=W}forEach(W){this.iterate(x=>(W(x),!0))}toArray(){const W=[];return this.iterate(x=>(W.push(x),!0)),W}filter(W){return new te(x=>this.iterate(H=>W(H)?x(H):!0))}map(W){return new te(x=>this.iterate(H=>x(W(H))))}some(W){let x=!1;return this.iterate(H=>(x=W(H),!x)),x}findFirst(W){let x;return this.iterate(H=>W(H)?(x=H,!1):!0),x}findLast(W){let x;return this.iterate(H=>(W(H)&&(x=H),!0)),x}findLastMaxBy(W){let x,H=!0;return this.iterate(Q=>((H||V.isGreaterThan(W(Q,x)))&&(H=!1,x=Q),!0)),x}}e.CallbackIterable=te,te.empty=new te(j=>{})}),define(pe[93],be([1,0,9]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(v,m){if(!v)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=L;function o(v,m="Unreachable"){throw new Error(m)}e.assertNever=o;function A(v){if(!v)throw new y.BugIndicatingError("Assertion Failed")}e.assert=A;function k(v){if(!v()){debugger;v(),(0,y.onUnexpectedError)(new y.BugIndicatingError("Assertion Failed"))}}e.assertFn=k;function T(v,m){let R=0;for(;R<v.length-1;){const E=v[R],b=v[R+1];if(!m(E,b))return!1;R++}return!0}e.checkAdjacentItems=T}),define(pe[71],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function y(L){const o=this;let A=!1,k;return function(){return A||(A=!0,k=L.apply(o,arguments)),k}}e.once=y}),define(pe[46],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(L){function o(I){return I&&typeof I=="object"&&typeof I[Symbol.iterator]=="function"}L.is=o;const A=Object.freeze([]);function k(){return A}L.empty=k;function*T(I){yield I}L.single=T;function v(I){return o(I)?I:T(I)}L.wrap=v;function m(I){return I||A}L.from=m;function R(I){return!I||I[Symbol.iterator]().next().done===!0}L.isEmpty=R;function E(I){return I[Symbol.iterator]().next().value}L.first=E;function b(I,O){for(const t of I)if(O(t))return!0;return!1}L.some=b;function d(I,O){for(const t of I)if(O(t))return t}L.find=d;function*g(I,O){for(const t of I)O(t)&&(yield t)}L.filter=g;function*p(I,O){let t=0;for(const n of I)yield O(n,t++)}L.map=p;function*r(...I){for(const O of I)for(const t of O)yield t}L.concat=r;function f(I,O,t){let n=t;for(const s of I)n=O(n,s);return n}L.reduce=f;function*c(I,O,t=I.length){for(O<0&&(O+=I.length),t<0?t+=I.length:t>I.length&&(t=I.length);O<t;O++)yield I[O]}L.slice=c;function u(I,O=Number.POSITIVE_INFINITY){const t=[];if(O===0)return[t,I];const n=I[Symbol.iterator]();for(let s=0;s<O;s++){const i=n.next();if(i.done)return[t,L.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return n}}]}L.consume=u})(y||(e.Iterable=y={}))}),define(pe[72],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var o;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(o||(e.ParseErrorCode=o={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function k(t,n=!1){let s=0;const i=t.length;let a="",l=0,h=16,C=0;function D(oe){let ue=0,me=0;for(;ue<oe;){const _=t.charCodeAt(s);if(_>=48&&_<=57)me=me*16+_-48;else if(_>=65&&_<=70)me=me*16+_-65+10;else if(_>=97&&_<=102)me=me*16+_-97+10;else break;s++,ue++}return ue<oe&&(me=-1),me}function w(oe){s=oe,a="",l=0,h=16,C=0}function S(){const oe=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&m(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&m(t.charCodeAt(s)))for(s++;s<t.length&&m(t.charCodeAt(s));)s++;else return C=3,t.substring(oe,s);let ue=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&m(t.charCodeAt(s))){for(s++;s<t.length&&m(t.charCodeAt(s));)s++;ue=s}else C=3;return t.substring(oe,ue)}function N(){let oe="",ue=s;for(;;){if(s>=i){oe+=t.substring(ue,s),C=2;break}const me=t.charCodeAt(s);if(me===34){oe+=t.substring(ue,s),s++;break}if(me===92){if(oe+=t.substring(ue,s),s++,s>=i){C=2;break}switch(t.charCodeAt(s++)){case 34:oe+='"';break;case 92:oe+="\\";break;case 47:oe+="/";break;case 98:oe+="\b";break;case 102:oe+="\f";break;case 110:oe+=`
`;break;case 114:oe+="\r";break;case 116:oe+="	";break;case 117:{const re=D(4);re>=0?oe+=String.fromCharCode(re):C=4;break}default:C=5}ue=s;continue}if(me>=0&&me<=31)if(v(me)){oe+=t.substring(ue,s),C=2;break}else C=6;s++}return oe}function $(){if(a="",C=0,l=s,s>=i)return l=i,h=17;let oe=t.charCodeAt(s);if(T(oe)){do s++,a+=String.fromCharCode(oe),oe=t.charCodeAt(s);while(T(oe));return h=15}if(v(oe))return s++,a+=String.fromCharCode(oe),oe===13&&t.charCodeAt(s)===10&&(s++,a+=`
`),h=14;switch(oe){case 123:return s++,h=1;case 125:return s++,h=2;case 91:return s++,h=3;case 93:return s++,h=4;case 58:return s++,h=6;case 44:return s++,h=5;case 34:return s++,a=N(),h=10;case 47:{const ue=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!v(t.charCodeAt(s));)s++;return a=t.substring(ue,s),h=12}if(t.charCodeAt(s+1)===42){s+=2;const me=i-1;let _=!1;for(;s<me;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,_=!0;break}s++}return _||(s++,C=1),a=t.substring(ue,s),h=13}return a+=String.fromCharCode(oe),s++,h=16}case 45:if(a+=String.fromCharCode(oe),s++,s===i||!m(t.charCodeAt(s)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=S(),h=11;default:for(;s<i&&ee(oe);)s++,oe=t.charCodeAt(s);if(l!==s){switch(a=t.substring(l,s),a){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return a+=String.fromCharCode(oe),s++,h=16}}function ee(oe){if(T(oe)||v(oe))return!1;switch(oe){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function he(){let oe;do oe=$();while(oe>=12&&oe<=15);return oe}return{setPosition:w,getPosition:()=>s,scan:n?he:$,getToken:()=>h,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>C}}e.createScanner=k;function T(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function v(t){return t===10||t===13||t===8232||t===8233}function m(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function E(t,n){const s=[],i=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function C(D,w,S,N){l.value=D,l.offset=w,l.length=S,l.type=N,l.colonOffset=void 0,a=l}try{u(t,{onObjectBegin:(D,w)=>{if(n<=D)throw i;a=void 0,h=n>D,s.push("")},onObjectProperty:(D,w,S)=>{if(n<w||(C(D,w,S,"property"),s[s.length-1]=D,n<=w+S))throw i},onObjectEnd:(D,w)=>{if(n<=D)throw i;a=void 0,s.pop()},onArrayBegin:(D,w)=>{if(n<=D)throw i;a=void 0,s.push(0)},onArrayEnd:(D,w)=>{if(n<=D)throw i;a=void 0,s.pop()},onLiteralValue:(D,w,S)=>{if(n<w||(C(D,w,S,O(D)),n<=w+S))throw i},onSeparator:(D,w,S)=>{if(n<=w)throw i;if(D===":"&&a&&a.type==="property")a.colonOffset=w,h=!1,a=void 0;else if(D===","){const N=s[s.length-1];typeof N=="number"?s[s.length-1]=N+1:(h=!0,s[s.length-1]=""),a=void 0}}})}catch(D){if(D!==i)throw D}return{path:s,previousNode:a,isAtPropertyKey:h,matches:D=>{let w=0;for(let S=0;w<D.length&&S<s.length;S++)if(D[w]===s[S]||D[w]==="*")w++;else if(D[w]!=="**")return!1;return w===D.length}}}e.getLocation=E;function b(t,n=[],s=A.DEFAULT){let i=null,a=[];const l=[];function h(D){Array.isArray(a)?a.push(D):i!==null&&(a[i]=D)}return u(t,{onObjectBegin:()=>{const D={};h(D),l.push(a),a=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const D=[];h(D),l.push(a),a=D,i=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:h,onError:(D,w,S)=>{n.push({error:D,offset:w,length:S})}},s),a[0]}e.parse=b;function d(t,n=[],s=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function l(D){return i.children.push(D),D}u(t,{onObjectBegin:D=>{i=l({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,w,S)=>{i=l({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:w,length:S,parent:i})},onObjectEnd:(D,w)=>{i.length=D+w-i.offset,i=i.parent,a(D+w)},onArrayBegin:(D,w)=>{i=l({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,w)=>{i.length=D+w-i.offset,i=i.parent,a(D+w)},onLiteralValue:(D,w,S)=>{l({type:O(D),offset:w,length:S,parent:i,value:D}),a(w+S)},onSeparator:(D,w,S)=>{i.type==="property"&&(D===":"?i.colonOffset=w:D===","&&a(w))},onError:(D,w,S)=>{n.push({error:D,offset:w,length:S})}},s);const C=i.children[0];return C&&delete C.parent,C}e.parseTree=d;function g(t,n){if(!t)return;let s=t;for(const i of n)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===i){s=l.children[1],a=!0;break}if(!a)return}else{const a=i;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}e.findNodeAtLocation=g;function p(t){if(!t.parent||!t.parent.children)return[];const n=p(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=p;function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const n=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(n[s.children[0].value]=r(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=r;function f(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=f;function c(t,n,s=!1){if(f(t,n,s)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=n;a++){const l=c(i[a],n,s);if(l)return l}return t}}e.findNodeAtOffset=c;function u(t,n,s=A.DEFAULT){const i=k(t,!1);function a(se){return se?()=>se(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(se){return se?Y=>se(Y,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=a(n.onObjectBegin),C=l(n.onObjectProperty),D=a(n.onObjectEnd),w=a(n.onArrayBegin),S=a(n.onArrayEnd),N=l(n.onLiteralValue),$=l(n.onSeparator),ee=a(n.onComment),he=l(n.onError),oe=s&&s.disallowComments,ue=s&&s.allowTrailingComma;function me(){for(;;){const se=i.scan();switch(i.getTokenError()){case 4:_(14);break;case 5:_(15);break;case 3:_(13);break;case 1:oe||_(11);break;case 2:_(12);break;case 6:_(16);break}switch(se){case 12:case 13:oe?_(10):ee();break;case 16:_(1);break;case 15:case 14:break;default:return se}}}function _(se,Y=[],ie=[]){if(he(se),Y.length+ie.length>0){let z=i.getToken();for(;z!==17;){if(Y.indexOf(z)!==-1){me();break}else if(ie.indexOf(z)!==-1)break;z=me()}}}function re(se){const Y=i.getTokenValue();return se?N(Y):C(Y),me(),!0}function q(){switch(i.getToken()){case 11:{let se=0;try{se=JSON.parse(i.getTokenValue()),typeof se!="number"&&(_(2),se=0)}catch{_(2)}N(se);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return me(),!0}function J(){return i.getToken()!==10?(_(3,[],[2,5]),!1):(re(!1),i.getToken()===6?($(":"),me(),V()||_(4,[],[2,5])):_(5,[],[2,5]),!0)}function U(){h(),me();let se=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(se||_(4,[],[]),$(","),me(),i.getToken()===2&&ue)break}else se&&_(6,[],[]);J()||_(4,[],[2,5]),se=!0}return D(),i.getToken()!==2?_(7,[2],[]):me(),!0}function ne(){w(),me();let se=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(se||_(4,[],[]),$(","),me(),i.getToken()===4&&ue)break}else se&&_(6,[],[]);V()||_(4,[],[4,5]),se=!0}return S(),i.getToken()!==4?_(8,[4],[]):me(),!0}function V(){switch(i.getToken()){case 3:return ne();case 1:return U();case 10:return re(!0);default:return q()}}return me(),i.getToken()===17?s.allowEmptyContent?!0:(_(4,[],[]),!1):V()?(i.getToken()!==17&&_(9,[],[]),!0):(_(4,[],[]),!1)}e.visit=u;function I(t,n){const s=k(t),i=[];let a,l=0,h;do switch(h=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:l!==h&&i.push(t.substring(l,h)),n!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,n)),l=s.getPosition();break}while(a!==17);return i.join("")}e.stripComments=I;function O(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=O}),define(pe[94],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class y{constructor(o){this.d=o,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(o){this.c=o}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=y}),define(pe[2],be([1,0,71,46]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const o=!1;let A=null;function k(l){A=l}if(e.setDisposableTracker=k,o){const l="__is_disposable_tracked__";k(new class{trackDisposable(h){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{h[l]||console.log(C)},3e3)}setParent(h,C){if(h&&h!==c.None)try{h[l]=!0}catch{}}markAsDisposed(h){if(h&&h!==c.None)try{h[l]=!0}catch{}}markAsSingleton(h){}})}function T(l){return A?.trackDisposable(l),l}function v(l){A?.markAsDisposed(l)}function m(l,h){A?.setParent(l,h)}function R(l,h){if(A)for(const C of l)A.setParent(C,h)}function E(l){return A?.markAsSingleton(l),l}e.markAsSingleton=E;function b(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=b;function d(l){if(L.Iterable.is(l)){const h=[];for(const C of l)if(C)try{C.dispose()}catch(D){h.push(D)}if(h.length===1)throw h[0];if(h.length>1)throw new AggregateError(h,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=d;function g(l){for(const h of l)b(h)&&h.dispose();return[]}e.disposeIfDisposable=g;function p(...l){const h=r(()=>d(l));return R(l,h),h}e.combinedDisposable=p;function r(l){const h=T({dispose:(0,y.once)(()=>{v(h),l()})});return h}e.toDisposable=r;class f{constructor(){this.f=new Set,this.g=!1,T(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(h){if(!h)return h;if(h===this)throw new Error("Cannot register a disposable on itself!");return m(h,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(h),h}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this.q=new f,T(this),m(this.q,this)}dispose(){v(this),this.q.dispose()}B(h){if(h===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(h)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class u{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(h){this.b||h===this.a||(this.a?.dispose(),h&&m(h,this),this.a=h)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const h=this.a;return this.a=void 0,h&&m(h,null),h}}e.MutableDisposable=u;class I{constructor(h){this.b=h,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=I;class O{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(h){let C=h;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,v(this))},this}}e.SafeDisposable=O;class t{constructor(){this.a=new Map}acquire(h,...C){let D=this.a.get(h);D||(D={counter:0,object:this.b(h,...C)},this.a.set(h,D));const{object:w}=D,S=(0,y.once)(()=>{--D.counter===0&&(this.c(h,D.object),this.a.delete(h))});return D.counter++,{object:w,dispose:S}}}e.ReferenceCollection=t;class n{constructor(h){this.a=h}async acquire(h,...C){const D=this.a.acquire(h,...C);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(w){throw D.dispose(),w}}}e.AsyncReferenceCollection=n;class s{constructor(h){this.object=h}dispose(){}}e.ImmortalReference=s;function i(l){const h=new f;try{l(h)}finally{h.dispose()}}e.disposeOnReturn=i;class a{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(h){return this.a.has(h)}get(h){return this.a.get(h)}set(h,C,D=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this.a.get(h)?.dispose(),this.a.set(h,C)}deleteAndDispose(h){this.a.get(h)?.dispose(),this.a.delete(h)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=a}),define(pe[95],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class y{constructor(A){this.element=A,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class L{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let A=this.a;for(;A!==y.Undefined;){const k=A.next;A.prev=y.Undefined,A.next=y.Undefined,A=k}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,k){const T=new y(A);if(this.a===y.Undefined)this.a=T,this.b=T;else if(k){const m=this.b;this.b=T,T.prev=m,m.next=T}else{const m=this.a;this.a=T,T.next=m,m.prev=T}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(T))}}shift(){if(this.a!==y.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==y.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==y.Undefined&&A.next!==y.Undefined){const k=A.prev;k.next=A.next,A.next.prev=k}else A.prev===y.Undefined&&A.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):A.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):A.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==y.Undefined;)yield A.element,A=A.next}}e.LinkedList=L}),define(pe[28],be([1,0]),function(le,e){"use strict";var y,L,o;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(p,r,f){let c=p.get(r);return c===void 0&&(c=f,p.set(r,c)),c}e.getOrSet=A;function k(p){const r=[];return p.forEach((f,c)=>{r.push(`${c} => ${f}`)}),`Map(${p.size}) {${r.join(", ")}}`}e.mapToString=k;function T(p){const r=[];return p.forEach(f=>{r.push(f)}),`Set(${p.size}) {${r.join(", ")}}`}e.setToString=T;class v{constructor(r,f){this.uri=r,this.value=f}}class m{constructor(r,f){this[y]="ResourceMap",r instanceof m?(this.b=new Map(r.b),this.c=f??m.a):(this.b=new Map,this.c=r??m.a)}set(r,f){return this.b.set(this.c(r),new v(r,f)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,f){typeof f<"u"&&(r=r.bind(f));for(const[c,u]of this.b)r(u.value,u.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}e.ResourceMap=m,m.a=p=>p.toString();class R{constructor(r,f){this[L]="ResourceSet",!r||typeof r=="function"?this.a=new m(r):(this.a=new m(f),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,f){this.a.forEach((c,u)=>r.call(f,u,u,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var E;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(E||(e.Touch=E={}));class b{constructor(){this[o]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,f=0){const c=this.a.get(r);if(c)return f!==0&&this.j(c,f),c.value}set(r,f,c=0){let u=this.a.get(r);if(u)u.value=f,c!==0&&this.j(u,c);else{switch(u={key:r,value:f,next:void 0,previous:void 0},c){case 0:this.h(u);break;case 1:this.g(u);break;case 2:this.h(u);break;default:this.h(u);break}this.a.set(r,u),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const f=this.a.get(r);if(f)return this.a.delete(r),this.i(f),this.d--,f.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,f){const c=this.e;let u=this.b;for(;u;){if(f?r.bind(f)(u.value,u.key,this):r(u.value,u.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,f=this.e;let c=this.b;const u={[Symbol.iterator](){return u},next(){if(r.e!==f)throw new Error("LinkedMap got modified during iteration.");if(c){const I={value:c.key,done:!1};return c=c.next,I}else return{value:void 0,done:!0}}};return u}values(){const r=this,f=this.e;let c=this.b;const u={[Symbol.iterator](){return u},next(){if(r.e!==f)throw new Error("LinkedMap got modified during iteration.");if(c){const I={value:c.value,done:!1};return c=c.next,I}else return{value:void 0,done:!0}}};return u}entries(){const r=this,f=this.e;let c=this.b;const u={[Symbol.iterator](){return u},next(){if(r.e!==f)throw new Error("LinkedMap got modified during iteration.");if(c){const I={value:[c.key,c.value],done:!1};return c=c.next,I}else return{value:void 0,done:!0}}};return u}[(o=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let f=this.b,c=this.size;for(;f&&c>r;)this.a.delete(f.key),f=f.next,c--;this.b=f,this.d=c,f&&(f.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const f=r.next,c=r.previous;if(!f||!c)throw new Error("Invalid list");f.previous=c,c.next=f}r.next=void 0,r.previous=void 0,this.e++}j(r,f){if(!this.b||!this.c)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(r===this.b)return;const c=r.next,u=r.previous;r===this.c?(u.next=void 0,this.c=u):(c.previous=u,u.next=c),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(f===2){if(r===this.c)return;const c=r.next,u=r.previous;r===this.b?(c.previous=void 0,this.b=c):(c.previous=u,u.next=c),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((f,c)=>{r.push([c,f])}),r}fromJSON(r){this.clear();for(const[f,c]of r)this.set(f,c)}}e.LinkedMap=b;class d extends b{constructor(r,f=1){super(),this.k=r,this.l=Math.min(Math.max(0,f),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,f=2){return super.get(r,f)}peek(r){return super.get(r,0)}set(r,f){return super.set(r,f,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=d;class g{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let f=this.a.get(r)||0;return f===0?!1:(f--,f===0?this.a.delete(r):this.a.set(r,f),!0)}has(r){return this.a.has(r)}}e.CounterSet=g}),function(le,e){typeof define=="function"&&define.amd?define(pe[141],be([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(j,W){for(var x=0;x<W.length;x++){var H=W[x];H.enumerable=H.enumerable||!1,H.configurable=!0,"value"in H&&(H.writable=!0),Object.defineProperty(j,H.key,H)}}function y(j,W,x){return W&&e(j.prototype,W),x&&e(j,x),Object.defineProperty(j,"prototype",{writable:!1}),j}function L(j,W){if(j){if(typeof j=="string")return o(j,W);var x=Object.prototype.toString.call(j).slice(8,-1);if(x==="Object"&&j.constructor&&(x=j.constructor.name),x==="Map"||x==="Set")return Array.from(j);if(x==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(x))return o(j,W)}}function o(j,W){(W==null||W>j.length)&&(W=j.length);for(var x=0,H=new Array(W);x<W;x++)H[x]=j[x];return H}function A(j,W){var x=typeof Symbol<"u"&&j[Symbol.iterator]||j["@@iterator"];if(x)return(x=x.call(j)).next.bind(x);if(Array.isArray(j)||(x=L(j))||W&&j&&typeof j.length=="number"){x&&(j=x);var H=0;return function(){return H>=j.length?{done:!0}:{done:!1,value:j[H++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=k();function T(j){le.defaults=j}var v=/[&<>"']/,m=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(W){return b[W]};function g(j,W){if(W){if(v.test(j))return j.replace(m,d)}else if(R.test(j))return j.replace(E,d);return j}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(j){return j.replace(p,function(W,x){return x=x.toLowerCase(),x==="colon"?":":x.charAt(0)==="#"?x.charAt(1)==="x"?String.fromCharCode(parseInt(x.substring(2),16)):String.fromCharCode(+x.substring(1)):""})}var f=/(^|[^\[])\^/g;function c(j,W){j=typeof j=="string"?j:j.source,W=W||"";var x={replace:function(Q,G){return G=G.source||G,G=G.replace(f,"$1"),j=j.replace(Q,G),x},getRegex:function(){return new RegExp(j,W)}};return x}var u=/[^\w:]/g,I=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function O(j,W,x){if(j){var H;try{H=decodeURIComponent(r(x)).replace(u,"").toLowerCase()}catch{return null}if(H.indexOf("javascript:")===0||H.indexOf("vbscript:")===0||H.indexOf("data:")===0)return null}W&&!I.test(x)&&(x=a(W,x));try{x=encodeURI(x).replace(/%25/g,"%")}catch{return null}return x}var t={},n=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(j,W){t[" "+j]||(n.test(j)?t[" "+j]=j+"/":t[" "+j]=D(j,"/",!0)),j=t[" "+j];var x=j.indexOf(":")===-1;return W.substring(0,2)==="//"?x?W:j.replace(s,"$1")+W:W.charAt(0)==="/"?x?W:j.replace(i,"$1")+W:j+W}var l={exec:function(){}};function h(j){for(var W=1,x,H;W<arguments.length;W++){x=arguments[W];for(H in x)Object.prototype.hasOwnProperty.call(x,H)&&(j[H]=x[H])}return j}function C(j,W){var x=j.replace(/\|/g,function(G,Z,ce){for(var Ee=!1,Ce=Z;--Ce>=0&&ce[Ce]==="\\";)Ee=!Ee;return Ee?"|":" |"}),H=x.split(/ \|/),Q=0;if(H[0].trim()||H.shift(),H.length>0&&!H[H.length-1].trim()&&H.pop(),H.length>W)H.splice(W);else for(;H.length<W;)H.push("");for(;Q<H.length;Q++)H[Q]=H[Q].trim().replace(/\\\|/g,"|");return H}function D(j,W,x){var H=j.length;if(H===0)return"";for(var Q=0;Q<H;){var G=j.charAt(H-Q-1);if(G===W&&!x)Q++;else if(G!==W&&x)Q++;else break}return j.slice(0,H-Q)}function w(j,W){if(j.indexOf(W[1])===-1)return-1;for(var x=j.length,H=0,Q=0;Q<x;Q++)if(j[Q]==="\\")Q++;else if(j[Q]===W[0])H++;else if(j[Q]===W[1]&&(H--,H<0))return Q;return-1}function S(j){j&&j.sanitize&&!j.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(j,W){if(W<1)return"";for(var x="";W>1;)W&1&&(x+=j),W>>=1,j+=j;return x+j}function $(j,W,x,H){var Q=W.href,G=W.title?g(W.title):null,Z=j[1].replace(/\\([\[\]])/g,"$1");if(j[0].charAt(0)!=="!"){H.state.inLink=!0;var ce={type:"link",raw:x,href:Q,title:G,text:Z,tokens:H.inlineTokens(Z)};return H.state.inLink=!1,ce}return{type:"image",raw:x,href:Q,title:G,text:g(Z)}}function ee(j,W){var x=j.match(/^(\s+)(?:```)/);if(x===null)return W;var H=x[1];return W.split(`
`).map(function(Q){var G=Q.match(/^\s+/);if(G===null)return Q;var Z=G[0];return Z.length>=H.length?Q.slice(H.length):Q}).join(`
`)}var he=function(){function j(x){this.options=x||le.defaults}var W=j.prototype;return W.space=function(H){var Q=this.rules.block.newline.exec(H);if(Q&&Q[0].length>0)return{type:"space",raw:Q[0]}},W.code=function(H){var Q=this.rules.block.code.exec(H);if(Q){var G=Q[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Q[0],codeBlockStyle:"indented",text:this.options.pedantic?G:D(G,`
`)}}},W.fences=function(H){var Q=this.rules.block.fences.exec(H);if(Q){var G=Q[0],Z=ee(G,Q[3]||"");return{type:"code",raw:G,lang:Q[2]?Q[2].trim():Q[2],text:Z}}},W.heading=function(H){var Q=this.rules.block.heading.exec(H);if(Q){var G=Q[2].trim();if(/#$/.test(G)){var Z=D(G,"#");(this.options.pedantic||!Z||/ $/.test(Z))&&(G=Z.trim())}return{type:"heading",raw:Q[0],depth:Q[1].length,text:G,tokens:this.lexer.inline(G)}}},W.hr=function(H){var Q=this.rules.block.hr.exec(H);if(Q)return{type:"hr",raw:Q[0]}},W.blockquote=function(H){var Q=this.rules.block.blockquote.exec(H);if(Q){var G=Q[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Q[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},W.list=function(H){var Q=this.rules.block.list.exec(H);if(Q){var G,Z,ce,Ee,Ce,ke,Fe,je,ge,Se,ye,Me,ze=Q[1].trim(),_e=ze.length>1,qe={type:"list",raw:"",ordered:_e,start:_e?+ze.slice(0,-1):"",loose:!1,items:[]};ze=_e?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=_e?ze:"[*+-]");for(var Ve=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");H&&(Me=!1,!(!(Q=Ve.exec(H))||this.rules.block.hr.test(H)));){if(G=Q[0],H=H.substring(G.length),je=Q[2].split(`
`,1)[0],ge=H.split(`
`,1)[0],this.options.pedantic?(Ee=2,ye=je.trimLeft()):(Ee=Q[2].search(/[^ ]/),Ee=Ee>4?1:Ee,ye=je.slice(Ee),Ee+=Q[1].length),ke=!1,!je&&/^ *$/.test(ge)&&(G+=ge+`
`,H=H.substring(ge.length+1),Me=!0),!Me)for(var et=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ge=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}(?:```|~~~)"),Xe=new RegExp("^ {0,"+Math.min(3,Ee-1)+"}#");H&&(Se=H.split(`
`,1)[0],je=Se,this.options.pedantic&&(je=je.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ge.test(je)||Xe.test(je)||et.test(je)||rt.test(H)));){if(je.search(/[^ ]/)>=Ee||!je.trim())ye+=`
`+je.slice(Ee);else if(!ke)ye+=`
`+je;else break;!ke&&!je.trim()&&(ke=!0),G+=Se+`
`,H=H.substring(Se.length+1)}qe.loose||(Fe?qe.loose=!0:/\n *\n *$/.test(G)&&(Fe=!0)),this.options.gfm&&(Z=/^\[[ xX]\] /.exec(ye),Z&&(ce=Z[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:G,task:!!Z,checked:ce,loose:!1,text:ye}),qe.raw+=G}qe.items[qe.items.length-1].raw=G.trimRight(),qe.items[qe.items.length-1].text=ye.trimRight(),qe.raw=qe.raw.trimRight();var fe=qe.items.length;for(Ce=0;Ce<fe;Ce++){this.lexer.state.top=!1,qe.items[Ce].tokens=this.lexer.blockTokens(qe.items[Ce].text,[]);var Ie=qe.items[Ce].tokens.filter(function(Re){return Re.type==="space"}),Te=Ie.every(function(Re){for(var Oe=Re.raw.split(""),$e=0,We=A(Oe),Qe;!(Qe=We()).done;){var Ye=Qe.value;if(Ye===`
`&&($e+=1),$e>1)return!0}return!1});!qe.loose&&Ie.length&&Te&&(qe.loose=!0,qe.items[Ce].loose=!0)}return qe}},W.html=function(H){var Q=this.rules.block.html.exec(H);if(Q){var G={type:"html",raw:Q[0],pre:!this.options.sanitizer&&(Q[1]==="pre"||Q[1]==="script"||Q[1]==="style"),text:Q[0]};if(this.options.sanitize){var Z=this.options.sanitizer?this.options.sanitizer(Q[0]):g(Q[0]);G.type="paragraph",G.text=Z,G.tokens=this.lexer.inline(Z)}return G}},W.def=function(H){var Q=this.rules.block.def.exec(H);if(Q){Q[3]&&(Q[3]=Q[3].substring(1,Q[3].length-1));var G=Q[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:Q[0],href:Q[2],title:Q[3]}}},W.table=function(H){var Q=this.rules.block.table.exec(H);if(Q){var G={type:"table",header:C(Q[1]).map(function(Fe){return{text:Fe}}),align:Q[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Q[3]&&Q[3].trim()?Q[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=Q[0];var Z=G.align.length,ce,Ee,Ce,ke;for(ce=0;ce<Z;ce++)/^ *-+: *$/.test(G.align[ce])?G.align[ce]="right":/^ *:-+: *$/.test(G.align[ce])?G.align[ce]="center":/^ *:-+ *$/.test(G.align[ce])?G.align[ce]="left":G.align[ce]=null;for(Z=G.rows.length,ce=0;ce<Z;ce++)G.rows[ce]=C(G.rows[ce],G.header.length).map(function(Fe){return{text:Fe}});for(Z=G.header.length,Ee=0;Ee<Z;Ee++)G.header[Ee].tokens=this.lexer.inline(G.header[Ee].text);for(Z=G.rows.length,Ee=0;Ee<Z;Ee++)for(ke=G.rows[Ee],Ce=0;Ce<ke.length;Ce++)ke[Ce].tokens=this.lexer.inline(ke[Ce].text);return G}}},W.lheading=function(H){var Q=this.rules.block.lheading.exec(H);if(Q)return{type:"heading",raw:Q[0],depth:Q[2].charAt(0)==="="?1:2,text:Q[1],tokens:this.lexer.inline(Q[1])}},W.paragraph=function(H){var Q=this.rules.block.paragraph.exec(H);if(Q){var G=Q[1].charAt(Q[1].length-1)===`
`?Q[1].slice(0,-1):Q[1];return{type:"paragraph",raw:Q[0],text:G,tokens:this.lexer.inline(G)}}},W.text=function(H){var Q=this.rules.block.text.exec(H);if(Q)return{type:"text",raw:Q[0],text:Q[0],tokens:this.lexer.inline(Q[0])}},W.escape=function(H){var Q=this.rules.inline.escape.exec(H);if(Q)return{type:"escape",raw:Q[0],text:g(Q[1])}},W.tag=function(H){var Q=this.rules.inline.tag.exec(H);if(Q)return!this.lexer.state.inLink&&/^<a /i.test(Q[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Q[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Q[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Q[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Q[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):g(Q[0]):Q[0]}},W.link=function(H){var Q=this.rules.inline.link.exec(H);if(Q){var G=Q[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var Z=D(G.slice(0,-1),"\\");if((G.length-Z.length)%2===0)return}else{var ce=w(Q[2],"()");if(ce>-1){var Ee=Q[0].indexOf("!")===0?5:4,Ce=Ee+Q[1].length+ce;Q[2]=Q[2].substring(0,ce),Q[0]=Q[0].substring(0,Ce).trim(),Q[3]=""}}var ke=Q[2],Fe="";if(this.options.pedantic){var je=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ke);je&&(ke=je[1],Fe=je[3])}else Fe=Q[3]?Q[3].slice(1,-1):"";return ke=ke.trim(),/^</.test(ke)&&(this.options.pedantic&&!/>$/.test(G)?ke=ke.slice(1):ke=ke.slice(1,-1)),$(Q,{href:ke&&ke.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},Q[0],this.lexer)}},W.reflink=function(H,Q){var G;if((G=this.rules.inline.reflink.exec(H))||(G=this.rules.inline.nolink.exec(H))){var Z=(G[2]||G[1]).replace(/\s+/g," ");if(Z=Q[Z.toLowerCase()],!Z||!Z.href){var ce=G[0].charAt(0);return{type:"text",raw:ce,text:ce}}return $(G,Z,G[0],this.lexer)}},W.emStrong=function(H,Q,G){G===void 0&&(G="");var Z=this.rules.inline.emStrong.lDelim.exec(H);if(Z&&!(Z[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=Z[1]||Z[2]||"";if(!ce||ce&&(G===""||this.rules.inline.punctuation.exec(G))){var Ee=Z[0].length-1,Ce,ke,Fe=Ee,je=0,ge=Z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,Q=Q.slice(-1*H.length+Ee);(Z=ge.exec(Q))!=null;)if(Ce=Z[1]||Z[2]||Z[3]||Z[4]||Z[5]||Z[6],!!Ce){if(ke=Ce.length,Z[3]||Z[4]){Fe+=ke;continue}else if((Z[5]||Z[6])&&Ee%3&&!((Ee+ke)%3)){je+=ke;continue}if(Fe-=ke,!(Fe>0)){if(ke=Math.min(ke,ke+Fe+je),Math.min(Ee,ke)%2){var Se=H.slice(1,Ee+Z.index+ke);return{type:"em",raw:H.slice(0,Ee+Z.index+ke+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var ye=H.slice(2,Ee+Z.index+ke-1);return{type:"strong",raw:H.slice(0,Ee+Z.index+ke+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},W.codespan=function(H){var Q=this.rules.inline.code.exec(H);if(Q){var G=Q[2].replace(/\n/g," "),Z=/[^ ]/.test(G),ce=/^ /.test(G)&&/ $/.test(G);return Z&&ce&&(G=G.substring(1,G.length-1)),G=g(G,!0),{type:"codespan",raw:Q[0],text:G}}},W.br=function(H){var Q=this.rules.inline.br.exec(H);if(Q)return{type:"br",raw:Q[0]}},W.del=function(H){var Q=this.rules.inline.del.exec(H);if(Q)return{type:"del",raw:Q[0],text:Q[2],tokens:this.lexer.inlineTokens(Q[2])}},W.autolink=function(H,Q){var G=this.rules.inline.autolink.exec(H);if(G){var Z,ce;return G[2]==="@"?(Z=g(this.options.mangle?Q(G[1]):G[1]),ce="mailto:"+Z):(Z=g(G[1]),ce=Z),{type:"link",raw:G[0],text:Z,href:ce,tokens:[{type:"text",raw:Z,text:Z}]}}},W.url=function(H,Q){var G;if(G=this.rules.inline.url.exec(H)){var Z,ce;if(G[2]==="@")Z=g(this.options.mangle?Q(G[0]):G[0]),ce="mailto:"+Z;else{var Ee;do Ee=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(Ee!==G[0]);Z=g(G[0]),G[1]==="www."?ce="http://"+Z:ce=Z}return{type:"link",raw:G[0],text:Z,href:ce,tokens:[{type:"text",raw:Z,text:Z}]}}},W.inlineText=function(H,Q){var G=this.rules.inline.text.exec(H);if(G){var Z;return this.lexer.state.inRawBlock?Z=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):g(G[0]):G[0]:Z=g(this.options.smartypants?Q(G[0]):G[0]),{type:"text",raw:G[0],text:Z}}},j}(),oe={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};oe._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,oe._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,oe.def=c(oe.def).replace("label",oe._label).replace("title",oe._title).getRegex(),oe.bullet=/(?:[*+-]|\d{1,9}[.)])/,oe.listItemStart=c(/^( *)(bull) */).replace("bull",oe.bullet).getRegex(),oe.list=c(oe.list).replace(/bull/g,oe.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+oe.def.source+")").getRegex(),oe._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",oe._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,oe.html=c(oe.html,"i").replace("comment",oe._comment).replace("tag",oe._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),oe.paragraph=c(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.blockquote=c(oe.blockquote).replace("paragraph",oe.paragraph).getRegex(),oe.normal=h({},oe),oe.gfm=h({},oe.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),oe.gfm.table=c(oe.gfm.table).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.gfm.paragraph=c(oe._paragraph).replace("hr",oe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",oe.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",oe._tag).getRegex(),oe.pedantic=h({},oe.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",oe._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:c(oe.normal._paragraph).replace("hr",oe.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",oe.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ue={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ue._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ue.punctuation=c(ue.punctuation).replace(/punctuation/g,ue._punctuation).getRegex(),ue.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ue.escapedEmSt=/\\\*|\\_/g,ue._comment=c(oe._comment).replace("(?:-->|$)","-->").getRegex(),ue.emStrong.lDelim=c(ue.emStrong.lDelim).replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimAst=c(ue.emStrong.rDelimAst,"g").replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimUnd=c(ue.emStrong.rDelimUnd,"g").replace(/punct/g,ue._punctuation).getRegex(),ue._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ue._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ue._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ue.autolink=c(ue.autolink).replace("scheme",ue._scheme).replace("email",ue._email).getRegex(),ue._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ue.tag=c(ue.tag).replace("comment",ue._comment).replace("attribute",ue._attribute).getRegex(),ue._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ue._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ue._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ue.link=c(ue.link).replace("label",ue._label).replace("href",ue._href).replace("title",ue._title).getRegex(),ue.reflink=c(ue.reflink).replace("label",ue._label).replace("ref",oe._label).getRegex(),ue.nolink=c(ue.nolink).replace("ref",oe._label).getRegex(),ue.reflinkSearch=c(ue.reflinkSearch,"g").replace("reflink",ue.reflink).replace("nolink",ue.nolink).getRegex(),ue.normal=h({},ue),ue.pedantic=h({},ue.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",ue._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ue._label).getRegex()}),ue.gfm=h({},ue.normal,{escape:c(ue.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ue.gfm.url=c(ue.gfm.url,"i").replace("email",ue.gfm._extended_email).getRegex(),ue.breaks=h({},ue.gfm,{br:c(ue.br).replace("{2,}","*").getRegex(),text:c(ue.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function me(j){return j.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function _(j){var W="",x,H,Q=j.length;for(x=0;x<Q;x++)H=j.charCodeAt(x),Math.random()>.5&&(H="x"+H.toString(16)),W+="&#"+H+";";return W}var re=function(){function j(x){this.tokens=[],this.tokens.links=Object.create(null),this.options=x||le.defaults,this.options.tokenizer=this.options.tokenizer||new he,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var H={block:oe.normal,inline:ue.normal};this.options.pedantic?(H.block=oe.pedantic,H.inline=ue.pedantic):this.options.gfm&&(H.block=oe.gfm,this.options.breaks?H.inline=ue.breaks:H.inline=ue.gfm),this.tokenizer.rules=H}j.lex=function(H,Q){var G=new j(Q);return G.lex(H)},j.lexInline=function(H,Q){var G=new j(Q);return G.inlineTokens(H)};var W=j.prototype;return W.lex=function(H){H=H.replace(/\r\n|\r/g,`
`),this.blockTokens(H,this.tokens);for(var Q;Q=this.inlineQueue.shift();)this.inlineTokens(Q.src,Q.tokens);return this.tokens},W.blockTokens=function(H,Q){var G=this;Q===void 0&&(Q=[]),this.options.pedantic?H=H.replace(/\t/g,"    ").replace(/^ +$/gm,""):H=H.replace(/^( *)(\t+)/gm,function(Fe,je,ge){return je+"    ".repeat(ge.length)});for(var Z,ce,Ee,Ce;H;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Fe){return(Z=Fe.call({lexer:G},H,Q))?(H=H.substring(Z.raw.length),Q.push(Z),!0):!1}))){if(Z=this.tokenizer.space(H)){H=H.substring(Z.raw.length),Z.raw.length===1&&Q.length>0?Q[Q.length-1].raw+=`
`:Q.push(Z);continue}if(Z=this.tokenizer.code(H)){H=H.substring(Z.raw.length),ce=Q[Q.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+Z.raw,ce.text+=`
`+Z.text,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):Q.push(Z);continue}if(Z=this.tokenizer.fences(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.heading(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.hr(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.blockquote(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.list(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.html(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.def(H)){H=H.substring(Z.raw.length),ce=Q[Q.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+Z.raw,ce.text+=`
`+Z.raw,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):this.tokens.links[Z.tag]||(this.tokens.links[Z.tag]={href:Z.href,title:Z.title});continue}if(Z=this.tokenizer.table(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.lheading(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Ee=H,this.options.extensions&&this.options.extensions.startBlock&&function(){var Fe=1/0,je=H.slice(1),ge=void 0;G.options.extensions.startBlock.forEach(function(Se){ge=Se.call({lexer:this},je),typeof ge=="number"&&ge>=0&&(Fe=Math.min(Fe,ge))}),Fe<1/0&&Fe>=0&&(Ee=H.substring(0,Fe+1))}(),this.state.top&&(Z=this.tokenizer.paragraph(Ee))){ce=Q[Q.length-1],Ce&&ce.type==="paragraph"?(ce.raw+=`
`+Z.raw,ce.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):Q.push(Z),Ce=Ee.length!==H.length,H=H.substring(Z.raw.length);continue}if(Z=this.tokenizer.text(H)){H=H.substring(Z.raw.length),ce=Q[Q.length-1],ce&&ce.type==="text"?(ce.raw+=`
`+Z.raw,ce.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):Q.push(Z);continue}if(H){var ke="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return this.state.top=!0,Q},W.inline=function(H,Q){return Q===void 0&&(Q=[]),this.inlineQueue.push({src:H,tokens:Q}),Q},W.inlineTokens=function(H,Q){var G=this;Q===void 0&&(Q=[]);var Z,ce,Ee,Ce=H,ke,Fe,je;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(ke=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)ge.includes(ke[0].slice(ke[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,ke.index)+"["+N("a",ke[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ke=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,ke.index)+"["+N("a",ke[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ke=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,ke.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;H;)if(Fe||(je=""),Fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(Z=ye.call({lexer:G},H,Q))?(H=H.substring(Z.raw.length),Q.push(Z),!0):!1}))){if(Z=this.tokenizer.escape(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.tag(H)){H=H.substring(Z.raw.length),ce=Q[Q.length-1],ce&&Z.type==="text"&&ce.type==="text"?(ce.raw+=Z.raw,ce.text+=Z.text):Q.push(Z);continue}if(Z=this.tokenizer.link(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.reflink(H,this.tokens.links)){H=H.substring(Z.raw.length),ce=Q[Q.length-1],ce&&Z.type==="text"&&ce.type==="text"?(ce.raw+=Z.raw,ce.text+=Z.text):Q.push(Z);continue}if(Z=this.tokenizer.emStrong(H,Ce,je)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.codespan(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.br(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.del(H)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Z=this.tokenizer.autolink(H,_)){H=H.substring(Z.raw.length),Q.push(Z);continue}if(!this.state.inLink&&(Z=this.tokenizer.url(H,_))){H=H.substring(Z.raw.length),Q.push(Z);continue}if(Ee=H,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Me=H.slice(1),ze=void 0;G.options.extensions.startInline.forEach(function(_e){ze=_e.call({lexer:this},Me),typeof ze=="number"&&ze>=0&&(ye=Math.min(ye,ze))}),ye<1/0&&ye>=0&&(Ee=H.substring(0,ye+1))}(),Z=this.tokenizer.inlineText(Ee,me)){H=H.substring(Z.raw.length),Z.raw.slice(-1)!=="_"&&(je=Z.raw.slice(-1)),Fe=!0,ce=Q[Q.length-1],ce&&ce.type==="text"?(ce.raw+=Z.raw,ce.text+=Z.text):Q.push(Z);continue}if(H){var Se="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return Q},y(j,null,[{key:"rules",get:function(){return{block:oe,inline:ue}}}]),j}(),q=function(){function j(x){this.options=x||le.defaults}var W=j.prototype;return W.code=function(H,Q,G){var Z=(Q||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(H,Z);ce!=null&&ce!==H&&(G=!0,H=ce)}return H=H.replace(/\n$/,"")+`
`,Z?'<pre><code class="'+this.options.langPrefix+g(Z,!0)+'">'+(G?H:g(H,!0))+`</code></pre>
`:"<pre><code>"+(G?H:g(H,!0))+`</code></pre>
`},W.blockquote=function(H){return`<blockquote>
`+H+`</blockquote>
`},W.html=function(H){return H},W.heading=function(H,Q,G,Z){if(this.options.headerIds){var ce=this.options.headerPrefix+Z.slug(G);return"<h"+Q+' id="'+ce+'">'+H+"</h"+Q+`>
`}return"<h"+Q+">"+H+"</h"+Q+`>
`},W.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},W.list=function(H,Q,G){var Z=Q?"ol":"ul",ce=Q&&G!==1?' start="'+G+'"':"";return"<"+Z+ce+`>
`+H+"</"+Z+`>
`},W.listitem=function(H){return"<li>"+H+`</li>
`},W.checkbox=function(H){return"<input "+(H?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},W.paragraph=function(H){return"<p>"+H+`</p>
`},W.table=function(H,Q){return Q&&(Q="<tbody>"+Q+"</tbody>"),`<table>
<thead>
`+H+`</thead>
`+Q+`</table>
`},W.tablerow=function(H){return`<tr>
`+H+`</tr>
`},W.tablecell=function(H,Q){var G=Q.header?"th":"td",Z=Q.align?"<"+G+' align="'+Q.align+'">':"<"+G+">";return Z+H+("</"+G+`>
`)},W.strong=function(H){return"<strong>"+H+"</strong>"},W.em=function(H){return"<em>"+H+"</em>"},W.codespan=function(H){return"<code>"+H+"</code>"},W.br=function(){return this.options.xhtml?"<br/>":"<br>"},W.del=function(H){return"<del>"+H+"</del>"},W.link=function(H,Q,G){if(H=O(this.options.sanitize,this.options.baseUrl,H),H===null)return G;var Z='<a href="'+g(H)+'"';return Q&&(Z+=' title="'+Q+'"'),Z+=">"+G+"</a>",Z},W.image=function(H,Q,G){if(H=O(this.options.sanitize,this.options.baseUrl,H),H===null)return G;var Z='<img src="'+H+'" alt="'+G+'"';return Q&&(Z+=' title="'+Q+'"'),Z+=this.options.xhtml?"/>":">",Z},W.text=function(H){return H},j}(),J=function(){function j(){}var W=j.prototype;return W.strong=function(H){return H},W.em=function(H){return H},W.codespan=function(H){return H},W.del=function(H){return H},W.html=function(H){return H},W.text=function(H){return H},W.link=function(H,Q,G){return""+G},W.image=function(H,Q,G){return""+G},W.br=function(){return""},j}(),U=function(){function j(){this.seen={}}var W=j.prototype;return W.serialize=function(H){return H.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},W.getNextSafeSlug=function(H,Q){var G=H,Z=0;if(this.seen.hasOwnProperty(G)){Z=this.seen[H];do Z++,G=H+"-"+Z;while(this.seen.hasOwnProperty(G))}return Q||(this.seen[H]=Z,this.seen[G]=0),G},W.slug=function(H,Q){Q===void 0&&(Q={});var G=this.serialize(H);return this.getNextSafeSlug(G,Q.dryrun)},j}(),ne=function(){function j(x){this.options=x||le.defaults,this.options.renderer=this.options.renderer||new q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new U}j.parse=function(H,Q){var G=new j(Q);return G.parse(H)},j.parseInline=function(H,Q){var G=new j(Q);return G.parseInline(H)};var W=j.prototype;return W.parse=function(H,Q){Q===void 0&&(Q=!0);var G="",Z,ce,Ee,Ce,ke,Fe,je,ge,Se,ye,Me,ze,_e,qe,Ve,et,rt,Ge,Xe,fe=H.length;for(Z=0;Z<fe;Z++){if(ye=H[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Xe=this.options.extensions.renderers[ye.type].call({parser:this},ye),Xe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){G+=Xe||"";continue}switch(ye.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,r(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ge="",je="",Ce=ye.header.length,ce=0;ce<Ce;ce++)je+=this.renderer.tablecell(this.parseInline(ye.header[ce].tokens),{header:!0,align:ye.align[ce]});for(ge+=this.renderer.tablerow(je),Se="",Ce=ye.rows.length,ce=0;ce<Ce;ce++){for(Fe=ye.rows[ce],je="",ke=Fe.length,Ee=0;Ee<ke;Ee++)je+=this.renderer.tablecell(this.parseInline(Fe[Ee].tokens),{header:!1,align:ye.align[Ee]});Se+=this.renderer.tablerow(je)}G+=this.renderer.table(ge,Se);continue}case"blockquote":{Se=this.parse(ye.tokens),G+=this.renderer.blockquote(Se);continue}case"list":{for(Me=ye.ordered,ze=ye.start,_e=ye.loose,Ce=ye.items.length,Se="",ce=0;ce<Ce;ce++)Ve=ye.items[ce],et=Ve.checked,rt=Ve.task,qe="",Ve.task&&(Ge=this.renderer.checkbox(et),_e?Ve.tokens.length>0&&Ve.tokens[0].type==="paragraph"?(Ve.tokens[0].text=Ge+" "+Ve.tokens[0].text,Ve.tokens[0].tokens&&Ve.tokens[0].tokens.length>0&&Ve.tokens[0].tokens[0].type==="text"&&(Ve.tokens[0].tokens[0].text=Ge+" "+Ve.tokens[0].tokens[0].text)):Ve.tokens.unshift({type:"text",text:Ge}):qe+=Ge),qe+=this.parse(Ve.tokens,_e),Se+=this.renderer.listitem(qe,rt,et);G+=this.renderer.list(Se,Me,ze);continue}case"html":{G+=this.renderer.html(ye.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Se=ye.tokens?this.parseInline(ye.tokens):ye.text;Z+1<fe&&H[Z+1].type==="text";)ye=H[++Z],Se+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);G+=Q?this.renderer.paragraph(Se):Se;continue}default:{var Ie='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return G},W.parseInline=function(H,Q){Q=Q||this.renderer;var G="",Z,ce,Ee,Ce=H.length;for(Z=0;Z<Ce;Z++){if(ce=H[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(Ee=this.options.extensions.renderers[ce.type].call({parser:this},ce),Ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ce.type))){G+=Ee||"";continue}switch(ce.type){case"escape":{G+=Q.text(ce.text);break}case"html":{G+=Q.html(ce.text);break}case"link":{G+=Q.link(ce.href,ce.title,this.parseInline(ce.tokens,Q));break}case"image":{G+=Q.image(ce.href,ce.title,ce.text);break}case"strong":{G+=Q.strong(this.parseInline(ce.tokens,Q));break}case"em":{G+=Q.em(this.parseInline(ce.tokens,Q));break}case"codespan":{G+=Q.codespan(ce.text);break}case"br":{G+=Q.br();break}case"del":{G+=Q.del(this.parseInline(ce.tokens,Q));break}case"text":{G+=Q.text(ce.text);break}default:{var ke='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return G},j}();function V(j,W,x){if(typeof j>"u"||j===null)throw new Error("marked(): input parameter is undefined or null");if(typeof j!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(j)+", string expected");if(typeof W=="function"&&(x=W,W=null),W=h({},V.defaults,W||{}),S(W),x){var H=W.highlight,Q;try{Q=re.lex(j,W)}catch(Ce){return x(Ce)}var G=function(ke){var Fe;if(!ke)try{W.walkTokens&&V.walkTokens(Q,W.walkTokens),Fe=ne.parse(Q,W)}catch(je){ke=je}return W.highlight=H,ke?x(ke):x(null,Fe)};if(!H||H.length<3||(delete W.highlight,!Q.length))return G();var Z=0;V.walkTokens(Q,function(Ce){Ce.type==="code"&&(Z++,setTimeout(function(){H(Ce.text,Ce.lang,function(ke,Fe){if(ke)return G(ke);Fe!=null&&Fe!==Ce.text&&(Ce.text=Fe,Ce.escaped=!0),Z--,Z===0&&G()})},0))}),Z===0&&G();return}function ce(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,W.silent)return"<p>An error occurred:</p><pre>"+g(Ce.message+"",!0)+"</pre>";throw Ce}try{var Ee=re.lex(j,W);if(W.walkTokens){if(W.async)return Promise.all(V.walkTokens(Ee,W.walkTokens)).then(function(){return ne.parse(Ee,W)}).catch(ce);V.walkTokens(Ee,W.walkTokens)}return ne.parse(Ee,W)}catch(Ce){ce(Ce)}}V.options=V.setOptions=function(j){return h(V.defaults,j),T(V.defaults),V},V.getDefaults=k,V.defaults=le.defaults,V.use=function(){for(var j=arguments.length,W=new Array(j),x=0;x<j;x++)W[x]=arguments[x];var H=h.apply(void 0,[{}].concat(W)),Q=V.defaults.extensions||{renderers:{},childTokens:{}},G;W.forEach(function(Z){if(Z.extensions&&(G=!0,Z.extensions.forEach(function(Ee){if(!Ee.name)throw new Error("extension name required");if(Ee.renderer){var Ce=Q.renderers?Q.renderers[Ee.name]:null;Ce?Q.renderers[Ee.name]=function(){for(var ke=arguments.length,Fe=new Array(ke),je=0;je<ke;je++)Fe[je]=arguments[je];var ge=Ee.renderer.apply(this,Fe);return ge===!1&&(ge=Ce.apply(this,Fe)),ge}:Q.renderers[Ee.name]=Ee.renderer}if(Ee.tokenizer){if(!Ee.level||Ee.level!=="block"&&Ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Q[Ee.level]?Q[Ee.level].unshift(Ee.tokenizer):Q[Ee.level]=[Ee.tokenizer],Ee.start&&(Ee.level==="block"?Q.startBlock?Q.startBlock.push(Ee.start):Q.startBlock=[Ee.start]:Ee.level==="inline"&&(Q.startInline?Q.startInline.push(Ee.start):Q.startInline=[Ee.start]))}Ee.childTokens&&(Q.childTokens[Ee.name]=Ee.childTokens)})),Z.renderer&&function(){var Ee=V.defaults.renderer||new q,Ce=function(je){var ge=Ee[je];Ee[je]=function(){for(var Se=arguments.length,ye=new Array(Se),Me=0;Me<Se;Me++)ye[Me]=arguments[Me];var ze=Z.renderer[je].apply(Ee,ye);return ze===!1&&(ze=ge.apply(Ee,ye)),ze}};for(var ke in Z.renderer)Ce(ke);H.renderer=Ee}(),Z.tokenizer&&function(){var Ee=V.defaults.tokenizer||new he,Ce=function(je){var ge=Ee[je];Ee[je]=function(){for(var Se=arguments.length,ye=new Array(Se),Me=0;Me<Se;Me++)ye[Me]=arguments[Me];var ze=Z.tokenizer[je].apply(Ee,ye);return ze===!1&&(ze=ge.apply(Ee,ye)),ze}};for(var ke in Z.tokenizer)Ce(ke);H.tokenizer=Ee}(),Z.walkTokens){var ce=V.defaults.walkTokens;H.walkTokens=function(Ee){var Ce=[];return Ce.push(Z.walkTokens.call(this,Ee)),ce&&(Ce=Ce.concat(ce.call(this,Ee))),Ce}}G&&(H.extensions=Q),V.setOptions(H)})},V.walkTokens=function(j,W){for(var x=[],H=function(){var ce=G.value;switch(x=x.concat(W.call(V,ce)),ce.type){case"table":{for(var Ee=A(ce.header),Ce;!(Ce=Ee()).done;){var ke=Ce.value;x=x.concat(V.walkTokens(ke.tokens,W))}for(var Fe=A(ce.rows),je;!(je=Fe()).done;)for(var ge=je.value,Se=A(ge),ye;!(ye=Se()).done;){var Me=ye.value;x=x.concat(V.walkTokens(Me.tokens,W))}break}case"list":{x=x.concat(V.walkTokens(ce.items,W));break}default:V.defaults.extensions&&V.defaults.extensions.childTokens&&V.defaults.extensions.childTokens[ce.type]?V.defaults.extensions.childTokens[ce.type].forEach(function(ze){x=x.concat(V.walkTokens(ce[ze],W))}):ce.tokens&&(x=x.concat(V.walkTokens(ce.tokens,W)))}},Q=A(j),G;!(G=Q()).done;)H();return x},V.parseInline=function(j,W){if(typeof j>"u"||j===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof j!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(j)+", string expected");W=h({},V.defaults,W||{}),S(W);try{var x=re.lexInline(j,W);return W.walkTokens&&V.walkTokens(x,W.walkTokens),ne.parseInline(x,W)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,W.silent)return"<p>An error occurred:</p><pre>"+g(H.message+"",!0)+"</pre>";throw H}},V.Parser=ne,V.parser=ne.parse,V.Renderer=q,V.TextRenderer=J,V.Lexer=re,V.lexer=re.lex,V.Tokenizer=he,V.Slugger=U,V.parse=V;var se=V.options,Y=V.setOptions,ie=V.use,z=V.walkTokens,P=V.parseInline,M=V,K=ne.parse,te=re.lex;le.Lexer=re,le.Parser=ne,le.Renderer=q,le.Slugger=U,le.TextRenderer=J,le.Tokenizer=he,le.getDefaults=k,le.lexer=te,le.marked=V,le.options=se,le.parse=M,le.parseInline=P,le.parser=K,le.setOptions=Y,le.use=ie,le.walkTokens=z,Object.defineProperty(le,"__esModule",{value:!0})}),define(pe[96],be([1,0,28]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new y.LRUCache(1e4);function o(m){return v(m,"NFC",L)}e.normalizeNFC=o;const A=new y.LRUCache(1e4);function k(m){return v(m,"NFD",A)}e.normalizeNFD=k;const T=/[^\u0000-\u0080]/;function v(m,R,E){if(!m)return m;const b=E.get(m);if(b)return b;let d;return T.test(m)?d=m.normalize(R):d=m,E.set(m,d),d}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(R){return k(R).replace(m,"")}}()}),define(pe[142],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function y(T,v,m){return Math.min(Math.max(T,v),m)}e.clamp=y;function L(T,v){return(v+T%v)%v}e.rot=L;class o{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=o;class A{constructor(){this.a=1,this.b=0}update(v){return this.b=this.b+(v-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class k{constructor(v){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(v),this.c.fill(0,0,v)}update(v){const m=this.c[this.d];return this.c[this.d]=v,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=v,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=k}),function(){function le(o){const A=[];typeof o=="number"&&A.push("code/timeOrigin",o);function k(v){A.push(v,Date.now())}function T(){const v=[];for(let m=0;m<A.length;m+=2)v.push({name:A[m],startTime:A[m+1]});return v}return{mark:k,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(o){performance.mark(o)},getMarks(){let o=performance.timeOrigin;typeof o!="number"&&(o=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(o)}];for(const k of performance.getEntriesByType("mark"))A.push({name:k.name,startTime:Math.round(o+k.startTime)});return A}};if(typeof process=="object"){const o=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(o)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function y(o){return o.MonacoPerformanceMarks||(o.MonacoPerformanceMarks=e()),o.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=y(L))}(),define(pe[3],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let y=!1,L=!1,o=!1,A=!1,k=!1,T=!1,v=!1,m=!1,R=!1,E=!1,b,d=e.LANGUAGE_DEFAULT,g=e.LANGUAGE_DEFAULT,p,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?f=e.globals.vscode.process:typeof process<"u"&&(f=process);const c=typeof f?.versions?.electron=="string",u=c&&f?.type==="renderer";if(typeof navigator=="object"&&!u){r=navigator.userAgent,y=r.indexOf("Windows")>=0,L=r.indexOf("Macintosh")>=0,m=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,o=r.indexOf("Linux")>=0,E=r?.indexOf("Mobi")>=0,T=!0,b=e.LANGUAGE_DEFAULT,d=b,g=navigator.language;const h=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),C=h&&h.getAttribute("data-settings");if(C)try{const D=JSON.parse(C),w=D.availableLanguages["*"];b=D.locale,g=D.osLocale,d=w||e.LANGUAGE_DEFAULT,p=D._translationsConfigFile}catch{}}else if(typeof f=="object"){y=f.platform==="win32",L=f.platform==="darwin",o=f.platform==="linux",A=o&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,v=c,R=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const h=f.env.VSCODE_NLS_CONFIG;if(h)try{const C=JSON.parse(h),D=C.availableLanguages["*"];b=C.locale,g=C.osLocale,d=D||e.LANGUAGE_DEFAULT,p=C._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var I;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(I||(e.Platform=I={}));function O(h){switch(h){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=O;let t=0;L?t=1:y?t=3:o&&(t=2),e.isWindows=y,e.isMacintosh=L,e.isLinux=o,e.isLinuxSnap=A,e.isNative=k,e.isElectron=v,e.isWeb=T,e.isWebWorker=T&&typeof e.globals.importScripts=="function",e.isIOS=m,e.isMobile=E,e.isCI=R,e.platform=t,e.userAgent=r,e.language=d;var n;(function(h){function C(){return e.language}h.value=C;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}h.isDefaultVariant=D;function w(){return e.language==="en"}h.isDefault=w})(n||(e.Language=n={})),e.locale=b,e.platformLocale=g,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const h=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let w=0,S=h.length;w<S;w++){const N=h[w];if(N.id===D.data.vscodeScheduleAsyncWork){h.splice(w,1),N.callback();return}}});let C=0;return D=>{const w=++C;h.push({id:w,callback:D}),e.globals.postMessage({vscodeScheduleAsyncWork:w},"*")}}return h=>setTimeout(h)})();var s;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=L||m?2:y?1:3;let i=!0,a=!1;function l(){if(!a){a=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,i=new Uint16Array(h.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(pe[29],be([1,0,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof y.globals.vscode<"u"&&typeof y.globals.vscode.process<"u"){const o=y.globals.vscode.process;L={get platform(){return o.platform},get arch(){return o.arch},get env(){return o.env},cwd(){return o.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(pe[7],be([1,0,29]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,o=97,A=90,k=122,T=46,v=47,m=92,R=58,E=63;class b extends Error{constructor(n,s,i){let a;typeof s=="string"&&s.indexOf("not ")===0?(a="must not be",s=s.replace(/^not /,"")):a="must be";const l=n.indexOf(".")!==-1?"property":"argument";let h=`The "${n}" ${l} ${a} of type ${s}`;h+=`. Received type ${typeof i}`,super(h),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,n){if(t===null||typeof t!="object")throw new b(n,"Object",t)}function g(t,n){if(typeof t!="string")throw new b(n,"string",t)}const p=y.platform==="win32";function r(t){return t===v||t===m}function f(t){return t===v}function c(t){return t>=L&&t<=A||t>=o&&t<=k}function u(t,n,s,i){let a="",l=0,h=-1,C=0,D=0;for(let w=0;w<=t.length;++w){if(w<t.length)D=t.charCodeAt(w);else{if(i(D))break;D=v}if(i(D)){if(!(h===w-1||C===1))if(C===2){if(a.length<2||l!==2||a.charCodeAt(a.length-1)!==T||a.charCodeAt(a.length-2)!==T){if(a.length>2){const S=a.lastIndexOf(s);S===-1?(a="",l=0):(a=a.slice(0,S),l=a.length-1-a.lastIndexOf(s)),h=w,C=0;continue}else if(a.length!==0){a="",l=0,h=w,C=0;continue}}n&&(a+=a.length>0?`${s}..`:"..",l=2)}else a.length>0?a+=`${s}${t.slice(h+1,w)}`:a=t.slice(h+1,w),l=w-h-1;h=w,C=0}else D===T&&C!==-1?++C:C=-1}return a}function I(t,n){d(n,"pathObject");const s=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return s?s===n.root?`${s}${i}`:`${s}${t}${i}`:i}e.win32={resolve(...t){let n="",s="",i=!1;for(let a=t.length-1;a>=-1;a--){let l;if(a>=0){if(l=t[a],g(l,"path"),l.length===0)continue}else n.length===0?l=y.cwd():(l=y.env[`=${n}`]||y.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==n.toLowerCase()&&l.charCodeAt(2)===m)&&(l=`${n}\\`));const h=l.length;let C=0,D="",w=!1;const S=l.charCodeAt(0);if(h===1)r(S)&&(C=1,w=!0);else if(r(S))if(w=!0,r(l.charCodeAt(1))){let N=2,$=N;for(;N<h&&!r(l.charCodeAt(N));)N++;if(N<h&&N!==$){const ee=l.slice($,N);for($=N;N<h&&r(l.charCodeAt(N));)N++;if(N<h&&N!==$){for($=N;N<h&&!r(l.charCodeAt(N));)N++;(N===h||N!==$)&&(D=`\\\\${ee}\\${l.slice($,N)}`,C=N)}}}else C=1;else c(S)&&l.charCodeAt(1)===R&&(D=l.slice(0,2),C=2,h>2&&r(l.charCodeAt(2))&&(w=!0,C=3));if(D.length>0)if(n.length>0){if(D.toLowerCase()!==n.toLowerCase())continue}else n=D;if(i){if(n.length>0)break}else if(s=`${l.slice(C)}\\${s}`,i=w,w&&n.length>0)break}return s=u(s,!i,"\\",r),i?`${n}\\${s}`:`${n}${s}`||"."},normalize(t){g(t,"path");const n=t.length;if(n===0)return".";let s=0,i,a=!1;const l=t.charCodeAt(0);if(n===1)return f(l)?"\\":t;if(r(l))if(a=!0,r(t.charCodeAt(1))){let C=2,D=C;for(;C<n&&!r(t.charCodeAt(C));)C++;if(C<n&&C!==D){const w=t.slice(D,C);for(D=C;C<n&&r(t.charCodeAt(C));)C++;if(C<n&&C!==D){for(D=C;C<n&&!r(t.charCodeAt(C));)C++;if(C===n)return`\\\\${w}\\${t.slice(D)}\\`;C!==D&&(i=`\\\\${w}\\${t.slice(D,C)}`,s=C)}}}else s=1;else c(l)&&t.charCodeAt(1)===R&&(i=t.slice(0,2),s=2,n>2&&r(t.charCodeAt(2))&&(a=!0,s=3));let h=s<n?u(t.slice(s),!a,"\\",r):"";return h.length===0&&!a&&(h="."),h.length>0&&r(t.charCodeAt(n-1))&&(h+="\\"),i===void 0?a?`\\${h}`:h:a?`${i}\\${h}`:`${i}${h}`},isAbsolute(t){g(t,"path");const n=t.length;if(n===0)return!1;const s=t.charCodeAt(0);return r(s)||n>2&&c(s)&&t.charCodeAt(1)===R&&r(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,s;for(let l=0;l<t.length;++l){const h=t[l];g(h,"path"),h.length>0&&(n===void 0?n=s=h:n+=`\\${h}`)}if(n===void 0)return".";let i=!0,a=0;if(typeof s=="string"&&r(s.charCodeAt(0))){++a;const l=s.length;l>1&&r(s.charCodeAt(1))&&(++a,l>2&&(r(s.charCodeAt(2))?++a:i=!1))}if(i){for(;a<n.length&&r(n.charCodeAt(a));)a++;a>=2&&(n=`\\${n.slice(a)}`)}return e.win32.normalize(n)},relative(t,n){if(g(t,"from"),g(n,"to"),t===n)return"";const s=e.win32.resolve(t),i=e.win32.resolve(n);if(s===i||(t=s.toLowerCase(),n=i.toLowerCase(),t===n))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===m;)a++;let l=t.length;for(;l-1>a&&t.charCodeAt(l-1)===m;)l--;const h=l-a;let C=0;for(;C<n.length&&n.charCodeAt(C)===m;)C++;let D=n.length;for(;D-1>C&&n.charCodeAt(D-1)===m;)D--;const w=D-C,S=h<w?h:w;let N=-1,$=0;for(;$<S;$++){const he=t.charCodeAt(a+$);if(he!==n.charCodeAt(C+$))break;he===m&&(N=$)}if($!==S){if(N===-1)return i}else{if(w>S){if(n.charCodeAt(C+$)===m)return i.slice(C+$+1);if($===2)return i.slice(C+$)}h>S&&(t.charCodeAt(a+$)===m?N=$:$===2&&(N=3)),N===-1&&(N=0)}let ee="";for($=a+N+1;$<=l;++$)($===l||t.charCodeAt($)===m)&&(ee+=ee.length===0?"..":"\\..");return C+=N,ee.length>0?`${ee}${i.slice(C,D)}`:(i.charCodeAt(C)===m&&++C,i.slice(C,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.win32.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===m){if(n.charCodeAt(1)===m){const s=n.charCodeAt(2);if(s!==E&&s!==T)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(c(n.charCodeAt(0))&&n.charCodeAt(1)===R&&n.charCodeAt(2)===m)return`\\\\?\\${n}`;return t},dirname(t){g(t,"path");const n=t.length;if(n===0)return".";let s=-1,i=0;const a=t.charCodeAt(0);if(n===1)return r(a)?t:".";if(r(a)){if(s=i=1,r(t.charCodeAt(1))){let C=2,D=C;for(;C<n&&!r(t.charCodeAt(C));)C++;if(C<n&&C!==D){for(D=C;C<n&&r(t.charCodeAt(C));)C++;if(C<n&&C!==D){for(D=C;C<n&&!r(t.charCodeAt(C));)C++;if(C===n)return t;C!==D&&(s=i=C+1)}}}}else c(a)&&t.charCodeAt(1)===R&&(s=n>2&&r(t.charCodeAt(2))?3:2,i=s);let l=-1,h=!0;for(let C=n-1;C>=i;--C)if(r(t.charCodeAt(C))){if(!h){l=C;break}}else h=!1;if(l===-1){if(s===-1)return".";l=s}return t.slice(0,l)},basename(t,n){n!==void 0&&g(n,"ext"),g(t,"path");let s=0,i=-1,a=!0,l;if(t.length>=2&&c(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(s=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let h=n.length-1,C=-1;for(l=t.length-1;l>=s;--l){const D=t.charCodeAt(l);if(r(D)){if(!a){s=l+1;break}}else C===-1&&(a=!1,C=l+1),h>=0&&(D===n.charCodeAt(h)?--h===-1&&(i=l):(h=-1,i=C))}return s===i?i=C:i===-1&&(i=t.length),t.slice(s,i)}for(l=t.length-1;l>=s;--l)if(r(t.charCodeAt(l))){if(!a){s=l+1;break}}else i===-1&&(a=!1,i=l+1);return i===-1?"":t.slice(s,i)},extname(t){g(t,"path");let n=0,s=-1,i=0,a=-1,l=!0,h=0;t.length>=2&&t.charCodeAt(1)===R&&c(t.charCodeAt(0))&&(n=i=2);for(let C=t.length-1;C>=n;--C){const D=t.charCodeAt(C);if(r(D)){if(!l){i=C+1;break}continue}a===-1&&(l=!1,a=C+1),D===T?s===-1?s=C:h!==1&&(h=1):s!==-1&&(h=-1)}return s===-1||a===-1||h===0||h===1&&s===a-1&&s===i+1?"":t.slice(s,a)},format:I.bind(null,"\\"),parse(t){g(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const s=t.length;let i=0,a=t.charCodeAt(0);if(s===1)return r(a)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(r(a)){if(i=1,r(t.charCodeAt(1))){let N=2,$=N;for(;N<s&&!r(t.charCodeAt(N));)N++;if(N<s&&N!==$){for($=N;N<s&&r(t.charCodeAt(N));)N++;if(N<s&&N!==$){for($=N;N<s&&!r(t.charCodeAt(N));)N++;N===s?i=N:N!==$&&(i=N+1)}}}}else if(c(a)&&t.charCodeAt(1)===R){if(s<=2)return n.root=n.dir=t,n;if(i=2,r(t.charCodeAt(2))){if(s===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let l=-1,h=i,C=-1,D=!0,w=t.length-1,S=0;for(;w>=i;--w){if(a=t.charCodeAt(w),r(a)){if(!D){h=w+1;break}continue}C===-1&&(D=!1,C=w+1),a===T?l===-1?l=w:S!==1&&(S=1):l!==-1&&(S=-1)}return C!==-1&&(l===-1||S===0||S===1&&l===C-1&&l===h+1?n.base=n.name=t.slice(h,C):(n.name=t.slice(h,l),n.base=t.slice(h,C),n.ext=t.slice(l,C))),h>0&&h!==i?n.dir=t.slice(0,h-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const O=(()=>{if(p){const t=/\\/g;return()=>{const n=y.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>y.cwd()})();e.posix={resolve(...t){let n="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const a=i>=0?t[i]:O();g(a,"path"),a.length!==0&&(n=`${a}/${n}`,s=a.charCodeAt(0)===v)}return n=u(n,!s,"/",f),s?`/${n}`:n.length>0?n:"."},normalize(t){if(g(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===v,s=t.charCodeAt(t.length-1)===v;return t=u(t,!n,"/",f),t.length===0?n?"/":s?"./":".":(s&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return g(t,"path"),t.length>0&&t.charCodeAt(0)===v},join(...t){if(t.length===0)return".";let n;for(let s=0;s<t.length;++s){const i=t[s];g(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.posix.normalize(n)},relative(t,n){if(g(t,"from"),g(n,"to"),t===n||(t=e.posix.resolve(t),n=e.posix.resolve(n),t===n))return"";const s=1,i=t.length,a=i-s,l=1,h=n.length-l,C=a<h?a:h;let D=-1,w=0;for(;w<C;w++){const N=t.charCodeAt(s+w);if(N!==n.charCodeAt(l+w))break;N===v&&(D=w)}if(w===C)if(h>C){if(n.charCodeAt(l+w)===v)return n.slice(l+w+1);if(w===0)return n.slice(l+w)}else a>C&&(t.charCodeAt(s+w)===v?D=w:w===0&&(D=0));let S="";for(w=s+D+1;w<=i;++w)(w===i||t.charCodeAt(w)===v)&&(S+=S.length===0?"..":"/..");return`${S}${n.slice(l+D)}`},toNamespacedPath(t){return t},dirname(t){if(g(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===v;let s=-1,i=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===v){if(!i){s=a;break}}else i=!1;return s===-1?n?"/":".":n&&s===1?"//":t.slice(0,s)},basename(t,n){n!==void 0&&g(n,"ext"),g(t,"path");let s=0,i=-1,a=!0,l;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let h=n.length-1,C=-1;for(l=t.length-1;l>=0;--l){const D=t.charCodeAt(l);if(D===v){if(!a){s=l+1;break}}else C===-1&&(a=!1,C=l+1),h>=0&&(D===n.charCodeAt(h)?--h===-1&&(i=l):(h=-1,i=C))}return s===i?i=C:i===-1&&(i=t.length),t.slice(s,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===v){if(!a){s=l+1;break}}else i===-1&&(a=!1,i=l+1);return i===-1?"":t.slice(s,i)},extname(t){g(t,"path");let n=-1,s=0,i=-1,a=!0,l=0;for(let h=t.length-1;h>=0;--h){const C=t.charCodeAt(h);if(C===v){if(!a){s=h+1;break}continue}i===-1&&(a=!1,i=h+1),C===T?n===-1?n=h:l!==1&&(l=1):n!==-1&&(l=-1)}return n===-1||i===-1||l===0||l===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:I.bind(null,"/"),parse(t){g(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const s=t.charCodeAt(0)===v;let i;s?(n.root="/",i=1):i=0;let a=-1,l=0,h=-1,C=!0,D=t.length-1,w=0;for(;D>=i;--D){const S=t.charCodeAt(D);if(S===v){if(!C){l=D+1;break}continue}h===-1&&(C=!1,h=D+1),S===T?a===-1?a=D:w!==1&&(w=1):a!==-1&&(w=-1)}if(h!==-1){const S=l===0&&s?1:l;a===-1||w===0||w===1&&a===h-1&&a===l+1?n.base=n.name=t.slice(S,h):(n.name=t.slice(S,a),n.base=t.slice(S,h),n.ext=t.slice(a,h))}return l>0?n.dir=t.slice(0,l-1):s&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(pe[58],be([1,0,7]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const E=(0,y.extname)(R),b=L[E.toLowerCase()];return b!==void 0?b:k(R)}e.getMediaOrTextMime=A;function k(R){const E=(0,y.extname)(R);return o[E.toLowerCase()]}e.getMediaMime=k;function T(R){for(const E in o)if(o[E]===R)return E}e.getExtensionForMimeType=T;const v=/^(.+)\/(.+?)(;.+)?$/;function m(R,E){const b=v.exec(R);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:E?void 0:R}e.normalizeMimeType=m}),define(pe[59],be([1,0,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(L||(e.Source=L={}));var o;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(o||(e.TerminateResponseCode=o={}));function A(T,...v){const m=v.reduce((b,d)=>(b[d]=!0,b),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(T).filter(b=>!m[b]).forEach(b=>{for(let d=0;d<R.length;d++)if(b.search(R[d])!==-1){delete T[b];break}})}e.sanitizeProcessEnvironment=A;function k(T){T&&(delete T.DEBUG,y.isMacintosh&&delete T.DYLD_LIBRARY_PATH,y.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var L in y)(typeof exports=="object"?exports:le)[L]=y[L]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function y(L){if(e[L])return e[L].exports;var o=e[L]={i:L,l:!1,exports:{}};return le[L].call(o.exports,o,o.exports,y),o.l=!0,o.exports}return y.m=le,y.c=e,y.d=function(L,o,A){y.o(L,o)||Object.defineProperty(L,o,{enumerable:!0,get:A})},y.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},y.t=function(L,o){if(1&o&&(L=y(L)),8&o||4&o&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(y.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&o&&typeof L!="string")for(var k in L)y.d(A,k,function(T){return L[T]}.bind(null,k));return A},y.n=function(L){var o=L&&L.__esModule?function(){return L.default}:function(){return L};return y.d(o,"a",o),o},y.o=function(L,o){return Object.prototype.hasOwnProperty.call(L,o)},y.p="",y(y.s=0)}([function(le,e,y){(function(L){var o;e=le.exports=ie,o=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],v=e.src=[],m=0,R=m++;v[R]="0|[1-9]\\d*";var E=m++;v[E]="[0-9]+";var b=m++;v[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=m++;v[d]="("+v[R]+")\\.("+v[R]+")\\.("+v[R]+")";var g=m++;v[g]="("+v[E]+")\\.("+v[E]+")\\.("+v[E]+")";var p=m++;v[p]="(?:"+v[R]+"|"+v[b]+")";var r=m++;v[r]="(?:"+v[E]+"|"+v[b]+")";var f=m++;v[f]="(?:-("+v[p]+"(?:\\."+v[p]+")*))";var c=m++;v[c]="(?:-?("+v[r]+"(?:\\."+v[r]+")*))";var u=m++;v[u]="[0-9A-Za-z-]+";var I=m++;v[I]="(?:\\+("+v[u]+"(?:\\."+v[u]+")*))";var O=m++,t="v?"+v[d]+v[f]+"?"+v[I]+"?";v[O]="^"+t+"$";var n="[v=\\s]*"+v[g]+v[c]+"?"+v[I]+"?",s=m++;v[s]="^"+n+"$";var i=m++;v[i]="((?:<|>)?=?)";var a=m++;v[a]=v[E]+"|x|X|\\*";var l=m++;v[l]=v[R]+"|x|X|\\*";var h=m++;v[h]="[v=\\s]*("+v[l]+")(?:\\.("+v[l]+")(?:\\.("+v[l]+")(?:"+v[f]+")?"+v[I]+"?)?)?";var C=m++;v[C]="[v=\\s]*("+v[a]+")(?:\\.("+v[a]+")(?:\\.("+v[a]+")(?:"+v[c]+")?"+v[I]+"?)?)?";var D=m++;v[D]="^"+v[i]+"\\s*"+v[h]+"$";var w=m++;v[w]="^"+v[i]+"\\s*"+v[C]+"$";var S=m++;v[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=m++;v[N]="(?:~>?)";var $=m++;v[$]="(\\s*)"+v[N]+"\\s+",T[$]=new RegExp(v[$],"g");var ee=m++;v[ee]="^"+v[N]+v[h]+"$";var he=m++;v[he]="^"+v[N]+v[C]+"$";var oe=m++;v[oe]="(?:\\^)";var ue=m++;v[ue]="(\\s*)"+v[oe]+"\\s+",T[ue]=new RegExp(v[ue],"g");var me=m++;v[me]="^"+v[oe]+v[h]+"$";var _=m++;v[_]="^"+v[oe]+v[C]+"$";var re=m++;v[re]="^"+v[i]+"\\s*("+n+")$|^$";var q=m++;v[q]="^"+v[i]+"\\s*("+t+")$|^$";var J=m++;v[J]="(\\s*)"+v[i]+"\\s*("+n+"|"+v[h]+")",T[J]=new RegExp(v[J],"g");var U=m++;v[U]="^\\s*("+v[h]+")\\s+-\\s+("+v[h]+")\\s*$";var ne=m++;v[ne]="^\\s*("+v[C]+")\\s+-\\s+("+v[C]+")\\s*$";var V=m++;v[V]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)o(se,v[se]),T[se]||(T[se]=new RegExp(v[se]));function Y(ge,Se){if(ge instanceof ie)return ge;if(typeof ge!="string"||ge.length>A||!(Se?T[s]:T[O]).test(ge))return null;try{return new ie(ge,Se)}catch{return null}}function ie(ge,Se){if(ge instanceof ie){if(ge.loose===Se)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof ie))return new ie(ge,Se);o("SemVer",ge,Se),this.loose=Se;var ye=ge.trim().match(Se?T[s]:T[O]);if(!ye)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var ze=+Me;if(ze>=0&&ze<k)return ze}return Me}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=Y,e.valid=function(ge,Se){var ye=Y(ge,Se);return ye?ye.version:null},e.clean=function(ge,Se){var ye=Y(ge.trim().replace(/^[=v]+/,""),Se);return ye?ye.version:null},e.SemVer=ie,ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ie.prototype.toString=function(){return this.version},ie.prototype.compare=function(ge){return o("SemVer.compare",this.version,this.loose,ge),ge instanceof ie||(ge=new ie(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},ie.prototype.compareMain=function(ge){return ge instanceof ie||(ge=new ie(ge,this.loose)),P(this.major,ge.major)||P(this.minor,ge.minor)||P(this.patch,ge.patch)},ie.prototype.comparePre=function(ge){if(ge instanceof ie||(ge=new ie(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var Se=0;do{var ye=this.prerelease[Se],Me=ge.prerelease[Se];if(o("prerelease compare",Se,ye,Me),ye===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ye===void 0)return-1;if(ye!==Me)return P(ye,Me)}while(++Se)},ie.prototype.inc=function(ge,Se){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,Se,ye,Me){typeof ye=="string"&&(Me=ye,ye=void 0);try{return new ie(ge,ye).inc(Se,Me).version}catch{return null}},e.diff=function(ge,Se){if(j(ge,Se))return null;var ye=Y(ge),Me=Y(Se);if(ye.prerelease.length||Me.prerelease.length){for(var ze in ye)if((ze==="major"||ze==="minor"||ze==="patch")&&ye[ze]!==Me[ze])return"pre"+ze;return"prerelease"}for(var ze in ye)if((ze==="major"||ze==="minor"||ze==="patch")&&ye[ze]!==Me[ze])return ze},e.compareIdentifiers=P;var z=/^[0-9]+$/;function P(ge,Se){var ye=z.test(ge),Me=z.test(Se);return ye&&Me&&(ge=+ge,Se=+Se),ye&&!Me?-1:Me&&!ye?1:ge<Se?-1:ge>Se?1:0}function M(ge,Se,ye){return new ie(ge,ye).compare(new ie(Se,ye))}function K(ge,Se,ye){return M(ge,Se,ye)>0}function te(ge,Se,ye){return M(ge,Se,ye)<0}function j(ge,Se,ye){return M(ge,Se,ye)===0}function W(ge,Se,ye){return M(ge,Se,ye)!==0}function x(ge,Se,ye){return M(ge,Se,ye)>=0}function H(ge,Se,ye){return M(ge,Se,ye)<=0}function Q(ge,Se,ye,Me){var ze;switch(Se){case"===":typeof ge=="object"&&(ge=ge.version),typeof ye=="object"&&(ye=ye.version),ze=ge===ye;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof ye=="object"&&(ye=ye.version),ze=ge!==ye;break;case"":case"=":case"==":ze=j(ge,ye,Me);break;case"!=":ze=W(ge,ye,Me);break;case">":ze=K(ge,ye,Me);break;case">=":ze=x(ge,ye,Me);break;case"<":ze=te(ge,ye,Me);break;case"<=":ze=H(ge,ye,Me);break;default:throw new TypeError("Invalid operator: "+Se)}return ze}function G(ge,Se){if(ge instanceof G){if(ge.loose===Se)return ge;ge=ge.value}if(!(this instanceof G))return new G(ge,Se);o("comparator",ge,Se),this.loose=Se,this.parse(ge),this.semver===Z?this.value="":this.value=this.operator+this.semver.version,o("comp",this)}e.rcompareIdentifiers=function(ge,Se){return P(Se,ge)},e.major=function(ge,Se){return new ie(ge,Se).major},e.minor=function(ge,Se){return new ie(ge,Se).minor},e.patch=function(ge,Se){return new ie(ge,Se).patch},e.compare=M,e.compareLoose=function(ge,Se){return M(ge,Se,!0)},e.rcompare=function(ge,Se,ye){return M(Se,ge,ye)},e.sort=function(ge,Se){return ge.sort(function(ye,Me){return e.compare(ye,Me,Se)})},e.rsort=function(ge,Se){return ge.sort(function(ye,Me){return e.rcompare(ye,Me,Se)})},e.gt=K,e.lt=te,e.eq=j,e.neq=W,e.gte=x,e.lte=H,e.cmp=Q,e.Comparator=G;var Z={};function ce(ge,Se){if(ge instanceof ce)return ge.loose===Se?ge:new ce(ge.raw,Se);if(ge instanceof G)return new ce(ge.value,Se);if(!(this instanceof ce))return new ce(ge,Se);if(this.loose=Se,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function Ee(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function Ce(ge,Se,ye,Me,ze,_e,qe,Ve,et,rt,Ge,Xe,fe){return((Se=Ee(ye)?"":Ee(Me)?">="+ye+".0.0":Ee(ze)?">="+ye+"."+Me+".0":">="+Se)+" "+(Ve=Ee(et)?"":Ee(rt)?"<"+(+et+1)+".0.0":Ee(Ge)?"<"+et+"."+(+rt+1)+".0":Xe?"<="+et+"."+rt+"."+Ge+"-"+Xe:"<="+Ve)).trim()}function ke(ge,Se){for(var ye=0;ye<ge.length;ye++)if(!ge[ye].test(Se))return!1;if(Se.prerelease.length){for(ye=0;ye<ge.length;ye++)if(o(ge[ye].semver),ge[ye].semver!==Z&&ge[ye].semver.prerelease.length>0){var Me=ge[ye].semver;if(Me.major===Se.major&&Me.minor===Se.minor&&Me.patch===Se.patch)return!0}return!1}return!0}function Fe(ge,Se,ye){try{Se=new ce(Se,ye)}catch{return!1}return Se.test(ge)}function je(ge,Se,ye,Me){var ze,_e,qe,Ve,et;switch(ge=new ie(ge,Me),Se=new ce(Se,Me),ye){case">":ze=K,_e=H,qe=te,Ve=">",et=">=";break;case"<":ze=te,_e=x,qe=K,Ve="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(ge,Se,Me))return!1;for(var rt=0;rt<Se.set.length;++rt){var Ge=Se.set[rt],Xe=null,fe=null;if(Ge.forEach(function(Ie){Ie.semver===Z&&(Ie=new G(">=0.0.0")),Xe=Xe||Ie,fe=fe||Ie,ze(Ie.semver,Xe.semver,Me)?Xe=Ie:qe(Ie.semver,fe.semver,Me)&&(fe=Ie)}),Xe.operator===Ve||Xe.operator===et||(!fe.operator||fe.operator===Ve)&&_e(ge,fe.semver)||fe.operator===et&&qe(ge,fe.semver))return!1}return!0}G.prototype.parse=function(ge){var Se=this.loose?T[re]:T[q],ye=ge.match(Se);if(!ye)throw new TypeError("Invalid comparator: "+ge);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new ie(ye[2],this.loose):this.semver=Z},G.prototype.toString=function(){return this.value},G.prototype.test=function(ge){return o("Comparator.test",ge,this.loose),this.semver===Z||(typeof ge=="string"&&(ge=new ie(ge,this.loose)),Q(ge,this.operator,this.semver,this.loose))},G.prototype.intersects=function(ge,Se){if(!(ge instanceof G))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new ce(ge.value,Se),Fe(this.value,ye,Se);if(ge.operator==="")return ye=new ce(this.value,Se),Fe(ge.semver,ye,Se);var Me=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),_e=this.semver.version===ge.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),Ve=Q(this.semver,"<",ge.semver,Se)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),et=Q(this.semver,">",ge.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return Me||ze||_e&&qe||Ve||et},e.Range=ce,ce.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},ce.prototype.toString=function(){return this.range},ce.prototype.parseRange=function(ge){var Se=this.loose;ge=ge.trim(),o("range",ge,Se);var ye=Se?T[ne]:T[U];ge=ge.replace(ye,Ce),o("hyphen replace",ge),ge=ge.replace(T[J],"$1$2$3"),o("comparator trim",ge,T[J]),ge=(ge=(ge=ge.replace(T[$],"$1~")).replace(T[ue],"$1^")).split(/\s+/).join(" ");var Me=Se?T[re]:T[q],ze=ge.split(" ").map(function(_e){return function(qe,Ve){return o("comp",qe),qe=function(et,rt){return et.trim().split(/\s+/).map(function(Ge){return function(Xe,fe){o("caret",Xe,fe);var Ie=fe?T[_]:T[me];return Xe.replace(Ie,function(Te,Re,Oe,$e,We){var Qe;return o("caret",Xe,Te,Re,Oe,$e,We),Ee(Re)?Qe="":Ee(Oe)?Qe=">="+Re+".0.0 <"+(+Re+1)+".0.0":Ee($e)?Qe=Re==="0"?">="+Re+"."+Oe+".0 <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+".0 <"+(+Re+1)+".0.0":We?(o("replaceCaret pr",We),We.charAt(0)!=="-"&&(We="-"+We),Qe=Re==="0"?Oe==="0"?">="+Re+"."+Oe+"."+$e+We+" <"+Re+"."+Oe+"."+(+$e+1):">="+Re+"."+Oe+"."+$e+We+" <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+"."+$e+We+" <"+(+Re+1)+".0.0"):(o("no pr"),Qe=Re==="0"?Oe==="0"?">="+Re+"."+Oe+"."+$e+" <"+Re+"."+Oe+"."+(+$e+1):">="+Re+"."+Oe+"."+$e+" <"+Re+"."+(+Oe+1)+".0":">="+Re+"."+Oe+"."+$e+" <"+(+Re+1)+".0.0"),o("caret return",Qe),Qe})}(Ge,rt)}).join(" ")}(qe,Ve),o("caret",qe),qe=function(et,rt){return et.trim().split(/\s+/).map(function(Ge){return function(Xe,fe){var Ie=fe?T[he]:T[ee];return Xe.replace(Ie,function(Te,Re,Oe,$e,We){var Qe;return o("tilde",Xe,Te,Re,Oe,$e,We),Ee(Re)?Qe="":Ee(Oe)?Qe=">="+Re+".0.0 <"+(+Re+1)+".0.0":Ee($e)?Qe=">="+Re+"."+Oe+".0 <"+Re+"."+(+Oe+1)+".0":We?(o("replaceTilde pr",We),We.charAt(0)!=="-"&&(We="-"+We),Qe=">="+Re+"."+Oe+"."+$e+We+" <"+Re+"."+(+Oe+1)+".0"):Qe=">="+Re+"."+Oe+"."+$e+" <"+Re+"."+(+Oe+1)+".0",o("tilde return",Qe),Qe})}(Ge,rt)}).join(" ")}(qe,Ve),o("tildes",qe),qe=function(et,rt){return o("replaceXRanges",et,rt),et.split(/\s+/).map(function(Ge){return function(Xe,fe){Xe=Xe.trim();var Ie=fe?T[w]:T[D];return Xe.replace(Ie,function(Te,Re,Oe,$e,We,Qe){o("xRange",Xe,Te,Re,Oe,$e,We,Qe);var Ye=Ee(Oe),Ke=Ye||Ee($e),tt=Ke||Ee(We);return Re==="="&&tt&&(Re=""),Ye?Te=Re===">"||Re==="<"?"<0.0.0":"*":Re&&tt?(Ke&&($e=0),tt&&(We=0),Re===">"?(Re=">=",Ke?(Oe=+Oe+1,$e=0,We=0):tt&&($e=+$e+1,We=0)):Re==="<="&&(Re="<",Ke?Oe=+Oe+1:$e=+$e+1),Te=Re+Oe+"."+$e+"."+We):Ke?Te=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":tt&&(Te=">="+Oe+"."+$e+".0 <"+Oe+"."+(+$e+1)+".0"),o("xRange return",Te),Te})}(Ge,rt)}).join(" ")}(qe,Ve),o("xrange",qe),qe=function(et,rt){return o("replaceStars",et,rt),et.trim().replace(T[V],"")}(qe,Ve),o("stars",qe),qe}(_e,Se)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(_e){return!!_e.match(Me)})),ze=ze.map(function(_e){return new G(_e,Se)})},ce.prototype.intersects=function(ge,Se){if(!(ge instanceof ce))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Me){return ge.set.some(function(ze){return ze.every(function(_e){return Me.intersects(_e,Se)})})})})},e.toComparators=function(ge,Se){return new ce(ge,Se).set.map(function(ye){return ye.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},ce.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new ie(ge,this.loose));for(var Se=0;Se<this.set.length;Se++)if(ke(this.set[Se],ge))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(ge,Se,ye){var Me=null,ze=null;try{var _e=new ce(Se,ye)}catch{return null}return ge.forEach(function(qe){_e.test(qe)&&(Me&&ze.compare(qe)!==-1||(ze=new ie(Me=qe,ye)))}),Me},e.minSatisfying=function(ge,Se,ye){var Me=null,ze=null;try{var _e=new ce(Se,ye)}catch{return null}return ge.forEach(function(qe){_e.test(qe)&&(Me&&ze.compare(qe)!==1||(ze=new ie(Me=qe,ye)))}),Me},e.validRange=function(ge,Se){try{return new ce(ge,Se).range||"*"}catch{return null}},e.ltr=function(ge,Se,ye){return je(ge,Se,"<",ye)},e.gtr=function(ge,Se,ye){return je(ge,Se,">",ye)},e.outside=je,e.prerelease=function(ge,Se){var ye=Y(ge,Se);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ge,Se,ye){return ge=new ce(ge,ye),Se=new ce(Se,ye),ge.intersects(Se)},e.coerce=function(ge){if(ge instanceof ie)return ge;if(typeof ge!="string")return null;var Se=ge.match(T[S]);return Se==null?null:Y((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,y(1))},function(le,e){var y,L,o=le.exports={};function A(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function T(r){if(y===setTimeout)return setTimeout(r,0);if((y===A||!y)&&setTimeout)return y=setTimeout,setTimeout(r,0);try{return y(r,0)}catch{try{return y.call(null,r,0)}catch{return y.call(this,r,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:A}catch{y=A}try{L=typeof clearTimeout=="function"?clearTimeout:k}catch{L=k}})();var v,m=[],R=!1,E=-1;function b(){R&&v&&(R=!1,v.length?m=v.concat(m):E=-1,m.length&&d())}function d(){if(!R){var r=T(b);R=!0;for(var f=m.length;f;){for(v=m,m=[];++E<f;)v&&v[E].run();E=-1,f=m.length}v=null,R=!1,function(c){if(L===clearTimeout)return clearTimeout(c);if((L===k||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(c);try{L(c)}catch{try{return L.call(null,c)}catch{return L.call(this,c)}}}(r)}}function g(r,f){this.fun=r,this.array=f}function p(){}o.nextTick=function(r){var f=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)f[c-1]=arguments[c];m.push(new g(r,f)),m.length!==1||R||T(d)},g.prototype.run=function(){this.fun.apply(null,this.array)},o.title="browser",o.browser=!0,o.env={},o.argv=[],o.version="",o.versions={},o.on=p,o.addListener=p,o.once=p,o.off=p,o.removeListener=p,o.removeAllListeners=p,o.emit=p,o.prependListener=p,o.prependOnceListener=p,o.listeners=function(r){return[]},o.binding=function(r){throw new Error("process.binding is not supported")},o.cwd=function(){return"/"},o.chdir=function(r){throw new Error("process.chdir is not supported")},o.umask=function(){return 0}}])}),define(pe[143],be([1,0]),function(le,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(T,v,m){this.level=T,this.key=v,this.value=m,this.forward=[]}}const o=void 0;class A{constructor(T,v=2**16){this.comparator=T,this[y]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new L(this.c,o,o)}get size(){return this.f}clear(){this.e=new L(this.c,o,o)}has(T){return!!A.g(this,T,this.comparator)}get(T){return A.g(this,T,this.comparator)?.value}set(T,v){return A.h(this,T,v,this.comparator)&&(this.f+=1),this}delete(T){const v=A.k(this,T,this.comparator);return v&&(this.f-=1),v}forEach(T,v){let m=this.e.forward[0];for(;m;)T.call(v,m.value,m.key,this),m=m.forward[0]}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let T=this.e.forward[0];for(;T;)yield[T.key,T.value],T=T.forward[0]}*keys(){let T=this.e.forward[0];for(;T;)yield T.key,T=T.forward[0]}*values(){let T=this.e.forward[0];for(;T;)yield T.value,T=T.forward[0]}toString(){let T="[SkipList]:",v=this.e.forward[0];for(;v;)T+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return T}static g(T,v,m){let R=T.e;for(let E=T.d-1;E>=0;E--)for(;R.forward[E]&&m(R.forward[E].key,v)<0;)R=R.forward[E];if(R=R.forward[0],R&&m(R.key,v)===0)return R}static h(T,v,m,R){const E=[];let b=T.e;for(let d=T.d-1;d>=0;d--){for(;b.forward[d]&&R(b.forward[d].key,v)<0;)b=b.forward[d];E[d]=b}if(b=b.forward[0],b&&R(b.key,v)===0)return b.value=m,!1;{const d=A.j(T);if(d>T.d){for(let g=T.d;g<d;g++)E[g]=T.e;T.d=d}b=new L(d,v,m);for(let g=0;g<d;g++)b.forward[g]=E[g].forward[g],E[g].forward[g]=b;return!0}}static j(T,v=.5){let m=1;for(;Math.random()<v&&m<T.c;)m+=1;return m}static k(T,v,m){const R=[];let E=T.e;for(let b=T.d-1;b>=0;b--){for(;E.forward[b]&&m(E.forward[b].key,v)<0;)E=E.forward[b];R[b]=E}if(E=E.forward[0],!E||m(E.key,v)!==0)return!1;for(let b=0;b<T.d&&R[b].forward[b]===E;b++)R[b].forward[b]=E.forward[b];for(;T.d>0&&T.e.forward[T.d-1]===o;)T.d-=1;return!0}}e.SkipList=A}),define(pe[97],be([1,0,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=y.globals.performance&&typeof y.globals.performance.now=="function";class o{static create(k=!0){return new o(k)}constructor(k){this.a=L&&k,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?y.globals.performance.now():Date.now()}}e.StopWatch=o}),define(pe[6],be([1,0,9,71,2,95,97]),function(le,e,y,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,v=!1;var m;(function(l){l.None=()=>o.Disposable.None;function h(K){if(v){const{onDidAddListener:te}=K,j=g.create();let W=0;K.onDidAddListener=()=>{++W===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),te?.()}}}function C(K,te){return ue(K,()=>{},0,void 0,!0,void 0,te)}l.defer=C;function D(K){return(te,j=null,W)=>{let x=!1,H;return H=K(Q=>{if(!x)return H?H.dispose():x=!0,te.call(j,Q)},null,W),x&&H.dispose(),H}}l.once=D;function w(K,te,j){return oe((W,x=null,H)=>K(Q=>W.call(x,te(Q)),null,H),j)}l.map=w;function S(K,te,j){return oe((W,x=null,H)=>K(Q=>{te(Q),W.call(x,Q)},null,H),j)}l.forEach=S;function N(K,te,j){return oe((W,x=null,H)=>K(Q=>te(Q)&&W.call(x,Q),null,H),j)}l.filter=N;function $(K){return K}l.signal=$;function ee(...K){return(te,j=null,W)=>(0,o.combinedDisposable)(...K.map(x=>x(H=>te.call(j,H),null,W)))}l.any=ee;function he(K,te,j,W){let x=j;return w(K,H=>(x=te(x,H),x),W)}l.reduce=he;function oe(K,te){let j;const W={onWillAddFirstListener(){j=K(x.fire,x)},onDidRemoveLastListener(){j?.dispose()}};te||h(W);const x=new r(W);return te?.add(x),x.event}function ue(K,te,j=100,W=!1,x=!1,H,Q){let G,Z,ce,Ee=0,Ce;const ke={leakWarningThreshold:H,onWillAddFirstListener(){G=K(je=>{Ee++,Z=te(Z,je),W&&!ce&&(Fe.fire(Z),Z=void 0),Ce=()=>{const ge=Z;Z=void 0,ce=void 0,(!W||Ee>1)&&Fe.fire(ge),Ee=0},typeof j=="number"?(clearTimeout(ce),ce=setTimeout(Ce,j)):ce===void 0&&(ce=0,queueMicrotask(Ce))})},onWillRemoveListener(){x&&Ee>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,G.dispose()}};Q||h(ke);const Fe=new r(ke);return Q?.add(Fe),Fe.event}l.debounce=ue;function me(K,te=0,j){return l.debounce(K,(W,x)=>W?(W.push(x),W):[x],te,void 0,!0,void 0,j)}l.accumulate=me;function _(K,te=(W,x)=>W===x,j){let W=!0,x;return N(K,H=>{const Q=W||!te(H,x);return W=!1,x=H,Q},j)}l.latch=_;function re(K,te,j){return[l.filter(K,te,j),l.filter(K,W=>!te(W),j)]}l.split=re;function q(K,te=!1,j=[]){let W=j.slice(),x=K(G=>{W?W.push(G):Q.fire(G)});const H=()=>{W?.forEach(G=>Q.fire(G)),W=null},Q=new r({onWillAddFirstListener(){x||(x=K(G=>Q.fire(G)))},onDidAddFirstListener(){W&&(te?setTimeout(H):H())},onDidRemoveLastListener(){x&&x.dispose(),x=null}});return Q.event}l.buffer=q;class J{constructor(te){this.event=te,this.c=new o.DisposableStore}map(te){return new J(w(this.event,te,this.c))}forEach(te){return new J(S(this.event,te,this.c))}filter(te){return new J(N(this.event,te,this.c))}reduce(te,j){return new J(he(this.event,te,j,this.c))}latch(){return new J(_(this.event,void 0,this.c))}debounce(te,j=100,W=!1,x=!1,H){return new J(ue(this.event,te,j,W,x,H,this.c))}on(te,j,W){return this.event(te,j,W)}once(te,j,W){return D(this.event)(te,j,W)}dispose(){this.c.dispose()}}function U(K){return new J(K)}l.chain=U;function ne(K,te,j=W=>W){const W=(...G)=>Q.fire(j(...G)),x=()=>K.on(te,W),H=()=>K.removeListener(te,W),Q=new r({onWillAddFirstListener:x,onDidRemoveLastListener:H});return Q.event}l.fromNodeEventEmitter=ne;function V(K,te,j=W=>W){const W=(...G)=>Q.fire(j(...G)),x=()=>K.addEventListener(te,W),H=()=>K.removeEventListener(te,W),Q=new r({onWillAddFirstListener:x,onDidRemoveLastListener:H});return Q.event}l.fromDOMEventEmitter=V;function se(K){return new Promise(te=>D(K)(te))}l.toPromise=se;function Y(K,te){return te(void 0),K(j=>te(j))}l.runAndSubscribe=Y;function ie(K,te){let j=null;function W(H){j?.dispose(),j=new o.DisposableStore,te(H,j)}W(void 0);const x=K(H=>W(H));return(0,o.toDisposable)(()=>{x.dispose(),j?.dispose()})}l.runAndSubscribeWithStore=ie;class z{constructor(te,j){this._observable=te,this.c=0,this.d=!1;const W={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};j||h(W),this.emitter=new r(W),j&&j.add(this.emitter)}beginUpdate(te){this.c++}handlePossibleChange(te){}handleChange(te,j){this.d=!0}endUpdate(te){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function P(K,te){return new z(K,te).emitter.event}l.fromObservable=P;function M(K){return te=>{let j=0,W=!1;const x={beginUpdate(){j++},endUpdate(){j--,j===0&&(K.reportChanges(),W&&(W=!1,te()))},handlePossibleChange(){},handleChange(){W=!0}};return K.addObserver(x),{dispose(){K.removeObserver(x)}}}}l.fromObservableLight=M})(m||(e.Event=m={}));class R{constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${R.c++}`,R.all.add(this)}start(h){this.d=new k.StopWatch(!0),this.listenerCount=h}stop(){if(this.d){const h=this.d.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=R,R.all=new Set,R.c=0;let E=-1;function b(l){const h=E;return E=l,{dispose(){E=h}}}e.setGlobalLeakWarningThreshold=b;class d{constructor(h,C=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=C,this.d=0}dispose(){this.c?.clear()}check(h,C){const D=this.threshold;if(D<=0||C<D)return;this.c||(this.c=new Map);const w=this.c.get(h.value)||0;if(this.c.set(h.value,w+1),this.d-=1,this.d<=0){this.d=D*.5;let S,N=0;for(const[$,ee]of this.c)(!S||N<ee)&&(S=$,N=ee);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${N}):`),console.warn(S)}return()=>{const S=this.c.get(h.value)||0;this.c.set(h.value,S-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(h,C,D){this.callback=h,this.callbackThis=C,this.stack=D,this.subscription=new o.SafeDisposable}invoke(h){this.callback.call(this.callbackThis,h)}}class r{constructor(h){this.j=!1,this.d=h,this.f=E>0||this.d?.leakWarningThreshold?new d(this.d?.leakWarningThreshold??E):void 0,this.g=this.d?._profName?new R(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(T){const h=Array.from(this.q);queueMicrotask(()=>{for(const C of h)C.subscription.isset()&&(C.subscription.unset(),C.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(h,C,D)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),o.Disposable.None;const w=this.q.isEmpty();w&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let S,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=g.create(),S=this.f.check(N,this.q.size+1)),T&&(N=N??g.create());const $=new p(h,C,N),ee=this.q.push($);w&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,h,C);const he=$.subscription.set(()=>{S?.(),this.j||(this.d?.onWillRemoveListener?.(this),ee(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return D instanceof o.DisposableStore?D.add(he):Array.isArray(D)&&D.push(he),he}),this.l}fire(h){if(this.q){this.m||(this.m=new c(this.d?.onListenerError));for(const C of this.q)this.m.push(this,C,h);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=r;class f{constructor(h=y.onUnexpectedError){this.d=h,this.c=new A.LinkedList}get size(){return this.c.size}push(h,C,D){this.c.push(new u(h,C,D))}clear(h){const C=new A.LinkedList;for(const D of this.c)D.emitter!==h&&C.push(D);this.c=C}deliver(){for(;this.c.size>0;){const h=this.c.shift();try{h.listener.invoke(h.event)}catch(C){this.d(C)}}}}e.EventDeliveryQueue=f;class c extends f{clear(h){this.c.clear()}}class u{constructor(h,C,D){this.emitter=h,this.listener=C,this.event=D}}class I extends r{async fireAsync(h,C,D){if(this.q){this.c||(this.c=new A.LinkedList);for(const w of this.q)this.c.push([w,h]);for(;this.c.size>0&&!C.isCancellationRequested;){const[w,S]=this.c.shift(),N=[],$={...S,token:C,waitUntil:ee=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");D&&(ee=D(ee,w.callback)),N.push(ee)}};try{w.invoke($)}catch(ee){(0,y.onUnexpectedError)(ee);continue}Object.freeze(N),await Promise.allSettled(N).then(ee=>{for(const he of ee)he.status==="rejected"&&(0,y.onUnexpectedError)(he.reason)})}}}}e.AsyncEmitter=I;class O extends r{get isPaused(){return this.h!==0}constructor(h){super(h),this.h=0,this.s=new A.LinkedList,this.t=h?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const h=Array.from(this.s);this.s.clear(),super.fire(this.t(h))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(h){this.q&&(this.h!==0?this.s.push(h):super.fire(h))}}e.PauseableEmitter=O;class t extends O{constructor(h){super(h),this.c=h.delay??100}fire(h){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(h)}}e.DebounceEmitter=t;class n extends r{constructor(h){super(h),this.c=[],this.h=h?.merge}fire(h){this.hasListeners()&&(this.c.push(h),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(C=>super.fire(C)),this.c=[]}))}}e.MicrotaskEmitter=n;class s{constructor(){this.d=!1,this.f=[],this.c=new r({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(h){const C={event:h,listener:null};this.f.push(C),this.d&&this.j(C);const D=()=>{this.d&&this.k(C);const w=this.f.indexOf(C);this.f.splice(w,1)};return(0,o.toDisposable)((0,L.once)(D))}g(){this.d=!0,this.f.forEach(h=>this.j(h))}h(){this.d=!1,this.f.forEach(h=>this.k(h))}j(h){h.listener=h.event(C=>this.c.fire(C))}k(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=s;class i{constructor(){this.c=[]}wrapEvent(h){return(C,D,w)=>h(S=>{const N=this.c[this.c.length-1];N?N.push(()=>C.call(D,S)):C.call(D,S)},void 0,w)}bufferEvents(h){const C=[];this.c.push(C);const D=h();return this.c.pop(),C.forEach(w=>w()),D}}e.EventBufferer=i;class a{constructor(){this.c=!1,this.d=m.None,this.f=o.Disposable.None,this.g=new r({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(h){this.d=h,this.c&&(this.f.dispose(),this.f=h(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=a}),define(pe[20],be([1,0,6]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(T,v){const m=setTimeout(T.bind(v),0);return{dispose(){clearTimeout(m)}}});var o;(function(T){function v(m){return m===T.None||m===T.Cancelled||m instanceof A?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}T.isCancellationToken=v,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(o||(e.CancellationToken=o={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new y.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class k{constructor(v){this.a=void 0,this.b=void 0,this.b=v&&v.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=o.Cancelled}dispose(v=!1){v&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=o.None}}e.CancellationTokenSource=k}),define(pe[144],be([1,0,20]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(T){this.b=T,this.a=null}get(){if(this.a)return this.a;const T=new y.CancellationTokenSource,v=this.b(T.token);return this.a={promise:v,dispose:()=>{this.a=null,T.cancel(),T.dispose()}},this.a}}e.Cache=L;class o{constructor(T){this.c=T,this.a=void 0,this.b=void 0}get(T){const v=JSON.stringify(T);return this.b!==v&&(this.b=v,this.a=this.c(T)),this.a}}e.LRUCachedFunction=o;class A{get cachedValues(){return this.a}constructor(T){this.b=T,this.a=new Map}get(T){if(this.a.has(T))return this.a.get(T);const v=this.b(T);return this.a.set(T,v),v}}e.CachedFunction=A}),define(pe[47],be([1,0,9,2]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function o(I){const O=I;return O?typeof O.read=="function":!1}e.isReadable=o;function A(I){const O=I;return O?[O.on,O.pause,O.resume,O.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=A;function k(I){const O=I;return O?A(O.stream)&&Array.isArray(O.buffer)&&typeof O.ended=="boolean":!1}e.isReadableBufferedStream=k;function T(I,O){return new v(I,O)}e.newWriteableStream=T;class v{constructor(O,t){this.e=O,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(O){if(!this.a.destroyed){if(this.a.flowing)this.g(O);else if(this.b.data.push(O),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(O){this.a.destroyed||(this.a.flowing?this.h(O):this.b.error.push(O))}end(O){this.a.destroyed||(typeof O<"u"&&this.write(O),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(O){this.c.data.slice(0).forEach(t=>t(O))}h(O){this.c.error.length===0?(0,y.onUnexpectedError)(O):this.c.error.slice(0).forEach(t=>t(O))}i(){this.c.end.slice(0).forEach(O=>O())}on(O,t){if(!this.a.destroyed)switch(O){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(O,t){if(this.a.destroyed)return;let n;switch(O){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const s=n.indexOf(t);s>=0&&n.splice(s,1)}}j(){if(this.b.data.length>0){const O=this.e(this.b.data);this.g(O),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const O of this.b.error)this.h(O);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(I,O){const t=[];let n;for(;(n=I.read())!==null;)t.push(n);return O(t)}e.consumeReadable=m;function R(I,O,t){const n=[];let s;for(;(s=I.read())!==null&&n.length<t;)n.push(s);return s===null&&n.length>0?O(n):{read:()=>{if(n.length>0)return n.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return I.read()}}}e.peekReadable=R;function E(I,O){return new Promise((t,n)=>{const s=[];b(I,{onData:i=>{O&&s.push(i)},onError:i=>{O?n(i):t(void 0)},onEnd:()=>{t(O?O(s):void 0)}})})}e.consumeStream=E;function b(I,O){let t=!1;return I.on("error",n=>{t||O.onError(n)}),I.on("end",()=>{t||O.onEnd()}),I.on("data",n=>{t||O.onData(n)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=b;function d(I,O){return new Promise((t,n)=>{const s=new L.DisposableStore,i=[],a=C=>{if(i.push(C),i.length>O)return s.dispose(),I.pause(),t({stream:I,buffer:i,ended:!1})},l=C=>n(C),h=()=>t({stream:I,buffer:i,ended:!0});s.add((0,L.toDisposable)(()=>I.removeListener("error",l))),I.on("error",l),s.add((0,L.toDisposable)(()=>I.removeListener("end",h))),I.on("end",h),s.add((0,L.toDisposable)(()=>I.removeListener("data",a))),I.on("data",a)})}e.peekStream=d;function g(I,O){const t=T(O);return t.end(I),t}e.toStream=g;function p(){const I=T(()=>{throw new Error("not supported")});return I.end(),I}e.emptyStream=p;function r(I){let O=!1;return{read:()=>O?null:(O=!0,I)}}e.toReadable=r;function f(I,O,t){const n=T(t);return b(I,{onData:s=>n.write(O.data(s)),onError:s=>n.error(O.error?O.error(s):s),onEnd:()=>n.end()}),n}e.transform=f;function c(I,O,t){let n=!1;return{read:()=>{const s=O.read();return n?s:(n=!0,s!==null?t([I,s]):I)}}}e.prefixedReadable=c;function u(I,O,t){let n=!1;const s=T(t);return b(O,{onData:i=>n?s.write(i):(n=!0,s.write(t([I,i]))),onError:i=>s.error(i),onEnd:()=>{n||(n=!0,s.write(I)),s.end()}}),s}e.prefixedStream=u}),define(pe[15],be([1,0,94,47]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const o=typeof Buffer<"u",A=new y.Lazy(()=>new Uint8Array(256));let k,T;class v{static alloc(w){return o?new v(Buffer.allocUnsafe(w)):new v(new Uint8Array(w))}static wrap(w){return o&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new v(w)}static fromString(w,S){return!(S?.dontUseNodeBuffer||!1)&&o?new v(Buffer.from(w)):(k||(k=new TextEncoder),new v(k.encode(w)))}static fromByteArray(w){const S=v.alloc(w.length);for(let N=0,$=w.length;N<$;N++)S.buffer[N]=w[N];return S}static concat(w,S){if(typeof S>"u"){S=0;for(let ee=0,he=w.length;ee<he;ee++)S+=w[ee].byteLength}const N=v.alloc(S);let $=0;for(let ee=0,he=w.length;ee<he;ee++){const oe=w[ee];N.set(oe,$),$+=oe.byteLength}return N}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=v.alloc(this.byteLength);return w.set(this),w}toString(){return o?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(w,S){return new v(this.buffer.subarray(w,S))}set(w,S){if(w instanceof v)this.buffer.set(w.buffer,S);else if(w instanceof Uint8Array)this.buffer.set(w,S);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),S);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return E(this.buffer,w)}writeUInt32BE(w,S){b(this.buffer,w,S)}readUInt32LE(w){return d(this.buffer,w)}writeUInt32LE(w,S){g(this.buffer,w,S)}readUInt8(w){return p(this.buffer,w)}writeUInt8(w,S){r(this.buffer,w,S)}indexOf(w){const S=w instanceof v?w.buffer:w,N=S.byteLength,$=this.buffer,ee=$.byteLength;if(N===0)return 0;if(N===1)return $.indexOf(S[0]);if(N>ee)return-1;const he=A.value;he.fill(S.length);for(let _=0;_<S.length;_++)he[S[_]]=S.length-_-1;let oe=S.length-1,ue=oe,me=-1;for(;oe<ee;)if($[oe]===S[ue]){if(ue===0){me=oe;break}oe--,ue--}else oe+=Math.max(S.length-ue,he[$[oe]]),ue=S.length-1;return me}}e.VSBuffer=v;function m(D,w){return D[w+0]<<0>>>0|D[w+1]<<8>>>0}e.readUInt16LE=m;function R(D,w,S){D[S+0]=w&255,w=w>>>8,D[S+1]=w&255}e.writeUInt16LE=R;function E(D,w){return D[w]*2**24+D[w+1]*2**16+D[w+2]*2**8+D[w+3]}e.readUInt32BE=E;function b(D,w,S){D[S+3]=w,w=w>>>8,D[S+2]=w,w=w>>>8,D[S+1]=w,w=w>>>8,D[S]=w}e.writeUInt32BE=b;function d(D,w){return D[w+0]<<0>>>0|D[w+1]<<8>>>0|D[w+2]<<16>>>0|D[w+3]<<24>>>0}e.readUInt32LE=d;function g(D,w,S){D[S+0]=w&255,w=w>>>8,D[S+1]=w&255,w=w>>>8,D[S+2]=w&255,w=w>>>8,D[S+3]=w&255}e.writeUInt32LE=g;function p(D,w){return D[w]}e.readUInt8=p;function r(D,w,S){D[S]=w}e.writeUInt8=r;function f(D){return L.consumeReadable(D,w=>v.concat(w))}e.readableToBuffer=f;function c(D){return L.toReadable(D)}e.bufferToReadable=c;function u(D){return L.consumeStream(D,w=>v.concat(w))}e.streamToBuffer=u;async function I(D){return D.ended?v.concat(D.buffer):v.concat([...D.buffer,await u(D.stream)])}e.bufferedStreamToBuffer=I;function O(D){return L.toStream(D,w=>v.concat(w))}e.bufferToStream=O;function t(D){return L.transform(D,{data:w=>typeof w=="string"?v.fromString(w):v.wrap(w)},w=>v.concat(w))}e.streamToBufferReadableStream=t;function n(D){return L.newWriteableStream(w=>v.concat(w),D)}e.newWriteableBufferStream=n;function s(D,w){return L.prefixedReadable(D,w,S=>v.concat(S))}e.prefixedBufferReadable=s;function i(D,w){return L.prefixedStream(D,w,S=>v.concat(S))}e.prefixedBufferStream=i;function a(D){let w=0,S=0,N=0;const $=new Uint8Array(Math.floor(D.length/4*3)),ee=oe=>{switch(S){case 3:$[N++]=w|oe,S=0;break;case 2:$[N++]=w|oe>>>2,w=oe<<6,S=3;break;case 1:$[N++]=w|oe>>>4,w=oe<<4,S=2;break;default:w=oe<<2,S=1}};for(let oe=0;oe<D.length;oe++){const ue=D.charCodeAt(oe);if(ue>=65&&ue<=90)ee(ue-65);else if(ue>=97&&ue<=122)ee(ue-97+26);else if(ue>=48&&ue<=57)ee(ue-48+52);else if(ue===43||ue===45)ee(62);else if(ue===47||ue===95)ee(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${D[oe]}`)}}const he=N;for(;S>0;)ee(0);return v.wrap($).slice(0,he)}e.decodeBase64=a;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:D},w=!0,S=!1){const N=S?h:l;let $="";const ee=D.byteLength%3;let he=0;for(;he<D.byteLength-ee;he+=3){const oe=D[he+0],ue=D[he+1],me=D[he+2];$+=N[oe>>>2],$+=N[(oe<<4|ue>>>4)&63],$+=N[(ue<<2|me>>>6)&63],$+=N[me&63]}if(ee===1){const oe=D[he+0];$+=N[oe>>>2],$+=N[oe<<4&63],w&&($+="==")}else if(ee===2){const oe=D[he+0],ue=D[he+1];$+=N[oe>>>2],$+=N[(oe<<4|ue>>>4)&63],$+=N[ue<<2&63],w&&($+="=")}return $}e.encodeBase64=C}),define(pe[17],be([1,0,144,94]),function(le,e,y,L){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(fe){return!fe||typeof fe!="string"?!0:fe.trim().length===0}e.isFalsyOrWhitespace=A;const k=/{(\d+)}/g;function T(fe,...Ie){return Ie.length===0?fe:fe.replace(k,function(Te,Re){const Oe=parseInt(Re,10);return isNaN(Oe)||Oe<0||Oe>=Ie.length?Te:Ie[Oe]})}e.format=T;const v=/{([^}]+)}/g;function m(fe,Ie){return fe.replace(v,(Te,Re)=>Ie[Re]??Te)}e.format2=m;function R(fe){return fe.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=R;function E(fe){return fe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function b(fe,Ie){let Te=0;const Re=Ie.charCodeAt(0);for(let Oe=fe.length-1;Oe>=0;Oe--)fe.charCodeAt(Oe)===Re&&Te++;return Te}e.count=b;function d(fe,Ie,Te="\u2026"){return fe.length<=Ie?fe:`${fe.substr(0,Ie)}${Te}`}e.truncate=d;function g(fe,Ie=" "){const Te=p(fe,Ie);return r(Te,Ie)}e.trim=g;function p(fe,Ie){if(!fe||!Ie)return fe;const Te=Ie.length;if(Te===0||fe.length===0)return fe;let Re=0;for(;fe.indexOf(Ie,Re)===Re;)Re=Re+Te;return fe.substring(Re)}e.ltrim=p;function r(fe,Ie){if(!fe||!Ie)return fe;const Te=Ie.length,Re=fe.length;if(Te===0||Re===0)return fe;let Oe=Re,$e=-1;for(;$e=fe.lastIndexOf(Ie,Oe-1),!($e===-1||$e+Te!==Oe);){if($e===0)return"";Oe=$e}return fe.substring(0,Oe)}e.rtrim=r;function f(fe){return fe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function c(fe){return fe.replace(/\*/g,"")}e.stripWildcards=c;function u(fe,Ie,Te={}){if(!fe)throw new Error("Cannot create regex from empty string");Ie||(fe=E(fe)),Te.wholeWord&&(/\B/.test(fe.charAt(0))||(fe="\\b"+fe),/\B/.test(fe.charAt(fe.length-1))||(fe=fe+"\\b"));let Re="";return Te.global&&(Re+="g"),Te.matchCase||(Re+="i"),Te.multiline&&(Re+="m"),Te.unicode&&(Re+="u"),new RegExp(fe,Re)}e.createRegExp=u;function I(fe){return fe.source==="^"||fe.source==="^$"||fe.source==="$"||fe.source==="^\\s*$"?!1:!!(fe.exec("")&&fe.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function O(fe){return!!fe.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=O;function t(fe){return(fe.global?"g":"")+(fe.ignoreCase?"i":"")+(fe.multiline?"m":"")+(fe.unicode?"u":"")}e.regExpFlags=t;function n(fe){return fe.split(/\r\n|\r|\n/)}e.splitLines=n;function s(fe){for(let Ie=0,Te=fe.length;Ie<Te;Ie++){const Re=fe.charCodeAt(Ie);if(Re!==32&&Re!==9)return Ie}return-1}e.firstNonWhitespaceIndex=s;function i(fe,Ie=0,Te=fe.length){for(let Re=Ie;Re<Te;Re++){const Oe=fe.charCodeAt(Re);if(Oe!==32&&Oe!==9)return fe.substring(Ie,Re)}return fe.substring(Ie,Te)}e.getLeadingWhitespace=i;function a(fe,Ie=fe.length-1){for(let Te=Ie;Te>=0;Te--){const Re=fe.charCodeAt(Te);if(Re!==32&&Re!==9)return Te}return-1}e.lastNonWhitespaceIndex=a;function l(fe,Ie,Te){const Re=[];let Oe=0;for(const $e of fe.matchAll(Ie)){if(Re.push(fe.slice(Oe,$e.index)),$e.index===void 0)throw new Error("match.index should be defined");Oe=$e.index+$e[0].length,Re.push(Te($e[0],...$e.slice(1),$e.index,fe,$e.groups))}return Re.push(fe.slice(Oe)),Promise.all(Re).then($e=>$e.join(""))}e.replaceAsync=l;function h(fe,Ie){return fe<Ie?-1:fe>Ie?1:0}e.compare=h;function C(fe,Ie,Te=0,Re=fe.length,Oe=0,$e=Ie.length){for(;Te<Re&&Oe<$e;Te++,Oe++){const Ye=fe.charCodeAt(Te),Ke=Ie.charCodeAt(Oe);if(Ye<Ke)return-1;if(Ye>Ke)return 1}const We=Re-Te,Qe=$e-Oe;return We<Qe?-1:We>Qe?1:0}e.compareSubstring=C;function D(fe,Ie){return w(fe,Ie,0,fe.length,0,Ie.length)}e.compareIgnoreCase=D;function w(fe,Ie,Te=0,Re=fe.length,Oe=0,$e=Ie.length){for(;Te<Re&&Oe<$e;Te++,Oe++){let Ye=fe.charCodeAt(Te),Ke=Ie.charCodeAt(Oe);if(Ye===Ke)continue;if(Ye>=128||Ke>=128)return C(fe.toLowerCase(),Ie.toLowerCase(),Te,Re,Oe,$e);N(Ye)&&(Ye-=32),N(Ke)&&(Ke-=32);const tt=Ye-Ke;if(tt!==0)return tt}const We=Re-Te,Qe=$e-Oe;return We<Qe?-1:We>Qe?1:0}e.compareSubstringIgnoreCase=w;function S(fe){return fe>=48&&fe<=57}e.isAsciiDigit=S;function N(fe){return fe>=97&&fe<=122}e.isLowerAsciiLetter=N;function $(fe){return fe>=65&&fe<=90}e.isUpperAsciiLetter=$;function ee(fe,Ie){return fe.length===Ie.length&&w(fe,Ie)===0}e.equalsIgnoreCase=ee;function he(fe,Ie){const Te=Ie.length;return Ie.length>fe.length?!1:w(fe,Ie,0,Te)===0}e.startsWithIgnoreCase=he;function oe(fe,Ie){const Te=Math.min(fe.length,Ie.length);let Re;for(Re=0;Re<Te;Re++)if(fe.charCodeAt(Re)!==Ie.charCodeAt(Re))return Re;return Te}e.commonPrefixLength=oe;function ue(fe,Ie){const Te=Math.min(fe.length,Ie.length);let Re;const Oe=fe.length-1,$e=Ie.length-1;for(Re=0;Re<Te;Re++)if(fe.charCodeAt(Oe-Re)!==Ie.charCodeAt($e-Re))return Re;return Te}e.commonSuffixLength=ue;function me(fe){return 55296<=fe&&fe<=56319}e.isHighSurrogate=me;function _(fe){return 56320<=fe&&fe<=57343}e.isLowSurrogate=_;function re(fe,Ie){return(fe-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=re;function q(fe,Ie,Te){const Re=fe.charCodeAt(Te);if(me(Re)&&Te+1<Ie){const Oe=fe.charCodeAt(Te+1);if(_(Oe))return re(Re,Oe)}return Re}e.getNextCodePoint=q;function J(fe,Ie){const Te=fe.charCodeAt(Ie-1);if(_(Te)&&Ie>1){const Re=fe.charCodeAt(Ie-2);if(me(Re))return re(Re,Te)}return Te}class U{get offset(){return this.e}constructor(Ie,Te=0){this.c=Ie,this.d=Ie.length,this.e=Te}setOffset(Ie){this.e=Ie}prevCodePoint(){const Ie=J(this.c,this.e);return this.e-=Ie>=65536?2:1,Ie}nextCodePoint(){const Ie=q(this.c,this.d,this.e);return this.e+=Ie>=65536?2:1,Ie}eol(){return this.e>=this.d}}e.CodePointIterator=U;class ne{get offset(){return this.c.offset}constructor(Ie,Te=0){this.c=new U(Ie,Te)}nextGraphemeLength(){const Ie=ze.getInstance(),Te=this.c,Re=Te.offset;let Oe=Ie.getGraphemeBreakType(Te.nextCodePoint());for(;!Te.eol();){const $e=Te.offset,We=Ie.getGraphemeBreakType(Te.nextCodePoint());if(ye(Oe,We)){Te.setOffset($e);break}Oe=We}return Te.offset-Re}prevGraphemeLength(){const Ie=ze.getInstance(),Te=this.c,Re=Te.offset;let Oe=Ie.getGraphemeBreakType(Te.prevCodePoint());for(;Te.offset>0;){const $e=Te.offset,We=Ie.getGraphemeBreakType(Te.prevCodePoint());if(ye(We,Oe)){Te.setOffset($e);break}Oe=We}return Re-Te.offset}eol(){return this.c.eol()}}e.GraphemeIterator=ne;function V(fe,Ie){return new ne(fe,Ie).nextGraphemeLength()}e.nextCharLength=V;function se(fe,Ie){return new ne(fe,Ie).prevGraphemeLength()}e.prevCharLength=se;function Y(fe,Ie){Ie>0&&_(fe.charCodeAt(Ie))&&Ie--;const Te=Ie+V(fe,Ie);return[Te-se(fe,Te),Te]}e.getCharContainingOffset=Y;function ie(fe){const Ie=new ne(fe);let Te=0;for(;!Ie.eol();)Te++,Ie.nextGraphemeLength();return Te}e.charCount=ie;let z;function P(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(fe){return z||(z=P()),z.test(fe)}e.containsRTL=M;const K=/^[\t\n\r\x20-\x7E]*$/;function te(fe){return K.test(fe)}e.isBasicASCII=te,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(fe){return e.UNUSUAL_LINE_TERMINATORS.test(fe)}e.containsUnusualLineTerminators=j;function W(fe){return fe>=11904&&fe<=55215||fe>=63744&&fe<=64255||fe>=65281&&fe<=65374}e.isFullWidthCharacter=W;function x(fe){return fe>=127462&&fe<=127487||fe===8986||fe===8987||fe===9200||fe===9203||fe>=9728&&fe<=10175||fe===11088||fe===11093||fe>=127744&&fe<=128591||fe>=128640&&fe<=128764||fe>=128992&&fe<=129008||fe>=129280&&fe<=129535||fe>=129648&&fe<=129782}e.isEmojiImprecise=x;function H(fe,Ie){if(fe.length<Ie)return fe;const Te=/\b/g;let Re=0;for(;Te.test(fe)&&!(fe.length-Te.lastIndex<Ie);)Re=Te.lastIndex,Te.lastIndex+=1;return fe.substring(Re).replace(/^\s/,"")}e.lcut=H;const Q=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,G=/\x1b\].*?\x07/g;function Z(fe){return fe&&(fe=fe.replace(Q,"").replace(G,"")),fe}e.removeAnsiEscapeCodes=Z,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(fe){return!!(fe&&fe.length>0&&fe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function Ee(fe){return ce(fe)?fe.substr(1):fe}e.stripUTF8BOM=Ee;function Ce(fe,Ie){if(!fe||!Ie||fe.length<Ie.length)return!1;const Te=Ie.length,Re=fe.toLowerCase();let Oe=0,$e=-1;for(;Oe<Te;){const We=Re.indexOf(Ie[Oe],$e+1);if(We<0)return!1;$e=We,Oe++}return!0}e.fuzzyContains=Ce;function ke(fe,Ie=!1){return fe?(Ie&&(fe=fe.replace(/\\./g,"")),fe.toLowerCase()!==fe):!1}e.containsUppercaseCharacter=ke;function Fe(fe){return fe.charAt(0).toUpperCase()+fe.slice(1)}e.uppercaseFirstLetter=Fe;function je(fe,Ie=1){if(Ie===0)return"";let Te=-1;do Te=fe.indexOf(`
`,Te+1),Ie--;while(Ie>0&&Te>=0);return Te===-1?fe:(fe[Te-1]==="\r"&&Te--,fe.substr(0,Te))}e.getNLines=je;function ge(fe){return fe=fe%(2*26),fe<26?String.fromCharCode(97+fe):String.fromCharCode(65+fe-26)}e.singleLetterHash=ge;function Se(fe){return ze.getInstance().getGraphemeBreakType(fe)}e.getGraphemeBreakType=Se;function ye(fe,Ie){return fe===0?Ie!==5&&Ie!==7:fe===2&&Ie===3?!1:fe===4||fe===2||fe===3||Ie===4||Ie===2||Ie===3?!0:!(fe===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(fe===11||fe===9)&&(Ie===9||Ie===10)||(fe===12||fe===10)&&Ie===10||Ie===5||Ie===13||Ie===7||fe===1||fe===13&&Ie===14||fe===6&&Ie===6)}var Me;(function(fe){fe[fe.Other=0]="Other",fe[fe.Prepend=1]="Prepend",fe[fe.CR=2]="CR",fe[fe.LF=3]="LF",fe[fe.Control=4]="Control",fe[fe.Extend=5]="Extend",fe[fe.Regional_Indicator=6]="Regional_Indicator",fe[fe.SpacingMark=7]="SpacingMark",fe[fe.L=8]="L",fe[fe.V=9]="V",fe[fe.T=10]="T",fe[fe.LV=11]="LV",fe[fe.LVT=12]="LVT",fe[fe.ZWJ=13]="ZWJ",fe[fe.Extended_Pictographic=14]="Extended_Pictographic"})(Me||(e.GraphemeBreakType=Me={}));class ze{static getInstance(){return ze.c||(ze.c=new ze),ze.c}constructor(){this.d=_e()}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Te=this.d,Re=Te.length/3;let Oe=1;for(;Oe<=Re;)if(Ie<Te[3*Oe])Oe=2*Oe;else if(Ie>Te[3*Oe+1])Oe=2*Oe+1;else return Te[3*Oe+2];return 0}}ze.c=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(fe,Ie){if(fe===0)return 0;const Te=Ve(fe,Ie);if(Te!==void 0)return Te;const Re=new U(Ie,fe);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=qe;function Ve(fe,Ie){const Te=new U(Ie,fe);let Re=Te.prevCodePoint();for(;et(Re)||Re===65039||Re===8419;){if(Te.offset===0)return;Re=Te.prevCodePoint()}if(!x(Re))return;let Oe=Te.offset;return Oe>0&&Te.prevCodePoint()===8205&&(Oe=Te.offset),Oe}function et(fe){return 127995<=fe&&fe<=127999}var rt;(function(fe){fe[fe.zwj=8205]="zwj",fe[fe.emojiVariantSelector=65039]="emojiVariantSelector",fe[fe.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.noBreakWhitespace="\xA0";class Ge{static getInstance(Ie){return Ge.d.get(Array.from(Ie))}static getLocales(){return Ge.e.value}constructor(Ie){this.f=Ie}isAmbiguous(Ie){return this.f.has(Ie)}getPrimaryConfusable(Ie){return this.f.get(Ie)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=Ge,o=Ge,Ge.c=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ge.d=new y.LRUCachedFunction(fe=>{function Ie(Ke){const tt=new Map;for(let it=0;it<Ke.length;it+=2)tt.set(Ke[it],Ke[it+1]);return tt}function Te(Ke,tt){const it=new Map(Ke);for(const[ut,Et]of tt)it.set(ut,Et);return it}function Re(Ke,tt){if(!Ke)return tt;const it=new Map;for(const[ut,Et]of Ke)tt.has(ut)&&it.set(ut,Et);return it}const Oe=o.c.value;let $e=fe.filter(Ke=>!Ke.startsWith("_")&&Ke in Oe);$e.length===0&&($e=["_default"]);let We;for(const Ke of $e){const tt=Ie(Oe[Ke]);We=Re(We,tt)}const Qe=Ie(Oe._common),Ye=Te(Qe,We);return new Ge(Ye)}),Ge.e=new L.Lazy(()=>Object.keys(Ge.c.value).filter(fe=>!fe.startsWith("_")));class Xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Xe.c())),this.d}static isInvisibleCharacter(Ie){return Xe.e().has(Ie)}static get codePoints(){return Xe.e()}}e.InvisibleCharacters=Xe,Xe.d=void 0}),define(pe[145],be([1,0,28,17]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function o(...G){return function(Z,ce){for(let Ee=0,Ce=G.length;Ee<Ce;Ee++){const ke=G[Ee](Z,ce);if(ke)return ke}return null}}e.or=o,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(G,Z,ce){if(!ce||ce.length<Z.length)return null;let Ee;return G?Ee=L.startsWithIgnoreCase(ce,Z):Ee=ce.indexOf(Z)===0,Ee?Z.length>0?[{start:0,end:Z.length}]:[]:null}function k(G,Z){const ce=Z.toLowerCase().indexOf(G.toLowerCase());return ce===-1?null:[{start:ce,end:ce+G.length}]}e.matchesContiguousSubString=k;function T(G,Z){return v(G.toLowerCase(),Z.toLowerCase(),0,0)}e.matchesSubString=T;function v(G,Z,ce,Ee){if(ce===G.length)return[];if(Ee===Z.length)return null;if(G[ce]===Z[Ee]){let Ce=null;return(Ce=v(G,Z,ce+1,Ee+1))?f({start:Ee,end:Ee+1},Ce):null}return v(G,Z,ce,Ee+1)}function m(G){return 97<=G&&G<=122}function R(G){return 65<=G&&G<=90}e.isUpper=R;function E(G){return 48<=G&&G<=57}function b(G){return G===32||G===9||G===10||G===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>d.add(G.charCodeAt(0)));function g(G){return b(G)||d.has(G)}function p(G,Z){return G===Z||g(G)&&g(Z)}function r(G){return m(G)||R(G)||E(G)}function f(G,Z){return Z.length===0?Z=[G]:G.end===Z[0].start?Z[0].start=G.start:Z.unshift(G),Z}function c(G,Z){for(let ce=Z;ce<G.length;ce++){const Ee=G.charCodeAt(ce);if(R(Ee)||E(Ee)||ce>0&&!r(G.charCodeAt(ce-1)))return ce}return G.length}function u(G,Z,ce,Ee){if(ce===G.length)return[];if(Ee===Z.length)return null;if(G[ce]!==Z[Ee].toLowerCase())return null;{let Ce=null,ke=Ee+1;for(Ce=u(G,Z,ce+1,Ee+1);!Ce&&(ke=c(Z,ke))<Z.length;)Ce=u(G,Z,ce+1,ke),ke++;return Ce===null?null:f({start:Ee,end:Ee+1},Ce)}}function I(G){let Z=0,ce=0,Ee=0,Ce=0,ke=0;for(let ye=0;ye<G.length;ye++)ke=G.charCodeAt(ye),R(ke)&&Z++,m(ke)&&ce++,r(ke)&&Ee++,E(ke)&&Ce++;const Fe=Z/G.length,je=ce/G.length,ge=Ee/G.length,Se=Ce/G.length;return{upperPercent:Fe,lowerPercent:je,alphaPercent:ge,numericPercent:Se}}function O(G){const{upperPercent:Z,lowerPercent:ce}=G;return ce===0&&Z>.6}function t(G){const{upperPercent:Z,lowerPercent:ce,alphaPercent:Ee,numericPercent:Ce}=G;return ce>.2&&Z<.8&&Ee>.6&&Ce<.2}function n(G){let Z=0,ce=0,Ee=0,Ce=0;for(let ke=0;ke<G.length;ke++)Ee=G.charCodeAt(ke),R(Ee)&&Z++,m(Ee)&&ce++,b(Ee)&&Ce++;return(Z===0||ce===0)&&Ce===0?G.length<=30:Z<=5}function s(G,Z){if(!Z||(Z=Z.trim(),Z.length===0)||!n(G)||Z.length>60)return null;const ce=I(Z);if(!t(ce)){if(!O(ce))return null;Z=Z.toLowerCase()}let Ee=null,Ce=0;for(G=G.toLowerCase();Ce<Z.length&&(Ee=u(G,Z,0,Ce))===null;)Ce=c(Z,Ce+1);return Ee}e.matchesCamelCase=s;function i(G,Z,ce=!1){if(!Z||Z.length===0)return null;let Ee=null,Ce=0;for(G=G.toLowerCase(),Z=Z.toLowerCase();Ce<Z.length&&(Ee=a(G,Z,0,Ce,ce))===null;)Ce=l(Z,Ce+1);return Ee}e.matchesWords=i;function a(G,Z,ce,Ee,Ce){if(ce===G.length)return[];if(Ee===Z.length)return null;if(p(G.charCodeAt(ce),Z.charCodeAt(Ee))){let ke=null,Fe=Ee+1;if(ke=a(G,Z,ce+1,Ee+1,Ce),!Ce)for(;!ke&&(Fe=l(Z,Fe))<Z.length;)ke=a(G,Z,ce+1,Fe,Ce),Fe++;return ke?G.charCodeAt(ce)!==Z.charCodeAt(Ee)?ke:f({start:Ee,end:Ee+1},ke):null}else return null}function l(G,Z){for(let ce=Z;ce<G.length;ce++)if(g(G.charCodeAt(ce))||ce>0&&g(G.charCodeAt(ce-1)))return ce;return G.length}const h=o(e.matchesPrefix,s,k),C=o(e.matchesPrefix,s,T),D=new y.LRUCache(1e4);function w(G,Z,ce=!1){if(typeof G!="string"||typeof Z!="string")return null;let Ee=D.get(G);Ee||(Ee=new RegExp(L.convertSimple2RegExpPattern(G),"i"),D.set(G,Ee));const Ce=Ee.exec(Z);return Ce?[{start:Ce.index,end:Ce.index+Ce[0].length}]:ce?C(G,Z):h(G,Z)}e.matchesFuzzy=w;function S(G,Z){const ce=K(G,G.toLowerCase(),0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ce?$(ce):null}e.matchesFuzzy2=S;function N(G,Z,ce,Ee,Ce,ke){const Fe=Math.min(13,G.length);for(;ce<Fe;ce++){const je=K(G,Z,ce,Ee,Ce,ke,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(je)return je}return[0,ke]}e.anyScore=N;function $(G){if(typeof G>"u")return[];const Z=[],ce=G[1];for(let Ee=G.length-1;Ee>1;Ee--){const Ce=G[Ee]+ce,ke=Z[Z.length-1];ke&&ke.end===Ce?ke.end=Ce+1:Z.push({start:Ce,end:Ce+1})}return Z}e.createMatches=$;const ee=128;function he(){const G=[],Z=[];for(let ce=0;ce<=ee;ce++)Z[ce]=0;for(let ce=0;ce<=ee;ce++)G.push(Z.slice(0));return G}function oe(G){const Z=[];for(let ce=0;ce<=G;ce++)Z[ce]=0;return Z}const ue=oe(2*ee),me=oe(2*ee),_=he(),re=he(),q=he(),J=!1;function U(G,Z,ce,Ee,Ce){function ke(je,ge,Se=" "){for(;je.length<ge;)je=Se+je;return je}let Fe=` |   |${Ee.split("").map(je=>ke(je,3)).join("|")}
`;for(let je=0;je<=ce;je++)je===0?Fe+=" |":Fe+=`${Z[je-1]}|`,Fe+=G[je].slice(0,Ce+1).map(ge=>ke(ge.toString(),3)).join("|")+`
`;return Fe}function ne(G,Z,ce,Ee){G=G.substr(Z),ce=ce.substr(Ee),console.log(U(re,G,G.length,ce,ce.length)),console.log(U(q,G,G.length,ce,ce.length)),console.log(U(_,G,G.length,ce,ce.length))}function V(G,Z){if(Z<0||Z>=G.length)return!1;const ce=G.codePointAt(Z);switch(ce){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ce)}}function se(G,Z){if(Z<0||Z>=G.length)return!1;switch(G.charCodeAt(Z)){case 32:case 9:return!0;default:return!1}}function Y(G,Z,ce){return Z[G]!==ce[G]}function ie(G,Z,ce,Ee,Ce,ke,Fe=!1){for(;Z<ce&&Ce<ke;)G[Z]===Ee[Ce]&&(Fe&&(ue[Z]=Ce),Z+=1),Ce+=1;return Z===ce}e.isPatternInWord=ie;var z;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(z||(z={}));var P;(function(G){G.Default=[-100,0];function Z(ce){return!ce||ce.length===2&&ce[0]===-100&&ce[1]===0}G.isDefault=Z})(P||(e.FuzzyScore=P={}));class M{constructor(Z,ce){this.firstMatchCanBeWeak=Z,this.boostFullMatch=ce}}e.FuzzyScoreOptions=M,M.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function K(G,Z,ce,Ee,Ce,ke,Fe=M.default){const je=G.length>ee?ee:G.length,ge=Ee.length>ee?ee:Ee.length;if(ce>=je||ke>=ge||je-ce>ge-ke||!ie(Z,ce,je,Ce,ke,ge,!0))return;te(je,ge,ce,ke,Z,Ce);let Se=1,ye=1,Me=ce,ze=ke;const _e=[!1];for(Se=1,Me=ce;Me<je;Se++,Me++){const Ge=ue[Me],Xe=me[Me],fe=Me+1<je?me[Me+1]:ge;for(ye=Ge-ke+1,ze=Ge;ze<fe;ye++,ze++){let Ie=Number.MIN_SAFE_INTEGER,Te=!1;ze<=Xe&&(Ie=j(G,Z,Me,ce,Ee,Ce,ze,ge,ke,_[Se-1][ye-1]===0,_e));let Re=0;Ie!==Number.MAX_SAFE_INTEGER&&(Te=!0,Re=Ie+re[Se-1][ye-1]);const Oe=ze>Ge,$e=Oe?re[Se][ye-1]+(_[Se][ye-1]>0?-5:0):0,We=ze>Ge+1&&_[Se][ye-1]>0,Qe=We?re[Se][ye-2]+(_[Se][ye-2]>0?-5:0):0;if(We&&(!Oe||Qe>=$e)&&(!Te||Qe>=Re))re[Se][ye]=Qe,q[Se][ye]=3,_[Se][ye]=0;else if(Oe&&(!Te||$e>=Re))re[Se][ye]=$e,q[Se][ye]=2,_[Se][ye]=0;else if(Te)re[Se][ye]=Re,q[Se][ye]=1,_[Se][ye]=_[Se-1][ye-1]+1;else throw new Error("not possible")}}if(J&&ne(G,ce,Ee,ke),!_e[0]&&!Fe.firstMatchCanBeWeak)return;Se--,ye--;const qe=[re[Se][ye],ke];let Ve=0,et=0;for(;Se>=1;){let Ge=ye;do{const Xe=q[Se][Ge];if(Xe===3)Ge=Ge-2;else if(Xe===2)Ge=Ge-1;else break}while(Ge>=1);Ve>1&&Z[ce+Se-1]===Ce[ke+ye-1]&&!Y(Ge+ke-1,Ee,Ce)&&Ve+1>_[Se][Ge]&&(Ge=ye),Ge===ye?Ve++:Ve=1,et||(et=Ge),Se--,ye=Ge-1,qe.push(ye)}ge===je&&Fe.boostFullMatch&&(qe[0]+=2);const rt=et-je;return qe[0]-=rt,qe}e.fuzzyScore=K;function te(G,Z,ce,Ee,Ce,ke){let Fe=G-1,je=Z-1;for(;Fe>=ce&&je>=Ee;)Ce[Fe]===ke[je]&&(me[Fe]=je,Fe--),je--}function j(G,Z,ce,Ee,Ce,ke,Fe,je,ge,Se,ye){if(Z[ce]!==ke[Fe])return Number.MIN_SAFE_INTEGER;let Me=1,ze=!1;return Fe===ce-Ee?Me=G[ce]===Ce[Fe]?7:5:Y(Fe,Ce,ke)&&(Fe===0||!Y(Fe-1,Ce,ke))?(Me=G[ce]===Ce[Fe]?7:5,ze=!0):V(ke,Fe)&&(Fe===0||!V(ke,Fe-1))?Me=5:(V(ke,Fe-1)||se(ke,Fe-1))&&(Me=5,ze=!0),Me>1&&ce===Ee&&(ye[0]=!0),ze||(ze=Y(Fe,Ce,ke)||V(ke,Fe-1)||se(ke,Fe-1)),ce===Ee?Fe>ge&&(Me-=ze?3:5):Se?Me+=ze?2:0:Me+=ze?0:1,Fe+1===je&&(Me-=ze?3:5),Me}function W(G,Z,ce,Ee,Ce,ke,Fe){return H(G,Z,ce,Ee,Ce,ke,!0,Fe)}e.fuzzyScoreGracefulAggressive=W;function x(G,Z,ce,Ee,Ce,ke,Fe){return H(G,Z,ce,Ee,Ce,ke,!1,Fe)}e.fuzzyScoreGraceful=x;function H(G,Z,ce,Ee,Ce,ke,Fe,je){let ge=K(G,Z,ce,Ee,Ce,ke,je);if(ge&&!Fe)return ge;if(G.length>=3){const Se=Math.min(7,G.length-1);for(let ye=ce+1;ye<Se;ye++){const Me=Q(G,ye);if(Me){const ze=K(Me,Me.toLowerCase(),ce,Ee,Ce,ke,je);ze&&(ze[0]-=3,(!ge||ze[0]>ge[0])&&(ge=ze))}}}return ge}function Q(G,Z){if(Z+1>=G.length)return;const ce=G[Z],Ee=G[Z+1];if(ce!==Ee)return G.slice(0,Z)+Ee+ce+G.slice(Z+2)}}),define(pe[73],be([1,0,17]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(f){return o(f,0)}e.hash=L;function o(f,c){switch(typeof f){case"object":return f===null?A(349,c):Array.isArray(f)?v(f,c):m(f,c);case"string":return T(f,c);case"boolean":return k(f,c);case"number":return A(f,c);case"undefined":return A(937,c);default:return A(617,c)}}e.doHash=o;function A(f,c){return(c<<5)-c+f|0}e.numberHash=A;function k(f,c){return A(f?433:863,c)}function T(f,c){c=A(149417,c);for(let u=0,I=f.length;u<I;u++)c=A(f.charCodeAt(u),c);return c}e.stringHash=T;function v(f,c){return c=A(104579,c),f.reduce((u,I)=>o(I,u),c)}function m(f,c){return c=A(181387,c),Object.keys(f).sort().reduce((u,I)=>(u=T(I,u),o(f[I],u)),c)}class R{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=o(c,this.g),this.g}}e.Hasher=R;var E;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function b(f,c,u=32){const I=u-c,O=~((1<<I)-1);return(f<<c|(O&f)>>>I)>>>0}function d(f,c=0,u=f.byteLength,I=0){for(let O=0;O<u;O++)f[c+O]=I}function g(f,c,u="0"){for(;f.length<c;)f=u+f;return f}function p(f,c=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(u=>u.toString(16).padStart(2,"0")).join(""):g((f>>>0).toString(16),c/4)}e.toHexString=p;class r{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const u=c.length;if(u===0)return;const I=this.p;let O=this.r,t=this.u,n,s;for(t!==0?(n=t,s=-1,t=0):(n=c.charCodeAt(0),s=0);;){let i=n;if(y.isHighSurrogate(n))if(s+1<u){const a=c.charCodeAt(s+1);y.isLowSurrogate(a)?(s++,i=y.computeCodePoint(n,a)):i=65533}else{t=n;break}else y.isLowSurrogate(n)&&(i=65533);if(O=this.w(I,O,i),s++,s<u)n=c.charCodeAt(s);else break}this.r=O,this.u=t}w(c,u,I){return I<128?c[u++]=I:I<2048?(c[u++]=192|(I&1984)>>>6,c[u++]=128|(I&63)>>>0):I<65536?(c[u++]=224|(I&61440)>>>12,c[u++]=128|(I&4032)>>>6,c[u++]=128|(I&63)>>>0):(c[u++]=240|(I&1835008)>>>18,c[u++]=128|(I&258048)>>>12,c[u++]=128|(I&4032)>>>6,c[u++]=128|(I&63)>>>0),u>=64&&(this.y(),u-=64,this.t+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),u}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=r.g,u=this.q;for(let h=0;h<64;h+=4)c.setUint32(h,u.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)c.setUint32(h,b(c.getUint32(h-12,!1)^c.getUint32(h-32,!1)^c.getUint32(h-56,!1)^c.getUint32(h-64,!1),1),!1);let I=this.h,O=this.l,t=this.m,n=this.n,s=this.o,i,a,l;for(let h=0;h<80;h++)h<20?(i=O&t|~O&n,a=1518500249):h<40?(i=O^t^n,a=1859775393):h<60?(i=O&t|O&n|t&n,a=2400959708):(i=O^t^n,a=3395469782),l=b(I,5)+i+s+a+c.getUint32(h*4,!1)&4294967295,s=n,n=t,t=b(O,30),O=I,I=l;this.h=this.h+I&4294967295,this.l=this.l+O&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+s&4294967295}}e.StringSHA1=r,r.g=new DataView(new ArrayBuffer(320))}),define(pe[60],be([1,0,17]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(o){o[o.Ignore=0]="Ignore",o[o.Info=1]="Info",o[o.Warning=2]="Warning",o[o.Error=3]="Error"})(L||(L={})),function(o){const A="error",k="warning",T="warn",v="info",m="ignore";function R(b){return b?y.equalsIgnoreCase(A,b)?o.Error:y.equalsIgnoreCase(k,b)||y.equalsIgnoreCase(T,b)?o.Warning:y.equalsIgnoreCase(v,b)?o.Info:o.Ignore:o.Ignore}o.fromValue=R;function E(b){switch(b){case o.Error:return A;case o.Warning:return k;case o.Info:return v;default:return m}}o.toString=E}(L||(L={})),e.default=L}),define(pe[146],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(pe[61],be([1,0,18,17]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class o{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const g=d.charCodeAt(0),p=this.b.charCodeAt(this.c);return g-p}value(){return this.b[this.c]}}e.StringIterator=o;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,L.compareSubstring)(d,this.b,0,d.length,this.c,this.d):(0,L.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class k{constructor(d=!0,g=!0){this.f=d,this.g=g}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let g=d.length-1;g>=0;g--,this.c--){const p=this.b.charCodeAt(g);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,L.compareSubstring)(d,this.b,0,d.length,this.d,this.e):(0,L.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=k;var T;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(T||(T={}));class v{constructor(d,g){this.f=d,this.g=g,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new k(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,L.compareIgnoreCase)(d,this.c.scheme);if(this.d[this.e]===2)return(0,L.compareIgnoreCase)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,L.compare)(d,this.c.query);if(this.d[this.e]===5)return(0,L.compare)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=v;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(R||(R={}));class E{static forUris(d=()=>!1,g=()=>!1){return new E(new v(d,g))}static forPaths(d=!1){return new E(new k(void 0,!d))}static forStrings(){return new E(new o)}static forConfigKeys(){return new E(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,g){if(g){const p=g.slice(0);(0,y.shuffle)(p);for(const r of p)this.set(r,d)}else{const p=d.slice(0);(0,y.shuffle)(p);for(const r of p)this.set(r[0],r[1])}}set(d,g){const p=this.b.reset(d);let r;this.c||(this.c=new m,this.c.segment=p.value());const f=[];for(r=this.c;;){const u=p.cmp(r.segment);if(u>0)r.left||(r.left=new m,r.left.segment=p.value()),f.push([-1,r]),r=r.left;else if(u<0)r.right||(r.right=new m,r.right.segment=p.value()),f.push([1,r]),r=r.right;else if(p.hasNext())p.next(),r.mid||(r.mid=new m,r.mid.segment=p.value()),f.push([0,r]),r=r.mid;else break}const c=r.value;r.value=g,r.key=d;for(let u=f.length-1;u>=0;u--){const I=f[u][1];I.updateHeight();const O=I.balanceFactor();if(O<-1||O>1){const t=f[u][0],n=f[u+1][0];if(t===1&&n===1)f[u][1]=I.rotateLeft();else if(t===-1&&n===-1)f[u][1]=I.rotateRight();else if(t===1&&n===-1)I.right=f[u+1][1]=f[u+1][1].rotateRight(),f[u][1]=I.rotateLeft();else if(t===-1&&n===1)I.left=f[u+1][1]=f[u+1][1].rotateLeft(),f[u][1]=I.rotateRight();else throw new Error;if(u>0)switch(f[u-1][0]){case-1:f[u-1][1].left=f[u][1];break;case 1:f[u-1][1].right=f[u][1];break;case 0:f[u-1][1].mid=f[u][1];break}else this.c=f[0][1]}}return c}get(d){return this.d(d)?.value}d(d){const g=this.b.reset(d);let p=this.c;for(;p;){const r=g.cmp(p.segment);if(r>0)p=p.left;else if(r<0)p=p.right;else if(g.hasNext())g.next(),p=p.mid;else break}return p}has(d){const g=this.d(d);return!(g?.value===void 0&&g?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,g){const p=this.b.reset(d),r=[];let f=this.c;for(;f;){const c=p.cmp(f.segment);if(c>0)r.push([-1,f]),f=f.left;else if(c<0)r.push([1,f]),f=f.right;else if(p.hasNext())p.next(),r.push([0,f]),f=f.mid;else break}if(f){if(g?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const c=this.f(f.right);if(c.key){const{key:u,value:I,segment:O}=c;this.e(c.key,!1),f.key=u,f.value=I,f.segment=O}}else{const c=f.left??f.right;if(r.length>0){const[u,I]=r[r.length-1];switch(u){case-1:I.left=c;break;case 0:I.mid=c;break;case 1:I.right=c;break}}else this.c=c}for(let c=r.length-1;c>=0;c--){const u=r[c][1];u.updateHeight();const I=u.balanceFactor();if(I>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),r[c][1]=u.rotateLeft()):I<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),r[c][1]=u.rotateRight()),c>0)switch(r[c-1][0]){case-1:r[c-1][1].left=r[c][1];break;case 1:r[c-1][1].right=r[c][1];break;case 0:r[c-1][1].mid=r[c][1];break}else this.c=r[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const g=this.b.reset(d);let p=this.c,r;for(;p;){const f=g.cmp(p.segment);if(f>0)p=p.left;else if(f<0)p=p.right;else if(g.hasNext())g.next(),r=p.value||r,p=p.mid;else break}return p&&p.value||r}findSuperstr(d){return this.g(d,!1)}g(d,g){const p=this.b.reset(d);let r=this.c;for(;r;){const f=p.cmp(r.segment);if(f>0)r=r.left;else if(f<0)r=r.right;else if(p.hasNext())p.next(),r=r.mid;else return r.mid?this.h(r.mid):g?r.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[g,p]of this)d(p,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const g=[];return this.j(d,g),g[Symbol.iterator]()}j(d,g){d&&(d.left&&this.j(d.left,g),d.value&&g.push([d.key,d.value]),d.mid&&this.j(d.mid,g),d.right&&this.j(d.right,g))}_isBalanced(){const d=g=>{if(!g)return!0;const p=g.balanceFactor();return p<-1||p>1?!1:d(g.left)&&d(g.right)};return d(this.c)}}e.TernarySearchTree=E}),define(pe[8],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function y(n){return typeof n=="string"}e.isString=y;function L(n){return Array.isArray(n)&&n.every(s=>y(s))}e.isStringArray=L;function o(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=o;function A(n){const s=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof s}e.isTypedArray=A;function k(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=k;function T(n){return!!n&&typeof n[Symbol.iterator]=="function"}e.isIterable=T;function v(n){return n===!0||n===!1}e.isBoolean=v;function m(n){return typeof n>"u"}e.isUndefined=m;function R(n){return!E(n)}e.isDefined=R;function E(n){return m(n)||n===null}e.isUndefinedOrNull=E;function b(n,s){if(!n)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=b;function d(n){if(E(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=d;function g(...n){const s=[];for(let i=0;i<n.length;i++){const a=n[i];if(E(a))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);s.push(a)}return s}e.assertAllDefined=g;const p=Object.prototype.hasOwnProperty;function r(n){if(!o(n))return!1;for(const s in n)if(p.call(n,s))return!1;return!0}e.isEmptyObject=r;function f(n){return typeof n=="function"}e.isFunction=f;function c(...n){return n.length>0&&n.every(f)}e.areFunctions=c;function u(n,s){const i=Math.min(n.length,s.length);for(let a=0;a<i;a++)I(n[a],s[a])}e.validateConstraints=u;function I(n,s){if(y(s)){if(typeof n!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(f(s)){try{if(n instanceof s)return}catch{}if(!E(n)&&n.constructor===s||s.length===1&&s.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=I;function O(n){return n===null?void 0:n}e.withNullAsUndefined=O;function t(n){return typeof n>"u"?null:n}e.withUndefinedAsNull=t}),define(pe[48],be([1,0,8]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function o(T,v){if((0,y.isString)(v)){const m=L[v];if(m===void 0)throw new Error(`${T} references an unknown codicon: ${v}`);v=m}return L[T]=v,{id:T}}function A(){return L}e.getCodiconFontCharacters=A;function k(){return Object.values(e.Codicon)}e.getAllCodicons=k,e.Codicon={add:o("add",6e4),plus:o("plus",6e4),gistNew:o("gist-new",6e4),repoCreate:o("repo-create",6e4),lightbulb:o("lightbulb",60001),lightBulb:o("light-bulb",60001),repo:o("repo",60002),repoDelete:o("repo-delete",60002),gistFork:o("gist-fork",60003),repoForked:o("repo-forked",60003),gitPullRequest:o("git-pull-request",60004),gitPullRequestAbandoned:o("git-pull-request-abandoned",60004),recordKeys:o("record-keys",60005),keyboard:o("keyboard",60005),tag:o("tag",60006),tagAdd:o("tag-add",60006),tagRemove:o("tag-remove",60006),person:o("person",60007),personFollow:o("person-follow",60007),personOutline:o("person-outline",60007),personFilled:o("person-filled",60007),gitBranch:o("git-branch",60008),gitBranchCreate:o("git-branch-create",60008),gitBranchDelete:o("git-branch-delete",60008),sourceControl:o("source-control",60008),mirror:o("mirror",60009),mirrorPublic:o("mirror-public",60009),star:o("star",60010),starAdd:o("star-add",60010),starDelete:o("star-delete",60010),starEmpty:o("star-empty",60010),comment:o("comment",60011),commentAdd:o("comment-add",60011),alert:o("alert",60012),warning:o("warning",60012),search:o("search",60013),searchSave:o("search-save",60013),logOut:o("log-out",60014),signOut:o("sign-out",60014),logIn:o("log-in",60015),signIn:o("sign-in",60015),eye:o("eye",60016),eyeUnwatch:o("eye-unwatch",60016),eyeWatch:o("eye-watch",60016),circleFilled:o("circle-filled",60017),primitiveDot:o("primitive-dot",60017),closeDirty:o("close-dirty",60017),debugBreakpoint:o("debug-breakpoint",60017),debugBreakpointDisabled:o("debug-breakpoint-disabled",60017),debugHint:o("debug-hint",60017),primitiveSquare:o("primitive-square",60018),edit:o("edit",60019),pencil:o("pencil",60019),info:o("info",60020),issueOpened:o("issue-opened",60020),gistPrivate:o("gist-private",60021),gitForkPrivate:o("git-fork-private",60021),lock:o("lock",60021),mirrorPrivate:o("mirror-private",60021),close:o("close",60022),removeClose:o("remove-close",60022),x:o("x",60022),repoSync:o("repo-sync",60023),sync:o("sync",60023),clone:o("clone",60024),desktopDownload:o("desktop-download",60024),beaker:o("beaker",60025),microscope:o("microscope",60025),vm:o("vm",60026),deviceDesktop:o("device-desktop",60026),file:o("file",60027),fileText:o("file-text",60027),more:o("more",60028),ellipsis:o("ellipsis",60028),kebabHorizontal:o("kebab-horizontal",60028),mailReply:o("mail-reply",60029),reply:o("reply",60029),organization:o("organization",60030),organizationFilled:o("organization-filled",60030),organizationOutline:o("organization-outline",60030),newFile:o("new-file",60031),fileAdd:o("file-add",60031),newFolder:o("new-folder",60032),fileDirectoryCreate:o("file-directory-create",60032),trash:o("trash",60033),trashcan:o("trashcan",60033),history:o("history",60034),clock:o("clock",60034),folder:o("folder",60035),fileDirectory:o("file-directory",60035),symbolFolder:o("symbol-folder",60035),logoGithub:o("logo-github",60036),markGithub:o("mark-github",60036),github:o("github",60036),terminal:o("terminal",60037),console:o("console",60037),repl:o("repl",60037),zap:o("zap",60038),symbolEvent:o("symbol-event",60038),error:o("error",60039),stop:o("stop",60039),variable:o("variable",60040),symbolVariable:o("symbol-variable",60040),array:o("array",60042),symbolArray:o("symbol-array",60042),symbolModule:o("symbol-module",60043),symbolPackage:o("symbol-package",60043),symbolNamespace:o("symbol-namespace",60043),symbolObject:o("symbol-object",60043),symbolMethod:o("symbol-method",60044),symbolFunction:o("symbol-function",60044),symbolConstructor:o("symbol-constructor",60044),symbolBoolean:o("symbol-boolean",60047),symbolNull:o("symbol-null",60047),symbolNumeric:o("symbol-numeric",60048),symbolNumber:o("symbol-number",60048),symbolStructure:o("symbol-structure",60049),symbolStruct:o("symbol-struct",60049),symbolParameter:o("symbol-parameter",60050),symbolTypeParameter:o("symbol-type-parameter",60050),symbolKey:o("symbol-key",60051),symbolText:o("symbol-text",60051),symbolReference:o("symbol-reference",60052),goToFile:o("go-to-file",60052),symbolEnum:o("symbol-enum",60053),symbolValue:o("symbol-value",60053),symbolRuler:o("symbol-ruler",60054),symbolUnit:o("symbol-unit",60054),activateBreakpoints:o("activate-breakpoints",60055),archive:o("archive",60056),arrowBoth:o("arrow-both",60057),arrowDown:o("arrow-down",60058),arrowLeft:o("arrow-left",60059),arrowRight:o("arrow-right",60060),arrowSmallDown:o("arrow-small-down",60061),arrowSmallLeft:o("arrow-small-left",60062),arrowSmallRight:o("arrow-small-right",60063),arrowSmallUp:o("arrow-small-up",60064),arrowUp:o("arrow-up",60065),bell:o("bell",60066),bold:o("bold",60067),book:o("book",60068),bookmark:o("bookmark",60069),debugBreakpointConditionalUnverified:o("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:o("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:o("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:o("debug-breakpoint-data-unverified",60072),debugBreakpointData:o("debug-breakpoint-data",60073),debugBreakpointDataDisabled:o("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:o("debug-breakpoint-log-unverified",60074),debugBreakpointLog:o("debug-breakpoint-log",60075),debugBreakpointLogDisabled:o("debug-breakpoint-log-disabled",60075),briefcase:o("briefcase",60076),broadcast:o("broadcast",60077),browser:o("browser",60078),bug:o("bug",60079),calendar:o("calendar",60080),caseSensitive:o("case-sensitive",60081),check:o("check",60082),checklist:o("checklist",60083),chevronDown:o("chevron-down",60084),dropDownButton:o("drop-down-button",60084),chevronLeft:o("chevron-left",60085),chevronRight:o("chevron-right",60086),chevronUp:o("chevron-up",60087),chromeClose:o("chrome-close",60088),chromeMaximize:o("chrome-maximize",60089),chromeMinimize:o("chrome-minimize",60090),chromeRestore:o("chrome-restore",60091),circle:o("circle",60092),circleOutline:o("circle-outline",60092),debugBreakpointUnverified:o("debug-breakpoint-unverified",60092),circleSlash:o("circle-slash",60093),circuitBoard:o("circuit-board",60094),clearAll:o("clear-all",60095),clippy:o("clippy",60096),closeAll:o("close-all",60097),cloudDownload:o("cloud-download",60098),cloudUpload:o("cloud-upload",60099),code:o("code",60100),collapseAll:o("collapse-all",60101),colorMode:o("color-mode",60102),commentDiscussion:o("comment-discussion",60103),compareChanges:o("compare-changes",60157),creditCard:o("credit-card",60105),dash:o("dash",60108),dashboard:o("dashboard",60109),database:o("database",60110),debugContinue:o("debug-continue",60111),debugDisconnect:o("debug-disconnect",60112),debugPause:o("debug-pause",60113),debugRestart:o("debug-restart",60114),debugStart:o("debug-start",60115),debugStepInto:o("debug-step-into",60116),debugStepOut:o("debug-step-out",60117),debugStepOver:o("debug-step-over",60118),debugStop:o("debug-stop",60119),debug:o("debug",60120),deviceCameraVideo:o("device-camera-video",60121),deviceCamera:o("device-camera",60122),deviceMobile:o("device-mobile",60123),diffAdded:o("diff-added",60124),diffIgnored:o("diff-ignored",60125),diffModified:o("diff-modified",60126),diffRemoved:o("diff-removed",60127),diffRenamed:o("diff-renamed",60128),diff:o("diff",60129),discard:o("discard",60130),editorLayout:o("editor-layout",60131),emptyWindow:o("empty-window",60132),exclude:o("exclude",60133),extensions:o("extensions",60134),eyeClosed:o("eye-closed",60135),fileBinary:o("file-binary",60136),fileCode:o("file-code",60137),fileMedia:o("file-media",60138),filePdf:o("file-pdf",60139),fileSubmodule:o("file-submodule",60140),fileSymlinkDirectory:o("file-symlink-directory",60141),fileSymlinkFile:o("file-symlink-file",60142),fileZip:o("file-zip",60143),files:o("files",60144),filter:o("filter",60145),flame:o("flame",60146),foldDown:o("fold-down",60147),foldUp:o("fold-up",60148),fold:o("fold",60149),folderActive:o("folder-active",60150),folderOpened:o("folder-opened",60151),gear:o("gear",60152),gift:o("gift",60153),gistSecret:o("gist-secret",60154),gist:o("gist",60155),gitCommit:o("git-commit",60156),gitCompare:o("git-compare",60157),gitMerge:o("git-merge",60158),githubAction:o("github-action",60159),githubAlt:o("github-alt",60160),globe:o("globe",60161),grabber:o("grabber",60162),graph:o("graph",60163),gripper:o("gripper",60164),heart:o("heart",60165),home:o("home",60166),horizontalRule:o("horizontal-rule",60167),hubot:o("hubot",60168),inbox:o("inbox",60169),issueClosed:o("issue-closed",60324),issueReopened:o("issue-reopened",60171),issues:o("issues",60172),italic:o("italic",60173),jersey:o("jersey",60174),json:o("json",60175),bracket:o("bracket",60175),kebabVertical:o("kebab-vertical",60176),key:o("key",60177),law:o("law",60178),lightbulbAutofix:o("lightbulb-autofix",60179),linkExternal:o("link-external",60180),link:o("link",60181),listOrdered:o("list-ordered",60182),listUnordered:o("list-unordered",60183),liveShare:o("live-share",60184),loading:o("loading",60185),location:o("location",60186),mailRead:o("mail-read",60187),mail:o("mail",60188),markdown:o("markdown",60189),megaphone:o("megaphone",60190),mention:o("mention",60191),milestone:o("milestone",60192),mortarBoard:o("mortar-board",60193),move:o("move",60194),multipleWindows:o("multiple-windows",60195),mute:o("mute",60196),noNewline:o("no-newline",60197),note:o("note",60198),octoface:o("octoface",60199),openPreview:o("open-preview",60200),package_:o("package",60201),paintcan:o("paintcan",60202),pin:o("pin",60203),play:o("play",60204),run:o("run",60204),plug:o("plug",60205),preserveCase:o("preserve-case",60206),preview:o("preview",60207),project:o("project",60208),pulse:o("pulse",60209),question:o("question",60210),quote:o("quote",60211),radioTower:o("radio-tower",60212),reactions:o("reactions",60213),references:o("references",60214),refresh:o("refresh",60215),regex:o("regex",60216),remoteExplorer:o("remote-explorer",60217),remote:o("remote",60218),remove:o("remove",60219),replaceAll:o("replace-all",60220),replace:o("replace",60221),repoClone:o("repo-clone",60222),repoForcePush:o("repo-force-push",60223),repoPull:o("repo-pull",60224),repoPush:o("repo-push",60225),report:o("report",60226),requestChanges:o("request-changes",60227),rocket:o("rocket",60228),rootFolderOpened:o("root-folder-opened",60229),rootFolder:o("root-folder",60230),rss:o("rss",60231),ruby:o("ruby",60232),saveAll:o("save-all",60233),saveAs:o("save-as",60234),save:o("save",60235),screenFull:o("screen-full",60236),screenNormal:o("screen-normal",60237),searchStop:o("search-stop",60238),server:o("server",60240),settingsGear:o("settings-gear",60241),settings:o("settings",60242),shield:o("shield",60243),smiley:o("smiley",60244),sortPrecedence:o("sort-precedence",60245),splitHorizontal:o("split-horizontal",60246),splitVertical:o("split-vertical",60247),squirrel:o("squirrel",60248),starFull:o("star-full",60249),starHalf:o("star-half",60250),symbolClass:o("symbol-class",60251),symbolColor:o("symbol-color",60252),symbolCustomColor:o("symbol-customcolor",60252),symbolConstant:o("symbol-constant",60253),symbolEnumMember:o("symbol-enum-member",60254),symbolField:o("symbol-field",60255),symbolFile:o("symbol-file",60256),symbolInterface:o("symbol-interface",60257),symbolKeyword:o("symbol-keyword",60258),symbolMisc:o("symbol-misc",60259),symbolOperator:o("symbol-operator",60260),symbolProperty:o("symbol-property",60261),wrench:o("wrench",60261),wrenchSubaction:o("wrench-subaction",60261),symbolSnippet:o("symbol-snippet",60262),tasklist:o("tasklist",60263),telescope:o("telescope",60264),textSize:o("text-size",60265),threeBars:o("three-bars",60266),thumbsdown:o("thumbsdown",60267),thumbsup:o("thumbsup",60268),tools:o("tools",60269),triangleDown:o("triangle-down",60270),triangleLeft:o("triangle-left",60271),triangleRight:o("triangle-right",60272),triangleUp:o("triangle-up",60273),twitter:o("twitter",60274),unfold:o("unfold",60275),unlock:o("unlock",60276),unmute:o("unmute",60277),unverified:o("unverified",60278),verified:o("verified",60279),versions:o("versions",60280),vmActive:o("vm-active",60281),vmOutline:o("vm-outline",60282),vmRunning:o("vm-running",60283),watch:o("watch",60284),whitespace:o("whitespace",60285),wholeWord:o("whole-word",60286),window:o("window",60287),wordWrap:o("word-wrap",60288),zoomIn:o("zoom-in",60289),zoomOut:o("zoom-out",60290),listFilter:o("list-filter",60291),listFlat:o("list-flat",60292),listSelection:o("list-selection",60293),selection:o("selection",60293),listTree:o("list-tree",60294),debugBreakpointFunctionUnverified:o("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:o("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:o("debug-breakpoint-function-disabled",60296),debugStackframeActive:o("debug-stackframe-active",60297),circleSmallFilled:o("circle-small-filled",60298),debugStackframeDot:o("debug-stackframe-dot",60298),debugStackframe:o("debug-stackframe",60299),debugStackframeFocused:o("debug-stackframe-focused",60299),debugBreakpointUnsupported:o("debug-breakpoint-unsupported",60300),symbolString:o("symbol-string",60301),debugReverseContinue:o("debug-reverse-continue",60302),debugStepBack:o("debug-step-back",60303),debugRestartFrame:o("debug-restart-frame",60304),callIncoming:o("call-incoming",60306),callOutgoing:o("call-outgoing",60307),menu:o("menu",60308),expandAll:o("expand-all",60309),feedback:o("feedback",60310),groupByRefType:o("group-by-ref-type",60311),ungroupByRefType:o("ungroup-by-ref-type",60312),account:o("account",60313),bellDot:o("bell-dot",60314),debugConsole:o("debug-console",60315),library:o("library",60316),output:o("output",60317),runAll:o("run-all",60318),syncIgnored:o("sync-ignored",60319),pinned:o("pinned",60320),githubInverted:o("github-inverted",60321),debugAlt:o("debug-alt",60305),serverProcess:o("server-process",60322),serverEnvironment:o("server-environment",60323),pass:o("pass",60324),stopCircle:o("stop-circle",60325),playCircle:o("play-circle",60326),record:o("record",60327),debugAltSmall:o("debug-alt-small",60328),vmConnect:o("vm-connect",60329),cloud:o("cloud",60330),merge:o("merge",60331),exportIcon:o("export",60332),graphLeft:o("graph-left",60333),magnet:o("magnet",60334),notebook:o("notebook",60335),redo:o("redo",60336),checkAll:o("check-all",60337),pinnedDirty:o("pinned-dirty",60338),passFilled:o("pass-filled",60339),circleLargeFilled:o("circle-large-filled",60340),circleLarge:o("circle-large",60341),circleLargeOutline:o("circle-large-outline",60341),combine:o("combine",60342),gather:o("gather",60342),table:o("table",60343),variableGroup:o("variable-group",60344),typeHierarchy:o("type-hierarchy",60345),typeHierarchySub:o("type-hierarchy-sub",60346),typeHierarchySuper:o("type-hierarchy-super",60347),gitPullRequestCreate:o("git-pull-request-create",60348),runAbove:o("run-above",60349),runBelow:o("run-below",60350),notebookTemplate:o("notebook-template",60351),debugRerun:o("debug-rerun",60352),workspaceTrusted:o("workspace-trusted",60353),workspaceUntrusted:o("workspace-untrusted",60354),workspaceUnspecified:o("workspace-unspecified",60355),terminalCmd:o("terminal-cmd",60356),terminalDebian:o("terminal-debian",60357),terminalLinux:o("terminal-linux",60358),terminalPowershell:o("terminal-powershell",60359),terminalTmux:o("terminal-tmux",60360),terminalUbuntu:o("terminal-ubuntu",60361),terminalBash:o("terminal-bash",60362),arrowSwap:o("arrow-swap",60363),copy:o("copy",60364),personAdd:o("person-add",60365),filterFilled:o("filter-filled",60366),wand:o("wand",60367),debugLineByLine:o("debug-line-by-line",60368),inspect:o("inspect",60369),layers:o("layers",60370),layersDot:o("layers-dot",60371),layersActive:o("layers-active",60372),compass:o("compass",60373),compassDot:o("compass-dot",60374),compassActive:o("compass-active",60375),azure:o("azure",60376),issueDraft:o("issue-draft",60377),gitPullRequestClosed:o("git-pull-request-closed",60378),gitPullRequestDraft:o("git-pull-request-draft",60379),debugAll:o("debug-all",60380),debugCoverage:o("debug-coverage",60381),runErrors:o("run-errors",60382),folderLibrary:o("folder-library",60383),debugContinueSmall:o("debug-continue-small",60384),beakerStop:o("beaker-stop",60385),graphLine:o("graph-line",60386),graphScatter:o("graph-scatter",60387),pieChart:o("pie-chart",60388),bracketDot:o("bracket-dot",60389),bracketError:o("bracket-error",60390),lockSmall:o("lock-small",60391),azureDevops:o("azure-devops",60392),verifiedFilled:o("verified-filled",60393),newLine:o("newline",60394),layout:o("layout",60395),layoutActivitybarLeft:o("layout-activitybar-left",60396),layoutActivitybarRight:o("layout-activitybar-right",60397),layoutPanelLeft:o("layout-panel-left",60398),layoutPanelCenter:o("layout-panel-center",60399),layoutPanelJustify:o("layout-panel-justify",60400),layoutPanelRight:o("layout-panel-right",60401),layoutPanel:o("layout-panel",60402),layoutSidebarLeft:o("layout-sidebar-left",60403),layoutSidebarRight:o("layout-sidebar-right",60404),layoutStatusbar:o("layout-statusbar",60405),layoutMenubar:o("layout-menubar",60406),layoutCentered:o("layout-centered",60407),layoutSidebarRightOff:o("layout-sidebar-right-off",60416),layoutPanelOff:o("layout-panel-off",60417),layoutSidebarLeftOff:o("layout-sidebar-left-off",60418),target:o("target",60408),indent:o("indent",60409),recordSmall:o("record-small",60410),errorSmall:o("error-small",60411),arrowCircleDown:o("arrow-circle-down",60412),arrowCircleLeft:o("arrow-circle-left",60413),arrowCircleRight:o("arrow-circle-right",60414),arrowCircleUp:o("arrow-circle-up",60415),heartFilled:o("heart-filled",60420),map:o("map",60421),mapFilled:o("map-filled",60422),circleSmall:o("circle-small",60423),bellSlash:o("bell-slash",60424),bellSlashDot:o("bell-slash-dot",60425),commentUnresolved:o("comment-unresolved",60426),gitPullRequestGoToChanges:o("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:o("git-pull-request-new-changes",60428),searchFuzzy:o("search-fuzzy",60429),commentDraft:o("comment-draft",60430),send:o("send",60431),sparkle:o("sparkle",60432),insert:o("insert",60433),dialogError:o("dialog-error","error"),dialogWarning:o("dialog-warning","warning"),dialogInfo:o("dialog-info","info"),dialogClose:o("dialog-close","close"),treeItemExpanded:o("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:o("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:o("tree-filter-on-type-off","list-selection"),treeFilterClear:o("tree-filter-clear","close"),treeItemLoading:o("tree-item-loading","loading"),menuSelection:o("menu-selection","check"),menuSubmenu:o("menu-submenu","chevron-right"),menuBarMore:o("menubar-more","more"),scrollbarButtonLeft:o("scrollbar-button-left","triangle-left"),scrollbarButtonRight:o("scrollbar-button-right","triangle-right"),scrollbarButtonUp:o("scrollbar-button-up","triangle-up"),scrollbarButtonDown:o("scrollbar-button-down","triangle-down"),toolBarMore:o("toolbar-more","more"),quickInputBack:o("quick-input-back","arrow-left")}}),define(pe[38],be([1,0,7,3,17,8]),function(le,e,y,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(l){return l===47||l===92}e.isPathSeparator=k;function T(l){return l.replace(/[\\/]/g,y.posix.sep)}e.toSlashes=T;function v(l){return l.indexOf("/")===-1&&(l=T(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=v;function m(l,h=y.posix.sep){if(!l)return"";const C=l.length,D=l.charCodeAt(0);if(k(D)){if(k(l.charCodeAt(1))&&!k(l.charCodeAt(2))){let S=3;const N=S;for(;S<C&&!k(l.charCodeAt(S));S++);if(N!==S&&!k(l.charCodeAt(S+1))){for(S+=1;S<C;S++)if(k(l.charCodeAt(S)))return l.slice(0,S+1).replace(/[\\/]/g,h)}}return h}else if(f(D)&&l.charCodeAt(1)===58)return k(l.charCodeAt(2))?l.slice(0,2)+h:l.slice(0,2);let w=l.indexOf("://");if(w!==-1){for(w+=3;w<C;w++)if(k(l.charCodeAt(w)))return l.slice(0,w+1)}return""}e.getRoot=m;function R(l){if(!L.isWindows||!l||l.length<5)return!1;let h=l.charCodeAt(0);if(h!==92||(h=l.charCodeAt(1),h!==92))return!1;let C=2;const D=C;for(;C<l.length&&(h=l.charCodeAt(C),h!==92);C++);return!(D===C||(h=l.charCodeAt(C+1),isNaN(h)||h===92))}e.isUNC=R;const E=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(l,h=L.isWindows){const C=h?E:b;return!(!l||l.length===0||/^\s+$/.test(l)||(C.lastIndex=0,C.test(l))||h&&d.test(l)||l==="."||l===".."||h&&l[l.length-1]==="."||h&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=g;function p(l,h,C){const D=l===h;return!C||D?D:!l||!h?!1:(0,o.equalsIgnoreCase)(l,h)}e.isEqual=p;function r(l,h,C,D=y.sep){if(l===h)return!0;if(!l||!h||h.length>l.length)return!1;if(C){if(!(0,o.startsWithIgnoreCase)(l,h))return!1;if(h.length===l.length)return!0;let S=h.length;return h.charAt(h.length-1)===D&&S--,l.charAt(S)===D}return h.charAt(h.length-1)!==D&&(h+=D),l.indexOf(h)===0}e.isEqualOrParent=r;function f(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=f;function c(l,h){return L.isWindows&&l.endsWith(":")&&(l+=y.sep),(0,y.isAbsolute)(l)||(l=(0,y.join)(h,l)),l=(0,y.normalize)(l),L.isWindows?(l=(0,o.rtrim)(l,y.sep),l.endsWith(":")&&(l+=y.sep)):(l=(0,o.rtrim)(l,y.sep),l||(l=y.sep)),l}e.sanitizeFilePath=c;function u(l){const h=(0,y.normalize)(l);return L.isWindows?l.length>3?!1:I(h)&&(l.length===2||h.charCodeAt(2)===92):h===y.posix.sep}e.isRootOrDriveLetter=u;function I(l,h=L.isWindows){return h?f(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=I;function O(l,h=L.isWindows){return I(l,h)?l[0]:void 0}e.getDriveLetter=O;function t(l,h,C){return h.length>l.length?-1:l===h?0:(C&&(l=l.toLowerCase(),h=h.toLowerCase()),l.indexOf(h))}e.indexOfPath=t;function n(l){const h=l.split(":");let C,D,w;for(const S of h){const N=Number(S);(0,A.isNumber)(N)?D===void 0?D=N:w===void 0&&(w=N):C=C?[C,S].join(":"):S}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:D!==void 0?D:void 0,column:w!==void 0?w:D!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(l,h,C=8){let D="";for(let S=0;S<C;S++){let N;S===0&&L.isWindows&&!h&&(C===3||C===4)?N=i:N=s,D+=N.charAt(Math.floor(Math.random()*N.length))}let w;return h?w=`${h}-${D}`:w=D,l?(0,y.join)(l,w):w}e.randomPath=a}),define(pe[22],be([1,0,8]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const c=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([u,I])=>{c[u]=I&&typeof I=="object"?L(I):I}),c}e.deepClone=L;function o(f){if(!f||typeof f!="object")return f;const c=[f];for(;c.length>0;){const u=c.shift();Object.freeze(u);for(const I in u)if(A.call(u,I)){const O=u[I];typeof O=="object"&&!Object.isFrozen(O)&&!(0,y.isTypedArray)(O)&&c.push(O)}}return f}e.deepFreeze=o;const A=Object.prototype.hasOwnProperty;function k(f,c){return T(f,c,new Set)}e.cloneAndChange=k;function T(f,c,u){if((0,y.isUndefinedOrNull)(f))return f;const I=c(f);if(typeof I<"u")return I;if(Array.isArray(f)){const O=[];for(const t of f)O.push(T(t,c,u));return O}if((0,y.isObject)(f)){if(u.has(f))throw new Error("Cannot clone recursive data-structure");u.add(f);const O={};for(const t in f)A.call(f,t)&&(O[t]=T(f[t],c,u));return u.delete(f),O}return f}function v(f,c,u=!0){return(0,y.isObject)(f)?((0,y.isObject)(c)&&Object.keys(c).forEach(I=>{I in f?u&&((0,y.isObject)(f[I])&&(0,y.isObject)(c[I])?v(f[I],c[I],u):f[I]=c[I]):f[I]=c[I]}),f):c}e.mixin=v;function m(f,c){if(f===c)return!0;if(f==null||c===null||c===void 0||typeof f!=typeof c||typeof f!="object"||Array.isArray(f)!==Array.isArray(c))return!1;let u,I;if(Array.isArray(f)){if(f.length!==c.length)return!1;for(u=0;u<f.length;u++)if(!m(f[u],c[u]))return!1}else{const O=[];for(I in f)O.push(I);O.sort();const t=[];for(I in c)t.push(I);if(t.sort(),!m(O,t))return!1;for(u=0;u<O.length;u++)if(!m(f[O[u]],c[O[u]]))return!1}return!0}e.equals=m;function R(f){const c=new Set;return JSON.stringify(f,(u,I)=>{if((0,y.isObject)(I)||Array.isArray(I)){if(c.has(I))return"[Circular]";c.add(I)}return I})}e.safeStringify=R;function E(f,c){const u=Object.create(null);return!f||!c||Object.keys(c).forEach(O=>{const t=f[O],n=c[O];m(t,n)||(u[O]=n)}),u}e.distinct=E;function b(f,c){const u=c.toLowerCase(),I=Object.keys(f).find(O=>O.toLowerCase()===u);return I?f[I]:f[c]}e.getCaseInsensitive=b;function d(f,c){const u=Object.create(null);for(const[I,O]of Object.entries(f))c(I,O)&&(u[I]=O);return u}e.filter=d;function g(f){let c=[],u=Object.getPrototypeOf(f);for(;Object.prototype!==u;)c=c.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return c}e.getAllPropertyNames=g;function p(f){const c=[];for(const u of g(f))typeof f[u]=="function"&&c.push(u);return c}e.getAllMethodNames=p;function r(f,c){const u=O=>function(){const t=Array.prototype.slice.call(arguments,0);return c(O,t)},I={};for(const O of f)I[O]=u(O);return I}e.createProxyObject=r}),define(pe[98],be([1,0,48]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(k){function T(v){return v&&typeof v=="object"&&typeof v.id=="string"}k.isThemeColor=T})(L||(e.ThemeColor=L={}));function o(k){return{id:k}}e.themeColorFromId=o;var A;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function v(c){const u=T.exec(c.id);if(!u)return v(y.Codicon.error);const[,I,O]=u,t=["codicon","codicon-"+I];return O&&t.push("codicon-modifier-"+O.substring(1)),t}k.asClassNameArray=v;function m(c){return v(c).join(" ")}k.asClassName=m;function R(c){return"."+v(c).join(".")}k.asCSSSelector=R;function E(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||L.isThemeColor(c.color))}k.isThemeIcon=E;const b=new RegExp(`^\\$\\((${k.iconNameExpression}(?:${k.iconModifierExpression})?)\\)$`);function d(c){const u=b.exec(c);if(!u)return;const[,I]=u;return{id:I}}k.fromString=d;function g(c){return{id:c}}k.fromId=g;function p(c,u){let I=c.id;const O=I.lastIndexOf("~");return O!==-1&&(I=I.substring(0,O)),u&&(I=`${I}~${u}`),{id:I}}k.modify=p;function r(c){const u=c.id.lastIndexOf("~");if(u!==-1)return c.id.substring(u+1)}k.getModifier=r;function f(c,u){return c.id===u.id&&c.color?.id===u.color?.id}k.isEqual=f})(A||(e.ThemeIcon=A={}))}),define(pe[147],be([1,0,145,17,98]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",k=new RegExp(`\\$\\(${o.ThemeIcon.iconNameExpression}(?:${o.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${k.source}`,"g");function v(f){return f.replace(T,(c,u)=>u?c:`\\${c}`)}e.escapeIcons=v;const m=new RegExp(`\\\\${k.source}`,"g");function R(f){return f.replace(m,c=>`\\${c}`)}e.markdownEscapeEscapedIcons=R;const E=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function b(f){return f.indexOf(A)===-1?f:f.replace(E,(c,u,I,O)=>I?c:u||O||"")}e.stripIcons=b;function d(f){return f?f.replace(/\$\((.*?)\)/g,(c,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=d;const g=new RegExp(`\\$\\(${o.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(f){g.lastIndex=0;let c="";const u=[];let I=0;for(;;){const O=g.lastIndex,t=g.exec(f),n=f.substring(O,t?.index);if(n.length>0){c+=n;for(let s=0;s<n.length;s++)u.push(I)}if(!t)break;I+=t[0].length}return{text:c,iconOffsets:u}}e.parseLabelWithIcons=p;function r(f,c,u=!1){const{text:I,iconOffsets:O}=c;if(!O||O.length===0)return(0,y.matchesFuzzy)(f,I,u);const t=(0,L.ltrim)(I," "),n=I.length-t.length,s=(0,y.matchesFuzzy)(f,t,u);if(s)for(const i of s){const a=O[i.start+n]+n;i.start+=a,i.end+=a}return s}e.matchesFuzzyIconAware=r}),define(pe[4],be([1,0,7,3]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const o=/^\w[\w\d+.-]*$/,A=/^\//,k=/^\/\//;function T(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!o.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function v(i,a){return!i&&!a?"file":i}function m(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==E&&(a=E+a):a=E;break}return a}const R="",E="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(a){return a instanceof d?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,l,h,C,D,w=!1){typeof a=="object"?(this.scheme=a.scheme||R,this.authority=a.authority||R,this.path=a.path||R,this.query=a.query||R,this.fragment=a.fragment||R):(this.scheme=v(a,w),this.authority=l||R,this.path=m(this.scheme,h||R),this.query=C||R,this.fragment=D||R,T(this,w))}get fsPath(){return I(this,!1)}with(a){if(!a)return this;let{scheme:l,authority:h,path:C,query:D,fragment:w}=a;return l===void 0?l=this.scheme:l===null&&(l=R),h===void 0?h=this.authority:h===null&&(h=R),C===void 0?C=this.path:C===null&&(C=R),D===void 0?D=this.query:D===null&&(D=R),w===void 0?w=this.fragment:w===null&&(w=R),l===this.scheme&&h===this.authority&&C===this.path&&D===this.query&&w===this.fragment?this:new r(l,h,C,D,w)}static parse(a,l=!1){const h=b.exec(a);return h?new r(h[2]||R,s(h[4]||R),s(h[5]||R),s(h[7]||R),s(h[9]||R),l):new r(R,R,R,R,R)}static file(a){let l=R;if(L.isWindows&&(a=a.replace(/\\/g,E)),a[0]===E&&a[1]===E){const h=a.indexOf(E,2);h===-1?(l=a.substring(2),a=E):(l=a.substring(2,h),a=a.substring(h)||E)}return new r("file",l,a,R,R)}static from(a,l){return new r(a.scheme,a.authority,a.path,a.query,a.fragment,l)}static joinPath(a,...l){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return L.isWindows&&a.scheme==="file"?h=d.file(y.win32.join(I(a,!0),...l)).path:h=y.posix.join(a.path,...l),a.with({path:h})}toString(a=!1){return O(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof d)return a;{const l=new r(a);return l._formatted=a.external??null,l._fsPath=a._sep===p?a.fsPath??null:null,l}}else return a}}e.URI=d;function g(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.isUriComponents=g;const p=L.isWindows?1:void 0;class r extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=I(this,!1)),this._fsPath}toString(a=!1){return a?O(this,!0):(this._formatted||(this._formatted=O(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=p),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function c(i,a,l){let h,C=-1;for(let D=0;D<i.length;D++){const w=i.charCodeAt(D);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||a&&w===47||l&&w===91||l&&w===93||l&&w===58)C!==-1&&(h+=encodeURIComponent(i.substring(C,D)),C=-1),h!==void 0&&(h+=i.charAt(D));else{h===void 0&&(h=i.substr(0,D));const S=f[w];S!==void 0?(C!==-1&&(h+=encodeURIComponent(i.substring(C,D)),C=-1),h+=S):C===-1&&(C=D)}}return C!==-1&&(h+=encodeURIComponent(i.substring(C))),h!==void 0?h:i}function u(i){let a;for(let l=0;l<i.length;l++){const h=i.charCodeAt(l);h===35||h===63?(a===void 0&&(a=i.substr(0,l)),a+=f[h]):a!==void 0&&(a+=i[l])}return a!==void 0?a:i}function I(i,a){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=I;function O(i,a){const l=a?u:c;let h="",{scheme:C,authority:D,path:w,query:S,fragment:N}=i;if(C&&(h+=C,h+=":"),(D||C==="file")&&(h+=E,h+=E),D){let $=D.indexOf("@");if($!==-1){const ee=D.substr(0,$);D=D.substr($+1),$=ee.lastIndexOf(":"),$===-1?h+=l(ee,!1,!1):(h+=l(ee.substr(0,$),!1,!1),h+=":",h+=l(ee.substr($+1),!1,!0)),h+="@"}D=D.toLowerCase(),$=D.lastIndexOf(":"),$===-1?h+=l(D,!1,!0):(h+=l(D.substr(0,$),!1,!0),h+=D.substr($))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const $=w.charCodeAt(1);$>=65&&$<=90&&(w=`/${String.fromCharCode($+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const $=w.charCodeAt(0);$>=65&&$<=90&&(w=`${String.fromCharCode($+32)}:${w.substr(2)}`)}h+=l(w,!0,!1)}return S&&(h+="?",h+=l(S,!1,!1)),N&&(h+="#",h+=a?N:c(N,!1,!1)),h}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(n)?i.replace(n,a=>t(a)):i}}),define(pe[148],be([1,0,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(m){const R=m;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=L;function o(m){const R=[];let E;try{const b=JSON.parse(m.arguments),d=b[b.length-1];d&&d.__$stack&&(b.pop(),E=d.__$stack),R.push(...b)}catch{R.push("Unable to log remote console arguments",m.arguments)}return{args:R,stack:E}}e.parse=o;function A(m){if(typeof m!="string")return A(o(m).stack);const R=m;if(R){const E=k(R),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(b&&b.length===4)return{uri:y.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=A;function k(m){if(!m)return m;const R=m.indexOf(`
`);return R===-1?m:m.substring(0,R)}function T(m,R){const{args:E,stack:b}=o(m),d=typeof E[0]=="string"&&E.length===1;let g=k(b);g&&(g=`(${g.trim()})`);let p=[];if(typeof E[0]=="string"?g&&d?p=[`%c[${R}] %c${E[0]} %c${g}`,v("blue"),v(""),v("grey")]:p=[`%c[${R}] %c${E[0]}`,v("blue"),v(""),...E.slice(1)]:p=[`%c[${R}]%`,v("blue"),...E],g&&!d&&p.push(g),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,p)}e.log=T;function v(m){return`color: ${m}`}}),define(pe[49],be([1,0,15,17,4]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(m){return JSON.stringify(m,T)}e.stringify=A;function k(m){let R=JSON.parse(m);return R=v(R),R}e.parse=k;function T(m,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,L.regExpFlags)(R)}:R}function v(m,R=0){if(!m||R>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return o.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof y.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let E=0;E<m.length;++E)m[E]=v(m[E],R+1);else for(const E in m)Object.hasOwnProperty.call(m,E)&&(m[E]=v(m[E],R+1))}return m}e.revive=v}),define(pe[13],be([1,0,9,3,4]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractive="vscode-interactive",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${A.vscodeRemoteResource}`}set(R,E,b){this.a[R]=E,this.b[R]=b}setConnectionToken(R,E){this.c[R]=E}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(r){return y.onUnexpectedError(r),R}const E=R.authority;let b=this.a[E];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const d=this.b[E],g=this.c[E];let p=`path=${encodeURIComponent(R.path)}`;return typeof g=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(g)}`),o.URI.from({scheme:L.isWeb?this.d:A.vscodeRemoteResource,authority:`${b}:${d}`,path:L.isWeb?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:p})}}e.RemoteAuthorities=new k,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class T{asBrowserUri(R){const E=this.b(R,le);return this.uriToBrowserUri(E)}uriToBrowserUri(R){return R.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===A.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${A.vscodeFileResource}://${T.a}`)?R.with({scheme:A.vscodeFileResource,authority:R.authority||T.a,query:null,fragment:null}):R}asFileUri(R){const E=this.b(R,le);return this.uriToFileUri(E)}uriToFileUri(R){return R.scheme===A.vscodeFileResource?R.with({scheme:A.file,authority:R.authority!==T.a?R.authority:null,query:null,fragment:null}):R}b(R,E){return o.URI.isUri(R)?R:o.URI.parse(E.toUrl(R))}}T.a="vscode-app",e.FileAccess=new T;var v;(function(m){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(R.get("3"));const E="vscode-coi";function b(g){let p;typeof g=="string"?p=new URL(g).searchParams:g instanceof URL?p=g.searchParams:o.URI.isUri(g)&&(p=new URL(g.toString(!0)).searchParams);const r=p?.get(E);if(r)return R.get(r)}m.getHeadersFromQuery=b;function d(g,p,r){if(!globalThis.crossOriginIsolated)return;const f=p&&r?"3":r?"2":"1";g instanceof URLSearchParams?g.set(E,f):g[E]=f}m.addSearchParam=d})(v||(e.COI=v={}))}),define(pe[19],be([1,0,38,13,7,3,17,4]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function v(d){return(0,T.uriToFsPath)(d,!0)}e.originalFSPath=v;class m{constructor(g){this.a=g}compare(g,p,r=!1){return g===p?0:(0,k.compare)(this.getComparisonKey(g,r),this.getComparisonKey(p,r))}isEqual(g,p,r=!1){return g===p?!0:!g||!p?!1:this.getComparisonKey(g,r)===this.getComparisonKey(p,r)}getComparisonKey(g,p=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,p,r=!1){if(g.scheme===p.scheme){if(g.scheme===L.Schemas.file)return y.isEqualOrParent(v(g),v(p),this.a(g))&&g.query===p.query&&(r||g.fragment===p.fragment);if((0,e.isEqualAuthority)(g.authority,p.authority))return y.isEqualOrParent(g.path,p.path,this.a(g),"/")&&g.query===p.query&&(r||g.fragment===p.fragment)}return!1}joinPath(g,...p){return T.URI.joinPath(g,...p)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return o.posix.basename(g.path)}extname(g){return o.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let p;return g.scheme===L.Schemas.file?p=T.URI.file(o.dirname(v(g))).path:(p=o.posix.dirname(g.path),g.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),p="/")),g.with({path:p})}normalizePath(g){if(!g.path.length)return g;let p;return g.scheme===L.Schemas.file?p=T.URI.file(o.normalize(v(g))).path:p=o.posix.normalize(g.path),g.with({path:p})}relativePath(g,p){if(g.scheme!==p.scheme||!(0,e.isEqualAuthority)(g.authority,p.authority))return;if(g.scheme===L.Schemas.file){const c=o.relative(v(g),v(p));return A.isWindows?y.toSlashes(c):c}let r=g.path||"/";const f=p.path||"/";if(this.a(g)){let c=0;for(const u=Math.min(r.length,f.length);c<u&&!(r.charCodeAt(c)!==f.charCodeAt(c)&&r.charAt(c).toLowerCase()!==f.charAt(c).toLowerCase());c++);r=f.substr(0,c)+r.substr(c)}return o.posix.relative(r,f)}resolvePath(g,p){if(g.scheme===L.Schemas.file){const r=T.URI.file(o.resolve(v(g),p));return g.with({authority:r.authority,path:r.path})}return p=y.toPosixPath(p),g.with({path:o.posix.resolve(g.path,p)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,p){return g===p||g!==void 0&&p!==void 0&&(0,k.equalsIgnoreCase)(g,p)}hasTrailingPathSeparator(g,p=o.sep){if(g.scheme===L.Schemas.file){const r=v(g);return r.length>y.getRoot(r).length&&r[r.length-1]===p}else{const r=g.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,p=o.sep){return(0,e.hasTrailingPathSeparator)(g,p)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,p=o.sep){let r=!1;if(g.scheme===L.Schemas.file){const f=v(g);r=f!==void 0&&f.length===y.getRoot(f).length&&f[f.length-1]===p}else{p="/";const f=g.path;r=f.length===1&&f.charCodeAt(f.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(g,p)?g.with({path:g.path+"/"}):g}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(d=>d.scheme===L.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new m(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(d,g){const p=[];for(let r=0;r<d.length;r++){const f=g(d[r]);d.some((c,u)=>u===r?!1:(0,e.isEqualOrParent)(f,g(c)))||p.push(d[r])}return p}e.distinctParents=R;var E;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function g(p){const r=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(u=>{const[I,O]=u.split(":");I&&O&&r.set(I,O)});const c=p.path.substring(0,p.path.indexOf(";"));return c&&r.set(d.META_DATA_MIME,c),r}d.parseMetaData=g})(E||(e.DataUri=E={}));function b(d,g,p){if(g){let r=d.path;return r&&r[0]!==o.posix.sep&&(r=o.posix.sep+r),d.with({scheme:p,authority:g,path:r})}return d.with({scheme:p})}e.toLocalResource=b}),define(pe[14],be([1,0,20,9,6,2,19,3,146]),function(le,e,y,L,o,A,k,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(z){return!!z&&typeof z.then=="function"}e.isThenable=m;function R(z){const P=new y.CancellationTokenSource,M=z(P.token),K=new Promise((te,j)=>{const W=P.token.onCancellationRequested(()=>{W.dispose(),P.dispose(),j(new L.CancellationError)});Promise.resolve(M).then(x=>{W.dispose(),P.dispose(),te(x)},x=>{W.dispose(),P.dispose(),j(x)})});return new class{cancel(){P.cancel()}then(te,j){return K.then(te,j)}catch(te){return this.then(void 0,te)}finally(te){return K.finally(te)}}}e.createCancelablePromise=R;function E(z,P,M){return new Promise((K,te)=>{const j=P.onCancellationRequested(()=>{j.dispose(),K(M)});z.then(K,te).finally(()=>j.dispose())})}e.raceCancellation=E;function b(z,P){return new Promise((M,K)=>{const te=P.onCancellationRequested(()=>{te.dispose(),K(new L.CancellationError)});z.then(M,K).finally(()=>te.dispose())})}e.raceCancellationError=b;async function d(z){let P=-1;const M=z.map((K,te)=>K.then(j=>(P=te,j)));try{return await Promise.race(M)}finally{z.forEach((K,te)=>{te!==P&&K.cancel()})}}e.raceCancellablePromises=d;function g(z,P,M){let K;const te=setTimeout(()=>{K?.(void 0),M?.()},P);return Promise.race([z.finally(()=>clearTimeout(te)),new Promise(j=>K=j)])}e.raceTimeout=g;function p(z){return new Promise((P,M)=>{const K=z();m(K)?K.then(P,M):P(K)})}e.asPromise=p;class r{constructor(){this.a=null,this.b=null,this.d=null}queue(P){if(this.a){if(this.d=P,!this.b){const M=()=>{this.b=null;const K=this.queue(this.d);return this.d=null,K};this.b=new Promise(K=>{this.a.then(M,M).then(K)})}return new Promise((M,K)=>{this.b.then(M,K)})}return this.a=P(),new Promise((M,K)=>{this.a.then(te=>{this.a=null,M(te)},te=>{this.a=null,K(te)})})}}e.Throttler=r;class f{constructor(){this.a=Promise.resolve(null)}queue(P){return this.a=this.a.then(()=>P(),()=>P())}}e.Sequencer=f;class c{constructor(){this.a=new Map}queue(P,M){const te=(this.a.get(P)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(P)===te&&this.a.delete(P)});return this.a.set(P,te),te}}e.SequencerByKey=c;const u=(z,P)=>{let M=!0;const K=setTimeout(()=>{M=!1,P()},z);return{isTriggered:()=>M,dispose:()=>{clearTimeout(K),M=!1}}},I=z=>{let P=!0;return queueMicrotask(()=>{P&&(P=!1,z())}),{isTriggered:()=>P,dispose:()=>{P=!1}}};class O{constructor(P){this.defaultDelay=P,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(P,M=this.defaultDelay){this.g=P,this.h(),this.b||(this.b=new Promise((te,j)=>{this.d=te,this.f=j}).then(()=>{if(this.b=null,this.d=null,this.g){const te=this.g;return this.g=null,te()}}));const K=()=>{this.a=null,this.d?.(null)};return this.a=M===v.MicrotaskDelay?I(K):u(M,K),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=O;class t{constructor(P){this.a=new O(P),this.b=new r}trigger(P,M){return this.a.trigger(()=>this.b.queue(P),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class n{constructor(){this.a=!1,this.b=new Promise((P,M)=>{this.d=P})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class s extends n{constructor(P){super(),this.f=setTimeout(()=>this.open(),P)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function i(z,P){return P?new Promise((M,K)=>{const te=setTimeout(()=>{j.dispose(),M()},z),j=P.onCancellationRequested(()=>{clearTimeout(te),j.dispose(),K(new L.CancellationError)})}):R(M=>i(z,M))}e.timeout=i;function a(z,P=0){const M=setTimeout(z,P);return(0,A.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=a;function l(z){const P=[];let M=0;const K=z.length;function te(){return M<K?z[M++]():null}function j(W){W!=null&&P.push(W);const x=te();return x?x.then(j):Promise.resolve(P)}return Promise.resolve(null).then(j)}e.sequence=l;function h(z,P=K=>!!K,M=null){let K=0;const te=z.length,j=()=>{if(K>=te)return Promise.resolve(M);const W=z[K++];return Promise.resolve(W()).then(H=>P(H)?Promise.resolve(H):j())};return j()}e.first=h;function C(z,P=K=>!!K,M=null){if(z.length===0)return Promise.resolve(M);let K=z.length;const te=()=>{K=-1;for(const j of z)j.cancel?.()};return new Promise((j,W)=>{for(const x of z)x.then(H=>{--K>=0&&P(H)?(te(),j(H)):K===0&&j(M)}).catch(H=>{--K>=0&&(te(),W(H))})})}e.firstParallel=C;class D{constructor(P){this.a=0,this.d=P,this.f=[],this.b=0,this.g=new o.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(P){return this.a++,new Promise((M,K)=>{this.f.push({factory:P,c:M,e:K}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const P=this.f.shift();this.b++;const M=P.factory();M.then(P.c,P.e),M.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=D;class w extends D{constructor(){super(1)}}e.Queue=w;class S{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const P=new U;return this.b.add(P),P.p}d(){for(const[,P]of this.a)if(P.size>0)return!1;return!0}queueFor(P,M=k.extUri){const K=M.getComparisonKey(P);let te=this.a.get(K);return te||(te=new w,o.Event.once(te.onDrained)(()=>{te?.dispose(),this.a.delete(K),this.f()}),this.a.set(K,te)),te}f(){this.d()&&this.g()}g(){for(const P of this.b)P.complete();this.b.clear()}dispose(){for(const[,P]of this.a)P.dispose();this.a.clear(),this.g()}}e.ResourceQueue=S;class N{constructor(P,M){this.a=-1,typeof P=="function"&&typeof M=="number"&&this.setIfNotSet(P,M)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(P,M){this.cancel(),this.a=setTimeout(()=>{this.a=-1,P()},M)}setIfNotSet(P,M){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,P()},M))}}e.TimeoutTimer=N;class ${constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(P,M){this.cancel(),this.a=setInterval(()=>{P()},M)}}e.IntervalTimer=$;class ee{constructor(P,M){this.b=-1,this.a=P,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(P=this.d){this.cancel(),this.b=setTimeout(this.f,P)}get delay(){return this.d}set delay(P){this.d=P}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=ee;class he{constructor(P,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=P,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(P=this.b){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(P/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=he;class oe extends ee{constructor(P,M){super(P,M),this.j=[]}work(P){this.j.push(P),this.isScheduled()||this.schedule()}h(){const P=this.j;this.j=[],this.a?.(P)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=oe;class ue extends A.Disposable{constructor(P,M){super(),this.g=P,this.h=M,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(P){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+P.length>this.g.maxBufferedWork)return!1}else if(this.pending+P.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const M of P)this.a.push(M);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=z=>{(0,T.setTimeout0)(()=>{if(P)return;const M=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let P=!1;return{dispose(){P||(P=!0)}}}:e.runWhenIdle=(z,P)=>{const M=requestIdleCallback(z,typeof P=="number"?{timeout:P}:void 0);let K=!1;return{dispose(){K||(K=!0,cancelIdleCallback(M))}}}}();class me{constructor(P){this.d=!1,this.a=()=>{try{this.f=P()}catch(M){this.g=M}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=me;async function _(z,P,M){let K;for(let te=0;te<M;te++)try{return await z()}catch(j){K=j,await i(P)}throw K}e.retry=_;class re{hasPending(P){return this.a?typeof P=="number"?this.a.taskId===P:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(P,M,K){return this.a={taskId:P,cancel:()=>K?.(),promise:M},M.then(()=>this.d(P),()=>this.d(P)),M}d(P){this.a&&P===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const P=this.b;this.b=void 0,P.run().then(P.promiseResolve,P.promiseReject)}}setNext(P){if(this.b)this.b.run=P;else{let M,K;const te=new Promise((j,W)=>{M=j,K=W});this.b={run:P,promise:te,promiseResolve:M,promiseReject:K}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=re;class q{constructor(P,M=()=>Date.now()){this.d=P,this.f=M,this.a=0,this.b=0}increment(){const P=this.f();return P-this.a>this.d&&(this.a=P,this.b=0),this.b++,this.b}}e.IntervalCounter=q;var J;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(J||(J={}));class U{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((P,M)=>{this.a=P,this.b=M})}complete(P){return new Promise(M=>{this.a(P),this.d={outcome:0,value:P},M()})}error(P){return new Promise(M=>{this.b(P),this.d={outcome:1,value:P},M()})}cancel(){return this.error(new L.CancellationError)}}e.DeferredPromise=U;var ne;(function(z){async function P(K){let te;const j=await Promise.all(K.map(W=>W.then(x=>x,x=>{te||(te=x)})));if(typeof te<"u")throw te;return j}z.settled=P;function M(K){return new Promise(async(te,j)=>{try{await K(te,j)}catch(W){j(W)}})}z.withAsyncBody=M})(ne||(e.Promises=ne={}));var V;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(V||(V={}));class se{static fromArray(P){return new se(M=>{M.emitMany(P)})}static fromPromise(P){return new se(async M=>{M.emitMany(await P)})}static fromPromises(P){return new se(async M=>{await Promise.all(P.map(async K=>M.emitOne(await K)))})}static merge(P){return new se(async M=>{await Promise.all(P.map(async K=>{for await(const te of K)M.emitOne(te)}))})}constructor(P){this.a=0,this.b=[],this.d=null,this.f=new o.Emitter,queueMicrotask(async()=>{const M={emitOne:K=>this.g(K),emitMany:K=>this.h(K),reject:K=>this.k(K)};try{await Promise.resolve(P(M)),this.j()}catch(K){this.k(K)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let P=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(P<this.b.length)return{done:!1,value:this.b[P++]};if(this.a===1)return{done:!0,value:void 0};await o.Event.toPromise(this.f.event)}while(!0)}}}static map(P,M){return new se(async K=>{for await(const te of P)K.emitOne(M(te))})}map(P){return se.map(this,P)}static filter(P,M){return new se(async K=>{for await(const te of P)M(te)&&K.emitOne(te)})}filter(P){return se.filter(this,P)}static coalesce(P){return se.filter(P,M=>!!M)}coalesce(){return se.coalesce(this)}static async toPromise(P){const M=[];for await(const K of P)M.push(K);return M}toPromise(){return se.toPromise(this)}g(P){this.a===0&&(this.b.push(P),this.f.fire())}h(P){this.a===0&&(this.b=this.b.concat(P),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(P){this.a===0&&(this.a=2,this.d=P,this.f.fire())}}e.AsyncIterableObject=se,se.EMPTY=se.fromArray([]);class Y extends se{constructor(P,M){super(M),this.l=P}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Y;function ie(z){const P=new y.CancellationTokenSource,M=z(P.token);return new Y(P,async K=>{const te=P.token.onCancellationRequested(()=>{te.dispose(),P.dispose(),K.reject(new L.CancellationError)});try{for await(const j of M){if(P.token.isCancellationRequested)return;K.emitOne(j)}te.dispose(),P.dispose()}catch(j){te.dispose(),P.dispose(),K.reject(j)}})}e.createCancelableAsyncIterable=ie}),define(pe[74],be([1,0,18,14,38,28,7,3,17]),function(le,e,y,L,o,A,k,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",E="[^/\\\\]",b=/\//g;function d(q,J){switch(q){case 0:return"";case 1:return`${E}*?`;default:return`(?:${R}|${E}+${R}${J?`|${R}${E}+`:""})*?`}}function g(q,J){if(!q)return[];const U=[];let ne=!1,V=!1,se="";for(const Y of q){switch(Y){case J:if(!ne&&!V){U.push(se),se="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":V=!0;break;case"]":V=!1;break}se+=Y}return se&&U.push(se),U}e.splitGlobAware=g;function p(q){if(!q)return"";let J="";const U=g(q,e.GLOB_SPLIT);if(U.every(ne=>ne===e.GLOBSTAR))J=".*";else{let ne=!1;U.forEach((V,se)=>{if(V===e.GLOBSTAR){if(ne)return;J+=d(2,se===U.length-1)}else{let Y=!1,ie="",z=!1,P="";for(const M of V){if(M!=="}"&&Y){ie+=M;continue}if(z&&(M!=="]"||!P)){let K;M==="-"?K=M:(M==="^"||M==="!")&&!P?K="^":M===e.GLOB_SPLIT?K="":K=(0,v.escapeRegExpCharacters)(M),P+=K;continue}switch(M){case"{":Y=!0;continue;case"[":z=!0;continue;case"}":{const te=`(?:${g(ie,",").map(j=>p(j)).join("|")})`;J+=te,Y=!1,ie="";break}case"]":{J+="["+P+"]",z=!1,P="";break}case"?":J+=E;continue;case"*":J+=d(1);continue;default:J+=(0,v.escapeRegExpCharacters)(M)}}se<U.length-1&&(U[se+1]!==e.GLOBSTAR||se+2<U.length)&&(J+=R)}ne=V===e.GLOBSTAR})}return J}const r=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,I=/^\*\*((\/[\w\.-]+)+)\/?$/,O=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),n=function(){return!1},s=function(){return null};function i(q,J){if(!q)return s;let U;typeof q!="string"?U=q.pattern:U=q,U=U.trim();const ne=`${U}_${!!J.trimForExclusions}`;let V=t.get(ne);if(V)return a(V,q);let se;return r.test(U)?V=h(U.substr(4),U):(se=f.exec(l(U,J)))?V=C(se[1],U):(J.trimForExclusions?u:c).test(U)?V=D(U,J):(se=I.exec(l(U,J)))?V=w(se[1].substr(1),U,!0):(se=O.exec(l(U,J)))?V=w(se[1],U,!1):V=S(U),t.set(ne,V),a(V,q)}function a(q,J){if(typeof J=="string")return q;const U=function(ne,V){return(0,o.isEqualOrParent)(ne,J.base,!T.isLinux)?q((0,v.ltrim)(ne.substr(J.base.length),k.sep),V):null};return U.allBasenames=q.allBasenames,U.allPaths=q.allPaths,U.basenames=q.basenames,U.patterns=q.patterns,U}function l(q,J){return J.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function h(q,J){return function(U,ne){return typeof U=="string"&&U.endsWith(q)?J:null}}function C(q,J){const U=`/${q}`,ne=`\\${q}`,V=function(Y,ie){return typeof Y!="string"?null:ie?ie===q?J:null:Y===q||Y.endsWith(U)||Y.endsWith(ne)?J:null},se=[q];return V.basenames=se,V.patterns=[J],V.allBasenames=se,V}function D(q,J){const U=_(q.slice(1,-1).split(",").map(ie=>i(ie,J)).filter(ie=>ie!==s),q),ne=U.length;if(!ne)return s;if(ne===1)return U[0];const V=function(ie,z){for(let P=0,M=U.length;P<M;P++)if(U[P](ie,z))return q;return null},se=U.find(ie=>!!ie.allBasenames);se&&(V.allBasenames=se.allBasenames);const Y=U.reduce((ie,z)=>z.allPaths?ie.concat(z.allPaths):ie,[]);return Y.length&&(V.allPaths=Y),V}function w(q,J,U){const ne=k.sep===k.posix.sep,V=ne?q:q.replace(b,k.sep),se=k.sep+V,Y=k.posix.sep+q;let ie;return U?ie=function(z,P){return typeof z=="string"&&(z===V||z.endsWith(se)||!ne&&(z===q||z.endsWith(Y)))?J:null}:ie=function(z,P){return typeof z=="string"&&(z===V||!ne&&z===q)?J:null},ie.allPaths=[(U?"*/":"./")+q],ie}function S(q){try{const J=new RegExp(`^${p(q)}$`);return function(U){return J.lastIndex=0,typeof U=="string"&&J.test(U)?q:null}}catch{return s}}function N(q,J,U){return!q||typeof J!="string"?!1:$(q)(J,void 0,U)}e.match=N;function $(q,J={}){if(!q)return n;if(typeof q=="string"||ee(q)){const U=i(q,J);if(U===s)return n;const ne=function(V,se){return!!U(V,se)};return U.allBasenames&&(ne.allBasenames=U.allBasenames),U.allPaths&&(ne.allPaths=U.allPaths),ne}return ue(q,J)}e.parse=$;function ee(q){const J=q;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.isRelativePattern=ee;function he(q){return q.allBasenames||[]}e.getBasenameTerms=he;function oe(q){return q.allPaths||[]}e.getPathTerms=oe;function ue(q,J){const U=_(Object.getOwnPropertyNames(q).map(ie=>me(ie,q[ie],J)).filter(ie=>ie!==s)),ne=U.length;if(!ne)return s;if(!U.some(ie=>!!ie.requiresSiblings)){if(ne===1)return U[0];const ie=function(M,K){let te;for(let j=0,W=U.length;j<W;j++){const x=U[j](M,K);if(typeof x=="string")return x;(0,L.isThenable)(x)&&(te||(te=[]),te.push(x))}return te?(async()=>{for(const j of te){const W=await j;if(typeof W=="string")return W}return null})():null},z=U.find(M=>!!M.allBasenames);z&&(ie.allBasenames=z.allBasenames);const P=U.reduce((M,K)=>K.allPaths?M.concat(K.allPaths):M,[]);return P.length&&(ie.allPaths=P),ie}const V=function(ie,z,P){let M,K;for(let te=0,j=U.length;te<j;te++){const W=U[te];W.requiresSiblings&&P&&(z||(z=(0,k.basename)(ie)),M||(M=z.substr(0,z.length-(0,k.extname)(ie).length)));const x=W(ie,z,M,P);if(typeof x=="string")return x;(0,L.isThenable)(x)&&(K||(K=[]),K.push(x))}return K?(async()=>{for(const te of K){const j=await te;if(typeof j=="string")return j}return null})():null},se=U.find(ie=>!!ie.allBasenames);se&&(V.allBasenames=se.allBasenames);const Y=U.reduce((ie,z)=>z.allPaths?ie.concat(z.allPaths):ie,[]);return Y.length&&(V.allPaths=Y),V}function me(q,J,U){if(J===!1)return s;const ne=i(q,U);if(ne===s)return s;if(typeof J=="boolean")return ne;if(J){const V=J.when;if(typeof V=="string"){const se=(Y,ie,z,P)=>{if(!P||!ne(Y,ie))return null;const M=V.replace("$(basename)",()=>z),K=P(M);return(0,L.isThenable)(K)?K.then(te=>te?q:null):K?q:null};return se.requiresSiblings=!0,se}}return ne}function _(q,J){const U=q.filter(ie=>!!ie.basenames);if(U.length<2)return q;const ne=U.reduce((ie,z)=>{const P=z.basenames;return P?ie.concat(P):ie},[]);let V;if(J){V=[];for(let ie=0,z=ne.length;ie<z;ie++)V.push(J)}else V=U.reduce((ie,z)=>{const P=z.patterns;return P?ie.concat(P):ie},[]);const se=function(ie,z){if(typeof ie!="string")return null;if(!z){let M;for(M=ie.length;M>0;M--){const K=ie.charCodeAt(M-1);if(K===47||K===92)break}z=ie.substr(M)}const P=ne.indexOf(z);return P!==-1?V[P]:null};se.basenames=ne,se.patterns=V,se.allBasenames=ne;const Y=q.filter(ie=>!ie.basenames);return Y.push(se),Y}function re(q,J){return(0,y.equals)(q,J,(U,ne)=>typeof U=="string"&&typeof ne=="string"?U===ne:typeof U!="string"&&typeof ne!="string"?U.base===ne.base&&U.pattern===ne.pattern:!1)}e.patternsEquals=re}),define(pe[99],be([1,0,9,147,19,17,4]),function(le,e,y,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class v{constructor(f="",c=!1){if(this.value=f,typeof this.value!="string")throw(0,y.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(f,c=0){return this.value+=b(this.supportThemeIcons?(0,L.escapeIcons)(f):f).replace(/([ \t]+)/g,(u,I)=>"&nbsp;".repeat(I.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,c){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(f,c,u){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(f),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(f,c){const u=new RegExp((0,A.escapeRegExpCharacters)(c),"g");return f.replace(u,(I,O)=>f.charAt(O-1)!=="\\"?`\\${I}`:I)}}e.MarkdownString=v;function m(r){return R(r)?!r.value:Array.isArray(r)?r.every(m):!0}e.isEmptyMarkdownString=m;function R(r){return r instanceof v?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function E(r,f){return r===f?!0:!r||!f?!1:r.value===f.value&&r.isTrusted===f.isTrusted&&r.supportThemeIcons===f.supportThemeIcons&&r.supportHtml===f.supportHtml&&(r.baseUri===f.baseUri||!!r.baseUri&&!!f.baseUri&&(0,o.isEqual)(k.URI.from(r.baseUri),k.URI.from(f.baseUri)))}e.markdownStringEqual=E;function b(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=b;function d(r){return r.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=d;function g(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=g;function p(r){const f=[],c=r.split("|").map(I=>I.trim());r=c[0];const u=c[1];if(u){const I=/height=(\d+)/.exec(u),O=/width=(\d+)/.exec(u),t=I?I[1]:"",n=O?O[1]:"",s=isFinite(parseInt(n)),i=isFinite(parseInt(t));s&&f.push(`width="${n}"`),i&&f.push(`height="${t}"`)}return{href:r,dimensions:f}}e.parseHrefAndDimensions=p}),define(pe[149],be([1,0,18,38,7,3,19,17]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function v(i,a){const{os:l,tildify:h,relative:C}=a;if(C){const S=m(i,C,l);if(typeof S=="string")return S}let D=i.fsPath;if(l===1&&!A.isWindows?D=D.replace(/\//g,"\\"):l!==1&&A.isWindows&&(D=D.replace(/\\/g,"/")),l!==1&&h?.userHome){const S=h.userHome.fsPath;let N;i.scheme!==h.userHome.scheme&&i.path.startsWith(o.posix.sep)?N=h.userHome.with({path:i.path}).fsPath:N=i.fsPath,D=b(N,S,l)}return(l===1?o.win32:o.posix).normalize(R(D,l===1))}e.getPathLabel=v;function m(i,a,l){const h=l===1?o.win32:o.posix,C=l===3?k.extUri:k.extUriIgnorePathCase,D=a.getWorkspace(),w=(0,y.firstOrDefault)(D.folders);if(!w)return;i.scheme!==w.uri.scheme&&i.path.startsWith(o.posix.sep)&&(i=w.uri.with({path:i.path}));const S=a.getWorkspaceFolder(i);if(!S)return;let N;if(C.isEqual(S.uri,i)?N="":N=C.relativePath(S.uri,i)??"",N&&(N=h.normalize(N)),D.folders.length>1&&!a.noPrefix){const $=S.name?S.name:C.basenameOrAuthority(S.uri);N=N?`${$} \u2022 ${N}`:$}return N}function R(i,a=A.isWindows){return(0,L.hasDriveLetter)(i,a)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=R;let E=Object.create(null);function b(i,a,l=A.OS){if(l===1||!i||!a)return i;let h=E.original===a?E.normalized:void 0;h||(h=a,A.isWindows&&(h=(0,L.toSlashes)(h)),h=`${(0,T.rtrim)(h,o.posix.sep)}${o.posix.sep}`,E={original:a,normalized:h});let C=i;return A.isWindows&&(C=(0,L.toSlashes)(C)),(l===3?C.startsWith(h):(0,T.startsWithIgnoreCase)(C,h))?`~/${C.substr(h.length)}`:i}e.tildify=b;function d(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=d;const g="\u2026",p="\\\\",r="~";function f(i,a=o.sep){const l=new Array(i.length);let h=!1;for(let C=0;C<i.length;C++){const D=i[C];if(D===""){l[C]=`.${a}`;continue}if(!D){l[C]=D;continue}h=!0;let w="",S=D;S.indexOf(p)===0?(w=S.substr(0,S.indexOf(p)+p.length),S=S.substr(S.indexOf(p)+p.length)):S.indexOf(a)===0?(w=S.substr(0,S.indexOf(a)+a.length),S=S.substr(S.indexOf(a)+a.length)):S.indexOf(r)===0&&(w=S.substr(0,S.indexOf(r)+r.length),S=S.substr(S.indexOf(r)+r.length));const N=S.split(a);for(let $=1;h&&$<=N.length;$++)for(let ee=N.length-$;h&&ee>=0;ee--){h=!1;let he=N.slice(ee,ee+$).join(a);for(let oe=0;!h&&oe<i.length;oe++)if(oe!==C&&i[oe]&&i[oe].indexOf(he)>-1){const ue=ee+$===N.length,me=ee>0&&i[oe].indexOf(a)>-1?a+he:he,_=i[oe].endsWith(me);h=!ue||_}if(!h){let oe="";(N[0].endsWith(":")||w!=="")&&(ee===1&&(ee=0,$++,he=N[0]+a+he),ee>0&&(oe=N[0]+a),oe=w+oe),ee>0&&(oe=oe+g+a),oe=oe+he,ee+$<N.length&&(oe=oe+a+g),l[C]=oe}}h&&(l[C]=D)}return l}e.shorten=f;var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function u(i,a=Object.create(null)){const l=[];let h=!1,C="";for(const D of i)if(D==="$"||h&&D==="{")C&&l.push({value:C,type:c.TEXT}),C="",h=!0;else if(D==="}"&&h){const w=a[C];if(typeof w=="string")w.length&&l.push({value:w,type:c.VARIABLE});else if(w){const S=l[l.length-1];(!S||S.type!==c.SEPARATOR)&&l.push({value:w.label,type:c.SEPARATOR})}C="",h=!1}else C+=D;return C&&!h&&l.push({value:C,type:c.TEXT}),l.filter((D,w)=>{if(D.type===c.SEPARATOR){const S=l[w-1],N=l[w+1];return[S,N].every($=>$&&($.type===c.VARIABLE||$.type===c.TEXT)&&$.value.length>0)}return!0}).map(D=>D.value).join("")}e.template=u;function I(i,a){return A.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=I;function O(i,a){return A.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=O;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function n(i){if(i.endsWith("]")){const a=i.lastIndexOf(" [",i.length-2);if(a!==-1){const l=s(i.substring(0,a));return{name:l.name,parentPath:l.parentPath+i.substring(a)}}}return s(i)}e.splitRecentLabel=n;function s(i){const a=i.indexOf("/")!==-1?o.posix:o.win32,l=a.basename(i),h=a.dirname(i);return l.length?{name:l,parentPath:h}:{name:h,parentPath:""}}}),define(pe[50],be([1,0,15,4]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function o(E){return E.toJSON()}class A{constructor(b){this.a=b}transformIncoming(b){const d=this.a.transformIncoming(b);return d===b?b:o(L.URI.from(d))}transformOutgoing(b){const d=this.a.transformOutgoing(b);return d===b?b:o(L.URI.from(d))}transformOutgoingURI(b){const d=this.a.transformOutgoing(b);return d===b?b:L.URI.from(d)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function k(E,b,d){if(!E||d>200)return null;if(typeof E=="object"){if(E instanceof L.URI)return b.transformOutgoing(E);for(const g in E)if(Object.hasOwnProperty.call(E,g)){const p=k(E[g],b,d+1);p!==null&&(E[g]=p)}}return null}function T(E,b){const d=k(E,b,0);return d===null?E:d}e.transformOutgoingURIs=T;function v(E,b,d,g){if(!E||g>200)return null;if(typeof E=="object"){if(E.$mid===1)return d?L.URI.revive(b.transformIncoming(E)):b.transformIncoming(E);if(E instanceof y.VSBuffer)return null;for(const p in E)if(Object.hasOwnProperty.call(E,p)){const r=v(E[p],b,d,g+1);r!==null&&(E[p]=r)}}return null}function m(E,b){const d=v(E,b,!1,0);return d===null?E:d}e.transformIncomingURIs=m;function R(E,b){const d=v(E,b,!0,0);return d===null?E:d}e.transformAndReviveIncomingURIs=R}),define(pe[21],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(o){return y.test(o)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let o;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?o=crypto.getRandomValues.bind(crypto):o=function(T){for(let v=0;v<T.length;v++)T[v]=Math.floor(Math.random()*256);return T};const A=new Uint8Array(16),k=[];for(let T=0;T<256;T++)k.push(T.toString(16).padStart(2,"0"));return function(){o(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let v=0,m="";return m+=k[A[v++]],m+=k[A[v++]],m+=k[A[v++]],m+=k[A[v++]],m+="-",m+=k[A[v++]],m+=k[A[v++]],m+="-",m+=k[A[v++]],m+=k[A[v++]],m+="-",m+=k[A[v++]],m+=k[A[v++]],m+="-",m+=k[A[v++]],m+=k[A[v++]],m+=k[A[v++]],m+=k[A[v++]],m+=k[A[v++]],m+=k[A[v++]],m}}()}),define(pe[150],be([1,0,18,46,21]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function A(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}e.createStringDataTransferItem=A;function k(E,b,d){const g={id:(0,o.generateUuid)(),name:E,uri:b,data:d};return{asString:async()=>"",asFile:()=>g,value:void 0}}e.createFileDataTransferItem=k;class T{constructor(){this.a=new Map}get size(){let b=0;for(const d of this.a)b++;return b}has(b){return this.a.has(this.b(b))}matches(b){const d=[...this.a.keys()];return L.Iterable.some(this,([g,p])=>p.asFile())&&d.push("files"),R(v(b),d)}get(b){return this.a.get(this.b(b))?.[0]}append(b,d){const g=this.a.get(b);g?g.push(d):this.a.set(this.b(b),[d])}replace(b,d){this.a.set(this.b(b),[d])}delete(b){this.a.delete(this.b(b))}*[Symbol.iterator](){for(const[b,d]of this.a)for(const g of d)yield[b,g]}b(b){return v(b)}}e.VSDataTransfer=T;function v(E){return E.toLowerCase()}function m(E,b){return R(v(E),b.map(v))}e.matchesMimeType=m;function R(E,b){if(E==="*/*")return b.length>0;if(b.includes(E))return!0;const d=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!d)return!1;const[g,p,r]=d;return r==="*"?b.some(f=>f.startsWith(p+"/")):!1}e.UriList=Object.freeze({create:E=>(0,y.distinct)(E.map(b=>b.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.UriList.split(E).filter(b=>!b.startsWith("#"))})}),function(){"use strict";function le(e,y,L){function o(d){return new Promise(g=>y.exists(d,g))}function A(d){return new Promise((g,p)=>{const r=new Date;y.utimes(d,r,r,f=>f?p(f):g())})}function k(d){return new Promise((g,p)=>y.mkdir(d,{recursive:!0},r=>r&&r.code!=="EEXIST"?p(r):g(d)))}function T(d){return new Promise((g,p)=>y.rm(d,{recursive:!0,force:!0,maxRetries:3},r=>r?p(r):g()))}function v(d){return new Promise((g,p)=>y.readFile(d,"utf8",(r,f)=>r?p(r):g(f)))}function m(d,g){return new Promise((p,r)=>y.writeFile(d,g,"utf8",f=>f?r(f):p()))}async function R(d){const g=e.join(d,"languagepacks.json");try{return JSON.parse(await v(g))}catch{}}function E(d,g){try{for(;g;){if(d[g])return g;{const p=g.lastIndexOf("-");if(p>0)g=g.substring(0,p);else return}}}catch(p){console.error("Resolving language pack configuration failed.",p)}}function b(d,g,p,r,f){const c=function(I){return L.mark("code/didGenerateNls"),Promise.resolve({locale:I,osLocale:f,availableLanguages:{}})};if(L.mark("code/willGenerateNls"),r==="pseudo")return Promise.resolve({locale:r,osLocale:f,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:r,osLocale:f,availableLanguages:{}});if(r&&(r==="en"||r==="en-us"))return Promise.resolve({locale:r,osLocale:f,availableLanguages:{}});const u=r;try{return d?R(g).then(I=>{if(!I)return c(u);const O=E(I,r);if(!O)return c(u);r=O;const t=I[r];let n;return!t||typeof t.hash!="string"||!t.translations||typeof(n=t.translations.vscode)!="string"?c(u):o(n).then(s=>{if(!s)return c(u);const i=t.hash+"."+r,a=e.join(g,"clp",i),l=e.join(a,d),h=e.join(a,"tcf.json"),C=e.join(a,"corrupted.info"),D={locale:u,osLocale:f,availableLanguages:{"*":r},_languagePackId:i,_translationsConfigFile:h,_cacheRoot:a,_resolvedLanguagePackCoreLocation:l,_corruptedFile:C};return o(C).then(w=>{let S;return w?S=T(a):S=Promise.resolve(void 0),S.then(()=>o(l).then(N=>N?(A(l).catch(()=>{}),L.mark("code/didGenerateNls"),D):k(l).then(()=>Promise.all([v(p),v(n)])).then($=>{const ee=JSON.parse($[0]),he=JSON.parse($[1]).contents,oe=Object.keys(ee.bundles),ue=[];for(const me of oe){const _=ee.bundles[me],re=Object.create(null);for(const q of _){const J=ee.keys[q],U=ee.messages[q],ne=he[q];let V;if(ne){V=[];for(let se=0;se<J.length;se++){const Y=J[se],ie=typeof Y=="string"?Y:Y.key;let z=ne[ie];z===void 0&&(z=U[se]),V.push(z)}}else V=U;re[q]=V}ue.push(m(e.join(l,me.replace(/\//g,"!")+".nls.json"),JSON.stringify(re)))}return ue.push(m(h,JSON.stringify(t.translations))),Promise.all(ue)}).then(()=>(L.mark("code/didGenerateNls"),D)).catch($=>(console.error("Generating translation files failed.",$),c(r)))))})})}):c(u)}catch(I){return console.error("Generating translation files failed.",I),c(r)}}return{getNLSConfiguration:b}}if(typeof define=="function")define(pe[151],be([75,33,42]),function(e,y,L){return le(e,y,L)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("fs"),L=require("../common/performance");module.exports=le(e,y,L)}else throw new Error("Unknown context")}(),define(pe[152],be([1,0,26]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function o(k){const T=k.replace(/\-/g,":").toLowerCase();return!L.has(T)}function A(){const k=(0,y.networkInterfaces)();for(const T in k){const v=k[T];if(v){for(const{mac:m}of v)if(o(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(pe[100],be([1,0,26,61,21,152]),function(le,e,y,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(m){return this.a||(this.a=L.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,R=0;const E=(0,y.networkInterfaces)();for(const b in E){const d=E[b];if(d)for(const{mac:g,internal:p}of d)p||(R+=1,this.c(g.toUpperCase())&&(m+=1))}this.b=R>0?m/R:0}return this.b}};let k;async function T(m){return k||(k=(async()=>await v(m)||o.generateUuid())()),k}e.getMachineId=T;async function v(m){try{const R=await new Promise((b,d)=>{le(["crypto"],b,d)}),E=(0,A.getMac)();return R.createHash("sha256").update(E,"utf8").digest("hex")}catch(R){m(R);return}}}),define(pe[23],be([1,0,33,26,295,14,38,96,7,3,19,4]),function(le,e,y,L,o,A,k,T,v,m,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(ue){ue[ue.UNLINK=0]="UNLINK",ue[ue.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function d(ue,me=b.UNLINK,_){if((0,k.isRootOrDriveLetter)(ue))throw new Error("rimraf - will refuse to recursively delete root");return me===b.UNLINK?p(ue):g(ue,_)}async function g(ue,me=(0,k.randomPath)((0,L.tmpdir)())){try{try{await y.promises.rename(ue,me)}catch(_){return _.code==="ENOENT"?void 0:p(ue)}p(me).catch(_=>{})}catch(_){if(_.code!=="ENOENT")throw _}}async function p(ue){return(0,o.promisify)(y.rm)(ue,{recursive:!0,force:!0,maxRetries:3})}function r(ue){if((0,k.isRootOrDriveLetter)(ue))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(ue,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function f(ue,me){return I(await(me?c(ue):(0,o.promisify)(y.readdir)(ue)))}async function c(ue){try{return await(0,o.promisify)(y.readdir)(ue,{withFileTypes:!0})}catch(re){console.warn("[node.js fs] readdir with filetypes failed with error: ",re)}const me=[],_=await f(ue);for(const re of _){let q=!1,J=!1,U=!1;try{const ne=await e.Promises.lstat((0,v.join)(ue,re));q=ne.isFile(),J=ne.isDirectory(),U=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}me.push({name:re,isFile:()=>q,isDirectory:()=>J,isSymbolicLink:()=>U})}return me}function u(ue){return I(y.readdirSync(ue))}e.readdirSync=u;function I(ue){return ue.map(me=>typeof me=="string"?m.isMacintosh?(0,T.normalizeNFC)(me):me:(me.name=m.isMacintosh?(0,T.normalizeNFC)(me.name):me.name,me))}async function O(ue){const me=await f(ue),_=[];for(const re of me)await n.existsDirectory((0,v.join)(ue,re))&&_.push(re);return _}function t(ue,me=1e3){return new Promise(_=>{let re=!1;const q=setInterval(()=>{re||(re=!0,y.access(ue,J=>{re=!1,J&&(clearInterval(q),_(void 0))}))},me)})}e.whenDeleted=t;var n;(function(ue){async function me(q){let J;try{if(J=await e.Promises.lstat(q),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(m.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw ne}throw U}}ue.stat=me;async function _(q){try{const{stat:J,symbolicLink:U}=await ue.stat(q);return J.isFile()&&U?.dangling!==!0}catch{}return!1}ue.existsFile=_;async function re(q){try{const{stat:J,symbolicLink:U}=await ue.stat(q);return J.isDirectory()&&U?.dangling!==!0}catch{}return!1}ue.existsDirectory=re})(n||(e.SymlinkSupport=n={}));const s=new A.ResourceQueue;function i(ue,me,_){return s.queueFor(E.URI.file(ue),R.extUriBiasedIgnorePathCase).queue(()=>{const re=D(_);return new Promise((q,J)=>h(ue,me,re,U=>U?J(U):q()))})}let a=!0;function l(ue){a=ue}e.configureFlushOnWrite=l;function h(ue,me,_,re){if(!a)return y.writeFile(ue,me,{mode:_.mode,flag:_.flag},re);y.open(ue,_.flag,_.mode,(q,J)=>{if(q)return re(q);y.writeFile(J,me,U=>{if(U)return y.close(J,()=>re(U));y.fdatasync(J,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),l(!1)),y.close(J,V=>re(V))))})})}function C(ue,me,_){const re=D(_);if(!a)return y.writeFileSync(ue,me,{mode:re.mode,flag:re.flag});const q=y.openSync(ue,re.flag,re.mode);try{y.writeFileSync(q,me);try{y.fdatasyncSync(q)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),l(!1)}}finally{y.closeSync(q)}}e.writeFileSync=C;function D(ue){return ue?{mode:typeof ue.mode=="number"?ue.mode:438,flag:typeof ue.flag=="string"?ue.flag:"w"}:{mode:438,flag:"w"}}async function w(ue,me){if(ue!==me)try{await e.Promises.rename(ue,me)}catch(_){if(ue.toLowerCase()!==me.toLowerCase()&&_.code==="EXDEV"||ue.endsWith("."))await S(ue,me,{preserveSymlinks:!1}),await d(ue,b.MOVE);else throw _}}async function S(ue,me,_){return $(ue,me,{root:{source:ue,target:me},options:_,handledSourcePaths:new Set})}const N=511;async function $(ue,me,_){if(_.handledSourcePaths.has(ue))return;_.handledSourcePaths.add(ue);const{stat:re,symbolicLink:q}=await n.stat(ue);if(q){if(_.options.preserveSymlinks)try{return await oe(ue,me,_)}catch(J){console.warn("[node.js fs] copy of symlink failed: ",J)}if(q.dangling)return}return re.isDirectory()?ee(ue,me,re.mode&N,_):he(ue,me,re.mode&N)}async function ee(ue,me,_,re){await e.Promises.mkdir(me,{recursive:!0,mode:_});const q=await f(ue);for(const J of q)await $((0,v.join)(ue,J),(0,v.join)(me,J),re)}async function he(ue,me,_){await e.Promises.copyFile(ue,me),await e.Promises.chmod(me,_)}async function oe(ue,me,_){let re=await e.Promises.readlink(ue);(0,k.isEqualOrParent)(re,_.root.source,!m.isLinux)&&(re=(0,v.join)(_.root.target,re.substr(_.root.source.length+1))),await e.Promises.symlink(re,me)}e.Promises=new class{get access(){return(0,o.promisify)(y.access)}get stat(){return(0,o.promisify)(y.stat)}get lstat(){return(0,o.promisify)(y.lstat)}get utimes(){return(0,o.promisify)(y.utimes)}get read(){return(ue,me,_,re,q)=>new Promise((J,U)=>{y.read(ue,me,_,re,q,(ne,V,se)=>ne?U(ne):J({bytesRead:V,buffer:se}))})}get readFile(){return(0,o.promisify)(y.readFile)}get write(){return(ue,me,_,re,q)=>new Promise((J,U)=>{y.write(ue,me,_,re,q,(ne,V,se)=>ne?U(ne):J({bytesWritten:V,buffer:se}))})}get appendFile(){return(0,o.promisify)(y.appendFile)}get fdatasync(){return(0,o.promisify)(y.fdatasync)}get truncate(){return(0,o.promisify)(y.truncate)}get rename(){return(0,o.promisify)(y.rename)}get copyFile(){return(0,o.promisify)(y.copyFile)}get open(){return(0,o.promisify)(y.open)}get close(){return(0,o.promisify)(y.close)}get symlink(){return(0,o.promisify)(y.symlink)}get readlink(){return(0,o.promisify)(y.readlink)}get chmod(){return(0,o.promisify)(y.chmod)}get mkdir(){return(0,o.promisify)(y.mkdir)}get unlink(){return(0,o.promisify)(y.unlink)}get rmdir(){return(0,o.promisify)(y.rmdir)}get realpath(){return(0,o.promisify)(y.realpath)}async exists(ue){try{return await e.Promises.access(ue),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return O}get writeFile(){return i}get rm(){return d}get move(){return w}get copy(){return S}}}),define(pe[153],be([1,0,33,7,3,17,23]),function(le,e,y,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(b){if(o.isLinux)return b;const d=(0,L.dirname)(b);if(b===d)return b;const g=((0,L.basename)(b)||b).toLowerCase();try{const r=(0,k.readdirSync)(d).filter(f=>f.toLowerCase()===g);if(r.length===1){const f=T(d);if(f)return(0,L.join)(f,r[0])}else if(r.length>1){const f=r.indexOf(g);if(f>=0){const c=T(d);if(c)return(0,L.join)(c,r[f])}}}catch{}return null}e.realcaseSync=T;async function v(b){if(o.isLinux)return b;const d=(0,L.dirname)(b);if(b===d)return b;const g=((0,L.basename)(b)||b).toLowerCase();try{const r=(await k.Promises.readdir(d)).filter(f=>f.toLowerCase()===g);if(r.length===1){const f=await v(d);if(f)return(0,L.join)(f,r[0])}else if(r.length>1){const f=r.indexOf(g);if(f>=0){const c=await v(d);if(c)return(0,L.join)(c,r[f])}}}catch{}return null}e.realcase=v;async function m(b){try{return await k.Promises.realpath(b)}catch{const g=E(b);return await k.Promises.access(g,y.constants.R_OK),g}}e.realpath=m;function R(b){try{return y.realpathSync(b)}catch{const g=E(b);return y.accessSync(g,y.constants.R_OK),g}}e.realpathSync=R;function E(b){return(0,A.rtrim)((0,L.normalize)(b),L.sep)}}),define(pe[154],be([1,0,76]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(T,v,m,R=1){let E=!1;return new Promise(b=>{const d=setTimeout(()=>{if(!E)return E=!0,b(0)},m);o(T,v,R,g=>{if(!E)return E=!0,clearTimeout(d),b(g)})})}e.findFreePort=L;function o(T,v,m,R){if(v===0)return R(0);const E=new y.Socket;E.once("connect",()=>(k(E),o(T+m,v-1,m,R))),E.once("data",()=>{}),E.once("error",b=>(k(E),b.code!=="ECONNREFUSED"?o(T+m,v-1,m,R):R(T))),E.connect(T,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(T,v,m,R="127.0.0.1"){let E=!1,b,d=1;const g=y.createServer({pauseOnConnect:!0});function p(r,f){E||(E=!0,g.removeAllListeners(),g.close(),b&&clearTimeout(b),f(r))}return new Promise(r=>{b=setTimeout(()=>{p(0,r)},m),g.on("listening",()=>{p(T,r)}),g.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&d<v?(T++,d++,g.listen(T,R)):p(0,r)}),g.on("close",()=>{p(0,r)}),g.listen(T,R)})}e.findFreePortFaster=A;function k(T){try{T.removeAllListeners("connect"),T.removeAllListeners("error"),T.end(),T.destroy(),T.unref()}catch(v){console.error(v)}}}),define(pe[101],be([1,0,26,7,23]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,k=/^Microsoft.PowerShell_.*/,T=/^Microsoft.PowerShellPreview_.*/;var v;(function(I){I[I.x64=0]="x64",I[I.x86=1]="x86",I[I.ARM=2]="ARM"})(v||(v={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class E{constructor(O,t,n){this.exePath=O,this.displayName=t,this.a=n}async exists(){return this.a===void 0&&(this.a=await o.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:I=!1}={}){return I?m===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:I=!1,findPreview:O=!1}={}){const t=b({useAlternateBitness:I});if(!t)return null;const n=L.join(t,"PowerShell");if(!await o.SymlinkSupport.existsDirectory(n))return null;let s=-1,i=null;for(const h of await o.Promises.readdir(n)){let C=-1;if(O){const w=h.indexOf("-");if(w<0)continue;const S=h.substring(0,w);if(!A.test(S)||h.substring(w+1)!=="preview")continue;C=parseInt(S,10)}else{if(!A.test(h))continue;C=parseInt(h,10)}if(C<=s)continue;const D=L.join(n,h,"pwsh.exe");await o.SymlinkSupport.existsFile(D)&&(i=D,s=C)}if(!i)return null;const a=t.includes("x86")?" (x86)":"",l=O?" Preview":"";return new E(i,`PowerShell${l}${a}`,!0)}async function g({findPreview:I}={}){if(!process.env.LOCALAPPDATA)return null;const O=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await o.SymlinkSupport.existsDirectory(O))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=I?{pwshMsixDirRegex:T,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const s of await o.Promises.readdir(O))if(t.test(s)){const i=L.join(O,s,"pwsh.exe");return new E(i,n)}return null}function p(){const I=L.join(y.homedir(),".dotnet","tools","pwsh.exe");return new E(I,".NET Core PowerShell Global Tool")}function r(){const I=L.join(process.env.windir,m===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(I,"Windows PowerShell",!0)}async function*f(){let I=await d();I&&(yield I),I=await d({useAlternateBitness:!0}),I&&(yield I),I=await g(),I&&(yield I),I=p(),I&&(yield I),I=await d({findPreview:!0}),I&&(yield I),I=await g({findPreview:!0}),I&&(yield I),I=await d({useAlternateBitness:!0,findPreview:!0}),I&&(yield I),I=r(),I&&(yield I)}async function*c(){for await(const I of f())await I.exists()&&(yield I)}e.enumeratePowerShellInstallations=c;async function u(){for await(const I of c())return I;return null}e.getFirstAvailablePowerShellInstallation=u}),define(pe[102],be([1,0,7,3,29,59,8,23]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function v(E=o.env){return E.comspec||"cmd.exe"}e.getWindowsShell=v;function m(E){let b=[],d=!1;const g=function(p){if(d){b.push(p);return}(!E.send(p,f=>{if(f&&console.error(f),d=!1,b.length>0){const c=b.slice(0);b=[],c.forEach(u=>g(u))}})||L.isWindows)&&(d=!0)};return{send:g}}e.createQueuedSender=m;var R;(function(E){async function b(d,g,p){if(y.isAbsolute(d))return d;if(g===void 0&&(g=o.cwd()),y.dirname(d)!=="."||(p===void 0&&k.isString(o.env.PATH)&&(p=o.env.PATH.split(y.delimiter)),p===void 0||p.length===0))return y.join(g,d);async function f(c){if(await T.Promises.exists(c)){let u;try{u=await T.Promises.stat(c)}catch(I){I.message.startsWith("EACCES")&&(u=await T.Promises.lstat(c))}return u?!u.isDirectory():!1}return!1}for(const c of p){let u;if(y.isAbsolute(c)?u=y.join(c,d):u=y.join(g,c,d),await f(u))return u;let I=u+".com";if(await f(I)||(I=u+".exe",await f(I)))return I}return y.join(g,d)}E.findExecutable=b})(R||(e.win32=R={}))}),define(pe[103],be([1,0,51,13]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function o(k){return new Promise((T,v)=>{let m;const R=new Map;function E(d,g,p,r,f){const c=R.get(g);if(d===k||c){const u={name:b(p),cmd:p,pid:d,ppid:g,load:r,mem:f};R.set(d,u),d===k&&(m=u),c&&(c.children||(c.children=[]),c.children.push(u),c.children.length>1&&(c.children=c.children.sort((I,O)=>I.pid-O.pid)))}}function b(d){const g=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,r=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,c=/conhost\.exe/i,u=/--type=([a-zA-Z-]+)/;if(r.exec(d))return"electron-crash-reporter";if(f.exec(d))return"winpty-process";if(c.exec(d))return"console-window-host (Windows internal process)";let I=u.exec(d);if(I&&I.length===2)return I[1]==="renderer"?"window":I[1]==="utility"?g.exec(d)?"utility-network-service":"utility-process":I[1]==="extensionHost"?"extension-host":I[1];const O=/[a-zA-Z-]+\.js/g;let t="";do I=O.exec(d),I&&(t+=I+" ");while(I);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${t})`:p.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substr(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substr(5):g;new Promise((g,p)=>{le(["@vscode/windows-process-tree"],g,p)}).then(g=>{g.getProcessList(k,p=>{if(!p){v(new Error(`Root process ${k} not found`));return}g.getProcessCpuUsage(p,r=>{const f=new Map;r.forEach(c=>{const u=d(c.commandLine||"");f.set(c.pid,{name:b(u),cmd:u,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),m=f.get(k),m?(f.forEach(c=>{const u=f.get(c.ppid);u&&(u.children||(u.children=[]),u.children.push(c))}),f.forEach(c=>{c.children&&(c.children=c.children.sort((u,I)=>u.pid-I.pid))}),T(m)):v(new Error(`Root process ${k} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let d=function(){let g=[m];const p=[];for(;g.length;){const f=g.shift();f&&(p.push(f.pid),f.children&&(g=g.concat(f.children)))}let r=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);r+=" "+p.join(" "),(0,y.exec)(r,{},(f,c,u)=>{if(f||u)v(f||new Error(u.toString()));else{const I=c.toString().split(`
`);for(let O=0;O<p.length;O++){const t=R.get(p[O]);t.load=parseFloat(I[O])}if(!m){v(new Error(`Root process ${k} not found`));return}T(m)}})};(0,y.exec)("which ps",{},(g,p,r)=>{if(g||r)if(process.platform!=="linux")v(g||new Error(r.toString()));else{const f=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,y.exec)(f,{},(c,u,I)=>{c||I?v(c||new Error(I.toString())):(A(u,E),d())})}else{const f=p.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${f} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,I,O)=>{u||O&&!O.includes("screen size is bogus")?v(u||new Error(O.toString())):(A(I,E),process.platform==="linux"?d():m?T(m):v(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=o;function A(k,T){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=k.toString().split(`
`);for(const R of m){const E=v.exec(R.trim());E&&E.length===6&&T(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(pe[155],be([1,0,26,3,101,102]),function(le,e,y,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function k(E,b){return E===1?L.isWindows?R():A.getWindowsShell(b):v(E,b)}e.getSystemShell=k;let T=null;function v(E,b){if(L.isLinux&&E===2||L.isMacintosh&&E===3)return"/bin/bash";if(!T){let d;if(L.isWindows)d="/bin/bash";else{if(d=b.SHELL,!d)try{d=(0,y.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}T=d}return T}let m=null;async function R(){return m||(m=(await(0,o.getFirstAvailablePowerShellInstallation)()).exePath),m}}),function(){function le(){function e(){return process.uncHostAllowlist}function y(v){const m=new Set;if(Array.isArray(v))for(const R of v)typeof R=="string"&&m.add(R);return Array.from(m)}function L(){const v=e();return v?Array.from(v):[]}function o(v){if(process.platform!=="win32")return;const m=e();if(m)if(typeof v=="string")m.add(v.toLowerCase());else for(const R of y(v))o(R)}function A(v){if(typeof v!="string")return;const m=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let R;for(const E of m){if(v.indexOf(E)!==0)continue;const d=v.indexOf("\\",E.length);if(d===-1)continue;const g=v.substring(E.length,d);if(g){R=g;break}}return R}function k(){process.platform==="win32"&&(process.enableUNCAccessChecks=!1)}function T(){return process.platform!=="win32"?!0:process.enableUNCAccessChecks===!1}return{getUNCHostAllowlist:L,addUNCHostToAllowlist:o,getUNCHost:A,disableUNCAccessRestrictions:k,isUNCAccessRestrictionsDisabled:T}}typeof define=="function"?define("vs/base/node/unc",[],function(){return le()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=le():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}();var Le=this&&this.__decorate||function(le,e,y,L){var o=arguments.length,A=o<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,y):L,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(le,e,y,L);else for(var T=le.length-1;T>=0;T--)(k=le[T])&&(A=(o<3?k(A):o>3?k(e,y,A):k(e,y))||A);return o>3&&A&&Object.defineProperty(e,y,A),A};define(pe[43],be([1,0,18,14,15,20,92,9,6,2,49,17,8]),function(le,e,y,L,o,A,k,T,v,m,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(d||(d={}));function g(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(p||(p={}));function r(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(f||(f={}));function c(J){let U=0;for(let ne=0;;ne+=7){const V=J.read(1);if(U|=(V.buffer[0]&127)<<ne,!(V.buffer[0]&128))return U}}const u=s(0);function I(J,U){if(U===0){J.write(u);return}let ne=0;for(let se=U;se!==0;se=se>>>7)ne++;const V=o.VSBuffer.alloc(ne);for(let se=0;U!==0;se++)V.buffer[se]=U&127,U=U>>>7,U>0&&(V.buffer[se]|=128);J.write(V)}class O{constructor(U){this.b=U,this.a=0}read(U){const ne=this.b.slice(this.a,this.a+U);return this.a+=ne.byteLength,ne}}e.BufferReader=O;class t{constructor(){this.a=[]}get buffer(){return o.VSBuffer.concat(this.a)}write(U){this.a.push(U)}}e.BufferWriter=t;var n;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(n||(n={}));function s(J){const U=o.VSBuffer.alloc(1);return U.writeUInt8(J,0),U}const i={Undefined:s(n.Undefined),String:s(n.String),Buffer:s(n.Buffer),VSBuffer:s(n.VSBuffer),Array:s(n.Array),Object:s(n.Object),Uint:s(n.Int)},a=typeof Buffer<"u";function l(J,U){if(typeof U>"u")J.write(i.Undefined);else if(typeof U=="string"){const ne=o.VSBuffer.fromString(U);J.write(i.String),I(J,ne.byteLength),J.write(ne)}else if(a&&Buffer.isBuffer(U)){const ne=o.VSBuffer.wrap(U);J.write(i.Buffer),I(J,ne.byteLength),J.write(ne)}else if(U instanceof o.VSBuffer)J.write(i.VSBuffer),I(J,U.byteLength),J.write(U);else if(Array.isArray(U)){J.write(i.Array),I(J,U.length);for(const ne of U)l(J,ne)}else if(typeof U=="number"&&(U|0)===U)J.write(i.Uint),I(J,U);else{const ne=o.VSBuffer.fromString(JSON.stringify(U));J.write(i.Object),I(J,ne.byteLength),J.write(ne)}}e.serialize=l;function h(J){switch(J.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return J.read(c(J)).toString();case n.Buffer:return J.read(c(J)).buffer;case n.VSBuffer:return J.read(c(J));case n.Array:{const ne=c(J),V=[];for(let se=0;se<ne;se++)V.push(h(J));return V}case n.Object:return JSON.parse(J.read(c(J)).toString());case n.Int:return c(J)}}e.deserialize=h;class C{constructor(U,ne,V=null,se=1e3){this.h=U,this.j=ne,this.k=V,this.l=se,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(U,ne){this.b.set(U,ne),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const ne=this.o([U.type]);this.k?.logOutgoing(ne,0,1,r(U.type));return}case 201:case 202:case 204:case 203:{const ne=this.o([U.type,U.id],U.data);this.k?.logOutgoing(ne,U.id,1,r(U.type),U.data);return}}}o(U,ne=void 0){const V=new t;return l(V,U),l(V,ne),this.p(V.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const ne=new O(U),V=h(ne),se=h(ne),Y=V[0];switch(Y){case 100:return this.k?.logIncoming(U.byteLength,V[1],1,`${g(Y)}: ${V[2]}.${V[3]}`,se),this.s({type:Y,id:V[1],channelName:V[2],name:V[3],arg:se});case 102:return this.k?.logIncoming(U.byteLength,V[1],1,`${g(Y)}: ${V[2]}.${V[3]}`,se),this.t({type:Y,id:V[1],channelName:V[2],name:V[3],arg:se});case 101:return this.k?.logIncoming(U.byteLength,V[1],1,`${g(Y)}`),this.u({type:Y,id:V[1]});case 103:return this.k?.logIncoming(U.byteLength,V[1],1,`${g(Y)}`),this.u({type:Y,id:V[1]})}}s(U){const ne=this.b.get(U.channelName);if(!ne){this.v(U);return}const V=new A.CancellationTokenSource;let se;try{se=ne.call(this.j,U.name,U.arg,V.token)}catch(z){se=Promise.reject(z)}const Y=U.id;se.then(z=>{this.m({id:Y,data:z,type:201}),this.d.delete(U.id)},z=>{z instanceof Error?this.m({id:Y,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:Y,data:z,type:203}),this.d.delete(U.id)});const ie=(0,m.toDisposable)(()=>V.cancel());this.d.set(U.id,ie)}t(U){const ne=this.b.get(U.channelName);if(!ne){this.v(U);return}const V=U.id,Y=ne.listen(this.j,U.name,U.arg)(ie=>this.m({id:V,data:ie,type:204}));this.d.set(U.id,Y)}u(U){const ne=this.d.get(U.id);ne&&(ne.dispose(),this.d.delete(U.id))}v(U){let ne=this.g.get(U.channelName);ne||(ne=[],this.g.set(U.channelName,ne));const V=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ne.push({request:U,timeoutTimer:V})}w(U){const ne=this.g.get(U);if(ne){for(const V of ne)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.s(V.request);break;case 102:this.t(V.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=C;var D;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class w{constructor(U,ne=null){this.l=U,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=ne}getChannel(U){const ne=this;return{call(V,se,Y){return ne.a?Promise.reject(new T.CancellationError):ne.m(U,V,se,Y)},listen(V,se){return ne.a?v.Event.None:ne.o(U,V,se)}}}m(U,ne,V,se=A.CancellationToken.None){const Y=this.g++,z={id:Y,type:100,channelName:U,name:ne,arg:V};if(se.isCancellationRequested)return Promise.reject(new T.CancellationError);let P;return new Promise((K,te)=>{if(se.isCancellationRequested)return te(new T.CancellationError);const j=()=>{const Q=G=>{switch(G.type){case 201:this.f.delete(Y),K(G.data);break;case 202:{this.f.delete(Y);const Z=new Error(G.data.message);Z.stack=Array.isArray(G.data.stack)?G.data.stack.join(`
`):G.data.stack,Z.name=G.data.name,te(Z);break}case 203:this.f.delete(Y),te(G.data);break}};this.f.set(Y,Q),this.p(z)};let W=null;this.b===f.Idle?j():(W=(0,L.createCancelablePromise)(Q=>this.u()),W.then(()=>{W=null,j()}));const x=()=>{W?(W.cancel(),W=null):this.p({id:Y,type:101}),te(new T.CancellationError)},H=se.onCancellationRequested(x);P=(0,m.combinedDisposable)((0,m.toDisposable)(x),H),this.d.add(P)}).finally(()=>{this.d.delete(P)})}o(U,ne,V){const se=this.g++,ie={id:se,type:102,channelName:U,name:ne,arg:V};let z=null;const P=new v.Emitter({onWillAddFirstListener:()=>{z=(0,L.createCancelablePromise)(K=>this.u()),z.then(()=>{z=null,this.d.add(P),this.p(ie)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(P),this.p({id:se,type:103}))}}),M=K=>P.fire(K.data);return this.f.set(se,M),P.event}p(U){switch(U.type){case 100:case 102:{const ne=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(ne,U.id,0,`${g(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const ne=this.q([U.type,U.id]);this.j?.logOutgoing(ne,U.id,0,g(U.type));return}}}q(U,ne=void 0){const V=new t;return l(V,U),l(V,ne),this.r(V.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const ne=new O(U),V=h(ne),se=h(ne),Y=V[0];switch(Y){case 200:return this.j?.logIncoming(U.byteLength,0,0,r(Y)),this.t({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,V[1],0,r(Y),se),this.t({type:V[0],id:V[1],data:se})}}t(U){if(U.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelClient=w,Le([k.memoize],w.prototype,"onDidInitializePromise",null);class S{get connections(){const U=[];return this.f.forEach(ne=>U.push(ne)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new v.Emitter,this.onDidAddConnection=this.g.event,this.h=new v.Emitter,this.onDidRemoveConnection=this.h.event,U(({protocol:ne,onDidClientDisconnect:V})=>{v.Event.once(ne.onMessage)(Y=>{const ie=new O(Y),z=h(ie),P=new C(ne,z),M=new w(ne);this.a.forEach((te,j)=>P.registerChannel(j,te));const K={channelServer:P,channelClient:M,ctx:z};this.f.add(K),this.g.fire(K),V(()=>{P.dispose(),M.dispose(),this.f.delete(K),this.h.fire(K)})})})}getChannel(U,ne){const V=this;return{call(se,Y,ie){let z;if((0,b.isFunction)(ne)){const M=(0,y.getRandomElement)(V.connections.filter(ne));z=M?Promise.resolve(M):v.Event.toPromise(v.Event.filter(V.onDidAddConnection,ne))}else z=ne.routeCall(V,se,Y);const P=z.then(M=>M.channelClient.getChannel(U));return $(P).call(se,Y,ie)},listen(se,Y){if((0,b.isFunction)(ne))return V.j(U,ne,se,Y);const ie=ne.routeEvent(V,se,Y).then(z=>z.channelClient.getChannel(U));return $(ie).listen(se,Y)}}}j(U,ne,V,se){const Y=this;let ie=new m.DisposableStore;const z=new v.Emitter({onWillAddFirstListener:()=>{ie=new m.DisposableStore;const P=new v.EventMultiplexer,M=new Map,K=j=>{const x=j.channelClient.getChannel(U).listen(V,se),H=P.add(x);M.set(j,H)},te=j=>{const W=M.get(j);W&&(W.dispose(),M.delete(j))};Y.connections.filter(ne).forEach(K),v.Event.filter(Y.onDidAddConnection,ne)(K,void 0,ie),Y.onDidRemoveConnection(te,void 0,ie),P.event(z.fire,z,ie),ie.add(P)},onDidRemoveLastListener:()=>{ie.dispose()}});return z.event}registerChannel(U,ne){this.a.set(U,ne),this.f.forEach(V=>{V.channelServer.registerChannel(U,ne)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=S;class N{constructor(U,ne,V=null){const se=new t;l(se,ne),U.send(se.buffer),this.a=new w(U,V),this.d=new C(U,ne,V)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,ne){this.d.registerChannel(U,ne)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function $(J){return{call(U,ne,V){return J.then(se=>se.call(U,ne,V))},listen(U,ne){const V=new v.Relay;return J.then(se=>V.input=se.listen(U,ne)),V.event}}}e.getDelayedChannel=$;function ee(J){let U=!1;return{call(ne,V,se){return U?J.call(ne,V,se):(0,L.timeout)(0).then(()=>U=!0).then(()=>J.call(ne,V,se))},listen(ne,V){if(U)return J.listen(ne,V);const se=new v.Relay;return(0,L.timeout)(0).then(()=>U=!0).then(()=>se.input=J.listen(ne,V)),se.event}}}e.getNextTickChannel=ee;class he{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const ne of U.connections)if(await Promise.resolve(this.a(ne.ctx)))return Promise.resolve(ne);return await v.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.StaticRouter=he;var oe;(function(J){function U(Y,ie){const z=Y,P=ie&&ie.disableMarshalling,M=new Map;for(const K in z)V(K)&&M.set(K,v.Event.buffer(z[K],!0));return new class{listen(K,te,j){const W=M.get(te);if(W)return W;if(se(te)){const x=z[te];if(typeof x=="function")return x.call(z,j)}throw new Error(`Event not found: ${te}`)}call(K,te,j){const W=z[te];if(typeof W=="function"){if(!P&&Array.isArray(j))for(let x=0;x<j.length;x++)j[x]=(0,R.revive)(j[x]);return W.apply(z,j)}throw new Error(`Method not found: ${te}`)}}}J.fromService=U;function ne(Y,ie){const z=ie&&ie.disableMarshalling;return new Proxy({},{get(P,M){if(typeof M=="string")return ie?.properties?.has(M)?ie.properties.get(M):se(M)?function(K){return Y.listen(M,K)}:V(M)?Y.listen(M):async function(...K){let te;ie&&!(0,b.isUndefinedOrNull)(ie.context)?te=[ie.context,...K]:te=K;const j=await Y.call(M,te);return z?j:(0,R.revive)(j)};throw new Error(`Property not found: ${String(M)}`)}})}J.toService=ne;function V(Y){return Y[0]==="o"&&Y[1]==="n"&&E.isUpperAsciiLetter(Y.charCodeAt(2))}function se(Y){return/^onDynamic/.test(Y)&&E.isUpperAsciiLetter(Y.charCodeAt(9))}})(oe||(e.ProxyChannel=oe={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function me(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const U=J.toString();if(U!=="[object Object]")return U}return J}function _(J){return Array.isArray(J)?J.map(me):me(J)}function re(J,U,ne,V,se,Y,ie){ie=_(ie);const z=ue[se],P=z[V%z.length];let M=[`%c[${J}]%c[${String(U).padStart(7," ")}]%c[len: ${String(ne).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(Y)?(M=M.concat(ie),M.push(")")):M.push(ie),console.log.apply(console,M)}class q{constructor(U,ne){this.d=U,this.f=ne,this.a=0,this.b=0}logOutgoing(U,ne,V,se,Y){this.b+=U,re(this.d,this.b,U,ne,V,se,Y)}logIncoming(U,ne,V,se,Y){this.a+=U,re(this.f,this.a,U,ne,V,se,Y)}}e.IPCLogger=q}),define(pe[104],be([1,0,14,15,6,2,43]),function(le,e,y,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(w){w.Created="created",w.Read="read",w.Write="write",w.Open="open",w.Error="error",w.Close="close",w.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",w.NodeEndReceived="nodeEndReceived",w.NodeEndSent="nodeEndSent",w.NodeDrainBegin="nodeDrainBegin",w.NodeDrainEnd="nodeDrainEnd",w.zlibInflateError="zlibInflateError",w.zlibInflateData="zlibInflateData",w.zlibInflateInitialWrite="zlibInflateInitialWrite",w.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",w.zlibInflateWrite="zlibInflateWrite",w.zlibInflateFlushFired="zlibInflateFlushFired",w.zlibDeflateError="zlibDeflateError",w.zlibDeflateData="zlibDeflateData",w.zlibDeflateWrite="zlibDeflateWrite",w.zlibDeflateFlushFired="zlibDeflateFlushFired",w.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",w.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",w.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",w.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",w.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",w.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",w.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",w.ProtocolHeaderRead="protocolHeaderRead",w.ProtocolMessageRead="protocolMessageRead",w.ProtocolHeaderWrite="protocolHeaderWrite",w.ProtocolMessageWrite="protocolMessageWrite",w.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var v;(function(w){w.enableDiagnostics=!1,w.records=[];const S=new WeakMap;let N=0;function $(he,oe){if(!S.has(he)){const ue=String(++N);S.set(he,ue)}return S.get(he)}function ee(he,oe,ue,me){if(!w.enableDiagnostics)return;const _=$(he,oe);if(me instanceof L.VSBuffer||me instanceof Uint8Array||me instanceof ArrayBuffer||ArrayBuffer.isView(me)){const re=L.VSBuffer.alloc(me.byteLength);re.set(me),w.records.push({timestamp:Date.now(),id:_,label:oe,type:ue,buff:re})}else w.records.push({timestamp:Date.now(),id:_,label:oe,type:ue,data:me})}w.traceSocketEvent=ee})(v||(e.SocketDiagnostics=v={}));var m;(function(w){w[w.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",w[w.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m||(e.SocketCloseEventType=m={}));let R=null;function E(){return R||(R=L.VSBuffer.alloc(0)),R}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(S){this.a.push(S),this.b+=S.byteLength}read(S){return this.c(S,!0)}peek(S){return this.c(S,!1)}c(S,N){if(S===0)return E();if(S>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===S){const oe=this.a[0];return N&&(this.a.shift(),this.b-=S),oe}if(this.a[0].byteLength>S){const oe=this.a[0].slice(0,S);return N&&(this.a[0]=this.a[0].slice(S),this.b-=S),oe}const $=L.VSBuffer.alloc(S);let ee=0,he=0;for(;S>0;){const oe=this.a[he];if(oe.byteLength>S){const ue=oe.slice(0,S);$.set(ue,ee),ee+=S,N&&(this.a[he]=oe.slice(S),this.b-=S),S-=S}else $.set(oe,ee),ee+=oe.byteLength,N?(this.a.shift(),this.b-=oe.byteLength):he++,S-=oe.byteLength}return $}}e.ChunkStream=b;var d;(function(w){w[w.None=0]="None",w[w.Regular=1]="Regular",w[w.Control=2]="Control",w[w.Ack=3]="Ack",w[w.Disconnect=5]="Disconnect",w[w.ReplayRequest=6]="ReplayRequest",w[w.Pause=7]="Pause",w[w.Resume=8]="Resume",w[w.KeepAlive=9]="KeepAlive",w[w.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",w[w.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(d||(d={}));function g(w){switch(w){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var p;(function(w){w[w.HeaderLength=13]="HeaderLength",w[w.AcknowledgeTime=2e3]="AcknowledgeTime",w[w.TimeoutTime=2e4]="TimeoutTime",w[w.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",w[w.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",w[w.KeepAliveSendTime=5e3]="KeepAliveSendTime",w[w.LatencySampleTime=6e4]="LatencySampleTime",w[w.LatencySampleCount=5]="LatencySampleCount",w[w.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",w[w.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(p||(e.ProtocolConstants=p={}));class r{constructor(S,N,$,ee){this.type=S,this.id=N,this.ack=$,this.data=ee,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends A.Disposable{constructor(S){super(),this.f=this.B(new o.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=S,this.b=!1,this.c=new b,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(S){if(!(!S||S.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(S);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,ee=this.g.id,he=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new r($,ee,he,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(S){this.k=null,this.a=!1,this.b=!1,this.c=S,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(S){if(this.a)return;S.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=L.VSBuffer.alloc(13);N.writeUInt8(S.type,0),N.writeUInt32BE(S.id,1),N.writeUInt32BE(S.ack,5),N.writeUInt32BE(S.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:g(S.type),id:S.id,ack:S.ack,messageSize:S.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",S.data),this.j(N,S.data)}g(S,N){const $=this.f===0;return this.d.push(S,N),this.f+=S.byteLength+N.byteLength,$}h(){const S=L.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,S}j(S,N){this.g(S,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const S=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:S.byteLength}),this.c.write(S)}}class u extends A.Disposable{constructor(S){super(),this.f=new o.Emitter,this.onMessage=this.f.event,this.g=new o.Emitter,this.onDidDispose=this.g.event,this.a=S,this.b=this.B(new c(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(S){this.b.write(new r(1,0,0,S))}}e.Protocol=u;class I extends k.IPCClient{static fromSocket(S,N){return new I(new u(S),N)}get onDidDispose(){return this.b.onDidDispose}constructor(S,N,$=null){super(S,N,$),this.b=S}dispose(){super.dispose();const S=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),S.end()}}e.Client=I;class O{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new o.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(S){this.b?this.d.length>0?this.d.push(S):this.a.fire(S):this.d.push(S)}flushBuffer(){this.d=[]}}e.BufferedEmitter=O;class t{constructor(S){this.data=S,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let S=0,N=this.a;for(;N;)N=N.next,S++;return S}peek(){return this.a?this.a.data:null}toArray(){const S=[];let N=0,$=this.a;for(;$;)S[N++]=$.data,$=$.next;return S}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(S){const N=new t(S);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const S=Date.now();for(let N=0;N<s.a;N++)this.c[N]=S-1e3*N;setInterval(()=>{for(let N=s.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const S=Date.now(),N=(1+s.a)*1e3;let $=0;for(let ee=0;ee<s.a;ee++)S-this.c[ee]<=N&&$++;return 1-$/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;var i;(function(w){w[w.Good=0]="Good",w[w.Poor=1]="Poor"})(i||(e.ConnectionHealth=i={}));function a(w){switch(w){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=a;class l{constructor(S){this.connectionHealth=S}}e.ConnectionHealthChangedEvent=l;class h{constructor(S,N){this.roundTripTime=S,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=h;class C{get unacknowledgedCount(){return this.c-this.d}constructor(S){this.x=new O,this.onControlMessage=this.x.event,this.y=new O,this.onMessage=this.y.event,this.z=new O,this.onDidDispose=this.z.event,this.A=new O,this.onSocketClose=this.A.event,this.B=new O,this.onSocketTimeout=this.B.event,this.C=new O,this.onHighRoundTripTime=this.C.event,this.D=new O,this.onDidChangeConnectionHealth=this.D.event,this.u=S.loadEstimator??s.getInstance(),this.v=S.measureRoundTripTime??!1,this.w=S.sendKeepAlive??!0,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new A.DisposableStore,this.o=S.socket,this.p=this.t.add(new c(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new D),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),S.initialChunk&&this.q.acceptChunk(S.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const S=new r(5,0,0,E());this.p.write(S),this.p.flush()}sendPause(){const S=new r(7,0,0,E());this.p.write(S)}sendResume(){const S=new r(8,0,0,E());this.p.write(S)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(S,N){this.a=!0,this.t.dispose(),this.t=new A.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=S,this.p=this.t.add(new c(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage($=>this.E($))),this.t.add(this.o.onClose($=>this.A.fire($))),this.r=this.t.add(new D),this.t.add(this.r.onSendLatencyRequest($=>this.J($))),this.t.add(this.r.onHighRoundTripTime($=>this.C.fire($))),this.t.add(this.r.onDidChangeConnectionHealth($=>this.D.fire($))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const S=new r(3,0,this.h,E());this.p.write(S);const N=this.b.toArray();for(let $=0,ee=N.length;$<ee;$++)this.p.write(N[$]);this.G()}acceptDisconnect(){this.z.fire()}E(S){if(S.ack>this.d){this.d=S.ack;do{const N=this.b.peek();if(N&&N.id<=S.ack)this.b.pop();else break}while(!0)}switch(S.type){case 0:break;case 1:{if(S.id>this.g)if(S.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new r(6,0,0,E())))}else this.g=S.id,this.j=Date.now(),this.F(),this.y.fire(S.data);break}case 2:{this.x.fire(S.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let $=0,ee=N.length;$<ee;$++)this.p.write(N[$]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(S.data);break}case 11:{this.r.handleResponse(S.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(S){const N=++this.c;this.h=this.g;const $=new r(1,N,this.h,S);this.b.push($),this.a||(this.p.write($),this.G())}sendControl(S){const N=new r(2,0,0,S);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const S=Date.now()-this.j;if(S>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-S+5)}G(){if(this.c<=this.d||this.f||this.a)return;const S=this.b.peek(),N=Date.now()-S.writtenTime,$=Date.now()-this.q.lastReadTime,ee=Date.now()-this.n;if(N>=2e4&&$>=2e4&&ee>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:$});return}const he=Math.max(2e4-N,2e4-$,2e4-ee,500);this.f=setTimeout(()=>{this.f=null,this.G()},he)}H(){if(this.g<=this.h)return;this.h=this.g;const S=new r(3,0,this.h,E());this.p.write(S)}I(){this.h=this.g;const S=new r(9,0,this.h,E());this.p.write(S)}J(S){this.h=this.g;const N=new r(10,0,this.h,S);this.p.write(N)}K(S){this.h=this.g;const N=new r(11,0,this.h,S);this.p.write(N)}}e.PersistentProtocol=C;class D extends A.Disposable{constructor(){super(),this.a=this.B(new o.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new o.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new o.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new y.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},S=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const S=++this.h,N=L.VSBuffer.alloc(4);N.writeUInt32BE(S,0),this.a.fire(N)},6e4)}handleResponse(S){if(S.byteLength!==4)return;const N=S.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const $=Date.now()-this.g,ee=this.k++;this.j[ee%this.j.length]=$;const he=this.l,oe=this.j.filter(ue=>ue>=1e3).length;this.l=oe>=3?1:0,$>1e3&&this.b.fire(new h($,oe)),he!==this.l&&this.c.fire(this.l)}}}),define(pe[105],be([1,0,51,14,15,20,148,9,6,2,22,102,59,43]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends d.ChannelServer{constructor(f){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",c=>o.VSBuffer.wrap(Buffer.from(c,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=g;class p{constructor(f,c){this.i=f,this.j=c,this.c=new Set,this.g=new Map,this.h=new v.Emitter,this.onDidProcessExit=this.h.event;const u=c&&c.timeout?c.timeout:6e4;this.b=new L.Delayer(u),this.d=null,this.f=null}getChannel(f){const c=this;return{call(u,I,O){return c.k(f,u,I,O)},listen(u,I){return c.l(f,u,I)}}}k(f,c,u,I=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(I.isCancellationRequested)return Promise.reject(T.canceled());this.b.cancel();const O=this.n(f),t=(0,L.createCancelablePromise)(i=>O.call(c,u,i)),n=I.onCancellationRequested(()=>t.cancel()),s=(0,m.toDisposable)(()=>t.cancel());return this.c.add(s),t.finally(()=>{n.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,c,u){if(!this.b)return v.Event.None;this.b.cancel();let I;const O=new v.Emitter({onWillAddFirstListener:()=>{I=this.n(f).listen(c,u)(O.fire,O),this.c.add(I)},onDidRemoveLastListener:()=>{this.c.delete(I),I.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return O.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],c=Object.create(null);c.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(c.env={...c.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(c.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,b.removeDangerousEnvVariables)(c.env),this.d=(0,y.fork)(this.i,f,c);const u=new v.Emitter;v.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,k.isRemoteConsoleLog)(a)){(0,k.log)(a,`IPC Library: ${this.j.serverName}`);return}u.fire(o.VSBuffer.wrap(Buffer.from(a,"base64")))});const O=this.j.useQueue?(0,E.createQueuedSender)(this.d):this.d,t=a=>this.d&&this.d.connected&&O.send(a.buffer.toString("base64")),n=u.event,s={send:t,onMessage:n};this.f=new d.ChannelClient(s);const i=()=>this.o();process.once("exit",i),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,l)=>{process.removeListener("exit",i),this.c.forEach(h=>(0,m.dispose)(h)),this.c.clear(),a!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:l})})}return this.f}n(f){let c=this.g.get(f);return c||(c=this.m.getChannel(f),this.g.set(f,c)),c}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=p}),define(pe[156],be([1,0,14,6,2,49,8]),function(le,e,y,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function v(b){const d=b;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=v;var m;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(m||(e.StorageState=m={}));class R extends o.Disposable{constructor(d,g=Object.create(null)){super(),this.m=d,this.n=g,this.b=this.B(new L.Emitter),this.onDidChangeStorage=this.b.event,this.c=m.None,this.f=new Map,this.g=new y.ThrottledDelayer(R.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(d=>this.r(d)))}r(d){d.changed?.forEach((g,p)=>this.s(p,g)),d.deleted?.forEach(g=>this.s(g,void 0))}s(d,g){if(this.c===m.Closed)return;let p=!1;(0,k.isUndefinedOrNull)(g)?p=this.f.delete(d):this.f.get(d)!==g&&(this.f.set(d,g),p=!0),p&&this.b.fire(d)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===m.None&&(this.c=m.Initialized,this.n.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(d,g){const p=this.f.get(d);return(0,k.isUndefinedOrNull)(p)?g:p}getBoolean(d,g){const p=this.get(d);return(0,k.isUndefinedOrNull)(p)?g:p==="true"}getNumber(d,g){const p=this.get(d);return(0,k.isUndefinedOrNull)(p)?g:parseInt(p,10)}getObject(d,g){const p=this.get(d);return(0,k.isUndefinedOrNull)(p)?g:(0,A.parse)(p)}async set(d,g){if(this.c===m.Closed)return;if((0,k.isUndefinedOrNull)(g))return this.delete(d);const p=(0,k.isObject)(g)||Array.isArray(g)?(0,A.stringify)(g):String(g);if(this.f.get(d)!==p)return this.f.set(d,p),this.j.set(d,p),this.h.delete(d),this.b.fire(d),this.w()}async delete(d){if(!(this.c===m.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire(d),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=m.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(d).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(d){if(this.u)return this.w(d)}async w(d){return this.g.trigger(()=>this.v(),d)}async whenFlushed(){if(this.u)return new Promise(d=>this.l.push(d))}isInMemory(){return this.n.hint===T.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=R,R.a=100;class E{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((g,p)=>this.a.set(p,g)),d.delete?.forEach(g=>this.a.delete(g))}async close(){}}e.InMemoryStorageDatabase=E}),define(pe[106],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class y{constructor(o,A){this.lineNumber=o,this.column=A}with(o=this.lineNumber,A=this.column){return o===this.lineNumber&&A===this.column?this:new y(o,A)}delta(o=0,A=0){return this.with(this.lineNumber+o,this.column+A)}equals(o){return y.equals(this,o)}static equals(o,A){return!o&&!A?!0:!!o&&!!A&&o.lineNumber===A.lineNumber&&o.column===A.column}isBefore(o){return y.isBefore(this,o)}static isBefore(o,A){return o.lineNumber<A.lineNumber?!0:A.lineNumber<o.lineNumber?!1:o.column<A.column}isBeforeOrEqual(o){return y.isBeforeOrEqual(this,o)}static isBeforeOrEqual(o,A){return o.lineNumber<A.lineNumber?!0:A.lineNumber<o.lineNumber?!1:o.column<=A.column}static compare(o,A){const k=o.lineNumber|0,T=A.lineNumber|0;if(k===T){const v=o.column|0,m=A.column|0;return v-m}return k-T}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(o){return new y(o.lineNumber,o.column)}static isIPosition(o){return o&&typeof o.lineNumber=="number"&&typeof o.column=="number"}}e.Position=y}),define(pe[52],be([1,0,106]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(A,k,T,v){A>T||A===T&&k>v?(this.startLineNumber=T,this.startColumn=v,this.endLineNumber=A,this.endColumn=k):(this.startLineNumber=A,this.startColumn=k,this.endLineNumber=T,this.endColumn=v)}isEmpty(){return L.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return L.containsPosition(this,A)}static containsPosition(A,k){return!(k.lineNumber<A.startLineNumber||k.lineNumber>A.endLineNumber||k.lineNumber===A.startLineNumber&&k.column<A.startColumn||k.lineNumber===A.endLineNumber&&k.column>A.endColumn)}static strictContainsPosition(A,k){return!(k.lineNumber<A.startLineNumber||k.lineNumber>A.endLineNumber||k.lineNumber===A.startLineNumber&&k.column<=A.startColumn||k.lineNumber===A.endLineNumber&&k.column>=A.endColumn)}containsRange(A){return L.containsRange(this,A)}static containsRange(A,k){return!(k.startLineNumber<A.startLineNumber||k.endLineNumber<A.startLineNumber||k.startLineNumber>A.endLineNumber||k.endLineNumber>A.endLineNumber||k.startLineNumber===A.startLineNumber&&k.startColumn<A.startColumn||k.endLineNumber===A.endLineNumber&&k.endColumn>A.endColumn)}strictContainsRange(A){return L.strictContainsRange(this,A)}static strictContainsRange(A,k){return!(k.startLineNumber<A.startLineNumber||k.endLineNumber<A.startLineNumber||k.startLineNumber>A.endLineNumber||k.endLineNumber>A.endLineNumber||k.startLineNumber===A.startLineNumber&&k.startColumn<=A.startColumn||k.endLineNumber===A.endLineNumber&&k.endColumn>=A.endColumn)}plusRange(A){return L.plusRange(this,A)}static plusRange(A,k){let T,v,m,R;return k.startLineNumber<A.startLineNumber?(T=k.startLineNumber,v=k.startColumn):k.startLineNumber===A.startLineNumber?(T=k.startLineNumber,v=Math.min(k.startColumn,A.startColumn)):(T=A.startLineNumber,v=A.startColumn),k.endLineNumber>A.endLineNumber?(m=k.endLineNumber,R=k.endColumn):k.endLineNumber===A.endLineNumber?(m=k.endLineNumber,R=Math.max(k.endColumn,A.endColumn)):(m=A.endLineNumber,R=A.endColumn),new L(T,v,m,R)}intersectRanges(A){return L.intersectRanges(this,A)}static intersectRanges(A,k){let T=A.startLineNumber,v=A.startColumn,m=A.endLineNumber,R=A.endColumn;const E=k.startLineNumber,b=k.startColumn,d=k.endLineNumber,g=k.endColumn;return T<E?(T=E,v=b):T===E&&(v=Math.max(v,b)),m>d?(m=d,R=g):m===d&&(R=Math.min(R,g)),T>m||T===m&&v>R?null:new L(T,v,m,R)}equalsRange(A){return L.equalsRange(this,A)}static equalsRange(A,k){return!A&&!k?!0:!!A&&!!k&&A.startLineNumber===k.startLineNumber&&A.startColumn===k.startColumn&&A.endLineNumber===k.endLineNumber&&A.endColumn===k.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(A){return new y.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(A){return new y.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,k){return new L(this.startLineNumber,this.startColumn,A,k)}setStartPosition(A,k){return new L(A,k,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(A){return new L(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return L.collapseToEnd(this)}static collapseToEnd(A){return new L(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new L(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,k=A){return new L(A.lineNumber,A.column,k.lineNumber,k.column)}static lift(A){return A?new L(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,k){return!(A.endLineNumber<k.startLineNumber||A.endLineNumber===k.startLineNumber&&A.endColumn<k.startColumn||k.endLineNumber<A.startLineNumber||k.endLineNumber===A.startLineNumber&&k.endColumn<A.startColumn)}static areIntersecting(A,k){return!(A.endLineNumber<k.startLineNumber||A.endLineNumber===k.startLineNumber&&A.endColumn<=k.startColumn||k.endLineNumber<A.startLineNumber||k.endLineNumber===A.startLineNumber&&k.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,k){if(A&&k){const m=A.startLineNumber|0,R=k.startLineNumber|0;if(m===R){const E=A.startColumn|0,b=k.startColumn|0;if(E===b){const d=A.endLineNumber|0,g=k.endLineNumber|0;if(d===g){const p=A.endColumn|0,r=k.endColumn|0;return p-r}return d-g}return E-b}return m-R}return(A?1:0)-(k?1:0)}static compareRangesUsingEnds(A,k){return A.endLineNumber===k.endLineNumber?A.endColumn===k.endColumn?A.startLineNumber===k.startLineNumber?A.startColumn-k.startColumn:A.startLineNumber-k.startLineNumber:A.endColumn-k.endColumn:A.endLineNumber-k.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=L}),define(pe[157],be([1,0,6,2]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class o{constructor(){this.a=new Map,this.b=new Map,this.c=new y.Emitter,this.onDidChange=this.c.event,this.d=null}handleChange(T){this.c.fire({changedLanguages:T,changedColorMap:!1})}register(T,v){return this.a.set(T,v),this.handleChange([T]),(0,L.toDisposable)(()=>{this.a.get(T)===v&&(this.a.delete(T),this.handleChange([T]))})}get(T){return this.a.get(T)||null}registerFactory(T,v){this.b.get(T)?.dispose();const m=new A(this,T,v);return this.b.set(T,m),(0,L.toDisposable)(()=>{const R=this.b.get(T);!R||R!==m||(this.b.delete(T),R.dispose())})}async getOrCreate(T){const v=this.get(T);if(v)return v;const m=this.b.get(T);return!m||m.isResolved?null:(await m.resolve(),this.get(T))}isResolved(T){if(this.get(T))return!0;const m=this.b.get(T);return!!(!m||m.isResolved)}setColorMap(T){this.d=T,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=o;class A extends L.Disposable{get isResolved(){return this.c}constructor(T,v,m){super(),this.f=T,this.g=v,this.h=m,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const T=await this.h.tokenizationSupport;this.c=!0,T&&!this.a&&this.B(this.f.register(this.g,T))}}}),define(pe[158],be([1,0,48,4,52,157]),function(le,e,y,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class k{constructor(N,$,ee){this.offset=N,this.type=$,this.language=ee,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=k;class T{constructor(N,$){this.tokens=N,this.endState=$,this._tokenizationResultBrand=void 0}}e.TokenizationResult=T;class v{constructor(N,$){this.tokens=N,this.endState=$,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=v;var m;(function(S){S[S.Method=0]="Method",S[S.Function=1]="Function",S[S.Constructor=2]="Constructor",S[S.Field=3]="Field",S[S.Variable=4]="Variable",S[S.Class=5]="Class",S[S.Struct=6]="Struct",S[S.Interface=7]="Interface",S[S.Module=8]="Module",S[S.Property=9]="Property",S[S.Event=10]="Event",S[S.Operator=11]="Operator",S[S.Unit=12]="Unit",S[S.Value=13]="Value",S[S.Constant=14]="Constant",S[S.Enum=15]="Enum",S[S.EnumMember=16]="EnumMember",S[S.Keyword=17]="Keyword",S[S.Text=18]="Text",S[S.Color=19]="Color",S[S.File=20]="File",S[S.Reference=21]="Reference",S[S.Customcolor=22]="Customcolor",S[S.Folder=23]="Folder",S[S.TypeParameter=24]="TypeParameter",S[S.User=25]="User",S[S.Issue=26]="Issue",S[S.Snippet=27]="Snippet"})(m||(e.CompletionItemKind=m={}));var R;(function(S){const N=new Map;N.set(0,y.Codicon.symbolMethod),N.set(1,y.Codicon.symbolFunction),N.set(2,y.Codicon.symbolConstructor),N.set(3,y.Codicon.symbolField),N.set(4,y.Codicon.symbolVariable),N.set(5,y.Codicon.symbolClass),N.set(6,y.Codicon.symbolStruct),N.set(7,y.Codicon.symbolInterface),N.set(8,y.Codicon.symbolModule),N.set(9,y.Codicon.symbolProperty),N.set(10,y.Codicon.symbolEvent),N.set(11,y.Codicon.symbolOperator),N.set(12,y.Codicon.symbolUnit),N.set(13,y.Codicon.symbolValue),N.set(15,y.Codicon.symbolEnum),N.set(14,y.Codicon.symbolConstant),N.set(15,y.Codicon.symbolEnum),N.set(16,y.Codicon.symbolEnumMember),N.set(17,y.Codicon.symbolKeyword),N.set(27,y.Codicon.symbolSnippet),N.set(18,y.Codicon.symbolText),N.set(19,y.Codicon.symbolColor),N.set(20,y.Codicon.symbolFile),N.set(21,y.Codicon.symbolReference),N.set(22,y.Codicon.symbolCustomColor),N.set(23,y.Codicon.symbolFolder),N.set(24,y.Codicon.symbolTypeParameter),N.set(25,y.Codicon.account),N.set(26,y.Codicon.issues);function $(oe){let ue=N.get(oe);return ue||(console.info("No codicon found for CompletionItemKind "+oe),ue=y.Codicon.symbolProperty),ue}S.toIcon=$;const ee=new Map;ee.set("method",0),ee.set("function",1),ee.set("constructor",2),ee.set("field",3),ee.set("variable",4),ee.set("class",5),ee.set("struct",6),ee.set("interface",7),ee.set("module",8),ee.set("property",9),ee.set("event",10),ee.set("operator",11),ee.set("unit",12),ee.set("value",13),ee.set("constant",14),ee.set("enum",15),ee.set("enum-member",16),ee.set("enumMember",16),ee.set("keyword",17),ee.set("snippet",27),ee.set("text",18),ee.set("color",19),ee.set("file",20),ee.set("reference",21),ee.set("customcolor",22),ee.set("folder",23),ee.set("type-parameter",24),ee.set("typeParameter",24),ee.set("account",25),ee.set("issue",26);function he(oe,ue){let me=ee.get(oe);return typeof me>"u"&&!ue&&(me=9),me}S.fromString=he})(R||(e.CompletionItemKinds=R={}));var E;(function(S){S[S.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var b;(function(S){S[S.None=0]="None",S[S.KeepWhitespace=1]="KeepWhitespace",S[S.InsertAsSnippet=4]="InsertAsSnippet"})(b||(e.CompletionItemInsertTextRule=b={}));var d;(function(S){S[S.Invoke=0]="Invoke",S[S.TriggerCharacter=1]="TriggerCharacter",S[S.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(e.CompletionTriggerKind=d={}));var g;(function(S){S[S.Automatic=0]="Automatic",S[S.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class p{constructor(N,$,ee,he){this.range=N,this.text=$,this.completionKind=ee,this.isSnippetText=he}equals(N){return o.Range.lift(this.range).equalsRange(N.range)&&this.text===N.text&&this.completionKind===N.completionKind&&this.isSnippetText===N.isSnippetText}}e.SelectedSuggestionInfo=p;var r;(function(S){S[S.Invoke=1]="Invoke",S[S.Auto=2]="Auto"})(r||(e.CodeActionTriggerType=r={}));var f;(function(S){S[S.Invoke=1]="Invoke",S[S.TriggerCharacter=2]="TriggerCharacter",S[S.ContentChange=3]="ContentChange"})(f||(e.SignatureHelpTriggerKind=f={}));var c;(function(S){S[S.Text=0]="Text",S[S.Read=1]="Read",S[S.Write=2]="Write"})(c||(e.DocumentHighlightKind=c={}));function u(S){return S&&L.URI.isUri(S.uri)&&o.Range.isIRange(S.range)&&(o.Range.isIRange(S.originSelectionRange)||o.Range.isIRange(S.targetSelectionRange))}e.isLocationLink=u;var I;(function(S){S[S.File=0]="File",S[S.Module=1]="Module",S[S.Namespace=2]="Namespace",S[S.Package=3]="Package",S[S.Class=4]="Class",S[S.Method=5]="Method",S[S.Property=6]="Property",S[S.Field=7]="Field",S[S.Constructor=8]="Constructor",S[S.Enum=9]="Enum",S[S.Interface=10]="Interface",S[S.Function=11]="Function",S[S.Variable=12]="Variable",S[S.Constant=13]="Constant",S[S.String=14]="String",S[S.Number=15]="Number",S[S.Boolean=16]="Boolean",S[S.Array=17]="Array",S[S.Object=18]="Object",S[S.Key=19]="Key",S[S.Null=20]="Null",S[S.EnumMember=21]="EnumMember",S[S.Struct=22]="Struct",S[S.Event=23]="Event",S[S.Operator=24]="Operator",S[S.TypeParameter=25]="TypeParameter"})(I||(e.SymbolKind=I={}));var O;(function(S){S[S.Deprecated=1]="Deprecated"})(O||(e.SymbolTag=O={}));var t;(function(S){const N=new Map;N.set(0,y.Codicon.symbolFile),N.set(1,y.Codicon.symbolModule),N.set(2,y.Codicon.symbolNamespace),N.set(3,y.Codicon.symbolPackage),N.set(4,y.Codicon.symbolClass),N.set(5,y.Codicon.symbolMethod),N.set(6,y.Codicon.symbolProperty),N.set(7,y.Codicon.symbolField),N.set(8,y.Codicon.symbolConstructor),N.set(9,y.Codicon.symbolEnum),N.set(10,y.Codicon.symbolInterface),N.set(11,y.Codicon.symbolFunction),N.set(12,y.Codicon.symbolVariable),N.set(13,y.Codicon.symbolConstant),N.set(14,y.Codicon.symbolString),N.set(15,y.Codicon.symbolNumber),N.set(16,y.Codicon.symbolBoolean),N.set(17,y.Codicon.symbolArray),N.set(18,y.Codicon.symbolObject),N.set(19,y.Codicon.symbolKey),N.set(20,y.Codicon.symbolNull),N.set(21,y.Codicon.symbolEnumMember),N.set(22,y.Codicon.symbolStruct),N.set(23,y.Codicon.symbolEvent),N.set(24,y.Codicon.symbolOperator),N.set(25,y.Codicon.symbolTypeParameter);function $(ee){let he=N.get(ee);return he||(console.info("No codicon found for SymbolKind "+ee),he=y.Codicon.symbolProperty),he}S.toIcon=$})(t||(e.SymbolKinds=t={}));class n{static fromValue(N){switch(N){case"comment":return n.Comment;case"imports":return n.Imports;case"region":return n.Region}return new n(N)}constructor(N){this.value=N}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var s;(function(S){function N($){return!$||typeof $!="object"?!1:typeof $.id=="string"&&typeof $.title=="string"}S.is=N})(s||(e.Command=s={}));var i;(function(S){S[S.Collapsed=0]="Collapsed",S[S.Expanded=1]="Expanded"})(i||(e.CommentThreadCollapsibleState=i={}));var a;(function(S){S[S.Unresolved=0]="Unresolved",S[S.Resolved=1]="Resolved"})(a||(e.CommentThreadState=a={}));var l;(function(S){S[S.Editing=0]="Editing",S[S.Preview=1]="Preview"})(l||(e.CommentMode=l={}));var h;(function(S){S[S.Published=0]="Published",S[S.Draft=1]="Draft"})(h||(e.CommentState=h={}));var C;(function(S){S[S.Type=1]="Type",S[S.Parameter=2]="Parameter"})(C||(e.InlayHintKind=C={}));class D{constructor(N){this.b=N,this.a=null}dispose(){this.a&&this.a.then(N=>{N&&N.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.LazyTokenizationSupport=D,e.TokenizationRegistry=new A.TokenizationRegistry;var w;(function(S){S[S.None=0]="None",S[S.Option=1]="Option",S[S.Default=2]="Default",S[S.Preferred=3]="Preferred"})(w||(e.ExternalUriOpenerPriority=w={}))}),define(pe[159],be([10,11]),function(le,e){return le.create("vs/base/common/actions",e)}),define(pe[160],be([1,0,6,2,159]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class A extends L.Disposable{constructor(b,d="",g="",p=!0,r){super(),this.h=this.B(new y.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=b,this.m=d,this.u=g,this.w=p,this.C=r}get id(){return this.j}get label(){return this.m}set label(b){this.D(b)}D(b){this.m!==b&&(this.m=b,this.h.fire({label:b}))}get tooltip(){return this.n||""}set tooltip(b){this.F(b)}F(b){this.n!==b&&(this.n=b,this.h.fire({tooltip:b}))}get class(){return this.u}set class(b){this.G(b)}G(b){this.u!==b&&(this.u=b,this.h.fire({class:b}))}get enabled(){return this.w}set enabled(b){this.H(b)}H(b){this.w!==b&&(this.w=b,this.h.fire({enabled:b}))}get checked(){return this.z}set checked(b){this.I(b)}I(b){this.z!==b&&(this.z=b,this.h.fire({checked:b}))}async run(b,d){this.C&&await this.C(b)}}e.Action=A;class k extends L.Disposable{constructor(){super(...arguments),this.f=this.B(new y.Emitter),this.onWillRun=this.f.event,this.h=this.B(new y.Emitter),this.onDidRun=this.h.event}async run(b,d){if(!b.enabled)return;this.f.fire({action:b});let g;try{await this.k(b,d)}catch(p){g=p}this.h.fire({action:b,error:g})}async k(b,d){await b.run(d)}}e.ActionRunner=k;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let d=[];for(const g of b)g.length&&(d.length?d=[...d,new T,...g]:d=g);return d}async run(){}}e.Separator=T,T.ID="vs.actions.separator";class v{get actions(){return this.a}constructor(b,d,g,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=d,this.class=p,this.a=g}async run(){}}e.SubmenuAction=v;class m extends A{constructor(){super(m.ID,o.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=m,m.ID="vs.actions.empty";function R(E){return{id:E.id,label:E.label,class:void 0,enabled:E.enabled??!0,checked:E.checked??!1,run:async()=>E.run(),tooltip:E.label}}e.toAction=R}),define(pe[161],be([10,11]),function(le,e){return le.create("vs/base/common/date",e)}),define(pe[162],be([1,0,161]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,o=L*60,A=o*24,k=A*7,T=A*30,v=A*365;function m(E,b,d,g){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,y.localize)(0,null,m(new Date().getTime()+p*1e3,!1));if(!g&&p<30)return(0,y.localize)(1,null);let r;return p<L?(r=p,b?r===1?d?(0,y.localize)(2,null,r):(0,y.localize)(3,null,r):d?(0,y.localize)(4,null,r):(0,y.localize)(5,null,r):r===1?d?(0,y.localize)(6,null,r):(0,y.localize)(7,null,r):d?(0,y.localize)(8,null,r):(0,y.localize)(9,null,r)):p<o?(r=Math.floor(p/L),b?r===1?d?(0,y.localize)(10,null,r):(0,y.localize)(11,null,r):d?(0,y.localize)(12,null,r):(0,y.localize)(13,null,r):r===1?d?(0,y.localize)(14,null,r):(0,y.localize)(15,null,r):d?(0,y.localize)(16,null,r):(0,y.localize)(17,null,r)):p<A?(r=Math.floor(p/o),b?r===1?d?(0,y.localize)(18,null,r):(0,y.localize)(19,null,r):d?(0,y.localize)(20,null,r):(0,y.localize)(21,null,r):r===1?d?(0,y.localize)(22,null,r):(0,y.localize)(23,null,r):d?(0,y.localize)(24,null,r):(0,y.localize)(25,null,r)):p<k?(r=Math.floor(p/A),b?r===1?(0,y.localize)(26,null,r):(0,y.localize)(27,null,r):r===1?(0,y.localize)(28,null,r):(0,y.localize)(29,null,r)):p<T?(r=Math.floor(p/k),b?r===1?d?(0,y.localize)(30,null,r):(0,y.localize)(31,null,r):d?(0,y.localize)(32,null,r):(0,y.localize)(33,null,r):r===1?d?(0,y.localize)(34,null,r):(0,y.localize)(35,null,r):d?(0,y.localize)(36,null,r):(0,y.localize)(37,null,r)):p<v?(r=Math.floor(p/T),b?r===1?d?(0,y.localize)(38,null,r):(0,y.localize)(39,null,r):d?(0,y.localize)(40,null,r):(0,y.localize)(41,null,r):r===1?d?(0,y.localize)(42,null,r):(0,y.localize)(43,null,r):d?(0,y.localize)(44,null,r):(0,y.localize)(45,null,r)):(r=Math.floor(p/v),b?r===1?d?(0,y.localize)(46,null,r):(0,y.localize)(47,null,r):d?(0,y.localize)(48,null,r):(0,y.localize)(49,null,r):r===1?d?(0,y.localize)(50,null,r):(0,y.localize)(51,null,r):d?(0,y.localize)(52,null,r):(0,y.localize)(53,null,r))}e.fromNow=m;function R(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(pe[163],be([10,11]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(pe[39],be([1,0,18,8,163]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(E,b){return b&&(E.stack||E.stacktrace)?o.localize(0,null,T(E),k(E.stack)||k(E.stacktrace)):T(E)}function k(E){return Array.isArray(E)?E.join(`
`):E}function T(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?o.localize(1,null,E.message):E.message||o.localize(2,null)}function v(E=null,b=!1){if(!E)return o.localize(3,null);if(Array.isArray(E)){const d=y.coalesce(E),g=v(d[0],b);return d.length>1?o.localize(4,null,g,d.length):g}if(L.isString(E))return E;if(E.detail){const d=E.detail;if(d.error)return A(d.error,b);if(d.exception)return A(d.exception,b)}return E.stack?A(E,b):E.message?E.message:o.localize(5,null)}e.toErrorMessage=v;function m(E){const b=E;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=m;function R(E,b){let d;return typeof E=="string"?d=new Error(E):d=E,d.actions=b,d}e.createErrorWithActions=R}),define(pe[164],be([10,11]),function(le,e){return le.create("vs/base/common/jsonErrorMessages",e)}),define(pe[165],be([1,0,164]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(o){switch(o){case 1:return(0,y.localize)(0,null);case 2:return(0,y.localize)(1,null);case 3:return(0,y.localize)(2,null);case 4:return(0,y.localize)(3,null);case 5:return(0,y.localize)(4,null);case 6:return(0,y.localize)(5,null);case 7:return(0,y.localize)(6,null);case 8:return(0,y.localize)(7,null);case 9:return(0,y.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(pe[166],be([10,11]),function(le,e){return le.create("vs/base/node/zip",e)}),define(pe[167],be([10,11]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[168],be([10,11]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(pe[169],be([10,11]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(pe[170],be([10,11]),function(le,e){return le.create("vs/platform/environment/node/argv",e)}),define(pe[171],be([10,11]),function(le,e){return le.create("vs/platform/environment/node/argvHelper",e)}),define(pe[172],be([10,11]),function(le,e){return le.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(pe[173],be([10,11]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[174],be([10,11]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(pe[175],be([10,11]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(pe[176],be([10,11]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(pe[177],be([10,11]),function(le,e){return le.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(pe[178],be([10,11]),function(le,e){return le.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(pe[179],be([10,11]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[180],be([10,11]),function(le,e){return le.create("vs/platform/files/common/fileService",e)}),define(pe[181],be([10,11]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(pe[182],be([10,11]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(pe[183],be([10,11]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(pe[184],be([10,11]),function(le,e){return le.create("vs/platform/languagePacks/common/languagePacks",e)}),define(pe[185],be([10,11]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(pe[186],be([10,11]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(pe[187],be([10,11]),function(le,e){return le.create("vs/platform/shell/node/shellEnv",e)}),define(pe[188],be([10,11]),function(le,e){return le.create("vs/platform/telemetry/common/telemetryService",e)}),define(pe[189],be([10,11]),function(le,e){return le.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(pe[190],be([10,11]),function(le,e){return le.create("vs/platform/terminal/common/terminalProfiles",e)}),define(pe[191],be([10,11]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(pe[192],be([10,11]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(pe[193],be([10,11]),function(le,e){return le.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(pe[194],be([10,11]),function(le,e){return le.create("vs/server/node/serverEnvironmentService",e)}),define(pe[195],be([10,11]),function(le,e){return le.create("vs/server/node/serverServices",e)}),define(pe[196],be([10,11]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(pe[197],be([10,11]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(pe[198],be([10,11]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[199],be([10,11]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(pe[200],be([1,0,9,169]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var o;(function(m){m[m.LParen=0]="LParen",m[m.RParen=1]="RParen",m[m.Neg=2]="Neg",m[m.Eq=3]="Eq",m[m.NotEq=4]="NotEq",m[m.Lt=5]="Lt",m[m.LtEq=6]="LtEq",m[m.Gt=7]="Gt",m[m.GtEq=8]="GtEq",m[m.RegexOp=9]="RegexOp",m[m.RegexStr=10]="RegexStr",m[m.True=11]="True",m[m.False=12]="False",m[m.In=13]="In",m[m.Not=14]="Not",m[m.And=15]="And",m[m.Or=16]="Or",m[m.Str=17]="Str",m[m.QuotedStr=18]="QuotedStr",m[m.Error=19]="Error",m[m.EOF=20]="EOF"})(o||(e.TokenType=o={}));function A(...m){switch(m.length){case 1:return(0,L.localize)(0,null,m[0]);case 2:return(0,L.localize)(1,null,m[0],m[1]);case 3:return(0,L.localize)(2,null,m[0],m[1],m[2]);default:return}}const k=(0,L.localize)(3,null),T=(0,L.localize)(4,null);class v{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,y.illegalState)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const E=this.d,b=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:b};this.g.push({offset:E,lexeme:b,additionalInfo:R}),this.f.push(d)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const E=this.c.substring(this.d,this.e),b=v.b.get(E);b?this.k(b):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(k);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,E=!1,b=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(T);return}const g=this.c.charCodeAt(R);if(E)E=!1;else if(g===47&&!b){R++;break}else g===91?b=!0:g===92?E=!0:g===93&&(b=!1);R++}for(;R<this.c.length&&v.a.has(this.c.charCodeAt(R));)R++;this.e=R;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.Scanner=v,v.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0))),v.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(pe[201],be([1,0,6,2]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class o{constructor(){this.a=new y.Emitter,this.b=new y.Emitter,this.c=new y.Emitter,this.d=new y.Emitter}call(T,v,m){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(T,v,m){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=o,o.ChannelName="extensionhostdebugservice";class A extends L.Disposable{constructor(T){super(),this.b=T}reload(T){this.b.call("reload",[T])}get onReload(){return this.b.listen("reload")}close(T){this.b.call("close",[T])}get onClose(){return this.b.listen("close")}attachSession(T,v,m){this.b.call("attach",[T,v,m])}get onAttachSession(){return this.b.listen("attach")}terminateSession(T,v){this.b.call("terminate",[T,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(T,v){return this.b.call("openExtensionDevelopmentHostWindow",[T,v])}}e.ExtensionHostDebugChannelClient=A}),define(pe[202],be([1,0,4]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class L{constructor(k){this.a=k}listen(k,T,v){throw new Error("Invalid listen")}call(k,T,v){switch(T){case"download":return this.a.download(y.URI.revive(v[0]),y.URI.revive(v[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=L;class o{constructor(k,T){this.a=k,this.b=T}async download(k,T){const v=this.b();v&&(k=v.transformOutgoingURI(k),T=v.transformOutgoingURI(T)),await this.a.call("download",[k,T])}}e.DownloadServiceChannelClient=o}),define(pe[203],be([1,0,162,92,13,7,29,19,4]),function(le,e,y,L,o,A,k,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,A.dirname)(o.FileAccess.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,T.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,T.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",d)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(v.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,T.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,T.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=k.env.VSCODE_PORTABLE;return d?v.URI.file((0,A.join)(d,"argv.json")):(0,T.joinPath)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.resolve)(d):(0,A.normalize)((0,A.join)(o.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?v.URI.file((0,A.resolve)(d)):v.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.resolve)(d);const g=k.env.VSCODE_EXTENSIONS;if(g)return g;const p=k.env.VSCODE_PORTABLE;return p?(0,A.join)(p,"extensions"):(0,T.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?v.URI.parse(g):v.URI.file((0,A.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?v.URI.parse(d):v.URI.file((0,A.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const g of this.args.log||[]){const p=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(g);p&&p[1]&&p[2]&&d.push([p[1],p[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,T.joinPath)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=k.env.VSCODE_PORTABLE;return d?v.URI.file((0,A.join)(d,"policy.json")):(0,T.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,g,p){this.a=d,this.b=g,this.c=p,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=m,Le([L.memoize],m.prototype,"appRoot",null),Le([L.memoize],m.prototype,"userHome",null),Le([L.memoize],m.prototype,"userDataPath",null),Le([L.memoize],m.prototype,"appSettingsHome",null),Le([L.memoize],m.prototype,"tmpDir",null),Le([L.memoize],m.prototype,"cacheHome",null),Le([L.memoize],m.prototype,"stateResource",null),Le([L.memoize],m.prototype,"userRoamingDataHome",null),Le([L.memoize],m.prototype,"userDataSyncHome",null),Le([L.memoize],m.prototype,"sync",null),Le([L.memoize],m.prototype,"machineSettingsResource",null),Le([L.memoize],m.prototype,"workspaceStorageHome",null),Le([L.memoize],m.prototype,"localHistoryHome",null),Le([L.memoize],m.prototype,"keyboardLayoutResource",null),Le([L.memoize],m.prototype,"argvResource",null),Le([L.memoize],m.prototype,"isExtensionDevelopment",null),Le([L.memoize],m.prototype,"untitledWorkspacesHome",null),Le([L.memoize],m.prototype,"builtinExtensionsPath",null),Le([L.memoize],m.prototype,"extensionsPath",null),Le([L.memoize],m.prototype,"extensionDevelopmentLocationURI",null),Le([L.memoize],m.prototype,"extensionDevelopmentKind",null),Le([L.memoize],m.prototype,"extensionTestsLocationURI",null),Le([L.memoize],m.prototype,"debugExtensionHost",null),Le([L.memoize],m.prototype,"logLevel",null),Le([L.memoize],m.prototype,"extensionLogLevel",null),Le([L.memoize],m.prototype,"serviceMachineIdResource",null),Le([L.memoize],m.prototype,"disableTelemetry",null),Le([L.memoize],m.prototype,"disableWorkspaceTrust",null),Le([L.memoize],m.prototype,"policyFile",null);function R(b,d){return E(b["inspect-extensions"],b["inspect-brk-extensions"],5870,d,b.debugId,b.extensionEnvironment)}e.parseExtensionHostDebugPort=R;function E(b,d,g,p,r,f){const u=Number(d||b)||(p?null:g),I=u?!!d:!1;let O;if(f)try{O=JSON.parse(f)}catch{}return{port:u,break:I,debugId:r,env:O}}e.parseDebugParams=E}),define(pe[62],be([1,0,296,3,170]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,o.localize)(0,null),e:(0,o.localize)(1,null),t:(0,o.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,o.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,o.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,o.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,o.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,o.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,o.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,o.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,o.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,o.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,o.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,o.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,o.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,o.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,o.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,o.localize)(17,null)},category:{type:"string",cat:"e",description:(0,o.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,o.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,o.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,o.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,o.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,o.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,o.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,o.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,o.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,o.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,o.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,o.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,o.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,o.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,o.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,o.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,o.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function T(p,r,f=k){const c=p.find(l=>l.length>0&&l[0]!=="-"),u={},I=["_"],O=[],t={};let n;for(const l in r){const h=r[l];h.type==="subcommand"?l===c&&(n=h):(h.alias&&(u[l]=h.alias),h.type==="string"||h.type==="string[]"?(I.push(l),h.deprecates&&I.push(...h.deprecates)):h.type==="boolean"&&(O.push(l),h.deprecates&&O.push(...h.deprecates)),h.global&&(t[l]=h))}if(n&&c){const l=t;for(const w in n.options)l[w]=n.options[w];const h=p.filter(w=>w!==c),C=f.getSubcommandReporter?f.getSubcommandReporter(c):void 0,D=T(h,l,C);return{[c]:D,_:[]}}const s=y(p,{string:I,boolean:O,alias:u}),i={},a=s;i._=s._.map(l=>String(l)).filter(l=>l.length>0),delete a._;for(const l in r){const h=r[l];if(h.type==="subcommand")continue;h.alias&&delete a[h.alias];let C=a[l];if(h.deprecates)for(const D of h.deprecates)a.hasOwnProperty(D)&&(C||(C=a[D],C&&f.onDeprecatedOption(D,h.deprecationMessage||(0,o.localize)(35,null,l))),delete a[D]);if(typeof C<"u"){if(h.type==="string[]"){if(Array.isArray(C)||(C=[C]),!h.allowEmptyValue){const D=C.filter(w=>w.length>0);D.length!==C.length&&(f.onEmptyValue(l),C=D.length>0?D:void 0)}}else h.type==="string"&&(Array.isArray(C)?(C=C.pop(),f.onMultipleValues(l,C)):!C&&!h.allowEmptyValue&&(f.onEmptyValue(l),C=void 0));i[l]=C,h.deprecationMessage&&f.onDeprecatedOption(l,h.deprecationMessage)}delete a[l]}for(const l in a)f.onUnknownOption(l);return i}e.parseArgs=T;function v(p,r){let f="";return r.args&&(Array.isArray(r.args)?f=` <${r.args.join("> <")}>`:f=` <${r.args}>`),r.alias?`-${r.alias} --${p}${f}`:`--${p}${f}`}function m(p,r){const f=[];for(const c in p){const u=p[c],I=v(c,u);f.push([I,u.description])}return R(f,r)}e.formatOptions=m;function R(p,r){const c=p.reduce((O,t)=>Math.max(O,t[0].length),12)+2+1;if(r-c<25)return p.reduce((O,t)=>O.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const u=r-c-1,I=[];for(const O of p){const t=O[0],n=b(O[1],u),s=E(c-t.length-2);I.push("  "+t+s+n[0]);for(let i=1;i<n.length;i++)I.push(E(c)+n[i])}return I}function E(p){return" ".repeat(p)}function b(p,r){const f=[];for(;p.length;){const c=p.length<r?p.length:p.lastIndexOf(" ",r),u=p.slice(0,c).trim();p=p.slice(c),f.push(u)}return f}function d(p,r,f,c,u){const I=process.stdout.isTTY&&process.stdout.columns||80,O=u?.noInputFiles!==!0?`[${(0,o.localize)(36,null)}...]`:"",t=[`${p} ${f}`];t.push(""),t.push(`${(0,o.localize)(37,null)}: ${r} [${(0,o.localize)(38,null)}]${O}`),t.push(""),u?.noPipe!==!0&&(L.isWindows?t.push((0,o.localize)(39,null,r)):t.push((0,o.localize)(40,null,r)),t.push(""));const n={},s=[];for(const i in c){const a=c[i];if(a.type==="subcommand")a.description&&s.push({command:i,description:a.description});else if(a.description&&a.cat){let l=n[a.cat];l||(n[a.cat]=l={}),l[i]=a}}for(const i in n){const a=i,l=n[a];l&&(t.push(A[a]),t.push(...m(l,I)),t.push(""))}return s.length&&(t.push((0,o.localize)(41,null)),t.push(...R(s.map(i=>[i.command,i.description]),I)),t.push("")),t.join(`
`)}e.buildHelpMessage=d;function g(p,r){return`${p||(0,o.localize)(42,null)}
${r||(0,o.localize)(43,null)}
${process.arch}`}e.buildVersionMessage=g}),define(pe[204],be([1,0,297,171,62]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(E,b){const d=(u,I)=>{console.warn((0,L.localize)(0,null,u,I))},g=u=>{console.warn((0,L.localize)(1,null,u))},p=(u,I)=>{console.warn((0,L.localize)(2,null,u,I))},r=u=>({onUnknownOption:I=>{u!=="tunnel"&&console.warn((0,L.localize)(3,null,I,u))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:p,getSubcommandReporter:u!=="tunnel"?r:void 0}),f={onUnknownOption:u=>{console.warn((0,L.localize)(4,null,u))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:p,getSubcommandReporter:r},c=(0,o.parseArgs)(E,o.OPTIONS,b?f:void 0);return c.goto&&c._.forEach(u=>y(/^(\w:)?[^:]+(:\d*){0,2}$/.test(u),(0,L.localize)(5,null))),c}function k(E){const b=E.findIndex(d=>!/^-/.test(d));if(b>-1)return[...E.slice(0,b),...E.slice(b+1)]}function T(E){let[,...b]=E;process.env.VSCODE_DEV&&(b=k(b)||[]);const d=!R(process.env);return A(b,d)}e.parseMainProcessArgv=T;function v(E){let[,,...b]=E;return process.env.VSCODE_DEV&&(b=k(b)||[]),A(b,!0)}e.parseCLIProcessArgv=v;function m(E,...b){const d=E.indexOf("--");return d===-1?E.push(...b):E.splice(d,0,...b),E}e.addArg=m;function R(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=R}),function(){"use strict";function le(e,y,L){function o(k,T){const v=A(k,T),m=[v];return e.isAbsolute(v)||m.unshift(L),e.resolve(...m)}function A(k,T){process.env.VSCODE_DEV&&(T="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,T);const R=k["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(E,"AppData","Roaming")}break;case"darwin":m=e.join(y.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,T)}return{getUserDataPath:o}}if(typeof define=="function")define(pe[205],be([75,26,29]),function(e,y,L){return le(e,y,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=le(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(pe[107],be([1,0,26,203,205]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(m,R){super(m,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,o.getUserDataPath)(m,R.nameShort)},R)}}e.NativeEnvironmentService=A;function k(v,m){return(0,L.parseDebugParams)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,m,v.extensionEnvironment)}e.parsePtyHostDebugPort=k;function T(v,m){return(0,L.parseDebugParams)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,m,v.extensionEnvironment)}e.parseSharedProcessDebugPort=T}),define(pe[206],be([1,0,8,175]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function o(k,T,v){try{A(k,T,v)}catch(m){console.error(m?.message??m)}return k}e.localizeManifest=o;function A(k,T,v){const m=(R,E,b)=>{const d=R[E];if((0,y.isString)(d)){const g=d,p=g.length;if(p>1&&g[0]==="%"&&g[p-1]==="%"){const r=g.substr(1,p-2);let f=T[r];f===void 0&&v&&(f=v[r]);const c=typeof f=="string"?f:f?.message,u=v?.[r],I=typeof u=="string"?u:u?.message;if(!c){I||console.warn(`[${k.name}]: ${(0,L.localize)(0,null,r)}`);return}if(b&&(E==="title"||E==="category")&&I&&I!==c){const O={value:c,original:I};R[E]=O}else R[E]=c}}else if((0,y.isObject)(d))for(const g in d)d.hasOwnProperty(g)&&(g==="commands"?m(d,g,!0):m(d,g,b));else if(Array.isArray(d))for(let g=0;g<d.length;g++)m(d,g,b)};for(const R in k)k.hasOwnProperty(R)&&m(k,R)}}),define(pe[77],be([1,0,19,60,179,53]),function(le,e,y,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function v(f){return f=f.trim(),f==="*"||k.test(f)}e.isValidVersionStr=v;function m(f){if(!v(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=f.match(k);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.parseVersion=m;function R(f){if(!f)return null;const c=f.majorBase,u=f.majorMustEqual,I=f.minorBase;let O=f.minorMustEqual;const t=f.patchBase;let n=f.patchMustEqual;f.hasCaret&&(c===0||(O=!1),n=!1);let s=0;if(f.preRelease){const i=T.exec(f.preRelease);if(i){const[,a,l,h]=i;s=Date.UTC(Number(a),Number(l)-1,Number(h))}}return{majorBase:c,majorMustEqual:u,minorBase:I,minorMustEqual:O,patchBase:t,patchMustEqual:n,isMinimum:f.hasGreaterEquals,notBefore:s}}e.normalizeVersion=R;function E(f,c,u){let I;typeof f=="string"?I=R(m(f)):I=f;let O;c instanceof Date?O=c.getTime():typeof c=="string"&&(O=new Date(c).getTime());let t;if(typeof u=="string"?t=R(m(u)):t=u,!I||!t)return!1;const n=I.majorBase,s=I.minorBase,i=I.patchBase;let a=t.majorBase,l=t.minorBase,h=t.patchBase;const C=t.notBefore;let D=t.majorMustEqual,w=t.minorMustEqual,S=t.patchMustEqual;return t.isMinimum?n>a?!0:n<a?!1:s>l?!0:s<l||O&&O<C?!1:i>=h:(n===1&&a===0&&(!D||!w||!S)&&(a=1,l=0,h=0,D=!0,w=!1,S=!1),n<a?!1:n>a?!D:s<l?!1:s>l?!w:i<h?!1:i>h?!S:!(O&&O<C))}e.isValidVersion=E;function b(f,c,u,I,O){const t=[];if(typeof I.publisher<"u"&&typeof I.publisher!="string")return t.push([L.default.Error,o.localize(0,null)]),t;if(typeof I.name!="string")return t.push([L.default.Error,o.localize(1,null,"name")]),t;if(typeof I.version!="string")return t.push([L.default.Error,o.localize(2,null,"version")]),t;if(!I.engines)return t.push([L.default.Error,o.localize(3,null,"engines")]),t;if(typeof I.engines.vscode!="string")return t.push([L.default.Error,o.localize(4,null,"engines.vscode")]),t;if(typeof I.extensionDependencies<"u"&&!r(I.extensionDependencies))return t.push([L.default.Error,o.localize(5,null,"extensionDependencies")]),t;if(typeof I.activationEvents<"u"){if(!r(I.activationEvents))return t.push([L.default.Error,o.localize(6,null,"activationEvents")]),t;if(typeof I.main>"u"&&typeof I.browser>"u")return t.push([L.default.Error,o.localize(7,null,"activationEvents","main","browser")]),t}if(typeof I.extensionKind<"u"&&typeof I.main>"u"&&t.push([L.default.Warning,o.localize(8,null,"extensionKind")]),typeof I.main<"u"){if(typeof I.main!="string")return t.push([L.default.Error,o.localize(9,null,"main")]),t;{const i=(0,y.joinPath)(u,I.main);(0,y.isEqualOrParent)(i,u)||t.push([L.default.Warning,o.localize(10,null,i.path,u.path)])}}if(typeof I.browser<"u"){if(typeof I.browser!="string")return t.push([L.default.Error,o.localize(11,null,"browser")]),t;{const i=(0,y.joinPath)(u,I.browser);(0,y.isEqualOrParent)(i,u)||t.push([L.default.Warning,o.localize(12,null,i.path,u.path)])}}if(!A.valid(I.version))return t.push([L.default.Error,o.localize(13,null)]),t;const n=[];if(!d(f,c,I,O,n))for(const i of n)t.push([L.default.Error,i]);return t}e.validateExtensionManifest=b;function d(f,c,u,I,O){return I||typeof u.main>"u"&&typeof u.browser>"u"?!0:p(f,c,u.engines.vscode,O)}e.isValidExtensionVersion=d;function g(f,c,u){return f==="*"||p(c,u,f)}e.isEngineValid=g;function p(f,c,u,I=[]){const O=R(m(u));if(!O)return I.push(o.localize(14,null,u)),!1;if(O.majorBase===0){if(!O.majorMustEqual||!O.minorMustEqual)return I.push(o.localize(15,null,u)),!1}else if(!O.majorMustEqual)return I.push(o.localize(16,null,u)),!1;return E(f,c,O)?!0:(I.push(o.localize(17,null,f,u)),!1)}function r(f){if(!Array.isArray(f))return!1;for(let c=0,u=f.length;c<u;c++)if(typeof f[c]!="string")return!1;return!0}}),define(pe[207],be([1,0,15,21]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function o(A,k,T){let v=T&&T.get("storage.serviceMachineId",-1)||null;if(v)return v;try{const R=(await k.readFile(A.serviceMachineIdResource)).value.toString();v=(0,L.isUUID)(R)?R:null}catch{v=null}if(!v){v=(0,L.generateUuid)();try{await k.writeFile(A.serviceMachineIdResource,y.VSBuffer.fromString(v))}catch{}}return T?.store("storage.serviceMachineId",v,-1,1),v}e.getServiceMachineId=o}),define(pe[63],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class y{constructor(o,A=[],k=!1){this.ctor=o,this.staticArguments=A,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=y}),define(pe[208],be([1,0,63]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var o;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(o||(e.InstantiationType=o={}));function A(T,v,m){v instanceof y.SyncDescriptor||(v=new y.SyncDescriptor(v,[],!!m)),L.push([T,v])}e.registerSingleton=A;function k(){return L}e.getSingletonServiceDescriptors=k}),define(pe[209],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class y{constructor(A,k){this.key=A,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=y;class L{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const k of this.a.values())k.outgoing.size===0&&A.push(k);return A}insertEdge(A,k){const T=this.lookupOrInsertNode(A),v=this.lookupOrInsertNode(k);T.outgoing.set(v.key,v),v.incoming.set(T.key,T)}removeNode(A){const k=this.b(A);this.a.delete(k);for(const T of this.a.values())T.outgoing.delete(k),T.incoming.delete(k)}lookupOrInsertNode(A){const k=this.b(A);let T=this.a.get(k);return T||(T=new y(k,A),this.a.set(k,T)),T}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[k,T]of this.a)A.push(`${k}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,k]of this.a){const T=new Set([A]),v=this.c(k,T);if(v)return v}}c(A,k){for(const[T,v]of A.outgoing){if(k.has(T))return[...k,T].join(" -> ");k.add(T);const m=this.c(v,k);if(m)return m;k.delete(T)}}}e.Graph=L}),define(pe[5],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var y;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function T(v){return v[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=T})(y||(e._util=y={})),e.IInstantiationService=o("instantiationService");function L(k,T,v){T[y.DI_TARGET]===T?T[y.DI_DEPENDENCIES].push({id:k,index:v}):(T[y.DI_DEPENDENCIES]=[{id:k,index:v}],T[y.DI_TARGET]=T)}function o(k){if(y.serviceIds.has(k))return y.serviceIds.get(k);const T=function(v,m,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(T,v,R)};return T.toString=()=>k,y.serviceIds.set(k,T),T}e.createDecorator=o;function A(k){return k}e.refineServiceDecorator=A}),define(pe[24],be([1,0,8,4,5]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,o.createDecorator)("configurationService");function A(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=A;function k(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=k;var T;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function v(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=v;function m(r,f){const c=Object.create(null);for(const u in r)R(c,u,r[u],f);return c}e.toValuesTree=m;function R(r,f,c,u){const I=f.split("."),O=I.pop();let t=r;for(let n=0;n<I.length;n++){const s=I[n];let i=t[s];switch(typeof i){case"undefined":i=t[s]=Object.create(null);break;case"object":break;default:u(`Ignoring ${f} as ${I.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[O]=c}catch{u(`Ignoring ${f} as ${I.join(".")} is ${JSON.stringify(t)}`)}else u(`Ignoring ${f} as ${I.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=R;function E(r,f){const c=f.split(".");b(r,c)}e.removeFromValueTree=E;function b(r,f){const c=f.shift();if(f.length===0){delete r[c];return}if(Object.keys(r).indexOf(c)!==-1){const u=r[c];typeof u=="object"&&!Array.isArray(u)&&(b(u,f),Object.keys(u).length===0&&delete r[c])}}function d(r,f,c){function u(t,n){let s=t;for(const i of n){if(typeof s!="object"||s===null)return;s=s[i]}return s}const I=f.split("."),O=u(r,I);return typeof O>"u"?c:O}e.getConfigurationValue=d;function g(r,f,c){Object.keys(f).forEach(u=>{u!=="__proto__"&&(u in r?y.isObject(r[u])&&y.isObject(f[u])?g(r[u],f[u],c):c&&(r[u]=f[u]):r[u]=f[u])})}e.merge=g;function p(r){return r.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(pe[64],be([1,0,3,17,200,5,168,9]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const v=new Map;v.set("false",!1),v.set("true",!0),v.set("isMac",y.isMacintosh),v.set("isLinux",y.isLinux),v.set("isWindows",y.isWindows),v.set("isWeb",y.isWeb),v.set("isMacNative",y.isMacintosh&&!y.isWeb),v.set("isEdge",y.isEdge),v.set("isFirefox",y.isFirefox),v.set("isChrome",y.isChrome),v.set("isSafari",y.isSafari);function m(z,P){if(v.get(z)!==void 0)throw(0,T.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");v.set(z,P)}e.setConstant=m;const R=Object.prototype.hasOwnProperty;var E;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const b={regexParsingWithErrorRecovery:!0},d=(0,k.localize)(0,null),g=(0,k.localize)(1,null),p=(0,k.localize)(2,null),r=(0,k.localize)(3,null),f=(0,k.localize)(4,null),c=(0,k.localize)(5,null),u=(0,k.localize)(6,null),I=(0,k.localize)(7,null);class O{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=b){this.k=P,this.d=new o.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const M=this.l();if(!this.E()){const K=this.D(),te=K.type===17?c:void 0;throw this.h.push({message:f,offset:K.offset,lexeme:o.Scanner.getLexeme(K),additionalInfo:te}),O.c}return M}catch(M){if(M!==O.c)throw M;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const M=this.o();P.push(M)}return P.length===1?P[0]:t.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const M=this.s();P.push(M)}return P.length===1?P[0]:t.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const M=this.l();return this.A(1,r),M?.negate()}case 17:return this.z(),N.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const M=this.l();return this.A(1,r),M}case 17:{const M=P.lexeme;if(this.z(),this.y(9)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==10)throw this.B("REGEX",te);const j=te.lexeme,W=j.lastIndexOf("/"),x=W===j.length-1?void 0:this.w(j.substring(W+1));let H;try{H=new RegExp(j.substring(1,W),x)}catch{throw this.B("REGEX",te)}return me.create(M,H)}switch(te.type){case 10:case 19:{const j=[te.lexeme];this.z();let W=this.D(),x=0;for(let ce=0;ce<te.lexeme.length;ce++)te.lexeme.charCodeAt(ce)===40?x++:te.lexeme.charCodeAt(ce)===41&&x--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:x++;break;case 1:x--;break;case 10:case 18:for(let ce=0;ce<W.lexeme.length;ce++)W.lexeme.charCodeAt(ce)===40?x++:te.lexeme.charCodeAt(ce)===41&&x--}if(x<0)break;j.push(o.Scanner.getLexeme(W)),this.z(),W=this.D()}const H=j.join(""),Q=H.lastIndexOf("/"),G=Q===H.length-1?void 0:this.w(H.substring(Q+1));let Z;try{Z=new RegExp(H.substring(1,Q),G)}catch{throw this.B("REGEX",te)}return t.regex(M,Z)}case 18:{const j=te.lexeme;this.z();let W=null;if(!(0,L.isFalsyOrWhitespace)(j)){const x=j.indexOf("/"),H=j.lastIndexOf("/");if(x!==H&&x>=0){const Q=j.slice(x+1,H),G=j[H+1]==="i"?"i":"";try{W=new RegExp(Q,G)}catch{throw this.B("REGEX",te)}}}if(W===null)throw this.B("REGEX",te);return me.create(M,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const te=this.u();return t.notIn(M,te)}switch(this.D().type){case 3:{this.z();const te=this.u();if(this.x().type===18)return t.equals(M,te);switch(te){case"true":return t.has(M);case"false":return t.not(M);default:return t.equals(M,te)}}case 4:{this.z();const te=this.u();if(this.x().type===18)return t.notEquals(M,te);switch(te){case"true":return t.not(M);case"false":return t.has(M);default:return t.notEquals(M,te)}}case 5:return this.z(),oe.create(M,this.u());case 6:return this.z(),ue.create(M,this.u());case 7:return this.z(),ee.create(M,this.u());case 8:return this.z(),he.create(M,this.u());case 13:return this.z(),t.in(M,this.u());default:return t.has(M)}}case 20:throw this.h.push({message:u,offset:P.offset,lexeme:"",additionalInfo:I}),O.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,M){if(this.C(P))return this.z();throw this.B(M,this.D())}B(P,M,K){const te=(0,k.localize)(8,null,P,o.Scanner.getLexeme(M)),j=M.offset,W=o.Scanner.getLexeme(M);return this.h.push({message:te,offset:j,lexeme:W,additionalInfo:K}),O.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}e.Parser=O,O.c=new Error;class t{static false(){return a.INSTANCE}static true(){return l.INSTANCE}static has(P){return h.create(P)}static equals(P,M){return C.create(P,M)}static notEquals(P,M){return S.create(P,M)}static regex(P,M){return me.create(P,M)}static in(P,M){return D.create(P,M)}static notIn(P,M){return w.create(P,M)}static not(P){return N.create(P)}static and(...P){return q.create(P,null,!0)}static or(...P){return J.create(P,null,!0)}static greater(P,M){return ee.create(P,M)}static greaterEquals(P,M){return he.create(P,M)}static smaller(P,M){return oe.create(P,M)}static smallerEquals(P,M){return ue.create(P,M)}static deserialize(P){return P==null?void 0:this.c.parse(P)}}e.ContextKeyExpr=t,t.c=new O({regexParsingWithErrorRecovery:!1});function n(z){const P=new O({regexParsingWithErrorRecovery:!1});return z.map(M=>(P.parse(M),P.lexingErrors.length>0?P.lexingErrors.map(K=>({errorMessage:K.additionalInfo?(0,k.localize)(9,null,K.additionalInfo):(0,k.localize)(10,null),offset:K.offset,length:K.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(K=>({errorMessage:K.additionalInfo?`${K.message}. ${K.additionalInfo}`:K.message,offset:K.offset,length:K.lexeme.length})):[]))}e.validateWhenClauses=n;function s(z,P){const M=z?z.substituteConstants():void 0,K=P?P.substituteConstants():void 0;return!M&&!K?!0:!M||!K?!1:M.equals(K)}e.expressionsAreEqualWithConstantSubstitution=s;function i(z,P){return z.cmp(P)}class a{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=a,a.INSTANCE=new a;class l{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return a.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class h{static create(P,M=null){const K=v.get(P);return typeof K=="boolean"?K?l.INSTANCE:a.INSTANCE:new h(P,M)}constructor(P,M){this.key=P,this.c=M,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=v.get(this.key);return typeof P=="boolean"?P?l.INSTANCE:a.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=h;class C{static create(P,M,K=null){if(typeof M=="boolean")return M?h.create(P,K):N.create(P,K);const te=v.get(P);return typeof te=="boolean"?M===(te?"true":"false")?l.INSTANCE:a.INSTANCE:new C(P,M,K)}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:V(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=v.get(this.c);if(typeof P=="boolean"){const M=P?"true":"false";return this.d===M?l.INSTANCE:a.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=C;class D{static create(P,M){return new D(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:V(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.f),K=P.getValue(this.d);return Array.isArray(M)?M.includes(K):typeof K=="string"&&typeof M=="object"&&M!==null?R.call(M,K):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=D;class w{static create(P,M){return new w(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=11,this.c=D.create(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=w;class S{static create(P,M,K=null){if(typeof M=="boolean")return M?N.create(P,K):h.create(P,K);const te=v.get(P);return typeof te=="boolean"?M===(te?"true":"false")?a.INSTANCE:l.INSTANCE:new S(P,M,K)}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:V(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=v.get(this.c);if(typeof P=="boolean"){const M=P?"true":"false";return this.d===M?a.INSTANCE:l.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=S;class N{static create(P,M=null){const K=v.get(P);return typeof K=="boolean"?K?a.INSTANCE:l.INSTANCE:new N(P,M)}constructor(P,M){this.c=P,this.d=M,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:ne(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=v.get(this.c);return typeof P=="boolean"?P?a.INSTANCE:l.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.ContextKeyNotExpr=N;function $(z,P){if(typeof z=="string"){const M=parseFloat(z);isNaN(M)||(z=M)}return typeof z=="string"||typeof z=="number"?P(z):a.INSTANCE}class ee{static create(P,M,K=null){return $(M,te=>new ee(P,te,K))}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:V(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=ee;class he{static create(P,M,K=null){return $(M,te=>new he(P,te,K))}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:V(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=he;class oe{static create(P,M,K=null){return $(M,te=>new oe(P,te,K))}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:V(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=oe;class ue{static create(P,M,K=null){return $(M,te=>new ue(P,te,K))}constructor(P,M,K){this.c=P,this.d=M,this.f=K,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:V(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=ue;class me{static create(P,M){return new me(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const M=this.f?this.f.source:"",K=P.f?P.f.source:"";return M<K?-1:M>K?1:0}equals(P){if(P.type===this.type){const M=this.f?this.f.source:"",K=P.f?P.f.source:"";return this.d===P.d&&M===K}return!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=_.create(this)),this.c}}e.ContextKeyRegexExpr=me;class _{static create(P){return new _(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(P){return new _(this.c.map(P))}negate(){return this.c}}e.ContextKeyNotRegexExpr=_;function re(z){let P=null;for(let M=0,K=z.length;M<K;M++){const te=z[M].substituteConstants();if(z[M]!==te&&P===null){P=[];for(let j=0;j<M;j++)P[j]=z[j]}P!==null&&(P[M]=te)}return P===null?z:P}class q{static create(P,M,K){return q.d(P,M,K)}constructor(P,M){this.expr=P,this.c=M,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,K=this.expr.length;M<K;M++){const te=i(this.expr[M],P.expr[M]);if(te!==0)return te}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,K=this.expr.length;M<K;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=re(this.expr);return P===this.expr?this:q.create(P,this.c,!1)}evaluate(P){for(let M=0,K=this.expr.length;M<K;M++)if(!this.expr[M].evaluate(P))return!1;return!0}static d(P,M,K){const te=[];let j=!1;for(const W of P)if(W){if(W.type===1){j=!0;continue}if(W.type===0)return a.INSTANCE;if(W.type===6){te.push(...W.expr);continue}te.push(W)}if(te.length===0&&j)return l.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(i);for(let W=1;W<te.length;W++)te[W-1].equals(te[W])&&(te.splice(W,1),W--);if(te.length===1)return te[0];for(;te.length>1;){const W=te[te.length-1];if(W.type!==9)break;te.pop();const x=te.pop(),H=te.length===0,Q=J.create(W.expr.map(G=>q.create([G,x],null,K)),null,H);Q&&(te.push(Q),te.sort(i))}if(te.length===1)return te[0];if(K){for(let W=0;W<te.length;W++)for(let x=W+1;x<te.length;x++)if(te[W].negate().equals(te[x]))return a.INSTANCE;if(te.length===1)return te[0]}return new q(te,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new q(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.c){const P=[];for(const M of this.expr)P.push(M.negate());this.c=J.create(P,this,!0)}return this.c}}e.ContextKeyAndExpr=q;class J{static create(P,M,K){return J.d(P,M,K)}constructor(P,M){this.expr=P,this.c=M,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,K=this.expr.length;M<K;M++){const te=i(this.expr[M],P.expr[M]);if(te!==0)return te}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,K=this.expr.length;M<K;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=re(this.expr);return P===this.expr?this:J.create(P,this.c,!1)}evaluate(P){for(let M=0,K=this.expr.length;M<K;M++)if(this.expr[M].evaluate(P))return!0;return!1}static d(P,M,K){let te=[],j=!1;if(P){for(let W=0,x=P.length;W<x;W++){const H=P[W];if(H){if(H.type===0){j=!0;continue}if(H.type===1)return l.INSTANCE;if(H.type===9){te=te.concat(H.expr);continue}te.push(H)}}if(te.length===0&&j)return a.INSTANCE;te.sort(i)}if(te.length!==0){if(te.length===1)return te[0];for(let W=1;W<te.length;W++)te[W-1].equals(te[W])&&(te.splice(W,1),W--);if(te.length===1)return te[0];if(K){for(let W=0;W<te.length;W++)for(let x=W+1;x<te.length;x++)if(te[W].negate().equals(te[x]))return l.INSTANCE;if(te.length===1)return te[0]}return new J(te,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new J(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.c){const P=[];for(const M of this.expr)P.push(M.negate());for(;P.length>1;){const M=P.shift(),K=P.shift(),te=[];for(const j of ie(M))for(const W of ie(K))te.push(q.create([j,W],null,!1));P.unshift(J.create(te,null,!1))}this.c=J.create(P,this,!0)}return this.c}}e.ContextKeyOrExpr=J;class U extends h{static all(){return U.d.values()}constructor(P,M,K){super(P,null),this.f=M,typeof K=="object"?U.d.push({...K,key:P}):K!==!0&&U.d.push({key:P,description:K,type:M!=null?typeof M:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return C.create(this.key,P)}notEqualsTo(P){return S.create(this.key,P)}}e.RawContextKey=U,U.d=[],e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function ne(z,P){return z<P?-1:z>P?1:0}function V(z,P,M,K){return z<M?-1:z>M?1:P<K?-1:P>K?1:0}function se(z,P){if(z.type===0||P.type===1)return!0;if(z.type===9)return P.type===9?Y(z.expr,P.expr):!1;if(P.type===9){for(const M of P.expr)if(se(z,M))return!0;return!1}if(z.type===6){if(P.type===6)return Y(P.expr,z.expr);for(const M of z.expr)if(se(M,P))return!0;return!1}return z.equals(P)}e.implies=se;function Y(z,P){let M=0,K=0;for(;M<z.length&&K<P.length;){const te=z[M].cmp(P[K]);if(te<0)return!1;te===0&&M++,K++}return M===z.length}function ie(z){return z.type===9?z.expr:[z]}}),define(pe[78],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,y.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,y.createDecorator)("credentialsMainService");class L{constructor(){this.a={}}async getPassword(A,k){return this.a[A]?.[k]??null}async setPassword(A,k,T){this.a[A]=this.a[A]??{},this.a[A][k]=T}async deletePassword(A,k){return this.a[A]?.[k]?(delete this.a[A][k],Object.keys(this.a[A]).length===0&&delete this.a[A],!0):!1}async findPassword(A){return JSON.stringify(this.a[A])??null}async findCredentials(A){const k=[];for(const T of Object.keys(this.a[A]||{}))k.push({account:T,password:this.a[A][T]});return k}async clear(){this.a={}}}e.InMemoryCredentialsProvider=L}),define(pe[210],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,y.createDecorator)(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=L;class o{async getPerformanceInfo(k,T){return{}}async getSystemInfo(k,T){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,T){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=o}),define(pe[79],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,y.createDecorator)("downloadService")}),define(pe[211],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,y.createDecorator)("encryptionMainService")}),define(pe[25],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,y.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,y.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[30],be([1,0,173,5]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function o(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=o;function A(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function k(c,u){switch(c){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function T(c,u){return u==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function v(c,u,I){return T(u,I)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===I?!0:m(I).includes(c)}e.isTargetPlatformCompatible=v;function m(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function R(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=R;var E;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var b;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var d;(function(c){c.Install="install",c.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var g;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var p;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var r;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class f extends Error{constructor(u,I){super(u),this.code=I,this.name=I}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,y.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,y.localize)(1,null),original:"Preferences"}}),define(pe[212],be([1,0,6,2,22,4,50,30]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function v(r,f){return r?A.URI.revive(f?f.transformIncoming(r):r):void 0}function m(r,f){return f?f.transformOutgoingURI(r):r}function R(r,f){f=f||k.DefaultURITransformer;const c=r.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...r,manifest:void 0},f),manifest:c}}function E(r,f){return r?.profileLocation?(0,k.transformAndReviveIncomingURIs)(r,f??k.DefaultURITransformer):r}function b(r,f){return f?(0,o.cloneAndChange)(r,c=>c instanceof A.URI?f.transformOutgoingURI(c):void 0):r}class d{constructor(f,c){this.a=f,this.b=c,this.onInstallExtension=y.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=y.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=y.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=y.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=y.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,c){const u=this.b(f);switch(c){case"onInstallExtension":return y.Event.map(this.onInstallExtension,I=>({...I,profileLocation:I.profileLocation?m(I.profileLocation,u):I.profileLocation}));case"onDidInstallExtensions":return y.Event.map(this.onDidInstallExtensions,I=>I.map(O=>({...O,local:O.local?b(O.local,u):O.local,profileLocation:O.profileLocation?m(O.profileLocation,u):O.profileLocation})));case"onUninstallExtension":return y.Event.map(this.onUninstallExtension,I=>({...I,profileLocation:I.profileLocation?m(I.profileLocation,u):I.profileLocation}));case"onDidUninstallExtension":return y.Event.map(this.onDidUninstallExtension,I=>({...I,profileLocation:I.profileLocation?m(I.profileLocation,u):I.profileLocation}));case"onDidUpdateExtensionMetadata":return y.Event.map(this.onDidUpdateExtensionMetadata,I=>b(I,u))}throw new Error("Invalid listen")}async call(f,c,u){const I=this.b(f);switch(c){case"zip":{const O=R(u[0],I),t=await this.a.zip(O);return m(t,I)}case"unzip":return this.a.unzip(v(u[0],I));case"install":return this.a.install(v(u[0],I),E(u[1],I));case"installFromLocation":return this.a.installFromLocation(v(u[0],I),v(u[1],I));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(u[0],v(u[1],I),v(u[2],I));case"getManifest":return this.a.getManifest(v(u[0],I));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(u[0]);case"installFromGallery":return this.a.installFromGallery(u[0],E(u[1],I));case"uninstall":return this.a.uninstall(R(u[0],I),E(u[1],I));case"reinstallFromGallery":return this.a.reinstallFromGallery(R(u[0],I));case"getInstalled":return(await this.a.getInstalled(u[0],v(u[1],I))).map(t=>b(t,I));case"copyExtensions":return this.a.copyExtensions(v(u[0],I),v(u[1],I));case"updateMetadata":{const O=await this.a.updateMetadata(R(u[0],I),u[1],v(u[2],I));return b(O,I)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(u[0],u[1],u[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class g extends L.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.k=f,this.c=this.B(new y.Emitter),this.f=this.B(new y.Emitter),this.g=this.B(new y.Emitter),this.h=this.B(new y.Emitter),this.j=this.B(new y.Emitter),this.B(this.k.listen("onInstallExtension")(c=>this.l(this.c,{...c,source:this.m(c.source)?A.URI.revive(c.source):c.source,profileLocation:A.URI.revive(c.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(c=>this.l(this.f,c.map(u=>({...u,local:u.local?R(u.local,null):u.local,source:this.m(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(c=>this.l(this.g,{...c,profileLocation:A.URI.revive(c.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(c=>this.l(this.h,{...c,profileLocation:A.URI.revive(c.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(c=>this.j.fire(R(c,null))))}l(f,c){f.fire(c)}m(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(f){const c=await this.getTargetPlatform();return f.allTargetPlatforms.some(u=>(0,T.isTargetPlatformCompatible)(u,f.allTargetPlatforms,c))}zip(f){return Promise.resolve(this.k.call("zip",[f]).then(c=>A.URI.revive(c)))}unzip(f){return Promise.resolve(this.k.call("unzip",[f]))}install(f,c){return Promise.resolve(this.k.call("install",[f,c])).then(u=>R(u,null))}installFromLocation(f,c){return Promise.resolve(this.k.call("installFromLocation",[f,c])).then(u=>R(u,null))}async installExtensionsFromProfile(f,c,u){return(await this.k.call("installExtensionsFromProfile",[f,c,u])).map(O=>R(O,null))}getManifest(f){return Promise.resolve(this.k.call("getManifest",[f]))}installFromGallery(f,c){return Promise.resolve(this.k.call("installFromGallery",[f,c])).then(u=>R(u,null))}uninstall(f,c){return Promise.resolve(this.k.call("uninstall",[f,c]))}reinstallFromGallery(f){return Promise.resolve(this.k.call("reinstallFromGallery",[f])).then(c=>R(c,null))}getInstalled(f=null,c){return Promise.resolve(this.k.call("getInstalled",[f,c])).then(u=>u.map(I=>R(I,null)))}updateMetadata(f,c,u){return Promise.resolve(this.k.call("updateMetadata",[f,c,u])).then(I=>R(I,null))}copyExtensions(f,c){return this.k.call("copyExtensions",[f,c])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(f,c,u){const I=await this.k.call("download",[f,c,u]);return A.URI.revive(I)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=g;class p{constructor(f){this.a=f}listen(f,c){throw new Error("Invalid listen")}call(f,c,u){switch(c){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=p}),define(pe[80],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,y.createDecorator)("IExtensionSignatureVerificationService");class L{b(){return this.a||(this.a=new Promise((A,k)=>le(["node-vsce-sign"],async T=>A(T),k))),this.a}async verify(A,k,T){let v;try{v=await this.b()}catch{return!1}return v.verify(A,k,T)}}e.ExtensionSignatureVerificationService=L}),define(pe[16],be([1,0,61,7,17,8,4,181,5,3,13]),function(le,e,y,L,o,A,k,T,v,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,v.createDecorator)("fileService");function E(U){return U.create===!0}e.isFileOpenForWriteOptions=E;var b;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var d;(function(U){U[U.Readonly=1]="Readonly",U[U.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var g;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileAtomicWrite=32768]="FileAtomicWrite",U[U.FileAtomicDelete=65536]="FileAtomicDelete",U[U.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function p(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=p;function r(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=r;function f(U){return!!(U.capabilities&131072)}e.hasFileCloneCapability=f;function c(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function u(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=u;function I(U){return p(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=I;function O(U){return p(U)?!!(U.capabilities&32768):!1}e.hasFileAtomicWriteCapability=O;function t(U){return!!(U.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;var n;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsStorageQuota="EntryExceedsStorageQuota",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class s extends Error{static create(ne,V){const se=new s(ne.toString(),V);return l(se,V),se}constructor(ne,V){super(ne),this.code=V}}e.FileSystemProviderError=s;function i(U,ne){return s.create(U,ne)}e.createFileSystemProviderError=i;function a(U){return U||i((0,T.localize)(0,null),n.Unknown)}e.ensureFileSystemProviderError=a;function l(U,ne){return U.name=ne?`${ne} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=l;function h(U){if(!U)return n.Unknown;if(U instanceof s)return U.code;const ne=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!ne)return n.Unknown;switch(ne[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.toFileSystemProviderErrorCode=h;function C(U){if(U instanceof ee)return U.fileOperationResult;switch(h(U)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=C;var D;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class w{constructor(ne,V,se){this.resource=ne,this.operation=V,this.target=se}isOperation(ne){return this.operation===ne}}e.FileOperationEvent=w;var S;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(S||(e.FileChangeType=S={}));class N{constructor(ne,V){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const Y of ne){const ie=se.get(Y.type);switch(ie?ie.push([Y.resource,Y]):se.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,ie]of se)switch(Y){case 1:this.a=y.TernarySearchTree.forUris(()=>V),this.a.fill(ie);break;case 0:this.b=y.TernarySearchTree.forUris(()=>V),this.b.fill(ie);break;case 2:this.c=y.TernarySearchTree.forUris(()=>V),this.c.fill(ie);break}}contains(ne,...V){return this.d(ne,{includeChildren:!1},...V)}affects(ne,...V){return this.d(ne,{includeChildren:!0},...V)}d(ne,V,...se){if(!ne)return!1;const Y=se.length>0;return!!((!Y||se.includes(1))&&(this.a?.get(ne)||V.includeChildren&&this.a?.findSuperstr(ne))||(!Y||se.includes(0))&&(this.b?.get(ne)||V.includeChildren&&this.b?.findSuperstr(ne))||(!Y||se.includes(2))&&(this.c?.findSubstr(ne)||V.includeChildren&&this.c?.findSuperstr(ne)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=N;function $(U,ne,V){return!U||!ne||U===ne||ne.length>U.length?!1:(ne.charAt(ne.length-1)!==L.sep&&(ne+=L.sep),V?(0,o.startsWithIgnoreCase)(U,ne):U.indexOf(ne)===0)}e.isParent=$;class ee extends Error{constructor(ne,V,se){super(ne),this.fileOperationResult=V,this.options=se}}e.FileOperationError=ee;class he extends ee{constructor(ne,V,se,Y){super(ne,V,Y),this.fileOperationResult=V,this.size=se}}e.TooLargeFileOperationError=he;class oe extends ee{constructor(ne,V,se){super(ne,2,se),this.stat=V}}e.NotModifiedSinceFileOperationError=oe;var ue;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(e.FileOperationResult=ue={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var me;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(me||(e.FileKind=me={})),e.ETAG_DISABLED="";function _(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=_;async function re(U,ne){if(!ne.hasProvider(k.URI.from({scheme:U.scheme})))return new Promise(V=>{const se=ne.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===U.scheme&&Y.added&&(se.dispose(),V())})})}e.whenProviderRegistered=re;class q{static formatSize(ne){return(0,A.isNumber)(ne)||(ne=0),ne<q.KB?(0,T.localize)(1,null,ne.toFixed(0)):ne<q.MB?(0,T.localize)(2,null,(ne/q.KB).toFixed(2)):ne<q.GB?(0,T.localize)(3,null,(ne/q.MB).toFixed(2)):ne<q.TB?(0,T.localize)(4,null,(ne/q.GB).toFixed(2)):(0,T.localize)(5,null,(ne/q.TB).toFixed(2))}}e.ByteSize=q,q.KB=1024,q.MB=q.KB*q.KB,q.GB=q.MB*q.KB,q.TB=q.GB*q.KB;function J(U){const ne=typeof U=="string"||U?.scheme===R.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===R.Schemas.file?1024*q.MB:ne?10*q.MB:m.isWeb?50*q.MB:1024*q.MB}e.getLargeFileConfirmationLimit=J}),define(pe[213],be([1,0,15,39,9,6,2,47,4,21,16]),function(le,e,y,L,o,A,k,T,v,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends k.Disposable{constructor(d,g){super(),this.a=d,this.b=g,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,m.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,g){const{buffer:p}=await this.a.call("readFile",[d,g]);return p}readFileStream(d,g,p){const r=(0,T.newWriteableStream)(c=>y.VSBuffer.concat(c.map(u=>y.VSBuffer.wrap(u))).buffer),f=this.a.listen("readFileStream",[d,g])(c=>{if(c instanceof y.VSBuffer)r.write(c.buffer);else{if(c==="end")r.end();else{let u;if(c instanceof Error)u=c;else{const I=c;u=(0,R.createFileSystemProviderError)(I.message??(0,L.toErrorMessage)(I),I.code??R.FileSystemProviderErrorCode.Unknown)}r.error(u),r.end()}f.dispose()}});return p.onCancellationRequested(()=>{r.error((0,o.canceled)()),r.end(),f.dispose()}),r}writeFile(d,g,p){return this.a.call("writeFile",[d,y.VSBuffer.wrap(g),p])}open(d,g){return this.a.call("open",[d,g])}close(d){return this.a.call("close",[d])}async read(d,g,p,r,f){const[c,u]=await this.a.call("read",[d,g,f]);return p.set(c.buffer.slice(0,u),r),u}write(d,g,p,r,f){return this.a.call("write",[d,g,y.VSBuffer.wrap(p),r,f])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,g){return this.a.call("delete",[d,g])}rename(d,g,p){return this.a.call("rename",[d,g,p])}copy(d,g,p){return this.a.call("copy",[d,g,p])}cloneFile(d,g){return this.a.call("cloneFile",[d,g])}i(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const g=d;this.f.fire(g.map(p=>({resource:v.URI.revive(p.resource),type:p.type})))}else{const g=d;this.g.fire(g)}}))}watch(d,g){const p=(0,m.generateUuid)();return this.a.call("watch",[this.h,p,d,g]),(0,k.toDisposable)(()=>this.a.call("unwatch",[this.h,p]))}}e.DiskFileSystemProviderClient=E}),define(pe[108],be([1,0,15,9,182,16]),function(le,e,y,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(R,E,b,d,g,p){let r;try{await T(R,E,b,d,g,p)}catch(f){r=f}finally{r&&g.errorTransformer&&(r=g.errorTransformer(r)),typeof r<"u"&&b.error(r),b.end()}}e.readFileIntoStream=k;async function T(R,E,b,d,g,p){v(p);const r=await R.open(E,{create:!1});try{v(p);let f=0,c=0,u=g&&typeof g.length=="number"?g.length:void 0,I=y.VSBuffer.alloc(Math.min(g.bufferSize,typeof u=="number"?u:g.bufferSize)),O=g&&typeof g.position=="number"?g.position:0,t=0;do c=await R.read(r,O,I.buffer,t,I.byteLength-t),O+=c,t+=c,f+=c,typeof u=="number"&&(u-=c),t===I.byteLength&&(await b.write(d(I)),I=y.VSBuffer.alloc(Math.min(g.bufferSize,typeof u=="number"?u:g.bufferSize)),t=0);while(c>0&&(typeof u!="number"||u>0)&&v(p)&&m(f,g));if(t>0){let n=t;typeof u=="number"&&(n=Math.min(t,u)),b.write(d(I.slice(0,n)))}}catch(f){throw(0,A.ensureFileSystemProviderError)(f)}finally{await R.close(r)}}function v(R){if(R.isCancellationRequested)throw(0,L.canceled)();return!0}function m(R,E){if(typeof E?.limits?.size=="number"&&R>E.limits.size)throw(0,A.createFileSystemProviderError)((0,o.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(pe[65],be([1,0,74,2,7,3,4,16]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function v(f){return f.recursive===!0}e.isRecursiveWatchRequest=v;class m extends L.Disposable{constructor(c,u,I,O){super(),this.h=c,this.i=u,this.j=I,this.k=O,this.c=this.B(new L.MutableDisposable),this.f=void 0,this.g=0}m(){const c=new L.DisposableStore;this.c.value=c,this.b=this.l(c),this.b.setVerboseLogging(this.j),c.add(this.b.onDidChangeFile(u=>this.h(u))),c.add(this.b.onDidLogMessage(u=>this.i(u))),c.add(this.b.onDidError(u=>this.n(u)))}n(c){this.k.restartOnError?this.g<m.a&&this.f?(this.r(`restarting watcher after error: ${c}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${c}`):this.r(c)}p(c){this.g++,this.m(),this.watch(c)}async watch(c){this.f=c,await this.b?.watch(c)}async setVerboseLogging(c){this.j=c,await this.b?.setVerboseLogging(c)}r(c){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${c}`})}s(c){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${c}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.a=5;class R extends m{constructor(c,u,I){super(c,u,I,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=R;class E extends m{constructor(c,u,I){super(c,u,I,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function b(f){return f.map(c=>({type:c.type,resource:k.URI.file(c.path)}))}e.toFileChanges=b;function d(f){const c=new r;for(const u of f)c.processEvent(u);return c.coalesce()}e.coalesceEvents=d;function g(f,c){return typeof c=="string"&&!c.startsWith(y.GLOBSTAR)&&!(0,o.isAbsolute)(c)?{base:f,pattern:c}:c}e.normalizeWatcherPattern=g;function p(f,c){const u=[];for(const I of c)u.push((0,y.parse)(g(f,I)));return u}e.parseWatcherPatterns=p;class r{constructor(){this.a=new Set,this.b=new Map}c(c){return A.isLinux?c.path:c.path.toLowerCase()}processEvent(c){const u=this.b.get(this.c(c));let I=!1;if(u){const O=u.type,t=c.type;u.path!==c.path&&(c.type===2||c.type===1)?I=!0:O===1&&t===2?(this.b.delete(this.c(c)),this.a.delete(u)):O===2&&t===1?u.type=0:O===1&&t===0||(u.type=t)}else I=!0;I&&(this.a.add(c),this.b.set(this.c(c),c))}coalesce(){const c=[],u=[];return Array.from(this.a).filter(I=>I.type!==2?(c.push(I),!1):!0).sort((I,O)=>I.path.length-O.path.length).filter(I=>u.some(O=>(0,T.isParent)(I.path,O,!A.isLinux))?!1:(u.push(I.path),!0)).concat(c)}}}),define(pe[214],be([1,0,33,14,20,38,2,96,7,3,153,23,65]),function(le,e,y,L,o,A,k,T,v,m,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends k.Disposable{constructor(r,f,c,u){super(),this.j=r,this.k=f,this.l=c,this.m=u,this.c=this.B(new L.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},I=>this.k(I))),this.f=this.B(new L.RunOnceWorker(I=>this.u(I),d.b)),this.g=(0,b.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,b.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new o.CancellationTokenSource,this.ready=this.n()}async n(){try{const r=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const f=await E.Promises.stat(r);this.B(await this.s(r,f.isDirectory()))}catch(r){r.code!=="ENOENT"?this.w(r):this.z(r)}}async r(r){let f=r.path;try{f=await E.Promises.realpath(r.path),r.path===f&&(f=await(0,R.realcase)(r.path)??r.path),r.path!==f&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${f})`)}catch{}return f}async s(r,f){if(m.isMacintosh&&(0,A.isEqualOrParent)(r,"/Volumes/",!0))return this.w(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const c=new o.CancellationTokenSource(this.i.token),u=new k.DisposableStore;try{const I=(0,v.basename)(r),O=(0,y.watch)(r);u.add((0,k.toDisposable)(()=>{O.removeAllListeners(),O.close()})),this.z(`Started watching: '${r}'`);const t=new Set;if(f)try{for(const s of await E.Promises.readdir(r))t.add(s)}catch(s){this.w(s)}const n=new Map;u.add((0,k.toDisposable)(()=>{for(const[,s]of n)s.dispose();n.clear()})),O.on("error",(s,i)=>{this.w(`Failed to watch ${r} for changes using fs.watch() (${s}, ${i})`),this.dispose()}),O.on("change",(s,i)=>{if(c.token.isCancellationRequested)return;this.z(`[raw] ["${s}"] ${i}`);let a="";if(i&&(a=i.toString(),m.isMacintosh&&(a=(0,T.normalizeNFC)(a))),!(!a||s!=="change"&&s!=="rename"))if(f)if(s==="rename"){n.get(a)?.dispose();const l=setTimeout(async()=>{if(n.delete(a),a===I&&!await E.Promises.exists(r)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.v((0,v.join)(r,a));if(c.token.isCancellationRequested)return;let C;h?t.has(a)?C=0:(C=1,t.add(a)):(t.delete(a),C=2),this.t({path:(0,v.join)(this.j.path,a),type:C})},d.a);n.set(a,(0,k.toDisposable)(()=>clearTimeout(l)))}else{let l;t.has(a)?l=0:(l=1,t.add(a)),this.t({path:(0,v.join)(this.j.path,a),type:l})}else if(s==="rename"||a!==I){const l=setTimeout(async()=>{const h=await E.Promises.exists(r);c.token.isCancellationRequested||(h?(this.t({path:this.j.path,type:0},!0),u.add(await this.s(r,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},d.a);u.clear(),u.add((0,k.toDisposable)(()=>clearTimeout(l)))}else this.t({path:this.j.path,type:0},!0)})}catch(I){await E.Promises.exists(r)&&!c.token.isCancellationRequested&&this.w(`Failed to watch ${r} for changes using fs.watch() (${I.toString()})`)}return(0,k.toDisposable)(()=>{c.dispose(!0),u.dispose()})}t(r,f=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`),!f&&this.g.some(c=>c(r.path))?this.m&&this.z(` >> ignored (excluded) ${r.path}`):!f&&this.h&&this.h.length>0&&!this.h.some(c=>c(r.path))?this.m&&this.z(` >> ignored (not included) ${r.path}`):this.f.work(r))}u(r){const f=(0,b.coalesceEvents)(r);if(f.length>0){if(this.m)for(const u of f)this.z(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);this.c.work(f)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(r){if(m.isLinux)return E.Promises.exists(r);try{const f=(0,v.basename)(r);return(await E.Promises.readdir((0,v.dirname)(r))).some(u=>u===f)}catch(f){return this.z(f),!1}}setVerboseLogging(r){this.m=r}w(r){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}y(r){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}z(r){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=d,d.a=100,d.b=75;async function g(p,r,f,c,u=512){const I=await E.Promises.open(p,"r"),O=Buffer.allocUnsafe(u),t=new o.CancellationTokenSource(c);let n,s=!1;const i={path:p,excludes:[],recursive:!1},a=new d(i,l=>{(async()=>{for(const{type:h}of l)if(h===0){if(s)return;s=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:C}=await E.Promises.read(I,O,0,u,null);if(!C||t.token.isCancellationRequested)break;r(O.slice(0,C))}}catch(C){n=new Error(C),t.dispose(!0)}finally{s=!1}}})()});return await a.ready,f(),new Promise((l,h)=>{t.token.onCancellationRequested(async()=>{a.dispose();try{await E.Promises.close(I)}catch(C){n=new Error(C)}n?h(n):l()})})}e.watchFileContents=g}),define(pe[215],be([1,0,6,74,2,3,214]),function(le,e,y,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class T extends o.Disposable{constructor(){super(...arguments),this.a=this.B(new y.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new y.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=y.Event.None,this.c=new Map,this.f=!1}async watch(m){const R=this.i(m),E=R.filter(d=>{const g=this.c.get(d.path);return g?!(0,L.patternsEquals)(g.request.excludes,d.excludes)||!(0,L.patternsEquals)(g.request.includes,d.includes):!0}),b=Array.from(this.c.values()).filter(({request:d})=>!R.find(g=>g.path===d.path&&(0,L.patternsEquals)(g.excludes,d.excludes)&&(0,L.patternsEquals)(g.includes,d.includes))).map(({request:d})=>d.path);E.length&&this.j(`Request to start watching: ${E.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),b.length&&this.j(`Request to stop watching: ${b.join(",")}`);for(const d of b)this.h(d);for(const d of E)this.g(d)}g(m){const R=new k.NodeJSFileWatcherLibrary(m,b=>this.a.fire(b),b=>this.b.fire(b),this.f),E={request:m,instance:R};this.c.set(m.path,E)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const R=this.c.get(m);R&&(this.c.delete(m),R.instance.dispose())}i(m){const R=new Map;for(const E of m){const b=A.isLinux?E.path:E.path.toLowerCase();R.set(b,E)}return Array.from(R.values())}async setVerboseLogging(m){this.f=m;for(const[,R]of this.c)R.instance.setVerboseLogging(m)}j(m){this.f&&this.b.fire({type:"trace",message:this.k(m)})}k(m,R){return R?`[File Watcher (node.js)] ${m} (path: ${R.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=T}),define(pe[216],be([1,0,65,215]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class o extends y.AbstractNonRecursiveWatcherClient{constructor(k,T,v){super(k,T,v),this.m()}l(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=o}),define(pe[217],be([1,0,13,43,105,65]),function(le,e,y,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends A.AbstractUniversalWatcherClient{constructor(v,m,R){super(v,m,R),this.m()}l(v){const m=v.add(new o.Client(y.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(m.onDidProcessExit(({code:R,signal:E})=>this.n(`terminated by itself with code ${R}, signal: ${E}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(pe[81],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class y{constructor(...o){this.a=new Map;for(const[A,k]of o)this.set(A,k)}set(o,A){const k=this.a.get(o);return this.a.set(o,A),k}has(o){return this.a.has(o)}get(o){return this.a.get(o)}}e.ServiceCollection=y}),define(pe[109],be([1,0,14,9,2,63,209,5,81,95]),function(le,e,y,L,o,A,k,T,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class E extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class b{constructor(r=new v.ServiceCollection,f=!1,c,u=R){this.f=r,this.g=f,this.h=c,this.i=u,this.o=new Set,this.f.set(T.IInstantiationService,this),this._globalGraph=u?c?._globalGraph??new k.Graph(I=>I):void 0}createChild(r){return new b(r,this.g,this,this.i)}invokeFunction(r,...f){const c=g.traceInvocation(this.i,r);let u=!1;try{return r({get:O=>{if(u)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(O,c);if(!t)throw new Error(`[invokeFunction] unknown service '${O}'`);return t}},...f)}finally{u=!0,c.stop()}}createInstance(r,...f){let c,u;return r instanceof A.SyncDescriptor?(c=g.traceCreation(this.i,r.ctor),u=this.j(r.ctor,r.staticArguments.concat(f),c)):(c=g.traceCreation(this.i,r),u=this.j(r,f,c)),c.stop(),u}j(r,f=[],c){const u=T._util.getServiceDependencies(r).sort((t,n)=>t.index-n.index),I=[];for(const t of u){const n=this.m(t.id,c);n||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),I.push(n)}const O=u.length>0?u[0].index:f.length;if(f.length!==O){console.trace(`[createInstance] First service dependency of ${r.name} at position ${O+1} conflicts with ${f.length} static arguments`);const t=O-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,O)}return Reflect.construct(r,f.concat(I))}k(r,f){if(this.f.get(r)instanceof A.SyncDescriptor)this.f.set(r,f);else if(this.h)this.h.k(r,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const f=this.f.get(r);return!f&&this.h?this.h.l(r):f}m(r,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const c=this.l(r);return c instanceof A.SyncDescriptor?this.q(r,c,f.branch(r,!0)):(f.branch(r,!1),c)}q(r,f,c){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,f,c)}finally{this.o.delete(r)}}r(r,f,c){const u=new k.Graph(t=>t.id.toString());let I=0;const O=[{id:r,desc:f,_trace:c}];for(;O.length;){const t=O.pop();if(u.lookupOrInsertNode(t),I++>1e3)throw new E(u);for(const n of T._util.getServiceDependencies(t.desc.ctor)){const s=this.l(n.id);if(s||this.u(`[createInstance] ${r} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),s instanceof A.SyncDescriptor){const i={id:n.id,desc:s,_trace:t._trace.branch(n.id,!0)};u.insertEdge(t,i),O.push(i)}}}for(;;){const t=u.roots();if(t.length===0){if(!u.isEmpty())throw new E(u);break}for(const{data:n}of t){if(this.l(n.id)instanceof A.SyncDescriptor){const i=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,i)}u.removeNode(n)}}return this.l(r)}s(r,f,c=[],u,I){if(this.f.get(r)instanceof A.SyncDescriptor)return this.t(r,f,c,u,I);if(this.h)return this.h.s(r,f,c,u,I);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(r,f,c=[],u,I){if(u){const O=new b(void 0,this.g,this,this.i);O.c=String(r);const t=new Map,n=new y.IdleValue(()=>{const s=O.j(f,c,I);for(const[i,a]of t){const l=s[i];if(typeof l=="function")for(const h of a)l.apply(s,h)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let h=t.get(i);return h||(h=new m.LinkedList,t.set(i,h)),(D,w,S)=>{const N=h.push([D,w,S]);return(0,o.toDisposable)(N)}}if(i in s)return s[i];const a=n.value;let l=a[i];return typeof l!="function"||(l=l.bind(a),s[i]=l),l},set(s,i,a){return n.value[i]=a,!0},getPrototypeOf(s){return f.prototype}})}else return this.j(f,c,I)}u(r,f){if(f&&console.warn(r),this.g)throw new Error(r)}}e.InstantiationService=b;var d;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(d||(d={}));class g{static traceInvocation(r,f){return r?new g(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(r,f){return r?new g(1,f.name):g.c}constructor(r,f){this.type=r,this.name=f,this.g=Date.now(),this.h=[]}branch(r,f){const c=new g(3,r.toString());return this.h.push([r,f,c]),c}stop(){const r=Date.now()-this.g;g.f+=r;let f=!1;function c(I,O){const t=[],n=new Array(I+1).join("	");for(const[s,i,a]of O.h)if(i&&a){f=!0,t.push(`${n}CREATES -> ${s}`);const l=c(I+1,a);l&&t.push(l)}else t.push(`${n}uses -> ${s}`);return t.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(r>2||f)&&g.all.add(u.join(`
`))}}e.Trace=g,g.all=new Set,g.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}},g.f=0}),define(pe[218],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.ILabelService=void 0,e.ILabelService=(0,y.createDecorator)("labelService");var L;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(L||(e.Verbosity=L={}))});var Ae=this&&this.__param||function(le,e){return function(y,L){e(y,L,le)}};define(pe[82],be([1,0,20,2,3,184,30,5]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function v(R){return R.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=v,e.ILanguagePackService=(0,T.createDecorator)("languagePackService");let m=e.LanguagePackBaseService=class extends L.Disposable{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new y.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const g=b.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(r=>r.startsWith("lp-"))).map(p=>{const r=p.properties.localizedLanguages?.[0],f=v(p);return{...this.f(f,r,p),extensionId:p.identifier.id,galleryExtension:p}});return g.push(this.f("en","English")),g}f(E,b,d){const g=b??E;let p;if(g!==E&&(p=`(${E})`),E.toLowerCase()===o.language.toLowerCase()&&(p??="",p+=(0,A.localize)(0,null)),d?.installCount){p??="";const r=d.installCount;let f;r>1e6?f=`${Math.floor(r/1e5)/10}M`:r>1e3?f=`${Math.floor(r/1e3)}K`:f=String(r),p+=` $(cloud-download) ${f}`}return{id:E,label:g,description:p}}};e.LanguagePackBaseService=m=Le([Ae(0,k.IExtensionGalleryService)],m)}),define(pe[12],be([1,0,39,6,73,2,28,3,19,8,4,64,5]),function(le,e,y,L,o,A,k,T,v,m,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function d(){return new Date().toISOString()}function g(D){return(0,m.isNumber)(D)}e.isLogLevel=g;var p;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(p||(e.LogLevel=p={})),e.DEFAULT_LOG_LEVEL=p.Info;function r(D,w,S){switch(w){case p.Trace:D.trace(S);break;case p.Debug:D.debug(S);break;case p.Info:D.info(S);break;case p.Warning:D.warn(S);break;case p.Error:D.error(S);break;case p.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=r;function f(D,w=!1){let S="";for(let N=0;N<D.length;N++){let $=D[N];if($ instanceof Error&&($=(0,y.toErrorMessage)($,w)),typeof $=="object")try{$=JSON.stringify($)}catch{}S+=(N>0?" ":"")+$}return S}class c extends A.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new L.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==p.Off&&this.b<=w}}e.AbstractLogger=c;class u extends c{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...S){this.f(p.Trace)&&this.g(p.Trace,f([w,...S],!0))}debug(w,...S){this.f(p.Debug)&&this.g(p.Debug,f([w,...S]))}info(w,...S){this.f(p.Info)&&this.g(p.Info,f([w,...S]))}warn(w,...S){this.f(p.Warning)&&this.g(p.Warning,f([w,...S]))}error(w,...S){if(this.f(p.Error))if(w instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=w.stack,this.g(p.Error,f(N))}else this.g(p.Error,f([w,...S]))}flush(){}}e.AbstractMessageLogger=u;class I extends c{constructor(w=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(w),this.g=!T.isWindows}trace(w,...S){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...S):console.log(`[main ${d()}]`,w,...S))}debug(w,...S){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...S):console.log(`[main ${d()}]`,w,...S))}info(w,...S){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...S):console.log(`[main ${d()}]`,w,...S))}warn(w,...S){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,w,...S):console.warn(`[main ${d()}]`,w,...S))}error(w,...S){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,w,...S):console.error(`[main ${d()}]`,w,...S))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class O extends c{constructor(w=e.DEFAULT_LOG_LEVEL,S=!0){super(),this.g=S,this.setLevel(w)}trace(w,...S){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...S):console.log(w,...S))}debug(w,...S){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...S):console.log(w,...S))}info(w,...S){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...S):console.log(w,...S))}warn(w,...S){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...S):console.log(w,...S))}error(w,...S){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...S):console.error(w,...S))}dispose(){}flush(){}}e.ConsoleLogger=O;class t extends c{constructor(w,S=e.DEFAULT_LOG_LEVEL){super(),this.g=w,this.setLevel(S)}trace(w,...S){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(w),...S])}debug(w,...S){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(w),...S])}info(w,...S){this.f(p.Info)&&this.g.log(p.Info,[this.h(w),...S])}warn(w,...S){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(w),...S])}error(w,...S){this.f(p.Error)&&this.g.log(p.Error,[this.h(w),...S])}h(w){return typeof w=="string"?w:(0,y.toErrorMessage)(w,this.f(p.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class n extends c{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const S of this.g)S.setLevel(w);super.setLevel(w)}trace(w,...S){for(const N of this.g)N.trace(w,...S)}debug(w,...S){for(const N of this.g)N.debug(w,...S)}info(w,...S){for(const N of this.g)N.info(w,...S)}warn(w,...S){for(const N of this.g)N.warn(w,...S)}error(w,...S){for(const N of this.g)N.error(w,...S)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.MultiplexLogger=n;class s extends A.Disposable{constructor(w,S,N){if(super(),this.h=w,this.j=S,this.b=new k.ResourceMap,this.c=this.B(new L.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeVisibility=this.g.event,N)for(const $ of N)this.b.set($.resource,{logger:void 0,info:$})}k(w){return(0,m.isString)(w)?[...this.b.values()].find(S=>S.info.id===w):this.b.get(w)}getLogger(w){return this.k(w)?.logger}createLogger(w,S){const N=this.l(w),$=(0,m.isString)(w)?w:S?.id??(0,o.hash)(N.toString()).toString(16);let ee=this.b.get(N)?.logger;const he=S?.logLevel==="always"?p.Trace:S?.logLevel;ee||(ee=this.m(N,he??this.getLogLevel(N)??this.h,{...S,id:$}));const oe={logger:ee,info:{resource:N,id:$,logLevel:he,name:S?.name,hidden:S?.hidden,extensionId:S?.extensionId,when:S?.when}};return this.registerLogger(oe.info),this.b.set(N,oe),ee}l(w){return(0,m.isString)(w)?(0,v.joinPath)(this.j,`${w}.log`):w}setLogLevel(w,S){if(R.URI.isUri(w)){const N=w,$=S,ee=this.b.get(N);ee&&$!==ee.info.logLevel&&(ee.info.logLevel=$===this.h?void 0:$,ee.logger?.setLevel($),this.b.set(ee.info.resource,ee),this.f.fire([N,$]))}else{this.h=w;for(const[N,$]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&$.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,S){const N=this.k(w);N&&S!==!N.info.hidden&&(N.info.hidden=!S,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,S]))}getLogLevel(w){let S;return w&&(S=this.b.get(w)?.info.logLevel),S??this.h}registerLogger(w){const S=this.b.get(w.resource);S?S.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const S=this.b.get(w);S&&(S.logger&&S.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[S.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=s;class i{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(w){}getLevel(){return p.Info}trace(w,...S){}debug(w,...S){}info(w,...S){}warn(w,...S){}error(w,...S){}critical(w,...S){}dispose(){}flush(){}}e.NullLogger=i;class a extends i{}e.NullLogService=a;function l(D){if(D.verbose)return p.Trace;if(typeof D.logLevel=="string"){const w=C(D.logLevel.toLowerCase());if(w!==void 0)return w}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function h(D){switch(D){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.LogLevelToString=h;function C(D){switch(D){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.parseLogLevel=C,e.CONTEXT_LOG_LEVEL=new E.RawContextKey("logLevel",h(p.Info))}),define(pe[219],be([1,0,78,6,2,12,3,14]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let v=e.BaseCredentialsMainService=class Kt extends o.Disposable{constructor(R){super(),this.h=R,this.c=this.B(new L.Emitter),this.onDidChangePassword=this.c.event,this.g=new T.SequencerByKey}async getPassword(R,E){this.h.trace("Going to get password from keytar:",R,E);let b;try{b=await this.i()}catch{return null}return await this.g.queue(R+E,()=>this.k(b,R,E))}async k(R,E,b){this.h.trace("Doing get password from keytar:",E,b);const d=await(0,T.retry)(()=>R.getPassword(E,b),50,3);if(!d)return this.h.trace("Did not get a password from keytar for account:",b),d;let g,p;try{const r=JSON.parse(d);g=r.content,p=r.hasNextChunk}catch{}if(!g||!p)return this.h.trace("Got password from keytar for account:",b),d;try{let r=1;for(;p;){const f=await(0,T.retry)(()=>R.getPassword(E,`${b}-${r}`),50,3),c=JSON.parse(f);g+=c.content,p=c.hasNextChunk,r++}return this.h.trace(`Got ${r}-chunked password from keytar for account:`,b),g}catch(r){return this.h.error(r),d}}async setPassword(R,E,b){this.h.trace("Going to set password using keytar:",R,E);let d;try{d=await this.i()}catch(g){throw this.j?.(g),g}await this.g.queue(R+E,()=>this.l(d,R,E,b)),this.c.fire({service:R,account:E})}async l(R,E,b,d){if(this.h.trace("Doing set password from keytar:",E,b),!k.isWindows){await(0,T.retry)(()=>R.setPassword(E,b,d),50,3),this.h.trace("Set password from keytar for account:",b);return}if(await this.m(R,E,b),d.length<=Kt.b){await(0,T.retry)(()=>R.setPassword(E,b,d),50,3),this.h.trace("Set password from keytar for account:",b);return}let g=0,p=0,r=!0;for(;r;){const f=d.substring(g,g+Kt.b);g+=Kt.b,r=d.length-g>0;const c={content:f,hasNextChunk:r};await(0,T.retry)(()=>R.setPassword(E,p?`${b}-${p}`:b,JSON.stringify(c)),50,3),p++}this.h.trace(`Set${p?` ${p}-chunked`:""} password from keytar for account:`,b)}async deletePassword(R,E){this.h.trace("Going to delete password using keytar:",R,E);let b;try{b=await this.i()}catch(g){throw this.j?.(g),g}const d=await this.g.queue(R+E,()=>this.m(b,R,E));return d&&this.c.fire({service:R,account:E}),d}async m(R,E,b){this.h.trace("Doing delete password from keytar:",E,b);const d=await R.getPassword(E,b);if(!d)return this.h.trace("Did not get a password to delete from keytar for account:",b),!1;let g,p;try{const f=JSON.parse(d);g=f.content,p=f.hasNextChunk}catch{}let r=0;if(g&&p)try{for(r++;p;){const f=`${b}-${r}`,c=await R.getPassword(E,f);await R.deletePassword(E,f),p=JSON.parse(c).hasNextChunk,r++}}catch(f){this.h.error(f)}return await R.deletePassword(E,b)?(this.h.trace(`Deleted${r?` ${r}-chunked`:""} password from keytar for account:`,b),!0):(this.h.trace(`Keytar failed to delete${r?` ${r}-chunked`:""} password for account:`,b),!1)}async findPassword(R){let E;try{E=await this.i()}catch{return null}return await E.findPassword(R)}async findCredentials(R){let E;try{E=await this.i()}catch{return[]}return await E.findCredentials(R)}clear(){return this.f instanceof y.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};v.a=2500,v.b=v.a-100,e.BaseCredentialsMainService=v=Le([Ae(0,A.ILogService)],v)}),define(pe[220],be([1,0,12]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let L=e.EncryptionMainService=class{constructor(A,k){this.a=A,this.b=k}c(){return new Promise((A,k)=>le(["vscode-encrypt"],A,k))}async encrypt(A){let k;try{k=await this.c()}catch{return A}try{return k.encrypt(this.a,A)}catch(T){return this.b.error(T),A}}async decrypt(A){let k;try{k=await this.c()}catch{return A}try{return k.decrypt(this.a,A)}catch(T){return this.b.error(T),A}}};e.EncryptionMainService=L=Le([Ae(1,y.ILogService)],L)}),define(pe[221],be([1,0,18,14,9,6,2,7,65,12]),function(le,e,y,L,o,A,k,T,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class R extends k.Disposable{constructor(b,d){super(),this.a=b,this.b=d,this.c=this.B(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new L.ThrottledDelayer(0)),this.s=[],this.t=this.B(new L.ThrottledDelayer(0))}watch(b,d){return d.recursive||this.b?.watcher?.forceUniversal?this.l(b,d):this.u(b,d)}l(b,d){const g={path:this.C(b),excludes:d.excludes,includes:d.includes,recursive:d.recursive},p=(0,y.insert)(this.j,g);return this.m(),(0,k.toDisposable)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(b=>(0,o.onUnexpectedError)(b))}n(){this.h||(this.h=this.B(this.p(d=>this.c.fire((0,v.toFileChanges)(d)),d=>this.z(d),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const d of this.j)(0,v.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const d of this.j)(0,v.isRecursiveWatchRequest)(d)&&b.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(b,d){const g={path:this.C(b),excludes:d.excludes,includes:d.includes,recursive:!1},p=(0,y.insert)(this.s,g);return this.v(),(0,k.toDisposable)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(b=>(0,o.onUnexpectedError)(b))}w(){return this.r||(this.r=this.B(this.y(b=>this.c.fire((0,v.toFileChanges)(b)),b=>this.z(b),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.r.watch(this.s)}z(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}C(b){return(0,T.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=R}),define(pe[110],be([1,0,18,14,15,20,6,73,46,2,61,13,42,19,47,180,16,108,12,9]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=e.FileService=class extends m.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new k.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new k.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new k.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new k.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new L.ResourceQueue)}registerProvider(t,n){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${t}`);const s=new m.DisposableStore;return this.h.set(t,n),this.c.fire({added:!0,scheme:t,provider:n}),s.add(n.onDidChangeFile(i=>this.R.fire(new r.FileChangesEvent(i,!this.O(n))))),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(i=>this.S.fire(new Error(i)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:t}))),(0,m.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:n}),this.h.delete(t),(0,m.dispose)(s)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const n=[];this.f.fire({scheme:t,join(s){n.push(s)}}),!this.h.has(t)&&await L.Promises.settled(n)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,n){const s=this.h.get(t.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return v.Iterable.map(this.h,([t,n])=>({scheme:t,capabilities:n.capabilities}))}async j(t){if(!(0,d.isAbsolutePath)(t))throw new r.FileOperationError((0,p.localize)(0,null,this.ob(t)),8);await this.activateProvider(t.scheme);const n=this.h.get(t.scheme);if(!n){const s=new u.ErrorNoTelemetry;throw s.message=(0,p.localize)(1,null,t.toString()),s}return n}async k(t){const n=await this.j(t);if((0,r.hasOpenReadWriteCloseCapability)(n)||(0,r.hasReadWriteCapability)(n)||(0,r.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const n=await this.j(t);if((0,r.hasOpenReadWriteCloseCapability)(n)||(0,r.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,n){try{return await this.n(t,n)}catch(s){throw(0,r.toFileSystemProviderErrorCode)(s)===r.FileSystemProviderErrorCode.FileNotFound?new r.FileOperationError((0,p.localize)(2,null,this.ob(t)),1):(0,r.ensureFileSystemProviderError)(s)}}async n(t,n){const s=await this.j(t),i=this.O(s),a=n?.resolveTo,l=n?.resolveSingleChildDescendants,h=n?.resolveMetadata,C=await s.stat(t);let D;return this.p(s,t,C,void 0,!!h,(w,S)=>(D||(D=R.TernarySearchTree.forUris(()=>!i),D.set(t,!0),a&&D.fill(!0,a)),D.get(w.resource)||D.findSuperstr(w.resource.with({query:null,fragment:null}))?!0:w.isDirectory&&l?S===1:!1))}async p(t,n,s,i,a,l){const{providerExtUri:h}=this.N(t),C={resource:n,name:h.basename(n),isFile:(s.type&r.FileType.File)!==0,isDirectory:(s.type&r.FileType.Directory)!==0,isSymbolicLink:(s.type&r.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&r.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((s.permissions??0)&r.FilePermission.Locked),etag:(0,r.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(C.isDirectory&&l(C,i)){try{const D=await t.readdir(n),w=await L.Promises.settled(D.map(async([S,N])=>{try{const $=h.joinPath(n,S),ee=a?await t.stat($):{type:N};return await this.p(t,$,ee,D.length,a,l)}catch($){return this.b.trace($),null}}));C.children=(0,y.coalesce)(w)}catch(D){this.b.trace(D),C.children=[]}return C}return C}async resolveAll(t){return L.Promises.settled(t.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const n=await this.j(t),s=await n.stat(t);return this.p(n,t,s,void 0,!0,()=>!1)}async exists(t){const n=await this.j(t);try{return!!await n.stat(t)}catch{return!1}}async canCreateFile(t,n){try{await this.r(t,n)}catch(s){return s}return!0}async r(t,n){if(!n?.overwrite&&await this.exists(t))throw new r.FileOperationError((0,p.localize)(3,null,this.ob(t)),3,n)}async createFile(t,n=o.VSBuffer.fromString(""),s){await this.r(t,s);const i=await this.writeFile(t,n);return this.m.fire(new r.FileOperationEvent(t,0,i)),i}async writeFile(t,n,s){const i=this.mb(await this.l(t),t),{providerExtUri:a}=this.N(i);try{await this.s(i,t,s)||await this.P(i,a.dirname(t));let h;if((0,r.hasReadWriteCapability)(i)&&!(n instanceof o.VSBuffer))if((0,g.isReadableStream)(n)){const C=await(0,g.peekStream)(n,3);C.ended?h=o.VSBuffer.concat(C.buffer):h=C}else h=(0,g.peekReadable)(n,C=>o.VSBuffer.concat(C),3);else h=n;if(!(0,r.hasOpenReadWriteCloseCapability)(i)||(0,r.hasReadWriteCapability)(i)&&h instanceof o.VSBuffer)await this.db(i,t,s,h);else{const C=h instanceof o.VSBuffer?(0,o.bufferToReadable)(h):h;s?.atomic!==!1&&s?.atomic?.postfix?await this.Y(i,t,(0,d.joinPath)((0,d.dirname)(t),`${(0,d.basename)(t)}${s.atomic.postfix}`),s,C):await this.Z(i,t,s,C)}this.m.fire(new r.FileOperationEvent(t,4))}catch(l){throw new r.FileOperationError((0,p.localize)(4,null,this.ob(t),(0,r.ensureFileSystemProviderError)(l).toString()),(0,r.toFileOperationResult)(l),s)}return this.resolve(t,{resolveMetadata:!0})}async s(t,n,s){const i=!!s?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,p.localize)(5,null,this.ob(n)));if(!!s?.atomic){if(!(t.capabilities&32768))throw new Error((0,p.localize)(6,null,this.ob(n)));if(i)throw new Error((0,p.localize)(7,null,this.ob(n)))}let l;try{l=await t.stat(n)}catch{return}if(l.type&r.FileType.Directory)throw new r.FileOperationError((0,p.localize)(8,null,this.ob(n)),0,s);if(this.nb(n,l),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==r.ETAG_DISABLED&&typeof l.mtime=="number"&&typeof l.size=="number"&&s.mtime<l.mtime&&s.etag!==(0,r.etag)({mtime:s.mtime,size:l.size}))throw new r.FileOperationError((0,p.localize)(9,null),3,s);return l}async readFile(t,n,s){const i=await this.k(t);return n?.atomic?this.t(i,t,n,s):this.u(i,t,n,s)}async t(t,n,s,i){return new Promise((a,l)=>{this.X.queueFor(n,this.N(t).providerExtUri).queue(async()=>{try{const h=await this.u(t,n,s,i);a(h)}catch(h){l(h)}})})}async u(t,n,s,i){const a=await this.v(t,n,{...s,preferUnbuffered:!0},i);return{...a,value:await(0,o.streamToBuffer)(a.value)}}async readFileStream(t,n,s){const i=await this.k(t);return this.v(i,t,n,s)}async v(t,n,s,i){const a=new A.CancellationTokenSource(i),l=this.F(n,s).then(C=>C,C=>{throw a.cancel(),C});let h;try{return typeof s?.etag=="string"&&s.etag!==r.ETAG_DISABLED&&await l,s?.atomic&&(0,r.hasFileAtomicReadCapability)(t)||!((0,r.hasOpenReadWriteCloseCapability)(t)||(0,r.hasFileReadStreamCapability)(t))||(0,r.hasReadWriteCapability)(t)&&s?.preferUnbuffered?h=this.D(t,n,s):(0,r.hasFileReadStreamCapability)(t)?h=this.z(t,n,a.token,s):h=this.C(t,n,a.token,s),{...await l,value:h}}catch(C){throw h&&await(0,g.consumeStream)(h),this.w(C,n,s)}}w(t,n,s){const i=(0,p.localize)(10,null,this.ob(n),(0,r.ensureFileSystemProviderError)(t).toString());return t instanceof r.NotModifiedSinceFileOperationError?new r.NotModifiedSinceFileOperationError(i,t.stat,s):t instanceof r.TooLargeFileOperationError?new r.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new r.FileOperationError(i,(0,r.toFileOperationResult)(t),s)}z(t,n,s,i=Object.create(null)){const a=t.readFileStream(n,i,s);return(0,g.transform)(a,{data:l=>l instanceof o.VSBuffer?l:o.VSBuffer.wrap(l),error:l=>this.w(l,n,i)},l=>o.VSBuffer.concat(l))}C(t,n,s,i=Object.create(null)){const a=(0,o.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,n,a,l=>l,{...i,bufferSize:this.a,errorTransformer:l=>this.w(l,n,i)},s),a}D(t,n,s){const i=(0,g.newWriteableStream)(a=>o.VSBuffer.concat(a));return(async()=>{try{let a;s?.atomic&&(0,r.hasFileAtomicReadCapability)(t)?a=await t.readFile(n,{atomic:!0}):a=await t.readFile(n),typeof s?.position=="number"&&(a=a.slice(s.position)),typeof s?.length=="number"&&(a=a.slice(0,s.length)),this.G(n,a.byteLength,s),i.end(o.VSBuffer.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async F(t,n){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new r.FileOperationError((0,p.localize)(11,null,this.ob(t)),0,n);if(typeof n?.etag=="string"&&n.etag!==r.ETAG_DISABLED&&n.etag===s.etag)throw new r.NotModifiedSinceFileOperationError((0,p.localize)(12,null),s,n);return this.G(t,s.size,n),s}G(t,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new r.TooLargeFileOperationError((0,p.localize)(13,null,this.ob(t)),7,n,s)}async canMove(t,n,s){return this.H(t,n,"move",s)}async canCopy(t,n,s){return this.H(t,n,"copy",s)}async H(t,n,s,i){if(t.toString()!==n.toString())try{const a=s==="move"?this.mb(await this.l(t),t):await this.k(t),l=this.mb(await this.l(n),n);await this.M(a,t,l,n,s,i)}catch(a){return a}return!0}async move(t,n,s){const i=this.mb(await this.l(t),t),a=this.mb(await this.l(n),n),l=await this.I(i,t,a,n,"move",!!s),h=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,l==="move"?2:3,h)),h}async copy(t,n,s){const i=await this.k(t),a=this.mb(await this.l(n),n),l=await this.I(i,t,a,n,"copy",!!s),h=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,l==="copy"?3:2,h)),h}async I(t,n,s,i,a,l){if(n.toString()===i.toString())return a;const{exists:h,isSameResourceWithDifferentPathCase:C}=await this.M(t,n,s,i,a,l);if(h&&!C&&l&&await this.del(i,{recursive:!0}),await this.P(s,this.N(s).providerExtUri.dirname(i)),a==="copy"){if(t===s&&(0,r.hasFileFolderCopyCapability)(t))await t.copy(n,i,{overwrite:l});else{const D=await this.resolve(n);D.isDirectory?await this.L(t,D,s,i):await this.J(t,n,s,i)}return a}else return t===s?(await t.rename(n,i,{overwrite:l}),a):(await this.I(t,n,s,i,"copy",l),await this.del(n,{recursive:!0}),"copy")}async J(t,n,s,i){if((0,r.hasOpenReadWriteCloseCapability)(t)&&(0,r.hasOpenReadWriteCloseCapability)(s))return this.fb(t,n,s,i);if((0,r.hasOpenReadWriteCloseCapability)(t)&&(0,r.hasReadWriteCapability)(s))return this.lb(t,n,s,i);if((0,r.hasReadWriteCapability)(t)&&(0,r.hasOpenReadWriteCloseCapability)(s))return this.jb(t,n,s,i);if((0,r.hasReadWriteCapability)(t)&&(0,r.hasReadWriteCapability)(s))return this.hb(t,n,s,i)}async L(t,n,s,i){await s.mkdir(i),Array.isArray(n.children)&&await L.Promises.settled(n.children.map(async a=>{const l=this.N(s).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.L(t,await this.resolve(a.resource),s,l):this.J(t,a.resource,s,l)}))}async M(t,n,s,i,a,l){let h=!1;if(t===s){const{providerExtUri:D,isPathCaseSensitive:w}=this.N(t);if(w||(h=D.isEqual(n,i)),h&&a==="copy")throw new Error((0,p.localize)(14,null,this.ob(n),this.ob(i)));if(!h&&D.isEqualOrParent(i,n))throw new Error((0,p.localize)(15,null,this.ob(n),this.ob(i)))}const C=await this.exists(i);if(C&&!h){if(!l)throw new r.FileOperationError((0,p.localize)(16,null,this.ob(n),this.ob(i)),4);if(t===s){const{providerExtUri:D}=this.N(t);if(D.isEqualOrParent(n,i))throw new Error((0,p.localize)(17,null,this.ob(n),this.ob(i)))}}return{exists:C,isSameResourceWithDifferentPathCase:h}}N(t){const n=this.O(t);return{providerExtUri:n?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:n}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const n=this.mb(await this.j(t),t);await this.P(n,t);const s=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,0,s)),s}async P(t,n){const s=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(n,i.dirname(n));)try{if(!((await t.stat(n)).type&r.FileType.Directory))throw new Error((0,p.localize)(18,null,this.ob(n)));break}catch(a){if((0,r.toFileSystemProviderErrorCode)(a)!==r.FileSystemProviderErrorCode.FileNotFound)throw a;s.push(i.basename(n)),n=i.dirname(n)}for(let a=s.length-1;a>=0;a--){n=i.joinPath(n,s[a]);try{await t.mkdir(n)}catch(l){if((0,r.toFileSystemProviderErrorCode)(l)!==r.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(t,n){try{await this.Q(t,n)}catch(s){return s}return!0}async Q(t,n){const s=this.mb(await this.j(t),t),i=!!n?.useTrash;if(i&&!(s.capabilities&4096))throw new Error((0,p.localize)(19,null,this.ob(t)));const a=n?.atomic;if(a&&!(s.capabilities&65536))throw new Error((0,p.localize)(20,null,this.ob(t)));if(i&&a)throw new Error((0,p.localize)(21,null,this.ob(t)));let l;try{l=await s.stat(t)}catch{}if(l)this.nb(t,l);else throw new r.FileOperationError((0,p.localize)(22,null,this.ob(t)),1);if(!!!n?.recursive){const C=await this.resolve(t);if(C.isDirectory&&Array.isArray(C.children)&&C.children.length>0)throw new Error((0,p.localize)(23,null,this.ob(t)))}return s}async del(t,n){const s=await this.Q(t,n),i=!!n?.useTrash,a=!!n?.recursive,l=n?.atomic??!1;await s.delete(t,{recursive:a,useTrash:i,atomic:l}),this.m.fire(new r.FileOperationEvent(t,1))}async cloneFile(t,n){const s=await this.j(t),i=this.mb(await this.l(n),n);if(s===i&&this.N(s).providerExtUri.isEqual(t,n))return;if(s===i&&(0,r.hasFileCloneCapability)(s))return s.cloneFile(t,n);await this.P(i,this.N(i).providerExtUri.dirname(n));const a=this.X.queueFor(t,this.N(s).providerExtUri);return s===i&&(0,r.hasFileFolderCopyCapability)(s)?a.queue(()=>s.copy(t,n,{overwrite:!0})):a.queue(()=>this.J(s,t,i,n))}watch(t,n={recursive:!1,excludes:[]}){const s=new m.DisposableStore;let i=!1,a=()=>{i=!0};return s.add((0,m.toDisposable)(()=>a())),(async()=>{try{const l=await this.W(t,n);i?(0,m.dispose)(l):a=()=>(0,m.dispose)(l)}catch(l){this.b.error(l)}})(),s}async W(t,n){const s=await this.j(t),i=(0,T.hash)([this.N(s).providerExtUri.getComparisonKey(t),n]);let a=this.U.get(i);return a||(a={count:0,disposable:s.watch(t,n)},this.U.set(i,a)),a.count+=1,(0,m.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,m.dispose)(a.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,m.dispose)(t.disposable);this.U.clear()}async Y(t,n,s,i,a){await this.Z(t,s,i,a);try{await t.rename(s,n,{overwrite:!0})}catch(l){try{await t.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}async Z(t,n,s,i){return this.X.queueFor(n,this.N(t).providerExtUri).queue(async()=>{const a=await t.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,g.isReadableStream)(i)||(0,g.isReadableBufferedStream)(i)?await this.ab(t,a,i):await this.bb(t,a,i)}catch(l){throw(0,r.ensureFileSystemProviderError)(l)}finally{await t.close(a)}})}async ab(t,n,s){let i=0,a;if((0,g.isReadableBufferedStream)(s)){if(s.buffer.length>0){const l=o.VSBuffer.concat(s.buffer);await this.cb(t,n,l,l.byteLength,i,0),i+=l.byteLength}if(s.ended)return;a=s.stream}else a=s;return new Promise((l,h)=>{(0,g.listenStream)(a,{onData:async C=>{a.pause();try{await this.cb(t,n,C,C.byteLength,i,0)}catch(D){return h(D)}i+=C.byteLength,setTimeout(()=>a.resume())},onError:C=>h(C),onEnd:()=>l()})})}async bb(t,n,s){let i=0,a;for(;(a=s.read())!==null;)await this.cb(t,n,a,a.byteLength,i,0),i+=a.byteLength}async cb(t,n,s,i,a,l){let h=0;for(;h<i;){const C=await t.write(n,a+h,s.buffer,l+h,i-h);h+=C}}async db(t,n,s,i){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.eb(t,n,s,i))}async eb(t,n,s,i){let a;i instanceof o.VSBuffer?a=i:(0,g.isReadableStream)(i)?a=await(0,o.streamToBuffer)(i):(0,g.isReadableBufferedStream)(i)?a=await(0,o.bufferedStreamToBuffer)(i):a=(0,o.readableToBuffer)(i),await t.writeFile(n,a.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async fb(t,n,s,i){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.gb(t,n,s,i))}async gb(t,n,s,i){let a,l;try{a=await t.open(n,{create:!1}),l=await s.open(i,{create:!0,unlock:!1});const h=o.VSBuffer.alloc(this.a);let C=0,D=0,w=0;do w=await t.read(a,C,h.buffer,D,h.byteLength-D),await this.cb(s,l,h,w,C,D),C+=w,D+=w,D===h.byteLength&&(D=0);while(w>0)}catch(h){throw(0,r.ensureFileSystemProviderError)(h)}finally{await L.Promises.settled([typeof a=="number"?t.close(a):Promise.resolve(),typeof l=="number"?s.close(l):Promise.resolve()])}}async hb(t,n,s,i){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.ib(t,n,s,i))}async ib(t,n,s,i){return s.writeFile(i,await t.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async jb(t,n,s,i){return this.X.queueFor(i,this.N(s).providerExtUri).queue(()=>this.kb(t,n,s,i))}async kb(t,n,s,i){const a=await s.open(i,{create:!0,unlock:!1});try{const l=await t.readFile(n);await this.cb(s,a,o.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,r.ensureFileSystemProviderError)(l)}finally{await s.close(a)}}async lb(t,n,s,i){const a=await(0,o.streamToBuffer)(this.C(t,n,A.CancellationToken.None));await this.db(s,i,void 0,a)}mb(t,n){if(t.capabilities&2048)throw new r.FileOperationError((0,p.localize)(24,null,this.ob(n)),6);return t}nb(t,n){if((n.permissions??0)&r.FilePermission.Readonly)throw new r.FileOperationError((0,p.localize)(25,null,this.ob(t)),6)}ob(t){return t.scheme===E.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=I=Le([Ae(0,c.ILogService)],I)}),define(pe[66],be([1,0,33,298,14,28,15,6,38,2,7,3,19,47,23,183,16,108,221,39,217,216]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c,u,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(y)}catch(n){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(n)}`)}})();class t extends c.AbstractDiskFileSystemProvider{constructor(s,i){super(s,i),this.onDidChangeCapabilities=T.Event.None,this.I=new A.ResourceMap(a=>b.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,E.isLinux&&(this.F|=1024)),this.F}async stat(s){try{const{stat:i,symbolicLink:a}=await g.SymlinkSupport.stat(this.C(s));return{type:this.H(i,a),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:r.FilePermission.Locked}}catch(i){throw this.bb(i)}}async G(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await g.Promises.readdir(this.C(s),{withFileTypes:!0}),a=[];return await Promise.all(i.map(async l=>{try{let h;l.isSymbolicLink()?h=(await this.stat((0,b.joinPath)(s,l.name))).type:h=this.H(l),a.push([l.name,h])}catch(h){this.a.trace(h)}})),a}catch(i){throw this.bb(i)}}H(s,i){let a;return i?.dangling?a=r.FileType.Unknown:s.isFile()?a=r.FileType.File:s.isDirectory()?a=r.FileType.Directory:a=r.FileType.Unknown,i&&(a|=r.FileType.SymbolicLink),a}async J(s){const i=this.C(s);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let a;for(;a=this.I.get(s);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await a.wait();const l=new o.Barrier;return this.I.set(s,l),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,m.toDisposable)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.I.get(s)===l&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.I.delete(s)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(s,i){let a;try{i?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(s)})`),a=await this.J(s));const l=this.C(s);return await g.Promises.readFile(l)}catch(l){throw this.bb(l)}finally{a?.dispose()}}L(s){t.D&&this.a.trace(s)}readFileStream(s,i,a){const l=(0,d.newWriteableStream)(h=>k.VSBuffer.concat(h.map(C=>k.VSBuffer.wrap(C))).buffer);return(0,f.readFileIntoStream)(this,s,l,h=>h.buffer,{...i,bufferSize:256*1024},a),l}async writeFile(s,i,a){return a?.atomic!==!1&&a?.atomic?.postfix?this.M(s,(0,b.joinPath)((0,b.dirname)(s),`${(0,b.basename)(s)}${a.atomic.postfix}`),i,a):this.N(s,i,a)}async M(s,i,a,l){await this.N(i,a,l);try{await this.rename(i,s,{overwrite:!0})}catch(h){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw h}}async N(s,i,a){let l;try{const h=this.C(s);if(!a.create||!a.overwrite){if(await g.Promises.exists(h)){if(!a.overwrite)throw(0,r.createFileSystemProviderError)((0,p.localize)(0,null),r.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,r.createFileSystemProviderError)((0,p.localize)(1,null),r.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(s,{create:!0,unlock:a.unlock}),await this.write(l,0,i,0,i.byteLength)}catch(h){throw await this.cb(s,h)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(s){t.R=s}async open(s,i){const a=this.C(s);let l;(0,r.isFileOpenForWriteOptions)(i)&&(l=await this.J(s));let h;try{if((0,r.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:D}=await g.SymlinkSupport.stat(a);D.mode&128||await g.Promises.chmod(a,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let C;if((0,r.isFileOpenForWriteOptions)(i)){if(E.isWindows)try{await g.Promises.truncate(a,0),C="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}C||(C="w")}else C="r";h=await g.Promises.open(a,C)}catch(C){throw l?.dispose(),(0,r.isFileOpenForWriteOptions)(i)?await this.cb(s,C):this.bb(C)}if(this.O.set(h,0),(0,r.isFileOpenForWriteOptions)(i)&&this.Q.set(h,s),l){const C=this.P.get(h);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${h} (${a})`),this.P.set(h,l),C&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${h} (${a})`),C.dispose())}return h}async close(s){const i=this.P.get(s);try{if(this.O.delete(s),this.Q.delete(s)&&t.R)try{await g.Promises.fdatasync(s)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await g.Promises.close(s)}catch(a){throw this.bb(a)}finally{i&&(this.P.get(s)===i&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.P.delete(s)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,a,l,h){const C=this.S(s,i);let D=null;try{D=(await g.Promises.read(s,a,l,h,C)).bytesRead}catch(w){throw this.bb(w)}finally{this.U(s,C,D)}return D}S(s,i){return i===this.O.get(s)?null:i}U(s,i,a){const l=this.O.get(s);typeof l=="number"&&(typeof i=="number"||(typeof a=="number"?this.O.set(s,l+a):this.O.delete(s)))}async write(s,i,a,l,h){return(0,o.retry)(()=>this.W(s,i,a,l,h),100,3)}async W(s,i,a,l,h){const C=this.S(s,i);let D=null;try{D=(await g.Promises.write(s,a,l,h,C)).bytesWritten}catch(w){throw await this.cb(this.Q.get(s),w)}finally{this.U(s,C,D)}return D}async mkdir(s){try{await g.Promises.mkdir(this.C(s))}catch(i){throw this.bb(i)}}async delete(s,i){try{const a=this.C(s);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,R.join)((0,R.dirname)(a),`${(0,R.basename)(a)}${i.atomic.postfix}`)),await g.Promises.rm(a,g.RimRafMode.MOVE,l)}else try{await g.Promises.unlink(a)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let h=!1;try{const{stat:C,symbolicLink:D}=await g.SymlinkSupport.stat(a);h=C.isDirectory()&&!D}catch{}if(h)await g.Promises.rmdir(a);else throw l}else throw l}}catch(a){throw this.bb(a)}}async rename(s,i,a){const l=this.C(s),h=this.C(i);if(l!==h)try{await this.X(s,i,"move",a.overwrite),await g.Promises.move(l,h)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,p.localize)(2,null,(0,R.basename)(l),(0,R.basename)((0,R.dirname)(h)),C.toString()))),this.bb(C)}}async copy(s,i,a){const l=this.C(s),h=this.C(i);if(l!==h)try{await this.X(s,i,"copy",a.overwrite),await g.Promises.copy(l,h,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,p.localize)(3,null,(0,R.basename)(l),(0,R.basename)((0,R.dirname)(h)),C.toString()))),this.bb(C)}}async X(s,i,a,l){const h=this.C(s),C=this.C(i);let D=!1;if(!!(this.capabilities&1024)||(D=(0,v.isEqual)(h,C,!0)),D){if(a==="copy")throw(0,r.createFileSystemProviderError)((0,p.localize)(4,null),r.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const S=await this.G(s);if(!S)throw(0,r.createFileSystemProviderError)((0,p.localize)(5,null),r.FileSystemProviderErrorCode.FileNotFound);const N=await this.G(i);if(N){if(!l)throw(0,r.createFileSystemProviderError)((0,p.localize)(6,null),r.FileSystemProviderErrorCode.FileExists);S.type&r.FileType.File&&N.type&r.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.Y(s,i,!1)}async Y(s,i,a){const l=this.C(s),h=this.C(i),C=!!(this.capabilities&1024);if((0,v.isEqual)(l,h,!C))return;const D=new m.DisposableStore;try{const[w,S]=await Promise.all([this.J(s),this.J(i)]);D.add(w),D.add(S),a&&await g.Promises.mkdir((0,R.dirname)(h),{recursive:!0}),await g.Promises.copyFile(l,h)}catch(w){if(w.code==="ENOENT"&&!a)return this.Y(s,i,!0);throw this.bb(w)}finally{D.dispose()}}p(s,i,a){return new I.UniversalWatcherClient(l=>s(l),l=>i(l),a)}y(s,i,a){return new O.NodeJSWatcherClient(l=>s(l),l=>i(l),a)}bb(s){if(s instanceof r.FileSystemProviderError)return s;let i=s,a;switch(s.code){case"ENOENT":a=r.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=r.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=r.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=r.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=r.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=r.FileSystemProviderErrorCode.Unknown;break;default:a=r.FileSystemProviderErrorCode.Unknown}return(0,r.createFileSystemProviderError)(i,a)}async cb(s,i){let a=this.bb(i);if(s&&a.code===r.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await g.SymlinkSupport.stat(this.C(s));l.mode&128||(a=(0,r.createFileSystemProviderError)(i,r.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return a}}e.DiskFileSystemProvider=t,t.D=!1,t.R=!0}),define(pe[222],be([1,0,6,66,2,15,47,20]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class v extends o.Disposable{constructor(E,b){super(),this.a=E,this.b=b,this.w=new Map,this.y=new Map}call(E,b,d){const g=this.c(E);switch(b){case"stat":return this.g(g,d[0]);case"readdir":return this.h(g,d[0]);case"open":return this.l(g,d[0],d[1]);case"close":return this.m(d[0]);case"read":return this.n(d[0],d[1],d[2]);case"readFile":return this.i(g,d[0],d[1]);case"write":return this.p(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.k(g,d[0],d[1],d[2]);case"rename":return this.t(g,d[0],d[1],d[2]);case"copy":return this.u(g,d[0],d[1],d[2]);case"cloneFile":return this.v(g,d[0],d[1]);case"mkdir":return this.r(g,d[0]);case"delete":return this.s(g,d[0],d[1]);case"watch":return this.C(g,d[0],d[1],d[2],d[3]);case"unwatch":return this.D(d[0],d[1])}throw new Error(`IPC Command ${b} not found`)}listen(E,b,d){const g=this.c(E);switch(b){case"fileChange":return this.z(g,d[0]);case"readFileStream":return this.j(g,d[0],d[1])}throw new Error(`Unknown event ${b}`)}g(E,b){const d=this.f(E,b,!0);return this.a.stat(d)}h(E,b){const d=this.f(E,b);return this.a.readdir(d)}async i(E,b,d){const g=this.f(E,b,!0),p=await this.a.readFile(g,d);return A.VSBuffer.wrap(p)}j(E,b,d){const g=this.f(E,b,!0),p=new T.CancellationTokenSource,r=new y.Emitter({onDidRemoveLastListener:()=>{p.cancel()}}),f=this.a.readFileStream(g,d,p.token);return(0,k.listenStream)(f,{onData:c=>r.fire(A.VSBuffer.wrap(c)),onError:c=>r.fire(c),onEnd:()=>{r.fire("end"),r.dispose(),p.dispose()}}),r.event}k(E,b,d,g){const p=this.f(E,b);return this.a.writeFile(p,d.buffer,g)}l(E,b,d){const g=this.f(E,b,!0);return this.a.open(g,d)}m(E){return this.a.close(E)}async n(E,b,d){const g=A.VSBuffer.alloc(d),p=0,r=await this.a.read(E,b,g.buffer,p,d);return[g,r]}p(E,b,d,g,p){return this.a.write(E,b,d.buffer,g,p)}r(E,b){const d=this.f(E,b);return this.a.mkdir(d)}s(E,b,d){const g=this.f(E,b);return this.a.delete(g,d)}t(E,b,d,g){const p=this.f(E,b),r=this.f(E,d);return this.a.rename(p,r,g)}u(E,b,d,g){const p=this.f(E,b),r=this.f(E,d);return this.a.copy(p,r,g)}v(E,b,d){const g=this.f(E,b),p=this.f(E,d);return this.a.cloneFile(g,p)}z(E,b){const d=new y.Emitter({onWillAddFirstListener:()=>{this.w.set(b,this.F(E,d))},onDidRemoveLastListener:()=>{(0,o.dispose)(this.w.get(b)),this.w.delete(b)}});return d.event}async C(E,b,d,g,p){const r=this.w.get(b);if(r){const f=this.f(E,g),c=r.watch(d,f,p);this.y.set(b+d,c)}}async D(E,b){const d=E+b,g=this.y.get(d);g&&((0,o.dispose)(g),this.y.delete(d))}dispose(){super.dispose();for(const[,E]of this.y)E.dispose();this.y.clear();for(const[,E]of this.w)E.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=v;class m extends o.Disposable{constructor(E,b,d,g){super(),this.c=E,this.f=d,this.g=g,this.a=new Map,this.b=this.B(new L.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(b)}h(E){const b=this.B(new y.Emitter);this.B(b.event(d=>{E.fire(d.map(g=>({resource:this.c.transformOutgoingURI(g.resource),type:g.type})))})),this.B(this.b.onDidChangeFile(d=>b.fire(d))),this.B(this.b.onDidWatchError(d=>E.fire(d)))}i(E){}j(E){}watch(E,b,d){const g=this.j(this.g);return Array.isArray(g)&&(d.excludes=[...d.excludes,...g]),this.a.set(E,this.b.watch(b,d)),(0,o.toDisposable)(()=>{(0,o.dispose)(this.a.get(E)),this.a.delete(E)})}dispose(){super.dispose();for(const[,E]of this.a)E.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=m}),define(pe[111],be([1,0,4,6,12,2]),function(le,e,y,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class k extends o.AbstractLoggerService{constructor(E,b,d,g,p){super(b,d,g),this.n=E,this.p=p,this.B(p.listen("onDidChangeLogLevel",E)(r=>{(0,o.isLogLevel)(r)?super.setLogLevel(r):super.setLogLevel(y.URI.revive(r[0]),r[1])})),this.B(p.listen("onDidChangeVisibility",E)(([r,f])=>super.setVisibility(y.URI.revive(r),f))),this.B(p.listen("onDidChangeLoggers",E)(({added:r,removed:f})=>{for(const c of r)super.registerLogger({...c,resource:y.URI.revive(c.resource)});for(const c of f)super.deregisterLogger(c.resource)}))}createConsoleMainLogger(){return new o.AdapterLogger({log:(E,b)=>{this.p.call("consoleLog",[E,b])}})}registerLogger(E){super.registerLogger(E),this.p.call("registerLogger",[E,this.n])}deregisterLogger(E){super.deregisterLogger(E),this.p.call("deregisterLogger",[E,this.n])}setLogLevel(E,b){super.setLogLevel(E,b),this.p.call("setLogLevel",[E,b])}setVisibility(E,b){super.setVisibility(E,b),this.p.call("setVisibility",[this.l(E),b])}m(E,b,d){return new T(this.p,E,b,d,this.n)}static setLogLevel(E,b,d){return E.call("setLogLevel",[b,d])}}e.LoggerChannelClient=k;class T extends o.AbstractMessageLogger{constructor(E,b,d,g,p){super(g?.logLevel==="always"),this.m=E,this.n=b,this.k=!1,this.l=[],this.setLevel(d),this.m.call("createLogger",[b,g,p]).then(()=>{this.r(this.l),this.k=!0})}g(E,b){const d=[[E,b]];this.k?this.r(d):this.l.push(...d)}r(E){this.m.call("log",[this.n,E])}}class v{constructor(E,b){this.a=E,this.b=b}listen(E,b){const d=this.b(E);switch(b){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(p=>this.c(p,d)),removed:[...g.removed].map(p=>this.c(p,d))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,g=>[d.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,g=>(0,o.isLogLevel)(g)?g:[d.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${b}`)}async call(E,b,d){const g=this.b(E);switch(b){case"setLogLevel":return(0,o.isLogLevel)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(y.URI.revive(g.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,g)))}throw new Error(`Call not found: ${b}`)}c(E,b){return{...E,resource:b.transformOutgoingURI(E.resource)}}}e.LoggerChannel=v;class m extends A.Disposable{constructor(E,b){super(),b.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(d=>b.call("setLogLevel",[d]))),b.call("getRegisteredLoggers").then(d=>{for(const g of d)E.registerLogger({...g,resource:y.URI.revive(g.resource)})}),this.B(b.listen("onDidChangeVisibility")(([d,g])=>E.setVisibility(y.URI.revive(d),g))),this.B(b.listen("onDidChangeLoggers")(({added:d,removed:g})=>{for(const p of d)E.registerLogger({...p,resource:y.URI.revive(p.resource)});for(const p of g)E.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=m}),define(pe[112],be([1,0,2,12]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class o extends y.Disposable{constructor(k,T=[]){super(),this.a=new L.MultiplexLogger([k,...T]),this.B(k.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(k){this.a.setLevel(k)}getLevel(){return this.a.getLevel()}trace(k,...T){this.a.trace(k,...T)}debug(k,...T){this.a.debug(k,...T)}info(k,...T){this.a.info(k,...T)}warn(k,...T){this.a.warn(k,...T)}error(k,...T){this.a.error(k,...T)}flush(){this.a.flush()}}e.LogService=o}),define(pe[223],be([1,0,16,12]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var o;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(o||(o={}));async function A(m,R,E,b,d){try{const g=await new Promise((r,f)=>{le(["@vscode/spdlog"],r,f)});g.setFlushOn(o.Trace);const p=await g.createAsyncRotatingLogger(m,R,E,b);return d?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(g){console.error(g)}return null}function k(m,R,E){switch(R){case L.LogLevel.Trace:m.trace(E);break;case L.LogLevel.Debug:m.debug(E);break;case L.LogLevel.Info:m.info(E);break;case L.LogLevel.Warning:m.warn(E);break;case L.LogLevel.Error:m.error(E);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function T(m,R){switch(R){case L.LogLevel.Trace:m.setLevel(o.Trace);break;case L.LogLevel.Debug:m.setLevel(o.Debug);break;case L.LogLevel.Info:m.setLevel(o.Info);break;case L.LogLevel.Warning:m.setLevel(o.Warning);break;case L.LogLevel.Error:m.setLevel(o.Error);break;case L.LogLevel.Off:m.setLevel(o.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class v extends L.AbstractMessageLogger{constructor(R,E,b,d,g){super(),this.k=[],this.setLevel(g),this.l=this.n(R,E,b,d),this.B(this.onDidChangeLogLevel(p=>{this.m&&T(this.m,p)}))}async n(R,E,b,d){const g=b?6:1,p=30/g*y.ByteSize.MB,r=await A(R,E,p,g,d);if(r){this.m=r,T(this.m,this.getLevel());for(const{level:f,message:c}of this.k)k(this.m,f,c);this.k=[]}}g(R,E){this.m?k(this.m,R,E):this.getLevel()<=R&&this.k.push({level:R,message:E})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=v}),define(pe[113],be([1,0,21,12,223]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends L.AbstractLoggerService{m(T,v,m){return new o.SpdLogLogger((0,y.generateUuid)(),T.fsPath,!m?.donotRotate,!!m?.donotUseFormatters,v)}}e.LoggerService=A}),define(pe[224],be([1,0,60,185,5]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var k;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(k||(e.MarkerSeverity=k={})),function(v){function m(g,p){return p-g}v.compare=m;const R=Object.create(null);R[v.Error]=(0,L.localize)(0,null),R[v.Warning]=(0,L.localize)(1,null),R[v.Info]=(0,L.localize)(2,null);function E(g){return R[g]||""}v.toString=E;function b(g){switch(g){case y.default.Error:return v.Error;case y.default.Warning:return v.Warning;case y.default.Info:return v.Info;case y.default.Ignore:return v.Hint}}v.fromSeverity=b;function d(g){switch(g){case v.Error:return y.default.Error;case v.Warning:return y.default.Warning;case v.Info:return y.default.Info;case v.Hint:return y.default.Ignore}}v.toSeverity=d}(k||(e.MarkerSeverity=k={}));var T;(function(v){const m="";function R(b){return E(b,!0)}v.makeKey=R;function E(b,d){const g=[m];return b.source?g.push(b.source.replace("\xA6","\\\xA6")):g.push(m),b.code?typeof b.code=="string"?g.push(b.code.replace("\xA6","\\\xA6")):g.push(b.code.value.replace("\xA6","\\\xA6")):g.push(m),b.severity!==void 0&&b.severity!==null?g.push(k.toString(b.severity)):g.push(m),b.message&&d?g.push(b.message.replace("\xA6","\\\xA6")):g.push(m),b.startLineNumber!==void 0&&b.startLineNumber!==null?g.push(b.startLineNumber.toString()):g.push(m),b.startColumn!==void 0&&b.startColumn!==null?g.push(b.startColumn.toString()):g.push(m),b.endLineNumber!==void 0&&b.endLineNumber!==null?g.push(b.endLineNumber.toString()):g.push(m),b.endColumn!==void 0&&b.endColumn!==null?g.push(b.endColumn.toString()):g.push(m),g.push(m),g.join("\xA6")}v.makeKeyOptionalMessage=E})(T||(e.IMarkerData=T={})),e.IMarkerService=(0,o.createDecorator)("markerService")}),define(pe[67],be([1,0,6,46,2,5]),function(le,e,y,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class k extends o.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new y.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const R=Object.keys(this.f).length;return this.f={...m,...this.f},R!==Object.keys(this.f).length&&await this.i(m),L.Iterable.reduce(this.g.entries(),(E,[b,d])=>({...E,[b]:d}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(m,[R,E])=>({...m,[R]:{definition:E,value:this.g.get(R)}}),{})}}e.AbstractPolicyService=k;class T{constructor(){this.onDidChange=y.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=T}),define(pe[54],be([1,0,3,29]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let o;if(typeof y.globals.vscode<"u"&&typeof y.globals.vscode.context<"u"){const A=y.globals.vscode.context.configuration();if(A)o=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(o=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`,serverDataFolderName:o.serverDataFolderName?`${o.serverDataFolderName}-dev`:void 0}),!o.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(o,{version:A.version})}Object.assign(o,{extensionsGallery:L.env.EXTENSIONS_GALLERY?JSON.parse(L.env.EXTENSIONS_GALLERY):o.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else o={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.78.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.79.2",commit:"695af097c7bd098fbf017ce3ac85e09bbc5dda06",date:"2023-06-22T06:47:55.646Z"},Object.keys(o).length===0&&Object.assign(o,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=o}),define(pe[27],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,y.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(pe[40],be([1,0,93,8]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class o{constructor(){this.a=new Map}add(k,T){y.ok(L.isString(k)),y.ok(L.isObject(T)),y.ok(!this.a.has(k),"There is already an extension with this id"),this.a.set(k,T)}knows(k){return this.a.has(k)}as(k){return this.a.get(k)||null}}e.Registry=new o}),define(pe[225],be([1,0,6,40]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function o(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class A{constructor(){this.b=new y.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,m){this.a[o(v)]=m,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const k=new A;L.Registry.add(e.Extensions.JSONContribution,k)}),define(pe[55],be([1,0,18,6,8,167,24,225,40]),function(le,e,y,L,o,A,k,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(O){O.Multiline="multilineText",O.Singleline="singlelineText"})(m||(e.EditPresentationTypes=m={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(O){O[O.APPLICATION=1]="APPLICATION",O[O.MACHINE=2]="MACHINE",O[O.WINDOW=3]="WINDOW",O[O.RESOURCE=4]="RESOURCE",O[O.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",O[O.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=v.Registry.as(T.Extensions.JSONContribution);class b{constructor(){this.h=new Set,this.i=new L.Emitter,this.onDidSchemaChange=this.i.event,this.j=new L.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const s=new Set;this.n(t,n,s),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const n=new Set;this.o(t,n),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const s=new Set;this.o(n,s),this.n(t,!1,s),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const s=[];for(const{overrides:i,source:a}of t)for(const l in i)if(n.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const h=this.a.get(l),C=h?.valuesSources??new Map;if(a)for(const N of Object.keys(i[l]))C.set(N,a);const D={...h?.value||{},...i[l]};this.a.set(l,{source:a,value:D,valuesSources:C});const w=(0,k.getLanguageTagSettingPlainKey)(l),S={type:"object",default:D,description:A.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:o.isString(a)?void 0:a,defaultValueSource:a};s.push(...p(l)),this.d[l]=S,this.b.properties[l]=S}else{this.a.set(l,{value:i[l],source:a});const h=this.d[l];h&&(this.w(l,h),this.r(l,h))}this.m(s)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:s,source:i}of t)for(const a in s){const l=this.a.get(a),h=o.isString(i)?i:i?.id,C=o.isString(l?.source)?l?.source:l?.source?.id;if(h===C)if(n.add(a),this.a.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.d[a],delete this.b.properties[a];else{const D=this.d[a];D&&(this.w(a,D),this.r(a,D))}}this.u()}deltaConfiguration(t){let n=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,s){t.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,s),this.c.push(i),this.q(i)})}o(t,n){const s=i=>{if(i.properties)for(const a in i.properties){n.add(a);const l=this.d[a];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[a],this.s(a,i.properties[a])}i.allOf?.forEach(a=>s(a))};for(const i of t){s(i);const a=this.c.indexOf(i);a!==-1&&this.c.splice(a,1)}}p(t,n=!0,s,i,a=3,l){a=o.isUndefinedOrNull(t.scope)?a:t.scope;const h=t.properties;if(h)for(const D in h){const w=h[D];if(n&&u(D,w)){delete h[D];continue}if(w.source=s,w.defaultDefaultValue=h[D].default,this.w(D,w),e.OVERRIDE_PROPERTY_REGEX.test(D)?w.scope=void 0:(w.scope=o.isUndefinedOrNull(w.scope)?a:w.scope,w.restricted=o.isUndefinedOrNull(w.restricted)?!!i?.includes(D):w.restricted),h[D].hasOwnProperty("included")&&!h[D].included){this.f[D]=h[D],delete h[D];continue}else this.d[D]=h[D],h[D].policy?.name&&this.e.set(h[D].policy.name,D);!h[D].deprecationMessage&&h[D].markdownDeprecationMessage&&(h[D].deprecationMessage=h[D].markdownDeprecationMessage),l.add(D)}const C=t.allOf;if(C)for(const D of C)this.p(D,n,s,i,a,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=s=>{const i=s.properties;if(i)for(const l in i)this.r(l,i[l]);s.allOf?.forEach(n)};n(t)}r(t,n){switch(e.allSettings.properties[t]=n,n.scope){case 1:e.applicationSettings.properties[t]=n;break;case 2:e.machineSettings.properties[t]=n;break;case 6:e.machineOverridableSettings.properties[t]=n;break;case 3:e.windowSettings.properties[t]=n;break;case 4:e.resourceSettings.properties[t]=n;break;case 5:e.resourceSettings.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.allSettings.properties[t],n.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,s={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(n,s),e.allSettings.properties[n]=s,e.applicationSettings.properties[n]=s,e.machineSettings.properties[n]=s,e.machineOverridableSettings.properties[n]=s,e.windowSettings.properties[n]=s,e.resourceSettings.properties[n]=s}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,n){const s=this.a.get(t);let i=s?.value,a=s?.source;o.isUndefined(i)&&(i=n.defaultDefaultValue,a=void 0),o.isUndefined(i)&&(i=f(n.type)),n.default=i,n.defaultValueSource=a}}const d="\\[([^\\]]+)\\]",g=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(O){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(O)){let n=g.exec(O);for(;n?.length;){const s=n[1].trim();s&&t.push(s),n=g.exec(O)}}return(0,y.distinct)(t)}e.overrideIdentifiersFromKey=p;function r(O){return O.reduce((t,n)=>`${t}[${n}]`,"")}e.keyFromOverrideIdentifiers=r;function f(O){switch(Array.isArray(O)?O[0]:O){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const c=new b;v.Registry.add(e.Extensions.Configuration,c);function u(O,t){return O.trim()?e.OVERRIDE_PROPERTY_REGEX.test(O)?A.localize(7,null,O):c.getConfigurationProperties()[O]!==void 0?A.localize(8,null,O):t.policy?.name&&c.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,O,t.policy?.name,c.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.validateProperty=u;function I(){const O=[],t=c.getConfigurationProperties();for(const n of Object.keys(t))O.push([n,t[n].scope]);return O.push(["launch",4]),O.push(["task",4]),O}e.getScopes=I}),define(pe[114],be([1,0,18,6,72,2,28,22,8,4,24,55,40]),function(le,e,y,L,o,A,k,T,v,m,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(n){return Object.isFrozen(n)?n:T.deepFreeze(n)}class g{constructor(s={},i=[],a=[],l){this.b=s,this.c=i,this.d=a,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof g)return i;const a=new p("");return a.parseRaw(i),a.configurationModel});this.f=s.reduce((i,a)=>a===i?a:i.merge(a),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,R.getConfigurationValue)(this.contents,s):this.contents}inspect(s,i){const a=this.rawConfiguration.getValue(s),l=i?this.rawConfiguration.getOverrideValue(s,i):void 0,h=i?this.rawConfiguration.override(i).getValue(s):a;return{value:a,override:l,merged:h}}getOverrideValue(s,i){const a=this.i(i);return a?s?(0,R.getConfigurationValue)(a,s):a:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const a of this.overrides)a.identifiers.includes(s)&&i.push(...a.keys);return y.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return y.distinct(s)}override(s){let i=this.a.get(s);return i||(i=this.g(s),this.a.set(s,i)),i}merge(...s){const i=T.deepClone(this.contents),a=T.deepClone(this.overrides),l=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const C of s)if(h.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(i,C.contents);for(const D of C.overrides){const[w]=a.filter(S=>y.equals(S.identifiers,D.identifiers));w?(this.h(w.contents,D.contents),w.keys.push(...D.keys),w.keys=y.distinct(w.keys)):a.push(T.deepClone(D))}for(const D of C.keys)l.indexOf(D)===-1&&l.push(D)}return new g(i,l,a,h.every(C=>C instanceof g)?void 0:h)}g(s){const i=this.i(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const a={};for(const l of y.distinct([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[l];const C=i[l];C&&(typeof h=="object"&&typeof C=="object"?(h=T.deepClone(h),this.h(h,C)):h=C),a[l]=h}return new g(a,this.keys,this.overrides)}h(s,i){for(const a of Object.keys(i)){if(a in s&&v.isObject(s[a])&&v.isObject(i[a])){this.h(s[a],i[a]);continue}s[a]=T.deepClone(i[a])}}i(s){let i=null,a=null;const l=h=>{h&&(a?this.h(a,h):a=T.deepClone(h))};for(const h of this.overrides)y.equals(h.identifiers,[s])?i=h.contents:h.identifiers.includes(s)&&l(h.contents);return l(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.j(s,i,!0)}setValue(s,i){this.j(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,R.removeFromValueTree)(this.contents,s),E.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(a=>y.equals(a.identifiers,(0,E.overrideIdentifiersFromKey)(s))),1))}j(s,i,a){(0,R.addToValueTree)(this.contents,s,i,l=>console.error(l)),a=a||this.keys.indexOf(s)===-1,a&&this.keys.push(s),E.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,E.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,R.toValuesTree)(this.contents[s],l=>console.error(l))})}}e.ConfigurationModel=g;class p{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,i){if(!v.isUndefinedOrNull(s)){const a=this.g(s);this.parseRaw(a,i)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,i){this.a=s;const{contents:a,keys:l,overrides:h,restricted:C,hasExcludedProperties:D}=this.h(s,i);this.b=new g(a,l,h,D?[s]:void 0),this.c=C||[]}g(s){let i={},a=null,l=[];const h=[],C=[];function D(S){Array.isArray(l)?l.push(S):a!==null&&(l[a]=S)}const w={onObjectBegin:()=>{const S={};D(S),h.push(l),l=S,a=null},onObjectProperty:S=>{a=S},onObjectEnd:()=>{l=h.pop()},onArrayBegin:()=>{const S=[];D(S),h.push(l),l=S,a=null},onArrayEnd:()=>{l=h.pop()},onLiteralValue:D,onError:(S,N,$)=>{C.push({error:S,offset:N,length:$})}};if(s)try{o.visit(s,w),i=l[0]||{}}catch(S){console.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return i}h(s,i){const a=b.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),l=this.i(s,a,!0,i);s=l.raw;const h=(0,R.toValuesTree)(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),C=Object.keys(s),D=this.j(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:h,keys:C,overrides:D,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(s,i,a,l){let h=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:h};const C={},D=[];for(const w in s)if(E.OVERRIDE_PROPERTY_REGEX.test(w)&&a){const S=this.i(s[w],i,!1,l);C[w]=S.raw,h=h||S.hasExcludedProperties,D.push(...S.restricted)}else{const S=i[w],N=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&D.push(w),(N===void 0||l.scopes===void 0||l.scopes.includes(N))&&!(l.skipRestricted&&S?.restricted)?C[w]=s[w]:h=!0}return{raw:C,restricted:D,hasExcludedProperties:h}}j(s,i){const a=[];for(const l of Object.keys(s))if(E.OVERRIDE_PROPERTY_REGEX.test(l)){const h={};for(const C in s[l])h[C]=s[l][C];a.push({identifiers:(0,E.overrideIdentifiersFromKey)(l),keys:Object.keys(h),contents:(0,R.toValuesTree)(h,i)})}return a}}e.ConfigurationModelParser=p;class r extends A.Disposable{constructor(s,i,a,l){super(),this.f=s,this.g=i,this.h=l,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.a=new p(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(L.Event.any(L.Event.filter(this.h.onDidFilesChange,h=>h.contains(this.f)),L.Event.filter(this.h.onDidRunOperation,h=>(h.isOperation(0)||h.isOperation(3)||h.isOperation(1)||h.isOperation(4))&&a.isEqual(h.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new g}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=r;class f{constructor(s,i,a,l,h,C,D,w,S,N,$,ee,he){this.a=s,this.b=i,this.c=a,this.overrideIdentifiers=l,this.d=h,this.f=C,this.g=D,this.h=w,this.i=S,this.j=N,this.k=$,this.l=ee,this.m=he}get value(){return d(this.c)}n(s,i,a){const l=s.inspect(i,a);return{get value(){return d(l.value)},get override(){return d(l.override)},get merged(){return d(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(s,i,a,l,h=new g,C=new g,D=new k.ResourceMap,w=new g,S=new k.ResourceMap){this.c=s,this.d=i,this.f=a,this.g=l,this.h=h,this.i=C,this.j=D,this.l=w,this.m=S,this.a=null,this.b=new k.ResourceMap,this.n=null}getValue(s,i,a){return this.q(s,i,a).getValue(s)}updateValue(s,i,a={}){let l;a.resource?(l=this.m.get(a.resource),l||(l=new g,this.m.set(a.resource,l))):l=this.l,i===void 0?l.removeValue(s):l.setValue(s,i),a.resource||(this.a=null)}inspect(s,i,a){const l=this.q(s,i,a),h=this.u(i.resource,a),C=i.resource?this.m.get(i.resource)||this.l:this.l,D=new Set;for(const w of l.overrides)for(const S of w.identifiers)l.getOverrideValue(s,S)!==void 0&&D.add(S);return new f(s,i,l.getValue(s),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,h||void 0,C)}keys(s){const i=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,i){this.j.set(s,i),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const a=[];if(!i){const{added:l,updated:h,removed:C}=O(this.c,s);i=[...l,...h,...C]}for(const l of i)for(const h of(0,E.overrideIdentifiersFromKey)(l)){const C=this.c.getKeysForOverrideIdentifier(h),D=s.getKeysForOverrideIdentifier(h),w=[...D.filter(S=>C.indexOf(S)===-1),...C.filter(S=>D.indexOf(S)===-1),...C.filter(S=>!T.equals(this.c.override(h).getValue(S),s.override(h).getValue(S)))];a.push([h,w])}return this.updateDefaultConfiguration(s),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:a,removed:l}=O(this.d,s),h=[...i,...a,...l];return h.length&&this.updatePolicyConfiguration(s),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:a,removed:l,overrides:h}=O(this.applicationConfiguration,s),C=[...i,...a,...l];return C.length&&this.updateApplicationConfiguration(s),{keys:C,overrides:h}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:a,removed:l,overrides:h}=O(this.localUserConfiguration,s),C=[...i,...a,...l];return C.length&&this.updateLocalUserConfiguration(s),{keys:C,overrides:h}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:a,removed:l,overrides:h}=O(this.remoteUserConfiguration,s),C=[...i,...a,...l];return C.length&&this.updateRemoteUserConfiguration(s),{keys:C,overrides:h}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:a,removed:l,overrides:h}=O(this.workspaceConfiguration,s),C=[...i,...a,...l];return C.length&&this.updateWorkspaceConfiguration(s),{keys:C,overrides:h}}compareAndUpdateFolderConfiguration(s,i){const a=this.p.get(s),{added:l,updated:h,removed:C,overrides:D}=O(a,i),w=[...l,...h,...C];return(w.length||!a)&&this.updateFolderConfiguration(s,i),{keys:w,overrides:D}}compareAndDeleteFolderConfiguration(s){const i=this.p.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:a,updated:l,removed:h,overrides:C}=O(i,void 0);return{keys:[...a,...l,...h],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,i,a){let l=this.r(i,a);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(l=l.merge(this.d)),l}r({resource:s},i){let a=this.s();if(i&&s){const l=i.getFolder(s);l&&(a=this.t(l.uri)||a);const h=this.m.get(s);h&&(a=a.merge(h))}return a}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let i=this.b.get(s);if(!i){const a=this.s(),l=this.j.get(s);l?(i=a.merge(l),this.b.set(s,i)):i=a}return i}u(s,i){if(i&&s){const a=i.getFolder(s);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,i)=>{const{contents:a,overrides:l,keys:h}=this.j.get(i);return s.push([i,{contents:a,overrides:l,keys:h}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this.i.keys.forEach(i=>s.add(i)),this.j.forEach(i=>i.keys.forEach(a=>s.add(a))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(a=>s.add(a))),[...s.values()]}w(s){const i=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a)),this.i.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(s).forEach(l=>i.add(l))),[...i.values()]}static parse(s){const i=this.x(s.defaults),a=this.x(s.policy),l=this.x(s.application),h=this.x(s.user),C=this.x(s.workspace),D=s.folders.reduce((w,S)=>(w.set(m.URI.revive(S[0]),this.x(S[1])),w),new k.ResourceMap);return new c(i,a,l,h,new g,C,D,new g,new k.ResourceMap)}static x(s){return new g(s.contents,s.keys,s.overrides)}}e.Configuration=c;function u(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const s=new Set,i=new Map;for(const l of n)l.keys.forEach(h=>s.add(h)),l.overrides.forEach(([h,C])=>{const D=(0,k.getOrSet)(i,h,new Set);C.forEach(w=>D.add(w))});const a=[];return i.forEach((l,h)=>a.push([h,[...l.values()]])),{keys:[...s.values()],overrides:a}}e.mergeChanges=u;class I{constructor(s,i,a,l){this.change=s,this.f=i,this.g=a,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const h of s.keys)this.affectedKeys.add(h);for(const[,h]of s.overrides)for(const C of h)this.affectedKeys.add(C);this.d=this.a;for(const h of this.affectedKeys)this.d+=h+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(s,i){const a=this.a+s,l=this.d.indexOf(a);if(l<0)return!1;const h=l+a.length;if(h>=this.d.length)return!1;const C=this.d.charCodeAt(h);if(C!==this.b&&C!==this.c)return!1;if(i){const D=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.f?.workspace):void 0,w=this.g.getValue(s,i,this.h);return!T.equals(D,w)}return!0}}e.ConfigurationChangeEvent=I;function O(n,s){const{added:i,removed:a,updated:l}=t(s?.rawConfiguration,n?.rawConfiguration),h=[],C=n?.getAllOverrideIdentifiers()||[],D=s?.getAllOverrideIdentifiers()||[];if(s){const w=D.filter(S=>!C.includes(S));for(const S of w)h.push([S,s.getKeysForOverrideIdentifier(S)])}if(n){const w=C.filter(S=>!D.includes(S));for(const S of w)h.push([S,n.getKeysForOverrideIdentifier(S)])}if(s&&n){for(const w of C)if(D.includes(w)){const S=t({contents:n.getOverrideValue(void 0,w)||{},keys:n.getKeysForOverrideIdentifier(w)},{contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)});h.push([w,[...S.added,...S.removed,...S.updated]])}}return{added:i,removed:a,updated:l,overrides:h}}function t(n,s){const i=n?s?n.keys.filter(h=>s.keys.indexOf(h)===-1):[...n.keys]:[],a=s?n?s.keys.filter(h=>n.keys.indexOf(h)===-1):[...s.keys]:[],l=[];if(n&&s){for(const h of s.keys)if(n.keys.indexOf(h)!==-1){const C=(0,R.getConfigurationValue)(s.contents,h),D=(0,R.getConfigurationValue)(n.contents,h);T.equals(C,D)||l.push(h)}}return{added:i,removed:a,updated:l}}}),define(pe[226],be([1,0,18,6,2,22,8,114,55,12,67,40]),function(le,e,y,L,o,A,k,T,v,m,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class b extends o.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new T.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.Registry.as(v.Extensions.Configuration).onDidUpdateConfiguration(({properties:r,defaultsOverrides:f})=>this.c(Array.from(r),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(r,f){this.h(r,E.Registry.as(v.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:r})}f(){return{}}g(){this.b=new T.ConfigurationModel;const r=E.Registry.as(v.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(r),r)}h(r,f){const c=this.f();for(const u of r){const I=c[u],O=f[u];I!==void 0?this.b.addValue(u,I):O?this.b.addValue(u,O.default):this.b.removeValue(u)}}}e.DefaultConfiguration=b;class d{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new T.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let g=e.PolicyConfiguration=class extends o.Disposable{get configurationModel(){return this.b}constructor(r,f,c){super(),this.c=r,this.f=f,this.g=c,this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new T.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(r=>this.i(r))),this.B(this.c.onDidChangeConfiguration(async({properties:r})=>this.j(await this.h(r),!0))),this.b}async h(r){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",r);const f={},c=[],u=E.Registry.as(v.Extensions.Configuration).getConfigurationProperties();for(const I of r){const O=u[I];if(!O){c.push(I);continue}if(O.policy){if(O.type!=="string"&&O.type!=="number"){this.g.warn(`Policy ${O.policy.name} has unsupported type ${O.type}`);continue}c.push(I),f[O.policy.name]={type:O.type}}}return(0,k.isEmptyObject)(f)||await this.f.updatePolicyDefinitions(f),c}i(r){this.g.trace("PolicyConfiguration#onDidChangePolicies",r);const f=E.Registry.as(v.Extensions.Configuration).getPolicyConfigurations(),c=(0,y.coalesce)(r.map(u=>f.get(u)));this.j(c,!0)}j(r,f){this.g.trace("PolicyConfiguration#update",r);const c=E.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),u=[],I=this.b.isEmpty();for(const O of r){const t=c[O]?.policy?.name;if(t){const n=this.f.getPolicyValue(t);(I?n!==void 0:!(0,A.equals)(this.b.getValue(O),n))&&u.push([O,n])}else this.b.getValue(O)!==void 0&&u.push([O,void 0])}if(u.length){this.g.trace("PolicyConfiguration#changed",u);const O=this.b;this.b=new T.ConfigurationModel;for(const t of O.keys)this.b.setValue(t,O.getValue(t));for(const[t,n]of u)n===void 0?this.b.removeValue(t):this.b.setValue(t,n);f&&this.a.fire(this.b)}}};e.PolicyConfiguration=g=Le([Ae(1,R.IPolicyService),Ae(2,m.ILogService)],g)}),define(pe[115],be([1,0,14,6,2,19,24,114,226,67]),function(le,e,y,L,o,A,k,T,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends o.Disposable{constructor(b,d,g,p){super(),this.i=b,this.h=this.B(new L.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.DefaultConfiguration),this.c=g instanceof m.NullPolicyService?new v.NullPolicyConfiguration:this.B(new v.PolicyConfiguration(this.b,g,p)),this.f=this.B(new T.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,d)),this.a=new T.Configuration(this.b.configurationModel,this.c.configurationModel,new T.ConfigurationModel,new T.ConfigurationModel),this.g=this.B(new y.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:f})=>this.k(r,f))),this.B(this.c.onDidChangeConfiguration(r=>this.l(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,d,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new T.Configuration(b,d,new T.ConfigurationModel,g)}getConfigurationData(){return this.a.toData()}getValue(b,d){const g=typeof b=="string"?b:void 0,p=(0,k.isConfigurationOverrides)(b)?b:(0,k.isConfigurationOverrides)(d)?d:{};return this.a.getValue(g,p,void 0)}updateValue(b,d,g,p){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.j(b)}j(b){const d=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(b);this.m(g,d,2)}k(b,d){const g=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(b,d);this.m(p,g,7)}l(b){const d=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(b);this.m(g,d,7)}m(b,d,g){const p=new T.ConfigurationChangeEvent(b,{data:d},this.a);p.source=g,p.sourceConfig=this.n(g),this.h.fire(p)}n(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(pe[116],be([1,0,9,5]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var o;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(o||(e.RemoteConnectionType=o={}));class A{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=A;class k{constructor(E,b){this.host=E,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=k;var T;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class v extends y.ErrorNoTelemetry{static isNotAvailable(E){return E instanceof v&&E._code===T.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof v&&E._code===T.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof v&&E._code===T.NoResolverFound}static isHandled(E){return E instanceof v&&E.isHandled}constructor(E,b=T.Unknown,d){super(E),this._message=E,this._code=b,this._detail=d,this.isHandled=b===T.NotAvailable&&d===!0,Object.setPrototypeOf(this,v.prototype)}}e.RemoteAuthorityResolverError=v;function m(R){const E=R.indexOf("+");return E===-1?R:R.substring(0,E)}e.getRemoteAuthorityPrefix=m}),define(pe[227],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannelName=e.IRemoteExtensionsScannerService=void 0,e.IRemoteExtensionsScannerService=(0,y.createDecorator)("IRemoteExtensionsScannerService"),e.RemoteExtensionsScannerChannelName="remoteExtensionsScanner"}),define(pe[56],be([1,0,13]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(m){return m.scheme===y.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=L;function o(m){if(!m)return;const R=m.indexOf("+");return R<0?m:m.substr(0,R)}e.getRemoteName=o;function A(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=A;function k(m){const{host:R,port:E}=v(m);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:E}}e.parseAuthorityWithPort=k;function T(m,R){let{host:E,port:b}=v(m);return typeof b>"u"&&(b=R),{host:E,port:b}}e.parseAuthorityWithOptionalPort=T;function v(m){const R=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const E=m.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const b=m.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:m,port:void 0}}}),define(pe[34],be([1,0,17,5,56]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(k||(e.ExtensionType=k={}));var T;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class v{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,f){if(typeof r>"u"||r===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof r=="string"||typeof f=="string"){const c=typeof r=="string"?r:r.value,u=typeof f=="string"?f:f.value;return y.equalsIgnoreCase(c,u)}return r._lower===f._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.ExtensionIdentifier=v;class m{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const f of r)this.add(f)}add(r){this.c.add(v.toKey(r))}delete(r){return this.c.delete(v.toKey(r))}has(r){return this.c.has(v.toKey(r))}}e.ExtensionIdentifierSet=m;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(v.toKey(r))}get(r){return this.c.get(v.toKey(r))}has(r){return this.c.has(v.toKey(r))}set(r,f){this.c.set(v.toKey(r),f)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function E(p){return b(p)}e.isApplicationScopedExtension=E;function b(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function d(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function g(p,r){if(r){const f=`onResolveRemoteAuthority:${(0,o.getRemoteName)(r)}`;return!!p.activationEvents?.includes(f)}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[228],be([1,0,9,34]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class o{constructor(){this.a=new Map,this.b=new WeakMap}register(k,T){this.a.set(k,T)}readActivationEvents(k){return this.b.has(k)||this.b.set(k,this.c(k)),this.b.get(k)}createActivationEventsMap(k){const T=Object.create(null);for(const v of k){const m=this.readActivationEvents(v);m.length>0&&(T[L.ExtensionIdentifier.toKey(v.identifier)]=m)}return T}c(k){if(typeof k.main>"u"&&typeof k.browser>"u")return[];const T=Array.isArray(k.activationEvents)?k.activationEvents.slice(0):[];if(!k.contributes)return T;for(const v in k.contributes){const m=this.a.get(v);if(!m)continue;const R=k.contributes[v],E=Array.isArray(R)?R:[R];try{m(E,T)}catch(b){(0,y.onUnexpectedError)(b)}}return T}}e.ImplicitActivationEventsImpl=o,e.ImplicitActivationEvents=new o}),define(pe[229],be([1,0,2,34,16]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends y.Disposable{constructor(T,v,m,R,E){super(),this.a=T,this.b=v,this.c=m,this.f=E,this.B(R.onDidInstallExtensions(b=>this.g(b))),this.B(R.onDidUninstallExtension(b=>this.h(b)))}g(T){for(const v of T)v.local&&this.invalidate(v.profileLocation)}h(T){T.error||this.invalidate(T.profileLocation)}async invalidate(T){if(T)for(const v of this.a.profiles)this.c.extUri.isEqual(v.extensionsResource,T)&&await this.i(v);else await this.i(this.a.defaultProfile)}async i(T){try{await this.b.del(this.c.extUri.joinPath(T.cacheHome,L.USER_MANIFEST_CACHE_FILE))}catch(v){(0,o.toFileOperationResult)(v)!==1&&this.f.error(v)}}}e.ExtensionsManifestCache=A}),define(pe[44],be([1,0,15,9,2,186,55,5,12,40]),function(le,e,y,L,o,A,k,T,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");class R{constructor(O){this.b=O}toJSON(){if(!this.a){const O=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?O[t]="*****":O[t]=this.b[t];this.a=O}return this.a}}class E extends o.Disposable{constructor(O){super(),this.b=0,this.a=O.createLogger("network",{name:(0,A.localize)(0,null),when:v.CONTEXT_LOG_LEVEL.isEqualTo((0,v.LogLevelToString)(v.LogLevel.Trace)).serialize()})}async c(O,t,n){const s=`${O} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new R(t.headers??{}));try{const i=await n();return this.a.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${s} - error`,t.type,(0,L.getErrorMessage)(i)),i}}}e.AbstractRequestService=E;function b(I){return I.res.statusCode&&I.res.statusCode>=200&&I.res.statusCode<300||I.res.statusCode===1223}e.isSuccess=b;function d(I){return I.res.statusCode===204}async function g(I){return d(I)?null:(await(0,y.streamToBuffer)(I.stream)).toString()}e.asText=g;async function p(I){if(!b(I))throw new Error("Server returned "+I.res.statusCode);return g(I)}e.asTextOrError=p;async function r(I){if(!b(I))throw new Error("Server returned "+I.res.statusCode);if(d(I))return null;const t=(await(0,y.streamToBuffer)(I.stream)).toString();try{return JSON.parse(t)}catch(n){throw n.message+=`:
`+t,n}}e.asJson=r;function f(I){u(I)}e.updateProxyConfigurationsScope=f;let c;function u(I){const O=m.Registry.as(k.Extensions.Configuration),t=c;c={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:I,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(5,null),(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null)],default:"override",description:(0,A.localize)(9,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(10,null),restricted:!0}}},O.updateConfigurations({add:[c],remove:t?[t]:[]})}u(1)}),define(pe[230],be([1,0,20,13,16,44]),function(le,e,y,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=e.DownloadService=class{constructor(v,m){this.a=v,this.b=m}async download(v,m,R=y.CancellationToken.None){if(v.scheme===L.Schemas.file||v.scheme===L.Schemas.vscodeRemote){await this.b.copy(v,m);return}const E={type:"GET",url:v.toString(!0)},b=await this.a.request(E,R);if(b.res.statusCode===200)await this.b.writeFile(m,b.stream);else{const d=await(0,A.asTextOrError)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${d}`)}}};e.DownloadService=k=Le([Ae(0,A.IRequestService),Ae(1,o.IFileService)],k)}),define(pe[231],be([1,0,15,20]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class o{constructor(T){this.a=T}listen(T,v){throw new Error("Invalid listen")}call(T,v,m,R=L.CancellationToken.None){switch(v){case"request":return this.a.request(m[0],R).then(async({res:E,stream:b})=>{const d=await(0,y.streamToBuffer)(b);return[{statusCode:E.statusCode,headers:E.headers},d]});case"resolveProxy":return this.a.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=o;class A{constructor(T){this.a=T}async request(T,v){const[m,R]=await this.a.call("request",[T],v);return{res:m,stream:(0,y.bufferToStream)(R)}}async resolveProxy(T){return this.a.call("resolveProxy",[T])}}e.RequestChannelClient=A}),define(pe[232],be([1,0,83,8]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function o(k,T){return k.protocol==="http:"?T.HTTP_PROXY||T.http_proxy||null:k.protocol==="https:"&&(T.HTTPS_PROXY||T.https_proxy||T.HTTP_PROXY||T.http_proxy)||null}async function A(k,T,v={}){const m=(0,y.parse)(k),R=v.proxyUrl||o(m,T);if(!R)return null;const E=(0,y.parse)(R);if(!/^https?:$/.test(E.protocol||""))return null;const b={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,L.isBoolean)(v.strictSSL)?v.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((d,g)=>{le(["http-proxy-agent"],d,g)}))(b):new(await new Promise((d,g)=>{le(["https-proxy-agent"],d,g)}))(b)}e.getProxyAgent=A}),define(pe[84],be([1,0,51,7,187,20,39,9,3,21,155,204,14,142]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let g;async function p(f,c,u,I){return u["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(I)&&!u["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(I)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=b.Promises.withAsyncBody(async(O,t)=>{const n=new A.CancellationTokenSource;let s=1e4;const i=f.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(s=(0,d.clamp)(i,1,120)*1e3);const a=setTimeout(()=>{n.dispose(!0),t(new Error((0,o.localize)(0,null)))},s);try{O(await r(c,n.token))}catch(l){!(0,T.isCancellationError)(l)&&!n.token.isCancellationRequested?t(new Error((0,o.localize)(1,null,(0,k.toErrorMessage)(l)))):O({})}finally{clearTimeout(a),n.dispose()}})),g)}e.getResolvedShellEnv=p;async function r(f,c){const u=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",u);const I=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",I);const O=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(O+"({.*})"+O),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",n);const s=await(0,R.getSystemShell)(v.OS,n);return f.trace("getUnixShellEnvironment#shell",s),new Promise((i,a)=>{if(c.isCancellationRequested)return a(new T.CancellationError);const l=(0,L.basename)(s);let h,C;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(h=`& '${process.execPath}' ${D} -p '''${O}'' + JSON.stringify(process.env) + ''${O}'''`,C=["-Login","-Command"]):l==="nu"?(h=`^'${process.execPath}' ${D} -p '"${O}" + JSON.stringify(process.env) + "${O}"'`,C=["-i","-l","-c"]):(h=`'${process.execPath}' ${D} -p '"${O}" + JSON.stringify(process.env) + "${O}"'`,l==="tcsh"||l==="csh"?C=["-ic"]:C=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(C),h);const w=(0,y.spawn)(s,[...C,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});c.onCancellationRequested(()=>(w.kill(),a(new T.CancellationError))),w.on("error",$=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)($)),a($)});const S=[];w.stdout.on("data",$=>S.push($));const N=[];w.stderr.on("data",$=>N.push($)),w.on("close",($,ee)=>{const he=Buffer.concat(S).toString("utf8");f.trace("getUnixShellEnvironment#raw",he);const oe=Buffer.concat(N).toString("utf8");if(oe.trim()&&f.trace("getUnixShellEnvironment#stderr",oe),$||ee)return a(new Error((0,o.localize)(2,null,$,ee)));const ue=t.exec(he),me=ue?ue[1]:"{}";try{const _=JSON.parse(me);u?_.ELECTRON_RUN_AS_NODE=u:delete _.ELECTRON_RUN_AS_NODE,I?_.ELECTRON_NO_ATTACH_CONSOLE=I:delete _.ELECTRON_NO_ATTACH_CONSOLE,delete _.VSCODE_RESOLVING_ENVIRONMENT,delete _.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",_),i(_)}catch(_){f.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(_)),a(_)}})})}}),define(pe[233],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,y.createDecorator)("stateReadService"),e.IStateService=(0,y.createDecorator)("stateService")}),define(pe[234],be([1,0,14,15,8,25,16,12]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var v;(function(b){b[b.IMMEDIATE=0]="IMMEDIATE",b[b.DELAYED=1]="DELAYED"})(v||(e.SaveStrategy=v={}));class m{constructor(d,g,p,r){this.f=d,this.g=p,this.h=r,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=g===0?void 0:new y.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==1&&this.g.error(d)}}getItem(d,g){const p=this.a[d];return(0,o.isUndefinedOrNull)(p)?g:p}setItem(d,g){this.setItems([{key:d,data:g}])}setItems(d){let g=!1;for(const{key:p,data:r}of d)this.a[p]!==r&&((0,o.isUndefinedOrNull)(r)?(0,o.isUndefined)(this.a[p])||(this.a[p]=void 0,g=!0):(this.a[p]=r,g=!0));g&&this.j()}removeItem(d){(0,o.isUndefined)(this.a[d])||(this.a[d]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.h.writeFile(this.f,L.VSBuffer.fromString(d),{atomic:{postfix:".vsctmp"}}),this.b=d}catch(g){this.g.error(g)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=m;let R=e.StateReadonlyService=class{constructor(d,g,p,r){this.a=new m(g.stateResource,d,p,r)}async init(){await this.a.init()}getItem(d,g){return this.a.getItem(d,g)}};e.StateReadonlyService=R=Le([Ae(1,A.IEnvironmentService),Ae(2,T.ILogService),Ae(3,k.IFileService)],R);class E extends R{setItem(d,g){this.a.setItem(d,g)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.StateService=E}),define(pe[117],be([1,0,3,29,21]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(v){if(y.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}function k(v,m,R,E,b,d,g,p){const r=Object.create(null);r["common.machineId"]=d,r.sessionID=(0,o.generateUuid)()+Date.now(),r.commitHash=E,r.version=b,r["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,y.PlatformToString)(y.platform),r["common.nodePlatform"]=L.platform,r["common.nodeArch"]=R,r["common.product"]=p||"desktop",g&&(r["common.msftInternal"]=g);let f=0;const c=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),y.isLinuxSnap&&(r["common.snap"]="true");const u=A(m);return u&&(r["common.platformDetail"]=u),r}e.resolveCommonProperties=k;function T(v){const m=L.env.USERDNSDOMAIN;if(!m)return!1;const R=m.toLowerCase();return v.some(E=>R===E)}e.verifyMicrosoftInternalDomain=T}),define(pe[235],be([1,0,18,9,2,22,16]),function(le,e,y,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var T;(function(m){function R(E,b){return E.callstack<b.callstack?-1:E.callstack>b.callstack?1:0}m.compare=R})(T||(e.ErrorEvent=T={}));class v{constructor(R,E=v.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new o.DisposableStore,this.c=R,this.d=E;const b=L.errorHandler.addListener(d=>this.j(d));this.h.add((0,o.toDisposable)(b)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(R){if(!R||(R.detail&&R.detail.stack&&(R=R.detail),L.ErrorNoTelemetry.isErrorNoTelemetry(R)||R instanceof k.FileOperationError||R?.message?.includes("Unable to read file")))return;const E=Array.isArray(R.stack)?R.stack.join(`
`):R.stack,b=R.message?R.message:(0,A.safeStringify)(R);E&&this.k({msg:b,callstack:E})}k(R){const E=(0,y.binarySearch)(this.g,R,T.compare);E<0?(R.count=1,this.g.splice(~E,0,R)):(this.g[E].count||(this.g[E].count=0),this.g[E].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const R of this.g)this.c.publicLogError2("UnhandledError",R);this.g.length=0}}v.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=v}),define(pe[236],be([1,0,2]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class L extends y.Disposable{constructor(A,k){super(),this.a=A,this.b=k}async call(A,k,T){switch(k){case"updateTelemetryLevel":{const{telemetryLevel:v}=T;return this.a.updateInjectedTelemetryLevel(v)}case"logTelemetry":{const{eventName:v,data:m}=T;return this.b?this.b.log(v,m):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${k} not found`)}listen(A,k,T){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=L}),define(pe[31],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,y.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,y.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var o;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(o||(e.TelemetryConfiguration=o={}))}),define(pe[237],be([1,0,26,14,72,13,7,3,4,100,23,103,210,16,27,31]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const r=new Map;async function f(t,n){const s=`${t}::${n.join(":")}`,i=r.get(s);if(i)return i;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,h=new Map,C=2e4;function D(S,N,$,ee){const he=N.substring(S.length+1);return L.Promises.withAsyncBody(async oe=>{let ue;try{ue=await R.Promises.readdir(N,{withFileTypes:!0})}catch{oe();return}if(ee.count>=C){ee.count+=ue.length,ee.maxReached=!0,oe();return}let me=ue.length;if(me===0){oe();return}let _=ue;ee.count+ue.length>C&&(ee.maxReached=!0,me=C-ee.count,_=ue.slice(0,me)),ee.count+=ue.length;for(const re of _)if(re.isDirectory()){if($.includes(re.name)||await D(S,(0,k.join)(N,re.name),$,ee),--me===0){oe();return}}else{const q=re.name.lastIndexOf(".");if(q>=0){const J=re.name.substring(q+1);J&&l.set(J,(l.get(J)??0)+1)}for(const J of a)J.relativePathPattern?.test(he)!==!1&&J.filePattern.test(re.name)&&h.set(J.tag,(h.get(J.tag)??0)+1);if(--me===0){oe();return}}})}const w=L.Promises.withAsyncBody(async S=>{const N={count:0,maxReached:!1};await D(t,t,n,N);const $=await I(t);S({configFiles:c(h),fileTypes:c(l),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:$})});return r.set(s,w),w}e.collectWorkspaceStats=f;function c(t){return Array.from(t.entries(),([n,s])=>({name:n,count:s})).sort((n,s)=>s.count-n.count)}function u(){const t={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},n=y.cpus();return n&&n.length>0&&(t.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),t}e.getMachineInfo=u;async function I(t){try{const n=new Map,s=(0,k.join)(t,".vscode","launch.json"),i=await R.Promises.readFile(s),a=[],l=(0,o.parse)(i.toString(),a);if(a.length)return console.log(`Unable to parse ${s}`),[];if((0,o.getNodeType)(l)==="object"&&l.configurations)for(const h of l.configurations){const C=h.type;C&&(n.has(C)?n.set(C,n.get(C)+1):n.set(C,1))}return c(n)}catch{return[]}}e.collectLaunchConfigs=I;let O=e.DiagnosticsService=class{constructor(n,s){this.c=n,this.d=s}f(n){const s=[];return s.push(`OS Version:       ${n.os}`),s.push(`CPUs:             ${n.cpus}`),s.push(`Memory (System):  ${n.memory}`),s.push(`VM:               ${n.vmHint}`),s.join(`
`)}g(n){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const i=y.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(y.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(y.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),T.isWindows||s.push(`Load (avg):       ${y.loadavg().map(a=>Math.round(a)).join(", ")}`),s.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${n.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(n.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(n,s){return Promise.all([(0,E.listProcesses)(n.mainPID),this.k(n)]).then(async i=>{let[a,l]=i,h=this.m(n,a);return s.forEach(C=>{if((0,b.isRemoteDiagnosticError)(C))h+=`
${C.errorMessage}`,l+=`
${C.errorMessage}`;else if(h+=`

Remote: ${C.hostName}`,C.processes&&(h+=`
${this.m(n,C.processes)}`),C.workspaceMetadata){l+=`
|  Remote: ${C.hostName}`;for(const D of Object.keys(C.workspaceMetadata)){const w=C.workspaceMetadata[D];let S=`${w.fileCount} files`;w.maxFilesReached&&(S=`more than ${S}`),l+=`|    Folder (${D}): ${S}`,l+=this.h(w)}}}),{processInfo:h,workspaceInfo:l}})}async getSystemInfo(n,s){const{memory:i,vmHint:a,os:l,cpus:h}=u(),C={os:l,memory:i,cpus:h,vmHint:a,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:s};return T.isWindows||(C.load=`${y.loadavg().map(D=>Math.round(D)).join(", ")}`),T.isLinux&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(n,s){const i=[];return(0,E.listProcesses)(n.mainPID).then(async a=>(i.push(""),i.push(this.g(n)),i.push(""),i.push(this.m(n,a)),n.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(n))),s.forEach(l=>{if((0,b.isRemoteDiagnosticError)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.f(l.machineInfo)),l.processes&&i.push(this.m(n,l.processes)),l.workspaceMetadata)for(const h of Object.keys(l.workspaceMetadata)){const C=l.workspaceMetadata[h];let D=`${C.fileCount} files`;C.maxFilesReached&&(D=`more than ${D}`),i.push(`Folder (${h}): ${D}`),i.push(this.h(C))}}),i.push(""),i.push(""),i.join(`
`)))}h(n){const s=[];let a=0;const l=(w,S)=>{const N=` ${w}(${S})`;a+N.length>60?(s.push(h),h="|                 ",a=h.length):a+=N.length,h+=N};let h="|      File types:";const C=10,D=n.fileTypes.length>C?C:n.fileTypes.length;for(let w=0;w<D;w++){const S=n.fileTypes[w];l(S.name,S.count)}if(s.push(h),n.configFiles.length>=0&&(h="|      Conf files:",a=0,n.configFiles.forEach(w=>{l(w.name,w.count)}),s.push(h)),n.launchConfigFiles.length>0){let w="|      Launch Configs:";n.launchConfigFiles.forEach(S=>{const N=S.count>1?` ${S.name}(${S.count})`:` ${S.name}`;w+=N}),s.push(w)}return s.join(`
`)}j(n){const s=Math.max(...Object.keys(n).map(i=>i.length));return Object.keys(n).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${n[i]}`).join(`
                  `)}k(n){const s=[],i=[];return n.windows.forEach(a=>{a.folderURIs.length===0||a.remoteAuthority||(s.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const h=v.URI.revive(l);if(h.scheme===A.Schemas.file){const C=h.fsPath;i.push(f(C,["node_modules",".git"]).then(D=>{let w=`${D.fileCount} files`;D.maxFilesReached&&(w=`more than ${w}`),s.push(`|    Folder (${(0,k.basename)(C)}): ${w}`),s.push(this.h(D))}).catch(D=>{s.push(`|      Error: Unable to collect workspace stats for folder ${C} (${D.toString()})`)}))}else s.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(a=>s.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(n,s){const i=new Map;n.windows.forEach(l=>i.set(l.pid,`window [${l.id}] (${l.title})`)),n.pidToNames.forEach(({pid:l,name:h})=>i.set(l,h));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),s&&this.n(n.mainPID,i,a,s,0),a.join(`
`)}n(n,s,i,a,l){const h=l===0;let C;h?C=a.pid===n?`${this.d.applicationName} main`:"remote agent":s.has(a.pid)?C=s.get(a.pid):C=`${"  ".repeat(l)} ${a.name}`;const D=process.platform==="win32"?a.mem:y.totalmem()*(a.mem/100);i.push(`${a.load.toFixed(0).padStart(5," ")}	${(D/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(a.children)&&a.children.forEach(w=>this.n(n,s,i,w,l+1))}async getWorkspaceFileExtensions(n){const s=new Set;for(const{uri:i}of n.folders){const a=v.URI.revive(i);if(a.scheme!==A.Schemas.file)continue;const l=a.fsPath;try{(await f(l,["node_modules",".git"])).fileTypes.forEach(C=>s.add(C.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(n){for(const{uri:s}of n.folders){const i=v.URI.revive(s);if(i.scheme!==A.Schemas.file)continue;const a=i.fsPath;try{const l=await f(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),l.fileTypes.forEach(h=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})}),l.launchConfigFiles.forEach(h=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})}),l.configFiles.forEach(h=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};e.DiagnosticsService=O=Le([Ae(0,p.ITelemetryService),Ae(1,g.IProductService)],O)}),define(pe[37],be([1,0,22,8,6,24,56,117,31]),function(le,e,y,L,o,A,k,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class m{constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=m;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=R,e.NullTelemetryService=new R;class E{async publicLog(a,l,h){}async publicLogError(a,l,h){}}e.NullEndpointTelemetryService=E,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(i,a){return o.Event.debounce(a.onDidChangeConfiguration,(h,C)=>{const D=h?new Set([...h.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:D}},1e3,!0)(h=>{h.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(h.source),configurationKeys:Array.from(h.affectedKeys)})})}e.configurationTelemetry=b;function d(i,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!i.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=d;function g(i,a){return!(a.isBuilt||a.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=g;function p(i){const a=i.getValue(v.TELEMETRY_SETTING_ID),l=i.getValue(v.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(v.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function r(i){const a={},l={},h={};u(i,h);for(let C in h){C=C.length>150?C.substr(C.length-149):C;const D=h[C];typeof D=="number"?l[C]=D:typeof D=="boolean"?l[C]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${D.length}`),a[C]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(a[C]=D)}return{properties:a,measurements:l}}e.validateTelemetryData=r;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(i){if(!i)return"none";const a=(0,k.getRemoteName)(i);return f.has(a)?a:"other"}e.cleanRemoteAuthority=c;function u(i,a,l=0,h){if(i)for(const C of Object.getOwnPropertyNames(i)){const D=i[C],w=h?h+C:C;Array.isArray(D)?a[w]=(0,y.safeStringify)(D):D instanceof Date?a[w]=D.toISOString():(0,L.isObject)(D)?l<2?u(D,a,l+1,w+"."):a[w]=(0,y.safeStringify)(D):a[w]=D}}function I(i,a){const l=i.msftInternalDomains||[],h=a.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(l)||h}e.isInternalTelemetry=I;function O(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=O;function t(i,a){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let l=i;const h=[];for(const S of a)for(;;){const N=S.exec(i);if(!N)break;h.push([N.index,S.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(l="";;){const S=D.exec(i);if(!S)break;const N=h.some(([$,ee])=>S.index<ee&&$<D.lastIndex);!C.test(S[0])&&!N&&(l+=i.substring(w,S.index)+"<REDACTED: user-file-path>",w=D.lastIndex)}return w<i.length&&(l+=i.substr(w)),l}function n(i){if(!i)return i;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of a)if(l.regex.test(i))return`<REDACTED: ${l.label}>`;return i}function s(i,a){return(0,y.cloneAndChange)(i,l=>{if(l instanceof m||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let h=l.replaceAll("%20"," ");h=t(h,a);for(const C of a)h=h.replace(C,"");return h=n(h),h}})}e.cleanData=s}),define(pe[35],be([1,0,17,30,34,3,4,9,29,37]),function(le,e,y,L,o,A,k,T,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,y.compareIgnoreCase)(s.id,i.id)===0}e.areSameExtensions=R;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const a=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,a,l)}static parse(i){const a=E.exec(i);return a&&a[1]&&a[2]?new b({id:a[1]},a[2],a[4]||void 0):null}constructor(i,a,l="undefined"){this.version=a,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?R(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=b;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(s){const i=d.exec(s);return i&&i[1]?[r(i[1]),i[2]]:[r(s),void 0]}e.getIdAndVersion=g;function p(s,i){return`${s}.${i}`}e.getExtensionId=p;function r(s){return s.toLowerCase()}e.adoptToGalleryExtensionId=r;function f(s,i){return r(p(s??o.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=f;function c(s,i){const a=[],l=h=>{for(const C of a)if(C.some(D=>R(i(D),i(h))))return C;return null};for(const h of s){const C=l(h);C?C.push(h):a.push([h])}return a}e.groupByExtension=c;function u(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=u;function I(s){return{id:new m.TelemetryTrustedValue(s.identifier.id),name:new m.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new o.ExtensionIdentifier("pprice.better-merge");function O(s,i){const a=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const h=l.shift();if(h&&a.every(C=>!R(C.identifier,{id:h}))){const C=s.filter(D=>R(D.identifier,{id:h}));C.length===1&&(a.push(C[0]),l.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=O;async function t(s,i){if(!A.isLinux)return!1;let a;try{a=(await s.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await s.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){i.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(h))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(s,i){const a=await t(s,i),l=(0,L.getTargetPlatform)(a?"alpine":A.platform,v.arch);return i.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=n}),define(pe[118],be([1,0,20,9,13,19,53,4,174,30,35,34]),function(le,e,y,L,o,A,k,T,v,m,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const b=r=>(0,v.localize)(0,null,r),d=(0,v.localize)(1,null,"ms-dotnettools.csharp");function g(r,f){return f?`${r.publisher}.${r.name}@${r.version}`:`${r.publisher}.${r.name}`}let p=e.ExtensionManagementCLI=class{constructor(f,c,u){this.a=f,this.b=c,this.d=u}get f(){}async listExtensions(f,c,u){let I=await this.b.getInstalled(1,u);const O=E.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(c&&c!==""){if(O.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}I=I.filter(n=>n.manifest.categories?n.manifest.categories.map(i=>i.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),O.forEach(n=>{this.a.info(n)});return}this.f&&this.a.info((0,v.localize)(2,null,this.f)),I=I.sort((n,s)=>n.identifier.id.localeCompare(s.identifier.id));let t;for(const n of I)t!==n.identifier.id&&(t=n.identifier.id,this.a.info(g(n.manifest,f)))}async installExtensions(f,c,u,I){const O=[];try{const t=[];f.length&&this.a.info(this.f?(0,v.localize)(3,null,this.f):(0,v.localize)(4,null));const n=[];let s=[];const i=(l,h,C)=>{s.push({id:l,version:h!=="prerelease"?h:void 0,installOptions:{...u,isBuiltin:C,installPreReleaseVersion:h==="prerelease"||u.installPreReleaseVersion}})};for(const l of f)if(l instanceof T.URI)n.push({vsix:l,installOptions:u});else{const[h,C]=(0,R.getIdAndVersion)(l);i(h,C,!1)}for(const l of c)if(l instanceof T.URI)n.push({vsix:l,installOptions:{...u,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[h,C]=(0,R.getIdAndVersion)(l);i(h,C,!0)}const a=await this.b.getInstalled(1,u.profileLocation);if(n.length&&await Promise.all(n.map(async({vsix:l,installOptions:h})=>{try{const C=await this.g(l,h,I,a);C&&t.push(C)}catch(C){this.a.error(C),O.push(l.toString())}})),s.length&&(s=s.filter(({id:l,version:h})=>{const C=a.find(D=>(0,R.areSameExtensions)(D.identifier,{id:l}));if(C){if(!I&&(!h||h==="prerelease"&&C.preRelease))return this.a.info((0,v.localize)(5,null,l,C.manifest.version,l)),!1;if(h&&C.manifest.version===h)return this.a.info((0,v.localize)(6,null,`${l}@${h}`)),!1}return!0}),s.length)){const l=await this.h(s);await Promise.all(s.map(async h=>{const C=l.get(h.id.toLowerCase());if(C)try{const D=await this.j(h,C,a);D&&t.push(D)}catch(D){this.a.error(D.message||D.stack||D),O.push(h.id)}else this.a.error(`${b(h.version?`${h.id}@${h.version}`:h.id)}
${d}`),O.push(h.id)}))}}catch(t){throw this.a.error((0,v.localize)(7,null,(0,L.getErrorMessage)(t))),t}if(O.length)throw new Error((0,v.localize)(8,null,O.join(", ")))}async g(f,c,u,I){const O=await this.b.getManifest(f);if(!O)throw new Error("Invalid vsix");if(await this.l(O,u,c.profileLocation,I))try{return await this.b.install(f,c),this.a.info((0,v.localize)(9,null,(0,A.basename)(f))),O}catch(n){if((0,L.isCancellationError)(n))return this.a.info((0,v.localize)(10,null,(0,A.basename)(f))),null;throw n}return null}async h(f){const c=new Map,u=f.some(t=>t.installOptions.installPreReleaseVersion),I=await this.b.getTargetPlatform(),O=[];for(const t of f)m.EXTENSION_IDENTIFIER_REGEX.test(t.id)&&O.push({...t,preRelease:u});if(O.length){const t=await this.d.getExtensions(O,{targetPlatform:I},y.CancellationToken.None);for(const n of t)c.set(n.identifier.id.toLowerCase(),n)}return c}async j({id:f,version:c,installOptions:u},I,O){const t=await this.d.getManifest(I,y.CancellationToken.None);if(t&&!this.k(t))return null;const n=O.find(s=>(0,R.areSameExtensions)(s.identifier,I.identifier));if(n){if(I.version===n.manifest.version)return this.a.info((0,v.localize)(11,null,c?`${f}@${c}`:f)),null;this.a.info((0,v.localize)(12,null,f,I.version))}try{u.isBuiltin?this.a.info(c?(0,v.localize)(13,null,f,c):(0,v.localize)(14,null,f)):this.a.info(c?(0,v.localize)(15,null,f,c):(0,v.localize)(16,null,f));const s=await this.b.installFromGallery(I,{...u,installGivenVersion:!!c});return this.a.info((0,v.localize)(17,null,f,s.manifest.version)),t}catch(s){if((0,L.isCancellationError)(s))return this.a.info((0,v.localize)(18,null,f)),null;throw s}}k(f){return!0}async l(f,c,u,I){if(!c){const O={id:(0,R.getGalleryExtensionId)(f.publisher,f.name)},t=I.find(n=>(0,R.areSameExtensions)(O,n.identifier)&&(0,k.gt)(n.manifest.version,f.version));if(t)return this.a.info((0,v.localize)(19,null,t.identifier.id,t.manifest.version,f.version)),!1}return this.k(f)}async uninstallExtensions(f,c,u){const I=async t=>{if(t instanceof T.URI){const n=await this.b.getManifest(t);return g(n)}return t},O=[];for(const t of f){const n=await I(t),i=(await this.b.getInstalled(void 0,u)).filter(a=>(0,R.areSameExtensions)(a.identifier,{id:n}));if(!i.length)throw new Error(`${this.m(n)}
${d}`);if(i.some(a=>a.type===0)){this.a.info((0,v.localize)(20,null,n));return}if(!c&&i.some(a=>a.isBuiltin)){this.a.info((0,v.localize)(21,null,n));return}this.a.info((0,v.localize)(22,null,n));for(const a of i)await this.b.uninstall(a,{profileLocation:u}),O.push(a);this.f?this.a.info((0,v.localize)(23,null,n,this.f)):this.a.info((0,v.localize)(24,null,n))}}async locateExtension(f){const c=await this.b.getInstalled();f.forEach(u=>{c.forEach(I=>{if(I.identifier.id===u&&I.location.scheme===o.Schemas.file){this.a.info(I.location.fsPath);return}})})}m(f){return this.f?(0,v.localize)(25,null,f,this.f):(0,v.localize)(26,null,f)}};e.ExtensionManagementCLI=p=Le([Ae(1,m.IExtensionManagementService),Ae(2,m.IExtensionGalleryService)],p)}),define(pe[238],be([1,0,6,2,28,35,34]),function(le,e,y,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class T extends L.Disposable{constructor(m,R,E,b,d,g,p){super(),this.f=m,this.g=R,this.h=E,this.i=b,this.j=d,this.k=g,this.l=p,this.a=this.B(new y.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.DisposableMap),this.m().then(null,r=>p.error(r))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(m=>this.p(m.added,m.removed))),this.B(this.i.onAddExtensions(m=>this.r(m))),this.B(this.i.onDidAddExtensions(m=>this.s(m))),this.B(this.i.onRemoveExtensions(m=>this.t(m))),this.B(this.i.onDidRemoveExtensions(m=>this.u(m))),this.B(this.k.onDidFilesChange(m=>this.v(m)))}async p(m,R){try{await Promise.all(R.map(E=>(this.c.deleteAndDispose(E.id),this.z(E.extensionsResource)))),m.length&&await Promise.all(m.map(E=>(this.c.set(E.id,(0,L.combinedDisposable)(this.k.watch(this.j.extUri.dirname(E.extensionsResource)),this.k.watch(E.extensionsResource))),this.y(E.extensionsResource))))}catch(E){throw this.l.error(E),E}}async r(m){for(const R of m.extensions)this.D(this.G(R.identifier,R.version),m.profileLocation)}async s(m){for(const R of m.extensions){const E=this.G(R.identifier,R.version);m.error?this.F(E,m.profileLocation):this.D(E,m.profileLocation)}}async t(m){for(const R of m.extensions)this.F(this.G(R.identifier,R.version),m.profileLocation)}async u(m){const R=[],E=[];for(const b of m.extensions){const d=this.G(b.identifier,b.version);m.error?this.D(d,m.profileLocation):(this.F(d,m.profileLocation),this.b.has(d)||(this.l.debug("Extension is removed from all profiles",b.identifier.id,b.version),E.push(this.f.scanInstalledExtensionAtLocation(b.location).then(g=>{g?R.push(g):this.l.info("Extension not found at the location",b.location.toString())},g=>this.l.error(g)))))}try{await Promise.all(E),R.length&&await this.C(R)}catch(b){this.l.error(b)}}v(m){for(const R of this.h.profiles)m.contains(R.extensionsResource,0,1)&&this.w(R.extensionsResource)}async w(m){const R=[],E=[],b=await this.i.scanProfileExtensions(m),d=new Set,g=new Set;for(const[p,r]of this.b)r.has(m)&&g.add(p);for(const p of b){const r=this.G(p.identifier,p.version);d.add(r),g.has(r)||(R.push(p.identifier),this.D(r,m))}for(const p of g)if(!d.has(p)){const r=this.H(p);r&&(E.push(r.identifier),this.F(p,m))}(R.length||E.length)&&this.a.fire({added:R.length?{extensions:R,profileLocation:m}:void 0,removed:E.length?{extensions:E,profileLocation:m}:void 0})}async y(m){const R=await this.i.scanProfileExtensions(m);for(const E of R)this.D(this.G(E.identifier,E.version),m)}async z(m){for(const R of[...this.b.keys()])this.F(R,m);await this.C()}async C(m){m||(m=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.G(E.identifier,E.manifest.version)))),m.length&&await this.f.markAsUninstalled(...m)}D(m,R){let E=this.b.get(m);E||this.b.set(m,E=new o.ResourceSet(b=>this.j.extUri.getComparisonKey(b))),E.add(R)}F(m,R){const E=this.b.get(m);E&&E.delete(R),E?.size||this.b.delete(m)}G(m,R){return`${k.ExtensionIdentifier.toKey(m.id)}@${R}`}H(m){const[R,E]=(0,A.getIdAndVersion)(m);return E?{identifier:{id:R},version:E}:void 0}}e.ExtensionsWatcher=T}),define(pe[239],be([1,0,207,37]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function o(A,k,T,v,m,R,E){const b={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${k.nameShort})`};if((0,L.supportsTelemetry)(k,T)&&(0,L.getTelemetryLevel)(v)===3){const d=await(0,y.getServiceMachineId)(T,m,R);b["X-Market-User-Id"]=d,b["VSCode-SessionId"]=E.machineId||d}return b}e.resolveMarketplaceHeaders=o}),define(pe[119],be([1,0,85,18,14,2,13,7,23,25,30,35,12,82,4]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let p=e.NativeLanguagePackService=class extends d.LanguagePackBaseService{constructor(u,I,O,t){super(O),this.h=u,this.i=t,this.g=this.B(new r(I,t)),this.h.registerParticipant({postInstall:async n=>this.j(n),postUninstall:async n=>this.k(n)})}async getBuiltInExtensionTranslationsUri(u,I){const t=(await this.g.getLanguagePacks())[I];if(!t){this.i.warn(`No language pack found for ${I}`);return}const n=t.translations[u];return n?g.URI.file(n):void 0}async getInstalledLanguages(){const u=await this.g.getLanguagePacks(),I=Object.keys(u).map(O=>{const t=u[O];return{...this.f(O,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return I.push(this.f("en","English")),I.sort((O,t)=>O.label.localeCompare(t.label)),I}async j(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",u.identifier.id),await this.update())}async k(u){const I=await this.g.getLanguagePacks();Object.keys(I).some(O=>I[O]&&I[O].extensions.some(t=>(0,E.areSameExtensions)(t.extensionIdentifier,u.identifier)))&&(this.i.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,I]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),O=await this.g.update(I);return!(0,L.equals)(Object.keys(u),Object.keys(O))}};e.NativeLanguagePackService=p=Le([Ae(0,R.IExtensionManagementService),Ae(1,m.INativeEnvironmentService),Ae(2,R.IExtensionGalleryService),Ae(3,b.ILogService)],p);let r=class extends A.Disposable{constructor(u,I){super(),this.i=I,this.c={},this.f=(0,T.join)(u.userDataPath,"languagepacks.json"),this.g=new o.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(u){return this.m(I=>{Object.keys(I).forEach(O=>delete I[O]),this.j(I,...u)}).then(()=>this.c)}j(u,...I){for(const O of I)O&&O.manifest&&O.manifest.contributes&&O.manifest.contributes.localizations&&O.manifest.contributes.localizations.length&&this.k(u,O);Object.keys(u).forEach(O=>this.l(u[O]))}k(u,I){const O=I.identifier,t=I.manifest.contributes&&I.manifest.contributes.localizations?I.manifest.contributes.localizations:[];for(const n of t)if(I.location.scheme===k.Schemas.file&&f(n)){let s=u[n.languageId];s||(s={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},u[n.languageId]=s);const i=s.extensions.filter(a=>(0,E.areSameExtensions)(a.extensionIdentifier,O))[0];i?i.version=I.manifest.version:s.extensions.push({extensionIdentifier:O,version:I.manifest.version});for(const a of n.translations)s.translations[a.id]=(0,T.join)(I.location.fsPath,a.path)}}l(u){if(u){const I=(0,y.createHash)("md5");for(const O of u.extensions)I.update(O.extensionIdentifier.uuid||O.extensionIdentifier.id).update(O.version);u.hash=I.digest("hex")}}m(u=()=>null){return this.g.queue(()=>{let I=null;return v.Promises.readFile(this.f,"utf8").then(void 0,O=>O.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(O)).then(O=>{try{return JSON.parse(O)}catch{return{}}}).then(O=>(I=u(O),O)).then(O=>{for(const n of Object.keys(O))O[n]||delete O[n];this.c=O,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),v.Promises.writeFile(this.f,t)}).then(()=>I,O=>this.i.error(O))})}};r=Le([Ae(0,m.INativeEnvironmentService),Ae(1,b.ILogService)],r);function f(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const u of c.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(pe[240],be([1,0,9,22,37]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function T(m,R,E){const b=await new Promise((f,c)=>{le(["@microsoft/1ds-core-js"],f,c)}),d=await new Promise((f,c)=>{le(["@microsoft/1ds-post-js"],f,c)}),g=new b.AppInsightsCore,p=new d.PostChannel,r={instrumentationKey:m,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(E){r.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:E};r.extensionConfig[p.identifier]=f}return g.initialize(r,[]),g.addTelemetryInitializer(f=>{R&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),g}class v{constructor(R,E,b,d,g){this.e=R,this.f=E,this.g=b,this.h=g,this.c=A,this.d=k,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(R){if(this.a){if(typeof this.a!="string"){R(this.a);return}this.b||(this.b=T(this.a,this.e,this.h)),this.b.then(E=>{R(E)},E=>{(0,y.onUnexpectedError)(E),console.error(E)})}}log(R,E){if(!this.a)return;E=(0,L.mixin)(E,this.g),E=(0,o.validateTelemetryData)(E);const b=this.f+"/"+R;try{this.i(d=>{d.pluginVersionString=E?.properties.version??"Unknown",d.track({name:b,baseData:{name:b,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this.a?new Promise(R=>{this.i(E=>{E.unload(!0,()=>{this.a=void 0,R(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=v}),define(pe[241],be([1,0,2,22,3,17,188,24,55,54,27,40,31,37]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=e.TelemetryService=class{constructor(f,c,u){this.k=c,this.l=u,this.d={},this.i=new y.DisposableStore,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const I of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(I),"gi")),I.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(I.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(I=>{(I.affectsConfiguration(b.TELEMETRY_SETTING_ID)||I.affectsConfiguration(b.TELEMETRY_OLD_SETTING_ID)||I.affectsConfiguration(b.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(f,c){this.d[f]=c}m(){let f=(0,d.getTelemetryLevel)(this.k);const c=this.l.enabledTelemetryLevels;if(c){this.h=this.sendErrorTelemetry?c.error:!1;const u=c.usage?3:c.error?2:0;f=Math.min(f,u)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,c,u){this.g<c||(u=(0,L.mixin)(u,this.d),u=(0,d.cleanData)(u,this.j),u=(0,L.mixin)(u,this.c),this.b.forEach(I=>I.log(f,u)))}publicLog(f,c){this.n(f,3,c)}publicLog2(f,c){this.publicLog(f,c)}publicLogError(f,c){this.h&&this.n(f,2,c)}publicLogError2(f,c){this.publicLogError(f,c)}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=g=Le([Ae(1,T.IConfigurationService),Ae(2,R.IProductService)],g);function p(){const r=(0,k.localize)(0,null,m.default.nameLong),f=m.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=o.isWeb?"":(0,k.localize)(3,null),u=(0,k.localize)(4,null),I=(0,k.localize)(5,null),O=(0,k.localize)(6,null),t=(0,k.localize)(7,null),n=`
|       | ${u} | ${I} | ${O} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,k.localize)(8,null);return`
${r} ${f} ${c}

&nbsp;

${t}
${n}

&nbsp;

${s}
`}E.Registry.as(v.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,k.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(v.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,k.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,k.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(pe[242],be([1,0,24,5,27,31,241,37]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let v=e.ServerTelemetryService=class extends k.TelemetryService{constructor(R,E,b,d){super(R,b,d),this.o=E}publicLog(R,E){if(!(this.o<3))return super.publicLog(R,E)}publicLog2(R,E){return this.publicLog(R,E)}publicLogError(R,E){return this.o<2?Promise.resolve(void 0):super.publicLogError(R,E)}publicLogError2(R,E){return this.publicLogError(R,E)}async updateInjectedTelemetryLevel(R){if(R===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,R):R,this.o===0&&this.dispose()}};e.ServerTelemetryService=v=Le([Ae(2,y.IConfigurationService),Ae(3,o.IProductService)],v),e.ServerNullTelemetryService=new class extends T.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,L.refineServiceDecorator)(A.ITelemetryService)}),define(pe[243],be([1,0,244,240]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class o extends L.AbstractOneDataSystemAppender{constructor(k,T,v,m){const R={sendPOST:(E,b)=>{const d={method:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data)}};try{const g=y.request(E.urlString,d,p=>{p.on("data",function(r){b(p.statusCode??200,p.headers,r.toString())}),p.on("error",function(r){b(0,{})})});g.write(E.data),g.end()}catch{b(0,{})}}};super(k,T,v,m,R)}}e.OneDataSystemAppender=o}),define(pe[245],be([1,0,9,235]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class o extends L.default{i(){(0,y.setUnexpectedErrorHandler)(T=>console.error(T));const k=[];process.on("unhandledRejection",(T,v)=>{k.push(v),setTimeout(()=>{const m=k.indexOf(v);m>=0&&v.catch(R=>{k.splice(m,1),(0,y.isCancellationError)(R)||(console.warn(`rejected promise not handled within 1 second: ${R}`),R.stack&&console.warn(`stack trace: ${R.stack}`),T&&(0,y.onUnexpectedError)(T))})},1e3)}),process.on("rejectionHandled",T=>{const v=k.indexOf(T);v>=0&&k.splice(v,1)}),process.on("uncaughtException",T=>{(0,y.isSigPipeError)(T)||(0,y.onUnexpectedError)(T)})}}e.default=o}),define(pe[120],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var y;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(y||(e.EnvironmentVariableMutatorType=y={}))}),define(pe[121],be([1,0,3,120]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const o=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(R){this.collections=R,this.a=new Map,this.b=new Map,R.forEach((E,b)=>{this.d(E,b);const d=E.map.entries();let g=d.next();for(;!g.done;){const p=g.value[1],r=g.value[0];let f=this.a.get(r);if(f||(f=[],this.a.set(r,f)),f.length>0&&f[0].type===L.EnvironmentVariableMutatorType.Replace){g=d.next();continue}const c={extensionIdentifier:b,value:p.value,type:p.type,scope:p.scope,variable:p.variable,options:p.options};c.scope||delete c.scope,f.unshift(c),g=d.next()}})}async applyToProcessEnvironment(R,E,b){let d;y.isWindows&&(d={},Object.keys(R).forEach(g=>d[g.toLowerCase()]=g));for(const[g,p]of this.getVariableMap(E)){const r=y.isWindows&&d[g.toLowerCase()]||g;for(const f of p){const c=b?await b(f.value):f.value;if(f.options?.applyAtProcessCreation??!0)switch(f.type){case L.EnvironmentVariableMutatorType.Append:R[r]=(R[r]||"")+c;break;case L.EnvironmentVariableMutatorType.Prepend:R[r]=c+(R[r]||"");break;case L.EnvironmentVariableMutatorType.Replace:R[r]=c;break}if(f.options?.applyAtShellIntegration??!1){const u=`VSCODE_ENV_${o.get(f.type)}`;R[u]=(R[u]?R[u]+":":"")+g+"="+this.c(c)}}}}c(R){return R.replaceAll(":","\\x3a")}diff(R,E){const b=new Map,d=new Map,g=new Map;if(R.getVariableMap(E).forEach((p,r)=>{const f=this.getVariableMap(E).get(r),c=T(p,f);c&&b.set(r,c)}),this.getVariableMap(E).forEach((p,r)=>{const f=R.getVariableMap(E).get(r),c=T(p,f);c&&g.set(r,c)}),this.getVariableMap(E).forEach((p,r)=>{const f=R.getVariableMap(E).get(r),c=v(p,f);c&&d.set(r,c)}),!(b.size===0&&d.size===0&&g.size===0))return{added:b,changed:d,removed:g}}getVariableMap(R){const E=new Map;return this.a.forEach((b,d)=>{const g=b.filter(p=>k(p,R));g.length>0&&E.set(g[0].variable,g)}),E}getDescriptionMap(R){const E=new Map;return this.b.forEach((b,d)=>{const g=b.filter(p=>k(p,R,!0));g.length>0&&E.set(g[0].extensionIdentifier,g[0].description)}),E}d(R,E){if(!R.descriptionMap)return;const b=R.descriptionMap.entries();let d=b.next();for(;!d.done;){const g=d.value[1],p=d.value[0];let r=this.b.get(p);r||(r=[],this.b.set(p,r));const f={extensionIdentifier:E,scope:g.scope,description:g.description};f.scope||delete f.scope,r.push(f),d=b.next()}}}e.MergedEnvironmentVariableCollection=A;function k(m,R,E=!1){return m.scope?!!(m.scope.workspaceFolder&&R?.workspaceFolder&&m.scope.workspaceFolder.index===R.workspaceFolder.index):E?R===m.scope:!0}function T(m,R){if(!R)return m;const E=new Set;R.forEach(d=>E.add(d.extensionIdentifier));const b=[];return m.forEach(d=>{E.has(d.extensionIdentifier)||b.push(d)}),b.length===0?void 0:b}function v(m,R){if(!R)return;const E=new Map;R.forEach(d=>E.set(d.extensionIdentifier,d));const b=[];return m.forEach(d=>{const g=E.get(d.extensionIdentifier);g&&(d.type!==g.type||d.value!==g.value||d.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index)&&b.push(g)}),b.length===0?void 0:b}}),define(pe[86],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function y(v){return[...v.entries()]}e.serializeEnvironmentVariableCollection=y;function L(v){return v?[...v.entries()]:[]}e.serializeEnvironmentDescriptionMap=L;function o(v){return new Map(v)}e.deserializeEnvironmentVariableCollection=o;function A(v){return new Map(v??[])}e.deserializeEnvironmentDescriptionMap=A;function k(v){return Array.from(v.entries()).map(m=>[m[0],y(m[1].map),L(m[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=k;function T(v){return new Map(v.map(m=>[m[0],{map:o(m[1]),descriptionMap:A(m[2])}]))}e.deserializeEnvironmentVariableCollections=T}),define(pe[246],be([1,0,14,20,6,2,12]),function(le,e,y,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let T=e.RequestStore=class extends A.Disposable{constructor(m,R){super(),this.h=R,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new o.Emitter),this.onCreateRequest=this.g.event,this.b=m===void 0?15e3:m}createRequest(m){return new Promise((R,E)=>{const b=++this.a;this.c.set(b,R),this.g.fire({requestId:b,...m});const d=new L.CancellationTokenSource;(0,y.timeout)(this.b,d.token).then(()=>E(`Request ${b} timed out (${this.b}ms)`)),this.f.set(b,[(0,A.toDisposable)(()=>d.cancel())])})}acceptReply(m,R){const E=this.c.get(m);E?(this.c.delete(m),(0,A.dispose)(this.f.get(m)||[]),this.f.delete(m),E(R)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${m}`)}};e.RequestStore=T=Le([Ae(1,k.ILogService)],T)}),define(pe[122],be([1,0,5,64]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new L.RawContextKey("terminalTabFocusMode",!1,!0);var o;(function(u){u.Shell="terminal.integrated.shell.",u.ShellArgs="terminal.integrated.shellArgs.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(o||(e.TerminalSettingPrefix=o={}));var A;(function(u){u.ShellLinux="terminal.integrated.shell.linux",u.ShellMacOs="terminal.integrated.shell.osx",u.ShellWindows="terminal.integrated.shell.windows",u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationShellLinux="terminal.integrated.automationShell.linux",u.AutomationShellMacOs="terminal.integrated.automationShell.osx",u.AutomationShellWindows="terminal.integrated.automationShell.windows",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ShellArgsLinux="terminal.integrated.shellArgs.linux",u.ShellArgsMacOs="terminal.integrated.shellArgs.osx",u.ShellArgsWindows="terminal.integrated.shellArgs.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.TabStopWidth="terminal.integrated.tabStopWidth",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.TabFocusMode="terminal.integrated.tabFocusMode",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",u.ExperimentalImageSupport="terminal.integrated.experimentalImageSupport",u.SmoothScrolling="terminal.integrated.smoothScrolling"})(A||(e.TerminalSettingId=A={}));var k;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(k||(e.PosixShellType=k={}));var T;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(T||(e.WindowsShellType=T={}));var v;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(v||(e.TitleEventSource=v={}));var m;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.PtyHostWindow="ptyHostWindow",u.Logger="logger",u.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={})),e.IPtyService=(0,y.createDecorator)("ptyService");var R;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(R||(e.ProcessPropertyType=R={}));var E;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E||(e.HeartbeatConstants=E={}));var b;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(b||(e.TerminalLocation=b={}));var d;(function(u){u.TerminalView="view",u.Editor="editor"})(d||(e.TerminalLocationString=d={}));var g;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(g||(e.LocalReconnectConstants=g={}));var p;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var r;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(r||(e.ProfileSource=r={}));var f;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var c;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(c||(e.TerminalExitReason=c={})),e.ILocalPtyService=(0,y.createDecorator)("localPtyService")}),define(pe[247],be([1,0,3]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function L(k){let T=k;T.includes("\\")&&(T=T.replace(/\\/g,"\\\\"));const v=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return T=T.replace(v,""),`'${T}'`}e.escapeNonWindowsPath=L;function o(k,T,v){if(!k)return"";if(!T)return k;T.match(/[\/\\]$/)&&(T=T.slice(0,T.length-1));const m=k.replace(/\\/g,"/").toLowerCase(),R=T.replace(/\\/g,"/").toLowerCase();return m.includes(R)?`~${v}${k.slice(T.length+1)}`:k}e.collapseTildePath=o;function A(k){return k.match(/^['"].*['"]$/)&&(k=k.substring(1,k.length-1)),y.OS===1&&k&&k[1]===":"?k[0].toUpperCase()+k.substring(1):k}e.sanitizeCwd=A}),define(pe[248],be([1,0,48,4,190,98]),function(le,e,y,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function k(b,d){const g=[{name:null,description:(0,o.localize)(0,null)}];return g.push(...b.map(p=>({name:p.profileName,description:T(p)}))),d&&g.push(...d.map(p=>({name:p.title,description:v(p)}))),{values:g.map(p=>p.name),markdownDescriptions:g.map(p=>p.description)}}e.createProfileSchemaEnums=k;function T(b){let d=`$(${A.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:y.Codicon.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?d+=`
- args: "${b.args}"`:d+=`
- args: [${b.args.length===0?"":`'${b.args.join("','")}'`}]`),b.overrideName!==void 0&&(d+=`
- overrideName: ${b.overrideName}`),b.color&&(d+=`
- color: ${b.color}`),b.env&&(d+=`
- env: ${JSON.stringify(b.env)}`),d}function v(b){return`$(${A.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:y.Codicon.terminal.id}) ${b.title}
- extensionIdentifier: ${b.extensionIdentifier}`}function m(b,d){if(!b&&!d)return!0;if(typeof b=="string"&&typeof d=="string")return b===d;if(Array.isArray(b)&&Array.isArray(d)){if(b.length!==d.length)return!1;for(let g=0;g<b.length;g++)if(b[g]!==d[g])return!1;return!0}return!1}e.terminalProfileArgsMatch=m;function R(b,d){if(!b&&!d)return!0;if(!b||!d)return!1;if(A.ThemeIcon.isThemeIcon(b)&&A.ThemeIcon.isThemeIcon(d))return b.id===d.id&&b.color===d.color;if(typeof b=="object"&&"light"in b&&"dark"in b&&typeof d=="object"&&"light"in d&&"dark"in d){const g=b,p=d;if((L.URI.isUri(g.light)||E(g.light))&&(L.URI.isUri(g.dark)||E(g.dark))&&(L.URI.isUri(p.light)||E(p.light))&&(L.URI.isUri(p.dark)||E(p.dark)))return g.light.path===p.light.path&&g.dark.path===p.dark.path}if(L.URI.isUri(b)&&L.URI.isUri(d)||E(b)||E(d)){const g=b,p=d;return g.path===p.path&&g.scheme===p.scheme}return!1}e.terminalIconsEqual=R;function E(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}e.isUriComponents=E}),define(pe[249],be([1,0,48,3,189,55,40,248]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,y.getAllCodicons)(),t=>t.id),markdownEnumDescriptions:Array.from((0,y.getAllCodicons)(),t=>`$(${t.id})`)};const v={args:{description:(0,o.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,o.localize)(1,null),type:"boolean"},icon:{description:(0,o.localize)(2,null),...e.terminalIconSchema},color:{description:(0,o.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,o.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,o.localize)(5,null),type:["string","array"],items:{type:"string"}},...v}},R={type:"object",required:["path"],properties:{path:{description:(0,o.localize)(6,null),type:["string"],items:{type:"string"}},...v}};function E(t){const n=t===2?"linux":t===1?"osx":"windows";return(0,o.localize)(7,null,(0,L.PlatformToString)(t),'```json\n"terminal.integrated.profile.'+n+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const b=(0,o.localize)(8,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),d=(0,o.localize)(9,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),g=(0,o.localize)(10,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,o.localize)(11,null,"`#terminal.integrated.automationProfile.linux#`"),r=(0,o.localize)(12,null,"`#terminal.integrated.automationProfile.osx#`"),f=(0,o.localize)(13,null,"`#terminal.integrated.automationProfile.windows#`"),c={id:"terminal",order:100,title:(0,o.localize)(14,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,o.localize)(15,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,o.localize)(16,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:r},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,o.localize)(17,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,o.localize)(18,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},R],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,o.localize)(19,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},R],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,o.localize)(20,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},R],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,o.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,o.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,o.localize)(23,null),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,o.localize)(24,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,o.localize)(25,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:d},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,o.localize)(26,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,o.localize)(27,null)}},{type:"string",markdownDescription:(0,o.localize)(28,null)}],default:[],markdownDeprecationMessage:g},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:E(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,o.localize)(29,null),enum:["PowerShell","Git Bash"]},...v}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,o.localize)(30,null),type:"string"},id:{description:(0,o.localize)(31,null),type:"string"},title:{description:(0,o.localize)(32,null),type:"string"},...v}},{type:"null"},m]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:E(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,o.localize)(33,null),type:"string"},id:{description:(0,o.localize)(34,null),type:"string"},title:{description:(0,o.localize)(35,null),type:"string"},...v}},{type:"null"},m]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:E(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,o.localize)(36,null),type:"string"},id:{description:(0,o.localize)(37,null),type:"string"},title:{description:(0,o.localize)(38,null),type:"string"},...v}},{type:"null"},m]}},["terminal.integrated.useWslProfiles"]:{description:(0,o.localize)(39,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,o.localize)(40,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,o.localize)(41,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,o.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,o.localize)(43,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){k.Registry.as(A.Extensions.Configuration).registerConfiguration(c),O()}e.registerTerminalPlatformConfiguration=u;let I;function O(t,n){const s=k.Registry.as(A.Extensions.Configuration);let i;t&&(i=(0,T.createProfileSchemaEnums)(t?.profiles,n));const a=I;I={id:"terminal",order:100,title:(0,o.localize)(44,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,o.localize)(45,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:t?.os===3?i?.values:void 0,markdownEnumDescriptions:t?.os===3?i?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,o.localize)(46,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:t?.os===2?i?.values:void 0,markdownEnumDescriptions:t?.os===2?i?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,o.localize)(47,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:t?.os===1?i?.values:void 0,markdownEnumDescriptions:t?.os===1?i?.markdownDescriptions:void 0}}},s.updateConfigurations({add:[I],remove:a?[a]:[]})}e.registerTerminalDefaultProfileConfiguration=O}),define(pe[250],be([1,0,2,13,105,25,107]),function(le,e,y,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodePtyHostStarter=void 0;let T=e.NodePtyHostStarter=class{constructor(m,R){this.a=m,this.b=R}start(m){const R={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:m,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},E=(0,k.parsePtyHostDebugPort)(this.b.args,this.b.isBuilt);E&&(E.break&&E.port?R.debugBrk=E.port:!E.break&&E.port&&(R.debug=E.port));const b=new o.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,R),d=new y.DisposableStore;return d.add(b),{client:b,store:d,onDidProcessExit:b.onDidProcessExit}}};e.NodePtyHostStarter=T=Le([Ae(1,A.IEnvironmentService)],T)}),define(pe[251],be([1,0,26,13,22,7,3,29,17,8,23,120,86,121]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function g(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let a=0;return i&&i.length===4&&(a=parseInt(i[3])),a}e.getWindowsBuildNumber=g;async function p(i,a,l,h=T.env,C=R.Promises.exists){if(A.isAbsolute(i))return await C(i)?i:void 0;if(a===void 0&&(a=T.cwd()),A.dirname(i)!=="."){const N=A.join(a,i);return await C(N)?N:void 0}const w=(0,o.getCaseInsensitive)(h,"PATH");if(l===void 0&&(0,m.isString)(w)&&(l=w.split(A.delimiter)),l===void 0||l.length===0){const N=A.join(a,i);return await C(N)?N:void 0}for(const N of l){let $;if(A.isAbsolute(N)?$=A.join(N,i):$=A.join(a,N,i),await C($))return $;if(k.isWindows){let ee=$+".com";if(await C(ee)||(ee=$+".exe",await C(ee)))return ee}}const S=A.join(a,i);return await C(S)?S:void 0}e.findExecutable=p;function r(i,a,l,h,C){const D=k.isWindows&&(!a.windowsEnableConpty||g()<18309);if(!a.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||D)return;const w=i.args,S=T.platform==="win32"?A.basename(i.executable).toLowerCase():A.basename(i.executable),N=A.dirname(L.FileAccess.asFileUri("").fsPath);let $;const ee={VSCODE_INJECTION:"1"};if(a.shellIntegration.nonce&&(ee.VSCODE_NONCE=a.shellIntegration.nonce),k.isWindows){if(S==="pwsh.exe"||S==="powershell.exe")return!w||n(w)?$=u.get(c.WindowsPwsh):t(w)&&($=u.get(c.WindowsPwshLogin)),$?($=[...$],$[$.length-1]=(0,v.format)($[$.length-1],N,""),{newArgs:$,envMixin:ee}):void 0;h.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(S){case"bash":return!w||w.length===0?$=u.get(c.Bash):s(w)&&(ee.VSCODE_SHELL_LOGIN="1",f(a,ee),$=u.get(c.Bash)),$?($=[...$],$[$.length-1]=(0,v.format)($[$.length-1],N),{newArgs:$,envMixin:ee}):void 0;case"fish":return;case"pwsh":return!w||n(w)?$=u.get(c.Pwsh):t(w)&&($=u.get(c.PwshLogin)),$?($=[...$],$[$.length-1]=(0,v.format)($[$.length-1],N,""),{newArgs:$,envMixin:ee}):void 0;case"zsh":{if(!w||w.length===0?$=u.get(c.Zsh):s(w)?($=u.get(c.ZshLogin),f(a,ee)):(w===u.get(c.Zsh)||w===u.get(c.ZshLogin))&&($=w),!$)return;$=[...$],$[$.length-1]=(0,v.format)($[$.length-1],N);let he;try{he=y.userInfo().username}catch{he="unknown"}const oe=A.join(y.tmpdir(),`${he}-${C.applicationName}-zsh`);ee.ZDOTDIR=oe;const ue=l?.ZDOTDIR??y.homedir()??"~";ee.USER_ZDOTDIR=ue;const me=[];return me.push({source:A.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(oe,".zshrc")}),me.push({source:A.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(oe,".zprofile")}),me.push({source:A.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(oe,".zshenv")}),me.push({source:A.join(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(oe,".zlogin")}),{newArgs:$,envMixin:ee,filesToCopy:me}}}h.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=r;function f(i,a){if(k.isMacintosh&&i.environmentVariableCollections){const l=(0,b.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),C=new d.MergedEnvironmentVariableCollection(l).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),D=[];if(C)for(const w of C)w.type===E.EnvironmentVariableMutatorType.Prepend&&D.push(w.value);D.length>0&&(a.VSCODE_PATH_PREFIX=D.join(""))}}var c;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(c||(c={}));const u=new Map;u.set(c.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),u.set(c.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),u.set(c.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),u.set(c.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),u.set(c.Zsh,["-i"]),u.set(c.ZshLogin,["-il"]),u.set(c.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const I=["-login","-l"],O=["-nol","-nologo"];function t(i){return typeof i=="string"?I.includes(i.toLowerCase()):i.length===1&&I.includes(i[0].toLowerCase())||i.length===2&&(I.includes(i[0].toLowerCase())||I.includes(i[1].toLowerCase()))&&(O.includes(i[0].toLowerCase())||O.includes(i[1].toLowerCase()))}function n(i){return typeof i=="string"?O.includes(i.toLowerCase()):i.length===0||i?.length===1&&O.includes(i[0].toLowerCase())}function s(i){return i==="string"&&I.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&I.includes(i[0].toLowerCase())}}),define(pe[252],be([1,0,51,48,7,3,8,23,101,251,75]),function(le,e,y,L,o,A,k,T,v,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let E,b=!0;function d(i,a,l,h,C=process.env,D,w,S,N){return D=D||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},A.isWindows?g(l,D,C,w,h.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:h.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:h.getValue("terminal.integrated.defaultProfile.windows"),N,S):t(D,w,l,i&&typeof i=="object"?{...i}:h.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:h.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),N,S,C)}e.detectAvailableProfiles=d;async function g(i,a,l,h,C,D,w,S,N){const $=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ee=`${process.env.windir}\\${$?"Sysnative":"System32"}`;let he=!1;(0,m.getWindowsBuildNumber)()>=16299&&(he=!0),await f(S);const oe=new Map;if(i){oe.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),oe.set("Windows PowerShell",{path:`${ee}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),oe.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),oe.set("Command Prompt",{path:`${ee}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0}),oe.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),oe.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:L.Codicon.terminalBash,isAutoDetected:!0});const me=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;oe.set("Cmder",{path:`${ee}\\cmd.exe`,args:["/K",me],requiresPath:process.env.CMDER_ROOT?me:{path:me,isUnsafe:!0},isAutoDetected:!0})}n(D,oe);const ue=await p(oe.entries(),w,a,l,h,N);if(i||C)try{const me=await I(`${ee}\\${he?"wsl":"bash"}.exe`,w);for(const _ of me)(!D||!(_.profileName in D))&&ue.push(_)}catch{b&&(h?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return ue}async function p(i,a,l,h=process.env,C,D){const w=[];for(const[S,N]of i){if(N===null)continue;let $,ee,he;if("source"in N&&!("path"in N)){const _=E?.get(N.source);if(!_)continue;$=_.paths,ee=N.args||_.args,N.icon?he=r(N.icon):_.icon&&(he=_.icon)}else $=Array.isArray(N.path)?N.path:[N.path],ee=A.isWindows||Array.isArray(N.args)?N.args:void 0,he=r(N.icon);let oe;if(D){const _=$.map(q=>typeof q=="string"?q:q.path),re=await D(_);oe=new Array($.length);for(let q=0;q<$.length;q++)typeof $[q]=="string"?oe[q]=re[q]:oe[q]={path:re[q],isUnsafe:!0}}else oe=$.slice();let ue;if(N.requiresPath){let _;if((0,k.isString)(N.requiresPath)?_=N.requiresPath:(_=N.requiresPath.path,N.requiresPath.isUnsafe&&(ue=_)),!await l.existsFile(_))continue}const me=await s(S,a,oe,l,h,ee,N.env,N.overrideName,N.isAutoDetected,ue);me?(me.isAutoDetected=N.isAutoDetected,me.icon=he,me.color=N.color,w.push(me)):C?.debug("Terminal profile not validated",S,$)}return C?.debug("Validated terminal profiles",w),w}function r(i){return typeof i=="string"?{id:i}:i}async function f(i){if(E&&!i)return;const[a,l]=await Promise.all([c(),i||u()]);E=new Map,E.set("Git Bash",{profileName:"Git Bash",paths:a,args:["--login","-i"]}),E.set("PowerShell",{profileName:"PowerShell",paths:l,icon:L.Codicon.terminalPowershell})}async function c(){const i=new Set,a=await(0,m.findExecutable)("git.exe");if(a){const C=(0,R.dirname)(a);i.add((0,R.resolve)(C,"../.."))}function l(C,D){D&&C.add(D)}l(i,process.env.ProgramW6432),l(i,process.env.ProgramFiles),l(i,process.env["ProgramFiles(X86)"]),l(i,`${process.env.LocalAppData}\\Program`);const h=[];for(const C of i)h.push(`${C}\\Git\\bin\\bash.exe`,`${C}\\Git\\usr\\bin\\bash.exe`,`${C}\\usr\\bin\\bash.exe`);return h.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),h}async function u(){const i=[];for await(const a of(0,v.enumeratePowerShellInstallations)())i.push(a.exePath);return i}async function I(i,a){const l=[],h=await new Promise((w,S)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(N,$)=>{if(N)return S("Problem occurred when getting wsl distros");w($)})});if(!h)return[];const C=new RegExp(/[\r?\n]/),D=h.split(C).filter(w=>w.trim().length>0&&w!=="");for(const w of D){if(w===""||w.startsWith("docker-desktop"))continue;const S=`${w} (WSL)`,N={profileName:S,path:i,args:["-d",`${w}`],isDefault:S===a,icon:O(w),isAutoDetected:!1};l.push(N)}return l}function O(i){return i.includes("Ubuntu")?L.Codicon.terminalUbuntu:i.includes("Debian")?L.Codicon.terminalDebian:L.Codicon.terminalLinux}async function t(i,a,l,h,C,D,w,S){const N=new Map;if(l){const $=(await i.readFile("/etc/shells")).toString(),ee=D||$.split(`
`).filter(oe=>oe.trim().includes("#")&&oe.trim().length>0),he=new Map;for(const oe of ee){let ue=(0,o.basename)(oe),me=he.get(ue)||0;me++,me>1&&(ue=`${ue} (${me})`),he.set(ue,me),N.set(ue,{path:oe,isAutoDetected:!0})}}return n(h,N),await p(N.entries(),C,i,S,a,w)}function n(i,a){if(i)for(const[l,h]of Object.entries(i))h===null||typeof h!="object"||!("path"in h)&&!("source"in h)?a.delete(l):(h.icon=h.icon||a.get(l)?.icon,a.set(l,h))}async function s(i,a,l,h,C,D,w,S,N,$){if(l.length===0)return Promise.resolve(void 0);const ee=l.shift();if(ee==="")return s(i,a,l,h,C,D,w,S,N);const he=typeof ee!="string"&&ee.isUnsafe,oe=typeof ee=="string"?ee:ee.path,ue={profileName:i,path:oe,args:D,env:w,overrideName:S,isAutoDetected:N,isDefault:i===a,isUnsafePath:he,requiresUnsafePath:$};if((0,o.basename)(oe)===oe){const _=C.PATH?C.PATH.split(o.delimiter):void 0,re=await(0,m.findExecutable)(oe,void 0,_,void 0,h.existsFile);return re?(ue.path=re,ue.isFromPath=!0,ue):s(i,a,l,h,C,D)}return await h.existsFile((0,o.normalize)(oe))?ue:s(i,a,l,h,C,D,w,S,N)}}),define(pe[253],be([1,0,6,2,3,43,24,12,111,84,246,122,249,252]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let p=0,r=e.PtyHostService=class extends L.Disposable{get c(){return this.g(),this.a}get f(){return this.g(),this.b}g(){this.a||([this.a,this.b]=this.O())}constructor(c,u,I,O){super(),this.G=c,this.H=u,this.I=I,this.J=O,this.i=!1,this.j=0,this.k=!0,this.l=!1,this.p=this.B(new y.Emitter),this.onPtyHostExit=this.p.event,this.r=this.B(new y.Emitter),this.onPtyHostStart=this.r.event,this.s=this.B(new y.Emitter),this.onPtyHostUnresponsive=this.s.event,this.t=this.B(new y.Emitter),this.onPtyHostResponsive=this.t.event,this.u=this.B(new y.Emitter),this.onPtyHostRequestResolveVariables=this.u.event,this.v=this.B(new y.Emitter),this.onProcessData=this.v.event,this.w=this.B(new y.Emitter),this.onProcessReady=this.w.event,this.y=this.B(new y.Emitter),this.onProcessReplay=this.y.event,this.z=this.B(new y.Emitter),this.onProcessOrphanQuestion=this.z.event,this.C=this.B(new y.Emitter),this.onDidRequestDetach=this.C.event,this.D=this.B(new y.Emitter),this.onDidChangeProperty=this.D.event,this.F=this.B(new y.Emitter),this.onProcessExit=this.F.event,(0,b.registerTerminalPlatformConfiguration)(),this.B((0,L.toDisposable)(()=>this.P())),this.h=this.B(new R.RequestStore(void 0,this.I)),this.h.onCreateRequest(this.u.fire,this.u),this.G.onBeforeWindowConnection?y.Event.once(this.G.onBeforeWindowConnection)(()=>this.g()):this.g(),this.G.onWillShutdown?.(()=>this.i=!0)}get L(){return this.H.getValue("terminal.integrated.ignoreProcessNames")}async M(){return this.f.refreshIgnoreProcessNames?.(this.L)}async N(){if(o.isWindows)return process.env;try{return await(0,m.getResolvedShellEnv)(this.H,this.I,{_:[]},process.env)}catch(c){return this.I.error("ptyHost was unable to resolve shell environment",c),{}}}O(){const c=this.G.start(p),u=c.client;this.r.fire(),A.ProxyChannel.toService(u.getChannel(E.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.Q()),this.Q(),this.B(c.onDidProcessExit(t=>{this.p.fire(t.code),!this.i&&!this.l&&(this.j<=g.MaxRestarts?(this.I.error(`ptyHost terminated unexpectedly with code ${t.code}`),this.j++,this.restartPtyHost()):this.I.error(`ptyHost terminated unexpectedly with code ${t.code}, giving up`))}));const O=A.ProxyChannel.toService(u.getChannel(E.TerminalIpcChannels.PtyHost));return this.B(O.onProcessData(t=>this.v.fire(t))),this.B(O.onProcessReady(t=>this.w.fire(t))),this.B(O.onProcessExit(t=>this.F.fire(t))),this.B(O.onDidChangeProperty(t=>this.D.fire(t))),this.B(O.onProcessReplay(t=>this.y.fire(t))),this.B(O.onProcessOrphanQuestion(t=>this.z.fire(t))),this.B(O.onDidRequestDetach(t=>this.C.fire(t))),y.Event.once(y.Event.any(O.onProcessReady,O.onProcessReplay))(()=>{this.B(new v.RemoteLoggerChannelClient(this.J,u.getChannel(E.TerminalIpcChannels.Logger)))}),this.a=c,this.b=O,this.B(this.H.onDidChangeConfiguration(async t=>{t.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.M()})),this.M(),[c,O]}dispose(){this.l=!0,super.dispose()}async createProcess(c,u,I,O,t,n,s,i,a,l,h){const C=setTimeout(()=>this.U(),E.HeartbeatConstants.CreateProcessTimeout),D=await this.f.createProcess(c,u,I,O,t,n,s,i,a,l,h);return clearTimeout(C),p=Math.max(p,D),D}updateTitle(c,u,I){return this.f.updateTitle(c,u,I)}updateIcon(c,u,I,O){return this.f.updateIcon(c,u,I,O)}attachToProcess(c){return this.f.attachToProcess(c)}detachFromProcess(c,u){return this.f.detachFromProcess(c,u)}listProcesses(){return this.f.listProcesses()}reduceConnectionGraceTime(){return this.f.reduceConnectionGraceTime()}start(c){return this.f.start(c)}shutdown(c,u){return this.f.shutdown(c,u)}input(c,u){return this.f.input(c,u)}processBinary(c,u){return this.f.processBinary(c,u)}resize(c,u,I){return this.f.resize(c,u,I)}acknowledgeDataEvent(c,u){return this.f.acknowledgeDataEvent(c,u)}setUnicodeVersion(c,u){return this.f.setUnicodeVersion(c,u)}getInitialCwd(c){return this.f.getInitialCwd(c)}getCwd(c){return this.f.getCwd(c)}getLatency(c){return this.f.getLatency(c)}orphanQuestionReply(c){return this.f.orphanQuestionReply(c)}installAutoReply(c,u){return this.f.installAutoReply(c,u)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(c){return this.f.uninstallAutoReply(c)}getDefaultSystemShell(c){return this.f.getDefaultSystemShell(c)}async getProfiles(c,u,I,O=!1){const t=await this.N();return(0,d.detectAvailableProfiles)(u,I,O,this.H,t,void 0,this.I,this.X.bind(this,c))}getEnvironment(){return this.f.getEnvironment()}getWslPath(c,u){return this.f.getWslPath(c,u)}getRevivedPtyNewId(c){return this.f.getRevivedPtyNewId(c)}setTerminalLayoutInfo(c){return this.f.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return await this.f.getTerminalLayoutInfo(c)}async requestDetachInstance(c,u){return this.f.requestDetachInstance(c,u)}async acceptDetachInstanceReply(c,u){return this.f.acceptDetachInstanceReply(c,u)}async freePortKillProcess(c){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(c)}async serializeTerminalState(c){return this.f.serializeTerminalState(c)}async reviveTerminalProcesses(c,u){return this.f.reviveTerminalProcesses(c,u)}async refreshProperty(c,u){return this.f.refreshProperty(c,u)}async updateProperty(c,u,I){return this.f.updateProperty(c,u,I)}async restartPtyHost(){this.P(),this.k=!0,this.O()}P(){this.f.shutdownAll?.(),this.c.store.dispose()}Q(){this.W(),this.m=setTimeout(()=>this.R(),E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier),this.k||(this.k=!0,this.t.fire())}R(){this.I.warn(`No ptyHost heartbeat after ${E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.m=void 0,this.n=setTimeout(()=>this.S(),E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.SecondWaitMultiplier)}S(){this.I.error(`No ptyHost heartbeat after ${(E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier+E.HeartbeatConstants.BeatInterval*E.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.n=void 0,this.k&&(this.k=!1,this.s.fire())}U(){this.W(),this.I.error(`No ptyHost response to createProcess after ${E.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.k&&(this.k=!1,this.s.fire())}W(){this.m&&(clearTimeout(this.m),this.m=void 0),this.n&&(clearTimeout(this.n),this.n=void 0)}X(c,u){return this.h.createRequest({workspaceId:c,originalText:u})}async acceptPtyHostResolvedVariables(c,u){this.h.acceptReply(c,u)}};e.PtyHostService=r=Le([Ae(1,k.IConfigurationService),Ae(2,T.ILogService),Ae(3,T.ILoggerService)],r)}),define(pe[36],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,y.createDecorator)("IUriIdentityService")}),define(pe[123],be([1,0,36,208,16,19,143,6,2]),function(le,e,y,L,o,A,k,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(b){this.uri=b,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let R=e.UriIdentityService=class{constructor(b){this.g=b,this.c=new v.DisposableStore,this.f=2**16;const d=new Map,g=p=>{let r=d.get(p.scheme);return r===void 0&&(r=b.hasProvider(p)&&!this.g.hasCapability(p,1024),d.set(p.scheme,r)),r};this.c.add(T.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(p=>{d.delete(p.scheme)})),this.extUri=new A.ExtUri(g),this.d=new k.SkipList((p,r)=>this.extUri.compare(p,r,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,A.normalizePath)(b));const d=this.d.get(b);return d?d.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new m(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((g,p)=>g[1].time<p[1].time?1:g[1].time>p[1].time?-1:0);m._clock=0,this.d.clear();const d=this.f*.5;for(let g=0;g<d;g++)this.d.set(b[g][0],b[g][1].touch())}};e.UriIdentityService=R=Le([Ae(0,o.IFileService)],R),(0,L.registerSingleton)(y.IUriIdentityService,R,1)}),define(pe[87],be([1,0,192,7,61,19,4,5,13]),function(le,e,y,L,o,A,k,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function m(i){const a=i;return typeof a?.id=="string"&&k.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=m;function R(i){return typeof i?.id=="string"&&!m(i)&&!b(i)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function E(i,a){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,L.basename)(i)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.toWorkspaceIdentifier=E;function b(i){const a=i;return typeof a?.id=="string"&&k.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=b;function d(i){const a=i;if(a?.uri)return{id:a.id,uri:k.URI.revive(a.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:k.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=d;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function p(i){const a=i;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=p;function r(i){const a=i;return!!(a&&typeof a=="object"&&k.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=r;class f{constructor(a,l,h,C,D){this.h=a,this.j=h,this.k=C,this.l=D,this.c=o.TernarySearchTree.forUris(this.l,()=>!0),this.folders=l}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=o.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class c{constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,A.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function u(i){return new c({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=u,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(i,a){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,a.untitledWorkspacesHome)}e.isUntitledWorkspace=I;function O(i){let a;return k.URI.isUri(i)?a=i:a=i.configuration,a?.scheme===v.Schemas.tmp}e.isTemporaryWorkspace=O,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function n(i,a){return!I(i,a)&&!O(i)}e.isSavedWorkspace=n;function s(i){return(typeof i=="string"?(0,L.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(pe[32],be([1,0,73,6,2,19,4,191,25,16,5,12,87,28,36,14,21,17,8]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function u(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&k.URI.isUri(i.location)&&k.URI.isUri(i.globalStorageHome)&&k.URI.isUri(i.settingsResource)&&k.URI.isUri(i.keybindingsResource)&&k.URI.isUri(i.tasksResource)&&k.URI.isUri(i.snippetsHome)&&k.URI.isUri(i.extensionsResource))}e.isUserDataProfile=u,e.IUserDataProfilesService=(0,R.createDecorator)("IUserDataProfilesService");function I(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:k.URI.revive(s.location).with({scheme:i}),globalStorageHome:k.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:k.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:k.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:k.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:k.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:k.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:k.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.reviveProfile=I;function O(s,i,a,l,h){return{id:s,name:i,location:a,isDefault:!1,shortName:h?.shortName,globalStorageHome:(0,A.joinPath)(a,"globalStorage"),settingsResource:(0,A.joinPath)(a,"settings.json"),keybindingsResource:(0,A.joinPath)(a,"keybindings.json"),tasksResource:(0,A.joinPath)(a,"tasks.json"),snippetsHome:(0,A.joinPath)(a,"snippets"),extensionsResource:(0,A.joinPath)(a,"extensions.json"),cacheHome:(0,A.joinPath)(l,s),useDefaultFlags:h?.useDefaultFlags,isTransient:h?.transient}}e.toUserDataProfile=O;let t=e.UserDataProfilesService=class extends o.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,a,l,h){super(),this.n=i,this.r=a,this.s=l,this.t=h,this.f=!0,this.h=this.B(new L.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new L.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new L.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new L.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,A.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=[];if(this.f)try{for(const C of this.J()){if(!C.name||!(0,c.isString)(C.name)||!C.location){this.t.warn("Skipping the invalid stored profile",C.location||C.name);continue}i.push(O((0,A.basename)(C.location),C.name,C.location,this.g,{shortName:C.shortName,useDefaultFlags:C.useDefaultFlags}))}}catch(C){this.t.error(C)}const a=new d.ResourceMap,l=new Map,h=this.w();if(i.unshift({...h,extensionsResource:this.O()??h.extensionsResource,isDefault:!0}),i.length)try{const C=this.M();if(C.workspaces)for(const[D,w]of Object.entries(C.workspaces)){const S=k.URI.parse(D),N=i.find($=>$.id===w);N&&a.set(S,N)}if(C.emptyWindows)for(const[D,w]of Object.entries(C.emptyWindows)){const S=i.find(N=>N.id===w);S&&l.set(D,S)}}catch(C){this.t.error(C)}this.u={profiles:i,workspaces:a,emptyWindows:l}}return this.u}w(){return O("__default__profile__",(0,T.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(i){const a="Temp",l=new RegExp(`${(0,f.escapeRegExpCharacters)(a)}\\s(\\d+)`);let h=0;for(const D of this.profiles){const w=l.exec(D.name),S=w?parseInt(w[1]):0;h=S>h?S:h}const C=`${a} ${h+1}`;return this.createProfile((0,y.hash)((0,r.generateUuid)()).toString(16),C,{transient:!0},i)}async createNamedProfile(i,a,l){return this.createProfile((0,y.hash)((0,r.generateUuid)()).toString(16),i,a,l)}async createProfile(i,a,l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.y(i,a,l);return h&&await this.setProfileForWorkspace(h,C),C}async y(i,a,l){if(!(0,c.isString)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let h=this.l.get(a);return h||(h=(async()=>{try{const C=this.profiles.find(S=>S.name===a||S.id===i);if(C)return C;const D=O(i,a,(0,A.joinPath)(this.profilesHome,i),this.g,l);await this.r.createFolder(D.location);const w=[];return this.i.fire({profile:D,join(S){w.push(S)}}),await p.Promises.settled(w),this.D([D],[],[]),D}finally{this.l.delete(a)}})(),this.l.set(a,h)),h}async updateProfile(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(h=>h.id===i.id);if(!l)throw new Error(`Profile '${i.name}' does not exist`);return l=O(l.id,a.name??l.name,l.location,this.g,{shortName:a.shortName??l.shortName,transient:a.transient??l.isTransient,useDefaultFlags:a.useDefaultFlags??l.useDefaultFlags}),this.D([],[],[l]),l}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(h=>h.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);const l=[];this.j.fire({profile:a,join(h){l.push(h)}});try{await Promise.allSettled(l)}catch(h){this.t.error(h)}for(const h of[...this.v.emptyWindows.keys()])a.id===this.v.emptyWindows.get(h)?.id&&this.v.emptyWindows.delete(h);for(const h of[...this.v.workspaces.keys()])a.id===this.v.workspaces.get(h)?.id&&this.v.workspaces.delete(h);this.H(),this.D([],[a],[]);try{await this.r.del(a.cacheHome,{recursive:!0})}catch(h){(0,m.toFileOperationResult)(h)!==1&&this.t.error(h)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(a.location,{recursive:!0})}catch(h){this.t.error(h)}}async setProfileForWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(h=>h.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);this.G(i,l)}unsetWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,a)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(a=>a.isDirectory&&this.profiles.every(l=>!this.s.extUri.isEqual(l.location,a.resource))).map(a=>this.r.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(a=>!this.C(a));await Promise.allSettled(i.map(a=>this.removeProfile(a)))}getProfileForWorkspace(i){const a=this.z(i);return k.URI.isUri(a)?this.m.workspaces.get(a)??this.v.workspaces.get(a):this.m.emptyWindows.get(a)??this.v.emptyWindows.get(a)}z(i){return(0,b.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,b.isWorkspaceIdentifier)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.m.workspaces.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.v.emptyWindows.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.v.workspaces.values()].some(a=>this.s.extUri.isEqual(a.location,i.location)))}D(i,a,l){const h=[...this.profiles,...i],C=[];this.m.profiles=[];for(let D of h)D.isDefault||a.some(w=>D.id===w.id)||(D=l.find(w=>D.id===w.id)??D,D.isTransient?this.m.profiles.push(D):C.push({location:D.location,name:D.name,shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}));this.L(C),this.u=void 0,this.F(i,a,l)}F(i,a,l){this.h.fire({added:i,removed:a,updated:l,all:this.profiles})}G(i,a,l){l=a?.isTransient?!0:l,l||this.G(i,void 0,!0);const h=this.z(i),C=l?this.m:this.v;k.URI.isUri(h)?(C.workspaces.delete(h),a&&C.workspaces.set(h,a)):(C.emptyWindows.delete(h),a&&C.emptyWindows.set(h,a)),l||this.H()}H(){const i={};for(const[l,h]of this.v.workspaces.entries())i[l.toString()]=h.id;const a={};for(const[l,h]of this.v.emptyWindows.entries())a[l.toString()]=h.id;this.N({workspaces:i,emptyWindows:a}),this.u=void 0}I(i){const a={},l=this.w();if(i.workspaces)for(const[C,D]of Object.entries(i.workspaces)){const w=k.URI.parse(D);a[C]=this.s.extUri.isEqual(w,l.location)?l.id:this.s.extUri.basename(w)}const h={};if(i.emptyWindows)for(const[C,D]of Object.entries(i.emptyWindows)){const w=k.URI.parse(D);h[C]=this.s.extUri.isEqual(w,l.location)?l.id:this.s.extUri.basename(w)}return{workspaces:a,emptyWindows:h}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",e.UserDataProfilesService=t=Le([Ae(0,v.IEnvironmentService),Ae(1,m.IFileService),Ae(2,g.IUriIdentityService),Ae(3,E.ILogService)],t);class n extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.InMemoryUserDataProfilesService=n}),define(pe[254],be([1,0,18,14,20,9,6,2,3,8,4,172,30,35,34,12,27,31,32]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let u=e.AbstractExtensionManagementService=class extends T.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,a,l,h,C){super(),this.t=i,this.u=a,this.v=l,this.w=h,this.y=C,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new k.Emitter),this.m=this.B(new k.Emitter),this.n=this.B(new k.Emitter),this.p=this.B(new k.Emitter),this.s=[],this.B((0,T.toDisposable)(()=>{this.j.forEach(({task:D})=>D.cancel()),this.k.forEach(D=>D.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const a=await this.getTargetPlatform();return i.allTargetPlatforms.some(l=>(0,b.isTargetPlatformCompatible)(l,i.allTargetPlatforms,a))}async installFromGallery(i,a={}){try{if(!this.t.isEnabled())throw new b.ExtensionManagementError(E.localize(0,null),b.ExtensionManagementErrorCode.Internal);const l=await this.G(i,!!a.installGivenVersion,!!a.installPreReleaseVersion);return await this.z(l.manifest,l.extension,a)}catch(l){throw t(this.u,"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(i),error:l}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(l),O(l)}}async uninstall(i,a={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,a)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,a,l){const h=l.isApplicationScoped||l.isBuiltin||(0,g.isApplicationScopedExtension)(i),C={...l,installOnlyNewlyAddedFromExtensionPack:R.URI.isUri(a)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:h,profileLocation:h?this.y.defaultProfile.extensionsResource:l.profileLocation??this.P()},D=he=>`${d.ExtensionKey.create(he).toString()}${C.profileLocation?`-${C.profileLocation.toString()}`:""}`;if(!R.URI.isUri(a)){const he=this.j.get(D(a));if(he)return this.v.info("Extensions is already requested to install",a.identifier.id),he.task.waitUntilTaskIsFinished()}const w=[],S=[],N=[],$=this.Q(i,a,C);R.URI.isUri(a)||this.j.set(D(a),{task:$,waitingTasks:[]}),this.l.fire({identifier:$.identifier,source:a,profileLocation:C.profileLocation}),this.v.info("Installing extension:",$.identifier.id),w.push({task:$,manifest:i});let ee=!1;try{if(C.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",$.identifier.id);else try{const oe=await this.F($.identifier,i,!!C.installOnlyNewlyAddedFromExtensionPack,!!C.installPreReleaseVersion,C.profileLocation),ue=await this.getInstalled(void 0,C.profileLocation);for(const{gallery:me,manifest:_}of(0,y.distinct)(oe,({gallery:re})=>re.identifier.id)){ee=ee||!!_.extensionDependencies?.some(J=>(0,d.areSameExtensions)({id:J},$.identifier));const re=D(me),q=this.j.get(re);if(q){if(this.C($,q.task)){const J=q.task.identifier;this.v.info("Waiting for already requested installing extension",J.id,$.identifier.id),q.waitingTasks.push($),S.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,U=>U.some(ne=>(0,d.areSameExtensions)(ne.identifier,J)))).then(U=>{if(this.v.info("Finished waiting for already requested installing extension",J.id,$.identifier.id),!U.find(V=>(0,d.areSameExtensions)(V.identifier,J))?.local)throw new Error(`Extension ${J.id} is not installed`)}))}}else if(!ue.some(({identifier:J})=>(0,d.areSameExtensions)(J,me.identifier))){const J=this.Q(_,me,{...C,donotIncludePackAndDependencies:!0});this.j.set(re,{task:J,waitingTasks:[$]}),this.l.fire({identifier:J.identifier,source:me,profileLocation:C.profileLocation}),this.v.info("Installing extension:",J.identifier.id,$.identifier.id),w.push({task:J,manifest:_})}}}catch(oe){if(R.URI.isUri($.source))(0,y.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",$.identifier.id,oe.message),(0,y.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",$.identifier.id,oe.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",$.identifier.id),oe}const he=w.reduce((oe,{task:ue,manifest:me})=>(oe.set(ue.identifier.id.toLowerCase(),{task:ue,manifest:me}),oe),new Map);for(;he.size;){let oe;const ue=[...he.values()].filter(({manifest:me})=>!me.extensionDependencies?.some(_=>he.has(_.toLowerCase())));ue.length?oe=he.size===1?ue:ue.filter(({task:me})=>!(me===$&&!ee)):(this.v.info("Found extensions with circular dependencies",ue.map(({task:me})=>me.identifier.id)),oe=[...he.values()]),await this.D(oe.map(async({task:me})=>{const _=new Date().getTime();try{const re=await me.run();if(await this.D(this.s.map(q=>q.postInstall(re,me.source,C,o.CancellationToken.None))),!R.URI.isUri(me.source)){const q=me.operation===3,J=q?void 0:(new Date().getTime()-me.source.lastUpdated)/1e3;if(t(this.u,q?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(me.source),verificationStatus:me.verificationStatus,duration:new Date().getTime()-_,durationSinceUpdate:J}),v.isWeb&&me.operation!==3)try{await this.t.reportStatistic(re.manifest.publisher,re.manifest.name,re.manifest.version,"install")}catch{}}N.push({local:re,identifier:me.identifier,operation:me.operation,source:me.source,context:C.context,profileLocation:me.profileLocation,applicationScoped:re.isApplicationScoped})}catch(re){throw R.URI.isUri(me.source)||t(this.u,me.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(me.source),verificationStatus:me.verificationStatus,duration:new Date().getTime()-_,error:re}),this.v.error("Error while installing the extension:",me.identifier.id),re}finally{he.delete(me.identifier.id.toLowerCase())}}))}return S.length&&await this.D(S),N.forEach(({identifier:oe})=>this.v.info("Extension installed successfully:",oe.id)),this.m.fire(N),N.filter(({identifier:oe})=>(0,d.areSameExtensions)(oe,$.identifier))[0].local}catch(he){if(w.forEach(({task:oe})=>oe.cancel()),N.length)try{const oe=await Promise.allSettled(N.map(({local:ue})=>this.R(ue,{versionOnly:!0,profileLocation:C.profileLocation}).run()));for(let ue=0;ue<oe.length;ue++){const me=oe[ue],{identifier:_}=N[ue];me.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",_.id):this.v.warn("Rollback: Error while uninstalling extension",_.id,(0,A.getErrorMessage)(me.reason))}}catch(oe){this.v.warn("Error while rolling back extensions",(0,A.getErrorMessage)(oe),N.map(({identifier:ue})=>ue.id))}throw this.m.fire(w.map(({task:oe})=>({identifier:oe.identifier,operation:2,source:oe.source,context:C.context,profileLocation:C.profileLocation}))),he}finally{for(const{task:he}of w)he.source&&!R.URI.isUri(he.source)&&this.j.delete(D(he.source))}}C(i,a){for(const[,{task:l,waitingTasks:h}]of this.j.entries())if(l===i&&(h.includes(a)||h.some(C=>this.C(C,a)))||l===a&&h[0]&&!this.C(i,h[0]))return!1;return!0}async D(i){const a=[],l=[],h=await Promise.allSettled(i);for(const C of h)C.status==="fulfilled"?a.push(C.value):l.push(C.reason);if(l.length)throw I(l);return a}async F(i,a,l,h,C){if(!this.t.isEnabled())return[];const D=await this.getInstalled(void 0,C),w=[],S=[],N=async($,ee)=>{w.push($);const he=ee.extensionDependencies||[],oe=[...he];if(ee.extensionPack){const ue=l?D.find(me=>(0,d.areSameExtensions)(me.identifier,$)):void 0;for(const me of ee.extensionPack)ue&&ue.manifest.extensionPack&&ue.manifest.extensionPack.some(_=>(0,d.areSameExtensions)({id:_},{id:me}))||oe.every(_=>!(0,d.areSameExtensions)({id:_},{id:me}))&&oe.push(me)}if(oe.length){const ue=oe.filter(me=>w.every(_=>!(0,d.areSameExtensions)(_,{id:me})));if(ue.length){const me=await this.t.getExtensions(ue.map(_=>({id:_,preRelease:h})),o.CancellationToken.None);for(const _ of me){if(w.find(J=>(0,d.areSameExtensions)(J,_.identifier)))continue;const re=he.some(J=>(0,d.areSameExtensions)({id:J},_.identifier));let q;try{q=await this.G(_,!1,h)}catch(J){if(J instanceof b.ExtensionManagementError&&J.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!re){this.v.info("Skipping the packed extension as it cannot be installed",_.identifier.id);continue}else throw J}S.push({gallery:q.extension,manifest:q.manifest}),await N(q.extension.identifier,q.manifest)}}}};return await N(i,a),S}async G(i,a,l){if((await this.getExtensionsControlManifest()).malicious.some(w=>(0,d.areSameExtensions)(i.identifier,w)))throw new b.ExtensionManagementError(E.localize(1,null,i.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const w=await this.getTargetPlatform();throw new b.ExtensionManagementError(E.localize(2,null,i.identifier.id,this.w.nameLong,(0,b.TargetPlatformToString)(w)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const C=await this.H(i,a,l);if(C){if(l&&!a&&i.hasPreReleaseVersion&&!C.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(E.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!l&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],o.CancellationToken.None))[0]?new b.ExtensionManagementError(E.localize(4,null,i.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(E.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),b.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",C.identifier.id);const D=await this.t.getManifest(C,o.CancellationToken.None);if(D===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(D.version!==C.version)throw new b.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:C,manifest:D}}async H(i,a,l){const h=await this.getTargetPlatform();let C=null;return!a&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==l&&(C=(await this.t.getExtensions([{...i.identifier,preRelease:l}],{targetPlatform:h,compatible:!0},o.CancellationToken.None))[0]||null),!C&&await this.t.isExtensionCompatible(i,l,h)&&(C=i),C||(a?C=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:h,compatible:!0},o.CancellationToken.None))[0]||null:C=await this.t.getCompatibleExtension(i,l,h)),C}async I(i,a){const l={...a,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},h=$=>`${$.id.toLowerCase()}${l.versionOnly?`-${i.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,C=this.k.get(h(i.identifier));if(C)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),C.waitUntilTaskIsFinished();const D=$=>{const ee=this.R($,l);return this.k.set(h(ee.extension.identifier),ee),l.profileLocation?this.v.info("Uninstalling extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,l.profileLocation.toString()):this.v.info("Uninstalling extension:",`${$.identifier.id}@${$.manifest.version}`),this.n.fire({identifier:$.identifier,profileLocation:l.profileLocation,applicationScoped:$.isApplicationScoped}),ee},w=($,ee)=>{ee?l.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,l.profileLocation.toString(),ee.message):this.v.error("Failed to uninstall extension:",`${$.identifier.id}@${$.manifest.version}`,ee.message):l.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${$.identifier.id}@${$.manifest.version}`,l.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${$.identifier.id}@${$.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,d.getLocalExtensionTelemetryData)($),error:ee}),this.p.fire({identifier:$.identifier,error:ee?.code,profileLocation:l.profileLocation,applicationScoped:$.isApplicationScoped})},S=[],N=[];try{S.push(D(i));const $=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const ee=this.M(i,$);for(const he of ee)this.k.has(h(he.identifier))?this.v.info("Extensions is already requested to uninstall",he.identifier.id):S.push(D(he))}l.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(S.map(ee=>ee.extension),$,i),await this.D(S.map(async ee=>{try{if(await ee.run(),await this.D(this.s.map(he=>he.postUninstall(ee.extension,l,o.CancellationToken.None))),ee.extension.identifier.uuid)try{await this.t.reportStatistic(ee.extension.manifest.publisher,ee.extension.manifest.name,ee.extension.manifest.version,"uninstall")}catch{}w(ee.extension)}catch(he){const oe=he instanceof b.ExtensionManagementError?he:new b.ExtensionManagementError((0,A.getErrorMessage)(he),b.ExtensionManagementErrorCode.Internal);throw w(ee.extension,oe),oe}finally{N.push(ee)}}))}catch($){const ee=$ instanceof b.ExtensionManagementError?$:new b.ExtensionManagementError((0,A.getErrorMessage)($),b.ExtensionManagementErrorCode.Internal);for(const he of S){try{he.cancel()}catch{}N.includes(he)||w(he.extension,ee)}throw ee}finally{for(const $ of S)this.k.delete(h($.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",$.extension.identifier.id)}}J(i,a,l){for(const h of i){const C=this.N(h,a);if(C.length){const D=C.filter(w=>!i.some(S=>(0,d.areSameExtensions)(S.identifier,w.identifier)));if(D.length)throw new Error(this.L(h,D,l))}}}L(i,a,l){return l===i?a.length===1?E.localize(6,null,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(7,null,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(8,null,l.manifest.displayName||l.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?E.localize(9,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?E.localize(10,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):E.localize(11,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}M(i,a,l=[]){if(l.indexOf(i)!==-1)return[];l.push(i);const h=i.manifest.extensionPack?i.manifest.extensionPack:[];if(h.length){const C=a.filter(w=>!w.isBuiltin&&h.some(S=>(0,d.areSameExtensions)({id:S},w.identifier))),D=[];for(const w of C)D.push(...this.M(w,a,l));return[...C,...D]}return[]}N(i,a){return a.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(h=>(0,d.areSameExtensions)({id:h},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};e.AbstractExtensionManagementService=u=Le([Ae(0,b.IExtensionGalleryService),Ae(1,f.ITelemetryService),Ae(2,p.ILogService),Ae(3,r.IProductService),Ae(4,c.IUserDataProfilesService)],u);function I(s){const i=Array.isArray(s)?s:[s];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((a,l)=>new Error(`${a.message}${a.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.joinErrors=I;function O(s){if(s instanceof b.ExtensionManagementError)return s;const i=new b.ExtensionManagementError(s.message,b.ExtensionManagementErrorCode.Internal);return i.stack=s.stack,i}function t(s,i,{extensionData:a,verificationStatus:l,duration:h,error:C,durationSinceUpdate:D}){let w,S;(0,m.isDefined)(l)&&(l===!0?l="Verified":(l===!1||(w=b.ExtensionManagementErrorCode.Signature,S=l),l="Unverified")),C&&(C instanceof b.ExtensionManagementError?(w=C.code,C.code===b.ExtensionManagementErrorCode.Signature&&(S=C.message)):w=b.ExtensionManagementErrorCode.Internal),s.publicLog(i,{...a,verificationStatus:l,success:!C,duration:h,errorcode:w,errorcodeDetail:S,durationSinceUpdate:D})}class n{constructor(){this.d=new L.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,L.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,L.createCancelablePromise)(i=>new Promise((a,l)=>{const h=i.onCancellationRequested(()=>{h.dispose(),l(new A.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=n}),define(pe[45],be([1,0,14,15,2,6,28,4,30,35,16,5,12,32,36,8,9,31]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var c;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(c||(e.ExtensionsProfileScanningErrorCode=c={}));class u extends Error{constructor(s,i){super(s),this.code=i}}e.ExtensionsProfileScanningError=u,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let I=e.AbstractExtensionsProfileScannerService=class extends o.Disposable{constructor(s,i,a,l,h,C){super(),this.i=s,this.j=i,this.k=a,this.l=l,this.m=h,this.n=C,this.b=this.B(new A.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new A.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new k.ResourceMap}scanProfileExtensions(s,i){return this.p(s,void 0,i)}async addExtensionsToProfile(s,i){const a=[],l=[];try{return await this.p(i,h=>{const C=[];for(const D of h)s.some(([w])=>(0,m.areSameExtensions)(w.identifier,D.identifier)&&w.manifest.version!==D.version)?a.push(D):C.push(D);for(const[D,w]of s)if(!C.some(S=>(0,m.areSameExtensions)(S.identifier,D.identifier)&&S.version===D.manifest.version)){const S={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:w};l.push(S),C.push(S)}return l.length&&this.b.fire({extensions:l,profileLocation:i}),a.length&&this.f.fire({extensions:a,profileLocation:i}),C}),l.length&&this.c.fire({extensions:l,profileLocation:i}),a.length&&this.g.fire({extensions:a,profileLocation:i}),l}catch(h){throw l.length&&this.c.fire({extensions:l,error:h,profileLocation:i}),a.length&&this.g.fire({extensions:a,error:h,profileLocation:i}),h}}async updateMetadata(s,i){const a=[];return await this.p(i,l=>{const h=[];for(const C of l){const D=s.find(([w])=>(0,m.areSameExtensions)(w.identifier,C.identifier)&&w.manifest.version===C.version);D&&(C.metadata={...C.metadata,...D[1]},a.push(C)),h.push(C)}return h}),a}async removeExtensionFromProfile(s,i){const a=[];this.f.fire({extensions:a,profileLocation:i});try{await this.p(i,l=>{const h=[];for(const C of l)(0,m.areSameExtensions)(C.identifier,s.identifier)?a.push(C):h.push(C);return a.length&&this.f.fire({extensions:a,profileLocation:i}),h}),a.length&&this.g.fire({extensions:a,profileLocation:i})}catch(l){throw a.length&&this.g.fire({extensions:a,error:l,profileLocation:i}),l}}async p(s,i,a){return this.w(s).queue(async()=>{let l=[],h;try{const C=await this.j.readFile(s);h=JSON.parse(C.value.toString().trim()||"[]")}catch(C){if((0,R.toFileOperationResult)(C)!==1)throw C;if(this.l.extUri.isEqual(s,this.k.defaultProfile.extensionsResource)&&(h=await this.v()),!h&&a?.bailOutWhenFileNotFound)throw new u((0,r.getErrorMessage)(C),"ERROR_PROFILE_NOT_FOUND")}if(h){Array.isArray(h)||this.r(s);let C=!1;for(const D of h){O(D)||this.r(s);let w;if((0,p.isString)(D.relativeLocation)&&D.relativeLocation)w=this.t(D.relativeLocation);else if((0,p.isString)(D.location))w=this.t(D.location),C=!0,D.relativeLocation=D.location,D.location=w.toJSON();else{w=T.URI.revive(D.location);const S=this.s(w);S&&(C=!0,D.relativeLocation=S)}l.push({identifier:D.identifier,location:w,version:D.version,metadata:D.metadata})}C&&await this.j.writeFile(s,L.VSBuffer.fromString(JSON.stringify(h)))}if(i){l=i(l);const C=l.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.s(D.location),metadata:D.metadata}));await this.j.writeFile(s,L.VSBuffer.fromString(JSON.stringify(C)))}return l})}r(s){const i=new u(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(s){return this.l.extUri.isEqual(this.l.extUri.dirname(s),this.i)?this.l.extUri.basename(s):void 0}t(s){return this.l.extUri.joinPath(this.i,s)}async v(){return this.u||(this.u=(async()=>{const s=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let a;try{a=(await this.j.readFile(s)).value.toString()}catch(h){if((0,R.toFileOperationResult)(h)===1)return;throw h}this.n.info("Migrating extensions from old default profile location",s.toString());let l;try{const h=JSON.parse(a);Array.isArray(h)&&h.every(C=>O(C))?l=h:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",h)}catch(h){this.n.error(h)}if(l)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(l)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",s.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(h){if((0,R.toFileOperationResult)(h)===3)this.n.info("Migration from old default profile location to new location is done by another window",s.toString(),this.k.defaultProfile.extensionsResource.toString());else throw h}try{await this.j.del(s)}catch(h){(0,R.toFileOperationResult)(h)!==1&&this.n.error(h)}try{await this.j.del(i)}catch(h){(0,R.toFileOperationResult)(h)!==1&&this.n.error(h)}return l})()),this.u}w(s){let i=this.h.get(s);return i||(i=new y.Queue,this.h.set(s,i)),i}};e.AbstractExtensionsProfileScannerService=I=Le([Ae(1,R.IFileService),Ae(2,d.IUserDataProfilesService),Ae(3,g.IUriIdentityService),Ae(4,f.ITelemetryService),Ae(5,b.ILogService)],I);function O(n){return(0,p.isObject)(n)&&(0,v.isIExtensionIdentifier)(n.identifier)&&(t(n.location)||(0,p.isString)(n.location)&&n.location)&&((0,p.isUndefined)(n.relativeLocation)||(0,p.isString)(n.relativeLocation))&&n.version&&(0,p.isString)(n.version)}function t(n){return n?(0,p.isString)(n.path)&&(0,p.isString)(n.scheme):!1}}),define(pe[57],be([1,0,18,14,22,15,9,72,165,2,13,7,3,19,53,60,8,4,176,25,35,34,77,16,5,12,27,6,49,45,32,36,206]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c,u,I,O,t,n,s,i,a,l,h,C,D,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var N;(function(_){function re(q,J){if(q===J)return!0;const U=Object.keys(q),ne=new Set;for(const V of Object.keys(J))ne.add(V);if(U.length!==ne.size)return!1;for(const V of U){if(q[V]!==J[V])return!1;ne.delete(V)}return ne.size===0}_.equals=re})(N||(e.Translations=N={})),e.IExtensionsScannerService=(0,s.createDecorator)("IExtensionsScannerService");let $=e.AbstractExtensionsScannerService=class extends m.Disposable{constructor(re,q,J,U,ne,V,se,Y,ie,z,P,M){super(),this.systemExtensionsLocation=re,this.userExtensionsLocation=q,this.l=J,this.m=U,this.n=ne,this.r=V,this.s=se,this.t=Y,this.u=ie,this.v=z,this.w=P,this.y=M,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(oe,this.m,this.h)),this.j=this.B(this.y.createInstance(oe,this.m,this.h)),this.k=this.B(this.y.createInstance(he,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,I.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions(re,q,J){const[U,ne]=await Promise.all([this.scanSystemExtensions(re),this.scanUserExtensions(q)]),V=J?await this.scanExtensionsUnderDevelopment(re,[...U,...ne]):[];return this.G(U,ne,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(re){const q=[];q.push(this.H(!!re.useCache,re.language)),q.push(this.I(re.language,!!re.checkControlFile));const[J,U]=await Promise.all(q);return this.F([...J,...U],0,re,!1)}async scanUserExtensions(re){const q=re.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",q);const J=this.w.extUri.isEqual(re.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.L(q,!!re.profileLocation,1,!re.includeUninstalled,re.language,!0,J),ne=re.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k;let V;try{V=await ne.scanExtensions(U)}catch(se){if(se instanceof C.ExtensionsProfileScanningError&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),V=await ne.scanExtensions(U);else throw se}return V=await this.F(V,1,re,!0),this.t.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(re,q){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const J=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(U=>U.scheme===R.Schemas.file).map(async U=>{const ne=await this.L(U,!1,1,!0,re.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(ne)).map(se=>(se.type=q.find(Y=>(0,I.areSameExtensions)(Y.identifier,se.identifier))?.type??se.type,this.k.validate(se,ne)))}))).flat();return this.F(J,"development",re,!0)}return[]}async scanExistingExtension(re,q,J){const U=await this.L(re,!1,q,!0,J.language,!0,void 0),ne=await this.k.scanExtension(U);return!ne||!J.includeInvalid&&!ne.isValid?null:ne}async scanOneOrMultipleExtensions(re,q,J){const U=await this.L(re,!1,q,!0,J.language,!0,void 0),ne=await this.k.scanOneOrMultipleExtensions(U);return this.F(ne,q,J,!0)}async scanMetadata(re){const q=(0,d.joinPath)(re,"package.json"),J=(await this.s.readFile(q)).value.toString();return JSON.parse(J).__metadata}async updateMetadata(re,q){const J=(0,d.joinPath)(re,"package.json"),U=(await this.s.readFile(J)).value.toString(),ne=JSON.parse(U);q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,ne.__metadata={...ne.__metadata,...q},await this.s.writeFile((0,d.joinPath)(re,"package.json"),A.VSBuffer.fromString(JSON.stringify(ne,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(re){if(re instanceof C.ExtensionsProfileScanningError&&re.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw re}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const re=await this.scanUserExtensions({includeInvalid:!0});if(re.length)await this.r.addExtensionsToProfile(re.map(q=>[q,q.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(q){(0,n.toFileOperationResult)(q)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(q))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(re){this.t.error(re)}finally{this.C=void 0}})()),this.C}async F(re,q,J,U){return J.includeAllVersions||(re=this.G(q===0?re:void 0,q===1?re:void 0,q==="development"?re:void 0,await this.getTargetPlatform(),U)),J.includeInvalid||(re=re.filter(ne=>ne.isValid)),re.sort((ne,V)=>{const se=E.basename(ne.location.fsPath),Y=E.basename(V.location.fsPath);return se<Y?-1:se>Y?1:0})}G(re,q,J,U,ne){const V=(Y,ie,z)=>{if(Y.isValid&&!ie.isValid)return!1;if(Y.isValid===ie.isValid){if(ne&&g.gt(Y.manifest.version,ie.manifest.version))return this.t.debug(`Skipping extension ${ie.location.path} with lower version ${ie.manifest.version} in favour of ${Y.location.path} with version ${Y.manifest.version}`),!1;if(g.eq(Y.manifest.version,ie.manifest.version)){if(Y.type===0)return this.t.debug(`Skipping extension ${ie.location.path} in favour of system extension ${Y.location.path} with same version`),!1;if(Y.targetPlatform===U)return this.t.debug(`Skipping extension ${ie.location.path} from different target platform ${ie.targetPlatform}`),!1}}return z?this.t.warn(`Overwriting user extension ${Y.location.path} with ${ie.location.path}.`):this.t.debug(`Overwriting user extension ${Y.location.path} with ${ie.location.path}.`),!0},se=new O.ExtensionIdentifierMap;return re?.forEach(Y=>{const ie=se.get(Y.identifier.id);(!ie||V(ie,Y,!1))&&se.set(Y.identifier.id,Y)}),q?.forEach(Y=>{const ie=se.get(Y.identifier.id);if(!ie&&re&&Y.type===0){this.t.debug(`Skipping obsolete system extension ${Y.location.path}.`);return}(!ie||V(ie,Y,!1))&&se.set(Y.identifier.id,Y)}),J?.forEach(Y=>{const ie=se.get(Y.identifier.id);(!ie||V(ie,Y,!0))&&se.set(Y.identifier.id,Y),se.set(Y.identifier.id,Y)}),[...se.values()]}async H(re,q){this.t.trace("Started scanning system extensions");const J=await this.L(this.systemExtensionsLocation,!1,0,!0,q,!0,void 0),ne=await(re&&!J.devMode?this.i:this.k).scanExtensions(J);return this.t.trace("Scanned system extensions:",ne.length),ne}async I(re,q){const J=this.u.isBuilt?[]:this.v.builtInExtensions;if(!J?.length)return[];this.t.trace("Started scanning dev system extensions");const U=q?await this.J():{},ne=[],V=f.URI.file(E.normalize(E.join(R.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Y of J){const ie=U[Y.name]||"marketplace";switch(ie){case"disabled":break;case"marketplace":ne.push((0,d.joinPath)(V,Y.name));break;default:ne.push(f.URI.file(ie));break}}const se=await Promise.all(ne.map(async Y=>this.k.scanExtension(await this.L(Y,!1,0,!0,re,!0,void 0))));return this.t.trace("Scanned dev system extensions:",se.length),(0,y.coalesce)(se)}async J(){try{const re=await this.s.readFile(this.l);return JSON.parse(re.value.toString())}catch{return{}}}async L(re,q,J,U,ne,V,se){const Y=await this.f(ne??b.language),ie=await this.M(re),z=q&&!this.w.extUri.isEqual(re,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,P=z?await this.M(z):void 0;return new ee(re,ie,z,P,q,se,J,U,V,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,ne,Y)}async M(re){try{const q=await this.s.stat(re);if(typeof q.mtime=="number")return q.mtime}catch{}}};e.AbstractExtensionsScannerService=$=Le([Ae(4,D.IUserDataProfilesService),Ae(5,C.IExtensionsProfileScannerService),Ae(6,n.IFileService),Ae(7,i.ILogService),Ae(8,u.IEnvironmentService),Ae(9,a.IProductService),Ae(10,w.IUriIdentityService),Ae(11,s.IInstantiationService)],$);class ee{constructor(re,q,J,U,ne,V,se,Y,ie,z,P,M,K,te,j){this.location=re,this.mtime=q,this.applicationExtensionslocation=J,this.applicationExtensionslocationMtime=U,this.profile=ne,this.profileScanOptions=V,this.type=se,this.excludeObsolete=Y,this.validate=ie,this.productVersion=z,this.productDate=P,this.productCommit=M,this.devMode=K,this.language=te,this.translations=j}static createNlsConfiguration(re){return{language:re.language,pseudo:re.language==="pseudo",devMode:re.devMode,translations:re.translations}}static equals(re,q){return(0,d.isEqual)(re.location,q.location)&&re.mtime===q.mtime&&(0,d.isEqual)(re.applicationExtensionslocation,q.applicationExtensionslocation)&&re.applicationExtensionslocationMtime===q.applicationExtensionslocationMtime&&re.profile===q.profile&&o.equals(re.profileScanOptions,q.profileScanOptions)&&re.type===q.type&&re.excludeObsolete===q.excludeObsolete&&re.validate===q.validate&&re.productVersion===q.productVersion&&re.productDate===q.productDate&&re.productCommit===q.productCommit&&re.devMode===q.devMode&&re.language===q.language&&N.equals(re.translations,q.translations)}}e.ExtensionScannerInput=ee;let he=class extends m.Disposable{constructor(re,q,J,U,ne){super(),this.f=re,this.g=q,this.h=J,this.i=U,this.j=ne}async scanExtensions(re){const q=re.profile?await this.l(re):await this.k(re);let J={};if(re.excludeObsolete&&re.type===1)try{const U=(await this.i.readFile(this.f)).value.toString();J=JSON.parse(U)}catch{}return(0,r.isEmptyObject)(J)?q:q.filter(U=>!J[I.ExtensionKey.create(U).toString()])}async k(re){const q=await this.i.resolve(re.location);if(!q.children?.length)return[];const J=await Promise.all(q.children.map(async U=>{if(!U.isDirectory||re.type===1&&(0,d.basename)(U.resource).indexOf(".")===0)return null;const ne=new ee(U.resource,re.mtime,re.applicationExtensionslocation,re.applicationExtensionslocationMtime,re.profile,re.profileScanOptions,re.type,re.excludeObsolete,re.validate,re.productVersion,re.productDate,re.productCommit,re.devMode,re.language,re.translations);return this.scanExtension(ne)}));return(0,y.coalesce)(J).sort((U,ne)=>U.location.path<ne.location.path?-1:1)}async l(re){let q=await this.m(re.location,()=>!0,re);if(re.applicationExtensionslocation&&!this.h.extUri.isEqual(re.location,re.applicationExtensionslocation)){q=q.filter(U=>!U.metadata?.isApplicationScoped);const J=await this.m(re.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,re);q.push(...J)}return q}async m(re,q,J){const U=await this.g.scanProfileExtensions(re,J.profileScanOptions);if(!U.length)return[];const ne=await Promise.all(U.map(async V=>{if(q(V)){const se=new ee(V.location,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(se,V.metadata)}return null}));return(0,y.coalesce)(ne)}async scanOneOrMultipleExtensions(re){try{if(await this.i.exists((0,d.joinPath)(re.location,"package.json"))){const q=await this.scanExtension(re);return q?[q]:[]}else return await this.scanExtensions(re)}catch(q){return this.j.error(`Error scanning extensions at ${re.location.path}:`,(0,k.getErrorMessage)(q)),[]}}async scanExtension(re,q){try{let J=await this.scanExtensionManifest(re.location);if(J){J.publisher||(J.publisher=O.UNDEFINED_PUBLISHER),q=q??J.__metadata,delete J.__metadata;const U=(0,I.getGalleryExtensionId)(J.publisher,J.name),ne=q?.id?{id:U,uuid:q.id}:{id:U},V=q?.isSystem?0:re.type,se=V===0||!!q?.isBuiltin;J=await this.n(re.location,J,ee.createNlsConfiguration(re));const Y={type:V,identifier:ne,manifest:J,location:re.location,isBuiltin:se,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return re.validate?this.validate(Y,re):Y}}catch(J){re.type!==0&&this.j.error(J)}return null}validate(re,q){let J=!0;const U=(0,t.validateExtensionManifest)(q.productVersion,q.productDate,q.location,re.manifest,re.isBuiltin);for(const[ne,V]of U)ne===p.default.Error&&(J=!1,this.j.error(this.u(q.location,V)));return re.isValid=J,re.validations=U,re}async scanExtensionManifest(re){const q=(0,d.joinPath)(re,"package.json");let J;try{J=(await this.i.readFile(q)).value.toString()}catch(ne){return(0,n.toFileOperationResult)(ne)!==1&&this.j.error(this.u(re,(0,c.localize)(0,null,q.path,ne.message))),null}let U;try{U=JSON.parse(J)}catch{const V=[];(0,T.parse)(J,V);for(const se of V)this.j.error(this.u(re,(0,c.localize)(1,null,q.path,se.offset,se.length,(0,v.getParseErrorMessage)(se.error))));return null}return(0,T.getNodeType)(U)!=="object"?(this.j.error(this.u(re,(0,c.localize)(2,null,q.path))),null):U}async n(re,q,J){const U=await this.r(re,q,J);if(U)try{const ne=[],V=await this.s(U.default,ne);if(ne.length>0)return ne.forEach(Y=>{this.j.error(this.u(re,(0,c.localize)(3,null,U.default?.path,(0,v.getParseErrorMessage)(Y.error))))}),q;if((0,T.getNodeType)(U)!=="object")return this.j.error(this.u(re,(0,c.localize)(4,null,U.default?.path))),q;const se=U.values||Object.create(null);return(0,S.localizeManifest)(q,se,V)}catch{}return q}async r(re,q,J){const U=(0,d.joinPath)(re,"package.nls.json"),ne=(ie,z)=>{z.forEach(P=>{this.j.error(this.u(re,(0,c.localize)(5,null,ie?.path,(0,v.getParseErrorMessage)(P.error))))})},V=ie=>{this.j.error(this.u(re,(0,c.localize)(6,null,ie?.path)))},se=`${q.publisher}.${q.name}`,Y=J.translations[se];if(Y)try{const ie=f.URI.file(Y),z=(await this.i.readFile(ie)).value.toString(),P=[],M=(0,T.parse)(z,P);return P.length>0?(ne(ie,P),{values:void 0,default:U}):(0,T.getNodeType)(M)!=="object"?(V(ie),{values:void 0,default:U}):{values:M.contents?M.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.i.exists(U))return;let z;try{z=await this.t(re,J)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const P=(await this.i.readFile(z.localized)).value.toString(),M=[],K=(0,T.parse)(P,M);return M.length>0?(ne(z.localized,M),{values:void 0,default:z.original}):(0,T.getNodeType)(K)!=="object"?(V(z.localized),{values:void 0,default:z.original}):{values:K,default:z.original}}catch{return{values:void 0,default:z.original}}}}async s(re,q){if(re)try{const J=(await this.i.readFile(re)).value.toString();return(0,T.parse)(J,q)}catch{}}t(re,q){return new Promise((J,U)=>{const ne=V=>{const se=(0,d.joinPath)(re,`package.nls.${V}.json`);this.i.exists(se).then(Y=>{Y&&J({localized:se,original:(0,d.joinPath)(re,"package.nls.json")});const ie=V.lastIndexOf("-");ie===-1?J({localized:(0,d.joinPath)(re,"package.nls.json"),original:null}):(V=V.substring(0,ie),ne(V))})};if(q.devMode||q.pseudo||!q.language)return J({localized:(0,d.joinPath)(re,"package.nls.json"),original:null});ne(q.language)})}u(re,q){return`[${re.path}]: ${q}`}};he=Le([Ae(1,C.IExtensionsProfileScannerService),Ae(2,w.IUriIdentityService),Ae(3,n.IFileService),Ae(4,i.ILogService)],he);let oe=class extends he{constructor(re,q,J,U,ne,V,se){super(q,U,ne,V,se),this.z=re,this.C=J,this.w=this.B(new L.ThrottledDelayer(3e3)),this.y=this.B(new l.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions(re){const q=this.H(re),J=await this.D(q);if(this.v=re,J&&J.input&&ee.equals(J.input,this.v))return this.j.debug("Using cached extensions scan result",re.location.toString()),this.w.trigger(()=>this.G()),J.result.map(ne=>(ne.location=f.URI.revive(ne.location),ne));const U=await super.scanExtensions(re);return await this.F(q,{input:re,result:U}),U}async D(re){try{const q=await this.i.readFile(re),J=JSON.parse(q.value.toString());return{result:J.result,input:(0,h.revive)(J.input)}}catch(q){this.j.debug("Error while reading the extension cache file:",re.path,(0,k.getErrorMessage)(q))}return null}async F(re,q){try{await this.i.writeFile(re,A.VSBuffer.fromString(JSON.stringify(q)))}catch(J){this.j.debug("Error while writing the extension cache file:",re.path,(0,k.getErrorMessage)(J))}}async G(){if(!this.v)return;const re=this.H(this.v),q=await this.D(re);if(!q)return;const J=q.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!o.equals(U,J))try{this.j.info("Invalidating Cache",J,U),await this.i.del(re),this.y.fire()}catch(ne){this.j.error(ne)}}H(re){const q=this.I(re);return this.h.extUri.joinPath(q.cacheHome,re.type===0?O.BUILTIN_MANIFEST_CACHE_FILE:O.USER_MANIFEST_CACHE_FILE)}I(re){return re.type===0?this.C.defaultProfile:re.profile?this.h.extUri.isEqual(re.location,this.z.extensionsResource)?this.z:this.C.profiles.find(q=>this.h.extUri.isEqual(re.location,q.extensionsResource))??this.z:this.C.defaultProfile}};oe=Le([Ae(2,D.IUserDataProfilesService),Ae(3,C.IExtensionsProfileScannerService),Ae(4,w.IUriIdentityService),Ae(5,n.IFileService),Ae(6,i.ILogService)],oe);function ue(_,re){const q=(0,I.getExtensionId)(_.manifest.publisher,_.manifest.name);return{id:q,identifier:new O.ExtensionIdentifier(q),isBuiltin:_.type===0,isUserBuiltin:_.type===1&&_.isBuiltin,isUnderDevelopment:re,extensionLocation:_.location,uuid:_.identifier.uuid,targetPlatform:_.targetPlatform,..._.manifest}}e.toExtensionDescription=ue;class me extends ${constructor(re,q,J,U,ne,V,se,Y,ie,z,P,M){super(re,q,(0,d.joinPath)(J,".vscode-oss-dev","extensions","control.json"),U,ne,V,se,Y,ie,z,P,M),this.N=(async()=>{if(b.translationsConfigFile)try{const K=await this.s.readFile(f.URI.file(b.translationsConfigFile));return JSON.parse(K.value.toString())}catch{}return Object.create(null)})()}f(re){return this.N}}e.NativeExtensionsScannerService=me}),define(pe[255],be([1,0,51,14,39,6,2,13,7,23,12,32]),function(le,e,y,L,o,A,k,T,v,m,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let b=e.ExtensionsLifecycle=class extends k.Disposable{constructor(g,p){super(),this.b=g,this.f=p,this.a=new L.Limiter(5)}async postUninstall(g){const p=this.g(g,"uninstall");p&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(r){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(r)}}));try{await m.Promises.rm(this.j(g))}catch(r){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(r)}}g(g,p){const r=`vscode:${p}`;if(g.location.scheme===T.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[r]=="string"){const f=g.manifest.scripts[r].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${r} should be a node script`),null):{script:(0,v.join)(g.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(g,p,r,f,c){return new Promise((u,I)=>{const O=this.i(g,p,r,c);let t;const n=s=>{t&&(clearTimeout(t),t=null),s?I(s):u(void 0)};O.on("error",s=>{n((0,o.toErrorMessage)(s)||"Unknown")}),O.on("exit",(s,i)=>{n(s?`post-${p} process exited with code ${s}`:void 0)}),f&&(t=setTimeout(()=>{t=null,O.kill(),I("timed out")},5e3))})}i(g,p,r,f){const c={silent:!0,execArgv:void 0},u=(0,y.fork)(g,[`--type=extension-post-${p}`,...r],c);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const I=A.Event.fromNodeEventEmitter(u.stdout,"data"),O=A.Event.fromNodeEventEmitter(u.stderr,"data");I(s=>this.f.info(f.identifier.id,f.manifest.version,`post-${p}`,s)),O(s=>this.f.error(f.identifier.id,f.manifest.version,`post-${p}`,s));const t=A.Event.any(A.Event.map(I,s=>({data:`%c${s}`,format:[""]})),A.Event.map(O,s=>({data:`%c${s}`,format:["color: red"]})));return A.Event.debounce(t,(s,i)=>s?{data:s.data+i.data,format:[...s.format,...i.format]}:{data:i.data,format:i.format},100)(s=>{console.group(f.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),u}j(g){return(0,v.join)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=b=Le([Ae(0,E.IUserDataProfilesService),Ae(1,R.ILogService)],b)}),define(pe[124],be([1,0,12,32,36,31,45,16,25,4]),function(le,e,y,L,o,A,k,T,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let R=e.ExtensionsProfileScannerService=class extends k.AbstractExtensionsProfileScannerService{constructor(b,d,g,p,r,f){super(m.URI.file(b.extensionsPath),d,g,p,r,f)}};e.ExtensionsProfileScannerService=R=Le([Ae(0,v.INativeEnvironmentService),Ae(1,T.IFileService),Ae(2,L.IUserDataProfilesService),Ae(3,o.IUriIdentityService),Ae(4,A.ITelemetryService),Ae(5,y.ILogService)],R)}),define(pe[256],be([1,0,14,6,2,42,8,156,5,32]),function(le,e,y,L,o,A,k,T,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,v.createDecorator)("storageService");var R;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var E;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var b;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function d(c){const u=c.get(e.TARGET_KEY);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.loadKeyTargets=d;class g extends o.Disposable{constructor(u={flushInterval:g.a}){super(),this.j=u,this.b=this.B(new L.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new L.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new y.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new o.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,y.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,o.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(u,I){if(I===e.TARGET_KEY){switch(u){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:u})}else this.b.fire({scope:u,key:I,target:this.F(u)[I]})}r(u){this.f.fire({reason:u})}get(u,I,O){return this.L(I)?.get(u,O)}getBoolean(u,I,O){return this.L(I)?.getBoolean(u,O)}getNumber(u,I,O){return this.L(I)?.getNumber(u,O)}getObject(u,I,O){return this.L(I)?.getObject(u,O)}store(u,I,O,t){if((0,k.isUndefinedOrNull)(I)){this.remove(u,O);return}this.t(()=>{this.u(u,O,t),this.L(O)?.set(u,I)})}remove(u,I){this.t(()=>{this.u(u,I,void 0),this.L(I)?.delete(u)})}t(u){this.b.pause(),this.c.pause();try{u()}finally{this.b.resume(),this.c.resume()}}keys(u,I){const O=[],t=this.F(u);for(const n of Object.keys(t))t[n]===I&&O.push(n);return O}u(u,I,O){const t=this.F(I);typeof O=="number"?t[u]!==O&&(t[u]=O,this.L(I)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[u]=="number"&&(delete t[u],this.L(I)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(u){switch(u){case-1:return this.D;case 0:return this.z;default:return this.w}}G(u){const I=this.L(u);return I?d(I):Object.create(null)}isNew(u){return this.getBoolean(e.IS_NEW_KEY,u)===!0}async flush(u=R.NONE){this.f.fire({reason:u});const I=this.L(-1),O=this.L(0),t=this.L(1);switch(u){case R.NONE:await y.Promises.settled([I?.whenFlushed()??Promise.resolve(),O?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await y.Promises.settled([I?.flush(0)??Promise.resolve(),O?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.L(-1)?.items??new Map,I=this.L(0)?.items??new Map,O=this.L(1)?.items??new Map;return f(u,I,O,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(u,I){return this.r(R.NONE),(0,m.isUserDataProfile)(u)?this.N(u,I):this.O(u,I)}H(u,I){return!(u.id===I.id||p(I)&&p(u))}I(u,I,O,t){this.t(()=>{if(t)for(const[n,s]of u)I.set(n,s);else{const n=new Set;for(const[s,i]of u)n.add(s),I.get(s)!==i&&this.n(O,s);for(const[s]of I.items)n.has(s)||this.n(O,s)}})}}e.AbstractStorageService=g,g.a=60*1e3;function p(c){return c.isDefault||!!c.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class r extends g{constructor(){super(),this.p=this.B(new T.Storage(new T.InMemoryStorageDatabase,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new T.Storage(new T.InMemoryStorageDatabase,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new T.Storage(new T.InMemoryStorageDatabase,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(u=>this.n(1,u))),this.B(this.P.onDidChangeStorage(u=>this.n(0,u))),this.B(this.p.onDidChangeStorage(u=>this.n(-1,u)))}L(u){switch(u){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(u){return!1}}e.InMemoryStorageService=r;async function f(c,u,I,O,t,n){const s=N=>{try{return JSON.parse(N)}catch{return N}},i=new Map,a=new Map;c.forEach((N,$)=>{i.set($,N),a.set($,s(N))});const l=new Map,h=new Map;u.forEach((N,$)=>{l.set($,N),h.set($,s(N))});const C=new Map,D=new Map;I.forEach((N,$)=>{C.set($,N),D.set($,s(N))}),console.group(O!==t?`Storage: Application (path: ${O})`:`Storage: Application & Profile (path: ${O}, default profile)`);const w=[];if(i.forEach((N,$)=>{w.push({key:$,value:N})}),console.table(w),console.groupEnd(),console.log(a),O!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const N=[];l.forEach(($,ee)=>{N.push({key:ee,value:$})}),console.table(N),console.groupEnd(),console.log(h)}console.group(`Storage: Workspace (path: ${n})`);const S=[];C.forEach((N,$)=>{S.push({key:$,value:N})}),console.table(S),console.groupEnd(),console.log(D)}e.logStorage=f}),define(pe[125],be([1,0,18,20,9,3,29,8,4,24,25,30,35,77,16,12,27,44,239,256,31]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c,u,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const O=A.isWeb?"web":(0,E.getTargetPlatform)(A.platform,k.arch),t="X-Market-Search-Activity-Id";var n;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished",z[z.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...z){return String(z.reduce((P,M)=>P|M,0))}var i;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},C={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class D{constructor(P=C){this.d=P}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(P,M=this.d.pageSize){return new D({...this.d,pageNumber:P,pageSize:M})}withFilter(P,...M){const K=[...this.d.criteria,...M.length?M.map(te=>({filterType:P,value:te})):[{filterType:P}]];return new D({...this.d,criteria:K})}withSortBy(P){return new D({...this.d,sortBy:P})}withSortOrder(P){return new D({...this.d,sortOrder:P})}withFlags(...P){return new D({...this.d,flags:P.reduce((M,K)=>M|K,0)})}withAssetTypes(...P){return new D({...this.d,assetTypes:P})}withSource(P){return new D({...this.d,source:P})}get raw(){const{criteria:P,pageNumber:M,pageSize:K,sortBy:te,sortOrder:j,flags:W,assetTypes:x}=this.d;return{filters:[{criteria:P,pageNumber:M,pageSize:K,sortBy:te,sortOrder:j}],assetTypes:x,flags:W}}get searchText(){const P=this.d.criteria.filter(M=>M.filterType===i.SearchText)[0];return P&&P.value?P.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(P=>String(P.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function w(z,P){const M=(z||[]).filter(K=>K.statisticName===P)[0];return M?M.value:0}function S(z){const P="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(K=>K.assetType.indexOf(P)===0).reduce((K,te)=>{const j=ee(z,te.assetType);return j&&K.push([te.assetType.substring(P.length),j]),K},[])}function N(z){if(z.properties){const P=z.properties.filter(te=>te.key===a.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),K=P.filter(te=>M.test(te.value))[0];return K?{uri:K.value,fallbackUri:K.value}:null}return ee(z,a.Repository)}function $(z){return{uri:`${z.fallbackAssetUri}/${a.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${a.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function ee(z,P){return z.files.filter(K=>K.assetType===P)[0]?{uri:`${z.assetUri}/${P}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${P}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}:null}function he(z,P){const M=z.properties?z.properties.filter(te=>te.key===P):[],K=M.length>0&&M[0].value;return K?K.split(",").map(te=>(0,b.adoptToGalleryExtensionId)(te)):[]}function oe(z){const P=z.properties?z.properties.filter(M=>M.key===l.Engine):[];return P.length>0&&P[0].value||""}function ue(z){const P=z.properties?z.properties.filter(M=>M.key===l.PreRelease):[];return P.length>0&&P[0].value==="true"}function me(z){const P=z.properties?z.properties.filter(K=>K.key===l.LocalizedLanguages):[],M=P.length>0&&P[0].value||"";return M?M.split(","):[]}function _(z){return z.properties?.find(P=>P.key===l.SponsorLink)?.value}function re(z){return z.indexOf("preview")!==-1}function q(z){return z.targetPlatform?(0,E.toTargetPlatform)(z.targetPlatform):"undefined"}function J(z){const P=(0,y.distinct)(z.versions.map(q)),M=!!z.tags?.includes(E.WEB_EXTENSION_TAG),K=P.indexOf("web");return M?K===-1&&P.push("web"):K!==-1&&P.splice(K,1),P}function U(z,P){const M=(0,E.getFallbackTargetPlarforms)(P);for(let K=0;K<z.length;K++){const te=z[K];if(te.version===z[K-1]?.version){let j=K;const W=q(te);if(W===P)for(;j>0&&z[j-1].version===te.version;)j--;else if(M.includes(W))for(;j>0&&z[j-1].version===te.version&&q(z[j-1])!==P;)j--;j!==K&&(z.splice(K,1),z.splice(j,0,te))}}return z}e.sortExtensionVersions=U;function ne(z,P,M){z.telemetryData={index:P,querySource:M,queryActivityId:z.queryContext?.[t]}}function V(z,P,M,K){const te=z.versions[0],j={manifest:ee(P,a.Manifest),readme:ee(P,a.Details),changelog:ee(P,a.Changelog),license:ee(P,a.License),repository:N(P),download:$(P),icon:ee(P,a.Icon),signature:ee(P,a.Signature),coreTranslations:S(P)};return{identifier:{id:(0,b.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:P.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,publisherDomain:z.publisher.domain?{link:z.publisher.domain,verified:!!z.publisher.isDomainVerified}:void 0,publisherSponsorLink:_(te),description:z.shortDescription||"",installCount:w(z.statistics,"install"),rating:w(z.statistics,"averagerating"),ratingCount:w(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:M,assets:j,properties:{dependencies:he(P,l.Dependency),extensionPack:he(P,l.ExtensionPack),engine:oe(P),localizedLanguages:me(P),targetPlatform:q(P),isPreReleaseVersion:ue(P)},hasPreReleaseVersion:ue(te),hasReleaseVersion:!0,preview:re(z.flags),isSigned:!!j.signature,queryContext:K}}let se=class{constructor(P,M,K,te,j,W,x,H){this.k=M,this.l=K,this.n=te,this.o=j,this.q=W,this.u=x,this.w=H;const Q=x.extensionsGallery,G=Q?.servicePPEUrl&&H.getValue("_extensionsGallery.enablePPE");this.d=G?Q.servicePPEUrl:Q?.serviceUrl,this.g=G?void 0:Q?.searchUrl,this.h=Q?.controlUrl,this.j=(0,c.resolveMarketplaceHeaders)(x.version,x,this.n,this.w,this.q,P,this.o)}x(P=""){return`${this.d}${P}`}isEnabled(){return!!this.d}async getExtensions(P,M,K){const te=L.CancellationToken.isCancellationToken(M)?{}:M,j=L.CancellationToken.isCancellationToken(M)?M:K,W=[],x=[],H=[],Q=[];let G=!0;for(const Ee of P){Ee.uuid?x.push(Ee.uuid):W.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);H.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&Q.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),G=G&&!!Ee.hasPreRelease&&!Ce}if(!x.length&&!W.length)return[];let Z=new D().withPage(1,P.length);x.length&&(Z=Z.withFilter(i.ExtensionId,...x)),W.length&&(Z=Z.withFilter(i.ExtensionName,...W)),(te.queryAllVersions||G)&&(Z=Z.withFlags(Z.flags,n.IncludeVersions)),te.source&&(Z=Z.withSource(te.source));const{extensions:ce}=await this.z(Z,{targetPlatform:te.targetPlatform??O,includePreRelease:H,versions:Q,compatible:!!te.compatible},j);return te.source&&ce.forEach((Ee,Ce)=>ne(Ee,Ce,te.source)),ce}async getCompatibleExtension(P,M,K){if((0,E.isNotWebExtensionInWebTargetPlatform)(P.allTargetPlatforms,K))return null;if(await this.isExtensionCompatible(P,M,K))return P;const te=new D().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,P.identifier.uuid),{extensions:j}=await this.z(te,{targetPlatform:K,compatible:!0,includePreRelease:M},L.CancellationToken.None);return j[0]||null}async isExtensionCompatible(P,M,K){if(!(0,E.isTargetPlatformCompatible)(P.properties.targetPlatform,P.allTargetPlatforms,K)||!M&&P.properties.isPreReleaseVersion)return!1;let te=P.properties.engine;if(!te){const j=await this.getManifest(P,L.CancellationToken.None);if(!j)throw new Error("Manifest was not found");te=j.engines.vscode}return(0,d.isEngineValid)(te,this.u.version,this.u.date)}async y(P,M,K,te,j){if(!(0,E.isTargetPlatformCompatible)(q(P),te,j)||M!=="any"&&ue(P)!==(M==="prerelease"))return!1;if(K)try{const W=await this.E(P);if(!(0,d.isEngineValid)(W,this.u.version,this.u.date))return!1}catch(W){return this.l.error(`Error while getting the engine for the version ${P.version}.`,(0,o.getErrorMessage)(W)),!1}return!0}async query(P,M){let K=P.text||"";const te=P.pageSize??50;let j=new D().withPage(1,te);K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(G,Z,ce)=>(j=j.withFilter(i.Category,ce||Z),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(G,Z,ce)=>(j=j.withFilter(i.Tag,ce||Z),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(j=j.withFilter(i.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),j=j.withFilter(i.SearchText,K)),j=j.withSortBy(0)):P.ids?j=j.withFilter(i.ExtensionId,...P.ids):P.names?j=j.withFilter(i.ExtensionName,...P.names):j=j.withSortBy(4),typeof P.sortBy=="number"&&(j=j.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(j=j.withSortOrder(P.sortOrder)),P.source&&(j=j.withSource(P.source));const W=async(G,Z)=>{const{extensions:ce,total:Ee}=await this.z(G,{targetPlatform:O,compatible:!1,includePreRelease:!!P.includePreRelease},Z);return ce.forEach((Ce,ke)=>ne(Ce,(G.pageNumber-1)*G.pageSize+ke,P.source)),{extensions:ce,total:Ee}},{extensions:x,total:H}=await W(j,M),Q=async(G,Z)=>{if(Z.isCancellationRequested)throw new o.CancellationError;const{extensions:ce}=await W(j.withPage(G+1),Z);return ce};return{firstPage:x,total:H,pageSize:j.pageSize,getPage:Q}}async z(P,M,K){const te=P.flags;P.flags&n.IncludeLatestVersionOnly&&P.flags&n.IncludeVersions&&(P=P.withFlags(P.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(P.flags&n.IncludeLatestVersionOnly)&&!(P.flags&n.IncludeVersions)&&(P=P.withFlags(P.flags,n.IncludeLatestVersionOnly)),M.versions?.length&&(P=P.withFlags(P.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),P=P.withFlags(P.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:j,total:W,context:x}=await this.B(P,K);if(!(P.flags&n.IncludeLatestVersionOnly)){const Z=[];for(const ce of j){const Ee=await this.A(ce,M,x);Ee&&Z.push(Ee)}return{extensions:Z,total:W}}const Q=[],G=new Map;for(let Z=0;Z<j.length;Z++){const ce=j[Z],Ee={id:(0,b.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},Ce=(0,T.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Fe=>(0,b.areSameExtensions)(Fe,Ee))?.includePreRelease;if(M.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(J(ce),M.targetPlatform))continue;const ke=await this.A(ce,M,x);!ke||ke.properties.isPreReleaseVersion&&(!Ce||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==M.targetPlatform&&ke.hasPreReleaseVersion?G.set(ce.extensionId,Z):Q.push([Z,ke])}if(G.size){const Z=new Date().getTime(),ce=new D().withFlags(te&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,G.size).withFilter(i.ExtensionId,...G.keys()),{extensions:Ee}=await this.z(ce,M,K);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-Z,count:G.size});for(const Ce of Ee){const ke=G.get(Ce.identifier.uuid);Q.push([ke,Ce])}}return{extensions:Q.sort((Z,ce)=>Z[0]-ce[0]).map(([,Z])=>Z),total:W}}async A(P,M,K){const te={id:(0,b.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},j=M.versions?.find(Q=>(0,b.areSameExtensions)(Q,te))?.version,W=(0,T.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Q=>(0,b.areSameExtensions)(Q,te))?.includePreRelease,x=J(P),H=U(P.versions,M.targetPlatform);if(M.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(x,M.targetPlatform))return null;for(let Q=0;Q<H.length;Q++){const G=H[Q];if(!(j&&G.version!==j)){if(await this.y(G,W?"any":"release",M.compatible,x,M.targetPlatform))return V(P,G,x,K);if(j&&G.version===j)return null}}return j||M.compatible?null:V(P,P.versions[0],x)}async B(P,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");P=P.withFlags(P.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,s(n.Unpublished));const K=await this.j,te=JSON.stringify(P.raw),j={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(te.length)},W=new Date().getTime();let x,H,Q=0;try{if(x=await this.k.request({type:"POST",url:this.g&&P.criteria.some(Z=>Z.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:te,headers:j},M),x.res.statusCode&&x.res.statusCode>=400&&x.res.statusCode<500)return{galleryExtensions:[],total:Q};const G=await(0,f.asJson)(x);if(G){const Z=G.results[0],ce=Z.extensions,Ee=Z.resultMetadata&&Z.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return Q=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ce,total:Q,context:{[t]:x.res.headers.activityid}}}return{galleryExtensions:[],total:Q}}catch(G){throw H=G,G}finally{this.o.publicLog2("galleryService:query",{...P.telemetryData,requestBodySize:String(te.length),duration:new Date().getTime()-W,success:!!x&&(0,f.isSuccess)(x),responseBodySize:x?.res.headers["Content-Length"],statusCode:x?String(x.res.statusCode):void 0,errorCode:H?(0,o.isCancellationError)(H)?"canceled":(0,o.getErrorMessage)(H).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Q)})}}async reportStatistic(P,M,K,te){if(!this.isEnabled())return;const j=A.isWeb?this.x(`/itemName/${P}.${M}/version/${K}/statType/${te==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${P}/extensions/${M}/${K}/stats?statType=${te}`),W=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",H={...await this.j,Accept:W};try{await this.k.request({type:"POST",url:j,headers:H},L.CancellationToken.None)}catch{}}async download(P,M,K){this.l.trace("ExtensionGalleryService#download",P.identifier.id);const te=(0,b.getGalleryExtensionTelemetryData)(P),j=new Date().getTime(),W=Z=>this.o.publicLog("galleryService:downloadVSIX",{...te,duration:Z}),x=K===2?"install":K===3?"update":"",H=x?{uri:`${P.assets.download.uri}${v.URI.parse(P.assets.download.uri).query?"&":"?"}${x}=true`,fallbackUri:`${P.assets.download.fallbackUri}${v.URI.parse(P.assets.download.fallbackUri).query?"&":"?"}${x}=true`}:P.assets.download,Q=P.queryContext?.[t]?{[t]:P.queryContext[t]}:void 0,G=await this.D(H,Q?{headers:Q}:void 0);await this.q.writeFile(M,G.stream),W(new Date().getTime()-j)}async downloadSignatureArchive(P,M){if(!P.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",P.identifier.id);const K=await this.D(P.assets.signature);await this.q.writeFile(M,K.stream)}async getReadme(P,M){if(P.assets.readme){const K=await this.D(P.assets.readme,{},M);return await(0,f.asTextOrError)(K)||""}return""}async getManifest(P,M){if(P.assets.manifest){const K=await this.D(P.assets.manifest,{},M),te=await(0,f.asTextOrError)(K);return te?JSON.parse(te):null}return null}async C(P,M){const K=ee(P,a.Manifest);if(!K)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},j=await this.D(K,{headers:te});return await(0,f.asJson)(j)}async getCoreTranslation(P,M){const K=P.assets.coreTranslations.filter(te=>te[0]===M.toUpperCase())[0];if(K){const te=await this.D(K[1]),j=await(0,f.asTextOrError)(te);return j?JSON.parse(j):null}return null}async getChangelog(P,M){if(P.assets.changelog){const K=await this.D(P.assets.changelog,{},M);return await(0,f.asTextOrError)(K)||""}return""}async getAllCompatibleVersions(P,M,K){let te=new D().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);P.identifier.uuid?te=te.withFilter(i.ExtensionId,P.identifier.uuid):te=te.withFilter(i.ExtensionName,P.identifier.id);const{galleryExtensions:j}=await this.B(te,L.CancellationToken.None);if(!j.length)return[];const W=J(j[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(W,K))return[];const x=[];await Promise.all(j[0].versions.map(async G=>{try{await this.y(G,M?"any":"release",!0,W,K)&&x.push(G)}catch{}}));const H=[],Q=new Set;for(const G of U(x,K))Q.has(G.version)||(Q.add(G.version),H.push({version:G.version,date:G.lastUpdated,isPreReleaseVersion:ue(G)}));return H}async D(P,M={},K=L.CancellationToken.None){const te=await this.j,j={type:"GET"},W={...te,...M.headers||{}};M={...M,...j,headers:W};const x=P.uri,H=P.fallbackUri,Q={...M,url:x};try{const G=await this.k.request(Q,K);if(G.res.statusCode===200)return G;const Z=await(0,f.asTextOrError)(G);throw new Error(`Expected 200, got back ${G.res.statusCode} instead.

${Z}`)}catch(G){if((0,o.isCancellationError)(G))throw G;const Z=(0,o.getErrorMessage)(G);this.o.publicLog2("galleryService:cdnFallback",{url:x,message:Z});const ce={...M,url:H};return this.k.request(ce,K)}}async E(P){let M=oe(P);if(!M){const K=await this.C(P,L.CancellationToken.None);if(!K)throw new Error("Manifest was not found");M=K.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const P=await this.k.request({type:"GET",url:this.h},L.CancellationToken.None);if(P.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,f.asJson)(P),K=[],te={};if(M){for(const j of M.malicious)K.push({id:j});if(M.migrateToPreRelease)for(const[j,W]of Object.entries(M.migrateToPreRelease))(!W.engine||(0,d.isEngineValid)(W.engine,this.u.version,this.u.date))&&(te[j.toLowerCase()]={disallowInstall:!0,extension:{id:W.id,displayName:W.displayName,autoMigrate:{storage:!!W.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[j,W]of Object.entries(M.deprecated))W&&(te[j.toLowerCase()]=(0,T.isBoolean)(W)?{}:W)}return{malicious:K,deprecated:te}}};se=Le([Ae(1,f.IRequestService),Ae(2,p.ILogService),Ae(3,R.IEnvironmentService),Ae(4,I.ITelemetryService),Ae(5,g.IFileService),Ae(6,r.IProductService),Ae(7,m.IConfigurationService)],se);let Y=e.ExtensionGalleryService=class extends se{constructor(P,M,K,te,j,W,x,H){super(P,M,K,te,j,W,x,H)}};e.ExtensionGalleryService=Y=Le([Ae(0,u.IStorageService),Ae(1,f.IRequestService),Ae(2,p.ILogService),Ae(3,R.IEnvironmentService),Ae(4,I.ITelemetryService),Ae(5,g.IFileService),Ae(6,r.IProductService),Ae(7,m.IConfigurationService)],Y);let ie=e.ExtensionGalleryServiceWithNoStorageService=class extends se{constructor(P,M,K,te,j,W,x){super(void 0,P,M,K,te,j,W,x)}};e.ExtensionGalleryServiceWithNoStorageService=ie=Le([Ae(0,f.IRequestService),Ae(1,p.ILogService),Ae(2,R.IEnvironmentService),Ae(3,I.ITelemetryService),Ae(4,g.IFileService),Ae(5,r.IProductService),Ae(6,m.IConfigurationService)],ie)}),define(pe[257],be([1,0,6,2,32,50]),function(le,e,y,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class k{constructor(m,R){this.a=m,this.b=R}listen(m,R){const E=this.b(m);switch(R){case"onDidChangeProfiles":return y.Event.map(this.a.onDidChangeProfiles,b=>({all:b.all.map(d=>(0,A.transformOutgoingURIs)({...d},E)),added:b.added.map(d=>(0,A.transformOutgoingURIs)({...d},E)),removed:b.removed.map(d=>(0,A.transformOutgoingURIs)({...d},E)),updated:b.updated.map(d=>(0,A.transformOutgoingURIs)({...d},E))}))}throw new Error(`Invalid listen ${R}`)}async call(m,R,E){const b=this.b(m);switch(R){case"createProfile":{const d=await this.a.createProfile(E[0],E[1],E[2]);return(0,A.transformOutgoingURIs)({...d},b)}case"updateProfile":{let d=(0,o.reviveProfile)((0,A.transformIncomingURIs)(E[0],b),this.a.profilesHome.scheme);return d=await this.a.updateProfile(d,E[1]),(0,A.transformOutgoingURIs)({...d},b)}case"removeProfile":{const d=(0,o.reviveProfile)((0,A.transformIncomingURIs)(E[0],b),this.a.profilesHome.scheme);return this.a.removeProfile(d)}}throw new Error(`Invalid call ${R}`)}}e.RemoteUserDataProfilesServiceChannel=k;class T extends L.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(m,R,E){super(),this.profilesHome=R,this.f=E,this.a=[],this.b=this.B(new y.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=m.map(b=>(0,o.reviveProfile)(b,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(b=>{const d=b.added.map(r=>(0,o.reviveProfile)(r,this.profilesHome.scheme)),g=b.removed.map(r=>(0,o.reviveProfile)(r,this.profilesHome.scheme)),p=b.updated.map(r=>(0,o.reviveProfile)(r,this.profilesHome.scheme));this.a=b.all.map(r=>(0,o.reviveProfile)(r,this.profilesHome.scheme)),this.b.fire({added:d,removed:g,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(m){this.c=m}isEnabled(){return this.c}async createNamedProfile(m,R,E){const b=await this.f.call("createNamedProfile",[m,R,E]);return(0,o.reviveProfile)(b,this.profilesHome.scheme)}async createProfile(m,R,E,b){const d=await this.f.call("createProfile",[m,R,E,b]);return(0,o.reviveProfile)(d,this.profilesHome.scheme)}async createTransientProfile(m){const R=await this.f.call("createTransientProfile",[m]);return(0,o.reviveProfile)(R,this.profilesHome.scheme)}async setProfileForWorkspace(m,R){await this.f.call("setProfileForWorkspace",[m,R])}removeProfile(m){return this.f.call("removeProfile",[m])}async updateProfile(m,R){const E=await this.f.call("updateProfile",[m,R]);return(0,o.reviveProfile)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=T}),define(pe[126],be([1,0,4,25,16,12,233,36,32,8,234]),function(le,e,y,L,o,A,k,T,v,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let E=e.UserDataProfilesReadonlyService=class Yt extends v.UserDataProfilesService{constructor(p,r,f,c,u){super(f,c,r,u),this.P=p,this.Q=f}J(){return this.P.getItem(Yt.b,[]).map(r=>({...r,location:(0,m.isString)(r.location)?this.s.extUri.joinPath(this.profilesHome,r.location):y.URI.revive(r.location)}))}M(){const p=this.P.getItem(Yt.c,{});return this.P.getItem(Yt.a,!1)?p:this.I(p)}O(){return this.s.extUri.joinPath(y.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};E.a="profileAssociationsMigration",e.UserDataProfilesReadonlyService=E=Le([Ae(0,k.IStateReadService),Ae(1,T.IUriIdentityService),Ae(2,L.INativeEnvironmentService),Ae(3,o.IFileService),Ae(4,A.ILogService)],E);let b=e.UserDataProfilesService=class Ft extends E{constructor(p,r,f,c,u){super(p,r,f,c,u),this.W=p}L(p){p.length?this.W.setItem(Ft.b,p.map(r=>({...r,location:this.s.extUri.basename(r.location)}))):this.W.removeItem(Ft.b)}J(){const p=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(p),this.W.setItem("userDataProfilesMigration",!0)),p}N(p){p.emptyWindows||p.workspaces?this.W.setItem(Ft.c,p):this.W.removeItem(Ft.c)}M(){const p="workspaceAndProfileInfo",r=this.W.getItem(p,void 0);if(r){this.W.removeItem(p);const c=r.reduce((u,{workspace:I,profile:O})=>(u[y.URI.revive(I).toString()]=y.URI.revive(O).toString(),u),{});this.W.setItem(Ft.c,{workspaces:c})}const f=super.M();return this.W.getItem(Ft.a,!1)||(this.N(f),this.W.setItem(Ft.a,!0)),f}};e.UserDataProfilesService=b=Le([Ae(0,k.IStateService),Ae(1,T.IUriIdentityService),Ae(2,L.INativeEnvironmentService),Ae(3,o.IFileService),Ae(4,A.ILogService)],b);let d=e.ServerUserDataProfilesService=class extends b{constructor(p,r,f,c){super(new R.StateService(0,r,c,f),p,r,f,c)}async init(){return await this.W.init(),super.init()}};e.ServerUserDataProfilesService=d=Le([Ae(0,T.IUriIdentityService),Ae(1,L.INativeEnvironmentService),Ae(2,o.IFileService),Ae(3,A.ILogService)],d)}),define(pe[127],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,y.createDecorator)("extensionHostStatusService");class L{constructor(){this.a=new Map}setExitInfo(A,k){this.a.set(A,k)}getExitInfo(A){return this.a.get(A)||null}}e.ExtensionHostStatusService=L}),define(pe[258],be([1,0,6,14]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=void 0;function o(k){let T=0,v=0,m=0;k>=1e3&&(m=Math.floor(k/1e3),k-=m*1e3),m>=60&&(v=Math.floor(m/60),m-=v*60),v>=60&&(T=Math.floor(v/60),v-=T*60);const R=T?`${T}h`:"",E=v?`${v}m`:"",b=m?`${m}s`:"",d=k?`${k}ms`:"";return`${R}${E}${b}${d}`}class A{constructor(T,v,m,R){this.i=T,this.j=v,this.a=new y.Emitter,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=m,this.protocol=R,this.e=!1,this.f=new L.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection grace time of ${o(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new L.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection short grace time of ${o(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${o(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(T){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${T}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${o(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const T=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),T.end(),this.a.fire(void 0)}acceptReconnection(T,v,m){this.d=T,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(v,m),this.protocol.endAcceptReconnection()}}e.ManagementConnection=A}),define(pe[88],be([1,0,33,13,7,151,54]),function(le,e,y,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const T=o.join(L.FileAccess.asFileUri("").fsPath,"nls.metadata.json"),v=new Map;function m(g){return new Promise(p=>y.exists(g,p))}function R(g,p){return m(T).then(r=>{if(!r||!k.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const f=`${g}||${p}`;let c=v.get(f);return c||(c=A.getNLSConfiguration(k.default.commit,p,T,g,g).then(u=>(E.is(u)&&(u._languagePackSupport=!0),u.locale!=="en"&&u.locale!=="en-us"&&Object.keys(u.availableLanguages).length===0&&v.delete(f),u)),v.set(f,c)),c})}e.getNLSConfiguration=R;var E;(function(g){function p(r){const f=r;return f&&typeof f._languagePackId=="string"}g.is=p})(E||(e.InternalNLSConfiguration=E={}));const b=async g=>{try{const p=d(await y.promises.readFile(g,"utf8"));return JSON.parse(p).locale}catch(p){return p.code!=="ENOENT"&&console.warn(p),"en"}};e.getLocaleFromConfig=b;const d=g=>{const p=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return g.replace(p,(r,f,c,u,I)=>{if(u)return"";if(I){const O=I.length;return O>2&&I[O-1]===`
`?I[O-2]==="\r"?`\r
`:`
`:""}else return r})}}),define(pe[128],be([1,0,19,4,25,45,57,16,5,12,27,36,32,88]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=e.ExtensionsScannerService=class extends k.AbstractExtensionsScannerService{constructor(r,f,c,u,I,O,t,n){super(L.URI.file(I.builtinExtensionsPath),L.URI.file(I.extensionsPath),(0,y.joinPath)(I.userHome,".vscode-oss-dev","extensions","control.json"),r.defaultProfile,r,f,c,u,I,O,t,n),this.N=I}async f(r){const f=await(0,d.getNLSConfiguration)(r,this.N.userDataPath);if(d.InternalNLSConfiguration.is(f))try{const c=await this.s.readFile(L.URI.file(f._translationsConfigFile));return JSON.parse(c.value.toString())}catch{}return Object.create(null)}};e.ExtensionsScannerService=g=Le([Ae(0,b.IUserDataProfilesService),Ae(1,A.IExtensionsProfileScannerService),Ae(2,T.IFileService),Ae(3,m.ILogService),Ae(4,o.INativeEnvironmentService),Ae(5,R.IProductService),Ae(6,E.IUriIdentityService),Ae(7,v.IInstantiationService)],g)}),define(pe[259],be([1,0,260,33,7,21,13,23]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const v=/^[0-9A-Za-z_-]+$/;var m;(function(r){r[r.None=0]="None",r[r.Optional=1]="Optional",r[r.Mandatory=2]="Mandatory"})(m||(e.ServerConnectionTokenType=m={}));class R{constructor(){this.type=0}validate(f){return!0}}e.NoneServerConnectionToken=R;class E{constructor(f){this.value=f,this.type=2}validate(f){return f===this.value}}e.MandatoryServerConnectionToken=E;class b{constructor(f){this.message=f}}e.ServerConnectionTokenParseError=b;async function d(r,f){const c=r["without-connection-token"],u=r["connection-token"],I=r["connection-token-file"];if(c)return typeof u<"u"||typeof I<"u"?new b("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new R;if(typeof I<"u"){if(typeof u<"u")return new b("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let O;try{O=L.readFileSync(I).toString().replace(/\r?\n$/,"")}catch{return new b(`Unable to read the connection token file at '${I}'.`)}return v.test(O)?new E(O):new b(`The connection token defined in '${I} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof u<"u"?v.test(u)?new E(u):new b(`The connection token '${u} does not adhere to the characters 0-9, a-z, A-Z or -.`):new E(await f())}e.parseServerConnectionToken=d;async function g(r){return d(r,async()=>{if(!r["user-data-dir"])return(0,A.generateUuid)();const c=o.join(r["user-data-dir"],"token");try{const O=(await T.Promises.readFile(c)).toString().replace(/\r?\n$/,"");if(v.test(O))return O}catch{}const u=(0,A.generateUuid)();try{await T.Promises.writeFile(c,u,{mode:384})}catch{}return u})}e.determineServerConnectionToken=g;function p(r,f,c){if(r.validate(c.query[k.connectionTokenQueryName]))return!0;const u=y.parse(f.headers.cookie||"");return r.validate(u[k.connectionTokenCookieName])}e.requestHasValidConnectionToken=p}),define(pe[41],be([1,0,194,107,62,5,25]),function(le,e,y,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:y.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:y.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:y.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:y.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:y.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:y.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:y.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:y.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:y.localize(8,null)},"user-data-dir":o.OPTIONS["user-data-dir"],"enable-smoke-test-driver":o.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":o.OPTIONS["disable-telemetry"],"disable-workspace-trust":o.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:o.OPTIONS.log,logsPath:o.OPTIONS.logsPath,"force-disable-user-env":o.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:y.localize(9,null)},"default-workspace":{type:"string",description:y.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":o.OPTIONS["extensions-dir"],"extensions-download-dir":o.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":o.OPTIONS["builtin-extensions-dir"],"install-extension":o.OPTIONS["install-extension"],"install-builtin-extension":o.OPTIONS["install-builtin-extension"],"uninstall-extension":o.OPTIONS["uninstall-extension"],"list-extensions":o.OPTIONS["list-extensions"],"locate-extension":o.OPTIONS["locate-extension"],"show-versions":o.OPTIONS["show-versions"],category:o.OPTIONS.category,force:o.OPTIONS.force,"do-not-sync":o.OPTIONS["do-not-sync"],"pre-release":o.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:y.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:o.OPTIONS.help,version:o.OPTIONS.version,"locate-shell-integration-path":o.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:o.OPTIONS._},e.IServerEnvironmentService=(0,A.refineServiceDecorator)(k.IEnvironmentService);class T extends L.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=T}),define(pe[261],be([1,0,78,12,41,27,219,21,18]),function(le,e,y,L,o,A,k,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let m=e.CredentialsWebMainService=class extends k.BaseCredentialsMainService{constructor(E,b,d){super(E),this.p=b,this.r=d,this.p.args["github-auth"]&&this.t(this.p.args["github-auth"]).catch(g=>{this.h.error("Failed to store provided GitHub token",g)})}async getSecretStoragePrefix(){return Promise.resolve(`${this.r.urlProtocol}-server`)}async i(){if(this.f)return this.f;if(this.p.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new y.InMemoryCredentialsProvider,this.f;try{this.f=await new Promise((E,b)=>{le(["keytar"],E,b)}),await this.f.findCredentials("test-keytar-loads")}catch(E){this.h.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${E.message??E}`),this.f=new y.InMemoryCredentialsProvider}return this.f}async t(E){const b="vscode.github-authentication",d=`${await this.getSecretStoragePrefix()}${b}`,g="github.auth",r=[["read:user","user:email","repo"]].map(u=>({id:(0,T.generateUuid)(),scopes:u.sort(),accessToken:E})),f=await this.getPassword(d,g);let c;if(f)try{const u=JSON.parse(f);u.content=JSON.parse(u.content),c=u}catch(u){this.h.error("Failed to parse existing GitHub credentials",u)}return c?.content&&(c.content=c.content.filter(u=>{const I=u.scopes.sort();return!r.find(O=>(0,v.equals)(I,O.scopes)&&O.account?.label===u.account?.label)})),this.setPassword(d,g,JSON.stringify({extensionId:b,...c||{},content:JSON.stringify([...r,...c?.content||[]])}))}};e.CredentialsWebMainService=m=Le([Ae(0,L.ILogService),Ae(1,o.IServerEnvironmentService),Ae(2,A.IProductService)],m)}),define(pe[262],be([1,0,299,244,263,26]),function(le,e,y,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryClient=void 0;class k extends y.AppInsightsCore{constructor(v){super(),this.a=v}track(v){const m=v.baseData||{};m.properties||(m.properties={}),m.measurements||(m.measurements={});try{const R=A.cpus();m.measurements.cores=R.length,m.properties["common.cpuModel"]=R[0].model}catch{}try{m.measurements.memoryFree=A.freemem(),m.measurements.memoryTotal=A.totalmem()}catch{}try{m.properties["common.shell"]=A.userInfo().shell,m.properties["common.release"]=A.release(),m.properties["common.arch"]=A.arch()}catch{}try{const R=(/^http:/.test(this.a)?o:L).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});R.on("error",()=>{}),R.write(JSON.stringify(m)),R.end()}catch{}}}e.TelemetryClient=k}),define(pe[264],be([1,0,33,75,83,260,85,38,58,3,12,41,7,13,21,27,44,20,4,15,8,88,56]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c,u,I,O,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOriginalUrl=e.relativePath=e.relativeRoot=e.normalizeUrlPath=e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const n={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function s(N,$,ee,he){$.writeHead(ee,{"Content-Type":"text/plain"}),$.end(he)}e.serveError=s;var i;(function(N){N[N.NO_CACHING=0]="NO_CACHING",N[N.ETAG=1]="ETAG",N[N.NO_EXPIRY=2]="NO_EXPIRY"})(i||(e.CacheControl=i={}));async function a(N,$,ee,he,oe,ue){try{const me=await y.promises.stat(N);if($===1){const _=`W/"${[me.ino,me.size,me.mtime.getTime()].join("-")}"`;if(he.headers["if-none-match"]===_)return oe.writeHead(304),void oe.end();ue.Etag=_}else $===2?ue["Cache-Control"]="public, max-age=31536000":$===0&&(ue["Cache-Control"]="no-store");ue["Content-Type"]=n[(0,b.extname)(N)]||(0,v.getMediaMime)(N)||"text/plain",oe.writeHead(200,ue),(0,y.createReadStream)(N).pipe(oe)}catch(me){return me.code!=="ENOENT"?(ee.error(me),console.error(me.toString())):console.error(`File not found: ${N}`),oe.writeHead(404,{"Content-Type":"text/plain"}),void oe.end("Not found")}}e.serveFile=a;const l=(0,b.dirname)(d.FileAccess.asFileUri("").fsPath);let h=e.WebClientServer=class{constructor($,ee,he,oe,ue){this.f=$,this.g=ee,this.h=he,this.i=oe,this.j=ue,this.a=this.j.extensionsGallery?.resourceUrlTemplate?c.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const me=(0,t.getRemoteServerRootPath)(ue);this.b=`${me}/static`,this.c=`${me}/callback`,this.d="/web-extension-resource"}async handle($,ee,he){try{const oe=he.pathname;return oe.startsWith(this.b)&&oe.charCodeAt(this.b.length)===47?this.k($,ee,he):oe==="/"?this.n($,ee,he):oe===this.c?this.p(ee):oe.startsWith(this.d)&&oe.charCodeAt(this.d.length)===47?this.m($,ee,he):s($,ee,404,"Not found.")}catch(oe){return this.h.error(oe),console.error(oe.toString()),s($,ee,500,"Internal Server Error.")}}async k($,ee,he){const oe=Object.create(null),me=decodeURIComponent(he.pathname).substring(this.b.length+1),_=(0,b.join)(l,me);return(0,T.isEqualOrParent)(_,l,!m.isLinux)?a(_,this.g.isBuilt?2:1,this.h,$,ee,oe):s($,ee,400,"Bad request.")}l($){const ee=$.authority.indexOf(".");return ee!==-1?$.authority.substring(ee+1):void 0}async m($,ee,he){if(!this.a)return s($,ee,500,"No extension gallery service configured.");const oe=decodeURIComponent(he.pathname),ue=(0,b.normalize)(oe.substring(this.d.length+1)),me=c.URI.parse(ue).with({scheme:this.a.scheme,authority:ue.substring(0,ue.indexOf("/")),path:ue.substring(ue.indexOf("/")+1)});if(this.l(this.a)!==this.l(me))return s($,ee,403,"Request Forbidden");const _={},re=se=>{const Y=$.headers[se];Y&&((0,I.isString)(Y)||Y[0])?_[se]=(0,I.isString)(Y)?Y:Y[0]:se!==se.toLowerCase()&&re(se.toLowerCase())};re("X-Client-Name"),re("X-Client-Version"),re("X-Machine-Id"),re("X-Client-Commit");const q=await this.i.request({type:"GET",url:me.toString(!0),headers:_},f.CancellationToken.None),J=q.res.statusCode||500;if(J!==200){let se=null;try{se=await(0,r.asTextOrError)(q)}catch{}return s($,ee,J,se||`Request failed with status ${J}`)}const U=Object.create(null),ne=se=>{const Y=q.res.headers[se];Y?U[se]=Y:se!==se.toLowerCase()&&ne(se.toLowerCase())};ne("Cache-Control"),ne("Content-Type"),ee.writeHead(200,U);const V=await(0,u.streamToBuffer)(q.stream);return void ee.end(V.buffer)}async n($,ee,he){const oe=he.query[d.connectionTokenQueryName];if(typeof oe=="string"){const j=Object.create(null);j["Set-Cookie"]=A.serialize(d.connectionTokenCookieName,oe,{sameSite:"lax",maxAge:60*60*24*7});const W=Object.create(null);for(const H in he.query)H!==d.connectionTokenQueryName&&(W[H]=he.query[H]);const x=o.format({pathname:"/",query:W});return j.Location=x,ee.writeHead(302,j),void ee.end()}const ue="remote";if(!ue)return s($,ee,400,"Bad request.");function me(j){return JSON.stringify(j).replace(/"/g,"&quot;")}let _;this.g.args["enable-smoke-test-driver"]&&(_=!1);const re=j=>j&&c.URI.file(L.resolve(j)).with({scheme:d.Schemas.vscodeRemote,authority:ue}),q=d.FileAccess.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,J=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,g.generateUuid)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,U=(0,e.relativeRoot)((0,e.getOriginalUrl)($)),ne=(0,e.relativePath)((0,e.getOriginalUrl)($)),V={codeServerVersion:this.j.codeServerVersion,rootEndpoint:U,updateEndpoint:this.g.args["disable-update-check"]?void 0:U+"/update/check",logoutEndpoint:this.g.args.auth&&this.g.args.auth!=="none"?U+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??U+"/proxy/{{port}}/",serviceWorker:{scope:ne+"/",path:U+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.j.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this.j.extensionsGallery};if(!this.g.isBuilt)try{const j=JSON.parse((await y.promises.readFile((0,b.join)(l,"product.overrides.json"))).toString());Object.assign(V,j)}catch{}const se={remoteAuthority:ue,webviewEndpoint:ne+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.g.userDataPath,isEnabledFileDownloads:!this.g.args["disable-file-downloads"],isEnabledCoderGettingStarted:!this.g.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:_,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:re(this.g.args["default-folder"]),workspaceUri:re(this.g.args["default-workspace"]),productConfiguration:V,callbackRoute:this.c},Y=this.g.args.locale||await(0,O.getLocaleFromConfig)(this.g.argvResource.fsPath),ie=await(0,O.getNLSConfiguration)(Y,this.g.userDataPath),z=this.j.extensionsGallery?.nlsBaseUrl,P={WORKBENCH_WEB_CONFIGURATION:me(se),WORKBENCH_AUTH_SESSION:J?me(J):"",WORKBENCH_WEB_BASE_URL:ne+this.b,WORKBENCH_NLS_BASE_URL:ne+(z?`${z}${z.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""),BASE:U,VS_BASE:ne,NLS_CONFIGURATION:me(ie)};let M;try{M=(await y.promises.readFile(q)).toString().replace(/\{\{([^}]+)\}\}/g,(W,x)=>P[x]??"undefined")}catch{return ee.writeHead(404,{"Content-Type":"text/plain"}),void ee.end("Not found")}const te={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(M).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=';`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(te["Set-Cookie"]=A.serialize(d.connectionTokenCookieName,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),ee.writeHead(200,te),void ee.end(M)}o($){const ee=/<script>([\s\S]+?)<\/script>/img,he=[];let oe;for(;oe=ee.exec($);){const ue=k.createHash("sha256"),me=oe[1].replace(/\r\n/g,`
`),_=ue.update(Buffer.from(me)).digest().toString("base64");he.push(`'sha256-${_}'`)}return he}async p($){const ee=d.FileAccess.asFileUri("vs/code/browser/workbench/callback.html").fsPath,he=(await y.promises.readFile(ee)).toString(),oe=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(he).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return $.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":oe}),void $.end(he)}};e.WebClientServer=h=Le([Ae(1,E.IServerEnvironmentService),Ae(2,R.ILogService),Ae(3,r.IRequestService),Ae(4,p.IProductService)],h);const C=(N,$=!1)=>N.replace(/\/\/+/g,"/").replace(/\/+$/,$?"/":"");e.normalizeUrlPath=C;const D=N=>{const $=(N.split("?",1)[0].match(/\//g)||[]).length;return(0,e.normalizeUrlPath)("./"+($>1?"../".repeat($-1):""))};e.relativeRoot=D;const w=N=>{const $=N.split("?",1)[0].split("/");return(0,e.normalizeUrlPath)("./"+$[$.length-1])};e.relativePath=w;const S=N=>N.originalUrl||N.url;e.getOriginalUrl=S}),define(pe[265],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,y.createDecorator)("IExtHostInitDataService")}),define(pe[266],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,y.createDecorator)("IExtHostRpcService");class L{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=L}),define(pe[68],be([1,0,50]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function L(A){return{transformIncoming:k=>k.scheme==="vscode-remote"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="file"?{scheme:"vscode-local",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoing:k=>k.scheme==="file"?{scheme:"vscode-remote",authority:A,path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="vscode-local"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoingScheme:k=>k==="file"?"vscode-remote":k==="vscode-local"?"file":k}}function o(A){return new y.URITransformer(L(A))}e.createURITransformer=o}),define(pe[267],be([1,0,3,42,4,68,50,103,237,7,19]),function(le,e,y,L,o,A,k,T,v,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class E{constructor(d,g,p,r){this.b=d,this.c=g,this.d=p,this.e=r}async call(d,g,p){switch(g){case"getEnvironmentData":{const r=p,f=(0,A.createURITransformer)(r.remoteAuthority);let c=await this.f(r.profile);return c=(0,k.transformOutgoingURIs)(c,f),c}case"getExtensionHostExitInfo":{const r=p;return this.e.getExitInfo(r.reconnectionToken)}case"getDiagnosticInfo":{const r=p,f={machineInfo:(0,v.getMachineInfo)()},c=r.includeProcesses?(0,T.listProcesses)(process.pid):Promise.resolve();let u=[];const I={};if(r.folders){const O=(0,A.createURITransformer)("");u=r.folders.map(n=>o.URI.revive(O.transformIncoming(n))).filter(n=>n.scheme==="file").map(n=>(0,v.collectWorkspaceStats)(n.fsPath,["node_modules",".git"]).then(s=>{I[(0,m.basename)(n.fsPath)]=s}))}return Promise.all([c,...u]).then(([O,t])=>(f.processes=O||void 0,f.workspaceMetadata=r.folders?I:void 0,f))}}throw new Error(`IPC Command ${g} not found`)}listen(d,g,p){throw new Error("Not supported")}async f(d){return d&&!this.d.profiles.some(g=>g.id===d)&&await this.d.createProfile(d,d),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:o.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,R.joinPath)(this.c.logsHome,`exthost${E.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:y.OS,arch:process.arch,marks:L.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(g=>({...g}))}}}}e.RemoteAgentEnvironmentChannel=E,E.a=1}),define(pe[268],be([1,0,4,68,66,7,222]),function(le,e,y,L,o,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class T extends k.AbstractDiskFileSystemProviderChannel{constructor(R,E){super(new o.DiskFileSystemProvider(R),R),this.H=E,this.G=new Map,this.B(this.a)}c(R){let E=this.G.get(R.remoteAuthority);return E||(E=(0,L.createURITransformer)(R.remoteAuthority),this.G.set(R.remoteAuthority,E)),E}f(R,E,b=!1){if(b&&E.path==="/vscode-resource"&&E.query){const d=JSON.parse(E.query).requestResourcePath;return y.URI.from({scheme:"file",path:d})}return y.URI.revive(R.transformIncoming(E))}F(R,E){return new v(R,E,this.b,this.H)}}e.RemoteAgentFileSystemProviderChannel=T;class v extends k.AbstractSessionFileWatcher{constructor(R,E,b,d){super(R,E,b,d)}i(R){const E=R.args["file-watcher-polling"];if(E){const b=E.split(A.delimiter),d=Number(b[0]);if(d>0)return{usePolling:b.length>1?b.slice(1):!0,pollingInterval:d}}}j(R){if(R.extensionsPath)return[A.posix.join(R.extensionsPath,"**")]}}}),define(pe[89],be([1,0,197,8,4,2,5,40,16,13,39,160,60]),function(le,e,y,L,o,A,k,T,v,m,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var d;(function(V){V[V.PROGRAMMATIC=1]="PROGRAMMATIC",V[V.USER=2]="USER",V[V.EDIT=3]="EDIT",V[V.NAVIGATION=4]="NAVIGATION",V[V.JUMP=5]="JUMP"})(d||(e.EditorPaneSelectionChangeReason=d={}));var g;(function(V){V[V.IDENTICAL=1]="IDENTICAL",V[V.SIMILAR=2]="SIMILAR",V[V.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function p(V){const se=V;return!!se&&typeof se.getSelection=="function"&&!!se.onDidChangeSelection}e.isEditorPaneWithSelection=p;function r(V,se,Y){for(const ie of Y.visibleEditorPanes)if(ie.group.id===se&&V.matches(ie.input))return ie.getViewState()}e.findViewStateForEditor=r;function f(V){if(l(V))return!1;const se=V;return o.URI.isUri(se?.resource)}e.isResourceEditorInput=f;function c(V){if(l(V))return!1;const se=V;return se?.original!==void 0&&se.modified!==void 0}e.isResourceDiffEditorInput=c;function u(V){if(l(V)||c(V))return!1;const se=V;return se?.primary!==void 0&&se.secondary!==void 0}e.isResourceSideBySideEditorInput=u;function I(V){if(l(V))return!1;const se=V;return se?se.resource===void 0||se.resource.scheme===m.Schemas.untitled||se.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=I;function O(V){if(l(V))return!1;const se=V;return o.URI.isUri(se?.base?.resource)&&o.URI.isUri(se?.input1?.resource)&&o.URI.isUri(se?.input2?.resource)&&o.URI.isUri(se?.result?.resource)}e.isResourceMergeEditorInput=O;var t;(function(V){V[V.SHORT=0]="SHORT",V[V.MEDIUM=1]="MEDIUM",V[V.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var n;(function(V){V[V.EXPLICIT=1]="EXPLICIT",V[V.AUTO=2]="AUTO",V[V.FOCUS_CHANGE=3]="FOCUS_CHANGE",V[V.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class s{constructor(){this.a=new Map}registerSource(se,Y){let ie=this.a.get(se);return ie||(ie={source:se,label:Y},this.a.set(se,ie)),ie.source}getSourceLabel(se){return this.a.get(se)?.label??se}}e.SaveSourceRegistry=new s;var i;(function(V){V[V.None=0]="None",V[V.Readonly=2]="Readonly",V[V.Untitled=4]="Untitled",V[V.Singleton=8]="Singleton",V[V.RequiresTrust=16]="RequiresTrust",V[V.CanSplitInGroup=32]="CanSplitInGroup",V[V.ForceDescription=64]="ForceDescription",V[V.CanDropIntoEditor=128]="CanDropIntoEditor",V[V.MultipleEditors=256]="MultipleEditors",V[V.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class a extends A.Disposable{}e.AbstractEditorInput=a;function l(V){return V instanceof a}e.isEditorInput=l;function h(V){const se=V;return o.URI.isUri(se?.preferredResource)}function C(V){const se=V;return l(se?.primary)&&l(se?.secondary)}e.isSideBySideEditorInput=C;function D(V){const se=V;return l(se?.modified)&&l(se?.original)}e.isDiffEditorInput=D;function w(V,se,Y,ie,z){return ne(ie,[(0,E.toAction)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const P={...Y,limits:{size:Number.MAX_VALUE}};V.openEditor(se,P)}}),(0,E.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>z.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:b.default.Warning})}e.createTooLargeFileError=w;function S(V){return l(V?.editor)}e.isEditorInputWithOptions=S;function N(V){const se=V;return S(V)&&se?.group!==void 0}e.isEditorInputWithOptionsAndGroup=N;function $(V){const se=V;return typeof se?.groupId=="number"&&l(se.editor)}e.isEditorIdentifier=$;var ee;(function(V){V[V.UNKNOWN=0]="UNKNOWN",V[V.REPLACE=1]="REPLACE",V[V.MOVE=2]="MOVE",V[V.UNPIN=3]="UNPIN"})(ee||(e.EditorCloseContext=ee={}));var he;(function(V){V[V.GROUP_ACTIVE=0]="GROUP_ACTIVE",V[V.GROUP_INDEX=1]="GROUP_INDEX",V[V.GROUP_LOCKED=2]="GROUP_LOCKED",V[V.EDITOR_OPEN=3]="EDITOR_OPEN",V[V.EDITOR_CLOSE=4]="EDITOR_CLOSE",V[V.EDITOR_MOVE=5]="EDITOR_MOVE",V[V.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",V[V.EDITOR_LABEL=7]="EDITOR_LABEL",V[V.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",V[V.EDITOR_PIN=9]="EDITOR_PIN",V[V.EDITOR_STICKY=10]="EDITOR_STICKY",V[V.EDITOR_DIRTY=11]="EDITOR_DIRTY",V[V.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(he||(e.GroupModelChangeKind=he={}));var oe;(function(V){V[V.PRIMARY=1]="PRIMARY",V[V.SECONDARY=2]="SECONDARY",V[V.BOTH=3]="BOTH",V[V.ANY=4]="ANY"})(oe||(e.SideBySideEditor=oe={}));class ue{getOriginalUri(se,Y){if(!se)return;if(O(se))return e.EditorResourceAccessor.getOriginalUri(se.result,Y);if(Y?.supportSideBySide){const{primary:z,secondary:P}=this.a(se);if(z&&P){if(Y?.supportSideBySide===oe.BOTH)return{primary:this.getOriginalUri(z,{filterByScheme:Y.filterByScheme}),secondary:this.getOriginalUri(P,{filterByScheme:Y.filterByScheme})};if(Y?.supportSideBySide===oe.ANY)return this.getOriginalUri(z,{filterByScheme:Y.filterByScheme})??this.getOriginalUri(P,{filterByScheme:Y.filterByScheme});se=Y.supportSideBySide===oe.PRIMARY?z:P}}if(c(se)||u(se)||O(se))return;const ie=h(se)?se.preferredResource:se.resource;return!ie||!Y||!Y.filterByScheme?ie:this.b(ie,Y.filterByScheme)}a(se){return C(se)||u(se)?{primary:se.primary,secondary:se.secondary}:D(se)||c(se)?{primary:se.modified,secondary:se.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(se,Y){if(!se)return;if(O(se))return e.EditorResourceAccessor.getCanonicalUri(se.result,Y);if(Y?.supportSideBySide){const{primary:z,secondary:P}=this.a(se);if(z&&P){if(Y?.supportSideBySide===oe.BOTH)return{primary:this.getCanonicalUri(z,{filterByScheme:Y.filterByScheme}),secondary:this.getCanonicalUri(P,{filterByScheme:Y.filterByScheme})};if(Y?.supportSideBySide===oe.ANY)return this.getCanonicalUri(z,{filterByScheme:Y.filterByScheme})??this.getCanonicalUri(P,{filterByScheme:Y.filterByScheme});se=Y.supportSideBySide===oe.PRIMARY?z:P}}if(c(se)||u(se)||O(se))return;const ie=se.resource;return!ie||!Y||!Y.filterByScheme?ie:this.b(ie,Y.filterByScheme)}b(se,Y){if(Array.isArray(Y)){if(Y.some(ie=>se.scheme===ie))return se}else if(Y===se.scheme)return se}}e.EditorResourceAccessor=new ue;var me;(function(V){V[V.LEFT=0]="LEFT",V[V.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class _{constructor(){this.c=new Map,this.d=new Map}start(se){const Y=this.a=se.get(k.IInstantiationService);for(const[ie,z]of this.c)this.e(ie,z,Y);this.c.clear()}e(se,Y,ie){const z=ie.createInstance(Y);this.d.set(se,z)}registerFileEditorFactory(se){if(this.b)throw new Error("Can only register one file editor factory.");this.b=se}getFileEditorFactory(){return(0,L.assertIsDefined)(this.b)}registerEditorSerializer(se,Y){if(this.c.has(se)||this.d.has(se))throw new Error(`A editor serializer with type ID '${se}' was already registered.`);return this.a?this.e(se,Y,this.a):this.c.set(se,Y),(0,A.toDisposable)(()=>{this.c.delete(se),this.d.delete(se)})}getEditorSerializer(se){return this.d.get(typeof se=="string"?se:se.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new _);async function re(V,se,Y){return!V||!V.length?[]:await Promise.all(V.map(async ie=>{const z=o.URI.revive(ie.fileUri);if(!z){Y.info("Cannot resolve the path because it is not valid.",ie);return}if(!await se.canHandleResource(z)){Y.info("Cannot resolve the path because it cannot be handled",ie);return}let M=ie.exists,K=ie.type;if(typeof M!="boolean"||typeof K!="number")try{K=(await se.stat(z)).isDirectory?v.FileType.Directory:v.FileType.Unknown,M=!0}catch(j){Y.error(j),M=!1}if(!M&&ie.openOnlyIfExists){Y.info("Cannot resolve the path because it does not exist",ie);return}if(K===v.FileType.Directory){Y.info("Cannot resolve the path because it is a directory",ie);return}const te={...ie.options,pinned:!0};return M?{resource:z,options:te}:{resource:z,options:te,forceUntitled:!0}}))}e.pathsToEditors=re;var q;(function(V){V[V.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",V[V.SEQUENTIAL=1]="SEQUENTIAL"})(q||(e.EditorsOrder=q={}));function J(V){const se=V;if(!se)return!1;const Y=se;if(Y.modified)return J(Y.modified);const ie=se;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.isTextEditorViewState=J;function U(V){return(0,R.isErrorWithActions)(V)}e.isEditorOpenError=U;function ne(V,se,Y){const ie=(0,R.createErrorWithActions)(V,se);return ie.forceMessage=Y?.forceMessage,ie.forceSeverity=Y?.forceSeverity,ie.allowDialog=Y?.allowDialog,ie}e.createEditorOpenError=ne}),define(pe[129],be([1,0,15,74,46,58,13,7,3,64]),function(le,e,y,L,o,A,k,T,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function(_){_[_.Markup=1]="Markup",_[_.Code=2]="Code"})(R||(e.CellKind=R={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var E;(function(_){_[_.Running=1]="Running",_[_.Idle=2]="Idle"})(E||(e.NotebookRunState=E={}));var b;(function(_){_[_.Unconfirmed=1]="Unconfirmed",_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var d;(function(_){_[_.Unconfirmed=1]="Unconfirmed",_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var g;(function(_){_[_.WithHardKernelDependency=0]="WithHardKernelDependency",_[_.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",_[_.Pure=2]="Pure",_[_.Never=3]="Never"})(g||(e.NotebookRendererMatch=g={}));var p;(function(_){_.Always="always",_.Never="never",_.Optional="optional"})(p||(e.RendererMessagingSpec=p={}));var r;(function(_){_[_.ModelChange=1]="ModelChange",_[_.Move=2]="Move",_[_.ChangeCellLanguage=5]="ChangeCellLanguage",_[_.Initialize=6]="Initialize",_[_.ChangeCellMetadata=7]="ChangeCellMetadata",_[_.Output=8]="Output",_[_.OutputItem=9]="OutputItem",_[_.ChangeCellContent=10]="ChangeCellContent",_[_.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",_[_.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",_[_.ChangeCellMime=13]="ChangeCellMime",_[_.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var f;(function(_){_[_.Handle=0]="Handle",_[_.Index=1]="Index"})(f||(e.SelectionStateType=f={}));var c;(function(_){_[_.Replace=1]="Replace",_[_.Output=2]="Output",_[_.Metadata=3]="Metadata",_[_.CellLanguage=4]="CellLanguage",_[_.DocumentMetadata=5]="DocumentMetadata",_[_.Move=6]="Move",_[_.OutputItems=7]="OutputItems",_[_.PartialMetadata=8]="PartialMetadata",_[_.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var u;(function(_){_.scheme=k.Schemas.vscodeNotebookCell;const re=["W","X","Y","Z","a","b","c","d","e","f"],q=new RegExp(`^[${re.join("")}]+`),J=7;function U(z,P){const M=P.toString(J),te=`${M.length<re.length?re[M.length-1]:"z"}${M}s${(0,y.encodeBase64)(y.VSBuffer.fromString(z.scheme),!0,!0)}`;return z.with({scheme:_.scheme,fragment:te})}_.generate=U;function ne(z){if(z.scheme!==_.scheme)return;const P=z.fragment.indexOf("s");if(P<0)return;const M=parseInt(z.fragment.substring(0,P).replace(q,""),J),K=(0,y.decodeBase64)(z.fragment.substring(P+1)).toString();if(!isNaN(M))return{handle:M,notebook:z.with({scheme:K,fragment:null})}}_.parse=ne;function V(z,P){return z.with({scheme:k.Schemas.vscodeNotebookCellOutput,fragment:`op${P??""},${z.scheme!==k.Schemas.file?z.scheme:""}`})}_.generateCellOutputUri=V;function se(z){if(z.scheme!==k.Schemas.vscodeNotebookCellOutput)return;const P=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(z.fragment);if(!P)return;const M=P[1]&&P[1]!==""?P[1]:void 0,K=P[2];return{outputId:M,notebook:z.with({scheme:K||k.Schemas.file,fragment:null})}}_.parseCellOutputUri=se;function Y(z,P,M){return _.generate(z,P).with({scheme:M})}_.generateCellPropertyUri=Y;function ie(z,P){if(z.scheme===P)return _.parse(z.with({scheme:_.scheme}))}_.parseCellPropertyUri=ie})(u||(e.CellUri=u={}));const I=_=>v.isWindows?_.replace(/\//g,"\\"):_;class O{constructor(re=[],q=e.NOTEBOOK_DISPLAY_ORDER){this.e=q,this.d=[...new Set(re)].map(J=>({pattern:J,matches:L.parse(I(J))}))}sort(re){const q=new Map(o.Iterable.map(re,U=>[U,I(U)]));let J=[];for(const{matches:U}of this.d)for(const[ne,V]of q)if(U(V)){J.push(ne),q.delete(ne);break}return q.size&&(J=J.concat([...q.keys()].sort((U,ne)=>this.e.indexOf(U)-this.e.indexOf(ne)))),J}prioritize(re,q){const J=this.f(re);if(J===-1){this.d.unshift({pattern:re,matches:L.parse(I(re))});return}const U=new Set(q.map(V=>this.f(V,J)));U.delete(-1);const ne=Array.from(U).sort();this.d.splice(J+1,0,...ne.map(V=>this.d[V]));for(let V=ne.length-1;V>=0;V--)this.d.splice(ne[V],1)}toArray(){return this.d.map(re=>re.pattern)}f(re,q=this.d.length){const J=I(re);for(let U=0;U<q;U++)if(this.d[U].matches(J))return U;return-1}}e.MimeTypeDisplayOrder=O;function t(_,re,q,J=(U,ne)=>U===ne){const U=[];function ne(Y,ie,z){if(ie===0&&z.length===0)return;const P=U[U.length-1];P&&P.start+P.deleteCount===Y?(P.deleteCount+=ie,P.toInsert.push(...z)):U.push({start:Y,deleteCount:ie,toInsert:z})}let V=0,se=0;for(;;){if(V===_.length){ne(V,0,re.slice(se));break}if(se===re.length){ne(V,_.length-V,[]);break}const Y=_[V],ie=re[se];if(J(Y,ie)){V+=1,se+=1;continue}q(ie)?(ne(V,1,[]),V+=1):(ne(V,0,[ie]),se+=1)}return U}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new m.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(_){_.default="default",_.option="option"})(n||(e.NotebookEditorPriority=n={}));function s(_){const re=_;return!!((typeof re.include=="string"||L.isRelativePattern(re.include))&&(typeof re.exclude=="string"||L.isRelativePattern(re.exclude)))}e.isDocumentExcludePattern=s;function i(_,re,q){if(Array.isArray(_.viewType)&&_.viewType.indexOf(re)>=0||_.viewType===re)return!0;if(_.filenamePattern){const J=s(_.filenamePattern)?_.filenamePattern.include:_.filenamePattern,U=s(_.filenamePattern)?_.filenamePattern.exclude:void 0;if(L.match(J,(0,T.basename)(q.fsPath).toLowerCase()))return!(U&&L.match(U,(0,T.basename)(q.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var a;(function(_){_[_.Left=1]="Left",_[_.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class l{static create(re){return`${l.d}${re}`}static parse(re){if(re.startsWith(l.d))return re.substring(l.d.length)}}e.NotebookWorkingCopyTypeIdentifier=l,l.d="notebook/";function h(_){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(_)}e.isTextStreamMime=h;const C=new TextDecoder;function D(_){const re=[];let q=!1;for(const J of _)(re.length===0||q)&&(re.push(J),q=!0);return $(re),me(y.VSBuffer.concat(re.map(J=>y.VSBuffer.wrap(J))))}e.compressOutputItemStreams=D;const w=`${String.fromCharCode(27)}[A`,S=w.split("").map(_=>_.charCodeAt(0)),N=10;function $(_){_.forEach((re,q)=>{if(q===0||re.length<w.length)return;const J=_[q-1],U=re.subarray(0,w.length);if(U[0]===S[0]&&U[1]===S[1]&&U[2]===S[2]){const ne=J.lastIndexOf(N);if(ne===-1)return;_[q-1]=J.subarray(0,ne),_[q]=re.subarray(w.length)}})}function ee(_){let re=_;do _=re,re=_.replace(/[^\n]\x08/gm,"");while(re.length<_.length);return _}function he(_){for(_=_.replace(/\r+\n/gm,`
`);_.search(/\r[^$]/g)>-1;){const re=_.match(/^(.*)\r+/m)[1];let q=_.match(/\r+(.*)$/m)[1];q=q+re.slice(q.length,re.length),_=_.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return _}const oe="\b".charCodeAt(0),ue="\r".charCodeAt(0);function me(_){return!_.buffer.includes(oe)&&!_.buffer.includes(ue)?_:y.VSBuffer.fromString(he(ee(C.decode(_.buffer))))}}),define(pe[269],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,y.createDecorator)("environmentVariableService")}),define(pe[270],be([1,0,7,4,59,3,247,8]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWorkspaceForTerminal=e.preparePathForShell=e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function v(s,i){if(i)if(A.isWindows)for(const a in i){let l=a;for(const C in s)if(a.toLowerCase()===C.toLowerCase()){l=C;break}const h=i[a];h!==void 0&&m(s,l,h)}else Object.keys(i).forEach(a=>{const l=i[a];l!==void 0&&m(s,a,l)})}e.mergeEnvironments=v;function m(s,i,a){typeof a=="string"?s[i]=a:delete s[i]}function R(s,i,a,l){s.TERM_PROGRAM="vscode",i&&(s.TERM_PROGRAM_VERSION=i),d(s,l)&&(s.LANG=g(a)),s.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=R;function E(s,i){if(i)for(const a of Object.keys(i)){const l=i[a];l!=null&&(s[a]=l)}}async function b(s,i){return await Promise.all(Object.entries(i).map(async([a,l])=>{if(typeof l=="string")try{i[a]=await s(l)}catch{i[a]=l}})),i}function d(s,i){if(i==="on")return!0;if(i==="auto"){const a=s.LANG;return!a||a.search(/\.UTF\-8$/)===-1&&a.search(/\.utf8$/)===-1&&a.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=d;function g(s){const i=s?s.split("-"):[],a=i.length;if(a===0)return"en_US.UTF-8";if(a===1){const l={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};i[0]in l&&i.push(l[i[0]])}else i[1]=i[1].toUpperCase();return i.join("_")+".UTF-8"}e.getLangEnvVariable=g;async function p(s,i,a,l,h,C){if(s.cwd){const w=typeof s.cwd=="object"?s.cwd.fsPath:s.cwd,S=await r(w,a);return(0,k.sanitizeCwd)(S||w)}let D;return!s.ignoreConfigurationCwd&&h&&(a&&(h=await r(h,a,C)),h&&(y.isAbsolute(h)?D=h:l&&(D=y.join(l.fsPath,h)))),D||(D=l?l.fsPath:i||""),(0,k.sanitizeCwd)(D)}e.getCwd=p;async function r(s,i,a){if(i)try{return await i(s)}catch(l){a?.error("Could not resolve terminal cwd",l);return}return s}function f(s,i,a){if(a)return l=>a.resolveWithEnvironment(i,s,l)}e.createVariableResolver=f;async function c(s,i,a,l,h,C,D,w=A.platform){let S;D&&(S=I(s,"automationShell",w)),S||(S=I(s,"shell",w));let N=S||i;if(w===3&&!a&&l){const $=y.join(l,"Sysnative").replace(/\//g,"\\").toLowerCase();N&&N.toLowerCase().indexOf($)===0&&(N=y.join(l,"System32",N.substr($.length+1)))}if(N&&w===3&&(N=N.replace(/\//g,"\\")),h)try{N=await h(N)}catch($){C.error("Could not resolve shell",$)}return N}e.getDefaultShell=c;async function u(s,i,a,l,h=A.platform){if(i&&I(s,"automationShell",h))return[];const C=h===3?"windows":h===1?"osx":"linux";let D=s(`terminal.integrated.shellArgs.${C}`);if(!D)return[];if(typeof D=="string"&&h===3)return a?await a(D):D;if(a){const w=[];for(const S of D)try{w.push(await a(S))}catch(N){l.error(`Could not resolve terminal.integrated.shellArgs.${C}`,N),w.push(S)}D=w}return D}e.getDefaultShellArgs=u;function I(s,i,a=A.platform){return s(`terminal.integrated.${i}.${a===3?"windows":a===1?"osx":"linux"}`)}async function O(s,i,a,l,h,C){const D={};if(s.strictEnv)E(D,s.env);else{E(D,C);const w={...i};a&&(w&&await b(a,w),s.env&&await b(a,s.env)),(0,o.sanitizeProcessEnvironment)(D,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),v(D,w),v(D,s.env),R(D,l,A.language,h)}return D}e.createTerminalEnvironment=O;async function t(s,i,a,l,h,C,D=A.isWindows){let w;if((0,T.isString)(s)?w=s:(w=s.fsPath,D&&C!==1?w=w.replace(/\\/g,"/"):!D&&C===1&&(w=w.replace(/\//g,"\\"))),!i)return w;const S=w.includes(" "),N=w.includes("(")||w.includes(")"),$=y.basename(i,".exe"),ee=$==="pwsh"||a==="pwsh"||$==="powershell"||a==="powershell";if(ee&&(S||w.includes("'")))return`& '${w.replace(/'/g,"''")}'`;if(N&&ee)return`& '${w}'`;if(C===1){if(l!==void 0)return l==="gitbash"?(0,k.escapeNonWindowsPath)(w.replace(/\\/g,"/")):l==="wsl"?h?.getWslPath(w,"win-to-unix")||w:S?`"${w}"`:w;const he=i.toLowerCase();return he.includes("wsl")||he.includes("bash.exe")&&!he.toLowerCase().includes("git")?h?.getWslPath(w,"win-to-unix")||w:S?`"${w}"`:w}return(0,k.escapeNonWindowsPath)(w)}e.preparePathForShell=t;function n(s,i,a){const l=typeof s=="string"?L.URI.parse(s):s;let h=l?(0,T.withNullAsUndefined)(i.getWorkspaceFolder(l)):void 0;if(!h){const C=a.getLastActiveWorkspaceRoot();h=C?(0,T.withNullAsUndefined)(i.getWorkspaceFolder(C)):void 0}return h}e.getWorkspaceForTerminal=n}),define(pe[69],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(A){A.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var L;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class o{static fromExtHostTestItem(k,T,v=k.parent){if(k._isRoot)return new o([T]);const m=[k.id];for(let R=v;R&&R.id!==T;R=R.parent)m.push(R.id);return m.push(T),new o(m.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const T=k.indexOf("\0");return T===-1?k:k.slice(0,T)}static fromString(k){return new o(k.split("\0"))}static join(k,T){return new o([...k.path,T])}static joinToString(k,T){return k.toString()+"\0"+T}static parentId(k){const T=k.lastIndexOf("\0");return T===-1?void 0:k.slice(0,T)}static localId(k){const T=k.lastIndexOf("\0");return T===-1?k:k.slice(T+1)}static isChild(k,T){return T.startsWith(k)&&T[k.length]==="\0"}static compare(k,T){return k===T?0:o.isChild(k,T)?2:o.isChild(T,k)?3:1}constructor(k,T=k.length){if(this.path=k,this.d=T,k.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new o(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let k=1;k<=this.d;k++)yield new o(this.path,k)}*idsToRoot(){for(let k=this.d;k>0;k--)yield new o(this.path,k)}compare(k){if(typeof k=="string")return o.compare(this.toString(),k);for(let T=0;T<k.d&&T<this.d;T++)if(k.path[T]!==this.path[T])return 1;return k.d>this.d?2:k.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let k=1;k<this.d;k++)this.c+="\0",this.c+=this.path[k]}return this.c}}e.TestId=o}),define(pe[90],be([1,0,4,52,69]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var k;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(k||(e.ExtTestRunProfileKind=k={}));var T;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(T||(e.TestRunProfileBitset=T={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const v=C=>"runId"in C;e.isStartControllerTests=v;var m;(function(C){C.serialize=D=>({range:D.range.toJSON(),uri:D.uri.toJSON()}),C.deserialize=D=>({range:L.Range.lift(D.range),uri:y.URI.revive(D.uri)})})(m||(e.IRichLocation=m={}));var R;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(R||(e.TestMessageType=R={}));var E;(function(C){C.serialize=D=>({message:D.message,type:0,expected:D.expected,actual:D.actual,location:D.location&&m.serialize(D.location)}),C.deserialize=D=>({message:D.message,type:0,expected:D.expected,actual:D.actual,location:D.location&&m.deserialize(D.location)})})(E||(e.ITestErrorMessage=E={}));const b=(C,D)=>`${D?"s":"e"}${C}`;e.getMarkId=b;var d;(function(C){C.serialize=D=>({message:D.message,type:1,offset:D.offset,length:D.length,location:D.location&&m.serialize(D.location)}),C.deserialize=D=>({message:D.message,type:1,offset:D.offset,length:D.length,location:D.location&&m.deserialize(D.location)})})(d||(e.ITestOutputMessage=d={}));var g;(function(C){C.serialize=D=>D.type===0?E.serialize(D):d.serialize(D),C.deserialize=D=>D.type===0?E.deserialize(D):d.deserialize(D)})(g||(e.ITestMessage=g={}));var p;(function(C){C.serializeWithoutMessages=D=>({state:D.state,duration:D.duration,messages:[]}),C.serialize=D=>({state:D.state,duration:D.duration,messages:D.messages.map(g.serialize)}),C.deserialize=D=>({state:D.state,duration:D.duration,messages:D.messages.map(g.deserialize)})})(p||(e.ITestTaskState=p={}));const r="\0",f=(C,D)=>C+r+D;e.namespaceTestTag=f;const c=C=>{const D=C.indexOf(r);return{ctrlId:C.slice(0,D),tagId:C.slice(D+1)}};e.denamespaceTestTag=c;var u;(function(C){C.serialize=D=>({extId:D.extId,label:D.label,tags:D.tags,busy:D.busy,children:void 0,uri:D.uri?.toJSON(),range:D.range?.toJSON()||null,description:D.description,error:D.error,sortText:D.sortText}),C.deserialize=D=>({extId:D.extId,label:D.label,tags:D.tags,busy:D.busy,children:void 0,uri:D.uri?y.URI.revive(D.uri):void 0,range:D.range?L.Range.lift(D.range):null,description:D.description,error:D.error,sortText:D.sortText})})(u||(e.ITestItem=u={}));var I;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(I||(e.TestItemExpandState=I={}));var O;(function(C){C.serialize=D=>({expand:D.expand,item:u.serialize(D.item)}),C.deserialize=D=>({controllerId:o.TestId.root(D.item.extId),expand:D.expand,item:u.deserialize(D.item)})})(O||(e.InternalTestItem=O={}));var t;(function(C){C.serialize=D=>{let w;return D.item&&(w={},D.item.label!==void 0&&(w.label=D.item.label),D.item.tags!==void 0&&(w.tags=D.item.tags),D.item.busy!==void 0&&(w.busy=D.item.busy),D.item.uri!==void 0&&(w.uri=D.item.uri?.toJSON()),D.item.range!==void 0&&(w.range=D.item.range?.toJSON()),D.item.description!==void 0&&(w.description=D.item.description),D.item.error!==void 0&&(w.error=D.item.error),D.item.sortText!==void 0&&(w.sortText=D.item.sortText)),{extId:D.extId,expand:D.expand,item:w}},C.deserialize=D=>{let w;return D.item&&(w={},D.item.label!==void 0&&(w.label=D.item.label),D.item.tags!==void 0&&(w.tags=D.item.tags),D.item.busy!==void 0&&(w.busy=D.item.busy),D.item.range!==void 0&&(w.range=D.item.range?L.Range.lift(D.item.range):null),D.item.description!==void 0&&(w.description=D.item.description),D.item.error!==void 0&&(w.error=D.item.error),D.item.sortText!==void 0&&(w.sortText=D.item.sortText)),{extId:D.extId,expand:D.expand,item:w}}})(t||(e.ITestItemUpdate=t={}));const n=(C,D)=>{D.expand!==void 0&&(C.expand=D.expand),D.item!==void 0&&(C.item=C.item?Object.assign(C.item,D.item):D.item)};e.applyTestItemUpdate=n;var s;(function(C){C.serializeWithoutMessages=D=>({...O.serialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(p.serializeWithoutMessages)}),C.serialize=D=>({...O.serialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(p.serialize)}),C.deserialize=D=>({...O.deserialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(p.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var i;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(i||(e.DetailType=i={}));var a;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(a||(e.TestDiffOpType=a={}));var l;(function(C){C.deserialize=D=>D.op===0?{op:D.op,item:O.deserialize(D.item)}:D.op===1?{op:D.op,item:t.deserialize(D.item)}:D.op===2?{op:D.op,uri:y.URI.revive(D.uri),docv:D.docv}:D,C.serialize=D=>D.op===0?{op:D.op,item:O.serialize(D.item)}:D.op===1?{op:D.op,item:t.serialize(D.item)}:D})(l||(e.TestsDiffOp=l={}));class h{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(D){const w=this.o();for(const S of D)switch(S.op){case 0:this.j(O.deserialize(S.item),w);break;case 1:this.k(t.deserialize(S.item),w);break;case 3:this.l(S.itemId,w);break;case 5:this.m(S.itemId);break;case 4:this.updatePendingRoots(S.amount);break;case 6:this.c.set(S.tag.id,S.tag);break;case 7:this.c.delete(S.id);break}w.complete?.()}j(D,w){const S=o.TestId.parentId(D.item.extId)?.toString();let N;if(!S)N=this.p(D),this.f.add(N),this.d.set(D.item.extId,N);else if(this.d.has(S)){const $=this.d.get(S);$.children.add(D.item.extId),N=this.p(D,$),this.d.set(D.item.extId,N)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(D)}`);return}return w.add?.(N),D.expand===2&&this.g++,N}k(D,w){const S=this.d.get(D.extId);if(S)return D.expand!==void 0&&(S.expand===2&&this.g--,D.expand===2&&this.g++),(0,e.applyTestItemUpdate)(S,D),w.update?.(S),S}l(D,w){const S=this.d.get(D);if(!S)return;const N=o.TestId.parentId(S.item.extId)?.toString();N?this.d.get(N).children.delete(S.item.extId):this.f.delete(S);const $=[[D]];for(;$.length;)for(const ee of $.pop()){const he=this.d.get(ee);he&&($.push(he.children),this.d.delete(ee),w.remove?.(he,he!==S),he.expand===2&&this.g--)}}m(D){}updatePendingRoots(D){this.h+=D}o(){return{}}}e.AbstractIncrementalTestCollection=h}),define(pe[130],be([1,0,14,6,2,93,90,69]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var v;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const m=(c,u)=>c===u,E=Object.entries({range:(c,u)=>c===u?!0:!c||!u?!1:c.equalsRange(u),busy:m,label:m,description:m,error:m,sortText:m,tags:(c,u)=>!(c.length!==u.length||c.some(I=>!u.includes(I)))}),b=(c,u)=>{let I;for(const[O,t]of E)t(c[O],u[O])||(I?I[O]=u[O]:I={[O]:u[O]});return I};class d extends o.Disposable{get root(){return this.m.root}constructor(u){super(),this.m=u,this.f=this.B(new y.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new L.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(u){this.h=u;for(const I of this.tree.values())this.G(I)}get resolveHandler(){return this.h}collectDiff(){const u=this.k;return this.k=[],u}pushDiff(u){switch(u.op){case 2:{for(const I of this.k)if(I.op===2&&I.uri===u.uri){I.docv=u.docv;return}break}case 1:{const I=this.k[this.k.length-1];if(I){if(I.op===1&&I.item.extId===u.item.extId){(0,k.applyTestItemUpdate)(I.item,u.item);return}if(I.op===0&&I.item.item.extId===u.item.extId){(0,k.applyTestItemUpdate)(I.item,u.item);return}}break}}this.k.push(u),this.f.isScheduled()||this.f.schedule()}expand(u,I){const O=this.tree.get(u);if(O){if((O.expandLevels===void 0||I>O.expandLevels)&&(O.expandLevels=I),O.expand===1){const t=this.I(O);return t.isOpen()?this.H(O,I-1):t.wait().then(()=>this.H(O,I-1))}else if(O.expand===3)return O.resolveBarrier?.isOpen()===!1?O.resolveBarrier.wait().then(()=>this.H(O,I-1)):this.H(O,I-1)}}dispose(){for(const u of this.tree.values())this.m.getApiFor(u.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(u,I){switch(I.op){case 3:this.L(T.TestId.joinToString(u.fullId,I.id));break;case 0:this.u(I.item,u);break;case 5:for(const O of I.ops)this.p(u,O);break;case 1:this.w(I.new,I.old,u.fullId.toString());break;case 2:this.G(u);break;case 4:this.pushDiff({op:1,item:{extId:u.fullId.toString(),item:I.update}});break;case 6:this.s(u.actual.uri);break;default:(0,A.assertNever)(I)}}s(u){u&&this.pushDiff({op:2,uri:u,docv:this.m.getDocumentVersion(u)})}u(u,I){const O=T.TestId.fromExtHostTestItem(u,this.root.id,I?.actual),t=this.m.getApiFor(u);t.parent&&t.parent!==I?.actual&&this.m.getChildren(t.parent).delete(u.id);let n=this.tree.get(O.toString());if(!n){n={fullId:O,actual:u,expandLevels:I?.expandLevels?I.expandLevels-1:void 0,expand:0},u.tags.forEach(this.y,this),this.tree.set(n.fullId.toString(),n),this.C(u,I),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:n.expand,item:this.m.toITestItem(u)}}),this.F(u,n,I);return}if(n.actual===u){this.D(u,n,I);return}if(n.actual.uri?.toString()!==u.uri?.toString())return this.L(O.toString()),this.u(u,I);const s=this.m.getChildren(n.actual),i=n.actual,a=b(this.m.toITestItem(i),this.m.toITestItem(u));this.m.getApiFor(i).listener=void 0,n.actual=u,n.expand=0,a&&(a.hasOwnProperty("tags")&&(this.w(u.tags,i.tags,O.toString()),delete a.tags),this.p(n,{op:4,update:a})),this.F(u,n,I);for(const[l,h]of s)this.m.getChildren(u).get(h.id)||this.L(T.TestId.joinToString(O,h.id));this.s(n.actual.uri)}w(u,I,O){const t=new Set(I.map(n=>n.id));for(const n of u)t.delete(n.id)||this.y(n);this.pushDiff({op:1,item:{extId:O,item:{tags:u.map(n=>(0,k.namespaceTestTag)(this.m.controllerId,n.id))}}}),t.forEach(this.z,this)}y(u){const I=this.j.get(u.id);I?I.refCount++:(this.j.set(u.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,k.namespaceTestTag)(this.m.controllerId,u.id)}}))}z(u){const I=this.j.get(u);I&&!--I.refCount&&(this.j.delete(u),this.pushDiff({op:7,id:(0,k.namespaceTestTag)(this.m.controllerId,u)}))}C(u,I){this.m.getApiFor(u).parent=I&&I.actual!==this.root?I.actual:void 0}D(u,I,O){this.C(u,O);const t=this.m.getApiFor(u);t.parent=O?.actual,t.listener=n=>this.p(I,n),this.G(I)}F(u,I,O){this.D(u,I,O);for(const[t,n]of this.m.getChildren(u))this.u(n,I)}G(u){let I;this.h?u.resolveBarrier?I=u.resolveBarrier.isOpen()?3:2:I=u.actual.canResolveChildren?1:0:I=0,I!==u.expand&&(u.expand=I,this.pushDiff({op:1,item:{extId:u.fullId.toString(),expand:I}}),I===1&&u.expandLevels!==void 0&&this.I(u))}H(u,I){if(I<0)return;const O=[];for(const[t,n]of this.m.getChildren(u.actual)){const s=this.expand(T.TestId.joinToString(u.fullId,n.id),I);(0,y.isThenable)(s)&&O.push(s)}if(O.length)return Promise.all(O).then(()=>{})}I(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this.h){const n=new y.Barrier;return n.open(),n}u.expand=2,this.J(u);const I=u.resolveBarrier=new y.Barrier,O=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,n)};let t;try{t=this.h(u.actual===this.root?void 0:u.actual)}catch(n){O(n)}return(0,y.isThenable)(t)?t.catch(O).then(()=>{I.open(),this.G(u)}):(I.open(),this.G(u)),u.resolveBarrier}J(u){this.pushDiff({op:1,item:{extId:u.fullId.toString(),expand:u.expand}})}L(u){const I=this.tree.get(u);if(!I)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:u});const O=[I];for(;O.length;){const t=O.pop();if(t){this.m.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.z(n.id);this.tree.delete(t.fullId.toString());for(const[n,s]of this.m.getChildren(t.actual))O.push(this.tree.get(T.TestId.joinToString(t.fullId,s.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.g.fire(u)}}e.TestItemCollection=d;class g extends Error{constructor(u){super(`Attempted to insert a duplicate test item ID ${u}`)}}e.DuplicateTestItemError=g;class p extends Error{constructor(u){super(`TestItem with ID "${u}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class r extends Error{constructor(u,I,O){super(`TestItem with ID "${u}" is from controller "${I}" and cannot be added as a child of an item from controller "${O}".`)}}e.MixedTestItemController=r;const f=(c,u,I)=>{let O=new Map;return{get size(){return O.size},forEach(t,n){for(const s of O.values())t.call(n,s,this)},[Symbol.iterator](){return O.entries()},replace(t){const n=new Map,s=new Set(O.keys()),i={op:5,ops:[]};for(const a of t){if(!(a instanceof I))throw new p(a.id);const l=u(a).controllerId;if(l!==c.controllerId)throw new r(a.id,l,c.controllerId);if(n.has(a.id))throw new g(a.id);n.set(a.id,a),s.delete(a.id),i.ops.push({op:0,item:a})}for(const a of s.keys())i.ops.push({op:3,id:a});c.listener?.(i),O=n},add(t){if(!(t instanceof I))throw new p(t.id);O.set(t.id,t),c.listener?.({op:0,item:t})},delete(t){O.delete(t)&&c.listener?.({op:3,id:t})},get(t){return O.get(t)},toJSON(){return Array.from(O.values())}}};e.createTestItemChildren=f}),define(pe[131],be([1,0,130]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const L=new WeakMap,o=(k,T)=>{const v={controllerId:T};return L.set(k,v),v};e.createPrivateApiFor=o;const A=k=>{const T=L.get(k);if(!T)throw new y.InvalidTestItemError(k?.id||"<unknown>");return T};e.getPrivateApiFor=A}),define(pe[271],be([1,0,24,5]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5,6],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,L.refineServiceDecorator)(y.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(pe[132],be([1,0,5]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,y.createDecorator)("configurationResolverService");var L;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(L||(e.VariableKind=L={}));class o extends Error{constructor(k,T){super(T),this.variable=k}}e.VariableError=o}),define(pe[272],be([1,0,7,29,8,22,3,149,198,132,17]),function(le,e,y,L,o,A,k,T,v,m,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class E{constructor(d,g,p,r){this.h=new Map,this.a=d,this.b=g,this.g=p,r&&(this.c=r.then(f=>this.i(f)))}i(d){if(k.isWindows){const g=Object.create(null);return Object.keys(d).forEach(p=>{g[p.toLowerCase()]=d[p]}),g}return d}resolveWithEnvironment(d,g,p){return this.l({env:this.i(d),userHome:void 0},g?g.uri:void 0,p)}async resolveAsync(d,g){const p={env:await this.c,userHome:await this.g};return this.l(p,d?d.uri:void 0,g)}async j(d,g,p,r){const f=A.deepClone(g);k.isWindows&&f.windows?Object.keys(f.windows).forEach(u=>f[u]=f.windows[u]):k.isMacintosh&&f.osx?Object.keys(f.osx).forEach(u=>f[u]=f.osx[u]):k.isLinux&&f.linux&&Object.keys(f.linux).forEach(u=>f[u]=f.linux[u]),delete f.windows,delete f.osx,delete f.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,d?d.uri:void 0,f,p,r)}async resolveAnyAsync(d,g,p){return this.j(d,g,p)}async resolveAnyMap(d,g,p){const r=new Map;return{newConfig:await this.j(d,g,p,r),resolvedVariables:r}}resolveWithInteractionReplace(d,g,p,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(d,g,p,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(d,g){if(this.h.has(d))throw new Error("Variable "+d+" is contributed twice.");this.h.set(d,g)}async l(d,g,p,r,f){if(o.isString(p))return this.m(d,g,p,r,f);if(Array.isArray(p))return Promise.all(p.map(c=>this.l(d,g,c,r,f)));if(o.isObject(p)){const c=Object.create(null),u=await Promise.all(Object.keys(p).map(async I=>[await this.m(d,g,I,r,f),await this.l(d,g,p[I],r,f)]));for(const[I,O]of u)c[I]=O;return c}return p}m(d,g,p,r,f){return(0,R.replaceAsync)(p,E.VARIABLE_REGEXP,async(c,u)=>{if(u.includes(E.VARIABLE_LHS))return c;let I=await this.o(d,c,u,g,r);return f?.set(u,I),I!==c&&o.isString(I)&&I.match(E.VARIABLE_REGEXP)&&(I=await this.m(d,g,I,r,f)),I})}n(d){return this.b?this.b.getUriLabel(d,{noPrefix:!0}):d.fsPath}async o(d,g,p,r,f){let c;const u=p.split(":");u.length>1&&(p=u[0],c=u[1]);const I=n=>{const s=this.a.getFilePath();if(s)return(0,T.normalizeDriveLetter)(s);throw new m.VariableError(n,(0,v.localize)(0,null,g))},O=n=>{const s=I(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,T.normalizeDriveLetter)(i)}throw new m.VariableError(n,(0,v.localize)(1,null,g,y.basename(s)))},t=n=>{if(c){const s=this.a.getFolderUri(c);if(s)return s;throw new m.VariableError(n,(0,v.localize)(2,null,g,c))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new m.VariableError(n,(0,v.localize)(3,null,g)):new m.VariableError(n,(0,v.localize)(4,null,g))};switch(p){case"env":if(c){if(d.env){const n=d.env[k.isWindows?c.toLowerCase():c];if(o.isString(n))return n}return""}throw new m.VariableError(m.VariableKind.Env,(0,v.localize)(5,null,g));case"config":if(c){const n=this.a.getConfigurationValue(r,c);if(o.isUndefinedOrNull(n))throw new m.VariableError(m.VariableKind.Config,(0,v.localize)(6,null,g,c));if(o.isObject(n))throw new m.VariableError(m.VariableKind.Config,(0,v.localize)(7,null,g,c));return n}throw new m.VariableError(m.VariableKind.Config,(0,v.localize)(8,null,g));case"command":return this.p(m.VariableKind.Command,g,c,f,"command");case"input":return this.p(m.VariableKind.Input,g,c,f,"input");case"extensionInstallFolder":if(c){const n=await this.a.getExtension(c);if(!n)throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,g,c));return this.n(n.extensionLocation)}throw new m.VariableError(m.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,g));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.n(t(m.VariableKind.WorkspaceFolder)));case"cwd":return r||c?(0,T.normalizeDriveLetter)(this.n(t(m.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.normalizeDriveLetter)(y.basename(this.n(t(m.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(d.userHome)return d.userHome;throw new m.VariableError(m.VariableKind.UserHome,(0,v.localize)(11,null,g))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new m.VariableError(m.VariableKind.LineNumber,(0,v.localize)(12,null,g))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new m.VariableError(m.VariableKind.SelectedText,(0,v.localize)(13,null,g))}case"file":return I(m.VariableKind.File);case"fileWorkspaceFolder":return O(m.VariableKind.FileWorkspaceFolder);case"relativeFile":return r||c?y.relative(this.n(t(m.VariableKind.RelativeFile)),I(m.VariableKind.RelativeFile)):I(m.VariableKind.RelativeFile);case"relativeFileDirname":{const n=y.dirname(I(m.VariableKind.RelativeFileDirname));if(r||c){const s=y.relative(this.n(t(m.VariableKind.RelativeFileDirname)),n);return s.length===0?".":s}return n}case"fileDirname":return y.dirname(I(m.VariableKind.FileDirname));case"fileExtname":return y.extname(I(m.VariableKind.FileExtname));case"fileBasename":return y.basename(I(m.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=y.basename(I(m.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-y.extname(n).length)}case"fileDirnameBasename":return y.basename(y.dirname(I(m.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||g}case"execInstallFolder":{const n=this.a.getAppRoot();return n||g}case"pathSeparator":return y.sep;default:try{const n=c?`${p}:${c}`:p;return this.p(m.VariableKind.Unknown,g,n,f,void 0)}catch{return g}}}}p(d,g,p,r,f){if(p&&r){const c=f===void 0?r[p]:r[f+":"+p];if(typeof c=="string")return c;throw new m.VariableError(d,(0,v.localize)(14,null,g))}return g}}e.AbstractVariableResolverService=E,E.VARIABLE_LHS="${",E.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[273],be([1,0,5,89]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,y.createDecorator)("editorGroupsService");var o;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(o||(e.GroupDirection=o={}));var A;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var k;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(k||(e.GroupLocation=k={}));var T;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(T||(e.GroupsArrangement=T={}));var v;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function m(g){const p=g;return(0,L.isEditorInput)(p?.editor)&&(0,L.isEditorInput)(p?.replacement)}e.isEditorReplacement=m;var R;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var E;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function b(g){const p=g;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=b;function d(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=d}),define(pe[133],be([1,0,5,273]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,y.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function o(A){const k=A;return typeof A=="number"||(0,L.isEditorGroup)(k)}e.isPreferredGroup=o}),define(pe[274],be([1,0,8,271,12,116,87,86,132,89,133,13,218,269]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let g=e.RemoteTerminalChannelClient=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(r,f,c,u,I,O,t,n,s,i){this.a=r,this.b=f,this.c=c,this.d=u,this.e=I,this.f=O,this.g=t,this.h=n,this.i=s,this.j=i}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(r,f,c,u,I,O,t,n){await this.c.whenRemoteConfigurationLoaded();const s=Object.create(null),i=c?(0,y.withNullAsUndefined)(this.d.getWorkspaceFolder(c)):void 0;let a;try{a=(await this.e.resolveAnyMap(i,{shellLaunchConfig:r,configuration:f})).resolvedVariables}catch(ee){this.h.error(ee)}if(a)for(const[ee,he]of a.entries())(/^config:/.test(ee)||ee==="selectedText"||ee==="lineNumber")&&(s[ee]=he);const l=[];for(const[ee,he]of this.f.collections.entries())l.push([ee,(0,T.serializeEnvironmentVariableCollection)(he.map),(0,T.serializeEnvironmentDescriptionMap)(he.descriptionMap)]);const h=await this.g.resolveAuthority(this.a),C=h.options&&h.options.extensionHostEnv,D=this.d.getWorkspace(),w=D.folders,S=c?this.d.getWorkspaceFolder(c):null,N=m.EditorResourceAccessor.getOriginalUri(this.i.activeEditor,{supportSideBySide:m.SideBySideEditor.PRIMARY,filterByScheme:[E.Schemas.file,E.Schemas.vscodeUserData,E.Schemas.vscodeRemote]}),$={configuration:f,resolvedVariables:s,envVariableCollections:l,shellLaunchConfig:r,workspaceId:D.id,workspaceName:this.j.getWorkspaceLabel(D),workspaceFolders:w,activeWorkspaceFolder:S,activeFileResource:N,shouldPersistTerminal:I,options:u,cols:O,rows:t,unicodeVersion:n,resolverEnv:C};return await this.b.call("$createProcess",$)}requestDetachInstance(r,f){return this.b.call("$requestDetachInstance",[r,f])}acceptDetachInstanceReply(r,f){return this.b.call("$acceptDetachInstanceReply",[r,f])}attachToProcess(r){return this.b.call("$attachToProcess",[r])}detachFromProcess(r,f){return this.b.call("$detachFromProcess",[r,f])}listProcesses(){return this.b.call("$listProcesses")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(r,f){return this.b.call("$processBinary",[r,f])}start(r){return this.b.call("$start",[r])}input(r,f){return this.b.call("$input",[r,f])}acknowledgeDataEvent(r,f){return this.b.call("$acknowledgeDataEvent",[r,f])}setUnicodeVersion(r,f){return this.b.call("$setUnicodeVersion",[r,f])}shutdown(r,f){return this.b.call("$shutdown",[r,f])}resize(r,f,c){return this.b.call("$resize",[r,f,c])}getInitialCwd(r){return this.b.call("$getInitialCwd",[r])}getCwd(r){return this.b.call("$getCwd",[r])}orphanQuestionReply(r){return this.b.call("$orphanQuestionReply",[r])}sendCommandResult(r,f,c){return this.b.call("$sendCommandResult",[r,f,c])}freePortKillProcess(r){return this.b.call("$freePortKillProcess",[r])}installAutoReply(r,f){return this.b.call("$installAutoReply",[r,f])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(r){return this.b.call("$getDefaultSystemShell",[r])}getProfiles(r,f,c){return this.b.call("$getProfiles",[this.d.getWorkspace().id,r,f,c])}acceptPtyHostResolvedVariables(r,f){return this.b.call("$acceptPtyHostResolvedVariables",[r,f])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(r,f){return this.b.call("$getWslPath",[r,f])}setTerminalLayoutInfo(r){const c={workspaceId:this.d.getWorkspace().id,tabs:r?r.tabs:[]};return this.b.call("$setTerminalLayoutInfo",c)}updateTitle(r,f,c){return this.b.call("$updateTitle",[r,f,c])}updateIcon(r,f,c,u){return this.b.call("$updateIcon",[r,f,c,u])}refreshProperty(r,f){return this.b.call("$refreshProperty",[r,f])}updateProperty(r,f,c){return this.b.call("$updateProperty",[r,f,c])}getTerminalLayoutInfo(){const f={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",f)}reviveTerminalProcesses(r,f){return this.b.call("$reviveTerminalProcesses",[r,f])}getRevivedPtyNewId(r){return this.b.call("$getRevivedPtyNewId",[r])}serializeTerminalState(r){return this.b.call("$serializeTerminalState",[r])}};e.RemoteTerminalChannelClient=g=Le([Ae(2,L.IWorkbenchConfigurationService),Ae(3,k.IWorkspaceContextService),Ae(4,v.IConfigurationResolverService),Ae(5,d.IEnvironmentVariableService),Ae(6,A.IRemoteAuthorityResolverService),Ae(7,o.ILogService),Ae(8,R.IEditorService),Ae(9,b.ILabelService)],g)}),define(pe[275],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var y;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(y||(e.ExtHostConnectionType=y={}));class L{constructor(E){this.pipeName=E,this.type=1}serialize(E){E[L.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=L,L.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class o{constructor(){this.type=2}serialize(E){E[o.ENV_KEY]="1"}}e.SocketExtHostConnection=o,o.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class A{constructor(){this.type=3}serialize(E){E[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A,A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function k(R){delete R[L.ENV_KEY],delete R[o.ENV_KEY],delete R[A.ENV_KEY]}function T(R,E){k(E),R.serialize(E)}e.writeExtHostConnection=T;function v(R){if(R[L.ENV_KEY])return m(R,new L(R[L.ENV_KEY]));if(R[o.ENV_KEY])return m(R,new o);if(R[A.ENV_KEY])return m(R,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=v;function m(R,E){return k(R),E}}),define(pe[276],be([1,0,15]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(m){m[m.Desktop=1]="Desktop",m[m.Web=2]="Web"})(L||(e.UIKind=L={}));var o;(function(m){m[m.VersionMismatch=55]="VersionMismatch",m[m.UnexpectedError=81]="UnexpectedError"})(o||(e.ExtensionHostExitCode=o={}));var A;(function(m){m[m.Initialized=0]="Initialized",m[m.Ready=1]="Ready",m[m.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function k(m){const R=y.VSBuffer.alloc(1);switch(m){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=k;function T(m,R){if(m.byteLength!==1)return!1;switch(m.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=T;var v;(function(m){m.Start="START_NATIVE_LOG",m.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(pe[277],be([1,0,5,6,12,265,276,56,37,22,4,2,196]),function(le,e,y,L,o,A,k,T,v,m,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let d=e.ExtHostTelemetry=class extends E.Disposable{constructor(f,c){super(),this.n=f,this.p=c,this.a=this.B(new L.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=R.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=c.createLogger(this.j,{id:v.extensionTelemetryLogChannelId,name:(0,b.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(u=>{(0,o.isLogLevel)(u)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===o.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(f,c,u){const I=this.getTelemetryDetails(),O=new g(c,u,f,this.k,this.i,this.getBuiltInCommonProperties(f),{isUsageEnabled:I.isUsageEnabled,isErrorsEnabled:I.isErrorsEnabled}),t=this.m.get(f.identifier.value)??[];return this.m.set(f.identifier.value,[...t,O]),O.apiTelemetryLogger}$initializeTelemetryLevel(f,c,u){this.f=f,this.g=c,this.c=u??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(f){const c=Object.create(null);switch(c["common.extname"]=`${f.publisher}.${f.name}`,c["common.extversion"]=f.version,c["common.vscodemachineid"]=this.n.telemetryInfo.machineId,c["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,c["common.vscodeversion"]=this.n.version,c["common.isnewappinstall"]=p(this.n.telemetryInfo.firstSessionDate),c["common.product"]=this.n.environment.appHost,this.n.uiKind){case k.UIKind.Web:c["common.uikind"]="web";break;case k.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,T.getRemoteName)((0,v.cleanRemoteAuthority)(this.n.remote.authority)),c}$onDidChangeTelemetryLevel(f){this.h=this.getTelemetryConfiguration(),this.f=f;const c=this.getTelemetryDetails();this.m.forEach((u,I)=>{const O=u.filter(t=>!t.isDisposed);O.length===0?this.m.delete(I):this.m.set(I,O)}),this.m.forEach(u=>{for(const I of u)I.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(f,c){const I=this.m.get(f.value)?.filter(t=>!t.isDisposed);if(!I)return this.m.delete(f.value),!1;let O=!1;for(const t of I)t.ignoreUnhandledExtHostErrors||(t.logError(c),O=!0);return O}};e.ExtHostTelemetry=d=Le([Ae(0,A.IExtHostInitDataService),Ae(1,o.ILoggerService)],d);class g{static validateSender(f){if(typeof f!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof f.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof f.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof f.flush<"u"&&typeof f.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(f,c,u,I,O,t,n){this.g=u,this.h=I,this.i=O,this.j=t,this.a=new L.Emitter,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=f,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(f,c){this.e&&(this.d={isUsageEnabled:f,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(f){let c="properties"in f?f.properties??{}:f;return c=(0,v.cleanData)(c,[]),this.c&&(c=(0,m.mixin)(c,this.c)),this.b||(c=(0,m.mixin)(c,this.j)),"properties"in f?f.properties=c:f=c,f}k(f,c){this.f&&(this.g.publisher==="vscode"?f=this.g.name+"/"+f:f=this.g.identifier.value+"/"+f,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(f,c),this.h.trace(f,c))}logUsage(f,c){this.d.isUsageEnabled&&this.k(f,c)}logError(f,c){!this.d.isErrorsEnabled||!this.f||(typeof f=="string"?this.k(f,c):this.f.sendErrorData(f,c))}get apiTelemetryLogger(){if(!this.e){const f=this,c={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f.d.isUsageEnabled},get isErrorsEnabled(){return f.d.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f.a.event.bind(f)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let f=this.f;this.f=void 0,Promise.resolve(f.flush()).then(f=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=g;function p(r){const f=Date.now()-new Date(r).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.isNewAppInstall=p,e.IExtHostTelemetry=(0,y.createDecorator)("IExtHostTelemetry")}),define(pe[278],be([1,0,6,4,35,228,34,5]),function(le,e,y,L,o,A,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new k.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class v{constructor(O){this.dependency=O}}e.MissingExtensionDependency=v;var m;(function(I){I[I.EagerAutoStart=1]="EagerAutoStart",I[I.EagerManualStart=2]="EagerManualStart",I[I.Lazy=3]="Lazy"})(m||(e.ExtensionHostStartup=m={}));class R{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:A.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(O,t){const n=[],s=[],i=[],a=[],l=E(this.c),h=E(O),C=($,ee)=>$.extensionLocation.toString()===ee.extensionLocation.toString()||$.isBuiltin===ee.isBuiltin||$.isUserBuiltin===ee.isUserBuiltin||$.isUnderDevelopment===ee.isUnderDevelopment;for(const $ of this.c){const ee=h.get($.identifier);if(!ee){n.push($.identifier),l.delete($.identifier);continue}if(!C($,ee)){n.push($.identifier),l.delete($.identifier);continue}}for(const $ of O){const ee=l.get($.identifier);if(!ee){s.push($);continue}if(!C(ee,$)){n.push(ee.identifier),l.delete(ee.identifier);continue}}const D=new k.ExtensionIdentifierSet(this.d),w=new k.ExtensionIdentifierSet(t);for(const $ of this.d)w.has($)||i.push($);for(const $ of t)D.has($)||a.push($);const S=A.ImplicitActivationEvents.createActivationEventsMap(s),N={toRemove:n,toAdd:s,addActivationEvents:S,myToRemove:i,myToAdd:a};return this.delta(N),N}delta(O){const{toRemove:t,toAdd:n,myToRemove:s,myToAdd:i}=O,a=new k.ExtensionIdentifierSet(t),l=new k.ExtensionIdentifierSet(s);for(let h=0;h<this.c.length;h++)a.has(this.c[h].identifier)&&(this.c.splice(h,1),h--);for(let h=0;h<this.d.length;h++)l.has(this.d[h])&&(this.d.splice(h,1),h--);for(const h of n)this.c.push(h);for(const h of i)this.d.push(h)}containsExtension(O){for(const t of this.d)if(k.ExtensionIdentifier.equals(t,O))return!0;return!1}}e.ExtensionHostExtensions=R;function E(I){const O=new k.ExtensionIdentifierMap;for(const t of I)O.set(t.identifier,t);return O}function b(I,O){return!0}e.isProposedApiEnabled=b;function d(I,O){if(!b(I,O))throw new Error(`Extension '${I.identifier.value}' CANNOT use API proposal: ${O}.
Its package.json#enabledApiProposals-property declares: ${I.enabledApiProposals?.join(", ")??"[]"} but NOT ${O}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${I.identifier.value}`)}e.checkProposedApiEnabled=d;class g{constructor(O,t,n,s){this.codeLoadingTime=O,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=s}}e.ActivationTimes=g;class p{constructor(O,t){this.description=O,this.value=t}}e.ExtensionPointContribution=p;var r;(function(I){I[I.Normal=0]="Normal",I[I.Immediate=1]="Immediate"})(r||(e.ActivationKind=r={}));function f(I){return{type:I.isBuiltin?0:1,isBuiltin:I.isBuiltin||I.isUserBuiltin,identifier:{id:(0,o.getGalleryExtensionId)(I.publisher,I.name),uuid:I.uuid},manifest:I,location:I.extensionLocation,targetPlatform:I.targetPlatform,validations:[],isValid:!0}}e.toExtension=f;function c(I,O){return{identifier:new k.ExtensionIdentifier((0,o.getExtensionId)(I.manifest.publisher,I.manifest.name)),isBuiltin:I.type===0,isUserBuiltin:I.type===1&&I.isBuiltin,isUnderDevelopment:!!O,extensionLocation:I.location,...I.manifest,uuid:I.identifier.uuid,targetPlatform:I.targetPlatform}}e.toExtensionDescription=c;class u{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(O){return Promise.resolve(void 0)}activationEventIsDone(O){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(O){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(O,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(O){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u});var kt=this&&this.__classPrivateFieldSet||function(le,e,y,L,o){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!o)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?le!==e||!o:!e.has(le))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?o.call(le,y):o?o.value=y:e.set(le,y),y},st=this&&this.__classPrivateFieldGet||function(le,e,y,L){if(y==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?le!==e||!L:!e.has(le))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?L:y==="a"?L.call(le):L?L.value:e.get(le)};define(pe[134],be([1,0,18,9,99,28,58,17,8,4,21,34,16,116,129,278]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p){"use strict";var r,f,c,u,I,O,t,n,s,i,a,l,h,C,D,w,S,N,$,ee,he,oe,ue,me,_,re;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.NotebookCodeActionKind=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function q(B){return Object.assign(B,{apply:function(){const ae=arguments.length===1?[]:arguments[1];return Reflect.construct(B,ae,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(B,[]);{const[ae,...ve]=arguments;return Reflect.construct(B,ve,ae.constructor)}}})}var J;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(J||(e.TerminalOutputAnchor=J={}));var U;(function(B){B[B.Command=0]="Command",B[B.Opener=1]="Opener"})(U||(e.TerminalQuickFixType=U={}));let ne=e.Disposable=s=class{static from(...F){let ae=F;return new s(function(){if(ae){for(const ve of ae)ve&&typeof ve.dispose=="function"&&ve.dispose();ae=void 0}})}constructor(F){r.set(this,void 0),kt(this,r,F,"f")}dispose(){typeof st(this,r,"f")=="function"&&(st(this,r,"f").call(this),kt(this,r,void 0,"f"))}};r=new WeakMap,e.Disposable=ne=s=Le([q],ne);let V=e.Position=i=class{static Min(...F){if(F.length===0)throw new TypeError;let ae=F[0];for(let ve=1;ve<F.length;ve++){const Ue=F[ve];Ue.isBefore(ae)&&(ae=Ue)}return ae}static Max(...F){if(F.length===0)throw new TypeError;let ae=F[0];for(let ve=1;ve<F.length;ve++){const Ue=F[ve];Ue.isAfter(ae)&&(ae=Ue)}return ae}static isPosition(F){if(!F)return!1;if(F instanceof i)return!0;const{line:ae,character:ve}=F;return typeof ae=="number"&&typeof ve=="number"}static of(F){if(F instanceof i)return F;if(this.isPosition(F))return new i(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,ae){if(F<0)throw(0,L.illegalArgument)("line must be non-negative");if(ae<0)throw(0,L.illegalArgument)("character must be non-negative");this.c=F,this.e=ae}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,ae=0){if(F===null||ae===null)throw(0,L.illegalArgument)();let ve;return typeof F>"u"?ve=0:typeof F=="number"?ve=F:(ve=typeof F.lineDelta=="number"?F.lineDelta:0,ae=typeof F.characterDelta=="number"?F.characterDelta:0),ve===0&&ae===0?this:new i(this.line+ve,this.character+ae)}with(F,ae=this.character){if(F===null||ae===null)throw(0,L.illegalArgument)();let ve;return typeof F>"u"?ve=this.line:typeof F=="number"?ve=F:(ve=typeof F.line=="number"?F.line:this.line,ae=typeof F.character=="number"?F.character:this.character),ve===this.line&&ae===this.character?this:new i(ve,ae)}toJSON(){return{line:this.line,character:this.character}}};e.Position=V=i=Le([q],V);let se=e.Range=a=class{static isRange(F){return F instanceof a?!0:F?V.isPosition(F.start)&&V.isPosition(F.end):!1}static of(F){if(F instanceof a)return F;if(this.isRange(F))return new a(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,ae,ve,Ue){let xe,Ze;if(typeof F=="number"&&typeof ae=="number"&&typeof ve=="number"&&typeof Ue=="number"?(xe=new V(F,ae),Ze=new V(ve,Ue)):V.isPosition(F)&&V.isPosition(ae)&&(xe=V.of(F),Ze=V.of(ae)),!xe||!Ze)throw new Error("Invalid arguments");xe.isBefore(Ze)?(this.c=xe,this.e=Ze):(this.c=Ze,this.e=xe)}contains(F){return a.isRange(F)?this.contains(F.start)&&this.contains(F.end):V.isPosition(F)?!(V.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const ae=V.Max(F.start,this.c),ve=V.Min(F.end,this.e);if(!ae.isAfter(ve))return new a(ae,ve)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const ae=V.Min(F.start,this.c),ve=V.Max(F.end,this.end);return new a(ae,ve)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,ae=this.end){if(F===null||ae===null)throw(0,L.illegalArgument)();let ve;return F?V.isPosition(F)?ve=F:(ve=F.start||this.start,ae=F.end||this.end):ve=this.start,ve.isEqual(this.c)&&ae.isEqual(this.end)?this:new a(ve,ae)}toJSON(){return[this.start,this.end]}};e.Range=se=a=Le([q],se);let Y=e.Selection=l=class extends se{static isSelection(F){return F instanceof l?!0:F?se.isRange(F)&&V.isPosition(F.anchor)&&V.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,ae,ve,Ue){let xe,Ze;if(typeof F=="number"&&typeof ae=="number"&&typeof ve=="number"&&typeof Ue=="number"?(xe=new V(F,ae),Ze=new V(ve,Ue)):V.isPosition(F)&&V.isPosition(ae)&&(xe=V.of(F),Ze=V.of(ae)),!xe||!Ze)throw new Error("Invalid arguments");super(xe,Ze),this.f=xe,this.g=Ze}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=Y=l=Le([q],Y);const ie=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,L.illegalArgument)("connectionToken")};class z{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,ae,ve){if(typeof F!="string"||F.length===0)throw(0,L.illegalArgument)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,L.illegalArgument)("port");typeof ve<"u"&&ie(ve),this.host=F,this.port=Math.round(ae),this.connectionToken=ve}}e.ResolvedAuthority=z;class P{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,ae){this.makeConnection=F,this.connectionToken=ae,typeof ae<"u"&&ie(ae)}}e.ManagedResolvedAuthority=P;class M extends Error{static NotAvailable(F,ae){return new M(F,d.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(F){return new M(F,d.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,ae=d.RemoteAuthorityResolverErrorCode.Unknown,ve){super(F),this._message=F,this._code=ae,this._detail=ve,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M;var K;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(K||(e.EndOfLine=K={}));var te;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(te||(e.EnvironmentVariableMutatorType=te={}));let j=e.TextEdit=h=class{static isTextEdit(F){return F instanceof h?!0:F?se.isRange(F)&&typeof F.newText=="string":!1}static replace(F,ae){return new h(F,ae)}static insert(F,ae){return h.replace(new se(F,F),ae)}static delete(F){return h.replace(F,"")}static setEndOfLine(F){const ae=new h(new se(new V(0,0),new V(0,0)),"");return ae.newEol=F,ae}get range(){return this.c}set range(F){if(F&&!se.isRange(F))throw(0,L.illegalArgument)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,L.illegalArgument)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,L.illegalArgument)("newEol");this.f=F}constructor(F,ae){this.c=F,this.e=ae}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.TextEdit=j=h=Le([q],j);let W=e.NotebookEdit=C=class{static isNotebookCellEdit(F){return F instanceof C?!0:F?Nt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,ae){return new C(F,ae)}static insertCells(F,ae){return new C(new Nt(F,F),ae)}static deleteCells(F){return new C(F,[])}static updateCellMetadata(F,ae){const ve=new C(new Nt(F,F),[]);return ve.newCellMetadata=ae,ve}static updateNotebookMetadata(F){const ae=new C(new Nt(0,0),[]);return ae.newNotebookMetadata=F,ae}constructor(F,ae){this.range=F,this.newCells=ae}};e.NotebookEdit=W=C=Le([q],W);class x{static isSnippetTextEdit(F){return F instanceof x?!0:F?se.isRange(F.range)&&G.isSnippetString(F.snippet):!1}static replace(F,ae){return new x(F,ae)}static insert(F,ae){return x.replace(new se(F,F),ae)}constructor(F,ae){this.range=F,this.snippet=ae}}e.SnippetTextEdit=x;var H;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(H||(e.FileEditType=H={}));let Q=e.WorkspaceEdit=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,ae,ve,Ue){this.c.push({_type:1,from:F,to:ae,options:ve,metadata:Ue})}createFile(F,ae,ve){this.c.push({_type:1,from:void 0,to:F,options:ae,metadata:ve})}deleteFile(F,ae,ve){this.c.push({_type:1,from:F,to:void 0,options:ae,metadata:ve})}e(F,ae,ve){this.c.push({_type:3,metadata:ve,uri:F,edit:{editType:5,metadata:ae},notebookMetadata:ae})}f(F,ae,ve,Ue){const xe=ae.start,Ze=ae.end;(xe!==Ze||ve.length>0)&&this.c.push({_type:5,uri:F,index:xe,count:Ze-xe,cells:ve,metadata:Ue})}g(F,ae,ve,Ue){this.c.push({_type:3,metadata:Ue,uri:F,edit:{editType:8,index:ae,metadata:ve}})}replace(F,ae,ve,Ue){this.c.push({_type:2,uri:F,edit:new j(ae,ve),metadata:Ue})}insert(F,ae,ve,Ue){this.replace(F,new se(ae,ae),ve,Ue)}delete(F,ae,ve){this.replace(F,ae,"",ve)}has(F){return this.c.some(ae=>ae._type===2&&ae.uri.toString()===F.toString())}set(F,ae){if(ae)for(const ve of ae){if(!ve)continue;let Ue,xe;Array.isArray(ve)?(Ue=ve[0],xe=ve[1]):Ue=ve,W.isNotebookCellEdit(Ue)?Ue.newCellMetadata?this.g(F,Ue.range.start,Ue.newCellMetadata,xe):Ue.newNotebookMetadata?this.e(F,Ue.newNotebookMetadata,xe):this.f(F,Ue.range,Ue.newCells,xe):x.isSnippetTextEdit(Ue)?this.c.push({_type:6,uri:F,range:Ue.range,edit:Ue.snippet,metadata:xe}):this.c.push({_type:2,uri:F,edit:Ue,metadata:xe})}else{for(let ve=0;ve<this.c.length;ve++){const Ue=this.c[ve];switch(Ue._type){case 2:case 6:case 3:case 5:Ue.uri.toString()===F.toString()&&(this.c[ve]=void 0);break}}(0,y.coalesceInPlace)(this.c)}}get(F){const ae=[];for(const ve of this.c)ve._type===2&&ve.uri.toString()===F.toString()&&ae.push(ve.edit);return ae}entries(){const F=new A.ResourceMap;for(const ae of this.c)if(ae._type===2){let ve=F.get(ae.uri);ve||(ve=[ae.uri,[]],F.set(ae.uri,ve)),ve[1].push(ae.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=Q=Le([q],Q);let G=e.SnippetString=D=class{static isSnippetString(F){return F instanceof D?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=D.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,ae=this.e++){if(typeof F=="function"){const ve=new D;ve.e=this.e,F(ve),this.e=ve.e,F=ve.value}else F=D.c(F);return this.value+="${",this.value+=ae,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,ae=this.e++){const ve=F.map(Ue=>Ue.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=ve,this.value+="|}",this}appendVariable(F,ae){if(typeof ae=="function"){const ve=new D;ve.e=this.e,ae(ve),this.e=ve.e,ae=ve.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};e.SnippetString=G=D=Le([q],G);var Z;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(Z||(e.DiagnosticTag=Z={}));var ce;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ce||(e.DiagnosticSeverity=ce={}));let Ee=e.Location=w=class{static isLocation(F){return F instanceof w?!0:F?se.isRange(F.range)&&m.URI.isUri(F.uri):!1}constructor(F,ae){if(this.uri=F,ae)if(se.isRange(ae))this.range=se.of(ae);else if(V.isPosition(ae))this.range=new se(ae,ae);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=Ee=w=Le([q],Ee);let Ce=e.DiagnosticRelatedInformation=class{static is(F){return F?typeof F.message=="string"&&F.location&&se.isRange(F.location.range)&&m.URI.isUri(F.location.uri):!1}constructor(F,ae){this.location=F,this.message=ae}static isEqual(F,ae){return F===ae?!0:!F||!ae?!1:F.message===ae.message&&F.location.range.isEqual(ae.location.range)&&F.location.uri.toString()===ae.location.uri.toString()}};e.DiagnosticRelatedInformation=Ce=Le([q],Ce);let ke=e.Diagnostic=class{constructor(F,ae,ve=ce.Error){if(!se.isRange(F))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=F,this.message=ae,this.severity=ve}toJSON(){return{severity:ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,ae){return F===ae?!0:!F||!ae?!1:F.message===ae.message&&F.severity===ae.severity&&F.code===ae.code&&F.severity===ae.severity&&F.source===ae.source&&F.range.isEqual(ae.range)&&(0,y.equals)(F.tags,ae.tags)&&(0,y.equals)(F.relatedInformation,ae.relatedInformation,Ce.isEqual)}};e.Diagnostic=ke=Le([q],ke);let Fe=e.Hover=class{constructor(F,ae){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=ae}};e.Hover=Fe=Le([q],Fe);var je;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(je||(e.DocumentHighlightKind=je={}));let ge=e.DocumentHighlight=class{constructor(F,ae=je.Text){this.range=F,this.kind=ae}toJSON(){return{range:this.range,kind:je[this.kind]}}};e.DocumentHighlight=ge=Le([q],ge);var Se;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Se||(e.SymbolKind=Se={}));var ye;(function(B){B[B.Deprecated=1]="Deprecated"})(ye||(e.SymbolTag=ye={}));let Me=e.SymbolInformation=S=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,ae,ve,Ue,xe){this.name=F,this.kind=ae,this.containerName=xe,typeof ve=="string"&&(this.containerName=ve),Ue instanceof Ee?this.location=Ue:ve instanceof se&&(this.location=new Ee(Ue,ve)),S.validate(this)}toJSON(){return{name:this.name,kind:Se[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Me=S=Le([q],Me);let ze=e.DocumentSymbol=N=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(N.validate)}constructor(F,ae,ve,Ue,xe){this.name=F,this.detail=ae,this.kind=ve,this.range=Ue,this.selectionRange=xe,this.children=[],N.validate(this)}};e.DocumentSymbol=ze=N=Le([q],ze);var _e;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(_e||(e.CodeActionTriggerKind=_e={}));let qe=e.CodeAction=class{constructor(F,ae){this.title=F,this.kind=ae}};e.CodeAction=qe=Le([q],qe);let Ve=e.CodeActionKind=$=class{constructor(F){this.value=F}append(F){return new $(this.value?this.value+$.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+$.c)}};Ve.c=".",e.CodeActionKind=Ve=$=Le([q],Ve);class et extends Ve{constructor(F){super(F),this.value=F}}e.NotebookCodeActionKind=et,Ve.Empty=new Ve(""),Ve.QuickFix=Ve.Empty.append("quickfix"),Ve.Refactor=Ve.Empty.append("refactor"),Ve.RefactorExtract=Ve.Refactor.append("extract"),Ve.RefactorInline=Ve.Refactor.append("inline"),Ve.RefactorMove=Ve.Refactor.append("move"),Ve.RefactorRewrite=Ve.Refactor.append("rewrite"),Ve.Source=Ve.Empty.append("source"),Ve.SourceOrganizeImports=Ve.Source.append("organizeImports"),Ve.SourceFixAll=Ve.Source.append("fixAll"),Ve.Notebook=Ve.Empty.append("notebook");let rt=e.SelectionRange=class{constructor(F,ae){if(this.range=F,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=rt=Le([q],rt);class Ge{constructor(F,ae,ve,Ue,xe,Ze){this.kind=F,this.name=ae,this.detail=ve,this.uri=Ue,this.range=xe,this.selectionRange=Ze}}e.CallHierarchyItem=Ge;class Xe{constructor(F,ae){this.fromRanges=ae,this.from=F}}e.CallHierarchyIncomingCall=Xe;class fe{constructor(F,ae){this.fromRanges=ae,this.to=F}}e.CallHierarchyOutgoingCall=fe;var Ie;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Ie||(e.LanguageStatusSeverity=Ie={}));let Te=e.CodeLens=class{constructor(F,ae){this.range=F,this.command=ae}get isResolved(){return!!this.command}};e.CodeLens=Te=Le([q],Te);let Re=e.MarkdownString=ee=class{static isMarkdownString(F){return F instanceof ee?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,ae=!1){f.set(this,void 0),kt(this,f,new o.MarkdownString(F,{supportThemeIcons:ae}),"f")}get value(){return st(this,f,"f").value}set value(F){st(this,f,"f").value=F}get isTrusted(){return st(this,f,"f").isTrusted}set isTrusted(F){st(this,f,"f").isTrusted=F}get supportThemeIcons(){return st(this,f,"f").supportThemeIcons}set supportThemeIcons(F){st(this,f,"f").supportThemeIcons=F}get supportHtml(){return st(this,f,"f").supportHtml}set supportHtml(F){st(this,f,"f").supportHtml=F}get baseUri(){return st(this,f,"f").baseUri}set baseUri(F){st(this,f,"f").baseUri=F}appendText(F){return st(this,f,"f").appendText(F),this}appendMarkdown(F){return st(this,f,"f").appendMarkdown(F),this}appendCodeblock(F,ae){return st(this,f,"f").appendCodeblock(ae??"",F),this}};f=new WeakMap,e.MarkdownString=Re=ee=Le([q],Re);let Oe=e.ParameterInformation=class{constructor(F,ae){this.label=F,this.documentation=ae}};e.ParameterInformation=Oe=Le([q],Oe);let $e=e.SignatureInformation=class{constructor(F,ae){this.label=F,this.documentation=ae,this.parameters=[]}};e.SignatureInformation=$e=Le([q],$e);let We=e.SignatureHelp=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=We=Le([q],We);var Qe;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(Qe||(e.SignatureHelpTriggerKind=Qe={}));var Ye;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(Ye||(e.InlayHintKind=Ye={}));let Ke=e.InlayHintLabelPart=class{constructor(F){this.value=F}};e.InlayHintLabelPart=Ke=Le([q],Ke);let tt=e.InlayHint=class{constructor(F,ae,ve){this.position=F,this.label=ae,this.kind=ve}};e.InlayHint=tt=Le([q],tt);var it;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(it||(e.CompletionTriggerKind=it={}));var ut;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(ut||(e.CompletionItemKind=ut={}));var Et;(function(B){B[B.Deprecated=1]="Deprecated"})(Et||(e.CompletionItemTag=Et={}));let ot=e.CompletionItem=class{constructor(F,ae){this.label=F,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&ut[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=ot=Le([q],ot);let Mt=e.CompletionList=class{constructor(F=[],ae=!1){this.items=F,this.isIncomplete=ae}};e.CompletionList=Mt=Le([q],Mt);let dt=e.InlineSuggestion=class{constructor(F,ae,ve){this.insertText=F,this.range=ae,this.command=ve}};e.InlineSuggestion=dt=Le([q],dt);let mt=e.InlineSuggestionList=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.InlineSuggestionList=mt=Le([q],mt);var gt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(gt||(e.ViewColumn=gt={}));var wt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(wt||(e.StatusBarAlignment=wt={}));function Ut(B,F){return`${E.ExtensionIdentifier.toKey(B)}.${F}`}e.asStatusBarItemIdentifier=Ut;var At;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(At||(e.TextEditorLineNumbersStyle=At={}));var yt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(yt||(e.TextDocumentSaveReason=yt={}));var Rt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Rt||(e.TextEditorRevealType=Rt={}));var St;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(St||(e.TextEditorSelectionChangeKind=St={}));var pt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(pt||(e.TextDocumentChangeReason=pt={}));var Tt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Tt||(e.DecorationRangeBehavior=Tt={})),function(B){function F(ae){switch(ae){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=F}(St||(e.TextEditorSelectionChangeKind=St={}));let Lt=e.DocumentLink=class{constructor(F,ae){if(ae&&!m.URI.isUri(ae))throw(0,L.illegalArgument)("target");if(!se.isRange(F)||F.isEmpty)throw(0,L.illegalArgument)("range");this.range=F,this.target=ae}};e.DocumentLink=Lt=Le([q],Lt);let we=e.Color=class{constructor(F,ae,ve,Ue){this.red=F,this.green=ae,this.blue=ve,this.alpha=Ue}};e.Color=we=Le([q],we);let De=e.ColorInformation=class{constructor(F,ae){if(ae&&!(ae instanceof we))throw(0,L.illegalArgument)("color");if(!se.isRange(F)||F.isEmpty)throw(0,L.illegalArgument)("range");this.range=F,this.color=ae}};e.ColorInformation=De=Le([q],De);let de=e.ColorPresentation=class{constructor(F){if(!F||typeof F!="string")throw(0,L.illegalArgument)("label");this.label=F}};e.ColorPresentation=de=Le([q],de);var X;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(X||(e.ColorFormat=X={}));var Pe;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Pe||(e.SourceControlInputBoxValidationType=Pe={}));var Ne;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(Ne||(e.TerminalExitReason=Ne={}));class He{constructor(F,ae,ve){if(this.startIndex=F,this.length=ae,this.tooltip=ve,typeof F!="number"||F<0)throw(0,L.illegalArgument)("startIndex");if(typeof ae!="number"||ae<1)throw(0,L.illegalArgument)("length");if(ve!==void 0&&typeof ve!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=He;class Be{constructor(F){this.uri=F}}e.TerminalQuickFixOpener=Be;class Je{constructor(F){this.terminalCommand=F}}e.TerminalQuickFixCommand=Je;var ct;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(ct||(e.TerminalLocation=ct={}));class vt{constructor(F){if(this.options=F,typeof F!="object")throw(0,L.illegalArgument)("options")}}e.TerminalProfile=vt;var ft;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(ft||(e.TaskRevealKind=ft={}));var lt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(lt||(e.TaskPanelKind=lt={}));let at=e.TaskGroup=he=class{static from(F){switch(F){case"clean":return he.Clean;case"build":return he.Build;case"rebuild":return he.Rebuild;case"test":return he.Test;default:return}}constructor(F,ae){if(this.label=ae,typeof F!="string"||typeof ae!="string")throw(0,L.illegalArgument)("name");this.c=F}get id(){return this.c}};at.Clean=new he("clean","Clean"),at.Build=new he("build","Build"),at.Rebuild=new he("rebuild","Rebuild"),at.Test=new he("test","Test"),e.TaskGroup=at=he=Le([q],at);function ni(B){let F="";for(let ae=0;ae<B.length;ae++)F+=B[ae].replace(/,/g,",,")+",";return F}let Xt=e.ProcessExecution=class{constructor(F,ae,ve){if(typeof F!="string")throw(0,L.illegalArgument)("process");this.e=[],this.c=F,ae!==void 0&&(Array.isArray(ae)?(this.e=ae,this.f=ve):this.f=ae)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,L.illegalArgument)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const ae of this.e)F.push(ae);return ni(F)}};e.ProcessExecution=Xt=Le([q],Xt);let Jt=e.ShellExecution=class{constructor(F,ae,ve){if(this.f=[],Array.isArray(ae)){if(!F)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,L.illegalArgument)("command");this.e=F,this.f=ae,this.g=ve}else{if(typeof F!="string")throw(0,L.illegalArgument)("commandLine");this.c=F,this.g=ae}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,L.illegalArgument)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,L.illegalArgument)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ae of this.f)F.push(typeof ae=="string"?ae:ae.value);return ni(F)}};e.ShellExecution=Jt=Le([q],Jt);var ri;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var Vt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Vt||(e.TaskScope=Vt={}));class si{constructor(F){this.c=F}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(F){this.c=F}get callback(){return this.c}}e.CustomExecution=si;let Bt=e.Task=oe=class{constructor(F,ae,ve,Ue,xe,Ze){this.j=!1,this.k=this.definition=F;let nt;typeof ae=="string"?(this.m=this.name=ae,this.t=this.source=ve,this.execution=Ue,nt=xe,this.j=!0):ae===Vt.Global||ae===Vt.Workspace?(this.target=ae,this.m=this.name=ve,this.t=this.source=Ue,this.execution=xe,nt=Ze):(this.target=ae,this.m=this.name=ve,this.t=this.source=Ue,this.execution=xe,nt=Ze),typeof nt=="string"?(this.o=[nt],this.q=!0):Array.isArray(nt)?(this.o=nt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(F){this.h=F}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Xt?this.k={type:oe.e,id:this.n.computeId()}:this.n instanceof Jt?this.k={type:oe.f,id:this.n.computeId()}:this.n instanceof si?this.k={type:oe.c,id:this.n.computeId()}:this.k={type:oe.g,id:(0,R.generateUuid)()}}get definition(){return this.k}set definition(F){if(F==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=F}get scope(){return this.l}set target(F){this.y(),this.l=F}get name(){return this.m}set name(F){if(typeof F!="string")throw(0,L.illegalArgument)("name");this.y(),this.m=F}get execution(){return this.n}set execution(F){F===null&&(F=void 0),this.y(),this.n=F;const ae=this.k.type;(oe.g===ae||oe.e===ae||oe.f===ae||oe.c===ae)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(F){if(Array.isArray(F))this.y(),this.o=F,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.y(),this.r=F}get source(){return this.t}set source(F){if(typeof F!="string"||F.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.y(),this.t=F}get group(){return this.u}set group(F){F===null&&(F=void 0),this.y(),this.u=F}get detail(){return this.x}set detail(F){F===null&&(F=void 0),this.x=F}get presentationOptions(){return this.v}set presentationOptions(F){F==null&&(F=Object.create(null)),this.y(),this.v=F}get runOptions(){return this.w}set runOptions(F){F==null&&(F=Object.create(null)),this.y(),this.w=F}};Bt.c="customExecution",Bt.e="process",Bt.f="shell",Bt.g="$empty",e.Task=Bt=oe=Le([q],Bt);var oi;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(oi||(e.ProgressLocation=oi={}));var ai;(function(B){function F(ae){const ve=ae;return(0,v.isNumber)(ve.value)?ve.tooltip&&!(0,v.isString)(ve.tooltip)?(console.log("INVALID view badge, invalid tooltip",ve.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ve.value),!1)}B.isViewBadge=F})(ai||(e.ViewBadge=ai={}));let li=e.TreeItem=ue=class{static isTreeItem(F,ae){const ve=F;if(ve.checkboxState!==void 0){(0,p.checkProposedApiEnabled)(ae,"treeItemCheckbox");const Ue=(0,v.isNumber)(ve.checkboxState)?ve.checkboxState:(0,v.isObject)(ve.checkboxState)&&(0,v.isNumber)(ve.checkboxState.state)?ve.checkboxState.state:void 0,xe=!(0,v.isNumber)(ve.checkboxState)&&(0,v.isObject)(ve.checkboxState)?ve.checkboxState.tooltip:void 0;if(Ue===void 0||Ue!==xt.Checked&&Ue!==xt.Unchecked||xe!==void 0&&!(0,v.isString)(xe))return console.log("INVALID tree item, invalid checkboxState",ve.checkboxState),!1}if(F instanceof ue)return!0;if(ve.label!==void 0&&!(0,v.isString)(ve.label)&&!ve.label?.label)return console.log("INVALID tree item, invalid label",ve.label),!1;if(ve.id!==void 0&&!(0,v.isString)(ve.id))return console.log("INVALID tree item, invalid id",ve.id),!1;if(ve.iconPath!==void 0&&!(0,v.isString)(ve.iconPath)&&!m.URI.isUri(ve.iconPath)&&(!ve.iconPath||!(0,v.isString)(ve.iconPath.id))){const Ue=ve.iconPath;if(!Ue||!(0,v.isString)(Ue.light)&&!m.URI.isUri(Ue.light)&&!(0,v.isString)(Ue.dark)&&!m.URI.isUri(Ue.dark))return console.log("INVALID tree item, invalid iconPath",ve.iconPath),!1}return ve.description!==void 0&&!(0,v.isString)(ve.description)&&typeof ve.description!="boolean"?(console.log("INVALID tree item, invalid description",ve.description),!1):ve.resourceUri!==void 0&&!m.URI.isUri(ve.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ve.resourceUri),!1):ve.tooltip!==void 0&&!(0,v.isString)(ve.tooltip)&&!(ve.tooltip instanceof Re)?(console.log("INVALID tree item, invalid tooltip",ve.tooltip),!1):ve.command!==void 0&&!ve.command.command?(console.log("INVALID tree item, invalid command",ve.command),!1):ve.collapsibleState!==void 0&&ve.collapsibleState<zt.None&&ve.collapsibleState>zt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ve.collapsibleState),!1):ve.contextValue!==void 0&&!(0,v.isString)(ve.contextValue)?(console.log("INVALID tree item, invalid contextValue",ve.contextValue),!1):ve.accessibilityInformation!==void 0&&!ve.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ve.accessibilityInformation),!1):!0}constructor(F,ae=zt.None){this.collapsibleState=ae,m.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.TreeItem=li=ue=Le([q],li);var zt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(zt||(e.TreeItemCollapsibleState=zt={}));var xt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(xt||(e.TreeItemCheckboxState=xt={}));let Qt=e.DataTransferItem=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.DataTransferItem=Qt=Le([q],Qt);class ci extends Qt{}e.InternalDataTransferItem=ci;class En extends ci{constructor(F){super(""),c.set(this,void 0),kt(this,c,F,"f")}asFile(){return st(this,c,"f")}}e.InternalFileDataTransferItem=En,c=new WeakMap;class wn{constructor(F,ae,ve,Ue){this.name=F,this.uri=ae,this._itemId=ve,this.c=Ue}data(){return this.c()}}e.DataTransferFile=wn;let ui=e.DataTransfer=class{constructor(F){u.add(this),I.set(this,new Map);for(const[ae,ve]of F??[]){const Ue=st(this,I,"f").get(st(this,u,"m",O).call(this,ae));Ue?Ue.push(ve):st(this,I,"f").set(st(this,u,"m",O).call(this,ae),[ve])}}get(F){return st(this,I,"f").get(st(this,u,"m",O).call(this,F))?.[0]}set(F,ae){st(this,I,"f").set(st(this,u,"m",O).call(this,F),[ae])}forEach(F,ae){for(const[ve,Ue]of st(this,I,"f"))for(const xe of Ue)F.call(ae,xe,ve,this)}*[(I=new WeakMap,u=new WeakSet,Symbol.iterator)](){for(const[F,ae]of st(this,I,"f"))for(const ve of ae)yield[F,ve]}};O=function(F){return F.toLowerCase()},e.DataTransfer=ui=Le([q],ui);let hi=e.DocumentDropEdit=class{constructor(F){this.insertText=F}};e.DocumentDropEdit=hi=Le([q],hi);let fi=e.DocumentPasteEdit=class{constructor(F,ae,ve){this.id=ae,this.label=ve,this.insertText=F}};e.DocumentPasteEdit=fi=Le([q],fi);let Ot=e.ThemeIcon=class{constructor(F,ae){this.id=F,this.color=ae}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.ThemeIcon=Ot=Le([q],Ot),Ot.File=new Ot("file"),Ot.Folder=new Ot("folder");let di=e.ThemeColor=class{constructor(F){this.id=F}};e.ThemeColor=di=Le([q],di);var mi;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(mi||(e.ConfigurationTarget=mi={}));let gi=e.RelativePattern=class{get base(){return this.c}set base(F){this.c=F,this.e=m.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,ae){if(typeof F!="string"&&(!F||!m.URI.isUri(F)&&!m.URI.isUri(F.uri)))throw(0,L.illegalArgument)("base");if(typeof ae!="string")throw(0,L.illegalArgument)("pattern");typeof F=="string"?this.baseUri=m.URI.file(F):m.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=ae}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=gi=Le([q],gi);const pi=new WeakMap;function yn(B,F){pi.set(B,F)}e.setBreakpointId=yn;let jt=e.Breakpoint=class{constructor(F,ae,ve,Ue){this.enabled=typeof F=="boolean"?F:!0,typeof ae=="string"&&(this.condition=ae),typeof ve=="string"&&(this.hitCondition=ve),typeof Ue=="string"&&(this.logMessage=Ue)}get id(){return this.c||(this.c=pi.get(this)??(0,R.generateUuid)()),this.c}};e.Breakpoint=jt=Le([q],jt);let vi=e.SourceBreakpoint=class extends jt{constructor(F,ae,ve,Ue,xe){if(super(ae,ve,Ue,xe),F===null)throw(0,L.illegalArgument)("location");this.location=F}};e.SourceBreakpoint=vi=Le([q],vi);let bi=e.FunctionBreakpoint=class extends jt{constructor(F,ae,ve,Ue,xe){super(ae,ve,Ue,xe),this.functionName=F}};e.FunctionBreakpoint=bi=Le([q],bi);let Ei=e.DataBreakpoint=class extends jt{constructor(F,ae,ve,Ue,xe,Ze,nt){if(super(Ue,xe,Ze,nt),!ae)throw(0,L.illegalArgument)("dataId");this.label=F,this.dataId=ae,this.canPersist=ve}};e.DataBreakpoint=Ei=Le([q],Ei);let wi=e.DebugAdapterExecutable=class{constructor(F,ae,ve){this.command=F,this.args=ae||[],this.options=ve}};e.DebugAdapterExecutable=wi=Le([q],wi);let yi=e.DebugAdapterServer=class{constructor(F,ae){this.port=F,this.host=ae}};e.DebugAdapterServer=yi=Le([q],yi);let Si=e.DebugAdapterNamedPipeServer=class{constructor(F){this.path=F}};e.DebugAdapterNamedPipeServer=Si=Le([q],Si);let Ii=e.DebugAdapterInlineImplementation=class{constructor(F){this.implementation=F}};e.DebugAdapterInlineImplementation=Ii=Le([q],Ii);let Di=e.StackFrameFocus=class{constructor(F,ae,ve){this.session=F,this.threadId=ae,this.frameId=ve}};e.StackFrameFocus=Di=Le([q],Di);let Ci=e.ThreadFocus=class{constructor(F,ae){this.session=F,this.threadId=ae}};e.ThreadFocus=Ci=Le([q],Ci);let Pi=e.EvaluatableExpression=class{constructor(F,ae){this.range=F,this.expression=ae}};e.EvaluatableExpression=Pi=Le([q],Pi);var ki;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(ki||(e.InlineCompletionTriggerKind=ki={}));let Ai=e.InlineValueText=class{constructor(F,ae){this.range=F,this.text=ae}};e.InlineValueText=Ai=Le([q],Ai);let Ri=e.InlineValueVariableLookup=class{constructor(F,ae,ve=!0){this.range=F,this.variableName=ae,this.caseSensitiveLookup=ve}};e.InlineValueVariableLookup=Ri=Le([q],Ri);let Ti=e.InlineValueEvaluatableExpression=class{constructor(F,ae){this.range=F,this.expression=ae}};e.InlineValueEvaluatableExpression=Ti=Le([q],Ti);let Li=e.InlineValueContext=class{constructor(F,ae){this.frameId=F,this.stoppedLocation=ae}};e.InlineValueContext=Li=Le([q],Li);var Oi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Oi||(e.FileChangeType=Oi={}));let Ni=e.FileSystemError=me=class extends Error{static FileExists(F){return new me(F,b.FileSystemProviderErrorCode.FileExists,me.FileExists)}static FileNotFound(F){return new me(F,b.FileSystemProviderErrorCode.FileNotFound,me.FileNotFound)}static FileNotADirectory(F){return new me(F,b.FileSystemProviderErrorCode.FileNotADirectory,me.FileNotADirectory)}static FileIsADirectory(F){return new me(F,b.FileSystemProviderErrorCode.FileIsADirectory,me.FileIsADirectory)}static NoPermissions(F){return new me(F,b.FileSystemProviderErrorCode.NoPermissions,me.NoPermissions)}static Unavailable(F){return new me(F,b.FileSystemProviderErrorCode.Unavailable,me.Unavailable)}constructor(F,ae=b.FileSystemProviderErrorCode.Unknown,ve){super(m.URI.isUri(F)?F.toString(!0):F),this.code=ve?.name??"Unknown",(0,b.markAsFileSystemProviderError)(this,ae),Object.setPrototypeOf(this,me.prototype),typeof Error.captureStackTrace=="function"&&typeof ve=="function"&&Error.captureStackTrace(this,ve)}};e.FileSystemError=Ni=me=Le([q],Ni);let Fi=e.FoldingRange=class{constructor(F,ae,ve){this.start=F,this.end=ae,this.kind=ve}};e.FoldingRange=Fi=Le([q],Fi);var Mi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Mi||(e.FoldingRangeKind=Mi={}));var Ui;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Ui||(e.CommentThreadCollapsibleState=Ui={}));var Bi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Bi||(e.CommentMode=Bi={}));var zi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(zi||(e.CommentState=zi={}));var ji;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(ji||(e.CommentThreadState=ji={}));class Sn{constructor(F,ae=[]){this.tokenTypes=F,this.tokenModifiers=ae}}e.SemanticTokensLegend=Sn;function In(B){return typeof B>"u"||(0,v.isStringArray)(B)}class Zt{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,F){this.l=!0;for(let ae=0,ve=F.tokenTypes.length;ae<ve;ae++)this.j.set(F.tokenTypes[ae],ae);for(let ae=0,ve=F.tokenModifiers.length;ae<ve;ae++)this.k.set(F.tokenModifiers[ae],ae)}}push(F,ae,ve,Ue,xe){if(typeof F=="number"&&typeof ae=="number"&&typeof ve=="number"&&typeof Ue=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.n(F,ae,ve,Ue,xe);if(se.isRange(F)&&typeof ae=="string"&&In(ve))return this.m(F,ae,ve);throw(0,L.illegalArgument)()}m(F,ae,ve){if(!this.l)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ae))throw new Error("`tokenType` is not in the provided legend");const Ue=F.start.line,xe=F.start.character,Ze=F.end.character-F.start.character,nt=this.j.get(ae);let ht=0;if(ve)for(const bt of ve){if(!this.k.has(bt))throw new Error("`tokenModifier` is not in the provided legend");const Dt=this.k.get(bt);ht|=1<<Dt>>>0}this.n(Ue,xe,Ze,nt,ht)}n(F,ae,ve,Ue,xe){if(this.f&&(F<this.c||F===this.c&&ae<this.e)){this.f=!1;const ht=this.g.length/5|0;let bt=0,Dt=0;for(let Ct=0;Ct<ht;Ct++){let Pt=this.g[5*Ct],Wt=this.g[5*Ct+1];Pt===0?(Pt=bt,Wt+=Dt):Pt+=bt,this.g[5*Ct]=Pt,this.g[5*Ct+1]=Wt,bt=Pt,Dt=Wt}}let Ze=F,nt=ae;this.f&&this.h>0&&(Ze-=this.c,Ze===0&&(nt-=this.e)),this.g[this.h++]=Ze,this.g[this.h++]=nt,this.g[this.h++]=ve,this.g[this.h++]=Ue,this.g[this.h++]=xe,this.c=F,this.e=ae}static o(F){const ae=[],ve=F.length/5|0;for(let nt=0;nt<ve;nt++)ae[nt]=nt;ae.sort((nt,ht)=>{const bt=F[5*nt],Dt=F[5*ht];if(bt===Dt){const Ct=F[5*nt+1],Pt=F[5*ht+1];return Ct-Pt}return bt-Dt});const Ue=new Uint32Array(F.length);let xe=0,Ze=0;for(let nt=0;nt<ve;nt++){const ht=5*ae[nt],bt=F[ht+0],Dt=F[ht+1],Ct=F[ht+2],Pt=F[ht+3],Wt=F[ht+4],bn=bt-xe,Vn=bn===0?Dt-Ze:Dt,Ht=5*nt;Ue[Ht+0]=bn,Ue[Ht+1]=Vn,Ue[Ht+2]=Ct,Ue[Ht+3]=Pt,Ue[Ht+4]=Wt,xe=bt,Ze=Dt}return Ue}build(F){return this.f?new _t(new Uint32Array(this.g),F):new _t(Zt.o(this.g),F)}}e.SemanticTokensBuilder=Zt;class _t{constructor(F,ae){this.resultId=ae,this.data=F}}e.SemanticTokens=_t;class Dn{constructor(F,ae,ve){this.start=F,this.deleteCount=ae,this.data=ve}}e.SemanticTokensEdit=Dn;class Cn{constructor(F,ae){this.resultId=ae,this.edits=F}}e.SemanticTokensEdits=Cn;var $i;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})($i||(e.DebugConsoleMode=$i={}));let ei=e.QuickInputButtons=class{constructor(){}};ei.Back={iconPath:new Ot("arrow-left")},e.QuickInputButtons=ei=Le([q],ei);var Wi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Wi||(e.QuickPickItemKind=Wi={}));var Hi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Hi||(e.InputBoxValidationSeverity=Hi={}));var Vi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Vi||(e.ExtensionKind=Vi={}));class Pn{static validate(F){if(typeof F.badge=="string"){let ae=(0,T.nextCharLength)(F.badge,0);if(ae<F.badge.length&&(ae+=(0,T.nextCharLength)(F.badge,ae)),F.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Ot.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,ae,ve){this.badge=F,this.tooltip=ae,this.color=ve}}e.FileDecoration=Pn;let xi=e.ColorTheme=class{constructor(F){this.kind=F}};e.ColorTheme=xi=Le([q],xi);var qi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(qi||(e.ColorThemeKind=qi={}));class Nt{static isNotebookRange(F){return F instanceof Nt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,ae){if(F<0)throw(0,L.illegalArgument)("start must be positive");if(ae<0)throw(0,L.illegalArgument)("end must be positive");F<=ae?(this.c=F,this.e=ae):(this.c=ae,this.e=F)}with(F){let ae=this.c,ve=this.e;return F.start!==void 0&&(ae=F.start),F.end!==void 0&&(ve=F.end),ae===this.c&&ve===this.e?this:new Nt(ae,ve)}}e.NotebookRange=Nt;class qt{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(ae=>qt.isNotebookCellData(ae))}static isNotebookCellData(F){return!0}constructor(F,ae,ve,Ue,xe,Ze,nt){this.kind=F,this.value=ae,this.languageId=ve,this.mime=Ue,this.outputs=xe??[],this.metadata=Ze,this.executionSummary=nt,qt.validate(this)}}e.NotebookCellData=qt;class kn{constructor(F){this.cells=F}}e.NotebookData=kn;class It{static isNotebookCellOutputItem(F){return F instanceof It?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const ae={name:F.name,message:F.message,stack:F.stack};return It.json(ae,"application/vnd.code.notebook.error")}static stdout(F){return It.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return It.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,ae="application/octet-stream"){return new It(F,ae)}static text(F,ae=k.Mimes.text){const ve=st(It,t,"f",n).encode(String(F));return new It(ve,ae)}static json(F,ae="text/x-json"){const ve=JSON.stringify(F,void 0,"	");return It.text(ve,ae)}constructor(F,ae){this.data=F,this.mime=ae;const ve=(0,k.normalizeMimeType)(ae,!0);if(!ve)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ve}}e.NotebookCellOutputItem=It,t=It,n={value:new TextEncoder};class Gt{static isNotebookCellOutput(F){return F instanceof Gt?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,ae=!1){const ve=new Set,Ue=new Set;for(let xe=0;xe<F.length;xe++){const Ze=F[xe],nt=(0,k.normalizeMimeType)(Ze.mime);if(!ve.has(nt)||(0,g.isTextStreamMime)(nt)){ve.add(nt);continue}Ue.add(xe),ae&&console.warn(`DUPLICATED mime type '${Ze.mime}' will be dropped`)}return Ue.size===0?F:F.filter((xe,Ze)=>!Ue.has(Ze))}constructor(F,ae,ve){this.items=Gt.ensureUniqueMimeTypes(F,!0),typeof ae=="string"?(this.id=ae,this.metadata=ve):(this.id=(0,R.generateUuid)(),this.metadata=ae??ve)}}e.NotebookCellOutput=Gt;var Gi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Gi||(e.NotebookCellKind=Gi={}));var Ki;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Ki||(e.NotebookCellExecutionState=Ki={}));var Yi;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Yi||(e.NotebookCellStatusBarAlignment=Yi={}));var Xi;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Xi||(e.NotebookEditorRevealType=Xi={}));class An{constructor(F,ae){this.text=F,this.alignment=ae}}e.NotebookCellStatusBarItem=An;var Ji;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Ji||(e.NotebookControllerAffinity=Ji={}));var Qi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(Qi||(e.NotebookControllerAffinity2=Qi={}));class Rn{constructor(F,ae=[]){this.uri=F,this.provides=(0,y.asArray)(ae)}}e.NotebookRendererScript=Rn;class Tn{constructor(F){this.label=F}}e.NotebookKernelSourceAction=Tn;let Zi=e.TimelineItem=class{constructor(F,ae){this.label=F,this.timestamp=ae}};e.TimelineItem=Zi=Le([q],Zi);var _i;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(_i||(e.ExtensionMode=_i={}));var en;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(en||(e.ExtensionRuntime=en={}));var tn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(tn||(e.StandardTokenType=tn={}));class Ln{constructor(F,ae){this.ranges=F,this.wordPattern=ae}}e.LinkedEditingRanges=Ln;class On{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.PortAttributes=On;var nn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(nn||(e.TestResultState=nn={}));var rn;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(rn||(e.TestRunProfileKind=rn={}));let ti=e.TestRunRequest=class{constructor(F=void 0,ae=void 0,ve=void 0,Ue=!1){this.include=F,this.exclude=ae,this.profile=ve,this.continuous=Ue}};e.TestRunRequest=ti=Le([q],ti);let sn=e.TestRunRequest2=class extends ti{};e.TestRunRequest2=sn=Le([q],sn);let on=e.TestMessage=_=class{static diff(F,ae,ve){const Ue=new _(F);return Ue.expectedOutput=ae,Ue.actualOutput=ve,Ue}constructor(F){this.message=F}};e.TestMessage=on=_=Le([q],on);let an=e.TestTag=class{constructor(F){this.id=F}};e.TestTag=an=Le([q],an);let $t=e.CoveredCount=class{constructor(F,ae){this.covered=F,this.total=ae}};e.CoveredCount=$t=Le([q],$t);let ln=e.FileCoverage=re=class{static fromDetails(F,ae){const ve=new $t(0,0),Ue=new $t(0,0),xe=new $t(0,0);for(const nt of ae)if("branches"in nt){ve.total+=1,ve.covered+=nt.executionCount>0?1:0;for(const ht of nt.branches)Ue.total+=1,Ue.covered+=ht.executionCount>0?1:0}else xe.total+=1,xe.covered+=nt.executionCount>0?1:0;const Ze=new re(F,ve,Ue.total>0?Ue:void 0,xe.total>0?xe:void 0);return Ze.detailedCoverage=ae,Ze}constructor(F,ae,ve,Ue){this.uri=F,this.statementCoverage=ae,this.branchCoverage=ve,this.functionCoverage=Ue}};e.FileCoverage=ln=re=Le([q],ln);let cn=e.StatementCoverage=class{constructor(F,ae,ve=[]){this.executionCount=F,this.location=ae,this.branches=ve}};e.StatementCoverage=cn=Le([q],cn);let un=e.BranchCoverage=class{constructor(F,ae){this.executionCount=F,this.location=ae}};e.BranchCoverage=un=Le([q],un);let hn=e.FunctionCoverage=class{constructor(F,ae){this.executionCount=F,this.location=ae}};e.FunctionCoverage=hn=Le([q],hn);var fn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(fn||(e.ExternalUriOpenerPriority=fn={}));var dn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(dn||(e.WorkspaceTrustState=dn={}));var mn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(mn||(e.PortAutoForwardAction=mn={}));class Nn{constructor(F,ae,ve,Ue,xe,Ze){this.kind=F,this.name=ae,this.detail=ve,this.uri=Ue,this.range=xe,this.selectionRange=Ze}}e.TypeHierarchyItem=Nn;class Fn{constructor(F){this.uri=F}}e.TextTabInput=Fn;class Mn{constructor(F,ae){this.original=F,this.modified=ae}}e.TextDiffTabInput=Mn;class Un{constructor(F,ae,ve,Ue){this.base=F,this.input1=ae,this.input2=ve,this.result=Ue}}e.TextMergeTabInput=Un;class Bn{constructor(F,ae){this.uri=F,this.viewType=ae}}e.CustomEditorTabInput=Bn;class zn{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=zn;class jn{constructor(F,ae){this.uri=F,this.notebookType=ae}}e.NotebookEditorTabInput=jn;class $n{constructor(F,ae,ve){this.original=F,this.modified=ae,this.notebookType=ve}}e.NotebookDiffEditorTabInput=$n;class Wn{constructor(){}}e.TerminalEditorTabInput=Wn;class Hn{constructor(F,ae){this.uri=F,this.inputBoxUri=ae}}e.InteractiveWindowInput=Hn;var gn;(function(B){B[B.Up=1]="Up",B[B.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var pn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var vn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone"})(vn||(e.InteractiveEditorResponseFeedbackKind=vn={}))}),define(pe[135],be([1,0,18,15,150,71,99,28,141,49,58,22,8,4,52,158,224,131,89,129,69,90,133,134]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c,u,I,O,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(we){function De(X){const{selectionStartLineNumber:Pe,selectionStartColumn:Ne,positionLineNumber:He,positionColumn:Be}=X,Je=new n.Position(Pe-1,Ne-1),ct=new n.Position(He-1,Be-1);return new n.Selection(Je,ct)}we.to=De;function de(X){const{anchor:Pe,active:Ne}=X;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Ne.line+1,positionColumn:Ne.character+1}}we.from=de})(s||(e.Selection=s={}));var i;(function(we){function De(X){if(!X)return;const{start:Pe,end:Ne}=X;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Ne.line+1,endColumn:Ne.character+1}}we.from=De;function de(X){if(!X)return;const{startLineNumber:Pe,startColumn:Ne,endLineNumber:He,endColumn:Be}=X;return new n.Range(Pe-1,Ne-1,He-1,Be-1)}we.to=de})(i||(e.Range=i={}));var a;(function(we){function De(de){switch(de){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}we.to=De})(a||(e.TokenType=a={}));var l;(function(we){function De(X){return new n.Position(X.lineNumber-1,X.column-1)}we.to=De;function de(X){return{lineNumber:X.line+1,column:X.character+1}}we.from=de})(l||(e.Position=l={}));var h;(function(we){function De(Pe,Ne,He){return(0,y.coalesce)((0,y.asArray)(Pe).map(Be=>de(Be,Ne,He)))}we.from=De;function de(Pe,Ne,He){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:He?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:X(Pe.scheme,Ne),pattern:Ie.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:He?.isBuiltin}}function X(Pe,Ne){return Ne&&typeof Pe=="string"?Ne.transformOutgoingScheme(Pe):Pe}})(h||(e.DocumentSelector=h={}));var C;(function(we){function De(X){switch(X){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}we.from=De;function de(X){switch(X){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}we.to=de})(C||(e.DiagnosticTag=C={}));var D;(function(we){function De(X){let Pe;return X.code&&((0,b.isString)(X.code)||(0,b.isNumber)(X.code)?Pe=String(X.code):Pe={value:String(X.code.value),target:X.code.target}),{...i.from(X.range),message:X.message,source:X.source,code:Pe,severity:S.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(w.from),tags:Array.isArray(X.tags)?(0,y.coalesce)(X.tags.map(C.from)):void 0}}we.from=De;function de(X){const Pe=new n.Diagnostic(i.to(X),X.message,S.to(X.severity));return Pe.source=X.source,Pe.code=(0,b.isString)(X.code)?X.code:X.code?.value,Pe.relatedInformation=X.relatedInformation&&X.relatedInformation.map(w.to),Pe.tags=X.tags&&(0,y.coalesce)(X.tags.map(C.to)),Pe}we.to=de})(D||(e.Diagnostic=D={}));var w;(function(we){function De(X){return{...i.from(X.location.range),message:X.message,resource:X.location.uri}}we.from=De;function de(X){return new n.DiagnosticRelatedInformation(new n.Location(X.resource,i.to(X)),X.message)}we.to=de})(w||(e.DiagnosticRelatedInformation=w={}));var S;(function(we){function De(X){switch(X){case n.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}we.from=De;function de(X){switch(X){case r.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}we.to=de})(S||(e.DiagnosticSeverity=S={}));var N;(function(we){function De(X){return typeof X=="number"&&X>=n.ViewColumn.One?X-1:X===n.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}we.from=De;function de(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=de})(N||(e.ViewColumn=N={}));function $(we){return typeof we.range<"u"}function ee(we){return we.length===0?!0:!!$(we[0])}e.isDecorationOptionsArr=ee;var he;(function(we){function De(Be){return Be.map(we.from)}we.fromMany=De;function de(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function X(Be){let Je;if(de(Be)){const{language:lt,value:at}=Be;Je={value:"```"+lt+`
`+at+"\n```\n"}}else n.MarkdownString.isMarkdownString(Be)?Je={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?Je={value:Be}:Je={value:""};const ct=Object.create(null);Je.uris=ct;const vt=lt=>{try{let at=d.URI.parse(lt,!0);at=at.with({query:Pe(at.query,ct)}),ct[lt]=at}catch{}return""},ft=new v.marked.Renderer;return ft.link=vt,ft.image=lt=>typeof lt=="string"?vt(k.parseHrefAndDimensions(lt).href):"",(0,v.marked)(Je.value,{renderer:ft}),Je}we.from=X;function Pe(Be,Je){if(!Be)return Be;let ct;try{ct=(0,m.parse)(Be)}catch{}if(!ct)return Be;let vt=!1;return ct=(0,E.cloneAndChange)(ct,ft=>{if(d.URI.isUri(ft)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Je[lt]=ft,vt=!0,lt}else return}),vt?JSON.stringify(ct):Be}function Ne(Be){const Je=new n.MarkdownString(Be.value,Be.supportThemeIcons);return Je.isTrusted=Be.isTrusted,Je.supportHtml=Be.supportHtml,Je.baseUri=Be.baseUri?d.URI.from(Be.baseUri):void 0,Je}we.to=Ne;function He(Be){if(Be)return typeof Be=="string"?Be:we.from(Be)}we.fromStrict=He})(he||(e.MarkdownString=he={}));function oe(we){return ee(we)?we.map(De=>({range:i.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?he.fromMany(De.hoverMessage):De.hoverMessage?he.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):we.map(De=>({range:i.from(De)}))}e.fromRangeOrRangeWithMessage=oe;function ue(we){return typeof we>"u"?we:typeof we=="string"?d.URI.file(we):we}e.pathOrURIToURI=ue;var me;(function(we){function De(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?ue(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}we.from=De})(me||(e.ThemableDecorationAttachmentRenderOptions=me={}));var _;(function(we){function De(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?ue(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?me.from(de.before):void 0,after:de.after?me.from(de.after):void 0}}we.from=De})(_||(e.ThemableDecorationRenderOptions=_={}));var re;(function(we){function De(de){if(typeof de>"u")return de;switch(de){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=De})(re||(e.DecorationRangeBehavior=re={}));var q;(function(we){function De(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?re.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?_.from(de.light):void 0,dark:de.dark?_.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?ue(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?me.from(de.before):void 0,after:de.after?me.from(de.after):void 0}}we.from=De})(q||(e.DecorationRenderOptions=q={}));var J;(function(we){function De(X){return{text:X.newText,eol:X.newEol&&et.from(X.newEol),range:i.from(X.range)}}we.from=De;function de(X){const Pe=new n.TextEdit(i.to(X.range),X.text);return Pe.newEol=typeof X.eol>"u"?void 0:et.to(X.eol),Pe}we.to=de})(J||(e.TextEdit=J={}));var U;(function(we){function De(X,Pe){const Ne={edits:[]};if(X instanceof n.WorkspaceEdit){const He=new T.ResourceSet;for(const Be of X._allEntries())Be._type===1&&d.URI.isUri(Be.to)&&Be.from===void 0&&He.add(Be.to);for(const Be of X._allEntries())if(Be._type===1){let Je;Be.options?.contents&&(ArrayBuffer.isView(Be.options.contents)?Je={type:"base64",value:(0,L.encodeBase64)(L.VSBuffer.wrap(Be.options.contents))}:Je={type:"dataTransferItem",id:Be.options.contents._itemId}),Ne.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contents:Je},metadata:Be.metadata})}else Be._type===2?Ne.edits.push({resource:Be.uri,textEdit:J.from(Be.edit),versionId:He.has(Be.uri)?void 0:Pe?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?Ne.edits.push({resource:Be.uri,textEdit:{range:i.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:He.has(Be.uri)?void 0:Pe?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Ne.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Ne.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(Ye.from)}})}return Ne}we.from=De;function de(X){const Pe=new n.WorkspaceEdit,Ne=new T.ResourceMap;for(const He of X.edits)if(He.textEdit){const Be=He,Je=d.URI.revive(Be.resource),ct=i.to(Be.textEdit.range),vt=Be.textEdit.text,ft=Be.textEdit.insertAsSnippet;let lt;ft?lt=n.SnippetTextEdit.replace(ct,new n.SnippetString(vt)):lt=n.TextEdit.replace(ct,vt);const at=Ne.get(Je);at?at.push(lt):Ne.set(Je,[lt])}else Pe.renameFile(d.URI.revive(He.oldResource),d.URI.revive(He.newResource),He.options);for(const[He,Be]of Ne)Pe.set(He,Be);return Pe}we.to=de})(U||(e.WorkspaceEdit=U={}));var ne;(function(we){const De=Object.create(null);De[n.SymbolKind.File]=0,De[n.SymbolKind.Module]=1,De[n.SymbolKind.Namespace]=2,De[n.SymbolKind.Package]=3,De[n.SymbolKind.Class]=4,De[n.SymbolKind.Method]=5,De[n.SymbolKind.Property]=6,De[n.SymbolKind.Field]=7,De[n.SymbolKind.Constructor]=8,De[n.SymbolKind.Enum]=9,De[n.SymbolKind.Interface]=10,De[n.SymbolKind.Function]=11,De[n.SymbolKind.Variable]=12,De[n.SymbolKind.Constant]=13,De[n.SymbolKind.String]=14,De[n.SymbolKind.Number]=15,De[n.SymbolKind.Boolean]=16,De[n.SymbolKind.Array]=17,De[n.SymbolKind.Object]=18,De[n.SymbolKind.Key]=19,De[n.SymbolKind.Null]=20,De[n.SymbolKind.EnumMember]=21,De[n.SymbolKind.Struct]=22,De[n.SymbolKind.Event]=23,De[n.SymbolKind.Operator]=24,De[n.SymbolKind.TypeParameter]=25;function de(Pe){return typeof De[Pe]=="number"?De[Pe]:6}we.from=de;function X(Pe){for(const Ne in De)if(De[Ne]===Pe)return Number(Ne);return n.SymbolKind.Property}we.to=X})(ne||(e.SymbolKind=ne={}));var V;(function(we){function De(X){switch(X){case n.SymbolTag.Deprecated:return 1}}we.from=De;function de(X){switch(X){case 1:return n.SymbolTag.Deprecated}}we.to=de})(V||(e.SymbolTag=V={}));var se;(function(we){function De(X){return{name:X.name,kind:ne.from(X.kind),tags:X.tags&&X.tags.map(V.from),containerName:X.containerName,location:M.from(X.location)}}we.from=De;function de(X){const Pe=new n.SymbolInformation(X.name,ne.to(X.kind),X.containerName,M.to(X.location));return Pe.tags=X.tags&&X.tags.map(V.to),Pe}we.to=de})(se||(e.WorkspaceSymbol=se={}));var Y;(function(we){function De(X){const Pe={name:X.name||"!!MISSING: name!!",detail:X.detail,range:i.from(X.range),selectionRange:i.from(X.selectionRange),kind:ne.from(X.kind),tags:X.tags?.map(V.from)??[]};return X.children&&(Pe.children=X.children.map(De)),Pe}we.from=De;function de(X){const Pe=new n.DocumentSymbol(X.name,X.detail,ne.to(X.kind),i.to(X.range),i.to(X.selectionRange));return(0,y.isNonEmptyArray)(X.tags)&&(Pe.tags=X.tags.map(V.to)),X.children&&(Pe.children=X.children.map(de)),Pe}we.to=de})(Y||(e.DocumentSymbol=Y={}));var ie;(function(we){function De(X){const Pe=new n.CallHierarchyItem(ne.to(X.kind),X.name,X.detail||"",d.URI.revive(X.uri),i.to(X.range),i.to(X.selectionRange));return Pe._sessionId=X._sessionId,Pe._itemId=X._itemId,Pe}we.to=De;function de(X,Pe,Ne){if(Pe=Pe??X._sessionId,Ne=Ne??X._itemId,Pe===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ne,name:X.name,detail:X.detail,kind:ne.from(X.kind),uri:X.uri,range:i.from(X.range),selectionRange:i.from(X.selectionRange),tags:X.tags?.map(V.from)}}we.from=de})(ie||(e.CallHierarchyItem=ie={}));var z;(function(we){function De(de){return new n.CallHierarchyIncomingCall(ie.to(de.from),de.fromRanges.map(X=>i.to(X)))}we.to=De})(z||(e.CallHierarchyIncomingCall=z={}));var P;(function(we){function De(de){return new n.CallHierarchyOutgoingCall(ie.to(de.to),de.fromRanges.map(X=>i.to(X)))}we.to=De})(P||(e.CallHierarchyOutgoingCall=P={}));var M;(function(we){function De(X){return{range:X.range&&i.from(X.range),uri:X.uri}}we.from=De;function de(X){return new n.Location(d.URI.revive(X.uri),i.to(X.range))}we.to=de})(M||(e.location=M={}));var K;(function(we){function De(X){const Pe=X,Ne=X;return{originSelectionRange:Pe.originSelectionRange?i.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Ne.uri,range:i.from(Pe.targetRange?Pe.targetRange:Ne.range),targetSelectionRange:Pe.targetSelectionRange?i.from(Pe.targetSelectionRange):void 0}}we.from=De;function de(X){return{targetUri:d.URI.revive(X.uri),targetRange:i.to(X.range),targetSelectionRange:X.targetSelectionRange?i.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?i.to(X.originSelectionRange):void 0}}we.to=de})(K||(e.DefinitionLink=K={}));var te;(function(we){function De(X){return{range:i.from(X.range),contents:he.fromMany(X.contents)}}we.from=De;function de(X){return new n.Hover(X.contents.map(he.to),i.to(X.range))}we.to=de})(te||(e.Hover=te={}));var j;(function(we){function De(X){return{range:i.from(X.range),expression:X.expression}}we.from=De;function de(X){return new n.EvaluatableExpression(i.to(X.range),X.expression)}we.to=de})(j||(e.EvaluatableExpression=j={}));var W;(function(we){function De(X){if(X instanceof n.InlineValueText)return{type:"text",range:i.from(X.range),text:X.text};if(X instanceof n.InlineValueVariableLookup)return{type:"variable",range:i.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof n.InlineValueEvaluatableExpression)return{type:"expression",range:i.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}we.from=De;function de(X){switch(X.type){case"text":return{range:i.to(X.range),text:X.text};case"variable":return{range:i.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:i.to(X.range),expression:X.expression}}}we.to=de})(W||(e.InlineValue=W={}));var x;(function(we){function De(X){return{frameId:X.frameId,stoppedLocation:i.from(X.stoppedLocation)}}we.from=De;function de(X){return new n.InlineValueContext(X.frameId,i.to(X.stoppedLocation))}we.to=de})(x||(e.InlineValueContext=x={}));var H;(function(we){function De(X){return{range:i.from(X.range),kind:X.kind}}we.from=De;function de(X){return new n.DocumentHighlight(i.to(X.range),X.kind)}we.to=de})(H||(e.DocumentHighlight=H={}));var Q;(function(we){function De(de){switch(de){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}we.to=De})(Q||(e.CompletionTriggerKind=Q={}));var G;(function(we){function De(de){return{triggerKind:Q.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}we.to=De})(G||(e.CompletionContext=G={}));var Z;(function(we){function De(X){switch(X){case n.CompletionItemTag.Deprecated:return 1}}we.from=De;function de(X){switch(X){case 1:return n.CompletionItemTag.Deprecated}}we.to=de})(Z||(e.CompletionItemTag=Z={}));var ce;(function(we){const De=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function de(Ne){return De.get(Ne)??9}we.from=de;const X=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Pe(Ne){return X.get(Ne)??n.CompletionItemKind.Property}we.to=Pe})(ce||(e.CompletionItemKind=ce={}));var Ee;(function(we){function De(de,X){const Pe=new n.CompletionItem(de.label);return Pe.insertText=de.insertText,Pe.kind=ce.to(de.kind),Pe.tags=de.tags?.map(Z.to),Pe.detail=de.detail,Pe.documentation=k.isMarkdownString(de.documentation)?he.to(de.documentation):de.documentation,Pe.sortText=de.sortText,Pe.filterText=de.filterText,Pe.preselect=de.preselect,Pe.commitCharacters=de.commitCharacters,g.Range.isIRange(de.range)?Pe.range=i.to(de.range):typeof de.range=="object"&&(Pe.range={inserting:i.to(de.range.insert),replacing:i.to(de.range.replace)}),Pe.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Pe.insertText=new n.SnippetString(de.insertText):(Pe.insertText=de.insertText,Pe.textEdit=Pe.range instanceof n.Range?new n.TextEdit(Pe.range,Pe.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Pe.additionalTextEdits=de.additionalTextEdits.map(Ne=>J.to(Ne))),Pe.command=X&&de.command?X.fromInternal(de.command):void 0,Pe}we.to=De})(Ee||(e.CompletionItem=Ee={}));var Ce;(function(we){function De(X){if(typeof X.label!="string"&&!Array.isArray(X.label))throw new TypeError("Invalid label");return{label:X.label,documentation:he.fromStrict(X.documentation)}}we.from=De;function de(X){return{label:X.label,documentation:k.isMarkdownString(X.documentation)?he.to(X.documentation):X.documentation}}we.to=de})(Ce||(e.ParameterInformation=Ce={}));var ke;(function(we){function De(X){return{label:X.label,documentation:he.fromStrict(X.documentation),parameters:Array.isArray(X.parameters)?X.parameters.map(Ce.from):[],activeParameter:X.activeParameter}}we.from=De;function de(X){return{label:X.label,documentation:k.isMarkdownString(X.documentation)?he.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(Ce.to):[],activeParameter:X.activeParameter}}we.to=de})(ke||(e.SignatureInformation=ke={}));var Fe;(function(we){function De(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(ke.from):[]}}we.from=De;function de(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(ke.to):[]}}we.to=de})(Fe||(e.SignatureHelp=Fe={}));var je;(function(we){function De(de,X){const Pe=new n.InlayHint(l.to(X.position),typeof X.label=="string"?X.label:X.label.map(ge.to.bind(void 0,de)),X.kind&&Se.to(X.kind));return Pe.textEdits=X.textEdits&&X.textEdits.map(J.to),Pe.tooltip=k.isMarkdownString(X.tooltip)?he.to(X.tooltip):X.tooltip,Pe.paddingLeft=X.paddingLeft,Pe.paddingRight=X.paddingRight,Pe}we.to=De})(je||(e.InlayHint=je={}));var ge;(function(we){function De(de,X){const Pe=new n.InlayHintLabelPart(X.label);return Pe.tooltip=k.isMarkdownString(X.tooltip)?he.to(X.tooltip):X.tooltip,p.Command.is(X.command)&&(Pe.command=de.fromInternal(X.command)),X.location&&(Pe.location=M.to(X.location)),Pe}we.to=De})(ge||(e.InlayHintLabelPart=ge={}));var Se;(function(we){function De(X){return X}we.from=De;function de(X){return X}we.to=de})(Se||(e.InlayHintKind=Se={}));var ye;(function(we){function De(X){return{range:i.from(X.range),url:X.target,tooltip:X.tooltip}}we.from=De;function de(X){let Pe;if(X.url)try{Pe=typeof X.url=="string"?d.URI.parse(X.url,!0):d.URI.revive(X.url)}catch{}return new n.DocumentLink(i.to(X.range),Pe)}we.to=de})(ye||(e.DocumentLink=ye={}));var Me;(function(we){function De(X){const Pe=new n.ColorPresentation(X.label);return X.textEdit&&(Pe.textEdit=J.to(X.textEdit)),X.additionalTextEdits&&(Pe.additionalTextEdits=X.additionalTextEdits.map(Ne=>J.to(Ne))),Pe}we.to=De;function de(X){return{label:X.label,textEdit:X.textEdit?J.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Pe=>J.from(Pe)):void 0}}we.from=de})(Me||(e.ColorPresentation=Me={}));var ze;(function(we){function De(X){return new n.Color(X[0],X[1],X[2],X[3])}we.to=De;function de(X){return[X.red,X.green,X.blue,X.alpha]}we.from=de})(ze||(e.Color=ze={}));var _e;(function(we){function De(X){return{range:i.from(X.range)}}we.from=De;function de(X){return new n.SelectionRange(i.to(X.range))}we.to=de})(_e||(e.SelectionRange=_e={}));var qe;(function(we){function De(de){switch(de){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}we.to=De})(qe||(e.TextDocumentSaveReason=qe={}));var Ve;(function(we){function De(X){switch(X){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}we.from=De;function de(X){switch(X){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}we.to=de})(Ve||(e.TextEditorLineNumbersStyle=Ve={}));var et;(function(we){function De(X){if(X===n.EndOfLine.CRLF)return 1;if(X===n.EndOfLine.LF)return 0}we.from=De;function de(X){if(X===1)return n.EndOfLine.CRLF;if(X===0)return n.EndOfLine.LF}we.to=de})(et||(e.EndOfLine=et={}));var rt;(function(we){function De(de){if(typeof de=="object")return de.viewId;switch(de){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=De})(rt||(e.ProgressLocation=rt={}));var Ge;(function(we){function De(X){const Pe={start:X.start+1,end:X.end+1};return X.kind&&(Pe.kind=Xe.from(X.kind)),Pe}we.from=De;function de(X){const Pe={start:X.start-1,end:X.end-1};return X.kind&&(Pe.kind=Xe.to(X.kind)),Pe}we.to=de})(Ge||(e.FoldingRange=Ge={}));var Xe;(function(we){function De(X){if(X)switch(X){case n.FoldingRangeKind.Comment:return p.FoldingRangeKind.Comment;case n.FoldingRangeKind.Imports:return p.FoldingRangeKind.Imports;case n.FoldingRangeKind.Region:return p.FoldingRangeKind.Region}}we.from=De;function de(X){if(X)switch(X.value){case p.FoldingRangeKind.Comment.value:return n.FoldingRangeKind.Comment;case p.FoldingRangeKind.Imports.value:return n.FoldingRangeKind.Imports;case p.FoldingRangeKind.Region.value:return n.FoldingRangeKind.Region}}we.to=de})(Xe||(e.FoldingRangeKind=Xe={}));var fe;(function(we){function De(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?i.from(de.selection):void 0,override:typeof de.override=="boolean"?c.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}we.from=De})(fe||(e.TextEditorOpenOptions=fe={}));var Ie;(function(we){function De(Ne){return Ne instanceof n.RelativePattern?Ne.toJSON():typeof Ne=="string"?Ne:de(Ne)||X(Ne)?new n.RelativePattern(Ne.baseUri??Ne.base,Ne.pattern).toJSON():Ne}we.from=De;function de(Ne){const He=Ne;return He?d.URI.isUri(He.baseUri)&&typeof He.pattern=="string":!1}function X(Ne){const He=Ne;return He?typeof He.base=="string"&&typeof He.pattern=="string":!1}function Pe(Ne){return typeof Ne=="string"?Ne:new n.RelativePattern(d.URI.revive(Ne.baseUri),Ne.pattern)}we.to=Pe})(Ie||(e.GlobPattern=Ie={}));var Te;(function(we){function De(de){if(de){if(Array.isArray(de))return de.map(De);if(typeof de=="string")return de;{const X=de;return{language:X.language,scheme:X.scheme,pattern:Ie.from(X.pattern),exclusive:X.exclusive,notebookType:X.notebookType}}}else return}we.from=De})(Te||(e.LanguageSelector=Te={}));var Re;(function(we){function De(X){return{start:X.start,end:X.end}}we.from=De;function de(X){return new n.NotebookRange(X.start,X.end)}we.to=de})(Re||(e.NotebookRange=Re={}));var Oe;(function(we){function De(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}we.to=De;function de(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}we.from=de})(Oe||(e.NotebookCellExecutionSummary=Oe={}));var $e;(function(we){function De(de){if(de===u.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(de===u.NotebookCellExecutionState.Pending)return;if(de===u.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}we.to=De})($e||(e.NotebookCellExecutionState=$e={}));var We;(function(we){function De(X){switch(X){case n.NotebookCellKind.Markup:return u.CellKind.Markup;case n.NotebookCellKind.Code:default:return u.CellKind.Code}}we.from=De;function de(X){switch(X){case u.CellKind.Markup:return n.NotebookCellKind.Markup;case u.CellKind.Code:default:return n.NotebookCellKind.Code}}we.to=de})(We||(e.NotebookCellKind=We={}));var Qe;(function(we){function De(X){const Pe={metadata:X.metadata??Object.create(null),cells:[]};for(const Ne of X.cells)n.NotebookCellData.validate(Ne),Pe.cells.push(Ye.from(Ne));return Pe}we.from=De;function de(X){const Pe=new n.NotebookData(X.cells.map(Ye.to));return(0,b.isEmptyObject)(X.metadata)||(Pe.metadata=X.metadata),Pe}we.to=de})(Qe||(e.NotebookData=Qe={}));var Ye;(function(we){function De(X){return{cellKind:We.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:Oe.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(tt.from):[]}}we.from=De;function de(X){return new n.NotebookCellData(We.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(tt.to):void 0,X.metadata,X.internalMetadata?Oe.to(X.internalMetadata):void 0)}we.to=de})(Ye||(e.NotebookCellData=Ye={}));var Ke;(function(we){function De(X){return{mime:X.mime,valueBytes:L.VSBuffer.wrap(X.data)}}we.from=De;function de(X){return new n.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}we.to=de})(Ke||(e.NotebookCellOutputItem=Ke={}));var tt;(function(we){function De(X){return{outputId:X.id,items:X.items.map(Ke.from),metadata:X.metadata}}we.from=De;function de(X){const Pe=X.items.map(Ke.to);return new n.NotebookCellOutput(Pe,X.outputId,X.metadata)}we.to=de})(tt||(e.NotebookCellOutput=tt={}));var it;(function(we){function De(Pe){return X(Pe)?{include:(0,b.withNullAsUndefined)(Ie.from(Pe.include)),exclude:(0,b.withNullAsUndefined)(Ie.from(Pe.exclude))}:(0,b.withNullAsUndefined)(Ie.from(Pe))}we.from=De;function de(Pe){return X(Pe)?{include:Ie.to(Pe.include),exclude:Ie.to(Pe.exclude)}:Ie.to(Pe)}we.to=de;function X(Pe){const Ne=Pe;return Ne?!(0,b.isUndefinedOrNull)(Ne.include)&&!(0,b.isUndefinedOrNull)(Ne.exclude):!1}})(it||(e.NotebookExclusiveDocumentPattern=it={}));var ut;(function(we){function De(de,X,Pe){const Ne=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Ne,Pe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}we.from=De})(ut||(e.NotebookStatusBarItem=ut={}));var Et;(function(we){function De(de,X,Pe){const Ne=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:X.toInternal(Ne,Pe),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}we.from=De})(Et||(e.NotebookKernelSourceAction=Et={}));var ot;(function(we){function De(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}we.from=De})(ot||(e.NotebookDocumentContentOptions=ot={}));var Mt;(function(we){function De(X){return{uri:X.uri,provides:X.provides}}we.from=De;function de(X){return new n.NotebookRendererScript(d.URI.revive(X.uri),X.provides)}we.to=de})(Mt||(e.NotebookRendererScript=Mt={}));var dt;(function(we){function De(X){return{message:he.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location&&{range:i.from(X.location.range),uri:X.location.uri}}}we.from=De;function de(X){const Pe=new n.TestMessage(typeof X.message=="string"?X.message:he.to(X.message));return Pe.actualOutput=X.actual,Pe.expectedOutput=X.expected,Pe.location=X.location?M.to(X.location):void 0,Pe}we.to=de})(dt||(e.TestMessage=dt={}));var mt;(function(we){we.namespace=O.namespaceTestTag,we.denamespace=O.denamespaceTestTag})(mt||(e.TestTag=mt={}));var gt;(function(we){function De(X){const Pe=(0,f.getPrivateApiFor)(X).controllerId;return{extId:I.TestId.fromExtHostTestItem(X,Pe).toString(),label:X.label,uri:d.URI.revive(X.uri),busy:X.busy,tags:X.tags.map(Ne=>mt.namespace(Pe,Ne.id)),range:g.Range.lift(i.from(X.range)),description:X.description||null,sortText:X.sortText||null,error:X.error&&he.fromStrict(X.error)||null}}we.from=De;function de(X){return{parent:void 0,error:void 0,id:I.TestId.fromString(X.extId).localId,label:X.label,uri:d.URI.revive(X.uri),tags:(X.tags||[]).map(Pe=>{const{tagId:Ne}=mt.denamespace(Pe);return new n.TestTag(Ne)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(X.range||void 0),canResolveChildren:!1,busy:X.busy,description:X.description||void 0,sortText:X.sortText||void 0}}we.toPlain=de})(gt||(e.TestItem=gt={})),function(we){function De(X){return{id:X.id}}we.from=De;function de(X){return new n.TestTag(X.id)}we.to=de}(mt||(e.TestTag=mt={}));var wt;(function(we){const De=(X,Pe)=>{const Ne=[];for(const[Be,Je]of Pe)I.TestId.compare(Je.item.extId,Be)===2&&(Pe.delete(Be),Ne.push(Je));const He={...gt.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(Je=>Je.type===0).map(dt.to)})),children:Ne.map(Be=>De(Be,Pe))};for(const Be of He.children)Be.parent=He;return He};function de(X){const Pe=[],Ne=new Map;for(const He of X.items){Ne.set(He.item.extId,He);const Be=I.TestId.root(He.item.extId);X.request.targets.some(Je=>Je.controllerId===Be&&Je.testIds.includes(He.item.extId))&&Pe.push(He)}return{completedAt:X.completedAt,results:Pe.map(He=>De(He,Ne))}}we.to=de})(wt||(e.TestResults=wt={}));var Ut;(function(we){function De(Ne){return{covered:Ne.covered,total:Ne.covered}}function de(Ne){return"line"in Ne?l.from(Ne):i.from(Ne)}function X(Ne){return"branches"in Ne?{count:Ne.executionCount,location:de(Ne.location),type:1,branches:Ne.branches.length?Ne.branches.map(He=>({count:He.executionCount,location:He.location&&de(He.location)})):void 0}:{type:0,count:Ne.executionCount,location:de(Ne.location)}}we.fromDetailed=X;function Pe(Ne){return{uri:Ne.uri,statement:De(Ne.statementCoverage),branch:Ne.branchCoverage&&De(Ne.branchCoverage),function:Ne.functionCoverage&&De(Ne.functionCoverage),details:Ne.detailedCoverage?.map(X)}}we.fromFile=Pe})(Ut||(e.TestCoverage=Ut={}));var At;(function(we){function De(de){switch(de){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}we.to=De})(At||(e.CodeActionTriggerKind=At={}));var yt;(function(we){function De(X){const Pe=new n.TypeHierarchyItem(ne.to(X.kind),X.name,X.detail||"",d.URI.revive(X.uri),i.to(X.range),i.to(X.selectionRange));return Pe._sessionId=X._sessionId,Pe._itemId=X._itemId,Pe}we.to=De;function de(X,Pe,Ne){if(Pe=Pe??X._sessionId,Ne=Ne??X._itemId,Pe===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ne,kind:ne.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:i.from(X.range),selectionRange:i.from(X.selectionRange),tags:X.tags?.map(V.from)}}we.from=de})(yt||(e.TypeHierarchyItem=yt={}));var Rt;(function(we){function De(de){if(de)return{value:de.value,tooltip:de.tooltip}}we.from=De})(Rt||(e.ViewBadge=Rt={}));var St;(function(we){function De(Ne,He,Be){const Je=He.fileData;return Je?new n.InternalFileDataTransferItem(new n.DataTransferFile(Je.name,d.URI.revive(Je.uri),Je.id,(0,A.once)(()=>Be(Je.id)))):Ne===R.Mimes.uriList&&He.uriListData?new n.InternalDataTransferItem(Pe(He.uriListData)):new n.InternalDataTransferItem(He.asString)}we.to=De;async function de(Ne,He){const Be=await He.asString();if(Ne===R.Mimes.uriList)return{asString:Be,fileData:void 0,uriListData:X(Be)};const Je=He.asFile();return{asString:Be,fileData:Je?{name:Je.name,uri:Je.uri,id:Je._itemId??Je.id}:void 0}}we.from=de;function X(Ne){return o.UriList.split(Ne).map(He=>{if(He.startsWith("#"))return He;try{return d.URI.parse(He)}catch{}return He})}function Pe(Ne){return o.UriList.create(Ne.map(He=>typeof He=="string"?He:d.URI.revive(He)))}})(St||(e.DataTransferItem=St={}));var pt;(function(we){function De(X,Pe){const Ne=X.items.map(([He,Be])=>[He,St.to(He,Be,Pe)]);return new n.DataTransfer(Ne)}we.toDataTransfer=De;async function de(X){const Pe={items:[]},Ne=[];for(const[He,Be]of X)Ne.push((async()=>{Pe.items.push([He,await St.from(He,Be)])})());return await Promise.all(Ne),Pe}we.from=de})(pt||(e.DataTransfer=pt={}));var Tt;(function(we){function De(X){return{message:X.message,metadata:X.metadata,title:X.title,tooltip:X.tooltip}}we.to=De;function de(X){return{kind:"reply",message:X.message,metadata:X.metadata,title:X.title,tooltip:X.tooltip}}we.from=de})(Tt||(e.ChatReplyFollowup=Tt={}));var Lt;(function(we){function De(de){return typeof de=="string"?{title:de,message:de,kind:"reply"}:"commandId"in de?{kind:"command",title:de.title??"",commandId:de.commandId??"",args:de.args}:Tt.from(de)}we.from=De})(Lt||(e.ChatFollowup=Lt={}))}),define(pe[279],be([1,0,52,131,69,130,90,135,4]),function(le,e,y,L,o,A,k,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const m=(u,I,O,t)=>{let n=I;return{enumerable:!0,configurable:!1,get(){return n},set(s){if(!O(n,s)){const i=n;n=s,u.listener?.(t(s,i))}}}},R=(u,I)=>u===I,E={range:(u,I)=>u===I?!0:!u||!I?!1:u.isEqual(I),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(u,I)=>!(u.length!==I.length||u.some(O=>!I.find(t=>O.id===t.id)))},b=u=>I=>({op:4,update:u(I)}),d=(u,I)=>({range:(()=>{let O;const t=b(n=>({range:y.Range.lift(T.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return O},set(n){u.listener?.({op:6}),E.range(O,n)||(O=n,u.listener?.(t(n)))}}})(),label:m(u,I,E.label,b(O=>({label:O}))),description:m(u,void 0,E.description,b(O=>({description:O}))),sortText:m(u,void 0,E.sortText,b(O=>({sortText:O}))),canResolveChildren:m(u,!1,E.canResolveChildren,O=>({op:2,state:O})),busy:m(u,!1,E.busy,b(O=>({busy:O}))),error:m(u,void 0,E.error,b(O=>({error:T.MarkdownString.fromStrict(O)||null}))),tags:m(u,[],E.tags,(O,t)=>({op:1,new:O.map(T.TestTag.from),old:t.map(T.TestTag.from)}))}),g=u=>{const I=o.TestId.fromString(u.extId),O=new r(I.controllerId,I.localId,u.label,v.URI.revive(u.uri)||void 0);return O.range=T.Range.to(u.range||void 0),O.description=u.description||void 0,O.sortText=u.sortText||void 0,O.tags=u.tags.map(t=>T.TestTag.to({id:(0,k.denamespaceTestTag)(t).tagId})),O},p=u=>{let I;for(const O of u.tests){const t=g(O.item);(0,L.getPrivateApiFor)(t).parent=I,I=t}return I};e.toItemFromContext=p;class r{constructor(I,O,t,n){if(O.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(O)} symbol`);const s=(0,L.createPrivateApiFor)(this,I);Object.defineProperties(this,{id:{value:O,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof f?void 0:s.parent}},children:{value:(0,A.createTestItemChildren)(s,L.getPrivateApiFor,r),enumerable:!0,writable:!1},...d(s,t)})}}e.TestItemImpl=r;class f extends r{constructor(I,O){super(I,I,O,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class c extends A.TestItemCollection{constructor(I,O,t){super({controllerId:I,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:L.getPrivateApiFor,getChildren:n=>n.children,root:new f(I,O),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=c}),define(pe[280],be([1,0,34,199,53]),function(le,e,y,L,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function A(k,T,v,m){const R=new y.ExtensionIdentifierMap;return k.forEach(E=>{const b=R.get(E.identifier);b&&m.warn((0,L.localize)(0,null,b.extensionLocation.fsPath,E.extensionLocation.fsPath)),R.set(E.identifier,E)}),T.forEach(E=>{const b=R.get(E.identifier);if(b)if(b.isBuiltin){if(o.gte(b.version,E.version)){m.warn(`Skipping extension ${E.extensionLocation.path} in favour of the builtin extension ${b.extensionLocation.path}.`);return}E.isBuiltin=!0}else m.warn((0,L.localize)(1,null,b.extensionLocation.fsPath,E.extensionLocation.fsPath));else if(E.isBuiltin){m.warn(`Skipping obsolete builtin extension ${E.extensionLocation.path}`);return}R.set(E.identifier,E)}),v.forEach(E=>{m.info((0,L.localize)(2,null,E.extensionLocation.fsPath));const b=R.get(E.identifier);b&&b.isBuiltin&&(E.isBuiltin=!0),R.set(E.identifier,E)}),Array.from(R.values())}e.dedupExtensions=A}),define(pe[281],be([1,0,7,3,29,4,42,50,64,57,280,13]),function(le,e,y,L,o,A,k,T,v,m,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannel=e.RemoteExtensionsScannerService=void 0;class b{constructor(p,r,f,c,u,I,O){this.b=p,this.c=f,this.d=c,this.f=u,this.g=I,this.h=O;const t=r.args["install-builtin-extension"];if(t){u.trace("Installing builtin extensions passed via args...");const s={isMachineScoped:!!r.args["do-not-sync"],installPreReleaseVersion:!!r.args["pre-release"]};k.mark("code/server/willInstallBuiltinExtensions"),this.a=p.installExtensions([],this.i(t),s,!!r.args.force).then(()=>{k.mark("code/server/didInstallBuiltinExtensions"),u.trace("Finished installing builtin extensions")},i=>{u.error(i)})}else this.a=Promise.resolve();const n=r.args["install-extension"];n&&(u.trace("Installing extensions passed via args..."),this.a.then(()=>p.installExtensions(this.i(n),[],{isMachineScoped:!!r.args["do-not-sync"],installPreReleaseVersion:!!r.args["pre-release"],isApplicationScoped:!0},!!r.args.force)).then(()=>{u.trace("Finished installing extensions")},s=>{u.error(s)}))}i(p){return p.map(r=>/\.vsix$/i.test(r)?A.URI.file((0,y.isAbsolute)(r)?r:(0,y.join)((0,o.cwd)(),r)):r)}whenExtensionsReady(){return this.a}async scanExtensions(p,r,f,c){k.mark("code/server/willScanExtensions"),this.f.trace(`Scanning extensions using UI language: ${p}`),await this.whenExtensionsReady();const u=f?f.filter(O=>O.scheme===E.Schemas.file).map(O=>O.fsPath):void 0;r=r??this.c.defaultProfile.extensionsResource;const I=await this.j(r,p??L.language,u,c);return this.f.trace("Scanned Extensions",I),this.q(I),k.mark("code/server/didScanExtensions"),I}async scanSingleExtension(p,r,f){await this.whenExtensionsReady();const c=p.scheme===E.Schemas.file?p.fsPath:null;if(!c)return null;const u=await this.n(c,r,f??L.language);return u?(this.q([u]),u):null}async j(p,r,f,c){await this.o(r,c);const[u,I,O]=await Promise.all([this.l(r),this.m(p,r),this.k(r,f)]);return(0,R.dedupExtensions)(u,I,O,this.f)}async k(p,r){return r?(await Promise.all(r.map(f=>this.d.scanOneOrMultipleExtensions(A.URI.file((0,y.resolve)(f)),1,{language:p})))).flat().map(f=>(0,m.toExtensionDescription)(f,!0)):[]}async l(p){return(await this.d.scanSystemExtensions({language:p,useCache:!0})).map(f=>(0,m.toExtensionDescription)(f,!1))}async m(p,r){return(await this.d.scanUserExtensions({profileLocation:p,language:r,useCache:!0})).map(c=>(0,m.toExtensionDescription)(c,!1))}async n(p,r,f){const c=A.URI.file((0,y.resolve)(p)),u=r?0:1,I=await this.d.scanExistingExtension(c,u,{language:f});return I?(0,m.toExtensionDescription)(I,!1):null}async o(p,r){if(!(p===L.LANGUAGE_DEFAULT||!this.g.isEnabled())){try{if((await this.h.getInstalledLanguages()).find(c=>c.id===p)){this.f.trace(`Language Pack ${p} is already installed. Skipping language pack installation.`);return}}catch(f){this.f.error(f)}if(!r){this.f.trace(`No language pack id provided for language ${p}. Skipping language pack installation.`);return}this.f.trace(`Language Pack ${r} for language ${p} is not installed. It will be installed now.`);try{await this.b.installExtensions([r],[],{isMachineScoped:!0},!0)}catch(f){this.f.error(f)}}}q(p){const r=(t,n)=>t.replace(/file/g,"vscode-remote"),f=t=>{let n="";return n+=t.global?"g":"",n+=t.ignoreCase?"i":"",n+=t.multiline?"m":"",new RegExp(r(t.source,!0),n)},c=new class{mapDefined(t){return v.ContextKeyDefinedExpr.create(t)}mapNot(t){return v.ContextKeyNotExpr.create(t)}mapEquals(t,n){return t==="resourceScheme"&&typeof n=="string"?v.ContextKeyEqualsExpr.create(t,r(n,!1)):v.ContextKeyEqualsExpr.create(t,n)}mapNotEquals(t,n){return t==="resourceScheme"&&typeof n=="string"?v.ContextKeyNotEqualsExpr.create(t,r(n,!1)):v.ContextKeyNotEqualsExpr.create(t,n)}mapGreater(t,n){return v.ContextKeyGreaterExpr.create(t,n)}mapGreaterEquals(t,n){return v.ContextKeyGreaterEqualsExpr.create(t,n)}mapSmaller(t,n){return v.ContextKeySmallerExpr.create(t,n)}mapSmallerEquals(t,n){return v.ContextKeySmallerEqualsExpr.create(t,n)}mapRegex(t,n){return t==="resourceScheme"&&n?v.ContextKeyRegexExpr.create(t,f(n)):v.ContextKeyRegexExpr.create(t,n)}mapIn(t,n){return v.ContextKeyInExpr.create(t,n)}mapNotIn(t,n){return v.ContextKeyNotInExpr.create(t,n)}},u=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const n=v.ContextKeyExpr.deserialize(t.when);if(!n)return;const s=n.map(c);t.when=s.serialize()},I=t=>{if(Array.isArray(t))for(const n of t)u(n);else u(t)},O=t=>{for(const n in t)I(t[n])};p.forEach(t=>{t.contributes&&(t.contributes.menus&&O(t.contributes.menus),t.contributes.keybindings&&I(t.contributes.keybindings),t.contributes.views&&O(t.contributes.views))})}}e.RemoteExtensionsScannerService=b;class d{constructor(p,r){this.a=p,this.b=r}listen(p,r){throw new Error("Invalid listen")}async call(p,r,f){const c=this.b(p);switch(r){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const u=f[0],I=f[1]?A.URI.revive(c.transformIncoming(f[1])):void 0,O=Array.isArray(f[2])?f[2].map(s=>A.URI.revive(c.transformIncoming(s))):void 0,t=f[3];return(await this.a.scanExtensions(u,I,O,t)).map(s=>(0,T.transformOutgoingURIs)(s,c))}case"scanSingleExtension":{const u=await this.a.scanSingleExtension(A.URI.revive(c.transformIncoming(f[0])),f[1],f[2]);return u?(0,T.transformOutgoingURIs)(u,c):null}}throw new Error("Invalid call")}}e.RemoteExtensionsScannerChannel=d}),define(pe[136],be([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class y{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++y.count}}e.ProxyIdentifier=y,y.count=0;const L=[];function o(T){const v=new y(T);return L[v.nid]=v,v}e.createProxyIdentifier=o;function A(T){return L[T].sid}e.getStringIdentifierForProxy=A;class k{constructor(v){this.value=v}}e.SerializableObjectWithBuffers=k}),define(pe[282],be([1,0,136]),function(le,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var o;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(o||(e.TabInputKind=o={}));var A;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var k;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(k||(e.WebviewEditorCapabilities=k={}));var T;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var v;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var m;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(m||(e.NotebookEditorRevealType=m={}));var R;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class E{static mixin(r){return r._id=E.a++,r}}e.IdObject=E,E.a=0;var b;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})(b||(e.ISuggestDataDtoField=b={}));var d;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(d||(e.ISuggestResultDtoField=d={}));var g;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.MainContext={MainThreadAuthentication:(0,y.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,y.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,y.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,y.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,y.createProxyIdentifier)("MainThreadChat"),MainThreadInteractiveEditor:(0,y.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,y.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,y.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,y.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,y.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,y.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,y.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,y.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,y.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostChat:(0,y.createProxyIdentifier)("ExtHostChat"),ExtHostSemanticSimilarity:(0,y.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,y.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,y.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.createProxyIdentifier)("ExtHostIssueReporter")}});var kt=this&&this.__classPrivateFieldSet||function(le,e,y,L,o){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!o)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?le!==e||!o:!e.has(le))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?o.call(le,y):o?o.value=y:e.set(le,y),y},st=this&&this.__classPrivateFieldGet||function(le,e,y,L){if(y==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?le!==e||!L:!e.has(le))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?L:y==="a"?L.call(le):L?L.value:e.get(le)};define(pe[283],be([1,0,8,134,135,22,282,18,12,49,52,106,4,2,5,266,279,15,136,39,97,37,277]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c,u,I,O,t){"use strict";var n,s,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=e.ExtHostCommands=class{constructor(S,N,$){n.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),i.set(this,void 0),kt(this,n,S.getProxy(k.MainContext.MainThreadCommands),"f"),this.d=N,kt(this,i,$,"f"),kt(this,s,S.getProxy(k.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,ee=>{const he=this.c.get(ee);return he?.result===C.Void?he:void 0},N),this.f=[{processArgument(ee){return(0,m.revive)(ee)}},{processArgument(ee){return(0,A.cloneAndChange)(ee,function(he){if(R.Range.isIRange(he))return o.Range.to(he);if(E.Position.isIPosition(he))return o.Position.to(he);if(R.Range.isIRange(he.range)&&b.URI.isUri(he.uri))return o.location.to(he);if(he instanceof f.VSBuffer)return he.buffer.buffer;if(!Array.isArray(he))return he})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const N=this.registerCommand(!1,S.id,async(...$)=>{const ee=S.args.map((oe,ue)=>{if(!oe.validate($[ue]))throw new Error(`Invalid argument '${oe.name}' when running '${S.id}', received: ${$[ue]}`);return oe.convert($[ue])}),he=await this.executeCommand(S.internalId,...ee);return S.result.convert(he,$,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new L.Disposable(()=>{N.dispose(),this.c.delete(S.id)})}registerCommand(S,N,$,ee,he,oe){if(this.d.trace("ExtHostCommands#registerCommand",N),!N.trim().length)throw new Error("invalid id");if(this.b.has(N))throw new Error(`command '${N}' already exists`);return this.b.set(N,{callback:$,thisArg:ee,description:he,extension:oe}),S&&st(this,n,"f").$registerCommand(N),new L.Disposable(()=>{this.b.delete(N)&&S&&st(this,n,"f").$unregisterCommand(N)})}executeCommand(S,...N){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,N,!0)}async g(S,N,$){if(this.b.has(S))return st(this,n,"f").$fireCommandActivationEvent(S),this.h(S,N,!1);{let ee=!1;const he=(0,A.cloneAndChange)(N,function(oe){if(oe instanceof L.Position)return o.Position.from(oe);if(oe instanceof L.Range)return o.Range.from(oe);if(oe instanceof L.Location)return o.location.from(oe);if(L.NotebookRange.isNotebookRange(oe))return o.NotebookRange.from(oe);if(oe instanceof ArrayBuffer)return ee=!0,f.VSBuffer.wrap(new Uint8Array(oe));if(oe instanceof Uint8Array)return ee=!0,f.VSBuffer.wrap(oe);if(oe instanceof f.VSBuffer)return ee=!0,oe;if(!Array.isArray(oe))return oe});try{const oe=await st(this,n,"f").$executeCommand(S,ee?new c.SerializableObjectWithBuffers(he):he,$);return(0,m.revive)(oe)}catch(oe){if(oe instanceof Error&&oe.message==="$executeCommand:retry")return this.g(S,N,!1);throw oe}}}async h(S,N,$){const ee=this.b.get(S);if(!ee)throw new Error("Unknown command");const{callback:he,thisArg:oe,description:ue}=ee;if(ue)for(let _=0;_<ue.args.length;_++)try{(0,y.validateConstraint)(N[_],ue.args[_].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${ue.args[_].name}' - ${ue.args[_].description}`)}const me=I.StopWatch.create();try{return await he.apply(oe,N)}catch(_){if(S===this.converter.delegatingCommandId){const re=this.converter.getActualCommand(...N);re&&(S=re.command)}if(this.d.error(_,S,ee.extension?.identifier),!$)throw _;if(ee.extension?.identifier){const re=st(this,i,"f").onExtensionError(ee.extension.identifier,_);this.d.trace("forwarded error to extension?",re,ee.extension?.identifier)}throw new class extends Error{constructor(){super((0,u.toErrorMessage)(_)),this.id=S,this.source=ee.extension?.displayName??ee.extension?.name}}}finally{this.j(ee,S,me.elapsed())}}j(S,N,$){S.extension&&st(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new O.TelemetryTrustedValue(N),duration:$})}$executeContributedCommand(S,...N){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const $=this.b.get(S);return $?(N=N.map(ee=>this.f.reduce((he,oe)=>oe.processArgument(he,$.extension?.identifier),ee)),this.h(S,N,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),st(this,n,"f").$getCommands().then(N=>(S&&(N=N.filter($=>$[0]!=="_")),N))}$getContributedCommandHandlerDescriptions(){const S=Object.create(null);for(const[N,$]of this.b){const{description:ee}=$;ee&&(S[N]=ee)}return Promise.resolve(S)}};n=new WeakMap,s=new WeakMap,i=new WeakMap,e.ExtHostCommands=a=Le([Ae(0,p.IExtHostRpcService),Ae(1,v.ILogService),Ae(2,t.IExtHostTelemetry)],a),e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class l{constructor(S,N,$){this.d=S,this.f=N,this.g=$,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,N){if(!S)return;const $={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return $;const ee=this.f(S.command);if(ee)$.id=ee.internalId,$.arguments=ee.args.map((he,oe)=>he.convert(S.arguments&&S.arguments[oe]));else if((0,T.isNonEmptyArray)(S.arguments)){const he=`${S.command}/${++this.c}`;this.b.set(he,S),N.add((0,d.toDisposable)(()=>{this.b.delete(he),this.g.trace("CommandsConverter#DISPOSE",he)})),$.$ident=he,$.id=this.delegatingCommandId,$.arguments=[he],this.g.trace("CommandsConverter#CREATE",S.command,he)}return $}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const N=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],N?N.command:"MISSING"),N?this.d.executeCommand(N.command,...N.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.CommandsConverter=l;class h{constructor(S,N,$,ee){this.name=S,this.description=N,this.validate=$,this.convert=ee}optional(){return new h(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,N){return new h(S??this.name,N??this.description,this.validate,this.convert)}}e.ApiCommandArgument=h,h.Uri=new h("uri","Uri of a text document",w=>b.URI.isUri(w),w=>w),h.Position=new h("position","A position in a text document",w=>L.Position.isPosition(w),o.Position.from),h.Range=new h("range","A range in a text document",w=>L.Range.isRange(w),o.Range.from),h.Selection=new h("selection","A selection in a text document",w=>L.Selection.isSelection(w),o.Selection.from),h.Number=new h("number","",w=>typeof w=="number",w=>w),h.String=new h("string","",w=>typeof w=="string",w=>w),h.CallHierarchyItem=new h("item","A call hierarchy item",w=>w instanceof L.CallHierarchyItem,o.CallHierarchyItem.from),h.TypeHierarchyItem=new h("item","A type hierarchy item",w=>w instanceof L.TypeHierarchyItem,o.TypeHierarchyItem.from),h.TestItem=new h("testItem","A VS Code TestItem",w=>w instanceof r.TestItemImpl,o.TestItem.from);class C{constructor(S,N){this.description=S,this.convert=N}}e.ApiCommandResult=C,C.Void=new C("no result",w=>w);class D{constructor(S,N,$,ee,he){this.id=S,this.internalId=N,this.description=$,this.args=ee,this.result=he}}e.ApiCommand=D}),define(pe[284],be([1,0,9,2,13,213]),function(le,e,y,L,o,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class k extends A.DiskFileSystemProviderClient{static register(v,m,R){const E=v.getConnection();if(!E)return L.Disposable.None;const b=new L.DisposableStore,d=(async()=>{try{const g=await v.getRawEnvironment();g?m.registerProvider(o.Schemas.vscodeRemote,b.add(new k(g,E))):R.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(g){R.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,y.getErrorMessage)(g))}})();return b.add(m.onWillActivateFileSystemProvider(g=>{g.scheme===o.Schemas.vscodeRemote&&g.join(d)})),b}constructor(v,m){super(m.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:v.os===3})}}e.RemoteFileSystemProviderClient=k}),define(pe[91],be([1,0,33,14,7,8,23,166,300,301]),function(le,e,y,L,o,A,k,T,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const R=new RegExp(e.CorruptZipMessage);class E extends Error{constructor(n,s){let i=s.message;switch(n){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=n,this.cause=s}}e.ExtractError=E;function b(t){const n=t.externalFileAttributes>>16||33188;return[448,56,7].map(s=>n&s).reduce((s,i)=>s+i,n&61440)}function d(t){if(t instanceof E)return t;let n;return R.test(t.message)&&(n="CorruptZip"),new E(n,t)}function g(t,n,s,i,a,l){const h=o.dirname(n),C=o.join(i,h);if(!C.startsWith(i))return Promise.reject(new Error(T.localize(0,null,n)));const D=o.join(i,n);let w;return l.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(k.Promises.mkdir(C,{recursive:!0})).then(()=>new Promise((S,N)=>{if(!l.isCancellationRequested)try{w=(0,y.createWriteStream)(D,{mode:s}),w.once("close",()=>S()),w.once("error",N),t.once("error",N),t.pipe(w)}catch($){N($)}}))}function p(t,n,s,i){let a=(0,L.createCancelablePromise)(()=>Promise.resolve()),l=0;return i.onCancellationRequested(()=>{a.cancel(),t.close()}),new Promise((h,C)=>{const D=new L.Sequencer,w=S=>{S.isCancellationRequested||(l++,t.readEntry())};t.once("error",C),t.once("close",()=>a.then(()=>{i.isCancellationRequested||t.entryCount===l?h():C(new E("Incomplete",new Error(T.localize(1,null,l,t.entryCount))))},C)),t.readEntry(),t.on("entry",S=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(S.fileName)){w(i);return}const N=S.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(N)){const he=o.join(n,N);a=(0,L.createCancelablePromise)(oe=>k.Promises.mkdir(he,{recursive:!0}).then(()=>w(oe)).then(void 0,C));return}const $=f(t,S),ee=b(S);a=(0,L.createCancelablePromise)(he=>D.queue(()=>$.then(oe=>g(oe,N,ee,n,s,he).then(()=>w(he)))).then(null,C))})})}function r(t,n=!1){return new Promise((s,i)=>{(0,v.open)(t,n?{lazyEntries:!0}:void 0,(a,l)=>{a?i(d(a)):s((0,A.assertIsDefined)(l))})})}function f(t,n){return new Promise((s,i)=>{t.openReadStream(n,(a,l)=>{a?i(d(a)):s((0,A.assertIsDefined)(l))})})}function c(t,n){return new Promise((s,i)=>{const a=new m.ZipFile;n.forEach(h=>{h.contents?a.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&a.addFile(h.localPath,h.path)}),a.end();const l=(0,y.createWriteStream)(t);a.outputStream.pipe(l),a.outputStream.once("error",i),l.once("error",i),l.once("finish",()=>s(t))})}e.zip=c;function u(t,n,s={},i){const a=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let l=r(t,!0);return s.overwrite&&(l=l.then(h=>k.Promises.rm(n).then(()=>h))),l.then(h=>p(h,n,{sourcePathRegex:a},i))}e.extract=u;function I(t,n){return r(t).then(s=>new Promise((i,a)=>{s.on("entry",l=>{l.fileName===n&&f(s,l).then(h=>i(h),h=>a(h))}),s.once("close",()=>a(new Error(T.localize(2,null,n))))}))}function O(t,n){return I(t,n).then(s=>new Promise((i,a)=>{const l=[];s.once("error",a),s.on("data",h=>l.push(h)),s.on("end",()=>i(Buffer.concat(l)))}))}e.buffer=O}),define(pe[285],be([1,0,14,9,2,13,3,19,53,8,21,23,91,24,25,30,35,80,16,12]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let I=e.ExtensionsDownloader=class ii extends o.Disposable{constructor(t,n,s,i,a,l){super(),this.h=n,this.i=s,this.j=i,this.k=a,this.l=l,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,n,s){await this.g;const i=(0,T.joinPath)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,i,l=>this.i.download(t,l,n))}catch(l){throw new p.ExtensionManagementError(l.message,p.ExtensionManagementErrorCode.Download)}let a=!1;if(s&&this.m(t)){const l=await this.n(t);try{a=await this.k.verify(i.fsPath,l.fsPath,this.l.getLevel()===u.LogLevel.Trace)}catch(h){const C=h;if(a=C.code,C.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${C.output}`),a===p.ExtensionSignaturetErrorCode.PackageIsInvalidZip||a===p.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new p.ExtensionManagementError(b.CorruptZipMessage,p.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(l)}catch(h){this.l.error(h)}}}return a===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):a===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${a}': ${t.identifier.id}`),{location:i,verificationStatus:a}}m(t){if(!t.isSigned)return!1;const n=this.j.getValue("extensions.verifySignature");return(0,m.isBoolean)(n)?n:!0}async n(t){await this.g;const n=(0,T.joinPath)(this.extensionsDownloadDir,`${this.v(t)}${ii.c}`);return await this.r(t,n,s=>this.i.downloadSignatureArchive(t,s)),n}async r(t,n,s){if(await this.h.exists(n))return;if(n.scheme!==A.Schemas.file){await s(n);return}const i=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,R.generateUuid)()}`);await this.h.exists(i)||await s(i);try{await this.t(i,n,Date.now()+2*60*1e3)}catch(a){try{await this.h.del(i)}catch{}if(a.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,n.path);else throw this.l.info(`Rename failed because of ${(0,L.getErrorMessage)(a)}. Deleted the file from downloaded location`,i.path),a}}async delete(t){await this.g,await this.h.del(t)}async t(t,n,s){try{await E.Promises.rename(t.fsPath,n.fsPath)}catch(i){if(k.isWindows&&i&&i.code==="EPERM"&&Date.now()<s)return this.l.info(`Failed renaming ${t} to ${n} with 'EPERM' error. Trying again...`),this.t(t,n,s);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const n=[],s=[],i=[];for(const h of t.children)if(h.name.endsWith(ii.c))i.push(h.resource);else{const C=r.ExtensionKey.parse(h.name);C&&s.push([C,h])}const a=(0,r.groupByExtension)(s,([h])=>h),l=[];for(const h of a)h.sort((C,D)=>v.rcompare(C[0].version,D[0].version)),n.push(...h.slice(1).map(C=>C[1].resource)),l.push(h[0][1]);l.sort((h,C)=>h.mtime-C.mtime),n.push(...l.slice(0,Math.max(0,l.length-this.f)).map(h=>h.resource)),n.push(...i),await y.Promises.settled(n.map(h=>(this.l.trace("Deleting from cache",h.path),this.h.del(h))))}}catch(t){this.l.error(t)}}v(t){return this.f?r.ExtensionKey.create(t).toString().toLowerCase():(0,R.generateUuid)()}};I.c=".sigzip",e.ExtensionsDownloader=I=Le([Ae(0,g.INativeEnvironmentService),Ae(1,c.IFileService),Ae(2,p.IExtensionGalleryService),Ae(3,d.IConfigurationService),Ae(4,f.IExtensionSignatureVerificationService),Ae(5,u.ILogService)],I)}),define(pe[286],be([1,0,91,178]),function(le,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function o(A){return(0,y.buffer)(A,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,L.localize)(0,null))}})}e.getManifest=o}),define(pe[137],be([1,0,14,15,20,39,9,6,2,28,13,7,3,19,53,8,4,21,23,91,177,79,25,254,30,35,45,57,285,255,286,229,238,77,16,5,12,27,31,36,32]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c,u,I,O,t,n,s,i,a,l,h,C,D,w,S,N,$,ee,he,oe,ue,me,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ee.refineServiceDecorator)(s.IExtensionManagementService);let re=e.ExtensionManagementService=class extends n.AbstractExtensionManagementService{constructor(Y,ie,z,P,M,K,te,j,W,x,H,Q){super(Y,ie,z,x,Q),this.Z=M,this.ab=K,this.bb=te,this.cb=W,this.db=H,this.X=this.B(new T.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new m.ResourceSet;const G=this.B(j.createInstance(C.ExtensionsLifecycle));this.S=this.B(j.createInstance(q,ce=>G.postUninstall(ce))),this.U=this.B(new w.ExtensionsManifestCache(Q,W,H,this,this.v)),this.W=this.B(j.createInstance(h.ExtensionsDownloader));const Z=this.B(new S.ExtensionsWatcher(this,this.Z,Q,K,H,W,z));this.B(Z.onDidChangeExtensionsByAnotherSource(ce=>this.kb(ce))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(Y){this.v.trace("ExtensionManagementService#zip",Y.identifier.id);const ie=await this.jb(Y),z=await(0,u.zip)((0,d.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,ie);return r.URI.file(z)}async unzip(Y){return this.v.trace("ExtensionManagementService#unzip",Y.toString()),(await this.install(Y)).identifier}async getManifest(Y){const{location:ie,cleanup:z}=await this.fb(Y),P=E.resolve(ie.fsPath);try{return await(0,D.getManifest)(P)}finally{await z()}}getInstalled(Y,ie=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(Y??null,ie)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Y){return this.S.scanUserExtensionAtLocation(Y)}async install(Y,ie={}){this.v.trace("ExtensionManagementService#install",Y.toString());const{location:z,cleanup:P}=await this.fb(Y);try{const M=await(0,D.getManifest)(E.resolve(z.fsPath));if(M.engines&&M.engines.vscode&&!(0,N.isEngineValid)(M.engines.vscode,this.w.version,this.w.date))throw new Error(I.localize(0,null,(0,i.getGalleryExtensionId)(M.publisher,M.name),this.w.version));return await this.z(M,z,ie)}finally{await P()}}async installFromLocation(Y,ie){this.v.trace("ExtensionManagementService#installFromLocation",Y.toString());const z=await this.S.scanUserExtensionAtLocation(Y);if(!z)throw new Error(`Cannot find a valid extension from the location ${Y.toString()}`);return await this.ob([[z,void 0]],ie),this.v.info("Successfully installed extension",z.identifier.id,ie.toString()),z}async installExtensionsFromProfile(Y,ie,z){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",Y,ie.toString(),z.toString());const P=(await this.S.scanExtensions(1,ie)).filter(M=>Y.some(K=>(0,i.areSameExtensions)(K,M.identifier)));if(P.length){const M=await Promise.all(P.map(K=>this.S.scanMetadata(K,ie)));await this.ob(P.map((K,te)=>[K,M[te]]),z),this.v.info("Successfully installed extensions",P.map(K=>K.identifier.id),z.toString())}return P}async updateMetadata(Y,ie,z=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",Y.identifier.id),ie.isPreReleaseVersion&&(ie.preRelease=!0),ie.isMachineScoped=ie.isMachineScoped||void 0,ie.isBuiltin=ie.isBuiltin||void 0,ie.pinned=ie.pinned||void 0,Y=await this.S.updateMetadata(Y,ie,z),this.U.invalidate(z),this.X.fire(Y),Y}async reinstallFromGallery(Y){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",Y.identifier.id),!this.t.isEnabled())throw new Error(I.localize(1,null));const ie=await this.getTargetPlatform(),[z]=await this.t.getExtensions([{...Y.identifier,preRelease:Y.preRelease}],{targetPlatform:ie,compatible:!0},o.CancellationToken.None);if(!z)throw new Error(I.localize(2,null));await this.S.setUninstalled(Y);try{await this.S.removeUninstalledExtension(Y)}catch(P){throw new Error(I.localize(3,null,(0,A.toErrorMessage)(P)))}return this.installFromGallery(z)}copyExtensions(Y,ie){return this.S.copyExtensions(Y,ie)}markAsUninstalled(...Y){return this.S.setUninstalled(...Y)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(Y){this.v.error(Y)}}async download(Y,ie,z){const{location:P}=await this.W.download(Y,ie,!z);return P}async fb(Y){if(Y.scheme===R.Schemas.file)return{location:Y,async cleanup(){}};this.v.trace("Downloading extension from",Y.toString());const ie=(0,d.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)());return await this.bb.download(Y,ie),this.v.info("Downloaded extension to",ie.toString()),{location:ie,cleanup:async()=>{try{await this.cb.del(ie)}catch(P){this.v.error(P)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(Y,ie,z){if(r.URI.isUri(ie))return new ne(Y,ie,z,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const P=i.ExtensionKey.create(ie).toString();let M=this.Y.get(P);return M||(this.Y.set(P,M=new U(Y,ie,z,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),M.waitUntilTaskIsFinished().finally(()=>this.Y.delete(P))),M}R(Y,ie){return new V(Y,ie.profileLocation,this.ab)}async jb(Y){const ie=async P=>{let M=await c.Promises.readdir(P);M=M.map(j=>E.join(P,j));const K=await Promise.all(M.map(j=>c.Promises.stat(j)));let te=Promise.resolve([]);return K.forEach((j,W)=>{const x=M[W];j.isFile()&&(te=te.then(H=>[...H,x])),j.isDirectory()&&(te=te.then(H=>ie(x).then(Q=>[...H,...Q])))}),te};return(await ie(Y.location.fsPath)).map(P=>({path:`extension/${E.relative(Y.location.fsPath,P)}`,localPath:P}))}async kb({added:Y,removed:ie}){if(ie)for(const z of ie.extensions)this.v.info("Extensions removed from another source",z.id,ie.profileLocation.toString()),this.p.fire({identifier:z,profileLocation:ie.profileLocation});if(Y){const P=(await this.S.scanExtensions(1,Y.profileLocation)).filter(M=>Y.extensions.some(K=>(0,i.areSameExtensions)(K,M.identifier)));this.m.fire(P.map(M=>(this.v.info("Extensions added from another source",M.identifier.id,Y.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:Y.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(ie=>this.lb.add(ie)));const Y=await this.cb.resolve(this.Z.userExtensionsLocation);for(const ie of Y.children??[])ie.isDirectory&&this.lb.add(ie.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(ie=>this.nb(ie)))}async nb(Y){if(!Y.affects(this.Z.userExtensionsLocation,1))return;const ie=[];for(const z of Y.rawAdded){if(this.lb.has(z)||!this.db.extUri.isEqual(this.db.extUri.dirname(z),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(z,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(z).startsWith(".")||!(await this.cb.stat(z)).isDirectory)continue;const P=await this.S.scanUserExtensionAtLocation(z);P&&P.installedTimestamp===void 0&&(this.lb.add(z),ie.push(P))}ie.length&&(await this.ob(ie.map(z=>[z,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",ie.map(z=>z.identifier.id)))}async ob(Y,ie){const z=Y.map(P=>P[0]);await this.pb(z),await this.ab.addExtensionsToProfile(Y,ie),this.m.fire(z.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:ie})))}async pb(Y){const ie=await this.S.getUninstalledExtensions();for(const z of Y){const P=i.ExtensionKey.create(z);ie[P.toString()]&&(this.v.trace("Removing the extension from uninstalled list:",P.id),await this.S.setInstalled(P),this.v.info("Removed the extension from uninstalled list:",P.id))}}};e.ExtensionManagementService=re=Le([Ae(0,s.IExtensionGalleryService),Ae(1,ue.ITelemetryService),Ae(2,he.ILogService),Ae(3,t.INativeEnvironmentService),Ae(4,l.IExtensionsScannerService),Ae(5,a.IExtensionsProfileScannerService),Ae(6,O.IDownloadService),Ae(7,ee.IInstantiationService),Ae(8,$.IFileService),Ae(9,oe.IProductService),Ae(10,me.IUriIdentityService),Ae(11,_.IUserDataProfilesService)],re);let q=e.ExtensionsScanner=class extends v.Disposable{constructor(Y,ie,z,P,M,K){super(),this.k=Y,this.l=ie,this.m=z,this.n=P,this.p=M,this.s=K,this.h=this.B(new T.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,d.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new y.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(Y,ie){const z={includeInvalid:!0,profileLocation:ie};let P=[];return Y===null||Y===0?P.push(...await this.m.scanAllExtensions({includeInvalid:!0},z,!1)):Y===1&&P.push(...await this.m.scanUserExtensions(z)),P=Y!==null?P.filter(M=>M.type===Y):P,Promise.all(P.map(M=>this.y(M)))}async scanAllUserExtensions(Y){const ie=await this.m.scanUserExtensions({includeAllVersions:!Y,includeInvalid:!0});return Promise.all(ie.map(z=>this.y(z)))}async scanUserExtensionAtLocation(Y){try{const ie=await this.m.scanExistingExtension(Y,1,{includeInvalid:!0});if(ie)return await this.y(ie)}catch(ie){this.s.error(ie)}return null}async extractUserExtension(Y,ie,z,P){await this.j.catch(()=>{});const M=Y.toString(),K=E.join(this.m.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),te=E.join(this.m.userExtensionsLocation.fsPath,M);try{await c.Promises.rm(te)}catch{throw new s.ExtensionManagementError(I.localize(4,null,te,Y.id),s.ExtensionManagementErrorCode.Delete)}await this.u(Y,ie,K,P),await this.m.updateMetadata(r.URI.file(K),z);try{this.h.fire(r.URI.file(te)),await this.v(Y,K,te,Date.now()+2*60*1e3),this.s.info("Renamed to",te)}catch(j){try{await c.Promises.rm(K)}catch{}if(j.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",Y.id);else throw this.s.info(`Rename failed because of ${(0,k.getErrorMessage)(j)}. Deleted from extracted location`,K),j}return this.w(r.URI.file(te),1)}async scanMetadata(Y,ie){return ie?(await this.n.scanProfileExtensions(ie)).find(P=>(0,i.areSameExtensions)(P.identifier,Y.identifier))?.metadata:this.m.scanMetadata(Y.location)}async updateMetadata(Y,ie,z){return z?await this.n.updateMetadata([[Y,ie]],z):await this.m.updateMetadata(Y.location,ie),this.w(Y.location,Y.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...Y){const ie=Y.map(z=>i.ExtensionKey.create(z));await this.t(z=>ie.forEach(P=>{z[P.toString()]=!0,this.s.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(Y){await this.t(ie=>delete ie[Y.toString()])}async removeExtension(Y,ie){this.s.trace(`Deleting ${ie} extension from disk`,Y.identifier.id,Y.location.fsPath);const z=this.p.extUri.joinPath(this.p.extUri.dirname(Y.location),`._${(0,f.generateUuid)()}`);await this.v(Y.identifier,Y.location.fsPath,z.fsPath,Date.now()+2*60*1e3),await this.l.del(z,{recursive:!0}),this.s.info("Deleted from disk",Y.identifier.id,Y.location.fsPath)}async removeUninstalledExtension(Y){await this.removeExtension(Y,"uninstalled"),await this.t(ie=>delete ie[i.ExtensionKey.create(Y).toString()])}async copyExtensions(Y,ie){const z=await this.scanExtensions(1,Y),P=await Promise.all(z.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,Y)]));await this.n.addExtensionsToProfile(P,ie)}async t(Y){return this.g.queue(async()=>{let ie;try{ie=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(P){if((0,$.toFileOperationResult)(P)!==1)throw P}let z={};if(ie)try{z=JSON.parse(ie)}catch{}return Y&&(Y(z),Object.keys(z).length?await this.l.writeFile(this.c,L.VSBuffer.fromString(JSON.stringify(z))):await this.l.del(this.c)),z})}async u(Y,ie,z,P){this.s.trace(`Started extracting the extension from ${ie} to ${z}`);try{await c.Promises.rm(z)}catch(M){throw new s.ExtensionManagementError(this.D(M).message,s.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(ie,z,{sourcePath:"extension",overwrite:!0},P),this.s.info(`Extracted extension to ${z}:`,Y.id)}catch(M){try{await c.Promises.rm(z)}catch{}let K=s.ExtensionManagementErrorCode.Extract;throw M instanceof u.ExtractError&&(M.type==="CorruptZip"?K=s.ExtensionManagementErrorCode.CorruptZip:M.type==="Incomplete"&&(K=s.ExtensionManagementErrorCode.IncompleteZip)),new s.ExtensionManagementError(M.message,K)}}async v(Y,ie,z,P){try{await c.Promises.rename(ie,z)}catch(M){if(b.isWindows&&M&&M.code==="EPERM"&&Date.now()<P)return this.s.info(`Failed renaming ${ie} to ${z} with 'EPERM' error. Trying again...`,Y.id),this.v(Y,ie,z,P);throw new s.ExtensionManagementError(M.message||I.localize(5,null,ie,z),M.code||s.ExtensionManagementErrorCode.Rename)}}async w(Y,ie){const z=await this.m.scanExistingExtension(Y,ie,{includeInvalid:!0});if(z)return this.y(z);throw new Error(I.localize(6,null,Y.path))}async y(Y){const ie=await this.l.resolve(Y.location);let z,P;return ie.children&&(z=ie.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,P=ie.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:Y.identifier,type:Y.type,isBuiltin:Y.isBuiltin||!!Y.metadata?.isBuiltin,location:Y.location,manifest:Y.manifest,targetPlatform:Y.targetPlatform,validations:Y.validations,isValid:Y.isValid,readmeUrl:z,changelogUrl:P,publisherDisplayName:Y.metadata?.publisherDisplayName||null,publisherId:Y.metadata?.publisherId||null,isApplicationScoped:!!Y.metadata?.isApplicationScoped,isMachineScoped:!!Y.metadata?.isMachineScoped,isPreReleaseVersion:!!Y.metadata?.isPreReleaseVersion,preRelease:!!Y.metadata?.preRelease,installedTimestamp:Y.metadata?.installedTimestamp,updated:!!Y.metadata?.updated,pinned:!!Y.metadata?.pinned}}async z(){const Y=await this.getUninstalledExtensions();if(Object.keys(Y).length===0){this.s.debug("No uninstalled extensions found.");return}this.s.debug("Removing uninstalled extensions:",Object.keys(Y));const ie=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),z=new Set;for(const M of ie)Y[i.ExtensionKey.create(M).toString()]||z.add(M.identifier.id.toLowerCase());try{const M=(0,i.groupByExtension)(ie,K=>K.identifier);await y.Promises.settled(M.map(async K=>{const te=K.sort((j,W)=>g.rcompare(j.manifest.version,W.manifest.version))[0];z.has(te.identifier.id.toLowerCase())||await this.k(await this.y(te))}))}catch(M){this.s.error(M)}const P=ie.filter(M=>M.metadata&&Y[i.ExtensionKey.create(M).toString()]);await Promise.allSettled(P.map(M=>this.removeUninstalledExtension(M)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const Y=[];let ie;try{ie=await this.l.resolve(this.m.userExtensionsLocation)}catch(z){(0,$.toFileOperationResult)(z)!==1&&this.s.error(z)}for(const z of ie?.children??[])z.isDirectory&&z.name.startsWith("._")&&(0,f.isUUID)(z.name.substring(2))&&Y.push((async()=>{this.s.trace("Deleting the generated extension folder",z.resource.toString());try{await this.l.del(z.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",z.resource.toString())}catch(P){this.s.error(P)}})());await Promise.allSettled(Y)}D(Y){const ie=Array.isArray(Y)?Y:[Y];return ie.length===1?ie[0]instanceof Error?ie[0]:new Error(ie[0]):ie.reduce((z,P)=>new Error(`${z.message}${z.message?",":""}${P instanceof Error?P.message:P}`),new Error(""))}};e.ExtensionsScanner=q=Le([Ae(1,$.IFileService),Ae(2,l.IExtensionsScannerService),Ae(3,a.IExtensionsProfileScannerService),Ae(4,me.IUriIdentityService),Ae(5,he.ILogService)],q);class J extends n.AbstractExtensionTask{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.isUndefined)(this.m.operation)?this.l:this.m.operation}constructor(Y,ie,z,P,M,K,te,j,W){super(),this.identifier=Y,this.source=ie,this.m=z,this.n=P,this.o=M,this.p=K,this.q=te,this.s=j,this.t=W,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(Y){const[ie,z]=await this.y(Y);return this.j=ie.isBuiltin||ie.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[ie,z]],this.j),ie}async v({zipPath:Y,key:ie,metadata:z},P){let M=await this.w(ie);return M||(this.t.trace("Extracting extension...",ie.id),M=await this.n.extractUserExtension(ie,Y,z,P),this.t.info("Extracting extension completed.",ie.id)),M}async w(Y){return await this.x(Y)?(this.t.trace("Removing the extension from uninstalled list:",Y.id),await this.n.setInstalled(Y),this.t.info("Removed the extension from uninstalled list:",Y.id),(await this.n.scanAllUserExtensions(!0)).find(P=>i.ExtensionKey.create(P).equals(Y))):void 0}async x(Y){return!!(await this.n.getUninstalledExtensions())[Y.toString()]}}class U extends J{constructor(Y,ie,z,P,M,K,te,j,W,x){super(ie.identifier,ie,z,M,K,te,j,W,x),this.z=ie,this.A=P}async y(Y){const z=(await this.n.scanExtensions(null,this.m.profileLocation)).find(te=>(0,i.areSameExtensions)(te.identifier,this.z.identifier));z&&(this.l=3);const P={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||z?.isMachineScoped,isBuiltin:this.m.isBuiltin||z?.isBuiltin,isSystem:z?.type===0?!0:void 0,updated:!!z,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,p.isBoolean)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:z?.preRelease)};if(z?.manifest.version===this.z.version)return[await this.n.updateMetadata(z,P),P];const{location:M,verificationStatus:K}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=K,this.C(M.fsPath),[await this.v({zipPath:M.fsPath,key:i.ExtensionKey.create(this.z),metadata:P},Y),P]}catch(te){try{await this.A.delete(M)}catch(j){this.t.warn("Error while deleting the downloaded file",M.toString(),(0,k.getErrorMessage)(j))}throw te}}async C(Y){try{await(0,D.getManifest)(Y)}catch(ie){throw new s.ExtensionManagementError((0,n.joinErrors)(ie).message,s.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=U;class ne extends J{constructor(Y,ie,z,P,M,K,te,j,W,x){super({id:(0,i.getGalleryExtensionId)(Y.publisher,Y.name)},ie,z,M,K,te,j,W,x),this.z=Y,this.A=ie,this.B=P}async h(Y){const ie=await super.h(Y);return this.E(ie,Y),ie}async y(Y){const ie=new i.ExtensionKey(this.identifier,this.z.version),P=(await this.n.scanExtensions(1,this.m.profileLocation)).find(te=>(0,i.areSameExtensions)(this.identifier,te.identifier)),M={isApplicationScoped:this.m.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||P?.isMachineScoped,isBuiltin:this.m.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(P)if(this.l=3,ie.equals(new i.ExtensionKey(P.identifier,P.manifest.version)))try{await this.n.removeExtension(P,"existing")}catch{throw new Error(I.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&g.gt(P.manifest.version,this.z.version)&&await this.n.setUninstalled(P);else{const te=await this.w(ie);if(te)try{await this.n.removeExtension(te,"existing")}catch{throw new Error(I.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:E.resolve(this.A.fsPath),key:ie,metadata:M},Y),M]}async E(Y,ie){try{let[z]=await this.B.getExtensions([{id:Y.identifier.id,version:Y.manifest.version}],ie);if(z||([z]=await this.B.getExtensions([{id:Y.identifier.id}],ie)),z){const P={id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId,isPreReleaseVersion:z.properties.isPreReleaseVersion,preRelease:z.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(Y,P,this.m.profileLocation)}}catch{}}}class V extends n.AbstractExtensionTask{constructor(Y,ie,z){super(),this.extension=Y,this.j=ie,this.k=z}async h(Y){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(pe[70],be([1,0,85,76,26,287,15,9,6,2,7,3,21,43,104]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{traceSocketEvent(w,S){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,S)}constructor(w,S=""){this.f=!0,this.debugLabel=S,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=N=>{if(this.traceSocketEvent("error",{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,T.onUnexpectedError)(N)}},this.socket.on("error",this.a),this.b=N=>{this.traceSocketEvent("close",{hadError:N}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(w){const S=N=>{this.traceSocketEvent("read",N),w(k.VSBuffer.wrap(N))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(w){const S=N=>{w({type:0,hadError:N,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(w){const S=()=>{w()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(w){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,T.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,T.onUnexpectedError)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.NodeSocket=p;var r;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(r||(r={}));var f;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})(f||(f={}));class c extends m.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(w,S){this.socket.traceSocketEvent(w,S)}constructor(w,S,N,$){super(),this.f=this.B(new v.Emitter),this.g=this.B(new v.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:N?.byteLength||0,recordInflateBytes:$}),this.a=this.B(new u(this,S,N,$,this.f,(ee,he)=>this.k(ee,he))),this.B(this.a.onError(ee=>{console.error(ee),(0,T.onUnexpectedError)(ee),this.g.fire({type:0,hadError:!0,error:ee})})),this.b=new g.ChunkStream,this.B(this.socket.onData(ee=>this.l(ee))),this.B(this.socket.onClose(async ee=>{this.a.isProcessingReadQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(ee)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this.f.event(w)}onClose(w){return this.g.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){let S=0;for(;S<w.byteLength;)this.a.writeMessage(w.slice(S,Math.min(S+262144,w.byteLength))),S+=262144}k(w,S){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let N=2;w.byteLength<126?N+=0:w.byteLength<2**16?N+=2:N+=8;const $=k.VSBuffer.alloc(N);if(S?$.writeUInt8(194,0):$.writeUInt8(130,0),w.byteLength<126)$.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){$.writeUInt8(126,1);let ee=1;$.writeUInt8(w.byteLength>>>8&255,++ee),$.writeUInt8(w.byteLength>>>0&255,++ee)}else{$.writeUInt8(127,1);let ee=1;$.writeUInt8(0,++ee),$.writeUInt8(0,++ee),$.writeUInt8(0,++ee),$.writeUInt8(0,++ee),$.writeUInt8(w.byteLength>>>24&255,++ee),$.writeUInt8(w.byteLength>>>16&255,++ee),$.writeUInt8(w.byteLength>>>8&255,++ee),$.writeUInt8(w.byteLength>>>0&255,++ee)}this.socket.write(k.VSBuffer.concat([$,w]))}end(){this.h=!0,this.socket.end()}l(w){if(w.byteLength!==0){for(this.b.acceptChunk(w);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const S=this.b.peek(this.j.readLen),N=S.readUInt8(0),$=(N&128)>>>7,ee=(N&64)>>>6,he=S.readUInt8(1),oe=(he&128)>>>7,ue=he&127;this.j.state=2,this.j.readLen=2+(oe?4:0)+(ue===126?2:0)+(ue===127?8:0),this.j.fin=$,this.j.firstFrameOfMessage&&(this.j.compressed=!!ee),this.j.firstFrameOfMessage=!!$,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const S=this.b.read(this.j.readLen),N=S.readUInt8(1),$=(N&128)>>>7;let ee=N&127,he=1;ee===126?ee=S.readUInt8(++he)*2**8+S.readUInt8(++he):ee===127&&(ee=S.readUInt8(++he)*0+S.readUInt8(++he)*0+S.readUInt8(++he)*0+S.readUInt8(++he)*0+S.readUInt8(++he)*2**24+S.readUInt8(++he)*2**16+S.readUInt8(++he)*2**8+S.readUInt8(++he));let oe=0;$&&(oe=S.readUInt8(++he)*2**24+S.readUInt8(++he)*2**16+S.readUInt8(++he)*2**8+S.readUInt8(++he)),this.j.state=3,this.j.readLen=ee,this.j.mask=oe,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const S=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),t(S,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(S,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=c;class u extends m.Disposable{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(w,S,N,$,ee,he){super(),this.l=w,this.m=ee,this.n=he,this.a=this.B(new v.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new v.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new v.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,S?(this.b=this.B(new I(this.l,$,N,{windowBits:15})),this.f=this.B(new O(this.l,{windowBits:15})),this.B(this.b.onError(oe=>this.a.fire(oe))),this.B(this.f.onError(oe=>this.a.fire(oe)))):(this.b=null,this.f=null)}writeMessage(w){this.g.push(w),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const w=this.g.shift();if(this.f){const S=await this.s(this.f,w);this.n(S,!0)}else this.n(w,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(w,S){return new Promise((N,$)=>{w.write(S),w.flush(ee=>N(ee))})}acceptFrame(w,S,N){this.h.push({data:w,isCompressed:S,isLastFrameOfMessage:N}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const w=this.h.shift();if(this.b&&w.isCompressed){const S=await this.w(this.b,w.data,w.isLastFrameOfMessage);this.m.fire(S)}else this.m.fire(w.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(w,S,N){return new Promise(($,ee)=>{w.write(S),N&&w.write(k.VSBuffer.fromByteArray([0,0,255,255])),w.flush(he=>$(he))})}}class I extends m.Disposable{get recordedInflateBytes(){return this.j?k.VSBuffer.concat(this.f):k.VSBuffer.alloc(0)}constructor(w,S,N,$){super(),this.h=w,this.j=S,this.a=this.B(new v.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)($),this.b.on("error",ee=>{this.h.traceSocketEvent("zlibInflateError",{message:ee?.message,code:ee?.code}),this.a.fire(ee)}),this.b.on("data",ee=>{this.h.traceSocketEvent("zlibInflateData",ee),this.g.push(k.VSBuffer.wrap(ee))}),N&&(this.h.traceSocketEvent("zlibInflateInitialWrite",N.buffer),this.b.write(N.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(w){this.j&&this.f.push(w.clone()),this.h.traceSocketEvent("zlibInflateWrite",w),this.b.write(w.buffer)}flush(w){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const S=k.VSBuffer.concat(this.g);this.g.length=0,w(S)})}}class O extends m.Disposable{constructor(w,S){super(),this.g=w,this.a=this.B(new v.Emitter),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",N=>{this.g.traceSocketEvent("zlibDeflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.g.traceSocketEvent("zlibDeflateData",N),this.f.push(k.VSBuffer.wrap(N))})}write(w){this.g.traceSocketEvent("zlibDeflateWrite",w.buffer),this.b.write(w.buffer)}flush(w){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let S=k.VSBuffer.concat(this.f);this.f.length=0,S=S.slice(0,S.byteLength-4),w(S)})}}function t(D,w){if(w===0)return;const S=D.byteLength>>>2;for(let ue=0;ue<S;ue++){const me=D.readUInt32BE(ue*4);D.writeUInt32BE(me^w,ue*4)}const N=S*4,$=D.byteLength-N,ee=w>>>24&255,he=w>>>16&255,oe=w>>>8&255;$>=1&&D.writeUInt8(D.readUInt8(N)^ee,N),$>=2&&D.writeUInt8(D.readUInt8(N+1)^he,N+1),$>=3&&D.writeUInt8(D.readUInt8(N+2)^oe,N+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function s(){const D=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const w=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,o.tmpdir)(),S=(0,R.join)(w,`vscode-ipc-${D}.sock`);return a(S),S}e.createRandomIPCHandle=s;function i(D,w,S){const N=(0,y.createHash)("md5").update(D).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${S}-${w}-sock`;const $=S.substr(0,4),ee=w.substr(0,6),he=N.substr(0,8);let oe;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?oe=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${he}-${$}-${ee}.sock`):oe=(0,R.join)(D,`${$}-${ee}.sock`),a(oe),oe}e.createStaticIPCHandle=i;function a(D){const w=n[E.platform];typeof w=="number"&&D.length>=w&&console.warn(`WARNING: IPC handle "${D}" is longer than ${w} chars, try a shorter --user-data-dir`)}class l extends d.IPCServer{static b(w){const S=v.Event.fromNodeEventEmitter(w,"connection");return v.Event.map(S,N=>({protocol:new g.Protocol(new p(N,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(N,"close"))}))}constructor(w){super(l.b(w)),this.d=w}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=l;function h(D){return new Promise((w,S)=>{const N=(0,L.createServer)();N.on("error",S),N.listen(D,()=>{N.removeListener("error",S),w(new l(N))})})}e.serve=h;function C(D,w){return new Promise((S,N)=>{const $=(0,L.createConnection)(D,()=>{$.removeListener("error",N),S(g.Client.fromSocket(new p($,`ipc-client${w}`),w))});$.once("error",N)})}e.connect=C}),define(pe[138],be([1,0,83,14,15,9,8,24,25,84,12,44,232,287]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let g=e.RequestService=class extends E.AbstractRequestService{constructor(c,u,I,O){super(O),this.j=c,this.k=u,this.l=I,this.m(),this.B(c.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const c=this.j.getValue("http");this.f=c?.proxy,this.g=!!c?.proxyStrictSSL,this.h=c?.proxyAuthorization}async request(c,u){const{f:I,g:O}=this;let t;try{t=await(0,m.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(i){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,A.getErrorMessage)(i)))}const n={...process.env,...t},s=c.agent?c.agent:await(0,b.getProxyAgent)(c.url||"",n,{proxyUrl:I,strictSSL:O});return c.agent=s,c.strictSSL=O,this.h&&(c.headers={...c.headers||{},"Proxy-Authorization":this.h}),this.c(c.isChromiumNetwork?"electron":"node",c,()=>r(c,u))}async resolveProxy(c){}};e.RequestService=g=Le([Ae(0,T.IConfigurationService),Ae(1,v.INativeEnvironmentService),Ae(2,R.ILogService),Ae(3,R.ILoggerService)],g);async function p(f){return((0,y.parse)(f.url).protocol==="https:"?await new Promise((I,O)=>{le(["https"],I,O)}):await new Promise((I,O)=>{le(["http"],I,O)})).request}async function r(f,c){return L.Promises.withAsyncBody(async(u,I)=>{const O=(0,y.parse)(f.url),t=f.getRawRequest?f.getRawRequest(f):await p(f),n={hostname:O.hostname,port:O.port?parseInt(O.port):O.protocol==="https:"?443:80,protocol:O.protocol,path:O.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,k.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(n.auth=f.user+":"+f.password);const s=t(n,i=>{const a=(0,k.isNumber)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&a>0&&i.headers.location)r({...f,url:i.headers.location,followRedirects:a-1},c).then(u,I);else{let l=i;!f.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,d.createGunzip)())),u({res:i,stream:(0,o.streamToBufferReadableStream)(l)})}});s.on("error",I),f.timeout&&s.setTimeout(f.timeout),f.isChromiumNetwork&&s.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&s.write(f.data),s.end(),c.onCancellationRequested(()=>{s.abort(),I(new A.CancellationError)})})}e.nodeRequest=r}),define(pe[139],be([1,0,51,76,88,13,7,15,6,70,84,12,41,3,59,127,2,275,24]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function u(i={},a,l,h,C,D){const w=await(0,o.getNLSConfiguration)(l,h.userDataPath);let S={};if(a)try{S=await(0,R.getResolvedShellEnv)(D,C,h.args,process.env)}catch(ue){C.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ue)}const $={...process.env,...S,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(w,void 0,0),...i},ee=h.isBuilt?(0,k.join)(h.appRoot,"bin"):(0,k.join)(h.appRoot,"resources","server","bin-dev"),he=(0,k.join)(ee,"remote-cli");let oe=t($,"PATH");return oe?oe=he+k.delimiter+oe:oe=he,n($,"PATH",oe),h.args["without-browser-env-var"]||($.BROWSER=(0,k.join)(ee,"helpers",d.isWindows?"browser.cmd":"browser.sh")),s($),$}e.buildUserEnvironment=u;class I{constructor(a,l){this.socket=a,this.initialDataChunk=l}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let a,l,h;return this.socket instanceof m.NodeSocket?(a=!0,l=!1,h=T.VSBuffer.alloc(0)):(a=!1,l=this.socket.permessageDeflate,h=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:a,permessageDeflate:l,inflateBytes:h.buffer.toString("base64")}}}let O=e.ExtensionHostConnection=class{constructor(a,l,h,C,D,w,S,N){this.i=a,this.j=D,this.l=w,this.m=S,this.n=N,this.b=new v.Emitter,this.onClose=this.b.event,this.c=!d.isWindows||!this.j.args["socket-path"],this.d=!1,this.f=l,this.g=null,this.h=new I(h,C),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(a){this.l.info(`${this.o}${a}`)}q(a){this.l.error(`${this.o}${a}`)}async r(a,l){const h=new r.DisposableStore;h.add(l.socket),h.add((0,r.toDisposable)(()=>{a.destroy()}));const C=()=>{h.dispose()};h.add(l.socket.onEnd(C)),h.add(l.socket.onClose(C)),h.add(v.Event.fromNodeEventEmitter(a,"end")(C)),h.add(v.Event.fromNodeEventEmitter(a,"close")(C)),h.add(v.Event.fromNodeEventEmitter(a,"error")(C)),h.add(l.socket.onData(D=>a.write(D.buffer))),h.add(v.Event.fromNodeEventEmitter(a,"data")(D=>{l.socket.write(T.VSBuffer.wrap(D))})),l.initialDataChunk.byteLength>0&&a.write(l.initialDataChunk.buffer)}async s(a,l){await l.socketDrain();const h=l.toIExtHostSocketMessage();let C;l.socket instanceof m.NodeSocket?C=l.socket.socket:C=l.socket.socket.socket,a.send(h,C)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const a={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(a)}acceptReconnection(a,l,h){this.f=a,this.p("The client has reconnected.");const C=new I(l,h);if(!this.g){this.h=C;return}this.s(this.g,C)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(a){try{let l=process.execArgv?process.execArgv.filter(he=>!/^--inspect(-brk)?=/.test(he)):[];a.port&&!process.pkg&&(l=[`--inspect${a.break?"-brk":""}=${a.port}`]);const h=await u(a.env,!0,a.language,this.j,this.l,this.n);(0,g.removeDangerousEnvVariables)(h);let C;if(this.c)(0,f.writeExtHostConnection)(new f.SocketExtHostConnection,h),C=null;else{const{namedPipeServer:he,pipeName:oe}=await this.u();(0,f.writeExtHostConnection)(new f.IPCExtHostConnection(oe),h),C=he}const D={env:h,execArgv:l,silent:!0},w=["--type=extensionHost","--transformURIs"],S=this.j.args["use-host-proxy"];w.push(`--useHostProxy=${S?"true":"false"}`),this.g=y.fork(A.FileAccess.asFileUri("bootstrap-fork").fsPath,w,D);const N=this.g.pid;this.p(`<${N}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const $=v.Event.fromNodeEventEmitter(this.g.stdout,"data"),ee=v.Event.fromNodeEventEmitter(this.g.stderr,"data");if($(he=>this.p(`<${N}> ${he}`)),ee(he=>this.p(`<${N}><stderr> ${he}`)),this.g.on("error",he=>{this.q(`<${N}> Extension Host Process had an error`),this.l.error(he),this.t()}),this.g.on("exit",(he,oe)=>{this.m.setExitInfo(this.i,{code:he,signal:oe}),this.p(`<${N}> Extension Host Process exited with code: ${he}, signal: ${oe}.`),this.t()}),C)C.on("connection",he=>{C.close(),this.r(he,this.h)});else{const he=oe=>{oe.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",he),this.s(this.g,this.h),this.h=null)};this.g.on("message",he)}}catch(l){console.error("ExtensionHostConnection errored"),l&&console.error(l)}}u(){return new Promise((a,l)=>{const h=(0,m.createRandomIPCHandle)(),C=L.createServer();C.on("error",l),C.listen(h,()=>{C?.removeListener("error",l),a({pipeName:h,namedPipeServer:C})})})}};e.ExtensionHostConnection=O=Le([Ae(4,b.IServerEnvironmentService),Ae(5,E.ILogService),Ae(6,p.IExtensionHostStatusService),Ae(7,c.IConfigurationService)],O);function t(i,a){const l=Object.keys(i).filter(C=>C.toLowerCase()===a.toLowerCase()),h=l.length>0?l[0]:a;return i[h]}function n(i,a,l){const h=Object.keys(i).filter(D=>D.toLowerCase()===a.toLowerCase()),C=h.length>0?h[0]:a;i[C]=l}function s(i){for(const a of Object.keys(i))i[a]===null&&delete i[a]}}),define(pe[288],be([1,0,81,12,63,115,24,44,138,37,31,30,125,137,80,109,54,2,110,66,13,16,27,41,118,82,119,9,4,7,29,230,79,36,123,62,3,57,128,32,45,67,126,124,112,113,193,289]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c,u,I,O,t,n,s,i,a,l,h,C,D,w,S,N,$,ee,he,oe,ue,me,_,re,q,J,U,ne,V,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class Y extends f.Disposable{constructor(M,K){super(),this.a=M,this.b=K,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const M=await this.f();await M.invokeFunction(async K=>{const te=K.get(k.IConfigurationService),j=K.get(L.ILogService);he.isWindows&&(te.getValue("security.restrictUNCAccess")===!1?(0,se.disableUNCAccessRestrictions)():(0,se.addUNCHostToAllowlist)(te.getValue("security.allowedUNCHosts")));try{await this.g(M.createInstance(s.ExtensionManagementCLI,new L.ConsoleLogger(j.getLevel(),!1)))}catch(W){throw j.error(W),console.error((0,l.getErrorMessage)(W)),W}})}async f(){const M=new y.ServiceCollection,K={_serviceBrand:void 0,...r.default};M.set(t.IProductService,K);const te=new n.ServerEnvironmentService(this.a,K);M.set(n.IServerEnvironmentService,te);const j=new ne.LoggerService((0,L.getLogLevel)(te),te.logsHome);M.set(L.ILoggerService,j);const W=new U.LogService(this.B(j.createLogger("remoteCLI",{name:(0,V.localize)(0,null)})));M.set(L.ILogService,W),W.trace(`Remote configuration data at ${this.b}`),W.trace("process arguments:",this.a);const x=this.B(new c.FileService(W));M.set(O.IFileService,x),x.registerProvider(I.Schemas.file,this.B(new u.DiskFileSystemProvider(W)));const H=new $.UriIdentityService(x);M.set(N.IUriIdentityService,H);const Q=this.B(new q.ServerUserDataProfilesService(H,te,x,W));M.set(me.IUserDataProfilesService,Q);const G=this.B(new A.ConfigurationService(Q.defaultProfile.settingsResource,x,new re.NullPolicyService,W));return M.set(k.IConfigurationService,G),await Promise.all([G.initialize(),Q.init()]),M.set(T.IRequestService,new o.SyncDescriptor(v.RequestService)),M.set(S.IDownloadService,new o.SyncDescriptor(w.DownloadService)),M.set(R.ITelemetryService,m.NullTelemetryService),M.set(E.IExtensionGalleryService,new o.SyncDescriptor(b.ExtensionGalleryServiceWithNoStorageService)),M.set(_.IExtensionsProfileScannerService,new o.SyncDescriptor(J.ExtensionsProfileScannerService)),M.set(oe.IExtensionsScannerService,new o.SyncDescriptor(ue.ExtensionsScannerService)),M.set(g.IExtensionSignatureVerificationService,new o.SyncDescriptor(g.ExtensionSignatureVerificationService)),M.set(d.INativeServerExtensionManagementService,new o.SyncDescriptor(d.ExtensionManagementService)),M.set(i.ILanguagePackService,new o.SyncDescriptor(a.NativeLanguagePackService)),new p.InstantiationService(M)}async g(M){if(this.a["list-extensions"])return M.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const K={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return M.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),K,!!this.a.force)}else{if(this.a["uninstall-extension"])return M.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return M.locateExtension(this.a["locate-extension"])}}h(M){return M.map(K=>/\.vsix$/i.test(K)?h.URI.file((0,C.isAbsolute)(K)?K:(0,C.join)((0,D.cwd)(),K)):K)}}function ie(P){setTimeout(()=>process.exit(P),0)}async function z(P,M,K){if(P.help){const j=r.default.serverApplicationName+(he.isWindows?".cmd":"");console.log((0,ee.buildHelpMessage)(r.default.nameLong,j,r.default.version,K,{noInputFiles:!0,noPipe:!0}));return}if(P.version){console.log((0,ee.buildVersionMessage)(r.default.version,r.default.commit));return}const te=new Y(P,M);try{await te.run(),ie(0)}catch{ie(1)}finally{te.dispose()}}e.run=z}),define(pe[290],be([1,0,70,263,33,283,4,12,87]),function(le,e,y,L,o,A,k,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class m{constructor(b,d,g){this.b=b,this.c=d,this.f=g,this.a=L.createServer((p,r)=>this.h(p,r)),this.g().catch(p=>(d.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",b=>this.c.error(b))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(b,d){const g=(r,f)=>{d.writeHead(r,{"content-type":"application/json"}),d.end(JSON.stringify(f||null),c=>c&&this.c.error(c))},p=[];b.setEncoding("utf8"),b.on("data",r=>p.push(r)),b.on("end",async()=>{try{const r=JSON.parse(p.join(""));let f;switch(r.type){case"open":f=await this.i(r);break;case"openExternal":f=await this.j(r);break;case"status":f=await this.l(r);break;case"extensionManagement":f=await this.k(r);break;default:g(404,`Unknown message type: ${r.type}`);break}g(200,f)}catch(r){const f=r instanceof Error?r.message:JSON.stringify(r);g(500,f),this.c.error("Error while processing pipe request",r)}})}async i(b){const{fileURIs:d,folderURIs:g,forceNewWindow:p,diffMode:r,mergeMode:f,addMode:c,forceReuseWindow:u,gotoLineMode:I,waitMarkerFilePath:O,remoteAuthority:t}=b,n=[];if(Array.isArray(g))for(const l of g)try{n.push({folderUri:k.URI.parse(l)})}catch{}if(Array.isArray(d))for(const l of d)try{(0,v.hasWorkspaceFileExtension)(l)?n.push({workspaceUri:k.URI.parse(l)}):n.push({fileUri:k.URI.parse(l)})}catch{}const s=O?k.URI.file(O):void 0,a={forceNewWindow:p,diffMode:r,mergeMode:f,addMode:c,gotoLineMode:I,forceReuseWindow:u,preferNewWindow:!u&&!s&&!c,waitMarkerFileURI:s,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",n,a),""}async j(b){for(const d of b.uris){const g=k.URI.parse(d),p=g.scheme==="file"?g:d;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k(b){const d=p=>p?.map(r=>/\.vsix$/i.test(r)?k.URI.parse(r):r),g={list:b.list,install:d(b.install),uninstall:d(b.uninstall),force:b.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",g)}async l(b){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&o.existsSync(this.f)&&o.unlinkSync(this.f)}}e.CLIServerBase=m;let R=e.CLIServer=class extends m{constructor(b,d){super(b,d,(0,y.createRandomIPCHandle)())}};e.CLIServer=R=Le([Ae(0,A.IExtHostCommands),Ae(1,T.ILogService)],R)}),define(pe[291],be([1,0,26,6,22,2,7,3,4,70,68,290,121,86,270,272,139,8]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class c extends p.AbstractVariableResolverService{constructor(O,t,n,s,i){super({getFolderUri:a=>{const l=t.filter(h=>h.name===a);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.length,getConfigurationValue:(a,l)=>s[`config:${l}`],getExecPath:()=>O.VSCODE_EXEC_PATH,getAppRoot:()=>O.VSCODE_CWD,getFilePath:()=>{if(n)return k.normalize(n.fsPath)},getSelectedText:()=>s.selectedText,getLineNumber:()=>s.lineNumber,getExtension:async a=>{const h=(await i.getInstalled()).find(C=>C.identifier.id===a);return h&&{extensionLocation:h.location}}},void 0,Promise.resolve(y.homedir()),Promise.resolve(O))}}class u extends A.Disposable{constructor(O,t,n,s,i,a){super(),this.g=O,this.h=t,this.i=n,this.j=s,this.l=i,this.m=a,this.a=0,this.b=new Map,this.c=this.B(new L.Emitter),this.onExecuteCommand=this.c.event}async call(O,t,n){switch(t){case"$restartPtyHost":return this.i.restartPtyHost?.apply(this.i,n);case"$createProcess":{const s=(0,R.createURITransformer)(O.remoteAuthority);return this.n(s,n)}case"$attachToProcess":return this.i.attachToProcess.apply(this.i,n);case"$detachFromProcess":return this.i.detachFromProcess.apply(this.i,n);case"$listProcesses":return this.i.listProcesses.apply(this.i,n);case"$orphanQuestionReply":return this.i.orphanQuestionReply.apply(this.i,n);case"$acceptPtyHostResolvedVariables":return this.i.acceptPtyHostResolvedVariables?.apply(this.i,n);case"$start":return this.i.start.apply(this.i,n);case"$input":return this.i.input.apply(this.i,n);case"$acknowledgeDataEvent":return this.i.acknowledgeDataEvent.apply(this.i,n);case"$shutdown":return this.i.shutdown.apply(this.i,n);case"$resize":return this.i.resize.apply(this.i,n);case"$getInitialCwd":return this.i.getInitialCwd.apply(this.i,n);case"$getCwd":return this.i.getCwd.apply(this.i,n);case"$processBinary":return this.i.processBinary.apply(this.i,n);case"$sendCommandResult":return this.r(n[0],n[1],n[2]);case"$installAutoReply":return this.i.installAutoReply.apply(this.i,n);case"$uninstallAllAutoReplies":return this.i.uninstallAllAutoReplies.apply(this.i,n);case"$getDefaultSystemShell":return this.s.apply(this,n);case"$getProfiles":return this.t.apply(this,n);case"$getEnvironment":return this.u();case"$getWslPath":return this.w(n[0],n[1]);case"$getTerminalLayoutInfo":return this.i.getTerminalLayoutInfo(n);case"$setTerminalLayoutInfo":return this.i.setTerminalLayoutInfo(n);case"$serializeTerminalState":return this.i.serializeTerminalState.apply(this.i,n);case"$reviveTerminalProcesses":return this.i.reviveTerminalProcesses.apply(this.i,n);case"$getRevivedPtyNewId":return this.i.getRevivedPtyNewId.apply(this.i,n);case"$setUnicodeVersion":return this.i.setUnicodeVersion.apply(this.i,n);case"$reduceConnectionGraceTime":return this.y();case"$updateIcon":return this.i.updateIcon.apply(this.i,n);case"$updateTitle":return this.i.updateTitle.apply(this.i,n);case"$updateProperty":return this.i.updateProperty.apply(this.i,n);case"$refreshProperty":return this.i.refreshProperty.apply(this.i,n);case"$requestDetachInstance":return this.i.requestDetachInstance(n[0],n[1]);case"$acceptDetachedInstance":return this.i.acceptDetachInstanceReply(n[0],n[1]);case"$freePortKillProcess":return this.i.freePortKillProcess?.apply(this.i,n)}throw new Error(`IPC Command ${t} not found`)}listen(O,t,n){switch(t){case"$onPtyHostExitEvent":return this.i.onPtyHostExit||L.Event.None;case"$onPtyHostStartEvent":return this.i.onPtyHostStart||L.Event.None;case"$onPtyHostUnresponsiveEvent":return this.i.onPtyHostUnresponsive||L.Event.None;case"$onPtyHostResponsiveEvent":return this.i.onPtyHostResponsive||L.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.i.onPtyHostRequestResolveVariables||L.Event.None;case"$onProcessDataEvent":return this.i.onProcessData;case"$onProcessReadyEvent":return this.i.onProcessReady;case"$onProcessExitEvent":return this.i.onProcessExit;case"$onProcessReplayEvent":return this.i.onProcessReplay;case"$onProcessOrphanQuestion":return this.i.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.i.onDidRequestDetach||L.Event.None;case"$onDidChangeProperty":return this.i.onDidChangeProperty;default:break}throw new Error("Not supported")}async n(O,t){const n={name:t.shellLaunchConfig.name,executable:t.shellLaunchConfig.executable,args:t.shellLaunchConfig.args,cwd:typeof t.shellLaunchConfig.cwd=="string"||typeof t.shellLaunchConfig.cwd>"u"?t.shellLaunchConfig.cwd:v.URI.revive(O.transformIncoming(t.shellLaunchConfig.cwd)),env:t.shellLaunchConfig.env,useShellEnvironment:t.shellLaunchConfig.useShellEnvironment,reconnectionProperties:t.shellLaunchConfig.reconnectionProperties,type:t.shellLaunchConfig.type,isFeatureTerminal:t.shellLaunchConfig.isFeatureTerminal},s=await(0,r.buildUserEnvironment)(t.resolverEnv,!!t.shellLaunchConfig.useShellEnvironment,T.language,this.g,this.h,this.m);this.h.trace("baseEnv",s);const i=me=>({uri:v.URI.revive(O.transformIncoming(me.uri)),name:me.name,index:me.index,toResource:()=>{throw new Error("Not implemented")}}),a=t.workspaceFolders.map(i),l=t.activeWorkspaceFolder?i(t.activeWorkspaceFolder):void 0,h=t.activeFileResource?v.URI.revive(O.transformIncoming(t.activeFileResource)):void 0,C=new c(s,a,h,t.resolvedVariables,this.l),D=g.createVariableResolver(l,process.env,C),w=await g.getCwd(n,y.homedir(),D,l?.uri,t.configuration["terminal.integrated.cwd"],this.h);n.cwd=w;const S=T.isWindows?"terminal.integrated.env.windows":T.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",N=t.configuration[S],$=await g.createTerminalEnvironment(n,N,D,this.j.version,t.configuration["terminal.integrated.detectLocale"],s);if(!n.strictEnv){const me=[];for(const[J,U,ne]of t.envVariableCollections)me.push([J,{map:(0,d.deserializeEnvironmentVariableCollection)(U),descriptionMap:(0,d.deserializeEnvironmentDescriptionMap)(ne)}]);const _=new Map(me),re=new b.MergedEnvironmentVariableCollection(_),q=l?(0,f.withNullAsUndefined)(l):void 0;await re.applyToProcessEnvironment($,{workspaceFolder:q},D)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:n,initialCwd:w,cols:t.cols,rows:t.rows,env:$});const ee=(0,m.createRandomIPCHandle)();$.VSCODE_IPC_HOOK_CLI=ee;const he=await this.i.createProcess(n,w,t.cols,t.rows,t.unicodeVersion,$,s,t.options,t.shouldPersistTerminal,t.workspaceId,t.workspaceName),oe={executeCommand:(me,..._)=>this.p(he,me,_,O)},ue=new E.CLIServerBase(oe,this.h,ee);return this.i.onProcessExit(me=>me.id===he&&ue.dispose()),{persistentTerminalId:he,resolvedShellLaunchConfig:n}}p(O,t,n,s){let i,a;const l=new Promise((D,w)=>{i=D,a=w}),h=++this.a;this.b.set(h,{resolve:i,reject:a,uriTransformer:s});const C=(0,o.cloneAndChange)(n,D=>{if(D&&D.$mid===1)return s.transformOutgoing(D);if(D&&D instanceof v.URI)return s.transformOutgoingURI(D)});return this.c.fire({reqId:h,persistentProcessId:O,commandId:t,commandArgs:C}),l}r(O,t,n){const s=this.b.get(O);if(!s)return;this.b.delete(O);const i=(0,o.cloneAndChange)(n,a=>{if(a&&a.$mid===1)return s.uriTransformer.transformIncoming(a)});t?s.reject(i):s.resolve(i)}s(O){return this.i.getDefaultSystemShell(O)}async t(O,t,n,s){return this.i.getProfiles?.(O,t,n,s)||[]}u(){return{...process.env}}w(O,t){return this.i.getWslPath(O,t)}y(){return this.i.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=u}),define(pe[292],be([1,0,26,6,2,13,7,100,23,43,24,115,78,261,201,79,202,211,220,25,125,30,80,118,212,137,16,110,66,63,109,81,82,119,12,54,27,44,231,138,117,31,37,245,122,253,36,123,267,268,236,242,291,68,41,274,284,127,57,128,45,32,262,67,243,113,126,124,112,111,195,281,227,257,250]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c,u,I,O,t,n,s,i,a,l,h,C,D,w,S,N,$,ee,he,oe,ue,me,_,re,q,J,U,ne,V,se,Y,ie,z,P,M,K,te,j,W,x,H,Q,G,Z,ce,Ee,Ce,ke,Fe,je,ge,Se,ye,Me,ze,_e,qe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Ve="monacoworkbench";async function et(Oe,$e,We,Qe){const Ye=new w.ServiceCollection,Ke=new Xe,tt={_serviceBrand:void 0,...ee.default};Ye.set(he.IProductService,tt);const it=new te.ServerEnvironmentService($e,tt);Ye.set(u.IEnvironmentService,it),Ye.set(u.INativeEnvironmentService,it);const ut=new ke.LoggerService((0,$.getLogLevel)(it),it.logsHome);Ye.set($.ILoggerService,ut),Ke.registerChannel("logger",new Se.LoggerChannel(ut,we=>Ge(we.remoteAuthority)));const Et=ut.createLogger("remoteagent",{name:(0,ye.localize)(0,null)}),ot=new ge.LogService(Et,[new fe((0,$.getLogLevel)(it))]);Ye.set($.ILogService,ot),setTimeout(()=>Re(it.logsHome.fsPath).then(null,we=>ot.error(we)),1e4),ot.onDidChangeLogLevel(we=>(0,$.log)(ot,we,`Log level changed to ${(0,$.LogLevelToString)(ot.getLevel())}`)),ot.trace(`Remote configuration data at ${We}`),ot.trace("process arguments:",it.args),Array.isArray(tt.serverGreeting)&&ot.info(`

${tt.serverGreeting.join(`
`)}

`),Ke.registerChannel(g.ExtensionHostDebugBroadcastChannel.ChannelName,new g.ExtensionHostDebugBroadcastChannel);const Mt=new m.StaticRouter(we=>we.clientId==="renderer"),dt=Qe.add(new l.FileService(ot));Ye.set(a.IFileService,dt),dt.registerProvider(A.Schemas.file,Qe.add(new h.DiskFileSystemProvider(ot)));const mt=new se.UriIdentityService(dt);Ye.set(V.IUriIdentityService,mt);const gt=new E.ConfigurationService(it.machineSettingsResource,dt,new Ee.NullPolicyService,ot);Ye.set(R.IConfigurationService,gt);const wt=new Fe.ServerUserDataProfilesService(mt,it,dt,ot);Ye.set(Z.IUserDataProfilesService,wt),Ke.registerChannel("userDataProfiles",new _e.RemoteUserDataProfilesServiceChannel(wt,we=>Ge(we.remoteAuthority)));const[,,Ut]=await Promise.all([gt.initialize(),wt.init(),(0,T.getMachineId)(ot.error.bind(ot))]),At=new x.ExtensionHostStatusService;Ye.set(x.IExtensionHostStatusService,At),Ye.set(oe.IRequestService,new C.SyncDescriptor(me.RequestService));let yt=q.NullAppender;const Rt=(0,q.isInternalTelemetry)(tt,gt);if((0,q.supportsTelemetry)(tt,it)){const we=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";we?yt=new Ce.OneDataSystemAppender(!1,Ve,null,()=>new ce.TelemetryClient(we)):tt.aiConfig&&tt.aiConfig.ariaKey&&(yt=new Ce.OneDataSystemAppender(Rt,Ve,null,tt.aiConfig.ariaKey)),Qe.add((0,o.toDisposable)(()=>yt?.flush()));const De={appenders:[yt],commonProperties:(0,_.resolveCommonProperties)((0,y.release)(),(0,y.hostname)(),process.arch,tt.commit,tt.version+"-remote",Ut,Rt,"remoteAgent"),piiPaths:(0,q.getPiiPathsFromEnvironment)(it)},de=it.args["telemetry-level"];let X=3;de==="all"?X=3:de==="error"?X=2:de==="crash"?X=1:de!==void 0&&(X=0),Ye.set(P.IServerTelemetryService,new C.SyncDescriptor(P.ServerTelemetryService,[De,X]))}else Ye.set(P.IServerTelemetryService,P.ServerNullTelemetryService);Ye.set(O.IExtensionGalleryService,new C.SyncDescriptor(I.ExtensionGalleryServiceWithNoStorageService));const St=Ke.getChannel("download",Mt);Ye.set(p.IDownloadService,new r.DownloadServiceChannelClient(St,()=>Ge("renderer"))),Ye.set(G.IExtensionsProfileScannerService,new C.SyncDescriptor(je.ExtensionsProfileScannerService)),Ye.set(H.IExtensionsScannerService,new C.SyncDescriptor(Q.ExtensionsScannerService)),Ye.set(t.IExtensionSignatureVerificationService,new C.SyncDescriptor(t.ExtensionSignatureVerificationService)),Ye.set(i.INativeServerExtensionManagementService,new C.SyncDescriptor(i.ExtensionManagementService));const pt=new D.InstantiationService(Ye);Ye.set(S.ILanguagePackService,pt.createInstance(N.NativeLanguagePackService));const Tt=pt.createInstance(qe.NodePtyHostStarter,{graceTime:108e5,shortGraceTime:3e5,scrollback:gt.getValue("terminal.integrated.persistentSessionScrollback")??100}),Lt=pt.createInstance(ne.PtyHostService,Tt);return Ye.set(U.IPtyService,Lt),Ye.set(f.IEncryptionMainService,new C.SyncDescriptor(c.EncryptionMainService,[Ut])),Ye.set(b.ICredentialsMainService,new C.SyncDescriptor(d.CredentialsWebMainService)),pt.invokeFunction(we=>{const De=we.get(i.INativeServerExtensionManagementService),de=we.get(H.IExtensionsScannerService),X=we.get(O.IExtensionGalleryService),Pe=we.get(S.ILanguagePackService),Ne=new Y.RemoteAgentEnvironmentChannel(Oe,it,wt,At);Ke.registerChannel("remoteextensionsenvironment",Ne);const He=new z.ServerTelemetryChannel(we.get(P.IServerTelemetryService),yt);Ke.registerChannel("telemetry",He),Ke.registerChannel(j.REMOTE_TERMINAL_CHANNEL_NAME,new M.RemoteTerminalChannel(it,ot,Lt,tt,De,gt));const Be=new Me.RemoteExtensionsScannerService(pt.createInstance(n.ExtensionManagementCLI,ot),it,wt,de,ot,X,Pe);Ke.registerChannel(ze.RemoteExtensionsScannerChannelName,new Me.RemoteExtensionsScannerChannel(Be,at=>Ge(at.remoteAuthority)));const Je=new ie.RemoteAgentFileSystemProviderChannel(ot,it);Ke.registerChannel(W.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Je),Ke.registerChannel("request",new ue.RequestChannel(we.get(oe.IRequestService)));const ct=new s.ExtensionManagementChannel(De,at=>Ge(at.remoteAuthority));Ke.registerChannel("extensions",ct);const vt=m.ProxyChannel.fromService(we.get(S.ILanguagePackService));Ke.registerChannel("languagePacks",vt);const ft=m.ProxyChannel.fromService(we.get(f.IEncryptionMainService));Ke.registerChannel("encryption",ft);const lt=m.ProxyChannel.fromService(we.get(b.ICredentialsMainService));return Ke.registerChannel("credentials",lt),Be.whenExtensionsReady().then(()=>De.cleanUp()),Qe.add(new J.default(we.get(re.ITelemetryService))),{telemetryService:we.get(re.ITelemetryService)}}),{socketServer:Ke,instantiationService:pt}}e.setupServerServices=et;const rt=Object.create(null);function Ge(Oe){return rt[Oe]||(rt[Oe]=(0,K.createURITransformer)(Oe)),rt[Oe]}class Xe extends m.IPCServer{constructor(){const $e=new L.Emitter;super($e.event),this.b=$e}acceptConnection($e,We){this.b.fire({protocol:$e,onDidClientDisconnect:We})}}e.SocketServer=Xe;class fe extends $.AbstractLogger{constructor($e=$.DEFAULT_LOG_LEVEL){super(),this.setLevel($e),this.g=!!process.stdout.isTTY}trace($e,...We){this.f($.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Ie()}]\x1B[0m`,$e,...We):console.log(`[${Ie()}]`,$e,...We))}debug($e,...We){this.f($.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Ie()}]\x1B[0m`,$e,...We):console.log(`[${Ie()}]`,$e,...We))}info($e,...We){this.f($.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Ie()}]\x1B[0m`,$e,...We):console.log(`[${Ie()}]`,$e,...We))}warn($e,...We){this.f($.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Ie()}]\x1B[0m`,$e,...We):console.warn(`[${Ie()}]`,$e,...We))}error($e,...We){this.f($.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Ie()}]\x1B[0m`,$e,...We):console.error(`[${Ie()}]`,$e,...We))}dispose(){}flush(){}}function Ie(){const Oe=new Date;return`${Te(Oe.getHours())}:${Te(Oe.getMinutes())}:${Te(Oe.getSeconds())}`}function Te(Oe){return Oe<10?`0${Oe}`:String(Oe)}async function Re(Oe){const $e=k.basename(Oe),We=k.dirname(Oe),Ke=(await v.Promises.readdir(We)).filter(it=>/^\d{8}T\d{6}$/.test(it)).sort().filter(it=>it!==$e),tt=Ke.slice(0,Math.max(0,Ke.length-9));await Promise.all(tt.map(it=>v.Promises.rm(k.join(We,it))))}}),define(pe[293],be([1,0,85,33,76,294,83,140,15,9,38,2,13,7,42,3,17,4,21,154,289,104,70,24,5,12,27,56,31,139,258,259,41,292,264]),function(le,e,y,L,o,A,k,T,v,m,R,E,b,d,g,p,r,f,c,u,I,O,t,n,s,i,a,l,h,C,D,w,S,N,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=void 0;const ee=5*60*1e3;let he=class extends E.Disposable{constructor(_,re,q,J,U,ne,V,se){super(),this.k=_,this.l=re,this.m=q,this.n=U,this.p=ne,this.r=V,this.s=se,this.h=ue.create(this.p),this.i=(0,l.getRemoteServerRootPath)(ne),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=J?this.s.createInstance($.WebClientServer,this.l):null,this.r.info("Extension host agent started."),this.F(!0)}async handleRequest(_,re){if(_.method!=="GET")return(0,$.serveError)(_,re,405,`Unsupported method ${_.method}`);if(!_.url)return(0,$.serveError)(_,re,400,"Bad request.");const q=k.parse(_.url,!0);let J=q.pathname;if(!J)return(0,$.serveError)(_,re,400,"Bad request.");if(J.startsWith(this.i)&&J.charCodeAt(this.i.length)===47&&(J=J.substring(this.i.length)),J==="/version")return re.writeHead(200,{"Content-Type":"text/plain"}),void re.end(this.p.commit||"");if(J==="/delay-shutdown")return this.H(),re.writeHead(200),void re.end("OK");if(!(0,w.requestHasValidConnectionToken)(this.l,_,q))return(0,$.serveError)(_,re,403,"Forbidden.");if(J==="/vscode-remote-resource"){const U=q.query.path;if(typeof U!="string")return(0,$.serveError)(_,re,400,"Bad request.");let ne;try{ne=f.URI.from({scheme:b.Schemas.file,path:U}).fsPath}catch{return(0,$.serveError)(_,re,400,"Bad request.")}const V=Object.create(null);this.n.isBuilt&&((0,R.isEqualOrParent)(ne,this.n.builtinExtensionsPath,!p.isLinux)||(0,R.isEqualOrParent)(ne,this.n.extensionsPath,!p.isLinux))&&(V["Cache-Control"]="public, max-age=31536000"),V.Vary="Origin";const se=_.headers.origin;return se&&this.h.matches(se)&&(V["Access-Control-Allow-Origin"]=se),(0,$.serveFile)(ne,1,this.r,_,re,V)}if(this.g){this.g.handle(_,re,q);return}return re.writeHead(404,{"Content-Type":"text/plain"}),void re.end("Not found")}handleUpgrade(_,re){let q=(0,c.generateUuid)(),J=!1,U=!1;if(_.url){const z=k.parse(_.url,!0).query;typeof z.reconnectionToken=="string"&&(q=z.reconnectionToken),z.reconnection==="true"&&(J=!0),z.skipWebSocketFrames==="true"&&(U=!0)}if(_.headers.upgrade===void 0||_.headers.upgrade.toLowerCase()!=="websocket"){re.end("HTTP/1.1 400 Bad Request");return}const ne=_.headers["sec-websocket-key"],V=y.createHash("sha1");V.update(ne+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const Y=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${V.digest("base64")}`];let ie=!1;if(!U&&!this.n.args["disable-websocket-compression"]&&_.headers["sec-websocket-extensions"]){const z=Array.isArray(_.headers["sec-websocket-extensions"])?_.headers["sec-websocket-extensions"]:[_.headers["sec-websocket-extensions"]];for(const P of z)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(P)){if(/\b(permessage-deflate)\b/.test(P)){ie=!0,Y.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(P)){ie=!0,Y.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}re.write(Y.join(`\r
`)+`\r
\r
`),re.setTimeout(0),re.setNoDelay(!0),U?this.v(new t.NodeSocket(re,`server-connection-${q}`),J,q):this.v(new t.WebSocketNodeSocket(new t.NodeSocket(re,`server-connection-${q}`),ie,null,!0),J,q)}handleServerError(_){this.r.error("Error occurred in server"),this.r.error(_)}t(_){let re;return _ instanceof t.NodeSocket?re=_.socket:re=_.socket.socket,re.remoteAddress||"<unknown>"}async u(_,re,q){const J=re.getSocket();this.r.error(`${_} ${q}.`);const U={type:"error",reason:q};re.sendControl(v.VSBuffer.fromString(JSON.stringify(U))),re.dispose(),await J.drain(),J.dispose()}v(_,re,q){const J=this.t(_),U=`[${J}][${q.substr(0,8)}]`,ne=new O.PersistentProtocol({socket:_}),V=this.m?new this.m.validator:null,se=this.m?new this.m.signer:null;let Y;(function(M){M[M.WaitingForAuth=0]="WaitingForAuth",M[M.WaitingForConnectionType=1]="WaitingForConnectionType",M[M.Done=2]="Done",M[M.Error=3]="Error"})(Y||(Y={}));let ie=0;const z=M=>{ie=3,P.dispose(),this.u(U,ne,M)},P=ne.onControlMessage(M=>{if(ie===0){let K;try{K=JSON.parse(M.toString())}catch{return z("Malformed first message")}if(K.type!=="auth")return z("Invalid first message");if(this.l.type===2&&!this.l.validate(K.auth))return z("Unauthorized client refused: auth mismatch");let te=(0,c.generateUuid)();if(se)try{te=se.sign(K.data)}catch{}let j=(0,c.generateUuid)();if(V)try{j=V.createNewMessage(j)}catch{}const W={type:"sign",data:j,signedData:te};ne.sendControl(v.VSBuffer.fromString(JSON.stringify(W))),ie=1}else if(ie===1){let K;try{K=JSON.parse(M.toString())}catch{return z("Malformed second message")}if(K.type!=="connectionType")return z("Invalid second message");if(typeof K.signedData!="string")return z("Invalid second message field type");const te=K.commit,j=this.p.commit;if(te&&j&&te!==j)return z("Client refused: version mismatch");let W=!1;if(!V)W=!0;else if(this.l.validate(K.signedData))W=!0;else try{W=V.validate(K.signedData)==="ok"}catch{}if(!W){if(this.n.isBuilt)return z("Unauthorized client refused");this.r.error(`${U} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const x in this.b)this.b[x].shortenReconnectionGraceTimeIfNecessary();for(const x in this.a)this.a[x].shortenReconnectionGraceTimeIfNecessary();ie=2,P.dispose(),this.w(J,U,ne,_,re,q,K)}})}async w(_,re,q,J,U,ne,V){const se=V.desiredConnectionType===1?`${re}[ManagementConnection]`:V.desiredConnectionType===2?`${re}[ExtensionHostConnection]`:re;if(V.desiredConnectionType===1)if(U){if(!this.b[ne])return this.f.has(ne)?this.u(se,q,"Unknown reconnection token (seen before)"):this.u(se,q,"Unknown reconnection token (never seen)");q.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const Y=q.readEntireBuffer();q.dispose(),this.b[ne].acceptReconnection(_,J,Y)}else{if(this.b[ne])return this.u(se,q,"Duplicate reconnection token");q.sendControl(v.VSBuffer.fromString(JSON.stringify({type:"ok"})));const Y=new D.ManagementConnection(this.r,ne,_,q);this.k.acceptConnection(Y.protocol,Y.onClose),this.b[ne]=Y,this.f.add(ne),Y.onClose(()=>{delete this.b[ne]})}else if(V.desiredConnectionType===2){const Y=V.args||{language:"en"},ie=await this.C(Y);if(ie.port&&this.r.trace(`${se} - startParams debug port ${ie.port}`),this.r.trace(`${se} - startParams language: ${ie.language}`),this.r.trace(`${se} - startParams env: ${JSON.stringify(ie.env)}`),U){if(!this.a[ne])return this.f.has(ne)?this.u(se,q,"Unknown reconnection token (seen before)"):this.u(se,q,"Unknown reconnection token (never seen)");q.sendPause(),q.sendControl(v.VSBuffer.fromString(JSON.stringify(ie.port?{debugPort:ie.port}:{})));const z=q.readEntireBuffer();q.dispose(),this.a[ne].acceptReconnection(_,J,z)}else{if(this.a[ne])return this.u(se,q,"Duplicate reconnection token");q.sendPause(),q.sendControl(v.VSBuffer.fromString(JSON.stringify(ie.port?{debugPort:ie.port}:{})));const z=q.readEntireBuffer();q.dispose();const P=this.s.createInstance(C.ExtensionHostConnection,ne,_,J,z);this.a[ne]=P,this.f.add(ne),P.onClose(()=>{delete this.a[ne],this.D()}),P.start(ie)}}else if(V.desiredConnectionType===3){const Y=V.args;this.y(q,Y)}else return this.u(se,q,"Unknown initial data received")}async y(_,re){const q=_.getSocket().socket,J=_.readEntireBuffer();_.dispose(),q.pause();const U=await this.z(re.host,re.port);J.byteLength>0&&U.write(J.buffer),U.on("end",()=>q.end()),U.on("close",()=>q.end()),U.on("error",()=>q.destroy()),q.on("end",()=>U.end()),q.on("close",()=>U.end()),q.on("error",()=>U.destroy()),U.pipe(q),q.pipe(U)}z(_,re){return new Promise((q,J)=>{const U=o.createConnection({host:_,port:re},()=>{U.removeListener("error",J),U.pause(),q(U)});U.once("error",J)})}C(_){return typeof _.port=="number"?(0,u.findFreePort)(_.port,10,5e3).then(re=>(_.port=re,_)):(_.debugId=void 0,_.port=void 0,_.break=void 0,Promise.resolve(_))}async D(){if(!this.n.args["enable-remote-auto-shutdown"])return;this.I(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.r.info("Last EH closed, waiting before shutting down"),this.F())}F(_=!1){this.n.args["enable-remote-auto-shutdown"]&&(this.n.args["remote-auto-shutdown-without-delay"]&&!_?this.G():this.j=setTimeout(()=>{this.j=void 0,this.G()},ee))}G(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.r.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.r.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}H(){this.j&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.r.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.I(),this.F())}I(){this.j&&(console.log("Cancelling previous shutdown timeout"),this.r.info("Cancelling previous shutdown timeout"),clearTimeout(this.j),this.j=void 0)}};he=Le([Ae(4,S.IServerEnvironmentService),Ae(5,a.IProductService),Ae(6,i.ILogService),Ae(7,s.IInstantiationService)],he);async function oe(me,_,re){const q=await(0,w.determineServerConnectionToken)(_);q instanceof w.ServerConnectionTokenParseError&&(console.warn(q.message),process.exit(1));function J(W){(0,m.setUnexpectedErrorHandler)(x=>{(0,m.isSigPipeError)(x)&&x.stack&&/unexpectedErrorHandler/.test(x.stack)||W(x)})}const U=[];J(W=>{U.push(W),console.error(W)});let ne=!1;process.on("SIGPIPE",()=>{ne||(ne=!0,(0,m.onUnexpectedError)(new Error("Unexpected SIGPIPE")))});const V=new E.DisposableStore,{socketServer:se,instantiationService:Y}=await(0,N.setupServerServices)(q,_,re,V);Y.invokeFunction(W=>{const x=W.get(i.ILogService);U.forEach(H=>x.error(H)),U.length=0,J(H=>x.error(H))}),Y.invokeFunction(W=>{const x=W.get(n.IConfigurationService);p.isWindows&&(x.getValue("security.restrictUNCAccess")===!1?(0,I.disableUNCAccessRestrictions)():(0,I.addUNCHostToAllowlist)(x.getValue("security.allowedUNCHosts")))}),Y.invokeFunction(W=>{const x=W.get(i.ILogService);if(p.isWindows&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const H=(0,d.join)(process.env.HOMEDRIVE,"node_modules"),Q=(0,d.dirname)((0,d.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),G=(0,d.join)(Q,"node_modules");if(L.existsSync(H)||L.existsSync(G)){const Z=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${H}
* ${G}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;x.warn(Z),console.warn(Z),process.exit(0)}}});const ie=Y.invokeFunction(W=>{const x=W.get(i.ILogService);if(L.existsSync((0,d.join)(b.FileAccess.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(Q){x.error(Q)}return null}),z=L.existsSync(b.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(z&&me&&typeof me!="string"){const W=q.type!==0?`?${b.connectionTokenQueryName}=${q.value}`:"";console.log(`Web UI available at http://localhost${me.port===80?"":`:${me.port}`}/${W}`)}const P=Y.createInstance(he,se,q,ie,z);g.mark("code/server/ready");const M=A.performance.now(),K=global.vscodeServerStartTime,te=global.vscodeServerListenTime,j=global.vscodeServerCodeLoadedTime;if(Y.invokeFunction(W=>{W.get(h.ITelemetryService).publicLog2("serverStart",{startTime:K,startedTime:te,codeLoadedTime:j,readyTime:M})}),_["print-startup-performance"]){const W=T.LoaderStats.get();let x="";x+=`

### Load AMD-module
`,x+=T.LoaderStats.toMarkdownTable(["Module","Duration"],W.amdLoad),x+=`

### Load commonjs-module
`,x+=T.LoaderStats.toMarkdownTable(["Module","Duration"],W.nodeRequire),x+=`

### Invoke AMD-module factory
`,x+=T.LoaderStats.toMarkdownTable(["Module","Duration"],W.amdInvoke),x+=`

### Invoke commonjs-module
`,x+=T.LoaderStats.toMarkdownTable(["Module","Duration"],W.nodeEval),x+=`Start-up time: ${te-K}
`,x+=`Code loading time: ${j-K}
`,x+=`Initialized time: ${M-K}
`,x+=`
`,console.log(x)}return P}e.createServer=oe;class ue{static create(_){const re=_.webEndpointUrlTemplate,q=_.commit,J=_.quality;if(!re||!q||!J)return new ue(null);const U=(0,c.generateUuid)(),V=new URL(re.replace("{{uuid}}",U).replace("{{commit}}",q).replace("{{quality}}",J)).origin,se=(0,r.escapeRegExpCharacters)(V).replace(U,"[a-zA-Z0-9\\-]+");try{const Y=(0,r.createRegExp)(`^${se}$`,!0,{matchCase:!1});return new ue(Y)}catch{return new ue(null)}}constructor(_){this.a=_}matches(_){return this.a?this.a.test(_):!1}}}),define(pe[302],be([1,0,26,33,13,288,293,62,7,294,41,54,42]),function(le,e,y,L,o,A,k,T,v,m,R,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,b.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=m.performance.now();const d={onMultipleValues:(c,u)=>{console.error(`Option '${c}' can only be defined once. Using value ${u}.`)},onEmptyValue:c=>{console.error(`Ignoring option '${c}': Value must not be empty.`)},onUnknownOption:c=>{console.error(`Ignoring option '${c}': not supported for server.`)},onDeprecatedOption:(c,u)=>{console.warn(`Option '${c}' is deprecated: ${u}`)}};function g(){return(0,T.parseArgs)(process.argv.slice(2),R.serverOptions,d)}function p(c){const u=c["server-data-dir"]||c["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.join)(y.homedir(),E.default.serverDataFolderName||".vscode-remote"),I=c["user-data-dir"]||(0,v.join)(u,"data"),O=(0,v.join)(I,"User"),t=(0,v.join)(O,"globalStorage"),n=(0,v.join)(O,"History"),s=(0,v.join)(I,"Machine");c["user-data-dir"]=I;const i=(0,v.dirname)(o.FileAccess.asFileUri("").fsPath),a=c["builtin-extensions-dir"]||(0,v.join)(i,"extensions");return c["builtin-extensions-dir"]=a,c["extensions-dir"]=c["extensions-dir"]||(0,v.join)(u,"extensions"),[u,c["extensions-dir"],I,O,s,t,n].forEach(l=>{try{L.existsSync(l)||L.mkdirSync(l,{mode:448})}catch(h){console.error(h)}}),u}function r(c=g()){return(0,A.run)(c,p(c),R.serverOptions)}e.spawnCli=r;function f(c,u=g()){return(0,k.createServer)(c,u,p(u))}e.createServer=f})}).call(this);

//# sourceMappingURL=server.main.js.map
