"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/base/common/event","vs/base/common/lifecycle","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/platform","vs/base/common/path","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/platform/log/common/log","vs/base/common/network","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/node/pfs","vs/base/common/extpath","vs/platform/files/common/files","vs/base/common/glob","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","child_process","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","fs","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/marshalling","os","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","http","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/dataTransfer","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(re){for(var e=[],c=0,R=re.length;c<R;c++)e[c]=Ce[re[c]];return e};define(Ce[65],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(L,A){const y=Object.create(null);for(const g of L){const T=A(g);let P=y[T];P||(P=y[T]=[]),P.push(g)}return y}e.groupBy=c;function R(L,A){const y=[],g=[];for(const T of L)A.has(T)||y.push(T);for(const T of A)L.has(T)||g.push(T);return{removed:y,added:g}}e.diffSets=R;function u(L,A){const y=[],g=[];for(const[T,P]of L)A.has(T)||y.push(P);for(const[T,P]of A)L.has(T)||g.push(P);return{removed:y,added:g}}e.diffMaps=u;class O{constructor(){this.a=new Map}add(A,y){let g=this.a.get(A);g||(g=new Set,this.a.set(A,g)),g.add(y)}delete(A,y){const g=this.a.get(A);g&&(g.delete(y),g.size===0&&this.a.delete(A))}forEach(A,y){const g=this.a.get(A);g&&g.forEach(y)}}e.SetMap=O}),define(Ce[66],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function c(L){return(A,y,g)=>{let T=null,P=null;if(typeof g.value=="function"?(T="value",P=g.value):typeof g.get=="function"&&(T="get",P=g.get),!P)throw new Error("not supported");g[T]=L(P,y)}}function R(L,A,y){let g=null,T=null;if(typeof y.value=="function"?(g="value",T=y.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(g="get",T=y.get),!T)throw new Error("not supported");const P=`$memoize$${A}`;y[g]=function(...m){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,m)}),this[P]}}e.memoize=R;function u(L,A,y){return c((g,T)=>{const P=`$debounce$${T}`,m=`$debounce$result$${T}`;return function(...D){this[m]||(this[m]=y?y():void 0),clearTimeout(this[P]),A&&(this[m]=A(this[m],...D),D=[this[m]]),this[P]=setTimeout(()=>{g.apply(this,D),this[m]=y?y():void 0},L)}})}e.debounce=u;function O(L,A,y){return c((g,T)=>{const P=`$throttle$timer$${T}`,m=`$throttle$result$${T}`,D=`$throttle$lastRun$${T}`,C=`$throttle$pending$${T}`;return function(...b){if(this[m]||(this[m]=y?y():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),A&&(this[m]=A(this[m],...b)),this[C])return;const n=this[D]+L;n<=Date.now()?(this[D]=Date.now(),g.apply(this,[this[m]]),this[m]=y?y():void 0):(this[C]=!0,this[P]=setTimeout(()=>{this[C]=!1,this[D]=Date.now(),g.apply(this,[this[m]]),this[m]=y?y():void 0},n-Date.now()))}})}e.throttle=O}),define(Ce[8],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?w.isErrorNoTelemetry(a)?new w(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(r=>{r(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}e.ErrorHandler=c,e.errorHandler=new c;function R(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=R;function u(t){if(!t||typeof t!="object")return!1;const a=t;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=u;function O(t){g(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=O;function L(t){g(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=L;function A(t){if(t instanceof Error){const{name:a,message:r}=t,o=t.stacktrace||t.stack;return{$isError:!0,name:a,message:r,stack:o,noTelemetry:w.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=A;const y="Canceled";function g(t){return t instanceof T?!0:t instanceof Error&&t.name===y&&t.message===y}e.isCancellationError=g;class T extends Error{constructor(){super(y),this.name=this.message}}e.CancellationError=T;function P(){const t=new Error(y);return t.name=t.message,t}e.canceled=P;function m(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=m;function D(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=D;function C(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function b(t){const a=new Error(`${t} has been disposed`);return a.name="DISPOSED",a}e.disposed=b;function n(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=n;class h extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=h;class d extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=d;class S extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=S;class w extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof w)return a;const r=new w;return r.message=a.message,r.stack=a.stack,r}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=w;class p extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype)}}e.BugIndicatingError=p}),define(Ce[19],De([1,0,8]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function R(_,ne=0){return _[_.length-(1+ne)]}e.tail=R;function u(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.tail2=u;function O(_,ne,le=(te,de)=>te===de){if(_===ne)return!0;if(!_||!ne||_.length!==ne.length)return!1;for(let te=0,de=_.length;te<de;te++)if(!le(_[te],ne[te]))return!1;return!0}e.equals=O;function L(_,ne){const le=_.length-1;ne<le&&(_[ne]=_[le]),_.pop()}e.removeFastWithoutKeepingOrder=L;function A(_,ne,le){return y(_.length,te=>le(_[te],ne))}e.binarySearch=A;function y(_,ne){let le=0,te=_-1;for(;le<=te;){const de=(le+te)/2|0,oe=ne(de);if(oe<0)le=de+1;else if(oe>0)te=de-1;else return de}return-(le+1)}e.binarySearch2=y;function g(_,ne){let le=0,te=_.length;if(te===0)return 0;for(;le<te;){const de=Math.floor((le+te)/2);ne(_[de])?te=de:le=de+1}return le}e.findFirstInSorted=g;function T(_,ne,le){if(_=_|0,_>=ne.length)throw new TypeError("invalid index");const te=ne[Math.floor(ne.length*Math.random())],de=[],oe=[],ue=[];for(const N of ne){const G=le(N,te);G<0?de.push(N):G>0?oe.push(N):ue.push(N)}return _<de.length?T(_,de,le):_<de.length+ue.length?ue[0]:T(_-(de.length+ue.length),oe,le)}e.quickSelect=T;function P(_,ne){const le=[];let te;for(const de of _.slice(0).sort(ne))!te||ne(te[0],de)!==0?(te=[de],le.push(te)):te.push(de);return le}e.groupBy=P;function m(_,ne,le){const te=[];function de(N,G,Y){if(G===0&&Y.length===0)return;const ie=te[te.length-1];ie&&ie.start+ie.deleteCount===N?(ie.deleteCount+=G,ie.toInsert.push(...Y)):te.push({start:N,deleteCount:G,toInsert:Y})}let oe=0,ue=0;for(;;){if(oe===_.length){de(oe,0,ne.slice(ue));break}if(ue===ne.length){de(oe,_.length-oe,[]);break}const N=_[oe],G=ne[ue],Y=le(N,G);Y===0?(oe+=1,ue+=1):Y<0?(de(oe,1,[]),oe+=1):Y>0&&(de(oe,0,[G]),ue+=1)}return te}e.sortedDiff=m;function D(_,ne,le){const te=m(_,ne,le),de=[],oe=[];for(const ue of te)de.push(..._.slice(ue.start,ue.start+ue.deleteCount)),oe.push(...ue.toInsert);return{removed:de,added:oe}}e.delta=D;function C(_,ne,le){if(le===0)return[];const te=_.slice(0,le).sort(ne);return n(_,ne,te,le,_.length),te}e.top=C;function b(_,ne,le,te,de){return le===0?Promise.resolve([]):new Promise((oe,ue)=>{(async()=>{const N=_.length,G=_.slice(0,le).sort(ne);for(let Y=le,ie=Math.min(le+te,N);Y<N;Y=ie,ie=Math.min(ie+te,N)){if(Y>le&&await new Promise(pe=>setTimeout(pe)),de&&de.isCancellationRequested)throw new c.CancellationError;n(_,ne,G,Y,ie)}return G})().then(oe,ue)})}e.topAsync=b;function n(_,ne,le,te,de){for(const oe=le.length;te<de;te++){const ue=_[te];if(ne(ue,le[oe-1])<0){le.pop();const N=g(le,G=>ne(ue,G)<0);le.splice(N,0,ue)}}}function h(_){return _.filter(ne=>!!ne)}e.coalesce=h;function d(_){let ne=0;for(let le=0;le<_.length;le++)_[le]&&(_[ne]=_[le],ne+=1);_.length=ne}e.coalesceInPlace=d;function S(_,ne,le){_.splice(le,0,_.splice(ne,1)[0])}e.move=S;function w(_){return!Array.isArray(_)||_.length===0}e.isFalsyOrEmpty=w;function p(_){return Array.isArray(_)&&_.length>0}e.isNonEmptyArray=p;function t(_,ne=le=>le){const le=new Set;return _.filter(te=>{const de=ne(te);return le.has(de)?!1:(le.add(de),!0)})}e.distinct=t;function a(_){const ne=new Set;return le=>{const te=_(le);return ne.has(te)?!1:(ne.add(te),!0)}}e.uniqueFilter=a;function r(_,ne){const le=o(_,ne);if(le!==-1)return _[le]}e.findLast=r;function o(_,ne){for(let le=_.length-1;le>=0;le--){const te=_[le];if(ne(te))return le}return-1}e.lastIndex=o;function f(_,ne){return _.length>0?_[0]:ne}e.firstOrDefault=f;function v(_,ne){return _.length>0?_[_.length-1]:ne}e.lastOrDefault=v;function l(_,ne,le=(te,de)=>te===de){let te=0;for(let de=0,oe=Math.min(_.length,ne.length);de<oe&&le(_[de],ne[de]);de++)te++;return te}e.commonPrefixLength=l;function I(_){return[].concat(..._)}e.flatten=I;function E(_,ne){let le=typeof ne=="number"?_:0;typeof ne=="number"?le=_:(le=0,ne=_);const te=[];if(le<=ne)for(let de=le;de<ne;de++)te.push(de);else for(let de=le;de>ne;de--)te.push(de);return te}e.range=E;function s(_,ne,le){return _.reduce((te,de)=>(te[ne(de)]=le?le(de):de,te),Object.create(null))}e.index=s;function i(_,ne){return _.push(ne),()=>k(_,ne)}e.insert=i;function k(_,ne){const le=_.indexOf(ne);if(le>-1)return _.splice(le,1),ne}e.remove=k;function F(_,ne,le){const te=_.slice(0,ne),de=_.slice(ne);return te.concat(le,de)}e.arrayInsert=F;function $(_,ne){let le;if(typeof ne=="number"){let te=ne;le=()=>{const de=Math.sin(te++)*179426549;return de-Math.floor(de)}}else le=Math.random;for(let te=_.length-1;te>0;te-=1){const de=Math.floor(le()*(te+1)),oe=_[te];_[te]=_[de],_[de]=oe}}e.shuffle=$;function j(_,ne){const le=_.indexOf(ne);le>-1&&(_.splice(le,1),_.unshift(ne))}e.pushToStart=j;function W(_,ne){const le=_.indexOf(ne);le>-1&&(_.splice(le,1),_.push(ne))}e.pushToEnd=W;function U(_,ne){for(const le of ne)_.push(le)}e.pushMany=U;function x(_,ne){return Array.isArray(_)?_.map(ne):ne(_)}e.mapArrayOrNot=x;function B(_){return Array.isArray(_)?_:[_]}e.asArray=B;function z(_){return _[Math.floor(Math.random()*_.length)]}e.getRandomElement=z;function ee(_,ne){for(const le of _){const te=ne(le);if(te!==void 0)return te}}e.mapFind=ee;function se(_,ne,le){const te=Z(_,ne),de=_.length,oe=le.length;_.length=de+oe;for(let ue=de-1;ue>=te;ue--)_[ue+oe]=_[ue];for(let ue=0;ue<oe;ue++)_[ue+te]=le[ue]}e.insertInto=se;function V(_,ne,le,te){const de=Z(_,ne),oe=_.splice(de,le);return se(_,de,te),oe}e.splice=V;function Z(_,ne){return ne<0?Math.max(ne+_.length,0):Math.min(ne,_.length)}var q;(function(_){function ne(de){return de<0}_.isLessThan=ne;function le(de){return de>0}_.isGreaterThan=le;function te(de){return de===0}_.isNeitherLessOrGreaterThan=te,_.greaterThan=1,_.lessThan=-1,_.neitherLessOrGreaterThan=0})(q||(e.CompareResult=q={}));function ae(_,ne){return(le,te)=>ne(_(le),_(te))}e.compareBy=ae;function Ee(..._){return(ne,le)=>{for(const te of _){const de=te(ne,le);if(!q.isNeitherLessOrGreaterThan(de))return de}return q.neitherLessOrGreaterThan}}e.tieBreakComparators=Ee;const ye=(_,ne)=>_-ne;e.numberComparator=ye;function be(_,ne){if(_.length===0)return;let le=_[0];for(let te=1;te<_.length;te++){const de=_[te];ne(de,le)>0&&(le=de)}return le}e.findMaxBy=be;function M(_,ne){if(_.length===0)return;let le=_[0];for(let te=1;te<_.length;te++){const de=_[te];ne(de,le)>=0&&(le=de)}return le}e.findLastMaxBy=M;function Q(_,ne){return be(_,(le,te)=>-ne(le,te))}e.findMinBy=Q;class fe{constructor(ne){this.f=ne,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ne){let le=this.c;for(;le<this.f.length&&ne(this.f[le]);)le++;const te=le===this.c?null:this.f.slice(this.c,le);return this.c=le,te}takeFromEndWhile(ne){let le=this.d;for(;le>=0&&ne(this.f[le]);)le--;const te=le===this.d?null:this.f.slice(le+1,this.d+1);return this.d=le,te}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ne=this.f[this.c];return this.c++,ne}removeLast(){const ne=this.f[this.d];return this.d--,ne}takeCount(ne){const le=this.f.slice(this.c,this.c+ne);return this.c+=ne,le}}e.ArrayQueue=fe;class we{constructor(ne){this.iterate=ne}forEach(ne){this.iterate(le=>(ne(le),!0))}toArray(){const ne=[];return this.iterate(le=>(ne.push(le),!0)),ne}filter(ne){return new we(le=>this.iterate(te=>ne(te)?le(te):!0))}map(ne){return new we(le=>this.iterate(te=>le(ne(te))))}some(ne){let le=!1;return this.iterate(te=>(le=ne(te),!le)),le}findFirst(ne){let le;return this.iterate(te=>ne(te)?(le=te,!1):!0),le}findLast(ne){let le;return this.iterate(te=>(ne(te)&&(le=te),!0)),le}findLastMaxBy(ne){let le,te=!0;return this.iterate(de=>((te||q.isGreaterThan(ne(de,le)))&&(te=!1,le=de),!0)),le}}e.CallbackIterable=we,we.empty=new we(_=>{})}),define(Ce[52],De([1,0,8]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(y,g){if(!y)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=R;function u(y,g="Unreachable"){throw new Error(g)}e.assertNever=u;function O(y){if(!y)throw new c.BugIndicatingError("Assertion Failed")}e.assert=O;function L(y){if(!y()){debugger;y(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=L;function A(y,g){let T=0;for(;T<y.length-1;){const P=y[T],m=y[T+1];if(!g(P,m))return!1;T++}return!0}e.checkAdjacentItems=A}),define(Ce[67],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(R){const u=this;let O=!1,L;return function(){return O||(O=!0,L=R.apply(u,arguments)),L}}e.once=c}),define(Ce[110],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(u){this.a=u,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(Ce[53],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(R){function u(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}R.is=u;const O=Object.freeze([]);function L(){return O}R.empty=L;function*A(w){yield w}R.single=A;function y(w){return u(w)?w:A(w)}R.wrap=y;function g(w){return w||O}R.from=g;function T(w){return!w||w[Symbol.iterator]().next().done===!0}R.isEmpty=T;function P(w){return w[Symbol.iterator]().next().value}R.first=P;function m(w,p){for(const t of w)if(p(t))return!0;return!1}R.some=m;function D(w,p){for(const t of w)if(p(t))return t}R.find=D;function*C(w,p){for(const t of w)p(t)&&(yield t)}R.filter=C;function*b(w,p){let t=0;for(const a of w)yield p(a,t++)}R.map=b;function*n(...w){for(const p of w)for(const t of p)yield t}R.concat=n;function h(w,p,t){let a=t;for(const r of w)a=p(a,r);return a}R.reduce=h;function*d(w,p,t=w.length){for(p<0&&(p+=w.length),t<0?t+=w.length:t>w.length&&(t=w.length);p<t;p++)yield w[p]}R.slice=d;function S(w,p=Number.POSITIVE_INFINITY){const t=[];if(p===0)return[t,w];const a=w[Symbol.iterator]();for(let r=0;r<p;r++){const o=a.next();if(o.done)return[t,R.empty()];t.push(o.value)}return[t,{[Symbol.iterator](){return a}}]}R.consume=S})(c||(e.Iterable=c={}))}),define(Ce[151],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(c||(e.ScanError=c={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var u;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(u||(e.ParseErrorCode=u={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function L(t,a=!1){let r=0;const o=t.length;let f="",v=0,l=16,I=0;function E(W){let U=0,x=0;for(;U<W;){const B=t.charCodeAt(r);if(B>=48&&B<=57)x=x*16+B-48;else if(B>=65&&B<=70)x=x*16+B-65+10;else if(B>=97&&B<=102)x=x*16+B-97+10;else break;r++,U++}return U<W&&(x=-1),x}function s(W){r=W,f="",v=0,l=16,I=0}function i(){const W=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&g(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&g(t.charCodeAt(r)))for(r++;r<t.length&&g(t.charCodeAt(r));)r++;else return I=3,t.substring(W,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&g(t.charCodeAt(r))){for(r++;r<t.length&&g(t.charCodeAt(r));)r++;U=r}else I=3;return t.substring(W,U)}function k(){let W="",U=r;for(;;){if(r>=o){W+=t.substring(U,r),I=2;break}const x=t.charCodeAt(r);if(x===34){W+=t.substring(U,r),r++;break}if(x===92){if(W+=t.substring(U,r),r++,r>=o){I=2;break}switch(t.charCodeAt(r++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const z=E(4);z>=0?W+=String.fromCharCode(z):I=4;break}default:I=5}U=r;continue}if(x>=0&&x<=31)if(y(x)){W+=t.substring(U,r),I=2;break}else I=6;r++}return W}function F(){if(f="",I=0,v=r,r>=o)return v=o,l=17;let W=t.charCodeAt(r);if(A(W)){do r++,f+=String.fromCharCode(W),W=t.charCodeAt(r);while(A(W));return l=15}if(y(W))return r++,f+=String.fromCharCode(W),W===13&&t.charCodeAt(r)===10&&(r++,f+=`
`),l=14;switch(W){case 123:return r++,l=1;case 125:return r++,l=2;case 91:return r++,l=3;case 93:return r++,l=4;case 58:return r++,l=6;case 44:return r++,l=5;case 34:return r++,f=k(),l=10;case 47:{const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<o&&!y(t.charCodeAt(r));)r++;return f=t.substring(U,r),l=12}if(t.charCodeAt(r+1)===42){r+=2;const x=o-1;let B=!1;for(;r<x;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,B=!0;break}r++}return B||(r++,I=1),f=t.substring(U,r),l=13}return f+=String.fromCharCode(W),r++,l=16}case 45:if(f+=String.fromCharCode(W),r++,r===o||!g(t.charCodeAt(r)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return f+=i(),l=11;default:for(;r<o&&$(W);)r++,W=t.charCodeAt(r);if(v!==r){switch(f=t.substring(v,r),f){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return f+=String.fromCharCode(W),r++,l=16}}function $(W){if(A(W)||y(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let W;do W=F();while(W>=12&&W<=15);return W}return{setPosition:s,getPosition:()=>r,scan:a?j:F,getToken:()=>l,getTokenValue:()=>f,getTokenOffset:()=>v,getTokenLength:()=>r-v,getTokenError:()=>I}}e.createScanner=L;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function P(t,a){const r=[],o=new Object;let f;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function I(E,s,i,k){v.value=E,v.offset=s,v.length=i,v.type=k,v.colonOffset=void 0,f=v}try{S(t,{onObjectBegin:(E,s)=>{if(a<=E)throw o;f=void 0,l=a>E,r.push("")},onObjectProperty:(E,s,i)=>{if(a<s||(I(E,s,i,"property"),r[r.length-1]=E,a<=s+i))throw o},onObjectEnd:(E,s)=>{if(a<=E)throw o;f=void 0,r.pop()},onArrayBegin:(E,s)=>{if(a<=E)throw o;f=void 0,r.push(0)},onArrayEnd:(E,s)=>{if(a<=E)throw o;f=void 0,r.pop()},onLiteralValue:(E,s,i)=>{if(a<s||(I(E,s,i,p(E)),a<=s+i))throw o},onSeparator:(E,s,i)=>{if(a<=s)throw o;if(E===":"&&f&&f.type==="property")f.colonOffset=s,l=!1,f=void 0;else if(E===","){const k=r[r.length-1];typeof k=="number"?r[r.length-1]=k+1:(l=!0,r[r.length-1]=""),f=void 0}}})}catch(E){if(E!==o)throw E}return{path:r,previousNode:f,isAtPropertyKey:l,matches:E=>{let s=0;for(let i=0;s<E.length&&i<r.length;i++)if(E[s]===r[i]||E[s]==="*")s++;else if(E[s]!=="**")return!1;return s===E.length}}}e.getLocation=P;function m(t,a=[],r=O.DEFAULT){let o=null,f=[];const v=[];function l(E){Array.isArray(f)?f.push(E):o!==null&&(f[o]=E)}return S(t,{onObjectBegin:()=>{const E={};l(E),v.push(f),f=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{f=v.pop()},onArrayBegin:()=>{const E=[];l(E),v.push(f),f=E,o=null},onArrayEnd:()=>{f=v.pop()},onLiteralValue:l,onError:(E,s,i)=>{a.push({error:E,offset:s,length:i})}},r),f[0]}e.parse=m;function D(t,a=[],r=O.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(E){o.type==="property"&&(o.length=E-o.offset,o=o.parent)}function v(E){return o.children.push(E),E}S(t,{onObjectBegin:E=>{o=v({type:"object",offset:E,length:-1,parent:o,children:[]})},onObjectProperty:(E,s,i)=>{o=v({type:"property",offset:s,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:E,offset:s,length:i,parent:o})},onObjectEnd:(E,s)=>{o.length=E+s-o.offset,o=o.parent,f(E+s)},onArrayBegin:(E,s)=>{o=v({type:"array",offset:E,length:-1,parent:o,children:[]})},onArrayEnd:(E,s)=>{o.length=E+s-o.offset,o=o.parent,f(E+s)},onLiteralValue:(E,s,i)=>{v({type:p(E),offset:s,length:i,parent:o,value:E}),f(s+i)},onSeparator:(E,s,i)=>{o.type==="property"&&(E===":"?o.colonOffset=s:E===","&&f(s))},onError:(E,s,i)=>{a.push({error:E,offset:s,length:i})}},r);const I=o.children[0];return I&&delete I.parent,I}e.parseTree=D;function C(t,a){if(!t)return;let r=t;for(const o of a)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let f=!1;for(const v of r.children)if(Array.isArray(v.children)&&v.children[0].value===o){r=v.children[1],f=!0;break}if(!f)return}else{const f=o;if(r.type!=="array"||f<0||!Array.isArray(r.children)||f>=r.children.length)return;r=r.children[f]}return r}e.findNodeAtLocation=C;function b(t){if(!t.parent||!t.parent.children)return[];const a=b(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;a.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&a.push(r)}return a}e.getNodePath=b;function n(t){switch(t.type){case"array":return t.children.map(n);case"object":{const a=Object.create(null);for(const r of t.children){const o=r.children[1];o&&(a[r.children[0].value]=n(o))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=n;function h(t,a,r=!1){return a>=t.offset&&a<t.offset+t.length||r&&a===t.offset+t.length}e.contains=h;function d(t,a,r=!1){if(h(t,a,r)){const o=t.children;if(Array.isArray(o))for(let f=0;f<o.length&&o[f].offset<=a;f++){const v=d(o[f],a,r);if(v)return v}return t}}e.findNodeAtOffset=d;function S(t,a,r=O.DEFAULT){const o=L(t,!1);function f(ae){return ae?()=>ae(o.getTokenOffset(),o.getTokenLength()):()=>!0}function v(ae){return ae?Ee=>ae(Ee,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=f(a.onObjectBegin),I=v(a.onObjectProperty),E=f(a.onObjectEnd),s=f(a.onArrayBegin),i=f(a.onArrayEnd),k=v(a.onLiteralValue),F=v(a.onSeparator),$=f(a.onComment),j=v(a.onError),W=r&&r.disallowComments,U=r&&r.allowTrailingComma;function x(){for(;;){const ae=o.scan();switch(o.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:W||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ae){case 12:case 13:W?B(10):$();break;case 16:B(1);break;case 15:case 14:break;default:return ae}}}function B(ae,Ee=[],ye=[]){if(j(ae),Ee.length+ye.length>0){let be=o.getToken();for(;be!==17;){if(Ee.indexOf(be)!==-1){x();break}else if(ye.indexOf(be)!==-1)break;be=x()}}}function z(ae){const Ee=o.getTokenValue();return ae?k(Ee):I(Ee),x(),!0}function ee(){switch(o.getToken()){case 11:{let ae=0;try{ae=JSON.parse(o.getTokenValue()),typeof ae!="number"&&(B(2),ae=0)}catch{B(2)}k(ae);break}case 7:k(null);break;case 8:k(!0);break;case 9:k(!1);break;default:return!1}return x(),!0}function se(){return o.getToken()!==10?(B(3,[],[2,5]),!1):(z(!1),o.getToken()===6?(F(":"),x(),q()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function V(){l(),x();let ae=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ae||B(4,[],[]),F(","),x(),o.getToken()===2&&U)break}else ae&&B(6,[],[]);se()||B(4,[],[2,5]),ae=!0}return E(),o.getToken()!==2?B(7,[2],[]):x(),!0}function Z(){s(),x();let ae=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ae||B(4,[],[]),F(","),x(),o.getToken()===4&&U)break}else ae&&B(6,[],[]);q()||B(4,[],[4,5]),ae=!0}return i(),o.getToken()!==4?B(8,[4],[]):x(),!0}function q(){switch(o.getToken()){case 3:return Z();case 1:return V();case 10:return z(!0);default:return ee()}}return x(),o.getToken()===17?r.allowEmptyContent?!0:(B(4,[],[]),!1):q()?(o.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=S;function w(t,a){const r=L(t),o=[];let f,v=0,l;do switch(l=r.getPosition(),f=r.scan(),f){case 12:case 13:case 17:v!==l&&o.push(t.substring(v,l)),a!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,a)),v=r.getPosition();break}while(f!==17);return o.join("")}e.stripComments=w;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Ce[54],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(u){this.d=u,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(u){this.c=u}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=c}),define(Ce[4],De([1,0,67,53]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const u=!1;let O=null;function L(v){O=v}if(e.setDisposableTracker=L,u){const v="__is_disposable_tracked__";L(new class{trackDisposable(l){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[v]||console.log(I)},3e3)}setParent(l,I){if(l&&l!==d.None)try{l[v]=!0}catch{}}markAsDisposed(l){if(l&&l!==d.None)try{l[v]=!0}catch{}}markAsSingleton(l){}})}function A(v){return O?.trackDisposable(v),v}function y(v){O?.markAsDisposed(v)}function g(v,l){O?.setParent(v,l)}function T(v,l){if(O)for(const I of v)O.setParent(I,l)}function P(v){return O?.markAsSingleton(v),v}e.markAsSingleton=P;function m(v){return typeof v.dispose=="function"&&v.dispose.length===0}e.isDisposable=m;function D(v){if(R.Iterable.is(v)){const l=[];for(const I of v)if(I)try{I.dispose()}catch(E){l.push(E)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}e.dispose=D;function C(v){for(const l of v)m(l)&&l.dispose();return[]}e.disposeIfDisposable=C;function b(...v){const l=n(()=>D(v));return T(v,l),l}e.combinedDisposable=b;function n(v){const l=A({dispose:(0,c.once)(()=>{y(l),v()})});return l}e.toDisposable=n;class h{constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(y(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{D(this.f)}finally{this.f.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return g(l,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(l),l}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this.q=new h,A(this),g(this.q,this)}dispose(){y(this),this.q.dispose()}B(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(l)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class S{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(l){this.b||l===this.a||(this.a?.dispose(),l&&g(l,this),this.a=l)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const l=this.a;return this.a=void 0,l&&g(l,null),l}}e.MutableDisposable=S;class w{constructor(l){this.b=l,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=w;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(l){let I=l;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,y(this))},this}}e.SafeDisposable=p;class t{constructor(){this.a=new Map}acquire(l,...I){let E=this.a.get(l);E||(E={counter:0,object:this.b(l,...I)},this.a.set(l,E));const{object:s}=E,i=(0,c.once)(()=>{--E.counter===0&&(this.c(l,E.object),this.a.delete(l))});return E.counter++,{object:s,dispose:i}}}e.ReferenceCollection=t;class a{constructor(l){this.a=l}async acquire(l,...I){const E=this.a.acquire(l,...I);try{return{object:await E.object,dispose:()=>E.dispose()}}catch(s){throw E.dispose(),s}}}e.AsyncReferenceCollection=a;class r{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=r;function o(v){const l=new h;try{v(l)}finally{l.dispose()}}e.disposeOnReturn=o;class f{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{D(this.a.values())}finally{this.a.clear()}}has(l){return this.a.has(l)}get(l){return this.a.get(l)}set(l,I,E=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),E||this.a.get(l)?.dispose(),this.a.set(l,I)}deleteAndDispose(l){this.a.get(l)?.dispose(),this.a.delete(l)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=f}),define(Ce[68],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(O){this.element=O,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class R{constructor(){this.a=c.Undefined,this.b=c.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===c.Undefined}clear(){let O=this.a;for(;O!==c.Undefined;){const L=O.next;O.prev=c.Undefined,O.next=c.Undefined,O=L}this.a=c.Undefined,this.b=c.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,L){const A=new c(O);if(this.a===c.Undefined)this.a=A,this.b=A;else if(L){const g=this.b;this.b=A,A.prev=g,g.next=A}else{const g=this.a;this.a=A,A.next=g,g.prev=A}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(A))}}shift(){if(this.a!==c.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==c.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==c.Undefined&&O.next!==c.Undefined){const L=O.prev;L.next=O.next,O.next.prev=L}else O.prev===c.Undefined&&O.next===c.Undefined?(this.a=c.Undefined,this.b=c.Undefined):O.next===c.Undefined?(this.b=this.b.prev,this.b.next=c.Undefined):O.prev===c.Undefined&&(this.a=this.a.next,this.a.prev=c.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==c.Undefined;)yield O.element,O=O.next}}e.LinkedList=R}),define(Ce[28],De([1,0]),function(re,e){"use strict";var c,R,u;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function O(b,n,h){let d=b.get(n);return d===void 0&&(d=h,b.set(n,d)),d}e.getOrSet=O;function L(b){const n=[];return b.forEach((h,d)=>{n.push(`${d} => ${h}`)}),`Map(${b.size}) {${n.join(", ")}}`}e.mapToString=L;function A(b){const n=[];return b.forEach(h=>{n.push(h)}),`Set(${b.size}) {${n.join(", ")}}`}e.setToString=A;class y{constructor(n,h){this.uri=n,this.value=h}}class g{constructor(n,h){this[c]="ResourceMap",n instanceof g?(this.b=new Map(n.b),this.c=h??g.a):(this.b=new Map,this.c=n??g.a)}set(n,h){return this.b.set(this.c(n),new y(n,h)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,h){typeof h<"u"&&(n=n.bind(h));for(const[d,S]of this.b)n(S.value,S.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.ResourceMap=g,g.a=b=>b.toString();class T{constructor(n,h){this[R]="ResourceSet",!n||typeof n=="function"?this.a=new g(n):(this.a=new g(h),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,h){this.a.forEach((d,S)=>n.call(h,S,S,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=T;var P;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(P||(e.Touch=P={}));class m{constructor(){this[u]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,h=0){const d=this.a.get(n);if(d)return h!==0&&this.j(d,h),d.value}set(n,h,d=0){let S=this.a.get(n);if(S)S.value=h,d!==0&&this.j(S,d);else{switch(S={key:n,value:h,next:void 0,previous:void 0},d){case 0:this.h(S);break;case 1:this.g(S);break;case 2:this.h(S);break;default:this.h(S);break}this.a.set(n,S),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const h=this.a.get(n);if(h)return this.a.delete(n),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,h){const d=this.e;let S=this.b;for(;S;){if(h?n.bind(h)(S.value,S.key,this):n(S.value,S.key,this),this.e!==d)throw new Error("LinkedMap got modified during iteration.");S=S.next}}keys(){const n=this,h=this.e;let d=this.b;const S={[Symbol.iterator](){return S},next(){if(n.e!==h)throw new Error("LinkedMap got modified during iteration.");if(d){const w={value:d.key,done:!1};return d=d.next,w}else return{value:void 0,done:!0}}};return S}values(){const n=this,h=this.e;let d=this.b;const S={[Symbol.iterator](){return S},next(){if(n.e!==h)throw new Error("LinkedMap got modified during iteration.");if(d){const w={value:d.value,done:!1};return d=d.next,w}else return{value:void 0,done:!0}}};return S}entries(){const n=this,h=this.e;let d=this.b;const S={[Symbol.iterator](){return S},next(){if(n.e!==h)throw new Error("LinkedMap got modified during iteration.");if(d){const w={value:[d.key,d.value],done:!1};return d=d.next,w}else return{value:void 0,done:!0}}};return S}[(u=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let h=this.b,d=this.size;for(;h&&d>n;)this.a.delete(h.key),h=h.next,d--;this.b=h,this.d=d,h&&(h.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const h=n.next,d=n.previous;if(!h||!d)throw new Error("Invalid list");h.previous=d,d.next=h}n.next=void 0,n.previous=void 0,this.e++}j(n,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(n===this.b)return;const d=n.next,S=n.previous;n===this.c?(S.next=void 0,this.c=S):(d.previous=S,S.next=d),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(h===2){if(n===this.c)return;const d=n.next,S=n.previous;n===this.b?(d.previous=void 0,this.b=d):(d.previous=S,S.next=d),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((h,d)=>{n.push([d,h])}),n}fromJSON(n){this.clear();for(const[h,d]of n)this.set(h,d)}}e.LinkedMap=m;class D extends m{constructor(n,h=1){super(),this.k=n,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,h=2){return super.get(n,h)}peek(n){return super.get(n,0)}set(n,h){return super.set(n,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=D;class C{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let h=this.a.get(n)||0;return h===0?!1:(h--,h===0?this.a.delete(n):this.a.set(n,h),!0)}has(n){return this.a.has(n)}}e.CounterSet=C}),function(re,e){typeof define=="function"&&define.amd?define(Ce[152],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(_,ne){for(var le=0;le<ne.length;le++){var te=ne[le];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(_,te.key,te)}}function c(_,ne,le){return ne&&e(_.prototype,ne),le&&e(_,le),Object.defineProperty(_,"prototype",{writable:!1}),_}function R(_,ne){if(_){if(typeof _=="string")return u(_,ne);var le=Object.prototype.toString.call(_).slice(8,-1);if(le==="Object"&&_.constructor&&(le=_.constructor.name),le==="Map"||le==="Set")return Array.from(_);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return u(_,ne)}}function u(_,ne){(ne==null||ne>_.length)&&(ne=_.length);for(var le=0,te=new Array(ne);le<ne;le++)te[le]=_[le];return te}function O(_,ne){var le=typeof Symbol<"u"&&_[Symbol.iterator]||_["@@iterator"];if(le)return(le=le.call(_)).next.bind(le);if(Array.isArray(_)||(le=R(_))||ne&&_&&typeof _.length=="number"){le&&(_=le);var te=0;return function(){return te>=_.length?{done:!0}:{done:!1,value:_[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=L();function A(_){re.defaults=_}var y=/[&<>"']/,g=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},D=function(ne){return m[ne]};function C(_,ne){if(ne){if(y.test(_))return _.replace(g,D)}else if(T.test(_))return _.replace(P,D);return _}var b=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(_){return _.replace(b,function(ne,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var h=/(^|[^\[])\^/g;function d(_,ne){_=typeof _=="string"?_:_.source,ne=ne||"";var le={replace:function(de,oe){return oe=oe.source||oe,oe=oe.replace(h,"$1"),_=_.replace(de,oe),le},getRegex:function(){return new RegExp(_,ne)}};return le}var S=/[^\w:]/g,w=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(_,ne,le){if(_){var te;try{te=decodeURIComponent(n(le)).replace(S,"").toLowerCase()}catch{return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}ne&&!w.test(le)&&(le=f(ne,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch{return null}return le}var t={},a=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(_,ne){t[" "+_]||(a.test(_)?t[" "+_]=_+"/":t[" "+_]=E(_,"/",!0)),_=t[" "+_];var le=_.indexOf(":")===-1;return ne.substring(0,2)==="//"?le?ne:_.replace(r,"$1")+ne:ne.charAt(0)==="/"?le?ne:_.replace(o,"$1")+ne:_+ne}var v={exec:function(){}};function l(_){for(var ne=1,le,te;ne<arguments.length;ne++){le=arguments[ne];for(te in le)Object.prototype.hasOwnProperty.call(le,te)&&(_[te]=le[te])}return _}function I(_,ne){var le=_.replace(/\|/g,function(oe,ue,N){for(var G=!1,Y=ue;--Y>=0&&N[Y]==="\\";)G=!G;return G?"|":" |"}),te=le.split(/ \|/),de=0;if(te[0].trim()||te.shift(),te.length>0&&!te[te.length-1].trim()&&te.pop(),te.length>ne)te.splice(ne);else for(;te.length<ne;)te.push("");for(;de<te.length;de++)te[de]=te[de].trim().replace(/\\\|/g,"|");return te}function E(_,ne,le){var te=_.length;if(te===0)return"";for(var de=0;de<te;){var oe=_.charAt(te-de-1);if(oe===ne&&!le)de++;else if(oe!==ne&&le)de++;else break}return _.slice(0,te-de)}function s(_,ne){if(_.indexOf(ne[1])===-1)return-1;for(var le=_.length,te=0,de=0;de<le;de++)if(_[de]==="\\")de++;else if(_[de]===ne[0])te++;else if(_[de]===ne[1]&&(te--,te<0))return de;return-1}function i(_){_&&_.sanitize&&!_.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(_,ne){if(ne<1)return"";for(var le="";ne>1;)ne&1&&(le+=_),ne>>=1,_+=_;return le+_}function F(_,ne,le,te){var de=ne.href,oe=ne.title?C(ne.title):null,ue=_[1].replace(/\\([\[\]])/g,"$1");if(_[0].charAt(0)!=="!"){te.state.inLink=!0;var N={type:"link",raw:le,href:de,title:oe,text:ue,tokens:te.inlineTokens(ue)};return te.state.inLink=!1,N}return{type:"image",raw:le,href:de,title:oe,text:C(ue)}}function $(_,ne){var le=_.match(/^(\s+)(?:```)/);if(le===null)return ne;var te=le[1];return ne.split(`
`).map(function(de){var oe=de.match(/^\s+/);if(oe===null)return de;var ue=oe[0];return ue.length>=te.length?de.slice(te.length):de}).join(`
`)}var j=function(){function _(le){this.options=le||re.defaults}var ne=_.prototype;return ne.space=function(te){var de=this.rules.block.newline.exec(te);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},ne.code=function(te){var de=this.rules.block.code.exec(te);if(de){var oe=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:E(oe,`
`)}}},ne.fences=function(te){var de=this.rules.block.fences.exec(te);if(de){var oe=de[0],ue=$(oe,de[3]||"");return{type:"code",raw:oe,lang:de[2]?de[2].trim():de[2],text:ue}}},ne.heading=function(te){var de=this.rules.block.heading.exec(te);if(de){var oe=de[2].trim();if(/#$/.test(oe)){var ue=E(oe,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(oe=ue.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:oe,tokens:this.lexer.inline(oe)}}},ne.hr=function(te){var de=this.rules.block.hr.exec(te);if(de)return{type:"hr",raw:de[0]}},ne.blockquote=function(te){var de=this.rules.block.blockquote.exec(te);if(de){var oe=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(oe,[]),text:oe}}},ne.list=function(te){var de=this.rules.block.list.exec(te);if(de){var oe,ue,N,G,Y,ie,pe,Ie,he,Re,Te,Ve,xe=de[1].trim(),tt=xe.length>1,Qe={type:"list",raw:"",ordered:tt,start:tt?+xe.slice(0,-1):"",loose:!1,items:[]};xe=tt?"\\d{1,9}\\"+xe.slice(-1):"\\"+xe,this.options.pedantic&&(xe=tt?xe:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+xe+")((?:[	 ][^\\n]*)?(?:\\n|$))");te&&(Ve=!1,!(!(de=Xe.exec(te))||this.rules.block.hr.test(te)));){if(oe=de[0],te=te.substring(oe.length),Ie=de[2].split(`
`,1)[0],he=te.split(`
`,1)[0],this.options.pedantic?(G=2,Te=Ie.trimLeft()):(G=de[2].search(/[^ ]/),G=G>4?1:G,Te=Ie.slice(G),G+=de[1].length),ie=!1,!Ie&&/^ *$/.test(he)&&(oe+=he+`
`,te=te.substring(he.length+1),Ve=!0),!Ve)for(var nt=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),Be=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");te&&(Re=te.split(`
`,1)[0],Ie=Re,this.options.pedantic&&(Ie=Ie.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(Ie)||Be.test(Ie)||nt.test(Ie)||ot.test(te)));){if(Ie.search(/[^ ]/)>=G||!Ie.trim())Te+=`
`+Ie.slice(G);else if(!ie)Te+=`
`+Ie;else break;!ie&&!Ie.trim()&&(ie=!0),oe+=Re+`
`,te=te.substring(Re.length+1)}Qe.loose||(pe?Qe.loose=!0:/\n *\n *$/.test(oe)&&(pe=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(Te),ue&&(N=ue[0]!=="[ ] ",Te=Te.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:oe,task:!!ue,checked:N,loose:!1,text:Te}),Qe.raw+=oe}Qe.items[Qe.items.length-1].raw=oe.trimRight(),Qe.items[Qe.items.length-1].text=Te.trimRight(),Qe.raw=Qe.raw.trimRight();var ke=Qe.items.length;for(Y=0;Y<ke;Y++){this.lexer.state.top=!1,Qe.items[Y].tokens=this.lexer.blockTokens(Qe.items[Y].text,[]);var X=Qe.items[Y].tokens.filter(function(me){return me.type==="space"}),J=X.every(function(me){for(var Fe=me.raw.split(""),ze=0,He=O(Fe),Je;!(Je=He()).done;){var ct=Je.value;if(ct===`
`&&(ze+=1),ze>1)return!0}return!1});!Qe.loose&&X.length&&J&&(Qe.loose=!0,Qe.items[Y].loose=!0)}return Qe}},ne.html=function(te){var de=this.rules.block.html.exec(te);if(de){var oe={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(de[0]):C(de[0]);oe.type="paragraph",oe.text=ue,oe.tokens=this.lexer.inline(ue)}return oe}},ne.def=function(te){var de=this.rules.block.def.exec(te);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var oe=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:oe,raw:de[0],href:de[2],title:de[3]}}},ne.table=function(te){var de=this.rules.block.table.exec(te);if(de){var oe={type:"table",header:I(de[1]).map(function(pe){return{text:pe}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=de[0];var ue=oe.align.length,N,G,Y,ie;for(N=0;N<ue;N++)/^ *-+: *$/.test(oe.align[N])?oe.align[N]="right":/^ *:-+: *$/.test(oe.align[N])?oe.align[N]="center":/^ *:-+ *$/.test(oe.align[N])?oe.align[N]="left":oe.align[N]=null;for(ue=oe.rows.length,N=0;N<ue;N++)oe.rows[N]=I(oe.rows[N],oe.header.length).map(function(pe){return{text:pe}});for(ue=oe.header.length,G=0;G<ue;G++)oe.header[G].tokens=this.lexer.inline(oe.header[G].text);for(ue=oe.rows.length,G=0;G<ue;G++)for(ie=oe.rows[G],Y=0;Y<ie.length;Y++)ie[Y].tokens=this.lexer.inline(ie[Y].text);return oe}}},ne.lheading=function(te){var de=this.rules.block.lheading.exec(te);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},ne.paragraph=function(te){var de=this.rules.block.paragraph.exec(te);if(de){var oe=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:oe,tokens:this.lexer.inline(oe)}}},ne.text=function(te){var de=this.rules.block.text.exec(te);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},ne.escape=function(te){var de=this.rules.inline.escape.exec(te);if(de)return{type:"escape",raw:de[0],text:C(de[1])}},ne.tag=function(te){var de=this.rules.inline.tag.exec(te);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):C(de[0]):de[0]}},ne.link=function(te){var de=this.rules.inline.link.exec(te);if(de){var oe=de[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var ue=E(oe.slice(0,-1),"\\");if((oe.length-ue.length)%2===0)return}else{var N=s(de[2],"()");if(N>-1){var G=de[0].indexOf("!")===0?5:4,Y=G+de[1].length+N;de[2]=de[2].substring(0,N),de[0]=de[0].substring(0,Y).trim(),de[3]=""}}var ie=de[2],pe="";if(this.options.pedantic){var Ie=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ie);Ie&&(ie=Ie[1],pe=Ie[3])}else pe=de[3]?de[3].slice(1,-1):"";return ie=ie.trim(),/^</.test(ie)&&(this.options.pedantic&&!/>$/.test(oe)?ie=ie.slice(1):ie=ie.slice(1,-1)),F(de,{href:ie&&ie.replace(this.rules.inline._escapes,"$1"),title:pe&&pe.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ne.reflink=function(te,de){var oe;if((oe=this.rules.inline.reflink.exec(te))||(oe=this.rules.inline.nolink.exec(te))){var ue=(oe[2]||oe[1]).replace(/\s+/g," ");if(ue=de[ue.toLowerCase()],!ue||!ue.href){var N=oe[0].charAt(0);return{type:"text",raw:N,text:N}}return F(oe,ue,oe[0],this.lexer)}},ne.emStrong=function(te,de,oe){oe===void 0&&(oe="");var ue=this.rules.inline.emStrong.lDelim.exec(te);if(ue&&!(ue[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var N=ue[1]||ue[2]||"";if(!N||N&&(oe===""||this.rules.inline.punctuation.exec(oe))){var G=ue[0].length-1,Y,ie,pe=G,Ie=0,he=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(he.lastIndex=0,de=de.slice(-1*te.length+G);(ue=he.exec(de))!=null;)if(Y=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!Y){if(ie=Y.length,ue[3]||ue[4]){pe+=ie;continue}else if((ue[5]||ue[6])&&G%3&&!((G+ie)%3)){Ie+=ie;continue}if(pe-=ie,!(pe>0)){if(ie=Math.min(ie,ie+pe+Ie),Math.min(G,ie)%2){var Re=te.slice(1,G+ue.index+ie);return{type:"em",raw:te.slice(0,G+ue.index+ie+1),text:Re,tokens:this.lexer.inlineTokens(Re)}}var Te=te.slice(2,G+ue.index+ie-1);return{type:"strong",raw:te.slice(0,G+ue.index+ie+1),text:Te,tokens:this.lexer.inlineTokens(Te)}}}}}},ne.codespan=function(te){var de=this.rules.inline.code.exec(te);if(de){var oe=de[2].replace(/\n/g," "),ue=/[^ ]/.test(oe),N=/^ /.test(oe)&&/ $/.test(oe);return ue&&N&&(oe=oe.substring(1,oe.length-1)),oe=C(oe,!0),{type:"codespan",raw:de[0],text:oe}}},ne.br=function(te){var de=this.rules.inline.br.exec(te);if(de)return{type:"br",raw:de[0]}},ne.del=function(te){var de=this.rules.inline.del.exec(te);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},ne.autolink=function(te,de){var oe=this.rules.inline.autolink.exec(te);if(oe){var ue,N;return oe[2]==="@"?(ue=C(this.options.mangle?de(oe[1]):oe[1]),N="mailto:"+ue):(ue=C(oe[1]),N=ue),{type:"link",raw:oe[0],text:ue,href:N,tokens:[{type:"text",raw:ue,text:ue}]}}},ne.url=function(te,de){var oe;if(oe=this.rules.inline.url.exec(te)){var ue,N;if(oe[2]==="@")ue=C(this.options.mangle?de(oe[0]):oe[0]),N="mailto:"+ue;else{var G;do G=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(G!==oe[0]);ue=C(oe[0]),oe[1]==="www."?N="http://"+ue:N=ue}return{type:"link",raw:oe[0],text:ue,href:N,tokens:[{type:"text",raw:ue,text:ue}]}}},ne.inlineText=function(te,de){var oe=this.rules.inline.text.exec(te);if(oe){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):C(oe[0]):oe[0]:ue=C(this.options.smartypants?de(oe[0]):oe[0]),{type:"text",raw:oe[0],text:ue}}},_}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=d(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=d(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=d(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=d(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=d(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=d(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=l({},W),W.gfm=l({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=d(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=d(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=l({},W.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:d(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=d(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=d(W._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=d(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=d(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=d(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=d(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=d(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=d(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=d(U.reflink).replace("label",U._label).replace("ref",W._label).getRegex(),U.nolink=d(U.nolink).replace("ref",W._label).getRegex(),U.reflinkSearch=d(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=l({},U),U.pedantic=l({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=l({},U.normal,{escape:d(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=d(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=l({},U.gfm,{br:d(U.br).replace("{2,}","*").getRegex(),text:d(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function x(_){return _.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(_){var ne="",le,te,de=_.length;for(le=0;le<de;le++)te=_.charCodeAt(le),Math.random()>.5&&(te="x"+te.toString(16)),ne+="&#"+te+";";return ne}var z=function(){function _(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||re.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:W.normal,inline:U.normal};this.options.pedantic?(te.block=W.pedantic,te.inline=U.pedantic):this.options.gfm&&(te.block=W.gfm,this.options.breaks?te.inline=U.breaks:te.inline=U.gfm),this.tokenizer.rules=te}_.lex=function(te,de){var oe=new _(de);return oe.lex(te)},_.lexInline=function(te,de){var oe=new _(de);return oe.inlineTokens(te)};var ne=_.prototype;return ne.lex=function(te){te=te.replace(/\r\n|\r/g,`
`),this.blockTokens(te,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ne.blockTokens=function(te,de){var oe=this;de===void 0&&(de=[]),this.options.pedantic?te=te.replace(/\t/g,"    ").replace(/^ +$/gm,""):te=te.replace(/^( *)(\t+)/gm,function(pe,Ie,he){return Ie+"    ".repeat(he.length)});for(var ue,N,G,Y;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(pe){return(ue=pe.call({lexer:oe},te,de))?(te=te.substring(ue.raw.length),de.push(ue),!0):!1}))){if(ue=this.tokenizer.space(te)){te=te.substring(ue.raw.length),ue.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ue);continue}if(ue=this.tokenizer.code(te)){te=te.substring(ue.raw.length),N=de[de.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+ue.raw,N.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=N.text):de.push(ue);continue}if(ue=this.tokenizer.fences(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.heading(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.hr(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.blockquote(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.list(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.html(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.def(te)){te=te.substring(ue.raw.length),N=de[de.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+ue.raw,N.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=N.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.lheading(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(G=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var pe=1/0,Ie=te.slice(1),he=void 0;oe.options.extensions.startBlock.forEach(function(Re){he=Re.call({lexer:this},Ie),typeof he=="number"&&he>=0&&(pe=Math.min(pe,he))}),pe<1/0&&pe>=0&&(G=te.substring(0,pe+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(G))){N=de[de.length-1],Y&&N.type==="paragraph"?(N.raw+=`
`+ue.raw,N.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):de.push(ue),Y=G.length!==te.length,te=te.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(te)){te=te.substring(ue.raw.length),N=de[de.length-1],N&&N.type==="text"?(N.raw+=`
`+ue.raw,N.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):de.push(ue);continue}if(te){var ie="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(ie);break}else throw new Error(ie)}}return this.state.top=!0,de},ne.inline=function(te,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:te,tokens:de}),de},ne.inlineTokens=function(te,de){var oe=this;de===void 0&&(de=[]);var ue,N,G,Y=te,ie,pe,Ie;if(this.tokens.links){var he=Object.keys(this.tokens.links);if(he.length>0)for(;(ie=this.tokenizer.rules.inline.reflinkSearch.exec(Y))!=null;)he.includes(ie[0].slice(ie[0].lastIndexOf("[")+1,-1))&&(Y=Y.slice(0,ie.index)+"["+k("a",ie[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ie=this.tokenizer.rules.inline.blockSkip.exec(Y))!=null;)Y=Y.slice(0,ie.index)+"["+k("a",ie[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ie=this.tokenizer.rules.inline.escapedEmSt.exec(Y))!=null;)Y=Y.slice(0,ie.index)+"++"+Y.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(pe||(Ie=""),pe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Te){return(ue=Te.call({lexer:oe},te,de))?(te=te.substring(ue.raw.length),de.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.tag(te)){te=te.substring(ue.raw.length),N=de[de.length-1],N&&ue.type==="text"&&N.type==="text"?(N.raw+=ue.raw,N.text+=ue.text):de.push(ue);continue}if(ue=this.tokenizer.link(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(ue.raw.length),N=de[de.length-1],N&&ue.type==="text"&&N.type==="text"?(N.raw+=ue.raw,N.text+=ue.text):de.push(ue);continue}if(ue=this.tokenizer.emStrong(te,Y,Ie)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.codespan(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.br(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.del(te)){te=te.substring(ue.raw.length),de.push(ue);continue}if(ue=this.tokenizer.autolink(te,B)){te=te.substring(ue.raw.length),de.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(te,B))){te=te.substring(ue.raw.length),de.push(ue);continue}if(G=te,this.options.extensions&&this.options.extensions.startInline&&function(){var Te=1/0,Ve=te.slice(1),xe=void 0;oe.options.extensions.startInline.forEach(function(tt){xe=tt.call({lexer:this},Ve),typeof xe=="number"&&xe>=0&&(Te=Math.min(Te,xe))}),Te<1/0&&Te>=0&&(G=te.substring(0,Te+1))}(),ue=this.tokenizer.inlineText(G,x)){te=te.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(Ie=ue.raw.slice(-1)),pe=!0,N=de[de.length-1],N&&N.type==="text"?(N.raw+=ue.raw,N.text+=ue.text):de.push(ue);continue}if(te){var Re="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return de},c(_,null,[{key:"rules",get:function(){return{block:W,inline:U}}}]),_}(),ee=function(){function _(le){this.options=le||re.defaults}var ne=_.prototype;return ne.code=function(te,de,oe){var ue=(de||"").match(/\S*/)[0];if(this.options.highlight){var N=this.options.highlight(te,ue);N!=null&&N!==te&&(oe=!0,te=N)}return te=te.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+C(ue,!0)+'">'+(oe?te:C(te,!0))+`</code></pre>
`:"<pre><code>"+(oe?te:C(te,!0))+`</code></pre>
`},ne.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},ne.html=function(te){return te},ne.heading=function(te,de,oe,ue){if(this.options.headerIds){var N=this.options.headerPrefix+ue.slug(oe);return"<h"+de+' id="'+N+'">'+te+"</h"+de+`>
`}return"<h"+de+">"+te+"</h"+de+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(te,de,oe){var ue=de?"ol":"ul",N=de&&oe!==1?' start="'+oe+'"':"";return"<"+ue+N+`>
`+te+"</"+ue+`>
`},ne.listitem=function(te){return"<li>"+te+`</li>
`},ne.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(te){return"<p>"+te+`</p>
`},ne.table=function(te,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+de+`</table>
`},ne.tablerow=function(te){return`<tr>
`+te+`</tr>
`},ne.tablecell=function(te,de){var oe=de.header?"th":"td",ue=de.align?"<"+oe+' align="'+de.align+'">':"<"+oe+">";return ue+te+("</"+oe+`>
`)},ne.strong=function(te){return"<strong>"+te+"</strong>"},ne.em=function(te){return"<em>"+te+"</em>"},ne.codespan=function(te){return"<code>"+te+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(te){return"<del>"+te+"</del>"},ne.link=function(te,de,oe){if(te=p(this.options.sanitize,this.options.baseUrl,te),te===null)return oe;var ue='<a href="'+C(te)+'"';return de&&(ue+=' title="'+de+'"'),ue+=">"+oe+"</a>",ue},ne.image=function(te,de,oe){if(te=p(this.options.sanitize,this.options.baseUrl,te),te===null)return oe;var ue='<img src="'+te+'" alt="'+oe+'"';return de&&(ue+=' title="'+de+'"'),ue+=this.options.xhtml?"/>":">",ue},ne.text=function(te){return te},_}(),se=function(){function _(){}var ne=_.prototype;return ne.strong=function(te){return te},ne.em=function(te){return te},ne.codespan=function(te){return te},ne.del=function(te){return te},ne.html=function(te){return te},ne.text=function(te){return te},ne.link=function(te,de,oe){return""+oe},ne.image=function(te,de,oe){return""+oe},ne.br=function(){return""},_}(),V=function(){function _(){this.seen={}}var ne=_.prototype;return ne.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(te,de){var oe=te,ue=0;if(this.seen.hasOwnProperty(oe)){ue=this.seen[te];do ue++,oe=te+"-"+ue;while(this.seen.hasOwnProperty(oe))}return de||(this.seen[te]=ue,this.seen[oe]=0),oe},ne.slug=function(te,de){de===void 0&&(de={});var oe=this.serialize(te);return this.getNextSafeSlug(oe,de.dryrun)},_}(),Z=function(){function _(le){this.options=le||re.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new se,this.slugger=new V}_.parse=function(te,de){var oe=new _(de);return oe.parse(te)},_.parseInline=function(te,de){var oe=new _(de);return oe.parseInline(te)};var ne=_.prototype;return ne.parse=function(te,de){de===void 0&&(de=!0);var oe="",ue,N,G,Y,ie,pe,Ie,he,Re,Te,Ve,xe,tt,Qe,Xe,nt,ot,et,Be,ke=te.length;for(ue=0;ue<ke;ue++){if(Te=te[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(Be=this.options.extensions.renderers[Te.type].call({parser:this},Te),Be!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Te.type))){oe+=Be||"";continue}switch(Te.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(Te.tokens),Te.depth,n(this.parseInline(Te.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(Te.text,Te.lang,Te.escaped);continue}case"table":{for(he="",Ie="",Y=Te.header.length,N=0;N<Y;N++)Ie+=this.renderer.tablecell(this.parseInline(Te.header[N].tokens),{header:!0,align:Te.align[N]});for(he+=this.renderer.tablerow(Ie),Re="",Y=Te.rows.length,N=0;N<Y;N++){for(pe=Te.rows[N],Ie="",ie=pe.length,G=0;G<ie;G++)Ie+=this.renderer.tablecell(this.parseInline(pe[G].tokens),{header:!1,align:Te.align[G]});Re+=this.renderer.tablerow(Ie)}oe+=this.renderer.table(he,Re);continue}case"blockquote":{Re=this.parse(Te.tokens),oe+=this.renderer.blockquote(Re);continue}case"list":{for(Ve=Te.ordered,xe=Te.start,tt=Te.loose,Y=Te.items.length,Re="",N=0;N<Y;N++)Xe=Te.items[N],nt=Xe.checked,ot=Xe.task,Qe="",Xe.task&&(et=this.renderer.checkbox(nt),tt?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=et+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=et+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:et}):Qe+=et),Qe+=this.parse(Xe.tokens,tt),Re+=this.renderer.listitem(Qe,ot,nt);oe+=this.renderer.list(Re,Ve,xe);continue}case"html":{oe+=this.renderer.html(Te.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(Te.tokens));continue}case"text":{for(Re=Te.tokens?this.parseInline(Te.tokens):Te.text;ue+1<ke&&te[ue+1].type==="text";)Te=te[++ue],Re+=`
`+(Te.tokens?this.parseInline(Te.tokens):Te.text);oe+=de?this.renderer.paragraph(Re):Re;continue}default:{var X='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return oe},ne.parseInline=function(te,de){de=de||this.renderer;var oe="",ue,N,G,Y=te.length;for(ue=0;ue<Y;ue++){if(N=te[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[N.type]&&(G=this.options.extensions.renderers[N.type].call({parser:this},N),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(N.type))){oe+=G||"";continue}switch(N.type){case"escape":{oe+=de.text(N.text);break}case"html":{oe+=de.html(N.text);break}case"link":{oe+=de.link(N.href,N.title,this.parseInline(N.tokens,de));break}case"image":{oe+=de.image(N.href,N.title,N.text);break}case"strong":{oe+=de.strong(this.parseInline(N.tokens,de));break}case"em":{oe+=de.em(this.parseInline(N.tokens,de));break}case"codespan":{oe+=de.codespan(N.text);break}case"br":{oe+=de.br();break}case"del":{oe+=de.del(this.parseInline(N.tokens,de));break}case"text":{oe+=de.text(N.text);break}default:{var ie='Token with "'+N.type+'" type was not found.';if(this.options.silent){console.error(ie);return}else throw new Error(ie)}}}return oe},_}();function q(_,ne,le){if(typeof _>"u"||_===null)throw new Error("marked(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");if(typeof ne=="function"&&(le=ne,ne=null),ne=l({},q.defaults,ne||{}),i(ne),le){var te=ne.highlight,de;try{de=z.lex(_,ne)}catch(Y){return le(Y)}var oe=function(ie){var pe;if(!ie)try{ne.walkTokens&&q.walkTokens(de,ne.walkTokens),pe=Z.parse(de,ne)}catch(Ie){ie=Ie}return ne.highlight=te,ie?le(ie):le(null,pe)};if(!te||te.length<3||(delete ne.highlight,!de.length))return oe();var ue=0;q.walkTokens(de,function(Y){Y.type==="code"&&(ue++,setTimeout(function(){te(Y.text,Y.lang,function(ie,pe){if(ie)return oe(ie);pe!=null&&pe!==Y.text&&(Y.text=pe,Y.escaped=!0),ue--,ue===0&&oe()})},0))}),ue===0&&oe();return}function N(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+C(Y.message+"",!0)+"</pre>";throw Y}try{var G=z.lex(_,ne);if(ne.walkTokens){if(ne.async)return Promise.all(q.walkTokens(G,ne.walkTokens)).then(function(){return Z.parse(G,ne)}).catch(N);q.walkTokens(G,ne.walkTokens)}return Z.parse(G,ne)}catch(Y){N(Y)}}q.options=q.setOptions=function(_){return l(q.defaults,_),A(q.defaults),q},q.getDefaults=L,q.defaults=re.defaults,q.use=function(){for(var _=arguments.length,ne=new Array(_),le=0;le<_;le++)ne[le]=arguments[le];var te=l.apply(void 0,[{}].concat(ne)),de=q.defaults.extensions||{renderers:{},childTokens:{}},oe;ne.forEach(function(ue){if(ue.extensions&&(oe=!0,ue.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var Y=de.renderers?de.renderers[G.name]:null;Y?de.renderers[G.name]=function(){for(var ie=arguments.length,pe=new Array(ie),Ie=0;Ie<ie;Ie++)pe[Ie]=arguments[Ie];var he=G.renderer.apply(this,pe);return he===!1&&(he=Y.apply(this,pe)),he}:de.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[G.level]?de[G.level].unshift(G.tokenizer):de[G.level]=[G.tokenizer],G.start&&(G.level==="block"?de.startBlock?de.startBlock.push(G.start):de.startBlock=[G.start]:G.level==="inline"&&(de.startInline?de.startInline.push(G.start):de.startInline=[G.start]))}G.childTokens&&(de.childTokens[G.name]=G.childTokens)})),ue.renderer&&function(){var G=q.defaults.renderer||new ee,Y=function(Ie){var he=G[Ie];G[Ie]=function(){for(var Re=arguments.length,Te=new Array(Re),Ve=0;Ve<Re;Ve++)Te[Ve]=arguments[Ve];var xe=ue.renderer[Ie].apply(G,Te);return xe===!1&&(xe=he.apply(G,Te)),xe}};for(var ie in ue.renderer)Y(ie);te.renderer=G}(),ue.tokenizer&&function(){var G=q.defaults.tokenizer||new j,Y=function(Ie){var he=G[Ie];G[Ie]=function(){for(var Re=arguments.length,Te=new Array(Re),Ve=0;Ve<Re;Ve++)Te[Ve]=arguments[Ve];var xe=ue.tokenizer[Ie].apply(G,Te);return xe===!1&&(xe=he.apply(G,Te)),xe}};for(var ie in ue.tokenizer)Y(ie);te.tokenizer=G}(),ue.walkTokens){var N=q.defaults.walkTokens;te.walkTokens=function(G){var Y=[];return Y.push(ue.walkTokens.call(this,G)),N&&(Y=Y.concat(N.call(this,G))),Y}}oe&&(te.extensions=de),q.setOptions(te)})},q.walkTokens=function(_,ne){for(var le=[],te=function(){var N=oe.value;switch(le=le.concat(ne.call(q,N)),N.type){case"table":{for(var G=O(N.header),Y;!(Y=G()).done;){var ie=Y.value;le=le.concat(q.walkTokens(ie.tokens,ne))}for(var pe=O(N.rows),Ie;!(Ie=pe()).done;)for(var he=Ie.value,Re=O(he),Te;!(Te=Re()).done;){var Ve=Te.value;le=le.concat(q.walkTokens(Ve.tokens,ne))}break}case"list":{le=le.concat(q.walkTokens(N.items,ne));break}default:q.defaults.extensions&&q.defaults.extensions.childTokens&&q.defaults.extensions.childTokens[N.type]?q.defaults.extensions.childTokens[N.type].forEach(function(xe){le=le.concat(q.walkTokens(N[xe],ne))}):N.tokens&&(le=le.concat(q.walkTokens(N.tokens,ne)))}},de=O(_),oe;!(oe=de()).done;)te();return le},q.parseInline=function(_,ne){if(typeof _>"u"||_===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");ne=l({},q.defaults,ne||{}),i(ne);try{var le=z.lexInline(_,ne);return ne.walkTokens&&q.walkTokens(le,ne.walkTokens),Z.parseInline(le,ne)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+C(te.message+"",!0)+"</pre>";throw te}},q.Parser=Z,q.parser=Z.parse,q.Renderer=ee,q.TextRenderer=se,q.Lexer=z,q.lexer=z.lex,q.Tokenizer=j,q.Slugger=V,q.parse=q;var ae=q.options,Ee=q.setOptions,ye=q.use,be=q.walkTokens,M=q.parseInline,Q=q,fe=Z.parse,we=z.lex;re.Lexer=z,re.Parser=Z,re.Renderer=ee,re.Slugger=V,re.TextRenderer=se,re.Tokenizer=j,re.getDefaults=L,re.lexer=we,re.marked=q,re.options=ae,re.parse=Q,re.parseInline=M,re.parser=fe,re.setOptions=Ee,re.use=ye,re.walkTokens=be,Object.defineProperty(re,"__esModule",{value:!0})}),define(Ce[69],De([1,0,28]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new c.LRUCache(1e4);function u(g){return y(g,"NFC",R)}e.normalizeNFC=u;const O=new c.LRUCache(1e4);function L(g){return y(g,"NFD",O)}e.normalizeNFD=L;const A=/[^\u0000-\u0080]/;function y(g,T,P){if(!g)return g;const m=P.get(g);if(m)return m;let D;return A.test(g)?D=g.normalize(T):D=g,P.set(g,D),D}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(T){return L(T).replace(g,"")}}()}),define(Ce[111],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(A,y,g){return Math.min(Math.max(A,y),g)}e.clamp=c;function R(A,y){return(y+A%y)%y}e.rot=R;class u{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=u;class O{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=O;class L{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const g=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=L}),function(){function re(u){const O=[];typeof u=="number"&&O.push("code/timeOrigin",u);function L(y){O.push(y,Date.now())}function A(){const y=[];for(let g=0;g<O.length;g+=2)y.push({name:O[g],startTime:O[g+1]});return y}return{mark:L,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(u){performance.mark(u)},getMarks(){let u=performance.timeOrigin;typeof u!="number"&&(u=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(u)}];for(const L of performance.getEntriesByType("mark"))O.push({name:L.name,startTime:Math.round(u+L.startTime)});return O}};if(typeof process=="object"){const u=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(u)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function c(u){return u.MonacoPerformanceMarks||(u.MonacoPerformanceMarks=e()),u.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=c(R))}(),define(Ce[9],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let c=!1,R=!1,u=!1,O=!1,L=!1,A=!1,y=!1,g=!1,T=!1,P=!1,m,D=e.LANGUAGE_DEFAULT,C=e.LANGUAGE_DEFAULT,b,n;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const d=typeof h?.versions?.electron=="string",S=d&&h?.type==="renderer";if(typeof navigator=="object"&&!S){n=navigator.userAgent,c=n.indexOf("Windows")>=0,R=n.indexOf("Macintosh")>=0,g=(n.indexOf("Macintosh")>=0||n.indexOf("iPad")>=0||n.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,u=n.indexOf("Linux")>=0,P=n?.indexOf("Mobi")>=0,A=!0,m=e.LANGUAGE_DEFAULT,D=m,C=navigator.language;const l=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),I=l&&l.getAttribute("data-settings");if(I)try{const E=JSON.parse(I),s=E.availableLanguages["*"];m=E.locale,C=E.osLocale,D=s||e.LANGUAGE_DEFAULT,b=E._translationsConfigFile}catch{}}else if(typeof h=="object"){c=h.platform==="win32",R=h.platform==="darwin",u=h.platform==="linux",O=u&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,y=d,T=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.LANGUAGE_DEFAULT,D=e.LANGUAGE_DEFAULT;const l=h.env.VSCODE_NLS_CONFIG;if(l)try{const I=JSON.parse(l),E=I.availableLanguages["*"];m=I.locale,C=I.osLocale,D=E||e.LANGUAGE_DEFAULT,b=I._translationsConfigFile}catch{}L=!0}else console.error("Unable to resolve platform.");var w;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(w||(e.Platform=w={}));function p(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let t=0;R?t=1:c?t=3:u&&(t=2),e.isWindows=c,e.isMacintosh=R,e.isLinux=u,e.isLinuxSnap=O,e.isNative=L,e.isElectron=y,e.isWeb=A,e.isWebWorker=A&&typeof e.globals.importScripts=="function",e.isIOS=g,e.isMobile=P,e.isCI=T,e.platform=t,e.userAgent=n,e.language=D;var a;(function(l){function I(){return e.language}l.value=I;function E(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=E;function s(){return e.language==="en"}l.isDefault=s})(a||(e.Language=a={})),e.locale=m,e.platformLocale=C,e.translationsConfigFile=b,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const l=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let s=0,i=l.length;s<i;s++){const k=l[s];if(k.id===E.data.vscodeScheduleAsyncWork){l.splice(s,1),k.callback();return}}});let I=0;return E=>{const s=++I;l.push({id:s,callback:E}),e.globals.postMessage({vscodeScheduleAsyncWork:s},"*")}}return l=>setTimeout(l)})();var r;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(r||(e.OperatingSystem=r={})),e.OS=R||g?2:c?1:3;let o=!0,f=!1;function v(){if(!f){f=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,o=new Uint16Array(l.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=v,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ce[39],De([1,0,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let R;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const u=c.globals.vscode.process;R={get platform(){return u.platform},get arch(){return u.arch},get env(){return u.env},cwd(){return u.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.arch=R.arch}),define(Ce[10],De([1,0,39]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,u=97,O=90,L=122,A=46,y=47,g=92,T=58,P=63;class m extends Error{constructor(a,r,o){let f;typeof r=="string"&&r.indexOf("not ")===0?(f="must not be",r=r.replace(/^not /,"")):f="must be";const v=a.indexOf(".")!==-1?"property":"argument";let l=`The "${a}" ${v} ${f} of type ${r}`;l+=`. Received type ${typeof o}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function D(t,a){if(t===null||typeof t!="object")throw new m(a,"Object",t)}function C(t,a){if(typeof t!="string")throw new m(a,"string",t)}const b=c.platform==="win32";function n(t){return t===y||t===g}function h(t){return t===y}function d(t){return t>=R&&t<=O||t>=u&&t<=L}function S(t,a,r,o){let f="",v=0,l=-1,I=0,E=0;for(let s=0;s<=t.length;++s){if(s<t.length)E=t.charCodeAt(s);else{if(o(E))break;E=y}if(o(E)){if(!(l===s-1||I===1))if(I===2){if(f.length<2||v!==2||f.charCodeAt(f.length-1)!==A||f.charCodeAt(f.length-2)!==A){if(f.length>2){const i=f.lastIndexOf(r);i===-1?(f="",v=0):(f=f.slice(0,i),v=f.length-1-f.lastIndexOf(r)),l=s,I=0;continue}else if(f.length!==0){f="",v=0,l=s,I=0;continue}}a&&(f+=f.length>0?`${r}..`:"..",v=2)}else f.length>0?f+=`${r}${t.slice(l+1,s)}`:f=t.slice(l+1,s),v=s-l-1;l=s,I=0}else E===A&&I!==-1?++I:I=-1}return f}function w(t,a){D(a,"pathObject");const r=a.dir||a.root,o=a.base||`${a.name||""}${a.ext||""}`;return r?r===a.root?`${r}${o}`:`${r}${t}${o}`:o}e.win32={resolve(...t){let a="",r="",o=!1;for(let f=t.length-1;f>=-1;f--){let v;if(f>=0){if(v=t[f],C(v,"path"),v.length===0)continue}else a.length===0?v=c.cwd():(v=c.env[`=${a}`]||c.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==a.toLowerCase()&&v.charCodeAt(2)===g)&&(v=`${a}\\`));const l=v.length;let I=0,E="",s=!1;const i=v.charCodeAt(0);if(l===1)n(i)&&(I=1,s=!0);else if(n(i))if(s=!0,n(v.charCodeAt(1))){let k=2,F=k;for(;k<l&&!n(v.charCodeAt(k));)k++;if(k<l&&k!==F){const $=v.slice(F,k);for(F=k;k<l&&n(v.charCodeAt(k));)k++;if(k<l&&k!==F){for(F=k;k<l&&!n(v.charCodeAt(k));)k++;(k===l||k!==F)&&(E=`\\\\${$}\\${v.slice(F,k)}`,I=k)}}}else I=1;else d(i)&&v.charCodeAt(1)===T&&(E=v.slice(0,2),I=2,l>2&&n(v.charCodeAt(2))&&(s=!0,I=3));if(E.length>0)if(a.length>0){if(E.toLowerCase()!==a.toLowerCase())continue}else a=E;if(o){if(a.length>0)break}else if(r=`${v.slice(I)}\\${r}`,o=s,s&&a.length>0)break}return r=S(r,!o,"\\",n),o?`${a}\\${r}`:`${a}${r}`||"."},normalize(t){C(t,"path");const a=t.length;if(a===0)return".";let r=0,o,f=!1;const v=t.charCodeAt(0);if(a===1)return h(v)?"\\":t;if(n(v))if(f=!0,n(t.charCodeAt(1))){let I=2,E=I;for(;I<a&&!n(t.charCodeAt(I));)I++;if(I<a&&I!==E){const s=t.slice(E,I);for(E=I;I<a&&n(t.charCodeAt(I));)I++;if(I<a&&I!==E){for(E=I;I<a&&!n(t.charCodeAt(I));)I++;if(I===a)return`\\\\${s}\\${t.slice(E)}\\`;I!==E&&(o=`\\\\${s}\\${t.slice(E,I)}`,r=I)}}}else r=1;else d(v)&&t.charCodeAt(1)===T&&(o=t.slice(0,2),r=2,a>2&&n(t.charCodeAt(2))&&(f=!0,r=3));let l=r<a?S(t.slice(r),!f,"\\",n):"";return l.length===0&&!f&&(l="."),l.length>0&&n(t.charCodeAt(a-1))&&(l+="\\"),o===void 0?f?`\\${l}`:l:f?`${o}\\${l}`:`${o}${l}`},isAbsolute(t){C(t,"path");const a=t.length;if(a===0)return!1;const r=t.charCodeAt(0);return n(r)||a>2&&d(r)&&t.charCodeAt(1)===T&&n(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,r;for(let v=0;v<t.length;++v){const l=t[v];C(l,"path"),l.length>0&&(a===void 0?a=r=l:a+=`\\${l}`)}if(a===void 0)return".";let o=!0,f=0;if(typeof r=="string"&&n(r.charCodeAt(0))){++f;const v=r.length;v>1&&n(r.charCodeAt(1))&&(++f,v>2&&(n(r.charCodeAt(2))?++f:o=!1))}if(o){for(;f<a.length&&n(a.charCodeAt(f));)f++;f>=2&&(a=`\\${a.slice(f)}`)}return e.win32.normalize(a)},relative(t,a){if(C(t,"from"),C(a,"to"),t===a)return"";const r=e.win32.resolve(t),o=e.win32.resolve(a);if(r===o||(t=r.toLowerCase(),a=o.toLowerCase(),t===a))return"";let f=0;for(;f<t.length&&t.charCodeAt(f)===g;)f++;let v=t.length;for(;v-1>f&&t.charCodeAt(v-1)===g;)v--;const l=v-f;let I=0;for(;I<a.length&&a.charCodeAt(I)===g;)I++;let E=a.length;for(;E-1>I&&a.charCodeAt(E-1)===g;)E--;const s=E-I,i=l<s?l:s;let k=-1,F=0;for(;F<i;F++){const j=t.charCodeAt(f+F);if(j!==a.charCodeAt(I+F))break;j===g&&(k=F)}if(F!==i){if(k===-1)return o}else{if(s>i){if(a.charCodeAt(I+F)===g)return o.slice(I+F+1);if(F===2)return o.slice(I+F)}l>i&&(t.charCodeAt(f+F)===g?k=F:F===2&&(k=3)),k===-1&&(k=0)}let $="";for(F=f+k+1;F<=v;++F)(F===v||t.charCodeAt(F)===g)&&($+=$.length===0?"..":"\\..");return I+=k,$.length>0?`${$}${o.slice(I,E)}`:(o.charCodeAt(I)===g&&++I,o.slice(I,E))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===g){if(a.charCodeAt(1)===g){const r=a.charCodeAt(2);if(r!==P&&r!==A)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(d(a.charCodeAt(0))&&a.charCodeAt(1)===T&&a.charCodeAt(2)===g)return`\\\\?\\${a}`;return t},dirname(t){C(t,"path");const a=t.length;if(a===0)return".";let r=-1,o=0;const f=t.charCodeAt(0);if(a===1)return n(f)?t:".";if(n(f)){if(r=o=1,n(t.charCodeAt(1))){let I=2,E=I;for(;I<a&&!n(t.charCodeAt(I));)I++;if(I<a&&I!==E){for(E=I;I<a&&n(t.charCodeAt(I));)I++;if(I<a&&I!==E){for(E=I;I<a&&!n(t.charCodeAt(I));)I++;if(I===a)return t;I!==E&&(r=o=I+1)}}}}else d(f)&&t.charCodeAt(1)===T&&(r=a>2&&n(t.charCodeAt(2))?3:2,o=r);let v=-1,l=!0;for(let I=a-1;I>=o;--I)if(n(t.charCodeAt(I))){if(!l){v=I;break}}else l=!1;if(v===-1){if(r===-1)return".";v=r}return t.slice(0,v)},basename(t,a){a!==void 0&&C(a,"ext"),C(t,"path");let r=0,o=-1,f=!0,v;if(t.length>=2&&d(t.charCodeAt(0))&&t.charCodeAt(1)===T&&(r=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let l=a.length-1,I=-1;for(v=t.length-1;v>=r;--v){const E=t.charCodeAt(v);if(n(E)){if(!f){r=v+1;break}}else I===-1&&(f=!1,I=v+1),l>=0&&(E===a.charCodeAt(l)?--l===-1&&(o=v):(l=-1,o=I))}return r===o?o=I:o===-1&&(o=t.length),t.slice(r,o)}for(v=t.length-1;v>=r;--v)if(n(t.charCodeAt(v))){if(!f){r=v+1;break}}else o===-1&&(f=!1,o=v+1);return o===-1?"":t.slice(r,o)},extname(t){C(t,"path");let a=0,r=-1,o=0,f=-1,v=!0,l=0;t.length>=2&&t.charCodeAt(1)===T&&d(t.charCodeAt(0))&&(a=o=2);for(let I=t.length-1;I>=a;--I){const E=t.charCodeAt(I);if(n(E)){if(!v){o=I+1;break}continue}f===-1&&(v=!1,f=I+1),E===A?r===-1?r=I:l!==1&&(l=1):r!==-1&&(l=-1)}return r===-1||f===-1||l===0||l===1&&r===f-1&&r===o+1?"":t.slice(r,f)},format:w.bind(null,"\\"),parse(t){C(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const r=t.length;let o=0,f=t.charCodeAt(0);if(r===1)return n(f)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(n(f)){if(o=1,n(t.charCodeAt(1))){let k=2,F=k;for(;k<r&&!n(t.charCodeAt(k));)k++;if(k<r&&k!==F){for(F=k;k<r&&n(t.charCodeAt(k));)k++;if(k<r&&k!==F){for(F=k;k<r&&!n(t.charCodeAt(k));)k++;k===r?o=k:k!==F&&(o=k+1)}}}}else if(d(f)&&t.charCodeAt(1)===T){if(r<=2)return a.root=a.dir=t,a;if(o=2,n(t.charCodeAt(2))){if(r===3)return a.root=a.dir=t,a;o=3}}o>0&&(a.root=t.slice(0,o));let v=-1,l=o,I=-1,E=!0,s=t.length-1,i=0;for(;s>=o;--s){if(f=t.charCodeAt(s),n(f)){if(!E){l=s+1;break}continue}I===-1&&(E=!1,I=s+1),f===A?v===-1?v=s:i!==1&&(i=1):v!==-1&&(i=-1)}return I!==-1&&(v===-1||i===0||i===1&&v===I-1&&v===l+1?a.base=a.name=t.slice(l,I):(a.name=t.slice(l,v),a.base=t.slice(l,I),a.ext=t.slice(v,I))),l>0&&l!==o?a.dir=t.slice(0,l-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(b){const t=/\\/g;return()=>{const a=c.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>c.cwd()})();e.posix={resolve(...t){let a="",r=!1;for(let o=t.length-1;o>=-1&&!r;o--){const f=o>=0?t[o]:p();C(f,"path"),f.length!==0&&(a=`${f}/${a}`,r=f.charCodeAt(0)===y)}return a=S(a,!r,"/",h),r?`/${a}`:a.length>0?a:"."},normalize(t){if(C(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===y,r=t.charCodeAt(t.length-1)===y;return t=S(t,!a,"/",h),t.length===0?a?"/":r?"./":".":(r&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return C(t,"path"),t.length>0&&t.charCodeAt(0)===y},join(...t){if(t.length===0)return".";let a;for(let r=0;r<t.length;++r){const o=t[r];C(o,"path"),o.length>0&&(a===void 0?a=o:a+=`/${o}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(C(t,"from"),C(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const r=1,o=t.length,f=o-r,v=1,l=a.length-v,I=f<l?f:l;let E=-1,s=0;for(;s<I;s++){const k=t.charCodeAt(r+s);if(k!==a.charCodeAt(v+s))break;k===y&&(E=s)}if(s===I)if(l>I){if(a.charCodeAt(v+s)===y)return a.slice(v+s+1);if(s===0)return a.slice(v+s)}else f>I&&(t.charCodeAt(r+s)===y?E=s:s===0&&(E=0));let i="";for(s=r+E+1;s<=o;++s)(s===o||t.charCodeAt(s)===y)&&(i+=i.length===0?"..":"/..");return`${i}${a.slice(v+E)}`},toNamespacedPath(t){return t},dirname(t){if(C(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===y;let r=-1,o=!0;for(let f=t.length-1;f>=1;--f)if(t.charCodeAt(f)===y){if(!o){r=f;break}}else o=!1;return r===-1?a?"/":".":a&&r===1?"//":t.slice(0,r)},basename(t,a){a!==void 0&&C(a,"ext"),C(t,"path");let r=0,o=-1,f=!0,v;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let l=a.length-1,I=-1;for(v=t.length-1;v>=0;--v){const E=t.charCodeAt(v);if(E===y){if(!f){r=v+1;break}}else I===-1&&(f=!1,I=v+1),l>=0&&(E===a.charCodeAt(l)?--l===-1&&(o=v):(l=-1,o=I))}return r===o?o=I:o===-1&&(o=t.length),t.slice(r,o)}for(v=t.length-1;v>=0;--v)if(t.charCodeAt(v)===y){if(!f){r=v+1;break}}else o===-1&&(f=!1,o=v+1);return o===-1?"":t.slice(r,o)},extname(t){C(t,"path");let a=-1,r=0,o=-1,f=!0,v=0;for(let l=t.length-1;l>=0;--l){const I=t.charCodeAt(l);if(I===y){if(!f){r=l+1;break}continue}o===-1&&(f=!1,o=l+1),I===A?a===-1?a=l:v!==1&&(v=1):a!==-1&&(v=-1)}return a===-1||o===-1||v===0||v===1&&a===o-1&&a===r+1?"":t.slice(a,o)},format:w.bind(null,"/"),parse(t){C(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const r=t.charCodeAt(0)===y;let o;r?(a.root="/",o=1):o=0;let f=-1,v=0,l=-1,I=!0,E=t.length-1,s=0;for(;E>=o;--E){const i=t.charCodeAt(E);if(i===y){if(!I){v=E+1;break}continue}l===-1&&(I=!1,l=E+1),i===A?f===-1?f=E:s!==1&&(s=1):f!==-1&&(s=-1)}if(l!==-1){const i=v===0&&r?1:v;f===-1||s===0||s===1&&f===l-1&&f===v+1?a.base=a.name=t.slice(i,l):(a.name=t.slice(i,f),a.base=t.slice(i,l),a.ext=t.slice(f,l))}return v>0?a.dir=t.slice(0,v-1):r&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b?e.win32.normalize:e.posix.normalize,e.isAbsolute=b?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b?e.win32.join:e.posix.join,e.resolve=b?e.win32.resolve:e.posix.resolve,e.relative=b?e.win32.relative:e.posix.relative,e.dirname=b?e.win32.dirname:e.posix.dirname,e.basename=b?e.win32.basename:e.posix.basename,e.extname=b?e.win32.extname:e.posix.extname,e.format=b?e.win32.format:e.posix.format,e.parse=b?e.win32.parse:e.posix.parse,e.toNamespacedPath=b?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b?e.win32.sep:e.posix.sep,e.delimiter=b?e.win32.delimiter:e.posix.delimiter}),define(Ce[112],De([1,0,54,10]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const u=new c.Lazy(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),O=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new c.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(I,E,s=!1){const i=I||"",k=E||"",F=u.value.collator.compare(i,k);return u.value.collatorIsNumeric&&F===0&&i!==k?i<k?-1:1:F}e.compareFileNames=A;function y(I,E){const s=O.value.collator;return I=I||"",E=E||"",w(s,I,E)}e.compareFileNamesDefault=y;function g(I,E){const s=O.value.collator;return I=I||"",E=E||"",r(I,E)||w(s,I,E)}e.compareFileNamesUpper=g;function T(I,E){const s=O.value.collator;return I=I||"",E=E||"",a(I,E)||w(s,I,E)}e.compareFileNamesLower=T;function P(I,E){return I=I||"",E=E||"",I===E?0:I<E?-1:1}e.compareFileNamesUnicode=P;function m(I,E){const[s,i]=d(I),[k,F]=d(E);let $=u.value.collator.compare(i,F);if($===0){if(u.value.collatorIsNumeric&&i!==F)return i<F?-1:1;if($=u.value.collator.compare(s,k),u.value.collatorIsNumeric&&$===0&&s!==k)return s<k?-1:1}return $}e.compareFileExtensions=m;function D(I,E){I=I||"",E=E||"";const s=S(I),i=S(E),k=O.value.collator,F=L.value.collator;return w(F,s,i)||w(k,I,E)}e.compareFileExtensionsDefault=D;function C(I,E){I=I||"",E=E||"";const s=S(I),i=S(E),k=O.value.collator,F=L.value.collator;return w(F,s,i)||r(I,E)||w(k,I,E)}e.compareFileExtensionsUpper=C;function b(I,E){I=I||"",E=E||"";const s=S(I),i=S(E),k=O.value.collator,F=L.value.collator;return w(F,s,i)||a(I,E)||w(k,I,E)}e.compareFileExtensionsLower=b;function n(I,E){I=I||"",E=E||"";const s=S(I).toLowerCase(),i=S(E).toLowerCase();return s!==i?s<i?-1:1:I!==E?I<E?-1:1:0}e.compareFileExtensionsUnicode=n;const h=/^(.*?)(\.([^.]*))?$/;function d(I,E=!1){const s=I?h.exec(I):[];let i=[s&&s[1]||"",s&&s[3]||""];return E&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function S(I){const E=I?h.exec(I):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function w(I,E,s){const i=I.compare(E,s);return i!==0?i:E.length!==s.length?E.length<s.length?-1:1:0}function p(I){const E=I.charAt(0);return E.toLocaleUpperCase()!==E}function t(I){const E=I.charAt(0);return E.toLocaleLowerCase()!==E}function a(I,E){return p(I)&&t(E)?-1:t(I)&&p(E)?1:0}function r(I,E){return t(I)&&p(E)?-1:p(I)&&t(E)?1:0}function o(I,E,s=!1){return s||(I=I&&I.toLowerCase(),E=E&&E.toLowerCase()),I===E?0:I<E?-1:1}function f(I,E,s=!1){const i=I.split(R.sep),k=E.split(R.sep),F=i.length-1,$=k.length-1;let j,W;for(let U=0;;U++){if(j=F===U,W=$===U,j&&W)return A(i[U],k[U],s);if(j)return-1;if(W)return 1;const x=o(i[U],k[U],s);if(x!==0)return x}}e.comparePaths=f;function v(I,E,s){const i=I.toLowerCase(),k=E.toLowerCase(),F=l(I,E,s);if(F)return F;const $=i.endsWith(s),j=k.endsWith(s);if($!==j)return $?-1:1;const W=A(i,k);return W!==0?W:i.localeCompare(k)}e.compareAnything=v;function l(I,E,s){const i=I.toLowerCase(),k=E.toLowerCase(),F=i.startsWith(s),$=k.startsWith(s);if(F!==$)return F?-1:1;if(F&&$){if(i.length<k.length)return-1;if(i.length>k.length)return 1}return 0}e.compareByPrefix=l}),define(Ce[91],De([1,0,10]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},u={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(T){const P=(0,c.extname)(T),m=R[P.toLowerCase()];return m!==void 0?m:L(T)}e.getMediaOrTextMime=O;function L(T){const P=(0,c.extname)(T);return u[P.toLowerCase()]}e.getMediaMime=L;function A(T){for(const P in u)if(u[P]===T)return P}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function g(T,P){const m=y.exec(T);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:P?void 0:T}e.normalizeMimeType=g}),define(Ce[92],De([1,0,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(R||(e.Source=R={}));var u;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(u||(e.TerminateResponseCode=u={}));function O(A,...y){const g=y.reduce((m,D)=>(m[D]=!0,m),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(A).filter(m=>!g[m]).forEach(m=>{for(let D=0;D<T.length;D++)if(m.search(T[D])!==-1){delete A[m];break}})}e.sanitizeProcessEnvironment=O;function L(A){A&&(delete A.DEBUG,c.isMacintosh&&delete A.DYLD_LIBRARY_PATH,c.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=L}),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var R in c)(typeof exports=="object"?exports:re)[R]=c[R]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function c(R){if(e[R])return e[R].exports;var u=e[R]={i:R,l:!1,exports:{}};return re[R].call(u.exports,u,u.exports,c),u.l=!0,u.exports}return c.m=re,c.c=e,c.d=function(R,u,O){c.o(R,u)||Object.defineProperty(R,u,{enumerable:!0,get:O})},c.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},c.t=function(R,u){if(1&u&&(R=c(R)),8&u||4&u&&typeof R=="object"&&R&&R.__esModule)return R;var O=Object.create(null);if(c.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:R}),2&u&&typeof R!="string")for(var L in R)c.d(O,L,function(A){return R[A]}.bind(null,L));return O},c.n=function(R){var u=R&&R.__esModule?function(){return R.default}:function(){return R};return c.d(u,"a",u),u},c.o=function(R,u){return Object.prototype.hasOwnProperty.call(R,u)},c.p="",c(c.s=0)}([function(re,e,c){(function(R){var u;e=re.exports=ye,u=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var he=Array.prototype.slice.call(arguments,0);he.unshift("SEMVER"),console.log.apply(console,he)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],g=0,T=g++;y[T]="0|[1-9]\\d*";var P=g++;y[P]="[0-9]+";var m=g++;y[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=g++;y[D]="("+y[T]+")\\.("+y[T]+")\\.("+y[T]+")";var C=g++;y[C]="("+y[P]+")\\.("+y[P]+")\\.("+y[P]+")";var b=g++;y[b]="(?:"+y[T]+"|"+y[m]+")";var n=g++;y[n]="(?:"+y[P]+"|"+y[m]+")";var h=g++;y[h]="(?:-("+y[b]+"(?:\\."+y[b]+")*))";var d=g++;y[d]="(?:-?("+y[n]+"(?:\\."+y[n]+")*))";var S=g++;y[S]="[0-9A-Za-z-]+";var w=g++;y[w]="(?:\\+("+y[S]+"(?:\\."+y[S]+")*))";var p=g++,t="v?"+y[D]+y[h]+"?"+y[w]+"?";y[p]="^"+t+"$";var a="[v=\\s]*"+y[C]+y[d]+"?"+y[w]+"?",r=g++;y[r]="^"+a+"$";var o=g++;y[o]="((?:<|>)?=?)";var f=g++;y[f]=y[P]+"|x|X|\\*";var v=g++;y[v]=y[T]+"|x|X|\\*";var l=g++;y[l]="[v=\\s]*("+y[v]+")(?:\\.("+y[v]+")(?:\\.("+y[v]+")(?:"+y[h]+")?"+y[w]+"?)?)?";var I=g++;y[I]="[v=\\s]*("+y[f]+")(?:\\.("+y[f]+")(?:\\.("+y[f]+")(?:"+y[d]+")?"+y[w]+"?)?)?";var E=g++;y[E]="^"+y[o]+"\\s*"+y[l]+"$";var s=g++;y[s]="^"+y[o]+"\\s*"+y[I]+"$";var i=g++;y[i]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var k=g++;y[k]="(?:~>?)";var F=g++;y[F]="(\\s*)"+y[k]+"\\s+",A[F]=new RegExp(y[F],"g");var $=g++;y[$]="^"+y[k]+y[l]+"$";var j=g++;y[j]="^"+y[k]+y[I]+"$";var W=g++;y[W]="(?:\\^)";var U=g++;y[U]="(\\s*)"+y[W]+"\\s+",A[U]=new RegExp(y[U],"g");var x=g++;y[x]="^"+y[W]+y[l]+"$";var B=g++;y[B]="^"+y[W]+y[I]+"$";var z=g++;y[z]="^"+y[o]+"\\s*("+a+")$|^$";var ee=g++;y[ee]="^"+y[o]+"\\s*("+t+")$|^$";var se=g++;y[se]="(\\s*)"+y[o]+"\\s*("+a+"|"+y[l]+")",A[se]=new RegExp(y[se],"g");var V=g++;y[V]="^\\s*("+y[l]+")\\s+-\\s+("+y[l]+")\\s*$";var Z=g++;y[Z]="^\\s*("+y[I]+")\\s+-\\s+("+y[I]+")\\s*$";var q=g++;y[q]="(<|>)?=?\\s*\\*";for(var ae=0;ae<35;ae++)u(ae,y[ae]),A[ae]||(A[ae]=new RegExp(y[ae]));function Ee(he,Re){if(he instanceof ye)return he;if(typeof he!="string"||he.length>O||!(Re?A[r]:A[p]).test(he))return null;try{return new ye(he,Re)}catch{return null}}function ye(he,Re){if(he instanceof ye){if(he.loose===Re)return he;he=he.version}else if(typeof he!="string")throw new TypeError("Invalid Version: "+he);if(he.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof ye))return new ye(he,Re);u("SemVer",he,Re),this.loose=Re;var Te=he.trim().match(Re?A[r]:A[p]);if(!Te)throw new TypeError("Invalid Version: "+he);if(this.raw=he,this.major=+Te[1],this.minor=+Te[2],this.patch=+Te[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");Te[4]?this.prerelease=Te[4].split(".").map(function(Ve){if(/^[0-9]+$/.test(Ve)){var xe=+Ve;if(xe>=0&&xe<L)return xe}return Ve}):this.prerelease=[],this.build=Te[5]?Te[5].split("."):[],this.format()}e.parse=Ee,e.valid=function(he,Re){var Te=Ee(he,Re);return Te?Te.version:null},e.clean=function(he,Re){var Te=Ee(he.trim().replace(/^[=v]+/,""),Re);return Te?Te.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(he){return u("SemVer.compare",this.version,this.loose,he),he instanceof ye||(he=new ye(he,this.loose)),this.compareMain(he)||this.comparePre(he)},ye.prototype.compareMain=function(he){return he instanceof ye||(he=new ye(he,this.loose)),M(this.major,he.major)||M(this.minor,he.minor)||M(this.patch,he.patch)},ye.prototype.comparePre=function(he){if(he instanceof ye||(he=new ye(he,this.loose)),this.prerelease.length&&!he.prerelease.length)return-1;if(!this.prerelease.length&&he.prerelease.length)return 1;if(!this.prerelease.length&&!he.prerelease.length)return 0;var Re=0;do{var Te=this.prerelease[Re],Ve=he.prerelease[Re];if(u("prerelease compare",Re,Te,Ve),Te===void 0&&Ve===void 0)return 0;if(Ve===void 0)return 1;if(Te===void 0)return-1;if(Te!==Ve)return M(Te,Ve)}while(++Re)},ye.prototype.inc=function(he,Re){switch(he){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Re),this.inc("pre",Re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Re),this.inc("pre",Re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Te=this.prerelease.length;--Te>=0;)typeof this.prerelease[Te]=="number"&&(this.prerelease[Te]++,Te=-2);Te===-1&&this.prerelease.push(0)}Re&&(this.prerelease[0]===Re?isNaN(this.prerelease[1])&&(this.prerelease=[Re,0]):this.prerelease=[Re,0]);break;default:throw new Error("invalid increment argument: "+he)}return this.format(),this.raw=this.version,this},e.inc=function(he,Re,Te,Ve){typeof Te=="string"&&(Ve=Te,Te=void 0);try{return new ye(he,Te).inc(Re,Ve).version}catch{return null}},e.diff=function(he,Re){if(_(he,Re))return null;var Te=Ee(he),Ve=Ee(Re);if(Te.prerelease.length||Ve.prerelease.length){for(var xe in Te)if((xe==="major"||xe==="minor"||xe==="patch")&&Te[xe]!==Ve[xe])return"pre"+xe;return"prerelease"}for(var xe in Te)if((xe==="major"||xe==="minor"||xe==="patch")&&Te[xe]!==Ve[xe])return xe},e.compareIdentifiers=M;var be=/^[0-9]+$/;function M(he,Re){var Te=be.test(he),Ve=be.test(Re);return Te&&Ve&&(he=+he,Re=+Re),Te&&!Ve?-1:Ve&&!Te?1:he<Re?-1:he>Re?1:0}function Q(he,Re,Te){return new ye(he,Te).compare(new ye(Re,Te))}function fe(he,Re,Te){return Q(he,Re,Te)>0}function we(he,Re,Te){return Q(he,Re,Te)<0}function _(he,Re,Te){return Q(he,Re,Te)===0}function ne(he,Re,Te){return Q(he,Re,Te)!==0}function le(he,Re,Te){return Q(he,Re,Te)>=0}function te(he,Re,Te){return Q(he,Re,Te)<=0}function de(he,Re,Te,Ve){var xe;switch(Re){case"===":typeof he=="object"&&(he=he.version),typeof Te=="object"&&(Te=Te.version),xe=he===Te;break;case"!==":typeof he=="object"&&(he=he.version),typeof Te=="object"&&(Te=Te.version),xe=he!==Te;break;case"":case"=":case"==":xe=_(he,Te,Ve);break;case"!=":xe=ne(he,Te,Ve);break;case">":xe=fe(he,Te,Ve);break;case">=":xe=le(he,Te,Ve);break;case"<":xe=we(he,Te,Ve);break;case"<=":xe=te(he,Te,Ve);break;default:throw new TypeError("Invalid operator: "+Re)}return xe}function oe(he,Re){if(he instanceof oe){if(he.loose===Re)return he;he=he.value}if(!(this instanceof oe))return new oe(he,Re);u("comparator",he,Re),this.loose=Re,this.parse(he),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,u("comp",this)}e.rcompareIdentifiers=function(he,Re){return M(Re,he)},e.major=function(he,Re){return new ye(he,Re).major},e.minor=function(he,Re){return new ye(he,Re).minor},e.patch=function(he,Re){return new ye(he,Re).patch},e.compare=Q,e.compareLoose=function(he,Re){return Q(he,Re,!0)},e.rcompare=function(he,Re,Te){return Q(Re,he,Te)},e.sort=function(he,Re){return he.sort(function(Te,Ve){return e.compare(Te,Ve,Re)})},e.rsort=function(he,Re){return he.sort(function(Te,Ve){return e.rcompare(Te,Ve,Re)})},e.gt=fe,e.lt=we,e.eq=_,e.neq=ne,e.gte=le,e.lte=te,e.cmp=de,e.Comparator=oe;var ue={};function N(he,Re){if(he instanceof N)return he.loose===Re?he:new N(he.raw,Re);if(he instanceof oe)return new N(he.value,Re);if(!(this instanceof N))return new N(he,Re);if(this.loose=Re,this.raw=he,this.set=he.split(/\s*\|\|\s*/).map(function(Te){return this.parseRange(Te.trim())},this).filter(function(Te){return Te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+he);this.format()}function G(he){return!he||he.toLowerCase()==="x"||he==="*"}function Y(he,Re,Te,Ve,xe,tt,Qe,Xe,nt,ot,et,Be,ke){return((Re=G(Te)?"":G(Ve)?">="+Te+".0.0":G(xe)?">="+Te+"."+Ve+".0":">="+Re)+" "+(Xe=G(nt)?"":G(ot)?"<"+(+nt+1)+".0.0":G(et)?"<"+nt+"."+(+ot+1)+".0":Be?"<="+nt+"."+ot+"."+et+"-"+Be:"<="+Xe)).trim()}function ie(he,Re){for(var Te=0;Te<he.length;Te++)if(!he[Te].test(Re))return!1;if(Re.prerelease.length){for(Te=0;Te<he.length;Te++)if(u(he[Te].semver),he[Te].semver!==ue&&he[Te].semver.prerelease.length>0){var Ve=he[Te].semver;if(Ve.major===Re.major&&Ve.minor===Re.minor&&Ve.patch===Re.patch)return!0}return!1}return!0}function pe(he,Re,Te){try{Re=new N(Re,Te)}catch{return!1}return Re.test(he)}function Ie(he,Re,Te,Ve){var xe,tt,Qe,Xe,nt;switch(he=new ye(he,Ve),Re=new N(Re,Ve),Te){case">":xe=fe,tt=te,Qe=we,Xe=">",nt=">=";break;case"<":xe=we,tt=le,Qe=fe,Xe="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(he,Re,Ve))return!1;for(var ot=0;ot<Re.set.length;++ot){var et=Re.set[ot],Be=null,ke=null;if(et.forEach(function(X){X.semver===ue&&(X=new oe(">=0.0.0")),Be=Be||X,ke=ke||X,xe(X.semver,Be.semver,Ve)?Be=X:Qe(X.semver,ke.semver,Ve)&&(ke=X)}),Be.operator===Xe||Be.operator===nt||(!ke.operator||ke.operator===Xe)&&tt(he,ke.semver)||ke.operator===nt&&Qe(he,ke.semver))return!1}return!0}oe.prototype.parse=function(he){var Re=this.loose?A[z]:A[ee],Te=he.match(Re);if(!Te)throw new TypeError("Invalid comparator: "+he);this.operator=Te[1],this.operator==="="&&(this.operator=""),Te[2]?this.semver=new ye(Te[2],this.loose):this.semver=ue},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(he){return u("Comparator.test",he,this.loose),this.semver===ue||(typeof he=="string"&&(he=new ye(he,this.loose)),de(he,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(he,Re){if(!(he instanceof oe))throw new TypeError("a Comparator is required");var Te;if(this.operator==="")return Te=new N(he.value,Re),pe(this.value,Te,Re);if(he.operator==="")return Te=new N(this.value,Re),pe(he.semver,Te,Re);var Ve=!(this.operator!==">="&&this.operator!==">"||he.operator!==">="&&he.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||he.operator!=="<="&&he.operator!=="<"),tt=this.semver.version===he.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||he.operator!==">="&&he.operator!=="<="),Xe=de(this.semver,"<",he.semver,Re)&&(this.operator===">="||this.operator===">")&&(he.operator==="<="||he.operator==="<"),nt=de(this.semver,">",he.semver,Re)&&(this.operator==="<="||this.operator==="<")&&(he.operator===">="||he.operator===">");return Ve||xe||tt&&Qe||Xe||nt},e.Range=N,N.prototype.format=function(){return this.range=this.set.map(function(he){return he.join(" ").trim()}).join("||").trim(),this.range},N.prototype.toString=function(){return this.range},N.prototype.parseRange=function(he){var Re=this.loose;he=he.trim(),u("range",he,Re);var Te=Re?A[Z]:A[V];he=he.replace(Te,Y),u("hyphen replace",he),he=he.replace(A[se],"$1$2$3"),u("comparator trim",he,A[se]),he=(he=(he=he.replace(A[F],"$1~")).replace(A[U],"$1^")).split(/\s+/).join(" ");var Ve=Re?A[z]:A[ee],xe=he.split(" ").map(function(tt){return function(Qe,Xe){return u("comp",Qe),Qe=function(nt,ot){return nt.trim().split(/\s+/).map(function(et){return function(Be,ke){u("caret",Be,ke);var X=ke?A[B]:A[x];return Be.replace(X,function(J,me,Fe,ze,He){var Je;return u("caret",Be,J,me,Fe,ze,He),G(me)?Je="":G(Fe)?Je=">="+me+".0.0 <"+(+me+1)+".0.0":G(ze)?Je=me==="0"?">="+me+"."+Fe+".0 <"+me+"."+(+Fe+1)+".0":">="+me+"."+Fe+".0 <"+(+me+1)+".0.0":He?(u("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Je=me==="0"?Fe==="0"?">="+me+"."+Fe+"."+ze+He+" <"+me+"."+Fe+"."+(+ze+1):">="+me+"."+Fe+"."+ze+He+" <"+me+"."+(+Fe+1)+".0":">="+me+"."+Fe+"."+ze+He+" <"+(+me+1)+".0.0"):(u("no pr"),Je=me==="0"?Fe==="0"?">="+me+"."+Fe+"."+ze+" <"+me+"."+Fe+"."+(+ze+1):">="+me+"."+Fe+"."+ze+" <"+me+"."+(+Fe+1)+".0":">="+me+"."+Fe+"."+ze+" <"+(+me+1)+".0.0"),u("caret return",Je),Je})}(et,ot)}).join(" ")}(Qe,Xe),u("caret",Qe),Qe=function(nt,ot){return nt.trim().split(/\s+/).map(function(et){return function(Be,ke){var X=ke?A[j]:A[$];return Be.replace(X,function(J,me,Fe,ze,He){var Je;return u("tilde",Be,J,me,Fe,ze,He),G(me)?Je="":G(Fe)?Je=">="+me+".0.0 <"+(+me+1)+".0.0":G(ze)?Je=">="+me+"."+Fe+".0 <"+me+"."+(+Fe+1)+".0":He?(u("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Je=">="+me+"."+Fe+"."+ze+He+" <"+me+"."+(+Fe+1)+".0"):Je=">="+me+"."+Fe+"."+ze+" <"+me+"."+(+Fe+1)+".0",u("tilde return",Je),Je})}(et,ot)}).join(" ")}(Qe,Xe),u("tildes",Qe),Qe=function(nt,ot){return u("replaceXRanges",nt,ot),nt.split(/\s+/).map(function(et){return function(Be,ke){Be=Be.trim();var X=ke?A[s]:A[E];return Be.replace(X,function(J,me,Fe,ze,He,Je){u("xRange",Be,J,me,Fe,ze,He,Je);var ct=G(Fe),st=ct||G(ze),ft=st||G(He);return me==="="&&ft&&(me=""),ct?J=me===">"||me==="<"?"<0.0.0":"*":me&&ft?(st&&(ze=0),ft&&(He=0),me===">"?(me=">=",st?(Fe=+Fe+1,ze=0,He=0):ft&&(ze=+ze+1,He=0)):me==="<="&&(me="<",st?Fe=+Fe+1:ze=+ze+1),J=me+Fe+"."+ze+"."+He):st?J=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":ft&&(J=">="+Fe+"."+ze+".0 <"+Fe+"."+(+ze+1)+".0"),u("xRange return",J),J})}(et,ot)}).join(" ")}(Qe,Xe),u("xrange",Qe),Qe=function(nt,ot){return u("replaceStars",nt,ot),nt.trim().replace(A[q],"")}(Qe,Xe),u("stars",Qe),Qe}(tt,Re)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(tt){return!!tt.match(Ve)})),xe=xe.map(function(tt){return new oe(tt,Re)})},N.prototype.intersects=function(he,Re){if(!(he instanceof N))throw new TypeError("a Range is required");return this.set.some(function(Te){return Te.every(function(Ve){return he.set.some(function(xe){return xe.every(function(tt){return Ve.intersects(tt,Re)})})})})},e.toComparators=function(he,Re){return new N(he,Re).set.map(function(Te){return Te.map(function(Ve){return Ve.value}).join(" ").trim().split(" ")})},N.prototype.test=function(he){if(!he)return!1;typeof he=="string"&&(he=new ye(he,this.loose));for(var Re=0;Re<this.set.length;Re++)if(ie(this.set[Re],he))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(he,Re,Te){var Ve=null,xe=null;try{var tt=new N(Re,Te)}catch{return null}return he.forEach(function(Qe){tt.test(Qe)&&(Ve&&xe.compare(Qe)!==-1||(xe=new ye(Ve=Qe,Te)))}),Ve},e.minSatisfying=function(he,Re,Te){var Ve=null,xe=null;try{var tt=new N(Re,Te)}catch{return null}return he.forEach(function(Qe){tt.test(Qe)&&(Ve&&xe.compare(Qe)!==1||(xe=new ye(Ve=Qe,Te)))}),Ve},e.validRange=function(he,Re){try{return new N(he,Re).range||"*"}catch{return null}},e.ltr=function(he,Re,Te){return Ie(he,Re,"<",Te)},e.gtr=function(he,Re,Te){return Ie(he,Re,">",Te)},e.outside=Ie,e.prerelease=function(he,Re){var Te=Ee(he,Re);return Te&&Te.prerelease.length?Te.prerelease:null},e.intersects=function(he,Re,Te){return he=new N(he,Te),Re=new N(Re,Te),he.intersects(Re)},e.coerce=function(he){if(he instanceof ye)return he;if(typeof he!="string")return null;var Re=he.match(A[i]);return Re==null?null:Ee((Re[1]||"0")+"."+(Re[2]||"0")+"."+(Re[3]||"0"))}}).call(this,c(1))},function(re,e){var c,R,u=re.exports={};function O(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function A(n){if(c===setTimeout)return setTimeout(n,0);if((c===O||!c)&&setTimeout)return c=setTimeout,setTimeout(n,0);try{return c(n,0)}catch{try{return c.call(null,n,0)}catch{return c.call(this,n,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:O}catch{c=O}try{R=typeof clearTimeout=="function"?clearTimeout:L}catch{R=L}})();var y,g=[],T=!1,P=-1;function m(){T&&y&&(T=!1,y.length?g=y.concat(g):P=-1,g.length&&D())}function D(){if(!T){var n=A(m);T=!0;for(var h=g.length;h;){for(y=g,g=[];++P<h;)y&&y[P].run();P=-1,h=g.length}y=null,T=!1,function(d){if(R===clearTimeout)return clearTimeout(d);if((R===L||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(d);try{R(d)}catch{try{return R.call(null,d)}catch{return R.call(this,d)}}}(n)}}function C(n,h){this.fun=n,this.array=h}function b(){}u.nextTick=function(n){var h=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)h[d-1]=arguments[d];g.push(new C(n,h)),g.length!==1||T||A(D)},C.prototype.run=function(){this.fun.apply(null,this.array)},u.title="browser",u.browser=!0,u.env={},u.argv=[],u.version="",u.versions={},u.on=b,u.addListener=b,u.once=b,u.off=b,u.removeListener=b,u.removeAllListeners=b,u.emit=b,u.prependListener=b,u.prependOnceListener=b,u.listeners=function(n){return[]},u.binding=function(n){throw new Error("process.binding is not supported")},u.cwd=function(){return"/"},u.chdir=function(n){throw new Error("process.chdir is not supported")},u.umask=function(){return 0}}])}),define(Ce[40],De([1,0,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=c.globals.performance&&typeof c.globals.performance.now=="function";class u{static create(L=!0){return new u(L)}constructor(L){this.a=R&&L,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?c.globals.performance.now():Date.now()}}e.StopWatch=u}),define(Ce[3],De([1,0,8,67,4,68,40]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,y=!1;var g;(function(v){v.None=()=>u.Disposable.None;function l(fe){if(y){const{onDidAddListener:we}=fe,_=C.create();let ne=0;fe.onDidAddListener=()=>{++ne===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),_.print()),we?.()}}}function I(fe,we){return U(fe,()=>{},0,void 0,!0,void 0,we)}v.defer=I;function E(fe){return(we,_=null,ne)=>{let le=!1,te;return te=fe(de=>{if(!le)return te?te.dispose():le=!0,we.call(_,de)},null,ne),le&&te.dispose(),te}}v.once=E;function s(fe,we,_){return W((ne,le=null,te)=>fe(de=>ne.call(le,we(de)),null,te),_)}v.map=s;function i(fe,we,_){return W((ne,le=null,te)=>fe(de=>{we(de),ne.call(le,de)},null,te),_)}v.forEach=i;function k(fe,we,_){return W((ne,le=null,te)=>fe(de=>we(de)&&ne.call(le,de),null,te),_)}v.filter=k;function F(fe){return fe}v.signal=F;function $(...fe){return(we,_=null,ne)=>(0,u.combinedDisposable)(...fe.map(le=>le(te=>we.call(_,te),null,ne)))}v.any=$;function j(fe,we,_,ne){let le=_;return s(fe,te=>(le=we(le,te),le),ne)}v.reduce=j;function W(fe,we){let _;const ne={onWillAddFirstListener(){_=fe(le.fire,le)},onDidRemoveLastListener(){_?.dispose()}};we||l(ne);const le=new n(ne);return we?.add(le),le.event}function U(fe,we,_=100,ne=!1,le=!1,te,de){let oe,ue,N,G=0,Y;const ie={leakWarningThreshold:te,onWillAddFirstListener(){oe=fe(Ie=>{G++,ue=we(ue,Ie),ne&&!N&&(pe.fire(ue),ue=void 0),Y=()=>{const he=ue;ue=void 0,N=void 0,(!ne||G>1)&&pe.fire(he),G=0},typeof _=="number"?(clearTimeout(N),N=setTimeout(Y,_)):N===void 0&&(N=0,queueMicrotask(Y))})},onWillRemoveListener(){le&&G>0&&Y?.()},onDidRemoveLastListener(){Y=void 0,oe.dispose()}};de||l(ie);const pe=new n(ie);return de?.add(pe),pe.event}v.debounce=U;function x(fe,we=0,_){return v.debounce(fe,(ne,le)=>ne?(ne.push(le),ne):[le],we,void 0,!0,void 0,_)}v.accumulate=x;function B(fe,we=(ne,le)=>ne===le,_){let ne=!0,le;return k(fe,te=>{const de=ne||!we(te,le);return ne=!1,le=te,de},_)}v.latch=B;function z(fe,we,_){return[v.filter(fe,we,_),v.filter(fe,ne=>!we(ne),_)]}v.split=z;function ee(fe,we=!1,_=[]){let ne=_.slice(),le=fe(oe=>{ne?ne.push(oe):de.fire(oe)});const te=()=>{ne?.forEach(oe=>de.fire(oe)),ne=null},de=new n({onWillAddFirstListener(){le||(le=fe(oe=>de.fire(oe)))},onDidAddFirstListener(){ne&&(we?setTimeout(te):te())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return de.event}v.buffer=ee;class se{constructor(we){this.event=we,this.c=new u.DisposableStore}map(we){return new se(s(this.event,we,this.c))}forEach(we){return new se(i(this.event,we,this.c))}filter(we){return new se(k(this.event,we,this.c))}reduce(we,_){return new se(j(this.event,we,_,this.c))}latch(){return new se(B(this.event,void 0,this.c))}debounce(we,_=100,ne=!1,le=!1,te){return new se(U(this.event,we,_,ne,le,te,this.c))}on(we,_,ne){return this.event(we,_,ne)}once(we,_,ne){return E(this.event)(we,_,ne)}dispose(){this.c.dispose()}}function V(fe){return new se(fe)}v.chain=V;function Z(fe,we,_=ne=>ne){const ne=(...oe)=>de.fire(_(...oe)),le=()=>fe.on(we,ne),te=()=>fe.removeListener(we,ne),de=new n({onWillAddFirstListener:le,onDidRemoveLastListener:te});return de.event}v.fromNodeEventEmitter=Z;function q(fe,we,_=ne=>ne){const ne=(...oe)=>de.fire(_(...oe)),le=()=>fe.addEventListener(we,ne),te=()=>fe.removeEventListener(we,ne),de=new n({onWillAddFirstListener:le,onDidRemoveLastListener:te});return de.event}v.fromDOMEventEmitter=q;function ae(fe){return new Promise(we=>E(fe)(we))}v.toPromise=ae;function Ee(fe,we){return we(void 0),fe(_=>we(_))}v.runAndSubscribe=Ee;function ye(fe,we){let _=null;function ne(te){_?.dispose(),_=new u.DisposableStore,we(te,_)}ne(void 0);const le=fe(te=>ne(te));return(0,u.toDisposable)(()=>{le.dispose(),_?.dispose()})}v.runAndSubscribeWithStore=ye;class be{constructor(we,_){this._observable=we,this.c=0,this.d=!1;const ne={onWillAddFirstListener:()=>{we.addObserver(this)},onDidRemoveLastListener:()=>{we.removeObserver(this)}};_||l(ne),this.emitter=new n(ne),_&&_.add(this.emitter)}beginUpdate(we){this.c++}handlePossibleChange(we){}handleChange(we,_){this.d=!0}endUpdate(we){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function M(fe,we){return new be(fe,we).emitter.event}v.fromObservable=M;function Q(fe){return we=>{let _=0,ne=!1;const le={beginUpdate(){_++},endUpdate(){_--,_===0&&(fe.reportChanges(),ne&&(ne=!1,we()))},handlePossibleChange(){},handleChange(){ne=!0}};return fe.addObserver(le),{dispose(){fe.removeObserver(le)}}}}v.fromObservableLight=Q})(g||(e.Event=g={}));class T{constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${T.c++}`,T.all.add(this)}start(l){this.d=new L.StopWatch(!0),this.listenerCount=l}stop(){if(this.d){const l=this.d.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=T,T.all=new Set,T.c=0;let P=-1;function m(v){const l=P;return P=v,{dispose(){P=l}}}e.setGlobalLeakWarningThreshold=m;class D{constructor(l,I=Math.random().toString(18).slice(2,5)){this.threshold=l,this.name=I,this.d=0}dispose(){this.c?.clear()}check(l,I){const E=this.threshold;if(E<=0||I<E)return;this.c||(this.c=new Map);const s=this.c.get(l.value)||0;if(this.c.set(l.value,s+1),this.d-=1,this.d<=0){this.d=E*.5;let i,k=0;for(const[F,$]of this.c)(!i||k<$)&&(i=F,k=$);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${k}):`),console.warn(i)}return()=>{const i=this.c.get(l.value)||0;this.c.set(l.value,i-1)}}}class C{static create(){return new C(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(l,I,E){this.callback=l,this.callbackThis=I,this.stack=E,this.subscription=new u.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class n{constructor(l){this.j=!1,this.d=l,this.f=P>0||this.d?.leakWarningThreshold?new D(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new T(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const l=Array.from(this.q);queueMicrotask(()=>{for(const I of l)I.subscription.isset()&&(I.subscription.unset(),I.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(l,I,E)=>{if(this.q||(this.q=new O.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),u.Disposable.None;const s=this.q.isEmpty();s&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let i,k;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(k=C.create(),i=this.f.check(k,this.q.size+1)),A&&(k=k??C.create());const F=new b(l,I,k),$=this.q.push(F);s&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,l,I);const j=F.subscription.set(()=>{i?.(),this.j||(this.d?.onWillRemoveListener?.(this),$(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return E instanceof u.DisposableStore?E.add(j):Array.isArray(E)&&E.push(j),j}),this.l}fire(l){if(this.q){this.m||(this.m=new d(this.d?.onListenerError));for(const I of this.q)this.m.push(this,I,l);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=n;class h{constructor(l=c.onUnexpectedError){this.d=l,this.c=new O.LinkedList}get size(){return this.c.size}push(l,I,E){this.c.push(new S(l,I,E))}clear(l){const I=new O.LinkedList;for(const E of this.c)E.emitter!==l&&I.push(E);this.c=I}deliver(){for(;this.c.size>0;){const l=this.c.shift();try{l.listener.invoke(l.event)}catch(I){this.d(I)}}}}e.EventDeliveryQueue=h;class d extends h{clear(l){this.c.clear()}}class S{constructor(l,I,E){this.emitter=l,this.listener=I,this.event=E}}class w extends n{async fireAsync(l,I,E){if(this.q){this.c||(this.c=new O.LinkedList);for(const s of this.q)this.c.push([s,l]);for(;this.c.size>0&&!I.isCancellationRequested;){const[s,i]=this.c.shift(),k=[],F={...i,token:I,waitUntil:$=>{if(Object.isFrozen(k))throw new Error("waitUntil can NOT be called asynchronous");E&&($=E($,s.callback)),k.push($)}};try{s.invoke(F)}catch($){(0,c.onUnexpectedError)($);continue}Object.freeze(k),await Promise.allSettled(k).then($=>{for(const j of $)j.status==="rejected"&&(0,c.onUnexpectedError)(j.reason)})}}}}e.AsyncEmitter=w;class p extends n{get isPaused(){return this.h!==0}constructor(l){super(l),this.h=0,this.s=new O.LinkedList,this.t=l?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const l=Array.from(this.s);this.s.clear(),super.fire(this.t(l))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(l){this.q&&(this.h!==0?this.s.push(l):super.fire(l))}}e.PauseableEmitter=p;class t extends p{constructor(l){super(l),this.c=l.delay??100}fire(l){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(l)}}e.DebounceEmitter=t;class a extends n{constructor(l){super(l),this.c=[],this.h=l?.merge}fire(l){this.hasListeners()&&(this.c.push(l),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(I=>super.fire(I)),this.c=[]}))}}e.MicrotaskEmitter=a;class r{constructor(){this.d=!1,this.f=[],this.c=new n({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(l){const I={event:l,listener:null};this.f.push(I),this.d&&this.j(I);const E=()=>{this.d&&this.k(I);const s=this.f.indexOf(I);this.f.splice(s,1)};return(0,u.toDisposable)((0,R.once)(E))}g(){this.d=!0,this.f.forEach(l=>this.j(l))}h(){this.d=!1,this.f.forEach(l=>this.k(l))}j(l){l.listener=l.event(I=>this.c.fire(I))}k(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class o{constructor(){this.c=[]}wrapEvent(l){return(I,E,s)=>l(i=>{const k=this.c[this.c.length-1];k?k.push(()=>I.call(E,i)):I.call(E,i)},void 0,s)}bufferEvents(l){const I=[];this.c.push(I);const E=l();return this.c.pop(),I.forEach(s=>s()),E}}e.EventBufferer=o;class f{constructor(){this.c=!1,this.d=g.None,this.f=u.Disposable.None,this.g=new n({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(l){this.d=l,this.c&&(this.f.dispose(),this.f=l(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=f}),define(Ce[21],De([1,0,3]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(A,y){const g=setTimeout(A.bind(y),0);return{dispose(){clearTimeout(g)}}});var u;(function(A){function y(g){return g===A.None||g===A.Cancelled||g instanceof O?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}A.isCancellationToken=y,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(u||(e.CancellationToken=u={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new c.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(y){this.a=void 0,this.b=void 0,this.b=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new O),this.a}cancel(){this.a?this.a instanceof O&&this.a.cancel():this.a=u.Cancelled}dispose(y=!1){y&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof O&&this.a.dispose():this.a=u.None}}e.CancellationTokenSource=L}),define(Ce[153],De([1,0,21]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class R{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new c.CancellationTokenSource,y=this.b(A.token);return this.a={promise:y,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=R;class u{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const y=JSON.stringify(A);return this.b!==y&&(this.b=y,this.a=this.c(A)),this.a}}e.LRUCachedFunction=u;class O{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const y=this.b(A);return this.a.set(A,y),y}}e.CachedFunction=O}),define(Ce[93],De([1,0,8,4]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function u(w){const p=w;return p?typeof p.read=="function":!1}e.isReadable=u;function O(w){const p=w;return p?[p.on,p.pause,p.resume,p.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=O;function L(w){const p=w;return p?O(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=L;function A(w,p){return new y(w,p)}e.newWriteableStream=A;class y{constructor(p,t){this.e=p,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(t=>t(p))}h(p){this.c.error.length===0?(0,c.onUnexpectedError)(p):this.c.error.slice(0).forEach(t=>t(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,t){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(p,t){if(this.a.destroyed)return;let a;switch(p){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const r=a.indexOf(t);r>=0&&a.splice(r,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(w,p){const t=[];let a;for(;(a=w.read())!==null;)t.push(a);return p(t)}e.consumeReadable=g;function T(w,p,t){const a=[];let r;for(;(r=w.read())!==null&&a.length<t;)a.push(r);return r===null&&a.length>0?p(a):{read:()=>{if(a.length>0)return a.shift();if(typeof r<"u"){const o=r;return r=void 0,o}return w.read()}}}e.peekReadable=T;function P(w,p){return new Promise((t,a)=>{const r=[];m(w,{onData:o=>{p&&r.push(o)},onError:o=>{p?a(o):t(void 0)},onEnd:()=>{t(p?p(r):void 0)}})})}e.consumeStream=P;function m(w,p){let t=!1;return w.on("error",a=>{t||p.onError(a)}),w.on("end",()=>{t||p.onEnd()}),w.on("data",a=>{t||p.onData(a)}),(0,R.toDisposable)(()=>t=!0)}e.listenStream=m;function D(w,p){return new Promise((t,a)=>{const r=new R.DisposableStore,o=[],f=I=>{if(o.push(I),o.length>p)return r.dispose(),w.pause(),t({stream:w,buffer:o,ended:!1})},v=I=>a(I),l=()=>t({stream:w,buffer:o,ended:!0});r.add((0,R.toDisposable)(()=>w.removeListener("error",v))),w.on("error",v),r.add((0,R.toDisposable)(()=>w.removeListener("end",l))),w.on("end",l),r.add((0,R.toDisposable)(()=>w.removeListener("data",f))),w.on("data",f)})}e.peekStream=D;function C(w,p){const t=A(p);return t.end(w),t}e.toStream=C;function b(){const w=A(()=>{throw new Error("not supported")});return w.end(),w}e.emptyStream=b;function n(w){let p=!1;return{read:()=>p?null:(p=!0,w)}}e.toReadable=n;function h(w,p,t){const a=A(t);return m(w,{onData:r=>a.write(p.data(r)),onError:r=>a.error(p.error?p.error(r):r),onEnd:()=>a.end()}),a}e.transform=h;function d(w,p,t){let a=!1;return{read:()=>{const r=p.read();return a?r:(a=!0,r!==null?t([w,r]):w)}}}e.prefixedReadable=d;function S(w,p,t){let a=!1;const r=A(t);return m(p,{onData:o=>a?r.write(o):(a=!0,r.write(t([w,o]))),onError:o=>r.error(o),onEnd:()=>{a||(a=!0,r.write(w)),r.end()}}),r}e.prefixedStream=S}),define(Ce[22],De([1,0,54,93]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const u=typeof Buffer<"u",O=new c.Lazy(()=>new Uint8Array(256));let L,A;class y{static alloc(s){return u?new y(Buffer.allocUnsafe(s)):new y(new Uint8Array(s))}static wrap(s){return u&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new y(s)}static fromString(s,i){return!(i?.dontUseNodeBuffer||!1)&&u?new y(Buffer.from(s)):(L||(L=new TextEncoder),new y(L.encode(s)))}static fromByteArray(s){const i=y.alloc(s.length);for(let k=0,F=s.length;k<F;k++)i.buffer[k]=s[k];return i}static concat(s,i){if(typeof i>"u"){i=0;for(let $=0,j=s.length;$<j;$++)i+=s[$].byteLength}const k=y.alloc(i);let F=0;for(let $=0,j=s.length;$<j;$++){const W=s[$];k.set(W,F),F+=W.byteLength}return k}constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}clone(){const s=y.alloc(this.byteLength);return s.set(this),s}toString(){return u?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(s,i){return new y(this.buffer.subarray(s,i))}set(s,i){if(s instanceof y)this.buffer.set(s.buffer,i);else if(s instanceof Uint8Array)this.buffer.set(s,i);else if(s instanceof ArrayBuffer)this.buffer.set(new Uint8Array(s),i);else if(ArrayBuffer.isView(s))this.buffer.set(new Uint8Array(s.buffer,s.byteOffset,s.byteLength),i);else throw new Error("Unknown argument 'array'")}readUInt32BE(s){return P(this.buffer,s)}writeUInt32BE(s,i){m(this.buffer,s,i)}readUInt32LE(s){return D(this.buffer,s)}writeUInt32LE(s,i){C(this.buffer,s,i)}readUInt8(s){return b(this.buffer,s)}writeUInt8(s,i){n(this.buffer,s,i)}indexOf(s){const i=s instanceof y?s.buffer:s,k=i.byteLength,F=this.buffer,$=F.byteLength;if(k===0)return 0;if(k===1)return F.indexOf(i[0]);if(k>$)return-1;const j=O.value;j.fill(i.length);for(let B=0;B<i.length;B++)j[i[B]]=i.length-B-1;let W=i.length-1,U=W,x=-1;for(;W<$;)if(F[W]===i[U]){if(U===0){x=W;break}W--,U--}else W+=Math.max(i.length-U,j[F[W]]),U=i.length-1;return x}}e.VSBuffer=y;function g(E,s){return E[s+0]<<0>>>0|E[s+1]<<8>>>0}e.readUInt16LE=g;function T(E,s,i){E[i+0]=s&255,s=s>>>8,E[i+1]=s&255}e.writeUInt16LE=T;function P(E,s){return E[s]*2**24+E[s+1]*2**16+E[s+2]*2**8+E[s+3]}e.readUInt32BE=P;function m(E,s,i){E[i+3]=s,s=s>>>8,E[i+2]=s,s=s>>>8,E[i+1]=s,s=s>>>8,E[i]=s}e.writeUInt32BE=m;function D(E,s){return E[s+0]<<0>>>0|E[s+1]<<8>>>0|E[s+2]<<16>>>0|E[s+3]<<24>>>0}e.readUInt32LE=D;function C(E,s,i){E[i+0]=s&255,s=s>>>8,E[i+1]=s&255,s=s>>>8,E[i+2]=s&255,s=s>>>8,E[i+3]=s&255}e.writeUInt32LE=C;function b(E,s){return E[s]}e.readUInt8=b;function n(E,s,i){E[i]=s}e.writeUInt8=n;function h(E){return R.consumeReadable(E,s=>y.concat(s))}e.readableToBuffer=h;function d(E){return R.toReadable(E)}e.bufferToReadable=d;function S(E){return R.consumeStream(E,s=>y.concat(s))}e.streamToBuffer=S;async function w(E){return E.ended?y.concat(E.buffer):y.concat([...E.buffer,await S(E.stream)])}e.bufferedStreamToBuffer=w;function p(E){return R.toStream(E,s=>y.concat(s))}e.bufferToStream=p;function t(E){return R.transform(E,{data:s=>typeof s=="string"?y.fromString(s):y.wrap(s)},s=>y.concat(s))}e.streamToBufferReadableStream=t;function a(E){return R.newWriteableStream(s=>y.concat(s),E)}e.newWriteableBufferStream=a;function r(E,s){return R.prefixedReadable(E,s,i=>y.concat(i))}e.prefixedBufferReadable=r;function o(E,s){return R.prefixedStream(E,s,i=>y.concat(i))}e.prefixedBufferStream=o;function f(E){let s=0,i=0,k=0;const F=new Uint8Array(Math.floor(E.length/4*3)),$=W=>{switch(i){case 3:F[k++]=s|W,i=0;break;case 2:F[k++]=s|W>>>2,s=W<<6,i=3;break;case 1:F[k++]=s|W>>>4,s=W<<4,i=2;break;default:s=W<<2,i=1}};for(let W=0;W<E.length;W++){const U=E.charCodeAt(W);if(U>=65&&U<=90)$(U-65);else if(U>=97&&U<=122)$(U-97+26);else if(U>=48&&U<=57)$(U-48+52);else if(U===43||U===45)$(62);else if(U===47||U===95)$(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${E[W]}`)}}const j=k;for(;i>0;)$(0);return y.wrap(F).slice(0,j)}e.decodeBase64=f;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:E},s=!0,i=!1){const k=i?l:v;let F="";const $=E.byteLength%3;let j=0;for(;j<E.byteLength-$;j+=3){const W=E[j+0],U=E[j+1],x=E[j+2];F+=k[W>>>2],F+=k[(W<<4|U>>>4)&63],F+=k[(U<<2|x>>>6)&63],F+=k[x&63]}if($===1){const W=E[j+0];F+=k[W>>>2],F+=k[W<<4&63],s&&(F+="==")}else if($===2){const W=E[j+0],U=E[j+1];F+=k[W>>>2],F+=k[(W<<4|U>>>4)&63],F+=k[U<<2&63],s&&(F+="=")}return F}e.encodeBase64=I}),define(Ce[11],De([1,0,153,54]),function(re,e,c,R){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function O(ke){return!ke||typeof ke!="string"?!0:ke.trim().length===0}e.isFalsyOrWhitespace=O;const L=/{(\d+)}/g;function A(ke,...X){return X.length===0?ke:ke.replace(L,function(J,me){const Fe=parseInt(me,10);return isNaN(Fe)||Fe<0||Fe>=X.length?J:X[Fe]})}e.format=A;const y=/{([^}]+)}/g;function g(ke,X){return ke.replace(y,(J,me)=>X[me]??J)}e.format2=g;function T(ke){return ke.replace(/[<>&]/g,function(X){switch(X){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return X}})}e.escape=T;function P(ke){return ke.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function m(ke,X){let J=0;const me=X.charCodeAt(0);for(let Fe=ke.length-1;Fe>=0;Fe--)ke.charCodeAt(Fe)===me&&J++;return J}e.count=m;function D(ke,X,J="\u2026"){return ke.length<=X?ke:`${ke.substr(0,X)}${J}`}e.truncate=D;function C(ke,X=" "){const J=b(ke,X);return n(J,X)}e.trim=C;function b(ke,X){if(!ke||!X)return ke;const J=X.length;if(J===0||ke.length===0)return ke;let me=0;for(;ke.indexOf(X,me)===me;)me=me+J;return ke.substring(me)}e.ltrim=b;function n(ke,X){if(!ke||!X)return ke;const J=X.length,me=ke.length;if(J===0||me===0)return ke;let Fe=me,ze=-1;for(;ze=ke.lastIndexOf(X,Fe-1),!(ze===-1||ze+J!==Fe);){if(ze===0)return"";Fe=ze}return ke.substring(0,Fe)}e.rtrim=n;function h(ke){return ke.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function d(ke){return ke.replace(/\*/g,"")}e.stripWildcards=d;function S(ke,X,J={}){if(!ke)throw new Error("Cannot create regex from empty string");X||(ke=P(ke)),J.wholeWord&&(/\B/.test(ke.charAt(0))||(ke="\\b"+ke),/\B/.test(ke.charAt(ke.length-1))||(ke=ke+"\\b"));let me="";return J.global&&(me+="g"),J.matchCase||(me+="i"),J.multiline&&(me+="m"),J.unicode&&(me+="u"),new RegExp(ke,me)}e.createRegExp=S;function w(ke){return ke.source==="^"||ke.source==="^$"||ke.source==="$"||ke.source==="^\\s*$"?!1:!!(ke.exec("")&&ke.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function p(ke){return!!ke.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function t(ke){return(ke.global?"g":"")+(ke.ignoreCase?"i":"")+(ke.multiline?"m":"")+(ke.unicode?"u":"")}e.regExpFlags=t;function a(ke){return ke.split(/\r\n|\r|\n/)}e.splitLines=a;function r(ke){for(let X=0,J=ke.length;X<J;X++){const me=ke.charCodeAt(X);if(me!==32&&me!==9)return X}return-1}e.firstNonWhitespaceIndex=r;function o(ke,X=0,J=ke.length){for(let me=X;me<J;me++){const Fe=ke.charCodeAt(me);if(Fe!==32&&Fe!==9)return ke.substring(X,me)}return ke.substring(X,J)}e.getLeadingWhitespace=o;function f(ke,X=ke.length-1){for(let J=X;J>=0;J--){const me=ke.charCodeAt(J);if(me!==32&&me!==9)return J}return-1}e.lastNonWhitespaceIndex=f;function v(ke,X,J){const me=[];let Fe=0;for(const ze of ke.matchAll(X)){if(me.push(ke.slice(Fe,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Fe=ze.index+ze[0].length,me.push(J(ze[0],...ze.slice(1),ze.index,ke,ze.groups))}return me.push(ke.slice(Fe)),Promise.all(me).then(ze=>ze.join(""))}e.replaceAsync=v;function l(ke,X){return ke<X?-1:ke>X?1:0}e.compare=l;function I(ke,X,J=0,me=ke.length,Fe=0,ze=X.length){for(;J<me&&Fe<ze;J++,Fe++){const ct=ke.charCodeAt(J),st=X.charCodeAt(Fe);if(ct<st)return-1;if(ct>st)return 1}const He=me-J,Je=ze-Fe;return He<Je?-1:He>Je?1:0}e.compareSubstring=I;function E(ke,X){return s(ke,X,0,ke.length,0,X.length)}e.compareIgnoreCase=E;function s(ke,X,J=0,me=ke.length,Fe=0,ze=X.length){for(;J<me&&Fe<ze;J++,Fe++){let ct=ke.charCodeAt(J),st=X.charCodeAt(Fe);if(ct===st)continue;if(ct>=128||st>=128)return I(ke.toLowerCase(),X.toLowerCase(),J,me,Fe,ze);k(ct)&&(ct-=32),k(st)&&(st-=32);const ft=ct-st;if(ft!==0)return ft}const He=me-J,Je=ze-Fe;return He<Je?-1:He>Je?1:0}e.compareSubstringIgnoreCase=s;function i(ke){return ke>=48&&ke<=57}e.isAsciiDigit=i;function k(ke){return ke>=97&&ke<=122}e.isLowerAsciiLetter=k;function F(ke){return ke>=65&&ke<=90}e.isUpperAsciiLetter=F;function $(ke,X){return ke.length===X.length&&s(ke,X)===0}e.equalsIgnoreCase=$;function j(ke,X){const J=X.length;return X.length>ke.length?!1:s(ke,X,0,J)===0}e.startsWithIgnoreCase=j;function W(ke,X){const J=Math.min(ke.length,X.length);let me;for(me=0;me<J;me++)if(ke.charCodeAt(me)!==X.charCodeAt(me))return me;return J}e.commonPrefixLength=W;function U(ke,X){const J=Math.min(ke.length,X.length);let me;const Fe=ke.length-1,ze=X.length-1;for(me=0;me<J;me++)if(ke.charCodeAt(Fe-me)!==X.charCodeAt(ze-me))return me;return J}e.commonSuffixLength=U;function x(ke){return 55296<=ke&&ke<=56319}e.isHighSurrogate=x;function B(ke){return 56320<=ke&&ke<=57343}e.isLowSurrogate=B;function z(ke,X){return(ke-55296<<10)+(X-56320)+65536}e.computeCodePoint=z;function ee(ke,X,J){const me=ke.charCodeAt(J);if(x(me)&&J+1<X){const Fe=ke.charCodeAt(J+1);if(B(Fe))return z(me,Fe)}return me}e.getNextCodePoint=ee;function se(ke,X){const J=ke.charCodeAt(X-1);if(B(J)&&X>1){const me=ke.charCodeAt(X-2);if(x(me))return z(me,J)}return J}class V{get offset(){return this.e}constructor(X,J=0){this.c=X,this.d=X.length,this.e=J}setOffset(X){this.e=X}prevCodePoint(){const X=se(this.c,this.e);return this.e-=X>=65536?2:1,X}nextCodePoint(){const X=ee(this.c,this.d,this.e);return this.e+=X>=65536?2:1,X}eol(){return this.e>=this.d}}e.CodePointIterator=V;class Z{get offset(){return this.c.offset}constructor(X,J=0){this.c=new V(X,J)}nextGraphemeLength(){const X=xe.getInstance(),J=this.c,me=J.offset;let Fe=X.getGraphemeBreakType(J.nextCodePoint());for(;!J.eol();){const ze=J.offset,He=X.getGraphemeBreakType(J.nextCodePoint());if(Te(Fe,He)){J.setOffset(ze);break}Fe=He}return J.offset-me}prevGraphemeLength(){const X=xe.getInstance(),J=this.c,me=J.offset;let Fe=X.getGraphemeBreakType(J.prevCodePoint());for(;J.offset>0;){const ze=J.offset,He=X.getGraphemeBreakType(J.prevCodePoint());if(Te(He,Fe)){J.setOffset(ze);break}Fe=He}return me-J.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Z;function q(ke,X){return new Z(ke,X).nextGraphemeLength()}e.nextCharLength=q;function ae(ke,X){return new Z(ke,X).prevGraphemeLength()}e.prevCharLength=ae;function Ee(ke,X){X>0&&B(ke.charCodeAt(X))&&X--;const J=X+q(ke,X);return[J-ae(ke,J),J]}e.getCharContainingOffset=Ee;function ye(ke){const X=new Z(ke);let J=0;for(;!X.eol();)J++,X.nextGraphemeLength();return J}e.charCount=ye;let be;function M(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Q(ke){return be||(be=M()),be.test(ke)}e.containsRTL=Q;const fe=/^[\t\n\r\x20-\x7E]*$/;function we(ke){return fe.test(ke)}e.isBasicASCII=we,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _(ke){return e.UNUSUAL_LINE_TERMINATORS.test(ke)}e.containsUnusualLineTerminators=_;function ne(ke){return ke>=11904&&ke<=55215||ke>=63744&&ke<=64255||ke>=65281&&ke<=65374}e.isFullWidthCharacter=ne;function le(ke){return ke>=127462&&ke<=127487||ke===8986||ke===8987||ke===9200||ke===9203||ke>=9728&&ke<=10175||ke===11088||ke===11093||ke>=127744&&ke<=128591||ke>=128640&&ke<=128764||ke>=128992&&ke<=129008||ke>=129280&&ke<=129535||ke>=129648&&ke<=129782}e.isEmojiImprecise=le;function te(ke,X){if(ke.length<X)return ke;const J=/\b/g;let me=0;for(;J.test(ke)&&!(ke.length-J.lastIndex<X);)me=J.lastIndex,J.lastIndex+=1;return ke.substring(me).replace(/^\s/,"")}e.lcut=te;const de=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,oe=/\x1b\].*?\x07/g;function ue(ke){return ke&&(ke=ke.replace(de,"").replace(oe,"")),ke}e.removeAnsiEscapeCodes=ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function N(ke){return!!(ke&&ke.length>0&&ke.charCodeAt(0)===65279)}e.startsWithUTF8BOM=N;function G(ke){return N(ke)?ke.substr(1):ke}e.stripUTF8BOM=G;function Y(ke,X){if(!ke||!X||ke.length<X.length)return!1;const J=X.length,me=ke.toLowerCase();let Fe=0,ze=-1;for(;Fe<J;){const He=me.indexOf(X[Fe],ze+1);if(He<0)return!1;ze=He,Fe++}return!0}e.fuzzyContains=Y;function ie(ke,X=!1){return ke?(X&&(ke=ke.replace(/\\./g,"")),ke.toLowerCase()!==ke):!1}e.containsUppercaseCharacter=ie;function pe(ke){return ke.charAt(0).toUpperCase()+ke.slice(1)}e.uppercaseFirstLetter=pe;function Ie(ke,X=1){if(X===0)return"";let J=-1;do J=ke.indexOf(`
`,J+1),X--;while(X>0&&J>=0);return J===-1?ke:(ke[J-1]==="\r"&&J--,ke.substr(0,J))}e.getNLines=Ie;function he(ke){return ke=ke%(2*26),ke<26?String.fromCharCode(97+ke):String.fromCharCode(65+ke-26)}e.singleLetterHash=he;function Re(ke){return xe.getInstance().getGraphemeBreakType(ke)}e.getGraphemeBreakType=Re;function Te(ke,X){return ke===0?X!==5&&X!==7:ke===2&&X===3?!1:ke===4||ke===2||ke===3||X===4||X===2||X===3?!0:!(ke===8&&(X===8||X===9||X===11||X===12)||(ke===11||ke===9)&&(X===9||X===10)||(ke===12||ke===10)&&X===10||X===5||X===13||X===7||ke===1||ke===13&&X===14||ke===6&&X===6)}var Ve;(function(ke){ke[ke.Other=0]="Other",ke[ke.Prepend=1]="Prepend",ke[ke.CR=2]="CR",ke[ke.LF=3]="LF",ke[ke.Control=4]="Control",ke[ke.Extend=5]="Extend",ke[ke.Regional_Indicator=6]="Regional_Indicator",ke[ke.SpacingMark=7]="SpacingMark",ke[ke.L=8]="L",ke[ke.V=9]="V",ke[ke.T=10]="T",ke[ke.LV=11]="LV",ke[ke.LVT=12]="LVT",ke[ke.ZWJ=13]="ZWJ",ke[ke.Extended_Pictographic=14]="Extended_Pictographic"})(Ve||(e.GraphemeBreakType=Ve={}));class xe{static getInstance(){return xe.c||(xe.c=new xe),xe.c}constructor(){this.d=tt()}getGraphemeBreakType(X){if(X<32)return X===10?3:X===13?2:4;if(X<127)return 0;const J=this.d,me=J.length/3;let Fe=1;for(;Fe<=me;)if(X<J[3*Fe])Fe=2*Fe;else if(X>J[3*Fe+1])Fe=2*Fe+1;else return J[3*Fe+2];return 0}}xe.c=null;function tt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(ke,X){if(ke===0)return 0;const J=Xe(ke,X);if(J!==void 0)return J;const me=new V(X,ke);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Qe;function Xe(ke,X){const J=new V(X,ke);let me=J.prevCodePoint();for(;nt(me)||me===65039||me===8419;){if(J.offset===0)return;me=J.prevCodePoint()}if(!le(me))return;let Fe=J.offset;return Fe>0&&J.prevCodePoint()===8205&&(Fe=J.offset),Fe}function nt(ke){return 127995<=ke&&ke<=127999}var ot;(function(ke){ke[ke.zwj=8205]="zwj",ke[ke.emojiVariantSelector=65039]="emojiVariantSelector",ke[ke.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={})),e.noBreakWhitespace="\xA0";class et{static getInstance(X){return et.d.get(Array.from(X))}static getLocales(){return et.e.value}constructor(X){this.f=X}isAmbiguous(X){return this.f.has(X)}getPrimaryConfusable(X){return this.f.get(X)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=et,u=et,et.c=new R.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),et.d=new c.LRUCachedFunction(ke=>{function X(st){const ft=new Map;for(let Pt=0;Pt<st.length;Pt+=2)ft.set(st[Pt],st[Pt+1]);return ft}function J(st,ft){const Pt=new Map(st);for(const[Tt,vt]of ft)Pt.set(Tt,vt);return Pt}function me(st,ft){if(!st)return ft;const Pt=new Map;for(const[Tt,vt]of st)ft.has(Tt)&&Pt.set(Tt,vt);return Pt}const Fe=u.c.value;let ze=ke.filter(st=>!st.startsWith("_")&&st in Fe);ze.length===0&&(ze=["_default"]);let He;for(const st of ze){const ft=X(Fe[st]);He=me(He,ft)}const Je=X(Fe._common),ct=J(Je,He);return new et(ct)}),et.e=new R.Lazy(()=>Object.keys(et.c.value).filter(ke=>!ke.startsWith("_")));class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(X){return Be.e().has(X)}static get codePoints(){return Be.e()}}e.InvisibleCharacters=Be,Be.d=void 0}),define(Ce[113],De([1,0,28,11]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function u(...oe){return function(ue,N){for(let G=0,Y=oe.length;G<Y;G++){const ie=oe[G](ue,N);if(ie)return ie}return null}}e.or=u,e.matchesStrictPrefix=O.bind(void 0,!1),e.matchesPrefix=O.bind(void 0,!0);function O(oe,ue,N){if(!N||N.length<ue.length)return null;let G;return oe?G=R.startsWithIgnoreCase(N,ue):G=N.indexOf(ue)===0,G?ue.length>0?[{start:0,end:ue.length}]:[]:null}function L(oe,ue){const N=ue.toLowerCase().indexOf(oe.toLowerCase());return N===-1?null:[{start:N,end:N+oe.length}]}e.matchesContiguousSubString=L;function A(oe,ue){return y(oe.toLowerCase(),ue.toLowerCase(),0,0)}e.matchesSubString=A;function y(oe,ue,N,G){if(N===oe.length)return[];if(G===ue.length)return null;if(oe[N]===ue[G]){let Y=null;return(Y=y(oe,ue,N+1,G+1))?h({start:G,end:G+1},Y):null}return y(oe,ue,N,G+1)}function g(oe){return 97<=oe&&oe<=122}function T(oe){return 65<=oe&&oe<=90}e.isUpper=T;function P(oe){return 48<=oe&&oe<=57}function m(oe){return oe===32||oe===9||oe===10||oe===13}const D=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(oe=>D.add(oe.charCodeAt(0)));function C(oe){return m(oe)||D.has(oe)}function b(oe,ue){return oe===ue||C(oe)&&C(ue)}function n(oe){return g(oe)||T(oe)||P(oe)}function h(oe,ue){return ue.length===0?ue=[oe]:oe.end===ue[0].start?ue[0].start=oe.start:ue.unshift(oe),ue}function d(oe,ue){for(let N=ue;N<oe.length;N++){const G=oe.charCodeAt(N);if(T(G)||P(G)||N>0&&!n(oe.charCodeAt(N-1)))return N}return oe.length}function S(oe,ue,N,G){if(N===oe.length)return[];if(G===ue.length)return null;if(oe[N]!==ue[G].toLowerCase())return null;{let Y=null,ie=G+1;for(Y=S(oe,ue,N+1,G+1);!Y&&(ie=d(ue,ie))<ue.length;)Y=S(oe,ue,N+1,ie),ie++;return Y===null?null:h({start:G,end:G+1},Y)}}function w(oe){let ue=0,N=0,G=0,Y=0,ie=0;for(let Te=0;Te<oe.length;Te++)ie=oe.charCodeAt(Te),T(ie)&&ue++,g(ie)&&N++,n(ie)&&G++,P(ie)&&Y++;const pe=ue/oe.length,Ie=N/oe.length,he=G/oe.length,Re=Y/oe.length;return{upperPercent:pe,lowerPercent:Ie,alphaPercent:he,numericPercent:Re}}function p(oe){const{upperPercent:ue,lowerPercent:N}=oe;return N===0&&ue>.6}function t(oe){const{upperPercent:ue,lowerPercent:N,alphaPercent:G,numericPercent:Y}=oe;return N>.2&&ue<.8&&G>.6&&Y<.2}function a(oe){let ue=0,N=0,G=0,Y=0;for(let ie=0;ie<oe.length;ie++)G=oe.charCodeAt(ie),T(G)&&ue++,g(G)&&N++,m(G)&&Y++;return(ue===0||N===0)&&Y===0?oe.length<=30:ue<=5}function r(oe,ue){if(!ue||(ue=ue.trim(),ue.length===0)||!a(oe)||ue.length>60)return null;const N=w(ue);if(!t(N)){if(!p(N))return null;ue=ue.toLowerCase()}let G=null,Y=0;for(oe=oe.toLowerCase();Y<ue.length&&(G=S(oe,ue,0,Y))===null;)Y=d(ue,Y+1);return G}e.matchesCamelCase=r;function o(oe,ue,N=!1){if(!ue||ue.length===0)return null;let G=null,Y=0;for(oe=oe.toLowerCase(),ue=ue.toLowerCase();Y<ue.length&&(G=f(oe,ue,0,Y,N))===null;)Y=v(ue,Y+1);return G}e.matchesWords=o;function f(oe,ue,N,G,Y){if(N===oe.length)return[];if(G===ue.length)return null;if(b(oe.charCodeAt(N),ue.charCodeAt(G))){let ie=null,pe=G+1;if(ie=f(oe,ue,N+1,G+1,Y),!Y)for(;!ie&&(pe=v(ue,pe))<ue.length;)ie=f(oe,ue,N+1,pe,Y),pe++;return ie?oe.charCodeAt(N)!==ue.charCodeAt(G)?ie:h({start:G,end:G+1},ie):null}else return null}function v(oe,ue){for(let N=ue;N<oe.length;N++)if(C(oe.charCodeAt(N))||N>0&&C(oe.charCodeAt(N-1)))return N;return oe.length}const l=u(e.matchesPrefix,r,L),I=u(e.matchesPrefix,r,A),E=new c.LRUCache(1e4);function s(oe,ue,N=!1){if(typeof oe!="string"||typeof ue!="string")return null;let G=E.get(oe);G||(G=new RegExp(R.convertSimple2RegExpPattern(oe),"i"),E.set(oe,G));const Y=G.exec(ue);return Y?[{start:Y.index,end:Y.index+Y[0].length}]:N?I(oe,ue):l(oe,ue)}e.matchesFuzzy=s;function i(oe,ue){const N=fe(oe,oe.toLowerCase(),0,ue,ue.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return N?F(N):null}e.matchesFuzzy2=i;function k(oe,ue,N,G,Y,ie){const pe=Math.min(13,oe.length);for(;N<pe;N++){const Ie=fe(oe,ue,N,G,Y,ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ie)return Ie}return[0,ie]}e.anyScore=k;function F(oe){if(typeof oe>"u")return[];const ue=[],N=oe[1];for(let G=oe.length-1;G>1;G--){const Y=oe[G]+N,ie=ue[ue.length-1];ie&&ie.end===Y?ie.end=Y+1:ue.push({start:Y,end:Y+1})}return ue}e.createMatches=F;const $=128;function j(){const oe=[],ue=[];for(let N=0;N<=$;N++)ue[N]=0;for(let N=0;N<=$;N++)oe.push(ue.slice(0));return oe}function W(oe){const ue=[];for(let N=0;N<=oe;N++)ue[N]=0;return ue}const U=W(2*$),x=W(2*$),B=j(),z=j(),ee=j(),se=!1;function V(oe,ue,N,G,Y){function ie(Ie,he,Re=" "){for(;Ie.length<he;)Ie=Re+Ie;return Ie}let pe=` |   |${G.split("").map(Ie=>ie(Ie,3)).join("|")}
`;for(let Ie=0;Ie<=N;Ie++)Ie===0?pe+=" |":pe+=`${ue[Ie-1]}|`,pe+=oe[Ie].slice(0,Y+1).map(he=>ie(he.toString(),3)).join("|")+`
`;return pe}function Z(oe,ue,N,G){oe=oe.substr(ue),N=N.substr(G),console.log(V(z,oe,oe.length,N,N.length)),console.log(V(ee,oe,oe.length,N,N.length)),console.log(V(B,oe,oe.length,N,N.length))}function q(oe,ue){if(ue<0||ue>=oe.length)return!1;const N=oe.codePointAt(ue);switch(N){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(N)}}function ae(oe,ue){if(ue<0||ue>=oe.length)return!1;switch(oe.charCodeAt(ue)){case 32:case 9:return!0;default:return!1}}function Ee(oe,ue,N){return ue[oe]!==N[oe]}function ye(oe,ue,N,G,Y,ie,pe=!1){for(;ue<N&&Y<ie;)oe[ue]===G[Y]&&(pe&&(U[ue]=Y),ue+=1),Y+=1;return ue===N}e.isPatternInWord=ye;var be;(function(oe){oe[oe.Diag=1]="Diag",oe[oe.Left=2]="Left",oe[oe.LeftLeft=3]="LeftLeft"})(be||(be={}));var M;(function(oe){oe.Default=[-100,0];function ue(N){return!N||N.length===2&&N[0]===-100&&N[1]===0}oe.isDefault=ue})(M||(e.FuzzyScore=M={}));class Q{constructor(ue,N){this.firstMatchCanBeWeak=ue,this.boostFullMatch=N}}e.FuzzyScoreOptions=Q,Q.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function fe(oe,ue,N,G,Y,ie,pe=Q.default){const Ie=oe.length>$?$:oe.length,he=G.length>$?$:G.length;if(N>=Ie||ie>=he||Ie-N>he-ie||!ye(ue,N,Ie,Y,ie,he,!0))return;we(Ie,he,N,ie,ue,Y);let Re=1,Te=1,Ve=N,xe=ie;const tt=[!1];for(Re=1,Ve=N;Ve<Ie;Re++,Ve++){const et=U[Ve],Be=x[Ve],ke=Ve+1<Ie?x[Ve+1]:he;for(Te=et-ie+1,xe=et;xe<ke;Te++,xe++){let X=Number.MIN_SAFE_INTEGER,J=!1;xe<=Be&&(X=_(oe,ue,Ve,N,G,Y,xe,he,ie,B[Re-1][Te-1]===0,tt));let me=0;X!==Number.MAX_SAFE_INTEGER&&(J=!0,me=X+z[Re-1][Te-1]);const Fe=xe>et,ze=Fe?z[Re][Te-1]+(B[Re][Te-1]>0?-5:0):0,He=xe>et+1&&B[Re][Te-1]>0,Je=He?z[Re][Te-2]+(B[Re][Te-2]>0?-5:0):0;if(He&&(!Fe||Je>=ze)&&(!J||Je>=me))z[Re][Te]=Je,ee[Re][Te]=3,B[Re][Te]=0;else if(Fe&&(!J||ze>=me))z[Re][Te]=ze,ee[Re][Te]=2,B[Re][Te]=0;else if(J)z[Re][Te]=me,ee[Re][Te]=1,B[Re][Te]=B[Re-1][Te-1]+1;else throw new Error("not possible")}}if(se&&Z(oe,N,G,ie),!tt[0]&&!pe.firstMatchCanBeWeak)return;Re--,Te--;const Qe=[z[Re][Te],ie];let Xe=0,nt=0;for(;Re>=1;){let et=Te;do{const Be=ee[Re][et];if(Be===3)et=et-2;else if(Be===2)et=et-1;else break}while(et>=1);Xe>1&&ue[N+Re-1]===Y[ie+Te-1]&&!Ee(et+ie-1,G,Y)&&Xe+1>B[Re][et]&&(et=Te),et===Te?Xe++:Xe=1,nt||(nt=et),Re--,Te=et-1,Qe.push(Te)}he===Ie&&pe.boostFullMatch&&(Qe[0]+=2);const ot=nt-Ie;return Qe[0]-=ot,Qe}e.fuzzyScore=fe;function we(oe,ue,N,G,Y,ie){let pe=oe-1,Ie=ue-1;for(;pe>=N&&Ie>=G;)Y[pe]===ie[Ie]&&(x[pe]=Ie,pe--),Ie--}function _(oe,ue,N,G,Y,ie,pe,Ie,he,Re,Te){if(ue[N]!==ie[pe])return Number.MIN_SAFE_INTEGER;let Ve=1,xe=!1;return pe===N-G?Ve=oe[N]===Y[pe]?7:5:Ee(pe,Y,ie)&&(pe===0||!Ee(pe-1,Y,ie))?(Ve=oe[N]===Y[pe]?7:5,xe=!0):q(ie,pe)&&(pe===0||!q(ie,pe-1))?Ve=5:(q(ie,pe-1)||ae(ie,pe-1))&&(Ve=5,xe=!0),Ve>1&&N===G&&(Te[0]=!0),xe||(xe=Ee(pe,Y,ie)||q(ie,pe-1)||ae(ie,pe-1)),N===G?pe>he&&(Ve-=xe?3:5):Re?Ve+=xe?2:0:Ve+=xe?0:1,pe+1===Ie&&(Ve-=xe?3:5),Ve}function ne(oe,ue,N,G,Y,ie,pe){return te(oe,ue,N,G,Y,ie,!0,pe)}e.fuzzyScoreGracefulAggressive=ne;function le(oe,ue,N,G,Y,ie,pe){return te(oe,ue,N,G,Y,ie,!1,pe)}e.fuzzyScoreGraceful=le;function te(oe,ue,N,G,Y,ie,pe,Ie){let he=fe(oe,ue,N,G,Y,ie,Ie);if(he&&!pe)return he;if(oe.length>=3){const Re=Math.min(7,oe.length-1);for(let Te=N+1;Te<Re;Te++){const Ve=de(oe,Te);if(Ve){const xe=fe(Ve,Ve.toLowerCase(),N,G,Y,ie,Ie);xe&&(xe[0]-=3,(!he||xe[0]>he[0])&&(he=xe))}}}return he}function de(oe,ue){if(ue+1>=oe.length)return;const N=oe[ue],G=oe[ue+1];if(N!==G)return oe.slice(0,ue)+G+N+oe.slice(ue+2)}}),define(Ce[70],De([1,0,11]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(h){return u(h,0)}e.hash=R;function u(h,d){switch(typeof h){case"object":return h===null?O(349,d):Array.isArray(h)?y(h,d):g(h,d);case"string":return A(h,d);case"boolean":return L(h,d);case"number":return O(h,d);case"undefined":return O(937,d);default:return O(617,d)}}e.doHash=u;function O(h,d){return(d<<5)-d+h|0}e.numberHash=O;function L(h,d){return O(h?433:863,d)}function A(h,d){d=O(149417,d);for(let S=0,w=h.length;S<w;S++)d=O(h.charCodeAt(S),d);return d}e.stringHash=A;function y(h,d){return d=O(104579,d),h.reduce((S,w)=>u(w,S),d)}function g(h,d){return d=O(181387,d),Object.keys(h).sort().reduce((S,w)=>(S=A(w,S),u(h[w],S)),d)}class T{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=u(d,this.g),this.g}}e.Hasher=T;var P;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function m(h,d,S=32){const w=S-d,p=~((1<<w)-1);return(h<<d|(p&h)>>>w)>>>0}function D(h,d=0,S=h.byteLength,w=0){for(let p=0;p<S;p++)h[d+p]=w}function C(h,d,S="0"){for(;h.length<d;)h=S+h;return h}function b(h,d=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(S=>S.toString(16).padStart(2,"0")).join(""):C((h>>>0).toString(16),d/4)}e.toHexString=b;class n{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const S=d.length;if(S===0)return;const w=this.p;let p=this.r,t=this.u,a,r;for(t!==0?(a=t,r=-1,t=0):(a=d.charCodeAt(0),r=0);;){let o=a;if(c.isHighSurrogate(a))if(r+1<S){const f=d.charCodeAt(r+1);c.isLowSurrogate(f)?(r++,o=c.computeCodePoint(a,f)):o=65533}else{t=a;break}else c.isLowSurrogate(a)&&(o=65533);if(p=this.w(w,p,o),r++,r<S)a=d.charCodeAt(r);else break}this.r=p,this.u=t}w(d,S,w){return w<128?d[S++]=w:w<2048?(d[S++]=192|(w&1984)>>>6,d[S++]=128|(w&63)>>>0):w<65536?(d[S++]=224|(w&61440)>>>12,d[S++]=128|(w&4032)>>>6,d[S++]=128|(w&63)>>>0):(d[S++]=240|(w&1835008)>>>18,d[S++]=128|(w&258048)>>>12,d[S++]=128|(w&4032)>>>6,d[S++]=128|(w&63)>>>0),S>=64&&(this.y(),S-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),S}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,D(this.p,this.r),this.r>56&&(this.y(),D(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=n.g,S=this.q;for(let l=0;l<64;l+=4)d.setUint32(l,S.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)d.setUint32(l,m(d.getUint32(l-12,!1)^d.getUint32(l-32,!1)^d.getUint32(l-56,!1)^d.getUint32(l-64,!1),1),!1);let w=this.h,p=this.l,t=this.m,a=this.n,r=this.o,o,f,v;for(let l=0;l<80;l++)l<20?(o=p&t|~p&a,f=1518500249):l<40?(o=p^t^a,f=1859775393):l<60?(o=p&t|p&a|t&a,f=2400959708):(o=p^t^a,f=3395469782),v=m(w,5)+o+r+f+d.getUint32(l*4,!1)&4294967295,r=a,a=t,t=m(p,30),p=w,w=v;this.h=this.h+w&4294967295,this.l=this.l+p&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+r&4294967295}}e.StringSHA1=n,n.g=new DataView(new ArrayBuffer(320))}),define(Ce[114],De([1,0,112,113,70,10,9,11]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,g=[y,[]];function T(B,z,ee,se){if(!B||!z)return g;const V=B.length,Z=z.length;if(V<Z)return g;const q=B.toLowerCase();return P(z,ee,Z,B,q,V,se)}e.scoreFuzzy=T;function P(B,z,ee,se,V,Z,q){const ae=[],Ee=[];for(let Q=0;Q<ee;Q++){const fe=Q*Z,we=fe-Z,_=Q>0,ne=B[Q],le=z[Q];for(let te=0;te<Z;te++){const de=te>0,oe=fe+te,ue=oe-1,N=we+te-1,G=de?ae[ue]:0,Y=_&&de?ae[N]:0,ie=_&&de?Ee[N]:0;let pe;!Y&&_?pe=0:pe=m(ne,le,se,V,te,ie),pe&&Y+pe>=G&&(q||_||V.startsWith(z,te))?(Ee[oe]=ie+1,ae[oe]=Y+pe):(Ee[oe]=y,ae[oe]=G)}}const ye=[];let be=ee-1,M=Z-1;for(;be>=0&&M>=0;){const Q=be*Z+M;Ee[Q]===y||(ye.push(M),be--),M--}return[ae[ee*Z-1],ye.reverse()]}function m(B,z,ee,se,V,Z){let q=0;if(!D(z,se[V]))return q;if(q+=1,Z>0&&(q+=Z*5),B===ee[V]&&(q+=1),V===0)q+=8;else{const ae=C(ee.charCodeAt(V-1));ae?q+=ae:(0,R.isUpper)(ee.charCodeAt(V))&&Z===0&&(q+=2)}return q}function D(B,z){return B===z?!0:B==="/"||B==="\\"?z==="/"||z==="\\":!1}function C(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const b=[void 0,[]];function n(B,z,ee=0,se=0){const V=z;return V.values&&V.values.length>1?h(B,V.values,ee,se):d(B,z,ee,se)}e.scoreFuzzy2=n;function h(B,z,ee,se){let V=0;const Z=[];for(const q of z){const[ae,Ee]=d(B,q,ee,se);if(typeof ae!="number")return b;V+=ae,Z.push(...Ee)}return[V,I(Z)]}function d(B,z,ee,se){const V=(0,R.fuzzyScore)(z.original,z.originalLowercase,ee,B,B.toLowerCase(),se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?[V[0],(0,R.createMatches)(V)]:b}const S=Object.freeze({score:0}),w=1<<18,p=1<<17,t=1<<16;function a(B,z,ee,se){const V=se.values?se.values:[se];return(0,u.hash)({[se.normalized]:{values:V.map(q=>({value:q.normalized,expectContiguousMatch:q.expectContiguousMatch})),label:B,description:z,allowNonContiguousMatches:ee}})}function r(B,z,ee,se,V){if(!B||!z.normalized)return S;const Z=se.getItemLabel(B);if(!Z)return S;const q=se.getItemDescription(B),ae=a(Z,q,ee,z),Ee=V[ae];if(Ee)return Ee;const ye=o(Z,q,se.getItemPath(B),z,ee);return V[ae]=ye,ye}e.scoreItemFuzzy=r;function o(B,z,ee,se,V){const Z=!ee||!se.containsPathSeparator;return ee&&(L.isLinux?se.pathNormalized===ee:(0,A.equalsIgnoreCase)(se.pathNormalized,ee))?{score:w,labelMatch:[{start:0,end:B.length}],descriptionMatch:z?[{start:0,end:z.length}]:void 0}:se.values&&se.values.length>1?f(B,z,ee,se.values,Z,V):v(B,z,ee,se,Z,V)}function f(B,z,ee,se,V,Z){let q=0;const ae=[],Ee=[];for(const ye of se){const{score:be,labelMatch:M,descriptionMatch:Q}=v(B,z,ee,ye,V,Z);if(be===y)return S;q+=be,M&&ae.push(...M),Q&&Ee.push(...Q)}return{score:q,labelMatch:I(ae),descriptionMatch:I(Ee)}}function v(B,z,ee,se,V,Z){if(V||!z){const[q,ae]=T(B,se.normalized,se.normalizedLowercase,Z&&!se.expectContiguousMatch);if(q){const Ee=(0,R.matchesPrefix)(se.normalized,B);let ye;if(Ee){ye=p;const be=Math.round(se.normalized.length/B.length*100);ye+=be}else ye=t;return{score:ye+q,labelMatch:Ee||l(ae)}}}if(z){let q=z;ee&&(q=`${z}${O.sep}`);const ae=q.length,Ee=`${q}${B}`,[ye,be]=T(Ee,se.normalized,se.normalizedLowercase,Z&&!se.expectContiguousMatch);if(ye){const M=l(be),Q=[],fe=[];return M.forEach(we=>{we.start<ae&&we.end>ae?(Q.push({start:0,end:we.end-ae}),fe.push({start:we.start,end:ae})):we.start>=ae?Q.push({start:we.start-ae,end:we.end-ae}):fe.push(we)}),{score:ye,labelMatch:Q,descriptionMatch:fe}}}return S}function l(B){const z=[];if(!B)return z;let ee;for(const se of B)ee&&ee.end===se?ee.end+=1:(ee={start:se,end:se+1},z.push(ee));return z}function I(B){const z=B.sort((V,Z)=>V.start-Z.start),ee=[];let se;for(const V of z)!se||!E(se,V)?(se=V,ee.push(V)):(se.start=Math.min(se.start,V.start),se.end=Math.max(se.end,V.end));return ee}function E(B,z){return!(B.end<z.start||z.end<B.start)}function s(B,z,ee,se,V,Z){const q=r(B,ee,se,V,Z),ae=r(z,ee,se,V,Z),Ee=q.score,ye=ae.score;if((Ee===w||ye===w)&&Ee!==ye)return Ee===w?-1:1;if(Ee>t||ye>t){if(Ee!==ye)return Ee>ye?-1:1;if(Ee<p&&ye<p){const ne=k(q.labelMatch,ae.labelMatch);if(ne!==0)return ne}const we=V.getItemLabel(B)||"",_=V.getItemLabel(z)||"";if(we.length!==_.length)return we.length-_.length}if(Ee!==ye)return Ee>ye?-1:1;const be=Array.isArray(q.labelMatch)&&q.labelMatch.length>0,M=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0;if(be&&!M)return-1;if(M&&!be)return 1;const Q=i(B,q,V),fe=i(z,ae,V);return Q&&fe&&Q!==fe?fe>Q?-1:1:F(B,z,ee,V)}e.compareItemsByFuzzyScore=s;function i(B,z,ee){let se=-1,V=-1;if(z.descriptionMatch&&z.descriptionMatch.length?se=z.descriptionMatch[0].start:z.labelMatch&&z.labelMatch.length&&(se=z.labelMatch[0].start),z.labelMatch&&z.labelMatch.length){if(V=z.labelMatch[z.labelMatch.length-1].end,z.descriptionMatch&&z.descriptionMatch.length){const Z=ee.getItemDescription(B);Z&&(V+=Z.length)}}else z.descriptionMatch&&z.descriptionMatch.length&&(V=z.descriptionMatch[z.descriptionMatch.length-1].end);return V-se}function k(B,z){if(!B&&!z||(!B||!B.length)&&(!z||!z.length))return 0;if(!z||!z.length)return-1;if(!B||!B.length)return 1;const ee=B[0].start,V=B[B.length-1].end-ee,Z=z[0].start,ae=z[z.length-1].end-Z;return V===ae?0:ae<V?1:-1}function F(B,z,ee,se){const V=se.getItemLabel(B)||"",Z=se.getItemLabel(z)||"",q=se.getItemDescription(B),ae=se.getItemDescription(z),Ee=V.length+(q?q.length:0),ye=Z.length+(ae?ae.length:0);if(Ee!==ye)return Ee-ye;const be=se.getItemPath(B),M=se.getItemPath(z);return be&&M&&be.length!==M.length?be.length-M.length:V!==Z?(0,c.compareAnything)(V,Z,ee.normalized):q&&ae&&q!==ae?(0,c.compareAnything)(q,ae,ee.normalized):be&&M&&be!==M?(0,c.compareAnything)(be,M,ee.normalized):0}function $(B){return B.startsWith('"')&&B.endsWith('"')}const j=" ";function W(B){typeof B!="string"&&(B="");const z=B.toLowerCase(),{pathNormalized:ee,normalized:se,normalizedLowercase:V}=U(B),Z=ee.indexOf(O.sep)>=0,q=$(B);let ae;const Ee=B.split(j);if(Ee.length>1)for(const ye of Ee){const be=$(ye),{pathNormalized:M,normalized:Q,normalizedLowercase:fe}=U(ye);Q&&(ae||(ae=[]),ae.push({original:ye,originalLowercase:ye.toLowerCase(),pathNormalized:M,normalized:Q,normalizedLowercase:fe,expectContiguousMatch:be}))}return{original:B,originalLowercase:z,pathNormalized:ee,normalized:se,normalizedLowercase:V,values:ae,containsPathSeparator:Z,expectContiguousMatch:q}}e.prepareQuery=W;function U(B){let z;L.isWindows?z=B.replace(/\//g,O.sep):z=B.replace(/\\/g,O.sep);const ee=(0,A.stripWildcards)(z).replace(/\s|"/g,"");return{pathNormalized:z,normalized:ee,normalizedLowercase:ee.toLowerCase()}}function x(B){return Array.isArray(B)?W(B.map(z=>z.original).join(j)):W(B.original)}e.pieceToQuery=x}),define(Ce[41],De([1,0,11]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(u){u[u.Ignore=0]="Ignore",u[u.Info=1]="Info",u[u.Warning=2]="Warning",u[u.Error=3]="Error"})(R||(R={})),function(u){const O="error",L="warning",A="warn",y="info",g="ignore";function T(m){return m?c.equalsIgnoreCase(O,m)?u.Error:c.equalsIgnoreCase(L,m)||c.equalsIgnoreCase(A,m)?u.Warning:c.equalsIgnoreCase(y,m)?u.Info:u.Ignore:u.Ignore}u.fromValue=T;function P(m){switch(m){case u.Error:return O;case u.Warning:return L;case u.Info:return y;default:return g}}u.toString=P}(R||(R={})),e.default=R}),define(Ce[154],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ce[71],De([1,0,19,11]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class u{constructor(){this.b="",this.c=0}reset(D){return this.b=D,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(D){const C=D.charCodeAt(0),b=this.b.charCodeAt(this.c);return C-b}value(){return this.b[this.c]}}e.StringIterator=u;class O{constructor(D=!0){this.e=D}reset(D){return this.b=D,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let D=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(D)this.c++;else break;else D=!1;return this}cmp(D){return this.e?(0,R.compareSubstring)(D,this.b,0,D.length,this.c,this.d):(0,R.compareSubstringIgnoreCase)(D,this.b,0,D.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=O;class L{constructor(D=!0,C=!0){this.f=D,this.g=C}reset(D){this.d=0,this.e=0,this.b=D,this.c=D.length;for(let C=D.length-1;C>=0;C--,this.c--){const b=this.b.charCodeAt(C);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let D=!0;for(;this.e<this.c;this.e++){const C=this.b.charCodeAt(this.e);if(C===47||this.f&&C===92)if(D)this.d++;else break;else D=!1}return this}cmp(D){return this.g?(0,R.compareSubstring)(D,this.b,0,D.length,this.d,this.e):(0,R.compareSubstringIgnoreCase)(D,this.b,0,D.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=L;var A;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(D,C){this.f=D,this.g=C,this.d=[],this.e=0}reset(D){return this.c=D,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(D)),this.b.reset(D.path),this.b.value()&&this.d.push(3)),this.g(D)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(D){if(this.d[this.e]===1)return(0,R.compareIgnoreCase)(D,this.c.scheme);if(this.d[this.e]===2)return(0,R.compareIgnoreCase)(D,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(D);if(this.d[this.e]===4)return(0,R.compare)(D,this.c.query);if(this.d[this.e]===5)return(0,R.compare)(D,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const D=this.right;return this.right=D.left,D.left=this,this.updateHeight(),D.updateHeight(),D}rotateRight(){const D=this.left;return this.left=D.right,D.right=this,this.updateHeight(),D.updateHeight(),D}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(T||(T={}));class P{static forUris(D=()=>!1,C=()=>!1){return new P(new y(D,C))}static forPaths(D=!1){return new P(new L(void 0,!D))}static forStrings(){return new P(new u)}static forConfigKeys(){return new P(new O)}constructor(D){this.b=D}clear(){this.c=void 0}fill(D,C){if(C){const b=C.slice(0);(0,c.shuffle)(b);for(const n of b)this.set(n,D)}else{const b=D.slice(0);(0,c.shuffle)(b);for(const n of b)this.set(n[0],n[1])}}set(D,C){const b=this.b.reset(D);let n;this.c||(this.c=new g,this.c.segment=b.value());const h=[];for(n=this.c;;){const S=b.cmp(n.segment);if(S>0)n.left||(n.left=new g,n.left.segment=b.value()),h.push([-1,n]),n=n.left;else if(S<0)n.right||(n.right=new g,n.right.segment=b.value()),h.push([1,n]),n=n.right;else if(b.hasNext())b.next(),n.mid||(n.mid=new g,n.mid.segment=b.value()),h.push([0,n]),n=n.mid;else break}const d=n.value;n.value=C,n.key=D;for(let S=h.length-1;S>=0;S--){const w=h[S][1];w.updateHeight();const p=w.balanceFactor();if(p<-1||p>1){const t=h[S][0],a=h[S+1][0];if(t===1&&a===1)h[S][1]=w.rotateLeft();else if(t===-1&&a===-1)h[S][1]=w.rotateRight();else if(t===1&&a===-1)w.right=h[S+1][1]=h[S+1][1].rotateRight(),h[S][1]=w.rotateLeft();else if(t===-1&&a===1)w.left=h[S+1][1]=h[S+1][1].rotateLeft(),h[S][1]=w.rotateRight();else throw new Error;if(S>0)switch(h[S-1][0]){case-1:h[S-1][1].left=h[S][1];break;case 1:h[S-1][1].right=h[S][1];break;case 0:h[S-1][1].mid=h[S][1];break}else this.c=h[0][1]}}return d}get(D){return this.d(D)?.value}d(D){const C=this.b.reset(D);let b=this.c;for(;b;){const n=C.cmp(b.segment);if(n>0)b=b.left;else if(n<0)b=b.right;else if(C.hasNext())C.next(),b=b.mid;else break}return b}has(D){const C=this.d(D);return!(C?.value===void 0&&C?.mid===void 0)}delete(D){return this.e(D,!1)}deleteSuperstr(D){return this.e(D,!0)}e(D,C){const b=this.b.reset(D),n=[];let h=this.c;for(;h;){const d=b.cmp(h.segment);if(d>0)n.push([-1,h]),h=h.left;else if(d<0)n.push([1,h]),h=h.right;else if(b.hasNext())b.next(),n.push([0,h]),h=h.mid;else break}if(h){if(C?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const d=this.f(h.right);if(d.key){const{key:S,value:w,segment:p}=d;this.e(d.key,!1),h.key=S,h.value=w,h.segment=p}}else{const d=h.left??h.right;if(n.length>0){const[S,w]=n[n.length-1];switch(S){case-1:w.left=d;break;case 0:w.mid=d;break;case 1:w.right=d;break}}else this.c=d}for(let d=n.length-1;d>=0;d--){const S=n[d][1];S.updateHeight();const w=S.balanceFactor();if(w>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),n[d][1]=S.rotateLeft()):w<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),n[d][1]=S.rotateRight()),d>0)switch(n[d-1][0]){case-1:n[d-1][1].left=n[d][1];break;case 1:n[d-1][1].right=n[d][1];break;case 0:n[d-1][1].mid=n[d][1];break}else this.c=n[0][1]}}}f(D){for(;D.left;)D=D.left;return D}findSubstr(D){const C=this.b.reset(D);let b=this.c,n;for(;b;){const h=C.cmp(b.segment);if(h>0)b=b.left;else if(h<0)b=b.right;else if(C.hasNext())C.next(),n=b.value||n,b=b.mid;else break}return b&&b.value||n}findSuperstr(D){return this.g(D,!1)}g(D,C){const b=this.b.reset(D);let n=this.c;for(;n;){const h=b.cmp(n.segment);if(h>0)n=n.left;else if(h<0)n=n.right;else if(b.hasNext())b.next(),n=n.mid;else return n.mid?this.h(n.mid):C?n.value:void 0}}hasElementOrSubtree(D){return this.g(D,!0)!==void 0}forEach(D){for(const[C,b]of this)D(b,C)}*[Symbol.iterator](){yield*this.h(this.c)}h(D){const C=[];return this.j(D,C),C[Symbol.iterator]()}j(D,C){D&&(D.left&&this.j(D.left,C),D.value&&C.push([D.key,D.value]),D.mid&&this.j(D.mid,C),D.right&&this.j(D.right,C))}_isBalanced(){const D=C=>{if(!C)return!0;const b=C.balanceFactor();return b<-1||b>1?!1:D(C.left)&&D(C.right)};return D(this.c)}}e.TernarySearchTree=P}),define(Ce[12],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(a){return typeof a=="string"}e.isString=c;function R(a){return Array.isArray(a)&&a.every(r=>c(r))}e.isStringArray=R;function u(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=u;function O(a){const r=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof r}e.isTypedArray=O;function L(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=L;function A(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=A;function y(a){return a===!0||a===!1}e.isBoolean=y;function g(a){return typeof a>"u"}e.isUndefined=g;function T(a){return!P(a)}e.isDefined=T;function P(a){return g(a)||a===null}e.isUndefinedOrNull=P;function m(a,r){if(!a)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=m;function D(a){if(P(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=D;function C(...a){const r=[];for(let o=0;o<a.length;o++){const f=a[o];if(P(f))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);r.push(f)}return r}e.assertAllDefined=C;const b=Object.prototype.hasOwnProperty;function n(a){if(!u(a))return!1;for(const r in a)if(b.call(a,r))return!1;return!0}e.isEmptyObject=n;function h(a){return typeof a=="function"}e.isFunction=h;function d(...a){return a.length>0&&a.every(h)}e.areFunctions=d;function S(a,r){const o=Math.min(a.length,r.length);for(let f=0;f<o;f++)w(a[f],r[f])}e.validateConstraints=S;function w(a,r){if(c(r)){if(typeof a!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(h(r)){try{if(a instanceof r)return}catch{}if(!P(a)&&a.constructor===r||r.length===1&&r.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=w;function p(a){return a===null?void 0:a}e.withNullAsUndefined=p;function t(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=t}),define(Ce[72],De([1,0,12]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const R=Object.create(null);function u(A,y){if((0,c.isString)(y)){const g=R[y];if(g===void 0)throw new Error(`${A} references an unknown codicon: ${y}`);y=g}return R[A]=y,{id:A}}function O(){return R}e.getCodiconFontCharacters=O;function L(){return Object.values(e.Codicon)}e.getAllCodicons=L,e.Codicon={add:u("add",6e4),plus:u("plus",6e4),gistNew:u("gist-new",6e4),repoCreate:u("repo-create",6e4),lightbulb:u("lightbulb",60001),lightBulb:u("light-bulb",60001),repo:u("repo",60002),repoDelete:u("repo-delete",60002),gistFork:u("gist-fork",60003),repoForked:u("repo-forked",60003),gitPullRequest:u("git-pull-request",60004),gitPullRequestAbandoned:u("git-pull-request-abandoned",60004),recordKeys:u("record-keys",60005),keyboard:u("keyboard",60005),tag:u("tag",60006),tagAdd:u("tag-add",60006),tagRemove:u("tag-remove",60006),person:u("person",60007),personFollow:u("person-follow",60007),personOutline:u("person-outline",60007),personFilled:u("person-filled",60007),gitBranch:u("git-branch",60008),gitBranchCreate:u("git-branch-create",60008),gitBranchDelete:u("git-branch-delete",60008),sourceControl:u("source-control",60008),mirror:u("mirror",60009),mirrorPublic:u("mirror-public",60009),star:u("star",60010),starAdd:u("star-add",60010),starDelete:u("star-delete",60010),starEmpty:u("star-empty",60010),comment:u("comment",60011),commentAdd:u("comment-add",60011),alert:u("alert",60012),warning:u("warning",60012),search:u("search",60013),searchSave:u("search-save",60013),logOut:u("log-out",60014),signOut:u("sign-out",60014),logIn:u("log-in",60015),signIn:u("sign-in",60015),eye:u("eye",60016),eyeUnwatch:u("eye-unwatch",60016),eyeWatch:u("eye-watch",60016),circleFilled:u("circle-filled",60017),primitiveDot:u("primitive-dot",60017),closeDirty:u("close-dirty",60017),debugBreakpoint:u("debug-breakpoint",60017),debugBreakpointDisabled:u("debug-breakpoint-disabled",60017),debugHint:u("debug-hint",60017),primitiveSquare:u("primitive-square",60018),edit:u("edit",60019),pencil:u("pencil",60019),info:u("info",60020),issueOpened:u("issue-opened",60020),gistPrivate:u("gist-private",60021),gitForkPrivate:u("git-fork-private",60021),lock:u("lock",60021),mirrorPrivate:u("mirror-private",60021),close:u("close",60022),removeClose:u("remove-close",60022),x:u("x",60022),repoSync:u("repo-sync",60023),sync:u("sync",60023),clone:u("clone",60024),desktopDownload:u("desktop-download",60024),beaker:u("beaker",60025),microscope:u("microscope",60025),vm:u("vm",60026),deviceDesktop:u("device-desktop",60026),file:u("file",60027),fileText:u("file-text",60027),more:u("more",60028),ellipsis:u("ellipsis",60028),kebabHorizontal:u("kebab-horizontal",60028),mailReply:u("mail-reply",60029),reply:u("reply",60029),organization:u("organization",60030),organizationFilled:u("organization-filled",60030),organizationOutline:u("organization-outline",60030),newFile:u("new-file",60031),fileAdd:u("file-add",60031),newFolder:u("new-folder",60032),fileDirectoryCreate:u("file-directory-create",60032),trash:u("trash",60033),trashcan:u("trashcan",60033),history:u("history",60034),clock:u("clock",60034),folder:u("folder",60035),fileDirectory:u("file-directory",60035),symbolFolder:u("symbol-folder",60035),logoGithub:u("logo-github",60036),markGithub:u("mark-github",60036),github:u("github",60036),terminal:u("terminal",60037),console:u("console",60037),repl:u("repl",60037),zap:u("zap",60038),symbolEvent:u("symbol-event",60038),error:u("error",60039),stop:u("stop",60039),variable:u("variable",60040),symbolVariable:u("symbol-variable",60040),array:u("array",60042),symbolArray:u("symbol-array",60042),symbolModule:u("symbol-module",60043),symbolPackage:u("symbol-package",60043),symbolNamespace:u("symbol-namespace",60043),symbolObject:u("symbol-object",60043),symbolMethod:u("symbol-method",60044),symbolFunction:u("symbol-function",60044),symbolConstructor:u("symbol-constructor",60044),symbolBoolean:u("symbol-boolean",60047),symbolNull:u("symbol-null",60047),symbolNumeric:u("symbol-numeric",60048),symbolNumber:u("symbol-number",60048),symbolStructure:u("symbol-structure",60049),symbolStruct:u("symbol-struct",60049),symbolParameter:u("symbol-parameter",60050),symbolTypeParameter:u("symbol-type-parameter",60050),symbolKey:u("symbol-key",60051),symbolText:u("symbol-text",60051),symbolReference:u("symbol-reference",60052),goToFile:u("go-to-file",60052),symbolEnum:u("symbol-enum",60053),symbolValue:u("symbol-value",60053),symbolRuler:u("symbol-ruler",60054),symbolUnit:u("symbol-unit",60054),activateBreakpoints:u("activate-breakpoints",60055),archive:u("archive",60056),arrowBoth:u("arrow-both",60057),arrowDown:u("arrow-down",60058),arrowLeft:u("arrow-left",60059),arrowRight:u("arrow-right",60060),arrowSmallDown:u("arrow-small-down",60061),arrowSmallLeft:u("arrow-small-left",60062),arrowSmallRight:u("arrow-small-right",60063),arrowSmallUp:u("arrow-small-up",60064),arrowUp:u("arrow-up",60065),bell:u("bell",60066),bold:u("bold",60067),book:u("book",60068),bookmark:u("bookmark",60069),debugBreakpointConditionalUnverified:u("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:u("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:u("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:u("debug-breakpoint-data-unverified",60072),debugBreakpointData:u("debug-breakpoint-data",60073),debugBreakpointDataDisabled:u("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:u("debug-breakpoint-log-unverified",60074),debugBreakpointLog:u("debug-breakpoint-log",60075),debugBreakpointLogDisabled:u("debug-breakpoint-log-disabled",60075),briefcase:u("briefcase",60076),broadcast:u("broadcast",60077),browser:u("browser",60078),bug:u("bug",60079),calendar:u("calendar",60080),caseSensitive:u("case-sensitive",60081),check:u("check",60082),checklist:u("checklist",60083),chevronDown:u("chevron-down",60084),dropDownButton:u("drop-down-button",60084),chevronLeft:u("chevron-left",60085),chevronRight:u("chevron-right",60086),chevronUp:u("chevron-up",60087),chromeClose:u("chrome-close",60088),chromeMaximize:u("chrome-maximize",60089),chromeMinimize:u("chrome-minimize",60090),chromeRestore:u("chrome-restore",60091),circle:u("circle",60092),circleOutline:u("circle-outline",60092),debugBreakpointUnverified:u("debug-breakpoint-unverified",60092),circleSlash:u("circle-slash",60093),circuitBoard:u("circuit-board",60094),clearAll:u("clear-all",60095),clippy:u("clippy",60096),closeAll:u("close-all",60097),cloudDownload:u("cloud-download",60098),cloudUpload:u("cloud-upload",60099),code:u("code",60100),collapseAll:u("collapse-all",60101),colorMode:u("color-mode",60102),commentDiscussion:u("comment-discussion",60103),compareChanges:u("compare-changes",60157),creditCard:u("credit-card",60105),dash:u("dash",60108),dashboard:u("dashboard",60109),database:u("database",60110),debugContinue:u("debug-continue",60111),debugDisconnect:u("debug-disconnect",60112),debugPause:u("debug-pause",60113),debugRestart:u("debug-restart",60114),debugStart:u("debug-start",60115),debugStepInto:u("debug-step-into",60116),debugStepOut:u("debug-step-out",60117),debugStepOver:u("debug-step-over",60118),debugStop:u("debug-stop",60119),debug:u("debug",60120),deviceCameraVideo:u("device-camera-video",60121),deviceCamera:u("device-camera",60122),deviceMobile:u("device-mobile",60123),diffAdded:u("diff-added",60124),diffIgnored:u("diff-ignored",60125),diffModified:u("diff-modified",60126),diffRemoved:u("diff-removed",60127),diffRenamed:u("diff-renamed",60128),diff:u("diff",60129),discard:u("discard",60130),editorLayout:u("editor-layout",60131),emptyWindow:u("empty-window",60132),exclude:u("exclude",60133),extensions:u("extensions",60134),eyeClosed:u("eye-closed",60135),fileBinary:u("file-binary",60136),fileCode:u("file-code",60137),fileMedia:u("file-media",60138),filePdf:u("file-pdf",60139),fileSubmodule:u("file-submodule",60140),fileSymlinkDirectory:u("file-symlink-directory",60141),fileSymlinkFile:u("file-symlink-file",60142),fileZip:u("file-zip",60143),files:u("files",60144),filter:u("filter",60145),flame:u("flame",60146),foldDown:u("fold-down",60147),foldUp:u("fold-up",60148),fold:u("fold",60149),folderActive:u("folder-active",60150),folderOpened:u("folder-opened",60151),gear:u("gear",60152),gift:u("gift",60153),gistSecret:u("gist-secret",60154),gist:u("gist",60155),gitCommit:u("git-commit",60156),gitCompare:u("git-compare",60157),gitMerge:u("git-merge",60158),githubAction:u("github-action",60159),githubAlt:u("github-alt",60160),globe:u("globe",60161),grabber:u("grabber",60162),graph:u("graph",60163),gripper:u("gripper",60164),heart:u("heart",60165),home:u("home",60166),horizontalRule:u("horizontal-rule",60167),hubot:u("hubot",60168),inbox:u("inbox",60169),issueClosed:u("issue-closed",60324),issueReopened:u("issue-reopened",60171),issues:u("issues",60172),italic:u("italic",60173),jersey:u("jersey",60174),json:u("json",60175),bracket:u("bracket",60175),kebabVertical:u("kebab-vertical",60176),key:u("key",60177),law:u("law",60178),lightbulbAutofix:u("lightbulb-autofix",60179),linkExternal:u("link-external",60180),link:u("link",60181),listOrdered:u("list-ordered",60182),listUnordered:u("list-unordered",60183),liveShare:u("live-share",60184),loading:u("loading",60185),location:u("location",60186),mailRead:u("mail-read",60187),mail:u("mail",60188),markdown:u("markdown",60189),megaphone:u("megaphone",60190),mention:u("mention",60191),milestone:u("milestone",60192),mortarBoard:u("mortar-board",60193),move:u("move",60194),multipleWindows:u("multiple-windows",60195),mute:u("mute",60196),noNewline:u("no-newline",60197),note:u("note",60198),octoface:u("octoface",60199),openPreview:u("open-preview",60200),package_:u("package",60201),paintcan:u("paintcan",60202),pin:u("pin",60203),play:u("play",60204),run:u("run",60204),plug:u("plug",60205),preserveCase:u("preserve-case",60206),preview:u("preview",60207),project:u("project",60208),pulse:u("pulse",60209),question:u("question",60210),quote:u("quote",60211),radioTower:u("radio-tower",60212),reactions:u("reactions",60213),references:u("references",60214),refresh:u("refresh",60215),regex:u("regex",60216),remoteExplorer:u("remote-explorer",60217),remote:u("remote",60218),remove:u("remove",60219),replaceAll:u("replace-all",60220),replace:u("replace",60221),repoClone:u("repo-clone",60222),repoForcePush:u("repo-force-push",60223),repoPull:u("repo-pull",60224),repoPush:u("repo-push",60225),report:u("report",60226),requestChanges:u("request-changes",60227),rocket:u("rocket",60228),rootFolderOpened:u("root-folder-opened",60229),rootFolder:u("root-folder",60230),rss:u("rss",60231),ruby:u("ruby",60232),saveAll:u("save-all",60233),saveAs:u("save-as",60234),save:u("save",60235),screenFull:u("screen-full",60236),screenNormal:u("screen-normal",60237),searchStop:u("search-stop",60238),server:u("server",60240),settingsGear:u("settings-gear",60241),settings:u("settings",60242),shield:u("shield",60243),smiley:u("smiley",60244),sortPrecedence:u("sort-precedence",60245),splitHorizontal:u("split-horizontal",60246),splitVertical:u("split-vertical",60247),squirrel:u("squirrel",60248),starFull:u("star-full",60249),starHalf:u("star-half",60250),symbolClass:u("symbol-class",60251),symbolColor:u("symbol-color",60252),symbolCustomColor:u("symbol-customcolor",60252),symbolConstant:u("symbol-constant",60253),symbolEnumMember:u("symbol-enum-member",60254),symbolField:u("symbol-field",60255),symbolFile:u("symbol-file",60256),symbolInterface:u("symbol-interface",60257),symbolKeyword:u("symbol-keyword",60258),symbolMisc:u("symbol-misc",60259),symbolOperator:u("symbol-operator",60260),symbolProperty:u("symbol-property",60261),wrench:u("wrench",60261),wrenchSubaction:u("wrench-subaction",60261),symbolSnippet:u("symbol-snippet",60262),tasklist:u("tasklist",60263),telescope:u("telescope",60264),textSize:u("text-size",60265),threeBars:u("three-bars",60266),thumbsdown:u("thumbsdown",60267),thumbsup:u("thumbsup",60268),tools:u("tools",60269),triangleDown:u("triangle-down",60270),triangleLeft:u("triangle-left",60271),triangleRight:u("triangle-right",60272),triangleUp:u("triangle-up",60273),twitter:u("twitter",60274),unfold:u("unfold",60275),unlock:u("unlock",60276),unmute:u("unmute",60277),unverified:u("unverified",60278),verified:u("verified",60279),versions:u("versions",60280),vmActive:u("vm-active",60281),vmOutline:u("vm-outline",60282),vmRunning:u("vm-running",60283),watch:u("watch",60284),whitespace:u("whitespace",60285),wholeWord:u("whole-word",60286),window:u("window",60287),wordWrap:u("word-wrap",60288),zoomIn:u("zoom-in",60289),zoomOut:u("zoom-out",60290),listFilter:u("list-filter",60291),listFlat:u("list-flat",60292),listSelection:u("list-selection",60293),selection:u("selection",60293),listTree:u("list-tree",60294),debugBreakpointFunctionUnverified:u("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:u("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:u("debug-breakpoint-function-disabled",60296),debugStackframeActive:u("debug-stackframe-active",60297),circleSmallFilled:u("circle-small-filled",60298),debugStackframeDot:u("debug-stackframe-dot",60298),debugStackframe:u("debug-stackframe",60299),debugStackframeFocused:u("debug-stackframe-focused",60299),debugBreakpointUnsupported:u("debug-breakpoint-unsupported",60300),symbolString:u("symbol-string",60301),debugReverseContinue:u("debug-reverse-continue",60302),debugStepBack:u("debug-step-back",60303),debugRestartFrame:u("debug-restart-frame",60304),callIncoming:u("call-incoming",60306),callOutgoing:u("call-outgoing",60307),menu:u("menu",60308),expandAll:u("expand-all",60309),feedback:u("feedback",60310),groupByRefType:u("group-by-ref-type",60311),ungroupByRefType:u("ungroup-by-ref-type",60312),account:u("account",60313),bellDot:u("bell-dot",60314),debugConsole:u("debug-console",60315),library:u("library",60316),output:u("output",60317),runAll:u("run-all",60318),syncIgnored:u("sync-ignored",60319),pinned:u("pinned",60320),githubInverted:u("github-inverted",60321),debugAlt:u("debug-alt",60305),serverProcess:u("server-process",60322),serverEnvironment:u("server-environment",60323),pass:u("pass",60324),stopCircle:u("stop-circle",60325),playCircle:u("play-circle",60326),record:u("record",60327),debugAltSmall:u("debug-alt-small",60328),vmConnect:u("vm-connect",60329),cloud:u("cloud",60330),merge:u("merge",60331),exportIcon:u("export",60332),graphLeft:u("graph-left",60333),magnet:u("magnet",60334),notebook:u("notebook",60335),redo:u("redo",60336),checkAll:u("check-all",60337),pinnedDirty:u("pinned-dirty",60338),passFilled:u("pass-filled",60339),circleLargeFilled:u("circle-large-filled",60340),circleLarge:u("circle-large",60341),circleLargeOutline:u("circle-large-outline",60341),combine:u("combine",60342),gather:u("gather",60342),table:u("table",60343),variableGroup:u("variable-group",60344),typeHierarchy:u("type-hierarchy",60345),typeHierarchySub:u("type-hierarchy-sub",60346),typeHierarchySuper:u("type-hierarchy-super",60347),gitPullRequestCreate:u("git-pull-request-create",60348),runAbove:u("run-above",60349),runBelow:u("run-below",60350),notebookTemplate:u("notebook-template",60351),debugRerun:u("debug-rerun",60352),workspaceTrusted:u("workspace-trusted",60353),workspaceUntrusted:u("workspace-untrusted",60354),workspaceUnspecified:u("workspace-unspecified",60355),terminalCmd:u("terminal-cmd",60356),terminalDebian:u("terminal-debian",60357),terminalLinux:u("terminal-linux",60358),terminalPowershell:u("terminal-powershell",60359),terminalTmux:u("terminal-tmux",60360),terminalUbuntu:u("terminal-ubuntu",60361),terminalBash:u("terminal-bash",60362),arrowSwap:u("arrow-swap",60363),copy:u("copy",60364),personAdd:u("person-add",60365),filterFilled:u("filter-filled",60366),wand:u("wand",60367),debugLineByLine:u("debug-line-by-line",60368),inspect:u("inspect",60369),layers:u("layers",60370),layersDot:u("layers-dot",60371),layersActive:u("layers-active",60372),compass:u("compass",60373),compassDot:u("compass-dot",60374),compassActive:u("compass-active",60375),azure:u("azure",60376),issueDraft:u("issue-draft",60377),gitPullRequestClosed:u("git-pull-request-closed",60378),gitPullRequestDraft:u("git-pull-request-draft",60379),debugAll:u("debug-all",60380),debugCoverage:u("debug-coverage",60381),runErrors:u("run-errors",60382),folderLibrary:u("folder-library",60383),debugContinueSmall:u("debug-continue-small",60384),beakerStop:u("beaker-stop",60385),graphLine:u("graph-line",60386),graphScatter:u("graph-scatter",60387),pieChart:u("pie-chart",60388),bracketDot:u("bracket-dot",60389),bracketError:u("bracket-error",60390),lockSmall:u("lock-small",60391),azureDevops:u("azure-devops",60392),verifiedFilled:u("verified-filled",60393),newLine:u("newline",60394),layout:u("layout",60395),layoutActivitybarLeft:u("layout-activitybar-left",60396),layoutActivitybarRight:u("layout-activitybar-right",60397),layoutPanelLeft:u("layout-panel-left",60398),layoutPanelCenter:u("layout-panel-center",60399),layoutPanelJustify:u("layout-panel-justify",60400),layoutPanelRight:u("layout-panel-right",60401),layoutPanel:u("layout-panel",60402),layoutSidebarLeft:u("layout-sidebar-left",60403),layoutSidebarRight:u("layout-sidebar-right",60404),layoutStatusbar:u("layout-statusbar",60405),layoutMenubar:u("layout-menubar",60406),layoutCentered:u("layout-centered",60407),layoutSidebarRightOff:u("layout-sidebar-right-off",60416),layoutPanelOff:u("layout-panel-off",60417),layoutSidebarLeftOff:u("layout-sidebar-left-off",60418),target:u("target",60408),indent:u("indent",60409),recordSmall:u("record-small",60410),errorSmall:u("error-small",60411),arrowCircleDown:u("arrow-circle-down",60412),arrowCircleLeft:u("arrow-circle-left",60413),arrowCircleRight:u("arrow-circle-right",60414),arrowCircleUp:u("arrow-circle-up",60415),heartFilled:u("heart-filled",60420),map:u("map",60421),mapFilled:u("map-filled",60422),circleSmall:u("circle-small",60423),bellSlash:u("bell-slash",60424),bellSlashDot:u("bell-slash-dot",60425),commentUnresolved:u("comment-unresolved",60426),gitPullRequestGoToChanges:u("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:u("git-pull-request-new-changes",60428),searchFuzzy:u("search-fuzzy",60429),commentDraft:u("comment-draft",60430),send:u("send",60431),sparkle:u("sparkle",60432),insert:u("insert",60433),dialogError:u("dialog-error","error"),dialogWarning:u("dialog-warning","warning"),dialogInfo:u("dialog-info","info"),dialogClose:u("dialog-close","close"),treeItemExpanded:u("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:u("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:u("tree-filter-on-type-off","list-selection"),treeFilterClear:u("tree-filter-clear","close"),treeItemLoading:u("tree-item-loading","loading"),menuSelection:u("menu-selection","check"),menuSubmenu:u("menu-submenu","chevron-right"),menuBarMore:u("menubar-more","more"),scrollbarButtonLeft:u("scrollbar-button-left","triangle-left"),scrollbarButtonRight:u("scrollbar-button-right","triangle-right"),scrollbarButtonUp:u("scrollbar-button-up","triangle-up"),scrollbarButtonDown:u("scrollbar-button-down","triangle-down"),toolBarMore:u("toolbar-more","more"),quickInputBack:u("quick-input-back","arrow-left")}}),define(Ce[30],De([1,0,10,9,11,12]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function L(v){return v===47||v===92}e.isPathSeparator=L;function A(v){return v.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=A;function y(v){return v.indexOf("/")===-1&&(v=A(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}e.toPosixPath=y;function g(v,l=c.posix.sep){if(!v)return"";const I=v.length,E=v.charCodeAt(0);if(L(E)){if(L(v.charCodeAt(1))&&!L(v.charCodeAt(2))){let i=3;const k=i;for(;i<I&&!L(v.charCodeAt(i));i++);if(k!==i&&!L(v.charCodeAt(i+1))){for(i+=1;i<I;i++)if(L(v.charCodeAt(i)))return v.slice(0,i+1).replace(/[\\/]/g,l)}}return l}else if(h(E)&&v.charCodeAt(1)===58)return L(v.charCodeAt(2))?v.slice(0,2)+l:v.slice(0,2);let s=v.indexOf("://");if(s!==-1){for(s+=3;s<I;s++)if(L(v.charCodeAt(s)))return v.slice(0,s+1)}return""}e.getRoot=g;function T(v){if(!R.isWindows||!v||v.length<5)return!1;let l=v.charCodeAt(0);if(l!==92||(l=v.charCodeAt(1),l!==92))return!1;let I=2;const E=I;for(;I<v.length&&(l=v.charCodeAt(I),l!==92);I++);return!(E===I||(l=v.charCodeAt(I+1),isNaN(l)||l===92))}e.isUNC=T;const P=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,D=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(v,l=R.isWindows){const I=l?P:m;return!(!v||v.length===0||/^\s+$/.test(v)||(I.lastIndex=0,I.test(v))||l&&D.test(v)||v==="."||v===".."||l&&v[v.length-1]==="."||l&&v.length!==v.trim().length||v.length>255)}e.isValidBasename=C;function b(v,l,I){const E=v===l;return!I||E?E:!v||!l?!1:(0,u.equalsIgnoreCase)(v,l)}e.isEqual=b;function n(v,l,I,E=c.sep){if(v===l)return!0;if(!v||!l||l.length>v.length)return!1;if(I){if(!(0,u.startsWithIgnoreCase)(v,l))return!1;if(l.length===v.length)return!0;let i=l.length;return l.charAt(l.length-1)===E&&i--,v.charAt(i)===E}return l.charAt(l.length-1)!==E&&(l+=E),v.indexOf(l)===0}e.isEqualOrParent=n;function h(v){return v>=65&&v<=90||v>=97&&v<=122}e.isWindowsDriveLetter=h;function d(v,l){return R.isWindows&&v.endsWith(":")&&(v+=c.sep),(0,c.isAbsolute)(v)||(v=(0,c.join)(l,v)),v=(0,c.normalize)(v),R.isWindows?(v=(0,u.rtrim)(v,c.sep),v.endsWith(":")&&(v+=c.sep)):(v=(0,u.rtrim)(v,c.sep),v||(v=c.sep)),v}e.sanitizeFilePath=d;function S(v){const l=(0,c.normalize)(v);return R.isWindows?v.length>3?!1:w(l)&&(v.length===2||l.charCodeAt(2)===92):l===c.posix.sep}e.isRootOrDriveLetter=S;function w(v,l=R.isWindows){return l?h(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}e.hasDriveLetter=w;function p(v,l=R.isWindows){return w(v,l)?v[0]:void 0}e.getDriveLetter=p;function t(v,l,I){return l.length>v.length?-1:v===l?0:(I&&(v=v.toLowerCase(),l=l.toLowerCase()),v.indexOf(l))}e.indexOfPath=t;function a(v){const l=v.split(":");let I,E,s;for(const i of l){const k=Number(i);(0,O.isNumber)(k)?E===void 0?E=k:s===void 0&&(s=k):I=I?[I,i].join(":"):i}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:E!==void 0?E:void 0,column:s!==void 0?s:E!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function f(v,l,I=8){let E="";for(let i=0;i<I;i++){let k;i===0&&R.isWindows&&!l&&(I===3||I===4)?k=o:k=r,E+=k.charAt(Math.floor(Math.random()*k.length))}let s;return l?s=`${l}-${E}`:s=E,v?(0,c.join)(v,s):s}e.randomPath=f}),define(Ce[23],De([1,0,12]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const d=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([S,w])=>{d[S]=w&&typeof w=="object"?R(w):w}),d}e.deepClone=R;function u(h){if(!h||typeof h!="object")return h;const d=[h];for(;d.length>0;){const S=d.shift();Object.freeze(S);for(const w in S)if(O.call(S,w)){const p=S[w];typeof p=="object"&&!Object.isFrozen(p)&&!(0,c.isTypedArray)(p)&&d.push(p)}}return h}e.deepFreeze=u;const O=Object.prototype.hasOwnProperty;function L(h,d){return A(h,d,new Set)}e.cloneAndChange=L;function A(h,d,S){if((0,c.isUndefinedOrNull)(h))return h;const w=d(h);if(typeof w<"u")return w;if(Array.isArray(h)){const p=[];for(const t of h)p.push(A(t,d,S));return p}if((0,c.isObject)(h)){if(S.has(h))throw new Error("Cannot clone recursive data-structure");S.add(h);const p={};for(const t in h)O.call(h,t)&&(p[t]=A(h[t],d,S));return S.delete(h),p}return h}function y(h,d,S=!0){return(0,c.isObject)(h)?((0,c.isObject)(d)&&Object.keys(d).forEach(w=>{w in h?S&&((0,c.isObject)(h[w])&&(0,c.isObject)(d[w])?y(h[w],d[w],S):h[w]=d[w]):h[w]=d[w]}),h):d}e.mixin=y;function g(h,d){if(h===d)return!0;if(h==null||d===null||d===void 0||typeof h!=typeof d||typeof h!="object"||Array.isArray(h)!==Array.isArray(d))return!1;let S,w;if(Array.isArray(h)){if(h.length!==d.length)return!1;for(S=0;S<h.length;S++)if(!g(h[S],d[S]))return!1}else{const p=[];for(w in h)p.push(w);p.sort();const t=[];for(w in d)t.push(w);if(t.sort(),!g(p,t))return!1;for(S=0;S<p.length;S++)if(!g(h[p[S]],d[p[S]]))return!1}return!0}e.equals=g;function T(h){const d=new Set;return JSON.stringify(h,(S,w)=>{if((0,c.isObject)(w)||Array.isArray(w)){if(d.has(w))return"[Circular]";d.add(w)}return w})}e.safeStringify=T;function P(h,d){const S=Object.create(null);return!h||!d||Object.keys(d).forEach(p=>{const t=h[p],a=d[p];g(t,a)||(S[p]=a)}),S}e.distinct=P;function m(h,d){const S=d.toLowerCase(),w=Object.keys(h).find(p=>p.toLowerCase()===S);return w?h[w]:h[d]}e.getCaseInsensitive=m;function D(h,d){const S=Object.create(null);for(const[w,p]of Object.entries(h))d(w,p)&&(S[w]=p);return S}e.filter=D;function C(h){let d=[],S=Object.getPrototypeOf(h);for(;Object.prototype!==S;)d=d.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return d}e.getAllPropertyNames=C;function b(h){const d=[];for(const S of C(h))typeof h[S]=="function"&&d.push(S);return d}e.getAllMethodNames=b;function n(h,d){const S=p=>function(){const t=Array.prototype.slice.call(arguments,0);return d(p,t)},w={};for(const p of h)w[p]=S(p);return w}e.createProxyObject=n}),define(Ce[55],De([1,0,72]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var R;(function(L){function A(y){return y&&typeof y=="object"&&typeof y.id=="string"}L.isThemeColor=A})(R||(e.ThemeColor=R={}));function u(L){return{id:L}}e.themeColorFromId=u;var O;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function y(d){const S=A.exec(d.id);if(!S)return y(c.Codicon.error);const[,w,p]=S,t=["codicon","codicon-"+w];return p&&t.push("codicon-modifier-"+p.substring(1)),t}L.asClassNameArray=y;function g(d){return y(d).join(" ")}L.asClassName=g;function T(d){return"."+y(d).join(".")}L.asCSSSelector=T;function P(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||R.isThemeColor(d.color))}L.isThemeIcon=P;const m=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function D(d){const S=m.exec(d);if(!S)return;const[,w]=S;return{id:w}}L.fromString=D;function C(d){return{id:d}}L.fromId=C;function b(d,S){let w=d.id;const p=w.lastIndexOf("~");return p!==-1&&(w=w.substring(0,p)),S&&(w=`${w}~${S}`),{id:w}}L.modify=b;function n(d){const S=d.id.lastIndexOf("~");if(S!==-1)return d.id.substring(S+1)}L.getModifier=n;function h(d,S){return d.id===S.id&&d.color?.id===S.color?.id}L.isEqual=h})(O||(e.ThemeIcon=O={}))}),define(Ce[155],De([1,0,113,11,55]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const O="$(",L=new RegExp(`\\$\\(${u.ThemeIcon.iconNameExpression}(?:${u.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${L.source}`,"g");function y(h){return h.replace(A,(d,S)=>S?d:`\\${d}`)}e.escapeIcons=y;const g=new RegExp(`\\\\${L.source}`,"g");function T(h){return h.replace(g,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=T;const P=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function m(h){return h.indexOf(O)===-1?h:h.replace(P,(d,S,w,p)=>w?d:S||p||"")}e.stripIcons=m;function D(h){return h?h.replace(/\$\((.*?)\)/g,(d,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=D;const C=new RegExp(`\\$\\(${u.ThemeIcon.iconNameCharacter}+\\)`,"g");function b(h){C.lastIndex=0;let d="";const S=[];let w=0;for(;;){const p=C.lastIndex,t=C.exec(h),a=h.substring(p,t?.index);if(a.length>0){d+=a;for(let r=0;r<a.length;r++)S.push(w)}if(!t)break;w+=t[0].length}return{text:d,iconOffsets:S}}e.parseLabelWithIcons=b;function n(h,d,S=!1){const{text:w,iconOffsets:p}=d;if(!p||p.length===0)return(0,c.matchesFuzzy)(h,w,S);const t=(0,R.ltrim)(w," "),a=w.length-t.length,r=(0,c.matchesFuzzy)(h,t,S);if(r)for(const o of r){const f=p[o.start+a]+a;o.start+=f,o.end+=f}return r}e.matchesFuzzyIconAware=n}),define(Ce[115],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(O){O[O.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",O[O.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",O[O.MAX_UINT_8=255]="MAX_UINT_8",O[O.MAX_UINT_16=65535]="MAX_UINT_16",O[O.MAX_UINT_32=4294967295]="MAX_UINT_32",O[O.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c||(e.Constants=c={}));function R(O){return O<0?0:O>255?255:O|0}e.toUint8=R;function u(O){return O<0?0:O>4294967295?4294967295:O|0}e.toUint32=u}),define(Ce[2],De([1,0,10,9]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.isUriComponents=e.URI=void 0;const u=/^\w[\w\d+.-]*$/,O=/^\//,L=/^\/\//;function A(o,f){if(!o.scheme&&f)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!u.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!O.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(o,f){return!o&&!f?"file":o}function g(o,f){switch(o){case"https":case"http":case"file":f?f[0]!==P&&(f=P+f):f=P;break}return f}const T="",P="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class D{static isUri(f){return f instanceof D?!0:f?typeof f.authority=="string"&&typeof f.fragment=="string"&&typeof f.path=="string"&&typeof f.query=="string"&&typeof f.scheme=="string"&&typeof f.fsPath=="string"&&typeof f.with=="function"&&typeof f.toString=="function":!1}constructor(f,v,l,I,E,s=!1){typeof f=="object"?(this.scheme=f.scheme||T,this.authority=f.authority||T,this.path=f.path||T,this.query=f.query||T,this.fragment=f.fragment||T):(this.scheme=y(f,s),this.authority=v||T,this.path=g(this.scheme,l||T),this.query=I||T,this.fragment=E||T,A(this,s))}get fsPath(){return w(this,!1)}with(f){if(!f)return this;let{scheme:v,authority:l,path:I,query:E,fragment:s}=f;return v===void 0?v=this.scheme:v===null&&(v=T),l===void 0?l=this.authority:l===null&&(l=T),I===void 0?I=this.path:I===null&&(I=T),E===void 0?E=this.query:E===null&&(E=T),s===void 0?s=this.fragment:s===null&&(s=T),v===this.scheme&&l===this.authority&&I===this.path&&E===this.query&&s===this.fragment?this:new n(v,l,I,E,s)}static parse(f,v=!1){const l=m.exec(f);return l?new n(l[2]||T,r(l[4]||T),r(l[5]||T),r(l[7]||T),r(l[9]||T),v):new n(T,T,T,T,T)}static file(f){let v=T;if(R.isWindows&&(f=f.replace(/\\/g,P)),f[0]===P&&f[1]===P){const l=f.indexOf(P,2);l===-1?(v=f.substring(2),f=P):(v=f.substring(2,l),f=f.substring(l)||P)}return new n("file",v,f,T,T)}static from(f,v){return new n(f.scheme,f.authority,f.path,f.query,f.fragment,v)}static joinPath(f,...v){if(!f.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return R.isWindows&&f.scheme==="file"?l=D.file(c.win32.join(w(f,!0),...v)).path:l=c.posix.join(f.path,...v),f.with({path:l})}toString(f=!1){return p(this,f)}toJSON(){return this}static revive(f){if(f){if(f instanceof D)return f;{const v=new n(f);return v._formatted=f.external??null,v._fsPath=f._sep===b?f.fsPath??null:null,v}}else return f}}e.URI=D;function C(o){return!o||typeof o!="object"?!1:typeof o.scheme=="string"&&(typeof o.authority=="string"||typeof o.authority>"u")&&(typeof o.path=="string"||typeof o.path>"u")&&(typeof o.query=="string"||typeof o.query>"u")&&(typeof o.fragment=="string"||typeof o.fragment>"u")}e.isUriComponents=C;const b=R.isWindows?1:void 0;class n extends D{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(f=!1){return f?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const f={$mid:1};return this._fsPath&&(f.fsPath=this._fsPath,f._sep=b),this._formatted&&(f.external=this._formatted),this.path&&(f.path=this.path),this.scheme&&(f.scheme=this.scheme),this.authority&&(f.authority=this.authority),this.query&&(f.query=this.query),this.fragment&&(f.fragment=this.fragment),f}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(o,f,v){let l,I=-1;for(let E=0;E<o.length;E++){const s=o.charCodeAt(E);if(s>=97&&s<=122||s>=65&&s<=90||s>=48&&s<=57||s===45||s===46||s===95||s===126||f&&s===47||v&&s===91||v&&s===93||v&&s===58)I!==-1&&(l+=encodeURIComponent(o.substring(I,E)),I=-1),l!==void 0&&(l+=o.charAt(E));else{l===void 0&&(l=o.substr(0,E));const i=h[s];i!==void 0?(I!==-1&&(l+=encodeURIComponent(o.substring(I,E)),I=-1),l+=i):I===-1&&(I=E)}}return I!==-1&&(l+=encodeURIComponent(o.substring(I))),l!==void 0?l:o}function S(o){let f;for(let v=0;v<o.length;v++){const l=o.charCodeAt(v);l===35||l===63?(f===void 0&&(f=o.substr(0,v)),f+=h[l]):f!==void 0&&(f+=o[v])}return f!==void 0?f:o}function w(o,f){let v;return o.authority&&o.path.length>1&&o.scheme==="file"?v=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?f?v=o.path.substr(1):v=o.path[1].toLowerCase()+o.path.substr(2):v=o.path,R.isWindows&&(v=v.replace(/\//g,"\\")),v}e.uriToFsPath=w;function p(o,f){const v=f?S:d;let l="",{scheme:I,authority:E,path:s,query:i,fragment:k}=o;if(I&&(l+=I,l+=":"),(E||I==="file")&&(l+=P,l+=P),E){let F=E.indexOf("@");if(F!==-1){const $=E.substr(0,F);E=E.substr(F+1),F=$.lastIndexOf(":"),F===-1?l+=v($,!1,!1):(l+=v($.substr(0,F),!1,!1),l+=":",l+=v($.substr(F+1),!1,!0)),l+="@"}E=E.toLowerCase(),F=E.lastIndexOf(":"),F===-1?l+=v(E,!1,!0):(l+=v(E.substr(0,F),!1,!0),l+=E.substr(F))}if(s){if(s.length>=3&&s.charCodeAt(0)===47&&s.charCodeAt(2)===58){const F=s.charCodeAt(1);F>=65&&F<=90&&(s=`/${String.fromCharCode(F+32)}:${s.substr(3)}`)}else if(s.length>=2&&s.charCodeAt(1)===58){const F=s.charCodeAt(0);F>=65&&F<=90&&(s=`${String.fromCharCode(F+32)}:${s.substr(2)}`)}l+=v(s,!0,!1)}return i&&(l+="?",l+=v(i,!1,!1)),k&&(l+="#",l+=f?k:d(k,!1,!1)),l}function t(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+t(o.substr(3)):o}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(o){return o.match(a)?o.replace(a,f=>t(f)):o}}),define(Ce[156],De([1,0,2]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(g){const T=g;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=R;function u(g){const T=[];let P;try{const m=JSON.parse(g.arguments),D=m[m.length-1];D&&D.__$stack&&(m.pop(),P=D.__$stack),T.push(...m)}catch{T.push("Unable to log remote console arguments",g.arguments)}return{args:T,stack:P}}e.parse=u;function O(g){if(typeof g!="string")return O(u(g).stack);const T=g;if(T){const P=L(T),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(m&&m.length===4)return{uri:c.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=O;function L(g){if(!g)return g;const T=g.indexOf(`
`);return T===-1?g:g.substring(0,T)}function A(g,T){const{args:P,stack:m}=u(g),D=typeof P[0]=="string"&&P.length===1;let C=L(m);C&&(C=`(${C.trim()})`);let b=[];if(typeof P[0]=="string"?C&&D?b=[`%c[${T}] %c${P[0]} %c${C}`,y("blue"),y(""),y("grey")]:b=[`%c[${T}] %c${P[0]}`,y("blue"),y(""),...P.slice(1)]:b=[`%c[${T}]%`,y("blue"),...P],C&&!D&&b.push(C),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,b)}e.log=A;function y(g){return`color: ${g}`}}),define(Ce[73],De([1,0,22,11,2]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function O(g){return JSON.stringify(g,A)}e.stringify=O;function L(g){let T=JSON.parse(g);return T=y(T),T}e.parse=L;function A(g,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,R.regExpFlags)(T)}:T}function y(g,T=0){if(!g||T>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return u.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 16:return new Date(g.source)}if(g instanceof c.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let P=0;P<g.length;++P)g[P]=y(g[P],T+1);else for(const P in g)Object.hasOwnProperty.call(g,P)&&(g[P]=y(g[P],T+1))}return g}e.revive=y}),define(Ce[18],De([1,0,8,9,2]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var O;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractive="vscode-interactive",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(T){this.d=T}setDelegate(T){this.e=T}setServerRootPath(T){this.f=`${T}/${O.vscodeRemoteResource}`}set(T,P,m){this.a[T]=P,this.b[T]=m}setConnectionToken(T,P){this.c[T]=P}getPreferredWebSchema(){return this.d}rewrite(T){if(this.e)try{return this.e(T)}catch(n){return c.onUnexpectedError(n),T}const P=T.authority;let m=this.a[P];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const D=this.b[P],C=this.c[P];let b=`path=${encodeURIComponent(T.path)}`;return typeof C=="string"&&(b+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),u.URI.from({scheme:R.isWeb?this.d:O.vscodeRemoteResource,authority:`${m}:${D}`,path:R.isWeb?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:b})}}e.RemoteAuthorities=new L,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(T){const P=this.b(T,re);return this.uriToBrowserUri(P)}uriToBrowserUri(T){return T.scheme===O.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===O.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${O.vscodeFileResource}://${A.a}`)?T.with({scheme:O.vscodeFileResource,authority:T.authority||A.a,query:null,fragment:null}):T}asFileUri(T){const P=this.b(T,re);return this.uriToFileUri(P)}uriToFileUri(T){return T.scheme===O.vscodeFileResource?T.with({scheme:O.file,authority:T.authority!==A.a?T.authority:null,query:null,fragment:null}):T}b(T,P){return u.URI.isUri(T)?T:u.URI.parse(P.toUrl(T))}}A.a="vscode-app",e.FileAccess=new A;var y;(function(g){const T=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(T.get("3"));const P="vscode-coi";function m(C){let b;typeof C=="string"?b=new URL(C).searchParams:C instanceof URL?b=C.searchParams:u.URI.isUri(C)&&(b=new URL(C.toString(!0)).searchParams);const n=b?.get(P);if(n)return T.get(n)}g.getHeadersFromQuery=m;function D(C,b,n){if(!globalThis.crossOriginIsolated)return;const h=b&&n?"3":n?"2":"1";C instanceof URLSearchParams?C.set(P,h):C[P]=h}g.addSearchParam=D})(y||(e.COI=y={}))}),define(Ce[24],De([1,0,30,18,10,9,11,2]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(D){return(0,A.uriToFsPath)(D,!0)}e.originalFSPath=y;class g{constructor(C){this.a=C}compare(C,b,n=!1){return C===b?0:(0,L.compare)(this.getComparisonKey(C,n),this.getComparisonKey(b,n))}isEqual(C,b,n=!1){return C===b?!0:!C||!b?!1:this.getComparisonKey(C,n)===this.getComparisonKey(b,n)}getComparisonKey(C,b=!1){return C.with({path:this.a(C)?C.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(C){return this.a(C)}isEqualOrParent(C,b,n=!1){if(C.scheme===b.scheme){if(C.scheme===R.Schemas.file)return c.isEqualOrParent(y(C),y(b),this.a(C))&&C.query===b.query&&(n||C.fragment===b.fragment);if((0,e.isEqualAuthority)(C.authority,b.authority))return c.isEqualOrParent(C.path,b.path,this.a(C),"/")&&C.query===b.query&&(n||C.fragment===b.fragment)}return!1}joinPath(C,...b){return A.URI.joinPath(C,...b)}basenameOrAuthority(C){return(0,e.basename)(C)||C.authority}basename(C){return u.posix.basename(C.path)}extname(C){return u.posix.extname(C.path)}dirname(C){if(C.path.length===0)return C;let b;return C.scheme===R.Schemas.file?b=A.URI.file(u.dirname(y(C))).path:(b=u.posix.dirname(C.path),C.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),b="/")),C.with({path:b})}normalizePath(C){if(!C.path.length)return C;let b;return C.scheme===R.Schemas.file?b=A.URI.file(u.normalize(y(C))).path:b=u.posix.normalize(C.path),C.with({path:b})}relativePath(C,b){if(C.scheme!==b.scheme||!(0,e.isEqualAuthority)(C.authority,b.authority))return;if(C.scheme===R.Schemas.file){const d=u.relative(y(C),y(b));return O.isWindows?c.toSlashes(d):d}let n=C.path||"/";const h=b.path||"/";if(this.a(C)){let d=0;for(const S=Math.min(n.length,h.length);d<S&&!(n.charCodeAt(d)!==h.charCodeAt(d)&&n.charAt(d).toLowerCase()!==h.charAt(d).toLowerCase());d++);n=h.substr(0,d)+n.substr(d)}return u.posix.relative(n,h)}resolvePath(C,b){if(C.scheme===R.Schemas.file){const n=A.URI.file(u.resolve(y(C),b));return C.with({authority:n.authority,path:n.path})}return b=c.toPosixPath(b),C.with({path:u.posix.resolve(C.path,b)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,b){return C===b||C!==void 0&&b!==void 0&&(0,L.equalsIgnoreCase)(C,b)}hasTrailingPathSeparator(C,b=u.sep){if(C.scheme===R.Schemas.file){const n=y(C);return n.length>c.getRoot(n).length&&n[n.length-1]===b}else{const n=C.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,b=u.sep){return(0,e.hasTrailingPathSeparator)(C,b)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,b=u.sep){let n=!1;if(C.scheme===R.Schemas.file){const h=y(C);n=h!==void 0&&h.length===c.getRoot(h).length&&h[h.length-1]===b}else{b="/";const h=C.path;n=h.length===1&&h.charCodeAt(h.length-1)===47}return!n&&!(0,e.hasTrailingPathSeparator)(C,b)?C.with({path:C.path+"/"}):C}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(D=>D.scheme===R.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new g(D=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(D,C){const b=[];for(let n=0;n<D.length;n++){const h=C(D[n]);D.some((d,S)=>S===n?!1:(0,e.isEqualOrParent)(h,C(d)))||b.push(D[n])}return b}e.distinctParents=T;var P;(function(D){D.META_DATA_LABEL="label",D.META_DATA_DESCRIPTION="description",D.META_DATA_SIZE="size",D.META_DATA_MIME="mime";function C(b){const n=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(S=>{const[w,p]=S.split(":");w&&p&&n.set(w,p)});const d=b.path.substring(0,b.path.indexOf(";"));return d&&n.set(D.META_DATA_MIME,d),n}D.parseMetaData=C})(P||(e.DataUri=P={}));function m(D,C,b){if(C){let n=D.path;return n&&n[0]!==u.posix.sep&&(n=u.posix.sep+n),D.with({scheme:b,authority:C,path:n})}return D.with({scheme:b})}e.toLocalResource=m}),define(Ce[16],De([1,0,21,8,3,4,24,9,154]),function(re,e,c,R,u,O,L,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(be){return!!be&&typeof be.then=="function"}e.isThenable=g;function T(be){const M=new c.CancellationTokenSource,Q=be(M.token),fe=new Promise((we,_)=>{const ne=M.token.onCancellationRequested(()=>{ne.dispose(),M.dispose(),_(new R.CancellationError)});Promise.resolve(Q).then(le=>{ne.dispose(),M.dispose(),we(le)},le=>{ne.dispose(),M.dispose(),_(le)})});return new class{cancel(){M.cancel()}then(we,_){return fe.then(we,_)}catch(we){return this.then(void 0,we)}finally(we){return fe.finally(we)}}}e.createCancelablePromise=T;function P(be,M,Q){return new Promise((fe,we)=>{const _=M.onCancellationRequested(()=>{_.dispose(),fe(Q)});be.then(fe,we).finally(()=>_.dispose())})}e.raceCancellation=P;function m(be,M){return new Promise((Q,fe)=>{const we=M.onCancellationRequested(()=>{we.dispose(),fe(new R.CancellationError)});be.then(Q,fe).finally(()=>we.dispose())})}e.raceCancellationError=m;async function D(be){let M=-1;const Q=be.map((fe,we)=>fe.then(_=>(M=we,_)));try{return await Promise.race(Q)}finally{be.forEach((fe,we)=>{we!==M&&fe.cancel()})}}e.raceCancellablePromises=D;function C(be,M,Q){let fe;const we=setTimeout(()=>{fe?.(void 0),Q?.()},M);return Promise.race([be.finally(()=>clearTimeout(we)),new Promise(_=>fe=_)])}e.raceTimeout=C;function b(be){return new Promise((M,Q)=>{const fe=be();g(fe)?fe.then(M,Q):M(fe)})}e.asPromise=b;class n{constructor(){this.a=null,this.b=null,this.d=null}queue(M){if(this.a){if(this.d=M,!this.b){const Q=()=>{this.b=null;const fe=this.queue(this.d);return this.d=null,fe};this.b=new Promise(fe=>{this.a.then(Q,Q).then(fe)})}return new Promise((Q,fe)=>{this.b.then(Q,fe)})}return this.a=M(),new Promise((Q,fe)=>{this.a.then(we=>{this.a=null,Q(we)},we=>{this.a=null,fe(we)})})}}e.Throttler=n;class h{constructor(){this.a=Promise.resolve(null)}queue(M){return this.a=this.a.then(()=>M(),()=>M())}}e.Sequencer=h;class d{constructor(){this.a=new Map}queue(M,Q){const we=(this.a.get(M)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(M)===we&&this.a.delete(M)});return this.a.set(M,we),we}}e.SequencerByKey=d;const S=(be,M)=>{let Q=!0;const fe=setTimeout(()=>{Q=!1,M()},be);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(fe),Q=!1}}},w=be=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,be())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};class p{constructor(M){this.defaultDelay=M,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(M,Q=this.defaultDelay){this.g=M,this.h(),this.b||(this.b=new Promise((we,_)=>{this.d=we,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const fe=()=>{this.a=null,this.d?.(null)};return this.a=Q===y.MicrotaskDelay?w(fe):S(Q,fe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class t{constructor(M){this.a=new p(M),this.b=new n}trigger(M,Q){return this.a.trigger(()=>this.b.queue(M),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class a{constructor(){this.a=!1,this.b=new Promise((M,Q)=>{this.d=M})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=a;class r extends a{constructor(M){super(),this.f=setTimeout(()=>this.open(),M)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function o(be,M){return M?new Promise((Q,fe)=>{const we=setTimeout(()=>{_.dispose(),Q()},be),_=M.onCancellationRequested(()=>{clearTimeout(we),_.dispose(),fe(new R.CancellationError)})}):T(Q=>o(be,Q))}e.timeout=o;function f(be,M=0){const Q=setTimeout(be,M);return(0,O.toDisposable)(()=>clearTimeout(Q))}e.disposableTimeout=f;function v(be){const M=[];let Q=0;const fe=be.length;function we(){return Q<fe?be[Q++]():null}function _(ne){ne!=null&&M.push(ne);const le=we();return le?le.then(_):Promise.resolve(M)}return Promise.resolve(null).then(_)}e.sequence=v;function l(be,M=fe=>!!fe,Q=null){let fe=0;const we=be.length,_=()=>{if(fe>=we)return Promise.resolve(Q);const ne=be[fe++];return Promise.resolve(ne()).then(te=>M(te)?Promise.resolve(te):_())};return _()}e.first=l;function I(be,M=fe=>!!fe,Q=null){if(be.length===0)return Promise.resolve(Q);let fe=be.length;const we=()=>{fe=-1;for(const _ of be)_.cancel?.()};return new Promise((_,ne)=>{for(const le of be)le.then(te=>{--fe>=0&&M(te)?(we(),_(te)):fe===0&&_(Q)}).catch(te=>{--fe>=0&&(we(),ne(te))})})}e.firstParallel=I;class E{constructor(M){this.a=0,this.d=M,this.f=[],this.b=0,this.g=new u.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(M){return this.a++,new Promise((Q,fe)=>{this.f.push({factory:M,c:Q,e:fe}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const M=this.f.shift();this.b++;const Q=M.factory();Q.then(M.c,M.e),Q.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=E;class s extends E{constructor(){super(1)}}e.Queue=s;class i{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const M=new V;return this.b.add(M),M.p}d(){for(const[,M]of this.a)if(M.size>0)return!1;return!0}queueFor(M,Q=L.extUri){const fe=Q.getComparisonKey(M);let we=this.a.get(fe);return we||(we=new s,u.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(fe),this.f()}),this.a.set(fe,we)),we}f(){this.d()&&this.g()}g(){for(const M of this.b)M.complete();this.b.clear()}dispose(){for(const[,M]of this.a)M.dispose();this.a.clear(),this.g()}}e.ResourceQueue=i;class k{constructor(M,Q){this.a=-1,typeof M=="function"&&typeof Q=="number"&&this.setIfNotSet(M,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(M,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,M()},Q)}setIfNotSet(M,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,M()},Q))}}e.TimeoutTimer=k;class F{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(M,Q){this.cancel(),this.a=setInterval(()=>{M()},Q)}}e.IntervalTimer=F;class ${constructor(M,Q){this.b=-1,this.a=M,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(M=this.d){this.cancel(),this.b=setTimeout(this.f,M)}get delay(){return this.d}set delay(M){this.d=M}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=$;class j{constructor(M,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=M,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(M=this.b){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(M/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=j;class W extends ${constructor(M,Q){super(M,Q),this.j=[]}work(M){this.j.push(M),this.isScheduled()||this.schedule()}h(){const M=this.j;this.j=[],this.a?.(M)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=W;class U extends O.Disposable{constructor(M,Q){super(),this.g=M,this.h=Q,this.a=[],this.b=this.B(new O.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(M){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+M.length>this.g.maxBufferedWork)return!1}else if(this.pending+M.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of M)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new $(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=be=>{(0,A.setTimeout0)(()=>{if(M)return;const Q=Date.now()+15;be(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Q-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:e.runWhenIdle=(be,M)=>{const Q=requestIdleCallback(be,typeof M=="number"?{timeout:M}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,cancelIdleCallback(Q))}}}}();class x{constructor(M){this.d=!1,this.a=()=>{try{this.f=M()}catch(Q){this.g=Q}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=x;async function B(be,M,Q){let fe;for(let we=0;we<Q;we++)try{return await be()}catch(_){fe=_,await o(M)}throw fe}e.retry=B;class z{hasPending(M){return this.a?typeof M=="number"?this.a.taskId===M:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(M,Q,fe){return this.a={taskId:M,cancel:()=>fe?.(),promise:Q},Q.then(()=>this.d(M),()=>this.d(M)),Q}d(M){this.a&&M===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const M=this.b;this.b=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this.b)this.b.run=M;else{let Q,fe;const we=new Promise((_,ne)=>{Q=_,fe=ne});this.b={run:M,promise:we,promiseResolve:Q,promiseReject:fe}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=z;class ee{constructor(M,Q=()=>Date.now()){this.d=M,this.f=Q,this.a=0,this.b=0}increment(){const M=this.f();return M-this.a>this.d&&(this.a=M,this.b=0),this.b++,this.b}}e.IntervalCounter=ee;var se;(function(be){be[be.Resolved=0]="Resolved",be[be.Rejected=1]="Rejected"})(se||(se={}));class V{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((M,Q)=>{this.a=M,this.b=Q})}complete(M){return new Promise(Q=>{this.a(M),this.d={outcome:0,value:M},Q()})}error(M){return new Promise(Q=>{this.b(M),this.d={outcome:1,value:M},Q()})}cancel(){return this.error(new R.CancellationError)}}e.DeferredPromise=V;var Z;(function(be){async function M(fe){let we;const _=await Promise.all(fe.map(ne=>ne.then(le=>le,le=>{we||(we=le)})));if(typeof we<"u")throw we;return _}be.settled=M;function Q(fe){return new Promise(async(we,_)=>{try{await fe(we,_)}catch(ne){_(ne)}})}be.withAsyncBody=Q})(Z||(e.Promises=Z={}));var q;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(q||(q={}));class ae{static fromArray(M){return new ae(Q=>{Q.emitMany(M)})}static fromPromise(M){return new ae(async Q=>{Q.emitMany(await M)})}static fromPromises(M){return new ae(async Q=>{await Promise.all(M.map(async fe=>Q.emitOne(await fe)))})}static merge(M){return new ae(async Q=>{await Promise.all(M.map(async fe=>{for await(const we of fe)Q.emitOne(we)}))})}constructor(M){this.a=0,this.b=[],this.d=null,this.f=new u.Emitter,queueMicrotask(async()=>{const Q={emitOne:fe=>this.g(fe),emitMany:fe=>this.h(fe),reject:fe=>this.k(fe)};try{await Promise.resolve(M(Q)),this.j()}catch(fe){this.k(fe)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(M<this.b.length)return{done:!1,value:this.b[M++]};if(this.a===1)return{done:!0,value:void 0};await u.Event.toPromise(this.f.event)}while(!0)}}}static map(M,Q){return new ae(async fe=>{for await(const we of M)fe.emitOne(Q(we))})}map(M){return ae.map(this,M)}static filter(M,Q){return new ae(async fe=>{for await(const we of M)Q(we)&&fe.emitOne(we)})}filter(M){return ae.filter(this,M)}static coalesce(M){return ae.filter(M,Q=>!!Q)}coalesce(){return ae.coalesce(this)}static async toPromise(M){const Q=[];for await(const fe of M)Q.push(fe);return Q}toPromise(){return ae.toPromise(this)}g(M){this.a===0&&(this.b.push(M),this.f.fire())}h(M){this.a===0&&(this.b=this.b.concat(M),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(M){this.a===0&&(this.a=2,this.d=M,this.f.fire())}}e.AsyncIterableObject=ae,ae.EMPTY=ae.fromArray([]);class Ee extends ae{constructor(M,Q){super(Q),this.l=M}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Ee;function ye(be){const M=new c.CancellationTokenSource,Q=be(M.token);return new Ee(M,async fe=>{const we=M.token.onCancellationRequested(()=>{we.dispose(),M.dispose(),fe.reject(new R.CancellationError)});try{for await(const _ of Q){if(M.token.isCancellationRequested)return;fe.emitOne(_)}we.dispose(),M.dispose()}catch(_){we.dispose(),M.dispose(),fe.reject(_)}})}e.createCancelableAsyncIterable=ye}),define(Ce[32],De([1,0,19,16,30,28,10,9,11]),function(re,e,c,R,u,O,L,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",P="[^/\\\\]",m=/\//g;function D(ee,se){switch(ee){case 0:return"";case 1:return`${P}*?`;default:return`(?:${T}|${P}+${T}${se?`|${T}${P}+`:""})*?`}}function C(ee,se){if(!ee)return[];const V=[];let Z=!1,q=!1,ae="";for(const Ee of ee){switch(Ee){case se:if(!Z&&!q){V.push(ae),ae="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":q=!0;break;case"]":q=!1;break}ae+=Ee}return ae&&V.push(ae),V}e.splitGlobAware=C;function b(ee){if(!ee)return"";let se="";const V=C(ee,e.GLOB_SPLIT);if(V.every(Z=>Z===e.GLOBSTAR))se=".*";else{let Z=!1;V.forEach((q,ae)=>{if(q===e.GLOBSTAR){if(Z)return;se+=D(2,ae===V.length-1)}else{let Ee=!1,ye="",be=!1,M="";for(const Q of q){if(Q!=="}"&&Ee){ye+=Q;continue}if(be&&(Q!=="]"||!M)){let fe;Q==="-"?fe=Q:(Q==="^"||Q==="!")&&!M?fe="^":Q===e.GLOB_SPLIT?fe="":fe=(0,y.escapeRegExpCharacters)(Q),M+=fe;continue}switch(Q){case"{":Ee=!0;continue;case"[":be=!0;continue;case"}":{const we=`(?:${C(ye,",").map(_=>b(_)).join("|")})`;se+=we,Ee=!1,ye="";break}case"]":{se+="["+M+"]",be=!1,M="";break}case"?":se+=P;continue;case"*":se+=D(1);continue;default:se+=(0,y.escapeRegExpCharacters)(Q)}}ae<V.length-1&&(V[ae+1]!==e.GLOBSTAR||ae+2<V.length)&&(se+=T)}Z=q===e.GLOBSTAR})}return se}const n=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.LRUCache(1e4),a=function(){return!1},r=function(){return null};function o(ee,se){if(!ee)return r;let V;typeof ee!="string"?V=ee.pattern:V=ee,V=V.trim();const Z=`${V}_${!!se.trimForExclusions}`;let q=t.get(Z);if(q)return f(q,ee);let ae;return n.test(V)?q=l(V.substr(4),V):(ae=h.exec(v(V,se)))?q=I(ae[1],V):(se.trimForExclusions?S:d).test(V)?q=E(V,se):(ae=w.exec(v(V,se)))?q=s(ae[1].substr(1),V,!0):(ae=p.exec(v(V,se)))?q=s(ae[1],V,!1):q=i(V),t.set(Z,q),f(q,ee)}function f(ee,se){if(typeof se=="string")return ee;const V=function(Z,q){return(0,u.isEqualOrParent)(Z,se.base,!A.isLinux)?ee((0,y.ltrim)(Z.substr(se.base.length),L.sep),q):null};return V.allBasenames=ee.allBasenames,V.allPaths=ee.allPaths,V.basenames=ee.basenames,V.patterns=ee.patterns,V}function v(ee,se){return se.trimForExclusions&&ee.endsWith("/**")?ee.substr(0,ee.length-2):ee}function l(ee,se){return function(V,Z){return typeof V=="string"&&V.endsWith(ee)?se:null}}function I(ee,se){const V=`/${ee}`,Z=`\\${ee}`,q=function(Ee,ye){return typeof Ee!="string"?null:ye?ye===ee?se:null:Ee===ee||Ee.endsWith(V)||Ee.endsWith(Z)?se:null},ae=[ee];return q.basenames=ae,q.patterns=[se],q.allBasenames=ae,q}function E(ee,se){const V=B(ee.slice(1,-1).split(",").map(ye=>o(ye,se)).filter(ye=>ye!==r),ee),Z=V.length;if(!Z)return r;if(Z===1)return V[0];const q=function(ye,be){for(let M=0,Q=V.length;M<Q;M++)if(V[M](ye,be))return ee;return null},ae=V.find(ye=>!!ye.allBasenames);ae&&(q.allBasenames=ae.allBasenames);const Ee=V.reduce((ye,be)=>be.allPaths?ye.concat(be.allPaths):ye,[]);return Ee.length&&(q.allPaths=Ee),q}function s(ee,se,V){const Z=L.sep===L.posix.sep,q=Z?ee:ee.replace(m,L.sep),ae=L.sep+q,Ee=L.posix.sep+ee;let ye;return V?ye=function(be,M){return typeof be=="string"&&(be===q||be.endsWith(ae)||!Z&&(be===ee||be.endsWith(Ee)))?se:null}:ye=function(be,M){return typeof be=="string"&&(be===q||!Z&&be===ee)?se:null},ye.allPaths=[(V?"*/":"./")+ee],ye}function i(ee){try{const se=new RegExp(`^${b(ee)}$`);return function(V){return se.lastIndex=0,typeof V=="string"&&se.test(V)?ee:null}}catch{return r}}function k(ee,se,V){return!ee||typeof se!="string"?!1:F(ee)(se,void 0,V)}e.match=k;function F(ee,se={}){if(!ee)return a;if(typeof ee=="string"||$(ee)){const V=o(ee,se);if(V===r)return a;const Z=function(q,ae){return!!V(q,ae)};return V.allBasenames&&(Z.allBasenames=V.allBasenames),V.allPaths&&(Z.allPaths=V.allPaths),Z}return U(ee,se)}e.parse=F;function $(ee){const se=ee;return se?typeof se.base=="string"&&typeof se.pattern=="string":!1}e.isRelativePattern=$;function j(ee){return ee.allBasenames||[]}e.getBasenameTerms=j;function W(ee){return ee.allPaths||[]}e.getPathTerms=W;function U(ee,se){const V=B(Object.getOwnPropertyNames(ee).map(ye=>x(ye,ee[ye],se)).filter(ye=>ye!==r)),Z=V.length;if(!Z)return r;if(!V.some(ye=>!!ye.requiresSiblings)){if(Z===1)return V[0];const ye=function(Q,fe){let we;for(let _=0,ne=V.length;_<ne;_++){const le=V[_](Q,fe);if(typeof le=="string")return le;(0,R.isThenable)(le)&&(we||(we=[]),we.push(le))}return we?(async()=>{for(const _ of we){const ne=await _;if(typeof ne=="string")return ne}return null})():null},be=V.find(Q=>!!Q.allBasenames);be&&(ye.allBasenames=be.allBasenames);const M=V.reduce((Q,fe)=>fe.allPaths?Q.concat(fe.allPaths):Q,[]);return M.length&&(ye.allPaths=M),ye}const q=function(ye,be,M){let Q,fe;for(let we=0,_=V.length;we<_;we++){const ne=V[we];ne.requiresSiblings&&M&&(be||(be=(0,L.basename)(ye)),Q||(Q=be.substr(0,be.length-(0,L.extname)(ye).length)));const le=ne(ye,be,Q,M);if(typeof le=="string")return le;(0,R.isThenable)(le)&&(fe||(fe=[]),fe.push(le))}return fe?(async()=>{for(const we of fe){const _=await we;if(typeof _=="string")return _}return null})():null},ae=V.find(ye=>!!ye.allBasenames);ae&&(q.allBasenames=ae.allBasenames);const Ee=V.reduce((ye,be)=>be.allPaths?ye.concat(be.allPaths):ye,[]);return Ee.length&&(q.allPaths=Ee),q}function x(ee,se,V){if(se===!1)return r;const Z=o(ee,V);if(Z===r)return r;if(typeof se=="boolean")return Z;if(se){const q=se.when;if(typeof q=="string"){const ae=(Ee,ye,be,M)=>{if(!M||!Z(Ee,ye))return null;const Q=q.replace("$(basename)",()=>be),fe=M(Q);return(0,R.isThenable)(fe)?fe.then(we=>we?ee:null):fe?ee:null};return ae.requiresSiblings=!0,ae}}return Z}function B(ee,se){const V=ee.filter(ye=>!!ye.basenames);if(V.length<2)return ee;const Z=V.reduce((ye,be)=>{const M=be.basenames;return M?ye.concat(M):ye},[]);let q;if(se){q=[];for(let ye=0,be=Z.length;ye<be;ye++)q.push(se)}else q=V.reduce((ye,be)=>{const M=be.patterns;return M?ye.concat(M):ye},[]);const ae=function(ye,be){if(typeof ye!="string")return null;if(!be){let Q;for(Q=ye.length;Q>0;Q--){const fe=ye.charCodeAt(Q-1);if(fe===47||fe===92)break}be=ye.substr(Q)}const M=Z.indexOf(be);return M!==-1?q[M]:null};ae.basenames=Z,ae.patterns=q,ae.allBasenames=Z;const Ee=ee.filter(ye=>!ye.basenames);return Ee.push(ae),Ee}function z(ee,se){return(0,c.equals)(ee,se,(V,Z)=>typeof V=="string"&&typeof Z=="string"?V===Z:typeof V!="string"&&typeof Z!="string"?V.base===Z.base&&V.pattern===Z.pattern:!1)}e.patternsEquals=z}),define(Ce[116],De([1,0,8,155,24,11,2]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(A||(e.MarkdownStringTextNewlineStyle=A={}));class y{constructor(h="",d=!1){if(this.value=h,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(h,d=0){return this.value+=m(this.supportThemeIcons?(0,R.escapeIcons)(h):h).replace(/([ \t]+)/g,(S,w)=>"&nbsp;".repeat(w.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,d){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}appendLink(h,d,S){return this.value+="[",this.value+=this.c(d,"]"),this.value+="](",this.value+=this.c(String(h),")"),S&&(this.value+=` "${this.c(this.c(S,'"'),")")}"`),this.value+=")",this}c(h,d){const S=new RegExp((0,O.escapeRegExpCharacters)(d),"g");return h.replace(S,(w,p)=>h.charAt(p-1)!=="\\"?`\\${w}`:w)}}e.MarkdownString=y;function g(n){return T(n)?!n.value:Array.isArray(n)?n.every(g):!0}e.isEmptyMarkdownString=g;function T(n){return n instanceof y?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||typeof n.isTrusted=="object"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function P(n,h){return n===h?!0:!n||!h?!1:n.value===h.value&&n.isTrusted===h.isTrusted&&n.supportThemeIcons===h.supportThemeIcons&&n.supportHtml===h.supportHtml&&(n.baseUri===h.baseUri||!!n.baseUri&&!!h.baseUri&&(0,u.isEqual)(L.URI.from(n.baseUri),L.URI.from(h.baseUri)))}e.markdownStringEqual=P;function m(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function D(n){return n.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=D;function C(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=C;function b(n){const h=[],d=n.split("|").map(w=>w.trim());n=d[0];const S=d[1];if(S){const w=/height=(\d+)/.exec(S),p=/width=(\d+)/.exec(S),t=w?w[1]:"",a=p?p[1]:"",r=isFinite(parseInt(a)),o=isFinite(parseInt(t));r&&h.push(`width="${a}"`),o&&h.push(`height="${t}"`)}return{href:n,dimensions:h}}e.parseHrefAndDimensions=b}),define(Ce[117],De([1,0,19,30,10,9,24,11]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitRecentLabel=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(o,f){const{os:v,tildify:l,relative:I}=f;if(I){const i=g(o,I,v);if(typeof i=="string")return i}let E=o.fsPath;if(v===1&&!O.isWindows?E=E.replace(/\//g,"\\"):v!==1&&O.isWindows&&(E=E.replace(/\\/g,"/")),v!==1&&l?.userHome){const i=l.userHome.fsPath;let k;o.scheme!==l.userHome.scheme&&o.path.startsWith(u.posix.sep)?k=l.userHome.with({path:o.path}).fsPath:k=o.fsPath,E=m(k,i,v)}return(v===1?u.win32:u.posix).normalize(T(E,v===1))}e.getPathLabel=y;function g(o,f,v){const l=v===1?u.win32:u.posix,I=v===3?L.extUri:L.extUriIgnorePathCase,E=f.getWorkspace(),s=(0,c.firstOrDefault)(E.folders);if(!s)return;o.scheme!==s.uri.scheme&&o.path.startsWith(u.posix.sep)&&(o=s.uri.with({path:o.path}));const i=f.getWorkspaceFolder(o);if(!i)return;let k;if(I.isEqual(i.uri,o)?k="":k=I.relativePath(i.uri,o)??"",k&&(k=l.normalize(k)),E.folders.length>1&&!f.noPrefix){const F=i.name?i.name:I.basenameOrAuthority(i.uri);k=k?`${F} \u2022 ${k}`:F}return k}function T(o,f=O.isWindows){return(0,R.hasDriveLetter)(o,f)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=T;let P=Object.create(null);function m(o,f,v=O.OS){if(v===1||!o||!f)return o;let l=P.original===f?P.normalized:void 0;l||(l=f,O.isWindows&&(l=(0,R.toSlashes)(l)),l=`${(0,A.rtrim)(l,u.posix.sep)}${u.posix.sep}`,P={original:f,normalized:l});let I=o;return O.isWindows&&(I=(0,R.toSlashes)(I)),(v===3?I.startsWith(l):(0,A.startsWithIgnoreCase)(I,l))?`~/${I.substr(l.length)}`:o}e.tildify=m;function D(o,f){return o.replace(/^~($|\/|\\)/,`${f}$1`)}e.untildify=D;const C="\u2026",b="\\\\",n="~";function h(o,f=u.sep){const v=new Array(o.length);let l=!1;for(let I=0;I<o.length;I++){const E=o[I];if(E===""){v[I]=`.${f}`;continue}if(!E){v[I]=E;continue}l=!0;let s="",i=E;i.indexOf(b)===0?(s=i.substr(0,i.indexOf(b)+b.length),i=i.substr(i.indexOf(b)+b.length)):i.indexOf(f)===0?(s=i.substr(0,i.indexOf(f)+f.length),i=i.substr(i.indexOf(f)+f.length)):i.indexOf(n)===0&&(s=i.substr(0,i.indexOf(n)+n.length),i=i.substr(i.indexOf(n)+n.length));const k=i.split(f);for(let F=1;l&&F<=k.length;F++)for(let $=k.length-F;l&&$>=0;$--){l=!1;let j=k.slice($,$+F).join(f);for(let W=0;!l&&W<o.length;W++)if(W!==I&&o[W]&&o[W].indexOf(j)>-1){const U=$+F===k.length,x=$>0&&o[W].indexOf(f)>-1?f+j:j,B=o[W].endsWith(x);l=!U||B}if(!l){let W="";(k[0].endsWith(":")||s!=="")&&($===1&&($=0,F++,j=k[0]+f+j),$>0&&(W=k[0]+f),W=s+W),$>0&&(W=W+C+f),W=W+j,$+F<k.length&&(W=W+f+C),v[I]=W}}l&&(v[I]=E)}return v}e.shorten=h;var d;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function S(o,f=Object.create(null)){const v=[];let l=!1,I="";for(const E of o)if(E==="$"||l&&E==="{")I&&v.push({value:I,type:d.TEXT}),I="",l=!0;else if(E==="}"&&l){const s=f[I];if(typeof s=="string")s.length&&v.push({value:s,type:d.VARIABLE});else if(s){const i=v[v.length-1];(!i||i.type!==d.SEPARATOR)&&v.push({value:s.label,type:d.SEPARATOR})}I="",l=!1}else I+=E;return I&&!l&&v.push({value:I,type:d.TEXT}),v.filter((E,s)=>{if(E.type===d.SEPARATOR){const i=v[s-1],k=v[s+1];return[i,k].every(F=>F&&(F.type===d.VARIABLE||F.type===d.TEXT)&&F.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=S;function w(o,f){return O.isMacintosh||f?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.isMacintosh?"&":"&&"):o.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=w;function p(o,f){return O.isMacintosh||f?o.replace(/\(&&\w\)|&&/g,""):O.isWindows?o.replace(/&&|&/g,v=>v==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function t(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=t;function a(o){if(o.endsWith("]")){const f=o.lastIndexOf(" [",o.length-2);if(f!==-1){const v=r(o.substring(0,f));return{name:v.name,parentPath:v.parentPath+o.substring(f)}}}return r(o)}e.splitRecentLabel=a;function r(o){const f=o.indexOf("/")!==-1?u.posix:u.win32,v=f.basename(o),l=f.dirname(o);return v.length?{name:v,parentPath:l}:{name:l,parentPath:""}}}),define(Ce[118],De([1,0,22,2]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function u(P){return P.toJSON()}class O{constructor(m){this.a=m}transformIncoming(m){const D=this.a.transformIncoming(m);return D===m?m:u(R.URI.from(D))}transformOutgoing(m){const D=this.a.transformOutgoing(m);return D===m?m:u(R.URI.from(D))}transformOutgoingURI(m){const D=this.a.transformOutgoing(m);return D===m?m:R.URI.from(D)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function L(P,m,D){if(!P||D>200)return null;if(typeof P=="object"){if(P instanceof R.URI)return m.transformOutgoing(P);for(const C in P)if(Object.hasOwnProperty.call(P,C)){const b=L(P[C],m,D+1);b!==null&&(P[C]=b)}}return null}function A(P,m){const D=L(P,m,0);return D===null?P:D}e.transformOutgoingURIs=A;function y(P,m,D,C){if(!P||C>200)return null;if(typeof P=="object"){if(P.$mid===1)return D?R.URI.revive(m.transformIncoming(P)):m.transformIncoming(P);if(P instanceof c.VSBuffer)return null;for(const b in P)if(Object.hasOwnProperty.call(P,b)){const n=y(P[b],m,D,C+1);n!==null&&(P[b]=n)}}return null}function g(P,m){const D=y(P,m,!1,0);return D===null?P:D}e.transformIncomingURIs=g;function T(P,m){const D=y(P,m,!0,0);return D===null?P:D}e.transformAndReviveIncomingURIs=T}),define(Ce[33],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(u){return c.test(u)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let u;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?u=crypto.getRandomValues.bind(crypto):u=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const O=new Uint8Array(16),L=[];for(let A=0;A<256;A++)L.push(A.toString(16).padStart(2,"0"));return function(){u(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let y=0,g="";return g+=L[O[y++]],g+=L[O[y++]],g+=L[O[y++]],g+=L[O[y++]],g+="-",g+=L[O[y++]],g+=L[O[y++]],g+="-",g+=L[O[y++]],g+=L[O[y++]],g+="-",g+=L[O[y++]],g+=L[O[y++]],g+="-",g+=L[O[y++]],g+=L[O[y++]],g+=L[O[y++]],g+=L[O[y++]],g+=L[O[y++]],g+=L[O[y++]],g}}()}),define(Ce[157],De([1,0,19,53,33]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.matchesMimeType=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function O(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.createStringDataTransferItem=O;function L(P,m,D){const C={id:(0,u.generateUuid)(),name:P,uri:m,data:D};return{asString:async()=>"",asFile:()=>C,value:void 0}}e.createFileDataTransferItem=L;class A{constructor(){this.a=new Map}get size(){let m=0;for(const D of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const D=[...this.a.keys()];return R.Iterable.some(this,([C,b])=>b.asFile())&&D.push("files"),T(y(m),D)}get(m){return this.a.get(this.b(m))?.[0]}append(m,D){const C=this.a.get(m);C?C.push(D):this.a.set(this.b(m),[D])}replace(m,D){this.a.set(this.b(m),[D])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,D]of this.a)for(const C of D)yield[m,C]}b(m){return y(m)}}e.VSDataTransfer=A;function y(P){return P.toLowerCase()}function g(P,m){return T(y(P),m.map(y))}e.matchesMimeType=g;function T(P,m){if(P==="*/*")return m.length>0;if(m.includes(P))return!0;const D=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!D)return!1;const[C,b,n]=D;return n==="*"?m.some(h=>h.startsWith(b+"/")):!1}e.UriList=Object.freeze({create:P=>(0,c.distinct)(P.map(m=>m.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.UriList.split(P).filter(m=>!m.startsWith("#"))})}),define(Ce[29],De([1,0,48,74,344,16,30,69,10,9,24,2]),function(re,e,c,R,u,O,L,A,y,g,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function D(U,x=m.UNLINK,B){if((0,L.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?b(U):C(U,B)}async function C(U,x=(0,L.randomPath)((0,R.tmpdir)())){try{try{await c.promises.rename(U,x)}catch(B){return B.code==="ENOENT"?void 0:b(U)}b(x).catch(B=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function b(U){return(0,u.promisify)(c.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function n(U){if((0,L.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=n;async function h(U,x){return w(await(x?d(U):(0,u.promisify)(c.readdir)(U)))}async function d(U){try{return await(0,u.promisify)(c.readdir)(U,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const x=[],B=await h(U);for(const z of B){let ee=!1,se=!1,V=!1;try{const Z=await e.Promises.lstat((0,y.join)(U,z));ee=Z.isFile(),se=Z.isDirectory(),V=Z.isSymbolicLink()}catch(Z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Z)}x.push({name:z,isFile:()=>ee,isDirectory:()=>se,isSymbolicLink:()=>V})}return x}function S(U){return w(c.readdirSync(U))}e.readdirSync=S;function w(U){return U.map(x=>typeof x=="string"?g.isMacintosh?(0,A.normalizeNFC)(x):x:(x.name=g.isMacintosh?(0,A.normalizeNFC)(x.name):x.name,x))}async function p(U){const x=await h(U),B=[];for(const z of x)await a.existsDirectory((0,y.join)(U,z))&&B.push(z);return B}function t(U,x=1e3){return new Promise(B=>{let z=!1;const ee=setInterval(()=>{z||(z=!0,c.access(U,se=>{z=!1,se&&(clearInterval(ee),B(void 0))}))},x)})}e.whenDeleted=t;var a;(function(U){async function x(ee){let se;try{if(se=await e.Promises.lstat(ee),!se.isSymbolicLink())return{stat:se}}catch{}try{return{stat:await e.Promises.stat(ee),symbolicLink:se?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&se)return{stat:se,symbolicLink:{dangling:!0}};if(g.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ee)),symbolicLink:{dangling:!1}}}catch(Z){if(Z.code==="ENOENT"&&se)return{stat:se,symbolicLink:{dangling:!0}};throw Z}throw V}}U.stat=x;async function B(ee){try{const{stat:se,symbolicLink:V}=await U.stat(ee);return se.isFile()&&V?.dangling!==!0}catch{}return!1}U.existsFile=B;async function z(ee){try{const{stat:se,symbolicLink:V}=await U.stat(ee);return se.isDirectory()&&V?.dangling!==!0}catch{}return!1}U.existsDirectory=z})(a||(e.SymlinkSupport=a={}));const r=new O.ResourceQueue;function o(U,x,B){return r.queueFor(P.URI.file(U),T.extUriBiasedIgnorePathCase).queue(()=>{const z=E(B);return new Promise((ee,se)=>l(U,x,z,V=>V?se(V):ee()))})}let f=!0;function v(U){f=U}e.configureFlushOnWrite=v;function l(U,x,B,z){if(!f)return c.writeFile(U,x,{mode:B.mode,flag:B.flag},z);c.open(U,B.flag,B.mode,(ee,se)=>{if(ee)return z(ee);c.writeFile(se,x,V=>{if(V)return c.close(se,()=>z(V));c.fdatasync(se,Z=>(Z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Z),v(!1)),c.close(se,q=>z(q))))})})}function I(U,x,B){const z=E(B);if(!f)return c.writeFileSync(U,x,{mode:z.mode,flag:z.flag});const ee=c.openSync(U,z.flag,z.mode);try{c.writeFileSync(ee,x);try{c.fdatasyncSync(ee)}catch(se){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",se),v(!1)}}finally{c.closeSync(ee)}}e.writeFileSync=I;function E(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function s(U,x){if(U!==x)try{await e.Promises.rename(U,x)}catch(B){if(U.toLowerCase()!==x.toLowerCase()&&B.code==="EXDEV"||U.endsWith("."))await i(U,x,{preserveSymlinks:!1}),await D(U,m.MOVE);else throw B}}async function i(U,x,B){return F(U,x,{root:{source:U,target:x},options:B,handledSourcePaths:new Set})}const k=511;async function F(U,x,B){if(B.handledSourcePaths.has(U))return;B.handledSourcePaths.add(U);const{stat:z,symbolicLink:ee}=await a.stat(U);if(ee){if(B.options.preserveSymlinks)try{return await W(U,x,B)}catch(se){console.warn("[node.js fs] copy of symlink failed: ",se)}if(ee.dangling)return}return z.isDirectory()?$(U,x,z.mode&k,B):j(U,x,z.mode&k)}async function $(U,x,B,z){await e.Promises.mkdir(x,{recursive:!0,mode:B});const ee=await h(U);for(const se of ee)await F((0,y.join)(U,se),(0,y.join)(x,se),z)}async function j(U,x,B){await e.Promises.copyFile(U,x),await e.Promises.chmod(x,B)}async function W(U,x,B){let z=await e.Promises.readlink(U);(0,L.isEqualOrParent)(z,B.root.source,!g.isLinux)&&(z=(0,y.join)(B.root.target,z.substr(B.root.source.length+1))),await e.Promises.symlink(z,x)}e.Promises=new class{get access(){return(0,u.promisify)(c.access)}get stat(){return(0,u.promisify)(c.stat)}get lstat(){return(0,u.promisify)(c.lstat)}get utimes(){return(0,u.promisify)(c.utimes)}get read(){return(U,x,B,z,ee)=>new Promise((se,V)=>{c.read(U,x,B,z,ee,(Z,q,ae)=>Z?V(Z):se({bytesRead:q,buffer:ae}))})}get readFile(){return(0,u.promisify)(c.readFile)}get write(){return(U,x,B,z,ee)=>new Promise((se,V)=>{c.write(U,x,B,z,ee,(Z,q,ae)=>Z?V(Z):se({bytesWritten:q,buffer:ae}))})}get appendFile(){return(0,u.promisify)(c.appendFile)}get fdatasync(){return(0,u.promisify)(c.fdatasync)}get truncate(){return(0,u.promisify)(c.truncate)}get rename(){return(0,u.promisify)(c.rename)}get copyFile(){return(0,u.promisify)(c.copyFile)}get open(){return(0,u.promisify)(c.open)}get close(){return(0,u.promisify)(c.close)}get symlink(){return(0,u.promisify)(c.symlink)}get readlink(){return(0,u.promisify)(c.readlink)}get chmod(){return(0,u.promisify)(c.chmod)}get mkdir(){return(0,u.promisify)(c.mkdir)}get unlink(){return(0,u.promisify)(c.unlink)}get rmdir(){return(0,u.promisify)(c.rmdir)}get realpath(){return(0,u.promisify)(c.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return p}get writeFile(){return o}get rm(){return D}get move(){return s}get copy(){return i}}}),define(Ce[94],De([1,0,48,10,9,11,29]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(m){if(u.isLinux)return m;const D=(0,R.dirname)(m);if(m===D)return m;const C=((0,R.basename)(m)||m).toLowerCase();try{const n=(0,L.readdirSync)(D).filter(h=>h.toLowerCase()===C);if(n.length===1){const h=A(D);if(h)return(0,R.join)(h,n[0])}else if(n.length>1){const h=n.indexOf(C);if(h>=0){const d=A(D);if(d)return(0,R.join)(d,n[h])}}}catch{}return null}e.realcaseSync=A;async function y(m){if(u.isLinux)return m;const D=(0,R.dirname)(m);if(m===D)return m;const C=((0,R.basename)(m)||m).toLowerCase();try{const n=(await L.Promises.readdir(D)).filter(h=>h.toLowerCase()===C);if(n.length===1){const h=await y(D);if(h)return(0,R.join)(h,n[0])}else if(n.length>1){const h=n.indexOf(C);if(h>=0){const d=await y(D);if(d)return(0,R.join)(d,n[h])}}}catch{}return null}e.realcase=y;async function g(m){try{return await L.Promises.realpath(m)}catch{const C=P(m);return await L.Promises.access(C,c.constants.R_OK),C}}e.realpath=g;function T(m){try{return c.realpathSync(m)}catch{const C=P(m);return c.accessSync(C,c.constants.R_OK),C}}e.realpathSync=T;function P(m){return(0,O.rtrim)((0,R.normalize)(m),R.sep)}}),define(Ce[95],De([1,0,10,9,39,92,12,29]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function y(P=u.env){return P.comspec||"cmd.exe"}e.getWindowsShell=y;function g(P){let m=[],D=!1;const C=function(b){if(D){m.push(b);return}(!P.send(b,h=>{if(h&&console.error(h),D=!1,m.length>0){const d=m.slice(0);m=[],d.forEach(S=>C(S))}})||R.isWindows)&&(D=!0)};return{send:C}}e.createQueuedSender=g;var T;(function(P){async function m(D,C,b){if(c.isAbsolute(D))return D;if(C===void 0&&(C=u.cwd()),c.dirname(D)!=="."||(b===void 0&&L.isString(u.env.PATH)&&(b=u.env.PATH.split(c.delimiter)),b===void 0||b.length===0))return c.join(C,D);async function h(d){if(await A.Promises.exists(d)){let S;try{S=await A.Promises.stat(d)}catch(w){w.message.startsWith("EACCES")&&(S=await A.Promises.lstat(d))}return S?!S.isDirectory():!1}return!1}for(const d of b){let S;if(c.isAbsolute(d)?S=c.join(d,D):S=c.join(C,d,D),await h(S))return S;let w=S+".com";if(await h(w)||(w=S+".exe",await h(w)))return w}return c.join(C,D)}P.findExecutable=m})(T||(e.win32=T={}))});var qe=this&&this.__decorate||function(re,e,c,R){var u=arguments.length,O=u<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,c):R,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(re,e,c,R);else for(var A=re.length-1;A>=0;A--)(L=re[A])&&(O=(u<3?L(O):u>3?L(e,c,O):L(e,c))||O);return u>3&&O&&Object.defineProperty(e,c,O),O};define(Ce[75],De([1,0,19,16,22,21,66,8,3,4,73,11,12]),function(re,e,c,R,u,O,L,A,y,g,T,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var D;(function(se){se[se.Promise=100]="Promise",se[se.PromiseCancel=101]="PromiseCancel",se[se.EventListen=102]="EventListen",se[se.EventDispose=103]="EventDispose"})(D||(D={}));function C(se){switch(se){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(se){se[se.Initialize=200]="Initialize",se[se.PromiseSuccess=201]="PromiseSuccess",se[se.PromiseError=202]="PromiseError",se[se.PromiseErrorObj=203]="PromiseErrorObj",se[se.EventFire=204]="EventFire"})(b||(b={}));function n(se){switch(se){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(se){se[se.Uninitialized=0]="Uninitialized",se[se.Idle=1]="Idle"})(h||(h={}));function d(se){let V=0;for(let Z=0;;Z+=7){const q=se.read(1);if(V|=(q.buffer[0]&127)<<Z,!(q.buffer[0]&128))return V}}const S=r(0);function w(se,V){if(V===0){se.write(S);return}let Z=0;for(let ae=V;ae!==0;ae=ae>>>7)Z++;const q=u.VSBuffer.alloc(Z);for(let ae=0;V!==0;ae++)q.buffer[ae]=V&127,V=V>>>7,V>0&&(q.buffer[ae]|=128);se.write(q)}class p{constructor(V){this.b=V,this.a=0}read(V){const Z=this.b.slice(this.a,this.a+V);return this.a+=Z.byteLength,Z}}e.BufferReader=p;class t{constructor(){this.a=[]}get buffer(){return u.VSBuffer.concat(this.a)}write(V){this.a.push(V)}}e.BufferWriter=t;var a;(function(se){se[se.Undefined=0]="Undefined",se[se.String=1]="String",se[se.Buffer=2]="Buffer",se[se.VSBuffer=3]="VSBuffer",se[se.Array=4]="Array",se[se.Object=5]="Object",se[se.Int=6]="Int"})(a||(a={}));function r(se){const V=u.VSBuffer.alloc(1);return V.writeUInt8(se,0),V}const o={Undefined:r(a.Undefined),String:r(a.String),Buffer:r(a.Buffer),VSBuffer:r(a.VSBuffer),Array:r(a.Array),Object:r(a.Object),Uint:r(a.Int)},f=typeof Buffer<"u";function v(se,V){if(typeof V>"u")se.write(o.Undefined);else if(typeof V=="string"){const Z=u.VSBuffer.fromString(V);se.write(o.String),w(se,Z.byteLength),se.write(Z)}else if(f&&Buffer.isBuffer(V)){const Z=u.VSBuffer.wrap(V);se.write(o.Buffer),w(se,Z.byteLength),se.write(Z)}else if(V instanceof u.VSBuffer)se.write(o.VSBuffer),w(se,V.byteLength),se.write(V);else if(Array.isArray(V)){se.write(o.Array),w(se,V.length);for(const Z of V)v(se,Z)}else if(typeof V=="number"&&(V|0)===V)se.write(o.Uint),w(se,V);else{const Z=u.VSBuffer.fromString(JSON.stringify(V));se.write(o.Object),w(se,Z.byteLength),se.write(Z)}}e.serialize=v;function l(se){switch(se.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return se.read(d(se)).toString();case a.Buffer:return se.read(d(se)).buffer;case a.VSBuffer:return se.read(d(se));case a.Array:{const Z=d(se),q=[];for(let ae=0;ae<Z;ae++)q.push(l(se));return q}case a.Object:return JSON.parse(se.read(d(se)).toString());case a.Int:return d(se)}}e.deserialize=l;class I{constructor(V,Z,q=null,ae=1e3){this.h=V,this.j=Z,this.k=q,this.l=ae,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Ee=>this.q(Ee)),this.m({type:200})}registerChannel(V,Z){this.b.set(V,Z),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const Z=this.o([V.type]);this.k?.logOutgoing(Z,0,1,n(V.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([V.type,V.id],V.data);this.k?.logOutgoing(Z,V.id,1,n(V.type),V.data);return}}}o(V,Z=void 0){const q=new t;return v(q,V),v(q,Z),this.p(q.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const Z=new p(V),q=l(Z),ae=l(Z),Ee=q[0];switch(Ee){case 100:return this.k?.logIncoming(V.byteLength,q[1],1,`${C(Ee)}: ${q[2]}.${q[3]}`,ae),this.s({type:Ee,id:q[1],channelName:q[2],name:q[3],arg:ae});case 102:return this.k?.logIncoming(V.byteLength,q[1],1,`${C(Ee)}: ${q[2]}.${q[3]}`,ae),this.t({type:Ee,id:q[1],channelName:q[2],name:q[3],arg:ae});case 101:return this.k?.logIncoming(V.byteLength,q[1],1,`${C(Ee)}`),this.u({type:Ee,id:q[1]});case 103:return this.k?.logIncoming(V.byteLength,q[1],1,`${C(Ee)}`),this.u({type:Ee,id:q[1]})}}s(V){const Z=this.b.get(V.channelName);if(!Z){this.v(V);return}const q=new O.CancellationTokenSource;let ae;try{ae=Z.call(this.j,V.name,V.arg,q.token)}catch(be){ae=Promise.reject(be)}const Ee=V.id;ae.then(be=>{this.m({id:Ee,data:be,type:201}),this.d.delete(V.id)},be=>{be instanceof Error?this.m({id:Ee,data:{message:be.message,name:be.name,stack:be.stack?be.stack.split?be.stack.split(`
`):be.stack:void 0},type:202}):this.m({id:Ee,data:be,type:203}),this.d.delete(V.id)});const ye=(0,g.toDisposable)(()=>q.cancel());this.d.set(V.id,ye)}t(V){const Z=this.b.get(V.channelName);if(!Z){this.v(V);return}const q=V.id,Ee=Z.listen(this.j,V.name,V.arg)(ye=>this.m({id:q,data:ye,type:204}));this.d.set(V.id,Ee)}u(V){const Z=this.d.get(V.id);Z&&(Z.dispose(),this.d.delete(V.id))}v(V){let Z=this.g.get(V.channelName);Z||(Z=[],this.g.set(V.channelName,Z));const q=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:V,timeoutTimer:q})}w(V){const Z=this.g.get(V);if(Z){for(const q of Z)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.s(q.request);break;case 102:this.t(q.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=I;var E;(function(se){se[se.LocalSide=0]="LocalSide",se[se.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));class s{constructor(V,Z=null){this.l=V,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(q=>this.s(q)),this.j=Z}getChannel(V){const Z=this;return{call(q,ae,Ee){return Z.a?Promise.reject(new A.CancellationError):Z.m(V,q,ae,Ee)},listen(q,ae){return Z.a?y.Event.None:Z.o(V,q,ae)}}}m(V,Z,q,ae=O.CancellationToken.None){const Ee=this.g++,be={id:Ee,type:100,channelName:V,name:Z,arg:q};if(ae.isCancellationRequested)return Promise.reject(new A.CancellationError);let M;return new Promise((fe,we)=>{if(ae.isCancellationRequested)return we(new A.CancellationError);const _=()=>{const de=oe=>{switch(oe.type){case 201:this.f.delete(Ee),fe(oe.data);break;case 202:{this.f.delete(Ee);const ue=new Error(oe.data.message);ue.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,ue.name=oe.data.name,we(ue);break}case 203:this.f.delete(Ee),we(oe.data);break}};this.f.set(Ee,de),this.p(be)};let ne=null;this.b===h.Idle?_():(ne=(0,R.createCancelablePromise)(de=>this.u()),ne.then(()=>{ne=null,_()}));const le=()=>{ne?(ne.cancel(),ne=null):this.p({id:Ee,type:101}),we(new A.CancellationError)},te=ae.onCancellationRequested(le);M=(0,g.combinedDisposable)((0,g.toDisposable)(le),te),this.d.add(M)}).finally(()=>{this.d.delete(M)})}o(V,Z,q){const ae=this.g++,ye={id:ae,type:102,channelName:V,name:Z,arg:q};let be=null;const M=new y.Emitter({onWillAddFirstListener:()=>{be=(0,R.createCancelablePromise)(fe=>this.u()),be.then(()=>{be=null,this.d.add(M),this.p(ye)})},onDidRemoveLastListener:()=>{be?(be.cancel(),be=null):(this.d.delete(M),this.p({id:ae,type:103}))}}),Q=fe=>M.fire(fe.data);return this.f.set(ae,Q),M.event}p(V){switch(V.type){case 100:case 102:{const Z=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(Z,V.id,0,`${C(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const Z=this.q([V.type,V.id]);this.j?.logOutgoing(Z,V.id,0,C(V.type));return}}}q(V,Z=void 0){const q=new t;return v(q,V),v(q,Z),this.r(q.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const Z=new p(V),q=l(Z),ae=l(Z),Ee=q[0];switch(Ee){case 200:return this.j?.logIncoming(V.byteLength,0,0,n(Ee)),this.t({type:q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,q[1],0,n(Ee),ae),this.t({type:q[0],id:q[1],data:ae})}}t(V){if(V.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.dispose)(this.d.values()),this.d.clear()}}e.ChannelClient=s,qe([L.memoize],s.prototype,"onDidInitializePromise",null);class i{get connections(){const V=[];return this.f.forEach(Z=>V.push(Z)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new y.Emitter,this.onDidAddConnection=this.g.event,this.h=new y.Emitter,this.onDidRemoveConnection=this.h.event,V(({protocol:Z,onDidClientDisconnect:q})=>{y.Event.once(Z.onMessage)(Ee=>{const ye=new p(Ee),be=l(ye),M=new I(Z,be),Q=new s(Z);this.a.forEach((we,_)=>M.registerChannel(_,we));const fe={channelServer:M,channelClient:Q,ctx:be};this.f.add(fe),this.g.fire(fe),q(()=>{M.dispose(),Q.dispose(),this.f.delete(fe),this.h.fire(fe)})})})}getChannel(V,Z){const q=this;return{call(ae,Ee,ye){let be;if((0,m.isFunction)(Z)){const Q=(0,c.getRandomElement)(q.connections.filter(Z));be=Q?Promise.resolve(Q):y.Event.toPromise(y.Event.filter(q.onDidAddConnection,Z))}else be=Z.routeCall(q,ae,Ee);const M=be.then(Q=>Q.channelClient.getChannel(V));return F(M).call(ae,Ee,ye)},listen(ae,Ee){if((0,m.isFunction)(Z))return q.j(V,Z,ae,Ee);const ye=Z.routeEvent(q,ae,Ee).then(be=>be.channelClient.getChannel(V));return F(ye).listen(ae,Ee)}}}j(V,Z,q,ae){const Ee=this;let ye=new g.DisposableStore;const be=new y.Emitter({onWillAddFirstListener:()=>{ye=new g.DisposableStore;const M=new y.EventMultiplexer,Q=new Map,fe=_=>{const le=_.channelClient.getChannel(V).listen(q,ae),te=M.add(le);Q.set(_,te)},we=_=>{const ne=Q.get(_);ne&&(ne.dispose(),Q.delete(_))};Ee.connections.filter(Z).forEach(fe),y.Event.filter(Ee.onDidAddConnection,Z)(fe,void 0,ye),Ee.onDidRemoveConnection(we,void 0,ye),M.event(be.fire,be,ye),ye.add(M)},onDidRemoveLastListener:()=>{ye.dispose()}});return be.event}registerChannel(V,Z){this.a.set(V,Z),this.f.forEach(q=>{q.channelServer.registerChannel(V,Z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=i;class k{constructor(V,Z,q=null){const ae=new t;v(ae,Z),V.send(ae.buffer),this.a=new s(V,q),this.d=new I(V,Z,q)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,Z){this.d.registerChannel(V,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=k;function F(se){return{call(V,Z,q){return se.then(ae=>ae.call(V,Z,q))},listen(V,Z){const q=new y.Relay;return se.then(ae=>q.input=ae.listen(V,Z)),q.event}}}e.getDelayedChannel=F;function $(se){let V=!1;return{call(Z,q,ae){return V?se.call(Z,q,ae):(0,R.timeout)(0).then(()=>V=!0).then(()=>se.call(Z,q,ae))},listen(Z,q){if(V)return se.listen(Z,q);const ae=new y.Relay;return(0,R.timeout)(0).then(()=>V=!0).then(()=>ae.input=se.listen(Z,q)),ae.event}}}e.getNextTickChannel=$;class j{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const Z of V.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await y.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.StaticRouter=j;var W;(function(se){function V(Ee,ye){const be=Ee,M=ye&&ye.disableMarshalling,Q=new Map;for(const fe in be)q(fe)&&Q.set(fe,y.Event.buffer(be[fe],!0));return new class{listen(fe,we,_){const ne=Q.get(we);if(ne)return ne;if(ae(we)){const le=be[we];if(typeof le=="function")return le.call(be,_)}throw new Error(`Event not found: ${we}`)}call(fe,we,_){const ne=be[we];if(typeof ne=="function"){if(!M&&Array.isArray(_))for(let le=0;le<_.length;le++)_[le]=(0,T.revive)(_[le]);return ne.apply(be,_)}throw new Error(`Method not found: ${we}`)}}}se.fromService=V;function Z(Ee,ye){const be=ye&&ye.disableMarshalling;return new Proxy({},{get(M,Q){if(typeof Q=="string")return ye?.properties?.has(Q)?ye.properties.get(Q):ae(Q)?function(fe){return Ee.listen(Q,fe)}:q(Q)?Ee.listen(Q):async function(...fe){let we;ye&&!(0,m.isUndefinedOrNull)(ye.context)?we=[ye.context,...fe]:we=fe;const _=await Ee.call(Q,we);return be?_:(0,T.revive)(_)};throw new Error(`Property not found: ${String(Q)}`)}})}se.toService=Z;function q(Ee){return Ee[0]==="o"&&Ee[1]==="n"&&P.isUpperAsciiLetter(Ee.charCodeAt(2))}function ae(Ee){return/^onDynamic/.test(Ee)&&P.isUpperAsciiLetter(Ee.charCodeAt(9))}})(W||(e.ProxyChannel=W={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(se){if(Array.isArray(se))return se;if(se&&typeof se=="object"&&typeof se.toString=="function"){const V=se.toString();if(V!=="[object Object]")return V}return se}function B(se){return Array.isArray(se)?se.map(x):x(se)}function z(se,V,Z,q,ae,Ee,ye){ye=B(ye);const be=U[ae],M=be[q%be.length];let Q=[`%c[${se}]%c[${String(V).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${Ee}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(Ee)?(Q=Q.concat(ye),Q.push(")")):Q.push(ye),console.log.apply(console,Q)}class ee{constructor(V,Z){this.d=V,this.f=Z,this.a=0,this.b=0}logOutgoing(V,Z,q,ae,Ee){this.b+=V,z(this.d,this.b,V,Z,q,ae,Ee)}logIncoming(V,Z,q,ae,Ee){this.a+=V,z(this.f,this.a,V,Z,q,ae,Ee)}}e.IPCLogger=ee}),define(Ce[119],De([1,0,16,22,3,4,75]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var y;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let k=0;function F(j,W){if(!i.has(j)){const U=String(++k);i.set(j,U)}return i.get(j)}function $(j,W,U,x){if(!s.enableDiagnostics)return;const B=F(j,W);if(x instanceof R.VSBuffer||x instanceof Uint8Array||x instanceof ArrayBuffer||ArrayBuffer.isView(x)){const z=R.VSBuffer.alloc(x.byteLength);z.set(x),s.records.push({timestamp:Date.now(),id:B,label:W,type:U,buff:z})}else s.records.push({timestamp:Date.now(),id:B,label:W,type:U,data:x})}s.traceSocketEvent=$})(y||(e.SocketDiagnostics=y={}));var g;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g||(e.SocketCloseEventType=g={}));let T=null;function P(){return T||(T=R.VSBuffer.alloc(0)),T}class m{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,k){if(i===0)return P();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const W=this.a[0];return k&&(this.a.shift(),this.b-=i),W}if(this.a[0].byteLength>i){const W=this.a[0].slice(0,i);return k&&(this.a[0]=this.a[0].slice(i),this.b-=i),W}const F=R.VSBuffer.alloc(i);let $=0,j=0;for(;i>0;){const W=this.a[j];if(W.byteLength>i){const U=W.slice(0,i);F.set(U,$),$+=i,k&&(this.a[j]=W.slice(i),this.b-=i),i-=i}else F.set(W,$),$+=W.byteLength,k?(this.a.shift(),this.b-=W.byteLength):j++,i-=W.byteLength}return F}}e.ChunkStream=m;var D;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive",s[s.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",s[s.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(D||(D={}));function C(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var b;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime",s[s.LatencySampleTime=6e4]="LatencySampleTime",s[s.LatencySampleCount=5]="LatencySampleCount",s[s.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",s[s.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(b||(e.ProtocolConstants=b={}));class n{constructor(i,k,F,$){this.type=i,this.id=k,this.ack=F,this.data=$,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends O.Disposable{constructor(i){super(),this.f=this.B(new u.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new m,this.B(this.a.onData(k=>this.acceptChunk(k))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const k=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=k.readUInt32BE(9),this.g.messageType=k.readUInt8(0),this.g.id=k.readUInt32BE(1),this.g.ack=k.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:C(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const F=this.g.messageType,$=this.g.id,j=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",k),this.f.fire(new n(F,$,j,k)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const k=R.VSBuffer.alloc(13);k.writeUInt8(i.type,0),k.writeUInt32BE(i.id,1),k.writeUInt32BE(i.ack,5),k.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:C(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(k,i.data)}g(i,k){const F=this.f===0;return this.d.push(i,k),this.f+=i.byteLength+k.byteLength,F}h(){const i=R.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,k){this.g(i,k)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class S extends O.Disposable{constructor(i){super(),this.f=new u.Emitter,this.onMessage=this.f.event,this.g=new u.Emitter,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new d(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(k=>{k.type===1&&this.f.fire(k.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new n(1,0,0,i))}}e.Protocol=S;class w extends L.IPCClient{static fromSocket(i,k){return new w(new S(i),k)}get onDidDispose(){return this.b.onDidDispose}constructor(i,k,F=null){super(i,k,F),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.Client=w;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new u.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.BufferedEmitter=p;class t{constructor(i){this.data=i,this.next=null}}class a{constructor(){this.a=null,this.b=null}length(){let i=0,k=this.a;for(;k;)k=k.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let k=0,F=this.a;for(;F;)i[k++]=F.data,F=F.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const k=new t(i);if(!this.a){this.a=k,this.b=k;return}this.b.next=k,this.b=k}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const i=Date.now();for(let k=0;k<r.a;k++)this.c[k]=i-1e3*k;setInterval(()=>{for(let k=r.a;k>=1;k--)this.c[k]=this.c[k-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),k=(1+r.a)*1e3;let F=0;for(let $=0;$<r.a;$++)i-this.c[$]<=k&&F++;return 1-F/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;var o;(function(s){s[s.Good=0]="Good",s[s.Poor=1]="Poor"})(o||(e.ConnectionHealth=o={}));function f(s){switch(s){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=f;class v{constructor(i){this.connectionHealth=i}}e.ConnectionHealthChangedEvent=v;class l{constructor(i,k){this.roundTripTime=i,this.recentHighRoundTripCount=k}}e.HighRoundTripTimeEvent=l;class I{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.x=new p,this.onControlMessage=this.x.event,this.y=new p,this.onMessage=this.y.event,this.z=new p,this.onDidDispose=this.z.event,this.A=new p,this.onSocketClose=this.A.event,this.B=new p,this.onSocketTimeout=this.B.event,this.C=new p,this.onHighRoundTripTime=this.C.event,this.D=new p,this.onDidChangeConnectionHealth=this.D.event,this.u=i.loadEstimator??r.getInstance(),this.v=i.measureRoundTripTime??!1,this.w=i.sendKeepAlive??!0,this.a=!1,this.b=new a,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new O.DisposableStore,this.o=i.socket,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(k=>this.E(k))),this.t.add(this.o.onClose(k=>this.A.fire(k))),this.r=this.t.add(new E),this.t.add(this.r.onSendLatencyRequest(k=>this.J(k))),this.t.add(this.r.onHighRoundTripTime(k=>this.C.fire(k))),this.t.add(this.r.onDidChangeConnectionHealth(k=>this.D.fire(k))),this.v&&this.r.start(),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new n(5,0,0,P());this.p.write(i),this.p.flush()}sendPause(){const i=new n(7,0,0,P());this.p.write(i)}sendResume(){const i=new n(8,0,0,P());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,k){this.a=!0,this.t.dispose(),this.t=new O.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new E),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.q.acceptChunk(k)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const i=new n(3,0,this.h,P());this.p.write(i);const k=this.b.toArray();for(let F=0,$=k.length;F<$;F++)this.p.write(k[F]);this.G()}acceptDisconnect(){this.z.fire()}E(i){if(i.ack>this.d){this.d=i.ack;do{const k=this.b.peek();if(k&&k.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const k=Date.now();k-this.m>1e4&&(this.m=k,this.p.write(new n(6,0,0,P())))}else this.g=i.id,this.j=Date.now(),this.F(),this.y.fire(i.data);break}case 2:{this.x.fire(i.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const k=this.b.toArray();for(let F=0,$=k.length;F<$;F++)this.p.write(k[F]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(i.data);break}case 11:{this.r.handleResponse(i.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const k=++this.c;this.h=this.g;const F=new n(1,k,this.h,i);this.b.push(F),this.a||(this.p.write(F),this.G())}sendControl(i){const k=new n(2,0,0,i);this.p.write(k)}F(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-i+5)}G(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),k=Date.now()-i.writtenTime,F=Date.now()-this.q.lastReadTime,$=Date.now()-this.n;if(k>=2e4&&F>=2e4&&$>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:k,timeSinceLastReceivedSomeData:F});return}const j=Math.max(2e4-k,2e4-F,2e4-$,500);this.f=setTimeout(()=>{this.f=null,this.G()},j)}H(){if(this.g<=this.h)return;this.h=this.g;const i=new n(3,0,this.h,P());this.p.write(i)}I(){this.h=this.g;const i=new n(9,0,this.h,P());this.p.write(i)}J(i){this.h=this.g;const k=new n(10,0,this.h,i);this.p.write(k)}K(i){this.h=this.g;const k=new n(11,0,this.h,i);this.p.write(k)}}e.PersistentProtocol=I;class E extends O.Disposable{constructor(){super(),this.a=this.B(new u.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new u.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new u.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new c.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},i=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const i=++this.h,k=R.VSBuffer.alloc(4);k.writeUInt32BE(i,0),this.a.fire(k)},6e4)}handleResponse(i){if(i.byteLength!==4)return;const k=i.readUInt32BE(0);if(this.g<=0||k!==this.h)return;const F=Date.now()-this.g,$=this.k++;this.j[$%this.j.length]=F;const j=this.l,W=this.j.filter(U=>U>=1e3).length;this.l=W>=3?1:0,F>1e3&&this.b.fire(new l(F,W)),j!==this.l&&this.c.fire(this.l)}}}),define(Ce[158],De([1,0,45,16,22,21,156,8,3,4,23,95,92,75]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class C extends D.ChannelServer{constructor(h){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",d=>u.VSBuffer.wrap(Buffer.from(d,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=C;class b{constructor(h,d){this.i=h,this.j=d,this.c=new Set,this.g=new Map,this.h=new y.Emitter,this.onDidProcessExit=this.h.event;const S=d&&d.timeout?d.timeout:6e4;this.b=new R.Delayer(S),this.d=null,this.f=null}getChannel(h){const d=this;return{call(S,w,p){return d.k(h,S,w,p)},listen(S,w){return d.l(h,S,w)}}}k(h,d,S,w=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(A.canceled());this.b.cancel();const p=this.n(h),t=(0,R.createCancelablePromise)(o=>p.call(d,S,o)),a=w.onCancellationRequested(()=>t.cancel()),r=(0,g.toDisposable)(()=>t.cancel());return this.c.add(r),t.finally(()=>{a.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,d,S){if(!this.b)return y.Event.None;this.b.cancel();let w;const p=new y.Emitter({onWillAddFirstListener:()=>{w=this.n(h).listen(d,S)(p.fire,p),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return p.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(f=>!/^--inspect(-brk)?=/.test(f)).filter(f=>!f.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(d.env),this.d=(0,c.fork)(this.i,h,d);const S=new y.Emitter;y.Event.fromNodeEventEmitter(this.d,"message",f=>f)(f=>{if((0,L.isRemoteConsoleLog)(f)){(0,L.log)(f,`IPC Library: ${this.j.serverName}`);return}S.fire(u.VSBuffer.wrap(Buffer.from(f,"base64")))});const p=this.j.useQueue?(0,P.createQueuedSender)(this.d):this.d,t=f=>this.d&&this.d.connected&&p.send(f.buffer.toString("base64")),a=S.event,r={send:t,onMessage:a};this.f=new D.ChannelClient(r);const o=()=>this.o();process.once("exit",o),this.d.on("error",f=>console.warn('IPC "'+this.j.serverName+'" errored with '+f)),this.d.on("exit",(f,v)=>{process.removeListener("exit",o),this.c.forEach(l=>(0,g.dispose)(l)),this.c.clear(),f!==0&&v!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+f+" and signal "+v),this.b?.cancel(),this.o(),this.h.fire({code:f,signal:v})})}return this.f}n(h){let d=this.g.get(h);return d||(d=this.m.getChannel(h),this.g.set(h,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=b}),define(Ce[120],De([1,0,115]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(A){const y=(0,c.toUint8)(A);this.c=y,this.a=R.d(y),this.b=new Map}static d(A){const y=new Uint8Array(256);return y.fill(A),y}set(A,y){const g=(0,c.toUint8)(y);A>=0&&A<256?this.a[A]=g:this.b.set(A,g)}get(A){return A>=0&&A<256?this.a[A]:this.b.get(A)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=R;var u;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(u||(u={}));class O{constructor(){this.a=new R(0)}add(A){this.a.set(A,1)}has(A){return this.a.get(A)===1}clear(){return this.a.clear()}}e.CharacterSet=O}),define(Ce[56],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(u,O){this.lineNumber=u,this.column=O}with(u=this.lineNumber,O=this.column){return u===this.lineNumber&&O===this.column?this:new c(u,O)}delta(u=0,O=0){return this.with(this.lineNumber+u,this.column+O)}equals(u){return c.equals(this,u)}static equals(u,O){return!u&&!O?!0:!!u&&!!O&&u.lineNumber===O.lineNumber&&u.column===O.column}isBefore(u){return c.isBefore(this,u)}static isBefore(u,O){return u.lineNumber<O.lineNumber?!0:O.lineNumber<u.lineNumber?!1:u.column<O.column}isBeforeOrEqual(u){return c.isBeforeOrEqual(this,u)}static isBeforeOrEqual(u,O){return u.lineNumber<O.lineNumber?!0:O.lineNumber<u.lineNumber?!1:u.column<=O.column}static compare(u,O){const L=u.lineNumber|0,A=O.lineNumber|0;if(L===A){const y=u.column|0,g=O.column|0;return y-g}return L-A}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(u){return new c(u.lineNumber,u.column)}static isIPosition(u){return u&&typeof u.lineNumber=="number"&&typeof u.column=="number"}}e.Position=c}),define(Ce[36],De([1,0,56]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(O,L,A,y){O>A||O===A&&L>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=O,this.endColumn=L):(this.startLineNumber=O,this.startColumn=L,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return R.isEmpty(this)}static isEmpty(O){return O.startLineNumber===O.endLineNumber&&O.startColumn===O.endColumn}containsPosition(O){return R.containsPosition(this,O)}static containsPosition(O,L){return!(L.lineNumber<O.startLineNumber||L.lineNumber>O.endLineNumber||L.lineNumber===O.startLineNumber&&L.column<O.startColumn||L.lineNumber===O.endLineNumber&&L.column>O.endColumn)}static strictContainsPosition(O,L){return!(L.lineNumber<O.startLineNumber||L.lineNumber>O.endLineNumber||L.lineNumber===O.startLineNumber&&L.column<=O.startColumn||L.lineNumber===O.endLineNumber&&L.column>=O.endColumn)}containsRange(O){return R.containsRange(this,O)}static containsRange(O,L){return!(L.startLineNumber<O.startLineNumber||L.endLineNumber<O.startLineNumber||L.startLineNumber>O.endLineNumber||L.endLineNumber>O.endLineNumber||L.startLineNumber===O.startLineNumber&&L.startColumn<O.startColumn||L.endLineNumber===O.endLineNumber&&L.endColumn>O.endColumn)}strictContainsRange(O){return R.strictContainsRange(this,O)}static strictContainsRange(O,L){return!(L.startLineNumber<O.startLineNumber||L.endLineNumber<O.startLineNumber||L.startLineNumber>O.endLineNumber||L.endLineNumber>O.endLineNumber||L.startLineNumber===O.startLineNumber&&L.startColumn<=O.startColumn||L.endLineNumber===O.endLineNumber&&L.endColumn>=O.endColumn)}plusRange(O){return R.plusRange(this,O)}static plusRange(O,L){let A,y,g,T;return L.startLineNumber<O.startLineNumber?(A=L.startLineNumber,y=L.startColumn):L.startLineNumber===O.startLineNumber?(A=L.startLineNumber,y=Math.min(L.startColumn,O.startColumn)):(A=O.startLineNumber,y=O.startColumn),L.endLineNumber>O.endLineNumber?(g=L.endLineNumber,T=L.endColumn):L.endLineNumber===O.endLineNumber?(g=L.endLineNumber,T=Math.max(L.endColumn,O.endColumn)):(g=O.endLineNumber,T=O.endColumn),new R(A,y,g,T)}intersectRanges(O){return R.intersectRanges(this,O)}static intersectRanges(O,L){let A=O.startLineNumber,y=O.startColumn,g=O.endLineNumber,T=O.endColumn;const P=L.startLineNumber,m=L.startColumn,D=L.endLineNumber,C=L.endColumn;return A<P?(A=P,y=m):A===P&&(y=Math.max(y,m)),g>D?(g=D,T=C):g===D&&(T=Math.min(T,C)),A>g||A===g&&y>T?null:new R(A,y,g,T)}equalsRange(O){return R.equalsRange(this,O)}static equalsRange(O,L){return!O&&!L?!0:!!O&&!!L&&O.startLineNumber===L.startLineNumber&&O.startColumn===L.startColumn&&O.endLineNumber===L.endLineNumber&&O.endColumn===L.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(O){return new c.Position(O.endLineNumber,O.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(O){return new c.Position(O.startLineNumber,O.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(O,L){return new R(this.startLineNumber,this.startColumn,O,L)}setStartPosition(O,L){return new R(O,L,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(O){return new R(O.startLineNumber,O.startColumn,O.startLineNumber,O.startColumn)}collapseToEnd(){return R.collapseToEnd(this)}static collapseToEnd(O){return new R(O.endLineNumber,O.endColumn,O.endLineNumber,O.endColumn)}delta(O){return new R(this.startLineNumber+O,this.startColumn,this.endLineNumber+O,this.endColumn)}static fromPositions(O,L=O){return new R(O.lineNumber,O.column,L.lineNumber,L.column)}static lift(O){return O?new R(O.startLineNumber,O.startColumn,O.endLineNumber,O.endColumn):null}static isIRange(O){return O&&typeof O.startLineNumber=="number"&&typeof O.startColumn=="number"&&typeof O.endLineNumber=="number"&&typeof O.endColumn=="number"}static areIntersectingOrTouching(O,L){return!(O.endLineNumber<L.startLineNumber||O.endLineNumber===L.startLineNumber&&O.endColumn<L.startColumn||L.endLineNumber<O.startLineNumber||L.endLineNumber===O.startLineNumber&&L.endColumn<O.startColumn)}static areIntersecting(O,L){return!(O.endLineNumber<L.startLineNumber||O.endLineNumber===L.startLineNumber&&O.endColumn<=L.startColumn||L.endLineNumber<O.startLineNumber||L.endLineNumber===O.startLineNumber&&L.endColumn<=O.startColumn)}static compareRangesUsingStarts(O,L){if(O&&L){const g=O.startLineNumber|0,T=L.startLineNumber|0;if(g===T){const P=O.startColumn|0,m=L.startColumn|0;if(P===m){const D=O.endLineNumber|0,C=L.endLineNumber|0;if(D===C){const b=O.endColumn|0,n=L.endColumn|0;return b-n}return D-C}return P-m}return g-T}return(O?1:0)-(L?1:0)}static compareRangesUsingEnds(O,L){return O.endLineNumber===L.endLineNumber?O.endColumn===L.endColumn?O.startLineNumber===L.startLineNumber?O.startColumn-L.startColumn:O.startLineNumber-L.startLineNumber:O.endColumn-L.endColumn:O.endLineNumber-L.endLineNumber}static spansMultipleLines(O){return O.endLineNumber>O.startLineNumber}toJSON(){return this}}e.Range=R}),define(Ce[159],De([1,0,56,36]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var u;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(u||(e.SelectionDirection=u={}));class O extends R.Range{constructor(A,y,g,T){super(A,y,g,T),this.selectionStartLineNumber=A,this.selectionStartColumn=y,this.positionLineNumber=g,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return O.selectionsEqual(this,A)}static selectionsEqual(A,y){return A.selectionStartLineNumber===y.selectionStartLineNumber&&A.selectionStartColumn===y.selectionStartColumn&&A.positionLineNumber===y.positionLineNumber&&A.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(A,y){return this.getDirection()===0?new O(this.startLineNumber,this.startColumn,A,y):new O(A,y,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(A,y){return this.getDirection()===0?new O(A,y,this.endLineNumber,this.endColumn):new O(this.endLineNumber,this.endColumn,A,y)}static fromPositions(A,y=A){return new O(A.lineNumber,A.column,y.lineNumber,y.column)}static fromRange(A,y){return y===0?new O(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):new O(A.endLineNumber,A.endColumn,A.startLineNumber,A.startColumn)}static liftSelection(A){return new O(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,y){if(A&&!y||!A&&y)return!1;if(!A&&!y)return!0;if(A.length!==y.length)return!1;for(let g=0,T=A.length;g<T;g++)if(!this.selectionsEqual(A[g],y[g]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,y,g,T,P){return P===0?new O(A,y,g,T):new O(g,T,A,y)}}e.Selection=O}),define(Ce[160],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[161],De([1,0,120]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(R||(e.WordCharacterClass=R={}));class u extends c.CharacterClassifier{constructor(A){super(0);for(let y=0,g=A.length;y<g;y++)this.set(A.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=u;function O(L){const A={};return y=>(A.hasOwnProperty(y)||(A[y]=L(y)),A[y])}e.getMapForWordSeparators=O(L=>new u(L))}),define(Ce[121],De([1,0,53,4,68]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function O(P=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.USUAL_WORD_SEPARATORS)P.indexOf(D)>=0||(m+="\\"+D);return m+="\\s]+)",new RegExp(m,"g")}e.DEFAULT_WORD_REGEXP=O();function L(P){let m=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)m=P;else{let D="g";P.ignoreCase&&(D+="i"),P.multiline&&(D+="m"),P.unicode&&(D+="u"),m=new RegExp(P.source,D)}return m.lastIndex=0,m}e.ensureValidWordDefinition=L;const A=new u.LinkedList;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(P){const m=A.unshift(P);return(0,R.toDisposable)(m)}e.setDefaultGetWordAtTextConfig=y;function g(P,m,D,C,b){if(b||(b=c.Iterable.first(A)),D.length>b.maxLen){let w=P-b.maxLen/2;return w<0?w=0:C+=w,D=D.substring(w,P+b.maxLen/2),g(P,m,D,C,b)}const n=Date.now(),h=P-1-C;let d=-1,S=null;for(let w=1;!(Date.now()-n>=b.timeBudget);w++){const p=h-b.windowSize*w;m.lastIndex=Math.max(0,p);const t=T(m,D,h,d);if(!t&&S||(S=t,p<=0))break;d=p}if(S){const w={word:S[0],startColumn:C+1+S.index,endColumn:C+1+S.index+S[0].length};return m.lastIndex=0,w}return null}e.getWordAtText=g;function T(P,m,D,C){let b;for(;b=P.exec(m);){const n=b.index||0;if(n<=D&&P.lastIndex>=D)return b;if(C>0&&n>C)return null}return null}}),define(Ce[162],De([1,0,32,10]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function u(O,L,A,y,g,T){if(Array.isArray(O)){let P=0;for(const m of O){const D=u(m,L,A,y,g,T);if(D===10)return D;D>P&&(P=D)}return P}else{if(typeof O=="string")return y?O==="*"?5:O===A?10:0:0;if(O){const{language:P,pattern:m,scheme:D,hasAccessToAllModels:C,notebookType:b}=O;if(!y&&!C)return 0;b&&g&&(L=g);let n=0;if(D)if(D===L.scheme)n=10;else if(D==="*")n=5;else return 0;if(P)if(P===A)n=10;else if(P==="*")n=Math.max(n,5);else return 0;if(b)if(b===T)n=10;else if(b==="*"&&T!==void 0)n=Math.max(n,5);else return 0;if(m){let h;if(typeof m=="string"?h=m:h={...m,base:(0,R.normalize)(m.base)},h===L.fsPath||(0,c.match)(h,L.fsPath))n=10;else return 0}return n}else return 0}}e.score=u}),define(Ce[163],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"})(c||(e.IndentAction=c={}));class R{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let y=0,g=A.notIn.length;y<g;y++)switch(A.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const g=A.findTokenIndexAtOffset(y-2),T=A.getStandardTokenType(g);return this.isOK(T)}g(A,y){for(let g=A;g<=y;g++){const T=String.fromCharCode(g);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=R;class u{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)O(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),O(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),O(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),O(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&O(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=u;function O(L,A,y){L.has(A)?L.get(A).push(y):L.set(A,[y])}}),define(Ce[164],De([1,0,120]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var R;(function(D){D[D.Invalid=0]="Invalid",D[D.Start=1]="Start",D[D.H=2]="H",D[D.HT=3]="HT",D[D.HTT=4]="HTT",D[D.HTTP=5]="HTTP",D[D.F=6]="F",D[D.FI=7]="FI",D[D.FIL=8]="FIL",D[D.BeforeColon=9]="BeforeColon",D[D.AfterColon=10]="AfterColon",D[D.AlmostThere=11]="AlmostThere",D[D.End=12]="End",D[D.Accept=13]="Accept",D[D.LastKnownState=14]="LastKnownState"})(R||(e.State=R={}));class u{constructor(C,b,n){const h=new Uint8Array(C*b);for(let d=0,S=C*b;d<S;d++)h[d]=n;this.a=h,this.rows=C,this.cols=b}get(C,b){return this.a[C*this.cols+b]}set(C,b,n){this.a[C*this.cols+b]=n}}class O{constructor(C){let b=0,n=0;for(let d=0,S=C.length;d<S;d++){const[w,p,t]=C[d];p>b&&(b=p),w>n&&(n=w),t>n&&(n=t)}b++,n++;const h=new u(n,b,0);for(let d=0,S=C.length;d<S;d++){const[w,p,t]=C[d];h.set(w,p,t)}this.a=h,this.b=b}nextState(C,b){return b<0||b>=this.b?0:this.a.get(C,b)}}e.StateMachine=O;let L=null;function A(){return L===null&&(L=new O([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var y;(function(D){D[D.None=0]="None",D[D.ForceTermination=1]="ForceTermination",D[D.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let g=null;function T(){if(g===null){g=new c.CharacterClassifier(0);const D=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let b=0;b<D.length;b++)g.set(D.charCodeAt(b),1);const C=".,;:";for(let b=0;b<C.length;b++)g.set(C.charCodeAt(b),2)}return g}class P{static a(C,b,n,h,d){let S=d-1;do{const w=b.charCodeAt(S);if(C.get(w)!==2)break;S--}while(S>h);if(h>0){const w=b.charCodeAt(h-1),p=b.charCodeAt(S);(w===40&&p===41||w===91&&p===93||w===123&&p===125)&&S--}return{range:{startLineNumber:n,startColumn:h+1,endLineNumber:n,endColumn:S+2},url:b.substring(h,S+1)}}static computeLinks(C,b=A()){const n=T(),h=[];for(let d=1,S=C.getLineCount();d<=S;d++){const w=C.getLineContent(d),p=w.length;let t=0,a=0,r=0,o=1,f=!1,v=!1,l=!1,I=!1;for(;t<p;){let E=!1;const s=w.charCodeAt(t);if(o===13){let i;switch(s){case 40:f=!0,i=0;break;case 41:i=f?0:1;break;case 91:l=!0,v=!0,i=0;break;case 93:l=!1,i=v?0:1;break;case 123:I=!0,i=0;break;case 125:i=I?0:1;break;case 39:case 34:case 96:r===s?i=1:r===39||r===34||r===96?i=0:i=1;break;case 42:i=r===42?1:0;break;case 124:i=r===124?1:0;break;case 32:i=l?0:1;break;default:i=n.get(s)}i===1&&(h.push(P.a(n,w,d,a,t)),E=!0)}else if(o===12){let i;s===91?(v=!0,i=0):i=n.get(s),i===1?E=!0:o=13}else o=b.nextState(o,s),o===0&&(E=!0);E&&(o=1,f=!1,v=!1,I=!1,a=t+1,r=s),t++}o===13&&h.push(P.a(n,w,d,a,p))}return h}}e.LinkComputer=P;function m(D){return!D||typeof D.getLineCount!="function"||typeof D.getLineContent!="function"?[]:P.computeLinks(D)}e.computeLinks=m}),define(Ce[122],De([1,0,23]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var R;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=4]="Right",w[w.Full=7]="Full"})(R||(e.OverviewRulerLane=R={}));var u;(function(w){w[w.Left=1]="Left",w[w.Right=2]="Right"})(u||(e.GlyphMarginLane=u={}));var O;(function(w){w[w.Inline=1]="Inline",w[w.Gutter=2]="Gutter"})(O||(e.MinimapPosition=O={}));var L;(function(w){w[w.Both=0]="Both",w[w.Right=1]="Right",w[w.Left=2]="Left",w[w.None=3]="None"})(L||(e.InjectedTextCursorStops=L={}));var A;(function(w){w[w.TextDefined=0]="TextDefined",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(A||(e.EndOfLinePreference=A={}));var y;(function(w){w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(y||(e.DefaultEndOfLine=y={}));var g;(function(w){w[w.LF=0]="LF",w[w.CRLF=1]="CRLF"})(g||(e.EndOfLineSequence=g={}));class T{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(p){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,p.tabSize|0),p.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,p.indentSize|0),this.a=!1),this.insertSpaces=!!p.insertSpaces,this.defaultEOL=p.defaultEOL|0,this.trimAutoWhitespace=!!p.trimAutoWhitespace,this.bracketPairColorizationOptions=p.bracketPairColorizationOptions}equals(p){return this.tabSize===p.tabSize&&this.a===p.a&&this.indentSize===p.indentSize&&this.insertSpaces===p.insertSpaces&&this.defaultEOL===p.defaultEOL&&this.trimAutoWhitespace===p.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,p.bracketPairColorizationOptions)}createChangeEvent(p){return{tabSize:this.tabSize!==p.tabSize,indentSize:this.indentSize!==p.indentSize,insertSpaces:this.insertSpaces!==p.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==p.trimAutoWhitespace}}}e.TextModelResolvedOptions=T;class P{constructor(p,t){this._findMatchBrand=void 0,this.range=p,this.matches=t}}e.FindMatch=P;var m;(function(w){w[w.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",w[w.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",w[w.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",w[w.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(e.TrackedRangeStickiness=m={}));function D(w){return w&&typeof w.read=="function"}e.isITextSnapshot=D;var C;(function(w){w[w.Left=0]="Left",w[w.Right=1]="Right",w[w.None=2]="None",w[w.LeftOfInjectedText=3]="LeftOfInjectedText",w[w.RightOfInjectedText=4]="RightOfInjectedText"})(C||(e.PositionAffinity=C={}));var b;(function(w){w[w.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(b||(e.ModelConstants=b={}));class n{constructor(p,t,a,r,o,f){this.identifier=p,this.range=t,this.text=a,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=o,this._isTracked=f}}e.ValidAnnotatedEditOperation=n;class h{constructor(p,t,a){this.regex=p,this.wordSeparators=t,this.simpleSearch=a}}e.SearchData=h;class d{constructor(p,t,a){this.reverseEdits=p,this.changes=t,this.trimAutoWhitespaceLineNumbers=a}}e.ApplyEditsResult=d;function S(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}e.shouldSynchronizeModel=S}),define(Ce[165],De([1,0,19,115]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class u{constructor(y){this.a=y,this.b=new Uint32Array(y.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(y,g){y=(0,R.toUint32)(y);const T=this.a,P=this.b,m=g.length;return m===0?!1:(this.a=new Uint32Array(T.length+m),this.a.set(T.subarray(0,y),0),this.a.set(T.subarray(y),y+m),this.a.set(g,y),y-1<this.c[0]&&(this.c[0]=y-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(y,g){return y=(0,R.toUint32)(y),g=(0,R.toUint32)(g),this.a[y]===g?!1:(this.a[y]=g,y-1<this.c[0]&&(this.c[0]=y-1),!0)}removeValues(y,g){y=(0,R.toUint32)(y),g=(0,R.toUint32)(g);const T=this.a,P=this.b;if(y>=T.length)return!1;const m=T.length-y;return g>=m&&(g=m),g===0?!1:(this.a=new Uint32Array(T.length-g),this.a.set(T.subarray(0,y),0),this.a.set(T.subarray(y+g),y),this.b=new Uint32Array(this.a.length),y-1<this.c[0]&&(this.c[0]=y-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(y){return y<0?0:(y=(0,R.toUint32)(y),this.d(y))}d(y){if(y<=this.c[0])return this.b[y];let g=this.c[0]+1;g===0&&(this.b[0]=this.a[0],g++),y>=this.a.length&&(y=this.a.length-1);for(let T=g;T<=y;T++)this.b[T]=this.b[T-1]+this.a[T];return this.c[0]=Math.max(this.c[0],y),this.b[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let g=0,T=this.a.length-1,P=0,m=0,D=0;for(;g<=T;)if(P=g+(T-g)/2|0,m=this.b[P],D=m-this.a[P],y<D)T=P-1;else if(y>=m)g=P+1;else break;return new L(P,y-D)}}e.PrefixSumComputer=u;class O{constructor(y){this.a=y,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(y){return this.g(),y===0?0:this.d[y-1]}getIndexOf(y){this.g();const g=this.e[y],T=g>0?this.d[g-1]:0;return new L(g,y-T)}removeValues(y,g){this.a.splice(y,g),this.f(y)}insertValues(y,g){this.a=(0,c.arrayInsert)(this.a,y,g),this.f(y)}f(y){this.b=!1,this.c=Math.min(this.c,y-1)}g(){if(!this.b){for(let y=this.c+1,g=this.a.length;y<g;y++){const T=this.a[y],P=y>0?this.d[y-1]:0;this.d[y]=P+T;for(let m=0;m<T;m++)this.e[P+m]=y}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(y,g){this.a[y]!==g&&(this.a[y]=g,this.f(y))}}e.ConstantTimePrefixSumComputer=O;class L{constructor(y,g){this.index=y,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=g}}e.PrefixSumIndexOfResult=L}),define(Ce[166],De([1,0,11,56,165]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class O{constructor(A,y,g,T){this.d=A,this.f=y,this.g=g,this.h=T,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(A){A.eol&&A.eol!==this.g&&(this.g=A.eol,this.j=null);const y=A.changes;for(const g of y)this.o(g.range),this.p(new R.Position(g.range.startLineNumber,g.range.startColumn),g.text);this.h=A.versionId,this.k=null}l(){if(!this.j){const A=this.g.length,y=this.f.length,g=new Uint32Array(y);for(let T=0;T<y;T++)g[T]=this.f[T].length+A;this.j=new u.PrefixSumComputer(g)}}n(A,y){this.f[A]=y,this.j&&this.j.setValue(A,this.f[A].length+this.g.length)}o(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this.n(A.startLineNumber-1,this.f[A.startLineNumber-1].substring(0,A.startColumn-1)+this.f[A.startLineNumber-1].substring(A.endColumn-1));return}this.n(A.startLineNumber-1,this.f[A.startLineNumber-1].substring(0,A.startColumn-1)+this.f[A.endLineNumber-1].substring(A.endColumn-1)),this.f.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this.j&&this.j.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}p(A,y){if(y.length===0)return;const g=(0,c.splitLines)(y);if(g.length===1){this.n(A.lineNumber-1,this.f[A.lineNumber-1].substring(0,A.column-1)+g[0]+this.f[A.lineNumber-1].substring(A.column-1));return}g[g.length-1]+=this.f[A.lineNumber-1].substring(A.column-1),this.n(A.lineNumber-1,this.f[A.lineNumber-1].substring(0,A.column-1)+g[0]);const T=new Uint32Array(g.length-1);for(let P=1;P<g.length;P++)this.f.splice(A.lineNumber+P-1,0,g[P]),T[P-1]=g[P].length+this.g.length;this.j&&this.j.insertValues(A.lineNumber,T)}}e.MirrorTextModel=O}),define(Ce[167],De([1,0,11,161,56,36,122]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class y{constructor(d,S,w,p){this.searchString=d,this.isRegex=S,this.matchCase=w,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=g(this.searchString):d=this.searchString.indexOf(`
`)>=0;let S=null;try{S=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch{return null}if(!S)return null;let w=!this.isRegex&&!d;return w&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(w=this.matchCase),new L.SearchData(S,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,w?this.searchString:null)}}e.SearchParams=y;function g(h){if(!h||h.length===0)return!1;for(let d=0,S=h.length;d<S;d++){const w=h.charCodeAt(d);if(w===10)return!0;if(w===92){if(d++,d>=S)break;const p=h.charCodeAt(d);if(p===110||p===114||p===87)return!0}}return!1}e.isMultilineRegexSource=g;function T(h,d,S){if(!S)return new L.FindMatch(h,null);const w=[];for(let p=0,t=d.length;p<t;p++)w[p]=d[p];return new L.FindMatch(h,w)}e.createFindMatch=T;class P{constructor(d){const S=[];let w=0;for(let p=0,t=d.length;p<t;p++)d.charCodeAt(p)===10&&(S[w++]=p);this.a=S}findLineFeedCountBeforeOffset(d){const S=this.a;let w=0,p=S.length-1;if(p===-1||d<=S[0])return 0;for(;w<p;){const t=w+((p-w)/2>>0);S[t]>=d?p=t-1:S[t+1]>=d?(w=t,p=t):w=t+1}return w+1}}class m{static findMatches(d,S,w,p,t){const a=S.parseSearchRequest();return a?a.regex.multiline?this.b(d,w,new n(a.wordSeparators,a.regex),p,t):this.c(d,w,a,p,t):[]}static a(d,S,w,p,t,a){let r,o=0;p?(o=p.findLineFeedCountBeforeOffset(t),r=S+t+o):r=S+t;let f;if(p){const E=p.findLineFeedCountBeforeOffset(t+a.length)-o;f=r+a.length+E}else f=r+a.length;const v=d.getPositionAt(r),l=d.getPositionAt(f);return new O.Range(v.lineNumber,v.column,l.lineNumber,l.column)}static b(d,S,w,p,t){const a=d.getOffsetAt(S.getStartPosition()),r=d.getValueInRange(S,1),o=d.getEOL()===`\r
`?new P(r):null,f=[];let v=0,l;for(w.reset(0);l=w.next(r);)if(f[v++]=T(this.a(d,a,r,o,l.index,l[0]),l,p),v>=t)return f;return f}static c(d,S,w,p,t){const a=[];let r=0;if(S.startLineNumber===S.endLineNumber){const f=d.getLineContent(S.startLineNumber).substring(S.startColumn-1,S.endColumn-1);return r=this.d(w,f,S.startLineNumber,S.startColumn-1,r,a,p,t),a}const o=d.getLineContent(S.startLineNumber).substring(S.startColumn-1);r=this.d(w,o,S.startLineNumber,S.startColumn-1,r,a,p,t);for(let f=S.startLineNumber+1;f<S.endLineNumber&&r<t;f++)r=this.d(w,d.getLineContent(f),f,0,r,a,p,t);if(r<t){const f=d.getLineContent(S.endLineNumber).substring(0,S.endColumn-1);r=this.d(w,f,S.endLineNumber,0,r,a,p,t)}return a}static d(d,S,w,p,t,a,r,o){const f=d.wordSeparators;if(!r&&d.simpleSearch){const I=d.simpleSearch,E=I.length,s=S.length;let i=-E;for(;(i=S.indexOf(I,i+E))!==-1;)if((!f||b(f,S,s,i,E))&&(a[t++]=new L.FindMatch(new O.Range(w,i+1+p,w,i+1+E+p),null),t>=o))return t;return t}const v=new n(d.wordSeparators,d.regex);let l;v.reset(0);do if(l=v.next(S),l&&(a[t++]=T(new O.Range(w,l.index+1+p,w,l.index+1+l[0].length+p),l,r),t>=o))return t;while(l);return t}static findNextMatch(d,S,w,p){const t=S.parseSearchRequest();if(!t)return null;const a=new n(t.wordSeparators,t.regex);return t.regex.multiline?this.e(d,w,a,p):this.f(d,w,a,p)}static e(d,S,w,p){const t=new u.Position(S.lineNumber,1),a=d.getOffsetAt(t),r=d.getLineCount(),o=d.getValueInRange(new O.Range(t.lineNumber,t.column,r,d.getLineMaxColumn(r)),1),f=d.getEOL()===`\r
`?new P(o):null;w.reset(S.column-1);const v=w.next(o);return v?T(this.a(d,a,o,f,v.index,v[0]),v,p):S.lineNumber!==1||S.column!==1?this.e(d,new u.Position(1,1),w,p):null}static f(d,S,w,p){const t=d.getLineCount(),a=S.lineNumber,r=d.getLineContent(a),o=this.g(w,r,a,S.column,p);if(o)return o;for(let f=1;f<=t;f++){const v=(a+f-1)%t,l=d.getLineContent(v+1),I=this.g(w,l,v+1,1,p);if(I)return I}return null}static g(d,S,w,p,t){d.reset(p-1);const a=d.next(S);return a?T(new O.Range(w,a.index+1,w,a.index+1+a[0].length),a,t):null}static findPreviousMatch(d,S,w,p){const t=S.parseSearchRequest();if(!t)return null;const a=new n(t.wordSeparators,t.regex);return t.regex.multiline?this.h(d,w,a,p):this.j(d,w,a,p)}static h(d,S,w,p){const t=this.b(d,new O.Range(1,1,S.lineNumber,S.column),w,p,10*A);if(t.length>0)return t[t.length-1];const a=d.getLineCount();return S.lineNumber!==a||S.column!==d.getLineMaxColumn(a)?this.h(d,new u.Position(a,d.getLineMaxColumn(a)),w,p):null}static j(d,S,w,p){const t=d.getLineCount(),a=S.lineNumber,r=d.getLineContent(a).substring(0,S.column-1),o=this.k(w,r,a,p);if(o)return o;for(let f=1;f<=t;f++){const v=(t+a-f-1)%t,l=d.getLineContent(v+1),I=this.k(w,l,v+1,p);if(I)return I}return null}static k(d,S,w,p){let t=null,a;for(d.reset(0);a=d.next(S);)t=T(new O.Range(w,a.index+1,w,a.index+1+a[0].length),a,p);return t}}e.TextModelSearch=m;function D(h,d,S,w,p){if(w===0)return!0;const t=d.charCodeAt(w-1);if(h.get(t)!==0||t===13||t===10)return!0;if(p>0){const a=d.charCodeAt(w);if(h.get(a)!==0)return!0}return!1}function C(h,d,S,w,p){if(w+p===S)return!0;const t=d.charCodeAt(w+p);if(h.get(t)!==0||t===13||t===10)return!0;if(p>0){const a=d.charCodeAt(w+p-1);if(h.get(a)!==0)return!0}return!1}function b(h,d,S,w,p){return D(h,d,S,w,p)&&C(h,d,S,w,p)}e.isValidMatch=b;class n{constructor(d,S){this._wordSeparators=d,this.a=S,this.b=-1,this.c=0}reset(d){this.a.lastIndex=d,this.b=-1,this.c=0}next(d){const S=d.length;let w;do{if(this.b+this.c===S||(w=this.a.exec(d),!w))return null;const p=w.index,t=w[0].length;if(p===this.b&&t===this.c){if(t===0){c.getNextCodePoint(d,S,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=p,this.c=t,!this._wordSeparators||b(this._wordSeparators,d,S,p,t))return w}while(w);return null}}e.Searcher=n}),define(Ce[123],De([1,0,22,9]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var u;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(u||(u={}));function O(P){for(let m=0,D=P.length;m<D;m+=4){const C=P[m+0],b=P[m+1],n=P[m+2],h=P[m+3];P[m+0]=h,P[m+1]=n,P[m+2]=b,P[m+3]=C}}function L(P){const m=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return R.isLittleEndian()||O(m),c.VSBuffer.wrap(m)}function A(P){const m=P.buffer;if(R.isLittleEndian()||O(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const D=new Uint8Array(m.byteLength);return D.set(m),new Uint32Array(D.buffer,D.byteOffset,D.length/4)}}function y(P){const m=new Uint32Array(g(P));let D=0;if(m[D++]=P.id,P.type==="full")m[D++]=1,m[D++]=P.data.length,m.set(P.data,D),D+=P.data.length;else{m[D++]=2,m[D++]=P.deltas.length;for(const C of P.deltas)m[D++]=C.start,m[D++]=C.deleteCount,C.data?(m[D++]=C.data.length,m.set(C.data,D),D+=C.data.length):m[D++]=0}return L(m)}e.encodeSemanticTokensDto=y;function g(P){let m=0;if(m+=1+1,P.type==="full")m+=1+P.data.length;else{m+=1,m+=(1+1+1)*P.deltas.length;for(const D of P.deltas)D.data&&(m+=D.data.length)}return m}function T(P){const m=A(P);let D=0;const C=m[D++];if(m[D++]===1){const d=m[D++],S=m.subarray(D,D+d);return D+=d,{id:C,type:"full",data:S}}const n=m[D++],h=[];for(let d=0;d<n;d++){const S=m[D++],w=m[D++],p=m[D++];let t;p>0&&(t=m.subarray(D,D+p),D+=p),h[d]={start:S,deleteCount:w,data:t}}return{id:C,type:"delta",deltas:h}}e.decodeSemanticTokensDto=T}),define(Ce[168],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class c{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const L=this.a.get(O);return this.a.delete(O),L}}addDragOperationTransfer(O,L){this.a.set(O,L)}}e.TreeViewsDnDService=c;class R{constructor(O){this.identifier=O}}e.DraggedTreeItemsIdentifier=R}),define(Ce[169],De([1,0,3,4]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class u{constructor(){this.a=new Map,this.b=new Map,this.c=new c.Emitter,this.onDidChange=this.c.event,this.d=null}handleChange(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,y){return this.a.set(A,y),this.handleChange([A]),(0,R.toDisposable)(()=>{this.a.get(A)===y&&(this.a.delete(A),this.handleChange([A]))})}get(A){return this.a.get(A)||null}registerFactory(A,y){this.b.get(A)?.dispose();const g=new O(this,A,y);return this.b.set(A,g),(0,R.toDisposable)(()=>{const T=this.b.get(A);!T||T!==g||(this.b.delete(A),T.dispose())})}async getOrCreate(A){const y=this.get(A);if(y)return y;const g=this.b.get(A);return!g||g.isResolved?null:(await g.resolve(),this.get(A))}isResolved(A){if(this.get(A))return!0;const g=this.b.get(A);return!!(!g||g.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=u;class O extends R.Disposable{get isResolved(){return this.c}constructor(A,y,g){super(),this.f=A,this.g=y,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await this.h.tokenizationSupport;this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(Ce[76],De([1,0,72,2,36,169]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class L{constructor(k,F,$){this.offset=k,this.type=F,this.language=$,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=L;class A{constructor(k,F){this.tokens=k,this.endState=F,this._tokenizationResultBrand=void 0}}e.TokenizationResult=A;class y{constructor(k,F){this.tokens=k,this.endState=F,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=y;var g;(function(i){i[i.Method=0]="Method",i[i.Function=1]="Function",i[i.Constructor=2]="Constructor",i[i.Field=3]="Field",i[i.Variable=4]="Variable",i[i.Class=5]="Class",i[i.Struct=6]="Struct",i[i.Interface=7]="Interface",i[i.Module=8]="Module",i[i.Property=9]="Property",i[i.Event=10]="Event",i[i.Operator=11]="Operator",i[i.Unit=12]="Unit",i[i.Value=13]="Value",i[i.Constant=14]="Constant",i[i.Enum=15]="Enum",i[i.EnumMember=16]="EnumMember",i[i.Keyword=17]="Keyword",i[i.Text=18]="Text",i[i.Color=19]="Color",i[i.File=20]="File",i[i.Reference=21]="Reference",i[i.Customcolor=22]="Customcolor",i[i.Folder=23]="Folder",i[i.TypeParameter=24]="TypeParameter",i[i.User=25]="User",i[i.Issue=26]="Issue",i[i.Snippet=27]="Snippet"})(g||(e.CompletionItemKind=g={}));var T;(function(i){const k=new Map;k.set(0,c.Codicon.symbolMethod),k.set(1,c.Codicon.symbolFunction),k.set(2,c.Codicon.symbolConstructor),k.set(3,c.Codicon.symbolField),k.set(4,c.Codicon.symbolVariable),k.set(5,c.Codicon.symbolClass),k.set(6,c.Codicon.symbolStruct),k.set(7,c.Codicon.symbolInterface),k.set(8,c.Codicon.symbolModule),k.set(9,c.Codicon.symbolProperty),k.set(10,c.Codicon.symbolEvent),k.set(11,c.Codicon.symbolOperator),k.set(12,c.Codicon.symbolUnit),k.set(13,c.Codicon.symbolValue),k.set(15,c.Codicon.symbolEnum),k.set(14,c.Codicon.symbolConstant),k.set(15,c.Codicon.symbolEnum),k.set(16,c.Codicon.symbolEnumMember),k.set(17,c.Codicon.symbolKeyword),k.set(27,c.Codicon.symbolSnippet),k.set(18,c.Codicon.symbolText),k.set(19,c.Codicon.symbolColor),k.set(20,c.Codicon.symbolFile),k.set(21,c.Codicon.symbolReference),k.set(22,c.Codicon.symbolCustomColor),k.set(23,c.Codicon.symbolFolder),k.set(24,c.Codicon.symbolTypeParameter),k.set(25,c.Codicon.account),k.set(26,c.Codicon.issues);function F(W){let U=k.get(W);return U||(console.info("No codicon found for CompletionItemKind "+W),U=c.Codicon.symbolProperty),U}i.toIcon=F;const $=new Map;$.set("method",0),$.set("function",1),$.set("constructor",2),$.set("field",3),$.set("variable",4),$.set("class",5),$.set("struct",6),$.set("interface",7),$.set("module",8),$.set("property",9),$.set("event",10),$.set("operator",11),$.set("unit",12),$.set("value",13),$.set("constant",14),$.set("enum",15),$.set("enum-member",16),$.set("enumMember",16),$.set("keyword",17),$.set("snippet",27),$.set("text",18),$.set("color",19),$.set("file",20),$.set("reference",21),$.set("customcolor",22),$.set("folder",23),$.set("type-parameter",24),$.set("typeParameter",24),$.set("account",25),$.set("issue",26);function j(W,U){let x=$.get(W);return typeof x>"u"&&!U&&(x=9),x}i.fromString=j})(T||(e.CompletionItemKinds=T={}));var P;(function(i){i[i.Deprecated=1]="Deprecated"})(P||(e.CompletionItemTag=P={}));var m;(function(i){i[i.None=0]="None",i[i.KeepWhitespace=1]="KeepWhitespace",i[i.InsertAsSnippet=4]="InsertAsSnippet"})(m||(e.CompletionItemInsertTextRule=m={}));var D;(function(i){i[i.Invoke=0]="Invoke",i[i.TriggerCharacter=1]="TriggerCharacter",i[i.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D||(e.CompletionTriggerKind=D={}));var C;(function(i){i[i.Automatic=0]="Automatic",i[i.Explicit=1]="Explicit"})(C||(e.InlineCompletionTriggerKind=C={}));class b{constructor(k,F,$,j){this.range=k,this.text=F,this.completionKind=$,this.isSnippetText=j}equals(k){return u.Range.lift(this.range).equalsRange(k.range)&&this.text===k.text&&this.completionKind===k.completionKind&&this.isSnippetText===k.isSnippetText}}e.SelectedSuggestionInfo=b;var n;(function(i){i[i.Invoke=1]="Invoke",i[i.Auto=2]="Auto"})(n||(e.CodeActionTriggerType=n={}));var h;(function(i){i[i.Invoke=1]="Invoke",i[i.TriggerCharacter=2]="TriggerCharacter",i[i.ContentChange=3]="ContentChange"})(h||(e.SignatureHelpTriggerKind=h={}));var d;(function(i){i[i.Text=0]="Text",i[i.Read=1]="Read",i[i.Write=2]="Write"})(d||(e.DocumentHighlightKind=d={}));function S(i){return i&&R.URI.isUri(i.uri)&&u.Range.isIRange(i.range)&&(u.Range.isIRange(i.originSelectionRange)||u.Range.isIRange(i.targetSelectionRange))}e.isLocationLink=S;var w;(function(i){i[i.File=0]="File",i[i.Module=1]="Module",i[i.Namespace=2]="Namespace",i[i.Package=3]="Package",i[i.Class=4]="Class",i[i.Method=5]="Method",i[i.Property=6]="Property",i[i.Field=7]="Field",i[i.Constructor=8]="Constructor",i[i.Enum=9]="Enum",i[i.Interface=10]="Interface",i[i.Function=11]="Function",i[i.Variable=12]="Variable",i[i.Constant=13]="Constant",i[i.String=14]="String",i[i.Number=15]="Number",i[i.Boolean=16]="Boolean",i[i.Array=17]="Array",i[i.Object=18]="Object",i[i.Key=19]="Key",i[i.Null=20]="Null",i[i.EnumMember=21]="EnumMember",i[i.Struct=22]="Struct",i[i.Event=23]="Event",i[i.Operator=24]="Operator",i[i.TypeParameter=25]="TypeParameter"})(w||(e.SymbolKind=w={}));var p;(function(i){i[i.Deprecated=1]="Deprecated"})(p||(e.SymbolTag=p={}));var t;(function(i){const k=new Map;k.set(0,c.Codicon.symbolFile),k.set(1,c.Codicon.symbolModule),k.set(2,c.Codicon.symbolNamespace),k.set(3,c.Codicon.symbolPackage),k.set(4,c.Codicon.symbolClass),k.set(5,c.Codicon.symbolMethod),k.set(6,c.Codicon.symbolProperty),k.set(7,c.Codicon.symbolField),k.set(8,c.Codicon.symbolConstructor),k.set(9,c.Codicon.symbolEnum),k.set(10,c.Codicon.symbolInterface),k.set(11,c.Codicon.symbolFunction),k.set(12,c.Codicon.symbolVariable),k.set(13,c.Codicon.symbolConstant),k.set(14,c.Codicon.symbolString),k.set(15,c.Codicon.symbolNumber),k.set(16,c.Codicon.symbolBoolean),k.set(17,c.Codicon.symbolArray),k.set(18,c.Codicon.symbolObject),k.set(19,c.Codicon.symbolKey),k.set(20,c.Codicon.symbolNull),k.set(21,c.Codicon.symbolEnumMember),k.set(22,c.Codicon.symbolStruct),k.set(23,c.Codicon.symbolEvent),k.set(24,c.Codicon.symbolOperator),k.set(25,c.Codicon.symbolTypeParameter);function F($){let j=k.get($);return j||(console.info("No codicon found for SymbolKind "+$),j=c.Codicon.symbolProperty),j}i.toIcon=F})(t||(e.SymbolKinds=t={}));class a{static fromValue(k){switch(k){case"comment":return a.Comment;case"imports":return a.Imports;case"region":return a.Region}return new a(k)}constructor(k){this.value=k}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var r;(function(i){function k(F){return!F||typeof F!="object"?!1:typeof F.id=="string"&&typeof F.title=="string"}i.is=k})(r||(e.Command=r={}));var o;(function(i){i[i.Collapsed=0]="Collapsed",i[i.Expanded=1]="Expanded"})(o||(e.CommentThreadCollapsibleState=o={}));var f;(function(i){i[i.Unresolved=0]="Unresolved",i[i.Resolved=1]="Resolved"})(f||(e.CommentThreadState=f={}));var v;(function(i){i[i.Editing=0]="Editing",i[i.Preview=1]="Preview"})(v||(e.CommentMode=v={}));var l;(function(i){i[i.Published=0]="Published",i[i.Draft=1]="Draft"})(l||(e.CommentState=l={}));var I;(function(i){i[i.Type=1]="Type",i[i.Parameter=2]="Parameter"})(I||(e.InlayHintKind=I={}));class E{constructor(k){this.b=k,this.a=null}dispose(){this.a&&this.a.then(k=>{k&&k.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.LazyTokenizationSupport=E,e.TokenizationRegistry=new O.TokenizationRegistry;var s;(function(i){i[i.None=0]="None",i[i.Option=1]="Option",i[i.Default=2]="Default",i[i.Preferred=3]="Preferred"})(s||(e.ExternalUriOpenerPriority=s={}))}),define(Ce[170],De([14,15]),function(re,e){return re.create("vs/base/common/actions",e)}),define(Ce[171],De([1,0,3,4,170]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class O extends R.Disposable{constructor(m,D="",C="",b=!0,n){super(),this.h=this.B(new c.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=D,this.u=C,this.w=b,this.C=n}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,D){this.C&&await this.C(m)}}e.Action=O;class L extends R.Disposable{constructor(){super(...arguments),this.f=this.B(new c.Emitter),this.onWillRun=this.f.event,this.h=this.B(new c.Emitter),this.onDidRun=this.h.event}async run(m,D){if(!m.enabled)return;this.f.fire({action:m});let C;try{await this.k(m,D)}catch(b){C=b}this.h.fire({action:m,error:C})}async k(m,D){await m.run(D)}}e.ActionRunner=L;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let D=[];for(const C of m)C.length&&(D.length?D=[...D,new A,...C]:D=C);return D}async run(){}}e.Separator=A,A.ID="vs.actions.separator";class y{get actions(){return this.a}constructor(m,D,C,b){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=D,this.class=b,this.a=C}async run(){}}e.SubmenuAction=y;class g extends O{constructor(){super(g.ID,u.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=g,g.ID="vs.actions.empty";function T(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}e.toAction=T}),define(Ce[172],De([14,15]),function(re,e){return re.create("vs/base/common/date",e)}),define(Ce[173],De([1,0,172]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,u=R*60,O=u*24,L=O*7,A=O*30,y=O*365;function g(P,m,D,C){typeof P!="number"&&(P=P.getTime());const b=Math.round((new Date().getTime()-P)/1e3);if(b<-30)return(0,c.localize)(0,null,g(new Date().getTime()+b*1e3,!1));if(!C&&b<30)return(0,c.localize)(1,null);let n;return b<R?(n=b,m?n===1?D?(0,c.localize)(2,null,n):(0,c.localize)(3,null,n):D?(0,c.localize)(4,null,n):(0,c.localize)(5,null,n):n===1?D?(0,c.localize)(6,null,n):(0,c.localize)(7,null,n):D?(0,c.localize)(8,null,n):(0,c.localize)(9,null,n)):b<u?(n=Math.floor(b/R),m?n===1?D?(0,c.localize)(10,null,n):(0,c.localize)(11,null,n):D?(0,c.localize)(12,null,n):(0,c.localize)(13,null,n):n===1?D?(0,c.localize)(14,null,n):(0,c.localize)(15,null,n):D?(0,c.localize)(16,null,n):(0,c.localize)(17,null,n)):b<O?(n=Math.floor(b/u),m?n===1?D?(0,c.localize)(18,null,n):(0,c.localize)(19,null,n):D?(0,c.localize)(20,null,n):(0,c.localize)(21,null,n):n===1?D?(0,c.localize)(22,null,n):(0,c.localize)(23,null,n):D?(0,c.localize)(24,null,n):(0,c.localize)(25,null,n)):b<L?(n=Math.floor(b/O),m?n===1?(0,c.localize)(26,null,n):(0,c.localize)(27,null,n):n===1?(0,c.localize)(28,null,n):(0,c.localize)(29,null,n)):b<A?(n=Math.floor(b/L),m?n===1?D?(0,c.localize)(30,null,n):(0,c.localize)(31,null,n):D?(0,c.localize)(32,null,n):(0,c.localize)(33,null,n):n===1?D?(0,c.localize)(34,null,n):(0,c.localize)(35,null,n):D?(0,c.localize)(36,null,n):(0,c.localize)(37,null,n)):b<y?(n=Math.floor(b/A),m?n===1?D?(0,c.localize)(38,null,n):(0,c.localize)(39,null,n):D?(0,c.localize)(40,null,n):(0,c.localize)(41,null,n):n===1?D?(0,c.localize)(42,null,n):(0,c.localize)(43,null,n):D?(0,c.localize)(44,null,n):(0,c.localize)(45,null,n)):(n=Math.floor(b/y),m?n===1?D?(0,c.localize)(46,null,n):(0,c.localize)(47,null,n):D?(0,c.localize)(48,null,n):(0,c.localize)(49,null,n):n===1?D?(0,c.localize)(50,null,n):(0,c.localize)(51,null,n):D?(0,c.localize)(52,null,n):(0,c.localize)(53,null,n))}e.fromNow=g;function T(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(Ce[174],De([14,15]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(Ce[46],De([1,0,19,12,174]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function O(P,m){return m&&(P.stack||P.stacktrace)?u.localize(0,null,A(P),L(P.stack)||L(P.stacktrace)):A(P)}function L(P){return Array.isArray(P)?P.join(`
`):P}function A(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?u.localize(1,null,P.message):P.message||u.localize(2,null)}function y(P=null,m=!1){if(!P)return u.localize(3,null);if(Array.isArray(P)){const D=c.coalesce(P),C=y(D[0],m);return D.length>1?u.localize(4,null,C,D.length):C}if(R.isString(P))return P;if(P.detail){const D=P.detail;if(D.error)return O(D.error,m);if(D.exception)return O(D.exception,m)}return P.stack?O(P,m):P.message?P.message:u.localize(5,null)}e.toErrorMessage=y;function g(P){const m=P;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=g;function T(P,m){let D;return typeof P=="string"?D=new Error(P):D=P,D.actions=m,D}e.createErrorWithActions=T}),define(Ce[175],De([14,15]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(Ce[124],De([1,0,175,9,121,19,23,160]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(J){this.c=J}hasChanged(J){return this.c[J]}}e.ConfigurationChangedEvent=g;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class P{constructor(J,me,Fe,ze){this.id=J,this.name=me,this.defaultValue=Fe,this.schema=ze}applyUpdate(J,me){return D(J,me)}compute(J,me,Fe){return Fe}}class m{constructor(J,me){this.newValue=J,this.didChange=me}}e.ApplyUpdateResult=m;function D(X,J){if(typeof X!="object"||typeof J!="object"||!X||!J)return new m(J,X!==J);if(Array.isArray(X)||Array.isArray(J)){const Fe=Array.isArray(X)&&Array.isArray(J)&&O.equals(X,J);return new m(J,!Fe)}let me=!1;for(const Fe in J)if(J.hasOwnProperty(Fe)){const ze=D(X[Fe],J[Fe]);ze.didChange&&(X[Fe]=ze.newValue,me=!0)}return new m(X,me)}class C{constructor(J){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0}applyUpdate(J,me){return D(J,me)}validate(J){return this.defaultValue}}class b{constructor(J,me,Fe,ze){this.id=J,this.name=me,this.defaultValue=Fe,this.schema=ze}applyUpdate(J,me){return D(J,me)}validate(J){return typeof J>"u"?this.defaultValue:J}compute(J,me,Fe){return Fe}}function n(X,J){return typeof X>"u"?J:X==="false"?!1:!!X}e.boolean=n;class h extends b{constructor(J,me,Fe,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=Fe),super(J,me,Fe,ze)}validate(J){return n(J,this.defaultValue)}}function d(X,J,me,Fe){if(typeof X>"u")return J;let ze=parseInt(X,10);return isNaN(ze)?J:(ze=Math.max(me,ze),ze=Math.min(Fe,ze),ze|0)}e.clampedInt=d;class S extends b{static clampedInt(J,me,Fe,ze){return d(J,me,Fe,ze)}constructor(J,me,Fe,ze,He,Je=void 0){typeof Je<"u"&&(Je.type="integer",Je.default=Fe,Je.minimum=ze,Je.maximum=He),super(J,me,Fe,Je),this.minimum=ze,this.maximum=He}validate(J){return S.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}function w(X,J,me,Fe){if(typeof X>"u")return J;const ze=p.float(X,J);return p.clamp(ze,me,Fe)}e.clampedFloat=w;class p extends b{static clamp(J,me,Fe){return J<me?me:J>Fe?Fe:J}static float(J,me){if(typeof J=="number")return J;if(typeof J>"u")return me;const Fe=parseFloat(J);return isNaN(Fe)?me:Fe}constructor(J,me,Fe,ze,He){typeof He<"u"&&(He.type="number",He.default=Fe),super(J,me,Fe,He),this.validationFn=ze}validate(J){return this.validationFn(p.float(J,this.defaultValue))}}class t extends b{static string(J,me){return typeof J!="string"?me:J}constructor(J,me,Fe,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=Fe),super(J,me,Fe,ze)}validate(J){return t.string(J,this.defaultValue)}}function a(X,J,me,Fe){return typeof X!="string"?J:Fe&&X in Fe?Fe[X]:me.indexOf(X)===-1?J:X}e.stringSet=a;class r extends b{constructor(J,me,Fe,ze,He=void 0){typeof He<"u"&&(He.type="string",He.enum=ze,He.default=Fe),super(J,me,Fe,He),this.c=ze}validate(J){return a(J,this.defaultValue,this.c)}}class o extends P{constructor(J,me,Fe,ze,He,Je,ct=void 0){typeof ct<"u"&&(ct.type="string",ct.enum=He,ct.default=ze),super(J,me,Fe,ct),this.c=He,this.d=Je}validate(J){return typeof J!="string"?this.defaultValue:this.c.indexOf(J)===-1?this.defaultValue:this.d(J)}}function f(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,me,Fe){return Fe===0?J.accessibilitySupport:Fe}}class l extends P{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:c.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertSpace:n(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function E(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var s;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(s||(e.TextEditorCursorStyle=s={}));function i(X){switch(X){case s.Line:return"line";case s.Block:return"block";case s.Underline:return"underline";case s.LineThin:return"line-thin";case s.BlockOutline:return"block-outline";case s.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=i;function k(X){switch(X){case"line":return s.Line;case"block":return s.Block;case"underline":return s.Underline;case"line-thin":return s.LineThin;case"block-outline":return s.BlockOutline;case"underline-thin":return s.UnderlineThin}}class F extends C{constructor(){super(137)}compute(J,me,Fe){const ze=["monaco-editor"];return me.get(37)&&ze.push(me.get(37)),J.extraEditorClassName&&ze.push(J.extraEditorClassName),me.get(71)==="default"?ze.push("mouse-default"):me.get(71)==="copy"&&ze.push("mouse-copy"),me.get(107)&&ze.push("showUnused"),me.get(135)&&ze.push("showDeprecated"),ze.join(" ")}}class $ extends h{constructor(){super(35,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(J,me,Fe){return Fe&&J.emptySelectionClipboard}}class j extends P{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:c.localize(16,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:c.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{cursorMoveOnType:n(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":a(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":a(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(me.loop,this.defaultValue.loop)}}}class W extends P{constructor(){super(49,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?W.OFF:J==="true"?W.ON:J:J?W.ON:W.OFF}}e.EditorFontLigatures=W,W.OFF='"liga" off, "calt" off',W.ON='"liga" on, "calt" on';class U extends P{constructor(){super(52,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?U.OFF:J==="true"?U.TRANSLATE:J:J?U.TRANSLATE:U.OFF}compute(J,me,Fe){return J.fontInfo.fontVariationSettings}}e.EditorFontVariations=U,U.OFF="normal",U.TRANSLATE="translate";class x extends C{constructor(){super(48)}compute(J,me,Fe){return J.fontInfo}}class B extends b{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(J){const me=p.float(J,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(me,6,100)}compute(J,me,Fe){return J.fontInfo.fontSize}}class z extends P{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(J){return J==="normal"||J==="bold"?J:String(S.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class ee extends P{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Fe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Fe,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Fe,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Fe,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Fe,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Fe,description:c.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{multiple:a(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??a(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??a(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??a(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??a(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??a(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class se extends P{constructor(){const J={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:J.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:c.localize(44,null)},"editor.hover.above":{type:"boolean",default:J.above,description:c.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),delay:S.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:n(me.sticky,this.defaultValue.sticky),above:n(me.above,this.defaultValue.above)}}}var V;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(V||(e.RenderMinimap=V={}));class Z extends C{constructor(){super(140)}compute(J,me,Fe){return Z.computeLayout(me,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio,glyphMarginDecorationLaneCount:J.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(J){const me=J.height/J.lineHeight,Fe=Math.floor(J.paddingTop/J.lineHeight);let ze=Math.floor(J.paddingBottom/J.lineHeight);J.scrollBeyondLastLine&&(ze=Math.max(ze,me-1));const He=(Fe+J.viewLineCount+ze)/(J.pixelRatio*J.height),Je=Math.floor(J.viewLineCount/He);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:Fe,extraLinesBeyondLastLine:ze,desiredRatio:He,minimapLineCount:Je}}static c(J,me){const Fe=J.outerWidth,ze=J.outerHeight,He=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(He*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Je=me.stableMinimapLayoutInput,ct=Je&&J.outerHeight===Je.outerHeight&&J.lineHeight===Je.lineHeight&&J.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&J.pixelRatio===Je.pixelRatio&&J.scrollBeyondLastLine===Je.scrollBeyondLastLine&&J.paddingTop===Je.paddingTop&&J.paddingBottom===Je.paddingBottom&&J.minimap.enabled===Je.minimap.enabled&&J.minimap.side===Je.minimap.side&&J.minimap.size===Je.minimap.size&&J.minimap.showSlider===Je.minimap.showSlider&&J.minimap.renderCharacters===Je.minimap.renderCharacters&&J.minimap.maxColumn===Je.minimap.maxColumn&&J.minimap.scale===Je.minimap.scale&&J.verticalScrollbarWidth===Je.verticalScrollbarWidth&&J.isViewportWrapping===Je.isViewportWrapping,st=J.lineHeight,ft=J.typicalHalfwidthCharacterWidth,Pt=J.scrollBeyondLastLine,Tt=J.minimap.renderCharacters;let vt=He>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Ht=J.minimap.maxColumn,Mt=J.minimap.size,qt=J.minimap.side,Ft=J.verticalScrollbarWidth,Ut=J.viewLineCount,jt=J.remainingWidth,ut=J.isViewportWrapping,gt=Tt?2:3;let Bt=Math.floor(He*ze);const $t=Bt/He;let yt=!1,mt=!1,kt=gt*vt,zt=vt/He,Oe=1;if(Mt==="fill"||Mt==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeforeFirstLine:it,extraLinesBeyondLastLine:Ct,desiredRatio:Lt,minimapLineCount:At}=Z.computeContainedMinimapLineCount({viewLineCount:Ut,scrollBeyondLastLine:Pt,paddingTop:J.paddingTop,paddingBottom:J.paddingBottom,height:ze,lineHeight:st,pixelRatio:He});if(Ut/At>1)yt=!0,mt=!0,vt=1,kt=1,zt=vt/He;else{let lt=!1,bt=vt+1;if(Mt==="fit"){const wt=Math.ceil((it+Ut+Ct)*kt);ut&&ct&&jt<=me.stableFitRemainingWidth?(lt=!0,bt=me.stableFitMaxMinimapScale):lt=wt>Bt}if(Mt==="fill"||lt){yt=!0;const wt=vt;kt=Math.min(st*He,Math.max(1,Math.floor(1/Lt))),ut&&ct&&jt<=me.stableFitRemainingWidth&&(bt=me.stableFitMaxMinimapScale),vt=Math.min(bt,Math.max(1,Math.floor(kt/gt))),vt>wt&&(Oe=Math.min(2,vt/wt)),zt=vt/He/Oe,Bt=Math.ceil(Math.max(Ge,it+Ut+Ct)*kt),ut?(me.stableMinimapLayoutInput=J,me.stableFitRemainingWidth=jt,me.stableFitMaxMinimapScale=vt):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const Ae=Math.floor(Ht*zt),Pe=Math.min(Ae,Math.max(0,Math.floor((jt-Ft-2)*zt/(ft+zt)))+e.MINIMAP_GUTTER_WIDTH);let ce=Math.floor(He*Pe);const Me=ce/He;ce=Math.floor(ce*Oe);const We=Tt?1:2,Ye=qt==="left"?0:Fe-Pe-Ft;return{renderMinimap:We,minimapLeft:Ye,minimapWidth:Pe,minimapHeightIsEditorHeight:yt,minimapIsSampling:mt,minimapScale:vt,minimapLineHeight:kt,minimapCanvasInnerWidth:ce,minimapCanvasInnerHeight:Bt,minimapCanvasOuterWidth:Me,minimapCanvasOuterHeight:$t}}static computeLayout(J,me){const Fe=me.outerWidth|0,ze=me.outerHeight|0,He=me.lineHeight|0,Je=me.lineNumbersDigitCount|0,ct=me.typicalHalfwidthCharacterWidth,st=me.maxDigitWidth,ft=me.pixelRatio,Pt=me.viewLineCount,Tt=J.get(132),vt=Tt==="inherit"?J.get(131):Tt,Ht=vt==="inherit"?J.get(127):vt,Mt=J.get(130),qt=me.isDominatedByLongLines,Ft=J.get(55),Ut=J.get(65).renderType!==0,jt=J.get(66),ut=J.get(101),gt=J.get(81),Bt=J.get(70),$t=J.get(99),yt=$t.verticalScrollbarSize,mt=$t.verticalHasArrows,kt=$t.arrowSize,zt=$t.horizontalScrollbarSize,Oe=J.get(41),Ae=J.get(106)!=="never";let Pe=J.get(63);Oe&&Ae&&(Pe+=16);let ce=0;if(Ut){const oi=Math.max(Je,jt);ce=Math.round(oi*st)}let Me=0;Ft&&(Me=He*me.glyphMarginDecorationLaneCount);let We=0,Ye=We+Me,Ge=Ye+ce,it=Ge+Pe;const Ct=Fe-Me-ce-Pe;let Lt=!1,At=!1,Et=-1;vt==="inherit"&&qt?(Lt=!0,At=!0):Ht==="on"||Ht==="bounded"?At=!0:Ht==="wordWrapColumn"&&(Et=Mt);const lt=Z.c({outerWidth:Fe,outerHeight:ze,lineHeight:He,typicalHalfwidthCharacterWidth:ct,pixelRatio:ft,scrollBeyondLastLine:ut,paddingTop:gt.top,paddingBottom:gt.bottom,minimap:Bt,verticalScrollbarWidth:yt,viewLineCount:Pt,remainingWidth:Ct,isViewportWrapping:At},me.memory||new T);lt.renderMinimap!==0&&lt.minimapLeft===0&&(We+=lt.minimapWidth,Ye+=lt.minimapWidth,Ge+=lt.minimapWidth,it+=lt.minimapWidth);const bt=Ct-lt.minimapWidth,wt=Math.max(1,Math.floor((bt-yt-2)/ct)),St=mt?kt:0;return At&&(Et=Math.max(1,wt),Ht==="bounded"&&(Et=Math.min(Et,Mt))),{width:Fe,height:ze,glyphMarginLeft:We,glyphMarginWidth:Me,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:Ye,lineNumbersWidth:ce,decorationsLeft:Ge,decorationsWidth:Pe,contentLeft:it,contentWidth:bt,minimap:lt,viewportColumn:wt,isWordWrapMinified:Lt,isViewportWrapping:At,wrappingColumn:Et,verticalScrollbarWidth:yt,horizontalScrollbarHeight:zt,overviewRuler:{top:St,width:yt,height:ze-2*St,right:0}}}}e.EditorLayoutInfoComputer=Z;class q extends P{constructor(){super(134,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(46,null),c.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(48,null)}})}validate(J){return a(J,"simple",["simple","advanced"])}compute(J,me,Fe){return me.get(2)===2?"advanced":Fe}}class ae extends P{constructor(){const J={enabled:!0};super(62,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:c.localize(49,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class Ee extends P{constructor(){const J={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(111,"stickyScroll",J,{"editor.stickyScroll.enabled":{type:"boolean",default:J.enabled,description:c.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:J.maxLineCount,minimum:1,maximum:10,description:c.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:J.defaultModel,description:c.localize(52,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),maxLineCount:S.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class ye extends P{constructor(){const J={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(136,"inlayHints",J,{"editor.inlayHints.enabled":{type:"string",default:J.enabled,description:c.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(54,null),c.localize(55,null,R.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(56,null,R.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:c.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:c.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:J.padding,description:c.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:a(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:S.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),padding:n(me.padding,this.defaultValue.padding)}}}class be extends P{constructor(){super(63,"lineDecorationsWidth",10)}validate(J){return typeof J=="string"&&/^\d+(\.\d+)?ch$/.test(J)?-parseFloat(J.substring(0,J.length-2)):S.clampedInt(J,this.defaultValue,0,1e3)}compute(J,me,Fe){return Fe<0?S.clampedInt(-Fe*J.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Fe}}class M extends p{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>p.clamp(J,0,150),{markdownDescription:c.localize(61,null)})}compute(J,me,Fe){return J.fontInfo.lineHeight}}class Q extends P{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:c.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:J.autohide,description:c.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(64,null),c.localize(65,null),c.localize(66,null)],default:J.size,description:c.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:c.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:c.localize(69,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:c.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:c.localize(72,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),autohide:n(me.autohide,this.defaultValue.autohide),size:a(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(me.side,this.defaultValue.side,["right","left"]),showSlider:a(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(me.renderCharacters,this.defaultValue.renderCharacters),scale:S.clampedInt(me.scale,1,1,3),maxColumn:S.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function fe(X){return X==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class we extends P{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(74,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{top:S.clampedInt(me.top,0,0,1e3),bottom:S.clampedInt(me.bottom,0,0,1e3)}}}class _ extends P{constructor(){const J={enabled:!0,cycle:!0};super(83,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:c.localize(76,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),cycle:n(me.cycle,this.defaultValue.cycle)}}}class ne extends C{constructor(){super(138)}compute(J,me,Fe){return J.pixelRatio}}class le extends P{constructor(){const J={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(77,null),c.localize(78,null),c.localize(79,null)]}];super(86,"quickSuggestions",J,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:J.strings,description:c.localize(80,null)},comments:{anyOf:me,default:J.comments,description:c.localize(81,null)},other:{anyOf:me,default:J.other,description:c.localize(82,null)}},default:J,markdownDescription:c.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=J}validate(J){if(typeof J=="boolean"){const ft=J?"on":"off";return{comments:ft,strings:ft,other:ft}}if(!J||typeof J!="object")return this.defaultValue;const{other:me,comments:Fe,strings:ze}=J,He=["on","inline","off"];let Je,ct,st;return typeof me=="boolean"?Je=me?"on":"off":Je=a(me,this.defaultValue.other,He),typeof Fe=="boolean"?ct=Fe?"on":"off":ct=a(Fe,this.defaultValue.comments,He),typeof ze=="boolean"?st=ze?"on":"off":st=a(ze,this.defaultValue.strings,He),{other:Je,comments:ct,strings:st}}}var te;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class de extends P{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(84,null),c.localize(85,null),c.localize(86,null),c.localize(87,null)],default:"on",description:c.localize(88,null)})}validate(J){let me=this.defaultValue.renderType,Fe=this.defaultValue.renderFn;return typeof J<"u"&&(typeof J=="function"?(me=4,Fe=J):J==="interval"?me=3:J==="relative"?me=2:J==="on"?me=1:me=0),{renderType:me,renderFn:Fe}}}function oe(X){const J=X.get(94);return J==="editable"?X.get(88):J!=="on"}e.filterValidationDecorations=oe;class ue extends P{constructor(){const J=[],me={type:"number",description:c.localize(89,null)};super(98,"rulers",J,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:c.localize(90,null),format:"color-hex"}}}]},default:J,description:c.localize(91,null)})}validate(J){if(Array.isArray(J)){const me=[];for(const Fe of J)if(typeof Fe=="number")me.push({column:S.clampedInt(Fe,0,0,1e4),color:null});else if(Fe&&typeof Fe=="object"){const ze=Fe;me.push({column:S.clampedInt(ze.column,0,0,1e4),color:ze.color})}return me.sort((Fe,ze)=>Fe.column-ze.column),me}return this.defaultValue}}function N(X,J){if(typeof X!="string")return J;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class G extends P{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(99,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(92,null),c.localize(93,null),c.localize(94,null)],default:"auto",description:c.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(96,null),c.localize(97,null),c.localize(98,null)],default:"auto",description:c.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:c.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:c.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:c.localize(102,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J,Fe=S.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=S.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:S.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(me.vertical,this.defaultValue.vertical),horizontal:N(me.horizontal,this.defaultValue.horizontal),useShadows:n(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Fe,horizontalSliderSize:S.clampedInt(me.horizontalSliderSize,Fe,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:S.clampedInt(me.verticalSliderSize,ze,0,1e3),scrollByPage:n(me.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Y extends P{constructor(){const J={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(121,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.nonBasicASCII,description:c.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:J.invisibleCharacters,description:c.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:J.ambiguousCharacters,description:c.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeComments,description:c.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeStrings,description:c.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:J.allowedCharacters,description:c.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:J.allowedLocales,description:c.localize(109,null)}})}applyUpdate(J,me){let Fe=!1;me.allowedCharacters&&J&&(L.equals(J.allowedCharacters,me.allowedCharacters)||(J={...J,allowedCharacters:me.allowedCharacters},Fe=!0)),me.allowedLocales&&J&&(L.equals(J.allowedLocales,me.allowedLocales)||(J={...J,allowedLocales:me.allowedLocales},Fe=!0));const ze=super.applyUpdate(J,me);return Fe?new m(ze.newValue,!0):ze}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{nonBasicASCII:he(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(J.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(J.allowedLocales,this.defaultValue.allowedLocales)}}c(J,me){if(typeof J!="object"||!J)return me;const Fe={};for(const[ze,He]of Object.entries(J))He===!0&&(Fe[ze]=!0);return Fe}}class ie extends P{constructor(){const J={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(60,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:c.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:J.showToolbar,enum:["always","onHover"],enumDescriptions:[c.localize(111,null),c.localize(112,null)],description:c.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:J.suppressSuggestions,description:c.localize(114,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),mode:a(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a(me.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:n(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(me.keepOnBlur,this.defaultValue.keepOnBlur)}}}class pe extends P{constructor(){const J={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,markdownDescription:c.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:J.independentColorPoolPerBracketType,description:c.localize(116,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ie extends P{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(117,null),c.localize(118,null),c.localize(119,null)],default:J.bracketPairs,description:c.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(121,null),c.localize(122,null),c.localize(123,null)],default:J.bracketPairsHorizontal,description:c.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:c.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:c.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(127,null),c.localize(128,null),c.localize(129,null)],default:J.highlightActiveIndentation,description:c.localize(130,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{bracketPairs:he(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(X,J,me){const Fe=me.indexOf(X);return Fe===-1?J:me[Fe]}class Re extends P{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(114,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(131,null),c.localize(132,null)],default:J.insertMode,description:c.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:c.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:c.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:c.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(137,null),c.localize(138,null),c.localize(139,null),c.localize(140,null)],default:J.selectionMode,markdownDescription:c.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:c.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:c.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:c.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:c.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:c.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(178,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertMode:a(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(me.showIcons,this.defaultValue.showIcons),showStatusBar:n(me.showStatusBar,this.defaultValue.showStatusBar),preview:n(me.preview,this.defaultValue.preview),previewMode:a(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(me.showMethods,this.defaultValue.showMethods),showFunctions:n(me.showFunctions,this.defaultValue.showFunctions),showConstructors:n(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(me.showFields,this.defaultValue.showFields),showVariables:n(me.showVariables,this.defaultValue.showVariables),showClasses:n(me.showClasses,this.defaultValue.showClasses),showStructs:n(me.showStructs,this.defaultValue.showStructs),showInterfaces:n(me.showInterfaces,this.defaultValue.showInterfaces),showModules:n(me.showModules,this.defaultValue.showModules),showProperties:n(me.showProperties,this.defaultValue.showProperties),showEvents:n(me.showEvents,this.defaultValue.showEvents),showOperators:n(me.showOperators,this.defaultValue.showOperators),showUnits:n(me.showUnits,this.defaultValue.showUnits),showValues:n(me.showValues,this.defaultValue.showValues),showConstants:n(me.showConstants,this.defaultValue.showConstants),showEnums:n(me.showEnums,this.defaultValue.showEnums),showEnumMembers:n(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(me.showKeywords,this.defaultValue.showKeywords),showWords:n(me.showWords,this.defaultValue.showWords),showColors:n(me.showColors,this.defaultValue.showColors),showFiles:n(me.showFiles,this.defaultValue.showFiles),showReferences:n(me.showReferences,this.defaultValue.showReferences),showFolders:n(me.showFolders,this.defaultValue.showFolders),showTypeParameters:n(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(me.showSnippets,this.defaultValue.showSnippets),showUsers:n(me.showUsers,this.defaultValue.showUsers),showIssues:n(me.showIssues,this.defaultValue.showIssues)}}}class Te extends P{constructor(){super(109,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(179,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var Ve;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class xe extends P{constructor(){super(133,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(180,null),c.localize(181,null),c.localize(182,null),c.localize(183,null)],description:c.localize(184,null),default:"same"}})}validate(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(J,me,Fe){return me.get(2)===2?0:Fe}}class tt extends C{constructor(){super(141)}compute(J,me,Fe){const ze=me.get(140);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class Qe extends P{constructor(){const J={enabled:!0,showDropSelector:"afterDrop"};super(34,"dropIntoEditor",J,{"editor.dropIntoEditor.enabled":{type:"boolean",default:J.enabled,markdownDescription:c.localize(185,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(186,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(187,null),c.localize(188,null)],default:"afterDrop"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),showDropSelector:a(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Xe extends P{constructor(){const J={enabled:!0,showPasteSelector:"afterPaste"};super(82,"pasteAs",J,{"editor.pasteAs.enabled":{type:"boolean",default:J.enabled,markdownDescription:c.localize(189,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(190,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(191,null),c.localize(192,null)],default:"afterPaste"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),showPasteSelector:a(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",ot="Menlo, Monaco, 'Courier New', monospace",et="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?ot:R.isLinux?et:nt,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(X){return e.editorOptionsRegistry[X.id]=X,X}var ke;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=7]="autoClosingDelete",X[X.autoClosingOvertype=8]="autoClosingOvertype",X[X.autoClosingQuotes=9]="autoClosingQuotes",X[X.autoIndent=10]="autoIndent",X[X.automaticLayout=11]="automaticLayout",X[X.autoSurround=12]="autoSurround",X[X.bracketPairColorization=13]="bracketPairColorization",X[X.guides=14]="guides",X[X.codeLens=15]="codeLens",X[X.codeLensFontFamily=16]="codeLensFontFamily",X[X.codeLensFontSize=17]="codeLensFontSize",X[X.colorDecorators=18]="colorDecorators",X[X.colorDecoratorsLimit=19]="colorDecoratorsLimit",X[X.columnSelection=20]="columnSelection",X[X.comments=21]="comments",X[X.contextmenu=22]="contextmenu",X[X.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",X[X.cursorBlinking=24]="cursorBlinking",X[X.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",X[X.cursorStyle=26]="cursorStyle",X[X.cursorSurroundingLines=27]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",X[X.cursorWidth=29]="cursorWidth",X[X.disableLayerHinting=30]="disableLayerHinting",X[X.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",X[X.domReadOnly=32]="domReadOnly",X[X.dragAndDrop=33]="dragAndDrop",X[X.dropIntoEditor=34]="dropIntoEditor",X[X.emptySelectionClipboard=35]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",X[X.extraEditorClassName=37]="extraEditorClassName",X[X.fastScrollSensitivity=38]="fastScrollSensitivity",X[X.find=39]="find",X[X.fixedOverflowWidgets=40]="fixedOverflowWidgets",X[X.folding=41]="folding",X[X.foldingStrategy=42]="foldingStrategy",X[X.foldingHighlight=43]="foldingHighlight",X[X.foldingImportsByDefault=44]="foldingImportsByDefault",X[X.foldingMaximumRegions=45]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=47]="fontFamily",X[X.fontInfo=48]="fontInfo",X[X.fontLigatures=49]="fontLigatures",X[X.fontSize=50]="fontSize",X[X.fontWeight=51]="fontWeight",X[X.fontVariations=52]="fontVariations",X[X.formatOnPaste=53]="formatOnPaste",X[X.formatOnType=54]="formatOnType",X[X.glyphMargin=55]="glyphMargin",X[X.gotoLocation=56]="gotoLocation",X[X.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",X[X.hover=58]="hover",X[X.inDiffEditor=59]="inDiffEditor",X[X.inlineSuggest=60]="inlineSuggest",X[X.letterSpacing=61]="letterSpacing",X[X.lightbulb=62]="lightbulb",X[X.lineDecorationsWidth=63]="lineDecorationsWidth",X[X.lineHeight=64]="lineHeight",X[X.lineNumbers=65]="lineNumbers",X[X.lineNumbersMinChars=66]="lineNumbersMinChars",X[X.linkedEditing=67]="linkedEditing",X[X.links=68]="links",X[X.matchBrackets=69]="matchBrackets",X[X.minimap=70]="minimap",X[X.mouseStyle=71]="mouseStyle",X[X.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=73]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",X[X.multiCursorModifier=75]="multiCursorModifier",X[X.multiCursorPaste=76]="multiCursorPaste",X[X.multiCursorLimit=77]="multiCursorLimit",X[X.occurrencesHighlight=78]="occurrencesHighlight",X[X.overviewRulerBorder=79]="overviewRulerBorder",X[X.overviewRulerLanes=80]="overviewRulerLanes",X[X.padding=81]="padding",X[X.pasteAs=82]="pasteAs",X[X.parameterHints=83]="parameterHints",X[X.peekWidgetDefaultFocus=84]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=85]="definitionLinkOpensInPeek",X[X.quickSuggestions=86]="quickSuggestions",X[X.quickSuggestionsDelay=87]="quickSuggestionsDelay",X[X.readOnly=88]="readOnly",X[X.renameOnType=89]="renameOnType",X[X.renderControlCharacters=90]="renderControlCharacters",X[X.renderFinalNewline=91]="renderFinalNewline",X[X.renderLineHighlight=92]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=93]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=94]="renderValidationDecorations",X[X.renderWhitespace=95]="renderWhitespace",X[X.revealHorizontalRightPadding=96]="revealHorizontalRightPadding",X[X.roundedSelection=97]="roundedSelection",X[X.rulers=98]="rulers",X[X.scrollbar=99]="scrollbar",X[X.scrollBeyondLastColumn=100]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=101]="scrollBeyondLastLine",X[X.scrollPredominantAxis=102]="scrollPredominantAxis",X[X.selectionClipboard=103]="selectionClipboard",X[X.selectionHighlight=104]="selectionHighlight",X[X.selectOnLineNumbers=105]="selectOnLineNumbers",X[X.showFoldingControls=106]="showFoldingControls",X[X.showUnused=107]="showUnused",X[X.snippetSuggestions=108]="snippetSuggestions",X[X.smartSelect=109]="smartSelect",X[X.smoothScrolling=110]="smoothScrolling",X[X.stickyScroll=111]="stickyScroll",X[X.stickyTabStops=112]="stickyTabStops",X[X.stopRenderingLineAfter=113]="stopRenderingLineAfter",X[X.suggest=114]="suggest",X[X.suggestFontSize=115]="suggestFontSize",X[X.suggestLineHeight=116]="suggestLineHeight",X[X.suggestOnTriggerCharacters=117]="suggestOnTriggerCharacters",X[X.suggestSelection=118]="suggestSelection",X[X.tabCompletion=119]="tabCompletion",X[X.tabIndex=120]="tabIndex",X[X.unicodeHighlighting=121]="unicodeHighlighting",X[X.unusualLineTerminators=122]="unusualLineTerminators",X[X.useShadowDOM=123]="useShadowDOM",X[X.useTabStops=124]="useTabStops",X[X.wordBreak=125]="wordBreak",X[X.wordSeparators=126]="wordSeparators",X[X.wordWrap=127]="wordWrap",X[X.wordWrapBreakAfterCharacters=128]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=129]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=130]="wordWrapColumn",X[X.wordWrapOverride1=131]="wordWrapOverride1",X[X.wordWrapOverride2=132]="wordWrapOverride2",X[X.wrappingIndent=133]="wrappingIndent",X[X.wrappingStrategy=134]="wrappingStrategy",X[X.showDeprecated=135]="showDeprecated",X[X.inlayHints=136]="inlayHints",X[X.editorClassName=137]="editorClassName",X[X.pixelRatio=138]="pixelRatio",X[X.tabFocusMode=139]="tabFocusMode",X[X.layoutInfo=140]="layoutInfo",X[X.wrappingInfo=141]="wrappingInfo",X[X.defaultColorDecorators=142]="defaultColorDecorators"})(ke||(e.EditorOption=ke={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(193,null)})),acceptSuggestionOnEnter:Be(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(194,null),""],markdownDescription:c.localize(195,null)})),accessibilitySupport:Be(new v),accessibilityPageSize:Be(new S(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(196,null),tags:["accessibility"]})),ariaLabel:Be(new t(4,"ariaLabel",c.localize(197,null))),screenReaderAnnounceInlineSuggestion:Be(new h(6,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(198,null),tags:["accessibility"]})),autoClosingBrackets:Be(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(199,null),c.localize(200,null),""],description:c.localize(201,null)})),autoClosingDelete:Be(new r(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(202,null),""],description:c.localize(203,null)})),autoClosingOvertype:Be(new r(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(204,null),""],description:c.localize(205,null)})),autoClosingQuotes:Be(new r(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(206,null),c.localize(207,null),""],description:c.localize(208,null)})),autoIndent:Be(new o(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[c.localize(209,null),c.localize(210,null),c.localize(211,null),c.localize(212,null),c.localize(213,null)],description:c.localize(214,null)})),automaticLayout:Be(new h(11,"automaticLayout",!1)),autoSurround:Be(new r(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(215,null),c.localize(216,null),c.localize(217,null),""],description:c.localize(218,null)})),bracketPairColorization:Be(new pe),bracketPairGuides:Be(new Ie),stickyTabStops:Be(new h(112,"stickyTabStops",!1,{description:c.localize(219,null)})),codeLens:Be(new h(15,"codeLens",!0,{description:c.localize(220,null)})),codeLensFontFamily:Be(new t(16,"codeLensFontFamily","",{description:c.localize(221,null)})),codeLensFontSize:Be(new S(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(222,null)})),colorDecorators:Be(new h(18,"colorDecorators",!0,{description:c.localize(223,null)})),colorDecoratorsLimit:Be(new S(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(224,null)})),columnSelection:Be(new h(20,"columnSelection",!1,{description:c.localize(225,null)})),comments:Be(new l),contextmenu:Be(new h(22,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new h(23,"copyWithSyntaxHighlighting",!0,{description:c.localize(226,null)})),cursorBlinking:Be(new o(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],E,{description:c.localize(227,null)})),cursorSmoothCaretAnimation:Be(new r(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(228,null),c.localize(229,null),c.localize(230,null)],description:c.localize(231,null)})),cursorStyle:Be(new o(26,"cursorStyle",s.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],k,{description:c.localize(232,null)})),cursorSurroundingLines:Be(new S(27,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(233,null)})),cursorSurroundingLinesStyle:Be(new r(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(234,null),c.localize(235,null)],description:c.localize(236,null)})),cursorWidth:Be(new S(29,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(237,null)})),disableLayerHinting:Be(new h(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new h(31,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new h(32,"domReadOnly",!1)),dragAndDrop:Be(new h(33,"dragAndDrop",!0,{description:c.localize(238,null)})),emptySelectionClipboard:Be(new $),dropIntoEditor:Be(new Qe),stickyScroll:Be(new Ee),experimentalWhitespaceRendering:Be(new r(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(239,null),c.localize(240,null),c.localize(241,null)],description:c.localize(242,null)})),extraEditorClassName:Be(new t(37,"extraEditorClassName","")),fastScrollSensitivity:Be(new p(38,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:c.localize(243,null)})),find:Be(new j),fixedOverflowWidgets:Be(new h(40,"fixedOverflowWidgets",!1)),folding:Be(new h(41,"folding",!0,{description:c.localize(244,null)})),foldingStrategy:Be(new r(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(245,null),c.localize(246,null)],description:c.localize(247,null)})),foldingHighlight:Be(new h(43,"foldingHighlight",!0,{description:c.localize(248,null)})),foldingImportsByDefault:Be(new h(44,"foldingImportsByDefault",!1,{description:c.localize(249,null)})),foldingMaximumRegions:Be(new S(45,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(250,null)})),unfoldOnClickAfterEndOfLine:Be(new h(46,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(251,null)})),fontFamily:Be(new t(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(252,null)})),fontInfo:Be(new x),fontLigatures2:Be(new W),fontSize:Be(new B),fontWeight:Be(new z),fontVariations:Be(new U),formatOnPaste:Be(new h(53,"formatOnPaste",!1,{description:c.localize(253,null)})),formatOnType:Be(new h(54,"formatOnType",!1,{description:c.localize(254,null)})),glyphMargin:Be(new h(55,"glyphMargin",!0,{description:c.localize(255,null)})),gotoLocation:Be(new ee),hideCursorInOverviewRuler:Be(new h(57,"hideCursorInOverviewRuler",!1,{description:c.localize(256,null)})),hover:Be(new se),inDiffEditor:Be(new h(59,"inDiffEditor",!1)),letterSpacing:Be(new p(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>p.clamp(X,-5,20),{description:c.localize(257,null)})),lightbulb:Be(new ae),lineDecorationsWidth:Be(new be),lineHeight:Be(new M),lineNumbers:Be(new de),lineNumbersMinChars:Be(new S(66,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new h(67,"linkedEditing",!1,{description:c.localize(258,null)})),links:Be(new h(68,"links",!0,{description:c.localize(259,null)})),matchBrackets:Be(new r(69,"matchBrackets","always",["always","near","never"],{description:c.localize(260,null)})),minimap:Be(new Q),mouseStyle:Be(new r(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new p(72,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:c.localize(261,null)})),mouseWheelZoom:Be(new h(73,"mouseWheelZoom",!1,{markdownDescription:c.localize(262,null)})),multiCursorMergeOverlapping:Be(new h(74,"multiCursorMergeOverlapping",!0,{description:c.localize(263,null)})),multiCursorModifier:Be(new o(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],fe,{markdownEnumDescriptions:[c.localize(264,null),c.localize(265,null)],markdownDescription:c.localize(266,null)})),multiCursorPaste:Be(new r(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(267,null),c.localize(268,null)],markdownDescription:c.localize(269,null)})),multiCursorLimit:Be(new S(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(270,null)})),occurrencesHighlight:Be(new h(78,"occurrencesHighlight",!0,{description:c.localize(271,null)})),overviewRulerBorder:Be(new h(79,"overviewRulerBorder",!0,{description:c.localize(272,null)})),overviewRulerLanes:Be(new S(80,"overviewRulerLanes",3,0,3)),padding:Be(new we),pasteAs:Be(new Xe),parameterHints:Be(new _),peekWidgetDefaultFocus:Be(new r(84,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(273,null),c.localize(274,null)],description:c.localize(275,null)})),definitionLinkOpensInPeek:Be(new h(85,"definitionLinkOpensInPeek",!1,{description:c.localize(276,null)})),quickSuggestions:Be(new le),quickSuggestionsDelay:Be(new S(87,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(277,null)})),readOnly:Be(new h(88,"readOnly",!1)),renameOnType:Be(new h(89,"renameOnType",!1,{description:c.localize(278,null),markdownDeprecationMessage:c.localize(279,null)})),renderControlCharacters:Be(new h(90,"renderControlCharacters",!0,{description:c.localize(280,null),restricted:!0})),renderFinalNewline:Be(new r(91,"renderFinalNewline",R.isLinux?"dimmed":"on",["off","on","dimmed"],{description:c.localize(281,null)})),renderLineHighlight:Be(new r(92,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(282,null)],description:c.localize(283,null)})),renderLineHighlightOnlyWhenFocus:Be(new h(93,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(284,null)})),renderValidationDecorations:Be(new r(94,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new r(95,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(285,null),c.localize(286,null),c.localize(287,null),""],description:c.localize(288,null)})),revealHorizontalRightPadding:Be(new S(96,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new h(97,"roundedSelection",!0,{description:c.localize(289,null)})),rulers:Be(new ue),scrollbar:Be(new G),scrollBeyondLastColumn:Be(new S(100,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(290,null)})),scrollBeyondLastLine:Be(new h(101,"scrollBeyondLastLine",!0,{description:c.localize(291,null)})),scrollPredominantAxis:Be(new h(102,"scrollPredominantAxis",!0,{description:c.localize(292,null)})),selectionClipboard:Be(new h(103,"selectionClipboard",!0,{description:c.localize(293,null),included:R.isLinux})),selectionHighlight:Be(new h(104,"selectionHighlight",!0,{description:c.localize(294,null)})),selectOnLineNumbers:Be(new h(105,"selectOnLineNumbers",!0)),showFoldingControls:Be(new r(106,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(295,null),c.localize(296,null),c.localize(297,null)],description:c.localize(298,null)})),showUnused:Be(new h(107,"showUnused",!0,{description:c.localize(299,null)})),showDeprecated:Be(new h(135,"showDeprecated",!0,{description:c.localize(300,null)})),inlayHints:Be(new ye),snippetSuggestions:Be(new r(108,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null),c.localize(304,null)],description:c.localize(305,null)})),smartSelect:Be(new Te),smoothScrolling:Be(new h(110,"smoothScrolling",!1,{description:c.localize(306,null)})),stopRenderingLineAfter:Be(new S(113,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new Re),inlineSuggest:Be(new ie),suggestFontSize:Be(new S(115,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(307,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new S(116,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(308,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new h(117,"suggestOnTriggerCharacters",!0,{description:c.localize(309,null)})),suggestSelection:Be(new r(118,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(310,null),c.localize(311,null),c.localize(312,null)],description:c.localize(313,null)})),tabCompletion:Be(new r(119,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(314,null),c.localize(315,null),c.localize(316,null)],description:c.localize(317,null)})),tabIndex:Be(new S(120,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new Y),unusualLineTerminators:Be(new r(122,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(318,null),c.localize(319,null),c.localize(320,null)],description:c.localize(321,null)})),useShadowDOM:Be(new h(123,"useShadowDOM",!0)),useTabStops:Be(new h(124,"useTabStops",!0,{description:c.localize(322,null)})),wordBreak:Be(new r(125,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(323,null),c.localize(324,null)],description:c.localize(325,null)})),wordSeparators:Be(new t(126,"wordSeparators",u.USUAL_WORD_SEPARATORS,{description:c.localize(326,null)})),wordWrap:Be(new r(127,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(327,null),c.localize(328,null),c.localize(329,null),c.localize(330,null)],description:c.localize(331,null)})),wordWrapBreakAfterCharacters:Be(new t(128,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new t(129,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new S(130,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(332,null)})),wordWrapOverride1:Be(new r(131,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new r(132,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new F),defaultColorDecorators:Be(new h(142,"defaultColorDecorators",!1,{markdownDescription:c.localize(333,null)})),pixelRatio:Be(new ne),tabFocusMode:Be(new h(139,"tabFocusMode",!1,{markdownDescription:c.localize(334,null)})),layoutInfo:Be(new Z),wrappingInfo:Be(new tt),wrappingIndent:Be(new xe),wrappingStrategy:Be(new q)}}),define(Ce[176],De([14,15]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[177],De([14,15]),function(re,e){return re.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[178],De([14,15]),function(re,e){return re.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[179],De([14,15]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[180],De([14,15]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[181],De([14,15]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ce[182],De([14,15]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(Ce[183],De([14,15]),function(re,e){return re.create("vs/platform/files/common/io",e)}),define(Ce[184],De([14,15]),function(re,e){return re.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ce[185],De([14,15]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(Ce[186],De([14,15]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[187],De([14,15]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(Ce[188],De([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostChat",e)}),define(Ce[189],De([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[190],De([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[191],De([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[192],De([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[193],De([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[194],De([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[195],De([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[196],De([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[197],De([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[198],De([14,15]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[199],De([14,15]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ce[200],De([14,15]),function(re,e){return re.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Ce[201],De([14,15]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(Ce[202],De([14,15]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(Ce[203],De([14,15]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[204],De([14,15]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[205],De([14,15]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ce[206],De([14,15]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[207],De([14,15]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[208],De([14,15]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[209],De([14,15]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[210],De([14,15]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[211],De([1,0,8,178]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var u;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(u||(e.TokenType=u={}));function O(...g){switch(g.length){case 1:return(0,R.localize)(0,null,g[0]);case 2:return(0,R.localize)(1,null,g[0],g[1]);case 3:return(0,R.localize)(2,null,g[0],g[1],g[2]);default:return}}const L=(0,R.localize)(3,null),A=(0,R.localize)(4,null);class y{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,c.illegalState)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const P=this.d,m=this.c.substring(this.d,this.e),D={type:19,offset:this.d,lexeme:m};this.g.push({offset:P,lexeme:m,additionalInfo:T}),this.f.push(D)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const P=this.c.substring(this.d,this.e),m=y.b.get(P);m?this.k(m):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,P=!1,m=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(A);return}const C=this.c.charCodeAt(T);if(P)P=!1;else if(C===47&&!m){T++;break}else C===91?m=!0:C===92?P=!0:C===93&&(m=!1);T++}for(;T<this.c.length&&y.a.has(this.c.charCodeAt(T));)T++;this.e=T;const D=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:D,offset:this.d})}r(){return this.e>=this.c.length}}e.Scanner=y,y.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0))),y.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Ce[212],De([1,0,24,41,180,345]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(h){return h=h.trim(),h==="*"||L.test(h)}e.isValidVersionStr=y;function g(h){if(!y(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=h.match(L);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=g;function T(h){if(!h)return null;const d=h.majorBase,S=h.majorMustEqual,w=h.minorBase;let p=h.minorMustEqual;const t=h.patchBase;let a=h.patchMustEqual;h.hasCaret&&(d===0||(p=!1),a=!1);let r=0;if(h.preRelease){const o=A.exec(h.preRelease);if(o){const[,f,v,l]=o;r=Date.UTC(Number(f),Number(v)-1,Number(l))}}return{majorBase:d,majorMustEqual:S,minorBase:w,minorMustEqual:p,patchBase:t,patchMustEqual:a,isMinimum:h.hasGreaterEquals,notBefore:r}}e.normalizeVersion=T;function P(h,d,S){let w;typeof h=="string"?w=T(g(h)):w=h;let p;d instanceof Date?p=d.getTime():typeof d=="string"&&(p=new Date(d).getTime());let t;if(typeof S=="string"?t=T(g(S)):t=S,!w||!t)return!1;const a=w.majorBase,r=w.minorBase,o=w.patchBase;let f=t.majorBase,v=t.minorBase,l=t.patchBase;const I=t.notBefore;let E=t.majorMustEqual,s=t.minorMustEqual,i=t.patchMustEqual;return t.isMinimum?a>f?!0:a<f?!1:r>v?!0:r<v||p&&p<I?!1:o>=l:(a===1&&f===0&&(!E||!s||!i)&&(f=1,v=0,l=0,E=!0,s=!1,i=!1),a<f?!1:a>f?!E:r<v?!1:r>v?!s:o<l?!1:o>l?!i:!(p&&p<I))}e.isValidVersion=P;function m(h,d,S,w,p){const t=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return t.push([R.default.Error,u.localize(0,null)]),t;if(typeof w.name!="string")return t.push([R.default.Error,u.localize(1,null,"name")]),t;if(typeof w.version!="string")return t.push([R.default.Error,u.localize(2,null,"version")]),t;if(!w.engines)return t.push([R.default.Error,u.localize(3,null,"engines")]),t;if(typeof w.engines.vscode!="string")return t.push([R.default.Error,u.localize(4,null,"engines.vscode")]),t;if(typeof w.extensionDependencies<"u"&&!n(w.extensionDependencies))return t.push([R.default.Error,u.localize(5,null,"extensionDependencies")]),t;if(typeof w.activationEvents<"u"){if(!n(w.activationEvents))return t.push([R.default.Error,u.localize(6,null,"activationEvents")]),t;if(typeof w.main>"u"&&typeof w.browser>"u")return t.push([R.default.Error,u.localize(7,null,"activationEvents","main","browser")]),t}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&t.push([R.default.Warning,u.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return t.push([R.default.Error,u.localize(9,null,"main")]),t;{const o=(0,c.joinPath)(S,w.main);(0,c.isEqualOrParent)(o,S)||t.push([R.default.Warning,u.localize(10,null,o.path,S.path)])}}if(typeof w.browser<"u"){if(typeof w.browser!="string")return t.push([R.default.Error,u.localize(11,null,"browser")]),t;{const o=(0,c.joinPath)(S,w.browser);(0,c.isEqualOrParent)(o,S)||t.push([R.default.Warning,u.localize(12,null,o.path,S.path)])}}if(!O.valid(w.version))return t.push([R.default.Error,u.localize(13,null)]),t;const a=[];if(!D(h,d,w,p,a))for(const o of a)t.push([R.default.Error,o]);return t}e.validateExtensionManifest=m;function D(h,d,S,w,p){return w||typeof S.main>"u"&&typeof S.browser>"u"?!0:b(h,d,S.engines.vscode,p)}e.isValidExtensionVersion=D;function C(h,d,S){return h==="*"||b(d,S,h)}e.isEngineValid=C;function b(h,d,S,w=[]){const p=T(g(S));if(!p)return w.push(u.localize(14,null,S)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return w.push(u.localize(15,null,S)),!1}else if(!p.majorMustEqual)return w.push(u.localize(16,null,S)),!1;return P(h,d,p)?!0:(w.push(u.localize(17,null,h,S)),!1)}function n(h){if(!Array.isArray(h))return!1;for(let d=0,S=h.length;d<S;d++)if(typeof h[d]!="string")return!1;return!0}}),define(Ce[96],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(u,O=[],L=!1){this.ctor=u,this.staticArguments=O,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=c}),define(Ce[97],De([1,0,96]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var u;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(u||(e.InstantiationType=u={}));function O(A,y,g){y instanceof c.SyncDescriptor||(y=new c.SyncDescriptor(y,[],!!g)),R.push([A,y])}e.registerSingleton=O;function L(){return R}e.getSingletonServiceDescriptors=L}),define(Ce[213],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(O,L){this.key=O,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class R{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const L of this.a.values())L.outgoing.size===0&&O.push(L);return O}insertEdge(O,L){const A=this.lookupOrInsertNode(O),y=this.lookupOrInsertNode(L);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(O){const L=this.b(O);this.a.delete(L);for(const A of this.a.values())A.outgoing.delete(L),A.incoming.delete(L)}lookupOrInsertNode(O){const L=this.b(O);let A=this.a.get(L);return A||(A=new c(L,O),this.a.set(L,A)),A}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[L,A]of this.a)O.push(`${L}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,L]of this.a){const A=new Set([O]),y=this.c(L,A);if(y)return y}}c(O,L){for(const[A,y]of O.outgoing){if(L.has(A))return[...L,A].join(" -> ");L.add(A);const g=this.c(y,L);if(g)return g;L.delete(A)}}}e.Graph=R}),define(Ce[5],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=A})(c||(e._util=c={})),e.IInstantiationService=u("instantiationService");function R(L,A,y){A[c.DI_TARGET]===A?A[c.DI_DEPENDENCIES].push({id:L,index:y}):(A[c.DI_DEPENDENCIES]=[{id:L,index:y}],A[c.DI_TARGET]=A)}function u(L){if(c.serviceIds.has(L))return c.serviceIds.get(L);const A=function(y,g,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(A,y,T)};return A.toString=()=>L,c.serviceIds.set(L,A),A}e.createDecorator=u;function O(L){return L}e.refineServiceDecorator=O}),define(Ce[57],De([1,0,12,2,5]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,u.createDecorator)("configurationService");function O(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof R.URI)}e.isConfigurationOverrides=O;function L(n){return n&&typeof n=="object"&&(!n.overrideIdentifiers||Array.isArray(n.overrideIdentifiers))&&!n.overrideIdentifier&&(!n.resource||n.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=L;var A;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.USER=2]="USER",n[n.USER_LOCAL=3]="USER_LOCAL",n[n.USER_REMOTE=4]="USER_REMOTE",n[n.WORKSPACE=5]="WORKSPACE",n[n.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",n[n.DEFAULT=7]="DEFAULT",n[n.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function y(n){switch(n){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function g(n,h){const d=Object.create(null);for(const S in n)T(d,S,n[S],h);return d}e.toValuesTree=g;function T(n,h,d,S){const w=h.split("."),p=w.pop();let t=n;for(let a=0;a<w.length;a++){const r=w[a];let o=t[r];switch(typeof o){case"undefined":o=t[r]=Object.create(null);break;case"object":break;default:S(`Ignoring ${h} as ${w.slice(0,a+1).join(".")} is ${JSON.stringify(o)}`);return}t=o}if(typeof t=="object"&&t!==null)try{t[p]=d}catch{S(`Ignoring ${h} as ${w.join(".")} is ${JSON.stringify(t)}`)}else S(`Ignoring ${h} as ${w.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=T;function P(n,h){const d=h.split(".");m(n,d)}e.removeFromValueTree=P;function m(n,h){const d=h.shift();if(h.length===0){delete n[d];return}if(Object.keys(n).indexOf(d)!==-1){const S=n[d];typeof S=="object"&&!Array.isArray(S)&&(m(S,h),Object.keys(S).length===0&&delete n[d])}}function D(n,h,d){function S(t,a){let r=t;for(const o of a){if(typeof r!="object"||r===null)return;r=r[o]}return r}const w=h.split("."),p=S(n,w);return typeof p>"u"?d:p}e.getConfigurationValue=D;function C(n,h,d){Object.keys(h).forEach(S=>{S!=="__proto__"&&(S in n?c.isObject(n[S])&&c.isObject(h[S])?C(n[S],h[S],d):d&&(n[S]=h[S]):n[S]=h[S])})}e.merge=C;function b(n){return n.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(Ce[47],De([1,0,9,11,211,5,177,8]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",c.isMacintosh),y.set("isLinux",c.isLinux),y.set("isWindows",c.isWindows),y.set("isWeb",c.isWeb),y.set("isMacNative",c.isMacintosh&&!c.isWeb),y.set("isEdge",c.isEdge),y.set("isFirefox",c.isFirefox),y.set("isChrome",c.isChrome),y.set("isSafari",c.isSafari);function g(be,M){if(y.get(be)!==void 0)throw(0,A.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(be,M)}e.setConstant=g;const T=Object.prototype.hasOwnProperty;var P;(function(be){be[be.False=0]="False",be[be.True=1]="True",be[be.Defined=2]="Defined",be[be.Not=3]="Not",be[be.Equals=4]="Equals",be[be.NotEquals=5]="NotEquals",be[be.And=6]="And",be[be.Regex=7]="Regex",be[be.NotRegex=8]="NotRegex",be[be.Or=9]="Or",be[be.In=10]="In",be[be.NotIn=11]="NotIn",be[be.Greater=12]="Greater",be[be.GreaterEquals=13]="GreaterEquals",be[be.Smaller=14]="Smaller",be[be.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const m={regexParsingWithErrorRecovery:!0},D=(0,L.localize)(0,null),C=(0,L.localize)(1,null),b=(0,L.localize)(2,null),n=(0,L.localize)(3,null),h=(0,L.localize)(4,null),d=(0,L.localize)(5,null),S=(0,L.localize)(6,null),w=(0,L.localize)(7,null);class p{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(M=m){this.k=M,this.d=new u.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(M){if(M===""){this.h.push({message:D,offset:0,lexeme:"",additionalInfo:C});return}this.f=this.d.reset(M).scan(),this.g=0,this.h=[];try{const Q=this.l();if(!this.E()){const fe=this.D(),we=fe.type===17?d:void 0;throw this.h.push({message:h,offset:fe.offset,lexeme:u.Scanner.getLexeme(fe),additionalInfo:we}),p.c}return Q}catch(Q){if(Q!==p.c)throw Q;return}}l(){return this.m()}m(){const M=[this.o()];for(;this.y(16);){const Q=this.o();M.push(Q)}return M.length===1?M[0]:t.or(...M)}o(){const M=[this.s()];for(;this.y(15);){const Q=this.s();M.push(Q)}return M.length===1?M[0]:t.and(...M)}s(){if(this.y(2)){const M=this.D();switch(M.type){case 11:return this.z(),f.INSTANCE;case 12:return this.z(),v.INSTANCE;case 0:{this.z();const Q=this.l();return this.A(1,n),Q?.negate()}case 17:return this.z(),k.create(M.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",M)}}return this.t()}t(){const M=this.D();switch(M.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const Q=this.l();return this.A(1,n),Q}case 17:{const Q=M.lexeme;if(this.z(),this.y(9)){const we=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),we.type!==10)throw this.B("REGEX",we);const _=we.lexeme,ne=_.lastIndexOf("/"),le=ne===_.length-1?void 0:this.w(_.substring(ne+1));let te;try{te=new RegExp(_.substring(1,ne),le)}catch{throw this.B("REGEX",we)}return x.create(Q,te)}switch(we.type){case 10:case 19:{const _=[we.lexeme];this.z();let ne=this.D(),le=0;for(let N=0;N<we.lexeme.length;N++)we.lexeme.charCodeAt(N)===40?le++:we.lexeme.charCodeAt(N)===41&&le--;for(;!this.E()&&ne.type!==15&&ne.type!==16;){switch(ne.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let N=0;N<ne.lexeme.length;N++)ne.lexeme.charCodeAt(N)===40?le++:we.lexeme.charCodeAt(N)===41&&le--}if(le<0)break;_.push(u.Scanner.getLexeme(ne)),this.z(),ne=this.D()}const te=_.join(""),de=te.lastIndexOf("/"),oe=de===te.length-1?void 0:this.w(te.substring(de+1));let ue;try{ue=new RegExp(te.substring(1,de),oe)}catch{throw this.B("REGEX",we)}return t.regex(Q,ue)}case 18:{const _=we.lexeme;this.z();let ne=null;if(!(0,R.isFalsyOrWhitespace)(_)){const le=_.indexOf("/"),te=_.lastIndexOf("/");if(le!==te&&le>=0){const de=_.slice(le+1,te),oe=_[te+1]==="i"?"i":"";try{ne=new RegExp(de,oe)}catch{throw this.B("REGEX",we)}}}if(ne===null)throw this.B("REGEX",we);return x.create(Q,ne)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const we=this.u();return t.notIn(Q,we)}switch(this.D().type){case 3:{this.z();const we=this.u();if(this.x().type===18)return t.equals(Q,we);switch(we){case"true":return t.has(Q);case"false":return t.not(Q);default:return t.equals(Q,we)}}case 4:{this.z();const we=this.u();if(this.x().type===18)return t.notEquals(Q,we);switch(we){case"true":return t.not(Q);case"false":return t.has(Q);default:return t.notEquals(Q,we)}}case 5:return this.z(),W.create(Q,this.u());case 6:return this.z(),U.create(Q,this.u());case 7:return this.z(),$.create(Q,this.u());case 8:return this.z(),j.create(Q,this.u());case 13:return this.z(),t.in(Q,this.u());default:return t.has(Q)}}case 20:throw this.h.push({message:S,offset:M.offset,lexeme:"",additionalInfo:w}),p.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const M=this.D();switch(M.type){case 17:case 18:return this.z(),M.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(M){return M.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(M){return this.C(M)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(M,Q){if(this.C(M))return this.z();throw this.B(Q,this.D())}B(M,Q,fe){const we=(0,L.localize)(8,null,M,u.Scanner.getLexeme(Q)),_=Q.offset,ne=u.Scanner.getLexeme(Q);return this.h.push({message:we,offset:_,lexeme:ne,additionalInfo:fe}),p.c}C(M){return this.D().type===M}D(){return this.f[this.g]}E(){return this.D().type===20}}e.Parser=p,p.c=new Error;class t{static false(){return f.INSTANCE}static true(){return v.INSTANCE}static has(M){return l.create(M)}static equals(M,Q){return I.create(M,Q)}static notEquals(M,Q){return i.create(M,Q)}static regex(M,Q){return x.create(M,Q)}static in(M,Q){return E.create(M,Q)}static notIn(M,Q){return s.create(M,Q)}static not(M){return k.create(M)}static and(...M){return ee.create(M,null,!0)}static or(...M){return se.create(M,null,!0)}static greater(M,Q){return $.create(M,Q)}static greaterEquals(M,Q){return j.create(M,Q)}static smaller(M,Q){return W.create(M,Q)}static smallerEquals(M,Q){return U.create(M,Q)}static deserialize(M){return M==null?void 0:this.c.parse(M)}}e.ContextKeyExpr=t,t.c=new p({regexParsingWithErrorRecovery:!1});function a(be){const M=new p({regexParsingWithErrorRecovery:!1});return be.map(Q=>(M.parse(Q),M.lexingErrors.length>0?M.lexingErrors.map(fe=>({errorMessage:fe.additionalInfo?(0,L.localize)(9,null,fe.additionalInfo):(0,L.localize)(10,null),offset:fe.offset,length:fe.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(fe=>({errorMessage:fe.additionalInfo?`${fe.message}. ${fe.additionalInfo}`:fe.message,offset:fe.offset,length:fe.lexeme.length})):[]))}e.validateWhenClauses=a;function r(be,M){const Q=be?be.substituteConstants():void 0,fe=M?M.substituteConstants():void 0;return!Q&&!fe?!0:!Q||!fe?!1:Q.equals(fe)}e.expressionsAreEqualWithConstantSubstitution=r;function o(be,M){return be.cmp(M)}class f{constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class v{constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class l{static create(M,Q=null){const fe=y.get(M);return typeof fe=="boolean"?fe?v.INSTANCE:f.INSTANCE:new l(M,Q)}constructor(M,Q){this.key=M,this.c=Q,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:Z(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=y.get(this.key);return typeof M=="boolean"?M?v.INSTANCE:f.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=k.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=l;class I{static create(M,Q,fe=null){if(typeof Q=="boolean")return Q?l.create(M,fe):k.create(M,fe);const we=y.get(M);return typeof we=="boolean"?Q===(we?"true":"false")?v.INSTANCE:f.INSTANCE:new I(M,Q,fe)}constructor(M,Q,fe){this.c=M,this.d=Q,this.f=fe,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:q(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=y.get(this.c);if(typeof M=="boolean"){const Q=M?"true":"false";return this.d===Q?v.INSTANCE:f.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=I;class E{static create(M,Q){return new E(M,Q)}constructor(M,Q){this.d=M,this.f=Q,this.type=10,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:q(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const Q=M.getValue(this.f),fe=M.getValue(this.d);return Array.isArray(Q)?Q.includes(fe):typeof fe=="string"&&typeof Q=="object"&&Q!==null?T.call(Q,fe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=s.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=E;class s{static create(M,Q){return new s(M,Q)}constructor(M,Q){this.d=M,this.f=Q,this.type=11,this.c=E.create(M,Q)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=s;class i{static create(M,Q,fe=null){if(typeof Q=="boolean")return Q?k.create(M,fe):l.create(M,fe);const we=y.get(M);return typeof we=="boolean"?Q===(we?"true":"false")?f.INSTANCE:v.INSTANCE:new i(M,Q,fe)}constructor(M,Q,fe){this.c=M,this.d=Q,this.f=fe,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:q(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=y.get(this.c);if(typeof M=="boolean"){const Q=M?"true":"false";return this.d===Q?f.INSTANCE:v.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=i;class k{static create(M,Q=null){const fe=y.get(M);return typeof fe=="boolean"?fe?f.INSTANCE:v.INSTANCE:new k(M,Q)}constructor(M,Q){this.c=M,this.d=Q,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:Z(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=y.get(this.c);return typeof M=="boolean"?M?f.INSTANCE:v.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.ContextKeyNotExpr=k;function F(be,M){if(typeof be=="string"){const Q=parseFloat(be);isNaN(Q)||(be=Q)}return typeof be=="string"||typeof be=="number"?M(be):f.INSTANCE}class ${static create(M,Q,fe=null){return F(Q,we=>new $(M,we,fe))}constructor(M,Q,fe){this.c=M,this.d=Q,this.f=fe,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:q(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=$;class j{static create(M,Q,fe=null){return F(Q,we=>new j(M,we,fe))}constructor(M,Q,fe){this.c=M,this.d=Q,this.f=fe,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:q(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=j;class W{static create(M,Q,fe=null){return F(Q,we=>new W(M,we,fe))}constructor(M,Q,fe){this.c=M,this.d=Q,this.f=fe,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:q(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=W;class U{static create(M,Q,fe=null){return F(Q,we=>new U(M,we,fe))}constructor(M,Q,fe){this.c=M,this.d=Q,this.f=fe,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:q(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=$.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=U;class x{static create(M,Q){return new x(M,Q)}constructor(M,Q){this.d=M,this.f=Q,this.type=7,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const Q=this.f?this.f.source:"",fe=M.f?M.f.source:"";return Q<fe?-1:Q>fe?1:0}equals(M){if(M.type===this.type){const Q=this.f?this.f.source:"",fe=M.f?M.f.source:"";return this.d===M.d&&Q===fe}return!1}substituteConstants(){return this}evaluate(M){const Q=M.getValue(this.d);return this.f?this.f.test(Q):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.ContextKeyRegexExpr=x;class B{static create(M){return new B(M)}constructor(M){this.c=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(M){return new B(this.c.map(M))}negate(){return this.c}}e.ContextKeyNotRegexExpr=B;function z(be){let M=null;for(let Q=0,fe=be.length;Q<fe;Q++){const we=be[Q].substituteConstants();if(be[Q]!==we&&M===null){M=[];for(let _=0;_<Q;_++)M[_]=be[_]}M!==null&&(M[Q]=we)}return M===null?be:M}class ee{static create(M,Q,fe){return ee.d(M,Q,fe)}constructor(M,Q){this.expr=M,this.c=Q,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let Q=0,fe=this.expr.length;Q<fe;Q++){const we=o(this.expr[Q],M.expr[Q]);if(we!==0)return we}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let Q=0,fe=this.expr.length;Q<fe;Q++)if(!this.expr[Q].equals(M.expr[Q]))return!1;return!0}return!1}substituteConstants(){const M=z(this.expr);return M===this.expr?this:ee.create(M,this.c,!1)}evaluate(M){for(let Q=0,fe=this.expr.length;Q<fe;Q++)if(!this.expr[Q].evaluate(M))return!1;return!0}static d(M,Q,fe){const we=[];let _=!1;for(const ne of M)if(ne){if(ne.type===1){_=!0;continue}if(ne.type===0)return f.INSTANCE;if(ne.type===6){we.push(...ne.expr);continue}we.push(ne)}if(we.length===0&&_)return v.INSTANCE;if(we.length!==0){if(we.length===1)return we[0];we.sort(o);for(let ne=1;ne<we.length;ne++)we[ne-1].equals(we[ne])&&(we.splice(ne,1),ne--);if(we.length===1)return we[0];for(;we.length>1;){const ne=we[we.length-1];if(ne.type!==9)break;we.pop();const le=we.pop(),te=we.length===0,de=se.create(ne.expr.map(oe=>ee.create([oe,le],null,fe)),null,te);de&&(we.push(de),we.sort(o))}if(we.length===1)return we[0];if(fe){for(let ne=0;ne<we.length;ne++)for(let le=ne+1;le<we.length;le++)if(we[ne].negate().equals(we[le]))return f.INSTANCE;if(we.length===1)return we[0]}return new ee(we,Q)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const Q of this.expr)M.push(...Q.keys());return M}map(M){return new ee(this.expr.map(Q=>Q.map(M)),null)}negate(){if(!this.c){const M=[];for(const Q of this.expr)M.push(Q.negate());this.c=se.create(M,this,!0)}return this.c}}e.ContextKeyAndExpr=ee;class se{static create(M,Q,fe){return se.d(M,Q,fe)}constructor(M,Q){this.expr=M,this.c=Q,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let Q=0,fe=this.expr.length;Q<fe;Q++){const we=o(this.expr[Q],M.expr[Q]);if(we!==0)return we}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let Q=0,fe=this.expr.length;Q<fe;Q++)if(!this.expr[Q].equals(M.expr[Q]))return!1;return!0}return!1}substituteConstants(){const M=z(this.expr);return M===this.expr?this:se.create(M,this.c,!1)}evaluate(M){for(let Q=0,fe=this.expr.length;Q<fe;Q++)if(this.expr[Q].evaluate(M))return!0;return!1}static d(M,Q,fe){let we=[],_=!1;if(M){for(let ne=0,le=M.length;ne<le;ne++){const te=M[ne];if(te){if(te.type===0){_=!0;continue}if(te.type===1)return v.INSTANCE;if(te.type===9){we=we.concat(te.expr);continue}we.push(te)}}if(we.length===0&&_)return f.INSTANCE;we.sort(o)}if(we.length!==0){if(we.length===1)return we[0];for(let ne=1;ne<we.length;ne++)we[ne-1].equals(we[ne])&&(we.splice(ne,1),ne--);if(we.length===1)return we[0];if(fe){for(let ne=0;ne<we.length;ne++)for(let le=ne+1;le<we.length;le++)if(we[ne].negate().equals(we[le]))return v.INSTANCE;if(we.length===1)return we[0]}return new se(we,Q)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const Q of this.expr)M.push(...Q.keys());return M}map(M){return new se(this.expr.map(Q=>Q.map(M)),null)}negate(){if(!this.c){const M=[];for(const Q of this.expr)M.push(Q.negate());for(;M.length>1;){const Q=M.shift(),fe=M.shift(),we=[];for(const _ of ye(Q))for(const ne of ye(fe))we.push(ee.create([_,ne],null,!1));M.unshift(se.create(we,null,!1))}this.c=se.create(M,this,!0)}return this.c}}e.ContextKeyOrExpr=se;class V extends l{static all(){return V.d.values()}constructor(M,Q,fe){super(M,null),this.f=Q,typeof fe=="object"?V.d.push({...fe,key:M}):fe!==!0&&V.d.push({key:M,description:fe,type:Q!=null?typeof Q:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return I.create(this.key,M)}notEqualsTo(M){return i.create(this.key,M)}}e.RawContextKey=V,V.d=[],e.IContextKeyService=(0,O.createDecorator)("contextKeyService");function Z(be,M){return be<M?-1:be>M?1:0}function q(be,M,Q,fe){return be<Q?-1:be>Q?1:M<fe?-1:M>fe?1:0}function ae(be,M){if(be.type===0||M.type===1)return!0;if(be.type===9)return M.type===9?Ee(be.expr,M.expr):!1;if(M.type===9){for(const Q of M.expr)if(ae(be,Q))return!0;return!1}if(be.type===6){if(M.type===6)return Ee(M.expr,be.expr);for(const Q of be.expr)if(ae(Q,M))return!0;return!1}return be.equals(M)}e.implies=ae;function Ee(be,M){let Q=0,fe=0;for(;Q<be.length&&fe<M.length;){const we=be[Q].cmp(M[fe]);if(we<0)return!1;we===0&&Q++,fe++}return Q===be.length}function ye(be){return be.type===9?be.expr:[be]}}),define(Ce[214],De([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[125],De([1,0,179,5]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function u(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=u;function O(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=O;function L(d,S){switch(d){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=L;function A(d,S){return S==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(d,S,w){return A(S,w)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===w?!0:g(w).includes(d)}e.isTargetPlatformCompatible=y;function g(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=g;function T(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=T;var P;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var m;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var D;(function(d){d.Install="install",d.Uninstall="uninstall"})(D||(e.StatisticType=D={}));var C;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(C||(e.InstallOperation=C={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var b;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var n;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n||(e.ExtensionSignaturetErrorCode=n={}));class h extends Error{constructor(S,w){super(S),this.code=w,this.name=w}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,c.localize)(1,null),original:"Preferences"}}),define(Ce[215],De([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(Ce[216],De([1,0,45,18,10,9,92,29,95,181,215]),function(re,e,c,R,u,O,L,A,y,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=g.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:D.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class D extends m{openTerminal(w,p){return this.spawnTerminal(c,w,y.getWindowsShell(),p)}spawnTerminal(w,p,t,a){const r=p.windowsExec||D.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const o=u.basename(r,".exe").toLowerCase();if(o==="cmder")return w.spawn(r,a?[a]:void 0),Promise.resolve(void 0);const f=["/c","start","/wait"];return r.indexOf(" ")>=0&&f.push('""'),f.push(r),o==="wt"&&f.push("-d ."),new Promise((v,l)=>{const I=n(process),E=w.spawn(t,f,{cwd:a,env:I});E.on("error",l),E.on("exit",()=>v())})}runInTerminal(w,p,t,a,r){const o="windowsExec"in r&&r.windowsExec?r.windowsExec:D.getDefaultTerminalWindows();return new Promise((f,v)=>{const l=`"${p} - ${P}"`,I=`""${t.join('" "')}" & pause"`,E=Object.assign({},n(process),a);Object.keys(E).filter($=>E[$]===null).forEach($=>delete E[$]);const s={cwd:p,env:E,windowsVerbatimArguments:!0};let i,k;u.basename(o,".exe")==="wt"?(i=o,k=["-d",".",D.b,"/c",I]):(i=D.b,k=["/c","start",l,"/wait",o,"/c",I]),c.spawn(i,k,s).on("error",$=>{v(h($))}),f(void 0)})}static getDefaultTerminalWindows(){if(!D.d){const w=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");D.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${w?"Sysnative":"System32"}\\cmd.exe`}return D.d}}e.WindowsExternalTerminalService=D,D.b="cmd.exe";class C extends m{openTerminal(w,p){return this.spawnTerminal(c,w,p)}runInTerminal(w,p,t,a,r){const o=r.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((f,v)=>{if(o===T.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const l=o===T.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[R.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`).fsPath,"-t",w||P,"-w",p];for(const k of t)E.push("-a"),E.push(k);if(a){const k=Object.assign({},n(process),a);for(const F in k){const $=k[F];$===null?(E.push("-u"),E.push(F)):(E.push("-e"),E.push(`${F}=${$}`))}}let s="";const i=c.spawn(C.b,E);i.on("error",k=>{v(h(k))}),i.stderr.on("data",k=>{s+=k.toString()}),i.on("exit",k=>{if(k===0)f(void 0);else if(s){const F=s.split(`
`,1);v(new Error(F[0]))}else v(new Error(g.localize(1,null,l,k)))})}else v(new Error(g.localize(2,null,o)))})}spawnTerminal(w,p,t){const a=p.osxExec||T.DEFAULT_TERMINAL_OSX;return new Promise((r,o)=>{const f=["-a",a];t&&f.push(t);const v=n(process),l=w.spawn("/usr/bin/open",f,{cwd:t,env:v});l.on("error",o),l.on("exit",()=>r())})}}e.MacExternalTerminalService=C,C.b="/usr/bin/osascript";class b extends m{openTerminal(w,p){return this.spawnTerminal(c,w,p)}runInTerminal(w,p,t,a,r){const o=r.linuxExec?Promise.resolve(r.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((f,v)=>{const l=[];o.then(I=>{I.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const E=`${d(t)}; echo; read -p "${b.b}" -n1;`;l.push(`''${E}''`);const s=Object.assign({},n(process),a);Object.keys(s).filter($=>s[$]===null).forEach($=>delete s[$]);const i={cwd:p,env:s};let k="";const F=c.spawn(I,l,i);F.on("error",$=>{v(h($))}),F.stderr.on("data",$=>{k+=$.toString()}),F.on("exit",$=>{if($===0)f(void 0);else if(k){const j=k.split(`
`,1);v(new Error(j[0]))}else v(new Error(g.localize(4,null,I,$)))})})})}static async getDefaultTerminalLinuxReady(){if(!b.d)if(!O.isLinux)b.d=Promise.resolve("xterm");else{const w=await A.Promises.exists("/etc/debian_version");b.d=new Promise(p=>{w?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return b.d}spawnTerminal(w,p,t){const a=p.linuxExec?Promise.resolve(p.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((r,o)=>{a.then(f=>{const v=n(process),l=w.spawn(f,[],{cwd:t,env:v});l.on("error",o),l.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=b,b.b=g.localize(3,null);function n(S){const w={...S.env};return(0,L.sanitizeProcessEnvironment)(w),w}function h(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(g.localize(5,null,S.path)):S}function d(S){let w="";for(const p of S)p.indexOf(" ")>=0?w+='"'+p+'"':w+=p,w+=" ";return w}}),define(Ce[31],De([1,0,71,10,11,12,2,182,5,9,18]),function(re,e,c,R,u,O,L,A,y,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicDeleteCapability=e.hasFileAtomicWriteCapability=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function P(V){return V.create===!0}e.isFileOpenForWriteOptions=P;var m;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var D;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(D||(e.FilePermission=D={}));var C;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(C||(e.FileSystemProviderCapabilities=C={}));function b(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=b;function n(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=n;function h(V){return!!(V.capabilities&131072)}e.hasFileCloneCapability=h;function d(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function S(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=S;function w(V){return b(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;function p(V){return b(V)?!!(V.capabilities&32768):!1}e.hasFileAtomicWriteCapability=p;function t(V){return!!(V.capabilities&65536)}e.hasFileAtomicDeleteCapability=t;var a;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class r extends Error{static create(Z,q){const ae=new r(Z.toString(),q);return v(ae,q),ae}constructor(Z,q){super(Z),this.code=q}}e.FileSystemProviderError=r;function o(V,Z){return r.create(V,Z)}e.createFileSystemProviderError=o;function f(V){return V||o((0,A.localize)(0,null),a.Unknown)}e.ensureFileSystemProviderError=f;function v(V,Z){return V.name=Z?`${Z} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=v;function l(V){if(!V)return a.Unknown;if(V instanceof r)return V.code;const Z=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!Z)return a.Unknown;switch(Z[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.toFileSystemProviderErrorCode=l;function I(V){if(V instanceof $)return V.fileOperationResult;switch(l(V)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=I;var E;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(E||(e.FileOperation=E={}));class s{constructor(Z,q,ae){this.resource=Z,this.operation=q,this.target=ae}isOperation(Z){return this.operation===Z}}e.FileOperationEvent=s;var i;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(i||(e.FileChangeType=i={}));class k{constructor(Z,q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ae=new Map;for(const Ee of Z){const ye=ae.get(Ee.type);switch(ye?ye.push([Ee.resource,Ee]):ae.set(Ee.type,[[Ee.resource,Ee]]),Ee.type){case 1:this.rawAdded.push(Ee.resource);break;case 0:this.rawUpdated.push(Ee.resource);break;case 2:this.rawDeleted.push(Ee.resource);break}}for(const[Ee,ye]of ae)switch(Ee){case 1:this.a=c.TernarySearchTree.forUris(()=>q),this.a.fill(ye);break;case 0:this.b=c.TernarySearchTree.forUris(()=>q),this.b.fill(ye);break;case 2:this.c=c.TernarySearchTree.forUris(()=>q),this.c.fill(ye);break}}contains(Z,...q){return this.d(Z,{includeChildren:!1},...q)}affects(Z,...q){return this.d(Z,{includeChildren:!0},...q)}d(Z,q,...ae){if(!Z)return!1;const Ee=ae.length>0;return!!((!Ee||ae.includes(1))&&(this.a?.get(Z)||q.includeChildren&&this.a?.findSuperstr(Z))||(!Ee||ae.includes(0))&&(this.b?.get(Z)||q.includeChildren&&this.b?.findSuperstr(Z))||(!Ee||ae.includes(2))&&(this.c?.findSubstr(Z)||q.includeChildren&&this.c?.findSuperstr(Z)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=k;function F(V,Z,q){return!V||!Z||V===Z||Z.length>V.length?!1:(Z.charAt(Z.length-1)!==R.sep&&(Z+=R.sep),q?(0,u.startsWithIgnoreCase)(V,Z):V.indexOf(Z)===0)}e.isParent=F;class $ extends Error{constructor(Z,q,ae){super(Z),this.fileOperationResult=q,this.options=ae}}e.FileOperationError=$;class j extends ${constructor(Z,q,ae,Ee){super(Z,q,Ee),this.fileOperationResult=q,this.size=ae}}e.TooLargeFileOperationError=j;class W extends ${constructor(Z,q,ae){super(Z,2,ae),this.stat=q}}e.NotModifiedSinceFileOperationError=W;var U;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(U||(e.FileOperationResult=U={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var x;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(x||(e.FileKind=x={})),e.ETAG_DISABLED="";function B(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=B;async function z(V,Z){if(!Z.hasProvider(L.URI.from({scheme:V.scheme})))return new Promise(q=>{const ae=Z.onDidChangeFileSystemProviderRegistrations(Ee=>{Ee.scheme===V.scheme&&Ee.added&&(ae.dispose(),q())})})}e.whenProviderRegistered=z;class ee{static formatSize(Z){return(0,O.isNumber)(Z)||(Z=0),Z<ee.KB?(0,A.localize)(1,null,Z.toFixed(0)):Z<ee.MB?(0,A.localize)(2,null,(Z/ee.KB).toFixed(2)):Z<ee.GB?(0,A.localize)(3,null,(Z/ee.MB).toFixed(2)):Z<ee.TB?(0,A.localize)(4,null,(Z/ee.GB).toFixed(2)):(0,A.localize)(5,null,(Z/ee.TB).toFixed(2))}}e.ByteSize=ee,ee.KB=1024,ee.MB=ee.KB*ee.KB,ee.GB=ee.MB*ee.KB,ee.TB=ee.GB*ee.KB;function se(V){const Z=typeof V=="string"||V?.scheme===T.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===T.Schemas.file?1024*ee.MB:Z?10*ee.MB:g.isWeb?50*ee.MB:1024*ee.MB}e.getLargeFileConfirmationLimit=se}),define(Ce[217],De([1,0,22,8,183,31]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(T,P,m,D,C,b){let n;try{await A(T,P,m,D,C,b)}catch(h){n=h}finally{n&&C.errorTransformer&&(n=C.errorTransformer(n)),typeof n<"u"&&m.error(n),m.end()}}e.readFileIntoStream=L;async function A(T,P,m,D,C,b){y(b);const n=await T.open(P,{create:!1});try{y(b);let h=0,d=0,S=C&&typeof C.length=="number"?C.length:void 0,w=c.VSBuffer.alloc(Math.min(C.bufferSize,typeof S=="number"?S:C.bufferSize)),p=C&&typeof C.position=="number"?C.position:0,t=0;do d=await T.read(n,p,w.buffer,t,w.byteLength-t),p+=d,t+=d,h+=d,typeof S=="number"&&(S-=d),t===w.byteLength&&(await m.write(D(w)),w=c.VSBuffer.alloc(Math.min(C.bufferSize,typeof S=="number"?S:C.bufferSize)),t=0);while(d>0&&(typeof S!="number"||S>0)&&y(b)&&g(h,C));if(t>0){let a=t;typeof S=="number"&&(a=Math.min(t,S)),m.write(D(w.slice(0,a)))}}catch(h){throw(0,O.ensureFileSystemProviderError)(h)}finally{await T.close(n)}}function y(T){if(T.isCancellationRequested)throw(0,R.canceled)();return!0}function g(T,P){if(typeof P?.limits?.size=="number"&&T>P.limits.size)throw(0,O.createFileSystemProviderError)((0,u.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ce[77],De([1,0,32,4,10,9,2,31]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function y(h){return h.recursive===!0}e.isRecursiveWatchRequest=y;class g extends R.Disposable{constructor(d,S,w,p){super(),this.h=d,this.i=S,this.j=w,this.k=p,this.c=this.B(new R.MutableDisposable),this.f=void 0,this.g=0}m(){const d=new R.DisposableStore;this.c.value=d,this.b=this.l(d),this.b.setVerboseLogging(this.j),d.add(this.b.onDidChangeFile(S=>this.h(S))),d.add(this.b.onDidLogMessage(S=>this.i(S))),d.add(this.b.onDidError(S=>this.n(S)))}n(d){this.k.restartOnError?this.g<g.a&&this.f?(this.r(`restarting watcher after error: ${d}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${d}`):this.r(d)}p(d){this.g++,this.m(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.j=d,await this.b?.setVerboseLogging(d)}r(d){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${d}`})}s(d){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=g,g.a=5;class T extends g{constructor(d,S,w){super(d,S,w,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class P extends g{constructor(d,S,w){super(d,S,w,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=P;function m(h){return h.map(d=>({type:d.type,resource:L.URI.file(d.path)}))}e.toFileChanges=m;function D(h){const d=new n;for(const S of h)d.processEvent(S);return d.coalesce()}e.coalesceEvents=D;function C(h,d){return typeof d=="string"&&!d.startsWith(c.GLOBSTAR)&&!(0,u.isAbsolute)(d)?{base:h,pattern:d}:d}e.normalizeWatcherPattern=C;function b(h,d){const S=[];for(const w of d)S.push((0,c.parse)(C(h,w)));return S}e.parseWatcherPatterns=b;class n{constructor(){this.a=new Set,this.b=new Map}c(d){return O.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const S=this.b.get(this.c(d));let w=!1;if(S){const p=S.type,t=d.type;S.path!==d.path&&(d.type===2||d.type===1)?w=!0:p===1&&t===2?(this.b.delete(this.c(d)),this.a.delete(S)):p===2&&t===1?S.type=0:p===1&&t===0||(S.type=t)}else w=!0;w&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],S=[];return Array.from(this.a).filter(w=>w.type!==2?(d.push(w),!1):!0).sort((w,p)=>w.path.length-p.path.length).filter(w=>S.some(p=>(0,A.isParent)(w.path,p,!O.isLinux))?!1:(S.push(w.path),!0)).concat(d)}}}),define(Ce[218],De([1,0,48,16,21,30,4,69,10,9,94,29,77]),function(re,e,c,R,u,O,L,A,y,g,T,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class D extends L.Disposable{constructor(n,h,d,S){super(),this.j=n,this.k=h,this.l=d,this.m=S,this.c=this.B(new R.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},w=>this.k(w))),this.f=this.B(new R.RunOnceWorker(w=>this.u(w),D.b)),this.g=(0,m.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,m.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new u.CancellationTokenSource,this.ready=this.n()}async n(){try{const n=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const h=await P.Promises.stat(n);this.B(await this.s(n,h.isDirectory()))}catch(n){n.code!=="ENOENT"?this.w(n):this.z(n)}}async r(n){let h=n.path;try{h=await P.Promises.realpath(n.path),n.path===h&&(h=await(0,T.realcase)(n.path)??n.path),n.path!==h&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${h})`)}catch{}return h}async s(n,h){if(g.isMacintosh&&(0,O.isEqualOrParent)(n,"/Volumes/",!0))return this.w(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const d=new u.CancellationTokenSource(this.i.token),S=new L.DisposableStore;try{const w=(0,y.basename)(n),p=(0,c.watch)(n);S.add((0,L.toDisposable)(()=>{p.removeAllListeners(),p.close()})),this.z(`Started watching: '${n}'`);const t=new Set;if(h)try{for(const r of await P.Promises.readdir(n))t.add(r)}catch(r){this.w(r)}const a=new Map;S.add((0,L.toDisposable)(()=>{for(const[,r]of a)r.dispose();a.clear()})),p.on("error",(r,o)=>{this.w(`Failed to watch ${n} for changes using fs.watch() (${r}, ${o})`),this.dispose()}),p.on("change",(r,o)=>{if(d.token.isCancellationRequested)return;this.z(`[raw] ["${r}"] ${o}`);let f="";if(o&&(f=o.toString(),g.isMacintosh&&(f=(0,A.normalizeNFC)(f))),!(!f||r!=="change"&&r!=="rename"))if(h)if(r==="rename"){a.get(f)?.dispose();const v=setTimeout(async()=>{if(a.delete(f),f===w&&!await P.Promises.exists(n)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.v((0,y.join)(n,f));if(d.token.isCancellationRequested)return;let I;l?t.has(f)?I=0:(I=1,t.add(f)):(t.delete(f),I=2),this.t({path:(0,y.join)(this.j.path,f),type:I})},D.a);a.set(f,(0,L.toDisposable)(()=>clearTimeout(v)))}else{let v;t.has(f)?v=0:(v=1,t.add(f)),this.t({path:(0,y.join)(this.j.path,f),type:v})}else if(r==="rename"||f!==w){const v=setTimeout(async()=>{const l=await P.Promises.exists(n);d.token.isCancellationRequested||(l?(this.t({path:this.j.path,type:0},!0),S.add(await this.s(n,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},D.a);S.clear(),S.add((0,L.toDisposable)(()=>clearTimeout(v)))}else this.t({path:this.j.path,type:0},!0)})}catch(w){await P.Promises.exists(n)&&!d.token.isCancellationRequested&&this.w(`Failed to watch ${n} for changes using fs.watch() (${w.toString()})`)}return(0,L.toDisposable)(()=>{d.dispose(!0),S.dispose()})}t(n,h=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.path}`),!h&&this.g.some(d=>d(n.path))?this.m&&this.z(` >> ignored (excluded) ${n.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(d=>d(n.path))?this.m&&this.z(` >> ignored (not included) ${n.path}`):this.f.work(n))}u(n){const h=(0,m.coalesceEvents)(n);if(h.length>0){if(this.m)for(const S of h)this.z(`>> normalized ${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.path}`);this.c.work(h)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(n){if(g.isLinux)return P.Promises.exists(n);try{const h=(0,y.basename)(n);return(await P.Promises.readdir((0,y.dirname)(n))).some(S=>S===h)}catch(h){return this.z(h),!1}}setVerboseLogging(n){this.m=n}w(n){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}y(n){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}z(n){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=D,D.a=100,D.b=75;async function C(b,n,h,d,S=512){const w=await P.Promises.open(b,"r"),p=Buffer.allocUnsafe(S),t=new u.CancellationTokenSource(d);let a,r=!1;const o={path:b,excludes:[],recursive:!1},f=new D(o,v=>{(async()=>{for(const{type:l}of v)if(l===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:I}=await P.Promises.read(w,p,0,S,null);if(!I||t.token.isCancellationRequested)break;n(p.slice(0,I))}}catch(I){a=new Error(I),t.dispose(!0)}finally{r=!1}}})()});return await f.ready,h(),new Promise((v,l)=>{t.token.onCancellationRequested(async()=>{f.dispose();try{await P.Promises.close(w)}catch(I){a=new Error(I)}a?l(a):v()})})}e.watchFileContents=C}),define(Ce[219],De([1,0,3,32,4,9,218]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class A extends u.Disposable{constructor(){super(...arguments),this.a=this.B(new c.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new c.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=c.Event.None,this.c=new Map,this.f=!1}async watch(g){const T=this.i(g),P=T.filter(D=>{const C=this.c.get(D.path);return C?!(0,R.patternsEquals)(C.request.excludes,D.excludes)||!(0,R.patternsEquals)(C.request.includes,D.includes):!0}),m=Array.from(this.c.values()).filter(({request:D})=>!T.find(C=>C.path===D.path&&(0,R.patternsEquals)(C.excludes,D.excludes)&&(0,R.patternsEquals)(C.includes,D.includes))).map(({request:D})=>D.path);P.length&&this.j(`Request to start watching: ${P.map(D=>`${D.path} (excludes: ${D.excludes.length>0?D.excludes:"<none>"}, includes: ${D.includes&&D.includes.length>0?JSON.stringify(D.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const D of m)this.h(D);for(const D of P)this.g(D)}g(g){const T=new L.NodeJSFileWatcherLibrary(g,m=>this.a.fire(m),m=>this.b.fire(m),this.f),P={request:g,instance:T};this.c.set(g.path,P)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const T=this.c.get(g);T&&(this.c.delete(g),T.instance.dispose())}i(g){const T=new Map;for(const P of g){const m=O.isLinux?P.path:P.path.toLowerCase();T.set(m,P)}return Array.from(T.values())}async setVerboseLogging(g){this.f=g;for(const[,T]of this.c)T.instance.setVerboseLogging(g)}j(g){this.f&&this.b.fire({type:"trace",message:this.k(g)})}k(g,T){return T?`[File Watcher (node.js)] ${g} (path: ${T.request.path})`:`[File Watcher (node.js)] ${g}`}}e.NodeJSWatcher=A}),define(Ce[220],De([1,0,77,219]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class u extends c.AbstractNonRecursiveWatcherClient{constructor(L,A,y){super(L,A,y),this.m()}l(){return new R.NodeJSWatcher}}e.NodeJSWatcherClient=u}),define(Ce[221],De([1,0,18,75,158,77]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends O.AbstractUniversalWatcherClient{constructor(y,g,T){super(y,g,T),this.m()}l(y){const g=y.add(new u.Client(c.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(g.onDidProcessExit(({code:T,signal:P})=>this.n(`terminated by itself with code ${T}, signal: ${P}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(g.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(Ce[98],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...u){this.a=new Map;for(const[O,L]of u)this.set(O,L)}set(u,O){const L=this.a.get(u);return this.a.set(u,O),L}has(u){return this.a.has(u)}get(u){return this.a.get(u)}}e.ServiceCollection=c}),define(Ce[222],De([1,0,16,8,4,96,213,5,98,68]),function(re,e,c,R,u,O,L,A,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const T=!1;class P extends Error{constructor(n){super("cyclic dependency between services"),this.message=n.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${n.toString()}`}}class m{constructor(n=new y.ServiceCollection,h=!1,d,S=T){this.f=n,this.g=h,this.h=d,this.i=S,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=S?d?._globalGraph??new L.Graph(w=>w):void 0}createChild(n){return new m(n,this.g,this,this.i)}invokeFunction(n,...h){const d=C.traceInvocation(this.i,n);let S=!1;try{return n({get:p=>{if(S)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(p,d);if(!t)throw new Error(`[invokeFunction] unknown service '${p}'`);return t}},...h)}finally{S=!0,d.stop()}}createInstance(n,...h){let d,S;return n instanceof O.SyncDescriptor?(d=C.traceCreation(this.i,n.ctor),S=this.j(n.ctor,n.staticArguments.concat(h),d)):(d=C.traceCreation(this.i,n),S=this.j(n,h,d)),d.stop(),S}j(n,h=[],d){const S=A._util.getServiceDependencies(n).sort((t,a)=>t.index-a.index),w=[];for(const t of S){const a=this.m(t.id,d);a||this.u(`[createInstance] ${n.name} depends on UNKNOWN service ${t.id}.`,!1),w.push(a)}const p=S.length>0?S[0].index:h.length;if(h.length!==p){console.trace(`[createInstance] First service dependency of ${n.name} at position ${p+1} conflicts with ${h.length} static arguments`);const t=p-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,p)}return Reflect.construct(n,h.concat(w))}k(n,h){if(this.f.get(n)instanceof O.SyncDescriptor)this.f.set(n,h);else if(this.h)this.h.k(n,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(n){const h=this.f.get(n);return!h&&this.h?this.h.l(n):h}m(n,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(n));const d=this.l(n);return d instanceof O.SyncDescriptor?this.q(n,d,h.branch(n,!0)):(h.branch(n,!1),d)}q(n,h,d){if(this.o.has(n))throw new Error(`illegal state - RECURSIVELY instantiating service '${n}'`);this.o.add(n);try{return this.r(n,h,d)}finally{this.o.delete(n)}}r(n,h,d){const S=new L.Graph(t=>t.id.toString());let w=0;const p=[{id:n,desc:h,_trace:d}];for(;p.length;){const t=p.pop();if(S.lookupOrInsertNode(t),w++>1e3)throw new P(S);for(const a of A._util.getServiceDependencies(t.desc.ctor)){const r=this.l(a.id);if(r||this.u(`[createInstance] ${n} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),r instanceof O.SyncDescriptor){const o={id:a.id,desc:r,_trace:t._trace.branch(a.id,!0)};S.insertEdge(t,o),p.push(o)}}}for(;;){const t=S.roots();if(t.length===0){if(!S.isEmpty())throw new P(S);break}for(const{data:a}of t){if(this.l(a.id)instanceof O.SyncDescriptor){const o=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,o)}S.removeNode(a)}}return this.l(n)}s(n,h,d=[],S,w){if(this.f.get(n)instanceof O.SyncDescriptor)return this.t(n,h,d,S,w);if(this.h)return this.h.s(n,h,d,S,w);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(n,h,d=[],S,w){if(S){const p=new m(void 0,this.g,this,this.i);p.c=String(n);const t=new Map,a=new c.IdleValue(()=>{const r=p.j(h,d,w);for(const[o,f]of t){const v=r[o];if(typeof v=="function")for(const l of f)v.apply(r,l)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,o){if(!a.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let l=t.get(o);return l||(l=new g.LinkedList,t.set(o,l)),(E,s,i)=>{const k=l.push([E,s,i]);return(0,u.toDisposable)(k)}}if(o in r)return r[o];const f=a.value;let v=f[o];return typeof v!="function"||(v=v.bind(f),r[o]=v),v},set(r,o,f){return a.value[o]=f,!0},getPrototypeOf(r){return h.prototype}})}else return this.j(h,d,w)}u(n,h){if(h&&console.warn(n),this.g)throw new Error(n)}}e.InstantiationService=m;var D;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(D||(D={}));class C{static traceInvocation(n,h){return n?new C(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):C.c}static traceCreation(n,h){return n?new C(1,h.name):C.c}constructor(n,h){this.type=n,this.name=h,this.g=Date.now(),this.h=[]}branch(n,h){const d=new C(3,n.toString());return this.h.push([n,h,d]),d}stop(){const n=Date.now()-this.g;C.f+=n;let h=!1;function d(w,p){const t=[],a=new Array(w+1).join("	");for(const[r,o,f]of p.h)if(o&&f){h=!0,t.push(`${a}CREATES -> ${r}`);const v=d(w+1,f);v&&t.push(v)}else t.push(`${a}uses -> ${r}`);return t.join(`
`)}const S=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${n.toFixed(2)}ms (grand total ${C.f.toFixed(2)}ms)`];(n>2||h)&&C.all.add(S.join(`
`))}}e.Trace=C,C.all=new Set,C.c=new class extends C{constructor(){super(0,null)}stop(){}branch(){return this}},C.f=0}),define(Ce[17],De([1,0,46,3,70,4,28,9,24,12,2,47,5]),function(re,e,c,R,u,O,L,A,y,g,T,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function D(){return new Date().toISOString()}function C(E){return(0,g.isNumber)(E)}e.isLogLevel=C;var b;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(b||(e.LogLevel=b={})),e.DEFAULT_LOG_LEVEL=b.Info;function n(E,s,i){switch(s){case b.Trace:E.trace(i);break;case b.Debug:E.debug(i);break;case b.Info:E.info(i);break;case b.Warning:E.warn(i);break;case b.Error:E.error(i);break;case b.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=n;function h(E,s=!1){let i="";for(let k=0;k<E.length;k++){let F=E[k];if(F instanceof Error&&(F=(0,c.toErrorMessage)(F,s)),typeof F=="object")try{F=JSON.stringify(F)}catch{}i+=(k>0?" ":"")+F}return i}class d extends O.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new R.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(s){this.b!==s&&(this.b=s,this.c.fire(this.b))}getLevel(){return this.b}f(s){return this.b!==b.Off&&this.b<=s}}e.AbstractLogger=d;class S extends d{constructor(s){super(),this.h=s}f(s){return this.h||super.f(s)}trace(s,...i){this.f(b.Trace)&&this.g(b.Trace,h([s,...i],!0))}debug(s,...i){this.f(b.Debug)&&this.g(b.Debug,h([s,...i]))}info(s,...i){this.f(b.Info)&&this.g(b.Info,h([s,...i]))}warn(s,...i){this.f(b.Warning)&&this.g(b.Warning,h([s,...i]))}error(s,...i){if(this.f(b.Error))if(s instanceof Error){const k=Array.prototype.slice.call(arguments);k[0]=s.stack,this.g(b.Error,h(k))}else this.g(b.Error,h([s,...i]))}flush(){}}e.AbstractMessageLogger=S;class w extends d{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.g=!A.isWindows}trace(s,...i){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,s,...i):console.log(`[main ${D()}]`,s,...i))}debug(s,...i){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,s,...i):console.log(`[main ${D()}]`,s,...i))}info(s,...i){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,s,...i):console.log(`[main ${D()}]`,s,...i))}warn(s,...i){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,s,...i):console.warn(`[main ${D()}]`,s,...i))}error(s,...i){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,s,...i):console.error(`[main ${D()}]`,s,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class p extends d{constructor(s=e.DEFAULT_LOG_LEVEL,i=!0){super(),this.g=i,this.setLevel(s)}trace(s,...i){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",s,...i):console.log(s,...i))}debug(s,...i){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",s,...i):console.log(s,...i))}info(s,...i){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",s,...i):console.log(s,...i))}warn(s,...i){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",s,...i):console.log(s,...i))}error(s,...i){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",s,...i):console.error(s,...i))}dispose(){}flush(){}}e.ConsoleLogger=p;class t extends d{constructor(s,i=e.DEFAULT_LOG_LEVEL){super(),this.g=s,this.setLevel(i)}trace(s,...i){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(s),...i])}debug(s,...i){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(s),...i])}info(s,...i){this.f(b.Info)&&this.g.log(b.Info,[this.h(s),...i])}warn(s,...i){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(s),...i])}error(s,...i){this.f(b.Error)&&this.g.log(b.Error,[this.h(s),...i])}h(s){return typeof s=="string"?s:(0,c.toErrorMessage)(s,this.f(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class a extends d{constructor(s){super(),this.g=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const i of this.g)i.setLevel(s);super.setLevel(s)}trace(s,...i){for(const k of this.g)k.trace(s,...i)}debug(s,...i){for(const k of this.g)k.debug(s,...i)}info(s,...i){for(const k of this.g)k.info(s,...i)}warn(s,...i){for(const k of this.g)k.warn(s,...i)}error(s,...i){for(const k of this.g)k.error(s,...i)}flush(){for(const s of this.g)s.flush()}dispose(){for(const s of this.g)s.dispose()}}e.MultiplexLogger=a;class r extends O.Disposable{constructor(s,i,k){if(super(),this.h=s,this.j=i,this.b=new L.ResourceMap,this.c=this.B(new R.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeVisibility=this.g.event,k)for(const F of k)this.b.set(F.resource,{logger:void 0,info:F})}k(s){return(0,g.isString)(s)?[...this.b.values()].find(i=>i.info.id===s):this.b.get(s)}getLogger(s){return this.k(s)?.logger}createLogger(s,i){const k=this.l(s),F=(0,g.isString)(s)?s:i?.id??(0,u.hash)(k.toString()).toString(16);let $=this.b.get(k)?.logger;const j=i?.logLevel==="always"?b.Trace:i?.logLevel;$||($=this.m(k,j??this.getLogLevel(k)??this.h,{...i,id:F}));const W={logger:$,info:{resource:k,id:F,logLevel:j,name:i?.name,hidden:i?.hidden,extensionId:i?.extensionId,when:i?.when}};return this.registerLogger(W.info),this.b.set(k,W),$}l(s){return(0,g.isString)(s)?(0,y.joinPath)(this.j,`${s}.log`):s}setLogLevel(s,i){if(T.URI.isUri(s)){const k=s,F=i,$=this.b.get(k);$&&F!==$.info.logLevel&&($.info.logLevel=F===this.h?void 0:F,$.logger?.setLevel(F),this.b.set($.info.resource,$),this.f.fire([k,F]))}else{this.h=s;for(const[k,F]of this.b.entries())this.b.get(k)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(s,i){const k=this.k(s);k&&i!==!k.info.hidden&&(k.info.hidden=!i,this.b.set(k.info.resource,k),this.g.fire([k.info.resource,i]))}getLogLevel(s){let i;return s&&(i=this.b.get(s)?.info.logLevel),i??this.h}registerLogger(s){const i=this.b.get(s.resource);i?i.info.hidden!==s.hidden&&this.setVisibility(s.resource,!s.hidden):(this.b.set(s.resource,{info:s,logger:void 0}),this.c.fire({added:[s],removed:[]}))}deregisterLogger(s){const i=this.b.get(s);i&&(i.logger&&i.logger.dispose(),this.b.delete(s),this.c.fire({added:[],removed:[i.info]}))}*getRegisteredLoggers(){for(const s of this.b.values())yield s.info}getRegisteredLogger(s){return this.b.get(s)?.info}dispose(){this.b.forEach(s=>s.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=r;class o{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(s){}getLevel(){return b.Info}trace(s,...i){}debug(s,...i){}info(s,...i){}warn(s,...i){}error(s,...i){}critical(s,...i){}dispose(){}flush(){}}e.NullLogger=o;class f extends o{}e.NullLogService=f;function v(E){if(E.verbose)return b.Trace;if(typeof E.logLevel=="string"){const s=I(E.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function l(E){switch(E){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=l;function I(E){switch(E){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=I,e.CONTEXT_LOG_LEVEL=new P.RawContextKey("logLevel",l(b.Info))}),define(Ce[223],De([1,0,19,16,8,3,4,10,77,17]),function(re,e,c,R,u,O,L,A,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends L.Disposable{constructor(m,D){super(),this.a=m,this.b=D,this.c=this.B(new O.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new O.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new R.ThrottledDelayer(0)),this.s=[],this.t=this.B(new R.ThrottledDelayer(0))}watch(m,D){return D.recursive||this.b?.watcher?.forceUniversal?this.l(m,D):this.u(m,D)}l(m,D){const C={path:this.C(m),excludes:D.excludes,includes:D.includes,recursive:D.recursive},b=(0,c.insert)(this.j,C);return this.m(),(0,L.toDisposable)(()=>{b(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,u.onUnexpectedError)(m))}n(){this.h||(this.h=this.B(this.p(D=>this.c.fire((0,y.toFileChanges)(D)),D=>this.z(D),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const D of this.j)(0,y.isRecursiveWatchRequest)(D)&&(D.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const D of this.j)(0,y.isRecursiveWatchRequest)(D)&&m.includes(D.path)&&(D.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,D){const C={path:this.C(m),excludes:D.excludes,includes:D.includes,recursive:!1},b=(0,c.insert)(this.s,C);return this.v(),(0,L.toDisposable)(()=>{b(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,u.onUnexpectedError)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,y.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,A.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(Ce[224],De([1,0,48,346,16,28,22,3,30,4,10,9,24,93,29,184,31,217,223,46,221,220]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d,S,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(c)}catch(a){console.error(`Error enabling graceful-fs: ${(0,S.toErrorMessage)(a)}`)}})();class t extends d.AbstractDiskFileSystemProvider{constructor(r,o){super(r,o),this.onDidChangeCapabilities=A.Event.None,this.I=new O.ResourceMap(f=>m.extUriBiasedIgnorePathCase.getComparisonKey(f)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,P.isLinux&&(this.F|=1024)),this.F}async stat(r){try{const{stat:o,symbolicLink:f}=await C.SymlinkSupport.stat(this.C(r));return{type:this.H(o,f),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size,permissions:o.mode&128?void 0:n.FilePermission.Locked}}catch(o){throw this.bb(o)}}async G(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const o=await C.Promises.readdir(this.C(r),{withFileTypes:!0}),f=[];return await Promise.all(o.map(async v=>{try{let l;v.isSymbolicLink()?l=(await this.stat((0,m.joinPath)(r,v.name))).type:l=this.H(v),f.push([v.name,l])}catch(l){this.a.trace(l)}})),f}catch(o){throw this.bb(o)}}H(r,o){let f;return o?.dangling?f=n.FileType.Unknown:r.isFile()?f=n.FileType.File:r.isDirectory()?f=n.FileType.Directory:f=n.FileType.Unknown,o&&(f|=n.FileType.SymbolicLink),f}async J(r){const o=this.C(r);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let f;for(;f=this.I.get(r);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await f.wait();const v=new u.Barrier;return this.I.set(r,v),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,g.toDisposable)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.I.get(r)===v&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.I.delete(r)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),v.open()})}async readFile(r,o){let f;try{o?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(r)})`),f=await this.J(r));const v=this.C(r);return await C.Promises.readFile(v)}catch(v){throw this.bb(v)}finally{f?.dispose()}}L(r){t.D&&this.a.trace(r)}readFileStream(r,o,f){const v=(0,D.newWriteableStream)(l=>L.VSBuffer.concat(l.map(I=>L.VSBuffer.wrap(I))).buffer);return(0,h.readFileIntoStream)(this,r,v,l=>l.buffer,{...o,bufferSize:256*1024},f),v}async writeFile(r,o,f){return f?.atomic!==!1&&f?.atomic?.postfix?this.M(r,(0,m.joinPath)((0,m.dirname)(r),`${(0,m.basename)(r)}${f.atomic.postfix}`),o,f):this.N(r,o,f)}async M(r,o,f,v){await this.N(o,f,v);try{await this.rename(o,r,{overwrite:!0})}catch(l){try{await this.delete(o,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}async N(r,o,f){let v;try{const l=this.C(r);if(!f.create||!f.overwrite){if(await C.Promises.exists(l)){if(!f.overwrite)throw(0,n.createFileSystemProviderError)((0,b.localize)(0,null),n.FileSystemProviderErrorCode.FileExists)}else if(!f.create)throw(0,n.createFileSystemProviderError)((0,b.localize)(1,null),n.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(r,{create:!0,unlock:f.unlock}),await this.write(v,0,o,0,o.byteLength)}catch(l){throw await this.cb(r,l)}finally{typeof v=="number"&&await this.close(v)}}static configureFlushOnWrite(r){t.R=r}async open(r,o){const f=this.C(r);let v;(0,n.isFileOpenForWriteOptions)(o)&&(v=await this.J(r));let l;try{if((0,n.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:E}=await C.SymlinkSupport.stat(f);E.mode&128||await C.Promises.chmod(f,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let I;if((0,n.isFileOpenForWriteOptions)(o)){if(P.isWindows)try{await C.Promises.truncate(f,0),I="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}I||(I="w")}else I="r";l=await C.Promises.open(f,I)}catch(I){throw v?.dispose(),(0,n.isFileOpenForWriteOptions)(o)?await this.cb(r,I):this.bb(I)}if(this.O.set(l,0),(0,n.isFileOpenForWriteOptions)(o)&&this.Q.set(l,r),v){const I=this.P.get(l);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${f})`),this.P.set(l,v),I&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${f})`),I.dispose())}return l}async close(r){const o=this.P.get(r);try{if(this.O.delete(r),this.Q.delete(r)&&t.R)try{await C.Promises.fdatasync(r)}catch(f){t.configureFlushOnWrite(!1),this.a.error(f)}return await C.Promises.close(r)}catch(f){throw this.bb(f)}finally{o&&(this.P.get(r)===o&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.P.delete(r)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),o.dispose())}}async read(r,o,f,v,l){const I=this.S(r,o);let E=null;try{E=(await C.Promises.read(r,f,v,l,I)).bytesRead}catch(s){throw this.bb(s)}finally{this.U(r,I,E)}return E}S(r,o){return o===this.O.get(r)?null:o}U(r,o,f){const v=this.O.get(r);typeof v=="number"&&(typeof o=="number"||(typeof f=="number"?this.O.set(r,v+f):this.O.delete(r)))}async write(r,o,f,v,l){return(0,u.retry)(()=>this.W(r,o,f,v,l),100,3)}async W(r,o,f,v,l){const I=this.S(r,o);let E=null;try{E=(await C.Promises.write(r,f,v,l,I)).bytesWritten}catch(s){throw await this.cb(this.Q.get(r),s)}finally{this.U(r,I,E)}return E}async mkdir(r){try{await C.Promises.mkdir(this.C(r))}catch(o){throw this.bb(o)}}async delete(r,o){try{const f=this.C(r);if(o.recursive){let v;o?.atomic!==!1&&o.atomic.postfix&&(v=(0,T.join)((0,T.dirname)(f),`${(0,T.basename)(f)}${o.atomic.postfix}`)),await C.Promises.rm(f,C.RimRafMode.MOVE,v)}else try{await C.Promises.unlink(f)}catch(v){if(v.code==="EPERM"||v.code==="EISDIR"){let l=!1;try{const{stat:I,symbolicLink:E}=await C.SymlinkSupport.stat(f);l=I.isDirectory()&&!E}catch{}if(l)await C.Promises.rmdir(f);else throw v}else throw v}}catch(f){throw this.bb(f)}}async rename(r,o,f){const v=this.C(r),l=this.C(o);if(v!==l)try{await this.X(r,o,"move",f.overwrite),await C.Promises.move(v,l)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,b.localize)(2,null,(0,T.basename)(v),(0,T.basename)((0,T.dirname)(l)),I.toString()))),this.bb(I)}}async copy(r,o,f){const v=this.C(r),l=this.C(o);if(v!==l)try{await this.X(r,o,"copy",f.overwrite),await C.Promises.copy(v,l,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,b.localize)(3,null,(0,T.basename)(v),(0,T.basename)((0,T.dirname)(l)),I.toString()))),this.bb(I)}}async X(r,o,f,v){const l=this.C(r),I=this.C(o);let E=!1;if(!!(this.capabilities&1024)||(E=(0,y.isEqual)(l,I,!0)),E){if(f==="copy")throw(0,n.createFileSystemProviderError)((0,b.localize)(4,null),n.FileSystemProviderErrorCode.FileExists);if(f==="move")return}const i=await this.G(r);if(!i)throw(0,n.createFileSystemProviderError)((0,b.localize)(5,null),n.FileSystemProviderErrorCode.FileNotFound);const k=await this.G(o);if(k){if(!v)throw(0,n.createFileSystemProviderError)((0,b.localize)(6,null),n.FileSystemProviderErrorCode.FileExists);i.type&n.FileType.File&&k.type&n.FileType.File||await this.delete(o,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,o){return this.Y(r,o,!1)}async Y(r,o,f){const v=this.C(r),l=this.C(o),I=!!(this.capabilities&1024);if((0,y.isEqual)(v,l,!I))return;const E=new g.DisposableStore;try{const[s,i]=await Promise.all([this.J(r),this.J(o)]);E.add(s),E.add(i),f&&await C.Promises.mkdir((0,T.dirname)(l),{recursive:!0}),await C.Promises.copyFile(v,l)}catch(s){if(s.code==="ENOENT"&&!f)return this.Y(r,o,!0);throw this.bb(s)}finally{E.dispose()}}p(r,o,f){return new w.UniversalWatcherClient(v=>r(v),v=>o(v),f)}y(r,o,f){return new p.NodeJSWatcherClient(v=>r(v),v=>o(v),f)}bb(r){if(r instanceof n.FileSystemProviderError)return r;let o=r,f;switch(r.code){case"ENOENT":f=n.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=n.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=n.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=n.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=n.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":o=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,f=n.FileSystemProviderErrorCode.Unknown;break;default:f=n.FileSystemProviderErrorCode.Unknown}return(0,n.createFileSystemProviderError)(o,f)}async cb(r,o){let f=this.bb(o);if(r&&f.code===n.FileSystemProviderErrorCode.NoPermissions)try{const{stat:v}=await C.SymlinkSupport.stat(this.C(r));v.mode&128||(f=(0,n.createFileSystemProviderError)(o,n.FileSystemProviderErrorCode.FileWriteLocked))}catch(v){this.a.trace(v)}return f}}e.DiskFileSystemProvider=t,t.D=!1,t.R=!0}),define(Ce[225],De([1,0,4,17]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class u extends c.Disposable{constructor(L,A=[]){super(),this.a=new R.MultiplexLogger([L,...A]),this.B(L.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...A){this.a.trace(L,...A)}debug(L,...A){this.a.debug(L,...A)}info(L,...A){this.a.info(L,...A)}warn(L,...A){this.a.warn(L,...A)}error(L,...A){this.a.error(L,...A)}flush(){this.a.flush()}}e.LogService=u}),define(Ce[226],De([1,0,31,17]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var u;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(u||(u={}));async function O(g,T,P,m,D){try{const C=await new Promise((n,h)=>{re(["@vscode/spdlog"],n,h)});C.setFlushOn(u.Trace);const b=await C.createAsyncRotatingLogger(g,T,P,m);return D?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(C){console.error(C)}return null}function L(g,T,P){switch(T){case R.LogLevel.Trace:g.trace(P);break;case R.LogLevel.Debug:g.debug(P);break;case R.LogLevel.Info:g.info(P);break;case R.LogLevel.Warning:g.warn(P);break;case R.LogLevel.Error:g.error(P);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function A(g,T){switch(T){case R.LogLevel.Trace:g.setLevel(u.Trace);break;case R.LogLevel.Debug:g.setLevel(u.Debug);break;case R.LogLevel.Info:g.setLevel(u.Info);break;case R.LogLevel.Warning:g.setLevel(u.Warning);break;case R.LogLevel.Error:g.setLevel(u.Error);break;case R.LogLevel.Off:g.setLevel(u.Off);break;default:throw new Error(`Invalid log level ${T}`)}}class y extends R.AbstractMessageLogger{constructor(T,P,m,D,C){super(),this.k=[],this.setLevel(C),this.l=this.n(T,P,m,D),this.B(this.onDidChangeLogLevel(b=>{this.m&&A(this.m,b)}))}async n(T,P,m,D){const C=m?6:1,b=30/C*c.ByteSize.MB,n=await O(T,P,b,C,D);if(n){this.m=n,A(this.m,this.getLevel());for(const{level:h,message:d}of this.k)L(this.m,h,d);this.k=[]}}g(T,P){this.m?L(this.m,T,P):this.getLevel()<=T&&this.k.push({level:T,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=y}),define(Ce[126],De([1,0,41,185,5]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var L;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(y){function g(C,b){return b-C}y.compare=g;const T=Object.create(null);T[y.Error]=(0,R.localize)(0,null),T[y.Warning]=(0,R.localize)(1,null),T[y.Info]=(0,R.localize)(2,null);function P(C){return T[C]||""}y.toString=P;function m(C){switch(C){case c.default.Error:return y.Error;case c.default.Warning:return y.Warning;case c.default.Info:return y.Info;case c.default.Ignore:return y.Hint}}y.fromSeverity=m;function D(C){switch(C){case y.Error:return c.default.Error;case y.Warning:return c.default.Warning;case y.Info:return c.default.Info;case y.Hint:return c.default.Ignore}}y.toSeverity=D}(L||(e.MarkerSeverity=L={}));var A;(function(y){const g="";function T(m){return P(m,!0)}y.makeKey=T;function P(m,D){const C=[g];return m.source?C.push(m.source.replace("\xA6","\\\xA6")):C.push(g),m.code?typeof m.code=="string"?C.push(m.code.replace("\xA6","\\\xA6")):C.push(m.code.value.replace("\xA6","\\\xA6")):C.push(g),m.severity!==void 0&&m.severity!==null?C.push(L.toString(m.severity)):C.push(g),m.message&&D?C.push(m.message.replace("\xA6","\\\xA6")):C.push(g),m.startLineNumber!==void 0&&m.startLineNumber!==null?C.push(m.startLineNumber.toString()):C.push(g),m.startColumn!==void 0&&m.startColumn!==null?C.push(m.startColumn.toString()):C.push(g),m.endLineNumber!==void 0&&m.endLineNumber!==null?C.push(m.endLineNumber.toString()):C.push(g),m.endColumn!==void 0&&m.endColumn!==null?C.push(m.endColumn.toString()):C.push(g),C.push(g),C.join("\xA6")}y.makeKeyOptionalMessage=P})(A||(e.IMarkerData=A={})),e.IMarkerService=(0,u.createDecorator)("markerService")}),define(Ce[227],De([1,0,3,41,5]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=R.default,e.INotificationService=(0,u.createDecorator)("notificationService");var O;(function(T){T[T.DEFAULT=0]="DEFAULT",T[T.SILENT=1]="SILENT",T[T.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var L;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.PROFILE=1]="PROFILE",T[T.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));var A;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(A||(e.NotificationsFilter=A={}));class y{constructor(){this.progress=new g,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.NoOpNotification=y;class g{infinite(){}done(){}total(P){}worked(P){}}e.NoOpProgress=g}),define(Ce[127],De([1,0,11,2,5]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,u.createDecorator)("openerService");function O(g,T){return R.URI.isUri(g)?(0,c.equalsIgnoreCase)(g.scheme,T):(0,c.startsWithIgnoreCase)(g,T+":")}e.matchesScheme=O;function L(g,...T){return T.some(P=>O(g,P))}e.matchesSomeScheme=L;function A(g,T){return g.with({fragment:`${T.startLineNumber},${T.startColumn}${T.endLineNumber?`-${T.endLineNumber}${T.endColumn?`,${T.endColumn}`:""}`:""}`})}e.withSelection=A;function y(g){let T;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return P&&(T={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},g=g.with({fragment:""})),{selection:T,uri:g}}e.extractSelection=y}),define(Ce[228],De([1,0,9,39]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let u;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.context<"u"){const O=c.globals.vscode.context.configuration();if(O)u=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(u=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(u,{nameShort:`${u.nameShort} Dev`,nameLong:`${u.nameLong} Dev`,dataFolderName:`${u.dataFolderName}-dev`,serverDataFolderName:u.serverDataFolderName?`${u.serverDataFolderName}-dev`:void 0}),!u.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(u,{version:O.version})}Object.assign(u,{extensionsGallery:R.env.EXTENSIONS_GALLERY?JSON.parse(R.env.EXTENSIONS_GALLERY):u.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else u={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.78.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.79.2",commit:"695af097c7bd098fbf017ce3ac85e09bbc5dda06",date:"2023-06-22T06:47:55.646Z"},Object.keys(u).length===0&&Object.assign(u,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=u}),define(Ce[229],De([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var je=this&&this.__param||function(re,e){return function(c,R){e(c,R,re)}};define(Ce[128],De([1,0,16,21,4,5]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,O.createDecorator)("progressService");var L;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(P){this.b=P}report(P){this.a=P,this.b(this.a)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=e.UnmanagedProgress=class extends u.Disposable{constructor(P,m){super(),this.a=new c.DeferredPromise,m.withProgress(P,D=>(this.b=D,this.c&&D.report(this.c),this.a.p)),this.B((0,u.toDisposable)(()=>this.a.complete()))}report(P){this.b?this.b.report(P):this.c=P}};e.UnmanagedProgress=y=qe([je(1,e.IProgressService)],y);class g extends u.Disposable{constructor(P){super(),this.g=P,this.a=0,this.b=this.B(new u.DisposableStore)}start(P){this.stop();const m=++this.a,D=new R.CancellationTokenSource;return this.f=setTimeout(()=>{m===this.a&&(this.c=this.g.show(!0))},P),this.b.add((0,u.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,u.toDisposable)(()=>D.cancel())),this.b.add((0,u.toDisposable)(()=>this.c?this.c.done():void 0)),{id:m,token:D.token,stop:()=>this.h(m),isCurrent:()=>this.a===m}}stop(){this.h(this.a)}h(P){this.a===P&&this.b.clear()}}e.LongRunningOperation=g,e.IEditorProgressService=(0,O.createDecorator)("editorProgressService")}),define(Ce[42],De([1,0,52,12]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class u{constructor(){this.a=new Map}add(L,A){c.ok(R.isString(L)),c.ok(R.isObject(A)),c.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,A)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.Registry=new u}),define(Ce[99],De([1,0,3,42]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function u(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class O{constructor(){this.b=new c.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,g){this.a[u(y)]=g,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const L=new O;R.Registry.add(e.Extensions.JSONContribution,L)}),define(Ce[129],De([1,0,19,3,12,176,57,99,42]),function(re,e,c,R,u,O,L,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=y.Registry.as(A.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new R.Emitter,this.onDidSchemaChange=this.i.event,this.j=new R.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const r=new Set;this.n(t,a,r),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const a=new Set;this.o(t,a),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const r=new Set;this.o(a,r),this.n(t,!1,r),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const r=[];for(const{overrides:o,source:f}of t)for(const v in o)if(a.add(v),e.OVERRIDE_PROPERTY_REGEX.test(v)){const l=this.a.get(v),I=l?.valuesSources??new Map;if(f)for(const k of Object.keys(o[v]))I.set(k,f);const E={...l?.value||{},...o[v]};this.a.set(v,{source:f,value:E,valuesSources:I});const s=(0,L.getLanguageTagSettingPlainKey)(v),i={type:"object",default:E,description:O.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:u.isString(f)?void 0:f,defaultValueSource:f};r.push(...b(v)),this.d[v]=i,this.b.properties[v]=i}else{this.a.set(v,{value:o[v],source:f});const l=this.d[v];l&&(this.w(v,l),this.r(v,l))}this.m(r)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:r,source:o}of t)for(const f in r){const v=this.a.get(f),l=u.isString(o)?o:o?.id,I=u.isString(v?.source)?v?.source:v?.source?.id;if(l===I)if(a.add(f),this.a.delete(f),e.OVERRIDE_PROPERTY_REGEX.test(f))delete this.d[f],delete this.b.properties[f];else{const E=this.d[f];E&&(this.w(f,E),this.r(f,E))}}this.u()}deltaConfiguration(t){let a=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,r){t.forEach(o=>{this.p(o,a,o.extensionInfo,o.restrictedProperties,void 0,r),this.c.push(o),this.q(o)})}o(t,a){const r=o=>{if(o.properties)for(const f in o.properties){a.add(f);const v=this.d[f];v?.policy?.name&&this.e.delete(v.policy.name),delete this.d[f],this.s(f,o.properties[f])}o.allOf?.forEach(f=>r(f))};for(const o of t){r(o);const f=this.c.indexOf(o);f!==-1&&this.c.splice(f,1)}}p(t,a=!0,r,o,f=3,v){f=u.isUndefinedOrNull(t.scope)?f:t.scope;const l=t.properties;if(l)for(const E in l){const s=l[E];if(a&&S(E,s)){delete l[E];continue}if(s.source=r,s.defaultDefaultValue=l[E].default,this.w(E,s),e.OVERRIDE_PROPERTY_REGEX.test(E)?s.scope=void 0:(s.scope=u.isUndefinedOrNull(s.scope)?f:s.scope,s.restricted=u.isUndefinedOrNull(s.restricted)?!!o?.includes(E):s.restricted),l[E].hasOwnProperty("included")&&!l[E].included){this.f[E]=l[E],delete l[E];continue}else this.d[E]=l[E],l[E].policy?.name&&this.e.set(l[E].policy.name,E);!l[E].deprecationMessage&&l[E].markdownDeprecationMessage&&(l[E].deprecationMessage=l[E].markdownDeprecationMessage),v.add(E)}const I=t.allOf;if(I)for(const E of I)this.p(E,a,r,o,f,v)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=r=>{const o=r.properties;if(o)for(const v in o)this.r(v,o[v]);r.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,r={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,r),e.allSettings.properties[a]=r,e.applicationSettings.properties[a]=r,e.machineSettings.properties[a]=r,e.machineOverridableSettings.properties[a]=r,e.windowSettings.properties[a]=r,e.resourceSettings.properties[a]=r}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const r=this.a.get(t);let o=r?.value,f=r?.source;u.isUndefined(o)&&(o=a.defaultDefaultValue,f=void 0),u.isUndefined(o)&&(o=h(a.type)),a.default=o,a.defaultValueSource=f}}const D="\\[([^\\]]+)\\]",C=new RegExp(D,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${D})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(p){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let a=C.exec(p);for(;a?.length;){const r=a[1].trim();r&&t.push(r),a=C.exec(p)}}return(0,c.distinct)(t)}e.overrideIdentifiersFromKey=b;function n(p){return p.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=n;function h(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const d=new m;y.Registry.add(e.Extensions.Configuration,d);function S(p,t){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?O.localize(7,null,p):d.getConfigurationProperties()[p]!==void 0?O.localize(8,null,p):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,p,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}e.validateProperty=S;function w(){const p=[],t=d.getConfigurationProperties();for(const a of Object.keys(t))p.push([a,t[a].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=w}),define(Ce[230],De([1,0,19,3,151,4,28,23,12,2,57,129,42]),function(re,e,c,R,u,O,L,A,y,g,T,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function D(a){return Object.isFrozen(a)?a:A.deepFreeze(a)}class C{constructor(r={},o=[],f=[],v){this.b=r,this.c=o,this.d=f,this.raw=v,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(o=>{if(o instanceof C)return o;const f=new b("");return f.parseRaw(o),f.configurationModel});this.f=r.reduce((o,f)=>f===o?f:o.merge(f),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,T.getConfigurationValue)(this.contents,r):this.contents}inspect(r,o){const f=this.rawConfiguration.getValue(r),v=o?this.rawConfiguration.getOverrideValue(r,o):void 0,l=o?this.rawConfiguration.override(o).getValue(r):f;return{value:f,override:v,merged:l}}getOverrideValue(r,o){const f=this.i(o);return f?r?(0,T.getConfigurationValue)(f,r):f:void 0}getKeysForOverrideIdentifier(r){const o=[];for(const f of this.overrides)f.identifiers.includes(r)&&o.push(...f.keys);return c.distinct(o)}getAllOverrideIdentifiers(){const r=[];for(const o of this.overrides)r.push(...o.identifiers);return c.distinct(r)}override(r){let o=this.a.get(r);return o||(o=this.g(r),this.a.set(r,o)),o}merge(...r){const o=A.deepClone(this.contents),f=A.deepClone(this.overrides),v=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const I of r)if(l.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(o,I.contents);for(const E of I.overrides){const[s]=f.filter(i=>c.equals(i.identifiers,E.identifiers));s?(this.h(s.contents,E.contents),s.keys.push(...E.keys),s.keys=c.distinct(s.keys)):f.push(A.deepClone(E))}for(const E of I.keys)v.indexOf(E)===-1&&v.push(E)}return new C(o,v,f,l.every(I=>I instanceof C)?void 0:l)}g(r){const o=this.i(r);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const f={};for(const v of c.distinct([...Object.keys(this.contents),...Object.keys(o)])){let l=this.contents[v];const I=o[v];I&&(typeof l=="object"&&typeof I=="object"?(l=A.deepClone(l),this.h(l,I)):l=I),f[v]=l}return new C(f,this.keys,this.overrides)}h(r,o){for(const f of Object.keys(o)){if(f in r&&y.isObject(r[f])&&y.isObject(o[f])){this.h(r[f],o[f]);continue}r[f]=A.deepClone(o[f])}}i(r){let o=null,f=null;const v=l=>{l&&(f?this.h(f,l):f=A.deepClone(l))};for(const l of this.overrides)c.equals(l.identifiers,[r])?o=l.contents:l.identifiers.includes(r)&&v(l.contents);return v(o),f}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,o){this.j(r,o,!0)}setValue(r,o){this.j(r,o,!1)}removeValue(r){const o=this.keys.indexOf(r);o!==-1&&(this.keys.splice(o,1),(0,T.removeFromValueTree)(this.contents,r),P.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(f=>c.equals(f.identifiers,(0,P.overrideIdentifiersFromKey)(r))),1))}j(r,o,f){(0,T.addToValueTree)(this.contents,r,o,v=>console.error(v)),f=f||this.keys.indexOf(r)===-1,f&&this.keys.push(r),P.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,P.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,T.toValuesTree)(this.contents[r],v=>console.error(v))})}}e.ConfigurationModel=C;class b{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new C}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,o){if(!y.isUndefinedOrNull(r)){const f=this.g(r);this.parseRaw(f,o)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,o){this.a=r;const{contents:f,keys:v,overrides:l,restricted:I,hasExcludedProperties:E}=this.h(r,o);this.b=new C(f,v,l,E?[r]:void 0),this.c=I||[]}g(r){let o={},f=null,v=[];const l=[],I=[];function E(i){Array.isArray(v)?v.push(i):f!==null&&(v[f]=i)}const s={onObjectBegin:()=>{const i={};E(i),l.push(v),v=i,f=null},onObjectProperty:i=>{f=i},onObjectEnd:()=>{v=l.pop()},onArrayBegin:()=>{const i=[];E(i),l.push(v),v=i,f=null},onArrayEnd:()=>{v=l.pop()},onLiteralValue:E,onError:(i,k,F)=>{I.push({error:i,offset:k,length:F})}};if(r)try{u.visit(r,s),o=v[0]||{}}catch(i){console.error(`Error while parsing settings file ${this.f}: ${i}`),this.d=[i]}return o}h(r,o){const f=m.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),v=this.i(r,f,!0,o);r=v.raw;const l=(0,T.toValuesTree)(r,s=>console.error(`Conflict in settings file ${this.f}: ${s}`)),I=Object.keys(r),E=this.j(r,s=>console.error(`Conflict in settings file ${this.f}: ${s}`));return{contents:l,keys:I,overrides:E,restricted:v.restricted,hasExcludedProperties:v.hasExcludedProperties}}i(r,o,f,v){let l=!1;if(!v?.scopes&&!v?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:l};const I={},E=[];for(const s in r)if(P.OVERRIDE_PROPERTY_REGEX.test(s)&&f){const i=this.i(r[s],o,!1,v);I[s]=i.raw,l=l||i.hasExcludedProperties,E.push(...i.restricted)}else{const i=o[s],k=i?typeof i.scope<"u"?i.scope:3:void 0;i?.restricted&&E.push(s),(k===void 0||v.scopes===void 0||v.scopes.includes(k))&&!(v.skipRestricted&&i?.restricted)?I[s]=r[s]:l=!0}return{raw:I,restricted:E,hasExcludedProperties:l}}j(r,o){const f=[];for(const v of Object.keys(r))if(P.OVERRIDE_PROPERTY_REGEX.test(v)){const l={};for(const I in r[v])l[I]=r[v][I];f.push({identifiers:(0,P.overrideIdentifiersFromKey)(v),keys:Object.keys(l),contents:(0,T.toValuesTree)(l,o)})}return f}}e.ConfigurationModelParser=b;class n extends O.Disposable{constructor(r,o,f,v){super(),this.f=r,this.g=o,this.h=v,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.a=new b(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(f.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(R.Event.any(R.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),R.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&f.isEqual(l.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new C}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=n;class h{constructor(r,o,f,v,l,I,E,s,i,k,F,$,j){this.a=r,this.b=o,this.c=f,this.overrideIdentifiers=v,this.d=l,this.f=I,this.g=E,this.h=s,this.i=i,this.j=k,this.k=F,this.l=$,this.m=j}get value(){return D(this.c)}n(r,o,f){const v=r.inspect(o,f);return{get value(){return D(v.value)},get override(){return D(v.override)},get merged(){return D(v.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(r,o,f,v,l=new C,I=new C,E=new L.ResourceMap,s=new C,i=new L.ResourceMap){this.c=r,this.d=o,this.f=f,this.g=v,this.h=l,this.i=I,this.j=E,this.l=s,this.m=i,this.a=null,this.b=new L.ResourceMap,this.n=null}getValue(r,o,f){return this.q(r,o,f).getValue(r)}updateValue(r,o,f={}){let v;f.resource?(v=this.m.get(f.resource),v||(v=new C,this.m.set(f.resource,v))):v=this.l,o===void 0?v.removeValue(r):v.setValue(r,o),f.resource||(this.a=null)}inspect(r,o,f){const v=this.q(r,o,f),l=this.u(o.resource,f),I=o.resource?this.m.get(o.resource)||this.l:this.l,E=new Set;for(const s of v.overrides)for(const i of s.identifiers)v.getOverrideValue(r,i)!==void 0&&E.add(i);return new h(r,o,v.getValue(r),E.size?[...E]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,f?this.i:void 0,l||void 0,I)}keys(r){const o=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,o){this.j.set(r,o),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,o){const f=[];if(!o){const{added:v,updated:l,removed:I}=p(this.c,r);o=[...v,...l,...I]}for(const v of o)for(const l of(0,P.overrideIdentifiersFromKey)(v)){const I=this.c.getKeysForOverrideIdentifier(l),E=r.getKeysForOverrideIdentifier(l),s=[...E.filter(i=>I.indexOf(i)===-1),...I.filter(i=>E.indexOf(i)===-1),...I.filter(i=>!A.equals(this.c.override(l).getValue(i),r.override(l).getValue(i)))];f.push([l,s])}return this.updateDefaultConfiguration(r),{keys:o,overrides:f}}compareAndUpdatePolicyConfiguration(r){const{added:o,updated:f,removed:v}=p(this.d,r),l=[...o,...f,...v];return l.length&&this.updatePolicyConfiguration(r),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:o,updated:f,removed:v,overrides:l}=p(this.applicationConfiguration,r),I=[...o,...f,...v];return I.length&&this.updateApplicationConfiguration(r),{keys:I,overrides:l}}compareAndUpdateLocalUserConfiguration(r){const{added:o,updated:f,removed:v,overrides:l}=p(this.localUserConfiguration,r),I=[...o,...f,...v];return I.length&&this.updateLocalUserConfiguration(r),{keys:I,overrides:l}}compareAndUpdateRemoteUserConfiguration(r){const{added:o,updated:f,removed:v,overrides:l}=p(this.remoteUserConfiguration,r),I=[...o,...f,...v];return I.length&&this.updateRemoteUserConfiguration(r),{keys:I,overrides:l}}compareAndUpdateWorkspaceConfiguration(r){const{added:o,updated:f,removed:v,overrides:l}=p(this.workspaceConfiguration,r),I=[...o,...f,...v];return I.length&&this.updateWorkspaceConfiguration(r),{keys:I,overrides:l}}compareAndUpdateFolderConfiguration(r,o){const f=this.p.get(r),{added:v,updated:l,removed:I,overrides:E}=p(f,o),s=[...v,...l,...I];return(s.length||!f)&&this.updateFolderConfiguration(r,o),{keys:s,overrides:E}}compareAndDeleteFolderConfiguration(r){const o=this.p.get(r);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:f,updated:v,removed:l,overrides:I}=p(o,void 0);return{keys:[...f,...v,...l],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,o,f){let v=this.r(o,f);return o.overrideIdentifier&&(v=v.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(v=v.merge(this.d)),v}r({resource:r},o){let f=this.s();if(o&&r){const v=o.getFolder(r);v&&(f=this.t(v.uri)||f);const l=this.m.get(r);l&&(f=f.merge(l))}return f}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let o=this.b.get(r);if(!o){const f=this.s(),v=this.j.get(r);v?(o=f.merge(v),this.b.set(r,o)):o=f}return o}u(r,o){if(o&&r){const f=o.getFolder(r);if(f)return this.j.get(f.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,o)=>{const{contents:f,overrides:v,keys:l}=this.j.get(o);return r.push([o,{contents:f,overrides:v,keys:l}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(o=>r.add(o)),this.userConfiguration.keys.forEach(o=>r.add(o)),this.i.keys.forEach(o=>r.add(o)),this.j.forEach(o=>o.keys.forEach(f=>r.add(f))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(f=>r.add(f))),[...r.values()]}w(r){const o=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(f=>o.add(f)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(f=>o.add(f)),this.i.getKeysForOverrideIdentifier(r).forEach(f=>o.add(f)),this.j.forEach(f=>f.getKeysForOverrideIdentifier(r).forEach(v=>o.add(v))),[...o.values()]}static parse(r){const o=this.x(r.defaults),f=this.x(r.policy),v=this.x(r.application),l=this.x(r.user),I=this.x(r.workspace),E=r.folders.reduce((s,i)=>(s.set(g.URI.revive(i[0]),this.x(i[1])),s),new L.ResourceMap);return new d(o,f,v,l,new C,I,E,new C,new L.ResourceMap)}static x(r){return new C(r.contents,r.keys,r.overrides)}}e.Configuration=d;function S(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const r=new Set,o=new Map;for(const v of a)v.keys.forEach(l=>r.add(l)),v.overrides.forEach(([l,I])=>{const E=(0,L.getOrSet)(o,l,new Set);I.forEach(s=>E.add(s))});const f=[];return o.forEach((v,l)=>f.push([l,[...v.values()]])),{keys:[...r.values()],overrides:f}}e.mergeChanges=S;class w{constructor(r,o,f,v){this.change=r,this.f=o,this.g=f,this.h=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of r.keys)this.affectedKeys.add(l);for(const[,l]of r.overrides)for(const I of l)this.affectedKeys.add(I);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(r,o){const f=this.a+r,v=this.d.indexOf(f);if(v<0)return!1;const l=v+f.length;if(l>=this.d.length)return!1;const I=this.d.charCodeAt(l);if(I!==this.b&&I!==this.c)return!1;if(o){const E=this.previousConfiguration?this.previousConfiguration.getValue(r,o,this.f?.workspace):void 0,s=this.g.getValue(r,o,this.h);return!A.equals(E,s)}return!0}}e.ConfigurationChangeEvent=w;function p(a,r){const{added:o,removed:f,updated:v}=t(r?.rawConfiguration,a?.rawConfiguration),l=[],I=a?.getAllOverrideIdentifiers()||[],E=r?.getAllOverrideIdentifiers()||[];if(r){const s=E.filter(i=>!I.includes(i));for(const i of s)l.push([i,r.getKeysForOverrideIdentifier(i)])}if(a){const s=I.filter(i=>!E.includes(i));for(const i of s)l.push([i,a.getKeysForOverrideIdentifier(i)])}if(r&&a){for(const s of I)if(E.includes(s)){const i=t({contents:a.getOverrideValue(void 0,s)||{},keys:a.getKeysForOverrideIdentifier(s)},{contents:r.getOverrideValue(void 0,s)||{},keys:r.getKeysForOverrideIdentifier(s)});l.push([s,[...i.added,...i.removed,...i.updated]])}}return{added:o,removed:f,updated:v,overrides:l}}function t(a,r){const o=a?r?a.keys.filter(l=>r.keys.indexOf(l)===-1):[...a.keys]:[],f=r?a?r.keys.filter(l=>a.keys.indexOf(l)===-1):[...r.keys]:[],v=[];if(a&&r){for(const l of r.keys)if(a.keys.indexOf(l)!==-1){const I=(0,T.getConfigurationValue)(r.contents,l),E=(0,T.getConfigurationValue)(a.contents,l);A.equals(I,E)||v.push(l)}}return{added:o,removed:f,updated:v}}}),define(Ce[130],De([1,0,8,5]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var u;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(u||(e.RemoteConnectionType=u={}));class O{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=O;class L{constructor(P,m){this.host=P,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=L;var A;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(A||(e.RemoteAuthorityResolverErrorCode=A={}));class y extends c.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof y&&P._code===A.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof y&&P._code===A.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof y&&P._code===A.NoResolverFound}static isHandled(P){return P instanceof y&&P.isHandled}constructor(P,m=A.Unknown,D){super(P),this._message=P,this._code=m,this._detail=D,this.isHandled=m===A.NotAvailable&&D===!0,Object.setPrototypeOf(this,y.prototype)}}e.RemoteAuthorityResolverError=y;function g(T){const P=T.indexOf("+");return P===-1?T:T.substring(0,P)}e.getRemoteAuthorityPrefix=g}),define(Ce[78],De([1,0,18]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(g){return g.scheme===c.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=R;function u(g){if(!g)return;const T=g.indexOf("+");return T<0?g:g.substr(0,T)}e.getRemoteName=u;function O(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.getRemoteServerRootPath=O;function L(g){const{host:T,port:P}=y(g);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:T,port:P}}e.parseAuthorityWithPort=L;function A(g,T){let{host:P,port:m}=y(g);return typeof m>"u"&&(m=T),{host:P,port:m}}e.parseAuthorityWithOptionalPort=A;function y(g){const T=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(T)return{host:T[1],port:parseInt(T[2],10)};const P=g.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const m=g.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:g,port:void 0}}}),define(Ce[26],De([1,0,11,5,78]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(L||(e.ExtensionType=L={}));var A;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class y{constructor(n){this.value=n,this._lower=n.toLowerCase()}static equals(n,h){if(typeof n>"u"||n===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof n=="string"||typeof h=="string"){const d=typeof n=="string"?n:n.value,S=typeof h=="string"?h:h.value;return c.equalsIgnoreCase(d,S)}return n._lower===h._lower}static toKey(n){return typeof n=="string"?n.toLowerCase():n._lower}}e.ExtensionIdentifier=y;class g{get size(){return this.c.size}constructor(n){if(this.c=new Set,n)for(const h of n)this.add(h)}add(n){this.c.add(y.toKey(n))}delete(n){return this.c.delete(y.toKey(n))}has(n){return this.c.has(y.toKey(n))}}e.ExtensionIdentifierSet=g;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(n){this.c.delete(y.toKey(n))}get(n){return this.c.get(y.toKey(n))}has(n){return this.c.has(y.toKey(n))}set(n,h){this.c.set(y.toKey(n),h)}values(){return this.c.values()}forEach(n){this.c.forEach(n)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=T;function P(b){return m(b)}e.isApplicationScopedExtension=P;function m(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function D(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=D;function C(b,n){if(n){const h=`onResolveRemoteAuthority:${(0,u.getRemoteName)(n)}`;return!!b.activationEvents?.includes(h)}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[131],De([1,0,8,26]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class u{constructor(){this.a=new Map,this.b=new WeakMap}register(L,A){this.a.set(L,A)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const A=Object.create(null);for(const y of L){const g=this.readActivationEvents(y);g.length>0&&(A[R.ExtensionIdentifier.toKey(y.identifier)]=g)}return A}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const A=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];if(!L.contributes)return A;for(const y in L.contributes){const g=this.a.get(y);if(!g)continue;const T=L.contributes[y],P=Array.isArray(T)?T:[T];try{g(P,A)}catch(m){(0,c.onUnexpectedError)(m)}}return A}}e.ImplicitActivationEventsImpl=u,e.ImplicitActivationEvents=new u}),define(Ce[231],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class c{constructor(){this.b=new Map}async createNewMessage(u){try{const O=await this.c();if(O){const L=String(c.a++);return this.b.set(L,O),{id:L,data:O.createNewMessage(u)}}}catch{}return{id:"",data:u}}async validate(u,O){if(!u.id)return!0;const L=this.b.get(u.id);if(!L)return!1;this.b.delete(u.id);try{return L.validate(O)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(u){try{return await this.d(u)}catch{}return u}}e.AbstractSignService=c,c.a=1}),define(Ce[232],De([1,0,231]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R extends c.AbstractSignService{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(L=>new L.signer().sign(O))}h(){return new Promise((O,L)=>re(["vsda"],O,L))}}e.SignService=R}),define(Ce[233],De([1,0,9,39,33]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(y){if(c.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function L(y,g,T,P,m,D,C,b){const n=Object.create(null);n["common.machineId"]=D,n.sessionID=(0,u.generateUuid)()+Date.now(),n.commitHash=P,n.version=m,n["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),n["common.platform"]=(0,c.PlatformToString)(c.platform),n["common.nodePlatform"]=R.platform,n["common.nodeArch"]=T,n["common.product"]=b||"desktop",C&&(n["common.msftInternal"]=C);let h=0;const d=Date.now();Object.defineProperties(n,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),c.isLinuxSnap&&(n["common.snap"]="true");const S=O(g);return S&&(n["common.platformDetail"]=S),n}e.resolveCommonProperties=L;function A(y){const g=R.env.USERDNSDOMAIN;if(!g)return!1;const T=g.toLowerCase();return y.some(P=>T===P)}e.verifyMicrosoftInternalDomain=A}),define(Ce[234],De([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var u;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(u||(e.TelemetryConfiguration=u={}))}),define(Ce[79],De([1,0,23,12,3,57,78,233,234]),function(re,e,c,R,u,O,L,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class g{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=g;class T{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class P{async publicLog(f,v,l){}async publicLogError(f,v,l){}}e.NullEndpointTelemetryService=P,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(o,f){return u.Event.debounce(f.onDidChangeConfiguration,(l,I)=>{const E=l?new Set([...l.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:E}},1e3,!0)(l=>{l.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,O.ConfigurationTargetToString)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.configurationTelemetry=m;function D(o,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!o.enableTelemetry||f.extensionTestsLocationURI)}e.supportsTelemetry=D;function C(o,f){return!(f.isBuilt||f.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=C;function b(o){const f=o.getValue(y.TELEMETRY_SETTING_ID),v=o.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||v===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=b;function n(o){const f={},v={},l={};S(o,l);for(let I in l){I=I.length>150?I.substr(I.length-149):I;const E=l[I];typeof E=="number"?v[I]=E:typeof E=="boolean"?v[I]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${E.length}`),f[I]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(f[I]=E)}return{properties:f,measurements:v}}e.validateTelemetryData=n;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(o){if(!o)return"none";const f=(0,L.getRemoteName)(o);return h.has(f)?f:"other"}e.cleanRemoteAuthority=d;function S(o,f,v=0,l){if(o)for(const I of Object.getOwnPropertyNames(o)){const E=o[I],s=l?l+I:I;Array.isArray(E)?f[s]=(0,c.safeStringify)(E):E instanceof Date?f[s]=E.toISOString():(0,R.isObject)(E)?v<2?S(E,f,v+1,s+"."):f[s]=(0,c.safeStringify)(E):f[s]=E}}function w(o,f){const v=o.msftInternalDomains||[],l=f.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(v)||l}e.isInternalTelemetry=w;function p(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=p;function t(o,f){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let v=o;const l=[];for(const i of f)for(;;){const k=i.exec(o);if(!k)break;l.push([k.index,i.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(v="";;){const i=E.exec(o);if(!i)break;const k=l.some(([F,$])=>i.index<$&&F<E.lastIndex);!I.test(i[0])&&!k&&(v+=o.substring(s,i.index)+"<REDACTED: user-file-path>",s=E.lastIndex)}return s<o.length&&(v+=o.substr(s)),v}function a(o){if(!o)return o;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const v of f)if(v.regex.test(o))return`<REDACTED: ${v.label}>`;return o}function r(o,f){return(0,c.cloneAndChange)(o,v=>{if(v instanceof g||Object.hasOwnProperty.call(v,"isTrustedTelemetryValue"))return v.value;if(typeof v=="string"){let l=v.replaceAll("%20"," ");l=t(l,f);for(const I of f)l=l.replace(I,"");return l=a(l),l}})}e.cleanData=r}),define(Ce[235],De([1,0,11,125,26,9,2,8,39,79]),function(re,e,c,R,u,O,L,A,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(r,o){return r.uuid&&o.uuid?r.uuid===o.uuid:r.id===o.id?!0:(0,c.compareIgnoreCase)(r.id,o.id)===0}e.areSameExtensions=T;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(o){const f=o.manifest?o.manifest.version:o.version,v=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new m(o.identifier,f,v)}static parse(o){const f=P.exec(o);return f&&f[1]&&f[2]?new m({id:f[1]},f[2],f[4]||void 0):null}constructor(o,f,v="undefined"){this.version=f,this.targetPlatform=v,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof m?T(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=m;const D=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(r){const o=D.exec(r);return o&&o[1]?[n(o[1]),o[2]]:[n(r),void 0]}e.getIdAndVersion=C;function b(r,o){return`${r}.${o}`}e.getExtensionId=b;function n(r){return r.toLowerCase()}e.adoptToGalleryExtensionId=n;function h(r,o){return n(b(r??u.UNDEFINED_PUBLISHER,o))}e.getGalleryExtensionId=h;function d(r,o){const f=[],v=l=>{for(const I of f)if(I.some(E=>T(o(E),o(l))))return I;return null};for(const l of r){const I=v(l);I?I.push(l):f.push([l])}return f}e.groupByExtension=d;function S(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function w(r){return{id:new g.TelemetryTrustedValue(r.identifier.id),name:new g.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new u.ExtensionIdentifier("pprice.better-merge");function p(r,o){const f=[],v=o.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const l=v.shift();if(l&&f.every(I=>!T(I.identifier,{id:l}))){const I=r.filter(E=>T(E.identifier,{id:l}));I.length===1&&(f.push(I[0]),v.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=p;async function t(r,o){if(!O.isLinux)return!1;let f;try{f=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{f=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){o.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(l))}}return!!f&&(f.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(r,o){const f=await t(r,o),v=(0,R.getTargetPlatform)(f?"alpine":O.platform,y.arch);return o.debug("ComputeTargetPlatform:",v),v}e.computeTargetPlatform=a}),define(Ce[236],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function c(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=c;function R(y){return y?[...y.entries()]:[]}e.serializeEnvironmentDescriptionMap=R;function u(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=u;function O(y){return new Map(y??[])}e.deserializeEnvironmentDescriptionMap=O;function L(y){return Array.from(y.entries()).map(g=>[g[0],c(g[1].map),R(g[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=L;function A(y){return new Map(y.map(g=>[g[0],{map:u(g[1]),descriptionMap:O(g[2])}]))}e.deserializeEnvironmentVariableCollections=A}),define(Ce[237],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(u){this.b=u,this.a=new Map}dispose(){for(const u of this.a.values())u.dispose()}startBuffering(u,O,L=5){const A=O(y=>{const g=typeof y=="string"?y:y.data;let T=this.a.get(u);if(T){T.data.push(g);return}const P=setTimeout(()=>this.flushBuffer(u),L);T={data:[g],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(u),A.dispose()}},this.a.set(u,T)});return A}stopBuffering(u){this.a.get(u)?.dispose()}flushBuffer(u){const O=this.a.get(u);O&&(this.a.delete(u),this.b(u,O.data.join("")))}}e.TerminalDataBufferer=c}),define(Ce[238],De([1,0,16,72,55,3,12,2,186,99,42]),function(re,e,c,R,u,O,L,A,y,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var P;(function(w){function p(t,a){let r=t.defaults;for(;u.ThemeIcon.isThemeIcon(r);){const o=C.getIcon(r.id);if(!o)return;r=o.defaults}return r}w.getDefinition=p})(P||(e.IconContribution=P={}));var m;(function(w){function p(a){return{weight:a.weight,style:a.style,src:a.src.map(r=>({format:r.format,location:r.location.toString()}))}}w.toJSONObject=p;function t(a){const r=o=>(0,L.isString)(o)?o:void 0;if(a&&Array.isArray(a.src)&&a.src.every(o=>(0,L.isString)(o.format)&&(0,L.isString)(o.location)))return{weight:r(a.weight),style:r(a.style),src:a.src.map(o=>({format:o.format,location:A.URI.parse(o.location)}))}}w.fromJSONObject=t})(m||(e.IconFontDefinition=m={}));class D{constructor(){this.a=new O.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${u.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,t,a,r){const o=this.b[p];if(o){if(a&&!o.description){o.description=a,this.d.properties[p].markdownDescription=`${a} $(${p})`;const l=this.e.enum.indexOf(p);l!==-1&&(this.e.enumDescriptions[l]=a),this.a.fire()}return o}const f={id:p,description:a,defaults:t,deprecationMessage:r};this.b[p]=f;const v={$ref:"#/definitions/icons"};return r&&(v.deprecationMessage=r),a&&(v.markdownDescription=`${a}: $(${p})`),this.d.properties[p]=v,this.e.enum.push(p),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const t=this.e.enum.indexOf(p);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,t){const a=this.f[p];return a||(this.f[p]=t,this.a.fire(),t)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(o,f)=>o.id.localeCompare(f.id),t=o=>{for(;u.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(o=>this.b[o]);for(const o of r.filter(f=>!!f.description).sort(p))a.push(`|<i class="${t(o)}"></i>|${o.id}|${u.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const o of r.filter(f=>!u.ThemeIcon.isThemeIcon(f.defaults)).sort(p))a.push(`|<i class="${t(o)}"></i>|${o.id}|`);return a.join(`
`)}}const C=new D;T.Registry.add(e.Extensions.IconContribution,C);function b(w,p,t,a){return C.registerIcon(w,p,t,a)}e.registerIcon=b;function n(){return C}e.getIconRegistry=n;function h(){const w=(0,R.getCodiconFontCharacters)();for(const p in w){const t="\\"+w[p].toString(16);C.registerIcon(p,{fontCharacter:t})}}h(),e.iconsSchemaId="vscode://schemas/icons";const d=T.Registry.as(g.Extensions.JSONContribution);d.registerSchema(e.iconsSchemaId,C.getIconSchema());const S=new c.RunOnceScheduler(()=>d.notifySchemaChanged(e.iconsSchemaId),200);C.onDidChange(()=>{S.isScheduled()||S.schedule()}),e.widgetClose=b("widget-close",R.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=b("goto-previous-location",R.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=b("goto-next-location",R.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=u.ThemeIcon.modify(R.Codicon.sync,"spin"),e.spinningLoading=u.ThemeIcon.modify(R.Codicon.loading,"spin")}),define(Ce[132],De([1,0,3,57,5,17]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,u.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,u.createDecorator)("sharedTunnelsService");var L;(function(b){b.Http="http",b.Https="https"})(L||(e.TunnelProtocol=L={}));var A;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(A||(e.TunnelPrivacyId=A={}));var y;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function g(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(n)return{address:n[1],port:+n[2]}}e.extractLocalHostUriMetaDataForPortMapping=g,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function T(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=T,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=P;function m(b,n,h,d){if(h===1)return!1;if(h===2&&P(n)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(S?.length===4&&parseInt(S[1])>=18)return!1}return b<1024}e.isPortPrivileged=m;class D{constructor(n,h,d){this.remoteAddress=n,this.localAddress=h,this.b=d,this.a=new c.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=D;let C=e.AbstractTunnelService=class{constructor(n,h){this.i=n,this.j=h,this.a=new c.Emitter,this.onTunnelOpened=this.a.event,this.b=new c.Emitter,this.onTunnelClosed=this.b.event,this.c=new c.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const n=this.j.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.e=n,n?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.f=n.elevation,this.g=n.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const n=[],h=Array.from(this.d.values());for(const d of h){const S=Array.from(d.values());for(const w of S){const p=await w.value;p&&n.push(p)}}return n}async dispose(){for(const n of this.d.values()){for(const{value:h}of n.values())await h.then(d=>d?.dispose());n.clear()}this.d.clear()}setEnvironmentTunnel(n,h,d,S,w){this.o(n,h,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:h,localAddress:d,privacy:S,protocol:w,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,h){(P(n)||T(n))&&(n=e.LOCALHOST_ADDRESSES[0]);const d=this.q(n,h);if(d)return++d.refcount,d.value}openTunnel(n,h,d,S,w,p=!1,t,a){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${d} on local port ${w}.`),!n)return;if(h||(h="localhost"),S||(S=this.k),this.e&&this.h.has(d)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(n,h,d,S,w,p,t,a);return r?r.then(o=>{if(!o){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,d);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.m(o);return(o.tunnelRemoteHost!==h||o.tunnelRemotePort!==d)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),t&&o.privacy!==t&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const h=this.d.get(n.tunnelRemoteHost);if(h){const d=h.get(n.tunnelRemotePort);d&&(d.refcount--,await this.n(n.tunnelRemoteHost,n.tunnelRemotePort,d))}}}}async n(n,h,d){if(d.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${h}.`);const S=d.value.then(async w=>{w&&(await w.dispose(!0),this.b.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this.d.has(n)&&this.d.get(n).delete(h),S}}async closeTunnel(n,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${h} `);const d=this.d.get(n);if(d&&d.has(h)){const S=d.get(h);S.refcount=0,await this.n(n,h,S)}}o(n,h,d){this.d.has(n)||this.d.set(n,new Map),this.d.get(n).set(h,{refcount:1,value:d})}async p(n,h){const d=this.d.get(n);d&&(await d.get(h)||d.delete(h),d.size===0&&this.d.delete(n))}q(n,h){const d=[n];T(n)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):P(n)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const S=d.map(w=>this.d.get(w));for(const w of S){const p=w?.get(h);if(p)return p}}canTunnel(n){return!!g(n)}s(n,h,d,S,w,p,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${d} on local port ${S}.`);const a=d;this.h.add(a);const r=S===void 0?d:S,o={elevationRequired:w?this.isPortPrivileged(r):!1},f={remoteAddress:{host:h,port:d},localAddressPort:S,privacy:p,public:p?p!==A.Private:void 0,protocol:t},v=n.forwardPort(f,o);return v?(this.o(h,d,v),v.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(a)})):this.h.delete(a),v}};e.AbstractTunnelService=C=qe([je(0,O.ILogService),je(1,R.IConfigurationService)],C)}),define(Ce[239],De([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var R;(function(u){u[u.Complete=100]="Complete",u[u.Partial=50]="Partial",u[u.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(Ce[240],De([1,0,18]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function R(y){return y.scheme!==c.Schemas.file&&y.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=R;function u(y){if(y.folders.length)return y.folders.every(g=>R(g.uri))?y.folders[0].uri:void 0;if(y.configuration&&R(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=u;function O(y){return u(y)?.scheme}e.getVirtualWorkspaceScheme=O;function L(y){return u(y)?.authority}e.getVirtualWorkspaceAuthority=L;function A(y){return u(y)!==void 0}e.isVirtualWorkspace=A}),define(Ce[49],De([1,0,187,10,71,24,2,5,18]),function(re,e,c,R,u,O,L,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function g(o){const f=o;return typeof f?.id=="string"&&L.URI.isUri(f.uri)}e.isSingleFolderWorkspaceIdentifier=g;function T(o){return typeof o?.id=="string"&&!g(o)&&!m(o)}e.isEmptyWorkspaceIdentifier=T,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function P(o,f){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,R.basename)(o)}:f?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const v=o;return v.configuration?{id:v.id,configPath:v.configuration}:v.folders.length===1?{id:v.id,uri:v.folders[0].uri}:{id:v.id}}e.toWorkspaceIdentifier=P;function m(o){const f=o;return typeof f?.id=="string"&&L.URI.isUri(f.configPath)}e.isWorkspaceIdentifier=m;function D(o){const f=o;if(f?.uri)return{id:f.id,uri:L.URI.revive(f.uri)};const v=o;if(v?.configPath)return{id:v.id,configPath:L.URI.revive(v.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=D;var C;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(C||(e.WorkbenchState=C={}));function b(o){const f=o;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=b;function n(o){const f=o;return!!(f&&typeof f=="object"&&L.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=n;class h{constructor(f,v,l,I,E){this.h=f,this.j=l,this.k=I,this.l=E,this.c=u.TernarySearchTree.forUris(this.l,()=>!0),this.folders=v}update(f){this.h=f.id,this.k=f.configuration,this.j=f.transient,this.l=f.l,this.folders=f.folders}get folders(){return this.g}set folders(f){this.g=f,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(f){this.k=f}getFolder(f){return f&&this.c.findSubstr(f)||null}n(){this.c=u.TernarySearchTree.forUris(this.l,()=>!0);for(const f of this.folders)this.c.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class d{constructor(f,v){this.raw=v,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,O.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function S(o){return new d({uri:o,index:0,name:(0,O.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(o,f){return O.extUriBiasedIgnorePathCase.isEqualOrParent(o,f.untitledWorkspacesHome)}e.isUntitledWorkspace=w;function p(o){let f;return L.URI.isUri(o)?f=o:f=o.configuration,f?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=p,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(o){return o.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function a(o,f){return!w(o,f)&&!p(o)}e.isSavedWorkspace=a;function r(o){return(typeof o=="string"?(0,R.extname)(o):(0,O.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Ce[80],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(u){this.d=u,this.b=new Map,this.c=1}add(u){const O=this.c++;return this.b.set(O,u),this.e(),O}get(u,O){return this.b.has(u)?this.b.get(u)[O]:void 0}delete(u){this.b.delete(u),this.e()}e(){c.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=c,c.a=!1}),define(Ce[50],De([1,0,18,24,5]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class O{constructor(){this.a=new Set(Object.keys(c.Schemas)),this.b=new Map,this.extUri=new R.ExtUri(A=>{const y=this.b.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this.b.delete(A.scheme):this.b.set(A.scheme,y)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=O,e.IExtHostFileSystemInfo=(0,u.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[27],De([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(Ce[241],De([1,0,192,17,225,27]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=e.ExtHostLogService=class extends u.LogService{constructor(y,g,T){const P=T.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",m=T.remote.isRemote?(0,c.localize)(0,null):y?(0,c.localize)(1,null):(0,c.localize)(2,null);super(g.createLogger(P,{name:m}))}};e.ExtHostLogService=L=qe([je(1,R.ILoggerService),je(2,O.IExtHostInitDataService)],L)}),define(Ce[242],De([1,0,16]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(L,A,y){this.h=new Map,this.a=L,this.b=A,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new c.RunOnceScheduler(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of g.values())T.complete()}catch(T){for(const P of g.values())P.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,A){let y=this.f[L];return typeof y>"u"&&(y=A),y}update(L,A){this.f[L]=A;const y=this.h.get(L);if(y!==void 0)return y.p;const g=new c.DeferredPromise;return this.h.set(L,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.ExtensionMemento=R;class u extends R{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,A){super(L.identifier.value,!0,A),this.j=L}}e.ExtensionGlobalMemento=u}),define(Ce[243],De([1,0,3,2]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class u{constructor(L){this.c=L,this.a=new c.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new c.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,A,y,g){const P=this.c.getNotebookDocument(R.URI.revive(L)).acceptModelChanged(A.value,y,g);this.b.fire(P)}$acceptDirtyStateChanged(L,A){this.c.getNotebookDocument(R.URI.revive(L)).acceptDirty(A)}$acceptModelSaved(L){const A=this.c.getNotebookDocument(R.URI.revive(L));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=u}),define(Ce[20],De([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class R{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.ExtHostRpcService=R});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,R,u){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Ne=this&&this.__classPrivateFieldGet||function(re,e,c,R){if(c==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?R:c==="a"?R.call(re):R?R.value:e.get(re)};define(Ce[244],De([1,0,26,3]),function(re,e,c,R){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class O{constructor(A,y){u.set(this,void 0),this.b=new R.Emitter,this.onDidChange=this.b.event,this.a=c.ExtensionIdentifier.toKey(A.identifier),Ze(this,u,y,"f"),Ne(this,u,"f").onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(A){return Ne(this,u,"f").get(this.a,A)}store(A,y){return Ne(this,u,"f").store(this.a,A,y)}delete(A){return Ne(this,u,"f").delete(this.a,A)}}e.ExtensionSecrets=O,u=new WeakMap}),define(Ce[58],De([1,0,5,132,3,20]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var L;(function(y){function g(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?R.TunnelPrivacyId.Public:R.TunnelPrivacyId.Private),protocol:P.protocol}}y.fromApiTunnel=g;function T(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==R.TunnelPrivacyId.ConstantPrivate&&P.privacy!==R.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}y.fromServiceTunnel=T})(L||(e.TunnelDtoConverter=L={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let A=e.ExtHostTunnelService=class{constructor(g){this.onDidChangeTunnels=new u.Emitter().event}async $applyCandidateFilter(g){return g}async openTunnel(g,T){}async getTunnels(){return[]}async setTunnelFactory(g){return{dispose:()=>{}}}registerPortsAttributesProvider(g,T){return{dispose:()=>{}}}async $providePortAttributes(g,T,P,m,D){return[]}async $forwardPort(g,T){}async $closeTunnel(g){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};e.ExtHostTunnelService=A=qe([je(0,O.IExtHostRpcService)],A)}),define(Ce[59],De([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class R{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.URITransformerService=R}),define(Ce[245],De([1,0,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(y){let g=this.buffers.indexOf(y);return g<0&&(g=this.buffers.length,this.buffers.push(y)),g}}function u(A,y){if(y.serializeBuffersForPostMessage){const g=new R,P=JSON.stringify(A,(D,C)=>{if(C instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(C)};if(ArrayBuffer.isView(C)){const b=O(C);if(b)return{$$vscode_array_buffer_reference$$:!0,index:g.add(C.buffer),view:{type:b,byteLength:C.byteLength,byteOffset:C.byteOffset}}}return C}),m=g.buffers.map(D=>{const C=new Uint8Array(D);return c.VSBuffer.wrap(C)});return{message:P,buffers:m}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=u;function O(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function L(A,y){const g=y.map(m=>{const D=new ArrayBuffer(m.byteLength);return new Uint8Array(D).set(m.buffer),D}),T=y.length?(m,D)=>{if(D&&typeof D=="object"&&D.$$vscode_array_buffer_reference$$){const C=D,{index:b}=C,n=g[b];if(C.view)switch(C.view.type){case 1:return new Int8Array(n,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(n,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(n,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(n,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(n,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(n,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(n,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(n,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(n,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(n,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(n,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return n}return D}:void 0;return{message:JSON.parse(A,T),arrayBuffers:g}}e.deserializeWebviewMessage=L}),define(Ce[246],De([1,0,100,347,348,2,349]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function A(P,m,D,C,b,n){const h=n.environment.useHostProxy,d=typeof h=="boolean"?h:!n.remote.isRemote,S=(0,L.createProxyResolver)({resolveProxy:p=>P.resolveProxy(p),getHttpProxySetting:()=>m.getConfiguration("http").get("proxy"),log:(p,t,...a)=>{switch(p){case L.LogLevel.Trace:C.trace(t,...a);break;case L.LogLevel.Debug:C.debug(t,...a);break;case L.LogLevel.Info:C.info(t,...a);break;case L.LogLevel.Warning:C.warn(t,...a);break;case L.LogLevel.Error:C.error(t,...a);break;case L.LogLevel.Critical:C.error(t,...a);break;case L.LogLevel.Off:break;default:r(p,t,a);break}function r(o,f,...v){C.error("Unknown log level",o),C.error(f,...v)}},getLogLevel:()=>C.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:d,env:process.env}),w=y(m,S);return T(D,w)}e.connectProxyResolver=A;function y(P,m){const D={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(b=>{D.config=P.getConfiguration("http").get("proxySupport")||"off"});const C={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(b=>{C.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,L.createHttpPatch)(c,m,{config:"off"},C,!0)),on:Object.assign({},c,(0,L.createHttpPatch)(c,m,{config:"on"},C,!0)),override:Object.assign({},c,(0,L.createHttpPatch)(c,m,{config:"override"},C,!0)),onRequest:Object.assign({},c,(0,L.createHttpPatch)(c,m,D,C,!0)),default:Object.assign(c,(0,L.createHttpPatch)(c,m,D,C,!1))},https:{off:Object.assign({},R,(0,L.createHttpPatch)(R,m,{config:"off"},C,!0)),on:Object.assign({},R,(0,L.createHttpPatch)(R,m,{config:"on"},C,!0)),override:Object.assign({},R,(0,L.createHttpPatch)(R,m,{config:"override"},C,!0)),onRequest:Object.assign({},R,(0,L.createHttpPatch)(R,m,D,C,!0)),default:Object.assign(R,(0,L.createHttpPatch)(R,m,D,C,!1))},tls:Object.assign(u,(0,L.createTlsPatch)(u))}}const g=new Map;function T(P,m){return P.getExtensionPathIndex().then(D=>{const C=globalThis._VSCODE_NODE_MODULES.module,b=C._load;C._load=function(h,d,S){if(h==="tls")return m.tls;if(h!=="http"&&h!=="https")return b.apply(this,arguments);const w=m[h],p=D.findSubstr(O.URI.file(d.filename));let t=g.get(p);if(t||g.set(p,t={}),!t[h]){const a=w.default;t[h]={...a}}return t[h]}})}}),define(Ce[247],De([1,0,118]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function R(O){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:O,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function u(O){return new c.URITransformer(R(O))}e.createURITransformer=u}),define(Ce[133],De([1,0,201,12,2,4,5,42,31,18,46,171,41]),function(re,e,c,R,u,O,L,A,y,g,T,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var D;(function(q){q[q.PROGRAMMATIC=1]="PROGRAMMATIC",q[q.USER=2]="USER",q[q.EDIT=3]="EDIT",q[q.NAVIGATION=4]="NAVIGATION",q[q.JUMP=5]="JUMP"})(D||(e.EditorPaneSelectionChangeReason=D={}));var C;(function(q){q[q.IDENTICAL=1]="IDENTICAL",q[q.SIMILAR=2]="SIMILAR",q[q.DIFFERENT=3]="DIFFERENT"})(C||(e.EditorPaneSelectionCompareResult=C={}));function b(q){const ae=q;return!!ae&&typeof ae.getSelection=="function"&&!!ae.onDidChangeSelection}e.isEditorPaneWithSelection=b;function n(q,ae,Ee){for(const ye of Ee.visibleEditorPanes)if(ye.group.id===ae&&q.matches(ye.input))return ye.getViewState()}e.findViewStateForEditor=n;function h(q){if(v(q))return!1;const ae=q;return u.URI.isUri(ae?.resource)}e.isResourceEditorInput=h;function d(q){if(v(q))return!1;const ae=q;return ae?.original!==void 0&&ae.modified!==void 0}e.isResourceDiffEditorInput=d;function S(q){if(v(q)||d(q))return!1;const ae=q;return ae?.primary!==void 0&&ae.secondary!==void 0}e.isResourceSideBySideEditorInput=S;function w(q){if(v(q))return!1;const ae=q;return ae?ae.resource===void 0||ae.resource.scheme===g.Schemas.untitled||ae.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=w;function p(q){if(v(q))return!1;const ae=q;return u.URI.isUri(ae?.base?.resource)&&u.URI.isUri(ae?.input1?.resource)&&u.URI.isUri(ae?.input2?.resource)&&u.URI.isUri(ae?.result?.resource)}e.isResourceMergeEditorInput=p;var t;(function(q){q[q.SHORT=0]="SHORT",q[q.MEDIUM=1]="MEDIUM",q[q.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var a;(function(q){q[q.EXPLICIT=1]="EXPLICIT",q[q.AUTO=2]="AUTO",q[q.FOCUS_CHANGE=3]="FOCUS_CHANGE",q[q.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class r{constructor(){this.a=new Map}registerSource(ae,Ee){let ye=this.a.get(ae);return ye||(ye={source:ae,label:Ee},this.a.set(ae,ye)),ye.source}getSourceLabel(ae){return this.a.get(ae)?.label??ae}}e.SaveSourceRegistry=new r;var o;(function(q){q[q.None=0]="None",q[q.Readonly=2]="Readonly",q[q.Untitled=4]="Untitled",q[q.Singleton=8]="Singleton",q[q.RequiresTrust=16]="RequiresTrust",q[q.CanSplitInGroup=32]="CanSplitInGroup",q[q.ForceDescription=64]="ForceDescription",q[q.CanDropIntoEditor=128]="CanDropIntoEditor",q[q.MultipleEditors=256]="MultipleEditors",q[q.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class f extends O.Disposable{}e.AbstractEditorInput=f;function v(q){return q instanceof f}e.isEditorInput=v;function l(q){const ae=q;return u.URI.isUri(ae?.preferredResource)}function I(q){const ae=q;return v(ae?.primary)&&v(ae?.secondary)}e.isSideBySideEditorInput=I;function E(q){const ae=q;return v(ae?.modified)&&v(ae?.original)}e.isDiffEditorInput=E;function s(q,ae,Ee,ye,be){return Z(ye,[(0,P.toAction)({id:"workbench.action.openLargeFile",label:(0,c.localize)(2,null),run:()=>{const M={...Ee,limits:{size:Number.MAX_VALUE}};q.openEditor(ae,M)}}),(0,P.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,c.localize)(3,null),run:()=>be.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.createTooLargeFileError=s;function i(q){return v(q?.editor)}e.isEditorInputWithOptions=i;function k(q){const ae=q;return i(q)&&ae?.group!==void 0}e.isEditorInputWithOptionsAndGroup=k;function F(q){const ae=q;return typeof ae?.groupId=="number"&&v(ae.editor)}e.isEditorIdentifier=F;var $;(function(q){q[q.UNKNOWN=0]="UNKNOWN",q[q.REPLACE=1]="REPLACE",q[q.MOVE=2]="MOVE",q[q.UNPIN=3]="UNPIN"})($||(e.EditorCloseContext=$={}));var j;(function(q){q[q.GROUP_ACTIVE=0]="GROUP_ACTIVE",q[q.GROUP_INDEX=1]="GROUP_INDEX",q[q.GROUP_LOCKED=2]="GROUP_LOCKED",q[q.EDITOR_OPEN=3]="EDITOR_OPEN",q[q.EDITOR_CLOSE=4]="EDITOR_CLOSE",q[q.EDITOR_MOVE=5]="EDITOR_MOVE",q[q.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",q[q.EDITOR_LABEL=7]="EDITOR_LABEL",q[q.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",q[q.EDITOR_PIN=9]="EDITOR_PIN",q[q.EDITOR_STICKY=10]="EDITOR_STICKY",q[q.EDITOR_DIRTY=11]="EDITOR_DIRTY",q[q.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var W;(function(q){q[q.PRIMARY=1]="PRIMARY",q[q.SECONDARY=2]="SECONDARY",q[q.BOTH=3]="BOTH",q[q.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class U{getOriginalUri(ae,Ee){if(!ae)return;if(p(ae))return e.EditorResourceAccessor.getOriginalUri(ae.result,Ee);if(Ee?.supportSideBySide){const{primary:be,secondary:M}=this.a(ae);if(be&&M){if(Ee?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(be,{filterByScheme:Ee.filterByScheme}),secondary:this.getOriginalUri(M,{filterByScheme:Ee.filterByScheme})};if(Ee?.supportSideBySide===W.ANY)return this.getOriginalUri(be,{filterByScheme:Ee.filterByScheme})??this.getOriginalUri(M,{filterByScheme:Ee.filterByScheme});ae=Ee.supportSideBySide===W.PRIMARY?be:M}}if(d(ae)||S(ae)||p(ae))return;const ye=l(ae)?ae.preferredResource:ae.resource;return!ye||!Ee||!Ee.filterByScheme?ye:this.b(ye,Ee.filterByScheme)}a(ae){return I(ae)||S(ae)?{primary:ae.primary,secondary:ae.secondary}:E(ae)||d(ae)?{primary:ae.modified,secondary:ae.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ae,Ee){if(!ae)return;if(p(ae))return e.EditorResourceAccessor.getCanonicalUri(ae.result,Ee);if(Ee?.supportSideBySide){const{primary:be,secondary:M}=this.a(ae);if(be&&M){if(Ee?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(be,{filterByScheme:Ee.filterByScheme}),secondary:this.getCanonicalUri(M,{filterByScheme:Ee.filterByScheme})};if(Ee?.supportSideBySide===W.ANY)return this.getCanonicalUri(be,{filterByScheme:Ee.filterByScheme})??this.getCanonicalUri(M,{filterByScheme:Ee.filterByScheme});ae=Ee.supportSideBySide===W.PRIMARY?be:M}}if(d(ae)||S(ae)||p(ae))return;const ye=ae.resource;return!ye||!Ee||!Ee.filterByScheme?ye:this.b(ye,Ee.filterByScheme)}b(ae,Ee){if(Array.isArray(Ee)){if(Ee.some(ye=>ae.scheme===ye))return ae}else if(Ee===ae.scheme)return ae}}e.EditorResourceAccessor=new U;var x;(function(q){q[q.LEFT=0]="LEFT",q[q.RIGHT=1]="RIGHT"})(x||(e.CloseDirection=x={}));class B{constructor(){this.c=new Map,this.d=new Map}start(ae){const Ee=this.a=ae.get(L.IInstantiationService);for(const[ye,be]of this.c)this.e(ye,be,Ee);this.c.clear()}e(ae,Ee,ye){const be=ye.createInstance(Ee);this.d.set(ae,be)}registerFileEditorFactory(ae){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ae}getFileEditorFactory(){return(0,R.assertIsDefined)(this.b)}registerEditorSerializer(ae,Ee){if(this.c.has(ae)||this.d.has(ae))throw new Error(`A editor serializer with type ID '${ae}' was already registered.`);return this.a?this.e(ae,Ee,this.a):this.c.set(ae,Ee),(0,O.toDisposable)(()=>{this.c.delete(ae),this.d.delete(ae)})}getEditorSerializer(ae){return this.d.get(typeof ae=="string"?ae:ae.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new B);async function z(q,ae,Ee){return!q||!q.length?[]:await Promise.all(q.map(async ye=>{const be=u.URI.revive(ye.fileUri);if(!be){Ee.info("Cannot resolve the path because it is not valid.",ye);return}if(!await ae.canHandleResource(be)){Ee.info("Cannot resolve the path because it cannot be handled",ye);return}let Q=ye.exists,fe=ye.type;if(typeof Q!="boolean"||typeof fe!="number")try{fe=(await ae.stat(be)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Q=!0}catch(_){Ee.error(_),Q=!1}if(!Q&&ye.openOnlyIfExists){Ee.info("Cannot resolve the path because it does not exist",ye);return}if(fe===y.FileType.Directory){Ee.info("Cannot resolve the path because it is a directory",ye);return}const we={...ye.options,pinned:!0};return Q?{resource:be,options:we}:{resource:be,options:we,forceUntitled:!0}}))}e.pathsToEditors=z;var ee;(function(q){q[q.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",q[q.SEQUENTIAL=1]="SEQUENTIAL"})(ee||(e.EditorsOrder=ee={}));function se(q){const ae=q;if(!ae)return!1;const Ee=ae;if(Ee.modified)return se(Ee.modified);const ye=ae;return!!(ye.contributionsState&&ye.viewState&&Array.isArray(ye.cursorState))}e.isTextEditorViewState=se;function V(q){return(0,T.isErrorWithActions)(q)}e.isEditorOpenError=V;function Z(q,ae,Ee){const ye=(0,T.createErrorWithActions)(q,ae);return ye.forceMessage=Ee?.forceMessage,ye.forceSeverity=Ee?.forceSeverity,ye.allowDialog=Ee?.allowDialog,ye}e.createEditorOpenError=Z}),define(Ce[248],De([1,0,3,202,5,4,28,42,19,65,23,72,238]),function(re,e,c,R,u,O,L,A,y,g,T,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",P.Codicon.window,(0,R.localize)(0,null));var D;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(D||(e.Extensions=D={}));var C;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(C||(e.ViewContainerLocation=C={})),e.ViewContainerLocations=[0,1,2];function b(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=b;class n extends O.Disposable{constructor(){super(...arguments),this.c=this.B(new c.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new c.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(o,f,v){const l=this.get(o.id);if(l)return l;const I=o;return I.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,L.getOrSet)(this.g,f,[]).push(I),v?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:f}),I}deregisterViewContainer(o){for(const f of this.g.keys()){const v=this.g.get(f),l=v?.indexOf(o);if(l!==-1){v?.splice(l,1),v.length===0&&this.g.delete(f),this.f.fire({viewContainer:o,viewContainerLocation:f});return}}}get(o){return this.all.filter(f=>f.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(v=>v?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(f=>this.getViewContainerLocation(f)===o)}}A.Registry.add(D.ViewContainersRegistry,new n);var h;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(h||(e.ViewContentGroups=h={}));function d(r,o){const f=r.group??h.More,v=o.group??h.More;return f!==v?f.localeCompare(v):(r.order??5)-(o.order??5)}class S extends O.Disposable{constructor(){super(...arguments),this.c=this.B(new c.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new c.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new c.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new c.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new g.SetMap}registerViews(o,f){this.registerViews2([{views:o,viewContainer:f}])}registerViews2(o){o.forEach(({views:f,viewContainer:v})=>this.l(f,v)),this.c.fire(o)}deregisterViews(o,f){const v=this.m(o,f);v.length&&this.f.fire({views:v,viewContainer:f})}moveViews(o,f){for(const v of this.j.keys())if(v!==f){const l=this.m(o,v);l.length&&(this.l(l,f),this.g.fire({views:l,from:v,to:f}))}}getViews(o){return this.j.get(o)||[]}getView(o){for(const f of this.i){const v=(this.j.get(f)||[]).filter(l=>l.id===o)[0];if(v)return v}return null}getViewContainer(o){for(const f of this.i)if((this.j.get(f)||[]).filter(l=>l.id===o)[0])return f;return null}registerViewWelcomeContent(o,f){return this.k.add(o,f),this.h.fire(o),(0,O.toDisposable)(()=>{this.k.delete(o,f),this.h.fire(o)})}registerViewWelcomeContent2(o,f){const v=new Map;for(const[l,I]of f)this.k.add(o,I),v.set(l,(0,O.toDisposable)(()=>{this.k.delete(o,I),this.h.fire(o)}));return this.h.fire(o),v}getViewWelcomeContent(o){const f=[];return this.k.forEach(o,v=>f.push(v)),f.sort(d)}l(o,f){let v=this.j.get(f);v||(v=[],this.j.set(f,v),this.i.push(f));for(const l of o){if(this.getView(l.id)!==null)throw new Error((0,R.localize)(1,null,l.id));v.push(l)}}m(o,f){const v=this.j.get(f);if(!v)return[];const l=[],I=[];for(const E of v)o.includes(E)?l.push(E):I.push(E);return l.length&&(I.length?this.j.set(f,I):(this.j.delete(f),this.i.splice(this.i.indexOf(f),1))),l}}A.Registry.add(D.ViewsRegistry,new S),e.IViewsService=(0,u.createDecorator)("viewsService"),e.IViewDescriptorService=(0,u.createDecorator)("viewDescriptorService");var w;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(w||(e.ViewVisibilityState=w={}));var p;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(p||(e.TreeItemCollapsibleState=p={}));class t{constructor(o,f){this.c=!1,this.d=!1,(0,T.mixin)(this,o),this.d=!!f,this.resolve=async v=>{if(f&&!this.c){const l=await f(v);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class a extends Error{constructor(o){super((0,R.localize)(2,null,o)),this.name="NoTreeViewError"}static is(o){return o.name==="NoTreeViewError"}}e.NoTreeViewError=a}),define(Ce[134],De([1,0,3,16,203]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class O{constructor(){this.f=new Map,this.k=[],this.m=new c.Emitter,this.n=new c.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,y,g,T){const P={command:A};if(y&&Object.keys(y).length>0&&(P.arguments=y),this.s("request",P),typeof T=="number"){const m=setTimeout(()=>{clearTimeout(m);const D=this.f.get(P.seq);if(D){this.f.delete(P.seq);const C={type:"response",seq:0,request_seq:P.seq,success:!1,command:A,message:(0,u.localize)(0,null,T,A)};D(C)}},T)}return g&&this.f.set(P.seq,g),P.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,y){return A.type!=="event"||y.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,R.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const y=A,g=this.f.get(y.request_seq);g&&(this.f.delete(y.request_seq),g(y));break}}}}s(A,y){y.type=A,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((y,g)=>A.set(g,y)),await(0,R.timeout)(500),A.forEach((y,g)=>{y({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=O}),define(Ce[249],De([1,0,204,47,5]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new R.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new R.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new R.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new R.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new R.RawContextKey("hasDebugged",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new R.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new R.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new R.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new R.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new R.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new R.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new R.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new R.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new R.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new R.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new R.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new R.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new R.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new R.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new R.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new R.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new R.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new R.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new R.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new R.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new R.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new R.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new R.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new R.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new R.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new R.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new R.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new R.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new R.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new R.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new R.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new R.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new R.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new R.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new R.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new R.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new R.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new R.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new R.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new R.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new R.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new R.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new R.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new R.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new R.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new R.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(50,null)});const O=m=>c.localize(51,null,m);e.debuggerDisabledMessage=O,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(52,null)};var L;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(L||(e.State=L={}));function A(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var g;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var T;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(T||(e.DebuggerString=T={})),e.IDebugService=(0,u.createDecorator)("debugService");var P;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(P||(e.BreakpointWidgetContext=P={}))}),define(Ce[250],De([1,0,11,2,10,23,18,36,21,19]),function(re,e,c,R,u,O,L,A,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function P(l,I,E){return l.replace(T,function(s,i){return I&&i.length>0&&i[0]!=="_"?s:E&&E.hasOwnProperty(i)?E[i]:s})}e.formatPII=P;function m(l){const I={};for(const E of Object.keys(l))E.startsWith("!")||(I[E]=l[E]);return I}e.filterExceptionsFromTelemetry=m;function D(l){return l.configuration.request==="attach"&&!C(l)&&(!l.parentSession||D(l.parentSession))}e.isSessionAttach=D;function C(l){let I=l.configuration.type;if(I)return I==="vslsShare"&&(I=l.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(I,"extensionhost")||(0,c.equalsIgnoreCase)(I,"pwa-extensionhost")?l:l.parentSession?C(l.parentSession):void 0}e.getExtensionHostDebugSession=C;function b(l){return l.type&&(l.label||l.program||l.runtime)}e.isDebuggerMainContribution=b;function n(l,I,E){let s,i=0;const k=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let F=null;for(;F=k.exec(l);){const $=F.index+1,j=$+F[0].length;if($<=I&&j>=E){s=F[0],i=$;break}}if(s){const $=/\w+/g;let j=null;for(;(j=$.exec(s))&&!(j.index+1+i+j[0].length>=E););j&&(s=s.substring(0,$.lastIndex))}return s?{start:i,end:i+s.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=n;async function h(l,I,E,s){if(l.evaluatableExpressionProvider.has(I)){const i=l.evaluatableExpressionProvider.ordered(I),k=(0,g.coalesce)(await Promise.all(i.map(async F=>{try{return await F.provideEvaluatableExpression(I,E,s??y.CancellationToken.None)}catch{return}})));if(k.length>0){let F=k[0].expression;const $=k[0].range;return F||(F=I.getLineContent(E.lineNumber).substring($.startColumn-1,$.endColumn-1)),{range:$,matchingExpression:F}}}else{const i=I.getLineContent(E.lineNumber),{start:k,end:F}=n(i,E.column,E.column),$=i.substring(k-1,F);return{matchingExpression:$,range:new A.Range(E.lineNumber,k,E.lineNumber,k+$.length)}}return null}e.getEvaluatableExpressionAtPosition=h;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function S(l){return!!(l&&l.match(d))}e.isUri=S;function w(l){if(typeof l.path=="string"&&!(typeof l.sourceReference=="number"&&l.sourceReference>0)){if(S(l.path))return R.URI.parse(l.path);if((0,u.isAbsolute)(l.path))return R.URI.file(l.path)}return l.path}function p(l){if(typeof l.path=="object"){const I=R.URI.revive(l.path);if(I)return I.scheme===L.Schemas.file?I.fsPath:I.toString()}return l.path}function t(l,I){const E=I?w:p,s=(0,O.deepClone)(l);return r(s,(i,k)=>{i&&k&&(k.path=E(k))}),s}e.convertToDAPaths=t;function a(l,I){const E=I?w:p,s=(0,O.deepClone)(l);return r(s,(i,k)=>{!i&&k&&(k.path=E(k))}),s}e.convertToVSCPaths=a;function r(l,I){switch(l.type){case"event":{const E=l;switch(E.event){case"output":I(!1,E.body.source);break;case"loadedSource":I(!1,E.body.source);break;case"breakpoint":I(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=l;switch(E.command){case"setBreakpoints":I(!0,E.arguments.source);break;case"breakpointLocations":I(!0,E.arguments.source);break;case"source":I(!0,E.arguments.source);break;case"gotoTargets":I(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(s=>I(!1,s));break;default:break}break}case"response":{const E=l;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(s=>I(!1,s.source));break;case"loadedSources":E.body.sources.forEach(s=>I(!1,s));break;case"scopes":E.body.scopes.forEach(s=>I(!1,s.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(s=>I(!1,s.source));break;case"setBreakpoints":E.body.breakpoints.forEach(s=>I(!1,s.source));break;case"disassemble":E.body?.instructions.forEach(i=>I(!1,i.location));break;default:break}break}}}function o(l){return l.filter(I=>!I.presentation?.hidden).sort((I,E)=>I.presentation?E.presentation?I.presentation.group?E.presentation.group?I.presentation.group!==E.presentation.group?I.presentation.group.localeCompare(E.presentation.group):f(I.presentation.order,E.presentation.order):-1:E.presentation.group?1:f(I.presentation.order,E.presentation.order):-1:E.presentation?1:0)}e.getVisibleAndSorted=o;function f(l,I){return typeof l!="number"?typeof I!="number"?0:1:typeof I!="number"?-1:l-I}async function v(l,I){const E=l.getValue("debug.saveBeforeStart",{overrideIdentifier:I.activeTextEditorLanguageId});if(E!=="none"&&(await I.saveAll(),E==="allEditorsInActiveGroup")){const s=I.activeEditorPane;s&&s.input.resource?.scheme===L.Schemas.untitled&&await I.save({editor:s.input,groupId:s.group.id})}await l.reloadConfiguration()}e.saveAllBeforeDebugStart=v}),define(Ce[251],De([1,0,45,135,23,10,9,11,29,205,134]),function(re,e,c,R,u,O,L,A,y,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends T.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(h,d){this.p=d,this.r=Buffer.allocUnsafe(0),this.t=-1,h.on("data",S=>this.w(S))}sendMessage(h){if(this.p){const d=JSON.stringify(h);this.p.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${P.a}${d}`,"utf8")}}w(h){for(this.r=Buffer.concat([this.r,h]);;){if(this.t>=0){if(this.r.length>=this.t){const d=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(S){this.m.fire(new Error((S.message||S)+`
`+d))}continue}}else{const d=this.r.indexOf(P.a);if(d!==-1){const w=this.r.toString("utf8",0,d).split(P.b);for(const p of w){const t=p.split(P.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(d+P.a.length);continue}}break}}}e.StreamDebugAdapter=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */;class m extends P{startSession(){return new Promise((h,d)=>{let S=!1;this.x=this.y(()=>{this.v(this.x,this.x),h(),S=!0}),this.x.on("close",()=>{S?this.m.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.x.on("error",w=>{S?this.m.fire(w):d(w)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=m;class D extends m{constructor(h){super(),this.z=h}y(h){return R.createConnection(this.z.port,this.z.host||"127.0.0.1",h)}}e.SocketDebugAdapter=D;class C extends m{constructor(h){super(),this.z=h}y(h){return R.createConnection(this.z.path,h)}}e.NamedPipeDebugAdapter=C;class b extends P{constructor(h,d){super(),this.y=h,this.z=d}async startSession(){const h=this.y.command,d=this.y.args,S=this.y.options||{};try{if(h)if(O.isAbsolute(h)){if(!await y.Promises.exists(h))throw new Error(g.localize(0,null,h))}else h.indexOf("/")<0&&h.indexOf("\\")<0;else throw new Error(g.localize(1,null,this.z));let w=process.env;if(S.env&&Object.keys(S.env).length>0&&(w=u.mixin(u.deepClone(process.env),S.env)),h==="node")if(Array.isArray(d)&&d.length>0){const p=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:w,execArgv:p?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};S.cwd&&(t.cwd=S.cwd);const a=c.fork(d[0],d.slice(1),t);if(!a.pid)throw new Error(g.localize(2,null,d[0]));this.x=a}else throw new Error(g.localize(3,null));else{const p={env:w};S.cwd&&(p.cwd=S.cwd),this.x=c.spawn(h,d,p)}this.x.on("error",p=>{this.m.fire(p)}),this.x.on("exit",(p,t)=>{this.n.fire(p)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",p=>{this.m.fire(p)}),this.x.stdin.on("error",p=>{this.m.fire(p)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(w){this.m.fire(w)}}async stopSession(){return this.x?(await this.u(),L.isWindows?new Promise((h,d)=>{const S=c.exec(`taskkill /F /T /PID ${this.x.pid}`,function(w,p,t){if(w)return d(w)});S.on("exit",h),S.on("error",d)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(h,d){if(!h)return;const S=Object.create(null);h.runtime&&(h.runtime.indexOf("./")===0?S.runtime=O.join(d,h.runtime):S.runtime=h.runtime),h.runtimeArgs&&(S.runtimeArgs=h.runtimeArgs),h.program&&(O.isAbsolute(h.program)?S.program=h.program:S.program=O.join(d,h.program)),h.args&&(S.args=h.args);const w=h;return w.win&&(S.win=b.A(w.win,d)),w.winx86&&(S.winx86=b.A(w.winx86,d)),w.windows&&(S.windows=b.A(w.windows,d)),w.osx&&(S.osx=b.A(w.osx,d)),w.linux&&(S.linux=b.A(w.linux,d)),S}static platformAdapterExecutable(h,d){let S=Object.create(null);d=d.toLowerCase();for(const o of h)if(o.contributes){const f=o.contributes.debuggers;f&&f.length>0&&f.filter(v=>typeof v.type=="string"&&A.equalsIgnoreCase(v.type,d)).forEach(v=>{const l=b.A(v,o.extensionLocation.fsPath);S=u.mixin(S,l,o.isBuiltin)})}let w;L.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?w=S.winx86||S.win||S.windows:L.isWindows?w=S.win||S.windows:L.isMacintosh?w=S.osx:L.isLinux&&(w=S.linux),w=w||S;const p=w.program||S.program,t=w.args||S.args,a=w.runtime||S.runtime,r=w.runtimeArgs||S.runtimeArgs;if(a)return{type:"executable",command:a,args:(r||[]).concat(typeof p=="string"?[p]:[]).concat(t||[])};if(p)return{type:"executable",command:p,args:t||[]}}}e.ExecutableDebugAdapter=b}),define(Ce[252],De([1,0,45,30,9]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function O(g,T){return new Promise((P,m)=>{let D="";const C=c.spawn(g,T);C.pid&&C.stdout.on("data",b=>{D+=b.toString()}),C.on("error",b=>{m(b)}),C.on("close",b=>{P(D)})})}async function L(g){if(g)if(u.isWindows){const T=await new Promise((P,m)=>{re(["@vscode/windows-process-tree"],P,m)});return new Promise(P=>{T.getProcessTree(g,m=>{P(!!m&&m.children.length>0)})})}else return O("/usr/bin/pgrep",["-lP",String(g)]).then(T=>{const P=T.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},T=>!0);return Promise.resolve(!0)}e.hasChildProcesses=L;var A;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(A||(A={}));function y(g,T,P,m,D){g=g.trim().toLowerCase();let C;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?C=1:g.indexOf("cmd.exe")>=0?C=0:g.indexOf("bash")>=0?C=2:u.isWindows?C=0:C=2;let b,n=" ";switch(C){case 1:if(b=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),m){const h=(0,R.getDriveLetter)(m);h&&(n+=`${h}:; `),n+=`cd ${b(m)}; `}if(D)for(const h in D){const d=D[h];d===null?n+=`Remove-Item env:${h}; `:n+=`\${env:${h}}='${d}'; `}if(T.length>0){const h=T.shift(),d=P?h:b(h);n+=d[0]==="'"?`& ${d} `:`${d} `;for(const S of T)n+=S==="<"||S===">"||P?S:b(S),n+=" "}break;case 0:if(b=h=>(h=h.replace(/\"/g,'""'),h=h.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(d=>h.includes(d))||h.length===0?`"${h}"`:h),m){const h=(0,R.getDriveLetter)(m);h&&(n+=`${h}: && `),n+=`cd ${b(m)} && `}if(D){n+='cmd /C "';for(const h in D){let d=D[h];d===null?n+=`set "${h}=" && `:(d=d.replace(/[&^|<>]/g,S=>`^${S}`),n+=`set "${h}=${d}" && `)}}for(const h of T)n+=h==="<"||h===">"||P?h:b(h),n+=" ";D&&(n+='"');break;case 2:{b=d=>(d=d.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),d.length===0?'""':d);const h=d=>/[^\w@%\/+=,.:^-]/.test(d)?`'${d.replace(/'/g,"'\\''")}'`:d;if(m&&(n+=`cd ${b(m)} ; `),D){n+="/usr/bin/env";for(const d in D){const S=D[d];S===null?n+=` -u ${h(d)}`:n+=` ${h(`${d}=${S}`)}`}n+=" "}for(const d of T)n+=d==="<"||d===">"||P?d:b(d),n+=" ";break}}return n}e.prepareCommand=y}),define(Ce[101],De([1,0,22,32,53,91,18,10,9,47]),function(re,e,c,R,u,O,L,A,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var T;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(T||(e.CellKind=T={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",O.Mimes.latex,O.Mimes.markdown,"image/png","image/jpeg",O.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[O.Mimes.latex,O.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(P||(e.NotebookRunState=P={}));var m;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var D;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(D||(e.NotebookExecutionState=D={}));var C;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(C||(e.NotebookRendererMatch=C={}));var b;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(b||(e.RendererMessagingSpec=b={}));var n;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(n||(e.NotebookCellsChangeType=n={}));var h;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var d;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(d||(e.CellEditType=d={}));var S;(function(B){B.scheme=L.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],ee=new RegExp(`^[${z.join("")}]+`),se=7;function V(be,M){const Q=M.toString(se),we=`${Q.length<z.length?z[Q.length-1]:"z"}${Q}s${(0,c.encodeBase64)(c.VSBuffer.fromString(be.scheme),!0,!0)}`;return be.with({scheme:B.scheme,fragment:we})}B.generate=V;function Z(be){if(be.scheme!==B.scheme)return;const M=be.fragment.indexOf("s");if(M<0)return;const Q=parseInt(be.fragment.substring(0,M).replace(ee,""),se),fe=(0,c.decodeBase64)(be.fragment.substring(M+1)).toString();if(!isNaN(Q))return{handle:Q,notebook:be.with({scheme:fe,fragment:null})}}B.parse=Z;function q(be,M){return be.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${M??""},${be.scheme!==L.Schemas.file?be.scheme:""}`})}B.generateCellOutputUri=q;function ae(be){if(be.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const M=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(be.fragment);if(!M)return;const Q=M[1]&&M[1]!==""?M[1]:void 0,fe=M[2];return{outputId:Q,notebook:be.with({scheme:fe||L.Schemas.file,fragment:null})}}B.parseCellOutputUri=ae;function Ee(be,M,Q){return B.generate(be,M).with({scheme:Q})}B.generateCellPropertyUri=Ee;function ye(be,M){if(be.scheme===M)return B.parse(be.with({scheme:B.scheme}))}B.parseCellPropertyUri=ye})(S||(e.CellUri=S={}));const w=B=>y.isWindows?B.replace(/\//g,"\\"):B;class p{constructor(z=[],ee=e.NOTEBOOK_DISPLAY_ORDER){this.e=ee,this.d=[...new Set(z)].map(se=>({pattern:se,matches:R.parse(w(se))}))}sort(z){const ee=new Map(u.Iterable.map(z,V=>[V,w(V)]));let se=[];for(const{matches:V}of this.d)for(const[Z,q]of ee)if(V(q)){se.push(Z),ee.delete(Z);break}return ee.size&&(se=se.concat([...ee.keys()].sort((V,Z)=>this.e.indexOf(V)-this.e.indexOf(Z)))),se}prioritize(z,ee){const se=this.f(z);if(se===-1){this.d.unshift({pattern:z,matches:R.parse(w(z))});return}const V=new Set(ee.map(q=>this.f(q,se)));V.delete(-1);const Z=Array.from(V).sort();this.d.splice(se+1,0,...Z.map(q=>this.d[q]));for(let q=Z.length-1;q>=0;q--)this.d.splice(Z[q],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,ee=this.d.length){const se=w(z);for(let V=0;V<ee;V++)if(this.d[V].matches(se))return V;return-1}}e.MimeTypeDisplayOrder=p;function t(B,z,ee,se=(V,Z)=>V===Z){const V=[];function Z(Ee,ye,be){if(ye===0&&be.length===0)return;const M=V[V.length-1];M&&M.start+M.deleteCount===Ee?(M.deleteCount+=ye,M.toInsert.push(...be)):V.push({start:Ee,deleteCount:ye,toInsert:be})}let q=0,ae=0;for(;;){if(q===B.length){Z(q,0,z.slice(ae));break}if(ae===z.length){Z(q,B.length-q,[]);break}const Ee=B[q],ye=z[ae];if(se(Ee,ye)){q+=1,ae+=1;continue}ee(ye)?(Z(q,1,[]),q+=1):(Z(q,0,[ye]),ae+=1)}return V}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new g.RawContextKey("notebookEditorCursorAtBoundary","none");var a;(function(B){B.default="default",B.option="option"})(a||(e.NotebookEditorPriority=a={}));function r(B){const z=B;return!!((typeof z.include=="string"||R.isRelativePattern(z.include))&&(typeof z.exclude=="string"||R.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=r;function o(B,z,ee){if(Array.isArray(B.viewType)&&B.viewType.indexOf(z)>=0||B.viewType===z)return!0;if(B.filenamePattern){const se=r(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,V=r(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(R.match(se,(0,A.basename)(ee.fsPath).toLowerCase()))return!(V&&R.match(V,(0,A.basename)(ee.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var f;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(f||(e.CellStatusbarAlignment=f={}));class v{static create(z){return`${v.d}${z}`}static parse(z){if(z.startsWith(v.d))return z.substring(v.d.length)}}e.NotebookWorkingCopyTypeIdentifier=v,v.d="notebook/";function l(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=l;const I=new TextDecoder;function E(B){const z=[];let ee=!1;for(const se of B)(z.length===0||ee)&&(z.push(se),ee=!0);return F(z),x(c.VSBuffer.concat(z.map(se=>c.VSBuffer.wrap(se))))}e.compressOutputItemStreams=E;const s=`${String.fromCharCode(27)}[A`,i=s.split("").map(B=>B.charCodeAt(0)),k=10;function F(B){B.forEach((z,ee)=>{if(ee===0||z.length<s.length)return;const se=B[ee-1],V=z.subarray(0,s.length);if(V[0]===i[0]&&V[1]===i[1]&&V[2]===i[2]){const Z=se.lastIndexOf(k);if(Z===-1)return;B[ee-1]=se.subarray(0,Z),B[ee]=z.subarray(s.length)}})}function $(B){let z=B;do B=z,z=B.replace(/[^\n]\x08/gm,"");while(z.length<B.length);return B}function j(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const z=B.match(/^(.*)\r+/m)[1];let ee=B.match(/\r+(.*)$/m)[1];ee=ee+z.slice(ee.length,z.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ee)}return B}const W="\b".charCodeAt(0),U="\r".charCodeAt(0);function x(B){return!B.buffer.includes(W)&&!B.buffer.includes(U)?B:c.VSBuffer.fromString(j($(I.decode(B.buffer))))}}),define(Ce[253],De([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var R;(function(u){u[u.Output=1]="Output",u[u.OutputItems=2]="OutputItems",u[u.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(Ce[60],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(O){O.Delimiter="\0"})(c||(e.TestIdPathParts=c={}));var R;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class u{static fromExtHostTestItem(L,A,y=L.parent){if(L._isRoot)return new u([A]);const g=[L.id];for(let T=y;T&&T.id!==A;T=T.parent)g.push(T.id);return g.push(A),new u(g.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const A=L.indexOf("\0");return A===-1?L:L.slice(0,A)}static fromString(L){return new u(L.split("\0"))}static join(L,A){return new u([...L.path,A])}static joinToString(L,A){return L.toString()+"\0"+A}static parentId(L){const A=L.lastIndexOf("\0");return A===-1?void 0:L.slice(0,A)}static localId(L){const A=L.lastIndexOf("\0");return A===-1?L:L.slice(A+1)}static isChild(L,A){return A.startsWith(L)&&A[L.length]==="\0"}static compare(L,A){return L===A?0:u.isChild(L,A)?2:u.isChild(A,L)?3:1}constructor(L,A=L.length){if(this.path=L,this.d=A,L.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new u(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new u(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new u(this.path,L)}compare(L){if(typeof L=="string")return u.compare(this.toString(),L);for(let A=0;A<L.d&&A<this.d;A++)if(L.path[A]!==this.path[A])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.TestId=u}),define(Ce[81],De([1,0,2,36,60]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var O;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(O||(e.TestResultState=O={}));var L;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(L||(e.ExtTestRunProfileKind=L={}));var A;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(A||(e.TestRunProfileBitset=A={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=I=>"runId"in I;e.isStartControllerTests=y;var g;(function(I){I.serialize=E=>({range:E.range.toJSON(),uri:E.uri.toJSON()}),I.deserialize=E=>({range:R.Range.lift(E.range),uri:c.URI.revive(E.uri)})})(g||(e.IRichLocation=g={}));var T;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(T||(e.TestMessageType=T={}));var P;(function(I){I.serialize=E=>({message:E.message,type:0,expected:E.expected,actual:E.actual,location:E.location&&g.serialize(E.location)}),I.deserialize=E=>({message:E.message,type:0,expected:E.expected,actual:E.actual,location:E.location&&g.deserialize(E.location)})})(P||(e.ITestErrorMessage=P={}));const m=(I,E)=>`${E?"s":"e"}${I}`;e.getMarkId=m;var D;(function(I){I.serialize=E=>({message:E.message,type:1,offset:E.offset,length:E.length,location:E.location&&g.serialize(E.location)}),I.deserialize=E=>({message:E.message,type:1,offset:E.offset,length:E.length,location:E.location&&g.deserialize(E.location)})})(D||(e.ITestOutputMessage=D={}));var C;(function(I){I.serialize=E=>E.type===0?P.serialize(E):D.serialize(E),I.deserialize=E=>E.type===0?P.deserialize(E):D.deserialize(E)})(C||(e.ITestMessage=C={}));var b;(function(I){I.serializeWithoutMessages=E=>({state:E.state,duration:E.duration,messages:[]}),I.serialize=E=>({state:E.state,duration:E.duration,messages:E.messages.map(C.serialize)}),I.deserialize=E=>({state:E.state,duration:E.duration,messages:E.messages.map(C.deserialize)})})(b||(e.ITestTaskState=b={}));const n="\0",h=(I,E)=>I+n+E;e.namespaceTestTag=h;const d=I=>{const E=I.indexOf(n);return{ctrlId:I.slice(0,E),tagId:I.slice(E+1)}};e.denamespaceTestTag=d;var S;(function(I){I.serialize=E=>({extId:E.extId,label:E.label,tags:E.tags,busy:E.busy,children:void 0,uri:E.uri?.toJSON(),range:E.range?.toJSON()||null,description:E.description,error:E.error,sortText:E.sortText}),I.deserialize=E=>({extId:E.extId,label:E.label,tags:E.tags,busy:E.busy,children:void 0,uri:E.uri?c.URI.revive(E.uri):void 0,range:E.range?R.Range.lift(E.range):null,description:E.description,error:E.error,sortText:E.sortText})})(S||(e.ITestItem=S={}));var w;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(w||(e.TestItemExpandState=w={}));var p;(function(I){I.serialize=E=>({expand:E.expand,item:S.serialize(E.item)}),I.deserialize=E=>({controllerId:u.TestId.root(E.item.extId),expand:E.expand,item:S.deserialize(E.item)})})(p||(e.InternalTestItem=p={}));var t;(function(I){I.serialize=E=>{let s;return E.item&&(s={},E.item.label!==void 0&&(s.label=E.item.label),E.item.tags!==void 0&&(s.tags=E.item.tags),E.item.busy!==void 0&&(s.busy=E.item.busy),E.item.uri!==void 0&&(s.uri=E.item.uri?.toJSON()),E.item.range!==void 0&&(s.range=E.item.range?.toJSON()),E.item.description!==void 0&&(s.description=E.item.description),E.item.error!==void 0&&(s.error=E.item.error),E.item.sortText!==void 0&&(s.sortText=E.item.sortText)),{extId:E.extId,expand:E.expand,item:s}},I.deserialize=E=>{let s;return E.item&&(s={},E.item.label!==void 0&&(s.label=E.item.label),E.item.tags!==void 0&&(s.tags=E.item.tags),E.item.busy!==void 0&&(s.busy=E.item.busy),E.item.range!==void 0&&(s.range=E.item.range?R.Range.lift(E.item.range):null),E.item.description!==void 0&&(s.description=E.item.description),E.item.error!==void 0&&(s.error=E.item.error),E.item.sortText!==void 0&&(s.sortText=E.item.sortText)),{extId:E.extId,expand:E.expand,item:s}}})(t||(e.ITestItemUpdate=t={}));const a=(I,E)=>{E.expand!==void 0&&(I.expand=E.expand),E.item!==void 0&&(I.item=I.item?Object.assign(I.item,E.item):E.item)};e.applyTestItemUpdate=a;var r;(function(I){I.serializeWithoutMessages=E=>({...p.serialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(b.serializeWithoutMessages)}),I.serialize=E=>({...p.serialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(b.serialize)}),I.deserialize=E=>({...p.deserialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(b.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var o;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(o||(e.DetailType=o={}));var f;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(f||(e.TestDiffOpType=f={}));var v;(function(I){I.deserialize=E=>E.op===0?{op:E.op,item:p.deserialize(E.item)}:E.op===1?{op:E.op,item:t.deserialize(E.item)}:E.op===2?{op:E.op,uri:c.URI.revive(E.uri),docv:E.docv}:E,I.serialize=E=>E.op===0?{op:E.op,item:p.serialize(E.item)}:E.op===1?{op:E.op,item:t.serialize(E.item)}:E})(v||(e.TestsDiffOp=v={}));class l{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(E){const s=this.o();for(const i of E)switch(i.op){case 0:this.j(p.deserialize(i.item),s);break;case 1:this.k(t.deserialize(i.item),s);break;case 3:this.l(i.itemId,s);break;case 5:this.m(i.itemId);break;case 4:this.updatePendingRoots(i.amount);break;case 6:this.c.set(i.tag.id,i.tag);break;case 7:this.c.delete(i.id);break}s.complete?.()}j(E,s){const i=u.TestId.parentId(E.item.extId)?.toString();let k;if(!i)k=this.p(E),this.f.add(k),this.d.set(E.item.extId,k);else if(this.d.has(i)){const F=this.d.get(i);F.children.add(E.item.extId),k=this.p(E,F),this.d.set(E.item.extId,k)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(E)}`);return}return s.add?.(k),E.expand===2&&this.g++,k}k(E,s){const i=this.d.get(E.extId);if(i)return E.expand!==void 0&&(i.expand===2&&this.g--,E.expand===2&&this.g++),(0,e.applyTestItemUpdate)(i,E),s.update?.(i),i}l(E,s){const i=this.d.get(E);if(!i)return;const k=u.TestId.parentId(i.item.extId)?.toString();k?this.d.get(k).children.delete(i.item.extId):this.f.delete(i);const F=[[E]];for(;F.length;)for(const $ of F.pop()){const j=this.d.get($);j&&(F.push(j.children),this.d.delete($),s.remove?.(j,j!==i),j.expand===2&&this.g--)}}m(E){}updatePendingRoots(E){this.h+=E}o(){return{}}}e.AbstractIncrementalTestCollection=l}),define(Ce[102],De([1,0,16,3,4,52,81,60]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const g=(d,S)=>d===S,P=Object.entries({range:(d,S)=>d===S?!0:!d||!S?!1:d.equalsRange(S),busy:g,label:g,description:g,error:g,sortText:g,tags:(d,S)=>!(d.length!==S.length||d.some(w=>!S.includes(w)))}),m=(d,S)=>{let w;for(const[p,t]of P)t(d[p],S[p])||(w?w[p]=S[p]:w={[p]:S[p]});return w};class D extends u.Disposable{get root(){return this.m.root}constructor(S){super(),this.m=S,this.f=this.B(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new R.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(S){this.h=S;for(const w of this.tree.values())this.G(w)}get resolveHandler(){return this.h}collectDiff(){const S=this.k;return this.k=[],S}pushDiff(S){switch(S.op){case 2:{for(const w of this.k)if(w.op===2&&w.uri===S.uri){w.docv=S.docv;return}break}case 1:{const w=this.k[this.k.length-1];if(w){if(w.op===1&&w.item.extId===S.item.extId){(0,L.applyTestItemUpdate)(w.item,S.item);return}if(w.op===0&&w.item.item.extId===S.item.extId){(0,L.applyTestItemUpdate)(w.item,S.item);return}}break}}this.k.push(S),this.f.isScheduled()||this.f.schedule()}expand(S,w){const p=this.tree.get(S);if(p){if((p.expandLevels===void 0||w>p.expandLevels)&&(p.expandLevels=w),p.expand===1){const t=this.I(p);return t.isOpen()?this.H(p,w-1):t.wait().then(()=>this.H(p,w-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,w-1)):this.H(p,w-1)}}dispose(){for(const S of this.tree.values())this.m.getApiFor(S.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(S,w){switch(w.op){case 3:this.L(A.TestId.joinToString(S.fullId,w.id));break;case 0:this.u(w.item,S);break;case 5:for(const p of w.ops)this.p(S,p);break;case 1:this.w(w.new,w.old,S.fullId.toString());break;case 2:this.G(S);break;case 4:this.pushDiff({op:1,item:{extId:S.fullId.toString(),item:w.update}});break;case 6:this.s(S.actual.uri);break;default:(0,O.assertNever)(w)}}s(S){S&&this.pushDiff({op:2,uri:S,docv:this.m.getDocumentVersion(S)})}u(S,w){const p=A.TestId.fromExtHostTestItem(S,this.root.id,w?.actual),t=this.m.getApiFor(S);t.parent&&t.parent!==w?.actual&&this.m.getChildren(t.parent).delete(S.id);let a=this.tree.get(p.toString());if(!a){a={fullId:p,actual:S,expandLevels:w?.expandLevels?w.expandLevels-1:void 0,expand:0},S.tags.forEach(this.y,this),this.tree.set(a.fullId.toString(),a),this.C(S,w),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:a.expand,item:this.m.toITestItem(S)}}),this.F(S,a,w);return}if(a.actual===S){this.D(S,a,w);return}if(a.actual.uri?.toString()!==S.uri?.toString())return this.L(p.toString()),this.u(S,w);const r=this.m.getChildren(a.actual),o=a.actual,f=m(this.m.toITestItem(o),this.m.toITestItem(S));this.m.getApiFor(o).listener=void 0,a.actual=S,a.expand=0,f&&(f.hasOwnProperty("tags")&&(this.w(S.tags,o.tags,p.toString()),delete f.tags),this.p(a,{op:4,update:f})),this.F(S,a,w);for(const[v,l]of r)this.m.getChildren(S).get(l.id)||this.L(A.TestId.joinToString(p,l.id));this.s(a.actual.uri)}w(S,w,p){const t=new Set(w.map(a=>a.id));for(const a of S)t.delete(a.id)||this.y(a);this.pushDiff({op:1,item:{extId:p,item:{tags:S.map(a=>(0,L.namespaceTestTag)(this.m.controllerId,a.id))}}}),t.forEach(this.z,this)}y(S){const w=this.j.get(S.id);w?w.refCount++:(this.j.set(S.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.namespaceTestTag)(this.m.controllerId,S.id)}}))}z(S){const w=this.j.get(S);w&&!--w.refCount&&(this.j.delete(S),this.pushDiff({op:7,id:(0,L.namespaceTestTag)(this.m.controllerId,S)}))}C(S,w){this.m.getApiFor(S).parent=w&&w.actual!==this.root?w.actual:void 0}D(S,w,p){this.C(S,p);const t=this.m.getApiFor(S);t.parent=p?.actual,t.listener=a=>this.p(w,a),this.G(w)}F(S,w,p){this.D(S,w,p);for(const[t,a]of this.m.getChildren(S))this.u(a,w)}G(S){let w;this.h?S.resolveBarrier?w=S.resolveBarrier.isOpen()?3:2:w=S.actual.canResolveChildren?1:0:w=0,w!==S.expand&&(S.expand=w,this.pushDiff({op:1,item:{extId:S.fullId.toString(),expand:w}}),w===1&&S.expandLevels!==void 0&&this.I(S))}H(S,w){if(w<0)return;const p=[];for(const[t,a]of this.m.getChildren(S.actual)){const r=this.expand(A.TestId.joinToString(S.fullId,a.id),w);(0,c.isThenable)(r)&&p.push(r)}if(p.length)return Promise.all(p).then(()=>{})}I(S){if(S.resolveBarrier)return S.resolveBarrier;if(!this.h){const a=new c.Barrier;return a.open(),a}S.expand=2,this.J(S);const w=S.resolveBarrier=new c.Barrier,p=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,a)};let t;try{t=this.h(S.actual===this.root?void 0:S.actual)}catch(a){p(a)}return(0,c.isThenable)(t)?t.catch(p).then(()=>{w.open(),this.G(S)}):(w.open(),this.G(S)),S.resolveBarrier}J(S){this.pushDiff({op:1,item:{extId:S.fullId.toString(),expand:S.expand}})}L(S){const w=this.tree.get(S);if(!w)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:S});const p=[w];for(;p.length;){const t=p.pop();if(t){this.m.getApiFor(t.actual).listener=void 0;for(const a of t.actual.tags)this.z(a.id);this.tree.delete(t.fullId.toString());for(const[a,r]of this.m.getChildren(t.actual))p.push(this.tree.get(A.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const S=this.collectDiff();S.length&&this.g.fire(S)}}e.TestItemCollection=D;class C extends Error{constructor(S){super(`Attempted to insert a duplicate test item ID ${S}`)}}e.DuplicateTestItemError=C;class b extends Error{constructor(S){super(`TestItem with ID "${S}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=b;class n extends Error{constructor(S,w,p){super(`TestItem with ID "${S}" is from controller "${w}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=n;const h=(d,S,w)=>{let p=new Map;return{get size(){return p.size},forEach(t,a){for(const r of p.values())t.call(a,r,this)},[Symbol.iterator](){return p.entries()},replace(t){const a=new Map,r=new Set(p.keys()),o={op:5,ops:[]};for(const f of t){if(!(f instanceof w))throw new b(f.id);const v=S(f).controllerId;if(v!==d.controllerId)throw new n(f.id,v,d.controllerId);if(a.has(f.id))throw new C(f.id);a.set(f.id,f),r.delete(f.id),o.ops.push({op:0,item:f})}for(const f of r.keys())o.ops.push({op:3,id:f});d.listener?.(o),p=a},add(t){if(!(t instanceof w))throw new b(t.id);p.set(t.id,t),d.listener?.({op:0,item:t})},delete(t){p.delete(t)&&d.listener?.({op:3,id:t})},get(t){return p.get(t)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=h}),define(Ce[136],De([1,0,102]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const R=new WeakMap,u=(L,A)=>{const y={controllerId:A};return R.set(L,y),y};e.createPrivateApiFor=u;const O=L=>{const A=R.get(L);if(!A)throw new c.InvalidTestItemError(L?.id||"<unknown>");return A};e.getPrivateApiFor=O}),define(Ce[103],De([1,0,18,2]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function u(A,y){return A.scheme===c.Schemas.http||A.scheme===c.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===c.Schemas.file&&(A=R.URI.from({scheme:c.Schemas.vscodeRemote,authority:y.authority,path:A.path})),R.URI.from({scheme:c.Schemas.https,authority:`${A.scheme}+${O(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=u;function O(A){return A.replace(/./g,y=>{const g=y.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?y:"-"+g.toString(16).padStart(4,"0")})}function L(A){return A.replace(/-([0-9a-f]{4})/g,(y,g)=>String.fromCharCode(parseInt(g,16)))}e.decodeAuthority=L}),define(Ce[254],De([1,0,3,4,103]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class O{constructor(A,y,g){this.d=A,this.e=y,this.f=g,this.a=0,this.b=new R.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const T=y.getVisibleTextEditors();for(const P of this.c.values())T.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,y,g,T,P){let m;for(const S of this.e.getVisibleTextEditors(!0))if(S.value===A){m=S;break}if(!m)throw new Error("not a visible editor");const D=this,C=this.a++,b=new c.Emitter,n=new c.Emitter,h=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(S){return(0,u.asWebviewUri)(S,D.f)}get cspSource(){return u.webviewGenericCspSource}set options(S){this.b=S,D.d.$setOptions(C,S)}get options(){return this.b}set html(S){this.a=S,D.d.$setHtml(C,S)}get html(){return this.a}get onDidReceiveMessage(){return b.event}postMessage(S){return D.d.$postMessage(C,S)}},d=new class{constructor(){this.editor=A,this.line=y,this.height=g,this.webview=h,this.onDidDispose=n.event}dispose(){D.c.has(C)&&(D.c.delete(C),D.d.$disposeEditorInset(C),n.fire(),n.dispose(),b.dispose())}};return this.d.$createEditorInset(C,m.id,m.value.document.uri,y+1,g,T||{},P.identifier,P.extensionLocation),this.c.set(C,{editor:A,inset:d,onDidReceiveMessage:b}),d}$onDidDispose(A){const y=this.c.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this.c.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=O}),define(Ce[255],De([1,0,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var R;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator"})(R||(e.VariableKind=R={}));class u extends Error{constructor(L,A){super(A),this.variable=L}}e.VariableError=u}),define(Ce[256],De([1,0,10,39,12,23,9,117,208,255,11]),function(re,e,c,R,u,O,L,A,y,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(D,C,b,n){this.h=new Map,this.a=D,this.b=C,this.g=b,n&&(this.c=n.then(h=>this.i(h)))}i(D){if(L.isWindows){const C=Object.create(null);return Object.keys(D).forEach(b=>{C[b.toLowerCase()]=D[b]}),C}return D}resolveWithEnvironment(D,C,b){return this.l({env:this.i(D),userHome:void 0},C?C.uri:void 0,b)}async resolveAsync(D,C){const b={env:await this.c,userHome:await this.g};return this.l(b,D?D.uri:void 0,C)}async j(D,C,b,n){const h=O.deepClone(C);L.isWindows&&h.windows?Object.keys(h.windows).forEach(S=>h[S]=h.windows[S]):L.isMacintosh&&h.osx?Object.keys(h.osx).forEach(S=>h[S]=h.osx[S]):L.isLinux&&h.linux&&Object.keys(h.linux).forEach(S=>h[S]=h.linux[S]),delete h.windows,delete h.osx,delete h.linux;const d={env:await this.c,userHome:await this.g};return this.l(d,D?D.uri:void 0,h,b,n)}async resolveAnyAsync(D,C,b){return this.j(D,C,b)}async resolveAnyMap(D,C,b){const n=new Map;return{newConfig:await this.j(D,C,b,n),resolvedVariables:n}}resolveWithInteractionReplace(D,C,b,n){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,C,b,n){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,C){if(this.h.has(D))throw new Error("Variable "+D+" is contributed twice.");this.h.set(D,C)}async l(D,C,b,n,h){if(u.isString(b))return this.m(D,C,b,n,h);if(Array.isArray(b))return Promise.all(b.map(d=>this.l(D,C,d,n,h)));if(u.isObject(b)){const d=Object.create(null),S=await Promise.all(Object.keys(b).map(async w=>[await this.m(D,C,w,n,h),await this.l(D,C,b[w],n,h)]));for(const[w,p]of S)d[w]=p;return d}return b}m(D,C,b,n,h){return(0,T.replaceAsync)(b,P.VARIABLE_REGEXP,async(d,S)=>{if(S.includes(P.VARIABLE_LHS))return d;let w=await this.o(D,d,S,C,n);return h?.set(S,w),w!==d&&u.isString(w)&&w.match(P.VARIABLE_REGEXP)&&(w=await this.m(D,C,w,n,h)),w})}n(D){return this.b?this.b.getUriLabel(D,{noPrefix:!0}):D.fsPath}async o(D,C,b,n,h){let d;const S=b.split(":");S.length>1&&(b=S[0],d=S[1]);const w=a=>{const r=this.a.getFilePath();if(r)return(0,A.normalizeDriveLetter)(r);throw new g.VariableError(a,(0,y.localize)(0,null,C))},p=a=>{const r=w(a);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,A.normalizeDriveLetter)(o)}throw new g.VariableError(a,(0,y.localize)(1,null,C,c.basename(r)))},t=a=>{if(d){const r=this.a.getFolderUri(d);if(r)return r;throw new g.VariableError(a,(0,y.localize)(2,null,C,d))}if(n)return n;throw this.a.getWorkspaceFolderCount()>1?new g.VariableError(a,(0,y.localize)(3,null,C)):new g.VariableError(a,(0,y.localize)(4,null,C))};switch(b){case"env":if(d){if(D.env){const a=D.env[L.isWindows?d.toLowerCase():d];if(u.isString(a))return a}return""}throw new g.VariableError(g.VariableKind.Env,(0,y.localize)(5,null,C));case"config":if(d){const a=this.a.getConfigurationValue(n,d);if(u.isUndefinedOrNull(a))throw new g.VariableError(g.VariableKind.Config,(0,y.localize)(6,null,C,d));if(u.isObject(a))throw new g.VariableError(g.VariableKind.Config,(0,y.localize)(7,null,C,d));return a}throw new g.VariableError(g.VariableKind.Config,(0,y.localize)(8,null,C));case"command":return this.p(g.VariableKind.Command,C,d,h,"command");case"input":return this.p(g.VariableKind.Input,C,d,h,"input");case"extensionInstallFolder":if(d){const a=await this.a.getExtension(d);if(!a)throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,C,d));return this.n(a.extensionLocation)}throw new g.VariableError(g.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,C));default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.n(t(g.VariableKind.WorkspaceFolder)));case"cwd":return n||d?(0,A.normalizeDriveLetter)(this.n(t(g.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(c.basename(this.n(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(D.userHome)return D.userHome;throw new g.VariableError(g.VariableKind.UserHome,(0,y.localize)(11,null,C))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new g.VariableError(g.VariableKind.LineNumber,(0,y.localize)(12,null,C))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new g.VariableError(g.VariableKind.SelectedText,(0,y.localize)(13,null,C))}case"file":return w(g.VariableKind.File);case"fileWorkspaceFolder":return p(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return n||d?c.relative(this.n(t(g.VariableKind.RelativeFile)),w(g.VariableKind.RelativeFile)):w(g.VariableKind.RelativeFile);case"relativeFileDirname":{const a=c.dirname(w(g.VariableKind.RelativeFileDirname));if(n||d){const r=c.relative(this.n(t(g.VariableKind.RelativeFileDirname)),a);return r.length===0?".":r}return a}case"fileDirname":return c.dirname(w(g.VariableKind.FileDirname));case"fileExtname":return c.extname(w(g.VariableKind.FileExtname));case"fileBasename":return c.basename(w(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=c.basename(w(g.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-c.extname(a).length)}case"fileDirnameBasename":return c.basename(c.dirname(w(g.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||C}case"execInstallFolder":{const a=this.a.getAppRoot();return a||C}case"pathSeparator":return c.sep;default:try{const a=d?`${b}:${d}`:b;return this.p(g.VariableKind.Unknown,C,a,h,void 0)}catch{return C}}}}p(D,C,b,n,h){if(b&&n){const d=h===void 0?n[b]:n[h+":"+b];if(typeof d=="string")return d;throw new g.VariableError(D,(0,y.localize)(14,null,C))}return C}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[137],De([1,0,5,133]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var u;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(u||(e.GroupDirection=u={}));var O;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var L;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var A;(function(C){C[C.MAXIMIZE=0]="MAXIMIZE",C[C.EVEN=1]="EVEN",C[C.TOGGLE=2]="TOGGLE"})(A||(e.GroupsArrangement=A={}));var y;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function g(C){const b=C;return(0,R.isEditorInput)(b?.editor)&&(0,R.isEditorInput)(b?.replacement)}e.isEditorReplacement=g;var T;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var P;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function m(C){const b=C;return!!b&&typeof b.id=="number"&&Array.isArray(b.editors)}e.isEditorGroup=m;function D(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=D}),define(Ce[257],De([1,0,5,137]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function u(O){const L=O;return typeof O=="number"||(0,R.isEditorGroup)(L)}e.isPreferredGroup=u}),define(Ce[258],De([1,0,5,214]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(R.IEnvironmentService)}),define(Ce[138],De([1,0,26,3,10,4]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class L{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=L;class A{static isHostExtension(n,h,d){if(h.getExtensionDescription(n))return!1;const S=d.getExtensionDescription(n);return S?!!((S.main||S.browser)&&S.api==="none"):!1}constructor(n,h){this.h=n,this.c=new R.Emitter,this.onDidChange=this.c.event,this.d=h,this.j()}j(){this.d.sort(D),this.e=new c.ExtensionIdentifierMap,this.f=[],this.g=new Map;for(const n of this.d){if(this.e.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.e.set(n.identifier,n),this.f.push(n);const h=this.h.readActivationEvents(n);if(Array.isArray(h))for(let d of h)d==="onUri"&&(d=`onUri:${c.ExtensionIdentifier.toKey(n.identifier)}`),this.g.has(d)||this.g.set(d,[]),this.g.get(d).push(n)}}set(n){this.d=n,this.j(),this.c.fire(void 0)}deltaExtensions(n,h){this.d=C(this.d,h),this.d=this.d.concat(n);const d=A.k(this.d);return this.d=C(this.d,d.map(S=>S.identifier)),this.j(),this.c.fire(void 0),new L(d)}static k(n){const h=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(t){this.d.has(t)||(this.d.add(t),this.e.push(t))}addArc(t,a){this.addNode(t),this.addNode(a),this.c.has(t)?this.c.get(t).push(a):this.c.set(t,[a])}getArcs(t){return this.c.has(t)?this.c.get(t):[]}hasOnlyGoodArcs(t,a){const r=h.getArcs(t);for(let o=0;o<r.length;o++)if(!a.has(r[o]))return!1;return!0}getNodes(){return this.e}},d=new c.ExtensionIdentifierMap;for(const t of n)if(d.set(t.identifier,t),t.extensionDependencies)for(const a of t.extensionDependencies)h.addArc(c.ExtensionIdentifier.toKey(t.identifier),c.ExtensionIdentifier.toKey(a));const S=new Set;h.getNodes().filter(t=>h.getArcs(t).length===0).forEach(t=>S.add(t));const w=h.getNodes().filter(t=>!S.has(t));let p;do{p=!1;for(let t=0;t<w.length;t++){const a=w[t];h.hasOnlyGoodArcs(a,S)&&(w.splice(t,1),t--,S.add(a),p=!0)}}while(p);return w.map(t=>d.get(t))}containsActivationEvent(n){return this.g.has(n)}containsExtension(n){return this.e.has(n)}getExtensionDescriptionsForActivationEvent(n){const h=this.g.get(n);return h?h.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(n){const h=this.e.get(n);return h||void 0}getExtensionDescriptionByUUID(n){for(const h of this.f)if(h.uuid===n)return h}getExtensionDescriptionByIdOrUUID(n,h){return this.getExtensionDescription(n)??(h?this.getExtensionDescriptionByUUID(h):void 0)}}e.ExtensionDescriptionRegistry=A,e.basicActivationEventsReader={readActivationEvents:b=>b.activationEvents};class y{constructor(n){this.d=new P,this.c=new A(n,[])}async acquireLock(n){const h=await this.d.acquire(n);return new g(this,h)}deltaExtensions(n,h,d){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(h,d)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,h){return this.c.getExtensionDescriptionByIdOrUUID(n,h)}}e.LockableExtensionDescriptionRegistry=y;class g extends O.Disposable{constructor(n,h){super(),this.f=n,this.c=!1,this.B(h)}isAcquiredFor(n){return!this.c&&this.f===n}}e.ExtensionDescriptionRegistryLock=g;class T{constructor(n){this.name=n,this.promise=new Promise((h,d)=>{this.c=h})}resolve(n){this.c(n)}}class P{constructor(){this.c=[],this.d=!1}async acquire(n){const h=new T(n);return this.c.push(h),this.e(),h.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let h=!0;const d=setTimeout(()=>{h&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),S=()=>{h&&(clearTimeout(d),h=!1,this.d=!1,this.e())};n.resolve((0,O.toDisposable)(S))}}var m;(function(b){b[b.Builtin=0]="Builtin",b[b.User=1]="User",b[b.Dev=2]="Dev"})(m||(m={}));function D(b,n){const h=b.isBuiltin?0:b.isUnderDevelopment?2:1,d=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(h!==d)return h-d;const S=u.posix.basename(b.extensionLocation.path),w=u.posix.basename(n.extensionLocation.path);return S<w?-1:S>w?1:0}function C(b,n){const h=new c.ExtensionIdentifierSet(n);return b.filter(d=>!h.has(d.identifier))}}),define(Ce[259],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(c||(e.ExtHostConnectionType=c={}));class R{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[R.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=R,R.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class u{constructor(){this.type=2}serialize(P){P[u.ENV_KEY]="1"}}e.SocketExtHostConnection=u,u.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class O{constructor(){this.type=3}serialize(P){P[O.ENV_KEY]="1"}}e.MessagePortExtHostConnection=O,O.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function L(T){delete T[R.ENV_KEY],delete T[u.ENV_KEY],delete T[O.ENV_KEY]}function A(T,P){L(P),T.serialize(P)}e.writeExtHostConnection=A;function y(T){if(T[R.ENV_KEY])return g(T,new R(T[R.ENV_KEY]));if(T[u.ENV_KEY])return g(T,new u);if(T[O.ENV_KEY])return g(T,new O);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function g(T,P){return L(T),P}}),define(Ce[104],De([1,0,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(R||(e.UIKind=R={}));var u;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(u||(e.ExtensionHostExitCode=u={}));var O;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function L(g){const T=c.VSBuffer.alloc(1);switch(g){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}e.createMessageOfType=L;function A(g,T){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}e.isMessageOfType=A;var y;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(Ce[82],De([1,0,5,3,17,27,104,78,79,23,2,4,195]),function(re,e,c,R,u,O,L,A,y,g,T,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let D=e.ExtHostTelemetry=class extends P.Disposable{constructor(h,d){super(),this.n=h,this.p=d,this.a=this.B(new R.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=T.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=d.createLogger(this.j,{id:y.extensionTelemetryLogChannelId,name:(0,m.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(d.onDidChangeLogLevel(S=>{(0,u.isLogLevel)(S)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===u.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(h,d,S){const w=this.getTelemetryDetails(),p=new C(d,S,h,this.k,this.i,this.getBuiltInCommonProperties(h),{isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled}),t=this.m.get(h.identifier.value)??[];return this.m.set(h.identifier.value,[...t,p]),p.apiTelemetryLogger}$initializeTelemetryLevel(h,d,S){this.f=h,this.g=d,this.c=S??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(h){const d=Object.create(null);switch(d["common.extname"]=`${h.publisher}.${h.name}`,d["common.extversion"]=h.version,d["common.vscodemachineid"]=this.n.telemetryInfo.machineId,d["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,d["common.vscodeversion"]=this.n.version,d["common.isnewappinstall"]=b(this.n.telemetryInfo.firstSessionDate),d["common.product"]=this.n.environment.appHost,this.n.uiKind){case L.UIKind.Web:d["common.uikind"]="web";break;case L.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.n.remote.authority)),d}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const d=this.getTelemetryDetails();this.m.forEach((S,w)=>{const p=S.filter(t=>!t.isDisposed);p.length===0?this.m.delete(w):this.m.set(w,p)}),this.m.forEach(S=>{for(const w of S)w.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(h,d){const w=this.m.get(h.value)?.filter(t=>!t.isDisposed);if(!w)return this.m.delete(h.value),!1;let p=!1;for(const t of w)t.ignoreUnhandledExtHostErrors||(t.logError(d),p=!0);return p}};e.ExtHostTelemetry=D=qe([je(0,O.IExtHostInitDataService),je(1,u.ILoggerService)],D);class C{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,d,S,w,p,t,a){this.g=S,this.h=w,this.i=p,this.j=t,this.a=new R.Emitter,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.b=d?.ignoreBuiltInCommonProperties??!1,this.c=d?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(h,d){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:d},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let d="properties"in h?h.properties??{}:h;return d=(0,y.cleanData)(d,[]),this.c&&(d=(0,g.mixin)(d,this.c)),this.b||(d=(0,g.mixin)(d,this.j)),"properties"in h?h.properties=d:h=d,h}k(h,d){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f?.sendEventData(h,d),this.h.trace(h,d))}logUsage(h,d){this.d.isUsageEnabled&&this.k(h,d)}logError(h,d){!this.d.isErrorsEnabled||!this.f||(typeof h=="string"?this.k(h,d):this.f.sendErrorData(h,d))}get apiTelemetryLogger(){if(!this.e){const h=this,d={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(d)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=C;function b(n){const h=Date.now()-new Date(n).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.isNewAppInstall=b,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(Ce[25],De([1,0,3,2,235,131,26,5]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class y{constructor(p){this.dependency=p}}e.MissingExtensionDependency=y;var g;(function(w){w[w.EagerAutoStart=1]="EagerAutoStart",w[w.EagerManualStart=2]="EagerManualStart",w[w.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class T{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:O.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(p,t){const a=[],r=[],o=[],f=[],v=P(this.c),l=P(p),I=(F,$)=>F.extensionLocation.toString()===$.extensionLocation.toString()||F.isBuiltin===$.isBuiltin||F.isUserBuiltin===$.isUserBuiltin||F.isUnderDevelopment===$.isUnderDevelopment;for(const F of this.c){const $=l.get(F.identifier);if(!$){a.push(F.identifier),v.delete(F.identifier);continue}if(!I(F,$)){a.push(F.identifier),v.delete(F.identifier);continue}}for(const F of p){const $=v.get(F.identifier);if(!$){r.push(F);continue}if(!I($,F)){a.push($.identifier),v.delete($.identifier);continue}}const E=new L.ExtensionIdentifierSet(this.d),s=new L.ExtensionIdentifierSet(t);for(const F of this.d)s.has(F)||o.push(F);for(const F of t)E.has(F)||f.push(F);const i=O.ImplicitActivationEvents.createActivationEventsMap(r),k={toRemove:a,toAdd:r,addActivationEvents:i,myToRemove:o,myToAdd:f};return this.delta(k),k}delta(p){const{toRemove:t,toAdd:a,myToRemove:r,myToAdd:o}=p,f=new L.ExtensionIdentifierSet(t),v=new L.ExtensionIdentifierSet(r);for(let l=0;l<this.c.length;l++)f.has(this.c[l].identifier)&&(this.c.splice(l,1),l--);for(let l=0;l<this.d.length;l++)v.has(this.d[l])&&(this.d.splice(l,1),l--);for(const l of a)this.c.push(l);for(const l of o)this.d.push(l)}containsExtension(p){for(const t of this.d)if(L.ExtensionIdentifier.equals(t,p))return!0;return!1}}e.ExtensionHostExtensions=T;function P(w){const p=new L.ExtensionIdentifierMap;for(const t of w)p.set(t.identifier,t);return p}function m(w,p){return!0}e.isProposedApiEnabled=m;function D(w,p){if(!m(w,p))throw new Error(`Extension '${w.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${w.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.checkProposedApiEnabled=D;class C{constructor(p,t,a,r){this.codeLoadingTime=p,this.activateCallTime=t,this.activateResolvedTime=a,this.activationReason=r}}e.ActivationTimes=C;class b{constructor(p,t){this.description=p,this.value=t}}e.ExtensionPointContribution=b;var n;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(n||(e.ActivationKind=n={}));function h(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,u.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation,targetPlatform:w.targetPlatform,validations:[],isValid:!0}}e.toExtension=h;function d(w,p){return{identifier:new L.ExtensionIdentifier((0,u.getExtensionId)(w.manifest.publisher,w.manifest.name)),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!p,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid,targetPlatform:w.targetPlatform}}e.toExtensionDescription=d;class S{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.onWillStop=c.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(p,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=S}),define(Ce[260],De([1,0,8,138,26,25,17,16]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(h,d,S,w){this.startup=h,this.codeLoadingTime=d,this.activateCallTime=S,this.activateResolvedTime=w}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class g{constructor(h){this.a=h,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(h,d){return h===-1||d===-1?-1:d-h}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=g;class T{constructor(h,d,S,w,p,t){this.activationFailed=h,this.activationFailedError=d,this.activationTimes=S,this.module=w,this.exports=p,this.subscriptions=t}}e.ActivatedExtension=T;class P extends T{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class m extends T{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=m;class D extends T{constructor(h){super(!0,h,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=e.ExtensionsActivator=class{constructor(h,d,S,w){this.g=w,this.a=h,this.b=d,this.c=S,this.d=new u.ExtensionIdentifierMap,this.f=Object.create(null)}dispose(){for(const[h,d]of this.d)d.dispose()}async waitForActivatingExtensions(){const h=[];for(const[d,S]of this.d)h.push(S.wait());await Promise.all(h)}isActivated(h){const d=this.d.get(h);return!!(d&&d.value)}getActivatedExtension(h){const d=this.d.get(h);if(!d||!d.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return d.value}async activateByEvent(h,d){if(this.f[h])return;const S=this.a.getExtensionDescriptionsForActivationEvent(h);await this.h(S.map(w=>({id:w.identifier,reason:{startup:d,extensionId:w.identifier,activationEvent:h}}))),this.f[h]=!0}activateById(h,d){const S=this.a.getExtensionDescription(h);if(!S)throw new Error(`Extension '${h}' is not known`);return this.h([{id:S.identifier,reason:d}])}async h(h){const d=h.filter(S=>!this.isActivated(S.id)).map(S=>this.j(S));await Promise.all(d.map(S=>S.wait()))}j(h){if(this.d.has(h.id))return this.d.get(h.id);if(this.l(h.id))return this.k(h,null,[],null);const d=this.a.getExtensionDescription(h.id);if(!d){const p=new Error(`Cannot activate unknown extension '${h.id.value}'`),t=this.k(h,null,[],new D(p));return this.c.onExtensionActivationError(h.id,p,new O.MissingExtensionDependency(h.id.value)),t}const S=[],w=typeof d.extensionDependencies>"u"?[]:d.extensionDependencies;for(const p of w){if(this.m(p))continue;const t=this.d.get(p);if(t){S.push(t);continue}if(this.l(p)){S.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:h.reason}));continue}const a=this.a.getExtensionDescription(p);if(a){if(!a.main&&!a.browser)continue;S.push(this.j({id:a.identifier,reason:h.reason}));continue}const r=d.displayName||d.identifier.value,o=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${p}'`),f=this.k(h,d.displayName,[],new D(o));return this.c.onExtensionActivationError(d.identifier,o,new O.MissingExtensionDependency(p)),f}return this.k(h,d.displayName,S,null)}k(h,d,S,w){const p=new b(h.id,d,h.reason,S,w,this.c,this.g);return this.d.set(h.id,p),p}l(h){return R.ExtensionDescriptionRegistry.isHostExtension(h,this.a,this.b)}m(h){const d=this.b.getExtensionDescription(h);return d?!d.main&&!d.browser:!1}};e.ExtensionsActivator=C=qe([je(3,L.ILogService)],C);let b=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(h,d,S,w,p,t,a){this.c=h,this.d=d,this.f=S,this.g=w,this.h=p,this.j=t,this.k=a,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let h=0;h<this.g.length;h++){const d=this.g[h];if(d.value&&!d.value.activationFailed){this.g.splice(h,1),h--;continue}if(d.value&&d.value.activationFailed){const S=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${d.friendlyName}' failed to activate`);S.detail=d.value.activationFailedError,this.h=new D(S),this.j.onExtensionActivationError(this.c,S,null);return}}this.g.length>0&&await Promise.race(this.g.map(h=>h.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(h){const d=new Error;if(h&&h.name&&(d.name=h.name),h&&h.message?d.message=`Activating extension '${this.c.value}' failed: ${h.message}.`:d.message=`Activating extension '${this.c.value}' failed: ${h}.`,h&&h.stack&&(d.stack=h.stack),this.h=new D(d),this.b&&c.isCancellationError(h))return;this.j.onExtensionActivationError(this.c,d,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(h)}}};b=qe([je(6,L.ILogService)],b)});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,R,u){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Ne=this&&this.__classPrivateFieldGet||function(re,e,c,R){if(c==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?R:c==="a"?R.call(re):R?R.value:e.get(re)};define(Ce[7],De([1,0,19,8,116,28,91,11,12,2,33,26,31,130,101,25]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b){"use strict";var n,h,d,S,w,p,t,a,r,o,f,v,l,I,E,s,i,k,F,$,j,W,U,x,B,z;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.ThreadFocus=e.StackFrameFocus=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.InternalFileDataTransferItem=e.InternalDataTransferItem=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.asStatusBarItemIdentifier=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.NotebookCodeActionKind=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ManagedResolvedAuthority=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function ee(K){return Object.assign(K,{apply:function(){const ve=arguments.length===1?[]:arguments[1];return Reflect.construct(K,ve,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(K,[]);{const[ve,...Le]=arguments;return Reflect.construct(K,Le,ve.constructor)}}})}var se;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(se||(e.TerminalOutputAnchor=se={}));var V;(function(K){K[K.Command=0]="Command",K[K.Opener=1]="Opener"})(V||(e.TerminalQuickFixType=V={}));let Z=e.Disposable=r=class{static from(...H){let ve=H;return new r(function(){if(ve){for(const Le of ve)Le&&typeof Le.dispose=="function"&&Le.dispose();ve=void 0}})}constructor(H){n.set(this,void 0),Ze(this,n,H,"f")}dispose(){typeof Ne(this,n,"f")=="function"&&(Ne(this,n,"f").call(this),Ze(this,n,void 0,"f"))}};n=new WeakMap,e.Disposable=Z=r=qe([ee],Z);let q=e.Position=o=class{static Min(...H){if(H.length===0)throw new TypeError;let ve=H[0];for(let Le=1;Le<H.length;Le++){const Ke=H[Le];Ke.isBefore(ve)&&(ve=Ke)}return ve}static Max(...H){if(H.length===0)throw new TypeError;let ve=H[0];for(let Le=1;Le<H.length;Le++){const Ke=H[Le];Ke.isAfter(ve)&&(ve=Ke)}return ve}static isPosition(H){if(!H)return!1;if(H instanceof o)return!0;const{line:ve,character:Le}=H;return typeof ve=="number"&&typeof Le=="number"}static of(H){if(H instanceof o)return H;if(this.isPosition(H))return new o(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,ve){if(H<0)throw(0,R.illegalArgument)("line must be non-negative");if(ve<0)throw(0,R.illegalArgument)("character must be non-negative");this.c=H,this.e=ve}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,ve=0){if(H===null||ve===null)throw(0,R.illegalArgument)();let Le;return typeof H>"u"?Le=0:typeof H=="number"?Le=H:(Le=typeof H.lineDelta=="number"?H.lineDelta:0,ve=typeof H.characterDelta=="number"?H.characterDelta:0),Le===0&&ve===0?this:new o(this.line+Le,this.character+ve)}with(H,ve=this.character){if(H===null||ve===null)throw(0,R.illegalArgument)();let Le;return typeof H>"u"?Le=this.line:typeof H=="number"?Le=H:(Le=typeof H.line=="number"?H.line:this.line,ve=typeof H.character=="number"?H.character:this.character),Le===this.line&&ve===this.character?this:new o(Le,ve)}toJSON(){return{line:this.line,character:this.character}}};e.Position=q=o=qe([ee],q);let ae=e.Range=f=class{static isRange(H){return H instanceof f?!0:H?q.isPosition(H.start)&&q.isPosition(H.end):!1}static of(H){if(H instanceof f)return H;if(this.isRange(H))return new f(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,ve,Le,Ke){let _e,at;if(typeof H=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof Ke=="number"?(_e=new q(H,ve),at=new q(Le,Ke)):q.isPosition(H)&&q.isPosition(ve)&&(_e=q.of(H),at=q.of(ve)),!_e||!at)throw new Error("Invalid arguments");_e.isBefore(at)?(this.c=_e,this.e=at):(this.c=at,this.e=_e)}contains(H){return f.isRange(H)?this.contains(H.start)&&this.contains(H.end):q.isPosition(H)?!(q.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const ve=q.Max(H.start,this.c),Le=q.Min(H.end,this.e);if(!ve.isAfter(Le))return new f(ve,Le)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const ve=q.Min(H.start,this.c),Le=q.Max(H.end,this.end);return new f(ve,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,ve=this.end){if(H===null||ve===null)throw(0,R.illegalArgument)();let Le;return H?q.isPosition(H)?Le=H:(Le=H.start||this.start,ve=H.end||this.end):Le=this.start,Le.isEqual(this.c)&&ve.isEqual(this.end)?this:new f(Le,ve)}toJSON(){return[this.start,this.end]}};e.Range=ae=f=qe([ee],ae);let Ee=e.Selection=v=class extends ae{static isSelection(H){return H instanceof v?!0:H?ae.isRange(H)&&q.isPosition(H.anchor)&&q.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,ve,Le,Ke){let _e,at;if(typeof H=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof Ke=="number"?(_e=new q(H,ve),at=new q(Le,Ke)):q.isPosition(H)&&q.isPosition(ve)&&(_e=q.of(H),at=q.of(ve)),!_e||!at)throw new Error("Invalid arguments");super(_e,at),this.f=_e,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=Ee=v=qe([ee],Ee);const ye=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,R.illegalArgument)("connectionToken")};class be{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,ve,Le){if(typeof H!="string"||H.length===0)throw(0,R.illegalArgument)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,R.illegalArgument)("port");typeof Le<"u"&&ye(Le),this.host=H,this.port=Math.round(ve),this.connectionToken=Le}}e.ResolvedAuthority=be;class M{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,ve){this.makeConnection=H,this.connectionToken=ve,typeof ve<"u"&&ye(ve)}}e.ManagedResolvedAuthority=M;class Q extends Error{static NotAvailable(H,ve){return new Q(H,D.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(H){return new Q(H,D.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,ve=D.RemoteAuthorityResolverErrorCode.Unknown,Le){super(H),this._message=H,this._code=ve,this._detail=Le,Object.setPrototypeOf(this,Q.prototype)}}e.RemoteAuthorityResolverError=Q;var fe;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(fe||(e.EndOfLine=fe={}));var we;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(we||(e.EnvironmentVariableMutatorType=we={}));let _=e.TextEdit=l=class{static isTextEdit(H){return H instanceof l?!0:H?ae.isRange(H)&&typeof H.newText=="string":!1}static replace(H,ve){return new l(H,ve)}static insert(H,ve){return l.replace(new ae(H,H),ve)}static delete(H){return l.replace(H,"")}static setEndOfLine(H){const ve=new l(new ae(new q(0,0),new q(0,0)),"");return ve.newEol=H,ve}get range(){return this.c}set range(H){if(H&&!ae.isRange(H))throw(0,R.illegalArgument)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,R.illegalArgument)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,R.illegalArgument)("newEol");this.f=H}constructor(H,ve){this.c=H,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.TextEdit=_=l=qe([ee],_);let ne=e.NotebookEdit=I=class{static isNotebookCellEdit(H){return H instanceof I?!0:H?Zt.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,ve){return new I(H,ve)}static insertCells(H,ve){return new I(new Zt(H,H),ve)}static deleteCells(H){return new I(H,[])}static updateCellMetadata(H,ve){const Le=new I(new Zt(H,H),[]);return Le.newCellMetadata=ve,Le}static updateNotebookMetadata(H){const ve=new I(new Zt(0,0),[]);return ve.newNotebookMetadata=H,ve}constructor(H,ve){this.range=H,this.newCells=ve}};e.NotebookEdit=ne=I=qe([ee],ne);class le{static isSnippetTextEdit(H){return H instanceof le?!0:H?ae.isRange(H.range)&&oe.isSnippetString(H.snippet):!1}static replace(H,ve){return new le(H,ve)}static insert(H,ve){return le.replace(new ae(H,H),ve)}constructor(H,ve){this.range=H,this.snippet=ve}}e.SnippetTextEdit=le;var te;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(te||(e.FileEditType=te={}));let de=e.WorkspaceEdit=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,ve,Le,Ke){this.c.push({_type:1,from:H,to:ve,options:Le,metadata:Ke})}createFile(H,ve,Le){this.c.push({_type:1,from:void 0,to:H,options:ve,metadata:Le})}deleteFile(H,ve,Le){this.c.push({_type:1,from:H,to:void 0,options:ve,metadata:Le})}e(H,ve,Le){this.c.push({_type:3,metadata:Le,uri:H,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(H,ve,Le,Ke){const _e=ve.start,at=ve.end;(_e!==at||Le.length>0)&&this.c.push({_type:5,uri:H,index:_e,count:at-_e,cells:Le,metadata:Ke})}g(H,ve,Le,Ke){this.c.push({_type:3,metadata:Ke,uri:H,edit:{editType:8,index:ve,metadata:Le}})}replace(H,ve,Le,Ke){this.c.push({_type:2,uri:H,edit:new _(ve,Le),metadata:Ke})}insert(H,ve,Le,Ke){this.replace(H,new ae(ve,ve),Le,Ke)}delete(H,ve,Le){this.replace(H,ve,"",Le)}has(H){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===H.toString())}set(H,ve){if(ve)for(const Le of ve){if(!Le)continue;let Ke,_e;Array.isArray(Le)?(Ke=Le[0],_e=Le[1]):Ke=Le,ne.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(H,Ke.range.start,Ke.newCellMetadata,_e):Ke.newNotebookMetadata?this.e(H,Ke.newNotebookMetadata,_e):this.f(H,Ke.range,Ke.newCells,_e):le.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:H,range:Ke.range,edit:Ke.snippet,metadata:_e}):this.c.push({_type:2,uri:H,edit:Ke,metadata:_e})}else{for(let Le=0;Le<this.c.length;Le++){const Ke=this.c[Le];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===H.toString()&&(this.c[Le]=void 0);break}}(0,c.coalesceInPlace)(this.c)}}get(H){const ve=[];for(const Le of this.c)Le._type===2&&Le.uri.toString()===H.toString()&&ve.push(Le.edit);return ve}entries(){const H=new O.ResourceMap;for(const ve of this.c)if(ve._type===2){let Le=H.get(ve.uri);Le||(Le=[ve.uri,[]],H.set(ve.uri,Le)),Le[1].push(ve.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=de=qe([ee],de);let oe=e.SnippetString=E=class{static isSnippetString(H){return H instanceof E?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=E.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,ve=this.e++){if(typeof H=="function"){const Le=new E;Le.e=this.e,H(Le),this.e=Le.e,H=Le.value}else H=E.c(H);return this.value+="${",this.value+=ve,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,ve=this.e++){const Le=H.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(H,ve){if(typeof ve=="function"){const Le=new E;Le.e=this.e,ve(Le),this.e=Le.e,ve=Le.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.SnippetString=oe=E=qe([ee],oe);var ue;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(ue||(e.DiagnosticTag=ue={}));var N;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(N||(e.DiagnosticSeverity=N={}));let G=e.Location=s=class{static isLocation(H){return H instanceof s?!0:H?ae.isRange(H.range)&&g.URI.isUri(H.uri):!1}constructor(H,ve){if(this.uri=H,ve)if(ae.isRange(ve))this.range=ae.of(ve);else if(q.isPosition(ve))this.range=new ae(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=G=s=qe([ee],G);let Y=e.DiagnosticRelatedInformation=class{static is(H){return H?typeof H.message=="string"&&H.location&&ae.isRange(H.location.range)&&g.URI.isUri(H.location.uri):!1}constructor(H,ve){this.location=H,this.message=ve}static isEqual(H,ve){return H===ve?!0:!H||!ve?!1:H.message===ve.message&&H.location.range.isEqual(ve.location.range)&&H.location.uri.toString()===ve.location.uri.toString()}};e.DiagnosticRelatedInformation=Y=qe([ee],Y);let ie=e.Diagnostic=class{constructor(H,ve,Le=N.Error){if(!ae.isRange(H))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=H,this.message=ve,this.severity=Le}toJSON(){return{severity:N[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,ve){return H===ve?!0:!H||!ve?!1:H.message===ve.message&&H.severity===ve.severity&&H.code===ve.code&&H.severity===ve.severity&&H.source===ve.source&&H.range.isEqual(ve.range)&&(0,c.equals)(H.tags,ve.tags)&&(0,c.equals)(H.relatedInformation,ve.relatedInformation,Y.isEqual)}};e.Diagnostic=ie=qe([ee],ie);let pe=e.Hover=class{constructor(H,ve){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=ve}};e.Hover=pe=qe([ee],pe);var Ie;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(Ie||(e.DocumentHighlightKind=Ie={}));let he=e.DocumentHighlight=class{constructor(H,ve=Ie.Text){this.range=H,this.kind=ve}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};e.DocumentHighlight=he=qe([ee],he);var Re;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(Re||(e.SymbolKind=Re={}));var Te;(function(K){K[K.Deprecated=1]="Deprecated"})(Te||(e.SymbolTag=Te={}));let Ve=e.SymbolInformation=i=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,ve,Le,Ke,_e){this.name=H,this.kind=ve,this.containerName=_e,typeof Le=="string"&&(this.containerName=Le),Ke instanceof G?this.location=Ke:Le instanceof ae&&(this.location=new G(Ke,Le)),i.validate(this)}toJSON(){return{name:this.name,kind:Re[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=Ve=i=qe([ee],Ve);let xe=e.DocumentSymbol=k=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(k.validate)}constructor(H,ve,Le,Ke,_e){this.name=H,this.detail=ve,this.kind=Le,this.range=Ke,this.selectionRange=_e,this.children=[],k.validate(this)}};e.DocumentSymbol=xe=k=qe([ee],xe);var tt;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(tt||(e.CodeActionTriggerKind=tt={}));let Qe=e.CodeAction=class{constructor(H,ve){this.title=H,this.kind=ve}};e.CodeAction=Qe=qe([ee],Qe);let Xe=e.CodeActionKind=F=class{constructor(H){this.value=H}append(H){return new F(this.value?this.value+F.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+F.c)}};Xe.c=".",e.CodeActionKind=Xe=F=qe([ee],Xe);class nt extends Xe{constructor(H){super(H),this.value=H}}e.NotebookCodeActionKind=nt,Xe.Empty=new Xe(""),Xe.QuickFix=Xe.Empty.append("quickfix"),Xe.Refactor=Xe.Empty.append("refactor"),Xe.RefactorExtract=Xe.Refactor.append("extract"),Xe.RefactorInline=Xe.Refactor.append("inline"),Xe.RefactorMove=Xe.Refactor.append("move"),Xe.RefactorRewrite=Xe.Refactor.append("rewrite"),Xe.Source=Xe.Empty.append("source"),Xe.SourceOrganizeImports=Xe.Source.append("organizeImports"),Xe.SourceFixAll=Xe.Source.append("fixAll"),Xe.Notebook=Xe.Empty.append("notebook");let ot=e.SelectionRange=class{constructor(H,ve){if(this.range=H,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=ot=qe([ee],ot);class et{constructor(H,ve,Le,Ke,_e,at){this.kind=H,this.name=ve,this.detail=Le,this.uri=Ke,this.range=_e,this.selectionRange=at}}e.CallHierarchyItem=et;class Be{constructor(H,ve){this.fromRanges=ve,this.from=H}}e.CallHierarchyIncomingCall=Be;class ke{constructor(H,ve){this.fromRanges=ve,this.to=H}}e.CallHierarchyOutgoingCall=ke;var X;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(X||(e.LanguageStatusSeverity=X={}));let J=e.CodeLens=class{constructor(H,ve){this.range=H,this.command=ve}get isResolved(){return!!this.command}};e.CodeLens=J=qe([ee],J);let me=e.MarkdownString=$=class{static isMarkdownString(H){return H instanceof $?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,ve=!1){h.set(this,void 0),Ze(this,h,new u.MarkdownString(H,{supportThemeIcons:ve}),"f")}get value(){return Ne(this,h,"f").value}set value(H){Ne(this,h,"f").value=H}get isTrusted(){return Ne(this,h,"f").isTrusted}set isTrusted(H){Ne(this,h,"f").isTrusted=H}get supportThemeIcons(){return Ne(this,h,"f").supportThemeIcons}set supportThemeIcons(H){Ne(this,h,"f").supportThemeIcons=H}get supportHtml(){return Ne(this,h,"f").supportHtml}set supportHtml(H){Ne(this,h,"f").supportHtml=H}get baseUri(){return Ne(this,h,"f").baseUri}set baseUri(H){Ne(this,h,"f").baseUri=H}appendText(H){return Ne(this,h,"f").appendText(H),this}appendMarkdown(H){return Ne(this,h,"f").appendMarkdown(H),this}appendCodeblock(H,ve){return Ne(this,h,"f").appendCodeblock(ve??"",H),this}};h=new WeakMap,e.MarkdownString=me=$=qe([ee],me);let Fe=e.ParameterInformation=class{constructor(H,ve){this.label=H,this.documentation=ve}};e.ParameterInformation=Fe=qe([ee],Fe);let ze=e.SignatureInformation=class{constructor(H,ve){this.label=H,this.documentation=ve,this.parameters=[]}};e.SignatureInformation=ze=qe([ee],ze);let He=e.SignatureHelp=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=He=qe([ee],He);var Je;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(Je||(e.SignatureHelpTriggerKind=Je={}));var ct;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(ct||(e.InlayHintKind=ct={}));let st=e.InlayHintLabelPart=class{constructor(H){this.value=H}};e.InlayHintLabelPart=st=qe([ee],st);let ft=e.InlayHint=class{constructor(H,ve,Le){this.position=H,this.label=ve,this.kind=Le}};e.InlayHint=ft=qe([ee],ft);var Pt;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Pt||(e.CompletionTriggerKind=Pt={}));var Tt;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Tt||(e.CompletionItemKind=Tt={}));var vt;(function(K){K[K.Deprecated=1]="Deprecated"})(vt||(e.CompletionItemTag=vt={}));let Ht=e.CompletionItem=class{constructor(H,ve){this.label=H,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&Tt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=Ht=qe([ee],Ht);let Mt=e.CompletionList=class{constructor(H=[],ve=!1){this.items=H,this.isIncomplete=ve}};e.CompletionList=Mt=qe([ee],Mt);let qt=e.InlineSuggestion=class{constructor(H,ve,Le){this.insertText=H,this.range=ve,this.command=Le}};e.InlineSuggestion=qt=qe([ee],qt);let Ft=e.InlineSuggestionList=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.InlineSuggestionList=Ft=qe([ee],Ft);var Ut;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(Ut||(e.ViewColumn=Ut={}));var jt;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(jt||(e.StatusBarAlignment=jt={}));function ut(K,H){return`${P.ExtensionIdentifier.toKey(K)}.${H}`}e.asStatusBarItemIdentifier=ut;var gt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(gt||(e.TextEditorLineNumbersStyle=gt={}));var Bt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Bt||(e.TextDocumentSaveReason=Bt={}));var $t;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})($t||(e.TextEditorRevealType=$t={}));var yt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(yt||(e.TextEditorSelectionChangeKind=yt={}));var mt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(mt||(e.TextDocumentChangeReason=mt={}));var kt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(kt||(e.DecorationRangeBehavior=kt={})),function(K){function H(ve){switch(ve){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=H}(yt||(e.TextEditorSelectionChangeKind=yt={}));let zt=e.DocumentLink=class{constructor(H,ve){if(ve&&!g.URI.isUri(ve))throw(0,R.illegalArgument)("target");if(!ae.isRange(H)||H.isEmpty)throw(0,R.illegalArgument)("range");this.range=H,this.target=ve}};e.DocumentLink=zt=qe([ee],zt);let Oe=e.Color=class{constructor(H,ve,Le,Ke){this.red=H,this.green=ve,this.blue=Le,this.alpha=Ke}};e.Color=Oe=qe([ee],Oe);let Ae=e.ColorInformation=class{constructor(H,ve){if(ve&&!(ve instanceof Oe))throw(0,R.illegalArgument)("color");if(!ae.isRange(H)||H.isEmpty)throw(0,R.illegalArgument)("range");this.range=H,this.color=ve}};e.ColorInformation=Ae=qe([ee],Ae);let Pe=e.ColorPresentation=class{constructor(H){if(!H||typeof H!="string")throw(0,R.illegalArgument)("label");this.label=H}};e.ColorPresentation=Pe=qe([ee],Pe);var ce;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(ce||(e.ColorFormat=ce={}));var Me;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Me||(e.SourceControlInputBoxValidationType=Me={}));var We;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(We||(e.TerminalExitReason=We={}));class Ye{constructor(H,ve,Le){if(this.startIndex=H,this.length=ve,this.tooltip=Le,typeof H!="number"||H<0)throw(0,R.illegalArgument)("startIndex");if(typeof ve!="number"||ve<1)throw(0,R.illegalArgument)("length");if(Le!==void 0&&typeof Le!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=Ye;class Ge{constructor(H){this.uri=H}}e.TerminalQuickFixOpener=Ge;class it{constructor(H){this.terminalCommand=H}}e.TerminalQuickFixCommand=it;var Ct;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(Ct||(e.TerminalLocation=Ct={}));class Lt{constructor(H){if(this.options=H,typeof H!="object")throw(0,R.illegalArgument)("options")}}e.TerminalProfile=Lt;var At;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(At||(e.TaskRevealKind=At={}));var Et;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(Et||(e.TaskPanelKind=Et={}));let lt=e.TaskGroup=j=class{static from(H){switch(H){case"clean":return j.Clean;case"build":return j.Build;case"rebuild":return j.Rebuild;case"test":return j.Test;default:return}}constructor(H,ve){if(this.label=ve,typeof H!="string"||typeof ve!="string")throw(0,R.illegalArgument)("name");this.c=H}get id(){return this.c}};lt.Clean=new j("clean","Clean"),lt.Build=new j("build","Build"),lt.Rebuild=new j("rebuild","Rebuild"),lt.Test=new j("test","Test"),e.TaskGroup=lt=j=qe([ee],lt);function bt(K){let H="";for(let ve=0;ve<K.length;ve++)H+=K[ve].replace(/,/g,",,")+",";return H}let wt=e.ProcessExecution=class{constructor(H,ve,Le){if(typeof H!="string")throw(0,R.illegalArgument)("process");this.e=[],this.c=H,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Le):this.f=ve)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,R.illegalArgument)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)H.push(ve);return bt(H)}};e.ProcessExecution=wt=qe([ee],wt);let St=e.ShellExecution=class{constructor(H,ve,Le){if(this.f=[],Array.isArray(ve)){if(!H)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,R.illegalArgument)("command");this.e=H,this.f=ve,this.g=Le}else{if(typeof H!="string")throw(0,R.illegalArgument)("commandLine");this.c=H,this.g=ve}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,R.illegalArgument)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,R.illegalArgument)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)H.push(typeof ve=="string"?ve:ve.value);return bt(H)}};e.ShellExecution=St=qe([ee],St);var oi;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(oi||(e.ShellQuoting=oi={}));var Vt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Vt||(e.TaskScope=Vt={}));class Oi{constructor(H){this.c=H}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(H){this.c=H}get callback(){return this.c}}e.CustomExecution=Oi;let Kt=e.Task=W=class{constructor(H,ve,Le,Ke,_e,at){this.j=!1,this.k=this.definition=H;let ht;typeof ve=="string"?(this.m=this.name=ve,this.t=this.source=Le,this.execution=Ke,ht=_e,this.j=!0):ve===Vt.Global||ve===Vt.Workspace?(this.target=ve,this.m=this.name=Le,this.t=this.source=Ke,this.execution=_e,ht=at):(this.target=ve,this.m=this.name=Le,this.t=this.source=Ke,this.execution=_e,ht=at),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(H){this.h=H}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof wt?this.k={type:W.e,id:this.n.computeId()}:this.n instanceof St?this.k={type:W.f,id:this.n.computeId()}:this.n instanceof Oi?this.k={type:W.c,id:this.n.computeId()}:this.k={type:W.g,id:(0,T.generateUuid)()}}get definition(){return this.k}set definition(H){if(H==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=H}get scope(){return this.l}set target(H){this.y(),this.l=H}get name(){return this.m}set name(H){if(typeof H!="string")throw(0,R.illegalArgument)("name");this.y(),this.m=H}get execution(){return this.n}set execution(H){H===null&&(H=void 0),this.y(),this.n=H;const ve=this.k.type;(W.g===ve||W.e===ve||W.f===ve||W.c===ve)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(H){if(Array.isArray(H))this.y(),this.o=H,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.y(),this.r=H}get source(){return this.t}set source(H){if(typeof H!="string"||H.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.y(),this.t=H}get group(){return this.u}set group(H){H===null&&(H=void 0),this.y(),this.u=H}get detail(){return this.x}set detail(H){H===null&&(H=void 0),this.x=H}get presentationOptions(){return this.v}set presentationOptions(H){H==null&&(H=Object.create(null)),this.y(),this.v=H}get runOptions(){return this.w}set runOptions(H){H==null&&(H=Object.create(null)),this.y(),this.w=H}};Kt.c="customExecution",Kt.e="process",Kt.f="shell",Kt.g="$empty",e.Task=Kt=W=qe([ee],Kt);var wi;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(wi||(e.ProgressLocation=wi={}));var Rt;(function(K){function H(ve){const Le=ve;return(0,y.isNumber)(Le.value)?Le.tooltip&&!(0,y.isString)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}K.isViewBadge=H})(Rt||(e.ViewBadge=Rt={}));let Fi=e.TreeItem=U=class{static isTreeItem(H,ve){const Le=H;if(Le.checkboxState!==void 0){(0,b.checkProposedApiEnabled)(ve,"treeItemCheckbox");const Ke=(0,y.isNumber)(Le.checkboxState)?Le.checkboxState:(0,y.isObject)(Le.checkboxState)&&(0,y.isNumber)(Le.checkboxState.state)?Le.checkboxState.state:void 0,_e=!(0,y.isNumber)(Le.checkboxState)&&(0,y.isObject)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Dt.Checked&&Ke!==Dt.Unchecked||_e!==void 0&&!(0,y.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(H instanceof U)return!0;if(Le.label!==void 0&&!(0,y.isString)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,y.isString)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,y.isString)(Le.iconPath)&&!g.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,y.isString)(Le.iconPath.id))){const Ke=Le.iconPath;if(!Ke||!(0,y.isString)(Ke.light)&&!g.URI.isUri(Ke.light)&&!(0,y.isString)(Ke.dark)&&!g.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,y.isString)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!g.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,y.isString)(Le.tooltip)&&!(Le.tooltip instanceof me)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<ai.None&&Le.collapsibleState>ai.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,y.isString)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(H,ve=ai.None){this.collapsibleState=ve,g.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.TreeItem=Fi=U=qe([ee],Fi);var ai;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(ai||(e.TreeItemCollapsibleState=ai={}));var Dt;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let di=e.DataTransferItem=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.DataTransferItem=di=qe([ee],di);class Ei extends di{}e.InternalDataTransferItem=Ei;class hi extends Ei{constructor(H){super(""),d.set(this,void 0),Ze(this,d,H,"f")}asFile(){return Ne(this,d,"f")}}e.InternalFileDataTransferItem=hi,d=new WeakMap;class cn{constructor(H,ve,Le,Ke){this.name=H,this.uri=ve,this._itemId=Le,this.c=Ke}data(){return this.c()}}e.DataTransferFile=cn;let Ni=e.DataTransfer=class{constructor(H){S.add(this),w.set(this,new Map);for(const[ve,Le]of H??[]){const Ke=Ne(this,w,"f").get(Ne(this,S,"m",p).call(this,ve));Ke?Ke.push(Le):Ne(this,w,"f").set(Ne(this,S,"m",p).call(this,ve),[Le])}}get(H){return Ne(this,w,"f").get(Ne(this,S,"m",p).call(this,H))?.[0]}set(H,ve){Ne(this,w,"f").set(Ne(this,S,"m",p).call(this,H),[ve])}forEach(H,ve){for(const[Le,Ke]of Ne(this,w,"f"))for(const _e of Ke)H.call(ve,_e,Le,this)}*[(w=new WeakMap,S=new WeakSet,Symbol.iterator)](){for(const[H,ve]of Ne(this,w,"f"))for(const Le of ve)yield[H,Le]}};p=function(H){return H.toLowerCase()},e.DataTransfer=Ni=qe([ee],Ni);let Nt=e.DocumentDropEdit=class{constructor(H){this.insertText=H}};e.DocumentDropEdit=Nt=qe([ee],Nt);let Si=e.DocumentPasteEdit=class{constructor(H,ve,Le){this.id=ve,this.label=Le,this.insertText=H}};e.DocumentPasteEdit=Si=qe([ee],Si);let Yt=e.ThemeIcon=class{constructor(H,ve){this.id=H,this.color=ve}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.ThemeIcon=Yt=qe([ee],Yt),Yt.File=new Yt("file"),Yt.Folder=new Yt("folder");let ci=e.ThemeColor=class{constructor(H){this.id=H}};e.ThemeColor=ci=qe([ee],ci);var li;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let dt=e.RelativePattern=class{get base(){return this.c}set base(H){this.c=H,this.e=g.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,ve){if(typeof H!="string"&&(!H||!g.URI.isUri(H)&&!g.URI.isUri(H.uri)))throw(0,R.illegalArgument)("base");if(typeof ve!="string")throw(0,R.illegalArgument)("pattern");typeof H=="string"?this.baseUri=g.URI.file(H):g.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=dt=qe([ee],dt);const Mi=new WeakMap;function ei(K,H){Mi.set(K,H)}e.setBreakpointId=ei;let Xt=e.Breakpoint=class{constructor(H,ve,Le,Ke){this.enabled=typeof H=="boolean"?H:!0,typeof ve=="string"&&(this.condition=ve),typeof Le=="string"&&(this.hitCondition=Le),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=Mi.get(this)??(0,T.generateUuid)()),this.c}};e.Breakpoint=Xt=qe([ee],Xt);let yi=e.SourceBreakpoint=class extends Xt{constructor(H,ve,Le,Ke,_e){if(super(ve,Le,Ke,_e),H===null)throw(0,R.illegalArgument)("location");this.location=H}};e.SourceBreakpoint=yi=qe([ee],yi);let Ui=e.FunctionBreakpoint=class extends Xt{constructor(H,ve,Le,Ke,_e){super(ve,Le,Ke,_e),this.functionName=H}};e.FunctionBreakpoint=Ui=qe([ee],Ui);let Bi=e.DataBreakpoint=class extends Xt{constructor(H,ve,Le,Ke,_e,at,ht){if(super(Ke,_e,at,ht),!ve)throw(0,R.illegalArgument)("dataId");this.label=H,this.dataId=ve,this.canPersist=Le}};e.DataBreakpoint=Bi=qe([ee],Bi);let $i=e.DebugAdapterExecutable=class{constructor(H,ve,Le){this.command=H,this.args=ve||[],this.options=Le}};e.DebugAdapterExecutable=$i=qe([ee],$i);let Ci=e.DebugAdapterServer=class{constructor(H,ve){this.port=H,this.host=ve}};e.DebugAdapterServer=Ci=qe([ee],Ci);let zi=e.DebugAdapterNamedPipeServer=class{constructor(H){this.path=H}};e.DebugAdapterNamedPipeServer=zi=qe([ee],zi);let Di=e.DebugAdapterInlineImplementation=class{constructor(H){this.implementation=H}};e.DebugAdapterInlineImplementation=Di=qe([ee],Di);let ni=e.StackFrameFocus=class{constructor(H,ve,Le){this.session=H,this.threadId=ve,this.frameId=Le}};e.StackFrameFocus=ni=qe([ee],ni);let Wi=e.ThreadFocus=class{constructor(H,ve){this.session=H,this.threadId=ve}};e.ThreadFocus=Wi=qe([ee],Wi);let fi=e.EvaluatableExpression=class{constructor(H,ve){this.range=H,this.expression=ve}};e.EvaluatableExpression=fi=qe([ee],fi);var mi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(mi||(e.InlineCompletionTriggerKind=mi={}));let Hi=e.InlineValueText=class{constructor(H,ve){this.range=H,this.text=ve}};e.InlineValueText=Hi=qe([ee],Hi);let ji=e.InlineValueVariableLookup=class{constructor(H,ve,Le=!0){this.range=H,this.variableName=ve,this.caseSensitiveLookup=Le}};e.InlineValueVariableLookup=ji=qe([ee],ji);let ri=e.InlineValueEvaluatableExpression=class{constructor(H,ve){this.range=H,this.expression=ve}};e.InlineValueEvaluatableExpression=ri=qe([ee],ri);let Vi=e.InlineValueContext=class{constructor(H,ve){this.frameId=H,this.stoppedLocation=ve}};e.InlineValueContext=Vi=qe([ee],Vi);var xi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(xi||(e.FileChangeType=xi={}));let qi=e.FileSystemError=x=class extends Error{static FileExists(H){return new x(H,m.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(H){return new x(H,m.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(H){return new x(H,m.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(H){return new x(H,m.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(H){return new x(H,m.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(H){return new x(H,m.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}constructor(H,ve=m.FileSystemProviderErrorCode.Unknown,Le){super(g.URI.isUri(H)?H.toString(!0):H),this.code=Le?.name??"Unknown",(0,m.markAsFileSystemProviderError)(this,ve),Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.FileSystemError=qi=x=qe([ee],qi);let si=e.FoldingRange=class{constructor(H,ve,Le){this.start=H,this.end=ve,this.kind=Le}};e.FoldingRange=si=qe([ee],si);var Gi;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Gi||(e.FoldingRangeKind=Gi={}));var Ki;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(Ki||(e.CommentThreadCollapsibleState=Ki={}));var Ii;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Ii||(e.CommentMode=Ii={}));var Xi;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var Qi;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(Qi||(e.CommentThreadState=Qi={}));class ln{constructor(H,ve=[]){this.tokenTypes=H,this.tokenModifiers=ve}}e.SemanticTokensLegend=ln;function ki(K){return typeof K>"u"||(0,y.isStringArray)(K)}class gi{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,H){this.l=!0;for(let ve=0,Le=H.tokenTypes.length;ve<Le;ve++)this.j.set(H.tokenTypes[ve],ve);for(let ve=0,Le=H.tokenModifiers.length;ve<Le;ve++)this.k.set(H.tokenModifiers[ve],ve)}}push(H,ve,Le,Ke,_e){if(typeof H=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof Ke=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(H,ve,Le,Ke,_e);if(ae.isRange(H)&&typeof ve=="string"&&ki(Le))return this.m(H,ve,Le);throw(0,R.illegalArgument)()}m(H,ve,Le){if(!this.l)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ve))throw new Error("`tokenType` is not in the provided legend");const Ke=H.start.line,_e=H.start.character,at=H.end.character-H.start.character,ht=this.j.get(ve);let Wt=0;if(Le)for(const Gt of Le){if(!this.k.has(Gt))throw new Error("`tokenModifier` is not in the provided legend");const Qt=this.k.get(Gt);Wt|=1<<Qt>>>0}this.n(Ke,_e,at,ht,Wt)}n(H,ve,Le,Ke,_e){if(this.f&&(H<this.c||H===this.c&&ve<this.e)){this.f=!1;const Wt=this.g.length/5|0;let Gt=0,Qt=0;for(let _t=0;_t<Wt;_t++){let ti=this.g[5*_t],Ri=this.g[5*_t+1];ti===0?(ti=Gt,Ri+=Qt):ti+=Gt,this.g[5*_t]=ti,this.g[5*_t+1]=Ri,Gt=ti,Qt=Ri}}let at=H,ht=ve;this.f&&this.h>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ht,this.g[this.h++]=Le,this.g[this.h++]=Ke,this.g[this.h++]=_e,this.c=H,this.e=ve}static o(H){const ve=[],Le=H.length/5|0;for(let ht=0;ht<Le;ht++)ve[ht]=ht;ve.sort((ht,Wt)=>{const Gt=H[5*ht],Qt=H[5*Wt];if(Gt===Qt){const _t=H[5*ht+1],ti=H[5*Wt+1];return _t-ti}return Gt-Qt});const Ke=new Uint32Array(H.length);let _e=0,at=0;for(let ht=0;ht<Le;ht++){const Wt=5*ve[ht],Gt=H[Wt+0],Qt=H[Wt+1],_t=H[Wt+2],ti=H[Wt+3],Ri=H[Wt+4],Rn=Gt-_e,Kn=Rn===0?Qt-at:Qt,Li=5*ht;Ke[Li+0]=Rn,Ke[Li+1]=Kn,Ke[Li+2]=_t,Ke[Li+3]=ti,Ke[Li+4]=Ri,_e=Gt,at=Qt}return Ke}build(H){return this.f?new $e(new Uint32Array(this.g),H):new $e(gi.o(this.g),H)}}e.SemanticTokensBuilder=gi;class $e{constructor(H,ve){this.resultId=ve,this.data=H}}e.SemanticTokens=$e;class Jt{constructor(H,ve,Le){this.start=H,this.deleteCount=ve,this.data=Le}}e.SemanticTokensEdit=Jt;class Yi{constructor(H,ve){this.resultId=ve,this.edits=H}}e.SemanticTokensEdits=Yi;var pt;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(pt||(e.DebugConsoleMode=pt={}));let Pi=e.QuickInputButtons=class{constructor(){}};Pi.Back={iconPath:new Yt("arrow-left")},e.QuickInputButtons=Pi=qe([ee],Pi);var Ji;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Ji||(e.QuickPickItemKind=Ji={}));var Ai;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(Ai||(e.InputBoxValidationSeverity=Ai={}));var Zi;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(Zi||(e.ExtensionKind=Zi={}));class pi{static validate(H){if(typeof H.badge=="string"){let ve=(0,A.nextCharLength)(H.badge,0);if(ve<H.badge.length&&(ve+=(0,A.nextCharLength)(H.badge,ve)),H.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!Yt.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,ve,Le){this.badge=H,this.tooltip=ve,this.color=Le}}e.FileDecoration=pi;let _i=e.ColorTheme=class{constructor(H){this.kind=H}};e.ColorTheme=_i=qe([ee],_i);var en;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class Zt{static isNotebookRange(H){return H instanceof Zt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,ve){if(H<0)throw(0,R.illegalArgument)("start must be positive");if(ve<0)throw(0,R.illegalArgument)("end must be positive");H<=ve?(this.c=H,this.e=ve):(this.c=ve,this.e=H)}with(H){let ve=this.c,Le=this.e;return H.start!==void 0&&(ve=H.start),H.end!==void 0&&(Le=H.end),ve===this.c&&Le===this.e?this:new Zt(ve,Le)}}e.NotebookRange=Zt;class ui{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(ve=>ui.isNotebookCellData(ve))}static isNotebookCellData(H){return!0}constructor(H,ve,Le,Ke,_e,at,ht){this.kind=H,this.value=ve,this.languageId=Le,this.mime=Ke,this.outputs=_e??[],this.metadata=at,this.executionSummary=ht,ui.validate(this)}}e.NotebookCellData=ui;class un{constructor(H){this.cells=H}}e.NotebookData=un;class xt{static isNotebookCellOutputItem(H){return H instanceof xt?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const ve={name:H.name,message:H.message,stack:H.stack};return xt.json(ve,"application/vnd.code.notebook.error")}static stdout(H){return xt.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return xt.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,ve="application/octet-stream"){return new xt(H,ve)}static text(H,ve=L.Mimes.text){const Le=Ne(xt,t,"f",a).encode(String(H));return new xt(Le,ve)}static json(H,ve="text/x-json"){const Le=JSON.stringify(H,void 0,"	");return xt.text(Le,ve)}constructor(H,ve){this.data=H,this.mime=ve;const Le=(0,L.normalizeMimeType)(ve,!0);if(!Le)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.NotebookCellOutputItem=xt,t=xt,a={value:new TextEncoder};class bi{static isNotebookCellOutput(H){return H instanceof bi?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,ve=!1){const Le=new Set,Ke=new Set;for(let _e=0;_e<H.length;_e++){const at=H[_e],ht=(0,L.normalizeMimeType)(at.mime);if(!Le.has(ht)||(0,C.isTextStreamMime)(ht)){Le.add(ht);continue}Ke.add(_e),ve&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?H:H.filter((_e,at)=>!Ke.has(at))}constructor(H,ve,Le){this.items=bi.ensureUniqueMimeTypes(H,!0),typeof ve=="string"?(this.id=ve,this.metadata=Le):(this.id=(0,T.generateUuid)(),this.metadata=ve??Le)}}e.NotebookCellOutput=bi;var tn;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var sn;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(sn||(e.NotebookEditorRevealType=sn={}));class dn{constructor(H,ve){this.text=H,this.alignment=ve}}e.NotebookCellStatusBarItem=dn;var on;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(on||(e.NotebookControllerAffinity=on={}));var ge;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(ge||(e.NotebookControllerAffinity2=ge={}));class Se{constructor(H,ve=[]){this.uri=H,this.provides=(0,c.asArray)(ve)}}e.NotebookRendererScript=Se;class Ue{constructor(H){this.label=H}}e.NotebookKernelSourceAction=Ue;let rt=e.TimelineItem=class{constructor(H,ve){this.label=H,this.timestamp=ve}};e.TimelineItem=rt=qe([ee],rt);var It;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(It||(e.ExtensionMode=It={}));var Ot;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(Ot||(e.ExtensionRuntime=Ot={}));var mn;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(mn||(e.StandardTokenType=mn={}));class Mn{constructor(H,ve){this.ranges=H,this.wordPattern=ve}}e.LinkedEditingRanges=Mn;class Un{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.PortAttributes=Un;var gn;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(gn||(e.TestResultState=gn={}));var pn;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(pn||(e.TestRunProfileKind=pn={}));let hn=e.TestRunRequest=class{constructor(H=void 0,ve=void 0,Le=void 0,Ke=!1){this.include=H,this.exclude=ve,this.profile=Le,this.continuous=Ke}};e.TestRunRequest=hn=qe([ee],hn);let bn=e.TestRunRequest2=class extends hn{};e.TestRunRequest2=bn=qe([ee],bn);let vn=e.TestMessage=B=class{static diff(H,ve,Le){const Ke=new B(H);return Ke.expectedOutput=ve,Ke.actualOutput=Le,Ke}constructor(H){this.message=H}};e.TestMessage=vn=B=qe([ee],vn);let wn=e.TestTag=class{constructor(H){this.id=H}};e.TestTag=wn=qe([ee],wn);let Ti=e.CoveredCount=class{constructor(H,ve){this.covered=H,this.total=ve}};e.CoveredCount=Ti=qe([ee],Ti);let En=e.FileCoverage=z=class{static fromDetails(H,ve){const Le=new Ti(0,0),Ke=new Ti(0,0),_e=new Ti(0,0);for(const ht of ve)if("branches"in ht){Le.total+=1,Le.covered+=ht.executionCount>0?1:0;for(const Wt of ht.branches)Ke.total+=1,Ke.covered+=Wt.executionCount>0?1:0}else _e.total+=1,_e.covered+=ht.executionCount>0?1:0;const at=new z(H,Le,Ke.total>0?Ke:void 0,_e.total>0?_e:void 0);return at.detailedCoverage=ve,at}constructor(H,ve,Le,Ke){this.uri=H,this.statementCoverage=ve,this.branchCoverage=Le,this.functionCoverage=Ke}};e.FileCoverage=En=z=qe([ee],En);let Sn=e.StatementCoverage=class{constructor(H,ve,Le=[]){this.executionCount=H,this.location=ve,this.branches=Le}};e.StatementCoverage=Sn=qe([ee],Sn);let yn=e.BranchCoverage=class{constructor(H,ve){this.executionCount=H,this.location=ve}};e.BranchCoverage=yn=qe([ee],yn);let Cn=e.FunctionCoverage=class{constructor(H,ve){this.executionCount=H,this.location=ve}};e.FunctionCoverage=Cn=qe([ee],Cn);var Dn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(Dn||(e.ExternalUriOpenerPriority=Dn={}));var In;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(In||(e.WorkspaceTrustState=In={}));var kn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(kn||(e.PortAutoForwardAction=kn={}));class Bn{constructor(H,ve,Le,Ke,_e,at){this.kind=H,this.name=ve,this.detail=Le,this.uri=Ke,this.range=_e,this.selectionRange=at}}e.TypeHierarchyItem=Bn;class $n{constructor(H){this.uri=H}}e.TextTabInput=$n;class zn{constructor(H,ve){this.original=H,this.modified=ve}}e.TextDiffTabInput=zn;class Wn{constructor(H,ve,Le,Ke){this.base=H,this.input1=ve,this.input2=Le,this.result=Ke}}e.TextMergeTabInput=Wn;class Hn{constructor(H,ve){this.uri=H,this.viewType=ve}}e.CustomEditorTabInput=Hn;class jn{constructor(H){this.viewType=H}}e.WebviewEditorTabInput=jn;class Vn{constructor(H,ve){this.uri=H,this.notebookType=ve}}e.NotebookEditorTabInput=Vn;class xn{constructor(H,ve,Le){this.original=H,this.modified=ve,this.notebookType=Le}}e.NotebookDiffEditorTabInput=xn;class qn{constructor(){}}e.TerminalEditorTabInput=qn;class Gn{constructor(H,ve){this.uri=H,this.inputBoxUri=ve}}e.InteractiveWindowInput=Gn;var Pn;(function(K){K[K.Up=1]="Up",K[K.Down=2]="Down"})(Pn||(e.InteractiveSessionVoteDirection=Pn={}));var An;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(An||(e.InteractiveSessionCopyKind=An={}));var Tn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone"})(Tn||(e.InteractiveEditorResponseFeedbackKind=Tn={}))}),define(Ce[139],De([1,0,52,18,11,166,121,7,19]),function(re,e,c,R,u,O,L,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const g=new Map;function T(C,b){b?g.set(C,b):g.delete(C)}e.setWordDefinitionFor=T;function P(C){return g.get(C)}class m extends O.MirrorTextModel{constructor(b,n,h,d,S,w,p,t){super(n,h,d,S),this.c=b,this.m=w,this.q=p,this.notebook=t,this.b=!1}dispose(){(0,c.ok)(!this.b),this.b=!0,this.q=!1}equalLines(b){return(0,y.equals)(this.f,b)}get document(){if(!this.a){const b=this;this.a={get uri(){return b.d},get fileName(){return b.d.fsPath},get isUntitled(){return b.d.scheme===R.Schemas.untitled},get languageId(){return b.m},get version(){return b.h},get isClosed(){return b.b},get isDirty(){return b.q},save(){return b.r()},getText(n){return n?b.s(n):b.getText()},get eol(){return b.g===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return b.f.length},lineAt(n){return b.t(n)},offsetAt(n){return b.u(n)},positionAt(n){return b.v(n)},validateRange(n){return b.w(n)},validatePosition(n){return b.x(n)},getWordRangeAtPosition(n,h){return b.y(n,h)}}}return Object.freeze(this.a)}_acceptLanguageId(b){(0,c.ok)(!this.b),this.m=b}_acceptIsDirty(b){(0,c.ok)(!this.b),this.q=b}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(b){const n=this.w(b);if(n.isEmpty)return"";if(n.isSingleLine)return this.f[n.start.line].substring(n.start.character,n.end.character);const h=this.g,d=n.start.line,S=n.end.line,w=[];w.push(this.f[d].substring(n.start.character));for(let p=d+1;p<S;p++)w.push(this.f[p]);return w.push(this.f[S].substring(0,n.end.character)),w.join(h)}t(b){let n;if(b instanceof A.Position?n=b.line:typeof b=="number"&&(n=b),typeof n!="number"||n<0||n>=this.f.length||Math.floor(n)!==n)throw new Error("Illegal value for `line`");return new D(n,this.f[n],n===this.f.length-1)}u(b){return b=this.x(b),this.l(),this.j.getPrefixSum(b.line-1)+b.character}v(b){b=Math.floor(b),b=Math.max(0,b),this.l();const n=this.j.getIndexOf(b),h=this.f[n.index].length;return new A.Position(n.index,Math.min(n.remainder,h))}w(b){if(!(b instanceof A.Range))throw new Error("Invalid argument");const n=this.x(b.start),h=this.x(b.end);return n===b.start&&h===b.end?b:new A.Range(n.line,n.character,h.line,h.character)}x(b){if(!(b instanceof A.Position))throw new Error("Invalid argument");if(this.f.length===0)return b.with(0,0);let{line:n,character:h}=b,d=!1;if(n<0)n=0,h=0,d=!0;else if(n>=this.f.length)n=this.f.length-1,h=this.f[n].length,d=!0;else{const S=this.f[n].length;h<0?(h=0,d=!0):h>S&&(h=S,d=!0)}return d?new A.Position(n,h):b}y(b,n){const h=this.x(b);if(!n)n=P(this.m);else if((0,u.regExpLeadsToEndlessLoop)(n))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${n.source}' because it matches the empty string.`);const d=(0,L.getWordAtText)(h.character+1,(0,L.ensureValidWordDefinition)(n),this.f[h.line],0);if(d)return new A.Range(h.line,d.startColumn-1,h.line,d.endColumn-1)}}e.ExtHostDocumentData=m;class D{constructor(b,n,h){this.a=b,this.b=n,this.c=h}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=D}),define(Ce[261],De([1,0,7,20,3]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let O=e.ExtHostTheming=class{constructor(A){this.a=new c.ColorTheme(c.ColorThemeKind.Dark),this.b=new u.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let y;switch(A){case"light":y=c.ColorThemeKind.Light;break;case"hcDark":y=c.ColorThemeKind.HighContrast;break;case"hcLight":y=c.ColorThemeKind.HighContrastLight;break;default:y=c.ColorThemeKind.Dark}this.a=new c.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.ExtHostTheming=O=qe([je(0,R.IExtHostRpcService)],O)}),define(Ce[13],De([1,0,19,22,157,67,116,28,152,73,91,23,12,2,36,76,126,136,133,101,60,81,257,7]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d,S,w,p,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Oe){function Ae(ce){const{selectionStartLineNumber:Me,selectionStartColumn:We,positionLineNumber:Ye,positionColumn:Ge}=ce,it=new a.Position(Me-1,We-1),Ct=new a.Position(Ye-1,Ge-1);return new a.Selection(it,Ct)}Oe.to=Ae;function Pe(ce){const{anchor:Me,active:We}=ce;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Oe.from=Pe})(r||(e.Selection=r={}));var o;(function(Oe){function Ae(ce){if(!ce)return;const{start:Me,end:We}=ce;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Oe.from=Ae;function Pe(ce){if(!ce)return;const{startLineNumber:Me,startColumn:We,endLineNumber:Ye,endColumn:Ge}=ce;return new a.Range(Me-1,We-1,Ye-1,Ge-1)}Oe.to=Pe})(o||(e.Range=o={}));var f;(function(Oe){function Ae(Pe){switch(Pe){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Oe.to=Ae})(f||(e.TokenType=f={}));var v;(function(Oe){function Ae(ce){return new a.Position(ce.lineNumber-1,ce.column-1)}Oe.to=Ae;function Pe(ce){return{lineNumber:ce.line+1,column:ce.character+1}}Oe.from=Pe})(v||(e.Position=v={}));var l;(function(Oe){function Ae(Me,We,Ye){return(0,c.coalesce)((0,c.asArray)(Me).map(Ge=>Pe(Ge,We,Ye)))}Oe.from=Ae;function Pe(Me,We,Ye){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Ye?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:ce(Me.scheme,We),pattern:X.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Ye?.isBuiltin}}function ce(Me,We){return We&&typeof Me=="string"?We.transformOutgoingScheme(Me):Me}})(l||(e.DocumentSelector=l={}));var I;(function(Oe){function Ae(ce){switch(ce){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Oe.from=Ae;function Pe(ce){switch(ce){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Oe.to=Pe})(I||(e.DiagnosticTag=I={}));var E;(function(Oe){function Ae(ce){let Me;return ce.code&&((0,m.isString)(ce.code)||(0,m.isNumber)(ce.code)?Me=String(ce.code):Me={value:String(ce.code.value),target:ce.code.target}),{...o.from(ce.range),message:ce.message,source:ce.source,code:Me,severity:i.from(ce.severity),relatedInformation:ce.relatedInformation&&ce.relatedInformation.map(s.from),tags:Array.isArray(ce.tags)?(0,c.coalesce)(ce.tags.map(I.from)):void 0}}Oe.from=Ae;function Pe(ce){const Me=new a.Diagnostic(o.to(ce),ce.message,i.to(ce.severity));return Me.source=ce.source,Me.code=(0,m.isString)(ce.code)?ce.code:ce.code?.value,Me.relatedInformation=ce.relatedInformation&&ce.relatedInformation.map(s.to),Me.tags=ce.tags&&(0,c.coalesce)(ce.tags.map(I.to)),Me}Oe.to=Pe})(E||(e.Diagnostic=E={}));var s;(function(Oe){function Ae(ce){return{...o.from(ce.location.range),message:ce.message,resource:ce.location.uri}}Oe.from=Ae;function Pe(ce){return new a.DiagnosticRelatedInformation(new a.Location(ce.resource,o.to(ce)),ce.message)}Oe.to=Pe})(s||(e.DiagnosticRelatedInformation=s={}));var i;(function(Oe){function Ae(ce){switch(ce){case a.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Oe.from=Ae;function Pe(ce){switch(ce){case n.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Oe.to=Pe})(i||(e.DiagnosticSeverity=i={}));var k;(function(Oe){function Ae(ce){return typeof ce=="number"&&ce>=a.ViewColumn.One?ce-1:ce===a.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Oe.from=Ae;function Pe(ce){if(typeof ce=="number"&&ce>=0)return ce+1;throw new Error("invalid 'EditorGroupColumn'")}Oe.to=Pe})(k||(e.ViewColumn=k={}));function F(Oe){return typeof Oe.range<"u"}function $(Oe){return Oe.length===0?!0:!!F(Oe[0])}e.isDecorationOptionsArr=$;var j;(function(Oe){function Ae(Ge){return Ge.map(Oe.from)}Oe.fromMany=Ae;function Pe(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function ce(Ge){let it;if(Pe(Ge)){const{language:Et,value:lt}=Ge;it={value:"```"+Et+`
`+lt+"\n```\n"}}else a.MarkdownString.isMarkdownString(Ge)?it={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?it={value:Ge}:it={value:""};const Ct=Object.create(null);it.uris=Ct;const Lt=Et=>{try{let lt=D.URI.parse(Et,!0);lt=lt.with({query:Me(lt.query,Ct)}),Ct[Et]=lt}catch{}return""},At=new y.marked.Renderer;return At.link=Lt,At.image=Et=>typeof Et=="string"?Lt(L.parseHrefAndDimensions(Et).href):"",(0,y.marked)(it.value,{renderer:At}),it}Oe.from=ce;function Me(Ge,it){if(!Ge)return Ge;let Ct;try{Ct=(0,g.parse)(Ge)}catch{}if(!Ct)return Ge;let Lt=!1;return Ct=(0,P.cloneAndChange)(Ct,At=>{if(D.URI.isUri(At)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[Et]=At,Lt=!0,Et}else return}),Lt?JSON.stringify(Ct):Ge}function We(Ge){const it=new a.MarkdownString(Ge.value,Ge.supportThemeIcons);return it.isTrusted=Ge.isTrusted,it.supportHtml=Ge.supportHtml,it.baseUri=Ge.baseUri?D.URI.from(Ge.baseUri):void 0,it}Oe.to=We;function Ye(Ge){if(Ge)return typeof Ge=="string"?Ge:Oe.from(Ge)}Oe.fromStrict=Ye})(j||(e.MarkdownString=j={}));function W(Oe){return $(Oe)?Oe.map(Ae=>({range:o.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?j.fromMany(Ae.hoverMessage):Ae.hoverMessage?j.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):Oe.map(Ae=>({range:o.from(Ae)}))}e.fromRangeOrRangeWithMessage=W;function U(Oe){return typeof Oe>"u"?Oe:typeof Oe=="string"?D.URI.file(Oe):Oe}e.pathOrURIToURI=U;var x;(function(Oe){function Ae(Pe){return typeof Pe>"u"?Pe:{contentText:Pe.contentText,contentIconPath:Pe.contentIconPath?U(Pe.contentIconPath):void 0,border:Pe.border,borderColor:Pe.borderColor,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,color:Pe.color,backgroundColor:Pe.backgroundColor,margin:Pe.margin,width:Pe.width,height:Pe.height}}Oe.from=Ae})(x||(e.ThemableDecorationAttachmentRenderOptions=x={}));var B;(function(Oe){function Ae(Pe){return typeof Pe>"u"?Pe:{backgroundColor:Pe.backgroundColor,outline:Pe.outline,outlineColor:Pe.outlineColor,outlineStyle:Pe.outlineStyle,outlineWidth:Pe.outlineWidth,border:Pe.border,borderColor:Pe.borderColor,borderRadius:Pe.borderRadius,borderSpacing:Pe.borderSpacing,borderStyle:Pe.borderStyle,borderWidth:Pe.borderWidth,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,cursor:Pe.cursor,color:Pe.color,opacity:Pe.opacity,letterSpacing:Pe.letterSpacing,gutterIconPath:Pe.gutterIconPath?U(Pe.gutterIconPath):void 0,gutterIconSize:Pe.gutterIconSize,overviewRulerColor:Pe.overviewRulerColor,before:Pe.before?x.from(Pe.before):void 0,after:Pe.after?x.from(Pe.after):void 0}}Oe.from=Ae})(B||(e.ThemableDecorationRenderOptions=B={}));var z;(function(Oe){function Ae(Pe){if(typeof Pe>"u")return Pe;switch(Pe){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Oe.from=Ae})(z||(e.DecorationRangeBehavior=z={}));var ee;(function(Oe){function Ae(Pe){return{isWholeLine:Pe.isWholeLine,rangeBehavior:Pe.rangeBehavior?z.from(Pe.rangeBehavior):void 0,overviewRulerLane:Pe.overviewRulerLane,light:Pe.light?B.from(Pe.light):void 0,dark:Pe.dark?B.from(Pe.dark):void 0,backgroundColor:Pe.backgroundColor,outline:Pe.outline,outlineColor:Pe.outlineColor,outlineStyle:Pe.outlineStyle,outlineWidth:Pe.outlineWidth,border:Pe.border,borderColor:Pe.borderColor,borderRadius:Pe.borderRadius,borderSpacing:Pe.borderSpacing,borderStyle:Pe.borderStyle,borderWidth:Pe.borderWidth,fontStyle:Pe.fontStyle,fontWeight:Pe.fontWeight,textDecoration:Pe.textDecoration,cursor:Pe.cursor,color:Pe.color,opacity:Pe.opacity,letterSpacing:Pe.letterSpacing,gutterIconPath:Pe.gutterIconPath?U(Pe.gutterIconPath):void 0,gutterIconSize:Pe.gutterIconSize,overviewRulerColor:Pe.overviewRulerColor,before:Pe.before?x.from(Pe.before):void 0,after:Pe.after?x.from(Pe.after):void 0}}Oe.from=Ae})(ee||(e.DecorationRenderOptions=ee={}));var se;(function(Oe){function Ae(ce){return{text:ce.newText,eol:ce.newEol&&nt.from(ce.newEol),range:o.from(ce.range)}}Oe.from=Ae;function Pe(ce){const Me=new a.TextEdit(o.to(ce.range),ce.text);return Me.newEol=typeof ce.eol>"u"?void 0:nt.to(ce.eol),Me}Oe.to=Pe})(se||(e.TextEdit=se={}));var V;(function(Oe){function Ae(ce,Me){const We={edits:[]};if(ce instanceof a.WorkspaceEdit){const Ye=new A.ResourceSet;for(const Ge of ce._allEntries())Ge._type===1&&D.URI.isUri(Ge.to)&&Ge.from===void 0&&Ye.add(Ge.to);for(const Ge of ce._allEntries())if(Ge._type===1){let it;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?it={type:"base64",value:(0,R.encodeBase64)(R.VSBuffer.wrap(Ge.options.contents))}:it={type:"dataTransferItem",id:Ge.options.contents._itemId}),We.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:it},metadata:Ge.metadata})}else Ge._type===2?We.edits.push({resource:Ge.uri,textEdit:se.from(Ge.edit),versionId:Ye.has(Ge.uri)?void 0:Me?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?We.edits.push({resource:Ge.uri,textEdit:{range:o.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ge.uri)?void 0:Me?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?We.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&We.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(ct.from)}})}return We}Oe.from=Ae;function Pe(ce){const Me=new a.WorkspaceEdit,We=new A.ResourceMap;for(const Ye of ce.edits)if(Ye.textEdit){const Ge=Ye,it=D.URI.revive(Ge.resource),Ct=o.to(Ge.textEdit.range),Lt=Ge.textEdit.text,At=Ge.textEdit.insertAsSnippet;let Et;At?Et=a.SnippetTextEdit.replace(Ct,new a.SnippetString(Lt)):Et=a.TextEdit.replace(Ct,Lt);const lt=We.get(it);lt?lt.push(Et):We.set(it,[Et])}else Me.renameFile(D.URI.revive(Ye.oldResource),D.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Ge]of We)Me.set(Ye,Ge);return Me}Oe.to=Pe})(V||(e.WorkspaceEdit=V={}));var Z;(function(Oe){const Ae=Object.create(null);Ae[a.SymbolKind.File]=0,Ae[a.SymbolKind.Module]=1,Ae[a.SymbolKind.Namespace]=2,Ae[a.SymbolKind.Package]=3,Ae[a.SymbolKind.Class]=4,Ae[a.SymbolKind.Method]=5,Ae[a.SymbolKind.Property]=6,Ae[a.SymbolKind.Field]=7,Ae[a.SymbolKind.Constructor]=8,Ae[a.SymbolKind.Enum]=9,Ae[a.SymbolKind.Interface]=10,Ae[a.SymbolKind.Function]=11,Ae[a.SymbolKind.Variable]=12,Ae[a.SymbolKind.Constant]=13,Ae[a.SymbolKind.String]=14,Ae[a.SymbolKind.Number]=15,Ae[a.SymbolKind.Boolean]=16,Ae[a.SymbolKind.Array]=17,Ae[a.SymbolKind.Object]=18,Ae[a.SymbolKind.Key]=19,Ae[a.SymbolKind.Null]=20,Ae[a.SymbolKind.EnumMember]=21,Ae[a.SymbolKind.Struct]=22,Ae[a.SymbolKind.Event]=23,Ae[a.SymbolKind.Operator]=24,Ae[a.SymbolKind.TypeParameter]=25;function Pe(Me){return typeof Ae[Me]=="number"?Ae[Me]:6}Oe.from=Pe;function ce(Me){for(const We in Ae)if(Ae[We]===Me)return Number(We);return a.SymbolKind.Property}Oe.to=ce})(Z||(e.SymbolKind=Z={}));var q;(function(Oe){function Ae(ce){switch(ce){case a.SymbolTag.Deprecated:return 1}}Oe.from=Ae;function Pe(ce){switch(ce){case 1:return a.SymbolTag.Deprecated}}Oe.to=Pe})(q||(e.SymbolTag=q={}));var ae;(function(Oe){function Ae(ce){return{name:ce.name,kind:Z.from(ce.kind),tags:ce.tags&&ce.tags.map(q.from),containerName:ce.containerName,location:Q.from(ce.location)}}Oe.from=Ae;function Pe(ce){const Me=new a.SymbolInformation(ce.name,Z.to(ce.kind),ce.containerName,Q.to(ce.location));return Me.tags=ce.tags&&ce.tags.map(q.to),Me}Oe.to=Pe})(ae||(e.WorkspaceSymbol=ae={}));var Ee;(function(Oe){function Ae(ce){const Me={name:ce.name||"!!MISSING: name!!",detail:ce.detail,range:o.from(ce.range),selectionRange:o.from(ce.selectionRange),kind:Z.from(ce.kind),tags:ce.tags?.map(q.from)??[]};return ce.children&&(Me.children=ce.children.map(Ae)),Me}Oe.from=Ae;function Pe(ce){const Me=new a.DocumentSymbol(ce.name,ce.detail,Z.to(ce.kind),o.to(ce.range),o.to(ce.selectionRange));return(0,c.isNonEmptyArray)(ce.tags)&&(Me.tags=ce.tags.map(q.to)),ce.children&&(Me.children=ce.children.map(Pe)),Me}Oe.to=Pe})(Ee||(e.DocumentSymbol=Ee={}));var ye;(function(Oe){function Ae(ce){const Me=new a.CallHierarchyItem(Z.to(ce.kind),ce.name,ce.detail||"",D.URI.revive(ce.uri),o.to(ce.range),o.to(ce.selectionRange));return Me._sessionId=ce._sessionId,Me._itemId=ce._itemId,Me}Oe.to=Ae;function Pe(ce,Me,We){if(Me=Me??ce._sessionId,We=We??ce._itemId,Me===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:We,name:ce.name,detail:ce.detail,kind:Z.from(ce.kind),uri:ce.uri,range:o.from(ce.range),selectionRange:o.from(ce.selectionRange),tags:ce.tags?.map(q.from)}}Oe.from=Pe})(ye||(e.CallHierarchyItem=ye={}));var be;(function(Oe){function Ae(Pe){return new a.CallHierarchyIncomingCall(ye.to(Pe.from),Pe.fromRanges.map(ce=>o.to(ce)))}Oe.to=Ae})(be||(e.CallHierarchyIncomingCall=be={}));var M;(function(Oe){function Ae(Pe){return new a.CallHierarchyOutgoingCall(ye.to(Pe.to),Pe.fromRanges.map(ce=>o.to(ce)))}Oe.to=Ae})(M||(e.CallHierarchyOutgoingCall=M={}));var Q;(function(Oe){function Ae(ce){return{range:ce.range&&o.from(ce.range),uri:ce.uri}}Oe.from=Ae;function Pe(ce){return new a.Location(D.URI.revive(ce.uri),o.to(ce.range))}Oe.to=Pe})(Q||(e.location=Q={}));var fe;(function(Oe){function Ae(ce){const Me=ce,We=ce;return{originSelectionRange:Me.originSelectionRange?o.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:We.uri,range:o.from(Me.targetRange?Me.targetRange:We.range),targetSelectionRange:Me.targetSelectionRange?o.from(Me.targetSelectionRange):void 0}}Oe.from=Ae;function Pe(ce){return{targetUri:D.URI.revive(ce.uri),targetRange:o.to(ce.range),targetSelectionRange:ce.targetSelectionRange?o.to(ce.targetSelectionRange):void 0,originSelectionRange:ce.originSelectionRange?o.to(ce.originSelectionRange):void 0}}Oe.to=Pe})(fe||(e.DefinitionLink=fe={}));var we;(function(Oe){function Ae(ce){return{range:o.from(ce.range),contents:j.fromMany(ce.contents)}}Oe.from=Ae;function Pe(ce){return new a.Hover(ce.contents.map(j.to),o.to(ce.range))}Oe.to=Pe})(we||(e.Hover=we={}));var _;(function(Oe){function Ae(ce){return{range:o.from(ce.range),expression:ce.expression}}Oe.from=Ae;function Pe(ce){return new a.EvaluatableExpression(o.to(ce.range),ce.expression)}Oe.to=Pe})(_||(e.EvaluatableExpression=_={}));var ne;(function(Oe){function Ae(ce){if(ce instanceof a.InlineValueText)return{type:"text",range:o.from(ce.range),text:ce.text};if(ce instanceof a.InlineValueVariableLookup)return{type:"variable",range:o.from(ce.range),variableName:ce.variableName,caseSensitiveLookup:ce.caseSensitiveLookup};if(ce instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(ce.range),expression:ce.expression};throw new Error("Unknown 'InlineValue' type")}Oe.from=Ae;function Pe(ce){switch(ce.type){case"text":return{range:o.to(ce.range),text:ce.text};case"variable":return{range:o.to(ce.range),variableName:ce.variableName,caseSensitiveLookup:ce.caseSensitiveLookup};case"expression":return{range:o.to(ce.range),expression:ce.expression}}}Oe.to=Pe})(ne||(e.InlineValue=ne={}));var le;(function(Oe){function Ae(ce){return{frameId:ce.frameId,stoppedLocation:o.from(ce.stoppedLocation)}}Oe.from=Ae;function Pe(ce){return new a.InlineValueContext(ce.frameId,o.to(ce.stoppedLocation))}Oe.to=Pe})(le||(e.InlineValueContext=le={}));var te;(function(Oe){function Ae(ce){return{range:o.from(ce.range),kind:ce.kind}}Oe.from=Ae;function Pe(ce){return new a.DocumentHighlight(o.to(ce.range),ce.kind)}Oe.to=Pe})(te||(e.DocumentHighlight=te={}));var de;(function(Oe){function Ae(Pe){switch(Pe){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Oe.to=Ae})(de||(e.CompletionTriggerKind=de={}));var oe;(function(Oe){function Ae(Pe){return{triggerKind:de.to(Pe.triggerKind),triggerCharacter:Pe.triggerCharacter}}Oe.to=Ae})(oe||(e.CompletionContext=oe={}));var ue;(function(Oe){function Ae(ce){switch(ce){case a.CompletionItemTag.Deprecated:return 1}}Oe.from=Ae;function Pe(ce){switch(ce){case 1:return a.CompletionItemTag.Deprecated}}Oe.to=Pe})(ue||(e.CompletionItemTag=ue={}));var N;(function(Oe){const Ae=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function Pe(We){return Ae.get(We)??9}Oe.from=Pe;const ce=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Me(We){return ce.get(We)??a.CompletionItemKind.Property}Oe.to=Me})(N||(e.CompletionItemKind=N={}));var G;(function(Oe){function Ae(Pe,ce){const Me=new a.CompletionItem(Pe.label);return Me.insertText=Pe.insertText,Me.kind=N.to(Pe.kind),Me.tags=Pe.tags?.map(ue.to),Me.detail=Pe.detail,Me.documentation=L.isMarkdownString(Pe.documentation)?j.to(Pe.documentation):Pe.documentation,Me.sortText=Pe.sortText,Me.filterText=Pe.filterText,Me.preselect=Pe.preselect,Me.commitCharacters=Pe.commitCharacters,C.Range.isIRange(Pe.range)?Me.range=o.to(Pe.range):typeof Pe.range=="object"&&(Me.range={inserting:o.to(Pe.range.insert),replacing:o.to(Pe.range.replace)}),Me.keepWhitespace=typeof Pe.insertTextRules>"u"?!1:!!(Pe.insertTextRules&1),typeof Pe.insertTextRules<"u"&&Pe.insertTextRules&4?Me.insertText=new a.SnippetString(Pe.insertText):(Me.insertText=Pe.insertText,Me.textEdit=Me.range instanceof a.Range?new a.TextEdit(Me.range,Me.insertText):void 0),Pe.additionalTextEdits&&Pe.additionalTextEdits.length>0&&(Me.additionalTextEdits=Pe.additionalTextEdits.map(We=>se.to(We))),Me.command=ce&&Pe.command?ce.fromInternal(Pe.command):void 0,Me}Oe.to=Ae})(G||(e.CompletionItem=G={}));var Y;(function(Oe){function Ae(ce){if(typeof ce.label!="string"&&!Array.isArray(ce.label))throw new TypeError("Invalid label");return{label:ce.label,documentation:j.fromStrict(ce.documentation)}}Oe.from=Ae;function Pe(ce){return{label:ce.label,documentation:L.isMarkdownString(ce.documentation)?j.to(ce.documentation):ce.documentation}}Oe.to=Pe})(Y||(e.ParameterInformation=Y={}));var ie;(function(Oe){function Ae(ce){return{label:ce.label,documentation:j.fromStrict(ce.documentation),parameters:Array.isArray(ce.parameters)?ce.parameters.map(Y.from):[],activeParameter:ce.activeParameter}}Oe.from=Ae;function Pe(ce){return{label:ce.label,documentation:L.isMarkdownString(ce.documentation)?j.to(ce.documentation):ce.documentation,parameters:Array.isArray(ce.parameters)?ce.parameters.map(Y.to):[],activeParameter:ce.activeParameter}}Oe.to=Pe})(ie||(e.SignatureInformation=ie={}));var pe;(function(Oe){function Ae(ce){return{activeSignature:ce.activeSignature,activeParameter:ce.activeParameter,signatures:Array.isArray(ce.signatures)?ce.signatures.map(ie.from):[]}}Oe.from=Ae;function Pe(ce){return{activeSignature:ce.activeSignature,activeParameter:ce.activeParameter,signatures:Array.isArray(ce.signatures)?ce.signatures.map(ie.to):[]}}Oe.to=Pe})(pe||(e.SignatureHelp=pe={}));var Ie;(function(Oe){function Ae(Pe,ce){const Me=new a.InlayHint(v.to(ce.position),typeof ce.label=="string"?ce.label:ce.label.map(he.to.bind(void 0,Pe)),ce.kind&&Re.to(ce.kind));return Me.textEdits=ce.textEdits&&ce.textEdits.map(se.to),Me.tooltip=L.isMarkdownString(ce.tooltip)?j.to(ce.tooltip):ce.tooltip,Me.paddingLeft=ce.paddingLeft,Me.paddingRight=ce.paddingRight,Me}Oe.to=Ae})(Ie||(e.InlayHint=Ie={}));var he;(function(Oe){function Ae(Pe,ce){const Me=new a.InlayHintLabelPart(ce.label);return Me.tooltip=L.isMarkdownString(ce.tooltip)?j.to(ce.tooltip):ce.tooltip,b.Command.is(ce.command)&&(Me.command=Pe.fromInternal(ce.command)),ce.location&&(Me.location=Q.to(ce.location)),Me}Oe.to=Ae})(he||(e.InlayHintLabelPart=he={}));var Re;(function(Oe){function Ae(ce){return ce}Oe.from=Ae;function Pe(ce){return ce}Oe.to=Pe})(Re||(e.InlayHintKind=Re={}));var Te;(function(Oe){function Ae(ce){return{range:o.from(ce.range),url:ce.target,tooltip:ce.tooltip}}Oe.from=Ae;function Pe(ce){let Me;if(ce.url)try{Me=typeof ce.url=="string"?D.URI.parse(ce.url,!0):D.URI.revive(ce.url)}catch{}return new a.DocumentLink(o.to(ce.range),Me)}Oe.to=Pe})(Te||(e.DocumentLink=Te={}));var Ve;(function(Oe){function Ae(ce){const Me=new a.ColorPresentation(ce.label);return ce.textEdit&&(Me.textEdit=se.to(ce.textEdit)),ce.additionalTextEdits&&(Me.additionalTextEdits=ce.additionalTextEdits.map(We=>se.to(We))),Me}Oe.to=Ae;function Pe(ce){return{label:ce.label,textEdit:ce.textEdit?se.from(ce.textEdit):void 0,additionalTextEdits:ce.additionalTextEdits?ce.additionalTextEdits.map(Me=>se.from(Me)):void 0}}Oe.from=Pe})(Ve||(e.ColorPresentation=Ve={}));var xe;(function(Oe){function Ae(ce){return new a.Color(ce[0],ce[1],ce[2],ce[3])}Oe.to=Ae;function Pe(ce){return[ce.red,ce.green,ce.blue,ce.alpha]}Oe.from=Pe})(xe||(e.Color=xe={}));var tt;(function(Oe){function Ae(ce){return{range:o.from(ce.range)}}Oe.from=Ae;function Pe(ce){return new a.SelectionRange(o.to(ce.range))}Oe.to=Pe})(tt||(e.SelectionRange=tt={}));var Qe;(function(Oe){function Ae(Pe){switch(Pe){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Oe.to=Ae})(Qe||(e.TextDocumentSaveReason=Qe={}));var Xe;(function(Oe){function Ae(ce){switch(ce){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Oe.from=Ae;function Pe(ce){switch(ce){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Oe.to=Pe})(Xe||(e.TextEditorLineNumbersStyle=Xe={}));var nt;(function(Oe){function Ae(ce){if(ce===a.EndOfLine.CRLF)return 1;if(ce===a.EndOfLine.LF)return 0}Oe.from=Ae;function Pe(ce){if(ce===1)return a.EndOfLine.CRLF;if(ce===0)return a.EndOfLine.LF}Oe.to=Pe})(nt||(e.EndOfLine=nt={}));var ot;(function(Oe){function Ae(Pe){if(typeof Pe=="object")return Pe.viewId;switch(Pe){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Oe.from=Ae})(ot||(e.ProgressLocation=ot={}));var et;(function(Oe){function Ae(ce){const Me={start:ce.start+1,end:ce.end+1};return ce.kind&&(Me.kind=Be.from(ce.kind)),Me}Oe.from=Ae;function Pe(ce){const Me={start:ce.start-1,end:ce.end-1};return ce.kind&&(Me.kind=Be.to(ce.kind)),Me}Oe.to=Pe})(et||(e.FoldingRange=et={}));var Be;(function(Oe){function Ae(ce){if(ce)switch(ce){case a.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}Oe.from=Ae;function Pe(ce){if(ce)switch(ce.value){case b.FoldingRangeKind.Comment.value:return a.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports.value:return a.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region.value:return a.FoldingRangeKind.Region}}Oe.to=Pe})(Be||(e.FoldingRangeKind=Be={}));var ke;(function(Oe){function Ae(Pe){if(Pe)return{pinned:typeof Pe.preview=="boolean"?!Pe.preview:void 0,inactive:Pe.background,preserveFocus:Pe.preserveFocus,selection:typeof Pe.selection=="object"?o.from(Pe.selection):void 0,override:typeof Pe.override=="boolean"?d.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Oe.from=Ae})(ke||(e.TextEditorOpenOptions=ke={}));var X;(function(Oe){function Ae(We){return We instanceof a.RelativePattern?We.toJSON():typeof We=="string"?We:Pe(We)||ce(We)?new a.RelativePattern(We.baseUri??We.base,We.pattern).toJSON():We}Oe.from=Ae;function Pe(We){const Ye=We;return Ye?D.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function ce(We){const Ye=We;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Me(We){return typeof We=="string"?We:new a.RelativePattern(D.URI.revive(We.baseUri),We.pattern)}Oe.to=Me})(X||(e.GlobPattern=X={}));var J;(function(Oe){function Ae(Pe){if(Pe){if(Array.isArray(Pe))return Pe.map(Ae);if(typeof Pe=="string")return Pe;{const ce=Pe;return{language:ce.language,scheme:ce.scheme,pattern:X.from(ce.pattern),exclusive:ce.exclusive,notebookType:ce.notebookType}}}else return}Oe.from=Ae})(J||(e.LanguageSelector=J={}));var me;(function(Oe){function Ae(ce){return{start:ce.start,end:ce.end}}Oe.from=Ae;function Pe(ce){return new a.NotebookRange(ce.start,ce.end)}Oe.to=Pe})(me||(e.NotebookRange=me={}));var Fe;(function(Oe){function Ae(ce){return{timing:typeof ce.runStartTime=="number"&&typeof ce.runEndTime=="number"?{startTime:ce.runStartTime,endTime:ce.runEndTime}:void 0,executionOrder:ce.executionOrder,success:ce.lastRunSuccess}}Oe.to=Ae;function Pe(ce){return{lastRunSuccess:ce.success,runStartTime:ce.timing?.startTime,runEndTime:ce.timing?.endTime,executionOrder:ce.executionOrder}}Oe.from=Pe})(Fe||(e.NotebookCellExecutionSummary=Fe={}));var ze;(function(Oe){function Ae(Pe){if(Pe===S.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(Pe===S.NotebookCellExecutionState.Pending)return;if(Pe===S.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Pe}`)}Oe.to=Ae})(ze||(e.NotebookCellExecutionState=ze={}));var He;(function(Oe){function Ae(ce){switch(ce){case a.NotebookCellKind.Markup:return S.CellKind.Markup;case a.NotebookCellKind.Code:default:return S.CellKind.Code}}Oe.from=Ae;function Pe(ce){switch(ce){case S.CellKind.Markup:return a.NotebookCellKind.Markup;case S.CellKind.Code:default:return a.NotebookCellKind.Code}}Oe.to=Pe})(He||(e.NotebookCellKind=He={}));var Je;(function(Oe){function Ae(ce){const Me={metadata:ce.metadata??Object.create(null),cells:[]};for(const We of ce.cells)a.NotebookCellData.validate(We),Me.cells.push(ct.from(We));return Me}Oe.from=Ae;function Pe(ce){const Me=new a.NotebookData(ce.cells.map(ct.to));return(0,m.isEmptyObject)(ce.metadata)||(Me.metadata=ce.metadata),Me}Oe.to=Pe})(Je||(e.NotebookData=Je={}));var ct;(function(Oe){function Ae(ce){return{cellKind:He.from(ce.kind),language:ce.languageId,mime:ce.mime,source:ce.value,metadata:ce.metadata,internalMetadata:Fe.from(ce.executionSummary??{}),outputs:ce.outputs?ce.outputs.map(ft.from):[]}}Oe.from=Ae;function Pe(ce){return new a.NotebookCellData(He.to(ce.cellKind),ce.source,ce.language,ce.mime,ce.outputs?ce.outputs.map(ft.to):void 0,ce.metadata,ce.internalMetadata?Fe.to(ce.internalMetadata):void 0)}Oe.to=Pe})(ct||(e.NotebookCellData=ct={}));var st;(function(Oe){function Ae(ce){return{mime:ce.mime,valueBytes:R.VSBuffer.wrap(ce.data)}}Oe.from=Ae;function Pe(ce){return new a.NotebookCellOutputItem(ce.valueBytes.buffer,ce.mime)}Oe.to=Pe})(st||(e.NotebookCellOutputItem=st={}));var ft;(function(Oe){function Ae(ce){return{outputId:ce.id,items:ce.items.map(st.from),metadata:ce.metadata}}Oe.from=Ae;function Pe(ce){const Me=ce.items.map(st.to);return new a.NotebookCellOutput(Me,ce.outputId,ce.metadata)}Oe.to=Pe})(ft||(e.NotebookCellOutput=ft={}));var Pt;(function(Oe){function Ae(Me){return ce(Me)?{include:(0,m.withNullAsUndefined)(X.from(Me.include)),exclude:(0,m.withNullAsUndefined)(X.from(Me.exclude))}:(0,m.withNullAsUndefined)(X.from(Me))}Oe.from=Ae;function Pe(Me){return ce(Me)?{include:X.to(Me.include),exclude:X.to(Me.exclude)}:X.to(Me)}Oe.to=Pe;function ce(Me){const We=Me;return We?!(0,m.isUndefinedOrNull)(We.include)&&!(0,m.isUndefinedOrNull)(We.exclude):!1}})(Pt||(e.NotebookExclusiveDocumentPattern=Pt={}));var Tt;(function(Oe){function Ae(Pe,ce,Me){const We=typeof Pe.command=="string"?{title:"",command:Pe.command}:Pe.command;return{alignment:Pe.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:ce.toInternal(We,Me),text:Pe.text,tooltip:Pe.tooltip,accessibilityInformation:Pe.accessibilityInformation,priority:Pe.priority}}Oe.from=Ae})(Tt||(e.NotebookStatusBarItem=Tt={}));var vt;(function(Oe){function Ae(Pe,ce,Me){const We=typeof Pe.command=="string"?{title:"",command:Pe.command}:Pe.command;return{command:ce.toInternal(We,Me),label:Pe.label,description:Pe.description,detail:Pe.detail,documentation:Pe.documentation}}Oe.from=Ae})(vt||(e.NotebookKernelSourceAction=vt={}));var Ht;(function(Oe){function Ae(Pe){return{transientOutputs:Pe?.transientOutputs??!1,transientCellMetadata:Pe?.transientCellMetadata??{},transientDocumentMetadata:Pe?.transientDocumentMetadata??{},cellContentMetadata:Pe?.cellContentMetadata??{}}}Oe.from=Ae})(Ht||(e.NotebookDocumentContentOptions=Ht={}));var Mt;(function(Oe){function Ae(ce){return{uri:ce.uri,provides:ce.provides}}Oe.from=Ae;function Pe(ce){return new a.NotebookRendererScript(D.URI.revive(ce.uri),ce.provides)}Oe.to=Pe})(Mt||(e.NotebookRendererScript=Mt={}));var qt;(function(Oe){function Ae(ce){return{message:j.fromStrict(ce.message)||"",type:0,expected:ce.expectedOutput,actual:ce.actualOutput,location:ce.location&&{range:o.from(ce.location.range),uri:ce.location.uri}}}Oe.from=Ae;function Pe(ce){const Me=new a.TestMessage(typeof ce.message=="string"?ce.message:j.to(ce.message));return Me.actualOutput=ce.actual,Me.expectedOutput=ce.expected,Me.location=ce.location?Q.to(ce.location):void 0,Me}Oe.to=Pe})(qt||(e.TestMessage=qt={}));var Ft;(function(Oe){Oe.namespace=p.namespaceTestTag,Oe.denamespace=p.denamespaceTestTag})(Ft||(e.TestTag=Ft={}));var Ut;(function(Oe){function Ae(ce){const Me=(0,h.getPrivateApiFor)(ce).controllerId;return{extId:w.TestId.fromExtHostTestItem(ce,Me).toString(),label:ce.label,uri:D.URI.revive(ce.uri),busy:ce.busy,tags:ce.tags.map(We=>Ft.namespace(Me,We.id)),range:C.Range.lift(o.from(ce.range)),description:ce.description||null,sortText:ce.sortText||null,error:ce.error&&j.fromStrict(ce.error)||null}}Oe.from=Ae;function Pe(ce){return{parent:void 0,error:void 0,id:w.TestId.fromString(ce.extId).localId,label:ce.label,uri:D.URI.revive(ce.uri),tags:(ce.tags||[]).map(Me=>{const{tagId:We}=Ft.denamespace(Me);return new a.TestTag(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(ce.range||void 0),canResolveChildren:!1,busy:ce.busy,description:ce.description||void 0,sortText:ce.sortText||void 0}}Oe.toPlain=Pe})(Ut||(e.TestItem=Ut={})),function(Oe){function Ae(ce){return{id:ce.id}}Oe.from=Ae;function Pe(ce){return new a.TestTag(ce.id)}Oe.to=Pe}(Ft||(e.TestTag=Ft={}));var jt;(function(Oe){const Ae=(ce,Me)=>{const We=[];for(const[Ge,it]of Me)w.TestId.compare(it.item.extId,Ge)===2&&(Me.delete(Ge),We.push(it));const Ye={...Ut.toPlain(ce.item),parent:void 0,taskStates:ce.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(it=>it.type===0).map(qt.to)})),children:We.map(Ge=>Ae(Ge,Me))};for(const Ge of Ye.children)Ge.parent=Ye;return Ye};function Pe(ce){const Me=[],We=new Map;for(const Ye of ce.items){We.set(Ye.item.extId,Ye);const Ge=w.TestId.root(Ye.item.extId);ce.request.targets.some(it=>it.controllerId===Ge&&it.testIds.includes(Ye.item.extId))&&Me.push(Ye)}return{completedAt:ce.completedAt,results:Me.map(Ye=>Ae(Ye,We))}}Oe.to=Pe})(jt||(e.TestResults=jt={}));var ut;(function(Oe){function Ae(We){return{covered:We.covered,total:We.covered}}function Pe(We){return"line"in We?v.from(We):o.from(We)}function ce(We){return"branches"in We?{count:We.executionCount,location:Pe(We.location),type:1,branches:We.branches.length?We.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&Pe(Ye.location)})):void 0}:{type:0,count:We.executionCount,location:Pe(We.location)}}Oe.fromDetailed=ce;function Me(We){return{uri:We.uri,statement:Ae(We.statementCoverage),branch:We.branchCoverage&&Ae(We.branchCoverage),function:We.functionCoverage&&Ae(We.functionCoverage),details:We.detailedCoverage?.map(ce)}}Oe.fromFile=Me})(ut||(e.TestCoverage=ut={}));var gt;(function(Oe){function Ae(Pe){switch(Pe){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Oe.to=Ae})(gt||(e.CodeActionTriggerKind=gt={}));var Bt;(function(Oe){function Ae(ce){const Me=new a.TypeHierarchyItem(Z.to(ce.kind),ce.name,ce.detail||"",D.URI.revive(ce.uri),o.to(ce.range),o.to(ce.selectionRange));return Me._sessionId=ce._sessionId,Me._itemId=ce._itemId,Me}Oe.to=Ae;function Pe(ce,Me,We){if(Me=Me??ce._sessionId,We=We??ce._itemId,Me===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:We,kind:Z.from(ce.kind),name:ce.name,detail:ce.detail??"",uri:ce.uri,range:o.from(ce.range),selectionRange:o.from(ce.selectionRange),tags:ce.tags?.map(q.from)}}Oe.from=Pe})(Bt||(e.TypeHierarchyItem=Bt={}));var $t;(function(Oe){function Ae(Pe){if(Pe)return{value:Pe.value,tooltip:Pe.tooltip}}Oe.from=Ae})($t||(e.ViewBadge=$t={}));var yt;(function(Oe){function Ae(We,Ye,Ge){const it=Ye.fileData;return it?new a.InternalFileDataTransferItem(new a.DataTransferFile(it.name,D.URI.revive(it.uri),it.id,(0,O.once)(()=>Ge(it.id)))):We===T.Mimes.uriList&&Ye.uriListData?new a.InternalDataTransferItem(Me(Ye.uriListData)):new a.InternalDataTransferItem(Ye.asString)}Oe.to=Ae;async function Pe(We,Ye){const Ge=await Ye.asString();if(We===T.Mimes.uriList)return{asString:Ge,fileData:void 0,uriListData:ce(Ge)};const it=Ye.asFile();return{asString:Ge,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}Oe.from=Pe;function ce(We){return u.UriList.split(We).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return D.URI.parse(Ye)}catch{}return Ye})}function Me(We){return u.UriList.create(We.map(Ye=>typeof Ye=="string"?Ye:D.URI.revive(Ye)))}})(yt||(e.DataTransferItem=yt={}));var mt;(function(Oe){function Ae(ce,Me){const We=ce.items.map(([Ye,Ge])=>[Ye,yt.to(Ye,Ge,Me)]);return new a.DataTransfer(We)}Oe.toDataTransfer=Ae;async function Pe(ce){const Me={items:[]},We=[];for(const[Ye,Ge]of ce)We.push((async()=>{Me.items.push([Ye,await yt.from(Ye,Ge)])})());return await Promise.all(We),Me}Oe.from=Pe})(mt||(e.DataTransfer=mt={}));var kt;(function(Oe){function Ae(ce){return{message:ce.message,metadata:ce.metadata,title:ce.title,tooltip:ce.tooltip}}Oe.to=Ae;function Pe(ce){return{kind:"reply",message:ce.message,metadata:ce.metadata,title:ce.title,tooltip:ce.tooltip}}Oe.from=Pe})(kt||(e.ChatReplyFollowup=kt={}));var zt;(function(Oe){function Ae(Pe){return typeof Pe=="string"?{title:Pe,message:Pe,kind:"reply"}:"commandId"in Pe?{kind:"command",title:Pe.title??"",commandId:Pe.commandId??"",args:Pe.args}:kt.from(Pe)}Oe.from=Ae})(zt||(e.ChatFollowup=zt={}))}),define(Ce[262],De([1,0,2,8,7,13,68]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(g,T,P,m={timeout:1500,errors:3}){this.c=g,this.d=T,this.f=P,this.g=m,this.a=new L.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(T,P,m)=>{const C={dispose:this.a.push([T,P,g])};return Array.isArray(m)&&m.push(C),C}}async $participateInSave(g,T){const P=c.URI.revive(g);let m=!1;const D=setTimeout(()=>m=!0,this.g.timeout),C=[];try{for(const b of[...this.a]){if(m)break;const n=this.d.getDocument(P),h=await this.h(b,{document:n,reason:O.TextDocumentSaveReason.to(T)});C.push(h)}}finally{clearTimeout(D)}return C}h([g,T,P],m){const D=this.b.get(g);return typeof D=="number"&&D>this.g.errors?Promise.resolve(!1):this.i(P,g,T,m).then(()=>!0,C=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const b=this.b.get(g);this.b.set(g,b?b+1:1),typeof b=="number"&&b>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,T,P,m){const D=[],C=Date.now(),{document:b,reason:n}=m,{version:h}=b,d=Object.freeze({document:b,reason:n,waitUntil(S){if(Object.isFrozen(D))throw(0,R.illegalState)("waitUntil can not be called async");D.push(Promise.resolve(S))}});try{T.apply(P,[d])}catch(S){return Promise.reject(S)}return Object.freeze(D),new Promise((S,w)=>{const p=setTimeout(()=>w(new Error("timeout")),this.g.timeout);return Promise.all(D).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(p),S(t)}).catch(t=>{clearTimeout(p),w(t)})}).then(S=>{const w={edits:[]};for(const p of S)if(Array.isArray(p)&&p.every(t=>t instanceof u.TextEdit))for(const{newText:t,newEol:a,range:r}of p)w.edits.push({resource:b.uri,versionId:void 0,textEdit:{range:r&&O.Range.from(r),text:t,eol:a&&O.EndOfLine.from(a)}});if(w.edits.length!==0)return h===b.version?this.f.$tryApplyWorkspaceEdit(w):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ce[263],De([1,0,18,2,13,7,101]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(P,m,D,C){this.start=P,this.deletedCount=m,this.deletedItems=D,this.items=C}asApiEvent(){return{range:new O.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(P,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,m,D){this.notebook=P,this.h=m,this.j=D,this.handle=D.handle,this.uri=R.URI.revive(D.uri),this.cellKind=D.cellKind,this.a=D.outputs.map(u.NotebookCellOutput.to),this.e=D.internalMetadata??{},this.b=Object.freeze(D.metadata??{}),this.d=Object.freeze(u.NotebookCellExecutionSummary.to(D.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const D={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:u.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return P.g},set mime(C){P.g=C},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(D)}return this.f}setOutputs(P){this.a=P.map(u.NotebookCellOutput.to)}setOutputItems(P,m,D){const C=D.map(u.NotebookCellOutputItem.to),b=this.a.find(n=>n.id===P);if(b&&(m||(b.items.length=0),b.items.push(...C),b.items.length>1&&b.items.every(n=>L.isTextStreamMime(n.mime)))){const n=new Map,h=[];b.items.forEach(d=>{let S;n.has(d.mime)?S=n.get(d.mime):(S=[],n.set(d.mime,S),h.push(d.mime)),S.push(d.data)}),b.items.length=0,h.forEach(d=>{const S=L.compressOutputItemStreams(n.get(d));b.items.push({mime:d,data:S.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(u.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=y;class g{constructor(P,m,D,C,b){this.k=P,this.l=m,this.m=D,this.uri=C,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=b.viewType,this.f=Object.freeze(b.metadata??Object.create(null)),this.r([[0,0,b.cells]],!0,void 0),this.g=b.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const P=this,m={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===c.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(D){return D=P.n(D),P.b[D].apiCell},getCells(D){return(D?P.p(D):P.b).map(b=>b.apiCell)},save(){return P.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,m,D){this.g=P.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:D});const C={notebook:this.apiNotebook,metadata:D,cellChanges:[],contentChanges:[]},b=[];for(const h of P.rawEvents)h.kind===L.NotebookCellsChangeType.ModelChange?this.r(h.changes,!1,C.contentChanges):h.kind===L.NotebookCellsChangeType.Move?this.s(h.index,h.length,h.newIdx,C.contentChanges):h.kind===L.NotebookCellsChangeType.Output?(this.t(h.index,h.outputs),b.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===L.NotebookCellsChangeType.OutputItem?(this.u(h.index,h.outputId,h.append,h.outputItems),b.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(h.index,h.language),b.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document})):h.kind===L.NotebookCellsChangeType.ChangeCellContent?b.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document}):h.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(h.index,h.mime):h.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(h.index,h.metadata),b.push({cell:this.b[h.index].apiCell,metadata:this.b[h.index].apiCell.metadata})):h.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(h.index,h.internalMetadata),b.push({cell:this.b[h.index].apiCell,executionSummary:this.b[h.index].apiCell.executionSummary}));const n=new Map;for(let h=0;h<b.length;h++){const d=b[h],S=n.get(d.cell);if(S===void 0){const w=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...d});n.set(d.cell,w-1)}else C.cellChanges[S]={...C.cellChanges[S],...d}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let m=P.start|0,D=P.end|0;return m<0&&(m=0),D>this.b.length&&(D=this.b.length),P.with({start:m,end:D})}p(P){P=this.o(P);const m=[];for(let D=P.start;D<P.end;D++)m.push(this.b[D]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,m,D){if(this.j)return;const C=[],b=[],n=[];if(P.reverse().forEach(h=>{const S=h[2].map(t=>{const a=new y(this,this.l,t);return m||b.push(y.asModelAddData(this.apiNotebook,t)),a}),w=new A(h[0],h[1],[],S),p=this.b.splice(h[0],h[1],...S);for(const t of p)n.push(t.uri),w.deletedItems.push(t.apiCell);C.push(w)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:b,removedDocuments:n}),D)for(const h of C)D.push(h.asApiEvent())}s(P,m,D,C){const b=this.b.splice(P,m);this.b.splice(D,0,...b);const n=[new A(P,m,b.map(h=>h.apiCell),[]),new A(D,0,[],b)];for(const h of n)C.push(h.asApiEvent())}t(P,m){this.b[P].setOutputs(m)}u(P,m,D,C){this.b[P].setOutputItems(m,D,C)}v(P,m){const D=this.b[P];D.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(D.uri,m)}w(P,m){const D=this.b[P];D.apiCell.mime=m}x(P,m){this.b[P].setMetadata(m)}y(P,m){this.b[P].setInternalMetadata(m)}getCellFromApiCell(P){return this.b.find(m=>m.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(m=>m.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.ExtHostNotebookDocument=g,g.a=0}),define(Ce[264],De([1,0,3,2,13,7]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class L{constructor(y,g,T,P={timeout:1500,errors:3}){this.b=y,this.c=g,this.d=T,this.f=P,this.a=new c.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(g,T,P)=>{const m=function(C){g.call(T,C)};return m.extension=y,this.a.event(m,void 0,P)}}async $participateInSave(y,g,T){const P=R.URI.revive(y),m=this.c.getNotebookDocument(P);if(!m)throw new Error("Unable to resolve notebook document");const D=[];if(await this.a.fireAsync({notebook:m.apiNotebook,reason:u.TextDocumentSaveReason.to(g)},T,async(b,n)=>{const h=Date.now(),d=await await Promise.resolve(b);Date.now()-h>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier),!T.isCancellationRequested&&d&&(d instanceof O.WorkspaceEdit?D.push(d):this.b.warn("onWillSaveNotebookDocument-listener from extension",n.extension.identifier,"ignored due to invalid data"))}),T.isCancellationRequested)return!1;if(D.length===0)return!0;const C={edits:[]};for(const b of D){const{edits:n}=u.WorkspaceEdit.from(b);C.edits=C.edits.concat(n)}return this.d.$tryApplyWorkspaceEdit(C)}}e.ExtHostNotebookDocumentSaveParticipant=L}),define(Ce[140],De([1,0,8,13,7]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class O{constructor(A,y,g,T,P,m){this.id=A,this.f=y,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=T,this.c=m}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(y){this.selections=[y]},get selections(){return A.a},set selections(y){if(!Array.isArray(y)||!y.every(u.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");A.a=y,A.g(y)},get visibleRanges(){return A.b},revealRange(y,g){A.f.$tryRevealRange(A.id,R.NotebookRange.from(y),g??u.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(R.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}e.ExtHostNotebookEditor=O,O.apiEditorsToExtHost=new WeakMap}),define(Ce[265],De([1,0,8,3,17,13]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let L=e.ExtHostNotebookEditors=class{constructor(y,g){this.c=y,this.d=g,this.a=new R.Emitter({onListenerError:c.onUnexpectedExternalError}),this.b=new R.Emitter({onListenerError:c.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(y,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,g);const T=this.d.getEditorById(y);g.visibleRanges&&T._acceptVisibleRanges(g.visibleRanges.ranges.map(O.NotebookRange.to)),g.selections&&T._acceptSelections(g.selections.selections.map(O.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:T.apiEditor,visibleRanges:T.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:T.apiEditor,selections:T.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const g in y)this.d.getEditorById(g)._acceptViewColumn(O.ViewColumn.to(y[g]))}};e.ExtHostNotebookEditors=L=qe([je(0,u.ILogService)],L)}),define(Ce[266],De([1,0,13,128,193,21,66,8]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,D,C){const b=this.b++,{title:n,location:h,cancellable:d}=D,S={label:(0,u.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(b,{location:c.ProgressLocation.from(h),title:n,source:S,cancellable:d},m.isUnderDevelopment?void 0:m.identifier.value).catch(A.onUnexpectedExternalError),this.d(b,C,!!d)}d(m,D,C){let b;C&&(b=new O.CancellationTokenSource,this.c.set(m,b));const n=d=>{this.a.$progressEnd(d),this.c.delete(d),b?.dispose()};let h;try{h=D(new T(this.a,m),C&&b?b.token:O.CancellationToken.None)}catch(d){throw n(m),d}return h.then(d=>n(m),d=>n(m)),h}$acceptProgressCanceled(m){const D=this.c.get(m);D&&(D.cancel(),this.c.delete(m))}}e.ExtHostProgress=y;function g(P,m){return P.message=m.message,typeof m.increment=="number"&&(typeof P.increment=="number"?P.increment+=m.increment:P.increment=m.increment),P}class T extends R.Progress{constructor(m,D){super(C=>this.throttledReport(C)),this.c=m,this.d=D}throttledReport(m){this.c.$progressReport(this.d,m)}}qe([(0,L.throttle)(100,(P,m)=>g(P,m),()=>Object.create(null))],T.prototype,"throttledReport",null)}),define(Ce[141],De([1,0,36,136,60,102,81,13,2]),function(re,e,c,R,u,O,L,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const g=(S,w,p,t)=>{let a=w;return{enumerable:!0,configurable:!1,get(){return a},set(r){if(!p(a,r)){const o=a;a=r,S.listener?.(t(r,o))}}}},T=(S,w)=>S===w,P={range:(S,w)=>S===w?!0:!S||!w?!1:S.isEqual(w),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(S,w)=>!(S.length!==w.length||S.some(p=>!w.find(t=>p.id===t.id)))},m=S=>w=>({op:4,update:S(w)}),D=(S,w)=>({range:(()=>{let p;const t=m(a=>({range:c.Range.lift(A.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return p},set(a){S.listener?.({op:6}),P.range(p,a)||(p=a,S.listener?.(t(a)))}}})(),label:g(S,w,P.label,m(p=>({label:p}))),description:g(S,void 0,P.description,m(p=>({description:p}))),sortText:g(S,void 0,P.sortText,m(p=>({sortText:p}))),canResolveChildren:g(S,!1,P.canResolveChildren,p=>({op:2,state:p})),busy:g(S,!1,P.busy,m(p=>({busy:p}))),error:g(S,void 0,P.error,m(p=>({error:A.MarkdownString.fromStrict(p)||null}))),tags:g(S,[],P.tags,(p,t)=>({op:1,new:p.map(A.TestTag.from),old:t.map(A.TestTag.from)}))}),C=S=>{const w=u.TestId.fromString(S.extId),p=new n(w.controllerId,w.localId,S.label,y.URI.revive(S.uri)||void 0);return p.range=A.Range.to(S.range||void 0),p.description=S.description||void 0,p.sortText=S.sortText||void 0,p.tags=S.tags.map(t=>A.TestTag.to({id:(0,L.denamespaceTestTag)(t).tagId})),p},b=S=>{let w;for(const p of S.tests){const t=C(p.item);(0,R.getPrivateApiFor)(t).parent=w,w=t}return w};e.toItemFromContext=b;class n{constructor(w,p,t,a){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const r=(0,R.createPrivateApiFor)(this,w);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof h?void 0:r.parent}},children:{value:(0,O.createTestItemChildren)(r,R.getPrivateApiFor,n),enumerable:!0,writable:!1},...D(r,t)})}}e.TestItemImpl=n;class h extends n{constructor(w,p){super(w,w,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class d extends O.TestItemCollection{constructor(w,p,t){super({controllerId:w,getDocumentVersion:a=>a&&t.getDocument(a)?.version,getApiFor:R.getPrivateApiFor,getChildren:a=>a.children,root:new h(w,p),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=d}),define(Ce[142],De([1,0,52,8,110,13,7]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(m,D,C){const b=A.c.nextId();m.$registerTextEditorDecorationType(D.identifier,b,O.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:b,dispose(){m.$removeTextEditorDecorationType(b)}})}}e.TextEditorDecorationType=A,A.c=new u.IdGenerator("TextEditorDecorationType");class y{constructor(m,D){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=D.undoStopBefore,this.f=D.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,D){this.k();let C=null;if(m instanceof L.Position)C=new L.Range(m,m);else if(m instanceof L.Range)C=m;else throw new Error("Unrecognized location");this.l(C,D,!1)}insert(m,D){this.k(),this.l(new L.Range(m,m),D,!0)}delete(m){this.k();let D=null;if(m instanceof L.Range)D=m;else throw new Error("Unrecognized location");this.l(D,null,!0)}l(m,D,C){const b=this.c.validateRange(m);this.g.push({range:b,text:D,forceMoveMarkers:C})}setEndOfLine(m){if(this.k(),m!==L.EndOfLine.LF&&m!==L.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this.h=m}}class g{constructor(m,D,C,b){this.c=m,this.d=D,this._accept(C),this.e=b;const n=this;this.value={get tabSize(){return n.f},set tabSize(h){n.m(h)},get indentSize(){return n.g},set indentSize(h){n.o(h)},get insertSpaces(){return n.h},set insertSpaces(h){n.q(h)},get cursorStyle(){return n.j},set cursorStyle(h){n.s(h)},get lineNumbers(){return n.k},set lineNumbers(h){n.t(h)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=O.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const D=Math.floor(m);return D>0?D:null}if(typeof m=="string"){const D=parseInt(m,10);return isNaN(D)?null:D>0?D:null}return null}m(m){const D=this.l(m);if(D!==null){if(typeof D=="number"){if(this.f===D)return;this.f=D}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:D}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const D=Math.floor(m);return D>0?D:null}if(typeof m=="string"){const D=parseInt(m,10);return isNaN(D)?null:D>0?D:null}return null}o(m){const D=this.n(m);if(D!==null){if(typeof D=="number"){if(this.g===D)return;this.g=D}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:D}))}}p(m){return m==="auto"?"auto":m==="false"?!1:!!m}q(m){const D=this.p(m);if(typeof D=="boolean"){if(this.h===D)return;this.h=D}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:D}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(m)})))}assign(m){const D={};let C=!1;if(typeof m.tabSize<"u"){const b=this.l(m.tabSize);b==="auto"?(C=!0,D.tabSize=b):typeof b=="number"&&this.f!==b&&(this.f=b,C=!0,D.tabSize=b)}if(typeof m.indentSize<"u"){const b=this.n(m.indentSize);b==="tabSize"?(C=!0,D.indentSize=b):typeof b=="number"&&this.g!==b&&(this.g=b,C=!0,D.indentSize=b)}if(typeof m.insertSpaces<"u"){const b=this.p(m.insertSpaces);b==="auto"?(C=!0,D.insertSpaces=b):this.h!==b&&(this.h=b,C=!0,D.insertSpaces=b)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,C=!0,D.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,C=!0,D.lineNumbers=O.TextEditorLineNumbersStyle.from(m.lineNumbers)),C&&this.u("setOptions",this.c.$trySetOptions(this.d,D))}u(m,D){D.catch(C=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(C)})}}e.ExtHostTextEditorOptions=g;class T{constructor(m,D,C,b,n,h,d,S){this.id=m,this.j=D,this.k=C,this.g=!1,this.h=new Set,this.c=n,this.d=new g(this.j,this.id,h,C),this.e=d,this.f=S;const w=this;this.value=Object.freeze({get document(){return b.value},set document(p){throw(0,R.readonly)("document")},get selection(){return w.c&&w.c[0]},set selection(p){if(!(p instanceof L.Selection))throw(0,R.illegalArgument)("selection");w.c=[p],w.l()},get selections(){return w.c},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof L.Selection)))throw(0,R.illegalArgument)("selections");w.c=p,w.l()},get visibleRanges(){return w.e},set visibleRanges(p){throw(0,R.readonly)("visibleRanges")},get options(){return w.d.value},set options(p){w.g||w.d.assign(p)},get viewColumn(){return w.f},set viewColumn(p){throw(0,R.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(w.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new y(b.value,t);return p(a),w.m(a)},insertSnippet(p,t,a={undoStopBefore:!0,undoStopAfter:!0}){if(w.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=w.c.map(o=>O.Range.from(o));else if(t instanceof L.Position){const{lineNumber:o,column:f}=O.Position.from(t);r=[{startLineNumber:o,startColumn:f,endLineNumber:o,endColumn:f}]}else if(t instanceof L.Range)r=[O.Range.from(t)];else{r=[];for(const o of t)if(o instanceof L.Range)r.push(O.Range.from(o));else{const{lineNumber:f,column:v}=O.Position.from(o);r.push({startLineNumber:f,startColumn:v,endLineNumber:f,endColumn:v})}}return D.$tryInsertSnippet(m,b.value.version,p.value,r,a)},setDecorations(p,t){const a=t.length===0;a&&!w.h.has(p.key)||(a?w.h.delete(p.key):w.h.add(p.key),w.n(()=>{if(O.isDecorationOptionsArr(t))return D.$trySetDecorations(m,p.key,O.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let o=0,f=t.length;o<f;o++){const v=t[o];r[4*o]=v.start.line+1,r[4*o+1]=v.start.character+1,r[4*o+2]=v.end.line+1,r[4*o+3]=v.end.character+1}return D.$trySetDecorationsFast(m,p.key,r)}}))},revealRange(p,t){w.n(()=>D.$tryRevealRange(m,O.Range.from(p),t||L.TextEditorRevealType.Default))},show(p){D.$tryShowEditor(m,O.ViewColumn.from(p))},hide(){D.$tryHideEditor(m)}})}dispose(){(0,c.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,c.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,c.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,c.ok)(!this.g),this.f=m}_acceptSelections(m){(0,c.ok)(!this.g),this.c=m}async l(){const m=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const D=m.finalize();if(D.edits.length===0&&!D.setEndOfLine)return Promise.resolve(!0);const C=D.edits.map(n=>n.range);C.sort((n,h)=>n.end.line===h.end.line?n.end.character===h.end.character?n.start.line===h.start.line?n.start.character-h.start.character:n.start.line-h.start.line:n.end.character-h.end.character:n.end.line-h.end.line);for(let n=0,h=C.length-1;n<h;n++){const d=C[n].end;if(C[n+1].start.isBefore(d))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const b=D.edits.map(n=>({range:O.Range.from(n.range),text:n.text,forceMoveMarkers:n.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,D.documentVersionId,b,{setEndOfLine:typeof D.setEndOfLine=="number"?O.EndOfLine.from(D.setEndOfLine):void 0,undoStopBefore:D.undoStopBefore,undoStopAfter:D.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,D=>(D instanceof Error&&D.name==="DISPOSED"||this.k.warn(D),null))}}e.ExtHostTextEditor=T}),define(Ce[267],De([1,0,197,7,24,2,3,4,248,16,7,12,19,13,21,25,168]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(w,p){if((0,P.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let t;return Array.isArray(w.highlights)&&(t=w.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),t=t.length?t:void 0),{label:w.label,highlights:t}}}class d{constructor(p,t,a){this.d=p,this.e=t,this.f=a,this.a=new Map,this.b=new n.TreeViewsDnDService;function r(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:o=>r(o)?this.i(o):Array.isArray(o)&&o.length>0?o.map(f=>r(f)?this.i(f):f):o})}registerTreeDataProvider(p,t,a){const r=this.createTreeView(p,{treeDataProvider:t},a);return{dispose:()=>r.dispose()}}createTreeView(p,t,a){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],o=t.dragAndDropController?.dragMimeTypes??[],f=!!t.dragAndDropController?.handleDrag,v=!!t.dragAndDropController?.handleDrop,l=this.h(p,t,a),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:o,hasHandleDrag:f,hasHandleDrop:v,manuallyManageCheckboxes:!!t.manuallyManageCheckboxSelection},E=this.d.$registerTreeViewDataProvider(p,I);return{get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,b.checkProposedApiEnabled)(a,"treeItemCheckbox"),l.onDidChangeCheckboxState},get message(){return l.message},set message(s){l.message=s},get title(){return l.title},set title(s){l.title=s},get description(){return l.description},set description(s){l.description=s},get badge(){return l.badge},set badge(s){s!==void 0&&T.ViewBadge.isViewBadge(s)?l.badge={value:Math.floor(Math.abs(s.value)),tooltip:s.tooltip}:s===void 0&&(l.badge=void 0)},reveal:(s,i)=>l.reveal(s,i),dispose:async()=>{await E,this.a.delete(p),l.dispose()}}}$getChildren(p,t){const a=this.a.get(p);return a?a.getChildren(t):Promise.reject(new y.NoTreeViewError(p))}async $handleDrop(p,t,a,r,o,f,v,l){const I=this.a.get(p);if(!I)return Promise.reject(new y.NoTreeViewError(p));const E=D.DataTransfer.toDataTransfer(a,async s=>(await this.d.$resolveDropFileData(p,t,s)).buffer);return v===p&&l&&await this.g(E,I,l,o,f),I.onDrop(E,r,o)}async g(p,t,a,r,o){const f=this.b.removeDragOperationTransfer(o);if(f)(await f)?.forEach((v,l)=>{v&&p.set(l,v)});else if(o&&t.handleDrag){const v=t.handleDrag(a,p,r);this.b.addDragOperationTransfer(o,v),await v}return p}async $handleDrag(p,t,a,r){const o=this.a.get(p);if(!o)return Promise.reject(new y.NoTreeViewError(p));const f=await this.g(new R.DataTransfer,o,t,r,a);if(!(!f||r.isCancellationRequested))return D.DataTransfer.from(f)}async $hasResolve(p){const t=this.a.get(p);if(!t)throw new y.NoTreeViewError(p);return t.hasResolve}$resolve(p,t,a){const r=this.a.get(p);if(!r)throw new y.NoTreeViewError(p);return r.resolveTreeItem(t,a)}$setExpanded(p,t,a){const r=this.a.get(p);if(!r)throw new y.NoTreeViewError(p);r.setExpanded(t,a)}$setSelection(p,t){const a=this.a.get(p);if(!a)throw new y.NoTreeViewError(p);a.setSelection(t)}$setFocus(p,t){const a=this.a.get(p);if(!a)throw new y.NoTreeViewError(p);a.setFocus(t)}$setVisible(p,t){const a=this.a.get(p);if(!a)throw new y.NoTreeViewError(p);a.setVisible(t)}$changeCheckboxState(p,t){const a=this.a.get(p);if(!a)throw new y.NoTreeViewError(p);a.setCheckboxState(t)}h(p,t,a){const r=new S(p,t,this.d,this.e.converter,this.f,a);return this.a.set(p,r),r}i(p){const t=this.a.get(p.$treeViewId);return t&&"$treeItemHandle"in p?t.getExtensionElement(p.$treeItemHandle):t&&"$focusedTreeItem"in p&&p.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=d;class S extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,P.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,t,a,r,o,f){if(super(),this.C=p,this.D=a,this.F=r,this.G=o,this.H=f,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new L.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new L.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new L.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new L.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new L.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new L.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new C.CancellationTokenSource,f.contributes&&f.contributes.views)for(const I in f.contributes.views)for(const E of f.contributes.views[I])E.id===p&&(this.J=E.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(I=>this.w.fire({message:!1,element:I})));let v,l;this.B(L.Event.debounce(this.w.event,(I,E)=>(I||(I={message:!1,elements:[]}),E.element!==!1&&(v||(v=new Promise(s=>l=s),this.y=this.y.then(()=>v)),Array.isArray(E.element)?I.elements.push(...E.element):I.elements.push(E.element)),E.message&&(I.message=!0),I),200,!0)(({message:I,elements:E})=>{E.length&&(this.z=this.z.then(()=>{const s=l;return v=null,this.U(E).then(()=>s())})),I&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const t=p?this.getExtensionElement(p):void 0;if(p&&!t)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let a=this.Q(p);return a||(a=await this.R(t)),a?a.map(r=>r.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,t){t=t||{select:!0,focus:!1};const a=(0,P.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,P.isUndefinedOrNull)(t.focus)?!1:t.focus,o=(0,P.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(f=>this.P(p,f[f.length-1]).then(v=>this.D.$reveal(this.C,{item:v.item,parentChain:f.map(l=>l.item)},{select:a,focus:r,expand:o})),f=>this.G.error(f)):this.D.$reveal(this.C,void 0,{select:a,focus:r,expand:o})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=D.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,t){const a=this.getExtensionElement(p);a&&(t?this.r.fire(Object.freeze({element:a})):this.s.fire(Object.freeze({element:a})))}setSelection(p){(0,m.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const t=(await Promise.all(p.map(async a=>{const r=this.getExtensionElement(a.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:a.newState?T.TreeItemCheckboxState.Checked:T.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(a=>a!==void 0);t.forEach(a=>{a.treeItem.checkboxState=a.newState?T.TreeItemCheckboxState.Checked:T.TreeItemCheckboxState.Unchecked}),this.v.fire({items:t.map(a=>[a.extensionItem,a.newState])})}async handleDrag(p,t,a){const r=[];for(const o of p){const f=this.getExtensionElement(o);f&&r.push(f)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,a),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,t,a){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,g.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,p,a):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,t){if(!this.f.resolveTreeItem)return;const a=this.i.get(p);if(a){const r=this.j.get(a);if(r){const o=await this.f.resolveTreeItem(r.extensionItem,a,t)??r.extensionItem;return this.db(o),r.item.tooltip=this.ab(o.tooltip),r.item.command=this.bb(r.disposableStore,o.command),r.item}}}N(p){return this.O(p).then(t=>t?this.N(t).then(a=>this.P(t,a[a.length-1]).then(r=>(a.push(r),a))):Promise.resolve([]))}O(p){const t=this.j.get(p);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,g.asPromise)(()=>this.f.getParent(p))}P(p,t){const a=this.j.get(p);return a?Promise.resolve(a):(0,g.asPromise)(()=>this.f.getTreeItem(p)).then(r=>this.gb(p,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const o=this.getExtensionElement(r);if(o){const f=this.j.get(o);if(f)return Promise.resolve(f)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(p){if(p){let t;if(typeof p=="string"){const a=this.getExtensionElement(p);t=a?this.j.get(a):void 0}else t=p;return t&&t.children||void 0}return this.h}async R(p){this.nb(p);const t=new C.CancellationTokenSource(this.S.token);try{const a=p?this.j.get(p):void 0,r=await this.f.getChildren(p);if(t.token.isCancellationRequested)return;const o=await Promise.all((0,m.coalesce)(r||[]).map(async f=>{const v=await this.f.getTreeItem(f);return v&&!t.token.isCancellationRequested?this.Z(f,v,a):null}));return t.token.isCancellationRequested?void 0:(0,m.coalesce)(o)}finally{t.dispose()}}U(p){if(p.some(a=>!a))return this.S.dispose(!0),this.S=new C.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const a=this.W(p);if(a.length)return this.X(a)}return Promise.resolve(void 0)}W(p){const t=new Set,a=p.map(o=>this.j.get(o));for(const o of a)if(o&&!t.has(o.item.handle)){let f=o;for(;f&&f.parent&&a.findIndex(v=>f&&f.parent&&v&&v.item.handle===f.parent.item.handle)===-1;){const v=this.i.get(f.parent.item.handle);f=v?this.j.get(v):void 0}f&&!f.parent&&t.add(o.item.handle)}const r=[];return t.forEach(o=>{const f=this.i.get(o);if(f){const v=this.j.get(f);v&&(!v.parent||!t.has(v.parent.item.handle))&&r.push(o)}}),r}X(p){const t={};return Promise.all(p.map(a=>this.Y(a).then(r=>{r&&(t[a]=r.item)}))).then(()=>Object.keys(t).length?this.D.$refresh(this.C,t):void 0)}Y(p){const t=this.getExtensionElement(p);if(t){const a=this.j.get(t);if(a)return this.nb(t),(0,g.asPromise)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const o=this.eb(t,r,a.parent);return this.lb(t,o,a,a.parent),a.dispose(),o}return null})}return Promise.resolve(null)}Z(p,t,a){const r=this.eb(p,t,a);if(t.id&&this.i.has(r.item.handle))throw new Error((0,c.localize)(0,null,t.id));return this.kb(p,r),this.mb(r,a),r}ab(p){return T.MarkdownString.isMarkdownString(p)?D.MarkdownString.from(p):p}bb(p,t){return t?{...this.F.toInternal(t,p),originalId:t.command}:void 0}cb(p){if(p.checkboxState===void 0)return;let t,a,r;return typeof p.checkboxState=="number"?t=p.checkboxState:(t=p.checkboxState.state,a=p.checkboxState.tooltip,r=p.checkboxState.accessibilityInformation),{isChecked:t===T.TreeItemCheckboxState.Checked,tooltip:a,accessibilityInformation:r}}db(p){if(!T.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,t,a){this.db(t);const r=new A.DisposableStore,o=this.gb(p,t,a),f=this.hb(t);return{item:{handle:o,parentHandle:a?a.item.handle:void 0,label:h(t.label,this.H),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(r,t.command),contextValue:t.contextValue,icon:f,iconDark:this.ib(t)||f,themeIcon:this.fb(t),collapsibleState:(0,P.isUndefinedOrNull)(t.collapsibleState)?T.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:a,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(p){return p.iconPath instanceof T.ThemeIcon?p.iconPath:void 0}gb(p,{id:t,label:a,resourceUri:r},o,f){if(t)return`${S.b}/${t}`;const v=h(a,this.H),l=o?o.item.handle:S.a;let I=v?v.label:r?(0,u.basename)(r):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const E=this.j.has(p)?this.j.get(p).item.handle:void 0,s=this.Q(o)||[];let i,k=0;do{if(i=`${l}/${k}:${I}`,f||!this.i.has(i)||E===i)break;k++}while(k<=s.length);return i}hb(p){if(p.iconPath&&!(p.iconPath instanceof T.ThemeIcon))return typeof p.iconPath=="string"||O.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof T.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return O.URI.isUri(p)?p:O.URI.file(p)}kb(p,t){this.i.set(t.item.handle,p),this.j.set(p,t)}lb(p,t,a,r){this.i.delete(t.item.handle),this.j.delete(p),t.item.handle!==a.item.handle&&this.i.delete(a.item.handle),this.kb(p,t);const o=this.Q(r)||[],f=o.filter(v=>v.item.handle===a.item.handle)[0];f&&o.splice(o.indexOf(f),1,t)}mb(p,t){t?(t.children||(t.children=[]),t.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const t=this.j.get(p);if(t){if(t.children)for(const a of t.children){const r=this.i.get(a.item.handle);r&&this.ob(r)}t.children=void 0}}else this.pb()}ob(p){const t=this.j.get(p);if(t){if(t.children)for(const a of t.children){const r=this.i.get(a.item.handle);r&&this.ob(r)}this.j.delete(p),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}S.a="0",S.b="1"}),define(Ce[268],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionOptions.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveSlashCommands.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testInvalidateResults:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testInvalidateResults.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[269],De([1,0,209,8,41,125,99,42,26,268,229,131]),function(re,e,c,R,u,O,L,A,y,g,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const m=A.Registry.as(L.Extensions.JSONContribution);class D{constructor(p,t,a){this.a=p,this.b=t,this.c=a}d(p,t){this.a({type:p,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(u.default.Error,p)}warn(p){this.d(u.default.Warning,p)}info(p){this.d(u.default.Info,p)}}e.ExtensionMessageCollector=D;class C{static a(p){const t=new y.ExtensionIdentifierSet;for(let a=0,r=p.length;a<r;a++)t.add(p[a].description.identifier);return t}static compute(p,t){if(!p||!p.length)return new C(t,[]);if(!t||!t.length)return new C([],p);const a=this.a(p),r=this.a(t),o=t.filter(v=>!a.has(v.description.identifier)),f=p.filter(v=>!r.has(v.description.identifier));return new C(o,f)}constructor(p,t){this.added=p,this.removed=t}}e.ExtensionPointUserDelta=C;class b{constructor(p,t){this.name=p,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=C.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,R.onUnexpectedError)(p)}}}e.ExtensionPoint=b;const n={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:c.localize(15,null),type:"string",enum:["none"],enumDescriptions:[c.localize(16,null)]},activationEvents:{description:c.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(32,null)},{label:"onUri",body:"onUri",description:c.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(37,null)},{label:"onRenderer",description:c.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:c.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(41,null)},{label:"*",description:c.localize(42,null),body:"*"}]}},badges:{type:"array",description:c.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(44,null)},href:{type:"string",description:c.localize(45,null)},description:{type:"string",description:c.localize(46,null)}}}},markdown:{type:"string",description:c.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(51,null),type:"array",items:n,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(52,null)},{body:["workspace"],description:c.localize(53,null)},{body:["ui","workspace"],description:c.localize(54,null)},{body:["workspace","ui"],description:c.localize(55,null)},{body:[],description:c.localize(56,null)}]},capabilities:{description:c.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(60,null),c.localize(61,null),c.localize(62,null)]},description:{type:"string",markdownDescription:c.localize(63,null)}}},untrustedWorkspaces:{description:c.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null)]},restrictedConfigurations:{description:c.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(70,null)}}}}},sponsor:{description:c.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(73,null),type:"string"},"vscode:uninstall":{description:c.localize(74,null),type:"string"}}},icon:{type:"string",description:c.localize(75,null)},l10n:{type:"string",description:c.localize(76,null)}}};class d{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const t=new b(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,t),p.activationEventsGenerator&&P.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,m.registerSchema(h,e.schema),t}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=d;const S={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(S.ExtensionsRegistry,new d),e.ExtensionsRegistry=A.Registry.as(S.ExtensionsRegistry),m.registerSchema(h,e.schema),m.registerSchema(T.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Ce[270],De([1,0,206,12,23,269,47,3]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var g;(function(m){function D(C,b,n){if(!C)return;const h=R.isString(C.type)?C.type:void 0;if(!h||h.length===0){n.error(c.localize(3,null));return}const d=[];if(Array.isArray(C.required))for(const S of C.required)R.isString(S)&&d.push(S);return{extensionId:b.value,taskType:h,required:d,properties:C.properties?u.deepClone(C.properties):{},when:C.when?L.ContextKeyExpr.deserialize(C.when):void 0}}m.from=D})(g||(g={}));const T=O.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,D)=>{for(const C of m)C.type&&D.push(`onTaskType:${C.type}`)},jsonSchema:{description:c.localize(4,null),type:"array",items:y}});class P{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((D,C)=>{T.setHandler((b,n)=>{this.c=void 0;try{for(const h of n.removed){const d=h.value;for(const S of d)this.a&&S.type&&this.a[S.type]&&delete this.a[S.type]}for(const h of n.added){const d=h.value;for(const S of d){const w=g.from(S,h.description.identifier,h.collector);w&&(this.a[w.taskType]=w)}}(n.removed.length>0||n.added.length>0)&&this.d.fire()}catch{}D(void 0)})})}onReady(){return this.b}get(D){return this.a[D]}all(){return Object.keys(this.a).map(D=>this.a[D])}getJsonSchema(){if(this.c===void 0){const D=[];for(const C of this.all()){const b={type:"object",additionalProperties:!1};C.required.length>0&&(b.required=C.required.slice(0)),C.properties!==void 0?b.properties=u.deepClone(C.properties):b.properties=Object.create(null),b.properties.type={type:"string",enum:[C.taskType]},D.push(b)}this.c={oneOf:D}}return this.c}}e.TaskDefinitionRegistry=new P}),define(Ce[271],De([1,0,207,12,24,23,47,270]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new L.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var y;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function x(B){if(!B)return U.Strong;switch(B.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=x}(y||(e.ShellQuoting=y={}));var g;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var T;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(T||(e.RevealKind=T={})),function(U){function x(B){switch(B.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=x}(T||(e.RevealKind=T={}));var P;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(U){function x(B){switch(B.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=x}(P||(e.RevealProblemKind=P={}));var m;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(m||(e.PanelKind=m={})),function(U){function x(B){switch(B.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=x}(m||(e.PanelKind=m={}));var D;(function(U){U.defaults={echo:!0,reveal:T.Always,revealProblems:P.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(D||(e.PresentationOptions=D={}));var C;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(C||(e.RuntimeType=C={})),function(U){function x(z){switch(z.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=x;function B(z){switch(z){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=B}(C||(e.RuntimeType=C={}));var b;(function(U){function x(B){return R.isString(B)?B:B.value}U.value=x})(b||(e.CommandString=b={}));var n;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function x(z){return z===U.Clean._id||z===U.Build._id||z===U.Rebuild._id||z===U.Test._id}U.is=x;function B(z){if(z!==void 0)return R.isString(z)?x(z)?{_id:z,isDefault:!1}:void 0:z}U.from=B})(n||(e.TaskGroup=n={}));var h;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(h||(e.TaskScope=h={}));var d;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function x(B){switch(B){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=x})(d||(e.TaskSourceKind=d={}));var S;(function(U){U.parallel="parallel",U.sequence="sequence"})(S||(e.DependsOrder=S={}));var w;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(w||(e.RunOnOptions=w={}));var p;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:w.default,instanceLimit:1}})(p||(e.RunOptions=p={}));class t{constructor(x,B,z,ee,se,V){this._label="",this._id=x,B&&(this._label=B),z&&(this.type=z),this.runOptions=ee,this.configurationProperties=se,this._source=V}getDefinition(x){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const x={folder:this.d(),id:this._id};return JSON.stringify(x)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(x,B=!1){if(x===void 0)return!1;if(R.isString(x))return x===this._label||x===this.configurationProperties.identifier||B&&x===this._id;const z=this.getDefinition(!0);return z!==void 0&&z._key===x._key}getQualifiedLabel(){const x=this.getWorkspaceFolder();return x?`${this._label} (${x.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(x){this.c===void 0&&(this.c=[]),x&&(this.c=this.c.concat(x))}get taskLoadMessages(){return this.c}}e.CommonTask=t;class a extends t{constructor(x,B,z,ee,se,V,Z,q){super(x,z,void 0,Z,q,B),this.command={},this._source=B,this.hasDefinedMatchers=V,se&&(this.command=se)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(x=!1){if(x&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case C.Shell:B="shell";break;case C.Process:B="process";break;case C.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(x){return x instanceof a}getMapKey(){const x=this._source.config.workspaceFolder;return x?`${x.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===d.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const x=this.d();if(!x)return;let B=this.configurationProperties.identifier;this._source.kind!==d.Workspace&&(B+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:x,id:B};return JSON.stringify(z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?u.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(x){return new a(x._id,x._source,x._label,x.type,x.command,x.hasDefinedMatchers,x.runOptions,x.configurationProperties)}}e.CustomTask=a;class r extends t{constructor(x,B,z,ee,se,V,Z){super(x,z,ee,V,Z,B),this._source=B,this.configures=se}static is(x){return x instanceof r}f(x){return x}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?u.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===d.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const x=this.d();if(!x)return;let B=this.configurationProperties.identifier;this._source.kind!==d.Workspace&&(B+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:x,id:B};return JSON.stringify(z)}}e.ConfiguringTask=r;class o extends t{constructor(x,B,z,ee,se,V,Z,q,ae){super(x,z,ee,q,ae,B),this.defines=se,this.hasDefinedMatchers=Z,this.command=V,this.icon=ae.icon,this.hide=ae.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(x){return x instanceof o}getMapKey(){const x=this._source.workspaceFolder;return x?`${this._source.scope.toString()}|${x.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const x={type:"contributed",scope:this._source.scope,id:this._id};return x.folder=this.d(),JSON.stringify(x)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(x){return new o(x._id,x._source,x._label,x.type,x.defines,x.command,x.hasDefinedMatchers,x.runOptions,x.configurationProperties)}}e.ContributedTask=o;class f extends t{constructor(x,B,z,ee,se,V){super(x,z,ee,se,V,B),this._source=B}clone(){return new f(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(x){return x instanceof f}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(x){return new f(x._id,x._source,x._label,x.type,x.runOptions,x.configurationProperties)}}e.InMemoryTask=f;var v;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(v||(e.ExecutionEngine=v={})),function(U){U._default=U.Terminal}(v||(e.ExecutionEngine=v={}));var l;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class I{constructor(x){this.c=new Map;for(let B=0;B<x.length;B++)this.c.set(x[B].uri.toString(),B)}compare(x,B){const z=x.getWorkspaceFolder(),ee=B.getWorkspaceFolder();if(z&&ee){let se=this.c.get(z.uri.toString());se=se===void 0?0:se+1;let V=this.c.get(ee.uri.toString());return V=V===void 0?0:V+1,se===V?x._label.localeCompare(B._label):se-V}else return!z&&ee?-1:z&&!ee?1:0}}e.TaskSorter=I;var E;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(E||(e.TaskEventKind=E={}));var s;(function(U){U.SingleRun="singleRun",U.Background="background"})(s||(e.TaskRunType=s={}));var i;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(i||(e.TaskRunSource=i={}));var k;(function(U){function x(B,z,ee,se){if(z){const V={kind:B,taskId:z._id,taskName:z.configurationProperties.name,runType:z.configurationProperties.isBackground?"background":"singleRun",group:z.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ee,__task:z};return B==="start"?V.resolvedVariables=se:B==="processStarted"?V.processId=se:B==="processEnded"&&(V.exitCode=se),Object.freeze(V)}else return Object.freeze({kind:"changed"})}U.create=x})(k||(e.TaskEvent=k={}));var F;(function(U){function x(z){const ee=Object.keys(z).sort();let se="";for(const V of ee){let Z=z[V];Z instanceof Object?Z=x(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),se+=V+","+Z+","}return se}function B(z){const se={_key:x(z),type:z.taskType};return Object.assign(se,z),se}U.create=B})(F||(e.KeyedTaskIdentifier=F={}));var $;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})($||(e.TaskSettingId=$={}));var j;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var W;(function(U){function x(B,z){const ee=A.TaskDefinitionRegistry.get(B.type);if(ee===void 0){const q=O.deepClone(B);return delete q._key,F.create(q)}const se=Object.create(null);se.type=ee.taskType;const V=new Set;ee.required.forEach(q=>V.add(q));const Z=ee.properties;for(const q of Object.keys(Z)){const ae=B[q];if(ae!=null)se[q]=ae;else if(V.has(q)){const Ee=Z[q];if(Ee.default!==void 0)se[q]=O.deepClone(Ee.default);else switch(Ee.type){case"boolean":se[q]=!1;break;case"number":case"integer":se[q]=0;break;case"string":se[q]="";break;default:z.error(c.localize(2,null,JSON.stringify(B,void 0,0),q));return}}}return F.create(se)}U.createTaskIdentifier=x})(W||(e.TaskDefinition=W={}))}),define(Ce[272],De([1,0,8]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class R{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,A)=>{this.b=L,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,c.onUnexpectedError)(L))}then(L,A){return this.j().then(L,A)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.LazyPromise=R;class u extends R{constructor(){super(),this.h=!0,this.i=new c.CancellationError}}e.CanceledLazyPromise=u}),define(Ce[61],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const R=[];function u(A){const y=new c(A);return R[y.nid]=y,y}e.createProxyIdentifier=u;function O(A){return R[A].sid}e.getStringIdentifierForProxy=O;class L{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=L}),define(Ce[6],De([1,0,61]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var u;(function(b){b[b.UnknownInput=0]="UnknownInput",b[b.TextInput=1]="TextInput",b[b.TextDiffInput=2]="TextDiffInput",b[b.TextMergeInput=3]="TextMergeInput",b[b.NotebookInput=4]="NotebookInput",b[b.NotebookDiffInput=5]="NotebookDiffInput",b[b.CustomEditorInput=6]="CustomEditorInput",b[b.WebviewEditorInput=7]="WebviewEditorInput",b[b.TerminalEditorInput=8]="TerminalEditorInput",b[b.InteractiveEditorInput=9]="InteractiveEditorInput"})(u||(e.TabInputKind=u={}));var O;(function(b){b[b.TAB_OPEN=0]="TAB_OPEN",b[b.TAB_CLOSE=1]="TAB_CLOSE",b[b.TAB_UPDATE=2]="TAB_UPDATE",b[b.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var L;(function(b){b[b.Editable=0]="Editable",b[b.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var A;(function(b){b[b.Int8Array=1]="Int8Array",b[b.Uint8Array=2]="Uint8Array",b[b.Uint8ClampedArray=3]="Uint8ClampedArray",b[b.Int16Array=4]="Int16Array",b[b.Uint16Array=5]="Uint16Array",b[b.Int32Array=6]="Int32Array",b[b.Uint32Array=7]="Uint32Array",b[b.Float32Array=8]="Float32Array",b[b.Float64Array=9]="Float64Array",b[b.BigInt64Array=10]="BigInt64Array",b[b.BigUint64Array=11]="BigUint64Array"})(A||(e.WebviewMessageArrayBufferViewType=A={}));var y;(function(b){b[b.Text=1]="Text",b[b.Error=2]="Error",b[b.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var g;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var T;(function(b){b[b.None=0]="None",b[b.Process=1]="Process",b[b.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class P{static mixin(n){return n._id=P.a++,n}}e.IdObject=P,P.a=0;var m;(function(b){b.label="a",b.kind="b",b.detail="c",b.documentation="d",b.sortText="e",b.filterText="f",b.preselect="g",b.insertText="h",b.insertTextRules="i",b.range="j",b.commitCharacters="k",b.additionalTextEdits="l",b.kindModifier="m",b.commandIdent="n",b.commandId="o",b.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var D;(function(b){b.defaultRanges="a",b.completions="b",b.isIncomplete="c",b.duration="d"})(D||(e.ISuggestResultDtoField=D={}));var C;(function(b){b[b.Workspace=0]="Workspace",b[b.TextDocument=1]="TextDocument"})(C||(e.ExtHostTestingResource=C={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,c.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,c.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadShare:(0,c.createProxyIdentifier)("MainThreadShare"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadChat:(0,c.createProxyIdentifier)("MainThreadChat"),MainThreadInteractiveEditor:(0,c.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadManagedSockets:(0,c.createProxyIdentifier)("MainThreadManagedSockets"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,c.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,c.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,c.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostStatusBar:(0,c.createProxyIdentifier)("ExtHostStatusBar"),ExtHostShare:(0,c.createProxyIdentifier)("ExtHostShare"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,c.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,c.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostChat:(0,c.createProxyIdentifier)("ExtHostChat"),ExtHostSemanticSimilarity:(0,c.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostManagedSockets:(0,c.createProxyIdentifier)("ExtHostManagedSockets"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,c.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Ce[83],De([1,0,5,17,6,20]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let L=e.ExtHostApiDeprecationService=class{constructor(y,g){this.c=g,this.a=new Set,this.b=y.getProxy(u.MainContext.MainThreadTelemetry)}report(y,g,T){const P=this.d(y,g);this.a.has(P)||(this.a.add(P),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:y}))}d(y,g){return`${y}-${g.identifier.value}`}};e.ExtHostApiDeprecationService=L=qe([je(0,O.IExtHostRpcService),je(1,R.ILogService)],L),e.NullApiDeprecationService=Object.freeze(new class{report(A,y,g){}})}),define(Ce[273],De([1,0,3,6,7,26]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class L{constructor(g){this.b=new Map,this.c=[],this.d=new c.Emitter,this.onDidChangeSessions=this.d.event,this.f=new A,this.g=new A,this.a=g.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,T,P,m={}){const D=O.ExtensionIdentifier.toKey(g.identifier),C=[...P].sort().join(" ");return await this.f.getOrCreate(`${D} ${T} ${C}`,async()=>{await this.a.$ensureProvider(T);const b=g.displayName||g.name;return this.a.$getSession(T,P,D,b,m)})}async getSessions(g,T,P){const m=O.ExtensionIdentifier.toKey(g.identifier),D=[...P].sort().join(" ");return await this.g.getOrCreate(`${m} ${D}`,async()=>{await this.a.$ensureProvider(T);const C=g.displayName||g.name;return this.a.$getSessions(T,P,m,C)})}async removeSession(g,T){const P=this.b.get(g);return P?P.provider.removeSession(T):this.a.$removeSession(g,T)}registerAuthenticationProvider(g,T,P,m){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:T,provider:P,options:m??{supportsMultipleAccounts:!1}}),this.c.find(C=>C.id===g)||this.c.push({id:g,label:T});const D=P.onDidChangeSessions(C=>{this.a.$sendDidChangeSessions(g,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this.a.$registerAuthenticationProvider(g,T,m?.supportsMultipleAccounts??!1),new u.Disposable(()=>{D.dispose(),this.b.delete(g);const C=this.c.findIndex(b=>b.id===g);C>-1&&this.c.splice(C),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,T,P){const m=this.b.get(g);if(m)return Promise.resolve(m.provider.createSession(T,P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,T){const P=this.b.get(g);if(P)return Promise.resolve(P.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,T){const P=this.b.get(g);if(P)return Promise.resolve(P.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,T){return this.d.fire({provider:{id:g,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=L;class A{constructor(){this.a=new Map}getOrCreate(g,T){const P=this.a.get(g);if(P)return P;const m=T().finally(()=>this.a.delete(g));return this.a.set(g,m),m}}}),define(Ce[274],De([1,0,6,20,13]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let O=e.ExtHostBulkEdits=class{constructor(A,y){this.a=A.getProxy(c.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>y.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,g){const T=u.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(T,void 0,g?.isRefactoring??!1)}};e.ExtHostBulkEdits=O=qe([je(0,R.IExtHostRpcService)],O)}),define(Ce[275],De([1,0,3,4,40,12,188,6,13]),function(re,e,c,R,u,O,L,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostChat=void 0;class g{constructor(m,D){this.extension=m,this.provider=D,this.handle=g.a++}}g.a=0;class T{constructor(m,D){this.i=D,this.b=new Map,this.d=new Map,this.e=new Map,this.g=new c.Emitter,this.onDidPerformUserAction=this.g.event,this.h=m.getProxy(A.MainContext.MainThreadChat)}registerChatProvider(m,D,C){const b=new g(m,C);return this.b.set(b.handle,b),this.h.$registerChatProvider(b.handle,D),(0,R.toDisposable)(()=>{this.h.$unregisterChatProvider(b.handle),this.b.delete(b.handle)})}addChatRequest(m){this.h.$addRequest(m)}sendInteractiveRequestToProvider(m,D){this.h.$sendRequestToProvider(m,D)}async $prepareChat(m,D,C){const b=this.b.get(m);if(!b)return;const n=await b.provider.prepareSession(D,C);if(!n)return;const h=T.a++;return this.e.set(h,n),{id:h,requesterUsername:n.requester?.name,requesterAvatarIconUri:n.requester?.icon,responderUsername:n.responder?.name,responderAvatarIconUri:n.responder?.icon,inputPlaceholder:n.inputPlaceholder}}async $resolveRequest(m,D,C,b){const n=this.b.get(m);if(!n)return;const h=this.e.get(D);if(!h||!n.provider.resolveRequest)return;const d=await n.provider.resolveRequest(h,C,b);if(d)return{message:typeof d.message=="string"?d.message:y.ChatReplyFollowup.from(d.message)}}async $provideWelcomeMessage(m,D){const C=this.b.get(m);if(!C||!C.provider.provideWelcomeMessage)return;const b=await C.provider.provideWelcomeMessage(D);if(b)return b.map(n=>typeof n=="string"?n:n.map(h=>y.ChatReplyFollowup.from(h)))}async $provideFollowups(m,D,C){const b=this.b.get(m);if(!b)return;const n=this.e.get(D);return!n||!b.provider.provideFollowups?void 0:(await b.provider.provideFollowups(n,C))?.map(d=>y.ChatFollowup.from(d))}$removeRequest(m,D,C){const b=this.b.get(m);if(!b)return;const n=this.e.get(D);n&&b.provider.removeRequest&&b.provider.removeRequest(n,C)}async $provideReply(m,D,C,b){const n=this.b.get(m);if(!n)return;const h=this.e.get(D);if(!h)return;const d={session:h,message:typeof C.message=="string"?C.message:y.ChatReplyFollowup.to(C.message)},S=u.StopWatch.create(!1);let w;const p={report:r=>{if(b.isCancellationRequested)return;typeof w>"u"&&(w=S.elapsed());const o="responseId"in r?{requestId:r.responseId}:r;this.h.$acceptResponseProgress(m,D,o)}};let t;try{t=await n.provider.provideResponseWithProgress(d,p,b),t||(t={errorDetails:{message:(0,L.localize)(0,null)}})}catch(r){t={errorDetails:{message:(0,L.localize)(1,null,r.message),responseIsIncomplete:!0}},this.i.error(r)}try{if(h.saveState&&this.e.has(D)){const r=h.saveState();this.h.$acceptChatState(D,r)}}catch(r){this.i.warn(r)}const a={firstProgress:w??0,totalElapsed:S.elapsed()};return{errorDetails:t.errorDetails,timings:a}}async $provideSlashCommands(m,D,C){const b=this.b.get(m);if(!b)return;const n=this.e.get(D);return!n||!b.provider.provideSlashCommands?void 0:(await b.provider.provideSlashCommands(n,C))?.map(d=>({...d,kind:y.CompletionItemKind.from(d.kind)}))}$releaseSession(m){this.e.delete(m)}async $onDidPerformUserAction(m){this.g.fire(m)}registerSlashCommandProvider(m,D,C){const b=new g(m,C);return this.d.set(b.handle,b),this.h.$registerSlashCommandProvider(b.handle,D),(0,R.toDisposable)(()=>{this.h.$unregisterSlashCommandProvider(b.handle),this.d.delete(b.handle)})}async $provideProviderSlashCommands(m,D){const C=this.d.get(m);return C?(await C.provider.provideSlashCommands(D))?.map(n=>({...n,kind:y.CompletionItemKind.from(n.kind)})):void 0}async $resolveSlashCommand(m,D,C){const b=this.d.get(m);if(!b)return;const n=await b.provider.resolveSlashCommand(D,C);return(0,O.withNullAsUndefined)(n)}}e.ExtHostChat=T,T.a=0}),define(Ce[276],De([1,0,6]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(O){const L=O.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(A){return L.$writeText(A)}})}}e.ExtHostClipboard=R});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,R,u){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Ne=this&&this.__classPrivateFieldGet||function(re,e,c,R){if(c==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?R:c==="a"?R.call(re):R?R.value:e.get(re)};define(Ce[37],De([1,0,12,7,13,23,6,19,17,73,36,56,2,4,5,20,141,22,61,46,40,79,82]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d,S,w,p,t){"use strict";var a,r,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let f=e.ExtHostCommands=class{constructor(i,k,F){a.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),o.set(this,void 0),Ze(this,a,i.getProxy(L.MainContext.MainThreadCommands),"f"),this.d=k,Ze(this,o,F,"f"),Ze(this,r,i.getProxy(L.MainContext.MainThreadTelemetry),"f"),this.converter=new v(this,$=>{const j=this.c.get($);return j?.result===I.Void?j:void 0},k),this.f=[{processArgument($){return(0,g.revive)($)}},{processArgument($){return(0,O.cloneAndChange)($,function(j){if(T.Range.isIRange(j))return u.Range.to(j);if(P.Position.isIPosition(j))return u.Position.to(j);if(T.Range.isIRange(j.range)&&m.URI.isUri(j.uri))return u.location.to(j);if(j instanceof h.VSBuffer)return j.buffer.buffer;if(!Array.isArray(j))return j})}}]}registerArgumentProcessor(i){this.f.push(i)}registerApiCommand(i){const k=this.registerCommand(!1,i.id,async(...F)=>{const $=i.args.map((W,U)=>{if(!W.validate(F[U]))throw new Error(`Invalid argument '${W.name}' when running '${i.id}', received: ${F[U]}`);return W.convert(F[U])}),j=await this.executeCommand(i.internalId,...$);return i.result.convert(j,F,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this.c.set(i.id,i),new R.Disposable(()=>{k.dispose(),this.c.delete(i.id)})}registerCommand(i,k,F,$,j,W){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:F,thisArg:$,description:j,extension:W}),i&&Ne(this,a,"f").$registerCommand(k),new R.Disposable(()=>{this.b.delete(k)&&i&&Ne(this,a,"f").$unregisterCommand(k)})}executeCommand(i,...k){return this.d.trace("ExtHostCommands#executeCommand",i),this.g(i,k,!0)}async g(i,k,F){if(this.b.has(i))return Ne(this,a,"f").$fireCommandActivationEvent(i),this.h(i,k,!1);{let $=!1;const j=(0,O.cloneAndChange)(k,function(W){if(W instanceof R.Position)return u.Position.from(W);if(W instanceof R.Range)return u.Range.from(W);if(W instanceof R.Location)return u.location.from(W);if(R.NotebookRange.isNotebookRange(W))return u.NotebookRange.from(W);if(W instanceof ArrayBuffer)return $=!0,h.VSBuffer.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return $=!0,h.VSBuffer.wrap(W);if(W instanceof h.VSBuffer)return $=!0,W;if(!Array.isArray(W))return W});try{const W=await Ne(this,a,"f").$executeCommand(i,$?new d.SerializableObjectWithBuffers(j):j,F);return(0,g.revive)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(i,k,!1);throw W}}}async h(i,k,F){const $=this.b.get(i);if(!$)throw new Error("Unknown command");const{callback:j,thisArg:W,description:U}=$;if(U)for(let B=0;B<U.args.length;B++)try{(0,c.validateConstraint)(k[B],U.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${U.args[B].name}' - ${U.args[B].description}`)}const x=w.StopWatch.create();try{return await j.apply(W,k)}catch(B){if(i===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...k);z&&(i=z.command)}if(this.d.error(B,i,$.extension?.identifier),!F)throw B;if($.extension?.identifier){const z=Ne(this,o,"f").onExtensionError($.extension.identifier,B);this.d.trace("forwarded error to extension?",z,$.extension?.identifier)}throw new class extends Error{constructor(){super((0,S.toErrorMessage)(B)),this.id=i,this.source=$.extension?.displayName??$.extension?.name}}}finally{this.j($,i,x.elapsed())}}j(i,k,F){i.extension&&Ne(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:i.extension.identifier.value,id:new p.TelemetryTrustedValue(k),duration:F})}$executeContributedCommand(i,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",i);const F=this.b.get(i);return F?(k=k.map($=>this.f.reduce((j,W)=>W.processArgument(j,F.extension?.identifier),$)),this.h(i,k,!0)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this.d.trace("ExtHostCommands#getCommands",i),Ne(this,a,"f").$getCommands().then(k=>(i&&(k=k.filter(F=>F[0]!=="_")),k))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(const[k,F]of this.b){const{description:$}=F;$&&(i[k]=$)}return Promise.resolve(i)}};a=new WeakMap,r=new WeakMap,o=new WeakMap,e.ExtHostCommands=f=qe([je(0,b.IExtHostRpcService),je(1,y.ILogService),je(2,t.IExtHostTelemetry)],f),e.IExtHostCommands=(0,C.createDecorator)("IExtHostCommands");class v{constructor(i,k,F){this.d=i,this.f=k,this.g=F,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(i,k){if(!i)return;const F={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return F;const $=this.f(i.command);if($)F.id=$.internalId,F.arguments=$.args.map((j,W)=>j.convert(i.arguments&&i.arguments[W]));else if((0,A.isNonEmptyArray)(i.arguments)){const j=`${i.command}/${++this.c}`;this.b.set(j,i),k.add((0,D.toDisposable)(()=>{this.b.delete(j),this.g.trace("CommandsConverter#DISPOSE",j)})),F.$ident=j,F.id=this.delegatingCommandId,F.arguments=[j],this.g.trace("CommandsConverter#CREATE",i.command,j)}return F}fromInternal(i){return typeof i.$ident=="string"?this.b.get(i.$ident):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this.b.get(i[0])}h(...i){const k=this.getActualCommand(...i);return this.g.trace("CommandsConverter#EXECUTE",i[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${i[0]}`)}}e.CommandsConverter=v;class l{constructor(i,k,F,$){this.name=i,this.description=k,this.validate=F,this.convert=$}optional(){return new l(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,k){return new l(i??this.name,k??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l,l.Uri=new l("uri","Uri of a text document",s=>m.URI.isUri(s),s=>s),l.Position=new l("position","A position in a text document",s=>R.Position.isPosition(s),u.Position.from),l.Range=new l("range","A range in a text document",s=>R.Range.isRange(s),u.Range.from),l.Selection=new l("selection","A selection in a text document",s=>R.Selection.isSelection(s),u.Selection.from),l.Number=new l("number","",s=>typeof s=="number",s=>s),l.String=new l("string","",s=>typeof s=="string",s=>s),l.CallHierarchyItem=new l("item","A call hierarchy item",s=>s instanceof R.CallHierarchyItem,u.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",s=>s instanceof R.TypeHierarchyItem,u.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",s=>s instanceof n.TestItemImpl,u.TestItem.from);class I{constructor(i,k){this.description=i,this.convert=k}}e.ApiCommandResult=I,I.Void=new I("no result",s=>s);class E{constructor(i,k,F,$,j){this.id=i,this.internalId=k,this.description=F,this.args=$,this.result=j}}e.ApiCommand=E}),define(Ce[277],De([1,0,19,18,2,76,123,47,127,37,13,7]),function(re,e,c,R,u,O,L,A,y,g,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const m=[new g.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(T.DocumentHighlight.to))),new g.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,h)=>{if((0,c.isFalsyOrEmpty)(n))return;class d extends P.SymbolInformation{static to(w){const p=new d(w.name,T.SymbolKind.to(w.kind),w.containerName||"",new P.Location(h[0],T.Range.to(w.range)));return p.detail=w.detail,p.range=p.location.range,p.selectionRange=T.Range.to(w.selectionRange),p.children=w.children?w.children.map(d.to):[],p}}return n.map(d.to)})),new g.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(T.TextEdit.to))),new g.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range,new g.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(T.TextEdit.to))),new g.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,new g.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new g.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new g.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(T.TextEdit.to))),new g.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(T.location.to))),new g.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(T.Hover.to))),new g.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(h=>P.Position.isPosition(h)),n=>n.map(T.Position.from))],new g.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(h=>{let d;for(const S of h.reverse())d=new P.SelectionRange(T.Range.to(S),d);return d}))),new g.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.ApiCommandArgument.String.with("query","Search string")],new g.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(T.WorkspaceSymbol.to))),new g.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(T.CallHierarchyItem.to))),new g.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.ApiCommandArgument.CallHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(T.CallHierarchyIncomingCall.to))),new g.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.ApiCommandArgument.CallHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(T.CallHierarchyOutgoingCall.to))),new g.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:T.Range.to(n.range),placeholder:n.text}})),new g.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("newName","The new symbol name")],new g.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return T.WorkspaceEdit.to(n)}})),new g.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(T.DocumentLink.to))),new g.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new P.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new g.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,L.decodeSemanticTokensDto)(n);if(h.type==="full")return new P.SemanticTokens(h.data,void 0)})),new g.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range.optional()],new g.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new P.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new g.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,L.decodeSemanticTokensDto)(n);if(h.type==="full")return new P.SemanticTokens(h.data,void 0)})),new g.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,h,d)=>{if(!n)return new P.CompletionList([]);const S=n.suggestions.map(w=>T.CompletionItem.to(w,d));return new P.CompletionList(S,n.incomplete)})),new g.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position,g.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return T.SignatureHelp.to(n)})),new g.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,h,d)=>C(S=>new P.CodeLens(T.Range.to(S.range),S.command&&d.fromInternal(S.command)))(n))),new g.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.ApiCommandArgument.Uri,new g.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>P.Range.isRange(n),n=>P.Selection.isSelection(n)?T.Selection.from(n):T.Range.from(n)),g.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),g.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,h,d)=>C(S=>{if(S._isSynthetic){if(!S.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(S.command)}else{const w=new P.CodeAction(S.title,S.kind?new P.CodeActionKind(S.kind):void 0);return S.edit&&(w.edit=T.WorkspaceEdit.to(S.edit)),S.command&&(w.command=d.fromInternal(S.command)),w.isPreferred=S.isPreferred,w}})(n))),new g.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(h=>new P.ColorInformation(T.Range.to(h.range),T.Color.to(h.color))):[])),new g.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.ApiCommandArgument("color","The color to show and insert",n=>n instanceof P.Color,T.Color.from),new g.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:T.Range.from(n.range)}))],new g.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(T.ColorPresentation.to):[])),new g.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to an array of Inlay objects",(n,h,d)=>n.map(T.InlayHint.to.bind(void 0,d)))),new g.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.ApiCommandArgument.Uri],new g.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(n,h)=>{if(n)return n.map(T.FoldingRange.to)})),new g.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(h=>T.NotebookExclusiveDocumentPattern.to(h))})))),new g.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Range],new g.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(T.InlineValue.to))),new g.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",n=>u.URI.isUri(n)||typeof n=="string"&&(0,y.matchesSomeScheme)(n,R.Schemas.http,R.Schemas.https),n=>n),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[T.ViewColumn.from(n),void 0]:[T.ViewColumn.from(n.viewColumn),T.TextEditorOpenOptions.from(n)])).optional(),g.ApiCommandArgument.String.with("label","").optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.ApiCommandArgument.Uri.with("resource","Resource to open"),g.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[T.ViewColumn.from(n),void 0]:[T.ViewColumn.from(n.viewColumn),T.TextEditorOpenOptions.from(n)])).optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),g.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),g.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new g.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[T.ViewColumn.from(n.viewColumn),T.TextEditorOpenOptions.from(n)]).optional()],g.ApiCommandResult.Void),new g.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.ApiCommandArgument.Uri,g.ApiCommandArgument.Position],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(T.TypeHierarchyItem.to))),new g.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.ApiCommandArgument.TypeHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(T.TypeHierarchyItem.to))),new g.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.ApiCommandArgument.TypeHierarchyItem],new g.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(T.TypeHierarchyItem.to))),new g.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.ApiCommandArgument.TestItem],g.ApiCommandResult.Void),new g.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.ApiCommandResult.Void),new g.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.ApiCommandArgument.String.with("name","The context key name"),new g.ApiCommandArgument("value","The context key value",()=>!0,n=>n)],g.ApiCommandResult.Void)];class D{static register(h){m.forEach(h.registerApiCommand,h),this.a(h)}static a(h){h.registerCommand(!1,"_validateWhenClauses",A.validateWhenClauses)}}e.ExtHostApiCommands=D;function C(n){return h=>{if(Array.isArray(h))return h.map(n)}}function b(n){if(!Array.isArray(n))return;const h=[];for(const d of n)O.isLocationLink(d)?h.push(T.DefinitionLink.to(d)):h.push(T.location.to(d));return h}}),define(Ce[278],De([1,0,16,66,3,4,2,76,26,13,7,6,25,12]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function C(b,n,h){const d=b.getProxy(P.MainContext.MainThreadComments);class S{constructor(){this.b=new Map,this.c=new y.ExtensionIdentifierMap,n.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const I=this.b.get(l.handle);return I?I.value:l}else if(l&&l.$mid===7){const I=this.b.get(l.commentControlHandle);if(!I)return l;const E=I.getCommentThread(l.commentThreadHandle);return E?E.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const I=this.b.get(l.thread.commentControlHandle);if(!I)return l;const E=I.getCommentThread(l.thread.commentThreadHandle);return E?l.$mid===8?E.value:{thread:E.value,text:l.text}:l}else if(l&&l.$mid===10){const I=this.b.get(l.thread.commentControlHandle);if(!I)return l;const E=I.getCommentThread(l.thread.commentThreadHandle);if(!E)return l;const s=l.commentUniqueId,i=E.getCommentByUniqueId(s);return i||l}else if(l&&l.$mid===11){const I=this.b.get(l.thread.commentControlHandle);if(!I)return l;const E=I.getCommentThread(l.thread.commentThreadHandle);if(!E)return l;const s=l.text,i=l.commentUniqueId,k=E.getCommentByUniqueId(i);return k?(typeof k.body=="string"?k.body=s:k.body=new T.MarkdownString(s),k):l}return l}})}createCommentController(l,I,E){const s=S.a++,i=new p(l,s,I,E);this.b.set(i.handle,i);const k=this.c.get(l.identifier)||[];return k.push(i),this.c.set(l.identifier,k),i.value}$createCommentThreadTemplate(l,I,E){const s=this.b.get(l);s&&s.$createCommentThreadTemplate(I,E)}async $updateCommentThreadTemplate(l,I,E){const s=this.b.get(l);s&&s.$updateCommentThreadTemplate(I,E)}$deleteCommentThread(l,I){this.b.get(l)?.$deleteCommentThread(I)}$provideCommentingRanges(l,I,E){const s=this.b.get(l);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const i=h.getDocument(L.URI.revive(I));return(0,c.asPromise)(async()=>{const k=await s.commentingRangeProvider.provideCommentingRanges(i,E);let F;return Array.isArray(k)?F={ranges:k,fileComments:!1}:k?F={ranges:k.ranges||[],fileComments:k.fileComments||!1}:F=(0,D.withNullAsUndefined)(k),F}).then(k=>{let F;return k&&(F={ranges:k.ranges.map($=>g.Range.from($)),fileComments:k.fileComments}),F})}$toggleReaction(l,I,E,s,i){const k=this.b.get(l);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const F=k.getCommentThread(I);if(F){const $=F.getCommentByUniqueId(s.uniqueIdInThread);if(k!==void 0&&$&&k.reactionHandler)return k.reactionHandler($,r(i))}return Promise.resolve(void 0)})}}S.a=0;class w{set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,I,E,s,i,k,F,$){this.m=I,this.n=E,this.o=s,this.p=i,this.q=k,this.extensionDescription=F,this.r=$,this.handle=w.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new u.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.MutableDisposable,this.l.value=new O.DisposableStore,this.n===void 0&&(this.n=`${l}.${this.handle}`),d.$createCommentThread(I,this.handle,this.n,this.o,g.Range.from(this.p),F.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{d.$deleteCommentThread(I,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(W){j.range=W},get comments(){return j.comments},set comments(W){j.comments=W},get collapsibleState(){return j.collapsibleState},set collapsibleState(W){j.collapsibleState=W},get canReply(){return j.canReply},set canReply(W){j.canReply=W},get contextValue(){return j.contextValue},set contextValue(W){j.contextValue=W},get label(){return j.label},set label(W){j.label=W},get state(){return j.state},set state(W){j.state=W},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.DisposableStore);const l=E=>Object.prototype.hasOwnProperty.call(this.b,E),I={};l("range")&&(I.range=g.Range.from(this.p)),l("label")&&(I.label=this.label),l("contextValue")&&(I.contextValue=this.contextValue??null),l("comments")&&(I.comments=this.q.map(E=>t(this,E,this.k,this.extensionDescription))),l("collapsibleState")&&(I.collapseState=o(this.g)),l("canReply")&&(I.canReply=this.canReply),l("state")&&(I.state=f(this.h)),l("isTemplate")&&(I.isTemplate=this.r),this.b={},d.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(l){for(const I of this.k){const E=I[0],s=I[1];if(l===s)return E}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}w.a=0,qe([(0,R.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class p{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,d.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,I,E,s){this.f=l,this.g=I,this.h=E,this.i=s,this.a=new Map,d.$registerCommentController(this.handle,E,s);const i=this;this.value=Object.freeze({id:i.id,label:i.label,get options(){return i.options},set options(k){i.options=k},get commentingRangeProvider(){return i.commentingRangeProvider},set commentingRangeProvider(k){i.commentingRangeProvider=k},get reactionHandler(){return i.reactionHandler},set reactionHandler(k){i.reactionHandler=k},createCommentThread(k,F,$){return i.createCommentThread(k,F,$).value},dispose:()=>{i.dispose()}}),this.e=[],this.e.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(l,I,E){I===void 0&&(0,m.checkProposedApiEnabled)(this.f,"fileComments");const s=new w(this.id,this.handle,void 0,l,I,E,this.f,!1);return this.a.set(s.handle,s),s}$createCommentThreadTemplate(l,I){const E=new w(this.id,this.handle,void 0,L.URI.revive(l),g.Range.to(I),[],this.f,!0);return E.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(E.handle,E),E}$updateCommentThreadTemplate(l,I){const E=this.a.get(l);E&&(E.range=g.Range.to(I))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function t(v,l,I,E){let s=I.get(l);return s||(s=++v.commentHandle,I.set(l,s)),l.state!==void 0&&(0,m.checkProposedApiEnabled)(E,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:s,body:typeof l.body=="string"?l.body:g.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(i=>a(i)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function a(v){return{label:v.label,iconPath:v.iconPath?g.pathOrURIToURI(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted}}function r(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?L.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1}}function o(v){if(v!==void 0)switch(v){case T.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function f(v){if(v!==void 0)switch(v){case T.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new S}e.createExtHostComments=C}),define(Ce[279],De([1,0,23,6,27,20]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let L=e.AbstractExtHostConsoleForwarder=class{constructor(T,P){this.a=T.getProxy(R.MainContext.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(T,P){const m=this,D=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){m.e(T,P,D,arguments)}})}e(T,P,m,D){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:y(D,this.b)}),this.c&&this.f(T,m,D)}};e.AbstractExtHostConsoleForwarder=L=qe([je(0,O.IExtHostRpcService),je(1,u.IExtHostInitDataService)],L);const A=1e5;function y(g,T){const P=[];if(g.length)for(let m=0;m<g.length;m++){let D=g[m];if(typeof D>"u")D="undefined";else if(D instanceof Error){const C=D;C.stack?D=C.stack:D=C.toString()}P.push(D)}if(T){const m=new Error().stack;m&&P.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,c.safeStringify)(P);return m.length>A?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ce[143],De([1,0,2,6,7,5,20,17,19,11,10,25]),function(re,e,c,R,u,O,L,A,y,g,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let m=e.ExtHostDecorations=class an{constructor(C,b){this.h=b,this.f=new Map,this.g=C.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(C,b){const n=an.c++;this.f.set(n,{provider:C,extensionDescription:b}),this.g.$registerDecorationProvider(n,b.identifier.value);const h=C.onDidChangeFileDecorations&&C.onDidChangeFileDecorations(d=>{if(!d){this.g.$onDidChange(n,null);return}const S=(0,y.asArray)(d);if(S.length<=an.d){this.g.$onDidChange(n,S);return}this.h.warn("[Decorations] CAPPING events from decorations provider",b.identifier.value,S.length);const w=S.map(a=>({uri:a,rank:(0,g.count)(a.path,"/")})),p=(0,y.groupBy)(w,(a,r)=>a.rank-r.rank||(0,g.compare)(a.uri.path,r.uri.path)),t=[];e:for(const a of p){let r;for(const o of a){const f=(0,T.dirname)(o.uri.path);if(r!==f&&(r=f,t.push(o.uri)>=an.d))break e}}this.g.$onDidChange(n,t)});return new u.Disposable(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(n),this.f.delete(n)})}async $provideDecorations(C,b,n){if(!this.f.has(C))return Object.create(null);const h=Object.create(null),{provider:d,extensionDescription:S}=this.f.get(C);return await Promise.all(b.map(async w=>{try{const{uri:p,id:t}=w,a=await Promise.resolve(d.provideFileDecoration(c.URI.revive(p),n));if(!a)return;try{u.FileDecoration.validate(a),a.badge&&typeof a.badge!="string"&&(0,P.checkProposedApiEnabled)(S,"codiconDecoration"),h[t]=[a.propagate,a.tooltip,a.badge,a.color]}catch(r){this.h.warn(`INVALID decoration from extension '${S}': ${r}`)}}catch(p){this.h.error(p)}})),h}};m.c=0,m.d=250,e.ExtHostDecorations=m=qe([je(0,L.IExtHostRpcService),je(1,A.ILogService)],m),e.IExtHostDecorations=(0,O.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,R,u){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Ne=this&&this.__classPrivateFieldGet||function(re,e,c,R){if(c==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?R:c==="a"?R.call(re):R?R.value:e.get(re)};define(Ce[280],De([1,0,189,126,2,6,7,13,3,17,28,50]),function(re,e,c,R,u,O,L,A,y,g,T,P){"use strict";var m,D,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class b{constructor(d,S,w,p,t,a,r){this.d=d,this.e=S,this.f=w,this.g=p,m.set(this,void 0),D.set(this,void 0),C.set(this,void 0),this.c=!1,Ze(this,C,new T.ResourceMap(o=>t.getComparisonKey(o)),"f"),Ze(this,m,a,"f"),Ze(this,D,r,"f")}dispose(){this.c||(Ne(this,D,"f").fire([...Ne(this,C,"f").keys()]),Ne(this,m,"f")?.$clear(this.e),Ne(this,C,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(d,S){if(!d){this.clear();return}this.h();let w=[];if(u.URI.isUri(d)){if(!S){this.delete(d);return}Ne(this,C,"f").set(d,S.slice()),w=[d]}else if(Array.isArray(d)){w=[];let t;d=[...d].sort(b.j);for(const a of d){const[r,o]=a;if((!t||r.toString()!==t.toString())&&(t&&Ne(this,C,"f").get(t).length===0&&Ne(this,C,"f").delete(t),t=r,w.push(r),Ne(this,C,"f").set(r,[])),o)Ne(this,C,"f").get(r)?.push(...o);else{const f=Ne(this,C,"f").get(r);f&&(f.length=0)}}}if(Ne(this,D,"f").fire(w),!Ne(this,m,"f"))return;const p=[];for(const t of w){let a=[];const r=Ne(this,C,"f").get(t);if(r)if(r.length>this.f){a=[];const o=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let f=0;f<4;f++)for(const v of r)if(v.severity===o[f]&&a.push({...A.Diagnostic.from(v),modelVersionId:this.g(t)})===this.f)break e;a.push({severity:R.MarkerSeverity.Info,message:(0,c.localize)(0,null,r.length-this.f),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=r.map(o=>({...A.Diagnostic.from(o),modelVersionId:this.g(t)}));p.push([t,a])}Ne(this,m,"f").$changeMany(this.e,p)}delete(d){this.h(),Ne(this,D,"f").fire([d]),Ne(this,C,"f").delete(d),Ne(this,m,"f")?.$changeMany(this.e,[[d,void 0]])}clear(){this.h(),Ne(this,D,"f").fire([...Ne(this,C,"f").keys()]),Ne(this,C,"f").clear(),Ne(this,m,"f")?.$clear(this.e)}forEach(d,S){this.h();for(const[w,p]of this)d.call(S,w,p,this)}*[(m=new WeakMap,D=new WeakMap,C=new WeakMap,Symbol.iterator)](){this.h();for(const d of Ne(this,C,"f").keys())yield[d,this.get(d)]}get(d){this.h();const S=Ne(this,C,"f").get(d);return Array.isArray(S)?Object.freeze(S.slice(0)):[]}has(d){return this.h(),Array.isArray(Ne(this,C,"f").get(d))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(d,S){return d[0].toString()<S[0].toString()?-1:d[0].toString()>S[0].toString()?1:0}}e.DiagnosticCollection=b;let n=e.ExtHostDiagnostics=class vi{static _mapper(d){const S=new T.ResourceMap;for(const w of d)S.set(w,w);return{uris:Object.freeze(Array.from(S.values()))}}constructor(d,S,w,p){this.h=S,this.j=w,this.k=p,this.f=new Map,this.g=new y.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,vi._mapper),this.e=d.getProxy(O.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(d,S){const{f:w,e:p,g:t,h:a,j:r,k:o}=this,f=new class{$changeMany(I,E){p.$changeMany(I,E),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,I,E.length===0?"CLEARING":E)}$clear(I){p.$clear(I),a.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,I)}dispose(){p.dispose()}};let v;if(!S)S="_generated_diagnostic_collection_name_#"+vi.c++,v=S;else if(!w.has(S))v=S;else{this.h.warn(`DiagnosticCollection with name '${S}' does already exist.`);do v=S+vi.c++;while(w.has(v))}return new class extends b{constructor(){super(S,v,vi.d,I=>o.getDocument(I)?.version,r.extUri,f,t),w.set(v,this)}dispose(){super.dispose(),w.delete(v)}}}getDiagnostics(d){if(d)return this.l(d);{const S=new Map,w=[];for(const p of this.f.values())p.forEach((t,a)=>{let r=S.get(t.toString());typeof r>"u"&&(r=w.length,S.set(t.toString(),r),w.push([t,[]])),w[r][1]=w[r][1].concat(...a)});return w}}l(d){let S=[];for(const w of this.f.values())w.has(d)&&(S=S.concat(w.get(d)));return S}$acceptMarkersChange(d){if(!this.m){const S="_generated_mirror",w=new b(S,S,vi.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(S,w),this.m=w}for(const[S,w]of d)this.m.set(u.URI.revive(S),w.map(A.Diagnostic.to))}};n.c=0,n.d=1e3,e.ExtHostDiagnostics=n=qe([je(1,g.ILogService),je(2,P.IExtHostFileSystemInfo)],n)}),define(Ce[281],De([1,0,2,6,25]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class O{constructor(A){this.a=A.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(A,y){return y?.allowUIResources&&(0,u.checkProposedApiEnabled)(A,"showLocal"),this.a.$showOpenDialog(y).then(g=>g?g.map(T=>c.URI.revive(T)):void 0)}showSaveDialog(A){return this.a.$showSaveDialog(A).then(y=>y?c.URI.revive(y):void 0)}}e.ExtHostDialogs=O}),define(Ce[282],De([1,0,8,2,7,6,18,21,11]),function(re,e,c,R,u,O,L,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class g{constructor(P,m,D){this.d=m,this.e=D,this.b=new Map,this.c=P.getProxy(O.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,m){if(Object.keys(L.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const D=g.a++;this.b.set(D,m),this.c.$registerTextContentProvider(D,P);let C;return typeof m.onDidChange=="function"&&(C=m.onDidChange(b=>{if(b.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${b.scheme}' which will be IGNORED`);return}this.d.getDocument(b)&&this.$provideTextDocumentContent(D,b).then(n=>{if(!n&&typeof n!="string")return;const h=this.d.getDocument(b);if(!h)return;const d=(0,y.splitLines)(n);if(!h.equalLines(d))return this.c.$onVirtualDocumentChange(b,n)},c.onUnexpectedError)})),new u.Disposable(()=>{this.b.delete(D)&&this.c.$unregisterTextContentProvider(D),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(P,m){const D=this.b.get(P);return D?Promise.resolve(D.provideTextDocumentContent(R.URI.revive(m),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=g,g.a=0}),define(Ce[283],De([1,0,3,4,2,6,139,13,12,23,7]),function(re,e,c,R,u,O,L,A,y,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(D,C){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new R.DisposableStore,this.h=new Map,this.f=D.getProxy(O.MainContext.MainThreadDocuments),this.g=C,this.g.onDidRemoveDocuments(b=>{for(const n of b)this.b.fire(n.document)},void 0,this.e),this.g.onDidAddDocuments(b=>{for(const n of b)this.a.fire(n.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const C=this.g.getDocument(D);if(C)return C}getDocument(D){const C=this.getDocumentData(D);if(!C?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return C.document}ensureDocumentData(D){const C=this.g.getDocument(D);if(C)return Promise.resolve(C);let b=this.h.get(D.toString());return b||(b=this.f.$tryOpenDocument(D).then(n=>{this.h.delete(D.toString());const h=u.URI.revive(n);return(0,y.assertIsDefined)(this.g.getDocument(h))},n=>(this.h.delete(D.toString()),Promise.reject(n))),this.h.set(D.toString(),b)),b}createDocumentData(D){return this.f.$tryCreateDocument(D).then(C=>u.URI.revive(C))}$acceptModelLanguageChanged(D,C){const b=u.URI.revive(D),n=this.g.getDocument(b);if(!n)throw new Error("unknown document");this.b.fire(n.document),n._acceptLanguageId(C),this.a.fire(n.document)}$acceptModelSaved(D){const C=u.URI.revive(D),b=this.g.getDocument(C);if(!b)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(b.document)}$acceptDirtyStateChanged(D,C){const b=u.URI.revive(D),n=this.g.getDocument(b);if(!n)throw new Error("unknown document");n._acceptIsDirty(C),this.c.fire({document:n.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,C,b){const n=u.URI.revive(D),h=this.g.getDocument(n);if(!h)throw new Error("unknown document");h._acceptIsDirty(b),h.onEvents(C);let d;C.isUndoing?d=T.TextDocumentChangeReason.Undo:C.isRedoing&&(d=T.TextDocumentChangeReason.Redo),this.c.fire((0,g.deepFreeze)({document:h.document,contentChanges:C.changes.map(S=>({range:A.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:d}))}setWordDefinitionFor(D,C){(0,L.setWordDefinitionFor)(D,C)}}e.ExtHostDocuments=P}),define(Ce[62],De([1,0,52,3,4,2,5,6,139,20,142,13,17,28,18,53,54]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(w){this.value=w,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let d=e.ExtHostDocumentsAndEditors=class{constructor(w,p){this.h=w,this.i=p,this.a=null,this.b=new Map,this.c=new D.ResourceMap,this.d=new R.Emitter,this.e=new R.Emitter,this.f=new R.Emitter,this.g=new R.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(w){this.acceptDocumentsAndEditorsDelta(w)}acceptDocumentsAndEditorsDelta(w){const p=[],t=[],a=[];if(w.removedDocuments)for(const r of w.removedDocuments){const o=O.URI.revive(r),f=this.c.get(o);f?.unref()&&(this.c.delete(o),p.push(f.value))}if(w.addedDocuments)for(const r of w.addedDocuments){const o=O.URI.revive(r.uri);let f=this.c.get(o);if(f&&o.scheme!==C.Schemas.vscodeNotebookCell&&o.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);f||(f=new h(new y.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),o,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(o,f),t.push(f.value)),f.ref()}if(w.removedEditors)for(const r of w.removedEditors){const o=this.b.get(r);this.b.delete(r),o&&a.push(o)}if(w.addedEditors)for(const r of w.addedEditors){const o=O.URI.revive(r.documentUri);c.ok(this.c.has(o),`document '${o}' does not exist`),c.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const f=this.c.get(o).value,v=new T.ExtHostTextEditor(r.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new n.Lazy(()=>f.document),r.selections.map(P.Selection.to),r.options,r.visibleRanges.map(l=>P.Range.to(l)),typeof r.editorPosition=="number"?P.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,v)}w.newActiveEditor!==void 0&&(c.ok(w.newActiveEditor===null||this.b.has(w.newActiveEditor),`active editor '${w.newActiveEditor}' does not exist`),this.a=w.newActiveEditor),(0,u.dispose)(p),(0,u.dispose)(a),w.removedDocuments&&this.e.fire(p),w.addedDocuments&&this.d.fire(t),(w.removedEditors||w.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),w.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(w){return this.c.get(w)?.value}allDocuments(){return b.Iterable.map(this.c.values(),w=>w.value)}getEditor(w){return this.b.get(w)}activeEditor(w){if(!this.a)return;const p=this.b.get(this.a);return w?p:p?.value}allEditors(){return[...this.b.values()]}};e.ExtHostDocumentsAndEditors=d=qe([je(0,g.IExtHostRpcService),je(1,m.ILogService)],d),e.IExtHostDocumentsAndEditors=(0,L.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[63],De([1,0,13,6,2,3,5,7,20,12,65]),function(re,e,c,R,u,O,L,A,y,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,L.createDecorator)("IExtHostEditorTabs");class P{constructor(n,h,d){this.e=d,this.d=h,this.acceptDtoUpdate(n)}get apiObject(){if(!this.a){const n=this,h={get isActive(){return n.b.id===n.e()},get label(){return n.b.label},get input(){return n.c},get isDirty(){return n.b.isDirty},get isPinned(){return n.b.isPinned},get isPreview(){return n.b.isPreview},get group(){return n.d.apiObject}};this.a=Object.freeze(h)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(n){this.b=n,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(u.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(u.URI.revive(this.b.input.original),u.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(u.URI.revive(this.b.input.base),u.URI.revive(this.b.input.input1),u.URI.revive(this.b.input.input2),u.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(u.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(u.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(u.URI.revive(this.b.input.original),u.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(u.URI.revive(this.b.input.uri),u.URI.revive(this.b.input.inputBoxUri));default:return}}}class m{constructor(n,h){this.c=[],this.d="",this.b=n,this.e=h;for(const d of n.tabs)d.isActive&&(this.d=d.id),this.c.push(new P(d,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const n=this,h={get isActive(){return n.b.groupId===n.e()},get viewColumn(){return c.ViewColumn.to(n.b.viewColumn)},get activeTab(){return n.c.find(d=>d.tabId===n.d)?.apiObject},get tabs(){return Object.freeze(n.c.map(d=>d.apiObject))}};this.a=Object.freeze(h)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(n){this.b=n}acceptTabOperation(n){if(n.kind===0){const d=new P(n.tabDto,this,()=>this.activeTabId());return this.c.splice(n.index,0,d),n.tabDto.isActive&&(this.d=d.tabId),d}else if(n.kind===1){const d=this.c.splice(n.index,1)[0];if(!d)throw new Error(`Tab close updated received for index ${n.index} which does not exist`);return d.tabId===this.d&&(this.d=""),d}else if(n.kind===3){if(n.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const d=this.c.splice(n.oldIndex,1)[0];if(!d)throw new Error(`Tab move updated received for index ${n.oldIndex} which does not exist`);return this.c.splice(n.index,0,d),d}const h=this.c.find(d=>d.tabId===n.tabDto.id);if(!h)throw new Error("INVALID tab");return n.tabDto.isActive?this.d=n.tabDto.id:this.d===n.tabDto.id&&!n.tabDto.isActive&&(this.d=""),h.acceptDtoUpdate(n.tabDto),h}activeTabId(){return this.d}}let D=e.ExtHostEditorTabs=class{constructor(n){this.b=new O.Emitter,this.c=new O.Emitter,this.e=[],this.a=n.getProxy(R.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const n=this,h={onDidChangeTabGroups:n.c.event,onDidChangeTabs:n.b.event,get all(){return Object.freeze(n.e.map(d=>d.apiObject))},get activeTabGroup(){const d=n.d;return(0,g.assertIsDefined)(n.e.find(w=>w.groupId===d)?.apiObject)},close:async(d,S)=>{const w=Array.isArray(d)?d:[d];return w.length?C(w[0])?this.j(w,S):this.i(w,S):!0}};this.f=Object.freeze(h)}return this.f}$acceptEditorTabModel(n){const h=new Set(this.e.map(r=>r.groupId)),d=new Set(n.map(r=>r.groupId)),S=(0,T.diffSets)(h,d),w=this.e.filter(r=>S.removed.includes(r.groupId)).map(r=>r.apiObject),p=[],t=[];this.e=n.map(r=>{const o=new m(r,()=>this.d);return S.added.includes(o.groupId)?p.push(o.apiObject):t.push(o.apiObject),o});const a=(0,g.assertIsDefined)(n.find(r=>r.isActive===!0)?.groupId);a!==void 0&&this.d!==a&&(this.d=a),this.c.fire(Object.freeze({opened:p,closed:w,changed:t}))}$acceptTabGroupUpdate(n){const h=this.e.find(d=>d.groupId===n.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(n),n.isActive&&(this.d=n.groupId),this.c.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(n){const h=this.e.find(S=>S.groupId===n.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const d=h.acceptTabOperation(n);switch(n.kind){case 0:this.b.fire(Object.freeze({opened:[d.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[d.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[d.apiObject]}));return}}g(n){for(const h of this.e)for(const d of h.tabs)if(d.apiObject===n)return d}h(n){return this.e.find(h=>h.apiObject===n)}async i(n,h){const d=[];for(const S of n){const w=this.g(S);if(!w)throw new Error("Tab close: Invalid tab not found!");d.push(w.tabId)}return this.a.$closeTab(d,h)}async j(n,h){const d=[];for(const S of n){const w=this.h(S);if(!w)throw new Error("Group close: Invalid group not found!");d.push(w.groupId)}return this.a.$closeGroup(d,h)}};e.ExtHostEditorTabs=D=qe([je(0,y.IExtHostRpcService)],D);function C(b){return b.tabs!==void 0}}),define(Ce[284],De([1,0,2,6,4,7,13,164,11,22,25]),function(re,e,c,R,u,O,L,A,y,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this.a=[]}add(C){this.b=void 0,this.a.push(C)}delete(C){const b=this.a.indexOf(C);b>=0&&(this.a.splice(b,1),this.b=void 0)}c(){if(!this.b){const C=this.a.sort(),b=[];let n,h,d=14,S=14;for(const w of C){let p=n?(0,y.commonPrefixLength)(n,w):0;for(p===0?h=1:h=S;p<w.length;p++)p+1===w.length?(d=S,S=9):S+=1,b.push([h,w.toUpperCase().charCodeAt(p),S]),b.push([h,w.toLowerCase().charCodeAt(p),S]),h=S;n=w,S=d}b.push([9,58,10]),b.push([10,47,12]),this.b=new A.StateMachine(b)}}provideDocumentLinks(C){this.c();const b=[],n=A.LinkComputer.computeLinks({getLineContent(h){return C.lineAt(h-1).text},getLineCount(){return C.lineCount}},this.b);for(const h of n){const d=L.DocumentLink.to(h);d.target&&b.push(d)}return b}}class m{constructor(C,b){this.i=b,this.b=new P,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=C.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(C,b,n,h={}){if(m.j(n),this.d.has(b))throw new Error(`a provider for the scheme '${b}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(C,"*",this.b));const d=this.h++;this.b.add(b),this.d.add(b),this.c.set(d,n);let S=2;h.isCaseSensitive&&(S+=1024),h.isReadonly&&(S+=2048),typeof n.copy=="function"&&(S+=8),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,T.checkProposedApiEnabled)(C,"fsChunks"),S+=4),this.a.$registerFileSystemProvider(d,b,S).catch(p=>{console.error(`FAILED to register filesystem provider of ${C.identifier.value}-extension for the scheme ${b}`),console.error(p)});const w=n.onDidChangeFile(p=>{const t=[];for(const a of p){const{uri:r,type:o}=a;if(r.scheme!==b)continue;let f;switch(o){case O.FileChangeType.Changed:f=0;break;case O.FileChangeType.Created:f=1;break;case O.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:f})}this.a.$onFileSystemChange(d,t)});return(0,u.toDisposable)(()=>{w.dispose(),this.b.delete(b),this.d.delete(b),this.c.delete(d),this.a.$unregisterProvider(d)})}static j(C){if(!C)throw new Error("MISSING provider");if(typeof C.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof C.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof C.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof C.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof C.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof C.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof C.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof C.rename!="function")throw new Error("Provider does NOT implement rename")}static k(C){const{type:b,ctime:n,mtime:h,size:d,permissions:S}=C;return{type:b,ctime:n,mtime:h,size:d,permissions:S}}$stat(C,b){return Promise.resolve(this.l(C).stat(c.URI.revive(b))).then(n=>m.k(n))}$readdir(C,b){return Promise.resolve(this.l(C).readDirectory(c.URI.revive(b)))}$readFile(C,b){return Promise.resolve(this.l(C).readFile(c.URI.revive(b))).then(n=>g.VSBuffer.wrap(n))}$writeFile(C,b,n,h){return Promise.resolve(this.l(C).writeFile(c.URI.revive(b),n.buffer,h))}$delete(C,b,n){return Promise.resolve(this.l(C).delete(c.URI.revive(b),n))}$rename(C,b,n,h){return Promise.resolve(this.l(C).rename(c.URI.revive(b),c.URI.revive(n),h))}$copy(C,b,n,h){const d=this.l(C);if(!d.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(d.copy(c.URI.revive(b),c.URI.revive(n),h))}$mkdir(C,b){return Promise.resolve(this.l(C).createDirectory(c.URI.revive(b)))}$watch(C,b,n,h){const d=this.l(C).watch(c.URI.revive(n),h);this.f.set(b,d)}$unwatch(C,b){const n=this.f.get(b);n&&(n.dispose(),this.f.delete(b))}$open(C,b,n){const h=this.l(C);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(c.URI.revive(b),n))}$close(C,b){const n=this.l(C);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(b))}$read(C,b,n,h){const d=this.l(C);if(!d.read)throw new Error('FileSystemProvider does not implement "read"');const S=g.VSBuffer.alloc(h);return Promise.resolve(d.read(b,n,S.buffer,0,h)).then(w=>S.slice(0,w))}$write(C,b,n,h){const d=this.l(C);if(!d.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(d.write(b,n,h.buffer,0,h.byteLength))}l(C){const b=this.c.get(C);if(!b){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return b}}e.ExtHostFileSystem=m}),define(Ce[64],De([1,0,6,31,7,22,5,20,50,4]),function(re,e,c,R,u,O,L,A,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let T=e.ExtHostConsumerFileSystem=class ii{constructor(m,D){this.b=new Map,this.a=m.getProxy(c.MainContext.MainThreadFileSystem);const C=this;this.value=Object.freeze({async stat(b){try{let n;const h=C.b.get(b.scheme);return h?(await C.a.$ensureActivation(b.scheme),n=await h.stat(b)):n=await C.a.$stat(b),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===R.FilePermission.Readonly?1:void 0}}catch(n){ii.c(n)}},async readDirectory(b){try{const n=C.b.get(b.scheme);return n?(await C.a.$ensureActivation(b.scheme),(await n.readDirectory(b)).slice()):await C.a.$readdir(b)}catch(n){return ii.c(n)}},async createDirectory(b){try{return await C.a.$mkdir(b)}catch(n){return ii.c(n)}},async readFile(b){try{const n=C.b.get(b.scheme);return n?(await C.a.$ensureActivation(b.scheme),(await n.readFile(b)).slice()):(await C.a.$readFile(b)).buffer}catch(n){return ii.c(n)}},async writeFile(b,n){try{return await C.a.$writeFile(b,O.VSBuffer.wrap(n))}catch(h){return ii.c(h)}},async delete(b,n){try{const h=C.b.get(b.scheme);return h?(await C.a.$ensureActivation(b.scheme),await h.delete(b,{recursive:!1,...n})):await C.a.$delete(b,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(h){return ii.c(h)}},async rename(b,n,h){try{return await C.a.$rename(b,n,{overwrite:!1,...h})}catch(d){return ii.c(d)}},async copy(b,n,h){try{return await C.a.$copy(b,n,{overwrite:!1,...h})}catch(d){return ii.c(d)}},isWritableFileSystem(b){const n=D.getCapabilities(b);if(typeof n=="number")return!(n&2048)}})}static c(m){if(m instanceof u.FileSystemError)throw m;if(m instanceof R.FileSystemProviderError)switch(m.code){case R.FileSystemProviderErrorCode.FileExists:throw u.FileSystemError.FileExists(m.message);case R.FileSystemProviderErrorCode.FileNotFound:throw u.FileSystemError.FileNotFound(m.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw u.FileSystemError.FileNotADirectory(m.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw u.FileSystemError.FileIsADirectory(m.message);case R.FileSystemProviderErrorCode.NoPermissions:throw u.FileSystemError.NoPermissions(m.message);case R.FileSystemProviderErrorCode.Unavailable:throw u.FileSystemError.Unavailable(m.message);default:throw new u.FileSystemError(m.message,m.name)}if(!(m instanceof Error))throw new u.FileSystemError(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw u.FileSystemError.Unavailable(m.message);switch(m.name){case R.FileSystemProviderErrorCode.FileExists:throw u.FileSystemError.FileExists(m.message);case R.FileSystemProviderErrorCode.FileNotFound:throw u.FileSystemError.FileNotFound(m.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw u.FileSystemError.FileNotADirectory(m.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw u.FileSystemError.FileIsADirectory(m.message);case R.FileSystemProviderErrorCode.NoPermissions:throw u.FileSystemError.NoPermissions(m.message);case R.FileSystemProviderErrorCode.Unavailable:throw u.FileSystemError.Unavailable(m.message);default:throw new u.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,D){return this.b.set(m,D),(0,g.toDisposable)(()=>this.b.delete(m))}};e.ExtHostConsumerFileSystem=T=qe([je(0,A.IExtHostRpcService),je(1,y.IExtHostFileSystemInfo)],T),e.IExtHostConsumerFileSystem=(0,L.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[285],De([1,0,3,32,2,6,13,7]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(P,m,D,C,b,n,h,d){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter;const S=this.h(P,D,b);this.g=0,n&&(this.g+=1),h&&(this.g+=2),d&&(this.g+=4);const w=(0,R.parse)(b),p=typeof b=="string",t=C(a=>{if(!n)for(const r of a.created){const o=u.URI.revive(r);w(o.fsPath)&&(!p||m.getWorkspaceFolder(o))&&this.a.fire(o)}if(!h)for(const r of a.changed){const o=u.URI.revive(r);w(o.fsPath)&&(!p||m.getWorkspaceFolder(o))&&this.b.fire(o)}if(!d)for(const r of a.deleted){const o=u.URI.revive(r);w(o.fsPath)&&(!p||m.getWorkspaceFolder(o))&&this.c.fire(o)}});this.d=A.Disposable.from(S,this.a,this.b,this.c,t)}h(P,m,D){const C=A.Disposable.from();if(typeof D=="string")return C;const b=P.getProxy(O.MainContext.MainThreadFileSystem);let n=!1;(D.pattern.includes(R.GLOBSTAR)||D.pattern.includes(R.GLOB_SPLIT))&&(n=!0);const h=Math.random();return b.$watch(m.identifier.value,h,D.baseUri,{recursive:n,excludes:[]}),A.Disposable.from({dispose:()=>b.$unwatch(h)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class g{constructor(P,m,D){this.j=P,this.k=m,this.l=D,this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.g=new c.AsyncEmitter,this.h=new c.AsyncEmitter,this.i=new c.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(P,m,D,C,b,n){return new y(this.j,P,m,this.a.event,L.GlobPattern.from(D),C,b,n)}$onFileEvent(P){this.a.fire(P)}$onDidRunFileOperation(P,m){switch(P){case 2:this.b.fire(Object.freeze({files:m.map(D=>({oldUri:u.URI.revive(D.source),newUri:u.URI.revive(D.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(D=>u.URI.revive(D.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(D=>u.URI.revive(D.target))}));break;default:}}getOnWillRenameFileEvent(P){return this.m(P,this.g)}getOnWillCreateFileEvent(P){return this.m(P,this.h)}getOnWillDeleteFileEvent(P){return this.m(P,this.i)}m(P,m){return(D,C,b)=>{const n=function(d){D.call(C,d)};return n.extension=P,m.event(n,void 0,b)}}async $onWillRunFileOperation(P,m,D,C){switch(P){case 2:return await this.n(this.g,{files:m.map(b=>({oldUri:u.URI.revive(b.source),newUri:u.URI.revive(b.target)}))},D,C);case 1:return await this.n(this.i,{files:m.map(b=>u.URI.revive(b.target))},D,C);case 0:case 3:return await this.n(this.h,{files:m.map(b=>u.URI.revive(b.target))},D,C)}}async n(P,m,D,C){const b=new Set,n=[];if(await P.fireAsync(m,C,async(d,S)=>{const w=Date.now(),p=await Promise.resolve(d);p instanceof A.WorkspaceEdit&&(n.push([S.extension,p]),b.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-w>D&&this.k.warn("SLOW file-participant",S.extension.identifier)}),C.isCancellationRequested||n.length===0)return;const h={edits:[]};for(const[,d]of n){const{edits:S}=L.WorkspaceEdit.from(d,{getTextDocumentVersion:w=>this.l.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}});h.edits=h.edits.concat(S)}return{edit:h,extensionNames:Array.from(b)}}}e.ExtHostFileSystemEventService=g}),define(Ce[286],De([1,0,2,37]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class u{constructor(L,A,y,g,T){this.a=A,this.b=y,this.c=g;const P=new R.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new R.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new R.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new R.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new R.ApiCommandResult("Notebook and input URI",m=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const D=this.a.getEditorById(m.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",D.id),{notebookUri:c.URI.revive(m.notebookUri),inputUri:c.URI.revive(m.inputUri),notebookEditor:D.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:c.URI.revive(m.notebookUri),inputUri:c.URI.revive(m.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(L,A,y,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:L,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(c.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(L,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.ExtHostInteractive=u}),define(Ce[287],De([1,0,4,2,6,13,7,37]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class y{constructor(m,D){this.extension=m,this.provider=D,this.handle=y.a++}}y.a=0;class g{constructor(m){this.session=m,this.responses=[]}}class T{constructor(m,D,C,b){this.f=C,this.g=b,this.b=new Map,this.d=new Map,this.e=m.getProxy(u.MainContext.MainThreadInteractiveEditor),D.registerApiCommand(new A.ApiCommand("vscode.editorChat.start","interactiveEditor.start","Invoke a new editor chat session",[new A.ApiCommandArgument("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?O.Range.from(n.initialRange):void 0,message:n.message,autoSend:n.autoSend}})],A.ApiCommandResult.Void))}registerProvider(m,D){const C=new y(m,D);return this.b.set(C.handle,C),this.e.$registerInteractiveEditorProvider(C.handle,m.identifier.value,typeof D.handleInteractiveEditorResponseFeedback=="function"),(0,c.toDisposable)(()=>{this.e.$unregisterInteractiveEditorProvider(C.handle),this.b.delete(C.handle)})}async $prepareInteractiveSession(m,D,C,b){const n=this.b.get(m);if(!n){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const h=this.f.getDocument(R.URI.revive(D)),d=O.Selection.to(C),S=await n.provider.prepareInteractiveEditorSession({document:h,selection:d},b);if(!S)return;if(S.wholeRange&&!S.wholeRange.contains(d))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const w=T.a++;return this.d.set(w,new g(S)),{id:w,placeholder:S.placeholder,slashCommands:S.slashCommands?.map(p=>({command:p.command,detail:p.detail,refer:p.refer})),wholeRange:O.Range.from(S.wholeRange)}}async $provideResponse(m,D,C,b){const n=this.b.get(m);if(!n)return;const h=this.d.get(D.id);if(!h)return;const d=await n.provider.provideInteractiveEditorResponse({session:h.session,prompt:C.prompt,selection:O.Selection.to(C.selection),wholeRange:O.Range.to(C.wholeRange),attempt:C.attempt},b);if(d){const S=h.responses.push(d)-1,w={wholeRange:O.Range.from(d.wholeRange),placeholder:d.placeholder};if(T.h(d))return{...w,id:S,type:"message",message:O.MarkdownString.from(d.contents)};const{edits:p}=d;if(p instanceof L.WorkspaceEdit)return{...w,id:S,type:"bulkEdit",edits:O.WorkspaceEdit.from(p)};if(Array.isArray(p))return{...w,id:S,type:"editorEdit",edits:p.map(O.TextEdit.from)}}}$handleFeedback(m,D,C,b){const n=this.b.get(m),h=this.d.get(D),d=h?.responses[C];if(n&&d){let S;switch(b){case 1:S=L.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:S=L.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:S=L.InteractiveEditorResponseFeedbackKind.Undone;break}n.provider.handleInteractiveEditorResponseFeedback?.(h.session,d,S)}}$releaseSession(m,D){const C=this.d.get(D),b=this.b.get(m);C&&b&&b.provider.releaseInteractiveEditorSession?.(C.session),this.d.delete(D)}static h(m){return typeof m=="object"&&typeof m.contents=="object"}}e.ExtHostInteractiveEditor=T,T.a=0}),define(Ce[288],De([1,0,6,7]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class u{constructor(L){this.a=new Map,this.b=L.getProxy(c.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(L,A){if(this.a.size===0)throw new Error("No issue request handlers registered");const y=this.a.get(L);if(!y)throw new Error("Issue request handler not found");const g=await y.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(L,A){const y=L.identifier.value;return this.a.set(y,A),this.b.$registerIssueUriRequestHandler(y),new R.Disposable(()=>{this.b.$unregisterIssueUriRequestHandler(y),this.a.delete(y)})}}e.ExtHostIssueReporter=u}),define(Ce[289],De([1,0,4,6]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class u{constructor(L){this.b=0,this.a=L.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(L){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,L),(0,c.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=u}),define(Ce[290],De([1,0,2,23,13,7,76,6,11,36,19,12,159,21,4,123,110,80,40,8,16,25,191]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d,S,w,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class a{constructor(N,G){this.d=N,this.e=G}async provideDocumentSymbols(N,G){const Y=this.d.getDocument(N),ie=await this.e.provideDocumentSymbols(Y,G);if(!(0,T.isFalsyOrEmpty)(ie))return ie[0]instanceof O.DocumentSymbol?ie.map(u.DocumentSymbol.from):a.f(ie)}static f(N){N=N.slice(0).sort((ie,pe)=>{let Ie=ie.location.range.start.compareTo(pe.location.range.start);return Ie===0&&(Ie=pe.location.range.end.compareTo(ie.location.range.end)),Ie});const G=[],Y=[];for(const ie of N){const pe={name:ie.name||"!!MISSING: name!!",kind:u.SymbolKind.from(ie.kind),tags:ie.tags?.map(u.SymbolTag.from)||[],detail:"",containerName:ie.containerName,range:u.Range.from(ie.location.range),selectionRange:u.Range.from(ie.location.range),children:[]};for(;;){if(Y.length===0){Y.push(pe),G.push(pe);break}const Ie=Y[Y.length-1];if(g.Range.containsRange(Ie.range,pe.range)&&!g.Range.equalsRange(Ie.range,pe.range)){Ie.children?.push(pe),Y.push(pe);break}Y.pop()}}return G}}class r{constructor(N,G,Y){this.g=N,this.h=G,this.j=Y,this.e=new h.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(N,G){const Y=this.g.getDocument(N),ie=await this.j.provideCodeLenses(Y,G);if(!ie||G.isCancellationRequested)return;const pe=this.e.add(ie),Ie=new C.DisposableStore;this.f.set(pe,Ie);const he={cacheId:pe,lenses:[]};for(let Re=0;Re<ie.length;Re++)he.lenses.push({cacheId:[pe,Re],range:u.Range.from(ie[Re].range),command:this.h.toInternal(ie[Re].command,Ie)});return he}async resolveCodeLens(N,G){const Y=N.cacheId&&this.e.get(...N.cacheId);if(!Y)return;let ie;if(typeof this.j.resolveCodeLens!="function"||Y.isResolved?ie=Y:ie=await this.j.resolveCodeLens(Y,G),ie||(ie=Y),G.isCancellationRequested)return;const pe=N.cacheId&&this.f.get(N.cacheId[0]);if(pe)return N.command=this.h.toInternal(ie.command??r.d,pe),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}r.d={command:"missing",title:"!!MISSING: command!!"};function o(ue){return Array.isArray(ue)?ue.map(u.DefinitionLink.from):ue?[u.DefinitionLink.from(ue)]:[]}class f{constructor(N,G){this.d=N,this.e=G}async provideDefinition(N,G,Y){const ie=this.d.getDocument(N),pe=u.Position.to(G),Ie=await this.e.provideDefinition(ie,pe,Y);return o(Ie)}}class v{constructor(N,G){this.d=N,this.e=G}async provideDeclaration(N,G,Y){const ie=this.d.getDocument(N),pe=u.Position.to(G),Ie=await this.e.provideDeclaration(ie,pe,Y);return o(Ie)}}class l{constructor(N,G){this.d=N,this.e=G}async provideImplementation(N,G,Y){const ie=this.d.getDocument(N),pe=u.Position.to(G),Ie=await this.e.provideImplementation(ie,pe,Y);return o(Ie)}}class I{constructor(N,G){this.d=N,this.e=G}async provideTypeDefinition(N,G,Y){const ie=this.d.getDocument(N),pe=u.Position.to(G),Ie=await this.e.provideTypeDefinition(ie,pe,Y);return o(Ie)}}class E{constructor(N,G){this.d=N,this.e=G}async provideHover(N,G,Y){const ie=this.d.getDocument(N),pe=u.Position.to(G),Ie=await this.e.provideHover(ie,pe,Y);if(!(!Ie||(0,T.isFalsyOrEmpty)(Ie.contents)))return Ie.range||(Ie.range=ie.getWordRangeAtPosition(pe)),Ie.range||(Ie.range=new O.Range(pe,pe)),u.Hover.from(Ie)}}class s{constructor(N,G){this.d=N,this.e=G}async provideEvaluatableExpression(N,G,Y){const ie=this.d.getDocument(N),pe=u.Position.to(G),Ie=await this.e.provideEvaluatableExpression(ie,pe,Y);if(Ie)return u.EvaluatableExpression.from(Ie)}}class i{constructor(N,G){this.d=N,this.e=G}async provideInlineValues(N,G,Y,ie){const pe=this.d.getDocument(N),Ie=await this.e.provideInlineValues(pe,u.Range.to(G),u.InlineValueContext.to(Y),ie);if(Array.isArray(Ie))return Ie.map(he=>u.InlineValue.from(he))}}class k{constructor(N,G){this.d=N,this.e=G}async provideDocumentHighlights(N,G,Y){const ie=this.d.getDocument(N),pe=u.Position.to(G),Ie=await this.e.provideDocumentHighlights(ie,pe,Y);if(Array.isArray(Ie))return Ie.map(u.DocumentHighlight.from)}}class F{constructor(N,G){this.d=N,this.e=G}async provideLinkedEditingRanges(N,G,Y){const ie=this.d.getDocument(N),pe=u.Position.to(G),Ie=await this.e.provideLinkedEditingRanges(ie,pe,Y);if(Ie&&Array.isArray(Ie.ranges))return{ranges:(0,T.coalesce)(Ie.ranges.map(u.Range.from)),wordPattern:Ie.wordPattern}}}class ${constructor(N,G){this.d=N,this.e=G}async provideReferences(N,G,Y,ie){const pe=this.d.getDocument(N),Ie=u.Position.to(G),he=await this.e.provideReferences(pe,Ie,Y,ie);if(Array.isArray(he))return he.map(u.location.from)}}class j{constructor(N,G,Y,ie,pe,Ie,he){this.g=N,this.h=G,this.j=Y,this.k=ie,this.l=pe,this.m=Ie,this.n=he,this.e=new h.Cache("CodeAction"),this.f=new Map}async provideCodeActions(N,G,Y,ie){const pe=this.g.getDocument(N),Ie=m.Selection.isISelection(G)?u.Selection.to(G):u.Range.to(G),he=[];for(const Qe of this.j.getDiagnostics(N))if(Ie.intersection(Qe.range)&&he.push(Qe)>j.d)break;const Re={diagnostics:he,only:Y.only?new O.CodeActionKind(Y.only):void 0,triggerKind:u.CodeActionTriggerKind.to(Y.trigger)},Te=await this.k.provideCodeActions(pe,Ie,Re,ie);if(!(0,T.isNonEmptyArray)(Te)||ie.isCancellationRequested)return;const Ve=this.e.add(Te),xe=new C.DisposableStore;this.f.set(Ve,xe);const tt=[];for(let Qe=0;Qe<Te.length;Qe++){const Xe=Te[Qe];Xe&&(j.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,xe)})):(Re.only&&(Xe.kind?Re.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ve,Qe],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,xe),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(u.Diagnostic.from),edit:Xe.edit&&u.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:Ve,actions:tt}}async resolveCodeAction(N,G){const[Y,ie]=N,pe=this.e.get(Y,ie);if(!pe||j.o(pe))return{};if(!this.k.resolveCodeAction)return{};const Ie=await this.k.resolveCodeAction(pe,G)??pe;let he;Ie.edit&&(he=u.WorkspaceEdit.from(Ie.edit,void 0));let Re;if(Ie.command){const Te=this.f.get(Y);Te&&(Re=this.h.toInternal(Ie.command,Te))}return{edit:he,command:Re}}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}j.d=1e3;class W{constructor(N,G,Y,ie,pe){this.d=N,this.e=G,this.f=Y,this.g=ie,this.h=pe}async prepareDocumentPaste(N,G,Y,ie){if(!this.f.prepareDocumentPaste)return;const pe=this.e.getDocument(N),Ie=G.map(Te=>u.Range.to(Te)),he=u.DataTransfer.toDataTransfer(Y,()=>{throw new S.NotImplementedError});if(await this.f.prepareDocumentPaste(pe,Ie,he,ie),ie.isCancellationRequested)return;const Re=Array.from(he).filter(([,Te])=>!(Te instanceof O.InternalDataTransferItem));return u.DataTransfer.from(Re)}async providePasteEdits(N,G,Y,ie,pe){if(!this.f.provideDocumentPasteEdits)return;const Ie=this.e.getDocument(G),he=Y.map(Ve=>u.Range.to(Ve)),Re=u.DataTransfer.toDataTransfer(ie,async Ve=>(await this.d.$resolvePasteFileData(this.g,N,Ve)).buffer),Te=await this.f.provideDocumentPasteEdits(Ie,he,Re,pe);if(Te)return{id:Te.id?this.h.identifier.value+"."+Te.id:this.h.identifier.value,label:Te.label??(0,t.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,priority:Te.priority??0,insertText:typeof Te.insertText=="string"?Te.insertText:{snippet:Te.insertText.value},additionalEdit:Te.additionalEdit?u.WorkspaceEdit.from(Te.additionalEdit,void 0):void 0}}}class U{constructor(N,G){this.d=N,this.e=G}async provideDocumentFormattingEdits(N,G,Y){const ie=this.d.getDocument(N),pe=await this.e.provideDocumentFormattingEdits(ie,G,Y);if(Array.isArray(pe))return pe.map(u.TextEdit.from)}}class x{constructor(N,G){this.d=N,this.e=G}async provideDocumentRangeFormattingEdits(N,G,Y,ie){const pe=this.d.getDocument(N),Ie=u.Range.to(G),he=await this.e.provideDocumentRangeFormattingEdits(pe,Ie,Y,ie);if(Array.isArray(he))return he.map(u.TextEdit.from)}async provideDocumentRangesFormattingEdits(N,G,Y,ie){(0,P.assertType)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const pe=this.d.getDocument(N),Ie=G.map(u.Range.to),he=await this.e.provideDocumentRangesFormattingEdits(pe,Ie,Y,ie);if(Array.isArray(he))return he.map(u.TextEdit.from)}}class B{constructor(N,G){this.d=N,this.e=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,G,Y,ie,pe){const Ie=this.d.getDocument(N),he=u.Position.to(G),Re=await this.e.provideOnTypeFormattingEdits(Ie,he,Y,ie,pe);if(Array.isArray(Re))return Re.map(u.TextEdit.from)}}class z{constructor(N,G){this.e=N,this.f=G,this.d=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,G){const Y=await this.e.provideWorkspaceSymbols(N,G);if(!(0,T.isNonEmptyArray)(Y))return{symbols:[]};const ie=this.d.add(Y),pe={cacheId:ie,symbols:[]};for(let Ie=0;Ie<Y.length;Ie++){const he=Y[Ie];if(!he||!he.name){this.f.warn("INVALID SymbolInformation",he);continue}pe.symbols.push({...u.WorkspaceSymbol.from(he),cacheId:[ie,Ie]})}return pe}async resolveWorkspaceSymbol(N,G){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const Y=this.d.get(...N.cacheId);if(Y){const ie=await this.e.resolveWorkspaceSymbol(Y,G);return ie&&(0,R.mixin)(N,u.WorkspaceSymbol.from(ie),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class ee{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,G,Y){this.d=N,this.e=G,this.f=Y}async provideRenameEdits(N,G,Y,ie){const pe=this.d.getDocument(N),Ie=u.Position.to(G);try{const he=await this.e.provideRenameEdits(pe,Ie,Y,ie);return he?u.WorkspaceEdit.from(he):void 0}catch(he){const Re=ee.g(he);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(N,G,Y){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const ie=this.d.getDocument(N),pe=u.Position.to(G);try{const Ie=await this.e.prepareRename(ie,pe,Y);let he,Re;if(O.Range.isRange(Ie)?(he=Ie,Re=ie.getText(Ie)):(0,P.isObject)(Ie)&&(he=Ie.range,Re=Ie.placeholder),!he||!Re)return;if(he.start.line>pe.line||he.end.line<pe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:u.Range.from(he),text:Re}}catch(Ie){const he=ee.g(Ie);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(Ie)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class se{constructor(N,G){this.resultId=N,this.tokens=G}}class V{constructor(N,G){this.f=N,this.g=G,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,G,Y){const ie=this.f.getDocument(N),pe=G!==0?this.d.get(G):null;let Ie=typeof pe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(ie,pe.resultId,Y):await this.g.provideDocumentSemanticTokens(ie,Y);return pe&&this.d.delete(G),Ie?(Ie=V.h(Ie),this.o(V.n(pe,Ie),Ie)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return V.j(N)?V.k(N)?N:new O.SemanticTokens(new Uint32Array(N.data),N.resultId):V.l(N)?V.m(N)?N:new O.SemanticTokensEdits(N.edits.map(G=>new O.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const G of N.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static n(N,G){if(!V.j(G)||!N||!N.tokens)return G;const Y=N.tokens,ie=Y.length,pe=G.data,Ie=pe.length;let he=0;const Re=Math.min(ie,Ie);for(;he<Re&&Y[he]===pe[he];)he++;if(he===ie&&he===Ie)return new O.SemanticTokensEdits([],G.resultId);let Te=0;const Ve=Re-he;for(;Te<Ve&&Y[ie-Te-1]===pe[Ie-Te-1];)Te++;return new O.SemanticTokensEdits([{start:he,deleteCount:ie-he-Te,data:pe.subarray(he,Ie-Te)}],G.resultId)}o(N,G){if(V.j(N)){const Y=this.e++;return this.d.set(Y,new se(N.resultId,N.data)),(0,b.encodeSemanticTokensDto)({id:Y,type:"full",data:N.data})}if(V.l(N)){const Y=this.e++;return V.j(G)?this.d.set(Y,new se(G.resultId,G.data)):this.d.set(Y,new se(N.resultId)),(0,b.encodeSemanticTokensDto)({id:Y,type:"delta",deltas:(N.edits||[]).map(ie=>({start:ie.start,deleteCount:ie.deleteCount,data:ie.data}))})}return null}}class Z{constructor(N,G){this.d=N,this.e=G}async provideDocumentRangeSemanticTokens(N,G,Y){const ie=this.d.getDocument(N),pe=await this.e.provideDocumentRangeSemanticTokens(ie,u.Range.to(G),Y);return pe?this.f(pe):null}f(N){return(0,b.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class q{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,G,Y,ie,pe){this.f=N,this.g=G,this.h=Y,this.j=ie,this.k=pe,this.d=new h.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(N,G,Y,ie){const pe=this.f.getDocument(N),Ie=u.Position.to(G),he=pe.getWordRangeAtPosition(Ie)||new O.Range(Ie,Ie),Re=he.with({end:Ie}),Te=new d.StopWatch(!0),Ve=await this.h.provideCompletionItems(pe,Ie,ie,u.CompletionContext.to(Y));if(!Ve||ie.isCancellationRequested)return;const xe=Array.isArray(Ve)?new O.CompletionList(Ve):Ve,tt=q.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),Qe=new C.DisposableStore;this.e.set(tt,Qe);const Xe=[],nt={x:tt,b:Xe,a:{replace:u.Range.from(he),insert:u.Range.from(Re)},c:xe.isIncomplete||void 0,d:Te.elapsed()};for(let ot=0;ot<xe.items.length;ot++){const et=xe.items[ot],Be=this.l(et,[tt,ot],Re,he);Xe.push(Be)}return nt}async resolveCompletionItem(N,G){if(typeof this.h.resolveCompletionItem!="function")return;const Y=this.d.get(...N);if(!Y)return;const ie=await this.h.resolveCompletionItem(Y,G);if(!ie)return;const pe={...Y,documentation:ie.documentation,detail:ie.detail,additionalTextEdits:ie.additionalTextEdits};return Y.insertText!==ie.insertText&&(this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),pe.insertText=ie.insertText),this.l(pe,N)}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,G,Y,ie){const pe=this.e.get(G[0]);if(!pe)throw Error("DisposableStore is missing...");const Ie=this.g.toInternal(N.command,pe),he={x:G,a:N.label,b:N.kind!==void 0?u.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(u.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:u.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(u.TextEdit.from),n:Ie?.$ident,o:Ie?.id,p:Ie?.$ident?void 0:Ie?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),he.h=N.textEdit.newText):typeof N.insertText=="string"?he.h=N.insertText:N.insertText instanceof O.SnippetString&&(he.h=N.insertText.value,he.i|=4);let Re;return N.textEdit?Re=N.textEdit.range:N.range&&(Re=N.range),O.Range.isRange(Re)?he.j=u.Range.from(Re):Re&&(!Y?.isEqual(Re.inserting)||!ie?.isEqual(Re.replacing))&&(he.j={insert:u.Range.from(Re.inserting),replace:u.Range.from(Re.replacing)}),he}}class ae{async provideInlineCompletions(N,G,Y,ie){}disposeCompletions(N){}handleDidShowCompletionItem(N,G,Y){}handlePartialAccept(N,G,Y){}}class Ee extends ae{constructor(N,G,Y,ie){super(),this.f=N,this.g=G,this.h=Y,this.j=ie,this.d=new ye,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[L.InlineCompletionTriggerKind.Automatic]:O.InlineCompletionTriggerKind.Automatic,[L.InlineCompletionTriggerKind.Explicit]:O.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(N,G,Y,ie){const pe=this.g.getDocument(N),Ie=u.Position.to(G),he=await this.h.provideInlineCompletionItems(pe,Ie,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:u.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Y.triggerKind]},ie);if(!he||ie.isCancellationRequested)return;const Re=Array.isArray(he)?he:he.items,Te=this.e?Array.isArray(he)?[]:he.commands||[]:[],Ve=this.e&&!Array.isArray(he)?he.suppressSuggestions:void 0,xe=this.e&&!Array.isArray(he)?he.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Re}),items:Re.map((Xe,nt)=>{let ot;Xe.command&&(tt||(tt=new C.DisposableStore),ot=this.j.toInternal(Xe.command,tt));const et=Xe.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:Xe.filterText,range:Xe.range?u.Range.from(Xe.range):void 0,command:ot,idx:nt,completeBracketPairs:this.e?Xe.completeBracketPairs:!1}}),commands:Te.map(Xe=>(tt||(tt=new C.DisposableStore),this.j.toInternal(Xe,tt))),suppressSuggestions:Ve,enableForwardStability:xe}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,G,Y){const ie=this.d.get(N)?.items[G];ie&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(ie,Y)}handlePartialAccept(N,G,Y){const ie=this.d.get(N)?.items[G];ie&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(ie,Y)}}class ye{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const G=this.e++;return this.d.set(G,N),G}disposeReferenceId(N){const G=this.d.get(N);return this.d.delete(N),G}get(N){return this.d.get(N)}}class be{constructor(N,G){this.e=N,this.f=G,this.d=new h.Cache("SignatureHelp")}async provideSignatureHelp(N,G,Y,ie){const pe=this.e.getDocument(N),Ie=u.Position.to(G),he=this.g(Y),Re=await this.f.provideSignatureHelp(pe,Ie,ie,he);if(Re){const Te=this.d.add([Re]);return{...u.SignatureHelp.from(Re),id:Te}}}g(N){let G;if(N.activeSignatureHelp){const Y=u.SignatureHelp.to(N.activeSignatureHelp),ie=this.d.get(N.activeSignatureHelp.id,0);ie?(G=ie,G.activeSignature=Y.activeSignature,G.activeParameter=Y.activeParameter):G=Y}return{...N,activeSignatureHelp:G}}releaseSignatureHelp(N){this.d.delete(N)}}class M{constructor(N,G,Y,ie,pe){this.f=N,this.g=G,this.h=Y,this.j=ie,this.k=pe,this.d=new h.Cache("InlayHints"),this.e=new Map}async provideInlayHints(N,G,Y){const ie=this.f.getDocument(N),pe=u.Range.to(G),Ie=await this.h.provideInlayHints(ie,pe,Y);if(!Array.isArray(Ie)||Ie.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${G}`);return}if(Y.isCancellationRequested)return;const he=this.d.add(Ie);this.e.set(he,new C.DisposableStore);const Re={hints:[],cacheId:he};for(let Te=0;Te<Ie.length;Te++)this.l(Ie[Te],pe)&&Re.hints.push(this.m(Ie[Te],[he,Te]));return this.j.trace(`[InlayHints] ${Re.hints.length} inlay hints from '${this.k.identifier.value}' for ${G}`),Re}async resolveInlayHint(N,G){if(typeof this.h.resolveInlayHint!="function")return;const Y=this.d.get(...N);if(!Y)return;const ie=await this.h.resolveInlayHint(Y,G);if(ie&&this.l(ie))return this.m(ie,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,G){return N.label.length===0||Array.isArray(N.label)&&N.label.every(Y=>Y.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(G&&!G.contains(N.position))}m(N,G){const Y=this.e.get(G[0]);if(!Y)throw Error("DisposableStore is missing...");const ie={label:"",cacheId:G,tooltip:u.MarkdownString.fromStrict(N.tooltip),position:u.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(u.TextEdit.from),kind:N.kind&&u.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?ie.label=N.label:ie.label=N.label.map(pe=>{const Ie={label:pe.value};return Ie.tooltip=u.MarkdownString.fromStrict(pe.tooltip),O.Location.isLocation(pe.location)&&(Ie.location=u.location.from(pe.location)),pe.command&&(Ie.command=this.g.toInternal(pe.command,Y)),Ie}),ie}}class Q{constructor(N,G){this.e=N,this.f=G,this.d=new h.Cache("DocumentLink")}async provideLinks(N,G){const Y=this.e.getDocument(N),ie=await this.f.provideDocumentLinks(Y,G);if(!(!Array.isArray(ie)||ie.length===0)&&!G.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:ie.filter(Q.g).map(u.DocumentLink.from)};{const pe=this.d.add(ie),Ie={links:[],cacheId:pe};for(let he=0;he<ie.length;he++){if(!Q.g(ie[he]))continue;const Re=u.DocumentLink.from(ie[he]);Re.cacheId=[pe,he],Ie.links.push(Re)}return Ie}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,G){if(typeof this.f.resolveDocumentLink!="function")return;const Y=this.d.get(...N);if(!Y)return;const ie=await this.f.resolveDocumentLink(Y,G);if(!(!ie||!Q.g(ie)))return u.DocumentLink.from(ie)}releaseLinks(N){this.d.delete(N)}}class fe{constructor(N,G){this.d=N,this.e=G}async provideColors(N,G){const Y=this.d.getDocument(N),ie=await this.e.provideDocumentColors(Y,G);return Array.isArray(ie)?ie.map(Ie=>({color:u.Color.from(Ie.color),range:u.Range.from(Ie.range)})):[]}async provideColorPresentations(N,G,Y){const ie=this.d.getDocument(N),pe=u.Range.to(G.range),Ie=u.Color.to(G.color),he=await this.e.provideColorPresentations(Ie,{document:ie,range:pe},Y);if(Array.isArray(he))return he.map(u.ColorPresentation.from)}}class we{constructor(N,G){this.d=N,this.e=G}async provideFoldingRanges(N,G,Y){const ie=this.d.getDocument(N),pe=await this.e.provideFoldingRanges(ie,G,Y);if(Array.isArray(pe))return pe.map(u.FoldingRange.from)}}class _{constructor(N,G,Y){this.d=N,this.e=G,this.f=Y}async provideSelectionRanges(N,G,Y){const ie=this.d.getDocument(N),pe=G.map(u.Position.to),Ie=await this.e.provideSelectionRanges(ie,pe,Y);if(!(0,T.isNonEmptyArray)(Ie))return[];if(Ie.length!==pe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Re=0;Re<pe.length;Re++){const Te=[];he.push(Te);let Ve=pe[Re],xe=Ie[Re];for(;;){if(!xe.range.contains(Ve))throw new Error("INVALID selection range, must contain the previous range");if(Te.push(u.SelectionRange.from(xe)),!xe.parent)break;Ve=xe.range,xe=xe.parent}}return he}}class ne{constructor(N,G){this.f=N,this.g=G,this.d=new n.IdGenerator(""),this.e=new Map}async prepareSession(N,G,Y){const ie=this.f.getDocument(N),pe=u.Position.to(G),Ie=await this.g.prepareCallHierarchy(ie,pe,Y);if(!Ie)return;const he=this.d.nextId();return this.e.set(he,new Map),Array.isArray(Ie)?Ie.map(Re=>this.h(he,Re)):[this.h(he,Ie)]}async provideCallsTo(N,G,Y){const ie=this.j(N,G);if(!ie)throw new Error("missing call hierarchy item");const pe=await this.g.provideCallHierarchyIncomingCalls(ie,Y);if(pe)return pe.map(Ie=>({from:this.h(N,Ie.from),fromRanges:Ie.fromRanges.map(he=>u.Range.from(he))}))}async provideCallsFrom(N,G,Y){const ie=this.j(N,G);if(!ie)throw new Error("missing call hierarchy item");const pe=await this.g.provideCallHierarchyOutgoingCalls(ie,Y);if(pe)return pe.map(Ie=>({to:this.h(N,Ie.to),fromRanges:Ie.fromRanges.map(he=>u.Range.from(he))}))}releaseSession(N){this.e.delete(N)}h(N,G){const Y=this.e.get(N),ie=u.CallHierarchyItem.from(G,N,Y.size.toString(36));return Y.set(ie._itemId,G),ie}j(N,G){return this.e.get(N)?.get(G)}}class le{constructor(N,G){this.f=N,this.g=G,this.d=new n.IdGenerator(""),this.e=new Map}async prepareSession(N,G,Y){const ie=this.f.getDocument(N),pe=u.Position.to(G),Ie=await this.g.prepareTypeHierarchy(ie,pe,Y);if(!Ie)return;const he=this.d.nextId();return this.e.set(he,new Map),Array.isArray(Ie)?Ie.map(Re=>this.h(he,Re)):[this.h(he,Ie)]}async provideSupertypes(N,G,Y){const ie=this.j(N,G);if(!ie)throw new Error("missing type hierarchy item");const pe=await this.g.provideTypeHierarchySupertypes(ie,Y);if(pe)return pe.map(Ie=>this.h(N,Ie))}async provideSubtypes(N,G,Y){const ie=this.j(N,G);if(!ie)throw new Error("missing type hierarchy item");const pe=await this.g.provideTypeHierarchySubtypes(ie,Y);if(pe)return pe.map(Ie=>this.h(N,Ie))}releaseSession(N){this.e.delete(N)}h(N,G){const Y=this.e.get(N),ie=u.TypeHierarchyItem.from(G,N,Y.size.toString(36));return Y.set(ie._itemId,G),ie}j(N,G){return this.e.get(N)?.get(G)}}class te{constructor(N,G,Y,ie,pe){this.d=N,this.e=G,this.f=Y,this.g=ie,this.h=pe}async provideDocumentOnDropEdits(N,G,Y,ie,pe){const Ie=this.e.getDocument(G),he=u.Position.to(Y),Re=u.DataTransfer.toDataTransfer(ie,async Ve=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,Ve)).buffer),Te=await this.f.provideDocumentDropEdits(Ie,he,Re,pe);if(Te)return{id:Te.id?this.h.identifier.value+"."+Te.id:this.h.identifier.value,label:Te.label??(0,t.localize)(1,null,this.h.displayName||this.h.name),priority:Te.priority??0,insertText:typeof Te.insertText=="string"?Te.insertText:{snippet:Te.insertText.value},additionalEdit:Te.additionalEdit?u.WorkspaceEdit.from(Te.additionalEdit,void 0):void 0}}}class de{constructor(N,G){this.adapter=N,this.extension=G}}class oe{constructor(N,G,Y,ie,pe,Ie,he,Re){this.g=G,this.h=Y,this.j=ie,this.k=pe,this.l=Ie,this.m=he,this.n=Re,this.f=new Map,this.e=N.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(N,G){return u.DocumentSelector.from(N,this.g,G)}p(N){return new O.Disposable(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return oe.d++}async s(N,G,Y,ie,pe,Ie=!1){const he=this.f.get(N);if(!he||!(he.adapter instanceof G))return ie;const Re=Date.now();Ie||this.l.trace(`[${he.extension.identifier.value}] INVOKE provider '${Y.toString().replace(/[\r\n]/g,"")}'`);const Te=Y(he.adapter,he.extension);return Promise.resolve(Te).catch(Ve=>{(0,S.isCancellationError)(Ve)||(this.l.error(`[${he.extension.identifier.value}] provider FAILED`),this.l.error(Ve),this.n.onExtensionError(he.extension.identifier,Ve))}).finally(()=>{Ie||this.l.trace(`[${he.extension.identifier.value}] provider DONE after ${Date.now()-Re}ms`)}),D.CancellationToken.isCancellationToken(pe)?(0,w.raceCancellationError)(Te,pe):Te}t(N,G){const Y=this.q();return this.f.set(Y,new de(N,G)),Y}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,G,Y,ie){const pe=this.t(new a(this.h,Y),N),Ie=ie&&ie.label||oe.u(N);return this.e.$registerDocumentSymbolProvider(pe,this.o(G,N),Ie),this.p(pe)}$provideDocumentSymbols(N,G,Y){return this.s(N,a,ie=>ie.provideDocumentSymbols(c.URI.revive(G),Y),void 0,Y)}registerCodeLensProvider(N,G,Y){const ie=this.q(),pe=typeof Y.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(ie,new de(new r(this.h,this.j.converter,Y),N)),this.e.$registerCodeLensSupport(ie,this.o(G,N),pe);let Ie=this.p(ie);if(pe!==void 0){const he=Y.onDidChangeCodeLenses(Re=>this.e.$emitCodeLensEvent(pe));Ie=O.Disposable.from(Ie,he)}return Ie}$provideCodeLenses(N,G,Y){return this.s(N,r,ie=>ie.provideCodeLenses(c.URI.revive(G),Y),void 0,Y)}$resolveCodeLens(N,G,Y){return this.s(N,r,ie=>ie.resolveCodeLens(G,Y),void 0,void 0)}$releaseCodeLenses(N,G){this.s(N,r,Y=>Promise.resolve(Y.releaseCodeLenses(G)),void 0,void 0)}registerDefinitionProvider(N,G,Y){const ie=this.t(new f(this.h,Y),N);return this.e.$registerDefinitionSupport(ie,this.o(G,N)),this.p(ie)}$provideDefinition(N,G,Y,ie){return this.s(N,f,pe=>pe.provideDefinition(c.URI.revive(G),Y,ie),[],ie)}registerDeclarationProvider(N,G,Y){const ie=this.t(new v(this.h,Y),N);return this.e.$registerDeclarationSupport(ie,this.o(G,N)),this.p(ie)}$provideDeclaration(N,G,Y,ie){return this.s(N,v,pe=>pe.provideDeclaration(c.URI.revive(G),Y,ie),[],ie)}registerImplementationProvider(N,G,Y){const ie=this.t(new l(this.h,Y),N);return this.e.$registerImplementationSupport(ie,this.o(G,N)),this.p(ie)}$provideImplementation(N,G,Y,ie){return this.s(N,l,pe=>pe.provideImplementation(c.URI.revive(G),Y,ie),[],ie)}registerTypeDefinitionProvider(N,G,Y){const ie=this.t(new I(this.h,Y),N);return this.e.$registerTypeDefinitionSupport(ie,this.o(G,N)),this.p(ie)}$provideTypeDefinition(N,G,Y,ie){return this.s(N,I,pe=>pe.provideTypeDefinition(c.URI.revive(G),Y,ie),[],ie)}registerHoverProvider(N,G,Y,ie){const pe=this.t(new E(this.h,Y),N);return this.e.$registerHoverProvider(pe,this.o(G,N)),this.p(pe)}$provideHover(N,G,Y,ie){return this.s(N,E,pe=>pe.provideHover(c.URI.revive(G),Y,ie),void 0,ie)}registerEvaluatableExpressionProvider(N,G,Y,ie){const pe=this.t(new s(this.h,Y),N);return this.e.$registerEvaluatableExpressionProvider(pe,this.o(G,N)),this.p(pe)}$provideEvaluatableExpression(N,G,Y,ie){return this.s(N,s,pe=>pe.provideEvaluatableExpression(c.URI.revive(G),Y,ie),void 0,ie)}registerInlineValuesProvider(N,G,Y,ie){const pe=typeof Y.onDidChangeInlineValues=="function"?this.q():void 0,Ie=this.t(new i(this.h,Y),N);this.e.$registerInlineValuesProvider(Ie,this.o(G,N),pe);let he=this.p(Ie);if(pe!==void 0){const Re=Y.onDidChangeInlineValues(Te=>this.e.$emitInlineValuesEvent(pe));he=O.Disposable.from(he,Re)}return he}$provideInlineValues(N,G,Y,ie,pe){return this.s(N,i,Ie=>Ie.provideInlineValues(c.URI.revive(G),Y,ie,pe),void 0,pe)}registerDocumentHighlightProvider(N,G,Y){const ie=this.t(new k(this.h,Y),N);return this.e.$registerDocumentHighlightProvider(ie,this.o(G,N)),this.p(ie)}$provideDocumentHighlights(N,G,Y,ie){return this.s(N,k,pe=>pe.provideDocumentHighlights(c.URI.revive(G),Y,ie),void 0,ie)}registerLinkedEditingRangeProvider(N,G,Y){const ie=this.t(new F(this.h,Y),N);return this.e.$registerLinkedEditingRangeProvider(ie,this.o(G,N)),this.p(ie)}$provideLinkedEditingRanges(N,G,Y,ie){return this.s(N,F,async pe=>{const Ie=await pe.provideLinkedEditingRanges(c.URI.revive(G),Y,ie);if(Ie)return{ranges:Ie.ranges,wordPattern:Ie.wordPattern?oe.w(Ie.wordPattern):void 0}},void 0,ie)}registerReferenceProvider(N,G,Y){const ie=this.t(new $(this.h,Y),N);return this.e.$registerReferenceSupport(ie,this.o(G,N)),this.p(ie)}$provideReferences(N,G,Y,ie,pe){return this.s(N,$,Ie=>Ie.provideReferences(c.URI.revive(G),Y,ie,pe),void 0,pe)}registerCodeActionProvider(N,G,Y,ie){const pe=new C.DisposableStore,Ie=this.t(new j(this.h,this.j.converter,this.k,Y,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(Ie,this.o(G,N),{providedKinds:ie?.providedCodeActionKinds?.map(he=>he.value),documentation:ie?.documentation?.map(he=>({kind:he.kind.value,command:this.j.converter.toInternal(he.command,pe)}))},oe.u(N),!!Y.resolveCodeAction),pe.add(this.p(Ie)),pe}$provideCodeActions(N,G,Y,ie,pe){return this.s(N,j,Ie=>Ie.provideCodeActions(c.URI.revive(G),Y,ie,pe),void 0,pe)}$resolveCodeAction(N,G,Y){return this.s(N,j,ie=>ie.resolveCodeAction(G,Y),{},void 0)}$releaseCodeActions(N,G){this.s(N,j,Y=>Promise.resolve(Y.releaseCodeActions(G)),void 0,void 0)}registerDocumentFormattingEditProvider(N,G,Y){const ie=this.t(new U(this.h,Y),N);return this.e.$registerDocumentFormattingSupport(ie,this.o(G,N),N.identifier,N.displayName||N.name),this.p(ie)}$provideDocumentFormattingEdits(N,G,Y,ie){return this.s(N,U,pe=>pe.provideDocumentFormattingEdits(c.URI.revive(G),Y,ie),void 0,ie)}registerDocumentRangeFormattingEditProvider(N,G,Y){const ie=typeof Y.provideDocumentRangesFormattingEdits=="function";ie&&(0,p.checkProposedApiEnabled)(N,"formatMultipleRanges");const pe=this.t(new x(this.h,Y),N);return this.e.$registerRangeFormattingSupport(pe,this.o(G,N),N.identifier,N.displayName||N.name,ie),this.p(pe)}$provideDocumentRangeFormattingEdits(N,G,Y,ie,pe){return this.s(N,x,Ie=>Ie.provideDocumentRangeFormattingEdits(c.URI.revive(G),Y,ie,pe),void 0,pe)}$provideDocumentRangesFormattingEdits(N,G,Y,ie,pe){return this.s(N,x,Ie=>Ie.provideDocumentRangesFormattingEdits(c.URI.revive(G),Y,ie,pe),void 0,pe)}registerOnTypeFormattingEditProvider(N,G,Y,ie){const pe=this.t(new B(this.h,Y),N);return this.e.$registerOnTypeFormattingSupport(pe,this.o(G,N),ie,N.identifier),this.p(pe)}$provideOnTypeFormattingEdits(N,G,Y,ie,pe,Ie){return this.s(N,B,he=>he.provideOnTypeFormattingEdits(c.URI.revive(G),Y,ie,pe,Ie),void 0,Ie)}registerWorkspaceSymbolProvider(N,G){const Y=this.t(new z(G,this.l),N);return this.e.$registerNavigateTypeSupport(Y,typeof G.resolveWorkspaceSymbol=="function"),this.p(Y)}$provideWorkspaceSymbols(N,G,Y){return this.s(N,z,ie=>ie.provideWorkspaceSymbols(G,Y),{symbols:[]},Y)}$resolveWorkspaceSymbol(N,G,Y){return this.s(N,z,ie=>ie.resolveWorkspaceSymbol(G,Y),void 0,void 0)}$releaseWorkspaceSymbols(N,G){this.s(N,z,Y=>Y.releaseWorkspaceSymbols(G),void 0,void 0)}registerRenameProvider(N,G,Y){const ie=this.t(new ee(this.h,Y,this.l),N);return this.e.$registerRenameSupport(ie,this.o(G,N),ee.supportsResolving(Y)),this.p(ie)}$provideRenameEdits(N,G,Y,ie,pe){return this.s(N,ee,Ie=>Ie.provideRenameEdits(c.URI.revive(G),Y,ie,pe),void 0,pe)}$resolveRenameLocation(N,G,Y,ie){return this.s(N,ee,pe=>pe.resolveRenameLocation(c.URI.revive(G),Y,ie),void 0,ie)}registerDocumentSemanticTokensProvider(N,G,Y,ie){const pe=this.t(new V(this.h,Y),N),Ie=typeof Y.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(pe,this.o(G,N),ie,Ie);let he=this.p(pe);if(Ie){const Re=Y.onDidChangeSemanticTokens(Te=>this.e.$emitDocumentSemanticTokensEvent(Ie));he=O.Disposable.from(he,Re)}return he}$provideDocumentSemanticTokens(N,G,Y,ie){return this.s(N,V,pe=>pe.provideDocumentSemanticTokens(c.URI.revive(G),Y,ie),null,ie)}$releaseDocumentSemanticTokens(N,G){this.s(N,V,Y=>Y.releaseDocumentSemanticColoring(G),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,G,Y,ie){const pe=this.t(new Z(this.h,Y),N);return this.e.$registerDocumentRangeSemanticTokensProvider(pe,this.o(G,N),ie),this.p(pe)}$provideDocumentRangeSemanticTokens(N,G,Y,ie){return this.s(N,Z,pe=>pe.provideDocumentRangeSemanticTokens(c.URI.revive(G),Y,ie),null,ie)}registerCompletionItemProvider(N,G,Y,ie){const pe=this.t(new q(this.h,this.j.converter,Y,this.m,N),N);return this.e.$registerCompletionsProvider(pe,this.o(G,N),ie,q.supportsResolving(Y),`${N.identifier.value}(${ie.join("")})`),this.p(pe)}$provideCompletionItems(N,G,Y,ie,pe){return this.s(N,q,Ie=>Ie.provideCompletionItems(c.URI.revive(G),Y,ie,pe),void 0,pe)}$resolveCompletionItem(N,G,Y){return this.s(N,q,ie=>ie.resolveCompletionItem(G,Y),void 0,Y)}$releaseCompletionItems(N,G){this.s(N,q,Y=>Y.releaseCompletionItems(G),void 0,void 0)}registerInlineCompletionsProvider(N,G,Y){const ie=new Ee(N,this.h,Y,this.j.converter),pe=this.t(ie,N);return this.e.$registerInlineCompletionsSupport(pe,this.o(G,N),ie.supportsHandleEvents),this.p(pe)}$provideInlineCompletions(N,G,Y,ie,pe){return this.s(N,ae,Ie=>Ie.provideInlineCompletions(c.URI.revive(G),Y,ie,pe),void 0,pe)}$handleInlineCompletionDidShow(N,G,Y,ie){this.s(N,ae,async pe=>{pe.handleDidShowCompletionItem(G,Y,ie)},void 0,void 0)}$handleInlineCompletionPartialAccept(N,G,Y,ie){this.s(N,ae,async pe=>{pe.handlePartialAccept(G,Y,ie)},void 0,void 0)}$freeInlineCompletionsList(N,G){this.s(N,ae,async Y=>{Y.disposeCompletions(G)},void 0,void 0)}registerSignatureHelpProvider(N,G,Y,ie){const pe=Array.isArray(ie)?{triggerCharacters:ie,retriggerCharacters:[]}:ie,Ie=this.t(new be(this.h,Y),N);return this.e.$registerSignatureHelpProvider(Ie,this.o(G,N),pe),this.p(Ie)}$provideSignatureHelp(N,G,Y,ie,pe){return this.s(N,be,Ie=>Ie.provideSignatureHelp(c.URI.revive(G),Y,ie,pe),void 0,pe)}$releaseSignatureHelp(N,G){this.s(N,be,Y=>Y.releaseSignatureHelp(G),void 0,void 0)}registerInlayHintsProvider(N,G,Y){const ie=typeof Y.onDidChangeInlayHints=="function"?this.q():void 0,pe=this.t(new M(this.h,this.j.converter,Y,this.l,N),N);this.e.$registerInlayHintsProvider(pe,this.o(G,N),typeof Y.resolveInlayHint=="function",ie,oe.u(N));let Ie=this.p(pe);if(ie!==void 0){const he=Y.onDidChangeInlayHints(Re=>this.e.$emitInlayHintsEvent(ie));Ie=O.Disposable.from(Ie,he)}return Ie}$provideInlayHints(N,G,Y,ie){return this.s(N,M,pe=>pe.provideInlayHints(c.URI.revive(G),Y,ie),void 0,ie)}$resolveInlayHint(N,G,Y){return this.s(N,M,ie=>ie.resolveInlayHint(G,Y),void 0,Y)}$releaseInlayHints(N,G){this.s(N,M,Y=>Y.releaseHints(G),void 0,void 0)}registerDocumentLinkProvider(N,G,Y){const ie=this.t(new Q(this.h,Y),N);return this.e.$registerDocumentLinkProvider(ie,this.o(G,N),typeof Y.resolveDocumentLink=="function"),this.p(ie)}$provideDocumentLinks(N,G,Y){return this.s(N,Q,ie=>ie.provideLinks(c.URI.revive(G),Y),void 0,Y,G.scheme==="output")}$resolveDocumentLink(N,G,Y){return this.s(N,Q,ie=>ie.resolveLink(G,Y),void 0,void 0,!0)}$releaseDocumentLinks(N,G){this.s(N,Q,Y=>Y.releaseLinks(G),void 0,void 0,!0)}registerColorProvider(N,G,Y){const ie=this.t(new fe(this.h,Y),N);return this.e.$registerDocumentColorProvider(ie,this.o(G,N)),this.p(ie)}$provideDocumentColors(N,G,Y){return this.s(N,fe,ie=>ie.provideColors(c.URI.revive(G),Y),[],Y)}$provideColorPresentations(N,G,Y,ie){return this.s(N,fe,pe=>pe.provideColorPresentations(c.URI.revive(G),Y,ie),void 0,ie)}registerFoldingRangeProvider(N,G,Y){const ie=this.q(),pe=typeof Y.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(ie,new de(new we(this.h,Y),N)),this.e.$registerFoldingRangeProvider(ie,this.o(G,N),N.identifier,pe);let Ie=this.p(ie);if(pe!==void 0){const he=Y.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(pe));Ie=O.Disposable.from(Ie,he)}return Ie}$provideFoldingRanges(N,G,Y,ie){return this.s(N,we,pe=>pe.provideFoldingRanges(c.URI.revive(G),Y,ie),void 0,ie)}registerSelectionRangeProvider(N,G,Y){const ie=this.t(new _(this.h,Y,this.l),N);return this.e.$registerSelectionRangeProvider(ie,this.o(G,N)),this.p(ie)}$provideSelectionRanges(N,G,Y,ie){return this.s(N,_,pe=>pe.provideSelectionRanges(c.URI.revive(G),Y,ie),[],ie)}registerCallHierarchyProvider(N,G,Y){const ie=this.t(new ne(this.h,Y),N);return this.e.$registerCallHierarchyProvider(ie,this.o(G,N)),this.p(ie)}$prepareCallHierarchy(N,G,Y,ie){return this.s(N,ne,pe=>Promise.resolve(pe.prepareSession(c.URI.revive(G),Y,ie)),void 0,ie)}$provideCallHierarchyIncomingCalls(N,G,Y,ie){return this.s(N,ne,pe=>pe.provideCallsTo(G,Y,ie),void 0,ie)}$provideCallHierarchyOutgoingCalls(N,G,Y,ie){return this.s(N,ne,pe=>pe.provideCallsFrom(G,Y,ie),void 0,ie)}$releaseCallHierarchy(N,G){this.s(N,ne,Y=>Promise.resolve(Y.releaseSession(G)),void 0,void 0)}registerTypeHierarchyProvider(N,G,Y){const ie=this.t(new le(this.h,Y),N);return this.e.$registerTypeHierarchyProvider(ie,this.o(G,N)),this.p(ie)}$prepareTypeHierarchy(N,G,Y,ie){return this.s(N,le,pe=>Promise.resolve(pe.prepareSession(c.URI.revive(G),Y,ie)),void 0,ie)}$provideTypeHierarchySupertypes(N,G,Y,ie){return this.s(N,le,pe=>pe.provideSupertypes(G,Y,ie),void 0,ie)}$provideTypeHierarchySubtypes(N,G,Y,ie){return this.s(N,le,pe=>pe.provideSubtypes(G,Y,ie),void 0,ie)}$releaseTypeHierarchy(N,G){this.s(N,le,Y=>Promise.resolve(Y.releaseSession(G)),void 0,void 0)}registerDocumentOnDropEditProvider(N,G,Y,ie){const pe=this.q();return this.f.set(pe,new de(new te(this.e,this.h,Y,pe,N),N)),this.e.$registerDocumentOnDropEditProvider(pe,this.o(G,N),(0,p.isProposedApiEnabled)(N,"dropMetadata")?ie:void 0),this.p(pe)}$provideDocumentOnDropEdits(N,G,Y,ie,pe,Ie){return this.s(N,te,he=>Promise.resolve(he.provideDocumentOnDropEdits(G,c.URI.revive(Y),ie,pe,Ie)),void 0,void 0)}registerDocumentPasteEditProvider(N,G,Y,ie){const pe=this.q();return this.f.set(pe,new de(new W(this.e,this.h,Y,pe,N),N)),this.e.$registerPasteEditProvider(pe,this.o(G,N),{supportsCopy:!!Y.prepareDocumentPaste,supportsPaste:!!Y.provideDocumentPasteEdits,copyMimeTypes:ie.copyMimeTypes,pasteMimeTypes:ie.pasteMimeTypes}),this.p(pe)}$prepareDocumentPaste(N,G,Y,ie,pe){return this.s(N,W,Ie=>Ie.prepareDocumentPaste(c.URI.revive(G),Y,ie,pe),void 0,pe)}$providePasteEdits(N,G,Y,ie,pe,Ie){return this.s(N,W,he=>he.providePasteEdits(G,c.URI.revive(Y),ie,pe,Ie),void 0,Ie)}static w(N){return{pattern:N.source,flags:(0,y.regExpFlags)(N)}}static y(N){return{decreaseIndentPattern:oe.w(N.decreaseIndentPattern),increaseIndentPattern:oe.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?oe.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?oe.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:oe.w(N.beforeText),afterText:N.afterText?oe.w(N.afterText):void 0,previousLineText:N.previousLineText?oe.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(oe.z)}setLanguageConfiguration(N,G,Y){const{wordPattern:ie}=Y;if(ie&&(0,y.regExpLeadsToEndlessLoop)(ie))throw new Error(`Invalid language configuration: wordPattern '${ie}' is not allowed to match the empty string.`);ie?this.h.setWordDefinitionFor(G,ie):this.h.setWordDefinitionFor(G,void 0),Y.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),Y.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const pe=this.q(),Ie={comments:Y.comments,brackets:Y.brackets,wordPattern:Y.wordPattern?oe.w(Y.wordPattern):void 0,indentationRules:Y.indentationRules?oe.y(Y.indentationRules):void 0,onEnterRules:Y.onEnterRules?oe.B(Y.onEnterRules):void 0,__electricCharacterSupport:Y.__electricCharacterSupport,__characterPairSupport:Y.__characterPairSupport};return this.e.$setLanguageConfiguration(pe,G,Ie),this.p(pe)}$setWordDefinitions(N){for(const G of N)this.h.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=oe,oe.d=0}),define(Ce[291],De([1,0,6,13,7,41,16,4]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(T,P,m,D){this.c=P,this.d=m,this.e=D,this.b=[],this.f=0,this.g=new Set,this.a=T.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(T){this.b=T}async getLanguages(){return this.b.slice(0)}async changeLanguage(T,P){await this.a.$changeLanguage(T,P);const m=this.c.getDocumentData(T);if(!m)throw new Error(`document '${T.toString()}' NOT found`);return m.document}async tokenAtPosition(T,P){const m=T.version,D=R.Position.from(P),C=await this.a.$tokensAtPosition(T.uri,D),b={type:u.StandardTokenType.Other,range:T.getWordRangeAtPosition(P)??new u.Range(P.line,P.character,P.line,P.character)};if(!C)return b;const n={range:R.Range.to(C.range),type:R.TokenType.to(C.type)};return!n.range.contains(P)||m!==T.version?b:n}createLanguageStatusItem(T,P,m){const D=this.f++,C=this.a,b=this.g,n=`${T.identifier.value}/${P}`;if(b.has(n))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);b.add(n);const h={selector:m,id:P,name:T.displayName??T.name,severity:u.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let d;const S=new A.DisposableStore,w=()=>{d?.dispose(),d=(0,L.disposableTimeout)(()=>{S.clear(),this.a.$setLanguageStatus(D,{id:n,name:h.name??T.displayName??T.name,source:T.displayName??T.name,selector:R.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===u.LanguageStatusSeverity.Error?O.default.Error:h.severity===u.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:h.command&&this.d.toInternal(h.command,S),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},p={dispose(){S.dispose(),d?.dispose(),C.$removeLanguageStatus(D),b.delete(n)},get id(){return h.id},get name(){return h.name},set name(t){h.name=t,w()},get selector(){return h.selector},set selector(t){h.selector=t,w()},get text(){return h.text},set text(t){h.text=t,w()},get detail(){return h.detail},set detail(t){h.detail=t,w()},get severity(){return h.severity},set severity(t){h.severity=t,w()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(t){h.accessibilityInformation=t,w()},get command(){return h.command},set command(t){h.command=t,w()},get busy(){return h.busy},set busy(t){h.busy=t,w()}};return w(),p}}e.ExtHostLanguages=y}),define(Ce[105],De([1,0,9,11,2,5,17,6,27,20]),function(re,e,c,R,u,O,L,A,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let T=e.ExtHostLocalizationService=class{constructor(m,D,C){this.f=C,this.d=new Map,this.a=D.getProxy(A.MainContext.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===c.LANGUAGE_DEFAULT}getMessage(m,D){const{message:C,args:b,comment:n}=D;if(this.c)return(0,R.format2)(C,b??{});let h=C;n&&n.length>0&&(h+=`/${Array.isArray(n)?n.join(""):n}`);const d=this.d.get(m)?.contents[h];return d||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,R.format2)(d??C,b??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let D;const C=await this.g(m);if(!C){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const b=await this.a.$fetchBundleContents(C),n=JSON.parse(b);D=m.isBuiltin?n.contents?.bundle:n}catch(b){this.f.error(`Failed to load translations for ${m.identifier.value} from ${C}: ${b.message}`);return}D&&this.d.set(m.identifier.value,{contents:D,uri:C})}async g(m){if(m.isBuiltin){const D=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return u.URI.revive(D)}return m.l10n?u.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.ExtHostLocalizationService=T=qe([je(0,y.IExtHostInitDataService),je(1,g.IExtHostRpcService),je(2,L.ILogService)],T),e.IExtHostLocalizationService=(0,O.createDecorator)("IExtHostLocalizationService")}),define(Ce[144],De([1,0,17,6,27,20,2,73]),function(re,e,c,R,u,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=e.ExtHostLoggerService=class extends c.AbstractLoggerService{constructor(P,m){super(m.logLevel,m.logsLocation,m.loggers.map(D=>(0,A.revive)(D))),this.n=P.getProxy(R.MainContext.MainThreadLogger)}$setLogLevel(P,m){m?this.setLogLevel(L.URI.revive(m),P):this.setLogLevel(P)}setVisibility(P,m){super.setVisibility(P,m),this.n.$setVisibility(P,m)}m(P,m,D){return new g(this.n,P,m,D)}};e.ExtHostLoggerService=y=qe([je(0,O.IExtHostRpcService),je(1,u.IExtHostInitDataService)],y);class g extends c.AbstractMessageLogger{constructor(P,m,D,C){super(C?.logLevel==="always"),this.m=P,this.n=m,this.k=!1,this.l=[],this.setLevel(D),this.m.$createLogger(m,C).then(()=>{this.r(this.l),this.k=!0})}g(P,m){const D=[[P,m]];this.k?this.r(D):this.l.push(...D)}r(P){this.m.$log(this.n,P)}flush(){this.m.$flush(this.n)}}}),define(Ce[106],De([1,0,6,5,4,20,22]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostManagedSockets=e.IExtHostManagedSockets=void 0,e.IExtHostManagedSockets=(0,R.createDecorator)("IExtHostManagedSockets");let A=e.ExtHostManagedSockets=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(c.MainContext.MainThreadManagedSockets)}setFactory(P,m){for(const D of this.d.values())D.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new y(P,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const m=++this.b,D=await this.c.makeConnection(),C=new u.DisposableStore;return this.d.set(m,new g(m,D,C)),C.add((0,u.toDisposable)(()=>this.d.delete(m))),C.add(D.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),C.dispose()})),C.add(D.onDidClose(b=>{this.a.$onDidManagedSocketClose(m,b?.stack??b?.message),C.dispose()})),C.add(D.onDidReceiveMessage(b=>this.a.$onDidManagedSocketHaveData(m,L.VSBuffer.wrap(b)))),m}$remoteSocketWrite(P,m){this.d.get(P)?.actual.send(m.buffer)}$remoteSocketEnd(P){const m=this.d.get(P);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.ExtHostManagedSockets=A=qe([je(0,O.IExtHostRpcService)],A);class y{constructor(P,m){this.socketFactoryId=P,this.makeConnection=m}}class g extends u.Disposable{constructor(P,m,D){super(),this.socketId=P,this.actual=m,this.B(D)}}}),define(Ce[292],De([1,0,6,17,25]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function O(A){return A&&A.title}let L=e.ExtHostMessageService=class{constructor(y,g){this.b=g,this.a=y.getProxy(c.MainContext.MainThreadMessageService)}showMessage(y,g,T,P,m){const D={source:{identifier:y.identifier,label:y.displayName||y.name}};let C;typeof P=="string"||O(P)?C=[P,...m]:(D.modal=P?.modal,D.useCustom=P?.useCustom,D.detail=P?.detail,C=m),D.useCustom&&(0,u.checkProposedApiEnabled)(y,"resolvers");const b=[];for(let n=0;n<C.length;n++){const h=C[n];if(typeof h=="string")b.push({title:h,handle:n,isCloseAffordance:!1});else if(typeof h=="object"){const{title:d,isCloseAffordance:S}=h;b.push({title:d,isCloseAffordance:!!S,handle:n})}else this.b.warn("Invalid message item:",h)}return this.a.$showMessage(g,T,D,b).then(n=>{if(typeof n=="number")return C[n]})}};e.ExtHostMessageService=L=qe([je(1,R.ILogService)],L)}),define(Ce[293],De([1,0,22,3,4,28,11,12,2,80,6,37,13,7,61,263,140,8]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class d{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(w=>w.apiEditor)}constructor(w,p,t,a){this.q=t,this.r=a,this.f=new Map,this.g=new O.ResourceMap,this.h=new Map,this.j=new R.Emitter({onListenerError:h.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.Emitter({onListenerError:h.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this.m.event,this.n=new R.Emitter({onListenerError:h.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this.n.event,this.o=new R.Emitter({onListenerError:h.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new g.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=w.getProxy(T.MainContext.MainThreadNotebook),this.c=w.getProxy(T.MainContext.MainThreadNotebookDocuments),this.d=w.getProxy(T.MainContext.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const o=r.notebookEditor?.notebookUri,f=r.cell.handle,l=this.g.get(o)?.getCell(f);if(l)return l.apiCell}if(r&&r.$mid===14){const o=r.uri,f=this.g.get(o);if(f)return f.apiNotebook}return r}}),d.x(p)}getEditorById(w){const p=this.h.get(w);if(!p)throw new Error(`unknown text editor: ${w}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(w){for(const[p,t]of this.h)if(t.apiEditor===w)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(w,p){const t=this.g.get(w);if(!t&&!p)throw new Error(`NO notebook document for '${w}'`);return t}static s(w,p){if(!p)return;const t=p.filenamePattern.map(a=>m.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(p.filenamePattern&&!t){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:p.displayName,filenamePattern:t,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,p,t){const a=d.a++,r=typeof t.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(a,t),this.b.$registerNotebookCellStatusBarItemProvider(a,r,p);let o;return r!==void 0&&(o=t.onDidChangeCellStatusBarItems(f=>this.b.$emitCellStatusBarEvent(r))),new D.Disposable(()=>{this.f.delete(a),this.b.$unregisterNotebookCellStatusBarItemProvider(a,r),o?.dispose()})}async createNotebookDocument(w){const p=await this.c.$tryCreateNotebook({viewType:w.viewType,content:w.content&&m.NotebookData.from(w.content)});return y.URI.revive(p)}async openNotebookDocument(w){const p=this.g.get(w);if(p)return p.apiNotebook;const t=await this.c.$tryOpenNotebook(w),a=this.g.get(y.URI.revive(t));return(0,A.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(w,p){y.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let t;typeof p=="object"?t={position:m.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(m.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:t={preserveFocus:!1};const a=await this.d.$tryShowNotebookDocument(w.uri,w.notebookType,t),r=a&&this.h.get(a)?.apiEditor;if(r)return r;throw a?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,p,t,a){const r=this.f.get(w),o=y.URI.revive(p),f=this.g.get(o);if(!f||!r)return;const v=f.getCellFromIndex(t);if(!v)return;const l=await r.provideCellStatusBarItems(v.apiCell,a);if(!l)return;const I=new u.DisposableStore,E=this.p.add([I]),i=(Array.isArray(l)?l:[l]).map(k=>m.NotebookStatusBarItem.from(k,this.i,I));return{cacheId:E,items:i}}$releaseNotebookCellStatusBarItems(w){this.p.delete(w)}registerNotebookSerializer(w,p,t,a,r){if((0,L.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const o=this.t++;return this.u.set(o,t),this.b.$registerNotebookSerializer(o,{id:w.identifier,location:w.extensionLocation},p,m.NotebookDocumentContentOptions.from(a),d.s(w,r)),(0,u.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(o)})}async $dataToNotebook(w,p,t){const a=this.u.get(w);if(!a)throw new Error("NO serializer found");const r=await a.deserializeNotebook(p.buffer,t);return new C.SerializableObjectWithBuffers(m.NotebookData.from(r))}async $notebookToData(w,p,t){const a=this.u.get(w);if(!a)throw new Error("NO serializer found");const r=await a.serializeNotebook(m.NotebookData.to(p.value),t);return c.VSBuffer.wrap(r)}w(w,p,t){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const a=new n.ExtHostNotebookEditor(p,this.d,w,t.visibleRanges.map(m.NotebookRange.to),t.selections.map(m.NotebookRange.to),typeof t.viewColumn=="number"?m.ViewColumn.to(t.viewColumn):void 0);this.h.set(p,a)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const t of w.value.removedDocuments){const a=y.URI.revive(t),r=this.g.get(a);r&&(r.dispose(),this.g.delete(a),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(o=>o.document.uri)}),this.n.fire(r.apiNotebook));for(const o of this.h.values())o.notebookData.uri.toString()===a.toString()&&this.h.delete(o.id)}if(w.value.addedDocuments){const t=[];for(const a of w.value.addedDocuments){const r=y.URI.revive(a.uri);if(this.g.has(r))throw new Error(`adding EXISTING notebook ${r} `);const o=new b.ExtHostNotebookDocument(this.c,this.q,this.r,r,a);t.push(...a.cells.map(f=>b.ExtHostCell.asModelAddData(o.apiNotebook,f))),this.g.get(r)?.dispose(),this.g.set(r,o),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:t}),this.m.fire(o.apiNotebook)}}if(w.value.addedEditors)for(const t of w.value.addedEditors){if(this.h.has(t.id))return;const a=y.URI.revive(t.documentUri),r=this.g.get(a);r&&this.w(r,t.id,t)}const p=[];if(w.value.removedEditors)for(const t of w.value.removedEditors){const a=this.h.get(t);a&&(this.h.delete(t),this.k?.id===a.id&&(this.k=void 0),p.push(a))}if(w.value.visibleEditors){this.l=w.value.visibleEditors.map(a=>this.h.get(a)).filter(a=>!!a);const t=new Set;this.l.forEach(a=>t.add(a.id));for(const a of this.h.values()){const r=t.has(a.id);a._acceptVisibility(r)}this.l=[...this.h.values()].map(a=>a).filter(a=>a.visible),this.o.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this.k=void 0:w.value.newActiveEditor&&(this.h.get(w.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${w.value.newActiveEditor}`),this.k=this.h.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(w){const p=P.ApiCommandArgument.String.with("notebookType","A notebook type"),t=new P.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new P.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>c.VSBuffer.wrap(r))],new P.ApiCommandResult("Notebook Data",r=>m.NotebookData.to(r.value))),a=new P.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new P.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new C.SerializableObjectWithBuffers(m.NotebookData.from(r)))],new P.ApiCommandResult("Bytes",r=>r.buffer));w.registerApiCommand(t),w.registerApiCommand(a)}}e.ExtHostNotebookController=d,d.a=0}),define(Ce[294],De([1,0,19,16,21,3,4,28,2,26,17,80,6,37,13,7,103,253,25,61]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let w=e.ExtHostNotebookKernels=class{constructor(l,I,E,s,i){this.m=I,this.n=E,this.o=s,this.q=i,this.b=new A.ResourceMap,this.c=new A.ResourceMap,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new P.Cache("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new O.Emitter,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=l.getProxy(m.MainContext.MainThreadNotebookKernels);const k=new D.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new D.ApiCommandArgument("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const $=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:$}}else if(F&&"notebookEditor"in F){const $=this.n.getIdByEditor(F.notebookEditor);if($===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:$}}return F})],D.ApiCommandResult.Void);this.o.registerApiCommand(k)}createNotebookController(l,I,E,s,i,k){for(const Ee of this.j.values())if(Ee.controller.id===I&&g.ExtensionIdentifier.equals(l.identifier,Ee.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const F=this.k++,$=this;this.q.trace(`NotebookController[${F}], CREATED by ${l.identifier.value}, ${I}`);const j=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${l.identifier}'`);let W=!1;const U=new L.DisposableStore,x=new O.Emitter,B=new O.Emitter,z={id:f(l.identifier,I),notebookType:E,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:s||l.identifier.value,preloads:k?k.map(C.NotebookRendererScript.from):[]};let ee=i??j,se;this.a.$addKernel(F,z).catch(Ee=>{console.log(Ee),W=!0});let V=0;const Z=()=>{if(W)return;const Ee=++V;Promise.resolve().then(()=>{Ee===V&&this.a.$updateKernel(F,z)})},q=new A.ResourceMap,ae={get id(){return I},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return z.label},set label(Ee){z.label=Ee??l.displayName??l.name,Z()},get detail(){return z.detail??""},set detail(Ee){z.detail=Ee,Z()},get description(){return z.description??""},set description(Ee){z.description=Ee,Z()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(Ee){z.supportedLanguages=Ee,Z()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(Ee){z.supportsExecutionOrder=Ee,Z()},get rendererScripts(){return z.preloads?z.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return ee},set executeHandler(Ee){ee=Ee??j},get interruptHandler(){return se},set interruptHandler(Ee){se=Ee,z.supportsInterrupt=!!Ee,Z()},createNotebookCellExecution(Ee){if(W)throw new Error("notebook controller is DISPOSED");if(!q.has(Ee.notebook.uri))throw $.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(q.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ee.notebook.uri.toString()}`);return $._createNotebookCellExecution(Ee,f(l.identifier,this.id))},createNotebookExecution(Ee){if((0,d.checkProposedApiEnabled)(l,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!q.has(Ee.uri))throw $.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(q.keys()).map(ye=>ye.toString())),new Error(`notebook controller is NOT associated to notebook: ${Ee.uri.toString()}`);return $._createNotebookExecution(Ee,f(l.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${F}], DISPOSED`),W=!0,this.j.delete(F),U.dispose(),x.dispose(),B.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(Ee,ye){ye===b.NotebookControllerAffinity2.Hidden&&(0,d.checkProposedApiEnabled)(l,"notebookControllerAffinityHidden"),$.a.$updateNotebookPriority(F,Ee.uri,ye)},onDidReceiveMessage:B.event,postMessage(Ee,ye){return(0,d.checkProposedApiEnabled)(l,"notebookMessaging"),$.a.$postMessage(F,ye&&$.n.getIdByEditor(ye),Ee)},asWebviewUri(Ee){return(0,d.checkProposedApiEnabled)(l,"notebookMessaging"),(0,n.asWebviewUri)(Ee,$.m.remote)}};return this.j.set(F,{extensionId:l.identifier,controller:ae,onDidReceiveMessage:B,onDidChangeSelection:x,associatedNotebooks:q}),ae}getIdByController(l){for(const[I,E]of this.j)if(E.controller===l)return f(E.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,I){const E=this.f++,s=this;this.q.trace(`NotebookControllerDetectionTask[${E}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(E,I);const i={dispose:()=>{this.e.delete(E),s.a.$removeKernelDetectionTask(E)}};return this.e.set(E,i),i}registerKernelSourceActionProvider(l,I,E){const s=this.h++,i=typeof E.onDidChangeNotebookKernelSourceActions=="function"?s:void 0,k=this;this.g.set(s,E),this.q.trace(`NotebookKernelSourceActionProvider[${s}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(s,s,I);let F;return i!==void 0&&(F=E.onDidChangeNotebookKernelSourceActions($=>this.a.$emitNotebookKernelSourceActionsChangeEvent(i))),{dispose:()=>{this.g.delete(s),k.a.$removeKernelSourceActionProvider(s,s),F?.dispose()}}}async $provideKernelSourceActions(l,I){const E=this.g.get(l);if(E){const s=new L.DisposableStore;return this.i.add([s]),(await E.provideNotebookKernelSourceActions(I)??[]).map(k=>C.NotebookKernelSourceAction.from(k,this.o.converter,s))}return[]}$acceptNotebookAssociation(l,I,E){const s=this.j.get(l);if(s){const i=this.n.getNotebookDocument(y.URI.revive(I));E?s.associatedNotebooks.set(i.uri,!0):s.associatedNotebooks.delete(i.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,i.uri.toString(),E),s.onDidChangeSelection.fire({selected:E,notebook:i.apiNotebook})}}async $executeCells(l,I,E){const s=this.j.get(l);if(!s)return;const i=this.n.getNotebookDocument(y.URI.revive(I)),k=[];for(const F of E){const $=i.getCell(F);$&&k.push($.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,i.uri.toString(),k.length),await s.controller.executeHandler.call(s.controller,k,i.apiNotebook,s.controller)}catch(F){this.q.error(`NotebookController[${l}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(l,I,E){const s=this.j.get(l);if(!s)return;const i=this.n.getNotebookDocument(y.URI.revive(I));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,i.apiNotebook);else for(const k of E){const F=i.getCell(k);F&&this.b.get(F.uri)?.cancel()}if(s.controller.interruptHandler){const k=this.c.get(i.uri);E.length&&Array.isArray(k)&&k.length&&k.forEach(F=>F.dispose())}}$acceptKernelMessageFromRenderer(l,I,E){const s=this.j.get(l);if(!s)return;const i=this.n.getEditorById(I);s.onDidReceiveMessage.fire(Object.freeze({editor:i.apiEditor,message:E}))}$cellExecutionChanged(l,I,E){const i=this.n.getNotebookDocument(y.URI.revive(l)).getCell(I);if(i){const k=E?C.NotebookCellExecutionState.to(E):b.NotebookCellExecutionState.Idle;k!==void 0&&this.l.fire({cell:i.apiCell,state:k})}}_createNotebookCellExecution(l,I){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!s)throw new Error("invalid cell");if(this.b.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const i=new t(I,s,this.a);this.b.set(s.uri,i);const k=i.onDidChangeState(()=>{i.state===p.Resolved&&(i.dispose(),k.dispose(),this.b.delete(s.uri))});return i.asApiObject()}_createNotebookExecution(l,I){const E=this.n.getNotebookDocument(l.uri),s=l.getCells().find(F=>{const $=E.getCellFromApiCell(F);return $&&this.b.has($.uri)});if(s)throw new Error(`duplicate cell execution for ${s.document.uri}`);if(this.c.has(E.uri))throw new Error(`duplicate notebook execution for ${E.uri}`);const i=new r(I,E,this.a),k=i.onDidChangeState(()=>{i.state===a.Resolved&&(i.dispose(),k.dispose(),this.c.delete(E.uri))});return this.c.set(E.uri,[i,k]),i.asApiObject()}};e.ExtHostNotebookKernels=w=qe([je(4,T.ILogService)],w);var p;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(p||(p={}));class t extends L.Disposable{get state(){return this.f}constructor(l,I,E){super(),this.j=I,this.k=E,this.b=t.a++,this.c=new O.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new u.CancellationTokenSource),this.h=new o(10,s=>this.m(s)),this.i=I.internalMetadata.executionOrder,this.k.$createExecution(this.b,l,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(l){await this.h.addItem(l)}async m(l){const I=Array.isArray(l)?l:[l];return this.k.$updateExecution(this.b,new S.SerializableObjectWithBuffers(I))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(l){let I=this.j;if(l&&(I=this.j.notebook.getCellFromApiCell(l)),!I)throw new Error("INVALID cell");return I.handle}s(l){return l.map(I=>{const E=b.NotebookCellOutput.ensureUniqueMimeTypes(I.items,!0);return E===I.items?C.NotebookCellOutput.from(I):C.NotebookCellOutput.from({items:E,id:I.id,metadata:I.metadata})})}async t(l,I,E){const s=this.r(I),i=this.s((0,c.asArray)(l));return this.l({editType:h.CellExecutionUpdateType.Output,cellHandle:s,append:E,outputs:i})}async w(l,I,E){return l=b.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(l),!0),this.l({editType:h.CellExecutionUpdateType.OutputItems,items:l.map(C.NotebookCellOutputItem.from),outputId:I.id,append:E})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.j.apiCell},get executionOrder(){return l.i},set executionOrder(E){l.i=E,l.m([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:l.i}])},start(E){if(l.f===p.Resolved||l.f===p.Started)throw new Error("Cannot call start again");l.f=p.Started,l.c.fire(),l.m({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:E})},end(E,s){if(l.f===p.Resolved)throw new Error("Cannot call resolve twice");l.f=p.Resolved,l.c.fire(),l.h.flush(),l.k.$completeExecution(l.b,new S.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:E}))},clearOutput(E){return l.n(),l.t([],E,!1)},appendOutput(E,s){return l.n(),l.t(E,s,!0)},replaceOutput(E,s){return l.n(),l.t(E,s,!1)},appendOutputItems(E,s){return l.n(),l.w(E,s,!0)},replaceOutputItems(E,s){return l.n(),l.w(E,s,!1)}})}}t.a=0;var a;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(a||(a={}));class r extends L.Disposable{get state(){return this.f}constructor(l,I,E){super(),this.h=I,this.i=E,this.b=r.a++,this.c=new O.Emitter,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new u.CancellationTokenSource),this.i.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===a.Resolved||this.f===a.Started)throw new Error("Cannot call start again");this.f=a.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===a.Resolved)throw new Error("Cannot call resolve twice");this.f=a.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}r.a=0;class o{constructor(l,I){this.e=l,this.f=I,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new R.DeferredPromise,this.b=Date.now(),(0,R.timeout)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>l.complete())}}function f(v,l){return`${v.value}/${l}`}e.createKernelId=f}),define(Ce[295],De([1,0,3,6,140]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class O{constructor(A,y){this.c=y,this.a=new Map,this.b=A.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,g){const T=this.c.getEditorById(A);this.a.get(y)?.fire({editor:T.apiEditor,message:g})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(T=>T.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(T,P,m)=>this.d(y).event(T,P,m),postMessage:(T,P)=>{u.ExtHostNotebookEditor.apiEditorsToExtHost.has(T)&&([T,P]=[P,T]);const m=P&&u.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.b.$postMessage(m?.id,y,T)}}}d(A){let y=this.a.get(A);return y||(y=new c.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(A)}}),this.a.set(A,y),y)}}e.ExtHostNotebookRenderers=O}),define(Ce[296],De([1,0,4,12,2,25,6]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(g){this.b=new Map,this.a=g.getProxy(L.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,T,P){if((0,O.checkProposedApiEnabled)(g,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,P),this.a.$registerProfileContentHandler(T,P.name,P.description,g.identifier.value),(0,c.toDisposable)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(g,T,P,m){const D=this.b.get(g);if(!D)throw new Error(`Unknown handler with id: ${g}`);return D.saveProfile(T,P,m)}async $readProfile(g,T,P){const m=this.b.get(g);if(!m)throw new Error(`Unknown handler with id: ${g}`);return m.readProfile((0,R.isString)(T)?T:u.URI.revive(T),P)}}e.ExtHostProfileContentHandlers=A}),define(Ce[297],De([1,0,2,6,16,13]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class L{constructor(y,g){this.d=g,this.c=new Map,this.b=y.getProxy(R.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,g,T){const P=c.URI.revive(g),m=this.c.get(y);return m?(0,u.asPromise)(()=>m.provideOriginalResource(P,T)).then(D=>D||null):Promise.resolve(null)}registerQuickDiffProvider(y,g,T,P){const m=L.a++;return this.c.set(m,g),this.b.$registerQuickDiffProvider(m,O.DocumentSelector.from(y,this.d),T,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.ExtHostQuickDiff=L,L.a=0}),define(Ce[298],De([1,0,21,3,4,6,2,7,8,19,41,55,25,13]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function C(b,n,h){const d=b.getProxy(O.MainContext.MainThreadQuickOpen);class S{constructor(l,I){this.e=new Map,this.f=0,this.a=l,this.b=I}showQuickPick(l,I,E,s=c.CancellationToken.None){this.c=void 0;const i=Promise.resolve(I),k=++this.f,F=d.$show(k,{title:E?.title,placeHolder:E?.placeHolder,matchOnDescription:E?.matchOnDescription,matchOnDetail:E?.matchOnDetail,ignoreFocusLost:E?.ignoreFocusOut,canPickMany:E?.canPickMany},s),$={},j=F.then(()=>$);return Promise.race([j,i]).then(W=>{if(W===$)return;const U=(0,m.isProposedApiEnabled)(l,"quickPickItemTooltip");return i.then(x=>{const B=[];for(let z=0;z<x.length;z++){const ee=x[z];typeof ee=="string"?B.push({label:ee,handle:z}):ee.kind===A.QuickPickItemKind.Separator?B.push({type:"separator",label:ee.label}):(ee.tooltip&&!U&&console.warn(`Extension '${l.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`),B.push({label:ee.label,description:ee.description,detail:ee.detail,picked:ee.picked,alwaysShow:ee.alwaysShow,tooltip:U?D.MarkdownString.fromStrict(ee.tooltip):void 0,handle:z}))}return E&&typeof E.onDidSelectItem=="function"&&(this.c=z=>{E.onDidSelectItem(x[z])}),d.$setItems(k,B),F.then(z=>{if(typeof z=="number")return x[z];if(Array.isArray(z))return z.map(ee=>x[ee])})})}).then(void 0,W=>{if(!(0,y.isCancellationError)(W))return d.$setError(k,W),Promise.reject(W)})}$onItemSelected(l){this.c?.(l)}showInput(l,I=c.CancellationToken.None){return this.d=l?.validateInput,d.$input(l,typeof this.d=="function",I).then(void 0,E=>{if(!(0,y.isCancellationError)(E))return Promise.reject(E)})}async $validateInput(l){if(!this.d)return;const I=await this.d(l);if(!I||typeof I=="string")return I;let E;switch(I.severity){case A.InputBoxValidationSeverity.Info:E=T.default.Info;break;case A.InputBoxValidationSeverity.Warning:E=T.default.Warning;break;case A.InputBoxValidationSeverity.Error:E=T.default.Error;break;default:E=I.message?T.default.Error:T.default.Ignore;break}return{content:I.message,severity:E}}async showWorkspaceFolderPick(l,I=c.CancellationToken.None){const E=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!E)return;const s=await this.a.getWorkspaceFolders2();if(s)return s.find(i=>i.uri.toString()===E.uri.toString())}createQuickPick(l){const I=new o(l,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(l){const I=new f(l,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(l,I){this.e.get(l)?._fireDidChangeValue(I)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,I){const E=this.e.get(l);E instanceof o&&E._fireDidChangeActive(I)}$onDidChangeSelection(l,I){const E=this.e.get(l);E instanceof o&&E._fireDidChangeSelection(I)}$onDidTriggerButton(l,I){this.e.get(l)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(l,I,E){const s=this.e.get(l);s instanceof o&&s._fireDidTriggerItemButton(I,E)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class w{constructor(l,I){this.x=l,this.y=I,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new R.Emitter,this.q=new R.Emitter,this.r=new R.Emitter,this.s=new R.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((I,E)=>{const s=I===A.QuickInputButtons.Back?-1:E;this.o.set(s,I)}),this.z({buttons:l.map((I,E)=>({...r(I),tooltip:I.tooltip,handle:I===A.QuickInputButtons.Back?-1:E}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const I=this.o.get(l);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,u.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),d.$dispose(this._id))}z(l){if(!this.v){for(const I of Object.keys(l)){const E=l[I];this.u[I]=E===void 0?null:E}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){d.$createOrUpdate(this.u),this.u={id:this._id}}}w.a=1;function p(v){if(v instanceof A.ThemeIcon)return{id:v.id};const l=a(v),I=t(v);return{dark:typeof l=="string"?L.URI.file(l):l,light:typeof I=="string"?L.URI.file(I):I}}function t(v){return typeof v=="object"&&"light"in v?v.light:v}function a(v){return typeof v=="object"&&"dark"in v?v.dark:v}function r(v){const l=p(v.iconPath);let I,E;return"id"in l?E=P.ThemeIcon.asClassName(l):I=l,{iconPath:I,iconClass:E}}class o extends w{constructor(l,I){super(l.identifier,I),this.O=l,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new R.Emitter,this.L=[],this.M=new R.Emitter,this.N=new R.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((s,i)=>{this.C.set(i,s),this.D.set(s,i)});const I=(0,m.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),E=[];for(let s=0;s<l.length;s++){const i=l[s];i.kind===A.QuickPickItemKind.Separator?E.push({type:"separator",label:i.label}):(i.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),E.push({handle:s,label:i.label,description:i.description,detail:i.detail,picked:i.picked,alwaysShow:i.alwaysShow,tooltip:I?D.MarkdownString.fromStrict(i.tooltip):void 0,buttons:i.buttons?.map((k,F)=>({...r(k),tooltip:k.tooltip,handle:F}))}))}this.z({items:E})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(l){const I=(0,g.coalesce)(l.map(E=>this.C.get(E)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(l){const I=(0,g.coalesce)(l.map(E=>this.C.get(E)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(l,I){const E=this.C.get(l);if(!E||!E.buttons||!E.buttons.length)return;const s=E.buttons[I];s&&this.N.fire({button:s,item:E})}}class f extends w{constructor(l,I){super(l.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:T.default.Error}):this.z({validationMessage:l.message,severity:l.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new S(n,h)}e.createExtHostQuickOpen=C});var Ne=this&&this.__classPrivateFieldGet||function(re,e,c,R){if(c==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?R:c==="a"?R.call(re):R?R.value:e.get(re)},Ze=this&&this.__classPrivateFieldSet||function(re,e,c,R,u){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c};define(Ce[299],De([1,0,2,3,66,4,16,6,19,112,17,26,55,13,25,18]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b){"use strict";var n,h,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function S(s){if(s)return typeof s.iconPath=="string"?c.URI.file(s.iconPath):c.URI.isUri(s.iconPath)||m.ThemeIcon.isThemeIcon(s.iconPath)?s.iconPath:void 0}function w(s,i){if(!s.iconPath&&!i.iconPath)return 0;if(s.iconPath){if(!i.iconPath)return 1}else return-1;const k=typeof s.iconPath=="string"?s.iconPath:c.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id,F=typeof i.iconPath=="string"?i.iconPath:c.URI.isUri(i.iconPath)?i.iconPath.fsPath:i.iconPath.id;return(0,g.comparePaths)(k,F)}function p(s,i){let k=0;if(s.strikeThrough!==i.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==i.faded)return s.faded?1:-1;if(s.tooltip!==i.tooltip)return(s.tooltip||"").localeCompare(i.tooltip||"");if(k=w(s,i),k!==0)return k;if(s.light&&i.light)k=w(s.light,i.light);else{if(s.light)return 1;if(i.light)return-1}if(k!==0)return k;if(s.dark&&i.dark)k=w(s.dark,i.dark);else{if(s.dark)return 1;if(i.dark)return-1}return k}function t(s,i){if(s.command!==i.command)return s.command<i.command?-1:1;if(s.title!==i.title)return s.title<i.title?-1:1;if(s.tooltip!==i.tooltip){if(s.tooltip!==void 0&&i.tooltip!==void 0)return s.tooltip<i.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(i.tooltip!==void 0)return-1}if(s.arguments===i.arguments)return 0;if(s.arguments)if(i.arguments){if(s.arguments.length!==i.arguments.length)return s.arguments.length-i.arguments.length}else return 1;else return-1;for(let k=0;k<s.arguments.length;k++){const F=s.arguments[k],$=i.arguments[k];if(F!==$)return F<$?-1:1}return 0}function a(s,i){let k=(0,g.comparePaths)(s.resourceUri.fsPath,i.resourceUri.fsPath,!0);if(k!==0)return k;if(s.command&&i.command)k=t(s.command,i.command);else{if(s.command)return 1;if(i.command)return-1}if(k!==0)return k;if(s.decorations&&i.decorations)k=p(s.decorations,i.decorations);else{if(s.decorations)return 1;if(i.decorations)return-1}return k}function r(s,i){for(let k=0;k<s.length;k++)if(s[k]!==i[k])return!1;return!0}function o(s,i){return s.command===i.command&&s.title===i.title&&s.tooltip===i.tooltip&&(s.arguments&&i.arguments?r(s.arguments,i.arguments):s.arguments===i.arguments)}function f(s,i){return(0,y.equals)(s,i,o)}class v{get value(){return this.d}set value(i){i=i??"",Ne(this,n,"f").$setInputBoxValue(this.l,i),this.n(i)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(i){Ne(this,n,"f").$setInputBoxPlaceholder(this.l,i),this.f=i}get validateInput(){return(0,C.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(i){if((0,C.checkProposedApiEnabled)(this.k,"scmValidation"),i&&typeof i!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=i,Ne(this,n,"f").$setValidationProviderIsEnabled(this.l,!!i)}get enabled(){return this.h}set enabled(i){i=!!i,this.h!==i&&(this.h=i,Ne(this,n,"f").$setInputBoxEnablement(this.l,i))}get visible(){return this.j}set visible(i){i=!!i,this.j!==i&&(this.j=i,Ne(this,n,"f").$setInputBoxVisibility(this.l,i))}get document(){return(0,C.checkProposedApiEnabled)(this.k,"scmTextDocument"),Ne(this,h,"f").getDocument(this.m)}constructor(i,k,F,$,j){this.k=i,this.l=$,this.m=j,n.set(this,void 0),h.set(this,void 0),this.d="",this.e=new R.Emitter,this.f="",this.h=!0,this.j=!0,Ze(this,h,k,"f"),Ze(this,n,F,"f")}showValidationMessage(i,k){(0,C.checkProposedApiEnabled)(this.k,"scmValidation"),Ne(this,n,"f").$showValidationMessage(this.l,i,k)}$onInputBoxValueChange(i){this.n(i)}n(i){this.d=i,this.e.fire(i)}}e.ExtHostSCMInputBox=v,n=new WeakMap,h=new WeakMap;class l{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(i){this.v=i,this.q.$updateGroupLabel(this.t,this.handle,i)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(i){this.p=i,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(i){this.f=[...i],this.k.fire()}constructor(i,k,F,$,j){this.q=i,this.s=k,this.t=F,this.u=$,this.v=j,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new R.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new R.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=l.d++}getResourceState(i){return this.g.get(i)}$executeResourceCommand(i,k){const F=this.h.get(i);return F?(0,L.asPromise)(()=>this.s.executeCommand(F.command,...F.arguments||[],k)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const i=[...this.f].sort(a),F=(0,y.sortedDiff)(this.o,i,a).map(W=>{const U=W.toInsert.map(x=>{const B=this.e++;this.g.set(B,x);const z=x.resourceUri;let ee;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const Q=new O.DisposableStore;ee=this.s.converter.toInternal(x.command,Q),this.j.set(B,Q)}else this.h.set(B,x.command);const se=S(x.decorations),V=x.decorations&&S(x.decorations.light)||se,Z=x.decorations&&S(x.decorations.dark)||se,q=[V,Z],ae=x.decorations&&x.decorations.tooltip||"",Ee=x.decorations&&!!x.decorations.strikeThrough,ye=x.decorations&&!!x.decorations.faded,be=x.contextValue||"";return{rawResource:[B,z,q,ae,Ee,ye,be,ee],handle:B}});return{start:W.start,deleteCount:W.deleteCount,toInsert:U}}),$=F.map(({start:W,deleteCount:U,toInsert:x})=>[W,U,x.map(B=>B.rawResource)]),j=F.reverse();for(const{start:W,deleteCount:U,toInsert:x}of j){const B=x.map(ee=>ee.handle),z=this.n.splice(W,U,...B);for(const ee of z)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.o=i,$}dispose(){this.l=!0,this.m.fire()}}l.d=0;class I{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(i){this.g!==i&&(this.g=i,Ne(this,d,"f").$updateSourceControl(this.t,{count:i}))}get quickDiffProvider(){return this.h}set quickDiffProvider(i){this.h=i;let k;(0,C.isProposedApiEnabled)(this.u,"quickDiffProvider")&&(k=i?.label),Ne(this,d,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!i,quickDiffLabel:k})}get commitTemplate(){return this.j}set commitTemplate(i){i!==this.j&&(this.j=i,Ne(this,d,"f").$updateSourceControl(this.t,{commitTemplate:i}))}get acceptInputCommand(){return this.l}set acceptInputCommand(i){this.k.value=new O.DisposableStore,this.l=i;const k=this.v.converter.toInternal(i,this.k.value);Ne(this,d,"f").$updateSourceControl(this.t,{acceptInputCommand:k})}get actionButton(){return(0,C.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(i){(0,C.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new O.DisposableStore,this.n=i;const k=i!==void 0?{command:this.v.converter.toInternal(i.command,this.m.value),secondaryCommands:i.secondaryCommands?.map(F=>F.map($=>this.v.converter.toInternal($,this.m.value))),description:i.description,enabled:i.enabled}:void 0;Ne(this,d,"f").$updateSourceControl(this.t,{actionButton:k??null})}get statusBarCommands(){return this.p}set statusBarCommands(i){if(this.p&&i&&f(this.p,i))return;this.o.value=new O.DisposableStore,this.p=i;const k=(i||[]).map(F=>this.v.converter.toInternal(F,this.o.value));Ne(this,d,"f").$updateSourceControl(this.t,{statusBarCommands:k})}get selected(){return this.q}constructor(i,k,F,$,j,W,U){this.u=i,this.v=$,this.w=j,this.x=W,this.y=U,d.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new O.MutableDisposable,this.l=void 0,this.m=new O.MutableDisposable,this.o=new O.MutableDisposable,this.p=void 0,this.q=!1,this.s=new R.Emitter,this.onDidChangeSelection=this.s.event,this.t=I.d++,this.z=new Map,this.A=new Set,Ze(this,d,F,"f");const x=c.URI.from({scheme:b.Schemas.vscodeSourceControl,path:`${j}/scm${this.t}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new v(i,k,Ne(this,d,"f"),this.t,x),Ne(this,d,"f").$registerSourceControl(this.t,j,W,U,x)}createResourceGroup(i,k){const F=new l(Ne(this,d,"f"),this.v,this.t,i,k),$=R.Event.once(F.onDidDispose)(()=>this.z.delete(F));return this.z.set(F,$),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const i=[],k=[];for(const[F,$]of this.z){$.dispose();const j=F.onDidUpdateResourceStates(()=>{this.A.add(F),this.eventuallyUpdateResourceStates()});R.Event.once(F.onDidDispose)(()=>{this.A.delete(F),j.dispose(),this.e.delete(F.handle),Ne(this,d,"f").$unregisterGroup(this.t,F.handle)}),i.push([F.handle,F.id,F.label,F.features]);const W=F._takeResourceStateSnapshot();W.length>0&&k.push([F.handle,W]),this.e.set(F.handle,F)}Ne(this,d,"f").$registerGroups(this.t,i,k),this.z.clear()}eventuallyUpdateResourceStates(){const i=[];this.A.forEach(k=>{const F=k._takeResourceStateSnapshot();F.length!==0&&i.push([k.handle,F])}),i.length>0&&Ne(this,d,"f").$spliceResourceStates(this.t,i),this.A.clear()}getResourceGroup(i){return this.e.get(i)}setSelectionState(i){this.q=i,this.s.fire(i)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(i=>i.dispose()),Ne(this,d,"f").$unregisterSourceControl(this.t)}}d=new WeakMap,I.d=0,qe([(0,u.debounce)(100)],I.prototype,"eventuallyAddResourceGroups",null),qe([(0,u.debounce)(100)],I.prototype,"eventuallyUpdateResourceStates",null);let E=e.ExtHostSCM=class Ln{get onDidChangeActiveProvider(){return this.j.event}constructor(i,k,F,$){this.l=k,this.m=F,this.n=$,this.g=new Map,this.h=new P.ExtensionIdentifierMap,this.j=new R.Emitter,this.e=i.getProxy(A.MainContext.MainThreadSCM),this.f=i.getProxy(A.MainContext.MainThreadTelemetry),k.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const W=this.g.get(j.sourceControlHandle);if(!W)return j;const U=W.getResourceGroup(j.groupHandle);return U?U.getResourceState(j.handle):j}else if(j&&j.$mid===4){const W=this.g.get(j.sourceControlHandle);return W?W.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const W=this.g.get(j.handle);return W||j}return j}})}createSourceControl(i,k,F,$){this.n.trace("ExtHostSCM#createSourceControl",i.identifier.value,k,F,$),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:i.identifier.value});const j=Ln.d++,W=new I(i,this.m,this.e,this.l,k,F,$);this.g.set(j,W);const U=this.h.get(i.identifier)||[];return U.push(W),this.h.set(i.identifier,U),W}getLastInputBox(i){this.n.trace("ExtHostSCM#getLastInputBox",i.identifier.value);const k=this.h.get(i.identifier),F=k&&k[k.length-1];return F&&F.inputBox}$provideOriginalResource(i,k,F){const $=c.URI.revive(k);this.n.trace("ExtHostSCM#$provideOriginalResource",i,$.toString());const j=this.g.get(i);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.asPromise)(()=>j.quickDiffProvider.provideOriginalResource($,F)).then(W=>W||null)}$onInputBoxValueChange(i,k){this.n.trace("ExtHostSCM#$onInputBoxValueChange",i);const F=this.g.get(i);return F&&F.inputBox.$onInputBoxValueChange(k),Promise.resolve(void 0)}$executeResourceCommand(i,k,F,$){this.n.trace("ExtHostSCM#$executeResourceCommand",i,k,F);const j=this.g.get(i);if(!j)return Promise.resolve(void 0);const W=j.getResourceGroup(k);return W?W.$executeResourceCommand(F,$):Promise.resolve(void 0)}$validateInput(i,k,F){this.n.trace("ExtHostSCM#$validateInput",i);const $=this.g.get(i);return!$||!$.inputBox.validateInput?Promise.resolve(void 0):(0,L.asPromise)(()=>$.inputBox.validateInput(k,F)).then(j=>{if(!j)return Promise.resolve(void 0);const W=D.MarkdownString.fromStrict(j.message);return W?Promise.resolve([W,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(i){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",i),i!==void 0&&this.g.get(i)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=i,Promise.resolve(void 0)}};E.d=0,e.ExtHostSCM=E=qe([je(3,T.ILogService)],E)}),define(Ce[107],De([1,0,6,3,5]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class O{constructor(A){this.b=new R.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,y){return this.a.$getPassword(A,y)}store(A,y,g){return this.a.$setPassword(A,y,g)}delete(A,y){return this.a.$deletePassword(A,y)}}e.ExtHostSecretState=O,e.IExtHostSecretState=(0,u.createDecorator)("IExtHostSecretState")}),define(Ce[300],De([1,0,6,7]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSemanticSimilarity=void 0;class u{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(c.MainContext.MainThreadSemanticSimilarity)}async $provideSimilarityScore(L,A,y,g){if(this.a.size===0)throw new Error("No semantic similarity providers registered");const T=this.a.get(L);if(!T)throw new Error("Semantic similarity provider not found");return await T.provideSimilarityScore(A,y,g)}registerSemanticSimilarityProvider(L,A){const y=this.b;return this.b++,this.a.set(y,A),this.c.$registerSemanticSimilarityProvider(y),new R.Disposable(()=>{this.c.$unregisterSemanticSimilarityProvider(y),this.a.delete(y)})}}e.ExtHostSemanticSimilarity=u}),define(Ce[301],De([1,0,6,13,2]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostShare=void 0;class O{constructor(A,y){this.d=y,this.c=new Map,this.b=A.getProxy(c.MainContext.MainThreadShare)}async $provideShare(A,y,g){return await this.c.get(A)?.provideShare({selection:R.Range.to(y.range),resourceUri:u.URI.revive(y.resourceUri)},g)??void 0}registerShareProvider(A,y){const g=O.a++;return this.c.set(g,y),this.b.$registerShareProvider(g,R.DocumentSelector.from(A,this.d),y.id,y.label,y.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.ExtHostShare=O,O.a=0});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,R,u){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Ne=this&&this.__classPrivateFieldGet||function(re,e,c,R){if(c==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?R:c==="a"?R.call(re):R?R.value:e.get(re)};define(Ce[302],De([1,0,7,6,194,4,13,12]),function(re,e,c,R,u,O,L,A){"use strict";var y,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class T{constructor(C,b,n,h,d,S=c.StatusBarAlignment.Left,w){if(y.set(this,void 0),g.set(this,void 0),this.i=!1,this.k="",this.q=new O.DisposableStore,Ze(this,y,C,"f"),Ze(this,g,b,"f"),d&&h){this.c=(0,c.asStatusBarItemIdentifier)(h.identifier,d);const p=n.get(this.c);p&&(this.j=!0,this.g=p.alignLeft?c.StatusBarAlignment.Left:c.StatusBarAlignment.Right,this.h=p.priority,this.name=p.name,this.text=p.text,this.command=p.command)}else this.c=String(T.a++);this.e=h,this.f=d,this.g=S,this.h=this.u(w)}u(C){if((0,A.isNumber)(C))return C===Number.POSITIVE_INFINITY?Number.MAX_VALUE:C===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:C}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(C){this.k=C,this.v()}set name(C){this.m=C,this.v()}set tooltip(C){this.l=C,this.v()}set color(C){this.n=C,this.v()}set backgroundColor(C){C&&!T.b.has(C.id)&&(C=void 0),this.o=C,this.v()}set command(C){this.r?.fromApi!==C&&(this.p&&this.q.add(this.p),this.p=new O.DisposableStore,typeof C=="string"?this.r={fromApi:C,internal:Ne(this,g,"f").toInternal({title:"",command:C},this.p)}:C?this.r={fromApi:C,internal:Ne(this,g,"f").toInternal(C,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(C){this.t=C,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ne(this,y,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let C;this.e?this.f?C=`${this.e.identifier.value}.${this.f}`:C=this.e.identifier.value:C=this.f;let b;this.m?b=this.m:b=(0,u.localize)(0,null,this.e.displayName||this.e.name);let n=this.n;this.o&&(n=T.b.get(this.o.id));const h=L.MarkdownString.fromStrict(this.l);Ne(this,y,"f").$setEntry(this.c,C,this.e?.identifier.value,b,this.k,h,this.r?.internal,n,this.o,this.g===c.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=T,y=new WeakMap,g=new WeakMap,T.a=0,T.b=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(C){this.b=[],this.a=C.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,u.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(C){const b={message:C};return this.b.unshift(b),this.c(),new c.Disposable(()=>{const n=this.b.indexOf(b);n>=0&&(this.b.splice(n,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class m{constructor(C,b){this.e=new Map,this.a=C.getProxy(R.MainContext.MainThreadStatusBar),this.b=b,this.c=new P(this)}$acceptStaticEntries(C){for(const b of C)this.e.set(b.entryId,b)}createStatusBarEntry(C,b,n,h){return new T(this.a,this.b,this.e,C,b,n,h)}setStatusBarMessage(C,b){const n=this.c.setMessage(C);let h;return typeof b=="number"?h=setTimeout(()=>n.dispose(),b):typeof b<"u"&&b.then(()=>n.dispose(),()=>n.dispose()),new c.Disposable(()=>{n.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=m}),define(Ce[108],De([1,0,6,3,5]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class O{constructor(A,y){this.c=y,this.b=new R.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this.a.$registerExtensionStorageKeysToSync(A,y)}async initializeExtensionStorage(A,y,g){const T=await this.a.$initializeExtensionStorage(A,y);let P;return T&&(P=this.d(A,y,T)),P||g}setValue(A,y,g){return this.a.$setValue(A,y,g)}$acceptValue(A,y,g){const T=this.d(A,y,g);T&&this.b.fire({shared:A,key:y,value:T})}d(A,y,g){try{return JSON.parse(g)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${A}): ${T}`)}}}e.ExtHostStorage=O,e.IExtHostStorage=(0,u.createDecorator)("IExtHostStorage")}),define(Ce[84],De([1,0,5,27,17,64,2]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let A=e.ExtensionStoragePaths=class{constructor(g,T,P){this.d=T,this.f=P,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(g){return L.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,T=await this.g(g);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(L.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(g){if(this.c)return L.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return L.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=A=qe([je(0,R.IExtHostInitDataService),je(1,u.ILogService),je(2,O.IExtHostConsumerFileSystem)],A)}),define(Ce[43],De([1,0,3,6,5,2,20,4,7,196,8,236,21,33,237,55,12,16,13,25]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,u.createDecorator)("IExtHostTerminalService");class w{constructor(s,i,k,F){this.k=s,this._id=i,this.l=k,this.m=F,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(j=>this.f=j);const $=this;this.value={get name(){return $.m||""},get processId(){return $.b},get creationOptions(){return $.l},get exitStatus(){return $.h},get state(){return $.j},sendText(j,W=!0){$.o(),$.k.$sendText($._id,j,W)},show(j){$.o(),$.k.$show($._id,j)},hide(){$.o(),$.k.$hide($._id)},dispose(){$.a||($.a=!0,$.k.$dispose($._id))},get dimensions(){if(!($.d===void 0||$.g===void 0))return{columns:$.d,rows:$.g}}}}async create(s,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:s.name,shellPath:(0,n.withNullAsUndefined)(s.shellPath),shellArgs:(0,n.withNullAsUndefined)(s.shellArgs),cwd:(0,n.withNullAsUndefined)(s.cwd),env:(0,n.withNullAsUndefined)(s.env),icon:(0,n.withNullAsUndefined)(v(s.iconPath)),color:b.ThemeColor.isThemeColor(s.color)?s.color.id:void 0,initialText:(0,n.withNullAsUndefined)(s.message),strictEnv:(0,n.withNullAsUndefined)(s.strictEnv),hideFromUser:(0,n.withNullAsUndefined)(s.hideFromUser),isFeatureTerminal:(0,n.withNullAsUndefined)(i?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,n.withNullAsUndefined)(i?.useShellEnvironment),location:i?.location||this.n(s.location,i?.resolvedExtHostIdentifier),isTransient:(0,n.withNullAsUndefined)(s.isTransient)})}async createExtensionTerminal(s,i,k,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:k,color:b.ThemeColor.isThemeColor(F)?F.id:void 0,location:this.n(s,i),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(s,i){return typeof s=="object"?"parentTerminal"in s&&s.parentTerminal&&i?{parentTerminal:i}:"viewColumn"in s?{viewColumn:d.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus}:void 0:s}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(s){this.m=s}setExitStatus(s,i){this.h=Object.freeze({code:s,reason:i})}setDimensions(s,i){return s===this.d&&i===this.g||s===0||i===0?!1:(this.d=s,this.g=i,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(s){this.f?(this.f(s),this.f=void 0):this.b.then(i=>{i!==s&&(this.b=Promise.resolve(s))})}}e.ExtHostTerminal=w;class p{get onProcessReady(){return this.b.event}constructor(s){this.g=s,this.id=0,this.shouldPersist=!1,this.a=new c.Emitter,this.onProcessData=this.a.event,this.b=new c.Emitter,this.d=new c.Emitter,this.onDidChangeProperty=this.d.event,this.f=new c.Emitter,this.onProcessExit=this.f.event}refreshProperty(s){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${s}`)}updateProperty(s,i){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${s}, value: ${i}`)}async start(){}shutdown(){this.g.close()}input(s){this.g.handleInput?.(s)}resize(s,i){this.g.setDimensions?.({columns:s,rows:i})}async processBinary(s){}acknowledgeDataEvent(s){}async setUnicodeVersion(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this.g.onDidWrite(i=>this.a.fire(i)),this.g.onDidClose?.((i=void 0)=>{this.f.fire(i===void 0?void 0:i)}),this.g.onDidOverrideDimensions?.(i=>{i&&this.d.fire({type:"overrideDimensions",value:{cols:i.columns,rows:i.rows}})}),this.g.onDidChangeName?.(i=>{this.d.fire({type:"title",value:i})}),this.g.open(s||void 0),s&&this.g.setDimensions?.(s),this.b.fire({pid:-1,cwd:""})}}let t=1,a=e.BaseExtHostTerminalService=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(s=>s.value)}get onDidWriteTerminalData(){return this.I.event}constructor(s,i){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new c.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new c.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new c.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new c.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new c.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new c.Emitter,this.onDidChangeShell=this.J.event,this.a=i.getProxy(R.MainContext.MainThreadTerminalService),this.s=new C.TerminalDataBufferer(this.a.$sendProcessData),this.I=new c.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(s),this.B({dispose:()=>{for(const[k,F]of this.g)F.shutdown(!0)}})}getDefaultShell(s){return(s?this.n:this.m)?.path||""}getDefaultShellArgs(s){return(s?this.n:this.m)?.args||[]}createExtensionTerminal(s,i){const k=new w(this.a,(0,D.generateUuid)(),s,s.name),F=new p(s.pty);return k.createExtensionTerminal(s.location,this.L(s,i).resolvedExtHostIdentifier,v(s.iconPath),l(s.color)).then($=>{const j=this.M($,F);this.h[$]=j}),this.f.push(k),k.value}L(s,i){if(i=i||{},s.location&&typeof s.location=="object"&&"parentTerminal"in s.location){const k=s.location.parentTerminal;if(k){const F=this.f.find($=>$.value===k);F&&(i.resolvedExtHostIdentifier=F._id)}}else s.location&&typeof s.location!="object"?i.location=s.location:i.location&&typeof i.location=="object"&&"splitActiveTerminal"in i.location&&(i.location={splitActiveTerminal:!0});return i}attachPtyToTerminal(s,i){if(!this.O(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const F=new p(i),$=this.M(s,F);this.h[s]=$}async $acceptActiveTerminalChanged(s){const i=this.b;if(s===null){this.b=void 0,i!==this.b&&this.F.fire(this.b);return}const k=this.O(s);k&&(this.b=k,i!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(s,i){const k=this.O(s);k&&this.I.fire({terminal:k.value,data:i})}async $acceptTerminalDimensions(s,i,k){const F=this.O(s);F&&F.setDimensions(i,k)&&this.G.fire({terminal:F.value,dimensions:F.value.dimensions})}async $acceptTerminalMaximumDimensions(s,i,k){this.g.get(s)?.resize(i,k)}async $acceptTerminalTitleChange(s,i){const k=this.O(s);k&&(k.name=i)}async $acceptTerminalClosed(s,i,k){const F=this.Q(this.f,s);if(F!==null){const $=this.f.splice(F,1)[0];$.setExitStatus(i,k),this.C.fire($.value)}}$acceptTerminalOpened(s,i,k,F){if(i){const W=this.Q(this.f,i);if(W!==null){this.f[W]._id=s,this.D.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const $={name:F.name,shellPath:F.executable,shellArgs:F.args,cwd:typeof F.cwd=="string"?F.cwd:O.URI.revive(F.cwd),env:F.env,hideFromUser:F.hideFromUser},j=new w(this.a,s,$,k);this.f.push(j),this.D.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(s,i){this.O(s)?._setProcessId(i)}async $startExtensionTerminal(s,i){const k=this.O(s);if(!k)return{message:(0,g.localize)(0,null,s)};k.isOpen||await new Promise($=>{const j=this.onDidOpenTerminal(async W=>{W===k.value&&(j.dispose(),$())})});const F=this.g.get(s);F?F.startSendingEvents(i):this.j[s]={initialDimensions:i}}M(s,i){const k=new A.DisposableStore;k.add(i.onProcessReady($=>this.a.$sendProcessReady(s,$.pid,$.cwd))),k.add(i.onDidChangeProperty($=>this.a.$sendProcessProperty(s,$))),this.s.startBuffering(s,i.onProcessData),k.add(i.onProcessExit($=>this.N(s,$))),this.g.set(s,i);const F=this.j[s];return F&&i instanceof p&&(i.startSendingEvents(F.initialDimensions),delete this.j[s]),k}$acceptProcessAckDataEvent(s,i){this.g.get(s)?.acknowledgeDataEvent(i)}$acceptProcessInput(s,i){this.g.get(s)?.input(i)}$acceptTerminalInteraction(s){const i=this.O(s);i?.setInteractedWith()&&this.H.fire(i.value)}$acceptProcessResize(s,i,k){try{this.g.get(s)?.resize(i,k)}catch(F){if(F.code!=="EPIPE"&&F.code!=="ERR_IPC_CHANNEL_CLOSED")throw F}}$acceptProcessShutdown(s,i){this.g.get(s)?.shutdown(i)}$acceptProcessRequestInitialCwd(s){this.g.get(s)?.getInitialCwd().then(i=>this.a.$sendProcessProperty(s,{type:"initialCwd",value:i}))}$acceptProcessRequestCwd(s){this.g.get(s)?.getCwd().then(i=>this.a.$sendProcessProperty(s,{type:"cwd",value:i}))}$acceptProcessRequestLatency(s){return Promise.resolve(s)}registerLinkProvider(s){return this.u.add(s),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(s),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(s,i,k){if(this.v.has(i))throw new Error(`Terminal profile provider "${i}" already registered`);return this.v.set(i,k),this.a.$registerProfileProvider(i,s.identifier.value),new y.Disposable(()=>{this.v.delete(i),this.a.$unregisterProfileProvider(i)})}registerTerminalQuickFixProvider(s,i,k){if(this.w.has(s))throw new Error(`Terminal quick fix provider "${s}" is already registered`);return this.w.set(s,k),this.a.$registerQuickFixProvider(s,i),new y.Disposable(()=>{this.w.delete(s),this.a.$unregisterQuickFixProvider(s)})}async $provideTerminalQuickFixes(s,i){const k=new m.CancellationTokenSource().token;if(k.isCancellationRequested)return;const F=this.w.get(s);if(!F)return;const $=await F.provideTerminalQuickFixes(i,k);if($!==null)return $}async $createContributedProfileTerminal(s,i){const k=new m.CancellationTokenSource().token;let F=await this.v.get(s)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(F&&!("options"in F)&&(F={options:F}),!F||!("options"in F))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in F.options){this.createExtensionTerminal(F.options,i);return}this.createTerminalFromOptions(F.options,i)}}async $provideLinks(s,i){const k=this.O(s);if(!k)return[];this.y.delete(s),this.z.get(s)?.dispose(!0);const $=new m.CancellationTokenSource;this.z.set(s,$);const j=[],W={terminal:k.value,line:i},U=[];for(const z of this.u)U.push(h.Promises.withAsyncBody(async ee=>{$.token.onCancellationRequested(()=>ee({provider:z,links:[]}));const se=await z.provideTerminalLinks(W,$.token)||[];$.token.isCancellationRequested||ee({provider:z,links:se})}));const x=await Promise.all(U);if($.token.isCancellationRequested)return[];const B=new Map;for(const z of x)z&&z.links.length>0&&j.push(...z.links.map(ee=>{const se={id:t++,startIndex:ee.startIndex,length:ee.length,label:ee.tooltip};return B.set(se.id,{provider:z.provider,link:ee}),se}));return this.y.set(s,B),j}$activateLink(s,i){const k=this.y.get(s)?.get(i);k&&k.provider.handleTerminalLink(k.link)}N(s,i){this.s.stopBuffering(s),this.g.delete(s),delete this.j[s];const k=this.h[s];k&&(k.dispose(),delete this.h[s]),this.a.$sendProcessExit(s,i)}O(s){return this.P(this.f,s)}P(s,i){const k=this.Q(s,i);return k!==null?s[k]:null}Q(s,i){let k=null;return s.some((F,$)=>F._id===i?(k=$,!0):!1),k}getEnvironmentVariableCollection(s){let i=this.l.get(s.identifier.value);return i||(i=new r(s),this.S(s.identifier.value,i)),i.getScopedEnvironmentVariableCollection(void 0)}R(s,i){const k=(0,P.serializeEnvironmentVariableCollection)(i.map),F=(0,P.serializeEnvironmentDescriptionMap)(i.descriptionMap);this.a.$setEnvironmentVariableCollection(s,i.persistent,k.length===0?void 0:k,F)}$initEnvironmentVariableCollections(s){s.forEach(i=>{const k=i[0],F=new r(void 0,i[1]);this.S(k,F)})}$acceptDefaultProfile(s,i){const k=this.m;this.m=s,this.n=i,k?.path!==s.path&&this.J.fire(s.path)}S(s,i){this.l.set(s,i),i.onDidChangeCollection(()=>{this.R(s,i)})}};e.BaseExtHostTerminalService=a=qe([je(1,L.IExtHostRpcService)],a);class r{get persistent(){return this.b}set persistent(s){this.b=s,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(s,i){this.f=s,this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new c.Emitter,this.map=new Map(i)}getScopedEnvironmentVariableCollection(s){this.f&&s&&(0,S.checkProposedApiEnabled)(this.f,"envCollectionWorkspace");const i=this.j(s);let k=this.a.get(i);return k||(k=new o(this,s),this.a.set(i,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(s,i,k,F){this.f&&k&&(0,S.checkProposedApiEnabled)(this.f,"envCollectionOptions"),this.g(s,{value:i,type:y.EnvironmentVariableMutatorType.Replace,options:k??{},scope:F})}append(s,i,k,F){this.f&&k&&(0,S.checkProposedApiEnabled)(this.f,"envCollectionOptions"),this.g(s,{value:i,type:y.EnvironmentVariableMutatorType.Append,options:k??{},scope:F})}prepend(s,i,k,F){this.f&&k&&(0,S.checkProposedApiEnabled)(this.f,"envCollectionOptions"),this.g(s,{value:i,type:y.EnvironmentVariableMutatorType.Prepend,options:k??{},scope:F})}g(s,i){if(i.options&&i.options.applyAtProcessCreation===!1&&!i.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.h(s,i.scope),F=this.map.get(k);if(!F||F.value!==i.value||F.type!==i.type||F.options?.applyAtProcessCreation!==(i.options.applyAtProcessCreation??!0)||F.options?.applyAtShellIntegration!==(i.options.applyAtShellIntegration??!1)||F.scope?.workspaceFolder?.index!==i.scope?.workspaceFolder?.index){const $=this.h(s,i.scope),j={variable:s,...i,options:{applyAtProcessCreation:i.options.applyAtProcessCreation??!0,applyAtShellIntegration:i.options.applyAtShellIntegration??!1}};this.map.set($,j),this.d.fire()}}get(s,i){const k=this.h(s,i),F=this.map.get(k);return F?I(F):void 0}h(s,i){const k=this.j(i);return k.length?`${s}:::${k}`:s}j(s){return this.k(s?.workspaceFolder)??""}k(s){return s?s.uri.toString():void 0}getVariableMap(s){const i=new Map;for(const[k,F]of this.map)this.j(F.scope)===this.j(s)&&i.set(k,I(F));return i}delete(s,i){const k=this.h(s,i);this.map.delete(k),this.d.fire()}clear(s){if(s?.workspaceFolder){for(const[i,k]of this.map)k.scope?.workspaceFolder?.index===s.workspaceFolder.index&&this.map.delete(i);this.l(s)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(s,i){const k=this.j(i),F=this.descriptionMap.get(k);if(!F||F.description!==s){let $;typeof s=="string"?$=s:$=s?.value.split(`

`)[0];const j={description:$,scope:i};this.descriptionMap.set(k,j),this.d.fire()}}getDescription(s){const i=this.j(s);return this.descriptionMap.get(i)?.description}l(s){const i=this.j(s);this.descriptionMap.delete(i)}}class o{get persistent(){return this.b.persistent}set persistent(s){this.b.persistent=s}get onDidChangeCollection(){return this.a&&this.a.event}constructor(s,i){this.b=s,this.d=i,this.a=new c.Emitter}getScopedEnvironmentVariableCollection(s){return this.b.getScopedEnvironmentVariableCollection(s)}replace(s,i,k){this.b.replace(s,i,k,this.d)}append(s,i,k){this.b.append(s,i,k,this.d)}prepend(s,i,k){this.b.prepend(s,i,k,this.d)}get(s){return this.b.get(s,this.d)}forEach(s,i){this.b.getVariableMap(this.d).forEach((k,F)=>s.call(i,F,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(s){this.b.delete(s,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(s){this.b.setDescription(s,this.d)}get description(){return this.b.getDescription(this.d)}}let f=e.WorkerExtHostTerminalService=class extends a{constructor(s){super(!1,s)}createTerminal(s,i,k){throw new T.NotSupportedError}createTerminalFromOptions(s,i){throw new T.NotSupportedError}};e.WorkerExtHostTerminalService=f=qe([je(0,L.IExtHostRpcService)],f);function v(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function l(E){return b.ThemeColor.isThemeColor(E)?E:void 0}function I(E){const s={...E};return delete s.scope,s.options=s.options??void 0,delete s.variable,s}});var Ne=this&&this.__classPrivateFieldGet||function(re,e,c,R){if(c==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?R:c==="a"?R.call(re):R?R.value:e.get(re)},Ze=this&&this.__classPrivateFieldSet||function(re,e,c,R,u){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c};define(Ce[303],De([1,0,19,16,22,21,3,67,70,4,23,12,33,6,20,141,13,7,60,102,81,25]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d,S,w,p){"use strict";var t,a;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=e.ExtHostTesting=class{constructor(U,x,B){this.j=B,this.c=new L.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=U.getProxy(D.MainContext.MainThreadTesting),this.h=new F(this.f),this.g=new l(this.f),x.registerArgumentProcessor({processArgument:z=>{if(z?.$mid!==15)return z;const ee=z,se=ee.tests[ee.tests.length-1].item.extId;return this.d.get(d.TestId.root(se))?.collection.tree.get(se)?.actual??(0,b.toItemFromContext)(z)}}),x.registerCommand(!1,"testing.getExplorerSelection",async()=>{const z=await x.executeCommand("_testing.getExplorerSelection"),ee=se=>{const V=this.d.get(d.TestId.root(se));if(V)return d.TestId.isRoot(se)?V.controller:V.collection.tree.get(se)?.actual};return{include:z?.include.map(ee).filter(P.isDefined)||[],exclude:z?.exclude.map(ee).filter(P.isDefined)||[]}})}createTestController(U,x,B,z){if(this.d.has(x))throw new Error(`Attempt to insert a duplicate controller with ID "${x}"`);const ee=new g.DisposableStore,se=ee.add(new b.ExtHostTestItemCollection(x,B,this.j));se.root.label=B;const V=new Map,Z=this.f,q={items:se.root.children,get label(){return B},set label(Ee){B=Ee,se.root.label=Ee,Z.$updateController(x,{label:B})},get refreshHandler(){return z},set refreshHandler(Ee){z=Ee,Z.$updateController(x,{canRefresh:!!Ee})},get id(){return x},createRunProfile:(Ee,ye,be,M,Q,fe)=>{let we=(0,y.hash)(Ee);for(;V.has(we);)we++;return new $(this.f,V,x,we,Ee,ye,be,M,Q,fe)},createTestItem(Ee,ye,be){return new b.TestItemImpl(x,Ee,ye,be)},createTestRun:(Ee,ye,be=!0)=>this.g.createTestRun(x,se,Ee,ye,be),invalidateTestResults:Ee=>{(0,p.checkProposedApiEnabled)(U,"testInvalidateResults");for(const ye of Ee instanceof Array?Ee:[Ee]){const be=ye?d.TestId.fromExtHostTestItem(ye,x).toString():x;this.f.$markTestRetired(be)}},set resolveHandler(Ee){se.resolveHandler=Ee},get resolveHandler(){return se.resolveHandler},dispose:()=>{ee.dispose()}};Z.$registerTestController(x,B,!!z),ee.add((0,g.toDisposable)(()=>Z.$unregisterTestController(x)));const ae={controller:q,collection:se,profiles:V};return this.d.set(x,ae),ee.add((0,g.toDisposable)(()=>this.d.delete(x))),ee.add(se.onDidGenerateDiff(Ee=>Z.$publishDiff(x,Ee.map(w.TestsDiffOp.serialize)))),q}createTestObserver(){return this.h.checkout()}async runTests(U,x=O.CancellationToken.None){const B=I(U);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.d.get(B.controllerId);if(!z)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(ee=>d.TestId.fromExtHostTestItem(ee,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:j[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:U.exclude?.map(ee=>ee.id)},x)}$syncTests(){for(const{collection:U}of this.d.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,x,B){return(0,c.mapFind)(this.g.trackers,ee=>ee.id===U?ee.getCoverage(x):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(U,x,B,z){return(0,c.mapFind)(this.g.trackers,se=>se.id===U?se.getCoverage(x):void 0)?.resolveFileCoverage(B,z)??Promise.resolve([])}$configureRunProfile(U,x){this.d.get(U)?.profiles.get(x)?.configureHandler?.()}async $refreshTests(U,x){await this.d.get(U)?.controller.refreshHandler?.(x)}$publishTestResults(U){this.results=Object.freeze(U.map(x=>(0,T.deepFreeze)(n.TestResults.to(x))).concat(this.results).sort((x,B)=>B.completedAt-x.completedAt).slice(0,32)),this.c.fire()}async $expandTest(U,x){const B=this.d.get(d.TestId.fromString(U).controllerId)?.collection;B&&(await B.expand(U,x<0?1/0:x),B.flushDiff())}$acceptDiff(U){this.h.applyDiff(U.map(w.TestsDiffOp.deserialize))}async $runControllerTests(U,x){return Promise.all(U.map(B=>this.k(B,!1,x)))}async $startContinuousRun(U,x){const B=new O.CancellationTokenSource(x),z=await Promise.all(U.map(ee=>this.k(ee,!0,B.token)));return!x.isCancellationRequested&&!z.some(ee=>ee.error)&&await new Promise(ee=>x.onCancellationRequested(ee)),B.dispose(!0),z}async k(U,x,B){const z=this.d.get(U.controllerId);if(!z)return{};const{collection:ee,profiles:se}=z,V=se.get(U.profileId);if(!V)return{};const Z=U.testIds.map(ye=>ee.tree.get(ye)).filter(P.isDefined),q=U.excludeExtIds.map(ye=>z.collection.tree.get(ye)).filter(P.isDefined).filter(ye=>Z.some(be=>be.fullId.compare(ye.fullId)===2));if(!Z.length)return{};const ae=new h.TestRunRequest(Z.some(ye=>ye.actual instanceof b.TestItemRootImpl)?void 0:Z.map(ye=>ye.actual),q.map(ye=>ye.actual),V,x),Ee=(0,w.isStartControllerTests)(U)&&this.g.prepareForMainThreadTestRun(ae,E.fromInternal(U,z.collection),B);try{return await V.runHandler(ae,B),{}}catch(ye){return{error:String(ye)}}finally{Ee&&(Ee.hasRunningTasks&&!B.isCancellationRequested&&await L.Event.toPromise(Ee.onEnd),Ee.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.g.cancelAllRuns():this.g.cancelRunById(U)}};e.ExtHostTesting=r=qe([je(0,C.IExtHostRpcService)],r);const o=1e4;var f;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(f||(f={}));class v extends g.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(U,x,B){super(),this.k=U,this.l=x,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new L.Emitter),this.onEnd=this.j.event,this.h=this.B(new O.CancellationTokenSource(B));const z=this.B(new R.RunOnceScheduler(()=>this.m(),o));this.B(this.h.token.onCancellationRequested(()=>z.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const x=this.k.id,B=this.k.controllerId,z=(0,m.generateUuid)(),ee=new s(this.l,x,z),se=ae=>(Ee,...ye)=>{if(Z){console.warn(`Setting the state of test "${Ee.id}" is a no-op after the run ends.`);return}this.k.isIncluded(Ee)&&(this.s(Ee),ae(Ee,...ye))},V=(ae,Ee)=>{const ye=Ee instanceof Array?Ee.map(n.TestMessage.from):[n.TestMessage.from(Ee)];if(ae.uri&&ae.range){const be={range:n.Range.from(ae.range),uri:ae.uri};for(const M of ye)M.location=M.location||be}this.l.$appendTestMessagesInRun(x,z,d.TestId.fromExtHostTestItem(ae,B).toString(),ye)};let Z=!1;const q={isPersisted:this.k.isPersisted,token:this.h.token,name:U,get coverageProvider(){return ee.coverageProvider},set coverageProvider(ae){ee.coverageProvider=ae},enqueued:se(ae=>{this.l.$updateTestStateInRun(x,z,d.TestId.fromExtHostTestItem(ae,B).toString(),1)}),skipped:se(ae=>{this.l.$updateTestStateInRun(x,z,d.TestId.fromExtHostTestItem(ae,B).toString(),5)}),started:se(ae=>{this.l.$updateTestStateInRun(x,z,d.TestId.fromExtHostTestItem(ae,B).toString(),2)}),errored:se((ae,Ee,ye)=>{V(ae,Ee),this.l.$updateTestStateInRun(x,z,d.TestId.fromExtHostTestItem(ae,B).toString(),6,ye)}),failed:se((ae,Ee,ye)=>{V(ae,Ee),this.l.$updateTestStateInRun(x,z,d.TestId.fromExtHostTestItem(ae,B).toString(),4,ye)}),passed:se((ae,Ee)=>{this.l.$updateTestStateInRun(x,z,d.TestId.fromExtHostTestItem(ae,this.k.controllerId).toString(),3,Ee)}),appendOutput:(ae,Ee,ye)=>{Z||(ye&&(this.k.isIncluded(ye)?this.s(ye):ye=void 0),this.l.$appendOutputToRun(x,z,u.VSBuffer.fromString(ae),Ee&&n.location.from(Ee),ye&&d.TestId.fromExtHostTestItem(ye,B).toString()))},end:()=>{Z||(Z=!0,this.l.$finishedTestRunTask(x,z),this.f.delete(z),this.f.size||this.p())}};return this.f.set(z,{run:q,coverage:ee}),this.l.$startedTestRunTask(x,{id:z,name:U,running:!0}),q}m(){for(const{run:U}of this.f.values())U.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(U){if(!(U instanceof b.TestItemImpl))throw new S.InvalidTestItemError(U.id);if(this.g.has(d.TestId.fromExtHostTestItem(U,this.k.controllerId).toString()))return;const x=[],B=this.k.colllection.root;for(;;){const z=n.TestItem.from(U);if(x.unshift(z),this.g.has(z.extId)||(this.g.add(z.extId),U===B))break;U=U.parent||B}this.l.$addTestsToRun(this.k.controllerId,this.k.id,x)}}class l{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,x,B){return this.f(U,x,B)}cancelRunById(U){for(const x of this.c.values())if(x.id===U){x.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,x,B,z,ee){const se=this.c.get(B);if(se)return se.createRun(z);const V=E.fromPublic(U,x,B,ee),Z=I(B);this.d.$startedExtensionTestRun({controllerId:U,continuous:!!B.continuous,profile:Z&&{group:j[Z.kind],id:Z.profileId},exclude:B.exclude?.map(ae=>d.TestId.fromExtHostTestItem(ae,x.root.id).toString())??[],id:V.id,include:B.include?.map(ae=>d.TestId.fromExtHostTestItem(ae,x.root.id).toString())??[x.root.id],persist:ee});const q=this.f(B,V);return q.onEnd(()=>{this.d.$finishedExtensionTestRun(V.id),q.dispose()}),q.createRun(z)}f(U,x,B){const z=new v(x,this.d,B);return this.c.set(U,z),z.onEnd(()=>this.c.delete(U)),z}}e.TestRunCoordinator=l;const I=W=>{if(W.profile){if(!(W.profile instanceof $))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class E{static fromPublic(U,x,B,z){return new E(U,(0,m.generateUuid)(),B.include?.map(ee=>d.TestId.fromExtHostTestItem(ee,U).toString())??[U],B.exclude?.map(ee=>d.TestId.fromExtHostTestItem(ee,U).toString())??[],z,x)}static fromInternal(U,x){return new E(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,x)}constructor(U,x,B,z,ee,se){this.controllerId=U,this.id=x,this.isPersisted=ee,this.colllection=se,this.c=B.map(V=>V+"\0"),this.d=z.map(V=>V+"\0")}isIncluded(U){const x=d.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const B of this.d)if(x===B||x.startsWith(B))return!1;for(const B of this.c)if(x===B||x.startsWith(B))return!0;return!1}}e.TestRunDto=E;class s{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,x,B){this.f=U,this.g=x,this.h=B}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(n.TestCoverage.fromFile)??[]}catch(x){throw this.d=void 0,x}}async resolveFileCoverage(U,x){const B=await this.d;let z=B?.[U];return!this.c||!B||!z?[]:(z.detailedCoverage||(z=B[U]=await this.c.resolveFileCoverage?.(z,x)??z),z.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class i{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,n.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const x=d.TestId.parentId(U.item.extId);if(x&&this.g.has(x.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:x,f:B}=this;return{get added(){return[...U].map(z=>z.revived)},get updated(){return[...x].map(z=>z.revived)},get removed(){return[...B].map(z=>z.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class k extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new L.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,x){return{...U,revived:n.TestItem.toPlain(U.item),depth:x?x.depth+1:0,children:new Set}}o(){return new i(this.q)}}class F{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(x=>x.revived)},dispose:(0,A.once)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new k;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class ${get label(){return this.d}set label(U){U!==this.d&&(this.d=U,Ne(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,Ne(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,Ne(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Ne(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?n.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,Ne(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,x,B,z,ee,se,V,Z=!1,q=void 0,ae=!1){this.controllerId=B,this.profileId=z,this.d=ee,this.kind=se,this.runHandler=V,this.f=Z,this._tag=q,this.g=ae,t.set(this,void 0),a.set(this,void 0),Ze(this,t,U,"f"),Ze(this,a,x,"f"),x.set(z,this);const Ee=j[se];if(typeof Ee!="number")throw new Error(`Unknown TestRunProfile.group ${se}`);Ne(this,t,"f").$publishTestRunProfile({profileId:z,controllerId:B,tag:q?n.TestTag.namespace(this.controllerId,q.id):null,label:ee,group:Ee,isDefault:Z,hasConfigurationHandler:!1,supportsContinuousRun:ae})}dispose(){Ne(this,a,"f")?.delete(this.profileId)&&(Ze(this,a,void 0,"f"),Ne(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=$,t=new WeakMap,a=new WeakMap;const j={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(Ce[304],De([1,0,19,8,3,6,142,13,7]),function(re,e,c,R,u,O,L,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class g{constructor(P,m){this.i=m,this.a=new u.Emitter({onListenerError:R.onUnexpectedExternalError}),this.b=new u.Emitter({onListenerError:R.onUnexpectedExternalError}),this.c=new u.Emitter({onListenerError:R.onUnexpectedExternalError}),this.d=new u.Emitter({onListenerError:R.onUnexpectedExternalError}),this.f=new u.Emitter({onListenerError:R.onUnexpectedExternalError}),this.g=new u.Emitter({onListenerError:R.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=P.getProxy(O.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(D=>this.g.fire(D)),this.i.onDidChangeActiveTextEditor(D=>this.f.fire(D))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(P){const m=this.i.allEditors();return P?m:m.map(D=>D.value)}async showTextDocument(P,m,D){let C;typeof m=="number"?C={position:A.ViewColumn.from(m),preserveFocus:D}:typeof m=="object"?C={position:A.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selection:typeof m.selection=="object"?A.Range.from(m.selection):void 0,pinned:typeof m.preview=="boolean"?!m.preview:void 0}:C={preserveFocus:!1};const b=await this.h.$tryShowTextDocument(P.uri,C),n=b&&this.i.getEditor(b);if(n)return n.value;throw b?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,m){return new L.TextEditorDecorationType(this.h,P,m).value}$acceptEditorPropertiesChanged(P,m){const D=this.i.getEditor(P);if(!D)throw new Error("unknown text editor");if(m.options&&D._acceptOptions(m.options),m.selections){const C=m.selections.selections.map(A.Selection.to);D._acceptSelections(C)}if(m.visibleRanges){const C=c.coalesce(m.visibleRanges.map(A.Range.to));D._acceptVisibleRanges(C)}if(m.options&&this.b.fire({textEditor:D.value,options:{...m.options,lineNumbers:A.TextEditorLineNumbersStyle.to(m.options.lineNumbers)}}),m.selections){const C=y.TextEditorSelectionChangeKind.fromValue(m.selections.source),b=m.selections.selections.map(A.Selection.to);this.a.fire({textEditor:D.value,selections:b,kind:C})}if(m.visibleRanges){const C=c.coalesce(m.visibleRanges.map(A.Range.to));this.c.fire({textEditor:D.value,visibleRanges:C})}}$acceptEditorPositionData(P){for(const m in P){const D=this.i.getEditor(m);if(!D)throw new Error("Unknown text editor");const C=A.ViewColumn.to(P[m]);D.value.viewColumn!==C&&(D._acceptViewColumn(C),this.d.fire({textEditor:D.value,viewColumn:C}))}}getDiffInformation(P){return Promise.resolve(this.h.$getDiffInformation(P))}}e.ExtHostEditors=g}),define(Ce[305],De([1,0,2,5,6,4,7,13,26,12]),function(re,e,c,R,u,O,L,A,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class T{constructor(D,C){this.b=new Map,this.c=new Map,this.a=D.getProxy(u.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:(b,n)=>{if(b&&b.$mid===12)if(this.b.get(b.source)&&y.ExtensionIdentifier.equals(n,this.b.get(b.source)?.extension)){const h=b.uri===void 0?void 0:c.URI.revive(b.uri);return this.c.get(b.source)?.get(P(h))?.get(b.handle)}else return;return b}})}async $getTimeline(D,C,b,n){return this.b.get(D)?.provider.provideTimeline(c.URI.revive(C),b,n)}registerTimelineProvider(D,C,b,n){const h=new O.DisposableStore,d=this.d(C.id,n,h).bind(this);let S;C.onDidChange&&(S=C.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:C.id}),this));const w=this.c;return this.f({...C,scheme:D,onDidChange:void 0,async provideTimeline(p,t,a){t?.resetCache&&(h.clear(),w.get(C.id)?.clear());const r=await C.provideTimeline(p,t,a);if(r==null)return;const o=d(p,t);return{...r,source:C.id,items:r.items.map(o)}},dispose(){for(const p of w.values())p.get(C.id)?.clear();S?.dispose(),h.dispose()}},b)}d(D,C,b){return(n,h)=>{let d;if(h?.cacheResults){let S=this.c.get(D);S===void 0&&(S=new Map,this.c.set(D,S));const w=P(n);d=S.get(w),d===void 0&&(d=new Map,S.set(w,d))}return S=>{const{iconPath:w,...p}=S,t=`${D}|${S.id??S.timestamp}`;d?.set(t,S);let a,r,o;S.iconPath&&(w instanceof L.ThemeIcon?o={id:w.id,color:w.color}:c.URI.isUri(w)?(a=w,r=w):{light:a,dark:r}=w);let f;return L.MarkdownString.isMarkdownString(p.tooltip)?f=A.MarkdownString.from(p.tooltip):(0,g.isString)(p.tooltip)?f=p.tooltip:L.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),f=A.MarkdownString.from(p.detail)):(0,g.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),f=p.detail),{...p,id:p.id??void 0,handle:t,source:D,command:S.command?C.toInternal(S.command,b):void 0,icon:a,iconDark:r,themeIcon:o,tooltip:f,accessibilityInformation:S.accessibilityInformation}}}}f(D,C){if(this.b.get(D.id))throw new Error(`Timeline Provider ${D.id} already exists.`);return this.a.$registerTimelineProvider({id:D.id,label:D.label,scheme:D.scheme}),this.b.set(D.id,{provider:D,extension:C}),(0,O.toDisposable)(()=>{for(const n of this.c.values())n.get(D.id)?.clear();this.b.delete(D.id),this.a.$unregisterTimelineProvider(D.id),D.dispose()})}}e.ExtHostTimeline=T;function P(m){return m?.toString()}}),define(Ce[306],De([1,0,4,18,2,6]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class L{constructor(y){this.c=new Map,this.b=y.getProxy(O.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,g,T,P){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const m=P.schemes.find(D=>!L.a.has(D));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(g,T),this.b.$registerUriOpener(g,P.schemes,y,P.label),(0,c.toDisposable)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(y,g,T){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener with id: ${y}`);const m=u.URI.revive(g);return P.canOpenExternalUri(m,T)}async $openUri(y,g,T){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener id: '${y}'`);return P.openExternalUri(u.URI.revive(g.resolvedUri),{sourceUri:u.URI.revive(g.sourceUri)},T)}}e.ExtHostUriOpeners=L,L.a=new Set([R.Schemas.http,R.Schemas.https])}),define(Ce[307],De([1,0,6,2,4,8,26]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(g){this.c=new L.ExtensionIdentifierSet,this.d=new Map,this.b=g.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(g,T){const P=g.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const m=A.a++;return this.c.add(P),this.d.set(m,T),this.b.$registerUriHandler(m,P,g.displayName||g.name),(0,u.toDisposable)(()=>{this.c.delete(P),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(g,T){const P=this.d.get(g);if(!P)return Promise.resolve(void 0);try{P.handleUri(R.URI.revive(T))}catch(m){(0,O.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(g){return R.URI.revive(await this.b.$createAppUri(g))}}e.ExtHostUrls=A,A.a=0});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,R,u){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Ne=this&&this.__classPrivateFieldGet||function(re,e,c,R){if(c==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?R:c==="a"?R.call(re):R?R.value:e.get(re)};define(Ce[85],De([1,0,3,18,23,2,212,245,103,6]),function(re,e,c,R,u,O,L,A,y,g){"use strict";var T,P,m,D,C,b,n,h,d,S,w,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class a{constructor(i,k,F,$,j,W,U){T.set(this,void 0),P.set(this,void 0),m.set(this,void 0),D.set(this,void 0),C.set(this,void 0),b.set(this,void 0),n.set(this,""),h.set(this,void 0),d.set(this,!1),S.set(this,!1),w.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new c.Emitter),this._onDidDispose=Ne(this,t,"f").event,Ze(this,T,i,"f"),Ze(this,P,k,"f"),Ze(this,h,F,"f"),Ze(this,D,$,"f"),Ze(this,C,j,"f"),Ze(this,b,W,"f"),Ze(this,w,r(W),"f"),Ze(this,p,o(W),"f"),Ze(this,m,U,"f")}dispose(){Ze(this,d,!0,"f"),Ne(this,t,"f").fire(),Ne(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(i){return Ze(this,S,!0,"f"),(0,y.asWebviewUri)(i,Ne(this,D,"f"))}get cspSource(){const i=Ne(this,b,"f").extensionLocation;if(i.scheme===R.Schemas.https||i.scheme===R.Schemas.http){let k=i.toString();return k.endsWith("/")||(k+="/"),k+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Ne(this,n,"f")}set html(i){this.a(),Ne(this,n,"f")!==i&&(Ze(this,n,i,"f"),Ne(this,p,"f")&&!Ne(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(i)&&(Ze(this,S,!0,"f"),Ne(this,m,"f").report("Webview vscode-resource: uris",Ne(this,b,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,P,"f").$setHtml(Ne(this,T,"f"),this.b(i)))}get options(){return this.a(),Ne(this,h,"f")}set options(i){this.a(),u.equals(Ne(this,h,"f"),i)||Ne(this,P,"f").$setOptions(Ne(this,T,"f"),l(Ne(this,b,"f"),Ne(this,C,"f"),i)),Ze(this,h,i,"f")}async postMessage(i){if(Ne(this,d,"f"))return!1;const k=(0,A.serializeWebviewMessage)(i,{serializeBuffersForPostMessage:Ne(this,w,"f")});return Ne(this,P,"f").$postMessage(Ne(this,T,"f"),k.message,...k.buffers)}a(){if(Ne(this,d,"f"))throw new Error("Webview is disposed")}b(i){if(!Ne(this,p,"f"))return i;const k=Ne(this,b,"f").extensionLocation?.scheme===R.Schemas.vscodeRemote,F=Ne(this,b,"f").extensionLocation.scheme===R.Schemas.vscodeRemote?Ne(this,b,"f").extensionLocation.authority:void 0;return i.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,($,j,W,U,x,B)=>{const z=O.URI.from({scheme:U||"file",path:decodeURIComponent(x)}),ee=(0,y.asWebviewUri)(z,{isRemote:k,authority:F}).toString();return`${j}${ee}${B}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,($,j,W,U,x,B)=>{const z=O.URI.from({scheme:U||"file",path:decodeURIComponent(x)}),ee=(0,y.asWebviewUri)(z,{isRemote:k,authority:F}).toString();return`${j}${ee}${B}`})}}e.ExtHostWebview=a,T=new WeakMap,P=new WeakMap,m=new WeakMap,D=new WeakMap,C=new WeakMap,b=new WeakMap,n=new WeakMap,h=new WeakMap,d=new WeakMap,S=new WeakMap,w=new WeakMap,p=new WeakMap,t=new WeakMap;function r(s){try{const i=(0,L.normalizeVersion)((0,L.parseVersion)(s.engines.vscode));return!!i&&i.majorBase>=1&&i.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function o(s){try{const i=(0,L.normalizeVersion)((0,L.parseVersion)(s.engines.vscode));return i?i.majorBase<1||i.majorBase===1&&i.minorBase<60:!1}catch{return!1}}class f{constructor(i,k,F,$,j){this.c=k,this.d=F,this.e=$,this.f=j,this.b=new Map,this.a=i.getProxy(g.MainContext.MainThreadWebviews)}$onMessage(i,k,F){const $=this.g(i);if($){const{message:j}=(0,A.deserializeWebviewMessage)(k,F.value);$._onMessageEmitter.fire(j)}}$onMissingCsp(i,k){this.e.warn(`${k} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(i,k,F){const $=new a(i,this.a,I(k),this.c,this.d,F,this.f);return this.b.set(i,$),$._onDidDispose(()=>{this.b.delete(i)}),$}deleteWebview(i){this.b.delete(i)}g(i){return this.b.get(i)}}e.ExtHostWebviews=f;function v(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=v;function l(s,i,k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots||E(s,i)}}e.serializeWebviewOptions=l;function I(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(i=>O.URI.from(i))}}function E(s,i){return[...(i?.getWorkspaceFolders()||[]).map(k=>k.uri),s.extensionLocation]}}),define(Ce[308],De([1,0,21,70,4,18,24,2,13,85,80,6,7]),function(re,e,c,R,u,O,L,A,y,g,T,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class D{constructor(a,r){this.document=a,this.b=r,this.a=1,this.c=new T.Cache("custom documents")}addEdit(a){return this.c.add([a])}async undo(a,r){await this.f(a).undo(),r||this.disposeBackup()}async redo(a,r){await this.f(a).redo(),r||this.disposeBackup()}disposeEdits(a){for(const r of a)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const a=p(this.document.uri)+this.a++;return(0,L.joinPath)(this.b,a)}updateBackup(a){this.d?.delete(),this.d=a}disposeBackup(){this.d?.delete(),this.d=void 0}f(a){const r=this.c.get(a,0);if(!r)throw new Error("No edit found");return r}}class C{constructor(){this.a=new Map}get(a,r){return this.a.get(this.b(a,r))}add(a,r,o){const f=this.b(a,r.uri);if(this.a.has(f))throw new Error(`Document already exists for viewType:${a} resource:${r.uri}`);const v=new D(r,o);return this.a.set(f,v),v}delete(a,r){const o=this.b(a,r.uri);this.a.delete(o)}b(a,r){return`${a}@@@${r}`}}var b;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(b||(b={}));class n{constructor(){this.a=new Map}addTextProvider(a,r,o){return this.b(0,a,r,o)}addCustomProvider(a,r,o){return this.b(1,a,r,o)}get(a){return this.a.get(a)}b(a,r,o,f){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:a,extension:o,provider:f}),new m.Disposable(()=>this.a.delete(r))}}class h{constructor(a,r,o,f,v){this.d=r,this.f=o,this.g=f,this.h=v,this.b=new n,this.c=new C,this.a=a.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,r,o,f){const v=new u.DisposableStore;return S(o)?(v.add(this.b.addTextProvider(r,a,o)),this.a.$registerTextEditorProvider((0,g.toExtensionData)(a),r,f.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,g.shouldSerializeBuffersForPostMessage)(a))):(v.add(this.b.addCustomProvider(r,a,o)),d(o)&&v.add(o.onDidChangeCustomDocument(l=>{const I=this.i(r,l.document.uri);if(w(l)){const E=I.addEdit(l);this.a.$onDidEdit(l.document.uri,r,E,l.label)}else this.a.$onContentChange(l.document.uri,r)})),this.a.$registerCustomEditorProvider((0,g.toExtensionData)(a),r,f.webviewOptions||{},!!f.supportsMultipleEditorsPerDocument,(0,g.shouldSerializeBuffersForPostMessage)(a))),m.Disposable.from(v,new m.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(a,r,o,f,v){const l=this.b.get(r);if(!l)throw new Error(`No provider found for '${r}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${r}'`);const I=A.URI.revive(a),E=await l.provider.openCustomDocument(I,{backupId:o,untitledDocumentData:f?.buffer},v);let s;return d(l.provider)&&this.f&&(s=this.f.workspaceValue(l.extension)??this.f.globalValue(l.extension)),this.c.add(r,E,s),{editable:d(l.provider)}}async $disposeCustomDocument(a,r){const o=this.b.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${r}'`);const f=A.URI.revive(a),{document:v}=this.i(r,f);this.c.delete(r,v),v.dispose()}async $resolveCustomEditor(a,r,o,f,v,l){const I=this.b.get(o);if(!I)throw new Error(`No provider found for '${o}'`);const E=y.ViewColumn.to(v),s=this.g.createNewWebview(r,f.contentOptions,I.extension),i=this.h.createNewWebviewPanel(r,o,f.title,E,f.options,s,f.active),k=A.URI.revive(a);switch(I.type){case 1:{const{document:F}=this.i(o,k);return I.provider.resolveCustomEditor(F,i,l)}case 0:{const F=this.d.getDocument(k);return I.provider.resolveCustomTextEditor(F,i,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,r,o){this.i(r,a).disposeEdits(o)}async $onMoveCustomEditor(a,r,o){const f=this.b.get(o);if(!f)throw new Error(`No provider found for '${o}'`);if(!f.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const v=this.h.getWebviewPanel(a);if(!v)throw new Error("No webview found");const l=A.URI.revive(r),I=this.d.getDocument(l);await f.provider.moveCustomTextEditor(I,v,c.CancellationToken.None)}async $undo(a,r,o,f){return this.i(r,a).undo(o,f)}async $redo(a,r,o,f){return this.i(r,a).redo(o,f)}async $revert(a,r,o){const f=this.i(r,a);await this.j(r).revertCustomDocument(f.document,o),f.disposeBackup()}async $onSave(a,r,o){const f=this.i(r,a);await this.j(r).saveCustomDocument(f.document,o),f.disposeBackup()}async $onSaveAs(a,r,o,f){const v=this.i(r,a);return this.j(r).saveCustomDocumentAs(v.document,A.URI.revive(o),f)}async $backup(a,r,o){const f=this.i(r,a),l=await this.j(r).backupCustomDocument(f.document,{destination:f.getNewBackupUri()},o);return f.updateBackup(l),l.id}i(a,r){const o=this.c.get(a,A.URI.revive(r));if(!o)throw new Error("No custom document found");return o}j(a){const o=this.b.get(a)?.provider;if(!o||!d(o))throw new Error("Custom document is not editable");return o}}e.ExtHostCustomEditors=h;function d(t){return!!t.onDidChangeCustomDocument}function S(t){return typeof t.resolveCustomTextEditor=="function"}function w(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function p(t){const a=t.scheme===O.Schemas.file||t.scheme===O.Schemas.untitled?t.fsPath:t.toString();return(0,R.hash)(a)+""}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,R,u){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Ne=this&&this.__classPrivateFieldGet||function(re,e,c,R){if(c==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?R:c==="a"?R.call(re):R?R.value:e.get(re)};define(Ce[309],De([1,0,3,4,2,33,13,85,6,7]),function(re,e,c,R,u,O,L,A,y,g){"use strict";var T,P,m,D,C,b,n,h,d,S,w,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class a extends R.Disposable{constructor(v,l,I,E){super(),T.set(this,void 0),P.set(this,void 0),m.set(this,void 0),D.set(this,void 0),C.set(this,void 0),b.set(this,void 0),n.set(this,void 0),h.set(this,void 0),d.set(this,!0),S.set(this,void 0),w.set(this,!1),p.set(this,this.B(new c.Emitter)),this.onDidDispose=Ne(this,p,"f").event,t.set(this,this.B(new c.Emitter)),this.onDidChangeViewState=Ne(this,t,"f").event,Ze(this,T,v,"f"),Ze(this,P,l,"f"),Ze(this,D,I,"f"),Ze(this,m,E.viewType,"f"),Ze(this,C,E.panelOptions,"f"),Ze(this,h,E.viewColumn,"f"),Ze(this,b,E.title,"f"),Ze(this,S,E.active,"f")}dispose(){Ne(this,w,"f")||(Ze(this,w,!0,"f"),Ne(this,p,"f").fire(),Ne(this,P,"f").$disposeWebview(Ne(this,T,"f")),Ne(this,D,"f").dispose(),super.dispose())}get webview(){return this.c(),Ne(this,D,"f")}get viewType(){return this.c(),Ne(this,m,"f")}get title(){return this.c(),Ne(this,b,"f")}set title(v){this.c(),Ne(this,b,"f")!==v&&(Ze(this,b,v,"f"),Ne(this,P,"f").$setTitle(Ne(this,T,"f"),v))}get iconPath(){return this.c(),Ne(this,n,"f")}set iconPath(v){this.c(),Ne(this,n,"f")!==v&&(Ze(this,n,v,"f"),Ne(this,P,"f").$setIconPath(Ne(this,T,"f"),u.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return Ne(this,C,"f")}get viewColumn(){if(this.c(),!(typeof Ne(this,h,"f")=="number"&&Ne(this,h,"f")<0))return Ne(this,h,"f")}get active(){return this.c(),Ne(this,S,"f")}get visible(){return this.c(),Ne(this,d,"f")}_updateViewState(v){Ne(this,w,"f")||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(Ze(this,S,v.active,"f"),Ze(this,d,v.visible,"f"),Ze(this,h,v.viewColumn,"f"),Ne(this,t,"f").fire({webviewPanel:this}))}reveal(v,l){this.c(),Ne(this,P,"f").$reveal(Ne(this,T,"f"),{viewColumn:typeof v>"u"?void 0:L.ViewColumn.from(v),preserveFocus:!!l})}c(){if(Ne(this,w,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,P=new WeakMap,m=new WeakMap,D=new WeakMap,C=new WeakMap,b=new WeakMap,n=new WeakMap,h=new WeakMap,d=new WeakMap,S=new WeakMap,w=new WeakMap,p=new WeakMap,t=new WeakMap;class r{static c(){return(0,O.generateUuid)()}constructor(v,l,I){this.g=l,this.h=I,this.e=new Map,this.f=new Map,this.d=v.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(v,l,I,E,s={}){const i=typeof E=="object"?E.viewColumn:E,k={viewColumn:L.ViewColumn.from(i),preserveFocus:typeof E=="object"&&!!E.preserveFocus},F=(0,A.shouldSerializeBuffersForPostMessage)(v),$=r.c();this.d.$createWebviewPanel((0,A.toExtensionData)(v),$,l,{title:I,panelOptions:o(s),webviewOptions:(0,A.serializeWebviewOptions)(v,this.h,s),serializeBuffersForPostMessage:F},k);const j=this.g.createNewWebview($,s,v);return this.createNewWebviewPanel($,l,I,i,s,j,!0)}$onDidChangeWebviewPanelViewStates(v){const l=Object.keys(v);l.sort((I,E)=>{const s=v[I],i=v[E];return s.active?1:i.active?-1:+s.visible-+i.visible});for(const I of l){const E=this.getWebviewPanel(I);if(!E)continue;const s=v[I];E._updateViewState({active:s.active,visible:s.visible,viewColumn:L.ViewColumn.to(s.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.e.delete(v),this.g.deleteWebview(v)}registerWebviewPanelSerializer(v,l,I){if(this.f.has(l))throw new Error(`Serializer for '${l}' already registered`);return this.f.set(l,{serializer:I,extension:v}),this.d.$registerSerializer(l,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(v)}),new g.Disposable(()=>{this.f.delete(l),this.d.$unregisterSerializer(l)})}async $deserializeWebviewPanel(v,l,I,E){const s=this.f.get(l);if(!s)throw new Error(`No serializer found for '${l}'`);const{serializer:i,extension:k}=s,F=this.g.createNewWebview(v,I.webviewOptions,k),$=this.createNewWebviewPanel(v,l,I.title,E,I.panelOptions,F,I.active);await i.deserializeWebviewPanel($,I.state)}createNewWebviewPanel(v,l,I,E,s,i,k){const F=new a(v,this.d,i,{viewType:l,title:I,viewColumn:E,panelOptions:s,active:k});return this.e.set(v,F),F}getWebviewPanel(v){return this.e.get(v)}}e.ExtHostWebviewPanels=r;function o(f){return{enableFindWidget:f.enableFindWidget,retainContextWhenHidden:f.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,R,u){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Ne=this&&this.__classPrivateFieldGet||function(re,e,c,R){if(c==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?R:c==="a"?R.call(re):R?R.value:e.get(re)};define(Ce[310],De([1,0,3,4,85,13,6,7]),function(re,e,c,R,u,O,L,A){"use strict";var y,g,T,P,m,D,C,b,n,h,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends R.Disposable{constructor(t,a,r,o,f,v){super(),y.set(this,void 0),g.set(this,void 0),T.set(this,void 0),P.set(this,void 0),m.set(this,!1),D.set(this,void 0),C.set(this,void 0),b.set(this,void 0),n.set(this,void 0),h.set(this,this.B(new c.Emitter)),this.onDidChangeVisibility=Ne(this,h,"f").event,d.set(this,this.B(new c.Emitter)),this.onDidDispose=Ne(this,d,"f").event,Ze(this,T,r,"f"),Ze(this,C,o,"f"),Ze(this,y,t,"f"),Ze(this,g,a,"f"),Ze(this,P,f,"f"),Ze(this,D,v,"f")}dispose(){Ne(this,m,"f")||(Ze(this,m,!0,"f"),Ne(this,d,"f").fire(),Ne(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Ne(this,C,"f")}set title(t){this.a(),Ne(this,C,"f")!==t&&(Ze(this,C,t,"f"),Ne(this,g,"f").$setWebviewViewTitle(Ne(this,y,"f"),t))}get description(){return this.a(),Ne(this,b,"f")}set description(t){this.a(),Ne(this,b,"f")!==t&&(Ze(this,b,t,"f"),Ne(this,g,"f").$setWebviewViewDescription(Ne(this,y,"f"),t))}get visible(){return Ne(this,D,"f")}get webview(){return Ne(this,P,"f")}get viewType(){return Ne(this,T,"f")}_setVisible(t){t===Ne(this,D,"f")||Ne(this,m,"f")||(Ze(this,D,t,"f"),Ne(this,h,"f").fire())}get badge(){return this.a(),Ne(this,n,"f")}set badge(t){this.a(),!(t?.value===Ne(this,n,"f")?.value&&t?.tooltip===Ne(this,n,"f")?.tooltip)&&(Ze(this,n,O.ViewBadge.from(t),"f"),Ne(this,g,"f").$setWebviewViewBadge(Ne(this,y,"f"),t))}show(t){this.a(),Ne(this,g,"f").$show(Ne(this,y,"f"),!!t)}a(){if(Ne(this,m,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,g=new WeakMap,T=new WeakMap,P=new WeakMap,m=new WeakMap,D=new WeakMap,C=new WeakMap,b=new WeakMap,n=new WeakMap,h=new WeakMap,d=new WeakMap;class w{constructor(t,a){this.d=a,this.b=new Map,this.c=new Map,this.a=t.getProxy(L.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,a,r,o){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:r,extension:t}),this.a.$registerWebviewViewProvider((0,u.toExtensionData)(t),a,{retainContextWhenHidden:o?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,u.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(t,a,r,o,f){const v=this.b.get(a);if(!v)throw new Error(`No view provider found for '${a}'`);const{provider:l,extension:I}=v,E=this.d.createNewWebview(t,{},I),s=new S(t,this.a,a,r,E,!0);this.c.set(t,s),await l.resolveWebviewView(s,{state:o},f)}async $onDidChangeWebviewViewVisibility(t,a){this.e(t)._setVisible(a)}async $disposeWebviewView(t){const a=this.e(t);this.c.delete(t),a.dispose(),this.d.deleteWebview(t)}e(t){const a=this.c.get(t);if(!a)throw new Error("No webview found");return a}}e.ExtHostWebviewViews=w}),define(Ce[145],De([1,0,3,6,2,18,11,5,20,25]),function(re,e,c,R,u,O,L,A,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=e.ExtHostWindow=class On{getState(m){const D=this.d;return{get focused(){return D.focused},get active(){return(0,g.checkProposedApiEnabled)(m,"windowActivity"),D.active}}}constructor(m){this.c=new c.Emitter,this.onDidChangeWindowState=this.c.event,this.d=On.a,this.b=m.getProxy(R.MainContext.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:C})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",C)})}$onDidChangeWindowFocus(m){this.onDidChangeWindowProperty("focused",m)}$onDidChangeWindowActive(m){this.onDidChangeWindowProperty("active",m)}onDidChangeWindowProperty(m,D){D!==this.d[m]&&(this.d={...this.d,[m]:D},this.c.fire(this.d))}openUri(m,D){let C;if(typeof m=="string"){C=m;try{m=u.URI.parse(m)}catch{return Promise.reject(`Invalid uri - '${m}'`)}}return(0,L.isFalsyOrWhitespace)(m.scheme)?Promise.reject("Invalid scheme - cannot be empty"):m.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${m.scheme}'`):this.b.$openUri(m,C,D)}async asExternalUri(m,D){if((0,L.isFalsyOrWhitespace)(m.scheme))return Promise.reject("Invalid scheme - cannot be empty");const C=await this.b.$asExternalUri(m,D);return u.URI.from(C)}};T.a={focused:!0,active:!0},e.ExtHostWindow=T=qe([je(0,y.IExtHostRpcService)],T),e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ce[311],De([1,0,279,27,20]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const O=1024*1024;let L=e.ExtHostConsoleForwarder=class extends c.AbstractExtHostConsoleForwarder{constructor(y,g){super(y,g),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(y,g,T){const P=y==="error"||y==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),g.apply(console,T),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(y,g){const T=process[y],P=T.write;let m="";Object.defineProperty(T,"write",{set:()=>{},get:()=>(D,C,b)=>{if(!this.g){m+=D.toString(C);const n=m.length>O?m.length:m.lastIndexOf(`
`);n!==-1&&(console[g](m.slice(0,n)),m=m.slice(n+1))}P.call(T,D,C,b)}})}};e.ExtHostConsoleForwarder=L=qe([je(0,u.IExtHostRpcService),je(1,R.IExtHostInitDataService)],L)}),define(Ce[312],De([1,0,64,18,17,224,31]),function(re,e,c,R,u,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiskFileSystemProvider=void 0;let A=e.ExtHostDiskFileSystemProvider=class{constructor(T,P){T.addFileSystemProvider(R.Schemas.file,new y(P))}};e.ExtHostDiskFileSystemProvider=A=qe([je(0,c.IExtHostConsumerFileSystem),je(1,u.ILogService)],A);class y{constructor(T){this.b=T,this.a=new O.DiskFileSystemProvider(this.b)}async stat(T){const P=await this.a.stat(T);return{type:P.type,ctime:P.ctime,mtime:P.mtime,size:P.size,permissions:P.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(T){return this.a.readdir(T)}createDirectory(T){return this.a.mkdir(T)}readFile(T){return this.a.readFile(T)}writeFile(T,P,m){return this.a.writeFile(T,P,{...m,unlock:!1,atomic:!1})}delete(T,P){return this.a.delete(T,{...P,useTrash:!1,atomic:!1})}rename(T,P,m){return this.a.rename(T,P,m)}copy(T,P,m){return this.a.copy(T,P,m)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(T,P){throw new Error("Method not implemented.")}}}),define(Ce[313],De([1,0,10,74,33,37,4,6,2,20]),function(re,e,c,R,u,O,L,A,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let T=e.ExtHostDownloadService=class extends L.Disposable{constructor(m,D){super();const C=m.getProxy(A.MainContext.MainThreadDownloadService);D.registerCommand(!1,"_workbench.downloadResource",async b=>{const n=y.URI.file((0,c.join)((0,R.tmpdir)(),(0,u.generateUuid)()));return await C.$download(b,n),n})}};e.ExtHostDownloadService=T=qe([je(0,g.IExtHostRpcService),je(1,O.IExtHostCommands)],T)}),define(Ce[314],De([1,0,144,18,226,33]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class L extends c.ExtHostLoggerService{m(y,g,T){return y.scheme===R.Schemas.file?new u.SpdLogLogger(T?.name||(0,O.generateUuid)(),y.fsPath,!T?.donotRotate,!!T?.donotUseFormatters,g):super.m(y,g,T)}registerLogger(y){super.registerLogger(y),this.n.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this.n.$deregisterLogger(y)}}e.ExtHostLoggerService=L}),define(Ce[315],De([1,0,48,10,2,84,4,18,16,29]),function(re,e,c,R,u,O,L,A,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class T extends O.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(t){const a=await super.g(t);if(a.scheme!==A.Schemas.file)return a;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${a.fsPath}.`),a;const r=a.fsPath;let o=0;do{let f;o===0?f=r:f=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${o}`:`${r}-${o}`,await P(f);const v=R.join(f,"vscode.lock"),l=await b(this.d,v,!1);if(l)return this.i=l,process.on("exit",()=>{l.dispose()}),u.URI.file(f);o++}while(o<10);return a}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=T;async function P(p){try{await g.Promises.stat(p);return}catch{}try{await g.Promises.mkdir(p,{recursive:!0})}catch{}}const m=1e3,D=10*60*1e3;class C extends L.Disposable{constructor(t,a){super(),this.b=t,this.c=a,this.a=this.B(new y.IntervalTimer),this.a.cancelAndSet(async()=>{const r=await n(t,a);(!r||r.pid!==process.pid)&&(t.info(`Lock '${a}': The lock was lost unexpectedly.`),this.a.cancel());try{await g.Promises.utimes(a,new Date,new Date)}catch(o){t.error(o),t.info(`Lock '${a}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{c.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const a={pid:process.pid,willReleaseAt:Date.now()+t};await g.Promises.writeFile(this.c,JSON.stringify(a),{flag:"w"})}catch(a){this.b.error(a)}}}async function b(p,t,a){try{const o={pid:process.pid,willReleaseAt:0};await g.Promises.writeFile(t,JSON.stringify(o),{flag:"wx"})}catch(o){p.error(o)}const r=await n(p,t);return!r||r.pid!==process.pid?a?(p.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),S(p,t)):(p.info(`Lock '${t}': Lock acquired.`),new C(p,t))}async function n(p,t){let a;try{a=await g.Promises.readFile(t)}catch(r){return p.error(r),null}try{return JSON.parse(String(a))}catch(r){return p.error(r),null}}async function h(p,t){let a;try{a=await g.Promises.stat(t)}catch(r){return p.error(r),0}return a.mtime.getTime()}function d(p){try{return process.kill(p,0),!0}catch{return!1}}async function S(p,t){const a=await n(p,t);if(!a)return p.info(`Lock '${t}': Could not read pid of lock holder.`),w(p,t);if(a.willReleaseAt){let l=a.willReleaseAt-Date.now();if(l<5e3){for(l>0?p.info(`Lock '${t}': The lockfile is scheduled to be released in ${l} ms.`):p.info(`Lock '${t}': The lockfile is scheduled to have been released.`);l>0;){if(await(0,y.timeout)(Math.min(100,l)),await h(p,t)===0)return w(p,t);l=a.willReleaseAt-Date.now()}return w(p,t)}}if(!d(a.pid))return p.info(`Lock '${t}': The pid ${a.pid} appears to be gone.`),w(p,t);const r=await h(p,t),o=Date.now()-r;if(o<=D)return p.info(`Lock '${t}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;p.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const f=await h(p,t),v=Date.now()-f;return v<=D?(p.info(`Lock '${t}': The lock does not look stale, elapsed: ${v} ms, giving up.`),null):(p.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),w(p,t))}async function w(p,t){p.info(`Lock '${t}': Deleting a stale lock.`);try{await g.Promises.unlink(t)}catch{}return b(p,t,!0)}}),define(Ce[316],De([1,0,33,20,43]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let O=e.ExtHostTerminalService=class extends u.BaseExtHostTerminalService{constructor(A){super(!0,A)}createTerminal(A,y,g){return this.createTerminalFromOptions({name:A,shellPath:y,shellArgs:g})}createTerminalFromOptions(A,y){const g=new u.ExtHostTerminal(this.a,(0,c.generateUuid)(),A,A.name);return this.f.push(g),g.create(A,this.L(A,y)),g.value}};e.ExtHostTerminalService=O=qe([je(0,R.IExtHostRpcService)],O)}),define(Ce[317],De([1,0,6,20,200,4,27,2,45,24,29,7,9,58,3,132,111,17]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class d extends b.DisposableTunnel{}function S(l){const I=l.trim().split(`
`),E=[];return I.forEach(i=>{const k=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(i);k&&k.length>=3&&E.push({pid:parseInt(k[1],10),socket:parseInt(k[2],10)})}),E.reduce((i,k)=>(i[k.socket]=k,i),{})}e.getSockets=S;function w(...l){const I=[].concat(...l.map(t));return[...new Map(I.filter(E=>E.st==="0A").map(E=>{const s=E.local_address.split(":");return{socket:parseInt(E.inode,10),ip:p(s[0]),port:parseInt(s[1],16)}}).map(E=>[E.ip+":"+E.port,E])).values()]}e.loadListeningPorts=w;function p(l){let I="";if(l.length===8)for(let E=l.length-2;E>=0;E-=2)I+=parseInt(l.substr(E,2),16),E!==0&&(I+=".");else for(let E=0;E<l.length;E+=8){const s=l.substring(E,E+8);let i="";for(let k=8;k>=2;k-=2)i+=s.substring(k-2,k),(k===6||k===2)&&(i=parseInt(i,16).toString(16),I+=`${i}`,i="",E+k!==l.length-6&&(I+=":"))}return I}e.parseIpAddress=p;function t(l){const I=l.trim().split(`
`),E=I.shift().trim().split(/\s+/).filter(i=>i!=="rx_queue"&&i!=="tm->when");return I.map(i=>i.trim().split(/\s+/).reduce((k,F,$)=>(k[E[$]||$]=F,k),{}))}e.loadConnectionTable=t;function a(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/server-main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function r(l){const I=l.trim().split(`
`),E=[];return I.forEach(s=>{const i=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(s);i&&i.length>=4&&E.push({pid:parseInt(i[1],10),ppid:parseInt(i[2]),cmd:i[3]})}),E}e.getRootProcesses=r;async function o(l,I,E){const s=E.reduce((k,F)=>(k[F.pid]=F,k),{}),i=[];return l.forEach(({socket:k,ip:F,port:$})=>{const j=I[k]?I[k].pid:void 0,W=j?s[j]?.cmd:void 0;j&&W&&!a(W)&&i.push({host:F,port:$,detail:W,pid:j})}),i}e.findPorts=o;function f(l,I,E){const s=new Map,i=r(I);for(const k of l){const F=E.get(k.port);if(F){s.set(k.port,F);continue}const $=i.find(j=>j.cmd.includes(`${k.port}`));if($){let j=$,W;do W=i.find(U=>U.ppid===j.pid),W&&(j=W);while(W);s.set(k.port,{host:k.ip,port:k.port,pid:j.pid,detail:j.cmd,ppid:j.ppid})}else s.set(k.port,{host:k.ip,port:k.port,ppid:Number.MAX_VALUE})}return s}e.tryFindRootPorts=f;let v=e.ExtHostTunnelService=class extends O.Disposable{constructor(I,E,s){super(),this.s=s,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new C.Emitter,this.onDidChangeTunnels=this.h.event,this.k=!1,this.l=new Map,this.n=void 0,this.p=0,this.r=new Map,this.a=I.getProxy(c.MainContext.MainThreadTunnelService),m.isLinux&&E.remote.isRemote&&E.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.t())}async openTunnel(I,E){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${I.identifier.value} called openTunnel API for ${E.remoteAddress.host}:${E.remoteAddress.port}.`);const s=await this.a.$openTunnel(E,I.displayName);if(s){const i=new d(s.remoteAddress,s.localAddress,()=>this.a.$closeTunnel(s.remoteAddress));return this.B(i),i}}async t(){this.n=await this.w(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.n.map(I=>I.port).join(", ")}`)}async getTunnels(){return this.a.$getTunnels()}u(I){return Math.max(I*20,2e3)}v(){return this.p++}registerPortsAttributesProvider(I,E){const s=this.v();return this.r.set(s,{selector:I,provider:E}),this.a.$registerPortsAttributesProvider(I,s),new P.Disposable(()=>{this.r.delete(s),this.a.$unregisterPortsAttributesProvider(s)})}async $providePortAttributes(I,E,s,i,k){const F=[];for(const j of I){const W=this.r.get(j);if(!W)return[];F.push(...await Promise.all(E.map(async U=>({providedAttributes:await W.provider.providePortAttributes(U,s,i,k),port:U}))))}const $=F.filter(j=>!!j.providedAttributes);return $.length>0?$.map(j=>({autoForwardAction:j.providedAttributes.autoForwardAction,port:j.port})):[]}async $registerCandidateFinder(I){if(I&&this.k)return;this.k=I;let E;this.n&&(E=this.n,await this.a.$onFoundNewCandidates(this.n));const s=new n.MovingAverage;let i=0;for(;this.k;){const k=new Date().getTime(),F=(await this.w()).filter(W=>(0,b.isLocalhost)(W.host)||(0,b.isAllInterfaces)(W.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(W=>W.port).join(", ")}`);const $=new Date().getTime()-k;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${$} ms.`),i++>3&&s.update($),(!E||JSON.stringify(E)!==JSON.stringify(F))&&(E=F,await this.a.$onFoundNewCandidates(E));const j=this.u(s.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${j} ms.`),await new Promise(W=>setTimeout(()=>W(),j))}}async setTunnelFactory(I){if(I){if(I.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(I.candidatePortSource),I.showCandidatePort&&(this.f=I.showCandidatePort,this.a.$setCandidateFilter()),I.tunnelFactory){this.b=I.tunnelFactory;let E=I.tunnelFeatures?.privacyOptions??[];I.tunnelFeatures?.public&&E.length===0&&(E=[{id:"private",label:u.localize(0,null),themeIcon:"lock"},{id:"public",label:u.localize(1,null),themeIcon:"eye"}]);const s=I.tunnelFeatures?{elevation:!!I.tunnelFeatures?.elevation,public:!!I.tunnelFeatures?.public,privacyOptions:E}:void 0;this.a.$setTunnelProvider(s)}}else this.b=void 0;return(0,O.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(I,E){if(this.g.has(I.host)){const s=this.g.get(I.host);s.has(I.port)&&(E&&s.get(I.port).disposeListener.dispose(),await s.get(I.port).tunnel.dispose(),s.delete(I.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(I,E){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const s=this.b(I,E);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),s!==void 0){const i=await s;this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.g.has(I.remoteAddress.host)||this.g.set(I.remoteAddress.host,new Map);const k=this.B(i.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(i.remoteAddress))));return this.g.get(I.remoteAddress.host).set(I.remoteAddress.port,{tunnel:i,disposeListener:k}),D.TunnelDtoConverter.fromApiTunnel(i)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(I){const E=await Promise.all(I.map(i=>this.f(i.host,i.port,i.detail??""))),s=I.filter((i,k)=>E[k]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${I.map(i=>i.port).join(", ")} to ${s.map(i=>i.port).join(", ")}`),s}async w(){let I="",E="";try{I=await T.Promises.readFile("/proc/net/tcp","utf8"),E=await T.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const s=w(I,E),i=await new Promise(B=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(z,ee,se)=>{B(ee)})}),k=S(i),F=await T.Promises.readdir("/proc"),$=[];for(const B of F)try{const z=Number(B),ee=g.joinPath(A.URI.file("/proc"),B);if((await T.Promises.stat(ee.fsPath)).isDirectory()&&!isNaN(z)){const V=await T.Promises.readlink(g.joinPath(ee,"cwd").fsPath),Z=await T.Promises.readFile(g.joinPath(ee,"cmdline").fsPath,"utf8");$.push({pid:z,cwd:V,cmd:Z})}}catch{}const j=[],W=s.filter(B=>{const z=k[B.socket];return z||j.push(B),z}),U=o(W,k,$);let x;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${j.length}`),j.length>0){const B=await new Promise(z=>{(0,y.exec)("ps -F -A -l | grep root",(ee,se,V)=>{z(se)})});this.l=f(j,B,this.l),x=Array.from(this.l.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${x.map(z=>z.port).join(", ")}`)}return U.then(B=>x?B.concat(x):B)}};e.ExtHostTunnelService=v=qe([je(0,R.IExtHostRpcService),je(1,L.IExtHostInitDataService),je(2,h.ILogService)],v)}),define(Ce[318],De([1,0,16,22,21,8,3,4,118,272,61]),function(re,e,c,R,u,O,L,A,y,g,T){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(s,i){try{return JSON.stringify(s,i)}catch{return"null"}}const D="$$ref$$",C={[D]:-1};class b{constructor(i,k){this.jsonString=i,this.referencedBuffers=k}}function n(s,i=null,k=!1){const F=[];return{jsonString:(k?m:JSON.stringify)(s,(j,W)=>{if(typeof W>"u")return C;if(typeof W=="object"){if(W instanceof R.VSBuffer){const U=F.push(W)-1;return{[D]:U}}if(i)return i(j,W)}return W}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=n;function h(s,i,k){return JSON.parse(s,(F,$)=>{if($){const j=$[D];if(typeof j=="number")return i[j];if(k&&$.$mid===1)return k.transformIncoming($)}return $})}e.parseJsonAndRestoreBufferRefs=h;function d(s,i){return JSON.stringify(s,i)}function S(s){return s?(i,k)=>k&&k.$mid===1?s.transformOutgoing(k):k:null}var w;(function(s){s[s.LocalSide=0]="LocalSide",s[s.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));var p;(function(s){s[s.Responsive=0]="Responsive",s[s.Unresponsive=1]="Unresponsive"})(p||(e.ResponsiveState=p={}));const t=()=>{},a=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class o extends A.Disposable{constructor(i,k=null,F=null){super(),this[P]=!0,this.b=this.B(new L.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=i,this.f=k,this.g=F,this.h=S(this.g),this.j=!1,this.k=[],this.l=[];for(let $=0,j=T.ProxyIdentifier.count;$<j;$++)this.k[$]=null,this.l[$]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new c.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage($=>this.G($))}dispose(){this.j=!0,Object.keys(this.s).forEach(i=>{this.s[i].resolveErr(O.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(i){this.u===0&&(this.v=Date.now()+o.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(i){this.v=Date.now()+o.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(i){this.t!==i&&(this.t=i,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(i){return this.g?(0,y.transformIncomingURIs)(i,this.g):i}getProxy(i){const{nid:k,sid:F}=i;return this.l[k]||(this.l[k]=this.F(k,F)),this.l[k]}F(i,k){const F={get:($,j)=>(typeof j=="string"&&!$[j]&&j.charCodeAt(0)===36&&($[j]=(...W)=>this.O(i,j,W)),j===r?k:$[j])};return new Proxy(Object.create(null),F)}set(i,k){return this.k[i.nid]=k,k}assertRegistered(i){for(let k=0,F=i.length;k<F;k++){const $=i[k];if(!this.k[$.nid])throw new Error(`Missing proxy instance ${$.sid}`)}}G(i){if(this.j)return;const k=i.byteLength,F=f.read(i,0),$=F.readUInt8(),j=F.readUInt32();switch($){case 1:case 2:{let{rpcId:W,method:U,args:x}=l.deserializeRequestJSONArgs(F);this.g&&(x=(0,y.transformIncomingURIs)(x,this.g)),this.H(k,j,W,U,x,$===2);break}case 3:case 4:{let{rpcId:W,method:U,args:x}=l.deserializeRequestMixedArgs(F);this.g&&(x=(0,y.transformIncomingURIs)(x,this.g)),this.H(k,j,W,U,x,$===4);break}case 5:{this.f?.logIncoming(k,j,0,"ack"),this.z(j);break}case 6:{this.I(k,j);break}case 7:{this.J(k,j,void 0);break}case 9:{let W=l.deserializeReplyOKJSON(F);this.g&&(W=(0,y.transformIncomingURIs)(W,this.g)),this.J(k,j,W);break}case 10:{const W=l.deserializeReplyOKJSONWithBuffers(F,this.g);this.J(k,j,W);break}case 8:{const W=l.deserializeReplyOKVSBuffer(F);this.J(k,j,W);break}case 11:{let W=l.deserializeReplyErrError(F);this.g&&(W=(0,y.transformIncomingURIs)(W,this.g)),this.L(k,j,W);break}case 12:{this.L(k,j,void 0);break}default:console.error("received unexpected message"),console.error(i)}}H(i,k,F,$,j,W){this.f?.logIncoming(i,k,1,`receiveRequest ${(0,T.getStringIdentifierForProxy)(F)}.${$}(`,j);const U=String(k);let x,B;if(W){const ee=new u.CancellationTokenSource;j.push(ee.token),x=this.M(F,$,j),B=()=>ee.cancel()}else x=this.M(F,$,j),B=t;this.p[U]=B;const z=l.serializeAcknowledged(k);this.f?.logOutgoing(z.byteLength,k,1,"ack"),this.c.send(z),x.then(ee=>{delete this.p[U];const se=l.serializeReplyOK(k,ee,this.h);this.f?.logOutgoing(se.byteLength,k,1,"reply:",ee),this.c.send(se)},ee=>{delete this.p[U];const se=l.serializeReplyErr(k,ee);this.f?.logOutgoing(se.byteLength,k,1,"replyErr:",ee),this.c.send(se)})}I(i,k){this.f?.logIncoming(i,k,1,"receiveCancel");const F=String(k);this.p[F]?.()}J(i,k,F){this.f?.logIncoming(i,k,0,"receiveReply:",F);const $=String(k);if(!this.s.hasOwnProperty($))return;const j=this.s[$];delete this.s[$],j.resolveOk(F)}L(i,k,F){this.f?.logIncoming(i,k,0,"receiveReplyErr:",F);const $=String(k);if(!this.s.hasOwnProperty($))return;const j=this.s[$];delete this.s[$];let W;F&&(F.$isError?(W=new Error,W.name=F.name,W.message=F.message,W.stack=F.stack):W=F),j.resolveErr(W)}M(i,k,F){try{return Promise.resolve(this.N(i,k,F))}catch($){return Promise.reject($)}}N(i,k,F){const $=this.k[i];if(!$)throw new Error("Unknown actor "+(0,T.getStringIdentifierForProxy)(i));const j=$[k];if(typeof j!="function")throw new Error("Unknown method "+k+" on actor "+(0,T.getStringIdentifierForProxy)(i));return j.apply($,F)}O(i,k,F){if(this.j)return new g.CanceledLazyPromise;let $=null;if(F.length>0&&u.CancellationToken.isCancellationToken(F[F.length-1])&&($=F.pop()),$&&$.isCancellationRequested)return Promise.reject(O.canceled());const j=l.serializeRequestArguments(F,this.h),W=++this.m,U=String(W),x=new g.LazyPromise;$&&$.onCancellationRequested(()=>{const z=l.serializeCancel(W);this.f?.logOutgoing(z.byteLength,W,0,"cancel"),this.c.send(l.serializeCancel(W))}),this.s[U]=x,this.y(W);const B=l.serializeRequest(W,i,k,j,!!$);return this.f?.logOutgoing(B.byteLength,W,0,`request: ${(0,T.getStringIdentifierForProxy)(i)}.${k}(`,F),this.c.send(B),x}}e.RPCProtocol=o,P=a,o.a=3*1e3;class f{static alloc(i,k,F){const $=new f(R.VSBuffer.alloc(F+1+4),0);return $.writeUInt8(i),$.writeUInt32(k),$}static read(i,k){return new f(i,k)}get buffer(){return this.a}constructor(i,k){this.a=i,this.b=k}static sizeUInt8(){return 1}writeUInt8(i){this.a.writeUInt8(i,this.b),this.b+=1}readUInt8(){const i=this.a.readUInt8(this.b);return this.b+=1,i}writeUInt32(i){this.a.writeUInt32BE(i,this.b),this.b+=4}readUInt32(){const i=this.a.readUInt32BE(this.b);return this.b+=4,i}static sizeShortString(i){return 1+i.byteLength}writeShortString(i){this.a.writeUInt8(i.byteLength,this.b),this.b+=1,this.a.set(i,this.b),this.b+=i.byteLength}readShortString(){const i=this.a.readUInt8(this.b);this.b+=1;const F=this.a.slice(this.b,this.b+i).toString();return this.b+=i,F}static sizeLongString(i){return 4+i.byteLength}writeLongString(i){this.a.writeUInt32BE(i.byteLength,this.b),this.b+=4,this.a.set(i,this.b),this.b+=i.byteLength}readLongString(){const i=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+i).toString();return this.b+=i,F}writeBuffer(i){this.a.writeUInt32BE(i.byteLength,this.b),this.b+=4,this.a.set(i,this.b),this.b+=i.byteLength}static sizeVSBuffer(i){return 4+i.byteLength}writeVSBuffer(i){this.a.writeUInt32BE(i.byteLength,this.b),this.b+=4,this.a.set(i,this.b),this.b+=i.byteLength}readVSBuffer(){const i=this.a.readUInt32BE(this.b);this.b+=4;const k=this.a.slice(this.b,this.b+i);return this.b+=i,k}static sizeMixedArray(i){let k=0;k+=1;for(let F=0,$=i.length;F<$;F++){const j=i[F];switch(k+=1,j.type){case 1:k+=this.sizeLongString(j.value);break;case 2:k+=this.sizeVSBuffer(j.value);break;case 3:k+=this.sizeUInt32,k+=this.sizeLongString(j.value);for(let W=0;W<j.buffers.length;++W)k+=this.sizeVSBuffer(j.buffers[W]);break;case 4:break}}return k}writeMixedArray(i){this.a.writeUInt8(i.length,this.b),this.b+=1;for(let k=0,F=i.length;k<F;k++){const $=i[k];switch($.type){case 1:this.writeUInt8(1),this.writeLongString($.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer($.value);break;case 3:this.writeUInt8(3),this.writeUInt32($.buffers.length),this.writeLongString($.value);for(let j=0;j<$.buffers.length;++j)this.writeBuffer($.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const i=this.a.readUInt8(this.b);this.b+=1;const k=new Array(i);for(let F=0;F<i;F++)switch(this.readUInt8()){case 1:k[F]=this.readLongString();break;case 2:k[F]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),W=this.readLongString(),U=[];for(let x=0;x<j;++x)U.push(this.readVSBuffer());k[F]=new T.SerializableObjectWithBuffers(h(W,U,null));break}case 4:k[F]=void 0;break}return k}}f.sizeUInt32=4;var v;(function(s){s[s.Simple=0]="Simple",s[s.Mixed=1]="Mixed"})(v||(v={}));class l{static a(i){for(let k=0,F=i.length;k<F;k++)if(i[k]instanceof R.VSBuffer||i[k]instanceof T.SerializableObjectWithBuffers||typeof i[k]>"u")return!0;return!1}static serializeRequestArguments(i,k){if(this.a(i)){const F=[];for(let $=0,j=i.length;$<j;$++){const W=i[$];if(W instanceof R.VSBuffer)F[$]={type:2,value:W};else if(typeof W>"u")F[$]={type:4};else if(W instanceof T.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:x}=n(W.value,k);F[$]={type:3,value:R.VSBuffer.fromString(U),buffers:x}}else F[$]={type:1,value:R.VSBuffer.fromString(d(W,k))}}return{type:1,args:F}}return{type:0,args:d(i,k)}}static serializeRequest(i,k,F,$,j){switch($.type){case 0:return this.b(i,k,F,$.args,j);case 1:return this.c(i,k,F,$.args,j)}}static b(i,k,F,$,j){const W=R.VSBuffer.fromString(F),U=R.VSBuffer.fromString($);let x=0;x+=f.sizeUInt8(),x+=f.sizeShortString(W),x+=f.sizeLongString(U);const B=f.alloc(j?2:1,i,x);return B.writeUInt8(k),B.writeShortString(W),B.writeLongString(U),B.buffer}static deserializeRequestJSONArgs(i){const k=i.readUInt8(),F=i.readShortString(),$=i.readLongString();return{rpcId:k,method:F,args:JSON.parse($)}}static c(i,k,F,$,j){const W=R.VSBuffer.fromString(F);let U=0;U+=f.sizeUInt8(),U+=f.sizeShortString(W),U+=f.sizeMixedArray($);const x=f.alloc(j?4:3,i,U);return x.writeUInt8(k),x.writeShortString(W),x.writeMixedArray($),x.buffer}static deserializeRequestMixedArgs(i){const k=i.readUInt8(),F=i.readShortString(),$=i.readMixedArray(),j=new Array($.length);for(let W=0,U=$.length;W<U;W++){const x=$[W];typeof x=="string"?j[W]=JSON.parse(x):j[W]=x}return{rpcId:k,method:F,args:j}}static serializeAcknowledged(i){return f.alloc(5,i,0).buffer}static serializeCancel(i){return f.alloc(6,i,0).buffer}static serializeReplyOK(i,k,F){if(typeof k>"u")return this.d(i);if(k instanceof R.VSBuffer)return this.e(i,k);if(k instanceof T.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:j}=n(k.value,F,!0);return this.g(i,$,j)}else return this.f(i,m(k,F))}static d(i){return f.alloc(7,i,0).buffer}static e(i,k){let F=0;F+=f.sizeVSBuffer(k);const $=f.alloc(8,i,F);return $.writeVSBuffer(k),$.buffer}static deserializeReplyOKVSBuffer(i){return i.readVSBuffer()}static f(i,k){const F=R.VSBuffer.fromString(k);let $=0;$+=f.sizeLongString(F);const j=f.alloc(9,i,$);return j.writeLongString(F),j.buffer}static g(i,k,F){const $=R.VSBuffer.fromString(k);let j=0;j+=f.sizeUInt32,j+=f.sizeLongString($);for(const U of F)j+=f.sizeVSBuffer(U);const W=f.alloc(10,i,j);W.writeUInt32(F.length),W.writeLongString($);for(const U of F)W.writeBuffer(U);return W.buffer}static deserializeReplyOKJSON(i){const k=i.readLongString();return JSON.parse(k)}static deserializeReplyOKJSONWithBuffers(i,k){const F=i.readUInt32(),$=i.readLongString(),j=[];for(let W=0;W<F;++W)j.push(i.readVSBuffer());return new T.SerializableObjectWithBuffers(h($,j,k))}static serializeReplyErr(i,k){const F=k?m(O.transformErrorForSerialization(k),null):void 0;if(typeof F!="string")return this.h(i);const $=R.VSBuffer.fromString(F);let j=0;j+=f.sizeLongString($);const W=f.alloc(11,i,j);return W.writeLongString($),W.buffer}static deserializeReplyErrError(i){const k=i.readLongString();return JSON.parse(k)}static h(i){return f.alloc(12,i,0).buffer}}var I;(function(s){s[s.RequestJSONArgs=1]="RequestJSONArgs",s[s.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",s[s.RequestMixedArgs=3]="RequestMixedArgs",s[s.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",s[s.Acknowledged=5]="Acknowledged",s[s.Cancel=6]="Cancel",s[s.ReplyOKEmpty=7]="ReplyOKEmpty",s[s.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",s[s.ReplyOKJSON=9]="ReplyOKJSON",s[s.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",s[s.ReplyErrError=11]="ReplyErrError",s[s.ReplyErrEmpty=12]="ReplyErrEmpty"})(I||(I={}));var E;(function(s){s[s.String=1]="String",s[s.VSBuffer=2]="VSBuffer",s[s.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",s[s.Undefined=4]="Undefined"})(E||(E={}))}),define(Ce[319],De([1,0,3,42,47,5]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new u.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new u.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new u.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,O.createDecorator)("outputService");var L;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.a=new Map,this.b=new c.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new c.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(T=>g.push(T)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}R.Registry.add(e.Extensions.OutputChannels,new A),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new u.RawContextKey("activeOutputChannel","")}),define(Ce[146],De([1,0,6,5,20,26,17,319,64,27,50,173,22,12,31,3,4]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class h extends L.AbstractMessageLogger{get disposed(){return this.l}constructor(p,t,a,r,o){super(),this.id=p,this.name=t,this.m=a,this.n=r,this.extension=o,this.k=0,this.l=!1,this.visible=!1,this.setLevel(a.getLevel()),this.B(a.onDidChangeLogLevel(f=>this.setLevel(f)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,p)}replace(p){const t=this.k;this.info(p),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(p,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:t))}hide(){this.n.$close(this.id)}g(p,t){this.k+=m.VSBuffer.fromString(t).byteLength,(0,L.log)(this.m,p,t),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class d extends h{appendLine(p){this.append(p)}}let S=e.ExtHostOutputService=class{constructor(p,t,a,r,o,f){this.i=t,this.j=a,this.k=r,this.l=o,this.m=f,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(c.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[t,a]of this.g)a.visible=t===this.h}createOutputChannel(p,t,a){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,o=(0,D.isString)(t)?t:void 0;if((0,D.isString)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let f;const v=this.i.environment.extensionLogLevel?.find(([I])=>O.ExtensionIdentifier.equals(a.identifier,I))?.[1];v&&(f=(0,L.parseLogLevel)(v));const l=r?this.o(p,f,a):this.n(p,o,a);return l.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),r?this.r(p,f??this.m.getLevel(),l):this.q(p,l)}async n(p,t,a){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,o=this.k.extUri.joinPath(r,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),v=await this.a.$register(p,o,t,a.identifier.value);return new h(v,p,f,this.a,a)}async o(p,t,a){const r=await this.p(a),o=p.replace(/[\\/:\*\?"<>\|]/g,""),f=this.k.extUri.joinPath(r,`${o}.log`),v=`${a.identifier.value}.${o}`,l=this.l.createLogger(f,{id:v,name:p,logLevel:t,extensionId:a.identifier.value});return new d(v,p,l,this.a,a)}p(p){let t=this.d.get(p.identifier.value);if(!t){const a=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(a)}catch(r){if((0,C.toFileSystemProviderErrorCode)(r)!==C.FileSystemProviderErrorCode.FileExists)throw r}return a})())}return t}q(p,t){let a=!1;const r=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return p},append(o){r(),t.then(f=>f.append(o))},appendLine(o){r(),t.then(f=>f.appendLine(o))},clear(){r(),t.then(o=>o.clear())},replace(o){r(),t.then(f=>f.replace(o))},show(o,f){r(),t.then(v=>v.show(o,f))},hide(){r(),t.then(o=>o.hide())},dispose(){a=!0,t.then(o=>o.dispose())}}}r(p,t,a){const r=new n.DisposableStore,o=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},f=r.add(new b.Emitter);function v(l){t=l,f.fire(l)}return a.then(l=>{r.add(l),l.logLevel!==t&&v(l.logLevel),r.add(l.onDidChangeLogLevel(I=>v(I)))}),{...this.q(p,a),get logLevel(){return t},onDidChangeLogLevel:f.event,trace(l,...I){o(),a.then(E=>E.trace(l,...I))},debug(l,...I){o(),a.then(E=>E.debug(l,...I))},info(l,...I){o(),a.then(E=>E.info(l,...I))},warn(l,...I){o(),a.then(E=>E.warn(l,...I))},error(l,...I){o(),a.then(E=>E.error(l,...I))},dispose(){r.dispose()}}}};e.ExtHostOutputService=S=qe([je(0,u.IExtHostRpcService),je(1,g.IExtHostInitDataService),je(2,y.IExtHostConsumerFileSystem),je(3,T.IExtHostFileSystemInfo),je(4,L.ILoggerService),je(5,L.ILogService)],S),e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")});var Ne=this&&this.__classPrivateFieldGet||function(re,e,c,R){if(c==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?R:c==="a"?R.call(re):R?R.value:e.get(re)},Ze=this&&this.__classPrivateFieldSet||function(re,e,c,R,u){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c};define(Ce[320],De([1,0,5,16]),function(re,e,c,R){"use strict";var u,O,L,A,y,g,T,P,m,D,C;Object.defineProperty(e,"__esModule",{value:!0}),e.remoteConnectionLatencyMeasurer=e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService"),e.remoteConnectionLatencyMeasurer=new(C=class{constructor(){u.set(this,5),O.set(this,2e3),L.set(this,[]),A.set(this,3),y.set(this,[]),g.set(this,100),T.set(this,2),P.set(this,500),m.set(this,1500),D.set(this,void 0)}get latency(){return Ne(this,D,"f")}async measure(b){let n=1/0;for(let d=0;d<Ne(this,u,"f");d++){const S=await b.getRoundTripTime();if(S===void 0)return;n=Math.min(n,S/2),await(0,R.timeout)(Ne(this,O,"f"))}Ne(this,y,"f").push(n),Ne(this,y,"f").length>Ne(this,g,"f")&&Ne(this,y,"f").shift();let h;return Ne(this,L,"f").length<Ne(this,A,"f")?Ne(this,L,"f").push(n):h=Ne(this,L,"f").reduce((d,S)=>d+S,0)/Ne(this,L,"f").length,Ze(this,D,{initial:h,current:n,average:Ne(this,y,"f").reduce((d,S)=>d+S,0)/Ne(this,y,"f").length,high:(()=>typeof h>"u"?!1:n>Ne(this,m,"f")||n>Ne(this,P,"f")&&n>h*Ne(this,T,"f"))()},"f"),Ne(this,D,"f")}},u=new WeakMap,O=new WeakMap,L=new WeakMap,A=new WeakMap,y=new WeakMap,g=new WeakMap,T=new WeakMap,P=new WeakMap,m=new WeakMap,D=new WeakMap,C)}),define(Ce[321],De([1,0,30,18,10,9,24,2,5,240,49,258,320]),function(re,e,c,R,u,O,L,A,y,g,T,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=e.AbstractPathService=class Fn{constructor(b,n,h,d){this.d=b,this.e=n,this.f=h,this.g=d,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const S=await this.e.getEnvironment();return this.c=S?.userHome??b})()}hasValidBasename(b,n,h){return typeof n=="string"||typeof n>"u"?this.a.then(d=>this.h(b,d,n)):this.h(b,n,h)}h(b,n,h){return b.scheme===R.Schemas.file||b.scheme===R.Schemas.vscodeRemote?(0,c.isValidBasename)(h??(0,L.basename)(b),n===1):!0}get defaultUriScheme(){return Fn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(b,n){if(b.remoteAuthority)return R.Schemas.vscodeRemote;const h=(0,g.getVirtualWorkspaceScheme)(n.getWorkspace());if(h)return h;const d=n.getWorkspace().folders[0];if(d)return d.uri.scheme;const S=n.getWorkspace().configuration;return S?S.scheme:R.Schemas.file}userHome(b){return b?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(b=>b===1?u.win32:u.posix)}async fileURI(b){let n="";if(await this.a===1&&(b=b.replace(/\\/g,"/")),b[0]==="/"&&b[1]==="/"){const d=b.indexOf("/",2);d===-1?(n=b.substring(2),b="/"):(n=b.substring(2,d),b=b.substring(d)||"/")}return A.URI.from({scheme:R.Schemas.file,authority:n,path:b,query:"",fragment:""})}};e.AbstractPathService=D=qe([je(1,m.IRemoteAgentService),je(2,P.IWorkbenchEnvironmentService),je(3,T.IWorkspaceContextService)],D)}),define(Ce[86],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(L,A){this.line=L,this.character=A}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,A){return new c(0,0)}with(L){return new c(0,0)}}e.Position=c;class R{constructor(L,A,y,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(L,A),this.end=new c(y,g)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new R(0,0,0,0)}with(L){return new R(0,0,0,0)}}e.Range=R;var u;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(u||(e.TextSearchCompleteMessageType=u={}))}),define(Ce[34],De([1,0,19,32,23,30,11,5,10,8,86,16]),function(re,e,c,R,u,O,L,A,y,g,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",D=" characters skipped \u27EB",C=(m.length+D.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var b;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text"})(b||(e.SearchProviderType=b={}));var n;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text"})(n||(e.QueryType=n={}));function h(Z){return!!Z.preview}e.resultIsMatch=h;function d(Z){return!!Z.resource}e.isFileMatch=d;function S(Z){return!!Z.message}e.isProgressMessage=S;var w;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(w||(e.SearchCompletionExitCode=w={}));class p{constructor(q){this.resource=q,this.results=[]}}e.FileMatch=p;class t{constructor(q,ae,Ee,ye){this.ranges=ae,this.webviewIndex=ye;const be=Array.isArray(ae)?ae:[ae];if(Ee&&Ee.matchLines===1&&a(be)){q=(0,L.getNLines)(q,Ee.matchLines);let M="",Q=0,fe=0;const we=Math.floor(Ee.charsPerLine/5),_=[];for(const ne of be){const le=Math.max(ne.startColumn-we,0),te=ne.startColumn+Ee.charsPerLine;if(le>fe+we+C){const de=m+(le-fe)+D;M+=de+q.slice(le,te),Q+=le-(fe+de.length)}else M+=q.slice(fe,te);_.push(new o(0,ne.startColumn-Q,ne.endColumn-Q)),fe=te}this.preview={text:M,matches:Array.isArray(this.ranges)?_:_[0]}}else{const M=Array.isArray(ae)?ae[0].startLineNumber:ae.startLineNumber;this.preview={text:q,matches:(0,c.mapArrayOrNot)(ae,Q=>new r(Q.startLineNumber-M,Q.startColumn,Q.endLineNumber-M,Q.endColumn))}}}}e.TextSearchMatch=t;function a(Z){const q=Z[0].startLineNumber;for(const ae of Z)if(ae.startLineNumber!==q||ae.endLineNumber!==q)return!1;return!0}class r{constructor(q,ae,Ee,ye){this.startLineNumber=q,this.startColumn=ae,this.endLineNumber=Ee,this.endColumn=ye}}e.SearchRange=r;class o extends r{constructor(q,ae,Ee){super(q,ae,q,Ee)}}e.OneLineRange=o;var f;(function(Z){Z.List="list",Z.Tree="tree"})(f||(e.ViewMode=f={}));var v;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(v||(e.SearchSortOrder=v={}));function l(Z,q=!0){const ae=Z&&Z.files&&Z.files.exclude,Ee=q&&Z&&Z.search&&Z.search.exclude;if(!ae&&!Ee)return;if(!ae||!Ee)return ae||Ee;let ye=Object.create(null);return ye=u.mixin(ye,u.deepClone(ae)),ye=u.mixin(ye,u.deepClone(Ee),!0),ye}e.getExcludes=l;function I(Z,q){return Z.excludePattern&&R.match(Z.excludePattern,q)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&R.match(Z.includePattern,q)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(ae=>{const Ee=ae.folder.fsPath;if(O.isEqualOrParent(q,Ee)){const ye=y.relative(Ee,q);return!ae.includePattern||!!R.match(ae.includePattern,ye)}else return!1}):!1:!0}e.pathIncludedInQuery=I;var E;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(E||(e.SearchErrorCode=E={}));class s extends Error{constructor(q,ae){super(q),this.code=ae}}e.SearchError=s;function i(Z){const q=Z.message;if((0,g.isCancellationError)(Z))return new s(q,E.canceled);try{const ae=JSON.parse(q);return new s(ae.message,ae.code)}catch{return new s(q,E.other)}}e.deserializeSearchError=i;function k(Z){const q={message:Z.message,code:Z.code};return new Error(JSON.stringify(q))}e.serializeSearchError=k;function F(Z){return Z.type==="error"?!0:Z.type==="success"}e.isSerializedSearchComplete=F;function $(Z){return Z.type==="success"}e.isSerializedSearchSuccess=$;function j(Z){return!!Z.path}e.isSerializedFileMatch=j;function W(Z,q){const ae=Z.searchPath?Z.searchPath:Z.relativePath;return(0,L.fuzzyContains)(ae,q)}e.isFilePatternMatch=W;class U{constructor(q){this.path=q,this.results=[]}addMatch(q){this.results.push(q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function x(Z,q){const ae={...Z||{},...q||{}};return Object.keys(ae).filter(Ee=>{const ye=ae[Ee];return typeof ye=="boolean"&&ye})}e.resolvePatternsForProvider=x;class B{constructor(q,ae){this.c=null,this.a={...q.excludePattern||{},...ae.excludePattern||{}},this.b=R.parse(this.a);let Ee=q.includePattern;ae.includePattern&&(Ee?Ee={...Ee,...ae.includePattern}:Ee=ae.includePattern),Ee&&(this.c=R.parse(Ee))}matchesExcludesSync(q,ae,Ee){return!!(this.b&&this.b(q,ae,Ee))}includedInQuerySync(q,ae,Ee){return!(this.b&&this.b(q,ae,Ee)||this.c&&!this.c(q,ae,Ee))}includedInQuery(q,ae,Ee){const ye=this.b(q,ae,Ee),be=()=>this.c?!!this.c(q,ae,Ee):!0;return(0,P.isThenable)(ye)?ye.then(M=>M?!1:be()):be()}hasSiblingExcludeClauses(){return z(this.a)}}e.QueryGlobTester=B;function z(Z){for(const q in Z)if(typeof Z[q]!="boolean")return!0;return!1}function ee(Z){if(!Z)return;let q;return ae=>(q||(q=(Z()||Promise.resolve([])).then(Ee=>Ee?V(Ee):{})),q.then(Ee=>!!Ee[ae]))}e.hasSiblingPromiseFn=ee;function se(Z){if(!Z)return;let q;return ae=>{if(!q){const Ee=Z();q=Ee?V(Ee):{}}return!!q[ae]}}e.hasSiblingFn=se;function V(Z){const q={};for(const ae of Z)q[ae]=!0;return q}}),define(Ce[35],De([1,0,19,16,21,3,4,71,18,111,24,11,12,2,198,5,17,227,49,50,27,20,13,7,59,34,6]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d,S,w,p,t,a,r,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function v($,j,W){return new T.ExtUri(U=>s(U,W)).isEqual($,j)}function l($,j,W){return v($.uri,j.uri,W)?0:(0,P.compare)($.uri.toString(),j.uri.toString())}function I($,j,W){return $.index!==j.index?$.index<j.index?-1:1:v($.uri,j.uri,W)?(0,P.compare)($.name,j.name):(0,P.compare)($.uri.toString(),j.uri.toString())}function E($,j,W,U){const x=$.slice(0).sort((z,ee)=>W(z,ee,U)),B=j.slice(0).sort((z,ee)=>W(z,ee,U));return(0,c.delta)(x,B,(z,ee)=>W(z,ee,U))}function s($,j){const W=j.getCapabilities($.scheme);return!(W&&W&1024)}class i extends d.Workspace{static toExtHostWorkspace(j,W,U,x){if(!j)return{workspace:null,added:[],removed:[]};const{id:B,name:z,folders:ee,configuration:se,transient:V,isUntitled:Z}=j,q=[],ae=W;W?ee.forEach((M,Q)=>{const fe=D.URI.revive(M.uri),we=i.o(U||W,fe,x);we?(we.name=M.name,we.index=M.index,q.push(we)):q.push({uri:fe,name:M.name,index:Q})}):q.push(...ee.map(({uri:M,name:Q,index:fe})=>({uri:D.URI.revive(M),name:Q,index:fe}))),q.sort((M,Q)=>M.index<Q.index?-1:1);const Ee=new i(B,z,q,!!V,se?D.URI.revive(se):null,!!Z,M=>s(M,x)),{added:ye,removed:be}=E(ae?ae.workspaceFolders:[],Ee.workspaceFolders,l,x);return{workspace:Ee,added:ye,removed:be}}static o(j,W,U){for(let x=0;x<j.folders.length;x++){const B=j.workspaceFolders[x];if(v(B.uri,W,U))return B}}constructor(j,W,U,x,B,z,ee){super(j,U.map(se=>new d.WorkspaceFolder(se)),x,B,ee),this.t=W,this.u=z,this.q=[],this.s=A.TernarySearchTree.forUris(ee),U.forEach(se=>{this.q.push(se),this.s.set(se.uri,se)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,W){return W&&this.s.get(j)&&(j=(0,T.dirname)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let k=e.ExtHostWorkspace=class{constructor(j,W,U,x,B){this.c=new O.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new O.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new O.AsyncEmitter,this.B=new Map,this.h=x,this.s=U,this.t=B,this.j=new g.Counter,this.k=new R.Barrier,this.o=j.getProxy(f.MainContext.MainThreadWorkspace),this.q=j.getProxy(f.MainContext.MainThreadMessageService);const z=W.workspace;this.l=z?new i(z.id,z.name,[],!!z.transient,z.configuration?D.URI.revive(z.configuration):null,!!z.isUntitled,ee=>s(ee,U)):void 0}$initializeWorkspace(j,W){this.v=W,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?D.URI.from({scheme:y.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,W,U,...x){const B=[];if(Array.isArray(x)&&x.forEach(Z=>{D.URI.isUri(Z.uri)&&!B.some(q=>v(q.uri,Z.uri,this.s))&&B.push({uri:Z.uri,name:Z.name||(0,T.basenameOrAuthority)(Z.uri)})}),this.n||[W,U].some(Z=>typeof Z!="number"||Z<0)||U===0&&B.length===0)return!1;const z=this.x?this.x.workspaceFolders:[];if(W+U>z.length)return!1;const ee=z.slice(0);ee.splice(W,U,...B.map(Z=>({uri:Z.uri,name:Z.name||(0,T.basenameOrAuthority)(Z.uri),index:void 0})));for(let Z=0;Z<ee.length;Z++){const q=ee[Z];if(ee.some((ae,Ee)=>Ee!==Z&&v(q.uri,ae.uri,this.s)))return!1}ee.forEach((Z,q)=>Z.index=q);const{added:se,removed:V}=E(z,ee,I,this.s);if(se.length===0&&V.length===0)return!1;if(this.o){const Z=j.displayName||j.name;this.o.$updateWorkspaceFolders(Z,W,U,B).then(void 0,q=>{this.n=void 0;const ae={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(h.Severity.Error,(0,C.localize)(0,null,Z,q.toString()),ae,[])})}return this.y(ee),!0}getWorkspaceFolder(j,W){if(this.x)return this.x.getWorkspaceFolder(j,W)}async getWorkspaceFolder2(j,W){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,W)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,W){let U,x="";if(typeof j=="string"?(U=D.URI.file(j),x=j):typeof j<"u"&&(U=j,x=j.fsPath),!U)return x;const B=this.getWorkspaceFolder(U,!0);if(!B)return x;typeof W>"u"&&this.x&&(W=this.x.folders.length>1);let z=(0,T.relativePath)(B.uri,U);return W&&B.name&&(z=`${B.name}/${z}`),z}y(j){this.x&&(this.n=i.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:W,added:U,removed:x}=i.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=W||void 0,this.n=void 0,this.c.fire(Object.freeze({added:U,removed:x}))}findFiles(j,W,U,x,B=u.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let z;if(W===null?z=!1:W&&(typeof W=="string"?z=W:z=W.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:ee,folder:se}=F(t.GlobPattern.from(j));return this.o.$startFileSearch((0,m.withUndefinedAsNull)(ee),(0,m.withUndefinedAsNull)(se),(0,m.withUndefinedAsNull)(z),(0,m.withUndefinedAsNull)(U),B).then(V=>Array.isArray(V)?V.map(Z=>D.URI.revive(Z)):[])}async findTextInFiles(j,W,U,x,B=u.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const z=this.j.getNext(),ee=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:se,folder:V}=F(t.GlobPattern.from(W.include)),Z=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,q={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:ee,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:se,excludePattern:Z},ae=!1;if(this.u[z]=Ee=>{if(ae)return;const ye=D.URI.revive(Ee.resource);Ee.results.forEach(be=>{(0,o.resultIsMatch)(be)?U({uri:ye,preview:{text:be.preview.text,matches:(0,c.mapArrayOrNot)(be.preview.matches,M=>new a.Range(M.startLineNumber,M.startColumn,M.endLineNumber,M.endColumn))},ranges:(0,c.mapArrayOrNot)(be.ranges,M=>new a.Range(M.startLineNumber,M.startColumn,M.endLineNumber,M.endColumn))}):U({uri:ye,text:be.text,lineNumber:be.lineNumber})})},B.isCancellationRequested)return{};try{const Ee=await this.o.$startTextSearch(j,(0,m.withUndefinedAsNull)(V),q,z,B);return delete this.u[z],Ee||{}}catch(Ee){throw delete this.u[z],Ee}}$handleTextSearchResult(j,W){this.u[W]?.(j)}async save(j){const W=await this.o.$save(j,{saveAs:!1});return D.URI.revive(W)}async saveAs(j){const W=await this.o.$save(j,{saveAs:!0});return D.URI.revive(W)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,W){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,W);const U=this.t.transformOutgoingScheme(j),x=this.z++;return this.o.$registerEditSessionIdentityProvider(x,U),(0,L.toDisposable)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(x)})}async $getEditSessionIdentifier(j,W){this.h.info("Getting edit session identifier for workspaceFolder",j);const U=await this.resolveWorkspaceFolder(D.URI.revive(j));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const x=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!x),!x)return;const B=await x.provideEditSessionIdentity(U,W);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(j,W,U,x){this.h.info("Getting edit session identifier for workspaceFolder",j);const B=await this.resolveWorkspaceFolder(D.URI.revive(j));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const z=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!z),!z)return;const ee=await z.provideEditSessionIdentityMatch?.(W,U,x);if(this.h.info("Provider returned edit session identifier match result: ",ee),!!ee)return ee}getOnWillCreateEditSessionIdentityEvent(j){return(W,U,x)=>{const B=function(ee){W.call(U,ee)};return B.extension=j,this.A.event(B,void 0,x)}}async $onWillCreateEditSessionIdentity(j,W,U){const x=await this.resolveWorkspaceFolder(D.URI.revive(j));if(x===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:x},W,async(B,z)=>{const ee=Date.now();await Promise.resolve(B),Date.now()-ee>U&&this.h.warn("SLOW edit session create-participant",z.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(j,W){if(this.B.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.B.set(j,W);const U=this.t.transformOutgoingScheme(j),x=this.z++;return this.o.$registerCanonicalUriProvider(x,U),(0,L.toDisposable)(()=>{this.B.delete(j),this.o.$unregisterCanonicalUriProvider(x)})}async provideCanonicalUri(j,W,U){const x=this.B.get(j.scheme);if(!x)return;const B=await x.provideCanonicalUri?.(D.URI.revive(j),W,U);if(B)return B}async $provideCanonicalUri(j,W,U){return this.provideCanonicalUri(D.URI.revive(j),{targetScheme:W},U)}};e.ExtHostWorkspace=k=qe([je(0,p.IExtHostRpcService),je(1,w.IExtHostInitDataService),je(2,S.IExtHostFileSystemInfo),je(3,n.ILogService),je(4,r.IURITransformerService)],k),e.IExtHostWorkspace=(0,b.createDecorator)("IExtHostWorkspace");function F($){let j,W;return $&&(typeof $=="string"?j=$:(j=$.pattern,W=D.URI.revive($.baseUri))),{includePattern:j,folder:W}}}),define(Ce[38],De([1,0,23,3,35,6,7,230,129,12,16,5,20,17,2]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function b(a,r){if(r){const o=r.split(".");let f=a;for(let v=0;f&&v<o.length;v++)f=f[o[v]];return f}}function n(a){return a instanceof C.URI}function h(a){return a&&a.uri instanceof C.URI&&a.languageId&&typeof a.languageId=="string"}function d(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function S(a){return a&&a.uri instanceof C.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function w(a){if(n(a))return{resource:a};if(h(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(d(a))return{overrideIdentifier:a.languageId};if(S(a))return{resource:a.uri};if(a===null)return{resource:null}}let p=e.ExtHostConfiguration=class{constructor(r,o,f){this.a=r.getProxy(O.MainContext.MainThreadConfiguration),this.c=o,this.b=f,this.d=new T.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,o){this.getConfigProvider().then(f=>f.$acceptConfigurationChanged(r,o))}};e.ExtHostConfiguration=p=qe([je(0,m.IExtHostRpcService),je(1,u.IExtHostWorkspace),je(2,D.ILogService)],p);class t{constructor(r,o,f,v){this.a=new R.Emitter,this.b=r,this.f=v,this.c=o,this.e=A.Configuration.parse(f),this.d=this.k(f.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,o){const f={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(o,f))}getConfiguration(r,o,f){const v=w(o)||{},l=this.g(r?b(this.e.getValue(void 0,v,this.c.workspace),r):this.e.getValue(void 0,v,this.c.workspace));r&&this.h(r,v,f?.identifier);function I(s){if(s==null)return null;if(typeof s=="boolean")return s?2:5;switch(s){case L.ConfigurationTarget.Global:return 2;case L.ConfigurationTarget.Workspace:return 5;case L.ConfigurationTarget.WorkspaceFolder:return 6}}const E={has(s){return typeof b(l,s)<"u"},get:(s,i)=>{this.h(r?`${r}.${s}`:s,v,f?.identifier);let k=b(l,s);if(typeof k>"u")k=i;else{let F;const $=(j,W)=>{if((0,g.isObject)(j)){let U;const x=()=>{F=F||(0,c.deepClone)(l),U=U||b(F,W)};return new Proxy(j,{get:(B,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return x(),()=>U;if(F)return U=U||b(F,W),U[z];const ee=B[z];return typeof z=="string"?$(ee,`${W}.${z}`):ee},set:(B,z,ee)=>(x(),U&&(U[z]=ee),!0),deleteProperty:(B,z)=>(x(),U&&delete U[z],!0),defineProperty:(B,z,ee)=>(x(),U&&Object.defineProperty(U,z,ee),!0)})}return Array.isArray(j)?(0,c.deepClone)(j):j};k=$(k,s)}return k},update:(s,i,k,F)=>{s=r?`${r}.${s}`:s;const $=I(k);return i!==void 0?this.b.$updateConfigurationOption($,s,i,v,F):this.b.$removeConfigurationOption($,s,v,F)},inspect:s=>{s=r?`${r}.${s}`:s;const i=this.e.inspect(s,v,this.c.workspace);if(i)return{key:s,defaultValue:(0,c.deepClone)(i.policy?.value??i.default?.value),globalValue:(0,c.deepClone)(i.user?.value??i.application?.value),workspaceValue:(0,c.deepClone)(i.workspace?.value),workspaceFolderValue:(0,c.deepClone)(i.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(i.default?.override),globalLanguageValue:(0,c.deepClone)(i.user?.override??i.application?.override),workspaceLanguageValue:(0,c.deepClone)(i.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(i.workspaceFolder?.override),languageIds:(0,c.deepClone)(i.overrideIdentifiers)}}};return typeof l=="object"&&(0,c.mixin)(E,l,!1),Object.freeze(E)}g(r){const o=f=>(0,g.isObject)(f)?new Proxy(f,{get:(v,l)=>o(v[l]),set:(v,l,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(v,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(v,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):f;return o(r)}h(r,o,f){const v=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),l=f?`[${f.value}] `:"";if(v===4){typeof o?.resource>"u"&&this.f.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){o?.resource&&this.f.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,o){const f=new A.ConfigurationChangeEvent(r,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(v,l)=>f.affectsConfiguration(v,w(l))})}k(r){return r.reduce((o,f)=>(o.set(f[0],f[1]),o),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,R,u){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Ne=this&&this.__classPrivateFieldGet||function(re,e,c,R){if(c==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?R:c==="a"?R.call(re):R?R.value:e.get(re)};define(Ce[87],De([1,0,2,16,3,6,7,35,62,38,21,43,20,27,5,18,9,17,83,271,8]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d,S,w){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(j){function W(x){if(x!=null)return x}j.from=W;function U(x){if(x!=null)return x}j.to=U})(t||(t={}));var a;(function(j){function W(x){if(x!=null)return x}j.from=W;function U(x){if(x!=null)return x}j.to=U})(a||(a={}));var r;(function(j){function W(x){if(x!=null)return x}j.from=W;function U(x){if(x!=null)return x}j.to=U})(r||(r={}));var o;(function(j){function W(B){if(B){const z=B;return z&&!!z.process}else return!1}j.is=W;function U(B){if(B==null)return;const z={process:B.process,args:B.args};return B.options&&(z.options=r.from(B.options)),z}j.from=U;function x(B){if(B!=null)return new L.ProcessExecution(B.process,B.args,B.options)}j.to=x})(o||(o={}));var f;(function(j){function W(x){if(x!=null)return x}j.from=W;function U(x){if(x!=null)return x}j.to=U})(f||(f={}));var v;(function(j){function W(B){if(B){const z=B;return z&&(!!z.commandLine||!!z.command)}else return!1}j.is=W;function U(B){if(B==null)return;const z={};return B.commandLine!==void 0?z.commandLine=B.commandLine:(z.command=B.command,z.args=B.args),B.options&&(z.options=f.from(B.options)),z}j.from=U;function x(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new L.ShellExecution(B.commandLine,B.options):new L.ShellExecution(B.command,B.args?B.args:[],B.options)}j.to=x})(v||(v={}));var l;(function(j){function W(B){if(B){const z=B;return z&&z.customExecution==="customExecution"}else return!1}j.is=W;function U(B){return{customExecution:"customExecution"}}j.from=U;function x(B,z){return z.get(B)}j.to=x})(l||(e.CustomExecutionDTO=l={}));var I;(function(j){function W(U,x){let B;return U.scope!==void 0&&typeof U.scope!="number"?B=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===L.TaskScope.Workspace&&x&&x.workspaceFile?B=x.workspaceFile:B=S.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:B}}j.from=W})(I||(e.TaskHandleDTO=I={}));var E;(function(j){function W(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}j.from=W})(E||(E={}));var s;(function(j){function W(B,z){if(B==null)return[];const ee=[];for(const se of B){const V=U(se,z);V&&ee.push(V)}return ee}j.fromMany=W;function U(B,z){if(B==null)return;let ee;B.execution instanceof L.ProcessExecution?ee=o.from(B.execution):B.execution instanceof L.ShellExecution?ee=v.from(B.execution):B.execution&&B.execution instanceof L.CustomExecution&&(ee=l.from(B.execution));const se=t.from(B.definition);let V;return B.scope?typeof B.scope=="number"?V=B.scope:V=B.scope.uri:V=L.TaskScope.Workspace,!se||!V?void 0:{_id:B._id,definition:se,name:B.name,source:{extensionId:z.identifier.value,label:B.source,scope:V},execution:ee,isBackground:B.isBackground,group:E.from(B.group),presentationOptions:a.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}j.from=U;async function x(B,z,ee){if(B==null)return;let se;o.is(B.execution)?se=o.to(B.execution):v.is(B.execution)?se=v.to(B.execution):l.is(B.execution)&&(se=l.to(B._id,ee));const V=t.to(B.definition);let Z;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?Z=B.source.scope:Z=await z.resolveWorkspaceFolder(c.URI.revive(B.source.scope)):Z=L.TaskScope.Workspace),!V||!Z)return;const q=new L.Task(V,Z,B.name,B.source.label,se,B.problemMatchers);return B.isBackground!==void 0&&(q.isBackground=B.isBackground),B.group!==void 0&&(q.group=L.TaskGroup.from(B.group._id),q.group&&B.group.isDefault&&(q.group=new L.TaskGroup(q.group.id,q.group.label),B.group.isDefault===!0&&(q.group.isDefault=B.group.isDefault))),B.presentationOptions&&(q.presentationOptions=a.to(B.presentationOptions)),B._id&&(q._id=B._id),B.detail&&(q.detail=B.detail),q}j.to=x})(s||(e.TaskDTO=s={}));var i;(function(j){function W(x){return x}j.from=W;function U(x){if(x)return Object.assign(Object.create(null),x)}j.to=U})(i||(i={}));class k{constructor(W,U,x){this._id=U,this.a=x,p.set(this,void 0),Ze(this,p,W,"f")}get task(){return this.a}terminate(){Ne(this,p,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}p=new WeakMap;let F=e.ExtHostTaskBase=class{constructor(W,U,x,B,z,ee,se,V){this.q=new u.Emitter,this.r=new u.Emitter,this.s=new u.Emitter,this.t=new u.Emitter,this.a=W.getProxy(O.MainContext.MainThreadTask),this.b=x,this.c=B,this.d=z,this.e=ee,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=se,this.g=V,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,U,x){if(!x)return new L.Disposable(()=>{});const B=this.w();return this.j.set(B,{type:U,provider:x,extension:W}),this.a.$registerTaskProvider(B,U),new L.Disposable(()=>{this.j.delete(B),this.a.$unregisterTaskProvider(B)})}registerTaskSystem(W,U){this.a.$registerTaskSystem(W,U)}fetchTasks(W){return this.a.$fetchTasks(i.from(W)).then(async U=>{const x=[];for(const B of U){const z=await s.to(B,this.b,this.m);z&&x.push(z)}return x})}get taskExecutions(){const W=[];return this.k.forEach(U=>W.push(U)),W}terminateTask(W){if(!(W instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,U,x){const B=this.m.get(W.id);B&&(this.o.set(W.id,B),this.e.attachPtyToTerminal(U,await B.callback(x))),this.p=W.id,this.q.fire({execution:await this.y(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){const U=await this.y(W);this.l.delete(W.id),this.k.delete(W.id),this.A(W),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const U=await this.y(W.id);this.s.fire({execution:U,processId:W.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(W){const U=await this.y(W.id);this.t.fire({execution:U,exitCode:W.exitCode})}$provideTasks(W,U){const x=this.j.get(W);if(!x)return Promise.reject(new Error("no handler found"));const B=[],z=(0,R.asPromise)(()=>x.provider.provideTasks(T.CancellationToken.None)).then(ee=>this.u(U,B,x,ee));return new Promise(ee=>{z.then(se=>{Promise.all(B).then(()=>{ee(se)})})})}async $resolveTask(W,U){const x=this.j.get(W);if(!x)return Promise.reject(new Error("no handler found"));if(U.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${x.type}].`);const B=await s.to(U,this.b,this.m);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const z=await x.provider.resolveTask(B,T.CancellationToken.None);if(!z)return;this.z(z,x);const ee=s.from(z,x.extension);if(!ee)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(ee.execution)&&await this.x(ee,z,!0),await this.v(ee)}w(){return this.h++}async x(W,U,x){const B=await this.a.$createTaskId(W);!x&&!this.m.has(B)&&(this.n.add(B),this.o.set(B,U.execution)),this.m.set(B,U.execution)}async y(W,U){if(typeof W=="string"){const z=this.l.get(W);if(!z)throw new w.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return z}const x=this.l.get(W.id);if(x)return x;const B=new Promise((z,ee)=>{function se(V,Z,q){q?z(new k(V,Z.id,q)):ee("Unexpected: Task does not exist.")}U?se(this,W,U):s.to(W.task,this.b,this.m).then(V=>se(this,W,V))});return this.l.set(W.id,B),B.then(z=>(this.k.set(W.id,z),z),z=>Promise.reject(z))}z(W,U){W._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const x=this.n.values();let B=x.next();for(;!B.done;)!this.o.has(B.value)&&this.p!==B.value&&(this.m.delete(B.value),this.n.delete(B.value)),B=x.next()}};e.ExtHostTaskBase=F=qe([je(0,m.IExtHostRpcService),je(1,D.IExtHostInitDataService),je(2,A.IExtHostWorkspace),je(3,y.IExtHostDocumentsAndEditors),je(4,g.IExtHostConfiguration),je(5,P.IExtHostTerminalService),je(6,h.ILogService),je(7,d.IExtHostApiDeprecationService)],F);let $=e.WorkerExtHostTask=class extends F{constructor(W,U,x,B,z,ee,se,V){super(W,U,x,B,z,ee,se,V),this.registerTaskSystem(b.Schemas.vscodeRemote,{scheme:b.Schemas.vscodeRemote,authority:"",platform:n.PlatformToString(0)})}async executeTask(W,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const x=s.from(U,W);if(x===void 0)throw new Error("Task is not valid");if(l.is(x.execution))await this.x(x,U,!1);else throw new w.NotSupportedError;const B=await this.y(await this.a.$getTaskExecution(x),U);return this.a.$executeTask(x).catch(z=>{throw new Error(z)}),B}u(W,U,x,B){const z=[];if(B)for(const ee of B){this.z(ee,x),(!ee.definition||!W[ee.definition.type])&&this.f.warn(`The task [${ee.source}, ${ee.name}] uses an undefined task type. The task will be ignored in the future.`);const se=s.from(ee,x.extension);se&&l.is(se.execution)?(z.push(se),U.push(this.x(se,ee,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:z,extension:x.extension}}async v(W){if(l.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,U,x){}};e.WorkerExtHostTask=$=qe([je(0,m.IExtHostRpcService),je(1,D.IExtHostInitDataService),je(2,A.IExtHostWorkspace),je(3,y.IExtHostDocumentsAndEditors),je(4,g.IExtHostConfiguration),je(5,P.IExtHostTerminalService),je(6,h.ILogService),je(7,d.IExtHostApiDeprecationService)],$),e.IExtHostTask=(0,C.createDecorator)("IExtHostTask")}),define(Ce[322],De([1,0,10,21,46,32,24,40,34]),function(re,e,c,R,u,O,L,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class g{constructor(m,D,C){this.k=m,this.l=D,this.o=C,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&O.parse(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&O.parse(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const D=this.k.folderQueries||[];return new Promise((C,b)=>{const n=h=>{this.f++,m(h)};if(this.g)return C({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(h=>{const d=h.toString(),S=c.basename(d);this.j&&this.j(d,S)||this.v(n,{base:h,basename:S})}),Promise.all(D.map(h=>this.p(h,n))).then(h=>{C({limitHit:this.e,stats:h[0]||void 0})},h=>{b(new Error((0,u.toErrorMessage)(h)))})})}async p(m,D){const C=new R.CancellationTokenSource,b=this.q(m),n=this.r(),h=new y.QueryGlobTester(this.k,m),d=!h.hasSiblingExcludeClauses();let S;try{this.h.add(C),S=A.StopWatch.create();const w=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},b,C.token),p=S.elapsed(),t=A.StopWatch.create();return this.g&&!this.e||(w&&w.forEach(a=>{const r=c.posix.relative(m.folder.path,a.path);if(d){const o=c.basename(a.path);this.v(D,{base:m.folder,relativePath:r,basename:o});return}this.s(n,m.folder,r,D)}),this.g&&!this.e)?null:(this.u(n,h,D),{providerTime:p,postProcessTime:t.elapsed()})}finally{C.dispose(),this.h.delete(C)}}q(m){const D=(0,y.resolvePatternsForProvider)(this.k.includePattern,m.includePattern),C=(0,y.resolvePatternsForProvider)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:C,includes:D,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},D,C,b){if(C===this.a){const h=c.basename(this.a);this.v(b,{base:D,relativePath:this.a,basename:h})}function n(h){const d=c.basename(h),S=c.dirname(h);let w=m[S];w||(w=m[S]=[],n(S)),w.push({base:D,relativePath:h,basename:d})}n(C)}u({rootEntries:m,pathToEntries:D},C,b){const n=this,h=this.a;function d(S){const w=(0,y.hasSiblingFn)(()=>S.map(p=>p.basename));for(let p=0,t=S.length;p<t;p++){const a=S[p],{relativePath:r,basename:o}=a;if(C.matchesExcludesSync(r,o,h!==o?w:void 0))continue;const f=D[r];if(f)d(f);else{if(r===h)continue;n.v(b,a)}if(n.e)break}}d(m)}v(m,D){(!this.b||D.relativePath&&this.b(D.relativePath,D.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(D))}}class T{constructor(){this.b=new Map}fileSearch(m,D,C,b){const n=this.c(m.cacheKey),h=new g(m,D,n&&n.token);let d=0;const S=w=>{d+=w.length,C(w.map(p=>this.d(p)))};return this.e(h,T.a,S,b).then(w=>({limitHit:w.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:d,detailStats:w.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new R.CancellationTokenSource),this.b.get(m)}d(m){return m.relativePath?{resource:L.joinPath(m.base,m.relativePath)}:{resource:m.base}}e(m,D,C,b){b.onCancellationRequested(()=>{m.cancel()});const n=d=>{d&&(h.push(d),D>0&&h.length>=D&&(C(h),h=[]))};let h=[];return m.search(n).then(d=>(h.length&&C(h),d),d=>(h.length&&C(h),Promise.reject(d)))}}e.FileSearchManager=T,T.a=512}),define(Ce[323],De([1,0,19,65,32,117,28,18,10,24,11,12,2,167,210,57,17,49,137,321,34]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=e.QueryBuilder=class{constructor(s,i,k,F,$){this.a=s,this.b=i,this.c=k,this.d=F,this.e=$}text(s,i,k={}){s=this.f(s,k);const F=this.a.getValue(),$=i&&i.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(i?.map(h.toWorkspaceFolder),k),type:2,contentPattern:s,previewOptions:k.previewOptions,maxFileSize:k.maxFileSize,usePCRE2:F.search.usePCRE2||$||!1,beforeContext:k.beforeContext,afterContext:k.afterContext,userDisabledExcludesAndIgnoreFiles:k.disregardExcludeSettings&&k.disregardIgnoreFiles}}f(s,i){const k=this.a.getValue();s.isRegExp&&(s.pattern=s.pattern.replace(/\r?\n/g,"\\n"));const F={...s,wordSeparators:k.editor.wordSeparators};return this.j(s,i)&&(F.isCaseSensitive=!0),this.k(s)&&(F.isMultiline=!0),i.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=i.notebookSearchConfig.includeMarkupInput),i.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=i.notebookSearchConfig.includeMarkupPreview),i.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=i.notebookSearchConfig.includeCodeInput),i.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=i.notebookSearchConfig.includeOutput),F}file(s,i={}){return{...this.h(s,i),type:1,filePattern:i.filePattern?i.filePattern.trim():i.filePattern,exists:i.exists,sortByScore:i.sortByScore,cacheKey:i.cacheKey}}g(s,i){return s?(s=Array.isArray(s)?s.map(f):f(s),i?this.parseSearchPaths(s):{pattern:a(...Array.isArray(s)?s:[s])}):{}}h(s=[],i={}){const k=this.g(i.includePattern,i.expandPatterns),F=this.g(i.excludePattern,i.expandPatterns),$=s.length>1,j=(k.searchPaths&&k.searchPaths.length?k.searchPaths.map(x=>this.q(x,i,F)):s.map(x=>this.r(x,i,F,$))).filter(x=>!!x),W={_reason:i._reason,folderQueries:j,usingSearchPaths:!!(k.searchPaths&&k.searchPaths.length),extraFileResources:i.extraFileResources,excludePattern:F.pattern,includePattern:k.pattern,onlyOpenEditors:i.onlyOpenEditors,maxResults:i.maxResults};if(i.onlyOpenEditors){const x=c.coalesce(c.flatten(this.c.groups.map(ee=>ee.editors.map(se=>se.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(x));const B=x.filter(ee=>(0,w.pathIncludedInQuery)(W,ee.fsPath)),z=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...W,...z}}const U=i.extraFileResources&&i.extraFileResources.filter(x=>(0,w.pathIncludedInQuery)(W,x.fsPath));return W.extraFileResources=U&&U.length?U:void 0,W}i(s){const i=[],k=new L.ResourceMap,F={};let $=!1;return s.forEach(j=>{if(j.scheme===A.Schemas.walkThrough)return;if((0,g.isAbsolutePath)(j)){const U=this.b.getWorkspaceFolder(j)?.uri??j.with({path:y.dirname(j.fsPath)});let x=k.get(U);x||($=!0,x={folder:U,includePattern:{}},i.push(x),k.set(U,x));const B=y.relative(U.fsPath,j.fsPath);(0,P.assertIsDefined)(x.includePattern)[B.replace(/\\/g,"/")]=!0}else j.fsPath&&($=!0,F[j.fsPath]=!0)}),{folderQueries:i,includePattern:F,usingSearchPaths:!0,excludePattern:$?void 0:{"**/*":!0}}}j(s,i){if(i.isSmartCase){if(s.isRegExp){if(T.containsUppercaseCharacter(s.pattern,!0))return!0}else if(T.containsUppercaseCharacter(s.pattern))return!0}return!!s.isCaseSensitive}k(s){return s.isMultiline||s.isRegExp&&(0,D.isMultilineRegexSource)(s.pattern)||s.pattern.indexOf(`
`)>=0?!0:!!s.isMultiline}parseSearchPaths(s){const i=z=>y.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),F=(Array.isArray(s)?s:r(s)).map(z=>{const ee=this.e.resolvedUserHome;return ee?(0,O.untildify)(z,ee.scheme===A.Schemas.file?ee.fsPath:ee.path):z}),$=R.groupBy(F,z=>i(z)?"searchPaths":"exprSegments"),j=($.exprSegments||[]).map(z=>T.rtrim(z,"/")).map(z=>T.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),o(z))),W={},U=this.m($.searchPaths||[]);U&&U.length&&(W.searchPaths=U);const x=c.flatten(j),B=a(...x);return B&&(W.pattern=B),W}l(s,i){return i.disregardExcludeSettings?void 0:(0,w.getExcludes)(s,!i.disregardSearchExcludeSettings)}m(s){if(!s||!s.length)return[];const i=s.flatMap(F=>{let{pathPortion:$,globPortion:j}=t(F);return j&&(j=v(j)),this.n($).flatMap(U=>this.o(U,j))}),k=new Map;return i.forEach(F=>{const $=F.searchPath.toString(),j=k.get($);j?F.pattern&&(j.pattern=j.pattern||{},j.pattern[F.pattern]=!0):k.set($,{searchPath:F.searchPath,pattern:F.pattern?a(F.pattern):void 0})}),Array.from(k.values())}n(s){if(y.isAbsolute(s)){const i=this.b.getWorkspace().folders;return i[0]&&i[0].uri.scheme!==A.Schemas.file?[{searchPath:i[0].uri.with({path:s})}]:[{searchPath:m.URI.file(y.normalize(s))}]}if(this.b.getWorkbenchState()===2){const i=this.b.getWorkspace().folders[0].uri;if(s=f(s),s.startsWith("../")||s===".."){const F=y.posix.resolve(i.path,s);return[{searchPath:i.with({path:F})}]}const k=v(s);return[{searchPath:i,pattern:k}]}else{if(s==="./"||s===".\\")return[];{const i=s.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map($=>{const j=i.match(new RegExp(`^${T.escapeRegExpCharacters($.name)}(?:/(.*)|$)`));return j?{match:j,folder:$}:null}).filter(P.isDefined);if(F.length)return F.map($=>{const j=$.match[1];return{searchPath:$.folder.uri,pattern:j&&v(j)}});{const $=s.match(/\.[\/\\](.+)[\/\\]?/),j=$?$[1]:s,W=C.localize(0,null,j);throw new Error(W)}}}}o(s,i){const k=s.pattern&&i?`${s.pattern}/${i}`:s.pattern||i,F=[{searchPath:s.searchPath,pattern:k}];return k&&!k.endsWith("**")&&F.push({searchPath:s.searchPath,pattern:k+"/**"}),F}q(s,i,k){const F=this.r((0,h.toWorkspaceFolder)(s.searchPath),i,k,!1);return F?{...F,includePattern:s.pattern}:null}r(s,i,k,F){let $;const j=m.URI.isUri(s)?s:s.uri;if(k.searchPaths){const z=k.searchPaths.filter(ee=>(0,g.isEqual)(ee.searchPath,j))[0];if(z&&!z.pattern)return null;z&&($=z.pattern)}const W=this.a.getValue({resource:j}),x={...this.l(W,i)||{},...$||{}},B=m.URI.isUri(s)?(0,g.basename)(s):s.name;return{folder:j,folderName:F?B:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof i.disregardIgnoreFiles=="boolean"?i.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof i.disregardGlobalIgnoreFiles=="boolean"?i.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof i.disregardParentIgnoreFiles=="boolean"?i.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof i.ignoreSymlinks=="boolean"?i.ignoreSymlinks:!W.search.followSymlinks}}};e.QueryBuilder=p=qe([je(0,b.IConfigurationService),je(1,h.IWorkspaceContextService),je(2,d.IEditorGroupsService),je(3,n.ILogService),je(4,S.IPathService)],p);function t(E){const s=E.match(/[\*\{\}\(\)\[\]\?]/);if(s){const i=s.index,k=E.substr(0,i).match(/[/|\\][^/\\]*$/);if(k){let F=E.substr(0,k.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:E.substr((k.index||0)+1)}}}return{pathPortion:E}}function a(...E){return E.length?E.reduce((s,i)=>(s[i]=!0,s),Object.create(null)):void 0}function r(E){return u.splitGlobAware(E,",").map(s=>s.trim()).filter(s=>!!s.length)}function o(E){return[`**/${E}/**`,`**/${E}`].map(i=>i.replace(/\*\*\/\*\*/g,"**"))}function f(E){return E.replace(/\\/g,"/")}function v(E){return f(E).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(E){return E.replace(/([?*[\]])/g,"[$1]")}function I(E,s){E=c.distinct(E,F=>F.toString());const i=[],k=s.getWorkspace();return E&&E.forEach(F=>{let $;if(s.getWorkbenchState()===2)$=(0,g.relativePath)(k.folders[0].uri,F),$&&$!=="."&&($="./"+$);else{const j=s.getWorkspaceFolder(F);if(j){const W=j.name;if(k.folders.filter(x=>x.name===W).length===1){const x=(0,g.relativePath)(j.uri,F);x===""?$=`./${j.name}`:$=`./${j.name}/${x}`}else $=F.fsPath}}$&&i.push(l($))}),i}e.resolveResourcesForSearchIncludes=I}),define(Ce[324],De([1,0,24,2,21,8,5,323,34,49]),function(re,e,c,R,u,O,L,A,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function P(b,n){const h=n.activationEvents;if(!h)return Promise.resolve(void 0);const d=[],S=[];for(const o of h)if(/^workspaceContains:/.test(o)){const f=o.substr(18);f.indexOf("*")>=0||f.indexOf("?")>=0||b.forceUsingSearch?S.push(f):d.push(f)}if(d.length===0&&S.length===0)return Promise.resolve(void 0);let w;const p=new Promise((o,f)=>{w=o}),t=o=>w({activationEvent:o}),a=Promise.all(d.map(o=>m(b,o,t))).then(()=>{}),r=D(b,n.identifier,S,t);return Promise.all([a,r]).then(()=>{w(void 0)}),p}e.checkActivateWorkspaceContainsExtension=P;async function m(b,n,h){for(const d of b.folders)if(await b.exists(c.joinPath(R.URI.revive(d),n))){h(`workspaceContains:${n}`);return}}async function D(b,n,h,d){if(h.length===0)return Promise.resolve(void 0);const S=new u.CancellationTokenSource,w=b.checkExists(b.folders,h,S.token),p=setTimeout(async()=>{S.cancel(),b.logService.info(`Not activating extension '${n.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},T);let t=!1;try{t=await w}catch(a){O.isCancellationError(a)||O.onUnexpectedError(a)}S.dispose(),clearTimeout(p),t&&d(`workspaceContains:${h.join(",")}`)}function C(b,n,h,d){const S=b.get(L.IInstantiationService),w=b.get(y.ISearchService),t=S.createInstance(A.QueryBuilder).file(n.map(a=>(0,g.toWorkspaceFolder)(R.URI.revive(a))),{_reason:"checkExists",includePattern:h,exists:!0});return w.fileSearch(t,d).then(a=>!!a.limitHit,a=>O.isCancellationError(a)?!1:Promise.reject(a))}e.checkGlobFileExists=C});var Ze=this&&this.__classPrivateFieldSet||function(re,e,c,R,u){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!u)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!u:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?u.call(re,c):u?u.value=c:e.set(re,c),c},Ne=this&&this.__classPrivateFieldGet||function(re,e,c,R){if(c==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!R:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?R:c==="a"?R.call(re):R?R.value:e.get(re)};define(Ce[44],De([1,0,190,10,88,24,16,4,71,2,17,6,38,260,108,35,25,138,8,26,22,242,7,130,5,27,84,20,98,58,43,3,324,107,244,18,105,40,9,106]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d,S,w,p,t,a,r,o,f,v,l,I,E,s,i,k,F,$,j,W,U,x){"use strict";var B,z,ee;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let se=e.AbstractExtHostExtensionService=class Nn extends A.Disposable{constructor(M,Q,fe,we,_,ne,le,te,de,oe,ue,N){super(),this.R=N,this.a=this.B(new s.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=Q,this.g=fe,this.f=le,this.j=we,this.k=_,this.l=ne,this.m=de,this.p=oe,this.s=ue,this.t=this.g.getProxy(P.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(P.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(P.MainContext.MainThreadExtensionService),this.w=new L.Barrier,this.y=new L.Barrier,this.z=new L.Barrier,this.C=new L.Barrier,this.D=new ye(this.f.activationEvents),this.G=new h.ExtensionDescriptionRegistry(this.D,this.f.allExtensions);const G=new S.ExtensionIdentifierSet(this.f.myExtensions);this.F=new h.ExtensionDescriptionRegistry(this.D,ae(this.G,G)),this.H=new C.ExtHostStorage(this.g,this.l),this.I=new k.ExtHostSecretState(this.g),this.J=te,this.h=M.createChild(new l.ServiceCollection([C.IExtHostStorage,this.H],[k.IExtHostSecretState,this.I])),this.L=this.B(new D.ExtensionsActivator(this.F,this.G,{onExtensionActivationError:(Y,ie,pe)=>{this.v.$onExtensionActivationError(Y,d.transformErrorForSerialization(ie),pe)},actualActivateExtension:async(Y,ie)=>{if(h.ExtensionDescriptionRegistry.isHostExtension(Y,this.F,this.G))return await this.v.$activateExtension(Y,ie),new D.HostExtension;const pe=this.F.getExtensionDescription(Y);return this.ab(pe,ie)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.qb(),this.w.open(),await this.j.waitForInitializeCall(),u.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.ob()}catch(M){d.onUnexpectedError(M)}}async S(){this.J.onWillDeactivateAll();let M=[];try{M=this.F.getAllExtensionDescriptions().map(_=>_.identifier).filter(_=>this.isActivated(_)).map(_=>this.Z(_))}catch{}await Promise.all(M)}terminate(M,Q=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${M}`),this.l.flush(),this.p.dispose(),this.L.dispose(),d.setUnexpectedErrorHandler(we=>{this.l.error(we)}),this.g.dispose();const fe=this.S();Promise.race([(0,L.timeout)(5e3),fe]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${Q}`):this.l.info(`Extension host exiting with code ${Q}`),this.l.flush(),this.l.dispose(),this.c.exit(Q)})}isActivated(M){return this.z.isOpen()?this.L.isActivated(M):!1}async getExtension(M){const Q=await this.v.$getExtension(M);return Q&&{...Q,identifier:new S.ExtensionIdentifier(Q.identifier.value),extensionLocation:g.URI.revive(Q.extensionLocation)}}U(M,Q){return this.L.activateByEvent(M,Q)}W(M,Q){return this.L.activateById(M,Q)}activateByIdWithErrors(M,Q){return this.W(M,Q).then(()=>{const fe=this.L.getActivatedExtension(M);if(fe.activationFailed)return Promise.reject(fe.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(M=>this.F)}getExtensionExports(M){if(this.z.isOpen())return this.L.getActivatedExtension(M).exports;try{return this.L.getActivatedExtension(M).exports}catch{return null}}async X(M){if(M.scheme!==$.Schemas.file)return M;const Q=await this.c.realpath(M.fsPath);return g.URI.file(Q)}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(M=>new Ee(M))),this.M}async Y(M){const Q=y.TernarySearchTree.forUris(fe=>O.extUriBiasedIgnorePathCase.ignorePathCasing(fe));return await Promise.all(M.map(async fe=>{if(this.rb(fe)){const we=await this.X(fe.extensionLocation);Q.set(we,fe)}})),Q}Z(M){let Q=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(M))return Q;const fe=this.L.getActivatedExtension(M);if(!fe)return Q;try{typeof fe.module.deactivate=="function"&&(Q=Promise.resolve(fe.module.deactivate()).then(void 0,we=>(this.l.error(we),Promise.resolve(void 0))))}catch(we){this.l.error(`An error occurred when deactivating the extension '${M.value}':`),this.l.error(we)}try{(0,A.dispose)(fe.subscriptions)}catch(we){this.l.error(`An error occurred when deactivating the subscriptions for extension '${M.value}':`),this.l.error(we)}return Q}async ab(M,Q){return this.f.remote.isRemote?this.v.$onWillActivateExtension(M.identifier):await this.v.$onWillActivateExtension(M.identifier),this.cb(M,Q).then(fe=>{const we=fe.activationTimes;return this.v.$onDidActivateExtension(M.identifier,we.codeLoadingTime,we.activateCallTime,we.activateResolvedTime,Q),this.bb(M,Q,"success",we),fe},fe=>{throw this.bb(M,Q,"failure"),fe})}bb(M,Q,fe,we){const _=Z(M,Q);this.u.$publicLog2("extensionActivationTimes",{..._,...we||{},outcome:fe})}cb(M,Q){const fe=Z(M,Q);this.u.$publicLog2("activatePlugin",fe);const we=this.rb(M);if(!we)return Promise.resolve(new D.EmptyExtension(D.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${M.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${M.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this.l.flush();const _=new D.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this.sb(M,(0,O.joinPath)(M.extensionLocation,we),_),this.db(M)]).then(ne=>(u.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Nn.eb(this.l,M.identifier,ne[0],ne[1],_))).then(ne=>(u.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),ne))}db(M){const Q=new p.ExtensionGlobalMemento(M,this.H),fe=new p.ExtensionMemento(M.identifier.value,!1,this.H),we=new F.ExtensionSecrets(M,this.I),_=M.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ne=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([Q.whenReady,fe.whenReady,this.J.whenReady]).then(()=>{const le=this;let te,de;const oe=(0,n.isProposedApiEnabled)(M,"ipc")?this.f.messagePorts?.get(S.ExtensionIdentifier.toKey(M.identifier)):void 0;return Object.freeze({globalState:Q,workspaceState:fe,secrets:we,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(ue){return R.join(M.extensionLocation.fsPath,ue)},get storagePath(){return le.J.workspaceValue(M)?.fsPath},get globalStoragePath(){return le.J.globalValue(M).fsPath},get logPath(){return R.join(le.f.logsLocation.fsPath,M.identifier.value)},get logUri(){return g.URI.joinPath(le.f.logsLocation,M.identifier.value)},get storageUri(){return le.J.workspaceValue(M)},get globalStorageUri(){return le.J.globalValue(M)},get extensionMode(){return _},get extension(){return te===void 0&&(te=new q(le,M.identifier,M,ne,!1)),te},get extensionRuntime(){return(0,n.checkProposedApiEnabled)(M,"extensionRuntime"),le.extensionRuntime},get environmentVariableCollection(){return le.p.getEnvironmentVariableCollection(M)},get messagePassingProtocol(){if(!de){if(!oe)return;const ue=s.Event.buffer(s.Event.fromDOMEventEmitter(oe,"message",N=>N.data));oe.start(),de={onDidReceiveMessage:ue,postMessage:oe.postMessage.bind(oe)}}return de}})})}static eb(M,Q,fe,we,_){return fe=fe||{activate:void 0,deactivate:void 0},this.fb(M,Q,fe,we,_).then(ne=>new D.ActivatedExtension(!1,null,_.build(),fe,ne,we.subscriptions))}static fb(M,Q,fe,we,_){if(typeof fe.activate=="function")try{_.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const ne=typeof global=="object"?global:self,le=fe.activate.apply(ne,[we]);return _.activateCallStop(),_.activateResolveStart(),Promise.resolve(le).then(te=>(_.activateResolveStop(),te))}catch(ne){return Promise.reject(ne)}else return Promise.resolve(fe)}gb(M,Q){this.W(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:Q}).then(void 0,fe=>{this.l.error(fe)})}hb(M,Q=0){const we=Date.now();(0,U.setTimeout0)(()=>{for(let _=Q;_<M.length;_+=1){const ne=M[_];for(const le of ne.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-we>50){this.hb(M,_);break}else this.gb(ne,le)}})}ib(){this.v.$setPerformanceMarks(u.getMarks()),this.k.getConfigProvider().then(M=>{const Q=M.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),fe=this.F.getAllExtensionDescriptions();if(Q)this.hb(fe);else for(const we of fe)if(we.activationEvents)for(const _ of we.activationEvents)_==="onStartupFinished"&&this.gb(we,_)})}jb(){const M=this.U("*",!0).then(void 0,ne=>{this.l.error(ne)});this.B(this.j.onDidChangeWorkspace(ne=>this.kb(ne.added)));const Q=this.j.workspace?this.j.workspace.folders:[],fe=this.kb(Q),we=this.mb(),_=Promise.all([we,M,fe]).then(()=>{});return Promise.race([_,(0,L.timeout)(1e4)]).then(()=>{this.ib()}),_}kb(M){return M.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(Q=>this.lb(M,Q))).then(()=>{})}async lb(M,Q){if(this.isActivated(Q.identifier))return;const fe=!this.f.remote.isRemote&&!!this.f.remote.authority,we={logService:this.l,folders:M.map(ne=>ne.uri),forceUsingSearch:fe,exists:ne=>this.c.exists(ne.fsPath),checkExists:(ne,le,te)=>this.t.$checkExists(ne,le,te)},_=await(0,i.checkActivateWorkspaceContainsExtension)(we,Q);if(_)return this.W(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:_.activationEvent}).then(void 0,ne=>this.l.error(ne))}async mb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.nb()}catch(M){throw console.error(M),M}}async nb(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:Q}=this.f.environment;if(!M||!Q)throw new Error(c.localize(0,null));const fe=await this.sb(null,Q,new D.ExtensionActivationTimesBuilder(!1));if(!fe||typeof fe.run!="function")throw new Error(c.localize(1,null,Q.toString()));return new Promise((we,_)=>{const ne=(de,oe)=>{de?_(de):we(typeof oe=="number"&&oe>0?1:0)},le=(0,O.originalFSPath)(Q),te=fe.run(le,ne);te&&te.then&&te.then(()=>{we(0)}).catch(de=>{_(de instanceof Error&&de.stack?de.stack:String(de))})})}ob(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,L.timeout)(1e3)])).then(()=>this.jb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(M,Q){return this.N[M]=Q,(0,A.toDisposable)(()=>{delete this.N[M]})}async pb(M){const Q=M.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const fe=M.substr(0,Q);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${fe}`,!1),{authorityPrefix:fe,resolver:this.N[fe]}}async $resolveAuthority(M,Q){const fe=W.StopWatch.create(!1),we=()=>`[resolveAuthority(${(0,a.getRemoteAuthorityPrefix)(M)},${Q})][${fe.elapsed()}ms] `,_=oe=>this.l.info(`${we()}${oe}`),ne=(oe,ue=void 0)=>this.l.error(`${we()}${oe}`,ue);_("activating resolver...");const{authorityPrefix:le,resolver:te}=await this.pb(M);if(!te)return ne("no resolver"),{type:"error",error:{code:a.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${le}.`,detail:void 0}};const de=new L.IntervalTimer;try{_("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(te)),de.cancelAndSet(()=>_("waiting..."),1e3),_("invoking resolve()..."),u.mark(`code/extHost/willResolveAuthority/${le}`);const oe=await te.resolve(M,{resolveAttempt:Q});u.mark(`code/extHost/didResolveAuthorityOK/${le}`),de.dispose();const ue={environmentTunnels:oe.environmentTunnels,features:oe.tunnelFeatures},N={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted,authenticationSession:oe.authenticationSessionForInitializingExtensions?{id:oe.authenticationSessionForInitializingExtensions.id,providerId:oe.authenticationSessionForInitializingExtensions.providerId}:void 0};_(`returned ${t.ManagedResolvedAuthority.isManagedResolvedAuthority(oe)?"managed authority":`${oe.host}:${oe.port}`}`);let G;if(t.ManagedResolvedAuthority.isManagedResolvedAuthority(oe)){const Y=Q;this.R.setFactory(Y,oe.makeConnection),G={authority:M,connectTo:new a.ManagedRemoteConnection(Y),connectionToken:oe.connectionToken}}else G={authority:M,connectTo:new a.WebSocketRemoteConnection(oe.host,oe.port),connectionToken:oe.connectionToken};return{type:"ok",value:{authority:G,options:N,tunnelInformation:ue}}}catch(oe){if(u.mark(`code/extHost/didResolveAuthorityError/${le}`),de.dispose(),ne("returned an error",oe),oe instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe}}async $getCanonicalURI(M,Q){this.l.info(`$getCanonicalURI invoked for authority (${(0,a.getRemoteAuthorityPrefix)(M)})`);const{resolver:fe}=await this.pb(M);if(!fe)return null;const we=g.URI.revive(Q);if(typeof fe.getCanonicalURI>"u")return we;const _=await(0,L.asPromise)(()=>fe.getCanonicalURI(we));return _||we}$startExtensionHost(M){M.toAdd.forEach(we=>we.extensionLocation=g.URI.revive(we.extensionLocation));const{globalRegistry:Q,myExtensions:fe}=V(this.D,this.G,this.F,M);return this.G.set(Q.getAllExtensionDescriptions()),this.F.set(fe),this.ob()}$activateByEvent(M,Q){return Q===1?this.U(M,!1):this.z.wait().then(fe=>this.U(M,!1))}async $activate(M,Q){return await this.z.wait(),this.F.getExtensionDescription(M)?(await this.W(M,Q),!0):!1}async $deltaExtensions(M){M.toAdd.forEach(ne=>ne.extensionLocation=g.URI.revive(ne.extensionLocation));const{globalRegistry:Q,myExtensions:fe}=V(this.D,this.G,this.F,M),we=await this.Y(fe);return(await this.getExtensionPathIndex()).setSearchTree(we),this.G.set(Q.getAllExtensionDescriptions()),this.F.set(fe),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){const Q=w.VSBuffer.alloc(M),fe=Math.random()%256;for(let we=0;we<M;we++)Q.writeUInt8(fe,we);return Q}async $updateRemoteConnectionData(M){this.Q=M,this.a.fire()}};e.AbstractExtHostExtensionService=se=qe([je(0,r.IInstantiationService),je(1,e.IHostUtils),je(2,v.IExtHostRpcService),je(3,b.IExtHostWorkspace),je(4,m.IExtHostConfiguration),je(5,T.ILogService),je(6,o.IExtHostInitDataService),je(7,f.IExtensionStoragePaths),je(8,I.IExtHostTunnelService),je(9,E.IExtHostTerminalService),je(10,j.IExtHostLocalizationService),je(11,x.IExtHostManagedSockets)],se);function V(be,M,Q,fe){be.addActivationEvents(fe.addActivationEvents);const we=new h.ExtensionDescriptionRegistry(be,M.getAllExtensionDescriptions());we.deltaExtensions(fe.toAdd,fe.toRemove);const _=new S.ExtensionIdentifierSet(Q.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of fe.myToRemove)_.delete(le);for(const le of fe.myToAdd)_.add(le);const ne=ae(we,_);return{globalRegistry:we,myExtensions:ne}}function Z(be,M){return{id:be.identifier.value,name:be.name,extensionVersion:be.version,publisherDisplayName:be.publisher,activationEvents:be.activationEvents?be.activationEvents.join(","):null,isBuiltin:be.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class q{constructor(M,Q,fe,we,_){B.set(this,void 0),z.set(this,void 0),ee.set(this,void 0),Ze(this,B,M,"f"),Ze(this,z,Q,"f"),Ze(this,ee,fe.identifier,"f"),this.id=fe.identifier.value,this.extensionUri=fe.extensionLocation,this.extensionPath=R.normalize((0,O.originalFSPath)(fe.extensionLocation)),this.packageJSON=fe,this.extensionKind=we,this.isFromDifferentExtensionHost=_}get isActive(){return Ne(this,B,"f").isActivated(Ne(this,ee,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ne(this,B,"f").getExtensionExports(Ne(this,ee,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ne(this,B,"f").activateByIdWithErrors(Ne(this,ee,"f"),{startup:!1,extensionId:Ne(this,z,"f"),activationEvent:"api"}),this.exports}}e.Extension=q,B=new WeakMap,z=new WeakMap,ee=new WeakMap;function ae(be,M){return be.getAllExtensionDescriptions().filter(Q=>M.has(Q.identifier))}class Ee{constructor(M){this.a=M}setSearchTree(M){this.a=M}findSubstr(M){return this.a.findSubstr(M)}forEach(M){return this.a.forEach(M)}}e.ExtensionPaths=Ee;class ye{constructor(M){this.a=new S.ExtensionIdentifierMap,this.addActivationEvents(M)}readActivationEvents(M){return this.a.get(M.identifier)}addActivationEvents(M){for(const Q of Object.keys(M))this.a.set(Q,M[Q])}}}),define(Ce[325],De([1,0,88,2,6,38,25,26,20,27,5,44,39,17,11]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let b=e.RequireInterceptor=class{constructor(p,t,a,r,o,f,v){this.c=p,this.d=t,this.f=a,this.g=r,this.h=o,this.i=f,this.j=v,this.a=new Map,this.b=[]}async install(){this.k(),c.mark("code/extHost/willWaitForConfig");const p=await this.g.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const t=await this.h.getExtensionPathIndex();this.register(new h(this.c,t,this.d,p,this.j)),this.register(this.f.createInstance(d,t)),this.register(this.f.createInstance(n)),this.i.remote.isRemote&&this.register(this.f.createInstance(S,t,this.i.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const t of p.nodeModuleName)this.a.set(t,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(t=>p.alternativeModuleName(t))}};e.RequireInterceptor=b=qe([je(2,T.IInstantiationService),je(3,O.IExtHostConfiguration),je(4,P.IExtHostExtensionService),je(5,g.IExtHostInitDataService),je(6,D.ILogService)],b);let n=class fn{constructor(p){if(p.environment.appRoot&&fn.a.size){const t=(0,C.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),a="[a-z0-9_.-]",r=`@${a}+\\/${a}+|${a}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${o}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const t=this.b.exec(this.c(p));if(!t)return;const[,a,r,o]=t,f=fn.a.get(r);if(f!==void 0)return console.warn(`${r} as been renamed to ${f}, please update your imports`),a+f+o}c(p){return p.replace(/\\/g,"/")}};n.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),n=qe([je(0,g.IExtHostInitDataService)],n);class h{constructor(p,t,a,r,o){this.c=p,this.d=t,this.e=a,this.f=r,this.g=o,this.nodeModuleName="vscode",this.a=new A.ExtensionIdentifierMap}load(p,t){const a=this.d.findSubstr(t);if(a){let r=this.a.get(a.identifier);return r||(r=this.c(a,this.e,this.f),this.a.set(a.identifier,r)),r}if(!this.b){let r="";this.d.forEach((o,f)=>r+=`	${f} -> ${o.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this.b=this.c(L.nullExtensionDescription,this.e,this.f)}return this.b}}let d=class{constructor(p,t,a){this.d=p,this.nodeModuleName="keytar",this.a=t.getProxy(u.MainContext.MainThreadTelemetry);const{environment:r}=a,o=t.getProxy(u.MainContext.MainThreadKeytar);if(r.appRoot){let f=r.appRoot.fsPath;m.platform==="win32"&&(f=f.replace(/\\/g,"/")),f[f.length-1]==="/"&&(f=f.substr(0,f.length-1)),this.b=new Set,this.b.add(`${f}/node_modules.asar/keytar`),this.b.add(`${f}/node_modules/keytar`)}this.c={getPassword:(f,v)=>o.$getPassword(f,v),setPassword:(f,v,l)=>o.$setPassword(f,v,l),deletePassword:(f,v)=>o.$deletePassword(f,v),findPassword:f=>o.$findPassword(f),findCredentials(f){return o.$findCredentials(f)}}}load(p,t){const a=this.d.findSubstr(t);return this.a.$publicLog2("shimming.keytar",{extension:a?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const t=p.length;if(t<=7||!this.b)return;const a=t-7;if((p.charAt(a)==="/"||p.charAt(a)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};d=qe([je(1,y.IExtHostRpcService),je(2,g.IExtHostInitDataService)],d);let S=class{constructor(p,t,a){this.e=p,this.f=t,this.nodeModuleName=["open","opn"],this.d=a.getProxy(u.MainContext.MainThreadTelemetry);const r=a.getProxy(u.MainContext.MainThreadWindow);this.c=(o,f)=>{const v=R.URI.parse(o);return f?this.g(o,f):v.scheme==="http"||v.scheme==="https"?r.$openUri(v,o,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?r.$openUri(v,o,{}):this.g(o,f)}}load(p,t,a){const r=this.e.findSubstr(t);return r&&(this.a=r.identifier.value,this.h()),this.b=a(p),this.c}g(p,t){return this.i(),this.b(p,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};S=qe([je(2,y.IExtHostRpcService)],S)}),define(Ce[51],De([1,0,54,4,10,39,5,62,63,44,7,35,256,38]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,L.createDecorator)("IExtHostVariableResolverProvider");class C extends m.AbstractVariableResolverService{constructor(h,d,S,w,p,t,a){function r(){if(S){const o=S.activeEditor();if(o)return o.document.uri;const f=w.tabGroups.all.find(v=>v.isActive)?.activeTab;if(f!==void 0){if(f.input instanceof T.TextDiffTabInput||f.input instanceof T.NotebookDiffEditorTabInput)return f.input.modified;if(f.input instanceof T.TextTabInput||f.input instanceof T.NotebookEditorTabInput||f.input instanceof T.CustomEditorTabInput)return f.input.uri}}}super({getFolderUri:o=>{const f=t.folders.filter(v=>v.name===o);if(f&&f.length>0)return f[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(o,f)=>p.getConfiguration(void 0,o).get(f),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=r();if(o)return u.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(d){const o=r();if(o){const f=d.getWorkspaceFolder(o);if(f)return u.normalize(f.uri.fsPath)}}},getSelectedText:()=>{if(S){const o=S.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(S){const o=S.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>h.getExtension(o)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(O.env))}}let b=e.ExtHostVariableResolverProviderService=class extends R.Disposable{constructor(h,d,S,w,p){super(),this.b=h,this.c=d,this.g=S,this.h=w,this.i=p,this.a=new c.Lazy(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new C(this.b,this.c,this.g,this.i,t,r,this.j())})}getResolver(){return this.a.value}j(){}};e.ExtHostVariableResolverProviderService=b=qe([je(0,g.IExtHostExtensionService),je(1,P.IExtHostWorkspace),je(2,A.IExtHostDocumentsAndEditors),je(3,D.IExtHostConfiguration),je(4,y.IExtHostEditorTabs)],b)}),define(Ce[89],De([1,0,16,3,12,2,5,6,63,44,20,7,35,134,250,38,51]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,L.createDecorator)("IExtHostDebugService");let h=e.ExtHostDebugServiceBase=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,o,f,v,l,I){this.F=o,this.G=f,this.H=v,this.I=l,this.J=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new R.Emitter,this.n=new R.Emitter,this.o=new R.Emitter,this.u=new R.Emitter,this.k=r.getProxy(A.MainContext.MainThreadDebugService),this.z=new R.Emitter({onWillAddFirstListener:()=>{this.V()}}),this.B=new R.Emitter,this.v=new S(this.k),this.w=new Map,this.y=!1,this.G.getExtensionRegistry().then(E=>{E.onDidChange(s=>{this.K(E)}),this.K(E)})}asDebugSourceUri(r,o){const f=r;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let v=`debug:${encodeURIComponent(f.path||"")}`,l="?";return o&&(v+=`${l}session=${encodeURIComponent(o.id)}`,l="&"),v+=`${l}ref=${f.sourceReference}`,O.URI.parse(v)}else{if(f.path)return O.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}K(r){const o=[];for(const f of r.getAllExtensionDescriptions())if(f.contributes){const v=f.contributes.debuggers;if(v&&v.length>0)for(const l of v)(0,C.isDebuggerMainContribution)(l)&&o.push(l.type)}this.k.$registerDebugTypes(o)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.V();const r=[];return this.w.forEach(o=>r.push(o)),r}addBreakpoints(r){this.V();const o=r.filter(l=>{const I=l.id;return this.w.has(I)?!1:(this.w.set(I,l),!0)});this.W(o,[],[]);const f=[],v=new Map;for(const l of o)if(l instanceof P.SourceBreakpoint){let I=v.get(l.location.uri.toString());I||(I={type:"sourceMulti",uri:l.location.uri,lines:[]},v.set(l.location.uri.toString(),I),f.push(I)),I.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof P.FunctionBreakpoint&&f.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this.k.$registerBreakpoints(f)}removeBreakpoints(r){this.V();const o=r.filter(I=>this.w.delete(I.id));this.W([],o,[]);const f=o.filter(I=>I instanceof P.SourceBreakpoint).map(I=>I.id),v=o.filter(I=>I instanceof P.FunctionBreakpoint).map(I=>I.id),l=o.filter(I=>I instanceof P.DataBreakpoint).map(I=>I.id);return this.k.$unregisterBreakpoints(f,v,l)}startDebugging(r,o,f){return this.k.$startDebugging(r?r.uri:void 0,o,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,o,f){if(!o)return new P.Disposable(()=>{});const v=this.d++;return this.f.push({type:r,handle:v,provider:o}),this.k.$registerDebugConfigurationProvider(r,f,!!o.provideDebugConfigurations,!!o.resolveDebugConfiguration,!!o.resolveDebugConfigurationWithSubstitutedVariables,v),new P.Disposable(()=>{this.f=this.f.filter(l=>l.provider!==o),this.k.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(r,o,f){if(!f)return new P.Disposable(()=>{});if(!this.R(r,o))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${o}' debugger.`);if(this.O(o))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this.g++;return this.h.push({type:o,handle:v,factory:f}),this.k.$registerDebugAdapterDescriptorFactory(o,v),new P.Disposable(()=>{this.h=this.h.filter(l=>l.factory!==f),this.k.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(r,o){if(!o)return new P.Disposable(()=>{});const f=this.i++;return this.j.push({type:r,handle:f,factory:o}),new P.Disposable(()=>{this.j=this.j.filter(v=>v.factory!==o)})}async $runInTerminal(r,o){return Promise.resolve(void 0)}async $substituteVariables(r,o){let f;const v=await this.Y(r);return v&&(f={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.J.getResolver()).resolveAnyAsync(f,o)}L(r,o){if(r.type==="implementation")return new p(r.implementation)}M(){}async $startDASession(r,o){const f=this,v=await this.X(o);return this.T(this.O(v.type),v).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const I=this.N(l),E=this.L(I,v);if(!E)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const s=E;return this.C.set(r,s),this.S(v).then(i=>(i&&this.D.set(r,i),s.onMessage(async k=>{if(k.type==="request"&&k.command==="handshake"){const F=k,$={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.E||(this.E=this.M());try{if(this.E){const j=await this.E.sign(F.arguments.value);$.body={signature:j},s.sendResponse($)}else throw new Error("no signer")}catch(j){$.success=!1,$.message=j.message,s.sendResponse($)}}else i&&i.onDidSendMessage&&i.onDidSendMessage(k),k=(0,C.convertToVSCPaths)(k,!0),f.k.$acceptDAMessage(r,k)}),s.onError(k=>{i&&i.onError&&i.onError(k),this.k.$acceptDAError(r,k.name,k.message,k.stack)}),s.onExit(k=>{i&&i.onExit&&i.onExit((0,u.withNullAsUndefined)(k),void 0),this.k.$acceptDAExit(r,(0,u.withNullAsUndefined)(k),void 0)}),i&&i.onWillStartSession&&i.onWillStartSession(),s.startSession()))})}$sendDAMessage(r,o){o=(0,C.convertToDAPaths)(o,!1);const f=this.D.get(r);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(o),this.C.get(r)?.sendMessage(o)}$stopDASession(r){const o=this.D.get(r);this.D.delete(r),o&&o.onWillStopSession&&o.onWillStopSession();const f=this.C.get(r);return this.C.delete(r),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const o=[],f=[],v=[];if(r.added)for(const l of r.added){const I=l.id;if(I&&!this.w.has(I)){let E;if(l.type==="function")E=new P.FunctionBreakpoint(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")E=new P.DataBreakpoint(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const s=O.URI.revive(l.uri);E=new P.SourceBreakpoint(new P.Location(s,new P.Position(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,P.setBreakpointId)(E,I),this.w.set(I,E),o.push(E)}}if(r.removed)for(const l of r.removed){const I=this.w.get(l);I&&(this.w.delete(l),f.push(I))}if(r.changed){for(const l of r.changed)if(l.id){const I=this.w.get(l.id);if(I){if(I instanceof P.FunctionBreakpoint&&l.type==="function"){const E=I;E.enabled=l.enabled,E.condition=l.condition,E.hitCondition=l.hitCondition,E.logMessage=l.logMessage,E.functionName=l.functionName}else if(I instanceof P.SourceBreakpoint&&l.type==="source"){const E=I;E.enabled=l.enabled,E.condition=l.condition,E.hitCondition=l.hitCondition,E.logMessage=l.logMessage,E.location=new P.Location(O.URI.revive(l.uri),new P.Position(l.line,l.character))}v.push(I)}}}this.W(o,f,v)}async $acceptStackFrameFocus(r){let o;const f=r.sessionId?await this.X(r.sessionId):void 0;if(!f)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?o=new P.ThreadFocus(f,r.threadId):o=new P.StackFrameFocus(f,r.threadId,r.frameId),this.A=o,this.B.fire(this.A)}$provideDebugConfigurations(r,o,f){return(0,c.asPromise)(async()=>{const v=this.Q(r);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.Y(o);return v.provideDebugConfigurations(l,f)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(r,o,f,v){return(0,c.asPromise)(async()=>{const l=this.Q(r);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.Y(o);return l.resolveDebugConfiguration(I,f,v)})}$resolveDebugConfigurationWithSubstitutedVariables(r,o,f,v){return(0,c.asPromise)(async()=>{const l=this.Q(r);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.Y(o);return l.resolveDebugConfigurationWithSubstitutedVariables(I,f,v)})}async $provideDebugAdapter(r,o){const f=this.P(r);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.X(o);return this.T(f,v).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.N(l)})}async $acceptDebugSessionStarted(r){const o=await this.X(r);this.m.fire(o)}async $acceptDebugSessionTerminated(r){const o=await this.X(r);o&&(this.n.fire(o),this.l.delete(o.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.X(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,o){(await this.X(r))?._acceptNameChanged(o)}async $acceptDebugSessionCustomEvent(r,o){const v={session:await this.X(r),event:o.event,body:o.body};this.u.fire(v)}N(r){if(r instanceof P.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof P.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}O(r){const o=this.h.filter(f=>f.type===r);if(o.length>0)return o[0].factory}P(r){const o=this.h.filter(f=>f.handle===r);if(o.length>0)return o[0].factory}Q(r){const o=this.f.filter(f=>f.handle===r);if(o.length>0)return o[0].provider}R(r,o){if(r.contributes){const f=r.contributes.debuggers;if(f&&f.length>0){for(const v of f)if(v.label&&v.type&&v.type===o)return!0}}return!1}S(r){const f=r.configuration.type,v=this.j.filter(l=>l.type===f||l.type==="*").map(l=>(0,c.asPromise)(()=>l.factory.createDebugAdapterTracker(r)).then(I=>I,I=>null));return Promise.race([Promise.all(v).then(l=>{const I=l.filter(E=>!!E);if(I.length>0)return new w(I)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async T(r,o){const f=o.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new P.DebugAdapterServer(f));if(r){const l=await this.G.getExtensionRegistry();return(0,c.asPromise)(()=>r.createDebugAdapterDescriptor(o,this.U(o,l))).then(I=>{if(I)return I})}const v=await this.G.getExtensionRegistry();return Promise.resolve(this.U(o,v))}U(r,o){}V(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}W(r,o,f){(r.length>0||o.length>0||f.length>0)&&this.z.fire(Object.freeze({added:r,removed:o,changed:f}))}async X(r){if(r)if(typeof r=="string"){const o=this.l.get(r);if(o)return o}else{let o=this.l.get(r.id);if(!o){const f=await this.Y(r.folderUri),v=r.parent?this.l.get(r.parent):void 0;o=new d(this.k,r.id,r.type,r.name,f,r.configuration,v),this.l.set(o.id,o),this.k.$sessionCached(o.id)}return o}throw new Error("cannot find session")}Y(r){if(r){const o=O.URI.revive(r);return this.F.resolveWorkspaceFolder(o)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=h=qe([je(0,T.IExtHostRpcService),je(1,m.IExtHostWorkspace),je(2,g.IExtHostExtensionService),je(3,b.IExtHostConfiguration),je(4,y.IExtHostEditorTabs),je(5,n.IExtHostVariableResolverProvider)],h);class d{constructor(r,o,f,v,l,I,E){this.d=r,this.f=o,this.g=f,this.h=v,this.i=l,this.j=I,this.k=E}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,o){return this.d.$customDebugAdapterRequest(this.f,r,o)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=d;class S{constructor(r){this.value=Object.freeze({append(o){r.$appendDebugConsole(o)},appendLine(o){this.append(o+`
`)}})}}e.ExtHostDebugConsole=S;class w{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(o=>o.onWillReceiveMessage?o.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(o=>o.onDidSendMessage?o.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(o=>o.onError?o.onError(r):void 0)}onExit(r,o){this.d.forEach(f=>f.onExit?f.onExit(r,o):void 0)}}class p extends D.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(o=>{this.acceptMessage(o)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let t=e.WorkerExtHostDebugService=class extends h{constructor(r,o,f,v,l,I){super(r,o,f,v,l,I)}};e.WorkerExtHostDebugService=t=qe([je(0,T.IExtHostRpcService),je(1,m.IExtHostWorkspace),je(2,g.IExtHostExtensionService),je(3,b.IExtHostConfiguration),je(4,y.IExtHostEditorTabs),je(5,n.IExtHostVariableResolverProvider)],t)}),define(Ce[326],De([1,0,8,88,2,6,318,17,97,98,27,222,20,59,44,82]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class n{static async installEarlyHandler(S){const w=S.get(A.ILogService),t=S.get(m.IExtHostRpcService).getProxy(O.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(a=>{w.error(a);const r=c.transformErrorForSerialization(a);t.$onUnexpectedError(r)})}static async installFullHandler(S){const w=S.get(A.ILogService),p=S.get(m.IExtHostRpcService),t=S.get(C.IExtHostExtensionService),a=S.get(b.IExtHostTelemetry),r=p.getProxy(O.MainContext.MainThreadExtensionService),o=p.getProxy(O.MainContext.MainThreadErrors),f=await t.getExtensionPathIndex(),v=new WeakMap;function l(E,s){let i="",k,F;for(const $ of s)i+=`
	at ${$.toString()}`,F=$.getFileName(),!k&&F&&(k=f.findSubstr(u.URI.file(F)));return v.set(E,k?.identifier),`${E.name||"Error"}: ${E.message||""}${i}`}let I=l;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return I},set(E){I=function(s,i){return l(s,i),E.call(Error,s,i)}}}),c.setUnexpectedErrorHandler(E=>{w.error(E);const s=c.transformErrorForSerialization(E),i=v.get(E);if(!i){o.$onUnexpectedError(s);return}r.$onExtensionRuntimeError(i,s);const k=a.onExtensionError(i,E);w.trace("forwarded error to extension?",k,i)})}}Error.stackTraceLimit=100;class h{constructor(S,w,p,t,a){this.a=p,this.b=new L.RPCProtocol(S,null,t),w=h.e(w,this.b);const r=new g.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());r.set(T.IExtHostInitDataService,{_serviceBrand:void 0,...w,messagePorts:a}),r.set(m.IExtHostRpcService,new m.ExtHostRpcService(this.b)),r.set(D.IURITransformerService,new D.URITransformerService(t)),r.set(C.IHostUtils,p);const o=new P.InstantiationService(r,!0);o.invokeFunction(n.installEarlyHandler),this.d=o.invokeFunction(f=>f.get(A.ILogService)),R.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",w),this.c=o.invokeFunction(f=>f.get(C.IExtHostExtensionService)),this.c.initialize(),o.invokeFunction(n.installFullHandler)}async asBrowserUri(S){const w=this.b.getProxy(O.MainContext.MainThreadExtensionService);return u.URI.revive(await w.$asBrowserUri(S))}terminate(S){this.c.terminate(S)}static e(S,w){S.allExtensions.forEach(t=>{t.extensionLocation=u.URI.revive(w.transformIncomingURIs(t.extensionLocation))}),S.environment.appRoot=u.URI.revive(w.transformIncomingURIs(S.environment.appRoot));const p=S.environment.extensionDevelopmentLocationURI;return p&&(S.environment.extensionDevelopmentLocationURI=p.map(t=>u.URI.revive(w.transformIncomingURIs(t)))),S.environment.extensionTestsLocationURI=u.URI.revive(w.transformIncomingURIs(S.environment.extensionTestsLocationURI)),S.environment.globalStorageHome=u.URI.revive(w.transformIncomingURIs(S.environment.globalStorageHome)),S.environment.workspaceStorageHome=u.URI.revive(w.transformIncomingURIs(S.environment.workspaceStorageHome)),S.environment.extensionTelemetryLogResource=u.URI.revive(w.transformIncomingURIs(S.environment.extensionTelemetryLogResource)),S.nlsBaseUrl=u.URI.revive(w.transformIncomingURIs(S.nlsBaseUrl)),S.logsLocation=u.URI.revive(w.transformIncomingURIs(S.logsLocation)),S.workspace=w.transformIncomingURIs(S.workspace),S}}e.ExtensionHostMain=h}),define(Ce[327],De([1,0,16,9,199,216,232,89,63,44,20,43,7,51,35,251,252,38]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let d=e.ExtHostDebugService=class extends A.ExtHostDebugServiceBase{constructor(a,r,o,f,v,l,I){super(a,r,o,f,l,I),this.bb=v,this.Z=new p}L(a,r){switch(a.type){case"server":return new b.SocketDebugAdapter(a);case"pipeServer":return new b.NamedPipeDebugAdapter(a);case"executable":return new b.ExecutableDebugAdapter(a,r.type)}return super.L(a,r)}U(a,r){const o=b.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),a.type);if(o)return new m.DebugAdapterExecutable(o.command,o.args,o.options)}M(){return new L.SignService}async $runInTerminal(a,r){if(a.kind==="integrated"){this.ab||(this.ab=this.bb.onDidCloseTerminal(j=>{this.Z.onTerminalClosed(j)}));const o=await this.H.getConfigProvider(),f=this.bb.getDefaultShell(!0),v=this.bb.getDefaultShellArgs(!0),l=a.title||u.localize(0,null),I=JSON.stringify({shell:f,shellArgs:v});let E=await this.Z.checkout(I,l),s,i=!1;if(E)s=a.cwd;else{const j={shellPath:f,shellArgs:v,cwd:a.cwd,name:l,iconPath:new m.ThemeIcon("debug")};i=!0,E=this.bb.createTerminalFromOptions(j,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.Z.insert(E,I)}E.show(!0);const k=await E.processId;i?await new Promise(j=>setTimeout(j,1e3)):o.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(f.indexOf("powershell")>=0||f.indexOf("pwsh")>=0||f.indexOf("cmd.exe")>=0?E.sendText("cls"):f.indexOf("bash")>=0?E.sendText("clear"):R.isWindows?E.sendText("cls"):E.sendText("clear"));const F=(0,n.prepareCommand)(f,a.args,!!a.argsCanBeInterpretedByShell,s,a.env);E.sendText(F);const $=this.onDidTerminateDebugSession(j=>{j.id===r&&(this.Z.free(E),$.dispose())});return k}else if(a.kind==="external")return w(a,await this.H.getConfigProvider());return super.$runInTerminal(a,r)}};e.ExtHostDebugService=d=qe([je(0,T.IExtHostRpcService),je(1,C.IExtHostWorkspace),je(2,g.IExtHostExtensionService),je(3,h.IExtHostConfiguration),je(4,P.IExtHostTerminalService),je(5,y.IExtHostEditorTabs),je(6,D.IExtHostVariableResolverProvider)],d);let S;function w(t,a){if(!S)if(R.isWindows)S=new O.WindowsExternalTerminalService;else if(R.isMacintosh)S=new O.MacExternalTerminalService;else if(R.isLinux)S=new O.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=a.getConfiguration("terminal");return S.runInTerminal(t.title,t.cwd,t.args,t.env||{},r.external||{})}class p{constructor(){this.b=new Map}async checkout(a,r){const f=[...this.b.entries()].map(([v,l])=>(0,c.createCancelablePromise)(async I=>{if(v.name!==r||l.lastUsedAt!==-1&&await(0,n.hasChildProcesses)(await v.processId))return null;const E=Date.now();return l.lastUsedAt+p.a>E||I.isCancellationRequested||l.config!==a?null:(l.lastUsedAt=E,v)}));return await(0,c.firstParallel)(f,v=>!!v)}insert(a,r){this.b.set(a,{lastUsedAt:Date.now(),config:r})}free(a){const r=this.b.get(a);r&&(r.lastUsedAt=-1)}onTerminalClosed(a){this.b.delete(a)}}p.a=1e3}),define(Ce[328],De([1,0,10,2,95,35,62,38,49,43,20,27,87,18,17,83,24,74,51]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let S=e.ExtHostTask=class extends m.ExtHostTaskBase{constructor(p,t,a,r,o,f,v,l,I){super(p,t,a,r,o,f,v,l),this.B=a,this.C=I,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(D.Schemas.vscodeRemote,{scheme:D.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(D.Schemas.file,{scheme:D.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(p,t){const a=t;if(!t.execution&&a._id===void 0)throw new Error("Tasks to execute must include an execution");if(a._id!==void 0){const r=m.TaskHandleDTO.from(a,this.B),o=await this.a.$getTaskExecution(r);if(o.task===void 0)throw new Error("Task from execution DTO is undefined");const f=await this.y(o,t);return this.a.$executeTask(r).catch(()=>{}),f}else{const r=m.TaskDTO.from(t,p);if(r===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(r.execution)&&await this.x(r,t,!1);const o=await this.y(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),o}}u(p,t,a,r){const o=[];if(r)for(const f of r){this.z(f,a),(!f.definition||!p[f.definition.type])&&this.f.warn(`The task [${f.source}, ${f.name}] uses an undefined task type. The task will be ignored in the future.`);const v=m.TaskDTO.from(f,a.extension);v&&(o.push(v),m.CustomExecutionDTO.is(v.execution)&&t.push(this.x(v,f,!0)))}return{tasks:o,extension:a.extension}}async v(p){return p}async F(p){let t=p&&p.length>0?p[0]:void 0;if(!t){const a=R.URI.file((0,h.homedir)());t=new y.WorkspaceFolder({uri:a,name:n.basename(a),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(p,t){const a=R.URI.revive(p),r={process:void 0,variables:Object.create(null)},o=await this.b.resolveWorkspaceFolder(a),f=await this.b.getWorkspaceFolders2()??[],v=await this.C.getResolver(),l=o?{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(f);for(const I of t.variables)r.variables[I]=await v.resolveAsync(l,I);if(t.process!==void 0){let I;if(t.process.path!==void 0){I=t.process.path.split(c.delimiter);for(let E=0;E<I.length;E++)I[E]=await v.resolveAsync(l,I[E])}r.process=await u.win32.findExecutable(await v.resolveAsync(l,t.process.name),t.process.cwd!==void 0?await v.resolveAsync(l,t.process.cwd):void 0,I)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(p,t,a){return u.win32.findExecutable(p,t,a)}};e.ExtHostTask=S=qe([je(0,T.IExtHostRpcService),je(1,P.IExtHostInitDataService),je(2,O.IExtHostWorkspace),je(3,L.IExtHostDocumentsAndEditors),je(4,A.IExtHostConfiguration),je(5,g.IExtHostTerminalService),je(6,C.ILogService),je(7,b.IExtHostApiDeprecationService),je(8,d.IExtHostVariableResolverProvider)],S)}),define(Ce[329],De([1,0,74,51]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class u extends R.ExtHostVariableResolverProviderService{j(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=u}),define(Ce[147],De([1,0,19,16,21,46,18,10,24,2,34]),function(re,e,c,R,u,O,L,A,y,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(d,S,w,p){this.d=d,this.e=S,this.f=w,this.g=p,this.a=null,this.b=!1,this.c=0}search(d,S){const w=this.d.folderQueries||[],p=new u.CancellationTokenSource;return S.onCancellationRequested(()=>p.cancel()),new Promise((t,a)=>{this.a=new D(d);let r=!1;const o=(f,v)=>{if(!r&&!this.b){const l=this.h(f);b(f)&&typeof this.d.maxResults=="number"&&this.c+l>this.d.maxResults&&(this.b=!0,r=!0,p.cancel(),f=this.j(f,this.d.maxResults-this.c));const I=this.h(f);this.c+=I,(I>0||!b(f))&&this.a.add(f,v)}};Promise.all(w.map((f,v)=>this.k(f,l=>o(l,v),p.token))).then(f=>{p.dispose(),this.a.flush();const v=f.some(l=>!!l&&!!l.limitHit);t({limitHit:this.b||v,messages:(0,c.flatten)(f.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.g}})},f=>{p.dispose();const v=(0,O.toErrorMessage)(f);a(new Error(v))})})}h(d){return b(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}j(d,S){const w=Array.isArray(d.ranges)?d.ranges:[d.ranges],p=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:w.slice(0,S),preview:{matches:p.slice(0,S),text:d.preview.text},uri:d.uri}}async k(d,S,w){const p=new T.QueryGlobTester(this.d,d),t=[],a={report:f=>{if(!this.l(f))return;const v=d.folder.scheme===L.Schemas.file?(0,T.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(f.uri))):void 0,l=y.relativePath(d.folder,f.uri);if(l){const I=p.includedInQuery(l,A.basename(l),v);(0,R.isThenable)(I)?t.push(I.then(E=>{E&&S(f)})):I&&S(f)}}},r=this.n(d),o=await this.e.provideTextSearchResults(m(this.d.contentPattern),r,a,w);return t.length&&await Promise.all(t),o}l(d){if(b(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(d){const S=(0,T.resolvePatternsForProvider)(this.d.includePattern,d.includePattern),w=(0,T.resolvePatternsForProvider)(this.d.excludePattern,d.excludePattern),p={folder:g.URI.from(d.folder),excludes:w,includes:S,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.f.toCanonicalName(d.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=P;function m(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class D{constructor(d){this.e=d,this.b=-1,this.d=null,this.a=new n(512,S=>this.g(S))}add(d,S){this.d&&(this.b!==S||!y.isEqual(this.c,d.uri))&&(this.f(),this.d=null),this.d||(this.b=S,this.d={resource:d.uri,results:[]}),this.d.results.push(C(d))}f(){const d=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,d)}flush(){this.f(),this.a.flush()}g(d){this.e(d)}}e.TextSearchResultsCollector=D;function C(h){return b(h)?{preview:{matches:(0,c.mapArrayOrNot)(h.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:h.preview.text},ranges:(0,c.mapArrayOrNot)(h.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function b(h){return!!h.preview}e.extensionResultIsMatch=b;class n{constructor(d,S){this.g=d,this.h=S,this.c=0,this.d=[],this.e=0}addItem(d,S){d&&this.j(d,S)}addItems(d,S){d&&this.k(d,S)}j(d,S){this.d.push(d),this.e+=S,this.l()}k(d,S){this.d=this.d.concat(d),this.e+=S,this.l()}l(){this.c<n.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},n.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=n,n.a=4e3,n.b=50}),define(Ce[90],De([1,0,4,6,5,322,20,59,17,2,147]),function(re,e,c,R,u,O,L,A,y,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,u.createDecorator)("IExtHostSearch");let P=e.ExtHostSearch=class{constructor(b,n,h){this.k=b,this.l=n,this.n=h,this.c=this.k.getProxy(R.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new O.FileSearchManager}o(b){return this.l.transformOutgoingScheme(b)}registerTextSearchProvider(b,n){if(this.g.has(b))throw new Error(`a text search provider for the scheme '${b}' is already registered`);this.g.add(b);const h=this.d++;return this.e.set(h,n),this.c.$registerTextSearchProvider(h,this.o(b)),(0,c.toDisposable)(()=>{this.g.delete(b),this.e.delete(h),this.c.$unregisterProvider(h)})}registerFileSearchProvider(b,n){if(this.i.has(b))throw new Error(`a file search provider for the scheme '${b}' is already registered`);this.i.add(b);const h=this.d++;return this.h.set(h,n),this.c.$registerFileSearchProvider(h,this.o(b)),(0,c.toDisposable)(()=>{this.i.delete(b),this.h.delete(h),this.c.$unregisterProvider(h)})}$provideFileSearchResults(b,n,h,d){const S=m(h),w=this.h.get(b);if(w)return this.j.fileSearch(S,w,p=>{this.c.$handleFileMatch(b,n,p.map(t=>t.resource))},d);throw new Error("unknown provider: "+b)}$clearCache(b){return this.j.clearCache(b),Promise.resolve(void 0)}$provideTextSearchResults(b,n,h,d){const S=this.e.get(b);if(!S||!S.provideTextSearchResults)throw new Error(`Unknown provider ${b}`);const w=m(h);return this.q(w,S).search(t=>this.c.$handleTextMatch(b,n,t),d)}$enableExtensionHostSearch(){}q(b,n){return new T.TextSearchManager(b,n,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};e.ExtHostSearch=P=qe([je(0,L.IExtHostRpcService),je(1,A.IURITransformerService),je(2,y.ILogService)],P);function m(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(D),extraFileResources:C.extraFileResources&&C.extraFileResources.map(b=>g.URI.revive(b))}}e.reviveQuery=m;function D(C){return{...C,folder:g.URI.revive(C.folder)}}}),define(Ce[330],De([1,0,21,8,3,41,2,124,122,163,162,31,6,104,277,276,37,278,38,280,281,282,262,283,62,44,284,285,290,291,292,146,266,298,299,302,108,43,304,267,13,7,79,307,85,145,35,26,254,289,78,143,87,89,90,17,59,20,27,293,261,58,83,273,305,84,64,310,308,309,274,50,303,306,107,63,82,294,86,295,18,127,265,243,286,4,25,249,105,239,296,297,275,287,264,300,288,106,301]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d,S,w,p,t,a,r,o,f,v,l,I,E,s,i,k,F,$,j,W,U,x,B,z,ee,se,V,Z,q,ae,Ee,ye,be,M,Q,fe,we,_,ne,le,te,de,oe,ue,N,G,Y,ie,pe,Ie,he,Re,Te,Ve,xe,tt,Qe,Xe,nt,ot,et,Be,ke,X,J,me,Fe,ze,He,Je,ct,st,ft,Pt,Tt,vt,Ht,Mt,qt,Ft,Ut){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function jt(ut){const gt=ut.get(te.IExtHostInitDataService),Bt=ut.get(Ve.IExtHostFileSystemInfo),$t=ut.get(pe.IExtHostConsumerFileSystem),yt=ut.get(o.IExtHostExtensionService),mt=ut.get(q.IExtHostWorkspace),kt=ut.get(nt.IExtHostTelemetry),zt=ut.get(d.IExtHostConfiguration),Oe=ut.get(ne.IURITransformerService),Ae=ut.get(le.IExtHostRpcService),Pe=ut.get(j.IExtHostStorage),ce=ut.get(ie.IExtensionStoragePaths),Me=ut.get(_.ILoggerService),We=ut.get(_.ILogService),Ye=ut.get(ue.IExtHostTunnelService),Ge=ut.get(N.IExtHostApiDeprecationService),it=ut.get(Z.IExtHostWindow),Ct=ut.get(Qe.IExtHostSecretState),Lt=ut.get(Xe.IExtHostEditorTabs),At=ut.get(Ft.IExtHostManagedSockets);Ae.set(m.ExtHostContext.ExtHostFileSystemInfo,Bt),Ae.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Me),Ae.set(m.ExtHostContext.ExtHostWorkspace,mt),Ae.set(m.ExtHostContext.ExtHostConfiguration,zt),Ae.set(m.ExtHostContext.ExtHostExtensionService,yt),Ae.set(m.ExtHostContext.ExtHostStorage,Pe),Ae.set(m.ExtHostContext.ExtHostTunnelService,Ye),Ae.set(m.ExtHostContext.ExtHostWindow,it),Ae.set(m.ExtHostContext.ExtHostSecretState,Ct),Ae.set(m.ExtHostContext.ExtHostTelemetry,kt),Ae.set(m.ExtHostContext.ExtHostEditorTabs,Lt),Ae.set(m.ExtHostContext.ExtHostManagedSockets,At);const Et=Ae.set(m.ExtHostContext.ExtHostDecorations,ut.get(M.IExtHostDecorations)),lt=Ae.set(m.ExtHostContext.ExtHostDocumentsAndEditors,ut.get(r.IExtHostDocumentsAndEditors)),bt=Ae.set(m.ExtHostContext.ExtHostCommands,ut.get(n.IExtHostCommands)),wt=Ae.set(m.ExtHostContext.ExtHostTerminalService,ut.get(W.IExtHostTerminalService)),St=Ae.set(m.ExtHostContext.ExtHostDebugService,ut.get(fe.IExtHostDebugService)),oi=Ae.set(m.ExtHostContext.ExtHostSearch,ut.get(we.IExtHostSearch)),Vt=Ae.set(m.ExtHostContext.ExtHostTask,ut.get(Q.IExtHostTask)),Oi=Ae.set(m.ExtHostContext.ExtHostOutputService,ut.get(s.IExtHostOutputService)),Kt=Ae.set(m.ExtHostContext.ExtHostLocalization,ut.get(ct.IExtHostLocalizationService)),wi=Ae.set(m.ExtHostContext.ExtHostUrls,new se.ExtHostUrls(Ae)),Rt=Ae.set(m.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(Ae,lt)),Fi=Ae.set(m.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ae,lt,We)),ai=Ae.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(We,Rt,Ae.getProxy(m.MainContext.MainThreadBulkEdits))),Dt=Ae.set(m.ExtHostContext.ExtHostNotebook,new de.ExtHostNotebookController(Ae,bt,lt,Rt)),di=Ae.set(m.ExtHostContext.ExtHostNotebookDocuments,new me.ExtHostNotebookDocuments(Dt)),Ei=Ae.set(m.ExtHostContext.ExtHostNotebookEditors,new J.ExtHostNotebookEditors(We,Dt)),hi=Ae.set(m.ExtHostContext.ExtHostNotebookKernels,new ot.ExtHostNotebookKernels(Ae,gt,Dt,bt,We)),cn=Ae.set(m.ExtHostContext.ExtHostNotebookRenderers,new Be.ExtHostNotebookRenderers(Ae,Dt)),Ni=Ae.set(m.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Ht.ExtHostNotebookDocumentSaveParticipant(We,Dt,Ae.getProxy(m.MainContext.MainThreadBulkEdits))),Nt=Ae.set(m.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Ae,lt)),Si=Ae.set(m.ExtHostContext.ExtHostTreeViews,new x.ExtHostTreeViews(Ae.getProxy(m.MainContext.MainThreadTreeViews),bt,We)),Yt=Ae.set(m.ExtHostContext.ExtHostEditorInsets,new Ee.ExtHostEditorInsets(Ae.getProxy(m.MainContext.MainThreadEditorInsets),Nt,gt.remote)),ci=Ae.set(m.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(Ae,We,Bt,lt)),li=Ae.set(m.ExtHostContext.ExtHostLanguages,new I.ExtHostLanguages(Ae,Rt,bt.converter,Oe)),dt=Ae.set(m.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(Ae,Oe,Rt,bt,ci,We,Ge,kt)),Mi=Ae.set(m.ExtHostContext.ExtHostFileSystem,new f.ExtHostFileSystem(Ae,dt)),ei=Ae.set(m.ExtHostContext.ExtHostFileSystemEventService,new v.ExtHostFileSystemEventService(Ae,We,lt)),Xt=Ae.set(m.ExtHostContext.ExtHostQuickOpen,(0,k.createExtHostQuickOpen)(Ae,mt,bt)),yi=Ae.set(m.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(Ae,bt,Rt,We)),Ui=Ae.set(m.ExtHostContext.ExtHostQuickDiff,new Pt.ExtHostQuickDiff(Ae,Oe)),Bi=Ae.set(m.ExtHostContext.ExtHostShare,new Ut.ExtHostShare(Ae,Oe)),$i=Ae.set(m.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(Ae,bt,Rt)),Ci=Ae.set(m.ExtHostContext.ExtHostProgress,new i.ExtHostProgress(Ae.getProxy(m.MainContext.MainThreadProgress))),zi=Ae.set(m.ExtHostContext.ExtHosLabelService,new ye.ExtHostLabelService(Ae)),Di=Ae.set(m.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Ae)),ni=Ae.set(m.ExtHostContext.ExtHostAuthentication,new G.ExtHostAuthentication(Ae)),Wi=Ae.set(m.ExtHostContext.ExtHostTimeline,new Y.ExtHostTimeline(Ae,bt)),fi=Ae.set(m.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Ae,gt.remote,mt,We,Ge)),mi=Ae.set(m.ExtHostContext.ExtHostWebviewPanels,new Re.ExtHostWebviewPanels(Ae,fi,mt)),Hi=Ae.set(m.ExtHostContext.ExtHostCustomEditors,new he.ExtHostCustomEditors(Ae,Rt,ce,fi,mi)),ji=Ae.set(m.ExtHostContext.ExtHostWebviewViews,new Ie.ExtHostWebviewViews(Ae,fi)),ri=Ae.set(m.ExtHostContext.ExtHostTesting,new xe.ExtHostTesting(Ae,bt,lt)),Vi=Ae.set(m.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(Ae)),xi=Ae.set(m.ExtHostContext.ExtHostProfileContentHandlers,new ft.ExtHostProfileContentHandlers(Ae));Ae.set(m.ExtHostContext.ExtHostInteractive,new Fe.ExtHostInteractive(Ae,Dt,lt,bt,We));const qi=Ae.set(m.ExtHostContext.ExtHostInteractiveEditor,new vt.ExtHostInteractiveEditor(Ae,bt,Rt,We)),si=Ae.set(m.ExtHostContext.ExtHostChat,new Tt.ExtHostChat(Ae,We)),Gi=Ae.set(m.ExtHostContext.ExtHostSemanticSimilarity,new Mt.ExtHostSemanticSimilarity(Ae)),Ki=Ae.set(m.ExtHostContext.ExtHostIssueReporter,new qt.ExtHostIssueReporter(Ae)),Ii=Ae.set(m.ExtHostContext.ExtHostStatusBar,new $.ExtHostStatusBar(Ae,bt.converter)),Xi=Object.values(m.ExtHostContext);Ae.assertRegistered(Xi);const Qi=new Te.ExtHostBulkEdits(Ae,lt),ln=new b.ExtHostClipboard(Ae),ki=new E.ExtHostMessageService(Ae,We),gi=new w.ExtHostDialogs(Ae);return C.ExtHostApiCommands.register(bt),function($e,Jt,Yi){const pt=function(){let ge=!$e.isUnderDevelopment;function Se(){ge||(We.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Ue(rt){if(Array.isArray(rt))rt.forEach(Ue);else if(typeof rt=="string")Se();else{const It=rt;typeof It.scheme>"u"&&Se(),typeof It.exclusive=="boolean"&&(0,He.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return rt}}(),Pi={getSession(ge,Se,Ue){return ni.getSession($e,ge,Se,Ue)},getSessions(ge,Se){return(0,He.checkProposedApiEnabled)($e,"authGetSessions"),ni.getSessions($e,ge,Se)},async hasSession(ge,Se){return(0,He.checkProposedApiEnabled)($e,"authSession"),!!await ni.getSession($e,ge,Se,{silent:!0})},get onDidChangeSessions(){return ni.onDidChangeSessions},registerAuthenticationProvider(ge,Se,Ue,rt){return ni.registerAuthenticationProvider(ge,Se,Ue,rt)}},Ji={registerCommand(ge,Se,Ue){return bt.registerCommand(!0,ge,Se,Ue,void 0,$e)},registerTextEditorCommand(ge,Se,Ue){return bt.registerCommand(!0,ge,(...rt)=>{const It=Nt.getActiveTextEditor();if(!It){We.warn("Cannot execute "+ge+" because there is no active text editor.");return}return It.edit(Ot=>{Se.apply(Ue,[It,Ot,...rt])}).then(Ot=>{Ot||We.warn("Edits from command "+ge+" were not applied.")},Ot=>{We.warn("An error occurred while running command "+ge,Ot)})},void 0,void 0,$e)},registerDiffInformationCommand:(ge,Se,Ue)=>((0,He.checkProposedApiEnabled)($e,"diffCommand"),bt.registerCommand(!0,ge,async(...rt)=>{const It=lt.activeEditor(!0);if(!It){We.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Ot=await Nt.getDiffInformation(It.id);Se.apply(Ue,[Ot,...rt])},void 0,void 0,$e)),executeCommand(ge,...Se){return bt.executeCommand(ge,...Se)},getCommands(ge=!1){return bt.getCommands(ge)}},Ai={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return wt.getDefaultShell(!1)},get onDidChangeShell(){return(0,He.checkProposedApiEnabled)($e,"envShellEvent"),wt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,He.checkProposedApiEnabled)($e,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,He.checkProposedApiEnabled)($e,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,Se){return nt.ExtHostTelemetryLogger.validateSender(ge),kt.instantiateLogger($e,ge,Se)},openExternal(ge,Se){return it.openUri(ge,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===gt.environment.appUriScheme)return wi.createAppUri(ge);try{return await it.asExternalUri(ge,{allowTunneling:!!gt.remote.authority})}catch(Se){if((0,X.matchesScheme)(ge,ke.Schemas.http)||(0,X.matchesScheme)(ge,ke.Schemas.https))return ge;throw Se}},get remoteName(){return(0,be.getRemoteName)(gt.remote.authority)},get remoteAuthority(){return(0,He.checkProposedApiEnabled)($e,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return We.getLevel()},get onDidChangeLogLevel(){return We.onDidChangeLogLevel},registerIssueUriRequestHandler(ge){return(0,He.checkProposedApiEnabled)($e,"handleIssueUri"),Ki.registerIssueUriRequestHandler($e,ge)},get appQuality(){return(0,He.checkProposedApiEnabled)($e,"resolvers"),gt.quality},get appCommit(){return(0,He.checkProposedApiEnabled)($e,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(Ai);const Zi={createTestController(ge,Se,Ue){return ri.createTestController($e,ge,Se,Ue)},createTestObserver(){return(0,He.checkProposedApiEnabled)($e,"testObserver"),ri.createTestObserver()},runTests(ge){return(0,He.checkProposedApiEnabled)($e,"testObserver"),ri.runTests(ge)},get onDidChangeTestResults(){return(0,He.checkProposedApiEnabled)($e,"testObserver"),ri.onResultsChanged},get testResults(){return(0,He.checkProposedApiEnabled)($e,"testObserver"),ri.results}},pi=gt.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,_i={getExtension(ge,Se){(0,He.isProposedApiEnabled)($e,"extensionsAny")||(Se=!1);const Ue=Jt.mine.getExtensionDescription(ge);if(Ue)return new o.Extension(yt,$e.identifier,Ue,pi,!1);if(Se){const rt=Jt.all.getExtensionDescription(ge);if(rt)return new o.Extension(yt,$e.identifier,rt,pi,!0)}},get all(){const ge=[];for(const Se of Jt.mine.getAllExtensionDescriptions())ge.push(new o.Extension(yt,$e.identifier,Se,pi,!1));return ge},get allAcrossExtensionHosts(){(0,He.checkProposedApiEnabled)($e,"extensionsAny");const ge=new ae.ExtensionIdentifierSet(Jt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Se=[];for(const Ue of Jt.all.getAllExtensionDescriptions()){const rt=!ge.has(Ue.identifier);Se.push(new o.Extension(yt,$e.identifier,Ue,pi,rt))}return Se},get onDidChange(){return(0,He.isProposedApiEnabled)($e,"extensionsAny")?u.Event.any(Jt.mine.onDidChange,Jt.all.onDidChange):Jt.mine.onDidChange}},en={createDiagnosticCollection(ge){return ci.createDiagnosticCollection($e.identifier,ge)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:ge=>ci.getDiagnostics(ge),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(ge,Se){return li.changeLanguage(ge.uri,Se)},match(ge,Se){const Ue=Rt.getDocumentData(Se.uri)?.notebook;return(0,T.score)(B.LanguageSelector.from(ge),Se.uri,Se.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(ge,Se,Ue){return dt.registerCodeActionProvider($e,pt(ge),Se,Ue)},registerDocumentPasteEditProvider(ge,Se,Ue){return(0,He.checkProposedApiEnabled)($e,"documentPaste"),dt.registerDocumentPasteEditProvider($e,pt(ge),Se,Ue)},registerCodeLensProvider(ge,Se){return dt.registerCodeLensProvider($e,pt(ge),Se)},registerDefinitionProvider(ge,Se){return dt.registerDefinitionProvider($e,pt(ge),Se)},registerDeclarationProvider(ge,Se){return dt.registerDeclarationProvider($e,pt(ge),Se)},registerImplementationProvider(ge,Se){return dt.registerImplementationProvider($e,pt(ge),Se)},registerTypeDefinitionProvider(ge,Se){return dt.registerTypeDefinitionProvider($e,pt(ge),Se)},registerHoverProvider(ge,Se){return dt.registerHoverProvider($e,pt(ge),Se,$e.identifier)},registerEvaluatableExpressionProvider(ge,Se){return dt.registerEvaluatableExpressionProvider($e,pt(ge),Se,$e.identifier)},registerInlineValuesProvider(ge,Se){return dt.registerInlineValuesProvider($e,pt(ge),Se,$e.identifier)},registerDocumentHighlightProvider(ge,Se){return dt.registerDocumentHighlightProvider($e,pt(ge),Se)},registerLinkedEditingRangeProvider(ge,Se){return dt.registerLinkedEditingRangeProvider($e,pt(ge),Se)},registerReferenceProvider(ge,Se){return dt.registerReferenceProvider($e,pt(ge),Se)},registerRenameProvider(ge,Se){return dt.registerRenameProvider($e,pt(ge),Se)},registerDocumentSymbolProvider(ge,Se,Ue){return dt.registerDocumentSymbolProvider($e,pt(ge),Se,Ue)},registerWorkspaceSymbolProvider(ge){return dt.registerWorkspaceSymbolProvider($e,ge)},registerDocumentFormattingEditProvider(ge,Se){return dt.registerDocumentFormattingEditProvider($e,pt(ge),Se)},registerDocumentRangeFormattingEditProvider(ge,Se){return dt.registerDocumentRangeFormattingEditProvider($e,pt(ge),Se)},registerOnTypeFormattingEditProvider(ge,Se,Ue,...rt){return dt.registerOnTypeFormattingEditProvider($e,pt(ge),Se,[Ue].concat(rt))},registerDocumentSemanticTokensProvider(ge,Se,Ue){return dt.registerDocumentSemanticTokensProvider($e,pt(ge),Se,Ue)},registerDocumentRangeSemanticTokensProvider(ge,Se,Ue){return dt.registerDocumentRangeSemanticTokensProvider($e,pt(ge),Se,Ue)},registerSignatureHelpProvider(ge,Se,Ue,...rt){return typeof Ue=="object"?dt.registerSignatureHelpProvider($e,pt(ge),Se,Ue):dt.registerSignatureHelpProvider($e,pt(ge),Se,typeof Ue>"u"?[]:[Ue,...rt])},registerCompletionItemProvider(ge,Se,...Ue){return dt.registerCompletionItemProvider($e,pt(ge),Se,Ue)},registerInlineCompletionItemProvider(ge,Se){return Se.handleDidShowCompletionItem&&(0,He.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),Se.handleDidPartiallyAcceptCompletionItem&&(0,He.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider($e,pt(ge),Se)},registerDocumentLinkProvider(ge,Se){return dt.registerDocumentLinkProvider($e,pt(ge),Se)},registerColorProvider(ge,Se){return dt.registerColorProvider($e,pt(ge),Se)},registerFoldingRangeProvider(ge,Se){return dt.registerFoldingRangeProvider($e,pt(ge),Se)},registerSelectionRangeProvider(ge,Se){return dt.registerSelectionRangeProvider($e,ge,Se)},registerCallHierarchyProvider(ge,Se){return dt.registerCallHierarchyProvider($e,ge,Se)},registerTypeHierarchyProvider(ge,Se){return dt.registerTypeHierarchyProvider($e,ge,Se)},setLanguageConfiguration:(ge,Se)=>dt.setLanguageConfiguration($e,ge,Se),getTokenInformationAtPosition(ge,Se){return(0,He.checkProposedApiEnabled)($e,"tokenInformation"),li.tokenAtPosition(ge,Se)},registerInlayHintsProvider(ge,Se){return dt.registerInlayHintsProvider($e,ge,Se)},createLanguageStatusItem(ge,Se){return li.createLanguageStatusItem($e,ge,Se)},registerDocumentDropEditProvider(ge,Se,Ue){return dt.registerDocumentOnDropEditProvider($e,ge,Se,(0,He.isProposedApiEnabled)($e,"dropMetadata")?Ue:void 0)}},Zt={get activeTextEditor(){return Nt.getActiveTextEditor()},get visibleTextEditors(){return Nt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(ge,Se,Ue){const rt=await(L.URI.isUri(ge)?Promise.resolve(ui.openTextDocument(ge)):Promise.resolve(ge));return Nt.showTextDocument(rt,Se,Ue)},createTextEditorDecorationType(ge){return Nt.createTextEditorDecorationType($e,ge)},onDidChangeActiveTextEditor(ge,Se,Ue){return Nt.onDidChangeActiveTextEditor(ge,Se,Ue)},onDidChangeVisibleTextEditors(ge,Se,Ue){return Nt.onDidChangeVisibleTextEditors(ge,Se,Ue)},onDidChangeTextEditorSelection(ge,Se,Ue){return Nt.onDidChangeTextEditorSelection(ge,Se,Ue)},onDidChangeTextEditorOptions(ge,Se,Ue){return Nt.onDidChangeTextEditorOptions(ge,Se,Ue)},onDidChangeTextEditorVisibleRanges(ge,Se,Ue){return Nt.onDidChangeTextEditorVisibleRanges(ge,Se,Ue)},onDidChangeTextEditorViewColumn(ge,Se,Ue){return Nt.onDidChangeTextEditorViewColumn(ge,Se,Ue)},onDidCloseTerminal(ge,Se,Ue){return wt.onDidCloseTerminal(ge,Se,Ue)},onDidOpenTerminal(ge,Se,Ue){return wt.onDidOpenTerminal(ge,Se,Ue)},onDidChangeActiveTerminal(ge,Se,Ue){return wt.onDidChangeActiveTerminal(ge,Se,Ue)},onDidChangeTerminalDimensions(ge,Se,Ue){return(0,He.checkProposedApiEnabled)($e,"terminalDimensions"),wt.onDidChangeTerminalDimensions(ge,Se,Ue)},onDidChangeTerminalState(ge,Se,Ue){return wt.onDidChangeTerminalState(ge,Se,Ue)},onDidWriteTerminalData(ge,Se,Ue){return(0,He.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),wt.onDidWriteTerminalData(ge,Se,Ue)},get state(){return it.getState($e)},onDidChangeWindowState(ge,Se,Ue){return it.onDidChangeWindowState(ge,Se,Ue)},showInformationMessage(ge,...Se){return ki.showMessage($e,O.default.Info,ge,Se[0],Se.slice(1))},showWarningMessage(ge,...Se){return ki.showMessage($e,O.default.Warning,ge,Se[0],Se.slice(1))},showErrorMessage(ge,...Se){return ki.showMessage($e,O.default.Error,ge,Se[0],Se.slice(1))},showQuickPick(ge,Se,Ue){return Xt.showQuickPick($e,ge,Se,Ue)},showWorkspaceFolderPick(ge){return Xt.showWorkspaceFolderPick(ge)},showInputBox(ge,Se){return Xt.showInput(ge,Se)},showOpenDialog(ge){return gi.showOpenDialog($e,ge)},showSaveDialog(ge){return gi.showSaveDialog(ge)},createStatusBarItem(ge,Se,Ue){let rt,It,Ot;return typeof ge=="string"?(rt=ge,It=Se,Ot=Ue):(It=ge,Ot=Se),Ii.createStatusBarEntry($e,rt,It,Ot)},setStatusBarMessage(ge,Se){return Ii.setStatusBarMessage(ge,Se)},withScmProgress(ge){return Ge.report("window.withScmProgress",$e,"Use 'withProgress' instead."),Ci.withProgress($e,{location:z.ProgressLocation.SourceControl},(Se,Ue)=>ge({report(rt){}}))},withProgress(ge,Se){return Ci.withProgress($e,ge,Se)},createOutputChannel(ge,Se){return Oi.createOutputChannel(ge,Se,$e)},createWebviewPanel(ge,Se,Ue,rt){return mi.createWebviewPanel($e,ge,Se,Ue,rt)},createWebviewTextEditorInset(ge,Se,Ue,rt){return(0,He.checkProposedApiEnabled)($e,"editorInsets"),Yt.createWebviewEditorInset(ge,Se,Ue,rt,$e)},createTerminal(ge,Se,Ue){return typeof ge=="object"?"pty"in ge?wt.createExtensionTerminal(ge):wt.createTerminalFromOptions(ge):wt.createTerminal(ge,Se,Ue)},registerTerminalLinkProvider(ge){return wt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,Se){return wt.registerProfileProvider($e,ge,Se)},registerTerminalQuickFixProvider(ge,Se){return(0,He.checkProposedApiEnabled)($e,"terminalQuickFixProvider"),wt.registerTerminalQuickFixProvider(ge,$e.identifier.value,Se)},registerTreeDataProvider(ge,Se){return Si.registerTreeDataProvider(ge,Se,$e)},createTreeView(ge,Se){return Si.createTreeView(ge,Se,$e)},registerWebviewPanelSerializer:(ge,Se)=>mi.registerWebviewPanelSerializer($e,ge,Se),registerCustomEditorProvider:(ge,Se,Ue={})=>Hi.registerCustomEditorProvider($e,ge,Se,Ue),registerFileDecorationProvider(ge){return Et.registerFileDecorationProvider(ge,$e)},registerUriHandler(ge){return wi.registerUriHandler($e,ge)},createQuickPick(){return Xt.createQuickPick($e)},createInputBox(){return Xt.createInputBox($e)},get activeColorTheme(){return Di.activeColorTheme},onDidChangeActiveColorTheme(ge,Se,Ue){return Di.onDidChangeActiveColorTheme(ge,Se,Ue)},registerWebviewViewProvider(ge,Se,Ue){return ji.registerWebviewViewProvider($e,ge,Se,Ue?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,Se,Ue){return Dt.onDidChangeActiveNotebookEditor(ge,Se,Ue)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,Se,Ue){return Ei.onDidChangeNotebookEditorSelection(ge,Se,Ue)},onDidChangeNotebookEditorVisibleRanges(ge,Se,Ue){return Ei.onDidChangeNotebookEditorVisibleRanges(ge,Se,Ue)},showNotebookDocument(ge,Se){return Dt.showNotebookDocument(ge,Se)},registerExternalUriOpener(ge,Se,Ue){return(0,He.checkProposedApiEnabled)($e,"externalUriOpener"),Vi.registerExternalUriOpener($e.identifier,ge,Se,Ue)},registerProfileContentHandler(ge,Se){return(0,He.checkProposedApiEnabled)($e,"profileContentHandlers"),xi.registrProfileContentHandler($e,ge,Se)},registerQuickDiffProvider(ge,Se,Ue,rt){return(0,He.checkProposedApiEnabled)($e,"quickDiffProvider"),Ui.registerQuickDiffProvider(pt(ge),Se,Ue,rt)},get tabGroups(){return Lt.tabGroups},registerShareProvider(ge,Se){return(0,He.checkProposedApiEnabled)($e,"shareProvider"),Bi.registerShareProvider(pt(ge),Se)}},ui={get rootPath(){return Ge.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(ge){throw R.readonly()},getWorkspaceFolder(ge){return mt.getWorkspaceFolder(ge)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(ge){throw R.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(ge){throw R.readonly()},updateWorkspaceFolders:(ge,Se,...Ue)=>mt.updateWorkspaceFolders($e,ge,Se||0,...Ue),onDidChangeWorkspaceFolders:function(ge,Se,Ue){return mt.onDidChangeWorkspace(ge,Se,Ue)},asRelativePath:(ge,Se)=>mt.getRelativePath(ge,Se),findFiles:(ge,Se,Ue,rt)=>mt.findFiles(ge,Se,Ue,$e.identifier,rt),findTextInFiles:(ge,Se,Ue,rt)=>{(0,He.checkProposedApiEnabled)($e,"findTextInFiles");let It,Ot;return typeof Se=="object"?(It=Se,Ot=Ue):(It={},Ot=Se,rt=Ue),mt.findTextInFiles(ge,It||{},Ot,$e.identifier,rt)},save:ge=>((0,He.checkProposedApiEnabled)($e,"saveEditor"),mt.save(ge)),saveAs:ge=>((0,He.checkProposedApiEnabled)($e,"saveEditor"),mt.saveAs(ge)),saveAll:ge=>mt.saveAll(ge),applyEdit(ge,Se){return Qi.applyWorkspaceEdit(ge,$e,Se)},createFileSystemWatcher:(ge,Se,Ue,rt)=>ei.createFileSystemWatcher(mt,$e,ge,Se,Ue,rt),get textDocuments(){return Rt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw R.readonly()},openTextDocument(ge){let Se;const Ue=ge;if(typeof ge=="string")Se=Promise.resolve(L.URI.file(ge));else if(L.URI.isUri(ge))Se=Promise.resolve(ge);else if(!Ue||typeof Ue=="object")Se=Rt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(rt=>Rt.ensureDocumentData(rt).then(It=>It.document))},onDidOpenTextDocument:(ge,Se,Ue)=>Rt.onDidAddDocument(ge,Se,Ue),onDidCloseTextDocument:(ge,Se,Ue)=>Rt.onDidRemoveDocument(ge,Se,Ue),onDidChangeTextDocument:(ge,Se,Ue)=>Rt.onDidChangeDocument(ge,Se,Ue),onDidSaveTextDocument:(ge,Se,Ue)=>Rt.onDidSaveDocument(ge,Se,Ue),onWillSaveTextDocument:(ge,Se,Ue)=>ai.getOnWillSaveTextDocumentEvent($e)(ge,Se,Ue),get notebookDocuments(){return Dt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,Se){let Ue;if(L.URI.isUri(ge))Ue=ge,await Dt.openNotebookDocument(ge);else if(typeof ge=="string")Ue=L.URI.revive(await Dt.createNotebookDocument({viewType:ge,content:Se}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(ge,Se,Ue){return di.onDidSaveNotebookDocument(ge,Se,Ue)},onDidChangeNotebookDocument(ge,Se,Ue){return di.onDidChangeNotebookDocument(ge,Se,Ue)},onWillSaveNotebookDocument(ge,Se,Ue){return Ni.getOnWillSaveNotebookDocumentEvent($e)(ge,Se,Ue)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,Se,Ue,rt){return Dt.registerNotebookSerializer($e,ge,Se,Ue,(0,He.isProposedApiEnabled)($e,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ge,Se,Ue)=>Yi.onDidChangeConfiguration(ge,Se,Ue),getConfiguration(ge,Se){return Se=arguments.length===1?void 0:Se,Yi.getConfiguration(ge,Se,$e)},registerTextDocumentContentProvider(ge,Se){return Fi.registerTextDocumentContentProvider(ge,Se)},registerTaskProvider:(ge,Se)=>(Ge.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),Vt.registerTaskProvider($e,ge,Se)),registerFileSystemProvider(ge,Se,Ue){return(0,ze.combinedDisposable)(Mi.registerFileSystemProvider($e,ge,Se,Ue),$t.addFileSystemProvider(ge,Se))},get fs(){return $t.value},registerFileSearchProvider:(ge,Se)=>((0,He.checkProposedApiEnabled)($e,"fileSearchProvider"),oi.registerFileSearchProvider(ge,Se)),registerTextSearchProvider:(ge,Se)=>((0,He.checkProposedApiEnabled)($e,"textSearchProvider"),oi.registerTextSearchProvider(ge,Se)),registerRemoteAuthorityResolver:(ge,Se)=>((0,He.checkProposedApiEnabled)($e,"resolvers"),yt.registerRemoteAuthorityResolver(ge,Se)),registerResourceLabelFormatter:ge=>((0,He.checkProposedApiEnabled)($e,"resolvers"),zi.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,Se,Ue)=>ei.onDidCreateFile(ge,Se,Ue),onDidDeleteFiles:(ge,Se,Ue)=>ei.onDidDeleteFile(ge,Se,Ue),onDidRenameFiles:(ge,Se,Ue)=>ei.onDidRenameFile(ge,Se,Ue),onWillCreateFiles:(ge,Se,Ue)=>ei.getOnWillCreateFileEvent($e)(ge,Se,Ue),onWillDeleteFiles:(ge,Se,Ue)=>ei.getOnWillDeleteFileEvent($e)(ge,Se,Ue),onWillRenameFiles:(ge,Se,Ue)=>ei.getOnWillRenameFileEvent($e)(ge,Se,Ue),openTunnel:ge=>((0,He.checkProposedApiEnabled)($e,"tunnels"),Ye.openTunnel($e,ge).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,He.checkProposedApiEnabled)($e,"tunnels"),Ye.getTunnels()},onDidChangeTunnels:(ge,Se,Ue)=>((0,He.checkProposedApiEnabled)($e,"tunnels"),Ye.onDidChangeTunnels(ge,Se,Ue)),registerPortAttributesProvider:(ge,Se)=>((0,He.checkProposedApiEnabled)($e,"portsAttributes"),Ye.registerPortsAttributesProvider(ge,Se)),registerTimelineProvider:(ge,Se)=>((0,He.checkProposedApiEnabled)($e,"timeline"),Wi.registerTimelineProvider(ge,Se,$e.identifier,bt.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:ge=>((0,He.checkProposedApiEnabled)($e,"workspaceTrust"),mt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,Se,Ue)=>mt.onDidGrantWorkspaceTrust(ge,Se,Ue),registerEditSessionIdentityProvider:(ge,Se)=>((0,He.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(ge,Se)),onWillCreateEditSessionIdentity:(ge,Se,Ue)=>((0,He.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),mt.getOnWillCreateEditSessionIdentityEvent($e)(ge,Se,Ue)),registerCanonicalUriProvider:(ge,Se)=>((0,He.checkProposedApiEnabled)($e,"canonicalUriProvider"),mt.registerCanonicalUriProvider(ge,Se)),getCanonicalUri:(ge,Se,Ue)=>((0,He.checkProposedApiEnabled)($e,"canonicalUriProvider"),mt.provideCanonicalUri(ge,Se,Ue))},un={get inputBox(){return Ge.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox($e)},createSourceControl(ge,Se,Ue){return yi.createSourceControl($e,ge,Se,Ue)}},xt={createCommentController(ge,Se){return $i.createCommentController($e,ge,Se)}},bi={get activeDebugSession(){return St.activeDebugSession},get activeDebugConsole(){return St.activeDebugConsole},get breakpoints(){return St.breakpoints},get stackFrameFocus(){return St.stackFrameFocus},onDidStartDebugSession(ge,Se,Ue){return St.onDidStartDebugSession(ge,Se,Ue)},onDidTerminateDebugSession(ge,Se,Ue){return St.onDidTerminateDebugSession(ge,Se,Ue)},onDidChangeActiveDebugSession(ge,Se,Ue){return St.onDidChangeActiveDebugSession(ge,Se,Ue)},onDidReceiveDebugSessionCustomEvent(ge,Se,Ue){return St.onDidReceiveDebugSessionCustomEvent(ge,Se,Ue)},onDidChangeBreakpoints(ge,Se,Ue){return St.onDidChangeBreakpoints(ge,Se,Ue)},onDidChangeStackFrameFocus(ge,Se,Ue){return(0,He.checkProposedApiEnabled)($e,"debugFocus"),St.onDidChangeStackFrameFocus(ge,Se,Ue)},registerDebugConfigurationProvider(ge,Se,Ue){return St.registerDebugConfigurationProvider(ge,Se,Ue||Je.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,Se){return St.registerDebugAdapterDescriptorFactory($e,ge,Se)},registerDebugAdapterTrackerFactory(ge,Se){return St.registerDebugAdapterTrackerFactory(ge,Se)},startDebugging(ge,Se,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?St.startDebugging(ge,Se,{parentSession:Ue}):St.startDebugging(ge,Se,Ue||{})},stopDebugging(ge){return St.stopDebugging(ge)},addBreakpoints(ge){return St.addBreakpoints(ge)},removeBreakpoints(ge){return St.removeBreakpoints(ge)},asDebugSourceUri(ge,Se){return St.asDebugSourceUri(ge,Se)}},tn={registerTaskProvider:(ge,Se)=>Vt.registerTaskProvider($e,ge,Se),fetchTasks:ge=>Vt.fetchTasks(ge),executeTask:ge=>Vt.executeTask($e,ge),get taskExecutions(){return Vt.taskExecutions},onDidStartTask:(ge,Se,Ue)=>Vt.onDidStartTask(ge,Se,Ue),onDidEndTask:(ge,Se,Ue)=>Vt.onDidEndTask(ge,Se,Ue),onDidStartTaskProcess:(ge,Se,Ue)=>Vt.onDidStartTaskProcess(ge,Se,Ue),onDidEndTaskProcess:(ge,Se,Ue)=>Vt.onDidEndTaskProcess(ge,Se,Ue)},nn={createNotebookController(ge,Se,Ue,rt,It){return hi.createNotebookController($e,ge,Se,Ue,rt,(0,He.isProposedApiEnabled)($e,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(ge,Se)=>Dt.registerNotebookCellStatusBarItemProvider($e,ge,Se),createRendererMessaging(ge){return cn.createRendererMessaging($e,ge)},createNotebookControllerDetectionTask(ge){return(0,He.checkProposedApiEnabled)($e,"notebookKernelSource"),hi.createNotebookControllerDetectionTask($e,ge)},registerKernelSourceActionProvider(ge,Se){return(0,He.checkProposedApiEnabled)($e,"notebookKernelSource"),hi.registerKernelSourceActionProvider($e,ge,Se)},onDidChangeNotebookCellExecutionState(ge,Se,Ue){return(0,He.checkProposedApiEnabled)($e,"notebookCellExecutionState"),hi.onDidChangeNotebookCellExecutionState(ge,Se,Ue)}},rn={t(...ge){if(typeof ge[0]=="string"){const Se=ge.shift(),Ue=!ge||typeof ge[0]!="object"?ge:ge[0];return Kt.getMessage($e.identifier.value,{message:Se,args:Ue})}return Kt.getMessage($e.identifier.value,ge[0])},get bundle(){return Kt.getBundle($e.identifier.value)},get uri(){return Kt.getBundleUri($e.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(ge){return(0,He.checkProposedApiEnabled)($e,"interactive"),qi.registerProvider($e,ge)},registerInteractiveSessionProvider(ge,Se){return(0,He.checkProposedApiEnabled)($e,"interactive"),si.registerChatProvider($e,ge,Se)},addInteractiveRequest(ge){return(0,He.checkProposedApiEnabled)($e,"interactive"),si.addChatRequest(ge)},sendInteractiveRequestToProvider(ge,Se){return(0,He.checkProposedApiEnabled)($e,"interactive"),si.sendInteractiveRequestToProvider(ge,Se)},get onDidPerformUserAction(){return(0,He.checkProposedApiEnabled)($e,"interactiveUserActions"),si.onDidPerformUserAction}},dn={registerSlashCommandProvider(ge,Se){return(0,He.checkProposedApiEnabled)($e,"interactiveSlashCommands"),si.registerSlashCommandProvider($e,ge,Se)}},on={registerSemanticSimilarityProvider(ge){return(0,He.checkProposedApiEnabled)($e,"semanticSimilarity"),Gi.registerSemanticSimilarityProvider($e,ge)}};return{version:gt.version,ai:on,authentication:Pi,commands:Ji,comments:xt,debug:bi,env:Ai,extensions:_i,interactive:sn,interactiveSlashCommands:dn,l10n:rn,languages:en,notebooks:nn,scm:un,tasks:tn,tests:Zi,window:Zt,workspace:ui,Breakpoint:z.Breakpoint,TerminalOutputAnchor:z.TerminalOutputAnchor,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentState:z.CommentState,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Je.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,EventEmitter:u.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileDecoration2:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionList:z.InlineSuggestionList,Hover:z.Hover,IndentAction:g.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalQuickFixCommand:z.TerminalQuickFixCommand,TerminalQuickFixOpener:z.TerminalQuickFixOpener,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TerminalExitReason:z.TerminalExitReason,TerminalQuickFixType:z.TerminalQuickFixType,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,SnippetTextEdit:z.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItem2:z.TreeItem,TreeItemCheckboxState:z.TreeItemCheckboxState,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:D.UIKind,Uri:L.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,DocumentDropEdit:z.DocumentDropEdit,DocumentPasteEdit:z.DocumentPasteEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,ManagedResolvedAuthority:z.ManagedResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,NotebookControllerAffinity2:z.NotebookControllerAffinity2,NotebookEdit:z.NotebookEdit,NotebookKernelSourceAction:z.NotebookKernelSourceAction,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestRunRequest2:z.TestRunRequest2,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:et.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind,InputBoxValidationSeverity:z.InputBoxValidationSeverity,TabInputText:z.TextTabInput,TabInputTextDiff:z.TextDiffTabInput,TabInputTextMerge:z.TextMergeTabInput,TabInputCustom:z.CustomEditorTabInput,TabInputNotebook:z.NotebookEditorTabInput,TabInputNotebookDiff:z.NotebookDiffEditorTabInput,TabInputWebview:z.WebviewEditorTabInput,TabInputTerminal:z.TerminalEditorTabInput,TabInputInteractiveWindow:z.InteractiveWindowInput,TelemetryTrustedValue:ee.TelemetryTrustedValue,LogLevel:_.LogLevel,EditSessionIdentityMatch:st.EditSessionIdentityMatch,InteractiveSessionVoteDirection:z.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:z.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:z.InteractiveEditorResponseFeedbackKind,StackFrameFocus:z.StackFrameFocus,ThreadFocus:z.ThreadFocus,NotebookCodeActionKind:z.NotebookCodeActionKind}}}e.createApiFactoryAndRegisterActors=jt}),define(Ce[331],De([1,0,97,146,35,143,38,37,62,43,87,89,90,108,58,83,145,64,50,107,82,63,144,17,51,105,106]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d,S,w,p,t,a,r,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,c.registerSingleton)(a.ILoggerService,t.ExtHostLoggerService,1),(0,c.registerSingleton)(b.IExtHostApiDeprecationService,b.ExtHostApiDeprecationService,1),(0,c.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,c.registerSingleton)(L.IExtHostConfiguration,L.ExtHostConfiguration,0),(0,c.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,0),(0,c.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,c.registerSingleton)(O.IExtHostDecorations,O.ExtHostDecorations,0),(0,c.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,c.registerSingleton)(f.IExtHostManagedSockets,f.ExtHostManagedSockets,0),(0,c.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo,0),(0,c.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService,1),(0,c.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,0),(0,c.registerSingleton)(D.IExtHostStorage,D.ExtHostStorage,0),(0,c.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask,0),(0,c.registerSingleton)(g.IExtHostTerminalService,g.WorkerExtHostTerminalService,0),(0,c.registerSingleton)(C.IExtHostTunnelService,C.ExtHostTunnelService,0),(0,c.registerSingleton)(n.IExtHostWindow,n.ExtHostWindow,0),(0,c.registerSingleton)(u.IExtHostWorkspace,u.ExtHostWorkspace,0),(0,c.registerSingleton)(S.IExtHostSecretState,S.ExtHostSecretState,0),(0,c.registerSingleton)(w.IExtHostTelemetry,w.ExtHostTelemetry,0),(0,c.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,c.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(Ce[109],De([1,0,19,17,34,86]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function L(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=L;function A(P,m,D,C){const b=(0,c.mapArrayOrNot)(D,y),n=new u.TextSearchMatch(m,b,C),h=n.preview.matches;return{ranges:(0,c.mapArrayOrNot)(b,g),uri:P,preview:{text:n.preview.text,matches:(0,c.mapArrayOrNot)(h,g)}}}e.createTextSearchResult=A;function y(P){return new u.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function g(P){return new O.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let T=e.OutputChannel=class{constructor(m,D){this.a=m,this.b=D}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.OutputChannel=T=qe([je(1,R.ILogService)],T)}),define(Ce[332],De([1,0,45,10,69,30,9,11,109,333]),function(re,e,c,R,u,O,L,A,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const T=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(S,w,p,t){const a=m(S,w,p,t),r=w.folder.fsPath;return{cmd:c.spawn(T,a.args,{cwd:r}),rgDiskPath:T,siblingClauses:a.siblingClauses,rgArgs:a,cwd:r}}e.spawnRipgrepCmd=P;function m(S,w,p,t){const a=["--files","--hidden","--case-sensitive"];C([w],p,!1).forEach(o=>{const f=(0,y.anchorGlob)(o);if(a.push("-g",f),L.isMacintosh){const v=(0,u.normalizeNFD)(f);v!==f&&a.push("-g",v)}});const r=D([w],t,void 0,!1);return r.globArgs.forEach(o=>{const f=`!${(0,y.anchorGlob)(o)}`;if(a.push("-g",f),L.isMacintosh){const v=(0,u.normalizeNFD)(f);v!==f&&a.push("-g",v)}}),w.disregardIgnoreFiles!==!1?a.push("--no-ignore"):w.disregardParentIgnoreFiles!==!1&&a.push("--no-ignore-parent"),w.ignoreSymlinks||a.push("--follow"),S.exists&&a.push("--quiet"),a.push("--no-config"),w.disregardGlobalIgnoreFiles&&a.push("--no-ignore-global"),{args:a,siblingClauses:r.siblingClauses}}function D(S,w,p,t=!0){const a=[];let r={};return S.forEach(o=>{const f=Object.assign({},o.excludePattern||{},w||{}),v=b(f,t?o.folder.fsPath:void 0,p);a.push(...v.globArgs),v.siblingClauses&&(r=Object.assign(r,v.siblingClauses))}),{globArgs:a,siblingClauses:r}}function C(S,w,p=!0){const t=[];return S.forEach(a=>{const r=Object.assign({},w||{},a.includePattern||{}),o=b(r,p?a.folder.fsPath:void 0);t.push(...o.globArgs)}),t}function b(S,w,p){const t=[],a={};return Object.keys(S).forEach(r=>{if(p&&p.has(r)||!r)return;const o=S[r];r=h(w?n(w,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof o=="boolean"&&o?(r.startsWith("\\\\")&&(r+="**"),t.push(d(r))):o&&o.when&&(a[r]=o)}),{globArgs:t,siblingClauses:a}}function n(S,w){return R.isAbsolute(w)?w:R.join(S,w)}e.getAbsoluteGlob=n;function h(S){return S=A.rtrim(S,"\\"),A.rtrim(S,"/")}function d(S){return O.getRoot(S).toLowerCase()==="c:/"?S.replace(/^c:[/\\]/i,"/"):S}e.fixDriveC=d}),define(Ce[334],De([1,0,45,48,10,335,19,46,32,69,30,9,40,11,12,29,34,332,114]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const S=new Set;process.on("exit",()=>{S.forEach(r=>r())});class w{constructor(o){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=o,this.b=o.filePattern||"",this.d=o.includePattern&&y.parse(o.includePattern),this.f=o.maxResults||null,this.g=!!o.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,d.prepareQuery)(this.b).normalizedLowercase),this.u=o.excludePattern&&y.parse(o.excludePattern),this.t=new Map,o.folderQueries.forEach(f=>{const v=Object.assign({},f.excludePattern||{},this.a.excludePattern||{}),l=f.folder.fsPath;o.folderQueries.map(I=>I.folder.fsPath).filter(I=>I!==l).forEach(I=>{(0,T.isEqualOrParent)(I,l)&&(v[u.relative(l,I)]=!0)}),this.t.set(l,new t(v,l))})}cancel(){this.l=!0,S.forEach(o=>o())}walk(o,f,v,l,I){if(this.m=m.StopWatch.create(!1),this.l)return I(null,this.j);f.forEach(E=>{const s=u.basename(E.fsPath);this.u&&this.u(E.fsPath,s)||this.J(v,{relativePath:E.fsPath,searchPath:void 0})}),this.r=m.StopWatch.create(!1),this.w(o,(E,s)=>{this.x(this.y,this,E,v,l,i=>{if(i){const k=(0,A.toErrorMessage)(i);console.error(k),this.q.push(k),s(i,void 0)}else s(null,void 0)})},(E,s)=>{this.m.stop();const i=E?L.coalesce(E)[0]:null;I(i,this.j)})}w(o,f,v){const l=new Array(o.length),I=new Array(o.length);let E=!1,s=0;if(o.length===0)return v(null,[]);o.forEach((i,k)=>{f(i,(F,$)=>{if(F?(E=!0,l[k]=null,I[k]=F):(l[k]=$,I[k]=null),++s===o.length)return v(E?I:null,l)})})}x(o,f,...v){try{o.apply(f,v)}catch(l){v[v.length-1](l)}}y(o,f,v,l){const I=o.folder.fsPath,E=P.isMacintosh,s=()=>j&&j.kill();S.add(s);let i=B=>{S.delete(s),i=()=>{},l(B)},k="";const F=this.D(),$=(0,h.spawnRipgrepCmd)(this.a,o,this.a.includePattern,this.t.get(o.folder.fsPath).expression),j=$.cmd,W=!Object.keys($.siblingClauses).length,U=$.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let x=`${$.rgDiskPath} ${U}
 - cwd: ${$.cwd}`;$.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify($.rgArgs.siblingClauses)}`),v({message:x}),this.s=0,this.z(j,"utf8",v,(B,z,ee)=>{if(B){i(B);return}if(this.j){i();return}const V=(k+(E?g.normalizeNFC(z||""):z)).split(`
`);if(ee){const Z=V.length;V[Z-1]=V[Z-1].trim(),V[Z-1]||V.pop()}else k=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){i(new Error("Splitting up files failed"));return}if(this.s+=V.length,W){for(const Z of V)if(this.J(f,{base:I,relativePath:Z,searchPath:this.N(o,Z)}),this.j){s();break}(ee||this.j)&&i();return}this.G(o,F,I,V,f),ee&&(this.H(F,I,f),i())})}spawnFindCmd(o){const f=this.t.get(o.folder.fsPath),v=f.getBasenameTerms(),l=f.getPathTerms(),I=["-L","."];if(v.length||l.length){I.push("-not","(","(");for(const E of v)I.push("-name",E),I.push("-o");for(const E of l)I.push("-path",E),I.push("-o");I.pop(),I.push(")","-prune",")")}return I.push("-type","f"),c.spawn("find",I,{cwd:o.folder.fsPath})}readStdout(o,f,v){let l="";this.z(o,f,()=>{},(I,E,s)=>{if(I){v(I);return}l+=E,s&&v(null,l)})}z(o,f,v,l){let I=(i,k,F)=>{(i||F)&&(I=()=>{},this.r?.stop()),l(i,k,F)},E=!1;o.stdout?(this.A(o.stdout,f,I),o.stdout.once("data",()=>E=!0)):v({message:"stdout is null"});let s;o.stderr?s=this.B(o.stderr):v({message:"stderr is null"}),o.on("error",i=>{I(i)}),o.on("close",i=>{let k;!E&&(k=this.C(s,f))&&a(k)?I(new Error(`command failed with error code ${i}: ${this.C(s,f)}`)):(this.g&&i===0&&(this.j=!0),I(null,"",!0))})}A(o,f,v){const l=new O.StringDecoder(f);return o.on("data",I=>{v(null,l.write(I))}),l}B(o){const f=[];return o.on("data",v=>{f.push(v)}),f}C(o,f){const v=new O.StringDecoder(f);return o.map(l=>v.write(l)).join("")}D(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}G(o,{pathToEntries:f},v,l,I){l.indexOf(this.b)!==-1&&this.J(I,{base:v,relativePath:this.b,searchPath:this.N(o,this.b)});const E=s=>{const i=u.basename(s),k=u.dirname(s);let F=f[k];F||(F=f[k]=[],E(k)),F.push({base:v,relativePath:s,basename:i,searchPath:this.N(o,s)})};l.forEach(E)}H({rootEntries:o,pathToEntries:f},v,l){const I=this,E=this.t.get(v),s=this.b;function i(k){I.o++;const F=(0,n.hasSiblingFn)(()=>k.map($=>$.basename));for(let $=0,j=k.length;$<j;$++){const W=k[$],{relativePath:U,basename:x}=W;if(E.test(U,x,s!==x?F:void 0))continue;const B=f[U];if(B)i(B);else{if(I.p++,U===s)continue;I.J(l,W)}if(I.j)break}}i(o)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(o,f,v,l,I){const E=o.folder,s=(0,n.hasSiblingFn)(()=>v);this.w(v,(i,k)=>{if(this.l||this.j)return k(null);const F=f?[f,i].join(u.sep):i;if(this.t.get(o.folder.fsPath).test(F,i,this.a.filePattern!==i?s:void 0))return k(null);const $=[E.fsPath,F].join(u.sep);R.lstat($,(j,W)=>{if(j||this.l||this.j)return k(null);this.L($,W,(U,x)=>U||this.l||this.j?k(null):x.isDirectory()?(this.o++,this.M($,W,(B,z)=>B||this.l||this.j||(z=z||"",this.v[z])?k(null):(this.v[z]=!0,b.Promises.readdir($).then(ee=>{if(this.l||this.j)return k(null);this.I(o,F,ee,l,se=>k(se||null))},ee=>{k(null)})))):(this.p++,F===this.b||this.h&&C.isNumber(x.size)&&x.size>this.h||this.J(l,{base:E.fsPath,relativePath:F,searchPath:this.N(o,F)}),k(null,void 0)))})},i=>{const k=i&&L.coalesce(i);return I(k&&k.length>0?k[0]:void 0)})}J(o,f){this.K(f)&&(!this.d||this.d(f.relativePath,u.basename(f.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||o(f))}K(o){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,n.isFilePatternMatch)(o,this.c)}return!0}L(o,f,v){return f.isSymbolicLink()?R.stat(o,v):v(null,f)}M(o,f,v){return f.isSymbolicLink()?R.realpath(o,(l,I)=>l?v(l):v(null,I)):v(null,o)}N(o,f){return o.folderName?u.join(o.folderName,f):f}}e.FileWalker=w;class p{constructor(o){this.a=o.folderQueries,this.b=o.extraFileResources||[],this.c=new w(o)}search(o,f,v){this.c.walk(this.a,this.b,o,f,(l,I)=>{v(l,{limitHit:I,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=p;class t{constructor(o,f){this.expression=o,this.c=f,this.d(o)}d(o){let f,v;Object.keys(o).filter(l=>o[l]).forEach(l=>{u.isAbsolute(l)?(f=f||y.getEmptyExpression(),f[l]=o[l]):(v=v||y.getEmptyExpression(),v[l]=o[l])}),this.a=f&&y.parse(f,{trimForExclusions:!0}),this.b=v&&y.parse(v,{trimForExclusions:!0})}test(o,f,v){return this.b&&this.b(o,f,v)||this.a&&this.a(u.join(this.c,o),f,v)}getBasenameTerms(){const o=[];return this.a&&o.push(...y.getBasenameTerms(this.a)),this.b&&o.push(...y.getBasenameTerms(this.b)),o}getPathTerms(){const o=[];return this.a&&o.push(...y.getPathTerms(this.a)),this.b&&o.push(...y.getPathTerms(this.b)),o}}function a(r){const o=r.trim().split(`
`),f=o[0].trim();if(f.startsWith("Error parsing regex"))return f;if(f.startsWith("regex parse error"))return D.uppercaseFirstLetter(o[o.length-1].trim());if(f.startsWith("error parsing glob")||f.startsWith("unsupported encoding"))return f.charAt(0).toUpperCase()+f.substr(1);if(f==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(f.startsWith("Literal "))return f}}),define(Ce[336],De([1,0,93,22]),function(re,e,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function u(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(o=>o===r)}e.isUTFEncoding=u,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const O=512,L=512,A=512*8,y=512*128;var g;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(g||(e.DecodeStreamErrorKind=g={}));class T extends Error{constructor(o,f){super(o),this.decodeStreamErrorKind=f}}e.DecodeStreamError=T;class P{static async create(o){let f;if(o!==e.UTF8)f=(await new Promise((l,I)=>{re(["@vscode/iconv-lite-umd"],l,I)})).getDecoder(b(o));else{const v=new TextDecoder;f={write(l){return v.decode(l,{stream:!0})},end(){return v.decode()}}}return new P(f)}constructor(o){this.a=o}write(o){return this.a.write(o)}end(){return this.a.end()}}function m(r,o){const f=o.minBytesRequiredForDetection??o.guessEncoding?A:L;return new Promise((v,l)=>{const I=(0,c.newWriteableStream)($=>$.join("")),E=[];let s=0,i;const k=async()=>{try{const $=await a({buffer:R.VSBuffer.concat(E),bytesRead:s},o.guessEncoding);if($.seemsBinary&&o.acceptTextOnly)throw new T("Stream is binary but only text is accepted for decoding",1);$.encoding=await o.overwriteEncoding($.encoding),i=await P.create($.encoding);const j=i.write(R.VSBuffer.concat(E).buffer);I.write(j),E.length=0,s=0,v({stream:I,detected:$})}catch($){F?.dispose(),I.destroy(),l($)}},F=(0,c.listenStream)(r,{onData:async $=>{i?I.write(i.write($.buffer)):(E.push($),s+=$.byteLength,s>=f&&(r.pause(),await k(),setTimeout(()=>r.resume())))},onError:$=>I.error($),onEnd:async()=>{i||await k(),I.end(i?.end())}})})}e.toDecodeStream=m;async function D(r,o,f){const l=(await new Promise((s,i)=>{re(["@vscode/iconv-lite-umd"],s,i)})).getEncoder(b(o),f);let I=!1,E=!1;return{read(){if(E)return null;const s=r.read();if(typeof s!="string"){if(E=!0,!I&&f?.addBOM)switch(o){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const i=l.end();return i&&i.length>0?(I=!0,R.VSBuffer.wrap(i)):null}return I=!0,R.VSBuffer.wrap(l.write(s))}}}e.toEncodeReadable=D;async function C(r){return(await new Promise((f,v)=>{re(["@vscode/iconv-lite-umd"],f,v)})).encodingExists(b(r))}e.encodingExists=C;function b(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=b;function n(r,o){if(!r||o<e.UTF16be_BOM.length)return null;const f=r.readUInt8(0),v=r.readUInt8(1);if(f===e.UTF16be_BOM[0]&&v===e.UTF16be_BOM[1])return e.UTF16be;if(f===e.UTF16le_BOM[0]&&v===e.UTF16le_BOM[1])return e.UTF16le;if(o<e.UTF8_BOM.length)return null;const l=r.readUInt8(2);return f===e.UTF8_BOM[0]&&v===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=n;const h=["ascii","utf-16","utf-32"];async function d(r){const o=await new Promise((E,s)=>{re(["jschardet"],E,s)}),f=r.slice(0,y),v=p(f.buffer),l=o.detect(v);if(!l||!l.encoding)return null;const I=l.encoding.toLowerCase();return 0<=h.indexOf(I)?null:w(l.encoding)}const S={ibm866:"cp866",big5:"cp950"};function w(r){const o=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return S[o]||o}function p(r){let o="";for(let f=0;f<r.length;f++)o+=String.fromCharCode(r[f]);return o}function t(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const o=r.match(/windows(\d+)/);return o?"windows-"+o[1]:r}}}e.toCanonicalName=t;function a({buffer:r,bytesRead:o},f){let v=n(r,o),l=!1;if(v!==e.UTF16be&&v!==e.UTF16le&&r){let I=!0,E=!0,s=!1;for(let i=0;i<o&&i<O;i++){const k=i%2===1,F=r.readUInt8(i)===0;if(F&&(s=!0),I&&(k&&!F||!k&&F)&&(I=!1),E&&(k&&F||!k&&!F)&&(E=!1),F&&!I&&!E)break}s&&(I?v=e.UTF16le:E?v=e.UTF16be:l=!0)}return f&&!l&&!v&&r?d(r.slice(0,o)).then(I=>({seemsBinary:!1,encoding:I})):{seemsBinary:l,encoding:v}}e.detectEncodingFromBuffer=a,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ce[148],De([1,0,336,29,147]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class O extends u.TextSearchManager{constructor(A,y,g=R,T="searchProcess"){super(A,y,{readdir:P=>g.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,c.toCanonicalName)(P)},T)}}e.NativeTextSearchManager=O}),define(Ce[149],De([1,0,45,350,335,19,65,32,10,11,2,34,86,351,333,109]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const n=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class h{constructor(i){this.a=i}provideTextSearchResults(i,k,F,$){return this.a.appendLine(`provideTextSearchResults ${i.pattern}, ${JSON.stringify({...k,folder:k.folder.toString()})}`),new Promise((j,W)=>{$.onCancellationRequested(()=>Z());const U=a(i,k),x=k.folder.fsPath,B=U.map(be=>be.match(/^-/)?be:`'${be}'`).join(" ");this.a.appendLine(`${n} ${B}
 - cwd: ${x}`);let z=c.spawn(n,U,{cwd:x});z.on("error",be=>{console.error(be),this.a.appendLine("Error: "+(be&&be.message)),W((0,P.serializeSearchError)(new P.SearchError(be&&be.message,P.SearchErrorCode.rgProcessError)))});let ee=!1;const se=new w(k.maxResults,x,k.previewOptions);se.on("result",be=>{ee=!0,ae="",F.report(be)});let V=!1;const Z=()=>{V=!0,z?.kill(),se?.cancel()};let q=!1;se.on("hitLimit",()=>{q=!0,Z()});let ae="";z.stdout.on("data",be=>{se.handleData(be),ee||(ae+=be)});let Ee=!1;z.stdout.once("data",()=>Ee=!0);let ye="";z.stderr.on("data",be=>{const M=be.toString();this.a.appendLine(M),ye.length+M.length<1e6&&(ye+=M)}),z.on("close",()=>{if(this.a.appendLine(Ee?"Got data from stdout":"No data from stdout"),this.a.appendLine(ee?"Got result from parser":"No result from parser"),ae&&this.a.appendLine(`Got data without result: ${ae}`),this.a.appendLine(""),V)j({limitHit:q});else{se.flush(),z=null;let be;ye&&!Ee&&(be=d(ye))?W((0,P.serializeSearchError)(new P.SearchError(be.message,be.code))):j({limitHit:q})}})})}}e.RipgrepTextSearchEngine=h;function d(s){const i=s.split(`
`),k=i[0].trim();if(i.some($=>$.startsWith("regex parse error")))return new P.SearchError(S(i),P.SearchErrorCode.regexParseError);const F=k.match(/grep config error: unknown encoding: (.*)/);if(F)return new P.SearchError(`Unknown encoding: ${F[1]}`,P.SearchErrorCode.unknownEncoding);if(k.startsWith("error parsing glob"))return new P.SearchError(k.charAt(0).toUpperCase()+k.substr(1),P.SearchErrorCode.globParseError);if(k.startsWith("the literal"))return new P.SearchError(k.charAt(0).toUpperCase()+k.substr(1),P.SearchErrorCode.invalidLiteral);if(k.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(k,P.SearchErrorCode.regexParseError)}function S(s){const i=["Regex parse error"],k=s.filter(F=>F.startsWith("PCRE2:"));if(k.length>=1){const F=k[0].replace("PCRE2:","");if(F.indexOf(":")!==-1&&F.split(":").length>=2){const $=F.split(":")[1];i.push(":"+$)}}return i.join("")}class w extends R.EventEmitter{constructor(i,k,F){super(),this.g=i,this.h=k,this.j=F,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new u.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(i,k){return super.on(i,k),this}handleData(i){if(this.b)return;const k=typeof i=="string"?i:this.d.write(i);this.k(k)}k(i){let k=i.indexOf(`
`);const F=this.a+i;if(k>=0)k+=this.a.length;else{this.a=F;return}let $=0;for(;k>=0;)this.m(F.substring($,k).trim()),$=k+1,k=F.indexOf(`
`,$);this.a=F.substring($)}m(i){if(this.b||!i)return;let k;try{k=JSON.parse(i)}catch{throw new Error(`malformed line from rg: ${i}`)}if(k.type==="match"){const F=p(k.data.path),$=T.URI.file(y.join(this.h,F)),j=this.n(k.data,$);this.p(j),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(k.type==="context"){const F=p(k.data.path),$=T.URI.file(y.join(this.h,F));this.o(k.data,$).forEach(W=>this.p(W))}}n(i,k){const F=i.line_number-1,$=p(i.lines),j=Buffer.from($);let W=0,U=0,x=F;i.submatches.length===0&&i.submatches.push($.length?{start:0,end:1,match:{text:$[0]}}:{start:0,end:0,match:{text:""}});const B=(0,O.coalesce)(i.submatches.map((z,ee)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const se=p(z.match),V=j.slice(W,z.start).toString(),Z=t(V),q=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+U,ae=t(se),Ee=Z.numLines+x,ye=ae.numLines+Ee,be=ae.numLines>0?ae.lastLineLength:ae.lastLineLength+q;return W=z.end,U=be,x=ye,new m.Range(Ee,q,ye,be)}));return(0,b.createTextSearchResult)(k,$,B,this.j)}o(i,k){const F=p(i.lines),$=i.line_number;return F.replace(/\r?\n$/,"").split(`
`).map((j,W)=>({text:j,uri:k,lineNumber:$+W}))}p(i){this.emit("result",i)}}e.RipgrepParser=w;function p(s){return s.bytes?Buffer.from(s.bytes,"base64").toString():s.text}function t(s){const i=/\n/g;let k=0,F=-1,$;for(;$=i.exec(s);)k++,F=$.index;const j=F>=0?s.length-F-1:s.length;return{numLines:k,lastLineLength:j}}function a(s,i){const k=["--hidden"];k.push(s.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:F,otherIncludes:$}=(0,L.groupBy)(i.includes,W=>W.startsWith("**")?"doubleStarIncludes":"otherIncludes");if($&&$.length){const W=new Set;$.forEach(U=>{W.add(U)}),k.push("-g","!*"),W.forEach(U=>{r(U).map(b.anchorGlob).forEach(x=>{k.push("-g",x)})})}F&&F.length&&F.forEach(W=>{k.push("-g",W)}),i.excludes.map(b.anchorGlob).forEach(W=>k.push("-g",`!${W}`)),i.maxFileSize&&k.push("--max-filesize",i.maxFileSize+""),i.useIgnoreFiles?i.useParentIgnoreFiles||k.push("--no-ignore-parent"):k.push("--no-ignore"),i.followSymlinks&&k.push("--follow"),i.encoding&&i.encoding!=="utf8"&&k.push("--encoding",i.encoding),s.pattern==="--"&&(s.isRegExp=!0,s.pattern="\\-\\-"),s.isMultiline&&!s.isRegExp&&(s.pattern=(0,g.escapeRegExpCharacters)(s.pattern),s.isRegExp=!0),i.usePCRE2&&k.push("--pcre2"),k.push("--crlf"),s.isRegExp&&(s.pattern=o(s.pattern),k.push("--engine","auto"));let j;if(s.isWordMatch){const U=(0,g.createRegExp)(s.pattern,!!s.isRegExp,{wholeWord:s.isWordMatch}).source.replace(/\\\//g,"/");k.push("--regexp",U)}else if(s.isRegExp){let W=v(s.pattern);W=l(W),k.push("--regexp",W)}else j=s.pattern,k.push("--fixed-strings");return k.push("--no-config"),i.useGlobalIgnoreFiles||k.push("--no-ignore-global"),k.push("--json"),s.isMultiline&&k.push("--multiline"),i.beforeContext&&k.push("--before-context",i.beforeContext+""),i.afterContext&&k.push("--after-context",i.afterContext+""),k.push("--"),j&&k.push(j),k.push("."),k}e.getRgArgs=a;function r(s){return E(s).flatMap(k=>{const F=(0,A.splitGlobAware)(k,"/");return F.map(($,j)=>F.slice(0,j+1).join("/"))})}function o(s){const i=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;s.match(i);)s=s.replace(i,"$1\\x{$2}");const k=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;s.match(k);)s=s.replace(k,"$1\\x{$2}");return s}e.unicodeEscapesToPCRE2=o;const f=s=>s.type==="Assertion"&&s.kind==="lookbehind";function v(s){let i;try{i=new D.RegExpParser().parsePattern(s)}catch{return s}let k="",F=0;const $=(U,x,B)=>{k+=s.slice(F,U)+B,F=x},j=[];return new D.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const x=j[0];if(!x)$(U.start,U.end,"\\r?\\n");else if(!j.some(f))if(x.type==="CharacterClass")if(x.negate){const B=s.slice(x.start+2,U.start)+s.slice(U.end,x.end-1);x.parent?.type==="Quantifier"?$(x.start,x.end,B?`[^${B}]`:"."):$(x.start,x.end,"(?!\\r?\\n"+(B?`|[${B}]`:"")+")")}else{const B=s.slice(x.start+1,U.start)+s.slice(U.end,x.end-1);$(x.start,x.end,B===""?"\\r?\\n":`(?:[${B}]|\\r?\\n)`)}else x.type==="Quantifier"&&$(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){j.unshift(U)},onQuantifierLeave(){j.shift()},onCharacterClassRangeEnter(U){j.unshift(U)},onCharacterClassRangeLeave(){j.shift()},onCharacterClassEnter(U){j.unshift(U)},onCharacterClassLeave(){j.shift()},onAssertionEnter(U){f(U)&&j.push(U)},onAssertionLeave(U){j[0]===U&&j.shift()}}).visit(i),k+=s.slice(F),k}e.fixRegexNewline=v;function l(s){return s.replace(/\n/g,"\\r?\\n")}e.fixNewline=l;function I(s){let i=!1,k=!1,F="",$="";for(let j=0;j<s.length;j++){const W=s[j];switch(W){case"\\":k?(i?$+="\\"+W:F+="\\"+W,k=!1):k=!0;break;case"{":if(k)i?$+=W:F+=W,k=!1;else{if(i)return{strInBraces:F+"{"+$+"{"+s.substring(j+1)};i=!0}break;case"}":if(k)i?$+=W:F+=W,k=!1;else{if(i)return{fixedStart:F,strInBraces:$,fixedEnd:s.substring(j+1)};F+=W}break;default:i?$+=(k?"\\":"")+W:F+=(k?"\\":"")+W,k=!1;break}}return{strInBraces:F+(i?"{"+$:"")}}function E(s){const{fixedStart:i,strInBraces:k,fixedEnd:F}=I(s);if(i===void 0||F===void 0)return[k];let $=(0,A.splitGlobAware)(k,",");$.length||($=[""]);const j=E(F);return $.flatMap(W=>{const U=i+W;return j.map(x=>U+x)})}e.performBraceExpansionForRipgrep=E}),define(Ce[337],De([1,0,21,149,128,18]),function(re,e,c,R,u,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class L{constructor(g){this.b=g,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(g,T,P,m){const D=new R.RipgrepTextSearchEngine(this.b);if(T.folder.scheme===O.Schemas.vscodeUserData){const C={...T,folder:T.folder.with({scheme:O.Schemas.file})},b=new u.Progress(n=>P.report({...n,uri:n.uri.with({scheme:T.folder.scheme})}));return this.c(m,n=>D.provideTextSearchResults(g,C,b,n))}else return this.c(m,C=>D.provideTextSearchResults(g,T,P,C))}async c(g,T){const P=A(g);this.a.add(P);const m=await T(P.token);return this.a.delete(P),m}d(){this.a.forEach(g=>g.cancel())}}e.RipgrepSearchProvider=L;function A(y){const g=new c.CancellationTokenSource;return y.onCancellationRequested(()=>g.cancel()),g}}),define(Ce[338],De([1,0,29,149,148]),function(re,e,c,R,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class O{constructor(y){this.a=y}search(y,g,T){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(D){T({message:D})}},m=new u.NativeTextSearchManager(this.a,new R.RipgrepTextSearchEngine(P),c);return new Promise((D,C)=>m.search(b=>{g(b.map(L))},y).then(b=>D({limitHit:b.limitHit,type:"success",stats:b.stats}),C))}}e.TextSearchEngineAdapter=O;function L(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((y,g)=>{if(g.ranges){const T=g;return y+(Array.isArray(T.ranges)?T.ranges.length:1)}else return y+1},0)}}}),define(Ce[339],De([1,0,19,16,8,3,114,10,40,2,31,34,334,338]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class C{constructor(w="searchProcess"){this.d=w,this.b=Object.create(null)}fileSearch(w){let p;const t=h(w),a=new O.Emitter({onDidAddFirstListener:()=>{p=(0,R.createCancelablePromise)(r=>this.doFileSearchWithEngine(m.Engine,t,o=>a.fire(o),r)),p.then(r=>a.fire(r),r=>a.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return a.event}textSearch(w){let p;const t=h(w),a=new O.Emitter({onDidAddFirstListener:()=>{p=(0,R.createCancelablePromise)(r=>this.f(t,o=>a.fire(o),r)),p.then(r=>a.fire(r),r=>a.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return a.event}f(w,p,t){return w.maxFileSize=this.g().maxFileSize,new D.TextSearchEngineAdapter(w).search(t,p,p)}g(){return{maxFileSize:process.arch==="ia32"?300*T.ByteSize.MB:16*T.ByteSize.GB}}doFileSearch(w,p,t){return this.doFileSearchWithEngine(m.Engine,w,p,t)}doFileSearchWithEngine(w,p,t,a,r=C.a){let o=0;const f=l=>{Array.isArray(l)?(o+=l.length,t(l.map(I=>this.h(I)))):l.relativePath?(o++,t(this.h(l))):t(l)};if(p.sortByScore){let l=this.l(p,f,a);if(!l){const I=p.maxResults?Object.assign({},p,{maxResults:null}):p,E=new w(I);l=this.j(E,p,t,f,a)}return new Promise((I,E)=>{l.then(([s,i])=>{const k=i.map(F=>this.h(F));this.o(k,t,r),I(s)},E)})}const v=new w(p);return this.r(v,f,r,a).then(l=>({limitHit:l.limitHit,type:"success",stats:{detailStats:l.stats,type:this.d,fromCache:!1,resultCount:o,sortingTime:void 0}}))}h(w){return{path:w.base?(0,A.join)(w.base,w.relativePath):w.relativePath}}j(w,p,t,a,r){const o=new O.Emitter;let f=(0,R.createCancelablePromise)(l=>{let I=[];const E=s=>{Array.isArray(s)?I=s:(a(s),o.fire(s))};return this.r(w,E,-1,l).then(s=>[s,I])}),v;if(p.cacheKey){v=this.k(p.cacheKey);const l={promise:f,event:o.event,resolved:!1};v.resultsToSearchCache[p.filePattern||""]=l,f.then(()=>{l.resolved=!0},I=>{delete v.resultsToSearchCache[p.filePattern||""]}),f=this.s(f)}return f.then(([l,I])=>{const E=v?v.scorerCache:Object.create(null),s=(typeof p.maxResults!="number"||p.maxResults>0)&&y.StopWatch.create(!1);return this.n(p,I,E,r).then(i=>{const k=s?s.elapsed():-1;return[{type:"success",stats:{detailStats:l.stats,sortingTime:k,fromCache:!1,type:this.d,workspaceFolderCount:p.folderQueries.length,resultCount:i.length},messages:l.messages,limitHit:l.limitHit||typeof p.maxResults=="number"&&I.length>p.maxResults},i]})})}k(w){const p=this.b[w];return p||(this.b[w]=new b)}l(w,p,t){const a=w.cacheKey&&this.b[w.cacheKey];if(!a)return;const r=this.q(a,w.filePattern||"",p,t);if(r)return r.then(([o,f,v])=>{const l=y.StopWatch.create(!1);return this.n(w,f,a.scorerCache,t).then(I=>{const E=l.elapsed(),s={fromCache:!0,detailStats:v,type:this.d,resultCount:f.length,sortingTime:E};return[{type:"success",limitHit:o.limitHit||typeof w.maxResults=="number"&&f.length>w.maxResults,stats:s},I]})})}n(w,p,t,a){const r=(0,L.prepareQuery)(w.filePattern||""),o=(v,l)=>(0,L.compareItemsByFuzzyScore)(v,l,r,!0,n,t),f=typeof w.maxResults=="number"?w.maxResults:Number.MAX_VALUE;return c.topAsync(p,o,f,1e4,a)}o(w,p,t){if(t&&t>0)for(let a=0;a<w.length;a+=t)p(w.slice(a,a+t));else p(w)}q(w,p,t,a){const r=y.StopWatch.create(!1),o=p.indexOf(A.sep)>=0;let f;for(const E in w.resultsToSearchCache)if(p.startsWith(E)){if(o&&E.indexOf(A.sep)<0&&E!=="")continue;const s=w.resultsToSearchCache[E];f={promise:this.s(s.promise),event:s.event,resolved:s.resolved};break}if(!f)return null;const v=r.elapsed(),l=y.StopWatch.create(!1),I=f.event(t);return a&&a.onCancellationRequested(()=>{I.dispose()}),f.promise.then(([E,s])=>{if(a&&a.isCancellationRequested)throw(0,u.canceled)();const i=[],k=(0,L.prepareQuery)(p).normalizedLowercase;for(const F of s)(0,P.isFilePatternMatch)(F,k)&&i.push(F);return[E,i,{cacheWasResolved:f.resolved,cacheLookupTime:v,cacheFilterTime:l.elapsed(),cacheEntryCount:s.length}]})}r(w,p,t,a){return new Promise((r,o)=>{let f=[];a?.onCancellationRequested(()=>w.cancel()),w.search(v=>{v&&(t?(f.push(v),t>0&&f.length>=t&&(p(f),f=[])):p(v))},v=>{p(v)},(v,l)=>{f.length&&p(f),v?o(v):r(l)})})}clearCache(w){return delete this.b[w],Promise.resolve(void 0)}s(w){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,t){return w.then(p,t)}catch(p){return this.then(void 0,p)}finally(p){return w.finally(p)}}}}e.SearchService=C,C.a=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const n=new class{getItemLabel(S){return(0,A.basename)(S.relativePath)}getItemDescription(S){return(0,A.dirname)(S.relativePath)}getItemPath(S){return S.relativePath}};function h(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(d),extraFileResources:S.extraFileResources&&S.extraFileResources.map(w=>g.URI.revive(w))}}function d(S){return{...S,folder:g.URI.revive(S.folder)}}}),define(Ce[340],De([1,0,4,18,2,29,17,27,20,90,59,34,339,337,109,148]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let n=e.NativeExtHostSearch=class extends g.ExtHostSearch{constructor(d,S,w,p){super(d,w,p),this.s=O,this.t=-1,this.v=null,this.w=!1;const t=new C.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(R.Schemas.vscodeUserData,new D.RipgrepSearchProvider(t)),S.remote.isRemote&&S.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const d=new C.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(R.Schemas.file,new D.RipgrepSearchProvider(d)),this.y(R.Schemas.file,new m.SearchService("fileSearchProvider"))}y(d,S){const w=this.d++;return this.v=S,this.t=w,this.c.$registerFileSearchProvider(w,this.o(d)),(0,c.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(w)})}$provideFileSearchResults(d,S,w,p){const t=(0,g.reviveQuery)(w);return d===this.t?this.z(d,S,t,p):super.$provideFileSearchResults(d,S,w,p)}z(d,S,w,p){const t=a=>{if((0,P.isSerializedFileMatch)(a)&&(a=[a]),Array.isArray(a)){this.c.$handleFileMatch(d,S,a.map(r=>u.URI.file(r.path)));return}a.message&&this.n.debug("ExtHostSearch",a.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(w,t,p)}$clearCache(d){return this.v?.clearCache(d),super.$clearCache(d)}q(d,S){return new b.NativeTextSearchManager(d,S,void 0,"textSearchProvider")}};e.NativeExtHostSearch=n=qe([je(0,y.IExtHostRpcService),je(1,A.IExtHostInitDataService),je(2,T.IURITransformerService),je(3,L.ILogService)],n)}),define(Ce[150],De([1,0,352,135,74,353,22,8,3,4,10,9,33,75,119]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class b{traceSocketEvent(s,i){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,i)}constructor(s,i=""){this.f=!0,this.debugLabel=i,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=k=>{if(this.traceSocketEvent("error",{code:k?.code,message:k?.message}),k){if(k.code==="EPIPE")return;(0,A.onUnexpectedError)(k)}},this.socket.on("error",this.a),this.b=k=>{this.traceSocketEvent("close",{hadError:k}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const i=k=>{this.traceSocketEvent("read",k),s(L.VSBuffer.wrap(k))};return this.socket.on("data",i),{dispose:()=>this.socket.off("data",i)}}onClose(s){const i=k=>{s({type:0,hadError:k,error:void 0})};return this.socket.on("close",i),{dispose:()=>this.socket.off("close",i)}}onEnd(s){const i=()=>{s()};return this.socket.on("end",i),{dispose:()=>this.socket.off("end",i)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,i=>{if(i){if(i.code==="EPIPE")return;(0,A.onUnexpectedError)(i)}})}catch(i){if(i.code==="EPIPE")return;(0,A.onUnexpectedError)(i)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,i)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const k=()=>{this.socket.off("close",k),this.socket.off("end",k),this.socket.off("error",k),this.socket.off("timeout",k),this.socket.off("drain",k),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",k),this.socket.on("end",k),this.socket.on("error",k),this.socket.on("timeout",k),this.socket.on("drain",k)})}}e.NodeSocket=b;var n;(function(E){E[E.MinHeaderByteSize=2]="MinHeaderByteSize",E[E.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(n||(n={}));var h;(function(E){E[E.PeekHeader=1]="PeekHeader",E[E.ReadHeader=2]="ReadHeader",E[E.ReadBody=3]="ReadBody",E[E.Fin=4]="Fin"})(h||(h={}));class d extends g.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,i){this.socket.traceSocketEvent(s,i)}constructor(s,i,k,F){super(),this.f=this.B(new y.Emitter),this.g=this.B(new y.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:i,inflateBytesLength:k?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new S(this,i,k,F,this.f,($,j)=>this.k($,j))),this.B(this.a.onError($=>{console.error($),(0,A.onUnexpectedError)($),this.g.fire({type:0,hadError:!0,error:$})})),this.b=new C.ChunkStream,this.B(this.socket.onData($=>this.l($))),this.B(this.socket.onClose(async $=>{this.a.isProcessingReadQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire($)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){let i=0;for(;i<s.byteLength;)this.a.writeMessage(s.slice(i,Math.min(i+262144,s.byteLength))),i+=262144}k(s,i){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let k=2;s.byteLength<126?k+=0:s.byteLength<2**16?k+=2:k+=8;const F=L.VSBuffer.alloc(k);if(i?F.writeUInt8(194,0):F.writeUInt8(130,0),s.byteLength<126)F.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){F.writeUInt8(126,1);let $=1;F.writeUInt8(s.byteLength>>>8&255,++$),F.writeUInt8(s.byteLength>>>0&255,++$)}else{F.writeUInt8(127,1);let $=1;F.writeUInt8(0,++$),F.writeUInt8(0,++$),F.writeUInt8(0,++$),F.writeUInt8(0,++$),F.writeUInt8(s.byteLength>>>24&255,++$),F.writeUInt8(s.byteLength>>>16&255,++$),F.writeUInt8(s.byteLength>>>8&255,++$),F.writeUInt8(s.byteLength>>>0&255,++$)}this.socket.write(L.VSBuffer.concat([F,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const i=this.b.peek(this.j.readLen),k=i.readUInt8(0),F=(k&128)>>>7,$=(k&64)>>>6,j=i.readUInt8(1),W=(j&128)>>>7,U=j&127;this.j.state=2,this.j.readLen=2+(W?4:0)+(U===126?2:0)+(U===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!$),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const i=this.b.read(this.j.readLen),k=i.readUInt8(1),F=(k&128)>>>7;let $=k&127,j=1;$===126?$=i.readUInt8(++j)*2**8+i.readUInt8(++j):$===127&&($=i.readUInt8(++j)*0+i.readUInt8(++j)*0+i.readUInt8(++j)*0+i.readUInt8(++j)*0+i.readUInt8(++j)*2**24+i.readUInt8(++j)*2**16+i.readUInt8(++j)*2**8+i.readUInt8(++j));let W=0;F&&(W=i.readUInt8(++j)*2**24+i.readUInt8(++j)*2**16+i.readUInt8(++j)*2**8+i.readUInt8(++j)),this.j.state=3,this.j.readLen=$,this.j.mask=W,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const i=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",i),t(i,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",i),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(i,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class S extends g.Disposable{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(s,i,k,F,$,j){super(),this.l=s,this.m=$,this.n=j,this.a=this.B(new y.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new y.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new y.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,i?(this.b=this.B(new w(this.l,F,k,{windowBits:15})),this.f=this.B(new p(this.l,{windowBits:15})),this.B(this.b.onError(W=>this.a.fire(W))),this.B(this.f.onError(W=>this.a.fire(W)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const i=await this.s(this.f,s);this.n(i,!0)}else this.n(s,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(s,i){return new Promise((k,F)=>{s.write(i),s.flush($=>k($))})}acceptFrame(s,i,k){this.h.push({data:s,isCompressed:i,isLastFrameOfMessage:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const i=await this.w(this.b,s.data,s.isLastFrameOfMessage);this.m.fire(i)}else this.m.fire(s.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(s,i,k){return new Promise((F,$)=>{s.write(i),k&&s.write(L.VSBuffer.fromByteArray([0,0,255,255])),s.flush(j=>F(j))})}}class w extends g.Disposable{get recordedInflateBytes(){return this.j?L.VSBuffer.concat(this.f):L.VSBuffer.alloc(0)}constructor(s,i,k,F){super(),this.h=s,this.j=i,this.a=this.B(new y.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(F),this.b.on("error",$=>{this.h.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this.a.fire($)}),this.b.on("data",$=>{this.h.traceSocketEvent("zlibInflateData",$),this.g.push(L.VSBuffer.wrap($))}),k&&(this.h.traceSocketEvent("zlibInflateInitialWrite",k.buffer),this.b.write(k.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const i=L.VSBuffer.concat(this.g);this.g.length=0,s(i)})}}class p extends g.Disposable{constructor(s,i){super(),this.g=s,this.a=this.B(new y.Emitter),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",k=>{this.g.traceSocketEvent("zlibDeflateError",{message:k?.message,code:k?.code}),this.a.fire(k)}),this.b.on("data",k=>{this.g.traceSocketEvent("zlibDeflateData",k),this.f.push(L.VSBuffer.wrap(k))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let i=L.VSBuffer.concat(this.f);this.f.length=0,i=i.slice(0,i.byteLength-4),s(i)})}}function t(E,s){if(s===0)return;const i=E.byteLength>>>2;for(let U=0;U<i;U++){const x=E.readUInt32BE(U*4);E.writeUInt32BE(x^s,U*4)}const k=i*4,F=E.byteLength-k,$=s>>>24&255,j=s>>>16&255,W=s>>>8&255;F>=1&&E.writeUInt8(E.readUInt8(k)^$,k),F>=2&&E.writeUInt8(E.readUInt8(k+1)^j,k+1),F>=3&&E.writeUInt8(E.readUInt8(k+2)^W,k+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function r(){const E=(0,m.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${E}-sock`;const s=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,u.tmpdir)(),i=(0,T.join)(s,`vscode-ipc-${E}.sock`);return f(i),i}e.createRandomIPCHandle=r;function o(E,s,i){const k=(0,c.createHash)("md5").update(E).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${k}-${i}-${s}-sock`;const F=i.substr(0,4),$=s.substr(0,6),j=k.substr(0,8);let W;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?W=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${j}-${F}-${$}.sock`):W=(0,T.join)(E,`${F}-${$}.sock`),f(W),W}e.createStaticIPCHandle=o;function f(E){const s=a[P.platform];typeof s=="number"&&E.length>=s&&console.warn(`WARNING: IPC handle "${E}" is longer than ${s} chars, try a shorter --user-data-dir`)}class v extends D.IPCServer{static b(s){const i=y.Event.fromNodeEventEmitter(s,"connection");return y.Event.map(i,k=>({protocol:new C.Protocol(new b(k,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(k,"close"))}))}constructor(s){super(v.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=v;function l(E){return new Promise((s,i)=>{const k=(0,R.createServer)();k.on("error",i),k.listen(E,()=>{k.removeListener("error",i),s(new v(k))})})}e.serve=l;function I(E,s){return new Promise((i,k)=>{const F=(0,R.createConnection)(E,()=>{F.removeListener("error",k),i(C.Client.fromSocket(new b(F,`ipc-client${s}`),s))});F.once("error",k)})}e.connect=I}),define(Ce[341],De([1,0,150,100,48,37,2,17,49]),function(re,e,c,R,u,O,L,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class g{constructor(m,D,C){this.b=m,this.c=D,this.f=C,this.a=R.createServer((b,n)=>this.h(b,n)),this.g().catch(b=>(D.error(b),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,D){const C=(n,h)=>{D.writeHead(n,{"content-type":"application/json"}),D.end(JSON.stringify(h||null),d=>d&&this.c.error(d))},b=[];m.setEncoding("utf8"),m.on("data",n=>b.push(n)),m.on("end",async()=>{try{const n=JSON.parse(b.join(""));let h;switch(n.type){case"open":h=await this.i(n);break;case"openExternal":h=await this.j(n);break;case"status":h=await this.l(n);break;case"extensionManagement":h=await this.k(n);break;default:C(404,`Unknown message type: ${n.type}`);break}C(200,h)}catch(n){const h=n instanceof Error?n.message:JSON.stringify(n);C(500,h),this.c.error("Error while processing pipe request",n)}})}async i(m){const{fileURIs:D,folderURIs:C,forceNewWindow:b,diffMode:n,mergeMode:h,addMode:d,forceReuseWindow:S,gotoLineMode:w,waitMarkerFilePath:p,remoteAuthority:t}=m,a=[];if(Array.isArray(C))for(const v of C)try{a.push({folderUri:L.URI.parse(v)})}catch{}if(Array.isArray(D))for(const v of D)try{(0,y.hasWorkspaceFileExtension)(v)?a.push({workspaceUri:L.URI.parse(v)}):a.push({fileUri:L.URI.parse(v)})}catch{}const r=p?L.URI.file(p):void 0,f={forceNewWindow:b,diffMode:n,mergeMode:h,addMode:d,gotoLineMode:w,forceReuseWindow:S,preferNewWindow:!S&&!r&&!d,waitMarkerFileURI:r,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",a,f),""}async j(m){for(const D of m.uris){const C=L.URI.parse(D),b=C.scheme==="file"?C:D;await this.b.executeCommand("_remoteCLI.openExternal",b)}}async k(m){const D=b=>b?.map(n=>/\.vsix$/i.test(n)?L.URI.parse(n):n),C={list:m.list,install:D(m.install),uninstall:D(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",C)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&u.existsSync(this.f)&&u.unlinkSync(this.f)}}e.CLIServerBase=g;let T=e.CLIServer=class extends g{constructor(m,D){super(m,D,(0,c.createRandomIPCHandle)())}};e.CLIServer=T=qe([je(0,O.IExtHostCommands),je(1,A.ILogService)],T)}),define(Ce[342],De([1,0,100,88,330,325,246,44,313,2,18,7,341,94,311,35,312]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends O.RequireInterceptor{k(){const w=this,p=globalThis._VSCODE_NODE_MODULES.module,t=p._load;p._load=function(f,v,l){return f=r(f),w.a.has(f)?w.a.get(f).load(f,g.URI.file((0,D.realpathSync)(v.filename)),I=>t.apply(this,[I,v,l])):t.apply(this,arguments)};const a=p._resolveLookupPaths;p._resolveLookupPaths=(o,f)=>a.call(this,r(o),f);const r=o=>{for(const f of w.b){const v=f(o);if(v){o=v;break}}return o}}}class d extends A.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Node}async qb(){this.h.createInstance(C.ExtHostConsoleForwarder);const w=this.h.invokeFunction(u.createApiFactoryAndRegisterActors);if(this.h.createInstance(y.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(m.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(n.ExtHostDiskFileSystemProvider),await this.h.createInstance(h,w,{mine:this.F,all:this.G}).install(),R.mark("code/extHost/didInitAPI"),(async()=>{const a=process.env.VSCODE_IPC_HOOK_CLI,r=process.env.CODE_SERVER_SESSION_SOCKET;if(!a||!r)return;const f={workspace:this.h.invokeFunction(l=>l.get(b.IExtHostWorkspace).workspace),socketPath:a},v=JSON.stringify({entry:f});await new Promise((l,I)=>{const E={path:"/add-session",socketPath:r,method:"POST",headers:{"content-type":"application/json"}},s=c.request(E,i=>{i.on("error",I),i.on("end",()=>{try{i.statusCode===200?l():I(new Error("Unexpected status code: "+i.statusCode))}catch(k){I(k)}})});s.on("error",I),s.write(v),s.end()})})().catch(a=>{this.l.error(a)});const t=await this.k.getConfigProvider();await(0,L.connectProxyResolver)(this.j,t,this,this.l,this.u,this.f),R.mark("code/extHost/didInitProxyResolver")}rb(w){return w.main}async sb(w,p,t){if(p.scheme!==T.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let a=null;t.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this.l.flush();const r=w?.identifier.value;w&&await this.s.initializeLocalizedMessages(w);try{r&&R.mark(`code/extHost/willLoadExtensionCode/${r}`),a=re.__$__nodeRequire(p.fsPath)}finally{r&&R.mark(`code/extHost/didLoadExtensionCode/${r}`),t.codeLoadingStop()}return a}async $setRemoteEnvironment(w){if(this.f.remote.isRemote)for(const p in w){const t=w[p];t===null?delete process.env[p]:process.env[p]=t}}}e.ExtHostExtensionService=d}),define(Ce[343],De([1,0,97,316,328,327,340,342,317,89,44,90,87,43,58,84,315,314,17,329,51,241,96]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d,S,w,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(T.IExtHostExtensionService,A.ExtHostExtensionService,0),(0,c.registerSingleton)(d.ILoggerService,h.ExtHostLoggerService,1),(0,c.registerSingleton)(d.ILogService,new t.SyncDescriptor(p.ExtHostLogService,[!1],!0)),(0,c.registerSingleton)(b.IExtensionStoragePaths,n.ExtensionStoragePaths,0),(0,c.registerSingleton)(g.IExtHostDebugService,O.ExtHostDebugService,0),(0,c.registerSingleton)(P.IExtHostSearch,L.NativeExtHostSearch,0),(0,c.registerSingleton)(m.IExtHostTask,u.ExtHostTask,0),(0,c.registerSingleton)(D.IExtHostTerminalService,R.ExtHostTerminalService,0),(0,c.registerSingleton)(C.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,c.registerSingleton)(w.IExtHostVariableResolverProvider,S.NodeExtHostVariableResolverProviderService,0)}),define(Ce[354],De([1,0,100,135,355,88,8,119,150,228,104,326,22,29,94,16,124,247,259,331,343]),function(re,e,c,R,u,O,L,A,y,g,T,P,m,D,C,b,n,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const S=u(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const v=globalThis._VSCODE_NODE_MODULES.module,l=v._load;v._load=function(I){if(I==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const w=process.exit.bind(process);function p(v){process.exit=function(l){if(v)w(l);else{const I=new Error("An extension called process.exit() and this was prevented.");console.warn(I.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let t=function(v){w()};function a(){const v=(0,d.readExtHostConnection)(process.env);if(v.type===3)return new Promise((l,I)=>{const E=s=>{const i=s[0],k=new A.BufferedEmitter;i.on("message",F=>k.fire(m.VSBuffer.wrap(F.data))),i.on("close",()=>{t("renderer closed the MessagePort")}),i.start(),l({onMessage:k.event,send:F=>i.postMessage(F.buffer)})};process.parentPort.on("message",s=>E(s.ports))});if(v.type===2)return new Promise((l,I)=>{let E=null;const s=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),i=108e5,k=3e5,F=new b.ProcessTimeRunOnceScheduler(()=>t("renderer disconnected for too long (1)"),i),$=new b.ProcessTimeRunOnceScheduler(()=>t("renderer disconnected for too long (2)"),k);process.on("message",(W,U)=>{if(W&&W.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const x=m.VSBuffer.wrap(Buffer.from(W.initialDataChunk,"base64"));let B;if(W.skipWebSocketFrames)B=new y.NodeSocket(U,"extHost-socket");else{const z=m.VSBuffer.wrap(Buffer.from(W.inflateBytes,"base64"));B=new y.WebSocketNodeSocket(new y.NodeSocket(U,"extHost-socket"),W.permessageDeflate,z,!1)}E?(F.cancel(),$.cancel(),E.beginAcceptReconnection(B,x),E.endAcceptReconnection(),E.sendResume()):(clearTimeout(s),E=new A.PersistentProtocol({socket:B,initialChunk:x}),E.sendResume(),E.onDidDispose(()=>t("renderer disconnected")),l(E),E.onSocketClose(()=>{F.schedule()}))}if(W&&W.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if($.isScheduled())return;F.isScheduled()&&$.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const l=v.pipeName;return new Promise((I,E)=>{const s=R.createConnection(l,()=>{s.removeListener("error",E);const i=new A.PersistentProtocol({socket:new y.NodeSocket(s,"extHost-renderer")});i.sendResume(),I(i)});s.once("error",E),s.on("close",()=>{t("renderer closed the socket")})})}}async function r(){const v=await a();return new class{constructor(){this.a=new A.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,v.onMessage(l=>{(0,T.isMessageOfType)(l,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(l)})}send(l){this.b||v.send(l)}async drain(){if(v.drain)return v.drain()}}}function o(v){return new Promise(l=>{const I=v.onMessage(E=>{I.dispose();const s=JSON.parse(E.toString()),i=s.commit,k=g.default.commit;if(i&&k&&i!==k&&w(55),s.parentPid){let F=0;setInterval(function(){try{process.kill(s.parentPid,0),F=0}catch(j){j&&j.code==="EPERM"?(F++,F>=3&&t(`parent process ${s.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):t(`parent process ${s.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let $;try{$=globalThis._VSCODE_NODE_MODULES["native-watchdog"],$.start(s.parentPid)}catch(j){(0,L.onUnexpectedError)(j)}}v.send((0,T.createMessageOfType)(0)),l({protocol:v,initData:s})});v.send((0,T.createMessageOfType)(1))})}async function f(){const v=[];process.on("unhandledRejection",(F,$)=>{v.push($),setTimeout(()=>{const j=v.indexOf($);j>=0&&$.catch(W=>{v.splice(j,1),(0,L.isCancellationError)(W)||(console.warn(`rejected promise not handled within 1 second: ${W}`),W&&W.stack&&console.warn(`stack trace: ${W.stack}`),F&&(0,L.onUnexpectedError)(F))})},1e3)}),process.on("rejectionHandled",F=>{const $=v.indexOf(F);$>=0&&v.splice($,1)}),process.on("uncaughtException",function(F){(0,L.isSigPipeError)(F)||(0,L.onUnexpectedError)(F)}),O.mark("code/extHost/willConnectToRenderer");const l=await r();O.mark("code/extHost/didConnectToRenderer");const I=await o(l);O.mark("code/extHost/didWaitForInitData");const{initData:E}=I;p(!!E.environment.extensionTestsLocationURI),E.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0,E.environment.skipWorkspaceStorageLock=(0,n.boolean)(S.skipWorkspaceStorageLock,!1);const s=new class{constructor(){this.pid=process.pid}exit($){w($)}exists($){return D.Promises.exists($)}realpath($){return(0,C.realpath)($)}};let i=null;E.remote.authority&&S.transformURIs&&(i=(0,h.createURITransformer)(E.remote.authority));const k=new P.ExtensionHostMain(I.protocol,E,s,i);t=F=>{k.terminate(F);const $=process.env.VSCODE_IPC_HOOK_CLI,j=process.env.CODE_SERVER_SESSION_SOCKET;if(!$||!j)return;const W=JSON.stringify({socketPath:$}),U={path:"/delete-session",socketPath:j,method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},x=c.request(U);x.write(W),x.end()}}f().catch(v=>console.log(v))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
